BEGIN TRY
IF  EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[HospitalsTemp]') AND type in (N'U'))
	DROP TABLE [HospitalsTemp]

IF NOT EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'[HospitalsTemp]') AND type in (N'U'))
BEGIN
CREATE TABLE [HospitalsTemp](
	[Id] [int] IDENTITY(1,1) NOT NULL,
	[Name] [nvarchar](255) NOT NULL,
	[IsSourcedFromBaseData] [bit] NOT NULL,
	[Version] [decimal](19, 5) NULL,
	[CCR] [decimal](19, 4) NULL,
	[CmsProviderID] [nvarchar](10) NULL,
	[LocalHospitalId] [nvarchar](20) NULL,
	[Description] [nvarchar](1000) NULL,
	[Employees] [int] NULL,
	[TotalBeds] [int] NULL,
	[HospitalOwnership] [nvarchar](100) NULL,
	[PhoneNumber] [nvarchar](50) NULL,
	[FaxNumber] [nvarchar](50) NULL,
	[MedicareMedicaidProvider] [bit] NULL,
	[EmergencyService] [bit] NULL,
	[TraumaService] [bit] NULL,
	[UrgentCareService] [bit] NULL,
	[PediatricService] [bit] NULL,
	[PediatricICUService] [bit] NULL,
	[CardiacCatherizationService] [bit] NULL,
	[PharmacyService] [bit] NULL,
	[DiagnosticXRayService] [bit] NULL,
	[ForceLocalHospitalIdValidation] [bit] NULL,
	[IsDeleted] [bit] NULL,
	[IsArchived] [bit] NULL,
	[ArchiveDate] [datetime] NULL,
	[LinkedHospitalId] [int] NULL,
	[Address] [nvarchar](100) NULL,
	[City] [nvarchar](100) NULL,
	[State] [nvarchar](10) NULL,
	[County] [nvarchar](10) NULL,
	[Zip] [nvarchar](12) NULL,
	[Latitude] [float] NULL,
	[Longitude] [float] NULL,
	[HospitalServiceArea_Id] [int] NULL,
	[HealthReferralRegion_Id] [int] NULL,
	[CustomRegion_Id] [int] NULL,
	[Registry_Id] [int] NULL
) ON [PRIMARY]
END

SET IDENTITY_INSERT [dbo].[HospitalsTemp] ON;

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1, N'Southeast Alabama Medical Center', 1, NULL, NULL, N'010001', NULL, NULL, 0, 420, NULL, N'3347938701', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1108 Ross Clark Circle', N'Dothan', N'AL', N'01069', N'36301', 31.214601, -85.361569, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2, N'Marshall Medical Center South', 1, NULL, NULL, N'010005', NULL, NULL, 0, 240, NULL, N'2565938310', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2505 U S Highway 431 North', N'Boaz', N'AL', N'01095', N'35957', 34.221523, -86.159229, 316, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3, N'Eliza Coffee Memorial Hospital', 1, NULL, NULL, N'010006', NULL, NULL, 0, 358, NULL, N'2567688400', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Maren Street', N'Florence', N'AL', N'01077', N'35631', 34.794895, -87.68504, 335, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4, N'Mizell Memorial Hospital', 1, NULL, NULL, N'010007', NULL, NULL, 0, 99, NULL, N'3344933541', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 N Main St', N'Opp', N'AL', N'01039', N'36467', 31.291972, -86.255415, 357, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5, N'Crenshaw Community Hospital', 1, NULL, NULL, N'010008', NULL, NULL, 0, 65, NULL, N'3343353374', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Circle', N'Luverne', N'AL', N'01041', N'36049', 31.694473, -86.26623, 349, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6, N'St Vincent''s East', 1, NULL, NULL, N'010011', NULL, NULL, 0, 362, NULL, N'2058383122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Medical Park East Drive', N'Birmingham', N'AL', N'01073', N'35235', 33.520682, -86.802433, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (7, N'Dekalb Regional Medical Center', 1, NULL, NULL, N'010012', NULL, NULL, 0, 134, NULL, N'2568453150', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Med Center Drive', N'Fort Payne', N'AL', N'01049', N'35968', 34.444255, -85.719689, 337, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (8, N'Shelby Baptist Medical Center', 1, NULL, NULL, N'010016', NULL, NULL, 0, 252, NULL, N'2056208100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 First Street North', N'Alabaster', N'AL', N'01117', N'35007', 33.255966, -86.813704, 307, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (9, N'Callahan Eye Hospital', 1, NULL, NULL, N'010018', NULL, NULL, 0, 106, NULL, N'2053258100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 University Blvd', N'Birmingham', N'AL', N'01073', N'35233', 33.503187, -86.802298, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (10, N'Helen Keller Memorial Hospital', 1, NULL, NULL, N'010019', NULL, NULL, 0, 185, NULL, N'2563864556', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 South Montmery Avenue', N'Sheffield', N'AL', N'01033', N'35660', 34.747681, -87.698875, 354, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (11, N'Dale Medical Center', 1, NULL, NULL, N'010021', NULL, NULL, 0, 89, NULL, N'3347742601', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 Hospital Ave', N'Ozark', N'AL', N'01045', N'36360', 31.451912, -85.631023, 358, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (12, N'Cherokee Medical Center', 1, NULL, NULL, N'010022', NULL, NULL, 0, 60, NULL, N'2569275531', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Northwood Dr', N'Centre', N'AL', N'01019', N'35960', 34.162675, -85.657041, 321, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (13, N'Baptist Medical Center South', 1, NULL, NULL, N'010023', NULL, NULL, 0, 454, NULL, N'3342882100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2105 East South Boulevard', N'Montmery', N'AL', N'01101', N'36116', 32.327153, -86.275985, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (14, N'Jackson Hospital & Clinic Inc', 1, NULL, NULL, N'010024', NULL, NULL, 0, 349, NULL, N'3342938000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Pine Street', N'Montmery', N'AL', N'01101', N'36106', 32.366605, -86.285278, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (15, N'East Alabama Medical Center', 1, NULL, NULL, N'010029', NULL, NULL, 0, 314, NULL, N'3347493411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Pepperell Parkway', N'Opelika', N'AL', N'01081', N'36801', 32.638138, -85.403112, 356, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (16, N'Wedowee Hospital', 1, NULL, NULL, N'010032', NULL, NULL, 0, 34, NULL, N'2563572111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 North Main Street', N'Wedowee', N'AL', N'01111', N'36278', 33.310467, -85.484971, 375, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (17, N'University Of Alabama Hospital', 1, NULL, NULL, N'010033', NULL, NULL, 0, 1127, NULL, N'2059344011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'619 South 19Th Street', N'Birmingham', N'AL', N'01073', N'35233', 33.506129, -86.801922, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (18, N'Community Hospital Inc', 1, NULL, NULL, N'010034', NULL, NULL, 0, 69, NULL, N'3342836541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Friendship Road', N'Tallassee', N'AL', N'01051', N'36078', 32.535308, -85.912104, 368, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (19, N'Cullman Regional Medical Center', 1, NULL, NULL, N'010035', NULL, NULL, 0, 115, NULL, N'2567372000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1912 Alabama Highway 157', N'Cullman', N'AL', N'01043', N'35058', 34.198579, -86.805369, 323, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (20, N'Andalusia Regional Hospital', 1, NULL, NULL, N'010036', NULL, NULL, 0, 100, NULL, N'3342228466', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'849 South Three Notch Street', N'Andalusia', N'AL', N'01039', N'36420', 31.297461, -86.495601, 309, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (21, N'Stringfellow Memorial Hospital', 1, NULL, NULL, N'010038', NULL, NULL, 0, 125, NULL, N'2562358900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East 18Th St', N'Anniston', N'AL', N'01015', N'36201', 33.667701, -85.825025, 310, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (22, N'Huntsville Hospital', 1, NULL, NULL, N'010039', NULL, NULL, 0, 881, NULL, N'2562651000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Sivley Rd', N'Huntsville', N'AL', N'01089', N'35801', 34.721067, -86.582196, 346, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (23, N'Gadsden Regional Medical Center', 1, NULL, NULL, N'010040', NULL, NULL, 0, 346, NULL, N'2564944000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 odyear Avenue', N'Gadsden', N'AL', N'01055', N'35903', 34.009389, -85.96752, 338, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (24, N'Marion Regional Medical Center', 1, NULL, NULL, N'010044', NULL, NULL, 0, 57, NULL, N'2059216200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1256 Military Street South', N'Hamilton', N'AL', N'01093', N'35570', 34.12602, -87.989811, 344, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (25, N'Fayette Medical Center', 1, NULL, NULL, N'010045', NULL, NULL, 0, 61, NULL, N'2059325966', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1653 Temple Avenue North', N'Fayette', N'AL', N'01057', N'35555', 33.707717, -87.823737, 333, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (26, N'Riverview Regional Medical Center', 1, NULL, NULL, N'010046', NULL, NULL, 0, 281, NULL, N'2565435200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Third Street', N'Gadsden', N'AL', N'01055', N'35901', 34.004976, -86.003963, 338, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (27, N'Georgiana Medical Center', 1, NULL, NULL, N'010047', NULL, NULL, 0, 22, NULL, N'3343762205', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 N Miranda Avenue', N'Georgiana', N'AL', N'01013', N'36033', 31.644527, -86.742733, 340, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (28, N'Medical Center Enterprise', 1, NULL, NULL, N'010049', NULL, NULL, 0, 131, NULL, N'3343470584', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Edwards Street', N'Enterprise', N'AL', N'01031', N'36330', 31.318144, -85.855319, 329, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (29, N'Greene County Hospital', 1, NULL, NULL, N'010051', NULL, NULL, 0, 20, NULL, N'2053723388', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Wilson Avenue', N'Eutaw', N'AL', N'01063', N'35462', 32.844744, -87.889307, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (30, N'Lake Martin Community Hospital', 1, NULL, NULL, N'010052', NULL, NULL, 0, 46, NULL, N'2568257821', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Mariarden Road', N'Dadeville', N'AL', N'01123', N'36853', 32.819955, -85.741599, 324, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (31, N'Flowers Hospital', 1, NULL, NULL, N'010055', NULL, NULL, 0, 235, NULL, N'3347935000', N'3346158419', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4370 West Main Street', N'Dothan', N'AL', N'01069', N'36305', 31.235991, -85.457937, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (32, N'St Vincent''s Birmingham', 1, NULL, NULL, N'010056', NULL, NULL, 0, 409, NULL, N'2059397000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 St Vincent''s Drive', N'Birmingham', N'AL', N'01073', N'35205', 33.507948, -86.788627, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (33, N'Bibb Medical Center', 1, NULL, NULL, N'010058', NULL, NULL, 0, 35, NULL, N'2059264881', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 Pierson Ave', N'Centreville', N'AL', N'01007', N'35042', 32.951367, -87.146934, 322, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (34, N'Lawrence Medical Center', 1, NULL, NULL, N'010059', NULL, NULL, 0, 98, NULL, N'2569742200', N'2569742240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Hospital Street', N'Moulton', N'AL', N'01079', N'35650', 34.482884, -87.286019, 353, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (35, N'Highlands Medical Center', 1, NULL, NULL, N'010061', NULL, NULL, 0, 170, NULL, N'2562594444', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Woods Cove Road', N'Scottsboro', N'AL', N'01071', N'35768', 34.663091, -86.045507, 364, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (36, N'Wiregrass Medical Center', 1, NULL, NULL, N'010062', NULL, NULL, 0, 83, NULL, N'3346843655', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 W Maple Avenue', N'Geneva', N'AL', N'01061', N'36340', 31.047753, -85.892518, 339, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (37, N'Russell Hospital', 1, NULL, NULL, N'010065', NULL, NULL, 0, 81, NULL, N'2563297100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3316 Highway 280', N'Alexander City', N'AL', N'01123', N'35010', 32.928407, -85.965371, 308, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (38, N'Medical Center Barbour', 1, NULL, NULL, N'010069', NULL, NULL, 0, 74, NULL, N'3346887271', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 W Washington St', N'Eufaula', N'AL', N'01005', N'36027', 31.888006, -85.155487, 330, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (39, N'Clay County Hospital', 1, NULL, NULL, N'010073', NULL, NULL, 0, 53, NULL, N'2563542131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'83825 Highway 9    P O Box 1270', N'Ashland', N'AL', N'01027', N'36251', 34.799257, -86.516102, 311, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (40, N'Northeast Alabama Regional Med Center', 1, NULL, NULL, N'010078', NULL, NULL, 0, 338, NULL, N'2562355121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East 10Th Street', N'Anniston', N'AL', N'01015', N'36207', 33.657123, -85.823353, 310, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (41, N'Athens-Limestone Hospital', 1, NULL, NULL, N'010079', NULL, NULL, 0, 101, NULL, N'2562339292', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Market Street', N'Athens', N'AL', N'01083', N'35611', 34.803499, -86.977803, 312, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (42, N'South Baldwin Regional Medical Center', 1, NULL, NULL, N'010083', NULL, NULL, 0, 112, NULL, N'2519493400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1613 North Mckenzie Street', N'Foley', N'AL', N'01003', N'36535', 30.426686, -87.683193, 336, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (43, N'Decatur Morgan Hospital-Decatur Campus', 1, NULL, NULL, N'010085', NULL, NULL, 0, 457, NULL, N'2563412000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 7Th Street Se', N'Decatur', N'AL', N'01103', N'35601', 34.591169, -86.972786, 325, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (44, N'Northwest Medical Center', 1, NULL, NULL, N'010086', NULL, NULL, 0, 71, NULL, N'2054877736', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 U S Highway 43', N'Winfield', N'AL', N'01093', N'35594', 33.928894, -87.82373, 376, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (45, N'University Of South Alabama Medical Center', 1, NULL, NULL, N'010087', NULL, NULL, 0, 406, NULL, N'2514717110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2451 Fillingim Street', N'Mobile', N'AL', N'01097', N'36617', 30.708197, -88.098946, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (46, N'Walker Baptist Medical Center', 1, NULL, NULL, N'010089', NULL, NULL, 0, 267, NULL, N'2053874000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Highway 78 East', N'Jasper', N'AL', N'01127', N'35502', 33.841142, -87.236879, 348, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (47, N'Providence Hospital', 1, NULL, NULL, N'010090', NULL, NULL, 0, 349, NULL, N'2516331000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6801 Airport Boulevard', N'Mobile', N'AL', N'01097', N'36608', 30.682265, -88.199618, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (48, N'Grove Hill Memorial Hospital', 1, NULL, NULL, N'010091', NULL, NULL, 0, 50, NULL, N'2512753191', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'295 Jackson Hwy S', N'Grove Hill', N'AL', N'01025', N'36451', 31.708768, -87.777222, 341, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (49, N'D C H Regional Medical Center', 1, NULL, NULL, N'010092', NULL, NULL, 0, 787, NULL, N'2057597111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 University Boulevard East', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.206164, -87.52551, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (50, N'Hale County Hospital', 1, NULL, NULL, N'010095', NULL, NULL, 0, 39, NULL, N'3346243024', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 Green Street', N'Greensboro', N'AL', N'01065', N'36744', 32.69472, -87.585443, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (51, N'Elmore Community Hospital', 1, NULL, NULL, N'010097', NULL, NULL, 0, 69, NULL, N'3345674311', N'3345674312', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Hospital Drive', N'Wetumpka', N'AL', N'01051', N'36092', 32.552, -86.186183, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (52, N'D W Mcmillan Memorial Hospital', 1, NULL, NULL, N'010099', NULL, NULL, 0, 65, NULL, N'2518678061', N'2518098459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Belleville Avenue', N'Brewton', N'AL', N'01053', N'36426', 31.127144, -87.072399, 317, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (53, N'Thomas Hospital', 1, NULL, NULL, N'010100', NULL, NULL, 0, 150, NULL, N'2519282375', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Morphy Avenue', N'Fairhope', N'AL', N'01003', N'36532', 30.519999, -87.890333, 332, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (54, N'Citizens Baptist Medical Center', 1, NULL, NULL, N'010101', NULL, NULL, 0, 122, NULL, N'2567614542', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 Stone Avenue', N'Talladega', N'AL', N'01121', N'35161', 33.439798, -86.091984, 367, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (55, N'J Paul Jones Hospital', 1, NULL, NULL, N'010102', NULL, NULL, 0, 30, NULL, N'3346824131', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Mcwilliams Avenue', N'Camden', N'AL', N'01131', N'36726', 31.995605, -87.299427, 319, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (56, N'Baptist Medical Center-Princeton', 1, NULL, NULL, N'010103', NULL, NULL, 0, 505, NULL, N'2057833800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Princeton Avenue Southwest', N'Birmingham', N'AL', N'01073', N'35211', 33.498977, -86.846442, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (57, N'Grandview Medical Center', 1, NULL, NULL, N'010104', NULL, NULL, 0, 372, NULL, N'2055921000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3690 Grandview Parkway', N'Birmingham', N'AL', N'01073', N'35243', 33.514854, -86.74741, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (58, N'Prattville Baptist Hospital', 1, NULL, NULL, N'010108', NULL, NULL, 0, 85, NULL, N'3343614267', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'124 S Memorial Dr', N'Prattville', N'AL', N'01001', N'36067', 32.463514, -86.450939, 360, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (59, N'Pickens County Medical Center', 1, NULL, NULL, N'010109', NULL, NULL, 0, 56, NULL, N'2053678111', N'2053672121', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'241 Robert K Wilson Drive', N'Carrollton', N'AL', N'01107', N'35447', 33.274807, -88.089673, 320, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (60, N'Bullock County Hospital', 1, NULL, NULL, N'010110', NULL, NULL, 0, 54, NULL, N'3347382140', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 West Conecuh Avenue', N'Union Springs', N'AL', N'01011', N'36089', 32.146178, -85.715994, 372, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (61, N'Bryan W. Whitfield Memorial Hospital', 1, NULL, NULL, N'010112', NULL, NULL, 0, 99, NULL, N'3342894000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Highway 80 East', N'Demopolis', N'AL', N'01091', N'36732', 32.268794, -86.57684, 326, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (62, N'Mobile Infirmary', 1, NULL, NULL, N'010113', NULL, NULL, 0, 689, NULL, N'2514354700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Mobile Infirmary Circle', N'Mobile', N'AL', N'01097', N'36652', 30.696591, -88.081622, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (63, N'Medical West An Affiliate Of Uab Health System', 1, NULL, NULL, N'010114', NULL, NULL, 0, 300, NULL, N'2054817000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'995 9Th Avenue Southwest', N'Bessemer', N'AL', N'01073', N'35021', 33.379573, -86.986239, 314, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (64, N'Vaughan Regional Medical Center Parkway Campus', 1, NULL, NULL, N'010118', NULL, NULL, 0, 214, NULL, N'3344184100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Medical Center Parkway', N'Selma', N'AL', N'01047', N'36701', 32.430311, -87.055271, 365, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (65, N'Monroe County Hospital', 1, NULL, NULL, N'010120', NULL, NULL, 0, 94, NULL, N'2515753111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2016 South Alabama Avenue Box 886', N'Monroeville', N'AL', N'01099', N'36460', 31.49935, -87.319144, 351, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (66, N'Lakeland Community Hospital', 1, NULL, NULL, N'010125', NULL, NULL, 0, 50, NULL, N'2054857117', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42024 Highway 195 E', N'Haleyville', N'AL', N'01133', N'35565', 34.241156, -87.590799, 343, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (67, N'Troy Regional Medical Center', 1, NULL, NULL, N'010126', NULL, NULL, 0, 97, NULL, N'3346705000', N'3345667490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1330 Highway 231 South', N'Troy', N'AL', N'01109', N'36081', 31.78056, -85.946277, 370, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (68, N'Jackson Medical Center', 1, NULL, NULL, N'010128', NULL, NULL, 0, 35, NULL, N'2512469021', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Hospital Drive', N'Jackson', N'AL', N'01025', N'36545', 31.531099, -87.894553, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (69, N'North Baldwin Infirmary', 1, NULL, NULL, N'010129', NULL, NULL, 0, 70, NULL, N'2519375521', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1815 Hand Avenue', N'Bay Minette', N'AL', N'01003', N'36507', 30.901934, -87.783058, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (70, N'St Vincent''s St Clair', 1, NULL, NULL, N'010130', NULL, NULL, 0, 40, NULL, N'2053383301', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7063 Veterans Parkway', N'Pell City', N'AL', N'01115', N'35125', 33.605262, -86.298969, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (71, N'Crestwood Medical Center', 1, NULL, NULL, N'010131', NULL, NULL, 0, 147, NULL, N'2568823100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Dr Se', N'Huntsville', N'AL', N'01089', N'35801', 34.615232, -86.807343, 346, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (72, N'Hill Hospital Of Sumter County', 1, NULL, NULL, N'010138', NULL, NULL, 0, 33, NULL, N'2053925263', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Derby Drive', N'York', N'AL', N'01119', N'36925', 32.492097, -88.296177, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (73, N'Brookwood Medical Center', 1, NULL, NULL, N'010139', NULL, NULL, 0, 607, NULL, N'2058771000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2010 Brookwood Medical Center Drive', N'Birmingham', N'AL', N'01073', N'35209', 33.463103, -86.776451, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (74, N'Springhill Memorial Hospital', 1, NULL, NULL, N'010144', NULL, NULL, 0, 263, NULL, N'2513449630', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3719 Dauphin Street', N'Mobile', N'AL', N'01097', N'36608', 30.686756, -88.130626, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (75, N'Rmc Jacksonville', 1, NULL, NULL, N'010146', NULL, NULL, 0, 89, NULL, N'2567824538', N'2567824589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 South Pelham Road', N'Jacksonville', N'AL', N'01015', N'36265', 33.785668, -85.761164, 347, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (76, N'Evergreen Medical Center', 1, NULL, NULL, N'010148', NULL, NULL, 0, 44, NULL, N'2515782480', N'2515782480', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Crestview Avenue', N'Evergreen', N'AL', N'01035', N'36401', 31.431763, -86.940492, 331, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (77, N'Baptist Medical Center East', 1, NULL, NULL, N'010149', NULL, NULL, 0, 150, NULL, N'3342448330', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Taylor Road', N'Montmery', N'AL', N'01101', N'36117', 32.376821, -86.172095, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (78, N'L V Stabler Memorial Hospital', 1, NULL, NULL, N'010150', NULL, NULL, 0, 72, NULL, N'3343822200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 L V Stabler Drive', N'Greenville', N'AL', N'01013', N'36037', 31.82945, -86.64586, 340, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (79, N'Shoals Hospital', 1, NULL, NULL, N'010157', NULL, NULL, 0, 178, NULL, N'2563861601', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 West Avalon Avenue', N'Muscle Shoals', N'AL', N'01033', N'35661', 34.744941, -87.676511, 354, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (80, N'Russellville Hospital', 1, NULL, NULL, N'010158', NULL, NULL, 0, 100, NULL, N'2563321611', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15155 Highway 43', N'Russellville', N'AL', N'01059', N'35653', 34.511362, -87.7176, 363, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (81, N'Coosa Valley Medical Center', 1, NULL, NULL, N'010164', NULL, NULL, 0, 163, NULL, N'2562495000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 W Hickory St', N'Sylacauga', N'AL', N'01121', N'35150', 33.164663, -86.25381, 366, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (82, N'Uab Highlands', 1, NULL, NULL, N'010167', NULL, NULL, 0, 219, NULL, N'2059307000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 11Th Avenue South', N'Birmingham', N'AL', N'01073', N'35205', 33.501979, -86.917126, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (83, N'Jack Hughston Memorial Hospital', 1, NULL, NULL, N'010168', NULL, NULL, 0, 70, NULL, N'3347323000', N'3347323020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 River Chase Drive', N'Phenix City', N'AL', N'01113', N'36867', 32.509045, -85.005696, 359, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (84, N'Atmore Community Hospital', 1, NULL, NULL, N'010169', NULL, NULL, 0, 49, NULL, N'2513682500', N'2513686237', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Medical Park Drive', N'Atmore', N'AL', N'01053', N'36502', 31.016525, -87.479655, 313, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (85, N'Washington County Hospital', 1, NULL, NULL, N'011300', NULL, NULL, 0, 25, NULL, N'2518472223', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14600 St. Stephens Avenue', N'Chatom', N'AL', N'01129', N'36518', 31.453192, -88.208144, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (86, N'Red Bay Hospital', 1, NULL, NULL, N'011302', NULL, NULL, 0, 25, NULL, N'2563569532', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Hospital Road', N'Red Bay', N'AL', N'01059', N'35582', 34.457424, -88.14693, 361, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (87, N'Choctaw General Hospital', 1, NULL, NULL, N'011304', NULL, NULL, 0, 25, NULL, N'2054599100', N'2054599190', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Vanity Fair Lane Po Box 618', N'Butler', N'AL', N'01023', N'36904', 32.092417, -88.208346, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (88, N'St Vincents Blount', 1, NULL, NULL, N'011305', NULL, NULL, 0, 25, NULL, N'2052743000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Gilbreath Drive', N'Oneonta', N'AL', N'01009', N'35121', 33.93301, -86.494266, 355, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (89, N'Infirmary Ltac Hospital', 1, NULL, NULL, N'012006', NULL, NULL, 0, 38, NULL, N'2516605611', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Mobile Infirmary Circle', N'Mobile', N'AL', N'01097', N'36607', 30.696401, -88.078851, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (90, N'Noland Hospital Montmery Ii Llc', 1, NULL, NULL, N'012007', NULL, NULL, 0, 60, NULL, N'3342400532', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Pine Street 5Th Floor North Wing', N'Montmery', N'AL', N'01101', N'36106', 32.3670876, -86.2875379, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (91, N'Select Specialty Hosp-Birmingham', 1, NULL, NULL, N'012008', NULL, NULL, 0, 38, NULL, N'2055994595', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Montclair Road 9Th Floor', N'Birmingham', N'AL', N'01073', N'35213', 33.516628, -86.748632, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (92, N'Noland Hospital Birmingham Ii Llc', 1, NULL, NULL, N'012009', NULL, NULL, 0, 45, NULL, N'2058385100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Medical Park East Drive 8Th Floor', N'Birmingham', N'AL', N'01073', N'35235', 33.5964614, -86.6698389, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (93, N'Noland Hospital Dothan Ii Llc', 1, NULL, NULL, N'012010', NULL, NULL, 0, 35, NULL, N'3346994300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1108 Ross Clark Circle 4Th Floor', N'Dothan', N'AL', N'01069', N'36302', 31.2167298, -85.3652563, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (94, N'Noland Hospital Anniston Ii Llc', 1, NULL, NULL, N'012011', NULL, NULL, 0, 38, NULL, N'2567416141', N'2567416158', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East 10Th Street 4Th Floor', N'Anniston', N'AL', N'01015', N'36202', 33.6563997, -85.8250239, 310, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (95, N'Noland Hospital Tuscaloosa Ii Llc', 1, NULL, NULL, N'012012', NULL, NULL, 0, 32, NULL, N'2057597241', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'809 University Boulevard East 4Th Floor', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.2054026, -87.5286699, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (96, N'Noland Hospital Shelby Ii Llc', 1, NULL, NULL, N'012013', NULL, NULL, 0, 52, NULL, N'2056208641', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 First Street 3Rd Floor', N'Alabaster', N'AL', N'01117', N'35007', 33.2524481, -86.8157432, 307, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (97, N'Healthsouth Lakeshore Rehabilitation Hospital', 1, NULL, NULL, N'013025', NULL, NULL, 0, 100, NULL, N'2058682000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Ridgeway Drive', N'Birmingham', N'AL', N'01073', N'35209', 33.520682, -86.802433, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (98, N'Healthsouth Rehabilitation Hospital Of Montmery', 1, NULL, NULL, N'013028', NULL, NULL, 0, 70, NULL, N'3342847821', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4465 Narrow Lane Rd', N'Montmery', N'AL', N'01101', N'36116', 32.366966, -86.300648, 352, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (99, N'Healthsouth Rehabilitation Hospital Of North Al', 1, NULL, NULL, N'013029', NULL, NULL, 0, 70, NULL, N'2055352300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 vernors Drive', N'Huntsville', N'AL', N'01089', N'35801', 34.720218, -86.619723, 346, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (100, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'013030', NULL, NULL, 0, 51, NULL, N'3347126333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1736 East Main Street', N'Dothan', N'AL', N'01069', N'36301', 31.218693, -85.365447, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (101, N'Healthsouth Rehabilitation Hospital Of Gadsden', 1, NULL, NULL, N'013032', NULL, NULL, 0, 44, NULL, N'2564395000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 odyear Ave', N'Gadsden', N'AL', N'01055', N'35903', 34.001631, -85.949158, 338, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (102, N'Regional Rehabilitation Hospital', 1, NULL, NULL, N'013033', NULL, NULL, 0, 48, NULL, N'3347322200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3715 Highway 280', N'Phenix City', N'AL', N'01113', N'36869', 32.470976, -85.000765, 359, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (103, N'Children''s Hospital Of Alabama', 1, NULL, NULL, N'013300', NULL, NULL, 0, 332, NULL, N'2059399100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Seventh Avenue South', N'Birmingham', N'AL', N'01073', N'35233', 33.520682, -86.802433, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (104, N'University Of S A Children''s And Women''s Hos', 1, NULL, NULL, N'013301', NULL, NULL, 0, 152, NULL, N'2514151000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Center Street', N'Mobile', N'AL', N'01097', N'36604', 30.696235, -88.07758, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (105, N'Hill Crest Behavioral Health Services', 1, NULL, NULL, N'014000', NULL, NULL, 0, 94, NULL, N'2058339000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6869 Fifth Avenue South', N'Birmingham', N'AL', N'01073', N'35212', 33.520682, -86.802433, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (106, N'Mountain View Hospital', 1, NULL, NULL, N'014006', NULL, NULL, 0, 68, NULL, N'2565469265', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 Scenic Highway', N'Gadsden', N'AL', N'01055', N'35902', 34.108974, -85.982199, 338, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (107, N'Bryce Hospital', 1, NULL, NULL, N'014007', NULL, NULL, 0, 268, NULL, N'2057590750', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 University Blvd', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.210662, -87.565588, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (108, N'Mary S Harper Geriatric Psychiatry Center', 1, NULL, NULL, N'014012', NULL, NULL, 0, 96, NULL, N'2057590900', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 University Blvd', N'Tuscaloosa', N'AL', N'01125', N'35401', 33.210662, -87.565588, 371, 6, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (109, N'Laurel Oaks Behavioral Health Center', 1, NULL, NULL, N'014013', NULL, NULL, 0, 24, NULL, N'3347947393', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Cottonwood Rd', N'Dothan', N'AL', N'01069', N'36301', 31.20484, -85.384179, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (110, N'Baypointe Behavioral Health', 1, NULL, NULL, N'014014', NULL, NULL, 0, 60, NULL, N'2516627998', N'2516667537', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5800 Southland Drive', N'Mobile', N'AL', N'01097', N'36693', 30.623903, -88.177561, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (111, N'Beacon Children''s Hospital', 1, NULL, NULL, N'014015', NULL, NULL, 0, 28, NULL, N'3343355040', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Hospital Drive', N'Luverne', N'AL', N'01041', N'36049', 31.716546, -86.263849, 349, 5, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (112, N'Sanctuary At The Woodlands The', 1, NULL, NULL, N'014016', NULL, NULL, 0, 20, NULL, N'2567391239', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 Cherokee Avenue Sw', N'Cullman', N'AL', N'01043', N'35055', 34.192697, -86.794376, 323, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (113, N'Eastpointe Hospital', 1, NULL, NULL, N'014017', NULL, NULL, 0, 66, NULL, N'2513786500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Roper Lane', N'Daphne', N'AL', N'01003', N'36526', 30.635236, -87.898021, 350, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (114, N'Behavioral Healthcare Center At Huntsville Inc', 1, NULL, NULL, N'014018', NULL, NULL, 0, 20, NULL, N'2569646700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5315 Millenium Drive Nw', N'Huntsville', N'AL', N'01089', N'35806', 34.753332, -86.6634564, 346, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (115, N'Children''s Hospital Of Alabama', 1, NULL, NULL, N'019801', NULL, NULL, 0, 0, NULL, N'2056389828', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Seventh Avenue South', N'Birmingham', N'AL', N'01073', N'35233', 33.520682, -86.802433, 315, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (116, N'Providence Alaska Medical Center', 1, NULL, NULL, N'020001', NULL, NULL, 0, 401, NULL, N'9072123675', N'9072613041', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 196604', N'Anchorage', N'AK', N'02020', N'99508', 61.624327, -149.77812, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (117, N'Mat-Su Regional Medical Center', 1, NULL, NULL, N'020006', NULL, NULL, 0, 39, NULL, N'9078616000', N'9077468653', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 South Woodworth Loop', N'Palmer', N'AK', N'02170', N'99645', 61.564015, -149.262393, 385, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (118, N'Bartlett Regional Hospital', 1, NULL, NULL, N'020008', NULL, NULL, 0, 57, NULL, N'9077968900', N'9074634919', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3260 Hospital Dr', N'Juneau', N'AK', N'02110', N'99801', 58.328647, -134.466731, 381, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (119, N'Fairbanks Memorial Hospital', 1, NULL, NULL, N'020012', NULL, NULL, 0, 162, NULL, N'9074528181', N'9074585324', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Cowles Street', N'Fairbanks', N'AK', N'02090', N'99701', 64.832881, -147.741909, 379, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (120, N'Alaska Regional Hospital', 1, NULL, NULL, N'020017', NULL, NULL, 0, 238, NULL, N'9072761131', N'9072641143', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Debarr Road', N'Anchorage', N'AK', N'02020', N'99508', 61.209613, -149.830958, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (121, N'Yukon Kuskokwim Delta Reg Hospital', 1, NULL, NULL, N'020018', NULL, NULL, 0, 50, NULL, N'9075436300', N'9075436366', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 287', N'Bethel', N'AK', N'02050', N'99559', 60.792222, -161.755833, 393, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (122, N'Central Peninsula General Hospital', 1, NULL, NULL, N'020024', NULL, NULL, 0, 49, NULL, N'9072624404', N'9072628184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Place', N'Soldotna', N'AK', NULL, N'99669', 60.493862, -151.077172, 389, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (123, N'Alaska Native Medical Center', 1, NULL, NULL, N'020026', NULL, NULL, 0, 159, NULL, N'9075632662', N'9077291984', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4315 Diplomacy Dr', N'Anchorage', N'AK', N'02020', N'99508', 61.181884, -149.800711, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (124, N'Providence Valdez Medical Center', 1, NULL, NULL, N'021301', NULL, NULL, 0, 15, NULL, N'9078352249', N'9078353735', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 550', N'Valdez', N'AK', NULL, N'99686', 61.139617, -146.384148, 390, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (125, N'Providence Seward Hospital', 1, NULL, NULL, N'021302', NULL, NULL, 0, 6, NULL, N'9072245205', N'9072247248', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'417 First Avenue Po Box 365', N'Seward', N'AK', NULL, N'99664', 60.105338, -149.445394, 387, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (126, N'Sitka Community Hospital', 1, NULL, NULL, N'021303', NULL, NULL, 0, 24, NULL, N'9077473241', N'9077471794', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Moller Drive', N'Sitka', N'AK', N'02220', N'99835', 57.058627, -135.344275, 388, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (127, N'Petersburg Medical Center', 1, NULL, NULL, N'021304', NULL, NULL, 0, 12, NULL, N'9077724291', N'9077723085', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 589', N'Petersburg', N'AK', NULL, N'99833', 56.812797, -132.95547, 386, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (128, N'Wrangell Medical Center', 1, NULL, NULL, N'021305', NULL, NULL, 0, 8, NULL, N'9078747000', N'9078747122', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Bennett Street Po Box 1081', N'Wrangell', N'AK', NULL, N'99929', 56.471388, -132.376615, 391, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (129, N'Providence Kodiak Island Medical Ctr', 1, NULL, NULL, N'021306', NULL, NULL, 0, 25, NULL, N'9074869592', N'9074862336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 East Rezanof Drive', N'Kodiak', N'AK', N'02150', N'99615', 57.800854, -152.373917, 383, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (130, N'Cordova Community Medical Center', 1, NULL, NULL, N'021307', NULL, NULL, 0, 13, NULL, N'9074248000', N'9074248160', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 160 - 602 Chase Avenue', N'Cordova', N'AK', NULL, N'99574', 60.55301, -145.6883, 378, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (131, N'Norton Sound Regional Hospital', 1, NULL, NULL, N'021308', NULL, NULL, 0, 21, NULL, N'9074433311', N'9074432113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Greg Kruschek Avenue (P O Box 966)', N'Nome', N'AK', N'02180', N'99762', 64.501111, -165.406389, 384, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (132, N'Kanakanak Hospital', 1, NULL, NULL, N'021309', NULL, NULL, 0, 15, NULL, N'9078425201', N'9078429354', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 130', N'Dillingham', N'AK', N'02070', N'99576', 59.047936, -158.520708, 394, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (133, N'Maniilaq Health Center', 1, NULL, NULL, N'021310', NULL, NULL, 0, 17, NULL, N'9074423321', N'9074427250', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 43', N'Kotzebue', N'AK', NULL, N'99752', 66.898206, -162.597762, 395, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (134, N'Ketchikan Medical Center', 1, NULL, NULL, N'021311', NULL, NULL, 0, 25, NULL, N'9072255171', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Tongass Avenue', N'Ketchikan', N'AK', N'02130', N'99901', 55.352784, -131.686295, 382, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (135, N'Samuel Simmonds Memorial Hospital', 1, NULL, NULL, N'021312', NULL, NULL, 0, 14, NULL, N'9078524611', N'9078529231', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Uula St', N'Barrow', N'AK', NULL, N'99723', 71.300465, -156.730897, 392, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (136, N'South Peninsula Hospital', 1, NULL, NULL, N'021313', NULL, NULL, 0, 22, NULL, N'9072358101', N'9072350253', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Bartlett St', N'Homer', N'AK', NULL, N'99603', 59.652103, -151.550293, 380, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (137, N'St Elias Specialty Hospital', 1, NULL, NULL, N'022001', NULL, NULL, 0, 60, NULL, N'9075613333', N'9075613332', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Cordova Street', N'Anchorage', N'AK', N'02020', N'99503', 61.789641, -149.280183, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (138, N'North Star Hospital', 1, NULL, NULL, N'024001', NULL, NULL, 0, 110, NULL, N'9072643526', N'9072777844', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2530 Debarr Rd', N'Anchorage', N'AK', N'02020', N'99508', 61.20875, -149.8329, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (139, N'Alaska Psychiatric Institute', 1, NULL, NULL, N'024002', NULL, NULL, 0, 95, NULL, N'9072697100', N'9072697521', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Piper Street', N'Anchorage', N'AK', N'02020', N'99508', 61.18654, -149.82655, 377, 7, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (140, N'Abrazo Maryvale Campus', 1, NULL, NULL, N'030001', NULL, NULL, 0, 232, NULL, N'6238485000', N'6238485553', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5102 West Campbell Avenue', N'Phoenix', N'AZ', N'04013', N'85031', 33.502138, -112.1689, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (141, N'Banner - University Medical Center Phoenix', 1, NULL, NULL, N'030002', NULL, NULL, 0, 668, NULL, N'6022392000', N'6022393749', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 East Mcdowell Road', N'Phoenix', N'AZ', N'04013', N'85006', 33.465717, -112.059335, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (142, N'Tucson Medical Center', 1, NULL, NULL, N'030006', NULL, NULL, 0, 616, NULL, N'5203275461', N'5203242443', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 East Grant Road', N'Tucson', N'AZ', N'04019', N'85712', 32.250766, -110.881304, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (143, N'Verde Valley Medical Center', 1, NULL, NULL, N'030007', NULL, NULL, 0, 110, NULL, N'9286396058', N'9287732348', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'269 South Candy Lane', N'Cottonwood', N'AZ', N'04025', N'86326', 34.735216, -112.031602, 400, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (144, N'St. Mary''s Hospital', 1, NULL, NULL, N'030010', NULL, NULL, 0, 400, NULL, N'5208723000', N'5208733921', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 West St Mary''s Road', N'Tucson', N'AZ', N'04019', N'85745', 32.228884, -110.999567, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (145, N'St Joseph''s Hospital', 1, NULL, NULL, N'030011', NULL, NULL, 0, 471, NULL, N'5208733000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North Wilmot Road', N'Tucson', N'AZ', N'04019', N'85711', 32.227194, -110.857841, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (146, N'Yavapai Regional Medical Center', 1, NULL, NULL, N'030012', NULL, NULL, 0, 134, NULL, N'9287715676', N'9284582015', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1003 Willow Creek Road', N'Prescott', N'AZ', N'04025', N'86301', 34.560004, -112.482086, 412, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (147, N'Yuma Regional Medical Center', 1, NULL, NULL, N'030013', NULL, NULL, 0, 369, NULL, N'9283367275', N'9283367337', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 South Avenue A', N'Yuma', N'AZ', N'04027', N'85364', 32.683963, -114.633239, 423, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (148, N'John C. Lincoln Medical Center', 1, NULL, NULL, N'030014', NULL, NULL, 0, 266, NULL, N'6028706368', N'6029449610', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 East Dunlap Avenue', N'Phoenix', N'AZ', N'04013', N'85020', 33.567758, -112.069882, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (149, N'Banner Casa Grande Medical Center', 1, NULL, NULL, N'030016', NULL, NULL, 0, 201, NULL, N'5203816300', N'5203816435', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Florence Boulevard', N'Casa Grande', N'AZ', N'04021', N'85222', 32.879608, -111.709253, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (150, N'Maricopa Medical Center', 1, NULL, NULL, N'030022', NULL, NULL, 0, 522, NULL, N'6023445011', N'6023445190', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 East Roosevelt Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.458518, -112.026971, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (151, N'Flagstaff Medical Center', 1, NULL, NULL, N'030023', NULL, NULL, 0, 267, NULL, N'9287732378', N'9287732348', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North Beaver Street', N'Flagstaff', N'AZ', N'04005', N'86001', 35.208651, -111.645096, 402, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (152, N'St Joseph''s Hospital And Medical Center', 1, NULL, NULL, N'030024', NULL, NULL, 0, 607, NULL, N'6024063000', N'6024067143', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road', N'Phoenix', N'AZ', N'04013', N'85013', 33.480294, -112.079235, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (153, N'Abrazo Central Campus', 1, NULL, NULL, N'030030', NULL, NULL, 0, 221, NULL, N'6022490212', N'6022465849', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 West Bethany Home Road', N'Phoenix', N'AZ', N'04013', N'85015', 33.524116, -112.101934, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (154, N'Banner Payson Medical Center', 1, NULL, NULL, N'030033', NULL, NULL, 0, 44, NULL, N'9284743222', N'9284721295', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 South Ponderosa Drive', N'Payson', N'AZ', N'04007', N'85541', 34.231351, -111.321361, 410, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (155, N'Chandler Regional Medical Center', 1, NULL, NULL, N'030036', NULL, NULL, 0, 243, NULL, N'4809634561', N'4808995548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1955 West Frye Road', N'Chandler', N'AZ', N'04013', N'85224', 33.29861, -111.87603, 399, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (156, N'St Luke''s Medical Center', 1, NULL, NULL, N'030037', NULL, NULL, 0, 226, NULL, N'6022518156', N'6022518685', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Van Buren Street', N'Phoenix', N'AZ', N'04013', N'85006', 33.451435, -112.043357, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (157, N'Scottsdale Osborn Medical Center', 1, NULL, NULL, N'030038', NULL, NULL, 0, 340, NULL, N'4808824000', N'4808824989', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Osborn Road', N'Scottsdale', N'AZ', N'04013', N'85251', 33.487639, -111.922895, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (158, N'Canyon Vista Medical Center', 1, NULL, NULL, N'030043', NULL, NULL, 0, 88, NULL, N'5204173001', N'5204173297', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5700 East Highway 90', N'Sierra Vista', N'AZ', N'04003', N'85635', 31.55463, -110.232095, 416, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (159, N'Kingman Regional Medical Center', 1, NULL, NULL, N'030055', NULL, NULL, 0, 235, NULL, N'9287572101', N'9287570604', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3269 Stockton Hill Road', N'Kingman', N'AZ', N'04015', N'86409', 35.220135, -114.035835, 405, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (160, N'Banner Boswell Medical Center', 1, NULL, NULL, N'030061', NULL, NULL, 0, 430, NULL, N'6238324000', N'6238765795', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10401 West Thunderbird Boulevard', N'Sun City', N'AZ', N'04013', N'85351', 33.604798, -112.282544, 418, 10, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (161, N'Summit Healthcare Regional Medical Center', 1, NULL, NULL, N'030062', NULL, NULL, 0, 89, NULL, N'9285374375', N'9285378839', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 East Show Low Lake Road', N'Show Low', N'AZ', N'04017', N'85901', 34.201967, -110.01839, 415, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (162, N'Banner-University Medical Center Tucson Campus', 1, NULL, NULL, N'030064', NULL, NULL, 0, 487, NULL, N'5208744189', N'5206944085', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 North Campbell Avenue', N'Tucson', N'AZ', N'04019', N'85724', 32.23864, -110.948304, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (163, N'Banner Desert Medical Center', 1, NULL, NULL, N'030065', NULL, NULL, 0, 639, NULL, N'4804123000', N'4804128711', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 South  Dobson Road', N'Mesa', N'AZ', N'04013', N'85202', 33.389795, -111.874638, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (164, N'Mt Graham Regional Medical Center', 1, NULL, NULL, N'030068', NULL, NULL, 0, 49, NULL, N'9283484000', N'9283485701', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600  South 20Th Avenue', N'Safford', N'AZ', N'04009', N'85546', 32.822621, -109.732991, 413, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (165, N'Havasu Regional Medical Center', 1, NULL, NULL, N'030069', NULL, NULL, 0, 162, NULL, N'9288558185', N'9285055768', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Civic Center Lane', N'Lake Havasu City', N'AZ', N'04015', N'86403', 34.479888, -114.3385, 406, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (166, N'Fort Defiance Indian Hospital', 1, NULL, NULL, N'030071', NULL, NULL, 0, 70, NULL, N'9287298000', N'6022631618', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 649', N'Fort Defiance', N'AZ', N'04001', N'86504', 35.74446, -109.076483, 404, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (167, N'Tuba City Regional Health Care Corporation', 1, NULL, NULL, N'030073', NULL, NULL, 0, 103, NULL, N'9282832501', N'9282832828', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 600', N'Tuba City', N'AZ', N'04005', N'86045', 36.135582, -111.240303, 427, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (168, N'Sells Indian Health Service Hospital', 1, NULL, NULL, N'030074', NULL, NULL, 0, 32, NULL, N'5203837200', N'5203837325', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 548', N'Sells', N'AZ', N'04019', N'85634', 31.915626, -111.886639, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (169, N'San Carlos Indian Hospital', 1, NULL, NULL, N'030077', NULL, NULL, 0, 36, NULL, N'9284757347', N'9284757370', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Cibecue Circle Road', N'San Carlos', N'AZ', N'04007', N'85550', 33.353192, -110.453633, 426, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (170, N'Phoenix Indian Medical Center', 1, NULL, NULL, N'030078', NULL, NULL, 0, 179, NULL, N'6022631200', N'6022631618', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4212 North 16Th Street', N'Phoenix', N'AZ', N'04013', N'85016', 33.496565, -112.047613, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (171, N'Abrazo Scottsdale Campus', 1, NULL, NULL, N'030083', NULL, NULL, 0, 136, NULL, N'6029235000', N'6029235657', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3929 East Bell Road', N'Phoenix', N'AZ', N'04013', N'85032', 33.640603, -111.997692, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (172, N'Chinle Comprehensive Health Care Facility', 1, NULL, NULL, N'030084', NULL, NULL, 0, 10, NULL, N'9286747001', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Us Hwy 191 Hospital Road', N'Chinle', N'AZ', N'04001', N'86503', 36.162132, -109.581274, 424, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (173, N'Northwest Medical Center', 1, NULL, NULL, N'030085', NULL, NULL, 0, 300, NULL, N'5204698100', N'5204698101', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 North La Cholla Boulevard', N'Tucson', N'AZ', N'04019', N'85741', 32.319572, -111.012054, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (174, N'Scottsdale Shea Medical Center', 1, NULL, NULL, N'030087', NULL, NULL, 0, 432, NULL, N'4803233009', N'4803233510', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9003 East Shea Boulevard', N'Scottsdale', N'AZ', N'04013', N'85260', 33.582463, -111.885291, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (175, N'Banner Baywood Medical Center', 1, NULL, NULL, N'030088', NULL, NULL, 0, 340, NULL, N'4803212000', N'4809814198', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6644 East Baywood Avenue', N'Mesa', N'AZ', N'04013', N'85206', 33.41047, -111.687145, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (176, N'Banner Thunderbird Medical Center', 1, NULL, NULL, N'030089', NULL, NULL, 0, 561, NULL, N'6028655555', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 West Thunderbird Road', N'Glendale', N'AZ', N'04013', N'85306', 33.61069, -112.181344, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (177, N'Honorhealth Deer Valley Medical Center', 1, NULL, NULL, N'030092', NULL, NULL, 0, 204, NULL, N'6238796100', N'6238795410', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19829 North 27Th Avenue', N'Phoenix', N'AZ', N'04013', N'85027', 33.665912, -112.117192, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (178, N'Banner Del E Webb Medical Center', 1, NULL, NULL, N'030093', NULL, NULL, 0, 375, NULL, N'6232144000', N'6235244105', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14502 West Meeker Boulevard', N'Sun City West', N'AZ', N'04013', N'85375', 33.658371, -112.371828, 418, 10, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (179, N'Abrazo Arrowhead Campus', 1, NULL, NULL, N'030094', NULL, NULL, 0, 217, NULL, N'6235611000', N'6235617142', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18701 North 67Th Avenue', N'Glendale', N'AZ', N'04013', N'85308', 33.653693, -112.202887, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (180, N'Western Arizona Regional Medical Center', 1, NULL, NULL, N'030101', NULL, NULL, 0, 139, NULL, N'9287632273', N'9287046785', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2735 Silver Creek Road', N'Bullhead City', N'AZ', N'04015', N'86442', 35.109878, -114.555412, 397, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (181, N'Mayo Clinic Hospital', 1, NULL, NULL, N'030103', NULL, NULL, 0, 268, NULL, N'4803422000', N'4803422525', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5777 East Mayo Boulevard', N'Phoenix', N'AZ', N'04013', N'85054', 33.660643, -111.951056, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (182, N'Banner Heart Hospital', 1, NULL, NULL, N'030105', NULL, NULL, 0, 111, NULL, N'4808545050', N'4808545011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6750 East Baywood Avenue', N'Mesa', N'AZ', N'04013', N'85206', 33.410382, -111.685419, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (183, N'Arizona Spine And Joint Hospital', 1, NULL, NULL, N'030107', NULL, NULL, 0, 23, NULL, N'4808324770', N'4808241269', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4620 East Baseline Road', N'Mesa', N'AZ', N'04013', N'85206', 33.379207, -111.734905, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (184, N'Core Institute Specialty Hospital The', 1, NULL, NULL, N'030108', NULL, NULL, 0, 33, NULL, N'6027956020', N'6027956022', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 North 19Th Avenue', N'Phoenix', N'AZ', N'04013', N'85015', 33.531394, -112.099637, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (185, N'Abrazo West Campus', 1, NULL, NULL, N'030110', NULL, NULL, 0, 164, NULL, N'6238821515', N'6238821510', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13677 West Mcdowell Road', N'odyear', N'AZ', N'04013', N'85395', 33.464285, -112.354176, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (186, N'Banner-University Medical Center South Campus', 1, NULL, NULL, N'030111', NULL, NULL, 0, 197, NULL, N'5202944471', N'5207414042', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 East Ajo Way', N'Tucson', N'AZ', N'04019', N'85713', 32.177882, -110.930891, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (187, N'Arizona Orthopedic And Surgical Speciality Hosp', 1, NULL, NULL, N'030112', NULL, NULL, 0, 24, NULL, N'4806039000', N'4806039107', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2905 West Warner Road', N'Chandler', N'AZ', N'04013', N'85224', 33.33484, -111.891133, 399, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (188, N'Whiteriver Phs Indian Hospital', 1, NULL, NULL, N'030113', NULL, NULL, 0, 40, NULL, N'9283384911', N'9283383530', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Hospital Drive  (Po Box 860)', N'Whiteriver', N'AZ', N'04017', N'85941', 33.875983, -109.959487, 415, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (189, N'Oro Valley Hospital', 1, NULL, NULL, N'030114', NULL, NULL, 0, 146, NULL, N'5209013549', N'5209013525', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1551 East Tangerine Road', N'Oro Valley', N'AZ', N'04019', N'85755', 32.426782, -110.951521, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (190, N'Banner Estrella Medical Center', 1, NULL, NULL, N'030115', NULL, NULL, 0, 214, NULL, N'6233274000', N'6233275110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9201 West Thomas Road', N'Phoenix', N'AZ', N'04013', N'85037', 33.479565, -112.257657, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (191, N'Valley View Medical Center', 1, NULL, NULL, N'030117', NULL, NULL, 0, 90, NULL, N'9287882273', N'9287887828', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5330 South Highway 95', N'Fort Mohave', N'AZ', N'04015', N'86426', 35.002638, -114.597956, 397, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (192, N'Yavapai Regional Medical Center-East Campus', 1, NULL, NULL, N'030118', NULL, NULL, 0, 72, NULL, N'9287715676', N'9284582015', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 East Florentine Road', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.588171, -112.330686, 412, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (193, N'Mercy Gilbert Medical Center', 1, NULL, NULL, N'030119', NULL, NULL, 0, 212, NULL, N'4807288000', N'4807289600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3555 South Val Vista Drive', N'Gilbert', N'AZ', N'04013', N'85296', 33.286661, -111.755311, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (194, N'Gilbert Hospital', 1, NULL, NULL, N'030120', NULL, NULL, 0, 19, NULL, N'4808403715', N'4802795836', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5656 South Power Road', N'Gilbert', N'AZ', N'04013', N'85295', 33.313777, -111.686798, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (195, N'Mountain Vista Medical Center Lp', 1, NULL, NULL, N'030121', NULL, NULL, 0, 178, NULL, N'4803586100', N'4803542678', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 South Crismon Road', N'Mesa', N'AZ', N'04013', N'85209', 33.391253, -111.615331, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (196, N'Banner Gateway Medical Center', 1, NULL, NULL, N'030122', NULL, NULL, 0, 177, NULL, N'4805432000', N'4805432299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North Higley Road', N'Gilbert', N'AZ', N'04013', N'85234', 33.38413, -111.719657, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (197, N'Scottsdale Thompson Peak Medical Center', 1, NULL, NULL, N'030123', NULL, NULL, 0, 64, NULL, N'4803247004', N'4803247010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Thompson Peak Parkway', N'Scottsdale', N'AZ', N'04013', N'85255', 33.669777, -111.921715, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (198, N'Banner Ironwood Medical Center', 1, NULL, NULL, N'030130', NULL, NULL, 0, 47, NULL, N'4803944030', N'4803944571', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'37000 North Gantzel Road', N'San Tan Valley', N'AZ', N'04021', N'85140', 33.213954, -111.56345, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (199, N'O.A.S.I.S. Hospital', 1, NULL, NULL, N'030131', NULL, NULL, 0, 64, NULL, N'6027977700', N'6027977979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 North 40Th Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.456823, -111.995208, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (200, N'Florence Hospital At Anthem Llc', 1, NULL, NULL, N'030132', NULL, NULL, 0, 36, NULL, N'5204242060', N'5204242507', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4545 North Hunt Highway', N'Florence', N'AZ', N'04021', N'85132', 33.075742, -111.487088, 403, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (201, N'Banner ldfield Medical Center', 1, NULL, NULL, N'030134', NULL, NULL, 0, 30, NULL, N'4807333300', N'4802373206', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 West Southern Avenue', N'Apache Junction', N'AZ', N'04021', N'85120', 33.393364, -111.566767, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (202, N'Dignity Health - Arizona General Hospital', 1, NULL, NULL, N'030136', NULL, NULL, 0, 16, NULL, N'6235845100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7171 South 51St Avenue', N'Laveen', N'AZ', N'04013', N'85339', 33.381471, -112.16824, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (203, N'Green Valley Hospital', 1, NULL, NULL, N'030137', NULL, NULL, 0, 49, NULL, N'6024718190', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4455 South I-19 Frontage Road', N'Green Valley', N'AZ', N'04019', N'85614', 31.854251, -110.993702, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (204, N'Wickenburg Community Hospital', 1, NULL, NULL, N'031300', NULL, NULL, 0, 19, NULL, N'9286845421', N'9286845081', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Rose Lane', N'Wickenburg', N'AZ', N'04013', N'85390', 33.978053, -112.739977, 420, 10, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (205, N'Benson Hospital', 1, NULL, NULL, N'031301', NULL, NULL, 0, 22, NULL, N'5205862261', N'5205862265', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 South Ocotillo Avenue', N'Benson', N'AZ', N'04003', N'85602', 31.964371, -110.307128, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (206, N'Northern Cochise Community Hospital', 1, NULL, NULL, N'031302', NULL, NULL, 0, 24, NULL, N'5203843541', N'5203846365', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Rex Allen Drive', N'Willcox', N'AZ', N'04003', N'85643', 32.264268, -109.837613, 421, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (207, N'Page Hospital', 1, NULL, NULL, N'031304', NULL, NULL, 0, 25, NULL, N'9286452424', N'9286453549', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North Navajo Drive', N'Page', N'AZ', N'04005', N'86040', 36.916837, -111.463714, 408, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (208, N'Hopi Health Care Center', 1, NULL, NULL, N'031305', NULL, NULL, 0, 15, NULL, N'9287376000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 264 Milepost 388', N'Polacca', N'AZ', N'04017', N'86042', 35.836672, -110.38152, 425, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (209, N'Parker Indian Health Center', 1, NULL, NULL, N'031307', NULL, NULL, 0, 20, NULL, N'9286692137', N'9286695860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12033 Agency Road', N'Parker', N'AZ', N'04012', N'85344', 34.150016, -114.289118, 409, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (210, N'Huhu Kam Memorial Hospital', 1, NULL, NULL, N'031308', NULL, NULL, 0, 15, NULL, N'5205623321', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'483 West Seed Farm Road', N'Sacaton', N'AZ', N'04021', N'85147', 33.076723, -111.739299, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (211, N'Sage Memorial Hospital', 1, NULL, NULL, N'031309', NULL, NULL, 0, 25, NULL, N'9287554559', N'9287554659', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'State Route 264 South 191 Po Box 457', N'Ganado', N'AZ', N'04001', N'86505', 35.71162, -109.542122, 404, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (212, N'Little Colorado Medical Center', 1, NULL, NULL, N'031311', NULL, NULL, 0, 25, NULL, N'9282894691', N'9282893855', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 North Williamson Avenue', N'Winslow', N'AZ', N'04017', N'86047', 35.035525, -110.691743, 422, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (213, N'Copper Queen Community Hospital', 1, NULL, NULL, N'031312', NULL, NULL, 0, 14, NULL, N'5204326401', N'5204321724', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Cole Avenue', N'Bisbee', N'AZ', N'04003', N'85603', 31.417714, -109.879997, 396, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (214, N'Holy Cross Hospital', 1, NULL, NULL, N'031313', NULL, NULL, 0, 25, NULL, N'5202853000', N'5202858015', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1171 West Target Range Road', N'Nogales', N'AZ', N'04023', N'85621', 31.341113, -110.958787, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (215, N'Cobre Valley Regional Medical Center', 1, NULL, NULL, N'031314', NULL, NULL, 0, 25, NULL, N'9284253261', N'9284257903', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5880 South Hospital Drive', N'Globe', N'AZ', N'04007', N'85501', 33.407666999999996, -110.82619, 428, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (216, N'White Mountain Regional Medical Center', 1, NULL, NULL, N'031315', NULL, NULL, 0, 25, NULL, N'9283334368', N'9283334369', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 South Mountain Avenue', N'Springerville', N'AZ', N'04001', N'85938', 34.132012, -109.286623, 417, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (217, N'La Paz Regional Hospital', 1, NULL, NULL, N'031317', NULL, NULL, 0, 25, NULL, N'9286699201', N'9286697417', 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Mohave Road', N'Parker', N'AZ', N'04012', N'85344', 34.135137, -114.285597, 409, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (218, N'Kindred Hospital Arizona Phoenix', 1, NULL, NULL, N'032000', NULL, NULL, 0, 116, NULL, N'6022807000', N'6022807299', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 East Indianola Avenue', N'Phoenix', N'AZ', N'04013', N'85012', 33.492466, -112.073274, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (219, N'Select Specialty Hospital Phoenix', 1, NULL, NULL, N'032001', NULL, NULL, 0, 48, NULL, N'6024066810', N'6024066891', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road 3Rd Floor', N'Phoenix', N'AZ', N'04013', N'85013', 33.480391, -112.07884, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (220, N'Kindred Hospital - Tucson', 1, NULL, NULL, N'032002', NULL, NULL, 0, 51, NULL, N'5205844500', N'5207908133', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 North Wilmot Road', N'Tucson', N'AZ', N'04019', N'85711', 32.223569, -110.857862, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (221, N'Chg Hospital Tucson Llc', 1, NULL, NULL, N'032004', NULL, NULL, 0, 34, NULL, N'5205464595', N'5202967630', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7220 East Rosewood Street', N'Tucson', N'AZ', N'04019', N'85710', 32.2309805, -110.8401997, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (222, N'Select Specialty Hospital Arizona', 1, NULL, NULL, N'032005', NULL, NULL, 0, 62, NULL, N'7179721100', N'4808826041', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 East Osborn Rd 3Rd Floor', N'Scottsdale', N'AZ', N'04013', N'85251', 33.488573, -111.922983, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (223, N'Promise Hospital Of Phoenix Inc', 1, NULL, NULL, N'032006', NULL, NULL, 0, 48, NULL, N'4804273000', N'4804273030', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 East 6Th Street', N'Mesa', N'AZ', N'04013', N'85203', 33.4253965, -111.8236259, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (224, N'Healthsouth Scottsdale Rehabilitation Hospital', 1, NULL, NULL, N'033025', NULL, NULL, 0, 60, NULL, N'4805515400', N'4806142155', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9630 East Shea Boulevard', N'Scottsdale', N'AZ', N'04013', N'85260', 33.582615, -111.87344, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (225, N'Healthsouth Rehabilitation Institute Of Tucson', 1, NULL, NULL, N'033028', NULL, NULL, 0, 80, NULL, N'5203251300', N'5203224400', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2650 North Wyatt Drive', N'Tucson', N'AZ', N'04019', N'85712', 32.255246, -110.883497, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (226, N'Healthsouth Rehabilitation Hospital Of Southern Az', 1, NULL, NULL, N'033029', NULL, NULL, 0, 60, NULL, N'5207422800', N'5207422639', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1921 West Hospital Drive', N'Tucson', N'AZ', N'04019', N'85704', 32.319199, -111.008284, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (227, N'Healthsouth Valley Of The Sun Rehabilitation', 1, NULL, NULL, N'033032', NULL, NULL, 0, 75, NULL, N'6238788800', N'6238785254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13460 North 67Th Avenue', N'Glendale', N'AZ', N'04013', N'85304', 33.607671, -112.202729, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (228, N'Yuma Rehabilitation Hospital', 1, NULL, NULL, N'033034', NULL, NULL, 0, 41, NULL, N'9287265000', N'9287265001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West 24Th Street', N'Yuma', N'AZ', N'04027', N'85364', 32.683887, -114.629933, 423, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (229, N'Mountain Valley Regional Rehabilitation Hospital', 1, NULL, NULL, N'033036', NULL, NULL, 0, 40, NULL, N'9287598800', N'9287598806', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 North Windsong Drive', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.590701, -112.326747, 412, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (230, N'Healthsouth East Valley Rehabilitation Hospital', 1, NULL, NULL, N'033037', NULL, NULL, 0, 60, NULL, N'4805670350', N'4805670352', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5652 East Baseline Road', N'Mesa', N'AZ', N'04013', N'85206', 33.379228, -111.713828, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (231, N'Honorhealth Rehabilitation Hospital', 1, NULL, NULL, N'033038', NULL, NULL, 0, 50, NULL, N'4808003900', N'4808003986', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8850 East Pima Center Parkway', N'Scottsdale', N'AZ', N'04013', N'85258', 33.509122, -111.899236, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (232, N'Los Ninos Hospital Inc', 1, NULL, NULL, N'033301', NULL, NULL, 0, 15, NULL, N'6029547311', N'6029547355', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2303 East Thomas', N'Phoenix', N'AZ', N'04013', N'85016', 33.4799805, -112.0345813, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (233, N'Phoenix Children''s Hospital', 1, NULL, NULL, N'033302', NULL, NULL, 0, 385, NULL, N'6029331000', N'6029330394', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1919 East Thomas Road', N'Phoenix', N'AZ', N'04013', N'85016', 33.480216, -112.041193, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (234, N'Banner Behavioral Health Hospital', 1, NULL, NULL, N'034004', NULL, NULL, 0, 78, NULL, N'4809417500', N'4809417548', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7575 East Earll Drive', N'Scottsdale', N'AZ', N'04013', N'85251', 33.483002, -111.918606, 414, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (235, N'St. Luke''s Behavioral Hospital Lp', 1, NULL, NULL, N'034013', NULL, NULL, 0, 124, NULL, N'6022518535', N'6022518707', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Van Buren', N'Phoenix', N'AZ', N'04013', N'85006', 33.4544896, -112.0445449, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (236, N'Haven Senior Horizons', 1, NULL, NULL, N'034020', NULL, NULL, 0, 19, NULL, N'6232362000', N'6022520032', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 South 7Th Avenue Suite 200', N'Phoenix', N'AZ', N'04013', N'85007', 33.436072, -112.082419, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (237, N'Arizona State Hospital', 1, NULL, NULL, N'034021', NULL, NULL, 0, 475, NULL, N'6022206000', N'6022206292', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 East Van Buren Street', N'Phoenix', N'AZ', N'04013', N'85008', 33.451427, -112.027658, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (238, N'Sonora Behavioral Health Hospital', 1, NULL, NULL, N'034022', NULL, NULL, 0, 56, NULL, N'5204698700', N'5208782320', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6050 North Corona Road', N'Tucson', N'AZ', N'04019', N'85704', 32.316672, -111.007814, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (239, N'Guidance Center The', 1, NULL, NULL, N'034023', NULL, NULL, 0, 16, NULL, N'9285271899', N'9287146480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2187 North Vickey Street', N'Flagstaff', N'AZ', N'04005', N'86004', 35.170264, -111.663254, 402, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (240, N'Aurora Behavioral Health System', 1, NULL, NULL, N'034024', NULL, NULL, 0, 90, NULL, N'6233444400', N'6237760343', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6015 West Peoria  Avenue', N'Glendale', N'AZ', N'04013', N'85302', 33.581969, -112.168926, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (241, N'Windhaven Psychiatric Hospital', 1, NULL, NULL, N'034025', NULL, NULL, 0, 16, NULL, N'9288997343', N'9284459522', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3347 North Windsong Drive', N'Prescott Valley', N'AZ', N'04025', N'86314', 34.590701, -112.326747, 412, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (242, N'Valley Hospital', 1, NULL, NULL, N'034026', NULL, NULL, 0, 122, NULL, N'6029574000', N'6029523921', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 East Pinchot Avenue', N'Phoenix', N'AZ', N'04013', N'85018', 33.482386, -112.005262, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (243, N'Community Counseling Ctrs Inc At Pineview Hospital', 1, NULL, NULL, N'034027', NULL, NULL, 0, 16, NULL, N'9283684110', N'9283684112', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1920 West Commerce Drive', N'Lakeside', N'AZ', N'04017', N'85929', 34.154488, -109.97344, 415, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (244, N'Aurora Behavioral Healthcare-Tempe', 1, NULL, NULL, N'034028', NULL, NULL, 0, 75, NULL, N'4803455400', N'4803455450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6350 South Maple Avenue', N'Tempe', N'AZ', N'04013', N'85283', 33.362633, -111.939137, 407, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (245, N'Oasis Behavioral Health Hospital', 1, NULL, NULL, N'034029', NULL, NULL, 0, 47, NULL, N'4809179301', N'4809170503', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2190 North Grace Boulevard', N'Chandler', N'AZ', N'04013', N'85225', 33.337643, -111.847175, 399, 8, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (246, N'Palo Verde Behavioral Health', 1, NULL, NULL, N'034030', NULL, NULL, 0, 48, NULL, N'5203222888', N'5203222792', 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2695 North Craycroft Road', N'Tucson', N'AZ', N'04019', N'85712', 32.255807, -110.875369, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (247, N'Quail Run Behavioral Health', 1, NULL, NULL, N'034031', NULL, NULL, 0, 102, NULL, N'6024555694', N'9403840402', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2545 West Quail Avenue', N'Phoenix', N'AZ', N'04013', N'85027', 33.67836, -112.113564, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (248, N'University Medical Center At The Arizona Health Sc', 1, NULL, NULL, N'039800', NULL, NULL, 0, 0, NULL, N'5206947367', N'5206947368', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1501 North Campbell Avenue', N'Tucson', N'AZ', N'04019', N'85724', 32.24053, -110.944076, 419, 11, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (249, N'Mayo Clinic Hospital', 1, NULL, NULL, N'039801', NULL, NULL, 0, 0, NULL, N'4803421900', N'4803422525', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5777 East Mayo Boulevard', N'Phoenix', N'AZ', N'04013', N'85054', 33.663713, -111.959332, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (250, N'Banner od Samaritan Medical Center', 1, NULL, NULL, N'039802', NULL, NULL, 0, 0, NULL, N'6022392716', N'6022393749', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1300 North 12Th Street Suite 404', N'Phoenix', N'AZ', N'04013', N'85006', 33.462702, -112.056479, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (251, N'St Joseph''s Hospital And Medical Center', 1, NULL, NULL, N'039803', NULL, NULL, 0, 0, NULL, N'6024063792', N'6027989884', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'350 West Thomas Road Suite #500', N'Phoenix', N'AZ', N'04013', N'85013', 33.480391, -112.07884, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (252, N'Phoenix Childrens Hospital', 1, NULL, NULL, N'039804', NULL, NULL, 0, 0, NULL, N'6025461000', N'6025460394', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1919 East Thomas Road', N'Phoenix', N'AZ', N'04013', N'85016', 33.480201, -112.040414, 411, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (253, N'Siloam Springs Regional Hospital', 1, NULL, NULL, N'040001', NULL, NULL, 0, 73, NULL, N'4795244141', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 North Progress Avenue', N'Siloam Springs', N'AR', N'05007', N'72761', 36.188656, -94.510476, 487, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (254, N'Johnson Regional Medical Center', 1, NULL, NULL, N'040002', NULL, NULL, 0, 90, NULL, N'4797545454', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East Poplar Street', N'Clarksville', N'AR', N'05071', N'72830', 35.464398, -93.446201, 440, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (255, N'Washington Regional Medical Center', 1, NULL, NULL, N'040004', NULL, NULL, 0, 269, NULL, N'4794635113', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3215 N North Hills Boulevard', N'Fayetteville', N'AR', N'05143', N'72703', 36.108324, -94.155932, 450, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (256, N'Chi-St Vincent Infirmary', 1, NULL, NULL, N'040007', NULL, NULL, 0, 897, NULL, N'5015523000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two St Vincent Circle', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (257, N'Mercy Hospital Northwest Arkansas', 1, NULL, NULL, N'040010', NULL, NULL, 0, 208, NULL, N'4793388000', N'4793382906', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2710 Rife Medical Lane', N'Rogers', N'AR', N'05007', N'72758', 36.311744, -94.183767, 483, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (258, N'Chambers Memorial Hospital', 1, NULL, NULL, N'040011', NULL, NULL, 0, 41, NULL, N'4794952241', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 Detroit Street', N'Danville', N'AR', N'05149', N'72833', 35.055046, -93.388606, 443, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (259, N'White County Medical Center', 1, NULL, NULL, N'040014', NULL, NULL, 0, 438, NULL, N'5012783100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3214 East Race Avenue', N'Searcy', N'AR', N'05145', N'72143', 35.250418, -91.694198, 486, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (260, N'Mena Regional Health System', 1, NULL, NULL, N'040015', NULL, NULL, 0, 65, NULL, N'4793946100', N'4793944577', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 North Morrow Street', N'Mena', N'AR', N'05113', N'71953', 34.588476, -94.222504, 467, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (261, N'Uams Medical Center', 1, NULL, NULL, N'040016', NULL, NULL, 0, 430, NULL, N'5016865000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 West Markham Street Mail Slot 612', N'Little Rock', N'AR', N'05119', N'72205', 34.751583, -92.320998, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (262, N'North Arkansas Regional Medical Center', 1, NULL, NULL, N'040017', NULL, NULL, 0, 174, NULL, N'8704144000', N'8704145129', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 North Main Street', N'Harrison', N'AR', N'05009', N'72601', 36.236286, -93.107146, 455, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (263, N'Sparks Medical Center - Van Buren', 1, NULL, NULL, N'040018', NULL, NULL, 0, 103, NULL, N'4794743401', N'4794740113', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'East Main And South 20Th Street', N'Van Buren', N'AR', N'05033', N'72956', 35.436756, -94.348268, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (264, N'Forrest City Medical Center', 1, NULL, NULL, N'040019', NULL, NULL, 0, 118, NULL, N'8702610000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Newcastle Road', N'Forrest City', N'AR', N'05123', N'72335', 35.026618, -90.776192, 452, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (265, N'St Bernards Medical Center', 1, NULL, NULL, N'040020', NULL, NULL, 0, 378, NULL, N'8709724100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 E Jackson', N'Jonesboro', N'AR', N'05031', N'72401', 35.837461, -90.703774, 461, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (266, N'Northwest Medical Center-Springdale', 1, NULL, NULL, N'040022', NULL, NULL, 0, 414, NULL, N'4797515711', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 West Maple Avenue', N'Springdale', N'AR', N'05143', N'72764', 36.181392, -94.136202, 488, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (267, N'Chi St. Vincent Hospital Hot Springs', 1, NULL, NULL, N'040026', NULL, NULL, 0, 282, NULL, N'5016221000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Werner Street', N'Hot Springs', N'AR', N'05051', N'71903', 34.466063, -93.067981, 459, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (268, N'Baxter Regional Medical Center', 1, NULL, NULL, N'040027', NULL, NULL, 0, 268, NULL, N'8705081000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 Hospital Drive', N'Mountain Home', N'AR', N'05005', N'72653', 36.342777, -92.395305, 470, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (269, N'Conway Regional Medical Center', 1, NULL, NULL, N'040029', NULL, NULL, 0, 154, NULL, N'5013293831', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2302 College Avenue', N'Conway', N'AR', N'05045', N'72034', 35.084839, -92.456768, 441, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (270, N'Baptist Health Medical Center North Little Rock', 1, NULL, NULL, N'040036', NULL, NULL, 0, 225, NULL, N'5012023000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Springhill Drive', N'North Little Rock', N'AR', N'05119', N'72117', 34.785114, -92.219506, 475, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (271, N'Arkansas Methodist Medical Center', 1, NULL, NULL, N'040039', NULL, NULL, 0, 129, NULL, N'8702397000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 West Kingshighway', N'Parauld', N'AR', N'05055', N'72450', 36.052588, -90.497709, 478, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (272, N'St Marys Regional Medical Center', 1, NULL, NULL, N'040041', NULL, NULL, 0, 170, NULL, N'4799682841', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1808 West Main Street', N'Russellville', N'AR', N'05115', N'72801', 35.282875, -93.149958, 484, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (273, N'Five Rivers Medical Center', 1, NULL, NULL, N'040047', NULL, NULL, 0, 50, NULL, N'8708926000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Medical Center Drive', N'Pocahontas', N'AR', N'05121', N'72455', 36.289948, -90.996181, 481, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (274, N'Ouachita County Medical Center', 1, NULL, NULL, N'040050', NULL, NULL, 0, 98, NULL, N'8708361000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'638 California Avenue', N'Camden', N'AR', N'05103', N'71701', 33.576637, -92.834033, 438, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (275, N'Drew Memorial Hospital', 1, NULL, NULL, N'040051', NULL, NULL, 0, 49, NULL, N'8703672411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'778 Scogin Drive', N'Monticello', N'AR', N'05043', N'71655', 33.60554, -91.81504, 468, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (276, N'Sparks Regional Medical Center', 1, NULL, NULL, N'040055', NULL, NULL, 0, 492, NULL, N'4794414000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Towson Avenue', N'Fort Smith', N'AR', N'05131', N'72902', 35.374465, -94.421312, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (277, N'St Edward Mercy Medical Center', 1, NULL, NULL, N'040062', NULL, NULL, 0, 360, NULL, N'4793146000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7301 Rogers Ave', N'Fort Smith', N'AR', N'05131', N'72917', 35.353647, -94.352964, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (278, N'Magnolia Hospital', 1, NULL, NULL, N'040067', NULL, NULL, 0, 70, NULL, N'8702353000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Drive', N'Magnolia', N'AR', N'05027', N'71754', 33.275073, -93.240113, 464, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (279, N'Great River Medical Center', 1, NULL, NULL, N'040069', NULL, NULL, 0, 168, NULL, N'8708387300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1520 N Division Street', N'Blytheville', N'AR', N'05093', N'72315', 35.943011, -89.918929, 435, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (280, N'Jefferson Regional Medical Center', 1, NULL, NULL, N'040071', NULL, NULL, 0, 471, NULL, N'8705417100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West 40Th Avenue', N'Pine Bluff', N'AR', N'05069', N'71603', 34.189117, -92.021094, 480, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (281, N'Baptist Health Medical Center-Stuttgart', 1, NULL, NULL, N'040072', NULL, NULL, 0, 49, NULL, N'8706733511', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1703 North Buerkle Road', N'Stuttgart', N'AR', N'05001', N'72160', 34.521968, -91.557478, 489, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (282, N'North Metro Medical Center', 1, NULL, NULL, N'040074', NULL, NULL, 0, 113, NULL, N'5019857000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Braden Street', N'Jacksonville', N'AR', N'05119', N'72076', 34.872352, -92.123476, 460, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (283, N'Baptist Health Medical Center-Hot Springs County', 1, NULL, NULL, N'040076', NULL, NULL, 0, 72, NULL, N'5013321000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Schneider Drive', N'Malvern', N'AR', N'05059', N'72104', 34.360178, -92.785664, 465, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (284, N'National Park Medical Center', 1, NULL, NULL, N'040078', NULL, NULL, 0, 176, NULL, N'5013211000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 Malvern Avenue', N'Hot Springs', N'AR', N'05051', N'71901', 34.486774, -93.033917, 459, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (285, N'Unity Health Harris Medical Center', 1, NULL, NULL, N'040080', NULL, NULL, 0, 133, NULL, N'8705238911', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 Mclain Street', N'Newport', N'AR', N'05067', N'72112', 35.608076, -91.264796, 474, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (286, N'Saline Memorial Hospital', 1, NULL, NULL, N'040084', NULL, NULL, 0, 177, NULL, N'5017766000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#1 Medical Park Drive', N'Benton', N'AR', N'05125', N'72015', 34.572716, -92.585094, 432, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (287, N'Helena Regional Medical Center', 1, NULL, NULL, N'040085', NULL, NULL, 0, 155, NULL, N'8703385800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Martin Luther King Jr Drive', N'Helena', N'AR', N'05107', N'72342', 34.502662, -90.605579, 457, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (288, N'Medical Center South Arkansas', 1, NULL, NULL, N'040088', NULL, NULL, 0, 149, NULL, N'8708632000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Grove Street', N'El Dorado', N'AR', N'05139', N'71731', 33.218363, -92.672295, 448, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (289, N'Baptist Health Medical Center-Little Rock', 1, NULL, NULL, N'040114', NULL, NULL, 0, 843, NULL, N'5012022000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (290, N'Nea Baptist Memorial Hospital', 1, NULL, NULL, N'040118', NULL, NULL, 0, 192, NULL, N'8709727000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 East Johnson Avenue', N'Jonesboro', N'AR', N'05031', N'72401', 35.864204, -90.639107, 461, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (291, N'White River Medical Center', 1, NULL, NULL, N'040119', NULL, NULL, 0, 224, NULL, N'8702621200', N'5012621458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Harrison Street', N'Batesville', N'AR', N'05063', N'72503', 35.769573, -91.63472, 431, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (292, N'Leo N Levi National Arthritis Hospital', 1, NULL, NULL, N'040132', NULL, NULL, 0, 50, NULL, N'5016241281', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Prospect Ave', N'Hot Springs', N'AR', N'05051', N'71901', 34.509615, -93.057381, 459, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (293, N'Arkansas Heart Hospital Llc', 1, NULL, NULL, N'040134', NULL, NULL, 0, 110, NULL, N'5012197000', N'5012197402', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 S Shackleford Road', N'Little Rock', N'AR', N'05119', N'72211', 34.739288, -92.394419, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (294, N'St Vincent Medical Center/North', 1, NULL, NULL, N'040137', NULL, NULL, 0, 69, NULL, N'5015527100', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Wildwood Avenue', N'Sherwood', N'AR', N'05119', N'72120', 34.814389, -92.208366, 475, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (295, N'Arkansas Surgical Hospital', 1, NULL, NULL, N'040147', NULL, NULL, 0, 51, NULL, N'5017488000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5201 North Shore Drive', N'No Little Rock', N'AR', N'05119', N'72118', 35.204888, -92.447911, 475, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (296, N'Physicians'' Specialty Hospital', 1, NULL, NULL, N'040152', NULL, NULL, 0, 21, NULL, N'4795717002', N'4794437531', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3873 North Parkview Drive', N'Fayetteville', N'AR', N'05143', N'72703', 36.121329, -94.13373, 450, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (297, N'Wadley Regional Medical Center At Hope', 1, NULL, NULL, N'040153', NULL, NULL, 0, 79, NULL, N'8707223800', N'9037988030', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 South Main', N'Hope', N'AR', N'05057', N'71801', 33.648271, -93.587047, 458, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (298, N'North Logan Mercy Hospital', 1, NULL, NULL, N'041300', NULL, NULL, 0, 16, NULL, N'4799636101', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East Academy', N'Paris', N'AR', N'05083', N'72855', 35.289985, -93.725168, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (299, N'River Valley Medical Center', 1, NULL, NULL, N'041302', NULL, NULL, 0, 35, NULL, N'4792294677', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North Third Street', N'Dardanelle', N'AR', N'05149', N'72834', 35.220205, -93.156605, 444, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (300, N'Mercy Hospital Turner Memorial', 1, NULL, NULL, N'041303', NULL, NULL, 0, 25, NULL, N'4796674138', N'4796679778', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 West River Street', N'Ozark', N'AR', N'05047', N'72949', 35.486054, -93.833458, 477, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (301, N'Eureka Springs Hospital Llc', 1, NULL, NULL, N'041304', NULL, NULL, 0, 15, NULL, N'4792537400', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Norris Street', N'Eureka Springs', N'AR', N'05015', N'72632', 36.400516, -93.744146, 449, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (302, N'St Edward Health Facilities Of Scott County', 1, NULL, NULL, N'041305', NULL, NULL, 0, 24, NULL, N'4796374135', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1341 West Sixth Street', N'Waldron', N'AR', N'05127', N'72958', 34.898432, -94.090763, 491, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (303, N'Community Medical Center Izard County', 1, NULL, NULL, N'041306', NULL, NULL, 0, 25, NULL, N'8702973726', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 Grasse Street', N'Calico Rock', N'AR', N'05065', N'72519', 36.125864, -92.128577, 437, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (304, N'Crossridge Community Hospital', 1, NULL, NULL, N'041307', NULL, NULL, 0, 25, NULL, N'8702383300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Falls Boulevard', N'Wynne', N'AR', N'05037', N'72396', 35.221107, -90.787405, 494, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (305, N'Mcgehee Hospital', 1, NULL, NULL, N'041308', NULL, NULL, 0, 25, NULL, N'8702225600', N'8702224260', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'900 South Third Street', N'Mcgehee', N'AR', N'05041', N'71654', 33.618708, -91.393365, 466, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (306, N'Lawrence Memorial Hospital', 1, NULL, NULL, N'041309', NULL, NULL, 0, 25, NULL, N'8708861200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 West Main', N'Walnut Ridge', N'AR', N'05075', N'72476', 36.074701, -90.966982, 461, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (307, N'Stone County Medical Center', 1, NULL, NULL, N'041310', NULL, NULL, 0, 25, NULL, N'8702694361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2106 East Main Street', N'Mountain View', N'AR', N'05137', N'72560', 35.855598, -92.082727, 471, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (308, N'Howard Memorial Hospital', 1, NULL, NULL, N'041311', NULL, NULL, 0, 25, NULL, N'8708454400', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Medical Circle', N'Nashville', N'AR', N'05061', N'71852', 33.949818, -93.879939, 473, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (309, N'Baptist Health Medical Center Heber Spings', 1, NULL, NULL, N'041312', NULL, NULL, 0, 25, NULL, N'5018873000', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Bypass Road', N'Heber Springs', N'AR', N'05023', N'72543', 35.491468, -92.03126, 456, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (310, N'Ozark Health', 1, NULL, NULL, N'041313', NULL, NULL, 0, 25, NULL, N'5017457000', N'5017459701', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Highway 65 South', N'Clinton', N'AR', N'05141', N'72031', 35.559635, -92.449991, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (311, N'Dewitt Hospital & Nursing Home Inc', 1, NULL, NULL, N'041314', NULL, NULL, 0, 25, NULL, N'8709463571', N'8709464577', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1641 Whitehead Drive', N'De Witt', N'AR', N'05001', N'72042', 34.27966, -91.336798, 446, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (312, N'South Missississpi County Regional Medical Center', 1, NULL, NULL, N'041316', NULL, NULL, 0, 25, NULL, N'8705637000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 West Lee Avenue', N'Osceola', N'AR', N'05093', N'72370', 35.700248, -89.975731, 476, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (313, N'Dallas County Medical Center', 1, NULL, NULL, N'041317', NULL, NULL, 0, 25, NULL, N'8703526300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Clifton Street', N'Fordyce', N'AR', N'05039', N'71742', 33.808184, -92.42557, 451, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (314, N'Mercy Hospital Booneville', 1, NULL, NULL, N'041318', NULL, NULL, 0, 25, NULL, N'4796752800', N'4796753406', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 West Main', N'Booneville', N'AR', N'05083', N'72927', 35.141205, -93.93635, 436, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (315, N'De Queen Medical Center Inc', 1, NULL, NULL, N'041319', NULL, NULL, 0, 35, NULL, N'8705844111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 West Collin Raye Drive', N'De Queen', N'AR', N'05133', N'71832', 34.046277, -94.356155, 445, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (316, N'Little River Memorial Hospital', 1, NULL, NULL, N'041320', NULL, NULL, 0, 25, NULL, N'8708985011', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 West Locke Street', N'Ashdown', N'AR', N'05081', N'71822', 33.669566, -94.134808, 430, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (317, N'Baptist Health Medical Center-Arkadelphia', 1, NULL, NULL, N'041321', NULL, NULL, 0, 25, NULL, N'8702452622', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Twin Rivers Drive', N'Arkadelphia', N'AR', N'05019', N'71923', 34.12259, -93.087637, 429, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (318, N'Fulton County Hospital', 1, NULL, NULL, N'041322', NULL, NULL, 0, 25, NULL, N'8708952691', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'679 North Main Street', N'Salem', N'AR', N'05049', N'72576', 36.383085, -91.812149, 485, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (319, N'Ashley County Medical Center', 1, NULL, NULL, N'041323', NULL, NULL, 0, 33, NULL, N'8703644111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Unity Road', N'Crossett', N'AR', N'05003', N'71635', 33.137928, -91.943174, 442, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (320, N'Chi St Vincent Morrilton', 1, NULL, NULL, N'041324', NULL, NULL, 0, 35, NULL, N'5019772300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#4 Hospital Drive', N'Morrilton', N'AR', N'05029', N'72110', 35.167569, -92.720273, 469, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (321, N'Delta Memorial Hospital', 1, NULL, NULL, N'041326', NULL, NULL, 0, 25, NULL, N'8703824303', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 Highway 65 South', N'Dumas', N'AR', N'05041', N'71639', 33.887048, -91.49179, 447, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (322, N'Bradley County Medical Center', 1, NULL, NULL, N'041327', NULL, NULL, 0, 35, NULL, N'8702263731', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 South Bradley Street', N'Warren', N'AR', N'05011', N'71671', 33.610669, -92.058638, 492, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (323, N'Chicot Memorial Medical Center', 1, NULL, NULL, N'041328', NULL, NULL, 0, 25, NULL, N'8702655351', N'8702652091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2729 South Highway 65 & 82', N'Lake Village', N'AR', N'05017', N'71653', 33.334123, -91.284001, 462, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (324, N'Mercy Hospital Berryville', 1, NULL, NULL, N'041329', NULL, NULL, 0, 25, NULL, N'8704233355', N'8704235268', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 Carter Street', N'Berryville', N'AR', N'05015', N'72616', 36.358217, -93.552029, 434, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (325, N'Pigtt Community Hospital', 1, NULL, NULL, N'041330', NULL, NULL, 0, 25, NULL, N'8705983881', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1206 rdon Duckworth Drive', N'Pigtt', N'AR', N'05021', N'72454', 36.390042, -90.204179, 479, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (326, N'Ozarks Community Hospital Of Gravette', 1, NULL, NULL, N'041331', NULL, NULL, 0, 25, NULL, N'4797875291', N'4797877890', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Jackson Street Sw', N'Gravette', N'AR', N'05007', N'72736', 36.409402, -94.460968, 454, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (327, N'Christus Dubuis Hospital Of Hot Springs', 1, NULL, NULL, N'042004', NULL, NULL, 0, 27, NULL, N'5016094333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Werner Street 3Rd Floor', N'Hot Springs', N'AR', N'05051', N'71913', 34.466148, -93.068649, 459, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (328, N'Select Speciality Hospital-Fort Smith Inc', 1, NULL, NULL, N'042006', NULL, NULL, 0, 34, NULL, N'4794413960', N'4794413961', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Towson Avenue', N'Fort Smith', N'AR', N'05131', N'72901', 35.374599, -94.421223, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (329, N'Christus Dubuis Hospital Of Fort Smith', 1, NULL, NULL, N'042008', NULL, NULL, 0, 25, NULL, N'4793144900', N'4793144999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7301 Rogers Avenue # 4', N'Fort Smith', N'AR', N'05131', N'72903', 35.35297, -94.351235, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (330, N'Regency Hospital Of Northwest Arkansas', 1, NULL, NULL, N'042009', NULL, NULL, 0, 50, NULL, N'4797137000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 West Maple Avenue', N'Springdale', N'AR', N'05143', N'72764', 36.186744, -94.128814, 488, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (331, N'Cornerstone Hospital Little Rock', 1, NULL, NULL, N'042010', NULL, NULL, 0, 40, NULL, N'5019857467', N'5019857162', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 St Vincent Circle 6Th Floor', N'Little Rock', N'AR', N'05119', N'72205', 34.749889, -92.340796, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (332, N'Advanced Care Hospital White County', 1, NULL, NULL, N'042011', NULL, NULL, 0, 27, NULL, N'5012783155', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 South Main Street', N'Searcy', N'AR', N'05145', N'72143', 35.226916, -91.732221, 486, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (333, N'Baptist Health Extended Care Hospital-Lr Inc', 1, NULL, NULL, N'042012', NULL, NULL, 0, 37, NULL, N'5012026000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 I-630 Exit 7 10Th Fl', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (334, N'Baptist Health Rehabilitation Institute', 1, NULL, NULL, N'043026', NULL, NULL, 0, 120, NULL, N'5012027578', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (335, N'Healthsouth Rehabilitation Hospital Of Fort Smith', 1, NULL, NULL, N'043028', NULL, NULL, 0, 80, NULL, N'4797853300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South J Street', N'Fort Smith', N'AR', N'05131', N'72901', 35.387222, -94.424898, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (336, N'Healthsouth Rehabilitation Hospital Of Jonesboro', 1, NULL, NULL, N'043029', NULL, NULL, 0, 67, NULL, N'8709320440', N'8709326792', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Fleming Ave', N'Jonesboro', N'AR', N'05031', N'72401', 35.833155, -90.692542, 461, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (337, N'St Vincent Rehab Hosp In Part Hlthsout', 1, NULL, NULL, N'043031', NULL, NULL, 0, 60, NULL, N'5018341800', N'5018342227', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Wildwood Avenue', N'Sherwood', N'AR', N'05119', N'72120', 34.814354, -92.206206, 475, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (338, N'Healthsouth Rehab Hosp In Part W/Washington Region', 1, NULL, NULL, N'043032', NULL, NULL, 0, 60, NULL, N'4794442200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'153 E Monte Painter Drive', N'Fayetteville', N'AR', N'05143', N'72703', 36.109085, -94.154829, 450, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (339, N'Conway Regional Rehabilitation Hospital', 1, NULL, NULL, N'043033', NULL, NULL, 0, 26, NULL, N'5019323500', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2210 Robinson Street', N'Conway', N'AR', N'05045', N'72034', 35.088696, -92.442101, 441, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (340, N'Southeast Rehabilitation Hospital', 1, NULL, NULL, N'043034', NULL, NULL, 0, 15, NULL, N'8702655343', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2729 A Highway 65 & 82 South', N'Lake Village', N'AR', N'05017', N'71653', 33.334123, -91.284001, 462, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (341, N'Arkansas Children''s Hospital', 1, NULL, NULL, N'043300', NULL, NULL, 0, 280, NULL, N'5013641100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Marshall Street Slot 301', N'Little Rock', N'AR', N'05119', N'72202', 34.742504, -92.291504, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (342, N'Vantage Point Of Northwest Arkansas', 1, NULL, NULL, N'044004', NULL, NULL, 0, 108, NULL, N'4795215731', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4253 Crossover Road', N'Fayetteville', N'AR', N'05143', N'72703', 36.111508, -94.209867, 450, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (343, N'Bridgeway Inc The', 1, NULL, NULL, N'044005', NULL, NULL, 0, 103, NULL, N'5017711500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21 Bridgeway Road', N'North Little Rock', N'AR', N'05119', N'72113', 34.782339, -92.161472, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (344, N'Valley Behavioral Health System', 1, NULL, NULL, N'044006', NULL, NULL, 0, 75, NULL, N'4794945700', N'4794945777', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10301 Mayo Drive', N'Barling', N'AR', N'05131', N'72923', 35.338778, -94.318523, 453, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (345, N'Rivendell Behavioral Health Services Of Arkansas', 1, NULL, NULL, N'044007', NULL, NULL, 0, 79, NULL, N'5013161255', N'5017940908', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Rivendell Drive', N'Benton', N'AR', N'05125', N'72019', 34.612071, -92.530695, 432, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (346, N'Arkansas State Hospital', 1, NULL, NULL, N'044011', NULL, NULL, 0, 321, NULL, N'5016869000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 S Palm Street', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (347, N'Pinnacle Pointe Hospital', 1, NULL, NULL, N'044013', NULL, NULL, 0, 124, NULL, N'5012233322', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11501 Financial Centre Parkway', N'Little Rock', N'AR', N'05119', N'72211', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (348, N'United Methodist Behavioral Hospital', 1, NULL, NULL, N'044017', NULL, NULL, 0, 60, NULL, N'5018033388', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Murphy Drive', N'Maumelle', N'AR', N'05119', N'72113', 34.877447, -92.39423, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (349, N'Springwoods Behavioral Health Services', 1, NULL, NULL, N'044019', NULL, NULL, 0, 80, NULL, N'4799736000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1955 West Trucker''s Drive', N'Fayetteville', N'AR', N'05143', N'72704', 36.108959, -94.182873, 450, 15, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (350, N'Riverview Behavioral Health', 1, NULL, NULL, N'044020', NULL, NULL, 0, 62, NULL, N'8707725028', N'8707722138', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Arkansas Boulevard Suite 300', N'Texarkana', N'AR', N'05091', N'71854', 33.460267, -94.034479, 490, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (351, N'Oakridge Behavioral Center', 1, NULL, NULL, N'044021', NULL, NULL, 0, 52, NULL, N'8703944113', N'8703949701', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North 7Th Street', N'West Memphis', N'AR', N'05035', N'72301', 35.156012, -90.17595, 493, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (352, N'Arkansas Children''s Hospital', 1, NULL, NULL, N'049801', NULL, NULL, 0, 0, NULL, N'5013641847', N'5013641780', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 Marshall Street', N'Little Rock', N'AR', N'05119', N'72202', 34.743407, -92.291362, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (353, N'Baptist Health Medical Center', 1, NULL, NULL, N'049802', NULL, NULL, 0, 0, NULL, N'5012021500', N'5012021357', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9601 Interstate 630 Exit 7', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (354, N'University Of Arkansas Medical Sciences-Transplant', 1, NULL, NULL, N'049803', NULL, NULL, 0, 0, NULL, N'5016031074', N'5016865725', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Transplant Surgery Slot 520-4 4301 W Markham', N'Little Rock', N'AR', N'05119', N'72205', 34.746481, -92.289595, 463, 14, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (355, N'St Rose Hospital', 1, NULL, NULL, N'050002', NULL, NULL, 0, 129, NULL, N'5107826200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27200 Calaroga Ave', N'Hayward', N'CA', N'06001', N'94545', 37.633409, -122.089812, 572, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (356, N'St Joseph Hospital', 1, NULL, NULL, N'050006', NULL, NULL, 0, 140, NULL, N'7074458121', N'7072693897', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Dolbeer St', N'Eureka', N'CA', N'06023', N'95501', 40.782346, -124.142047, 546, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (357, N'Mills-Peninsula Medical Center', 1, NULL, NULL, N'050007', NULL, NULL, 0, 301, NULL, N'6506965270', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Trousdale Drive', N'Burlingame', N'CA', N'06081', N'94010', 37.592591, -122.385318, 515, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (358, N'California Pacific Medical Ctr-Davies Campus Hosp', 1, NULL, NULL, N'050008', NULL, NULL, 0, 341, NULL, N'4156006000', N'4156008666', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Duboce Ave', N'San Francisco', N'CA', N'06075', N'94117', 37.769114, -122.434706, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (359, N'Queen Of The Valley Medical Center', 1, NULL, NULL, N'050009', NULL, NULL, 0, 171, NULL, N'7072524411', N'7072574173', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Trancas St', N'Napa', N'CA', N'06055', N'94558', 38.323554, -122.295968, 614, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (360, N'St Helena Hospital', 1, NULL, NULL, N'050013', NULL, NULL, 0, 181, NULL, N'7079633611', N'7079675712', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Woodland Road', N'Saint Helena', N'CA', N'06055', N'94574', 38.542024, -122.475271, 537, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (361, N'Sutter Amador Hospital', 1, NULL, NULL, N'050014', NULL, NULL, 0, 84, NULL, N'2092237500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Mission Blvd', N'Jackson', N'CA', N'06005', N'95642', 38.349554, -120.765903, 579, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (362, N'Marian Regional Medical Center Arroyo Grande', 1, NULL, NULL, N'050016', NULL, NULL, 0, 67, NULL, N'8054894261', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 S Halcyon Rd', N'Arroyo Grande', N'CA', N'06079', N'93420', 35.134377, -120.570432, 502, 34, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (363, N'Mercy General Hospital', 1, NULL, NULL, N'050017', NULL, NULL, 0, 300, NULL, N'9164534545', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4001 J St', N'Sacramento', N'CA', N'06067', N'95819', 38.569319, -121.452238, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (364, N'Pacific Alliance Medical Center', 1, NULL, NULL, N'050018', NULL, NULL, 0, 155, NULL, N'2136248411', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'531 W College St', N'Los Angeles', N'CA', N'06037', N'90012', 34.064729, -118.239532, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (365, N'Riverside Community Hospital', 1, NULL, NULL, N'050022', NULL, NULL, 0, 369, NULL, N'9517883000', N'9517883494', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4445 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92501', 33.975701, -117.380349, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (366, N'Paradise Valley Hospital', 1, NULL, NULL, N'050024', NULL, NULL, 0, 237, NULL, N'6194704321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 East 4Th St', N'National City', N'CA', N'06073', N'91950', 32.686203, -117.083713, 615, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (367, N'University Of California San Die Medical Center', 1, NULL, NULL, N'050025', NULL, NULL, 0, 600, NULL, N'6195436222', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Arbor Drive', N'San Die', N'CA', N'06073', N'92103', 32.753782, -117.165086, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (368, N'Grossmont Hospital', 1, NULL, NULL, N'050026', NULL, NULL, 0, 536, NULL, N'6194650711', N'6194617191', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 Grossmont Center Drive Box 58', N'La Mesa', N'CA', N'06073', N'91942', 32.779489, -117.009234, 583, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (369, N'Mad River Community Hospital', 1, NULL, NULL, N'050028', NULL, NULL, 0, 80, NULL, N'7078223621', N'7078226311', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Janes Rd', N'Arcata', N'CA', N'06023', N'95521', 40.903697, -124.090089, 501, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (370, N'Oroville Hospital', 1, NULL, NULL, N'050030', NULL, NULL, 0, 153, NULL, N'5305338500', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2767 Olive Highway', N'Oroville', N'CA', N'06007', N'95966', 39.504535, -121.542106, 626, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (371, N'Bakersfield Memorial Hospital', 1, NULL, NULL, N'050036', NULL, NULL, 0, 367, NULL, N'6613271792', N'6613260706', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 34Th St Box 1888', N'Bakersfield', N'CA', N'06029', N'93301', 35.390474, -119.006671, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (372, N'Santa Clara Valley Medical Center', 1, NULL, NULL, N'050038', NULL, NULL, 0, 574, NULL, N'4088855000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 South Bascom Avenue', N'San Jose', N'CA', N'06085', N'95128', 37.313774, -121.931899, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (373, N'Enloe Medical Center', 1, NULL, NULL, N'050039', NULL, NULL, 0, 298, NULL, N'5303327300', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1531 Esplanade', N'Chico', N'CA', N'06007', N'95926', 39.742284, -121.849128, 522, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (374, N'Lac/Olive View-Ucla Medical Center', 1, NULL, NULL, N'050040', NULL, NULL, 0, 324, NULL, N'8183641555', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14445 Olive View Drive', N'Sylmar', N'CA', N'06037', N'91342', 34.325912, -118.445513, 606, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (375, N'St Elizabeth Community Hospital', 1, NULL, NULL, N'050042', NULL, NULL, 0, 76, NULL, N'5305298012', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 Sister Mary Columba Drive', N'Red Bluff', N'CA', N'06103', N'96080', 40.149104, -122.217395, 643, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (376, N'Alta Bates Summit Medical Center', 1, NULL, NULL, N'050043', NULL, NULL, 0, 569, NULL, N'5106554000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Hawthorne Avenue', N'Oakland', N'CA', N'06001', N'94609', 37.820913, -122.262087, 622, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (377, N'El Centro Regional Medical Center', 1, NULL, NULL, N'050045', NULL, NULL, 0, 107, NULL, N'7603397100', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1415 Ross Avenue', N'El Centro', N'CA', N'06025', N'92243', 32.781498, -115.56862, 542, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (378, N'California Pacific Medical Ctr-Pacific Campus Hosp', 1, NULL, NULL, N'050047', NULL, NULL, 0, 806, NULL, N'4156006000', N'4156008666', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Buchanan Street', N'San Francisco', N'CA', N'06075', N'94115', 37.791188, -122.43096, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (379, N'San rnio Memorial Hospital', 1, NULL, NULL, N'050054', NULL, NULL, 0, 72, NULL, N'9518451121', N'9518452836', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Highland Springs Avenue', N'Banning', N'CA', N'06065', N'92220', 33.925569, -116.875289, 506, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (380, N'California Pacific Medical Ctr - St. Luke''s Campus', 1, NULL, NULL, N'050055', NULL, NULL, 0, 229, NULL, N'4156416562', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3555 Cesar Chavez Street', N'San Francisco', N'CA', N'06075', N'94110', 37.779277, -122.41927, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (381, N'Antelope Valley Hospital', 1, NULL, NULL, N'050056', NULL, NULL, 0, 341, NULL, N'6619495000', N'6619495510', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W Ave J', N'Lancaster', N'CA', N'06037', N'93534', 34.689374, -118.157996, 588, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (382, N'Kaweah Delta Medical Center', 1, NULL, NULL, N'050057', NULL, NULL, 0, 419, NULL, N'5596242000', N'5596354064', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W Mineral King Ave', N'Visalia', N'CA', N'06107', N'93291', 36.327415, -119.294172, 701, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (383, N'Glendale Mem Hospital & Hlth Center', 1, NULL, NULL, N'050058', NULL, NULL, 0, 334, NULL, N'8185021900', N'8185027314', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 S Central Ave', N'Glendale', N'CA', N'06037', N'91204', 34.127789, -118.257795, 562, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (384, N'Community Regional Medical Center', 1, NULL, NULL, N'050060', NULL, NULL, 0, 794, NULL, N'5594596000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2823 Fresno Street', N'Fresno', N'CA', N'06019', N'93721', 36.742582, -119.783024, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (385, N'Hollywood Presbyterian Medical Center', 1, NULL, NULL, N'050063', NULL, NULL, 0, 345, NULL, N'2134133000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 N Vermont Ave', N'Los Angeles', N'CA', N'06037', N'90027', 34.095832, -118.291752, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (386, N'Oak Valley District Hospital', 1, NULL, NULL, N'050067', NULL, NULL, 0, 39, NULL, N'2098473011', N'2098484110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 S Oak Ave', N'Oakdale', N'CA', N'06099', N'95361', 37.758063, -120.86034, 621, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (387, N'St Joseph Hospital', 1, NULL, NULL, N'050069', NULL, NULL, 0, 462, NULL, N'7146339111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West Stewart Dr', N'Orange', N'CA', N'06059', N'92868', 33.782329, -117.864891, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (388, N'Kaiser Foundation Hospital - South San Francisco', 1, NULL, NULL, N'050070', NULL, NULL, 0, 120, NULL, N'6507423200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 El Camino Real', N'South San Francisco', N'CA', N'06081', N'94080', 37.657535, -122.437658, 681, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (389, N'Kaiser Foundation Hospital-Santa Clara', 1, NULL, NULL, N'050071', NULL, NULL, 0, 286, NULL, N'4082366400', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Lawrence Expressway', N'Santa Clara', N'CA', N'06085', N'95051', 37.332022, -121.995672, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (390, N'Kaiser Foundation Hospital - Walnut Creek', 1, NULL, NULL, N'050072', NULL, NULL, 0, 362, NULL, N'9252954000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 S Main Street', N'Walnut Creek', N'CA', N'06013', N'94596', 37.891513, -122.057943, 702, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (391, N'Kaiser Foundation Hospital And Rehab Center', 1, NULL, NULL, N'050073', NULL, NULL, 0, 475, NULL, N'7076511000', N'7076512223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Sereno Dr', N'Vallejo', N'CA', N'06095', N'94589', 38.128437, -122.247584, 697, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (392, N'Kaiser Foundation Hospital - Oakland/Richmond', 1, NULL, NULL, N'050075', NULL, NULL, 0, 396, NULL, N'5107521000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 W Macarthur Boulevard', N'Oakland', N'CA', N'06001', N'94611', 37.823952, -122.257738, 622, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (393, N'Kaiser Foundation Hospital - San Francisco', 1, NULL, NULL, N'050076', NULL, NULL, 0, 542, NULL, N'4158332646', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Geary Blvd', N'San Francisco', N'CA', N'06075', N'94115', 37.782741, -122.443564, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (394, N'Scripps Mercy Hospital', 1, NULL, NULL, N'050077', NULL, NULL, 0, 700, NULL, N'6192948111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4077 5Th Ave', N'San Die', N'CA', N'06073', N'92103', 32.751172, -117.160922, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (395, N'Providence Little Co Of Mary Med Ctr San Pedro', 1, NULL, NULL, N'050078', NULL, NULL, 0, 387, NULL, N'3108323311', N'3105145314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 W 7Th St', N'San Pedro', N'CA', N'06037', N'90732', 33.737928, -118.305005, 664, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (396, N'St Johns Regional Medical Center', 1, NULL, NULL, N'050082', NULL, NULL, 0, 265, NULL, N'8059882500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N Rose Ave', N'Oxnard', N'CA', N'06111', N'93030', 34.216566, -119.158348, 627, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (397, N'St Joseph''s Medical Center Of Stockton', 1, NULL, NULL, N'050084', NULL, NULL, 0, 294, NULL, N'2099432000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 N California St', N'Stockton', N'CA', N'06077', N'95204', 37.970726, -121.289216, 683, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (398, N'Community Hospital Of San Bernardino', 1, NULL, NULL, N'050089', NULL, NULL, 0, 347, NULL, N'9098876333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 Medical Center Drive', N'San Bernardino', N'CA', N'06071', N'92411', 34.131272, -117.322558, 653, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (399, N'Sonoma Valley Hospital', 1, NULL, NULL, N'050090', NULL, NULL, 0, 83, NULL, N'7079355000', N'7079355433', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 Andrieux St', N'Sonoma', N'CA', N'06097', N'95476', 38.288499, -122.465236, 676, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (400, N'Community Hospital Of Huntington Park', 1, NULL, NULL, N'050091', NULL, NULL, 0, 226, NULL, N'3235831931', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2623 E Slauson Ave', N'Huntington Park', N'CA', N'06037', N'90255', 33.989167, -118.224259, 599, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (401, N'Saint Agnes Medical Center', 1, NULL, NULL, N'050093', NULL, NULL, 0, 436, NULL, N'5594503000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1303 E Herndon Ave', N'Fresno', N'CA', N'06019', N'93710', 36.837103, -119.765685, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (402, N'Doctors Hospital Of West Covina Inc', 1, NULL, NULL, N'050096', NULL, NULL, 0, 57, NULL, N'6263388481', N'6269609178', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 S Orange Ave', N'West Covina', N'CA', N'06037', N'91790', 34.070227, -117.945126, 705, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (403, N'San Antonio Regional Hospital', 1, NULL, NULL, N'050099', NULL, NULL, 0, 281, NULL, N'7149852811', N'9099857659', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'999 San Bernardino Road', N'Upland', N'CA', N'06071', N'91786', 34.10092, -117.637226, 694, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (404, N'Sharp Memorial Hospital', 1, NULL, NULL, N'050100', NULL, NULL, 0, 881, NULL, N'8589393400', N'8585413919', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7901 Frost St', N'San Die', N'CA', N'06073', N'92123', 32.800257, -117.154391, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (405, N'Sutter Solano Medical Center', 1, NULL, NULL, N'050101', NULL, NULL, 0, 111, NULL, N'7075545280', N'7076483227', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Hospital Dr', N'Vallejo', N'CA', N'06095', N'94589', 38.1309, -122.240455, 697, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (406, N'Parkview Community Hospital Medical Center', 1, NULL, NULL, N'050102', NULL, NULL, 0, 193, NULL, N'9516882211', N'9513525427', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3865 Jackson Street', N'Riverside', N'CA', N'06065', N'92503', 33.925637, -117.440003, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (407, N'White Memorial Medical Center', 1, NULL, NULL, N'050103', NULL, NULL, 0, 377, NULL, N'3232685000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 E Cesar Avenue', N'Los Angeles', N'CA', N'06037', N'90033', 34.054394, -118.243941, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (408, N'Saint Francis Medical Center', 1, NULL, NULL, N'050104', NULL, NULL, 0, 448, NULL, N'3109008900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3630 East Imperial Highway', N'Lynwood', N'CA', N'06037', N'90262', 33.931007, -118.203856, 599, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (409, N'Marian Regional Medical Center', 1, NULL, NULL, N'050107', NULL, NULL, 0, 227, NULL, N'8057393000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Church St', N'Santa Maria', N'CA', N'06083', N'93454', 34.952165, -120.414052, 668, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (410, N'Sutter Medical Center Sacramento', 1, NULL, NULL, N'050108', NULL, NULL, 0, 754, NULL, N'9167338999', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2825 Capitol Avenue', N'Sacramento', N'CA', N'06067', N'95816', 38.570343, -121.470013, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (411, N'Lompoc Valley Medical Center', 1, NULL, NULL, N'050110', NULL, NULL, 0, 170, NULL, N'8057373300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 E Ocean Avenue', N'Lompoc', N'CA', N'06083', N'93436', 34.640639, -120.439899, 593, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (412, N'Santa Monica - Ucla Med Ctr & Orthopaedic Hospital', 1, NULL, NULL, N'050112', NULL, NULL, 0, 363, NULL, N'3103194000', N'4242596626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 16Th Street', N'Santa Monica', N'CA', N'06037', N'90404', 34.027506, -118.485997, 669, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (413, N'San Mateo Medical Center', 1, NULL, NULL, N'050113', NULL, NULL, 0, 134, NULL, N'6505732222', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 W 39Th Ave', N'San Mateo', N'CA', N'06081', N'94403', 37.530457, -122.298572, 662, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (414, N'Palomar Health Downtown Campus', 1, NULL, NULL, N'050115', NULL, NULL, 0, 679, NULL, N'7607393000', N'7607393107', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 E Valley Parkway', N'Escondido', N'CA', N'06073', N'92025', 33.12607, -117.076075, 545, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (415, N'Northridge Hospital Medical Center', 1, NULL, NULL, N'050116', NULL, NULL, 0, 435, NULL, N'8188858500', N'8188855439', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 Roscoe Blvd', N'Northridge', N'CA', N'06037', N'91325', 34.220793, -118.533046, 618, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (416, N'Doctors Hospital Of Manteca', 1, NULL, NULL, N'050118', NULL, NULL, 0, 73, NULL, N'2098233111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 E North Street', N'Manteca', N'CA', N'06077', N'95336', 37.801092, -121.198181, 602, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (417, N'Adventist Medical Center', 1, NULL, NULL, N'050121', NULL, NULL, 0, 199, NULL, N'2094107200', N'2094107280', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Mall Drive', N'Hanford', N'CA', N'06031', N'93230', 36.323862, -119.666955, 569, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (418, N'Dameron Hospital', 1, NULL, NULL, N'050122', NULL, NULL, 0, 211, NULL, N'2099445550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 West Acacia Street', N'Stockton', N'CA', N'06077', N'95203', 37.961201, -121.300691, 683, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (419, N'Usc Verdu Hills Hospital', 1, NULL, NULL, N'050124', NULL, NULL, 0, 158, NULL, N'8187907100', N'8189524649', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1812 Verdu Blvd', N'Glendale', N'CA', N'06037', N'91209', 34.205605, -118.216172, 562, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (420, N'Regional Medical Center Of San Jose', 1, NULL, NULL, N'050125', NULL, NULL, 0, 204, NULL, N'4082595000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 N Jackson Avenue', N'San Jose', N'CA', N'06085', N'95116', 37.362599, -121.847672, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (421, N'Valley Presbyterian Hospital', 1, NULL, NULL, N'050126', NULL, NULL, 0, 362, NULL, N'8187826600', N'8189023974', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15107 Vanowen St', N'Van Nuys', N'CA', N'06037', N'91406', 34.193916, -118.463376, 698, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (422, N'Woodland Memorial Hospital', 1, NULL, NULL, N'050127', NULL, NULL, 0, 122, NULL, N'5306623961', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Cottonwood Street', N'Woodland', N'CA', N'06113', N'95695', 38.664339, -121.793404, 709, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (423, N'Tri-City Medical Center', 1, NULL, NULL, N'050128', NULL, NULL, 0, 397, NULL, N'7607248411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4002 Vista Way', N'Oceanside', N'CA', N'06073', N'92056', 33.183699, -117.292335, 623, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (424, N'St Bernardine Medical Center', 1, NULL, NULL, N'050129', NULL, NULL, 0, 291, NULL, N'9098814440', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 N Waterman Ave', N'San Bernardino', N'CA', N'06071', N'92404', 34.134062, -117.27876, 653, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (425, N'Novato Community Hospital', 1, NULL, NULL, N'050131', NULL, NULL, 0, 75, NULL, N'4152091300', N'4152091321', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Rowland Way', N'Novato', N'CA', N'06041', N'94945', 38.098081, -122.559664, 620, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (426, N'San Gabriel Valley Medical Center', 1, NULL, NULL, N'050132', NULL, NULL, 0, 273, NULL, N'6262895454', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'438 W Las Tunas Drive', N'San Gabriel', N'CA', N'06037', N'91776', 34.102461, -118.105572, 658, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (427, N'Rideout Memorial Hospital', 1, NULL, NULL, N'050133', NULL, NULL, 0, 149, NULL, N'5307494300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 4Th St', N'Marysville', N'CA', N'06115', N'95901', 39.13879, -121.594157, 604, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (428, N'Southern California Hospital At Hollywood', 1, NULL, NULL, N'050135', NULL, NULL, 0, 579, NULL, N'3234622271', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6245 De Longpre Ave', N'Hollywood', N'CA', N'06037', N'90028', 34.096192, -118.32542, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (429, N'Petaluma Valley Hospital', 1, NULL, NULL, N'050136', NULL, NULL, 0, 99, NULL, N'7077781111', N'7077789117', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Mcdowell Blvd', N'Petaluma', N'CA', N'06097', N'94954', 38.252762, -122.632081, 633, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (430, N'Kaiser Foundation Hospital - Panorama City', 1, NULL, NULL, N'050137', NULL, NULL, 0, 325, NULL, N'8183753333', N'8183753480', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13652 Cantara St', N'Panorama City', N'CA', N'06037', N'91402', 34.219847, -118.430299, 629, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (431, N'Kaiser Foundation Hospital - Los Angeles', 1, NULL, NULL, N'050138', NULL, NULL, 0, 613, NULL, N'3237834011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4867 Sunset Blvd', N'Los Angeles', N'CA', N'06037', N'90027', 34.098139, -118.29535, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (432, N'Kaiser Foundation Hospital - Downey', 1, NULL, NULL, N'050139', NULL, NULL, 0, 453, NULL, N'5624616007', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9333 Imperial Highway', N'Downey', N'CA', N'06037', N'90242', 33.917101, -118.128999, 540, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (433, N'Kaiser Foundation Hospital Fontana', 1, NULL, NULL, N'050140', NULL, NULL, 0, 438, NULL, N'9094275500', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9961 Sierra Ave', N'Fontana', N'CA', N'06071', N'92335', 34.072835, -117.43562, 551, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (434, N'Community Hospital Of The Monterey Peninsula', 1, NULL, NULL, N'050145', NULL, NULL, 0, 173, NULL, N'8316245311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23625 W R Holman Highway', N'Monterey', N'CA', N'06053', N'93940', 36.584417, -121.866793, 610, 29, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (435, N'City Of Hope Helford Clinical Research Hospital', 1, NULL, NULL, N'050146', NULL, NULL, 0, 212, NULL, N'6263598111', N'6263018889', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Duarte Road', N'Duarte', N'CA', N'06037', N'91010', 34.13233, -117.974986, 541, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (436, N'California Hospital Medical Center La', 1, NULL, NULL, N'050149', NULL, NULL, 0, 309, NULL, N'2137482411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South Grand Avenue', N'Los Angeles', N'CA', N'06037', N'90015', 34.037212, -118.265363, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (437, N'Sierra Nevada Memorial Hospital', 1, NULL, NULL, N'050150', NULL, NULL, 0, 124, NULL, N'5302746000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Glasson Way', N'Grass Valley', N'CA', N'06057', N'95945', 39.229083, -121.0474, 565, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (438, N'Saint Francis Memorial Hospital', 1, NULL, NULL, N'050152', NULL, NULL, 0, 362, NULL, N'4153536000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hyde St', N'San Francisco', N'CA', N'06075', N'94109', 37.789561, -122.417112, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (439, N'O''connor Hospital', 1, NULL, NULL, N'050153', NULL, NULL, 0, 358, NULL, N'4089472500', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2105 Forest Avenue', N'San Jose', N'CA', N'06085', N'95128', 37.327054, -121.937186, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (440, N'Encino Hospital Medical Center', 1, NULL, NULL, N'050158', NULL, NULL, 0, 150, NULL, N'8189955000', N'8189078630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16237 Ventura Blvd', N'Encino', N'CA', N'06037', N'91436', 34.156654, -118.485748, 544, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (441, N'Ventura County Medical Center', 1, NULL, NULL, N'050159', NULL, NULL, 0, 272, NULL, N'8056526075', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3291 Loma Vista Rd', N'Ventura', N'CA', N'06111', N'93003', 34.276288, -119.251685, 699, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (442, N'San Joaquin General Hospital', 1, NULL, NULL, N'050167', NULL, NULL, 0, 212, NULL, N'2094686000', N'2094687011', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Hospital Road', N'French Camp', N'CA', N'06077', N'95231', 37.886447, -121.282073, 683, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (443, N'St Jude Medical Center', 1, NULL, NULL, N'050168', NULL, NULL, 0, 301, NULL, N'7149923000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Valencia Mesa Drive', N'Fullerton', N'CA', N'06059', N'92835', 33.893493, -117.928025, 557, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (444, N'Presbyterian Intercommunity Hospital', 1, NULL, NULL, N'050169', NULL, NULL, 0, 343, NULL, N'5266980811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12401 E Washington Blvd', N'Whittier', N'CA', N'06037', N'90602', 33.992436, -118.112761, 706, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (445, N'Santa Rosa Memorial Hospital', 1, NULL, NULL, N'050174', NULL, NULL, 0, 346, NULL, N'7075255300', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1165 Montmery Dr', N'Santa Rosa', N'CA', N'06097', N'95405', 38.442949, -122.701135, 671, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (446, N'Emanuel Medical Center', 1, NULL, NULL, N'050179', NULL, NULL, 0, 354, NULL, N'2096674200', N'2096349336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Delbon Ave', N'Turlock', N'CA', N'06099', N'95382', 37.510499, -120.83719, 692, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (447, N'John Muir Medical Center - Walnut Creek Campus', 1, NULL, NULL, N'050180', NULL, NULL, 0, 296, NULL, N'9259393000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Ygnacio Valley Rd', N'Walnut Creek', N'CA', N'06013', N'94598', 37.914211, -122.042168, 702, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (448, N'George L Mee Memorial Hospital', 1, NULL, NULL, N'050189', NULL, NULL, 0, 68, NULL, N'8313856000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Canal Street', N'King City', N'CA', N'06053', N'93930', 36.207025, -121.132304, 581, 29, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (449, N'St Mary Medical Center', 1, NULL, NULL, N'050191', NULL, NULL, 0, 539, NULL, N'5624919000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Linden Ave', N'Long Beach', N'CA', N'06037', N'90813', 33.7801, -118.186686, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (450, N'Adventist Medical Center - Reedley', 1, NULL, NULL, N'050192', NULL, NULL, 0, 44, NULL, N'5596388155', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'372 W Cypress Ave', N'Reedley', N'CA', N'06019', N'93654', 36.607797, -119.451281, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (451, N'Watsonville Community Hospital', 1, NULL, NULL, N'050194', NULL, NULL, 0, 106, NULL, N'8317244741', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Nielson Street', N'Watsonville', N'CA', N'06087', N'95076', 36.928282, -121.79376, 703, 37, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (452, N'Washington Hospital', 1, NULL, NULL, N'050195', NULL, NULL, 0, 265, NULL, N'5107971111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Mowry Ave', N'Fremont', N'CA', N'06001', N'94538', 37.558558, -121.980116, 555, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (453, N'Central Valley General Hospital', 1, NULL, NULL, N'050196', NULL, NULL, 0, 49, NULL, N'5595832100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 N Douty St', N'Hanford', N'CA', N'06031', N'93230', 36.335958, -119.646035, 569, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (454, N'Sequoia Hospital', 1, NULL, NULL, N'050197', NULL, NULL, 0, 189, NULL, N'6503675551', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Alameda De Las Pulgas', N'Redwood City', N'CA', N'06081', N'94062', 37.480998, -122.253237, 646, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (455, N'Palmdale Regional Medical Center', 1, NULL, NULL, N'050204', NULL, NULL, 0, 157, NULL, N'6613825000', N'6613826178', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'38600 Medical Center Drive', N'Palmdale', N'CA', N'06037', N'93552', 34.584408, -118.144391, 588, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (456, N'Glendora Community Hospital', 1, NULL, NULL, N'050205', NULL, NULL, 0, 128, NULL, N'6263350231', N'6268525055', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 West Route 66', N'Glendora', N'CA', N'06037', N'91740', 34.128685, -117.865193, 563, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (457, N'Alameda Hospital', 1, NULL, NULL, N'050211', NULL, NULL, 0, 145, NULL, N'5105223700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2070 Clinton Avenue', N'Alameda', N'CA', N'06001', N'94501', 37.763531, -122.254228, 495, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (458, N'Sharp Chula Vista Medical Center', 1, NULL, NULL, N'050222', NULL, NULL, 0, 306, NULL, N'6195025800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Medical Center Court', N'Chula Vista', N'CA', N'06073', N'91911', 32.618201, -117.023568, 524, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (459, N'Hoag Memorial Hospital Presbyterian', 1, NULL, NULL, N'050224', NULL, NULL, 0, 409, NULL, N'9497644624', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hoag Drive', N'Newport Beach', N'CA', N'06059', N'92663', 33.617009, -117.92944, 617, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (460, N'Feather River Hospital', 1, NULL, NULL, N'050225', NULL, NULL, 0, 100, NULL, N'5308779361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5974 Pentz Road', N'Paradise', N'CA', N'06007', N'95969', 39.756407, -121.572303, 630, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (461, N'Ahmc Anaheim Regional Medical Center', 1, NULL, NULL, N'050226', NULL, NULL, 0, 224, NULL, N'7147741450', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 W La Palma Avenue', N'Anaheim', N'CA', N'06059', N'92801', 33.847148, -117.932805, 497, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (462, N'San Francisco General Hospital', 1, NULL, NULL, N'050228', NULL, NULL, 0, 509, NULL, N'4152068000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Potrero Avenue', N'San Francisco', N'CA', N'06075', N'94110', 37.756171, -122.406608, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (463, N'Garden Grove Hospital & Medical Center', 1, NULL, NULL, N'050230', NULL, NULL, 0, 167, NULL, N'7145375160', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12601 Garden Grove Blvd', N'Garden Grove', N'CA', N'06059', N'92843', 33.774471, -117.913687, 559, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (464, N'Pomona Valley Hospital Medical Center', 1, NULL, NULL, N'050231', NULL, NULL, 0, 447, NULL, N'9098659500', N'9098659796', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1798 N Garey Ave', N'Pomona', N'CA', N'06037', N'91767', 34.07752, -117.752315, 637, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (465, N'French Hospital Medical Center', 1, NULL, NULL, N'050232', NULL, NULL, 0, 135, NULL, N'8055435353', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1911 Johnson Ave', N'San Luis Obispo', N'CA', N'06079', N'93401', 35.277987, -120.649611, 661, 34, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (466, N'Sharp Coronado Hospital And Hlthcr Ctr', 1, NULL, NULL, N'050234', NULL, NULL, 0, 204, NULL, N'6194356251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Prospect Place', N'Coronado', N'CA', N'06073', N'92118', 32.694245, -117.167953, 531, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (467, N'Providence Saint Joseph Medical Ctr', 1, NULL, NULL, N'050235', NULL, NULL, 0, 360, NULL, N'8188435111', N'8188476514', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Buena Vista', N'Burbank', N'CA', N'06037', N'91505', 34.181648, -118.325855, 514, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (468, N'Simi Valley Hospital & Health Care Services', 1, NULL, NULL, N'050236', NULL, NULL, 0, 149, NULL, N'8059556000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2975 N Sycamore Dr', N'Simi Valley', N'CA', N'06111', N'93065', 34.289125, -118.743955, 674, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (469, N'Methodist Hospital Of Southern Ca', 1, NULL, NULL, N'050238', NULL, NULL, 0, 374, NULL, N'6264454441', N'6265743767', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W Huntington Dr', N'Arcadia', N'CA', N'06037', N'91006', 34.13523, -118.042103, 500, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (470, N'Glendale Adventist Medical Center', 1, NULL, NULL, N'050239', NULL, NULL, 0, 515, NULL, N'8184098202', N'8185465600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1509 E Wilson Terrace', N'Glendale', N'CA', N'06037', N'91206', 34.149471, -118.231078, 562, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (471, N'Dominican Hospital', 1, NULL, NULL, N'050242', NULL, NULL, 0, 288, NULL, N'8314627700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 Soquel Drive', N'Santa Cruz', N'CA', N'06087', N'95065', 36.988292, -121.983953, 667, 37, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (472, N'Desert Regional Medical Center', 1, NULL, NULL, N'050243', NULL, NULL, 0, 367, NULL, N'7603236511', N'7603236725', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 North Indian Canyon Drive', N'Palm Springs', N'CA', N'06065', N'92262', 33.838887, -116.545598, 628, 26, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (473, N'Arrowhead Regional Medical Center', 1, NULL, NULL, N'050245', NULL, NULL, 0, 456, NULL, N'9095801000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Pepper Avenue', N'Colton', N'CA', N'06071', N'92324', 34.072483, -117.352835, 592, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (474, N'Natividad Medical Center', 1, NULL, NULL, N'050248', NULL, NULL, 0, 172, NULL, N'8317554195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Constitution Boulevard', N'Salinas', N'CA', N'06053', N'93906', 36.695487, -121.631223, 651, 29, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (475, N'Marshall Medical Center', 1, NULL, NULL, N'050254', NULL, NULL, 0, 107, NULL, N'5306221441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Marshall Way', N'Placerville', N'CA', N'06017', N'95667', 38.724319, -120.790607, 636, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (476, N'od Samaritan Hospital', 1, NULL, NULL, N'050257', NULL, NULL, 0, 64, NULL, N'6613994461', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Olive Drive', N'Bakersfield', N'CA', N'06029', N'93308', 35.41226, -119.03994, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (477, N'Sierra View Medical Center', 1, NULL, NULL, N'050261', NULL, NULL, 0, 120, NULL, N'5597841110', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'465 W Putnam Ave', N'Porterville', N'CA', N'06107', N'93257', 36.069573, -119.027252, 638, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (478, N'Ronald Reagan U C L A Medical Center', 1, NULL, NULL, N'050262', NULL, NULL, 0, 466, NULL, N'3108256301', N'3107943284', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'757 Westwood Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.06577, -118.445389, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (479, N'Redlands Community Hospital', 1, NULL, NULL, N'050272', NULL, NULL, 0, 229, NULL, N'9093355500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Terracina Blvd', N'Redlands', N'CA', N'06071', N'92373', 34.037042, -117.204319, 645, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (480, N'Contra Costa Regional Medical Center', 1, NULL, NULL, N'050276', NULL, NULL, 0, 164, NULL, N'9253705000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Alhambra Ave', N'Martinez', N'CA', N'06013', N'94553', 38.006467, -122.130891, 603, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (481, N'Providence Holy Cross Medical Center', 1, NULL, NULL, N'050278', NULL, NULL, 0, 257, NULL, N'8183658051', N'8184964477', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15031 Rinaldi St', N'Mission Hills', N'CA', N'06037', N'91346', 34.279029, -118.461203, 606, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (482, N'Hi-Desert Medical Center', 1, NULL, NULL, N'050279', NULL, NULL, 0, 175, NULL, N'7603663711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 White Feather Road', N'Joshua Tree', N'CA', N'06071', N'92252', 34.129664, -116.276736, 580, 26, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (483, N'Mercy Medical Center Redding', 1, NULL, NULL, N'050280', NULL, NULL, 0, 267, NULL, N'5302256102', N'5302425453', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2175 Rosaline Ave Clairmont Hgts', N'Redding', N'CA', N'06089', N'96001', 40.572546, -122.396346, 644, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (484, N'Alhambra Hospital Medical Center', 1, NULL, NULL, N'050281', NULL, NULL, 0, 144, NULL, N'6265701606', N'6265708825', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 S Raymond Ave', N'Alhambra', N'CA', N'06037', N'91801', 34.09048, -118.145019, 658, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (485, N'Valleycare Medical Center', 1, NULL, NULL, N'050283', NULL, NULL, 0, 175, NULL, N'9254477000', N'9253734025', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 West Las Positas Boulevard', N'Pleasanton', N'CA', N'06001', N'94588', 37.692133, -121.880012, 714, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (486, N'Seton Medical Center', 1, NULL, NULL, N'050289', NULL, NULL, 0, 279, NULL, N'6509924000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Sullivan Avenue', N'Daly City', N'CA', N'06081', N'94015', 37.679979, -122.472996, 535, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (487, N'Providence Saint John''s Health Center', 1, NULL, NULL, N'050290', NULL, NULL, 0, 317, NULL, N'3108295511', N'3108298062', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2121 Santa Monica Blvd', N'Santa Monica', N'CA', N'06037', N'90404', 34.029735, -118.478727, 669, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (488, N'Sutter Santa Rosa Regional Hospital', 1, NULL, NULL, N'050291', NULL, NULL, 0, 170, NULL, N'7075764000', N'7075764318', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Mark West Springs Road', N'Santa Rosa', N'CA', N'06097', N'95403', 38.496343, -122.75204, 671, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (489, N'Riverside County Regional Medical Center', 1, NULL, NULL, N'050292', NULL, NULL, 0, 439, NULL, N'9514864000', N'9514864475', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26520 Cactus Avenue', N'Moreno Valley', N'CA', N'06065', N'92555', 33.910031, -117.200443, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (490, N'Mercy Hospital', 1, NULL, NULL, N'050295', NULL, NULL, 0, 211, NULL, N'6616325000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Truxtun Avenue', N'Bakersfield', N'CA', N'06029', N'93301', 35.373324, -119.027251, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (491, N'Hazel Hawkins Memorial Hospital', 1, NULL, NULL, N'050296', NULL, NULL, 0, 49, NULL, N'8316375711', N'8316375601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Sunset Drive', N'Hollister', N'CA', N'06069', N'95023', 36.835135, -121.386931, 575, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (492, N'Barstow Community Hospital', 1, NULL, NULL, N'050298', NULL, NULL, 0, 56, NULL, N'7602561761', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 E Mountain View Street', N'Barstow', N'CA', N'06071', N'92311', 34.893356, -117.017457, 507, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (493, N'St Mary Medical Center', 1, NULL, NULL, N'050300', NULL, NULL, 0, 208, NULL, N'7602422311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 Highway 18', N'Apple Valley', N'CA', N'06071', N'92307', 34.500831, -117.185876, 499, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (494, N'Ukiah Valley Medical Center', 1, NULL, NULL, N'050301', NULL, NULL, 0, 127, NULL, N'7074623111', N'7074637384', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Hospital Drive', N'Ukiah', N'CA', N'06045', N'95482', 39.15374, -123.20396, 693, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (495, N'Alta Bates Summit Medical Center - Alta Bates Camp', 1, NULL, NULL, N'050305', NULL, NULL, 0, 555, NULL, N'5102044444', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 Ashby Ave', N'Berkeley', N'CA', N'06001', N'94705', 37.856409, -122.257997, 509, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (496, N'El Camino Hospital', 1, NULL, NULL, N'050308', NULL, NULL, 0, 443, NULL, N'6509407000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Grant Road', N'Mountain View', N'CA', N'06085', N'94040', 37.369813, -122.077933, 613, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (497, N'Sutter Roseville Medical Center', 1, NULL, NULL, N'050309', NULL, NULL, 0, 298, NULL, N'9167811000', N'9167811200', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Plaza', N'Roseville', N'CA', N'06061', N'95661', 38.75187, -121.313874, 649, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (498, N'Sutter Tracy Community Hospital', 1, NULL, NULL, N'050313', NULL, NULL, 0, 82, NULL, N'2098351500', N'2098326091', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 N Tracy Blvd', N'Tracy', N'CA', N'06077', N'95376', 37.744231, -121.43494, 689, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (499, N'Kern Medical Center', 1, NULL, NULL, N'050315', NULL, NULL, 0, 222, NULL, N'6613262000', N'6613262100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Mount Vernon Avenue', N'Bakersfield', N'CA', N'06029', N'93306', 35.382404, -118.967548, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (500, N'Highland Hospital', 1, NULL, NULL, N'050320', NULL, NULL, 0, 613, NULL, N'5104374800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 E 31St Street', N'Oakland', N'CA', N'06001', N'94602', 37.799231, -122.231183, 622, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (501, N'Scripps Memorial Hospital La Jolla', 1, NULL, NULL, N'050324', NULL, NULL, 0, 332, NULL, N'8586264123', N'8586266122', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9888 Genesee Avenue', N'La Jolla', N'CA', N'06073', N'92037', 32.885475, -117.222971, 582, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (502, N'Loma Linda University Medical Center', 1, NULL, NULL, N'050327', NULL, NULL, 0, 881, NULL, N'9095584000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11234 Anderson St', N'Loma Linda', N'CA', N'06071', N'92354', 34.049616, -117.261118, 592, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (503, N'Corona Regional Medical Center', 1, NULL, NULL, N'050329', NULL, NULL, 0, 240, NULL, N'9517374343', N'9517366310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 South Main Street', N'Corona', N'CA', N'06065', N'92882', 33.873327, -117.566768, 530, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (504, N'Salinas Valley Memorial Hospital', 1, NULL, NULL, N'050334', NULL, NULL, 0, 269, NULL, N'8317574333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 East Romie Lane', N'Salinas', N'CA', N'06053', N'93901', 36.659973, -121.6463, 651, 29, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (505, N'Sonora Regional Medical Center', 1, NULL, NULL, N'050335', NULL, NULL, 0, 143, NULL, N'2095323161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Greenley Road', N'Sonora', N'CA', N'06109', N'95370', 37.976624, -120.36933, 677, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (506, N'Lodi Memorial Hospital', 1, NULL, NULL, N'050336', NULL, NULL, 0, 71, NULL, N'2093343411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 S Fairmont Avenue', N'Lodi', N'CA', N'06077', N'95240', 38.121894, -121.285788, 591, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (507, N'Pioneers Memorial Healthcare District', 1, NULL, NULL, N'050342', NULL, NULL, 0, 99, NULL, N'7603513333', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 West Legion Road', N'Brawley', N'CA', N'06025', N'92227', 32.959947, -115.552723, 513, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (508, N'University Of California Irvine Med Center', 1, NULL, NULL, N'050348', NULL, NULL, 0, 415, NULL, N'7144566112', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 City Drive South', N'Orange', N'CA', N'06059', N'92868', 33.780112, -117.894303, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (509, N'Beverly Hospital', 1, NULL, NULL, N'050350', NULL, NULL, 0, 214, NULL, N'3237261222', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 W Beverly Blvd', N'Montebello', N'CA', N'06037', N'90640', 34.016002, -118.100382, 609, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (510, N'Torrance Memorial Medical Center', 1, NULL, NULL, N'050351', NULL, NULL, 0, 380, NULL, N'3103259110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Lomita Blvd', N'Torrance', N'CA', N'06037', N'90509', 33.812701, -118.343882, 688, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (511, N'Barton Memorial Hospital', 1, NULL, NULL, N'050352', NULL, NULL, 0, 64, NULL, N'5305413420', N'5305442605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2170 South Avenue', N'South Lake Tahoe', N'CA', N'06017', N'96150', 38.912334, -119.99863, 680, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (512, N'Providence Little Company Of Mary Med Ctr Torrance', 1, NULL, NULL, N'050353', NULL, NULL, 0, 366, NULL, N'3105407676', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4101 Torrance Blvd', N'Torrance', N'CA', N'06037', N'90503', 33.837577, -118.35708, 688, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (513, N'leta Valley Cottage Hospital', 1, NULL, NULL, N'050357', NULL, NULL, 0, 122, NULL, N'8056816446', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 S Patterson Ave', N'Santa Barbara', N'CA', N'06083', N'93111', 34.434463, -119.809234, 666, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (514, N'Tulare Regional Medical Center', 1, NULL, NULL, N'050359', NULL, NULL, 0, 112, NULL, N'5596880821', N'5596853835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'869 Cherry Avenue', N'Tulare', N'CA', N'06107', N'93274', 36.219846, -119.337669, 691, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (515, N'Marin General Hospital', 1, NULL, NULL, N'050360', NULL, NULL, 0, 325, NULL, N'4159257900', N'4159257933', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Bon Air Road Po Box 8010', N'Greenbrae', N'CA', N'06041', N'94904', 37.948899, -122.535807, 566, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (516, N'Northbay Medical Center', 1, NULL, NULL, N'050367', NULL, NULL, 0, 123, NULL, N'7076465000', N'7076465002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 B  Gale Wilson Blvd', N'Fairfield', N'CA', N'06095', N'94533', 38.261104, -122.047589, 547, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (517, N'Lac+Usc Medical Center', 1, NULL, NULL, N'050373', NULL, NULL, 0, 1395, NULL, N'3232262800', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N State St Room C2k100', N'Los Angeles', N'CA', N'06037', N'90033', 34.060777, -118.208954, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (518, N'Lac/Harbor-Ucla Med Center', 1, NULL, NULL, N'050376', NULL, NULL, 0, 553, NULL, N'3102222101', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Carson St', N'Torrance', N'CA', N'06037', N'90509', 33.831583, -118.294487, 688, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (519, N'Pacifica Hospital Of The Valley', 1, NULL, NULL, N'050378', NULL, NULL, 0, 242, NULL, N'8187673310', N'8182522478', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9449 San Fernando Rd', N'Sun Valley', N'CA', N'06037', N'91352', 34.240621, -118.395131, 514, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (520, N'od Samaritan Hospital', 1, NULL, NULL, N'050380', NULL, NULL, 0, 429, NULL, N'4085592011', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Samaritan Drive', N'San Jose', N'CA', N'06085', N'95124', 37.251108, -121.947049, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (521, N'Citrus Valley Medical Center-Ic Campus', 1, NULL, NULL, N'050382', NULL, NULL, 0, 193, NULL, N'6268142468', N'6268595865', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 W  San Bernardino Road', N'Covina', N'CA', N'06037', N'91723', 34.090035, -117.892646, 532, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (522, N'Hemet Valley Medical Center', 1, NULL, NULL, N'050390', NULL, NULL, 0, 433, NULL, N'9516522811', N'9517666419', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1117 East Devonshire', N'Hemet', N'CA', N'06065', N'92543', 33.75122, -116.959841, 574, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (523, N'Pih Hospital - Downey', 1, NULL, NULL, N'050393', NULL, NULL, 0, 199, NULL, N'5269045000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11500 Brookshire Avenue', N'Downey', N'CA', N'06037', N'90241', 33.936016, -118.131342, 540, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (524, N'Community Memorial Hospital San Buenaventura', 1, NULL, NULL, N'050394', NULL, NULL, 0, 242, NULL, N'8056525011', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'147 N Brent St', N'Ventura', N'CA', N'06111', N'93003', 34.274708, -119.257355, 699, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (525, N'Santa Barbara Cottage Hospital', 1, NULL, NULL, N'050396', NULL, NULL, 0, 450, NULL, N'8056827111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Pueblo', N'Santa Barbara', N'CA', N'06083', N'93102', 34.429483, -119.723077, 666, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (526, N'Coalinga Regional Medical Center', 1, NULL, NULL, N'050397', NULL, NULL, 0, 138, NULL, N'5599356400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1191 Phelps Avenue', N'Coalinga', N'CA', N'06019', N'93210', 36.150975, -120.337673, 526, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (527, N'Chinese Hospital', 1, NULL, NULL, N'050407', NULL, NULL, 0, 54, NULL, N'4159822400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'845 Jackson St', N'San Francisco', N'CA', N'06075', N'94133', 37.795724, -122.409014, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (528, N'Kaiser Foundation Hospital - South Bay', 1, NULL, NULL, N'050411', NULL, NULL, 0, 251, NULL, N'3105176441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25825 South Vermont Avenue', N'Harbor City', N'CA', N'06037', N'90710', 33.789002, -118.294068, 570, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (529, N'Mercy Hospital Of Folsom', 1, NULL, NULL, N'050414', NULL, NULL, 0, 106, NULL, N'9169837400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Creekside Drive', N'Folsom', N'CA', N'06067', N'95630', 38.670751, -121.146682, 550, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (530, N'Sutter Coast Hospital', 1, NULL, NULL, N'050417', NULL, NULL, 0, 49, NULL, N'7074648880', N'7074648886', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Washington Blvd', N'Crescent City', N'CA', N'06015', N'95531', 41.772697, -124.194039, 533, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (531, N'Palo Verde Hospital', 1, NULL, NULL, N'050423', NULL, NULL, 0, 51, NULL, N'7609224115', N'7609215201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 North First Street', N'Blythe', N'CA', N'06065', N'92225', 33.612342, -114.595476, 512, 9, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (532, N'Scripps Green Hospital', 1, NULL, NULL, N'050424', NULL, NULL, 0, 173, NULL, N'8584559100', N'8585543636', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10666 North Torrey Pines Road', N'La Jolla', N'CA', N'06073', N'92037', 32.900046, -117.24248, 582, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (533, N'Kaiser Foundation Hospital - Sacramento', 1, NULL, NULL, N'050425', NULL, NULL, 0, 628, NULL, N'9169735000', N'9169734405', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Morse Avenue', N'Sacramento', N'CA', N'06067', N'95825', 38.600954, -121.392237, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (534, N'West Anaheim Medical Center', 1, NULL, NULL, N'050426', NULL, NULL, 0, 219, NULL, N'7148273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3033 W Orange Avenue', N'Anaheim', N'CA', N'06059', N'92804', 33.824732, -117.995529, 497, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (535, N'Colusa Regional Medical Center', 1, NULL, NULL, N'050434', NULL, NULL, 0, 42, NULL, N'5304585821', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 East Webster St', N'Colusa', N'CA', N'06011', N'95932', 39.207289, -121.999985, 527, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (536, N'Fallbrook Hospital District', 1, NULL, NULL, N'050435', NULL, NULL, 0, 140, NULL, N'7607281191', N'7607236214', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 E Elder St', N'Fallbrook', N'CA', N'06073', N'92028', 33.380175, -117.24443, 549, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (537, N'Huntington Memorial Hospital', 1, NULL, NULL, N'050438', NULL, NULL, 0, 625, NULL, N'6263975000', N'6263972995', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 W  California Blvd', N'Pasadena', N'CA', N'06037', N'91109', 34.135708, -118.152486, 632, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (538, N'Stanford Health Care', 1, NULL, NULL, N'050441', NULL, NULL, 0, 613, NULL, N'6507235708', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pasteur Drive', N'Stanford', N'CA', N'06085', N'94305', 37.433094, -122.174472, 682, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (539, N'Mercy Medical Center', 1, NULL, NULL, N'050444', NULL, NULL, 0, 186, NULL, N'2095645000', N'2095845096', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Mercy Avenue', N'Merced', N'CA', N'06047', N'95340', 37.340118, -120.465214, 605, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (540, N'Ucsf Medical Center', 1, NULL, NULL, N'050454', NULL, NULL, 0, 722, NULL, N'4153532733', N'4153538645', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Parnassus Ave Box 0296', N'San Francisco', N'CA', N'06075', N'94143', 37.763471, -122.457942, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (541, N'San Joaquin Community Hospital', 1, NULL, NULL, N'050455', NULL, NULL, 0, 255, NULL, N'6613953000', N'6613245162', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2615 Chester Avenue', N'Bakersfield', N'CA', N'06029', N'93301', 35.383051, -119.018768, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (542, N'St Mary''s Medical Center', 1, NULL, NULL, N'050457', NULL, NULL, 0, 371, NULL, N'4156681000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Stanyan St', N'San Francisco', N'CA', N'06075', N'94117', 37.773859, -122.454498, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (543, N'Doctors Medical Center', 1, NULL, NULL, N'050464', NULL, NULL, 0, 461, NULL, N'2095781211', N'2095763910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Florida Avenue', N'Modesto', N'CA', N'06099', N'95350', 37.665531, -120.996248, 608, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (544, N'Memorial Hospital Of Gardena', 1, NULL, NULL, N'050468', NULL, NULL, 0, 180, NULL, N'3105324200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1145 W Redondo Beach Blvd', N'Gardena', N'CA', N'06037', N'90247', 33.892374, -118.295131, 560, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (545, N'od Samaritan Hospital', 1, NULL, NULL, N'050471', NULL, NULL, 0, 408, NULL, N'2139772121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Wilshire Boulevard', N'Los Angeles', N'CA', N'06037', N'90017', 34.053196, -118.265262, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (546, N'West Hills Hospital & Medical Center', 1, NULL, NULL, N'050481', NULL, NULL, 0, 236, NULL, N'8186764100', N'8187043880', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 Medical Center Dr', N'West Hills', N'CA', N'06037', N'91307', 34.202369, -118.629478, 517, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (547, N'Long Beach Memorial Medical Center', 1, NULL, NULL, N'050485', NULL, NULL, 0, 570, NULL, N'5629332000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Atlantic Ave', N'Long Beach', N'CA', N'06037', N'90806', 33.80801, -118.185092, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (548, N'Eden Medical Center', 1, NULL, NULL, N'050488', NULL, NULL, 0, 155, NULL, N'5105371234', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20103 Lake Chabot Road', N'Castro Valley', N'CA', N'06001', N'94546', 37.697919, -122.087178, 519, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (549, N'Clovis Community Medical Center', 1, NULL, NULL, N'050492', NULL, NULL, 0, 109, NULL, N'5593244000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2755 Herndon Ave', N'Clovis', N'CA', N'06019', N'93611', 36.837434, -119.661562, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (550, N'John Muir Medical Center - Concord Campus', 1, NULL, NULL, N'050496', NULL, NULL, 0, 303, NULL, N'9256828200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2540 East St', N'Concord', N'CA', N'06013', N'94520', 37.983101, -122.03434, 528, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (551, N'Sutter Auburn Faith Hospital', 1, NULL, NULL, N'050498', NULL, NULL, 0, 97, NULL, N'5308884500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11815 Education Street', N'Auburn', N'CA', N'06061', N'95603', 38.94437, -121.098214, 503, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (552, N'Saint Vincent Medical Center', 1, NULL, NULL, N'050502', NULL, NULL, 0, 381, NULL, N'2134847111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 W 3Rd St', N'Los Angeles', N'CA', N'06037', N'90057', 34.063226, -118.273755, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (553, N'Scripps Memorial Hospital - Encinitas', 1, NULL, NULL, N'050503', NULL, NULL, 0, 158, NULL, N'7607536501', N'7606337356', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'354 Santa Fe Drive', N'Encinitas', N'CA', N'06073', N'92024', 33.036274, -117.283218, 543, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (554, N'Sierra Vista Regional Medical Center', 1, NULL, NULL, N'050506', NULL, NULL, 0, 186, NULL, N'8505467600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Murray St', N'San Luis Obispo', N'CA', N'06079', N'93405', 35.29096, -120.665394, 661, 34, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (555, N'Kaiser Foundation Hospital', 1, NULL, NULL, N'050510', NULL, NULL, 0, 120, NULL, N'4154442000', N'4154444731', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Montecillo Rd', N'San Rafael', N'CA', N'06041', N'94903', 38.006049, -122.555273, 566, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (556, N'Kaiser Foundation Hospital - Fremont', 1, NULL, NULL, N'050512', NULL, NULL, 0, 193, NULL, N'5107844000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39400 Paseo Padre Pkwy', N'Fremont', N'CA', N'06001', N'94538', 37.550913, -121.975769, 555, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (557, N'Kaiser Foundation Hospital - San Die', 1, NULL, NULL, N'050515', NULL, NULL, 0, 397, NULL, N'6195285000', N'6195285317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4647 Zion Ave', N'San Die', N'CA', N'06073', N'92120', 32.792969, -117.094905, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (558, N'Mercy San Juan Medical Center', 1, NULL, NULL, N'050516', NULL, NULL, 0, 254, NULL, N'9165375000', N'9165375111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 Coyle Ave', N'Carmichael', N'CA', N'06067', N'95608', 38.668044, -121.31378, 518, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (559, N'Victor Valley Global Medical Center', 1, NULL, NULL, N'050517', NULL, NULL, 0, 101, NULL, N'7602458691', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15248 11Th St', N'Victorville', N'CA', N'06071', N'92392', 34.528027, -117.292535, 700, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (560, N'Sutter Delta Medical Center', 1, NULL, NULL, N'050523', NULL, NULL, 0, 111, NULL, N'9257797200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Lone Tree Way', N'Antioch', N'CA', N'06013', N'94509', 37.982378, -121.805547, 498, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (561, N'Huntington Beach Hospital', 1, NULL, NULL, N'050526', NULL, NULL, 0, 131, NULL, N'7148435000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17772 Beach Blvd', N'Huntington Beach', N'CA', N'06059', N'92647', 33.703982, -117.989066, 576, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (562, N'Memorial Hospital Los Banos', 1, NULL, NULL, N'050528', NULL, NULL, 0, 48, NULL, N'2098260591', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West I St', N'Los Banos', N'CA', N'06047', N'93635', 37.06343, -120.859426, 598, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (563, N'John F Kennedy Memorial Hospital', 1, NULL, NULL, N'050534', NULL, NULL, 0, 156, NULL, N'7603476191', N'7607758014', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'47111 Monroe Street', N'Indio', N'CA', N'06065', N'92201', 33.706355, -116.233881, 577, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (564, N'Sutter Davis Hospital', 1, NULL, NULL, N'050537', NULL, NULL, 0, 48, NULL, N'5307566440', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Sutter Place', N'Davis', N'CA', N'06113', N'95616', 38.56131, -121.772611, 536, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (565, N'Kaiser Foundation Hospital - Redwood City', 1, NULL, NULL, N'050541', NULL, NULL, 0, 213, NULL, N'6502992000', N'6502994949', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Veterans Boulevard', N'Redwood City', N'CA', N'06081', N'94063', 37.489531, -122.223374, 646, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (566, N'College Hospital Costa Mesa', 1, NULL, NULL, N'050543', NULL, NULL, 0, 122, NULL, N'9496422734', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Victoria Street', N'Costa Mesa', N'CA', N'06059', N'92627', 33.652605, -117.911941, 617, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (567, N'Lanterman Developmental Center', 1, NULL, NULL, N'050545', NULL, NULL, 0, 39, NULL, N'9095951221', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3530 Pomona Boulevard', N'Pomona', N'CA', N'06037', N'91768', 34.045967, -117.812607, 637, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (568, N'Porterville Developmental Center', 1, NULL, NULL, N'050546', NULL, NULL, 0, 1226, NULL, N'5597822222', N'5597822193', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26501 Avenue 140', N'Porterville', N'CA', N'06107', N'93257', 36.043907, -118.980426, 638, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (569, N'Sonoma Developmental Center', 1, NULL, NULL, N'050547', NULL, NULL, 0, 13, NULL, N'7079386000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'15000 Arnold Drive   /  P O Box 1493', N'Eldridge', N'CA', N'06097', N'95431', 38.349446, -122.517417, 676, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (570, N'Fairview Developmental Center', 1, NULL, NULL, N'050548', NULL, NULL, 0, 1228, NULL, N'7149575000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Harbor Boulevard', N'Costa Mesa', N'CA', N'06059', N'92626', 33.663272, -117.919275, 617, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (571, N'Los Robles Hospital & Medical Center', 1, NULL, NULL, N'050549', NULL, NULL, 0, 273, NULL, N'8054972727', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 W Janss Rd', N'Thousand Oaks', N'CA', N'06111', N'91360', 34.206407, -118.882497, 687, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (572, N'Los Alamitos Medical Center', 1, NULL, NULL, N'050551', NULL, NULL, 0, 167, NULL, N'5627993220', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3751 Katella Avenue', N'Los Alamitos', N'CA', N'06059', N'90720', 33.803175, -118.067483, 596, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (573, N'Motion Picture & Television Hospital', 1, NULL, NULL, N'050552', NULL, NULL, 0, 256, NULL, N'8188761888', N'8188761079', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23388 Mulholland Drive', N'Woodland Hills', N'CA', N'06037', N'91364', 34.158498, -118.636141, 517, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (574, N'Memorial Medical Center', 1, NULL, NULL, N'050557', NULL, NULL, 0, 275, NULL, N'2095264500', N'2095697417', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Coffee Rd', N'Modesto', N'CA', N'06099', N'95355', 37.668749, -120.975673, 608, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (575, N'Kaiser Foundation Hospital - West La', 1, NULL, NULL, N'050561', NULL, NULL, 0, 293, NULL, N'2138572201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6041 Cadillac Ave', N'Los Angeles', N'CA', N'06037', N'90034', 34.037627, -118.374908, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (576, N'Mission Hospital Regional Med Center', 1, NULL, NULL, N'050567', NULL, NULL, 0, 565, NULL, N'9493641400', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27700 Medical Center Rd', N'Mission Viejo', N'CA', N'06059', N'92691', 33.562742, -117.667758, 607, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (577, N'Madera Community Hospital', 1, NULL, NULL, N'050568', NULL, NULL, 0, 106, NULL, N'5596755555', N'5596755574', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 E Almond Ave', N'Madera', N'CA', N'06039', N'93637', 36.945433, -120.045781, 600, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (578, N'Fountain Valley Regional Hospital & Medical Center', 1, NULL, NULL, N'050570', NULL, NULL, 0, 405, NULL, N'7149667200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17100 Euclid Street', N'Fountain Valley', N'CA', N'06059', N'92708', 33.714417, -117.937007, 554, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (579, N'Eisenhower Medical Center', 1, NULL, NULL, N'050573', NULL, NULL, 0, 289, NULL, N'7603403911', N'7607734336', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39-000 Bob Hope Drive', N'Rancho Mirage', N'CA', N'06065', N'92270', 33.763402, -116.408082, 642, 26, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (580, N'Gardens Regional Hospital And Medical Center', 1, NULL, NULL, N'050575', NULL, NULL, 0, 107, NULL, N'5628600401', N'5629245871', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21530 S Pioneer Blvd', N'Hawaiian Gardens', N'CA', N'06037', N'90716', 33.833516, -118.081794, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (581, N'La Palma Intercommunity Hospital', 1, NULL, NULL, N'050580', NULL, NULL, 0, 141, NULL, N'7146707400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7901 Walker Street', N'La Palma', N'CA', N'06059', N'90623', 33.848275, -118.037261, 497, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (582, N'Lakewood Regional Medical Center', 1, NULL, NULL, N'050581', NULL, NULL, 0, 170, NULL, N'5626026751', N'5626020083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 E South St', N'Lakewood', N'CA', N'06037', N'90712', 33.860228, -118.147613, 587, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (583, N'Chino Valley Medical Center', 1, NULL, NULL, N'050586', NULL, NULL, 0, 126, NULL, N'9096276111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5451 Walnut Ave', N'Chino', N'CA', N'06071', N'91710', 34.026344, -117.684726, 523, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (584, N'San Dimas Community Hospital', 1, NULL, NULL, N'050588', NULL, NULL, 0, 101, NULL, N'9095996811', N'9093942789', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 W Covina Blvd', N'San Dimas', N'CA', N'06037', N'91773', 34.099423, -117.835006, 656, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (585, N'Placentia Linda Hospital', 1, NULL, NULL, N'050589', NULL, NULL, 0, 114, NULL, N'7149932000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 N Rose Drive', N'Placentia', N'CA', N'06059', N'92870', 33.88674, -117.842037, 557, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (586, N'Methodist Hospital Of Sacramento', 1, NULL, NULL, N'050590', NULL, NULL, 0, 158, NULL, N'9164236010', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Hospital Drive', N'Sacramento', N'CA', N'06067', N'95823', 38.464232, -121.416383, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (587, N'Foothill Presbyterian Hospital', 1, NULL, NULL, N'050597', NULL, NULL, 0, 106, NULL, N'6269638411', N'6268595865', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 S Grand Ave', N'Glendora', N'CA', N'06037', N'91740', 34.1332, -117.872533, 563, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (588, N'University Of California Davis Medical Center', 1, NULL, NULL, N'050599', NULL, NULL, 0, 631, NULL, N'9167342011', N'9167347411', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2315 Stockton Boulevard', N'Sacramento', N'CA', N'06067', N'95817', 38.554375, -121.457535, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (589, N'Saddleback Memorial Medical Center', 1, NULL, NULL, N'050603', NULL, NULL, 0, 325, NULL, N'9498374500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24451 Health Center Drive', N'Laguna Hills', N'CA', N'06059', N'92653', 33.607975, -117.708217, 584, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (590, N'Kaiser Foundation Hospital-San Jose', 1, NULL, NULL, N'050604', NULL, NULL, 0, 228, NULL, N'4089727000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Parkway', N'San Jose', N'CA', N'06085', N'95119', 37.239463, -121.800936, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (591, N'Delano Regional Medical Center', 1, NULL, NULL, N'050608', NULL, NULL, 0, 156, NULL, N'6617254800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Garces Highway', N'Delano', N'CA', N'06029', N'93215', 35.761418, -119.238924, 538, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (592, N'Kaiser Foundation Hospital - Orange County - Anahe', 1, NULL, NULL, N'050609', NULL, NULL, 0, 200, NULL, N'7142794000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3440 E La Palma Ave', N'Anaheim', N'CA', N'06059', N'92806', 33.854441, -117.84411, 497, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (593, N'St Johns Pleasant Valley Hospital', 1, NULL, NULL, N'050616', NULL, NULL, 0, 180, NULL, N'8053895800', N'8053837450', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2309 Antonio Ave', N'Camarillo', N'CA', N'06111', N'93010', 34.244396, -119.019137, 516, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (594, N'Henry Mayo Newhall  Hospital', 1, NULL, NULL, N'050624', NULL, NULL, 0, 227, NULL, N'6612538000', N'6612001042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23845  Mcbean Pkwy', N'Valencia', N'CA', N'06037', N'91355', 34.396424, -118.553041, 696, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (595, N'Cedars-Sinai Medical Center', 1, NULL, NULL, N'050625', NULL, NULL, 0, 877, NULL, N'3104235000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8700 Beverly Blvd', N'Los Angeles', N'CA', N'06037', N'90048', 34.076776, -118.380053, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (596, N'Twin Cities Community Hospital', 1, NULL, NULL, N'050633', NULL, NULL, 0, 114, NULL, N'8054343500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Las Tablas Rd', N'Templeton', N'CA', N'06079', N'93465', 35.554384, -120.720652, 686, 34, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (597, N'Pomerado Hospital', 1, NULL, NULL, N'050636', NULL, NULL, 0, 236, NULL, N'8584856511', N'8586134764', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15615 Pomerado Road', N'Poway', N'CA', N'06073', N'92064', 32.996719, -117.057855, 640, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (598, N'East Los Angeles Doctors Hospital', 1, NULL, NULL, N'050641', NULL, NULL, 0, 127, NULL, N'3232685514', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4060 Whittier Blvd', N'Los Angeles', N'CA', N'06037', N'90023', 34.023932, -118.184028, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (599, N'Usc Kenneth Norris Jr Cancer Hospital', 1, NULL, NULL, N'050660', NULL, NULL, 0, 60, NULL, N'3238653000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Eastlake Ave', N'Los Angeles', N'CA', N'06037', N'90089', 34.061458, -118.204333, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (600, N'Los Angeles Community Hospital', 1, NULL, NULL, N'050663', NULL, NULL, 0, 180, NULL, N'3232670477', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4081 E Olympic Blvd', N'Los Angeles', N'CA', N'06037', N'90023', 34.018874, -118.186579, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (601, N'Laguna Honda Hospital & Rehabilitation Center', 1, NULL, NULL, N'050668', NULL, NULL, 0, 11, NULL, N'4157592300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Laguna Honda Blvd', N'San Francisco', N'CA', N'06075', N'94116', 37.74755, -122.458778, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (602, N'Kaiser Foundation Hosp So Sacramento', 1, NULL, NULL, N'050674', NULL, NULL, 0, 223, NULL, N'9166882000', N'9166277015', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6600 Bruceville Road', N'Sacramento', N'CA', N'06067', N'95823', 38.471685, -121.42385, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (603, N'Kaiser Foundation Hospital - Woodland Hills', 1, NULL, NULL, N'050677', NULL, NULL, 0, 218, NULL, N'8187193800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 De Soto', N'Woodland Hills', N'CA', N'06037', N'91367', 34.171005, -118.588182, 517, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (604, N'Orange Coast Memorial Medical Center', 1, NULL, NULL, N'050678', NULL, NULL, 0, 210, NULL, N'7143787406', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9920 Talbert Avenue', N'Fountain Valley', N'CA', N'06059', N'92708', 33.70166, -117.956192, 554, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (605, N'Northbay Vacavalley Hospital', 1, NULL, NULL, N'050680', NULL, NULL, 0, 50, NULL, N'7076247000', N'7076247002', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Nut Tree Road', N'Vacaville', N'CA', N'06095', N'95688', 38.367197, -121.955222, 695, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (606, N'Menifee Valley Medical Center', 1, NULL, NULL, N'050684', NULL, NULL, 0, 84, NULL, N'9516798888', N'9517666419', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28400 Mccall B0ulevard', N'Sun City', N'CA', N'06065', N'92585', 33.701022, -117.202787, 716, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (607, N'Kaiser Foundation Hospital Riverside', 1, NULL, NULL, N'050686', NULL, NULL, 0, 215, NULL, N'9513532000', N'9513534611', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10800 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92505', 33.906505, -117.47071, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (608, N'Saint Louise Regional Hospital', 1, NULL, NULL, N'050688', NULL, NULL, 0, 93, NULL, N'4088482000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9400 No Name Uno', N'Gilroy', N'CA', N'06085', N'95020', 37.036542, -121.573714, 561, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (609, N'San Ramon Regional Medical Ctr', 1, NULL, NULL, N'050689', NULL, NULL, 0, 123, NULL, N'9252759200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Norris Canyon Road', N'San Ramon', N'CA', N'06013', N'94583', 37.775963, -121.959254, 715, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (610, N'Kaiser Foundation Hospital-Santa Rosa', 1, NULL, NULL, N'050690', NULL, NULL, 0, 173, NULL, N'7075714000', N'7075714693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Bicentennial Way', N'Santa Rosa', N'CA', N'06097', N'95403', 38.470227, -122.726127, 671, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (611, N'Keck Hospital Of Usc', 1, NULL, NULL, N'050696', NULL, NULL, 0, 285, NULL, N'3234428656', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 San Pablo St', N'Los Angeles', N'CA', N'06037', N'90033', 34.062178, -118.20323, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (612, N'Patients'' Hospital Of Redding', 1, NULL, NULL, N'050697', NULL, NULL, 0, 10, NULL, N'5302258700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Eureka Way', N'Redding', N'CA', N'06089', N'96001', 40.585461, -122.416635, 644, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (613, N'Southwest Healthcare System', 1, NULL, NULL, N'050701', NULL, NULL, 0, 218, NULL, N'9516966000', N'9516987721', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25500 Medical Center Drive', N'Murrieta', N'CA', N'06065', N'92562', 33.558122, -117.183112, 707, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (614, N'Mission Community Hospital', 1, NULL, NULL, N'050704', NULL, NULL, 0, 96, NULL, N'8189043100', N'8183048646', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14850 Roscoe Blvd', N'Panorama City', N'CA', N'06037', N'91402', 34.221497, -118.456712, 629, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (615, N'Fresno Surgical Hospital', 1, NULL, NULL, N'050708', NULL, NULL, 0, 31, NULL, N'5594318000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6125 North Fresno St', N'Fresno', N'CA', N'06019', N'93710', 36.825107, -119.781419, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (616, N'Desert Valley Hospital', 1, NULL, NULL, N'050709', NULL, NULL, 0, 148, NULL, N'7602418000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16850 Bear Valley Rd', N'Victorville', N'CA', N'06071', N'92395', 34.470898, -117.297831, 700, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (617, N'Kaiser Foundation Hospital - Fresno', 1, NULL, NULL, N'050710', NULL, NULL, 0, 169, NULL, N'5594484500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 North Fresno St', N'Fresno', N'CA', N'06019', N'93720', 36.842292, -119.783213, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (618, N'Sutter Maternity & Surgery Center Of Santa Cruz', 1, NULL, NULL, N'050714', NULL, NULL, 0, 30, NULL, N'8314772200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Chanticleer Avenue', N'Santa Cruz', N'CA', N'06087', N'95065', 36.987829, -121.978192, 667, 37, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (619, N'Lac/Rancho Los Amis National Rehabilitation  Ctr', 1, NULL, NULL, N'050717', NULL, NULL, 0, 395, NULL, N'5624017022', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 East Imperial Highway', N'Downey', N'CA', N'06059', N'90242', 33.924594, -118.153071, 540, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (620, N'Kaiser Foundation Hospital - Baldwin Park', 1, NULL, NULL, N'050723', NULL, NULL, 0, 269, NULL, N'6268511011', N'6264056281', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Baldwin Park Blvd', N'Baldwin Park', N'CA', N'06037', N'91706', 34.064322, -117.984957, 705, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (621, N'Bakersfield Heart Hospital', 1, NULL, NULL, N'050724', NULL, NULL, 0, 47, NULL, N'6613166000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Sillect Avenue', N'Bakersfield', N'CA', N'06029', N'93308', 35.386043, -119.040006, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (622, N'Stanislaus Surgical Hospital', 1, NULL, NULL, N'050726', NULL, NULL, 0, 23, NULL, N'2095722700', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1421 Oakdale Road', N'Modesto', N'CA', N'06099', N'95355', 37.664674, -120.957518, 608, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (623, N'Community Hospital Of Long Beach', 1, NULL, NULL, N'050727', NULL, NULL, 0, 258, NULL, N'5624940600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 Termino Avenue', N'Long Beach', N'CA', N'06037', N'90804', 33.787633, -118.145881, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (624, N'Fresno Heart And Surgical Hospital', 1, NULL, NULL, N'050732', NULL, NULL, 0, 57, NULL, N'5594338000', NULL, 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 East Audubon Drive', N'Fresno', N'CA', N'06019', N'93720', 36.860955, -119.789293, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (625, N'Whittier Hospital Medical Center', 1, NULL, NULL, N'050735', NULL, NULL, 0, 178, NULL, N'5629453561', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9080 Colima Rd', N'Whittier', N'CA', N'06037', N'90605', 33.950867, -118.005045, 706, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (626, N'Monterey Park Hospital', 1, NULL, NULL, N'050736', NULL, NULL, 0, 102, NULL, N'6265709000', N'6262814719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 S Atlantic Blvd', N'Monterey Park', N'CA', N'06037', N'91754', 34.05016, -118.138511, 611, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (627, N'Garfield Medical Center', 1, NULL, NULL, N'050737', NULL, NULL, 0, 210, NULL, N'6265732222', N'6265718972', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Garfield Ave', N'Monterey Park', N'CA', N'06037', N'91754', 34.068982, -118.122924, 611, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (628, N'Greater El Monte Community Hospital', 1, NULL, NULL, N'050738', NULL, NULL, 0, 104, NULL, N'6263507975', N'6263500368', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Santa Anita Ave', N'South El Monte', N'CA', N'06037', N'91733', 34.047972, -118.042423, 678, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (629, N'Centinela Hospital Medical Center', 1, NULL, NULL, N'050739', NULL, NULL, 0, 346, NULL, N'3106734660', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 East Hardy Street', N'Inglewood', N'CA', N'06037', N'90301', 33.949086, -118.348319, 578, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (630, N'Marina Del Rey Hospital', 1, NULL, NULL, N'050740', NULL, NULL, 0, 145, NULL, N'3108238911', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4650 Lincoln Blvd', N'Marina Del Rey', N'CA', N'06037', N'90291', 33.98224, -118.440631, 669, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (631, N'Olympia Medical Center', 1, NULL, NULL, N'050742', NULL, NULL, 0, 204, NULL, N'3106575900', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 West Olympic Boulevard', N'Los Angeles', N'CA', N'06037', N'90036', 34.057527, -118.359857, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (632, N'Anaheim Global Medical Center', 1, NULL, NULL, N'050744', NULL, NULL, 0, 188, NULL, N'7145336220', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 S Anaheim Blvd', N'Anaheim', N'CA', N'06059', N'92805', 33.820566, -117.909002, 497, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (633, N'Chapman Global Medical Center', 1, NULL, NULL, N'050745', NULL, NULL, 0, 84, NULL, N'7146330011', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 E Chapman Ave', N'Orange', N'CA', N'06059', N'92869', 33.787878, -117.827058, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (634, N'Orange County Global Medical Center', 1, NULL, NULL, N'050746', NULL, NULL, 0, 282, NULL, N'7149533331', N'7149533613', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 North Tustin Avenue', N'Santa Ana', N'CA', N'06059', N'92705', 33.753635, -117.834209, 665, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (635, N'South Coast Global Medical Center', 1, NULL, NULL, N'050747', NULL, NULL, 0, 178, NULL, N'7147545454', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 S Bristol St', N'Santa Ana', N'CA', N'06059', N'92704', 33.710708, -117.885409, 554, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (636, N'Kaiser Foundation Hospital Manteca', 1, NULL, NULL, N'050748', NULL, NULL, 0, 224, NULL, N'2098253700', N'2098253524', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1777 West Yosemite Ave', N'Manteca', N'CA', N'06077', N'95337', 37.797371, -121.246189, 602, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (637, N'Miracle Mile Medical Center', 1, NULL, NULL, N'050751', NULL, NULL, 0, 17, NULL, N'3239301040', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 San Vicente Blvd', N'Los Angeles', N'CA', N'06037', N'90036', 34.057356, -118.361988, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (638, N'Menlo Park Surgical Hospital', 1, NULL, NULL, N'050754', NULL, NULL, 0, 16, NULL, N'6503248500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'570 Willow Road', N'Menlo Park', N'CA', N'06081', N'94025', 37.462072, -122.159496, 682, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (639, N'Sherman Oaks Hospital', 1, NULL, NULL, N'050755', NULL, NULL, 0, 153, NULL, N'8189817111', N'8185015316', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4929 Van Nuys Blvd', N'Sherman Oaks', N'CA', N'06037', N'91403', 34.160574, -118.448705, 698, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (640, N'Alvarado Hospital Medical Center', 1, NULL, NULL, N'050757', NULL, NULL, 0, 311, NULL, N'6192293172', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 Alvarado Road', N'San Die', N'CA', N'06073', N'92120', 32.777253, -117.057301, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (641, N'Montclair Hospital Medical Center', 1, NULL, NULL, N'050758', NULL, NULL, 0, 102, NULL, N'9096258300', N'9096264777', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 San Bernardino St', N'Montclair', N'CA', N'06071', N'91763', 34.077663, -117.695812, 637, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (642, N'Kaiser Foundation Hospital - Antioch', 1, NULL, NULL, N'050760', NULL, NULL, 0, 150, NULL, N'9258136500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4501 Sand Creek Road', N'Antioch', N'CA', N'06013', N'94531', 37.949475, -121.774946, 498, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (643, N'Providence Tarzana Medical Center', 1, NULL, NULL, N'050761', NULL, NULL, 0, 245, NULL, N'8188810800', N'8187085382', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18321 Clark Street', N'Tarzana', N'CA', N'06037', N'91356', 34.169773, -118.531305, 685, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (644, N'Silver Lake Medical Center', 1, NULL, NULL, N'050763', NULL, NULL, 0, 187, NULL, N'2139896123', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1711 West Temple Street', N'Los Angeles', N'CA', N'06037', N'90026', 34.068688, -118.263235, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (645, N'Shasta Regional Medical Center', 1, NULL, NULL, N'050764', NULL, NULL, 0, 246, NULL, N'5302445454', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Butte St', N'Redding', N'CA', N'06089', N'96001', 40.584999, -122.388246, 644, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (646, N'Kaiser Foundation Hospital-Moreno Valley', 1, NULL, NULL, N'050765', NULL, NULL, 0, 101, NULL, N'9512516000', N'9512512005', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27300 Iris Avenue', N'Moreno Valley', N'CA', N'06065', N'92555', 33.895697, -117.187121, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (647, N'Sutter Surgical Hospital - North Valley', 1, NULL, NULL, N'050766', NULL, NULL, 0, 14, NULL, N'5307495700', N'5307495720', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 Plumas Blvd', N'Yuba City', N'CA', N'06101', N'95991', 39.131804, -121.613662, 711, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (648, N'Kaiser Foundation Hospital - Vacaville', 1, NULL, NULL, N'050767', NULL, NULL, 0, 72, NULL, N'7076244000', N'7076242051', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Quality Drive', N'Vacaville', N'CA', N'06095', N'95688', 38.388736, -121.938023, 695, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (649, N'Hoag Orthopedic Institute', 1, NULL, NULL, N'050769', NULL, NULL, 0, 70, NULL, N'9497275000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16250 Sand Canyon Avenue', N'Irvine', N'CA', N'06059', N'92618', 33.66137, -117.774051, 665, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (650, N'Loma Linda University Medical Center-Murrieta', 1, NULL, NULL, N'050770', NULL, NULL, 0, 106, NULL, N'9512904000', N'9516514215', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28062 Baxter Road', N'Murrieta', N'CA', N'06065', N'92563', 33.613472, -117.169343, 707, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (651, N'Coast Plaza Hospital', 1, NULL, NULL, N'050771', NULL, NULL, 0, 117, NULL, N'3103560550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13100 Studerbaker Road', N'Norwalk', N'CA', N'06037', N'90650', 33.90928, -118.084917, 619, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (652, N'Kaiser Foundation Hospital - Roseville', 1, NULL, NULL, N'050772', NULL, NULL, 0, 340, NULL, N'9167844000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Eureka Road', N'Roseville', N'CA', N'06061', N'95661', 38.7481, -121.24762, 649, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (653, N'San Leandro Hospital', 1, NULL, NULL, N'050773', NULL, NULL, 0, 10, NULL, N'5103576500', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13855 E 14Th Street', N'San Leandro', N'CA', N'06001', N'94578', 37.714618, -122.14195, 660, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (654, N'Temecula Valley Hospital', 1, NULL, NULL, N'050775', NULL, NULL, 0, 140, NULL, N'9513312200', N'9513312202', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'31700 Temecula Pkwy', N'Temecula', N'CA', N'06065', N'92592', 33.479662, -117.104288, 707, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (655, N'College Medical Center', 1, NULL, NULL, N'050776', NULL, NULL, 0, 157, NULL, N'5625951911', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2776 Pacific Avenue', N'Long Beach', N'CA', N'06037', N'90806', 33.807253, -118.19372, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (656, N'Kaiser Foundation Hospital - San Leandro', 1, NULL, NULL, N'050777', NULL, NULL, 0, 108, NULL, N'5104541000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Merced Street', N'San Leandro', N'CA', N'06001', N'94577', 37.706524, -122.169447, 660, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (657, N'Loma Linda University Children''s Hospital', 1, NULL, NULL, N'050778', NULL, NULL, 0, 343, NULL, N'9095588000', N'9095580223', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11234 Anderson Street Suite A', N'Loma Linda', N'CA', N'06071', N'92354', 34.049616, -117.261118, 592, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (658, N'Martin Luther King Jr. Community Hospital', 1, NULL, NULL, N'050779', NULL, NULL, 0, 131, NULL, N'4248356808', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1680 East 120Th Street', N'Los Angeles', N'CA', N'06037', N'90059', 33.9239321, -118.2473415, 599, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (659, N'Foothill Regional Medical Center', 1, NULL, NULL, N'050780', NULL, NULL, 0, 135, NULL, N'7146197700', N'3234633830', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14662 Newport Ave', N'Tustin', N'CA', N'06059', N'92780', 33.739775, -117.820433, 665, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (660, N'Eastern Plumas Hospital - Portola Campus', 1, NULL, NULL, N'051300', NULL, NULL, 0, 9, NULL, N'5308324277', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 First Avenue', N'Portola', N'CA', N'06063', N'96122', 39.805746, -120.46232, 639, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (661, N'Tehachapi Hospital', 1, NULL, NULL, N'051301', NULL, NULL, 0, 24, NULL, N'6618223241', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 West E Street', N'Tehachapi', N'CA', N'06029', N'93561', 35.129958, -118.448208, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (662, N'Southern Inyo Hospital', 1, NULL, NULL, N'051302', NULL, NULL, 0, 25, NULL, N'7608765501', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'501 East Locust Street', N'Lone Pine', N'CA', N'06027', N'93545', 36.608373, -118.057948, 594, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (663, N'Mammoth Hospital', 1, NULL, NULL, N'051303', NULL, NULL, 0, 17, NULL, N'7609343311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 Sierra Park Road Po Box 660', N'Mammoth Lakes', N'CA', N'06051', N'93546', 37.644301, -118.963926, 601, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (664, N'John C Fremont Healthcare District', 1, NULL, NULL, N'051304', NULL, NULL, 0, 34, NULL, N'2099663631', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5189 Hospital Road', N'Mariposa', N'CA', N'06043', N'95338', 37.49985, -119.976657, 605, 23, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (665, N'Mayers Memorial Hospital', 1, NULL, NULL, N'051305', NULL, NULL, 0, 121, NULL, N'5303365511', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43563 Hwy 299 East', N'Fall River Mills', N'CA', N'06089', N'96028', 41.004608, -121.438314, 548, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (666, N'Glenn Medical Center', 1, NULL, NULL, N'051306', NULL, NULL, 0, 47, NULL, N'5309341818', N'5309341818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1133 W Sycamore St', N'Willows', N'CA', N'06021', N'95988', 39.520467, -122.20812, 522, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (667, N'Catalina Island Medical Center', 1, NULL, NULL, N'051307', NULL, NULL, 0, 12, NULL, N'3105100700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Falls Canyon Road', N'Avalon', N'CA', N'06037', N'90704', 33.338904, -118.330972, 504, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (668, N'Surprise Valley Community Hospital', 1, NULL, NULL, N'051308', NULL, NULL, 0, 26, NULL, N'5302796111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'741 North Main Street', N'Cedarville', N'CA', N'06049', N'96104', 41.532, -120.171898, 520, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (669, N'Jerold Phelps Community Hospital', 1, NULL, NULL, N'051309', NULL, NULL, 0, 16, NULL, N'7079233921', N'7079231456', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'733 Cedar St', N'Garberville', N'CA', N'06023', N'95542', 40.101491, -123.792756, 558, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (670, N'Frank R Howard Memorial Hospital', 1, NULL, NULL, N'051310', NULL, NULL, 0, 25, NULL, N'7074563031', N'7074599486', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Marcela Dr', N'Willits', N'CA', N'06045', N'95490', 39.400913, -123.350619, 708, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (671, N'Orchard Hospital', 1, NULL, NULL, N'051311', NULL, NULL, 0, 24, NULL, N'5308465671', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Spruce Street', N'Gridley', N'CA', N'06007', N'95948', 39.366972, -121.689959, 568, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (672, N'Mountains Community Hospital', 1, NULL, NULL, N'051312', NULL, NULL, 0, 17, NULL, N'9093363651', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29101 Hospital Road', N'Lake Arrowhead', N'CA', N'06071', N'92352', 34.266553, -117.168211, 653, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (673, N'Kern Valley Healthcare District', 1, NULL, NULL, N'051314', NULL, NULL, 0, 27, NULL, N'7603792681', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6412 Laurel Ave', N'Lake Isabella', N'CA', N'06029', N'93240', 35.635292, -118.406179, 585, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (674, N'Trinity Hospital', 1, NULL, NULL, N'051315', NULL, NULL, 0, 25, NULL, N'5306235541', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Easter Avenue', N'Weaverville', N'CA', N'06105', N'96093', 40.737821, -122.940472, 704, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (675, N'Fairchild Medical Center', 1, NULL, NULL, N'051316', NULL, NULL, 0, 28, NULL, N'5308424121', N'5308410913', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'444 Bruce Street', N'Yreka', N'CA', N'06093', N'96097', 41.718564, -122.644826, 710, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (676, N'St Helena Hospital-Clearlake', 1, NULL, NULL, N'051317', NULL, NULL, 0, 32, NULL, N'7079946486', N'7079953516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15630 18Th Ave - Hwy 53', N'Clearlake', N'CA', N'06033', N'95422', 38.936107, -122.615392, 525, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (677, N'Redwood Memorial Hospital', 1, NULL, NULL, N'051318', NULL, NULL, 0, 25, NULL, N'7074458121', N'7077257212', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Renner Drive', N'Fortuna', N'CA', N'06023', N'95540', 40.582575, -124.135547, 553, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (678, N'Mercy Medical Center Mt Shasta', 1, NULL, NULL, N'051319', NULL, NULL, 0, 25, NULL, N'5309266111', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'914 Pine Street', N'Mount Shasta', N'CA', N'06093', N'96067', 41.31891, -122.323102, 612, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (679, N'Banner Lassen Medical Center', 1, NULL, NULL, N'051320', NULL, NULL, 0, 38, NULL, N'5302522000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Spring Ridge Drive', N'Susanville', N'CA', N'06035', N'96130', 40.43819, -120.629027, 684, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (680, N'Healdsburg District Hospital', 1, NULL, NULL, N'051321', NULL, NULL, 0, 43, NULL, N'7074316500', N'7074316588', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 University Avenue', N'Healdsburg', N'CA', N'06097', N'95448', 38.627342, -122.863746, 573, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (681, N'Colorado River Medical Center', 1, NULL, NULL, N'051323', NULL, NULL, 0, 25, NULL, N'7603264531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Bailey Ave', N'Needles', N'CA', N'06071', N'92363', 34.832788, -114.618317, 616, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (682, N'Northern Inyo Hospital', 1, NULL, NULL, N'051324', NULL, NULL, 0, 25, NULL, N'7608735811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Pioneer Lane', N'Bishop', N'CA', N'06027', N'93514', 37.361601, -118.407362, 511, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (683, N'Mendocino Coast District Hospital', 1, NULL, NULL, N'051325', NULL, NULL, 0, 25, NULL, N'7079611234', N'7079614794', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 River Dr', N'Fort Bragg', N'CA', N'06045', N'95437', 39.432466, -123.800799, 552, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (684, N'Plumas District Hospital', 1, NULL, NULL, N'051326', NULL, NULL, 0, 25, NULL, N'5302832121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1065 Bucks Lake Road', N'Quincy', N'CA', N'06063', N'95971', 39.939215, -120.962222, 641, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (685, N'Seneca District Hospital', 1, NULL, NULL, N'051327', NULL, NULL, 0, 26, NULL, N'5302582121', NULL, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'130 Brentwood Drive', N'Chester', N'CA', N'06063', N'96020', 40.305125, -121.234169, 521, 19, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (686, N'Tahoe Forest Hospital', 1, NULL, NULL, N'051328', NULL, NULL, 0, 72, NULL, N'5305876011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10121 Pine Ave', N'Truckee', N'CA', N'06057', N'96161', 39.324884, -120.201295, 690, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (687, N'Sutter Lakeside Hospital', 1, NULL, NULL, N'051329', NULL, NULL, 0, 30, NULL, N'7072625000', N'7072625003', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5176 Hill Road East', N'Lakeport', N'CA', N'06033', N'95453', 39.101994, -122.910446, 586, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (688, N'Modoc Medical Center', 1, NULL, NULL, N'051330', NULL, NULL, 0, 16, NULL, N'5302335131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'228 W Mcdowell Ave', N'Alturas', N'CA', N'06049', N'96101', 41.479999, -120.544389, 496, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (689, N'Santa Ynez Valley Cottage Hospital', 1, NULL, NULL, N'051331', NULL, NULL, 0, 10, NULL, N'8056886431', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Viborg Rd', N'Solvang', N'CA', N'06083', N'93463', 34.602456, -120.125936, 675, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (690, N'Mark Twain Medical Center', 1, NULL, NULL, N'051332', NULL, NULL, 0, 25, NULL, N'2097542515', N'2097542626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'768 Mountain Ranch Rd', N'San Andreas', N'CA', N'06009', N'95249', 38.190208, -120.671186, 652, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (691, N'Ridgecrest Regional Hospital', 1, NULL, NULL, N'051333', NULL, NULL, 0, 98, NULL, N'7604463551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1081 North China Lake Blvd', N'Ridgecrest', N'CA', N'06029', N'93555', 35.641292, -117.67115, 647, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (692, N'Ojai Valley Community Hospital', 1, NULL, NULL, N'051334', NULL, NULL, 0, 110, NULL, N'8056402280', N'8056401051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 Maricopa Hwy', N'Ojai', N'CA', N'06111', N'93023', 34.442357, -119.264825, 624, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (693, N'Bear Valley Community Hospital', 1, NULL, NULL, N'051335', NULL, NULL, 0, 30, NULL, N'9098666501', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41870 Garstin Dr', N'Big Bear Lake', N'CA', N'06071', N'92315', 34.246042, -116.889236, 510, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (694, N'Sunland Home Corporation', 1, NULL, NULL, N'051990', NULL, NULL, 0, 20, NULL, N'7609442976', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'691 Sparta Drive', N'Encinitas', N'CA', N'06073', N'92024', 33.070119, -117.291337, 543, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (695, N'Broadview Inc', 1, NULL, NULL, N'051991', NULL, NULL, 0, 42, NULL, N'2132219174', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4570 Griffin Avenue', N'Los Angeles', N'CA', N'06037', N'90031', 34.095478, -118.201709, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (696, N'Arden Wood Inc', 1, NULL, NULL, N'051993', NULL, NULL, 0, 13, NULL, N'4156815500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'445 Wawona Street', N'San Francisco', N'CA', N'06075', N'94116', 37.7373622, -122.4736817, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (697, N'Fern Lodge Inc', 1, NULL, NULL, N'051994', NULL, NULL, 0, 28, NULL, N'5108862448', N'5108865992', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'18457 Madison Avenue', N'Castro Valley', N'CA', N'06001', N'94546', 37.7133532, -122.0664357, 519, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (698, N'Olive Glen Foundation', 1, NULL, NULL, N'051995', NULL, NULL, 0, 13, NULL, N'9164861161', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3025 Becerra Way', N'Sacramento', N'CA', N'06067', N'95821', 38.620297, -121.373861, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (699, N'Barlow Respiratory Hospital', 1, NULL, NULL, N'052031', NULL, NULL, 0, 99, NULL, N'2132504200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Stadium Way', N'Los Angeles', N'CA', N'06037', N'90026', 34.07523, -118.248275, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (700, N'Kindred - Los Angeles', 1, NULL, NULL, N'052032', NULL, NULL, 0, 81, NULL, N'3106420325', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5525  W Slauson Avenue', N'Los Angeles', N'CA', N'06037', N'90056', 33.988891, -118.35267, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (701, N'Vibra Hospital Of Sacramento', 1, NULL, NULL, N'052033', NULL, NULL, 0, 58, NULL, N'9163519151', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Montrose Drive', N'Folsom', N'CA', N'06067', N'95630', 38.681583, -121.158175, 550, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (702, N'Kindred Hospital - San Francisco Bay Area', 1, NULL, NULL, N'052034', NULL, NULL, 0, 99, NULL, N'5103578300', N'5103571284', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Benedict Drive', N'San Leandro', N'CA', N'06001', N'94577', 37.716124, -122.131164, 660, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (703, N'Kindred Hospital Westminster', 1, NULL, NULL, N'052035', NULL, NULL, 0, 109, NULL, N'7148934541', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Circle', N'Westminster', N'CA', N'06059', N'92683', 33.763851, -117.994497, 554, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (704, N'Kindred Hospital - San Die', 1, NULL, NULL, N'052036', NULL, NULL, 0, 70, NULL, N'6195434500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1940 El Cajon Blvd', N'San Die', N'CA', N'06073', N'92104', 32.756133, -117.144357, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (705, N'Kindred Hospital Ontario', 1, NULL, NULL, N'052037', NULL, NULL, 0, 91, NULL, N'9093910333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 North Monterey', N'Ontario', N'CA', N'06071', N'91764', 34.063344, -117.650888, 694, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (706, N'Kindred Hospital -- La Mirada', 1, NULL, NULL, N'052038', NULL, NULL, 0, 277, NULL, N'5629441900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14900 E Imperial Hwy', N'La Mirada', N'CA', N'06037', N'90637', 33.917344, -117.996023, 706, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (707, N'Kindred Hospital Brea', 1, NULL, NULL, N'052039', NULL, NULL, 0, 48, NULL, N'7145296842', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'875 N Brea Blvd', N'Brea', N'CA', N'06059', N'92821', 33.93411, -117.893402, 557, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (708, N'Kentfield Rehabilitation & Specialty Hospital', 1, NULL, NULL, N'052043', NULL, NULL, 0, 60, NULL, N'4154569680', N'4154853622', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Sir Francis Drake Blvd', N'Kentfield', N'CA', N'06041', N'94904', 37.951996, -122.557212, 566, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (709, N'Vibra Hospital Of San Die', 1, NULL, NULL, N'052044', NULL, NULL, 0, 88, NULL, N'6192608300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Washington Street', N'San Die', N'CA', N'06073', N'92103', 32.749886, -117.159742, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (710, N'Kindred Hospital Baldwin Park', 1, NULL, NULL, N'052045', NULL, NULL, 0, 95, NULL, N'6263882700', N'8558375738', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14148 East Francisquito Avenue', N'Baldwin Park', N'CA', N'06037', N'91706', 34.085474, -117.961176, 705, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (711, N'Promise Hospital Of East Los Angeles', 1, NULL, NULL, N'052046', NULL, NULL, 0, 177, NULL, N'3232611181', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'443 South Soto Street', N'Los Angeles', N'CA', N'06037', N'90033', 34.054394, -118.243941, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (712, N'Vibra Hospital Of Northern California', 1, NULL, NULL, N'052047', NULL, NULL, 0, 56, NULL, N'5302469000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Eureka Way', N'Redding', N'CA', N'06089', N'96001', 40.585634, -122.413093, 644, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (713, N'Kindred Hospital Rancho', 1, NULL, NULL, N'052049', NULL, NULL, 0, 55, NULL, N'9095816400', N'9095816418', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10841 White Oak Avenue', N'Rancho Cucamonga', N'CA', N'06071', N'91730', 34.103177, -117.56421, 694, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (714, N'Kindred Hospital South Bay', 1, NULL, NULL, N'052050', NULL, NULL, 0, 58, NULL, N'3103235330', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1246 West 155Th Street', N'Gardena', N'CA', N'06037', N'90247', 33.890425, -118.29743, 560, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (715, N'Promise Hospital Of San Die', 1, NULL, NULL, N'052051', NULL, NULL, 0, 100, NULL, N'6195823800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5550 University Avenue', N'San Die', N'CA', N'06073', N'92105', 32.749642, -117.076557, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (716, N'Kindred Hospital Riverside', 1, NULL, NULL, N'052052', NULL, NULL, 0, 40, NULL, N'9514363535', N'9516573968', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2224 Medical Center Drive', N'Perris', N'CA', N'06065', N'92571', 33.810388, -117.221822, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (717, N'Monrovia Memorial Hospital', 1, NULL, NULL, N'052054', NULL, NULL, 0, 49, NULL, N'6263599341', N'6264089809', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South Heliotrope Avenue', N'Monrovia', N'CA', N'06037', N'91016', 34.149097, -117.992276, 500, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (718, N'Casa Colina Hosp And Centers For Healthcare', 1, NULL, NULL, N'053027', NULL, NULL, 0, 68, NULL, N'9095967733', N'9095967845', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 E Bonita Ave', N'Pomona', N'CA', N'06037', N'91767', 34.096136, -117.735373, 637, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (719, N'Healthsouth Bakersfield Rehabilitation Hospital', 1, NULL, NULL, N'053031', NULL, NULL, 0, 60, NULL, N'6613235500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 Commerce Drive', N'Bakersfield', N'CA', N'06029', N'93309', 35.367704, -119.058309, 505, 18, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (720, N'San Joaquin Valley Rehabilitation Hosp', 1, NULL, NULL, N'053032', NULL, NULL, 0, 62, NULL, N'5594363600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7173 N Sharon Avenue', N'Fresno', N'CA', N'06019', N'93720', 36.839921, -119.759616, 556, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (721, N'Healthsouth Tustin Rehabilitation Hospital', 1, NULL, NULL, N'053034', NULL, NULL, 0, 117, NULL, N'7148329200', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14851 Yorba Street', N'Tustin', N'CA', N'06059', N'92780', 33.745762, -117.830108, 665, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (722, N'Ballard Rehabilitation Hospital', 1, NULL, NULL, N'053037', NULL, NULL, 0, 60, NULL, N'9094731275', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1760 West 16Th St', N'San Bernardino', N'CA', N'06071', N'92411', 34.128713, -117.325062, 653, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (723, N'Totally Kids Rehabilitation Hospital', 1, NULL, NULL, N'053038', NULL, NULL, 0, 25, NULL, N'9097966915', N'9097964365', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 Mountain View Avenue', N'Loma Linda', N'CA', N'06071', N'92354', 34.054074, -117.243674, 592, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (724, N'Valley Children''s Hospital', 1, NULL, NULL, N'053300', NULL, NULL, 0, 348, NULL, N'5593535116', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9300 Valley Childrens Place', N'Madera', N'CA', N'06019', N'93636', 36.941812, -120.171438, 600, 21, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (725, N'Children''s Hospital & Research Center Oakland', 1, NULL, NULL, N'053301', NULL, NULL, 0, 190, NULL, N'5104283000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'747 52Nd Street', N'Oakland', N'CA', N'06001', N'94609', 37.837244, -122.268071, 622, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (726, N'Children''s Hosp Of Los Angeles', 1, NULL, NULL, N'053302', NULL, NULL, 0, 568, NULL, N'3236692164', N'3233614002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4650 Sunset Blvd', N'Los Angeles', N'CA', N'06037', N'90027', 34.098145, -118.290754, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (727, N'Rady Children''s Hospital - San Die', 1, NULL, NULL, N'053303', NULL, NULL, 0, 518, NULL, N'8585761700', N'8589668590', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3020 Childrens Way', N'San Die', N'CA', N'06073', N'92123', 32.717421, -117.162771, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (728, N'Children''s Hospital Of Orange County', 1, NULL, NULL, N'053304', NULL, NULL, 0, 192, NULL, N'7149973000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 W La Veta Ave', N'Orange', N'CA', N'06059', N'92868', 33.780405, -117.865987, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (729, N'Lucile Salter Packard Children''s Hsp At Stanford', 1, NULL, NULL, N'053305', NULL, NULL, 0, 287, NULL, N'6504978000', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 Welch Road', N'Palo Alto', N'CA', N'06085', N'94304', 37.437193, -122.174248, 682, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (730, N'Children''s Hospital At Mission', 1, NULL, NULL, N'053306', NULL, NULL, 0, 48, NULL, N'9493652408', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27700 Medical Center Rd 5Th Floor', N'Mission Viejo', N'CA', N'06059', N'92691', 33.561279, -117.666946, 607, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (731, N'Healthbridge Children''s Hospital - Orange', 1, NULL, NULL, N'053308', NULL, NULL, 0, 6, NULL, N'7142892400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'393 S Tustin Street', N'Orange', N'CA', N'06059', N'92866', 33.783267, -117.835633, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (732, N'Miller Children''s Hospital', 1, NULL, NULL, N'053309', NULL, NULL, 0, 171, NULL, N'5629338001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Atlantic Avenue', N'Long Beach', N'CA', N'06037', N'90806', 33.80801, -118.185092, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (733, N'Shriners Hospitals For Children', 1, NULL, NULL, N'053310', NULL, NULL, 0, 60, NULL, N'2133883151', N'2133877528', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3160 Geneva Street', N'Los Angeles', N'CA', N'06037', N'90020', 34.067638, -118.286008, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (734, N'Shriners Hospitals For Children Northern Calif', 1, NULL, NULL, N'053311', NULL, NULL, 0, 80, NULL, N'9164532000', N'9164532388', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2425 Stockton Boulevard', N'Sacramento', N'CA', N'06067', N'95817', 38.552889, -121.456107, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (735, N'Resnick Neuropsychiatric Hospital At Ucla', 1, NULL, NULL, N'054009', NULL, NULL, 0, 209, NULL, N'3108256962', N'3102672021', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Medical Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.054394, -118.243941, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (736, N'Gateways Hosp  Mental Health Ctr', 1, NULL, NULL, N'054028', NULL, NULL, 0, 55, NULL, N'2136660171', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1891 Effie St', N'Los Angeles', N'CA', N'06037', N'90026', 34.084502, -118.256752, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (737, N'Bhc Alhambra Hosp', 1, NULL, NULL, N'054032', NULL, NULL, 0, 85, NULL, N'6262861191', N'6262862489', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4619 N Rosemead Blvd', N'Rosemead', N'CA', N'06037', N'91770', 34.067617, -118.087976, 658, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (738, N'Del Amo Hospital', 1, NULL, NULL, N'054053', NULL, NULL, 0, 166, NULL, N'3105301151', NULL, 1, 1, 0, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'23700 Camino Del Sol', N'Torrance', N'CA', N'06037', N'90505', 33.808846, -118.344031, 688, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (739, N'College Hospital', 1, NULL, NULL, N'054055', NULL, NULL, 0, 157, NULL, N'5625951911', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10802 College Pl', N'Cerritos', N'CA', N'06037', N'90703', 33.88517, -118.102252, 508, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (740, N'Aurora Charter Oak', 1, NULL, NULL, N'054069', NULL, NULL, 0, 95, NULL, N'6269661632', N'6268595292', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1161 E Covina Blvd', N'Covina', N'CA', N'06037', N'91724', 34.099345, -117.864511, 532, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (741, N'St. Helena Hospital Center For Behavioral Health', 1, NULL, NULL, N'054074', NULL, NULL, 0, 61, NULL, N'7076482200', N'7076494014', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Oren St', N'Vallejo', N'CA', N'06095', N'94590', 38.118363, -122.251037, 697, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (742, N'Alvarado Parkway Institute Behavioral Health Syste', 1, NULL, NULL, N'054075', NULL, NULL, 0, 66, NULL, N'6194654411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7050 Parkway Drive', N'La Mesa', N'CA', N'06073', N'91942', 32.774583, -117.044143, 583, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (743, N'Aurora Vista Del Mar Hospital', 1, NULL, NULL, N'054077', NULL, NULL, 0, 87, NULL, N'8056536434', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Seneca St', N'Ventura', N'CA', N'06111', N'93001', 34.305606, -119.283792, 699, 40, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (744, N'Aurora Las Encinas Hospital', 1, NULL, NULL, N'054078', NULL, NULL, 0, 118, NULL, N'8662793709', N'6263562503', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2900 E Del Mar Blvd', N'Pasadena', N'CA', N'06037', N'91107', 34.142098, -118.089193, 632, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (745, N'Kedren Community Mental Health Center', 1, NULL, NULL, N'054083', NULL, NULL, 0, 72, NULL, N'3232330425', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4211 South Avalon Blvd', N'Los Angeles', N'CA', N'06037', N'90011', 33.880552, -118.264818, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (746, N'Sierra Vista Hospital Inc', 1, NULL, NULL, N'054087', NULL, NULL, 0, 72, NULL, N'9164232000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8001 Bruceville Road', N'Sacramento', N'CA', N'06067', N'95823', 38.4669422, -121.4193157, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (747, N'Jewish Home', 1, NULL, NULL, N'054089', NULL, NULL, 0, 13, NULL, N'4153342500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302  Silver Ave', N'San Francisco', N'CA', N'06075', N'94112', 37.72861, -122.431122, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (748, N'Loma Linda Behavioral Med Ctr', 1, NULL, NULL, N'054093', NULL, NULL, 0, 89, NULL, N'9095589200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Barton Road', N'Redlands', N'CA', N'06071', N'92373', 34.04795, -117.21047, 645, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (749, N'Aurora San Die', 1, NULL, NULL, N'054095', NULL, NULL, 0, 80, NULL, N'8584873200', N'8584855418', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11878 Avenue Of Industry', N'San Die', N'CA', N'06073', N'92128', 33.8091, -117.140583, 640, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (750, N'Sutter Center For Psychiatry', 1, NULL, NULL, N'054096', NULL, NULL, 0, 69, NULL, N'9163863000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 Folsom Blvd', N'Sacramento', N'CA', N'06067', N'95826', 38.550749, -121.414928, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (751, N'Heritage Oaks Hospital', 1, NULL, NULL, N'054104', NULL, NULL, 0, 76, NULL, N'9164893336', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Auburn Blvd', N'Sacramento', N'CA', N'06067', N'95841', 38.643411, -121.365456, 518, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (752, N'Fremont Hospital', 1, NULL, NULL, N'054110', NULL, NULL, 0, 96, NULL, N'5107961100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39001 Sundale Drive', N'Fremont', N'CA', N'06001', N'94538', 37.546123, -121.979006, 555, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (753, N'Canyon Ridge Hospital', 1, NULL, NULL, N'054111', NULL, NULL, 0, 106, NULL, N'9095903700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 G Street', N'Chino', N'CA', N'06071', N'91710', 34.009856, -117.688262, 523, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (754, N'San Die County Psychiatric Hospital', 1, NULL, NULL, N'054114', NULL, NULL, 0, 109, NULL, N'6196928211', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3851 Rosecrans St', N'San Die', N'CA', N'06073', N'92110', 32.753627, -117.202586, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (755, N'Dept Of State Hospitals - Napa', 1, NULL, NULL, N'054122', NULL, NULL, 0, 1362, NULL, N'7072535000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Napa-Vallejo Highway', N'Napa', N'CA', N'06055', N'94558', 38.269988, -122.271634, 614, 24, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (756, N'St Joseph''s Behavioral Health Center', 1, NULL, NULL, N'054123', NULL, NULL, 0, 35, NULL, N'2094612000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2510 N  California St', N'Stockton', N'CA', N'06077', N'95204', 37.945655, -121.282419, 683, 39, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (757, N'Sempervirens', 1, NULL, NULL, N'054124', NULL, NULL, 0, 16, NULL, N'7072682990', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Wood St', N'Eureka', N'CA', N'06023', N'95501', 40.78111, -124.160953, 546, 27, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (758, N'Santa Barbara County Psychiatric Health Facility', 1, NULL, NULL, N'054125', NULL, NULL, 0, 16, NULL, N'8056815244', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Camino Del Remedio', N'Santa Barbara', N'CA', N'06083', N'93110', 34.445112, -119.779451, 666, 36, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (759, N'Pacific Grove Hospital', 1, NULL, NULL, N'054130', NULL, NULL, 0, 68, NULL, N'9512758400', N'9517884136', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Brockton Ave', N'Riverside', N'CA', N'06065', N'92506', 33.963008, -117.395259, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (760, N'John Muir Behavioral Health Center', 1, NULL, NULL, N'054131', NULL, NULL, 0, 73, NULL, N'9256744101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2740 Grant St', N'Concord', N'CA', N'06013', N'94524', 37.986674, -122.039066, 528, 20, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (761, N'Dept Of State Hospitals - Metropolitan - Psy', 1, NULL, NULL, N'054133', NULL, NULL, 0, 1254, NULL, N'5628637011', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11401 S Norwalk Blvd', N'Norwalk', N'CA', N'06037', N'90650', 33.90928, -118.084917, 619, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (762, N'Newport Bay Hospital', 1, NULL, NULL, N'054135', NULL, NULL, 0, 34, NULL, N'9496509750', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 E 16Th St', N'Newport Beach', N'CA', N'06059', N'92663', 33.623265, -117.908027, 617, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (763, N'Langley Porter Psychiatric Institute', 1, NULL, NULL, N'054144', NULL, NULL, 0, 67, NULL, N'4154767000', N'4154767404', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Parnassus Avenue', N'San Francisco', N'CA', N'06075', N'94143', 37.763413, -122.456797, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (764, N'Sharp Mesa Vista Hospital', 1, NULL, NULL, N'054145', NULL, NULL, 0, 149, NULL, N'8582784110', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7850 Vista Hill Avenue', N'San Die', N'CA', N'06073', N'92123', 32.795679, -117.155228, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (765, N'Telecare Heritage Psychiatric Health Facility', 1, NULL, NULL, N'054146', NULL, NULL, 0, 26, NULL, N'5105355115', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2633 E 27Th Street Building B', N'Oakland', N'CA', N'06001', N'94601', 37.791133, -122.222097, 622, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (766, N'Joyce Eisenberg Keefer Medical Center', 1, NULL, NULL, N'054147', NULL, NULL, 0, 10, NULL, N'8187743314', N'8187574408', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7150 Tampa Avenue', N'Reseda', N'CA', N'06037', N'91335', 34.200062, -118.553416, 618, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (767, N'Tarzana Treatment Center', 1, NULL, NULL, N'054148', NULL, NULL, 0, 60, NULL, N'8189961051', N'8189963051', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18646 Oxnard Street', N'Tarzana', N'CA', N'06037', N'91356', 34.180174, -118.547518, 685, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (768, N'Willow Rock Center', 1, NULL, NULL, N'054149', NULL, NULL, 0, 16, NULL, N'5108955502', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2050 Fairmont Drive', N'San Leandro', N'CA', N'06001', N'94578', 37.703373, -122.125889, 660, 25, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (769, N'Kaiser Permanente Psychiatric Health Facility-Sant', 1, NULL, NULL, N'054150', NULL, NULL, 0, 24, NULL, N'4088514850', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3840 Homestead Road', N'Santa Clara', N'CA', N'06085', N'95051', 37.337835, -121.988497, 659, 33, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (770, N'Aurora Behavioral Healthcare-Santa Rosa Llc', 1, NULL, NULL, N'054151', NULL, NULL, 0, 95, NULL, N'7078007700', N'7078007797', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1287 Fulton Road', N'Santa Rosa', N'CA', N'06097', N'95401', 38.4504664, -122.7737874, 671, 38, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (771, N'Santa Cruz County Psychiatric Health Facility', 1, NULL, NULL, N'054152', NULL, NULL, 0, 16, NULL, N'8316002801', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2250 Soquel Avenue Suite 150', N'Santa Cruz', N'CA', N'06087', N'95062', 36.978333, -122.013394, 667, 37, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (772, N'Ocean View Psychiatric Health Facility', 1, NULL, NULL, N'054153', NULL, NULL, 0, 20, NULL, N'7146140474', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Redondo Avenue Suite 500', N'Long Beach', N'CA', N'06037', N'90806', 33.804898, -118.15077, 595, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (773, N'Sharp Memorial Hospital-Transplant', 1, NULL, NULL, N'059800', NULL, NULL, 0, 521, NULL, N'8589393400', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7901 Frost Street', N'San Die', N'CA', N'06073', N'92123', 32.80017, -117.154197, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (774, N'Cedars-Sinai Medical Center - Transplant Services', 1, NULL, NULL, N'059801', NULL, NULL, 0, 0, NULL, N'3104233277', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8700 Beverly Boulevard', N'Los Angeles', N'CA', N'06037', N'90048', 34.076095, -118.362641, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (775, N'Western Medical Transplant Center', 1, NULL, NULL, N'059802', NULL, NULL, 0, 0, NULL, N'7148353555', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1001 North Tustin Avenue', N'Santa Ana', N'CA', N'06059', N'92705', 33.768084, -117.835764, 665, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (776, N'Stanford Hospital Transplant', 1, NULL, NULL, N'059803', NULL, NULL, 0, 0, NULL, N'6507235708', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Pasteur Drive', N'Stanford', N'CA', N'06085', N'94305', 37.433094, -122.174472, 682, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (777, N'Lucile Salter Packard Children''s Hospital At Stanf', 1, NULL, NULL, N'059804', NULL, NULL, 0, 0, NULL, N'6504978705', N'6504978612', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'725 Welch Road', N'Palo Alto', N'CA', N'06085', N'94304', 37.435679, -122.175119, 682, 35, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (778, N'Rady Children''s Hospital San Die', 1, NULL, NULL, N'059805', NULL, NULL, 0, 0, NULL, N'8585761700', N'8589665815', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3020 Children''s Way Mail Code 5115', N'San Die', N'CA', N'06073', N'92123', 32.798648, -117.150897, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (779, N'California Pacific Medical Center', 1, NULL, NULL, N'059806', NULL, NULL, 0, 0, NULL, N'4156001522', N'4156006575', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2333 Buchanan Street', N'San Francisco', N'CA', N'06075', N'94115', 37.7905, -122.432309, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (780, N'University Of California San Francisco', 1, NULL, NULL, N'059807', NULL, NULL, 0, 0, NULL, N'4153539162', N'4153538645', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'505 Parnassus Avenue', N'San Francisco', N'CA', N'06075', N'94143', 37.830289, -122.47974, 657, 32, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (781, N'University Of California Davis Medical Center', 1, NULL, NULL, N'059808', NULL, NULL, 0, 0, NULL, N'9167345693', N'9167347945', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2315 Stockton Blvd Rm 1018', N'Sacramento', N'CA', N'06067', N'95817', 38.581572, -121.4944, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (782, N'Sutter Medical Center Sacramento', 1, NULL, NULL, N'059809', NULL, NULL, 0, 0, NULL, N'9167338133', N'9167331967', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2825 Capitol Avenue', N'Sacramento', N'CA', N'06067', N'95816', 38.044827, -121.751459, 650, 28, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (783, N'University Of California San Die Medical Center', 1, NULL, NULL, N'059810', NULL, NULL, 0, 0, NULL, N'6195748612', N'6192987985', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 West Arbor Drive #8745', N'San Die', N'CA', N'06073', N'92103', 32.7548266, -117.1680204, 655, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (784, N'University Of California Irvine Medical Center', 1, NULL, NULL, N'059811', NULL, NULL, 0, 0, NULL, N'7144565841', N'7144568441', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 The City Drive', N'Orange', N'CA', N'06059', N'92868', 33.7879929, -117.8923226, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (785, N'Ronald Reagan Ucla Medical Center - Transplant Svs', 1, NULL, NULL, N'059812', NULL, NULL, 0, 0, NULL, N'3108255041', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'757 Westwood Plaza', N'Los Angeles', N'CA', N'06037', N'90095', 34.066465, -118.446507, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (786, N'Children''s Hospital Of Los Angeles', 1, NULL, NULL, N'059813', NULL, NULL, 0, 0, NULL, N'3233615954', N'3233713612', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4650 Sunset Blvd Ms#72', N'Los Angeles', N'CA', N'06037', N'90027', 34.054394, -118.243941, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (787, N'Loma Linda University Medical Center Transplant I', 1, NULL, NULL, N'059814', NULL, NULL, 0, 0, NULL, N'9095588068', N'9095580702', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11234 Anderson Street', N'Loma Linda', N'CA', N'06071', N'92354', 34.0494563, -117.2663661, 592, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (788, N'Green Hospital Of Scripps Clinic', 1, NULL, NULL, N'059815', NULL, NULL, 0, 0, NULL, N'8585544310', N'8585544311', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'10666 North Torrey Pines Road', N'La Jolla', N'CA', N'06073', N'92037', 32.870564, -117.242784, 582, 31, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (789, N'St Joseph Hospital', 1, NULL, NULL, N'059816', NULL, NULL, 0, 0, NULL, N'7147718087', N'7147448636', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 Stewart Drive', N'Orange', N'CA', N'06059', N'92868', 33.787257, -117.850309, 625, 17, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (790, N'Riverside Community Hospital', 1, NULL, NULL, N'059817', NULL, NULL, 0, 0, NULL, N'9516841415', N'9517886107', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4445 Magnolia Avenue', N'Riverside', N'CA', N'06065', N'92501', 33.976257, -117.378381, 648, 30, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (791, N'Lac Harbor-Ucla Medical Center', 1, NULL, NULL, N'059818', NULL, NULL, 0, 0, NULL, N'3102222155', N'3103289624', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 W Carson Street', N'Torrance', N'CA', N'06037', N'90509', 33.831318, -118.324596, 688, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (792, N'Keck Hospital Of Usc', 1, NULL, NULL, N'059819', NULL, NULL, 0, 0, NULL, N'3234425901', N'3234427515', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1500 San Pablo Street', N'Los Angeles', N'CA', N'06037', N'90033', 34.062618, -118.202928, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (793, N'Saint Vincent Medical Center - Transplant Center', 1, NULL, NULL, N'059820', NULL, NULL, 0, 0, NULL, N'2132075681', N'2134845588', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2131 W Third Street', N'Los Angeles', N'CA', N'06037', N'90057', 34.054394, -118.243941, 597, 22, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (794, N'North Colorado Medical Center', 1, NULL, NULL, N'060001', NULL, NULL, 0, 378, NULL, N'9703524121', N'9703506644', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 16Th Street', N'Greeley', N'CO', N'08123', N'80631', 40.413831, -104.708507, 738, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (795, N'Longmont United Hospital', 1, NULL, NULL, N'060003', NULL, NULL, 0, 186, NULL, N'3036515111', N'3036784050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Mountain View Avenue', N'Longmont', N'CO', N'08013', N'80501', 40.181324, -105.126335, 749, 41, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (796, N'Platte Valley Medical Center', 1, NULL, NULL, N'060004', NULL, NULL, 0, 98, NULL, N'3034981601', N'3034981608', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Prairie Center Parkway', N'Brighton', N'CO', N'08001', N'80601', 39.965474, -104.770928, 721, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (797, N'Montrose Memorial Hospital', 1, NULL, NULL, N'060006', NULL, NULL, 0, 75, NULL, N'9702492211', N'9702522525', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S 3Rd St', N'Montrose', N'CO', N'08085', N'81401', 38.480091, -107.869926, 752, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (798, N'San Luis Valley Health', 1, NULL, NULL, N'060008', NULL, NULL, 0, 59, NULL, N'7195892511', N'7195871372', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Blanca Ave', N'Alamosa', N'CO', N'08003', N'81101', 37.471731, -105.883516, 717, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (799, N'Lutheran Medical Center', 1, NULL, NULL, N'060009', NULL, NULL, 0, 364, NULL, N'3034254500', N'3034258198', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8300 W 38Th Ave', N'Wheat Ridge', N'CO', N'08059', N'80033', 39.769334, -105.087949, 763, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (800, N'Poudre Valley Hospital', 1, NULL, NULL, N'060010', NULL, NULL, 0, 281, NULL, N'9704957000', N'9704957663', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024 S Lemay Ave', N'Fort Collins', N'CO', N'08069', N'80524', 40.571241, -105.057875, 734, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (801, N'Denver Health Medical Center', 1, NULL, NULL, N'060011', NULL, NULL, 0, 398, NULL, N'3034366000', N'3034365131', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Bannock St', N'Denver', N'CO', N'08031', N'80204', 39.72823, -104.990066, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (802, N'Centura Health-St Mary Corwin Medical Center', 1, NULL, NULL, N'060012', NULL, NULL, 0, 408, NULL, N'7195574000', N'7195575823', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 Minnequa Ave', N'Pueblo', N'CO', N'08101', N'81004', 38.233217, -104.622203, 753, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (803, N'Mercy Regional Medical Center', 1, NULL, NULL, N'060013', NULL, NULL, 0, 82, NULL, N'9702474311', N'9707643919', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Three Springs Blvd', N'Duran', N'CO', N'08067', N'81301', 37.235093, -107.824771, 731, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (804, N'Presbyterian St Lukes Medical Center', 1, NULL, NULL, N'060014', NULL, NULL, 0, 680, NULL, N'3038396000', N'3038692428', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1719 E 19Th Ave', N'Denver', N'CO', N'08031', N'80218', 39.746083, -104.966482, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (805, N'Centura Health-St Anthony Hospital', 1, NULL, NULL, N'060015', NULL, NULL, 0, 593, NULL, N'7203210000', N'7203211621', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11600 West 2Nd Place', N'Lakewood', N'CO', N'08059', N'80228', 39.717956, -105.127494, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (806, N'Centura Health-St Thomas More Hospital', 1, NULL, NULL, N'060016', NULL, NULL, 0, 55, NULL, N'7192852000', N'7192852370', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1338 Phay Ave', N'Canon City', N'CO', N'08043', N'81212', 38.455748, -105.230064, 724, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (807, N'Parkview Medical Center Inc', 1, NULL, NULL, N'060020', NULL, NULL, 0, 350, NULL, N'7195844000', N'7195449799', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W 16Th Street', N'Pueblo', N'CO', N'08101', N'81003', 38.281678, -104.612123, 753, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (808, N'University Colo Health Memorial Hospital Central', 1, NULL, NULL, N'060022', NULL, NULL, 0, 583, NULL, N'7193655000', N'7193656870', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Boulder St', N'Colorado Springs', N'CO', N'08041', N'80909', 38.838828, -104.800454, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (809, N'St Marys  Medical Center', 1, NULL, NULL, N'060023', NULL, NULL, 0, 346, NULL, N'9702981950', N'9702987510', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2635 N 7Th Street', N'Grand Junction', N'CO', N'08077', N'81502', 39.091217, -108.561604, 737, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (810, N'University Of Colorado Hospital Anschutz Inpatient', 1, NULL, NULL, N'060024', NULL, NULL, 0, 568, NULL, N'7208480000', N'7208485540', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12605 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.741365, -104.841553, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (811, N'Foothills Hospital', 1, NULL, NULL, N'060027', NULL, NULL, 0, 211, NULL, N'3034402273', N'3034402435', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4747 Arapahoe Avenue', N'Boulder', N'CO', N'08013', N'80304', 40.014807, -105.236573, 720, 41, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (812, N'Saint Joseph Hospital', 1, NULL, NULL, N'060028', NULL, NULL, 0, 565, NULL, N'3038122000', N'3038124934', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 East 19Th Ave', N'Denver', N'CO', N'08031', N'80218', 39.745722, -104.972135, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (813, N'Mckee Medical Center', 1, NULL, NULL, N'060030', NULL, NULL, 0, 115, NULL, N'9706694640', N'9706354137', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Boise Ave', N'Loveland', N'CO', N'08069', N'80538', 40.413212, -105.053604, 750, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (814, N'Centura Health-Penrose St Francis Health Services', 1, NULL, NULL, N'060031', NULL, NULL, 0, 522, NULL, N'7197765000', N'7197765914', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 N Nevada Ave', N'Colorado Springs', N'CO', N'08041', N'80907', 38.865568, -104.820123, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (815, N'Rose Medical Center', 1, NULL, NULL, N'060032', NULL, NULL, 0, 422, NULL, N'3033202121', N'3033202200', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4567 E 9Th Avenue', N'Denver', N'CO', N'08031', N'80220', 39.731071, -104.934324, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (816, N'Swedish Medical Center', 1, NULL, NULL, N'060034', NULL, NULL, 0, 368, NULL, N'3037885000', N'3037886269', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 E Hampden Avenue', N'Englewood', N'CO', N'08005', N'80113', 39.653139, -104.980568, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (817, N'Arkansas Valley Regional Medical Center', 1, NULL, NULL, N'060036', NULL, NULL, 0, 78, NULL, N'7193836000', N'7193836005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Carson Avenue', N'La Junta', N'CO', N'08089', N'81050', 37.976639, -103.548741, 746, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (818, N'Keefe Memorial Hospital', 1, NULL, NULL, N'060043', NULL, NULL, 0, 32, NULL, N'7197675661', N'7197678042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 N 6Th W St', N'Cheyenne Wells', N'CO', N'08017', N'80810', 38.821395, -102.353243, 725, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (819, N'Colorado Plains Medical Center', 1, NULL, NULL, N'060044', NULL, NULL, 0, 50, NULL, N'9708673391', N'9705423306', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Lincoln St', N'Fort Morgan', N'CO', N'08087', N'80701', 40.260397, -103.796215, 735, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (820, N'Yampa Valley Medical Center', 1, NULL, NULL, N'060049', NULL, NULL, 0, 39, NULL, N'9708791322', N'9708701223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024 Central Park Dr', N'Steamboat Springs', N'CO', N'08107', N'80487', 40.462457, -106.814347, 757, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (821, N'Community Hospital', 1, NULL, NULL, N'060054', NULL, NULL, 0, 78, NULL, N'9702566201', N'9702566501', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2021 N 12Th St', N'Grand Junction', N'CO', N'08077', N'81501', 39.085895, -108.552345, 737, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (822, N'Centura Health-Porter Adventist Hospital', 1, NULL, NULL, N'060064', NULL, NULL, 0, 368, NULL, N'3037781955', N'3037785252', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 S Downing St', N'Denver', N'CO', N'08031', N'80210', 39.669574, -104.973493, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (823, N'North Suburban Medical Center', 1, NULL, NULL, N'060065', NULL, NULL, 0, 157, NULL, N'3034517800', N'3034504458', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9191 Grant St', N'Thornton', N'CO', N'08001', N'80229', 39.86438, -104.984783, 759, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (824, N'Delta County Memorial Hospital', 1, NULL, NULL, N'060071', NULL, NULL, 0, 49, NULL, N'9708747681', N'9708742227', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 E 3Rd Street', N'Delta', N'CO', N'08029', N'81416', 38.743165, -108.047341, 729, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (825, N'Valley View Hospital Association', 1, NULL, NULL, N'060075', NULL, NULL, 0, 78, NULL, N'9709456535', N'9703844235', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1906 Blake Ave', N'Glenwood Springs', N'CO', N'08045', N'81601', 39.532226, -107.322901, 736, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (826, N'Sterling Regional Medcenter', 1, NULL, NULL, N'060076', NULL, NULL, 0, 36, NULL, N'9705220122', N'9705228532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Fairhurst St', N'Sterling', N'CO', N'08075', N'80751', 40.613681, -103.220685, 758, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (827, N'Vail Valley Medical Center', 1, NULL, NULL, N'060096', NULL, NULL, 0, 58, NULL, N'9704762451', N'9704797192', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 W Meadow Drive', N'Vail', N'CO', N'08037', N'81657', 39.642818, -106.381675, 761, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (828, N'Medical Center Of Aurora The', 1, NULL, NULL, N'060100', NULL, NULL, 0, 346, NULL, N'3036952600', N'3033682500', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 S Potomac St', N'Aurora', N'CO', N'08005', N'80012', 39.69025, -104.831154, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (829, N'Centura Health-Avista Adventist Hospital', 1, NULL, NULL, N'060103', NULL, NULL, 0, 66, NULL, N'3036731000', N'3036731048', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Health Park Drive', N'Louisville', N'CO', N'08013', N'80027', 39.952044, -105.150831, 720, 41, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (830, N'St Anthony North Health Campus', 1, NULL, NULL, N'060104', NULL, NULL, 0, 196, NULL, N'3034303201', N'3034262155', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14300 Orchard Parkway', N'Westminster', N'CO', N'08014', N'80023', 39.829096, -105.038202, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (831, N'National Jewish Health', 1, NULL, NULL, N'060107', NULL, NULL, 0, 46, NULL, N'3033884461', N'3032702165', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Jackson St', N'Denver', N'CO', N'08031', N'80206', 39.739169, -104.942466, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (832, N'Sky Ridge Medical Center', 1, NULL, NULL, N'060112', NULL, NULL, 0, 186, NULL, N'7202251000', N'7202251009', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Ridge Gate Parkway', N'Lone Tree', N'CO', N'08035', N'80124', 39.527938, -104.872872, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (833, N'Centura Health-Littleton Adventist Hospital', 1, NULL, NULL, N'060113', NULL, NULL, 0, 231, NULL, N'3037305888', N'3037305858', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 S Broadway', N'Littleton', N'CO', N'08005', N'80122', 39.576136, -104.988494, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (834, N'Parker Adventist Hospital', 1, NULL, NULL, N'060114', NULL, NULL, 0, 104, NULL, N'3032694000', N'3032694019', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9395 Crown Crest Blvd', N'Parker', N'CO', N'08035', N'80138', 39.549745, -104.769813, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (835, N'Colorado Mental Health Institute At Pueblo', 1, NULL, NULL, N'060115', NULL, NULL, 0, 35, NULL, N'7195464147', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W 24Th St', N'Pueblo', N'CO', N'08101', N'81003', 38.290955, -104.627732, 753, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (836, N'od Samaritan Medical Center', 1, NULL, NULL, N'060116', NULL, NULL, 0, 234, NULL, N'3036894000', N'3036895241', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Exempla Circle', N'Lafayette', N'CO', N'08013', N'80026', 39.970618, -105.082978, 720, 41, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (837, N'Animas Surgical Hospital Llc', 1, NULL, NULL, N'060117', NULL, NULL, 0, 12, NULL, N'9702473537', N'9703852355', 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'575 Rivergate Lane', N'Duran', N'CO', N'08067', N'81301', 37.248889, -107.870774, 731, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (838, N'St Anthony Summit Medical Center', 1, NULL, NULL, N'060118', NULL, NULL, 0, 35, NULL, N'9706683300', N'9706681517', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Peak One Drive', N'Frisco', N'CO', N'08117', N'80443', 39.569226, -106.079829, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (839, N'Medical Center Of The Rockies', 1, NULL, NULL, N'060119', NULL, NULL, 0, 136, NULL, N'9706242500', N'9706241290', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Rocky Mountain Avenue', N'Loveland', N'CO', N'08069', N'80538', 40.414889, -105.001661, 750, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (840, N'Orthocolorado Hospital At St Anthony Med Campus', 1, NULL, NULL, N'060124', NULL, NULL, 0, 48, NULL, N'7203215000', N'7203215011', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11650 W 2Nd Place', N'Lakewood', N'CO', N'08059', N'80228', 39.717953, -105.12813, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (841, N'Castle Rock Adventist Hospital', 1, NULL, NULL, N'060125', NULL, NULL, 0, 50, NULL, N'7204552500', N'7204552555', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2350 Meadows Blvd', N'Castle Rock', N'CO', N'08035', N'80109', 39.404113, -104.886146, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (842, N'Banner Fort Collins Medical Center', 1, NULL, NULL, N'060126', NULL, NULL, 0, 22, NULL, N'9702294000', N'9702294501', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Lady Moon Dr', N'Fort Collins', N'CO', N'08069', N'80528', 40.523467, -105.010834, 734, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (843, N'Weisbrod Memorial County Hospital', 1, NULL, NULL, N'061300', NULL, NULL, 0, 25, NULL, N'7194385401', N'7194385697', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1208 Luther Street', N'Eads', N'CO', N'08061', N'81036', 38.480912, -102.784463, 732, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (844, N'Rio Grande Hospital', 1, NULL, NULL, N'061301', NULL, NULL, 0, 17, NULL, N'7196572510', N'7196572511', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 County Rd 14', N'Del Norte', N'CO', N'08105', N'81132', 37.673153, -106.366525, 717, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (845, N'Colorado Canyons Hospital And Medical Center', 1, NULL, NULL, N'061302', NULL, NULL, 0, 10, NULL, N'9708589871', N'9708582224', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Ottley Avenue', N'Fruita', N'CO', N'08077', N'81521', 39.164335, -108.736862, 737, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (846, N'East Morgan County Hospital', 1, NULL, NULL, N'061303', NULL, NULL, 0, 25, NULL, N'9708426200', N'9708423572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 W Edison St', N'Brush', N'CO', N'08087', N'80723', 40.254674, -103.649186, 722, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (847, N'Haxtun Hospital District', 1, NULL, NULL, N'061304', NULL, NULL, 0, 25, NULL, N'9707746123', N'9707746158', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 W Fletcher Street', N'Haxtun', N'CO', N'08095', N'80731', 40.641389, -102.631573, 740, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (848, N'Melissa Memorial Hospital', 1, NULL, NULL, N'061305', NULL, NULL, 0, 16, NULL, N'9708542241', N'9708543821', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 E Johnson Street', N'Holyoke', N'CO', N'08095', N'80734', 40.578418, -102.290625, 741, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (849, N'Lincoln Community Hospital', 1, NULL, NULL, N'061306', NULL, NULL, 0, 15, NULL, N'7197432421', N'7197432880', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 6Th St', N'Hu', N'CO', N'08073', N'80821', 39.137951, -103.474048, 742, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (850, N'Rangely District Hospital', 1, NULL, NULL, N'061307', NULL, NULL, 0, 25, NULL, N'9706755011', N'9706755224', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Eaglecrest', N'Rangely', N'CO', N'08103', N'81648', 39.619309, -106.618233, 754, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (851, N'San Luis Valley Health Conejos County Hospital', 1, NULL, NULL, N'061308', NULL, NULL, 0, 17, NULL, N'7192745121', N'7192746003', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19021 Us Hwy 285', N'La Jara', N'CO', N'08021', N'81140', 37.278333, -105.960947, 745, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (852, N'Wray Community District Hospital', 1, NULL, NULL, N'061309', NULL, NULL, 0, 15, NULL, N'9703324811', N'9703324800', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1017 W 7Th St', N'Wray', N'CO', N'08125', N'80758', 40.075336, -102.234859, 764, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (853, N'Sedgwick County Memorial Hospital', 1, NULL, NULL, N'061310', NULL, NULL, 0, 25, NULL, N'9704743323', N'9704742758', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Cedar Street', N'Julesburg', N'CO', N'08115', N'80737', 40.993249, -102.268793, 743, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (854, N'Southeast Colorado Hospital', 1, NULL, NULL, N'061311', NULL, NULL, 0, 23, NULL, N'7195234501', N'7195239972', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'373 E Tenth Ave', N'Springfield', N'CO', N'08009', N'81073', 37.404163, -102.612516, 756, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (855, N'Estes Park Medical Center', 1, NULL, NULL, N'061312', NULL, NULL, 0, 23, NULL, N'9705864439', N'9705869514', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Prospect Avenue', N'Estes Park', N'CO', N'08069', N'80517', 40.37231, -105.513926, 733, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (856, N'Kit Carson County Memorial Hospital', 1, NULL, NULL, N'061313', NULL, NULL, 0, 19, NULL, N'7193465311', N'7193464880', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'286 16Th Street', N'Burlington', N'CO', N'08063', N'80807', 39.303421, -102.270668, 723, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (857, N'Memorial Hospital The', 1, NULL, NULL, N'061314', NULL, NULL, 0, 25, NULL, N'9708249411', N'9708263119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Hospital Loop', N'Craig', N'CO', N'08081', N'81625', 40.518508, -107.578654, 728, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (858, N'Yuma District Hospital', 1, NULL, NULL, N'061315', NULL, NULL, 0, 22, NULL, N'9708485405', N'9708484952', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West 8Th Avenue', N'Yuma', N'CO', N'08125', N'80759', 40.118445, -102.736641, 765, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (859, N'Spanish Peaks Regional Health Center', 1, NULL, NULL, N'061316', NULL, NULL, 0, 25, NULL, N'7197385100', N'7197385138', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23500 Us Hwy 160', N'Walsenburg', N'CO', N'08055', N'81089', 37.607688, -104.819786, 762, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (860, N'Grand River Medical Center', 1, NULL, NULL, N'061317', NULL, NULL, 0, 25, NULL, N'9706251510', N'9706256486', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Airport Road', N'Rifle', N'CO', N'08045', N'81650', 39.522626, -107.769906, 736, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (861, N'Middle Park Medical Center', 1, NULL, NULL, N'061318', NULL, NULL, 0, 25, NULL, N'9707243442', N'9707249606', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 S 4Th Street', N'Kremmling', N'CO', N'08049', N'80459', 40.057492, -106.391183, 744, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (862, N'St Vincent Hospital General District', 1, NULL, NULL, N'061319', NULL, NULL, 0, 25, NULL, N'7194860230', N'7194861077', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'822 W 4Th Street', N'Leadville', N'CO', N'08065', N'80461', 39.244777, -106.301567, 748, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (863, N'Gunnison Valley Hospital', 1, NULL, NULL, N'061320', NULL, NULL, 0, 24, NULL, N'9706411456', N'9706417233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 N Taylor Street', N'Gunnison', N'CO', N'08051', N'81230', 38.551423, -106.924322, 739, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (864, N'Mt San Rafael Hospital', 1, NULL, NULL, N'061321', NULL, NULL, 0, 25, NULL, N'7198469213', N'7198462752', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Benedicta Avenue', N'Trinidad', N'CO', N'08071', N'81082', 37.17338, -104.488796, 760, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (865, N'Heart Of The Rockies Regional Medical Center', 1, NULL, NULL, N'061322', NULL, NULL, 0, 25, NULL, N'7195302200', N'7195302232', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Rush Drive', N'Salida', N'CO', N'08015', N'81201', 38.534719, -105.998902, 755, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (866, N'Prowers Medical Center', 1, NULL, NULL, N'061323', NULL, NULL, 0, 25, NULL, N'7193364343', N'7193367207', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Kendall Drive', N'Lamar', N'CO', N'08099', N'81052', 38.070781, -102.611653, 747, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (867, N'Aspen Valley Hospital', 1, NULL, NULL, N'061324', NULL, NULL, 0, 25, NULL, N'9705441261', N'9705441585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'0401 Castle Creek Road', N'Aspen', N'CO', N'08097', N'81611', 39.191022, -106.838256, 718, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (868, N'Pioneers Medical Center', 1, NULL, NULL, N'061325', NULL, NULL, 0, 15, NULL, N'9708785047', N'9708783285', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Pioneers Medical Center Drive', N'Meeker', N'CO', N'08103', N'81641', 40.037473, -107.91313, 751, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (869, N'Pikes Peak Regional Hospital', 1, NULL, NULL, N'061326', NULL, NULL, 0, 15, NULL, N'7196879999', N'7196865725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16420 Highway 24', N'Woodland Park', N'CO', N'08119', N'80863', 39.009936, -105.045003, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (870, N'Southwest Memorial Hospital', 1, NULL, NULL, N'061327', NULL, NULL, 0, 25, NULL, N'9705656666', N'9705642149', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1311 N Mildred Rd', N'Cortez', N'CO', N'08083', N'81321', 37.363313, -108.572725, 727, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (871, N'Pasa Springs Medical Center', 1, NULL, NULL, N'061328', NULL, NULL, 0, 11, NULL, N'9707313700', N'9707313707', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 South Pasa Boulevard', N'Pasa Springs', N'CO', N'08007', N'81147', 37.25235, -107.077148, 731, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (872, N'Wide Horizon', 1, NULL, NULL, N'061990', NULL, NULL, 0, 24, NULL, N'3034244445', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8900 West 38Th Avenue', N'Wheat Ridge', N'CO', N'08059', N'80033', 39.769369, -105.062673, 763, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (873, N'Kindred Hospital-Denver', 1, NULL, NULL, N'062009', NULL, NULL, 0, 68, NULL, N'3033315219', N'3033315220', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1920 High St', N'Denver', N'CO', N'08031', N'80218', 39.74628, -104.964447, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (874, N'Craig Hospital', 1, NULL, NULL, N'062011', NULL, NULL, 0, 93, NULL, N'3037898000', N'3037898219', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3425 S Clarkson St', N'Englewood', N'CO', N'08005', N'80113', 39.654221, -104.978454, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (875, N'Colorado Acute Long Term Hospital', 1, NULL, NULL, N'062012', NULL, NULL, 0, 63, NULL, N'3032646865', N'3032646853', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1690 N Meade St', N'Denver', N'CO', N'08031', N'80204', 39.739154, -104.984703, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (876, N'Kindred Hospital Aurora', 1, NULL, NULL, N'062013', NULL, NULL, 0, 37, NULL, N'7208578333', N'7208580366', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Potomac St 2Nd Floor', N'Aurora', N'CO', N'08001', N'80011', 39.729432, -104.83192, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (877, N'Vibra Hospital Of Denver', 1, NULL, NULL, N'062014', NULL, NULL, 0, 54, NULL, N'3032883000', N'3032865029', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8451 Pearl St', N'Thornton', N'CO', N'08001', N'80229', 39.850403, -104.979412, 759, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (878, N'Select Specialty Hospital-Denver', 1, NULL, NULL, N'062015', NULL, NULL, 0, 65, NULL, N'3038980369', N'3037157398', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 S Downing St 3Rd Floor', N'Denver', N'CO', N'08031', N'80218', 39.739154, -104.984703, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (879, N'Select Long Term Care Hospital-Colorado Springs', 1, NULL, NULL, N'062016', NULL, NULL, 0, 30, NULL, N'7195716000', N'7195716182', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 East Woodmen Road', N'Colorado Springs', N'CO', N'08041', N'80923', 38.938559, -104.716966, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (880, N'Northern Colorado Long Term Acute Hosp - Long Term', 1, NULL, NULL, N'062017', NULL, NULL, 0, 20, NULL, N'9706193400', N'9702789340', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Union Street', N'Johnstown', N'CO', N'08069', N'80534', 40.33503, -104.909284, 738, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (881, N'Spalding Rehabilitation Hospital', 1, NULL, NULL, N'063027', NULL, NULL, 0, 122, NULL, N'3033671166', N'3033608208', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Potomac Street', N'Aurora', N'CO', N'08001', N'80011', 39.731093, -104.8274, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (882, N'Healthsouth Rehabilitation Hospital Of Co Spgs', 1, NULL, NULL, N'063030', NULL, NULL, 0, 64, NULL, N'7196308000', N'7195200387', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Parkside Drive', N'Colorado Springs', N'CO', N'08041', N'80910', 40.799638, -106.938986, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (883, N'Northern Colorado Rehabilitation Hospital', 1, NULL, NULL, N'063033', NULL, NULL, 0, 40, NULL, N'9706193400', N'9702789340', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Union Street', N'Johnstown', N'CO', N'08123', N'80534', 40.33503, -104.909284, 738, 46, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (884, N'Healthsouth Rehabilitation Hospital Of Littleton', 1, NULL, NULL, N'063034', NULL, NULL, 0, 40, NULL, N'3033341100', N'2052628547', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 West Mineral Avenue', N'Littleton', N'CO', N'08005', N'80120', 39.573619, -105.00026, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (885, N'Childrens Hospital Colorado', 1, NULL, NULL, N'063301', NULL, NULL, 0, 414, NULL, N'7207771234', N'7207777267', 1, 0, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13123 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.741635, -104.835018, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (886, N'Colorado Mental Health Institute At Pueblo-Psych', 1, NULL, NULL, N'064001', NULL, NULL, 0, 438, NULL, N'7195464443', N'7195464770', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West 24Th St', N'Pueblo', N'CO', N'08101', N'81003', 38.290955, -104.627732, 753, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (887, N'Colorado Mental Health Institute At Ft Logan', 1, NULL, NULL, N'064003', NULL, NULL, 0, 173, NULL, N'3038667066', N'3038667088', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3520 W Oxford Ave', N'Denver', N'CO', N'08031', N'80236', 39.739154, -104.984703, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (888, N'Centennial Peaks Hospital', 1, NULL, NULL, N'064007', NULL, NULL, 0, 72, NULL, N'3036739990', N'3036739703', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2255 S 88Th St', N'Louisville', N'CO', N'08013', N'80027', 39.952058, -105.148206, 720, 41, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (889, N'Cedar Springs Behavioral Health System', 1, NULL, NULL, N'064009', NULL, NULL, 0, 52, NULL, N'7196334114', N'7193295315', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2135 Southgate Rd', N'Colorado Springs', N'CO', N'08041', N'80906', 38.806366, -104.821689, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (890, N'West Springs Hospital', 1, NULL, NULL, N'064023', NULL, NULL, 0, 46, NULL, N'9702634918', N'9706837280', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 28 3/4 Road', N'Grand Junction', N'CO', N'08077', N'81501', 39.079624, -108.519932, 737, 45, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (891, N'Highlands Behavioral Health System', 1, NULL, NULL, N'064024', NULL, NULL, 0, 86, NULL, N'7203482800', N'7203482803', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8565 S Poplar Way', N'Littleton', N'CO', N'08035', N'80130', 39.613321, -105.01665, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (892, N'Haven Behavioral Hospital Of Southern Colo', 1, NULL, NULL, N'064025', NULL, NULL, 0, 30, NULL, N'7195466000', N'7195654021', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 Minnequa Avenue Suite 6100', N'Pueblo', N'CO', N'08101', N'81004', 38.233235, -104.619462, 753, 47, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (893, N'Peak View Behavioral Health', 1, NULL, NULL, N'064026', NULL, NULL, 0, 24, NULL, N'7194448484', N'7195444842', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7353 Sisters Grove', N'Colorado Springs', N'CO', N'08041', N'80918', 38.833958, -104.825348, 726, 42, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (894, N'Centura Health-Porter Adventist Hospital', 1, NULL, NULL, N'069864', NULL, NULL, 0, 0, NULL, N'3037785671', N'3037785205', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2535 South Downing Street #380', N'Denver', N'CO', N'08031', N'80210', 39.670426, -104.97394, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (895, N'Presbyterian St Luke''s Medical Center', 1, NULL, NULL, N'069865', NULL, NULL, 0, 0, NULL, N'3038396100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1719 East 19Th Avenue', N'Denver', N'CO', N'08031', N'80218', 39.7472, -104.966532, 730, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (896, N'University Of Colorado Hospital Anschutz Inpatient', 1, NULL, NULL, N'069866', NULL, NULL, 0, 0, NULL, N'7208487800', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12605 East 16Th Avenue', N'Aurora', N'CO', N'08001', N'80045', 39.742544, -104.841661, 719, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (897, N'St Francis Hospital & Medical Center', 1, NULL, NULL, N'070002', NULL, NULL, 0, 617, NULL, N'8607144000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'114 Woodland Street', N'Hartford', N'CT', N'09003', N'06105', 41.774847, -72.699481, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (898, N'Day Kimball Hospital', 1, NULL, NULL, N'070003', NULL, NULL, 0, 104, NULL, N'8609286541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Pomfret Street', N'Putnam', N'CT', N'09015', N'06260', 41.907274, -71.915585, 782, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (899, N'Sharon Hospital', 1, NULL, NULL, N'070004', NULL, NULL, 0, 78, NULL, N'8603644228', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Hospital Hill Road Po Box 789', N'Sharon', N'CT', N'09005', N'06069', 41.881172, -73.483551, 784, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (900, N'Waterbury Hospital', 1, NULL, NULL, N'070005', NULL, NULL, 0, 357, NULL, N'2035736000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64 Robbins St', N'Waterbury', N'CT', N'09009', N'06721', 41.558209, -73.058995, 789, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (901, N'Stamford Hospital', 1, NULL, NULL, N'070006', NULL, NULL, 0, 305, NULL, N'2032761000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Shelburne Road', N'Stamford', N'CT', N'09001', N'06904', 41.055813, -73.553929, 787, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (902, N'Lawrence & Memorial Hospital', 1, NULL, NULL, N'070007', NULL, NULL, 0, 280, NULL, N'8604420711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 Montauk Ave', N'New London', N'CT', N'09011', N'06320', 41.336728, -72.103328, 778, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (903, N'Johnson Memorial Hospital', 1, NULL, NULL, N'070008', NULL, NULL, 0, 92, NULL, N'8606844251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Chestnut Hill Rd', N'Stafford Springs', N'CT', N'09013', N'06076', 41.977003, -72.387746, 786, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (904, N'Bridgeport Hospital', 1, NULL, NULL, N'070010', NULL, NULL, 0, 395, NULL, N'2033843000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'267 Grant Street', N'Bridgeport', N'CT', N'09001', N'06610', 41.188813, -73.166655, 766, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (905, N'Charlotte Hungerford Hospital', 1, NULL, NULL, N'070011', NULL, NULL, 0, 109, NULL, N'8604966666', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 Litchfield St', N'Torrington', N'CT', N'09005', N'06790', 41.790799, -73.135288, 788, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (906, N'Rockville General Hospital', 1, NULL, NULL, N'070012', NULL, NULL, 0, 102, NULL, N'8608725160', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'31 Union St', N'Rockville', N'CT', N'09013', N'06066', 41.866959, -72.451083, 783, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (907, N'Saint Marys Hospital', 1, NULL, NULL, N'070016', NULL, NULL, 0, 347, NULL, N'2035746000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56 Franklin St', N'Waterbury', N'CT', N'09009', N'06706', 41.552609, -73.035948, 789, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (908, N'Midstate Medical Center', 1, NULL, NULL, N'070017', NULL, NULL, 0, 144, NULL, N'2036948200', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 Lewis Avenue', N'Meriden', N'CT', N'09009', N'06450', 41.548706, -72.80447, 773, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (909, N'Greenwich Hospital Association', 1, NULL, NULL, N'070018', NULL, NULL, 0, 206, NULL, N'2038633000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Perryridge Rd', N'Greenwich', N'CT', N'09001', N'06830', 41.034928, -73.629602, 770, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (910, N'Milford Hospital Inc', 1, NULL, NULL, N'070019', NULL, NULL, 0, 106, NULL, N'2038764000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Seaside Avenue', N'Milford', N'CT', N'09009', N'06460', 41.216757, -73.064151, 775, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (911, N'Middlesex Hospital', 1, NULL, NULL, N'070020', NULL, NULL, 0, 275, NULL, N'8603446000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28 Crescent St', N'Middletown', N'CT', N'09007', N'06457', 41.555126, -72.647319, 774, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (912, N'Windham Comm Mem Hosp & Hatch Hosp', 1, NULL, NULL, N'070021', NULL, NULL, 0, 130, NULL, N'8604569116', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 Mansfield Ave', N'Willimantic', N'CT', N'09015', N'06226', 41.716794, -72.223996, 790, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (913, N'Yale-New Haven Hospital', 1, NULL, NULL, N'070022', NULL, NULL, 0, 874, NULL, N'2036884242', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 York St', N'New Haven', N'CT', N'09009', N'06504', 41.30436, -72.934637, 777, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (914, N'William W Backus Hospital', 1, NULL, NULL, N'070024', NULL, NULL, 0, 213, NULL, N'8608898331', N'8608236329', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 Washington St', N'Norwich', N'CT', N'09011', N'06360', 41.543402, -72.086747, 781, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (915, N'Hartford Hospital', 1, NULL, NULL, N'070025', NULL, NULL, 0, 819, NULL, N'8605455000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Seymour Street', N'Hartford', N'CT', N'09003', N'06102', 41.754123, -72.68082, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (916, N'Manchester Memorial Hospital', 1, NULL, NULL, N'070027', NULL, NULL, 0, 249, NULL, N'8606474780', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Haynes St', N'Manchester', N'CT', N'09003', N'06040', 41.781079, -72.525291, 772, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (917, N'St Vincent''s Medical Center', 1, NULL, NULL, N'070028', NULL, NULL, 0, 397, NULL, N'2035765551', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Main St', N'Bridgeport', N'CT', N'09001', N'06606', 41.20046, -73.202749, 766, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (918, N'Bristol Hospital', 1, NULL, NULL, N'070029', NULL, NULL, 0, 134, NULL, N'8605853000', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Brewster Rd', N'Bristol', N'CT', N'09003', N'06010', 41.675528, -72.930577, 767, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (919, N'Griffin Hospital', 1, NULL, NULL, N'070031', NULL, NULL, 0, 160, NULL, N'2037327500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Division St', N'Derby', N'CT', N'09009', N'06418', 41.335978, -73.088689, 769, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (920, N'Danbury Hospital', 1, NULL, NULL, N'070033', NULL, NULL, 0, 345, NULL, N'2037397000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Hospital Ave', N'Danbury', N'CT', N'09001', N'06810', 41.406208, -73.446137, 768, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (921, N'Norwalk Hospital Association', 1, NULL, NULL, N'070034', NULL, NULL, 0, 328, NULL, N'2038522000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Stevens Street', N'Norwalk', N'CT', N'09001', N'06856', 41.110437, -73.421017, 780, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (922, N'Hospital Of Central Connecticut The', 1, NULL, NULL, N'070035', NULL, NULL, 0, 330, NULL, N'8602245011', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Grand Street', N'New Britain', N'CT', N'09003', N'06050', 41.662034, -72.787052, 776, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (923, N'John Dempsey Hospital', 1, NULL, NULL, N'070036', NULL, NULL, 0, 204, NULL, N'8606791145', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'263 Farmington Ave', N'Farmington', N'CT', N'09003', N'06032', 41.73509, -72.79582, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (924, N'Connecticut Hospice Incthe', 1, NULL, NULL, N'070038', NULL, NULL, 0, 52, NULL, N'2033157500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Double Beach Road', N'Branford', N'CT', N'09009', N'06405', 41.256186, -72.83301, 777, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (925, N'Masonic Home And Hospital', 1, NULL, NULL, N'070039', NULL, NULL, 0, 91, NULL, N'2036795900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Masonic Ave', N'Wallingford', N'CT', N'09009', N'06492', 41.461412, -72.836082, 773, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (926, N'Hebrew Home And Hospital Inc', 1, NULL, NULL, N'070040', NULL, NULL, 0, 45, NULL, N'8605233800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Abrahms Boulevard', N'West Hartford', N'CT', N'09003', N'06117', 41.802797, -72.728823, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (927, N'Gaylord Hospital Inc', 1, NULL, NULL, N'072003', NULL, NULL, 0, 137, NULL, N'2032842800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Gaylord Farm Rd', N'Wallingford', N'CT', N'09009', N'06492', 41.474532, -72.859133, 773, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (928, N'Hospital For Special Care', 1, NULL, NULL, N'072004', NULL, NULL, 0, 228, NULL, N'8602232761', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2150 Corbin Ave', N'New Britain', N'CT', N'09003', N'06050', 41.688295, -72.800607, 776, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (929, N'State Of Connecticut Dept Of Veterans'' Affairs', 1, NULL, NULL, N'072006', NULL, NULL, 0, 350, NULL, N'8605292571', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'287 West Street', N'Rocky Hill', N'CT', N'09003', N'06067', 41.6534314, -72.653283, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (930, N'Mount Sinai Rehabilitation Hospital Inc', 1, NULL, NULL, N'073025', NULL, NULL, 0, 60, NULL, N'8607143500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'490 Blue Hills Avenue', N'Hartford', N'CT', N'09003', N'06112', 41.800004, -72.693822, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (931, N'Connecticut Childrens Medical Center', 1, NULL, NULL, N'073300', NULL, NULL, 0, 129, NULL, N'8605459000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'282 Washington Street', N'Hartford', N'CT', N'09003', N'06106', 41.753541, -72.682805, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (932, N'Connecticut Valley Hosp', 1, NULL, NULL, N'074003', NULL, NULL, 0, 604, NULL, N'2033442666', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Silver St', N'Middletown', N'CT', N'09007', N'06457', 41.552253, -72.637942, 774, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (933, N'Natchaug Hospital', 1, NULL, NULL, N'074008', NULL, NULL, 0, 60, NULL, N'8604561311', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 Storrs Rd', N'Mansfield Center', N'CT', N'09013', N'06250', 41.765376, -72.198133, 790, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (934, N'Connecticut Mental Health Center', 1, NULL, NULL, N'074011', NULL, NULL, 0, 70, NULL, N'2039743000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34 Park St', N'New Haven', N'CT', N'09009', N'06508', 41.305456, -72.936831, 777, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (935, N'Southwest Connecticut Mental Health', 1, NULL, NULL, N'074012', NULL, NULL, 0, 62, NULL, N'2035796646', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635 Central Ave', N'Bridgeport', N'CT', N'09001', N'06610', 41.18953, -73.167593, 766, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (936, N'Silver Hill Hospital Inc', 1, NULL, NULL, N'074014', NULL, NULL, 0, 129, NULL, N'2039663561', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 Valley Road', N'New Canaan', N'CT', N'09001', N'06840', 42.050301, -73.256329, 780, 48, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (937, N'Yale-New Haven Hospital -  Transplant Center', 1, NULL, NULL, N'079801', NULL, NULL, 0, 0, NULL, N'2037852611', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'20 York Street', N'New Haven', N'CT', N'09009', N'06504', 41.304312, -72.935992, 777, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (938, N'Hartford Hospital - Transplant Center', 1, NULL, NULL, N'079802', NULL, NULL, 0, 0, NULL, N'8605454339', N'8605454366', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'80 Seymour Street Po Box 5037', N'Hartford', N'CT', N'09003', N'06106', 41.75486, -72.680582, 771, 49, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (939, N'Christiana Care Health Services Inc.', 1, NULL, NULL, N'080001', NULL, NULL, 0, 1196, NULL, N'3027331000', N'3027331366', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4755 Ogletown-Stanton Road', N'Newark', N'DE', N'10003', N'19718', 39.689677, -75.673642, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (940, N'St Francis Hospital', 1, NULL, NULL, N'080003', NULL, NULL, 0, 395, NULL, N'3024214100', N'3025758335', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th And Clayton Sts', N'Wilmington', N'DE', N'10003', N'19805', 39.745947, -75.546589, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (941, N'Bayhealth - Kent General Hospital', 1, NULL, NULL, N'080004', NULL, NULL, 0, 304, NULL, N'3027447001', N'3026740703', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 S State Street', N'Dover', N'DE', N'10001', N'19901', 39.150749, -75.522324, 792, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (942, N'Nanticoke Memorial Hospital', 1, NULL, NULL, N'080006', NULL, NULL, 0, 119, NULL, N'3026296611', N'3026292493', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Middleford Rd', N'Seaford', N'DE', N'10005', N'19973', 38.642332, -75.605325, 795, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (943, N'Beebe Medical Center', 1, NULL, NULL, N'080007', NULL, NULL, 0, 155, NULL, N'3026453300', N'3026453635', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'424 Savannah Rd', N'Lewes', N'DE', N'10005', N'19958', 38.770627, -75.143049, 793, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (944, N'Bayhealth - Milford Memorial Hospital', 1, NULL, NULL, N'080009', NULL, NULL, 0, 168, NULL, N'3024223311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21 West Clarke Avenue', N'Milford', N'DE', N'10005', N'19963', 38.906209, -75.433393, 794, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (945, N'Select Specialty Hospital Wilmington', 1, NULL, NULL, N'082000', NULL, NULL, 0, 35, NULL, N'3024214591', N'7179759981', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th & Clayton Streets  5Th Floor', N'Wilmington', N'DE', N'10003', N'19805', 39.745947, -75.546589, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (946, N'Healthsouth Rehabilitation Hospital Of Middletown', 1, NULL, NULL, N'083026', NULL, NULL, 0, 34, NULL, N'4848899815', N'2052624216', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 East Hampden Road', N'Middletown', N'DE', N'10003', N'19709', 39.449556, -75.716321, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (947, N'Alfred I Dupont Hospital For Children', 1, NULL, NULL, N'083300', NULL, NULL, 0, 260, NULL, N'3026514000', N'3026514055', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Rockland Rd Po Box 269', N'Wilmington', N'DE', N'10003', N'19899', 39.745947, -75.546589, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (948, N'Delaware Psychiatric Center', 1, NULL, NULL, N'084001', NULL, NULL, 0, 281, NULL, N'3022552700', N'3022554422', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 N Dupont Highway', N'New Castle', N'DE', N'10003', N'19720', 39.698644, -75.574344, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (949, N'Rockford Center', 1, NULL, NULL, N'084002', NULL, NULL, 0, 92, NULL, N'3029965480', N'3029960269', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Rockford Drive', N'Newark', N'DE', N'10003', N'19713', 39.685219, -75.750829, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (950, N'Meadowwood Behavioral Health System', 1, NULL, NULL, N'084003', NULL, NULL, 0, 58, NULL, N'3023283330', N'3023289336', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 South Dupont Highway', N'New Castle', N'DE', N'10003', N'19720', 39.644655, -75.624868, 796, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (951, N'Dover Behavioral Health System', 1, NULL, NULL, N'084004', NULL, NULL, 0, 73, NULL, N'3027410140', N'3027418551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 Horsepond Road', N'Dover', N'DE', N'10001', N'19901', 39.151271, -75.485814, 792, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (952, N'George Washington Univ Hospital', 1, NULL, NULL, N'090001', NULL, NULL, 0, 371, NULL, N'2027164605', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 23Rd St Nw', N'Washington', N'DC', N'11001', N'20037', 38.901697, -77.050115, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (953, N'Howard University Hospital', 1, NULL, NULL, N'090003', NULL, NULL, 0, 479, NULL, N'2027456100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2041 Georgia Ave Nw', N'Washington', N'DC', N'11001', N'20060', 38.917011, -77.021896, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (954, N'Medstar Georgetown University Hospital', 1, NULL, NULL, N'090004', NULL, NULL, 0, 535, NULL, N'2027843000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3800 Reservoir Rd', N'Washington', N'DC', N'11001', N'20007', 38.912597, -77.074329, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (955, N'Sibley Memorial Hospital', 1, NULL, NULL, N'090005', NULL, NULL, 0, 362, NULL, N'2025374680', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5255 Loughboro Rd Nw', N'Washington', N'DC', N'11001', N'20016', 38.935747, -77.109889, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (956, N'Providence Hospital', 1, NULL, NULL, N'090006', NULL, NULL, 0, 408, NULL, N'2022697000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 Varnum St Ne', N'Washington', N'DC', N'11001', N'20017', 38.942876, -76.991721, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (957, N'United Medical Center', 1, NULL, NULL, N'090008', NULL, NULL, 0, 184, NULL, N'2025746611', N'2025747188', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Southern Avenue  Se', N'Washington', N'DC', N'11001', N'20032', 38.834841, -76.983834, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (958, N'Medstar Washington Hospital Center', 1, NULL, NULL, N'090011', NULL, NULL, 0, 818, NULL, N'2028777000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Irving St Nw', N'Washington', N'DC', N'11001', N'20010', 38.931165, -77.013142, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (959, N'Bridgepoint Hospital Capitol Hill', 1, NULL, NULL, N'092002', NULL, NULL, 0, 60, NULL, N'2026750400', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Constitution Avenue Ne', N'Washington', N'DC', N'11001', N'20002', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (960, N'Bridgepoint Hospital Hadley', 1, NULL, NULL, N'092003', NULL, NULL, 0, 82, NULL, N'2025745770', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Martin Luther King Jr Avenue', N'Washington', N'DC', N'11001', N'20032', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (961, N'Medstar National Rehabilitation Hospital', 1, NULL, NULL, N'093025', NULL, NULL, 0, 137, NULL, N'2028771737', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Irving Street Nw', N'Washington', N'DC', N'11001', N'20010', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (962, N'Children''s Hospital Nmc', 1, NULL, NULL, N'093300', NULL, NULL, 0, 303, NULL, N'2024765000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Michigan Ave Nw', N'Washington', N'DC', N'11001', N'20010', 38.92661, -77.015141, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (963, N'St Elizabeths Hospital', 1, NULL, NULL, N'094001', NULL, NULL, 0, 600, NULL, N'2022995500', N'2025616957', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Alabama Avenue Se', N'Washington', N'DC', N'11001', N'20032', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (964, N'Psychiatric Institute Of Washington Dc', 1, NULL, NULL, N'094004', NULL, NULL, 0, 104, NULL, N'2028855600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4228 Wisconsin Avenue Nw', N'Washington', N'DC', N'11001', N'20016', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (965, N'Medstar Washington Hospital Center', 1, NULL, NULL, N'099800', NULL, NULL, 0, 0, NULL, N'2028776102', N'2028777826', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'110 Irving St Nw', N'Washington', N'DC', N'11001', N'20010', 38.929652, -77.015648, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (966, N'Children''s National Medical Center', 1, NULL, NULL, N'099801', NULL, NULL, 0, 0, NULL, N'2028845058', N'2028842090', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 Michigan Ave Nw', N'Washington', N'DC', N'11001', N'20010', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (967, N'Medstar Georgetown University Hospital', 1, NULL, NULL, N'099802', NULL, NULL, 0, 0, NULL, N'2024448054', N'2024443095', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3800 Reservoir Rd Nw Ste 2 Main', N'Washington', N'DC', N'11001', N'20007', 38.894955, -77.036646, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (968, N'Uf Health Jacksonville', 1, NULL, NULL, N'100001', NULL, NULL, 0, 695, NULL, N'9042440411', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'655 W 8Th St', N'Jacksonville', N'FL', N'12031', N'32209', 30.346868, -81.664567, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (969, N'Bethesda Hospital East', 1, NULL, NULL, N'100002', NULL, NULL, 0, 481, NULL, N'5617377733', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2815 S Seacrest Blvd', N'Boynton Beach', N'FL', N'12099', N'33435', 26.504567, -80.068295, 806, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (970, N'Orlando Health', 1, NULL, NULL, N'100006', NULL, NULL, 0, 1690, NULL, N'3218438000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'52 W Underwood St', N'Orlando', N'FL', N'12095', N'32806', 28.524911, -81.378093, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (971, N'Florida Hospital', 1, NULL, NULL, N'100007', NULL, NULL, 0, 2449, NULL, N'4073031976', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E Rollins St', N'Orlando', N'FL', N'12095', N'32803', 28.573113, -81.369381, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (972, N'Baptist Hospital Of Miami', 1, NULL, NULL, N'100008', NULL, NULL, 0, 728, NULL, N'7865961960', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8900 N Kendall Dr', N'Miami', N'FL', NULL, N'33176', 25.687753, -80.339862, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (973, N'University Of Miami Hospital', 1, NULL, NULL, N'100009', NULL, NULL, 0, 560, NULL, N'3053255511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.787597, -80.215085, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (974, N'Lee Memorial Hospital', 1, NULL, NULL, N'100012', NULL, NULL, 0, 783, NULL, N'2393321111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2776 Cleveland Ave', N'Fort Myers', N'FL', N'12071', N'33901', 26.627344, -81.872315, 832, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (975, N'Bert Fish Medical Center', 1, NULL, NULL, N'100014', NULL, NULL, 0, 112, NULL, N'3864245000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Palmetto St', N'New Smyrna Beach', N'FL', N'12127', N'32170', 29.021661, -80.923122, 866, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (976, N'Halifax Health Medical Center', 1, NULL, NULL, N'100017', NULL, NULL, 0, 638, NULL, N'3862544000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N Clyde Morris Blvd', N'Daytona Beach', N'FL', N'12127', N'32114', 29.200838, -81.055493, 822, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (977, N'Naples Community Hospital', 1, NULL, NULL, N'100018', NULL, NULL, 0, 716, NULL, N'2394365000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 7Th St N', N'Naples', N'FL', N'12021', N'34102', 26.150556, -81.799454, 864, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (978, N'Holmes Regional Medical Center', 1, NULL, NULL, N'100019', NULL, NULL, 0, 514, NULL, N'3214347000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 S Hickory St', N'Melbourne', N'FL', N'12009', N'32901', 28.087054, -80.613526, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (979, N'Jackson Memorial Hospital', 1, NULL, NULL, N'100022', NULL, NULL, 0, 2101, NULL, N'3055851111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1611 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.790612, -80.214945, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (980, N'Citrus Memorial Hospital', 1, NULL, NULL, N'100023', NULL, NULL, 0, 198, NULL, N'3527261551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Highland Blvd', N'Inverness', N'FL', N'12017', N'34452', 28.832242, -82.335337, 842, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (981, N'Sacred Heart Hospital', 1, NULL, NULL, N'100025', NULL, NULL, 0, 466, NULL, N'8504167000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5151 N 9Th Ave', N'Pensacola', N'FL', N'12033', N'32504', 30.476313, -87.21054, 878, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (982, N'Bay Medical Center Sacred Heart Health System', 1, NULL, NULL, N'100026', NULL, NULL, 0, 323, NULL, N'8507691511', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Bonita Ave', N'Panama City', N'FL', N'12005', N'32401', 30.159753, -85.647066, 876, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (983, N'Parrish Medical Center', 1, NULL, NULL, N'100028', NULL, NULL, 0, 210, NULL, N'3212686111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 N Washington Ave', N'Titusville', N'FL', N'12009', N'32796', 28.627529, -80.824023, 904, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (984, N'North Shore Medical Center', 1, NULL, NULL, N'100029', NULL, NULL, 0, 816, NULL, N'3058356000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Nw 95Th St', N'Miami', N'FL', NULL, N'33150', 25.861622, -80.215632, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (985, N'Health Central', 1, NULL, NULL, N'100030', NULL, NULL, 0, 171, NULL, N'4072961820', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10000 W Colonial Dr', N'Ocoee', N'FL', N'12095', N'34761', 28.551655, -81.527573, 911, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (986, N'Bayfront Health - St Petersburg', 1, NULL, NULL, N'100032', NULL, NULL, 0, 480, NULL, N'7278231234', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 6Th St S', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.763102, -82.641662, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (987, N'Mount Sinai Medical Center', 1, NULL, NULL, N'100034', NULL, NULL, 0, 672, NULL, N'3056742121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Alton Rd', N'Miami Beach', N'FL', NULL, N'33140', 25.814949, -80.138001, 862, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (988, N'Manatee Memorial Hospital', 1, NULL, NULL, N'100035', NULL, NULL, 0, 319, NULL, N'9417465111', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 2Nd St E', N'Bradenton', N'FL', N'12081', N'34208', 27.497526, -82.561238, 807, 53, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (989, N'Memorial Regional Hospital', 1, NULL, NULL, N'100038', NULL, NULL, 0, 993, NULL, N'9549872000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Johnson St', N'Hollywood', N'FL', N'12011', N'33021', 26.018263, -80.178792, 839, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (990, N'Broward Health Medical Center', 1, NULL, NULL, N'100039', NULL, NULL, 0, 716, NULL, N'9543554400', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 S Andrews Ave', N'Fort Lauderdale', N'FL', N'12011', N'33316', 26.101804, -80.142274, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (991, N'St Vincent''s Medical Center Riverside', 1, NULL, NULL, N'100040', NULL, NULL, 0, 528, NULL, N'9043087300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Shircliff Way', N'Jacksonville', N'FL', N'12031', N'32204', 30.307891, -81.689154, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (992, N'Mease Dunedin Hospital', 1, NULL, NULL, N'100043', NULL, NULL, 0, 120, NULL, N'7277331111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Main St', N'Dunedin', N'FL', N'12103', N'34698', 28.014032, -82.783822, 827, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (993, N'Martin Medical Center', 1, NULL, NULL, N'100044', NULL, NULL, 0, 344, NULL, N'7722875200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Se Hospital Ave', N'Stuart', N'FL', N'12085', N'34995', 27.19943, -80.243027, 897, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (994, N'Florida Hospital Deland', 1, NULL, NULL, N'100045', NULL, NULL, 0, 156, NULL, N'3869434772', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 W Plymouth Ave', N'Deland', N'FL', N'12127', N'32720', 29.042607, -81.31786, 824, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (995, N'Florida Hospital Zephyrhills', 1, NULL, NULL, N'100046', NULL, NULL, 0, 139, NULL, N'8137880411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7050 Gall Blvd', N'Zephyrhills', N'FL', N'12101', N'33541', 28.261042, -82.188041, 910, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (996, N'Bayfront Health Punta rda', 1, NULL, NULL, N'100047', NULL, NULL, 0, 208, NULL, N'9416393131', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 E Marion Ave', N'Punta rda', N'FL', N'12015', N'33950', 26.940672, -82.041808, 885, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (997, N'Jay Hospital', 1, NULL, NULL, N'100048', NULL, NULL, 0, 55, NULL, N'8506754532', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14114 Alabama St', N'Jay', N'FL', N'12113', N'32565', 30.949884, -87.151732, 846, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (998, N'Highlands Regional Medical Center', 1, NULL, NULL, N'100049', NULL, NULL, 0, 126, NULL, N'8633856101', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 S Highlands Ave', N'Sebring', N'FL', N'12055', N'33870', 27.466365, -81.433704, 891, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (999, N'Palm Springs General Hospital', 1, NULL, NULL, N'100050', NULL, NULL, 0, 247, NULL, N'3055582500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1475 W 49Th St', N'Hialeah', N'FL', NULL, N'33012', 25.86666, -80.312448, 838, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1000, N'South Lake Hospital', 1, NULL, NULL, N'100051', NULL, NULL, 0, 122, NULL, N'3523944071', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Don Wickham Dr', N'Clermont', N'FL', N'12069', N'34711', 28.551172, -81.722939, 814, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1001, N'Winter Haven Hospital', 1, NULL, NULL, N'100052', NULL, NULL, 0, 529, NULL, N'8632931121', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Ave F Ne', N'Winter Haven', N'FL', N'12105', N'33881', 28.027614, -81.726081, 908, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1002, N'Hialeah Hospital', 1, NULL, NULL, N'100053', NULL, NULL, 0, 378, NULL, N'3056936100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 E 25Th St', N'Hialeah', N'FL', NULL, N'33013', 25.845088, -80.267596, 838, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1003, N'Twin Cities Hospital', 1, NULL, NULL, N'100054', NULL, NULL, 0, 65, NULL, N'8506784131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2190 Hwy 85 N', N'Niceville', N'FL', N'12091', N'32578', 30.522651, -86.491453, 867, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1004, N'Florida Hospital North Pinellas', 1, NULL, NULL, N'100055', NULL, NULL, 0, 168, NULL, N'7279425000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1395 S Pinellas Ave', N'Tarpon Springs', N'FL', N'12103', N'34689', 28.133188, -82.758572, 902, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1005, N'Florida Hospital Waterman', 1, NULL, NULL, N'100057', NULL, NULL, 0, 269, NULL, N'3522533300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Waterman Way', N'Tavares', N'FL', N'12069', N'32778', 28.822351, -81.71021, 829, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1006, N'Munroe Regional Medical Center', 1, NULL, NULL, N'100062', NULL, NULL, 0, 421, NULL, N'3523517200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 1St Ave', N'Ocala', N'FL', N'12083', N'34474', 29.174235, -82.137834, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1007, N'Morton Plant North Bay Hospital', 1, NULL, NULL, N'100063', NULL, NULL, 0, 226, NULL, N'7278428468', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6600 Madison St', N'New Port Richey', N'FL', N'12101', N'34652', 28.254367, -82.715483, 865, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1008, N'St Anthonys Hospital', 1, NULL, NULL, N'100067', NULL, NULL, 0, 395, NULL, N'7278251100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Seventh Ave N', N'Saint Petersburg', N'FL', N'12103', N'33705', 27.779367, -82.648092, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1009, N'Florida Hospital Memorial Medical Center', 1, NULL, NULL, N'100068', NULL, NULL, 0, 396, NULL, N'3866766000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Memorial Medical Parkway', N'Daytona Beach', N'FL', N'12127', N'32117', 29.24275, -81.1093, 822, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1010, N'Florida Hospital Carrollwood', 1, NULL, NULL, N'100069', NULL, NULL, 0, 120, NULL, N'8139322222', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7171 N Dale Mabry Hwy', N'Tampa', N'FL', N'12057', N'33614', 28.013102, -82.504954, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1011, N'Venice Regional Medical Center - Bayfront Health', 1, NULL, NULL, N'100070', NULL, NULL, 0, 312, NULL, N'9414857711', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 The Rialto', N'Venice', N'FL', N'12115', N'34285', 27.091587, -82.444326, 905, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1012, N'Bayfront Health Brooksville', 1, NULL, NULL, N'100071', NULL, NULL, 0, 244, NULL, N'3527965111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17240 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34601', 28.541115, -82.443386, 809, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1013, N'Florida Hospital Fish Memorial', 1, NULL, NULL, N'100072', NULL, NULL, 0, 175, NULL, N'3869175000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 Saxon Blvd', N'Orange City', N'FL', N'12127', N'32763', 28.911303, -81.283751, 824, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1014, N'Holy Cross Hospital', 1, NULL, NULL, N'100073', NULL, NULL, 0, 559, NULL, N'9547718000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4725 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.185294, -80.117714, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1015, N'St Josephs Hospital', 1, NULL, NULL, N'100075', NULL, NULL, 0, 1006, NULL, N'8138704398', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 W Martin Luther King Jr Blvd', N'Tampa', N'FL', N'12057', N'33677', 27.981218, -82.478254, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1016, N'Metropolitan Hospital Of Miami', 1, NULL, NULL, N'100076', NULL, NULL, 0, 146, NULL, N'3052641000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Nw 7Th St', N'Miami', N'FL', NULL, N'33126', 25.777919, -80.293084, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1017, N'Bayfront Health Port Charlotte', 1, NULL, NULL, N'100077', NULL, NULL, 0, 254, NULL, N'9417664122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Harbor Blvd', N'Port Charlotte', N'FL', N'12015', N'33952', 26.989849, -82.096685, 882, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1018, N'University Of Miami Hospital And Clinics', 1, NULL, NULL, N'100079', NULL, NULL, 0, 40, NULL, N'3052431000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1475 Nw 12Th Ave', N'Miami', N'FL', NULL, N'33136', 25.792502, -80.214978, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1019, N'Jfk Medical Center', 1, NULL, NULL, N'100080', NULL, NULL, 0, 460, NULL, N'5619657300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 S Congress Ave', N'Atlantis', N'FL', N'12099', N'33462', 26.598561, -80.090304, 800, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1020, N'Healthmark Regional Medical Center', 1, NULL, NULL, N'100081', NULL, NULL, 0, 50, NULL, N'8509514500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4413 Us Hwy 331 S', N'Defuniak Springs', N'FL', N'12131', N'32435', 30.659228, -86.119509, 823, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1021, N'Leesburg Regional Medical Center', 1, NULL, NULL, N'100084', NULL, NULL, 0, 316, NULL, N'3523235762', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Dixie Ave', N'Leesburg', N'FL', N'12069', N'34748', 28.806581, -81.869269, 854, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1022, N'Broward Health North', 1, NULL, NULL, N'100086', NULL, NULL, 0, 409, NULL, N'9547866950', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 E Sample Rd', N'Pompano Beach', N'FL', N'12011', N'33064', 26.275137, -80.120739, 881, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1023, N'Sarasota Memorial Hospital', 1, NULL, NULL, N'100087', NULL, NULL, 0, 819, NULL, N'9419179000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 S Tamiami Trl', N'Sarasota', N'FL', N'12115', N'34239', 27.318268, -82.529687, 889, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1024, N'Baptist Medical Center Jacksonville', 1, NULL, NULL, N'100088', NULL, NULL, 0, 901, NULL, N'9042022000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Prudential Dr', N'Jacksonville', N'FL', N'12031', N'32207', 30.316273, -81.664099, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1025, N'Flagler Hospital', 1, NULL, NULL, N'100090', NULL, NULL, 0, 335, NULL, N'9048194426', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Health Park Blvd', N'Saint Augustine', N'FL', N'12109', N'32086', 29.862626, -81.319513, 894, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1026, N'Wuesthoff Medical Center-Rockledge', 1, NULL, NULL, N'100092', NULL, NULL, 0, 298, NULL, N'3216372603', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Longwood Ave', N'Rockledge', N'FL', N'12009', N'32955', 28.33454, -80.723248, 886, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1027, N'Baptist Hospital', 1, NULL, NULL, N'100093', NULL, NULL, 0, 569, NULL, N'8504344011', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Moreno St', N'Pensacola', N'FL', N'12033', N'32501', 30.428691, -87.232163, 878, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1028, N'Lake Wales Medical Center', 1, NULL, NULL, N'100099', NULL, NULL, 0, 160, NULL, N'8636761433', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 S 11Th St', N'Lake Wales', N'FL', N'12105', N'33853', 27.896586, -81.564665, 851, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1029, N'Shands Lake Shore Regional Medical Center', 1, NULL, NULL, N'100102', NULL, NULL, 0, 99, NULL, N'3862928000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'368 Ne Franklin St', N'Lake City', N'FL', N'12023', N'32055', 30.193472, -82.633152, 850, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1030, N'Indian River Medical Center', 1, NULL, NULL, N'100105', NULL, NULL, 0, 339, NULL, N'7725674311', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 36Th St', N'Vero Beach', N'FL', N'12061', N'32960', 27.658443, -80.396876, 906, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1031, N'Doctor''s Memorial Hospital Inc', 1, NULL, NULL, N'100106', NULL, NULL, 0, 48, NULL, N'8505840800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Byron Butler Pkwy', N'Perry', N'FL', N'12123', N'32348', 30.121302, -83.592148, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1032, N'Lehigh Regional Medical Center', 1, NULL, NULL, N'100107', NULL, NULL, 0, 88, NULL, N'2393692101', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Lee Blvd', N'Lehigh Acres', N'FL', N'12071', N'33936', 26.614294, -81.659485, 855, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1033, N'Florida Hospital Heartland Medical Center', 1, NULL, NULL, N'100109', NULL, NULL, 0, 197, NULL, N'8633144466', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Sun N Lake Blvd', N'Sebring', N'FL', N'12055', N'33871', 27.538455, -81.506881, 891, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1034, N'Osceola Regional Medical Center', 1, NULL, NULL, N'100110', NULL, NULL, 0, 257, NULL, N'4078462266', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Oak Street', N'Kissimmee', N'FL', N'12097', N'34741', 28.300919, -81.409316, 849, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1035, N'Uf Health Shands Hospital', 1, NULL, NULL, N'100113', NULL, NULL, 0, 996, NULL, N'3522658000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32610', 29.638271, -82.346041, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1036, N'Baptist Medical Center - Beaches', 1, NULL, NULL, N'100117', NULL, NULL, 0, 146, NULL, N'9042472900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 13Th Ave S', N'Jacksonville Beach', N'FL', N'12031', N'32250', 30.274502, -81.400352, 844, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1037, N'Florida Hospital Flagler', 1, NULL, NULL, N'100118', NULL, NULL, 0, 99, NULL, N'3865862000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Memorial Medical Pkwy', N'Palm Coast', N'FL', N'12035', N'32164', 29.478987, -81.190091, 810, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1038, N'Bartow Regional Medical Center', 1, NULL, NULL, N'100121', NULL, NULL, 0, 72, NULL, N'8635338111', N'8635191420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Osprey Blvd', N'Bartow', N'FL', N'12105', N'33831', 27.918979, -81.846689, 802, 60, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1039, N'North Okaloosa Medical Center', 1, NULL, NULL, N'100122', NULL, NULL, 0, 110, NULL, N'8506898100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 Redstone Ave Se', N'Crestview', N'FL', N'12091', N'32539', 30.736945, -86.562026, 819, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1040, N'Santa Rosa Medical Center', 1, NULL, NULL, N'100124', NULL, NULL, 0, 129, NULL, N'8506267762', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6002 Berryhill Rd', N'Milton', N'FL', N'12113', N'32570', 30.632616, -87.06825, 863, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1041, N'Homestead Hospital', 1, NULL, NULL, N'100125', NULL, NULL, 0, 142, NULL, N'7862438000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Baptist Way', N'Homestead', N'FL', NULL, N'33033', 25.478666, -80.428218, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1042, N'Palms Of Pasadena Hospital', 1, NULL, NULL, N'100126', NULL, NULL, 0, 307, NULL, N'7273811000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Pasadena Ave S', N'Saint Petersburg', N'FL', N'12103', N'33707', 27.753517, -82.738176, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1043, N'Morton Plant Hospital', 1, NULL, NULL, N'100127', NULL, NULL, 0, 687, NULL, N'7274627000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pinellas St', N'Clearwater', N'FL', N'12103', N'33756', 27.951855, -82.803766, 813, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1044, N'Tampa General Hospital', 1, NULL, NULL, N'100128', NULL, NULL, 0, 1018, NULL, N'8138447000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Tampa General Cir', N'Tampa', N'FL', N'12057', N'33606', 27.937332, -82.459651, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1045, N'Lakeside Medical Center', 1, NULL, NULL, N'100130', NULL, NULL, 0, 70, NULL, N'5619966571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'39200 Hooker Hwy', N'Belle Glade', N'FL', N'12099', N'33430', 26.725671, -80.67127, 803, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1046, N'Aventura Hospital And Medical Center', 1, NULL, NULL, N'100131', NULL, NULL, 0, 407, NULL, N'3056827000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20900 Biscayne Blvd', N'Aventura', N'FL', NULL, N'33180', 25.969698, -80.144331, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1047, N'South Florida Baptist Hospital', 1, NULL, NULL, N'100132', NULL, NULL, 0, 147, NULL, N'8137571200', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 N Alexander St', N'Plant City', N'FL', N'12057', N'33563', 28.015806, -82.137999, 879, 60, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1048, N'Ed Fraser Memorial Hospital', 1, NULL, NULL, N'100134', NULL, NULL, 0, 25, NULL, N'9042593151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'159 N 3Rd St', N'Macclenny', N'FL', N'12003', N'32063', 30.285031, -82.119433, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1049, N'Tallahassee Memorial Hospital', 1, NULL, NULL, N'100135', NULL, NULL, 0, 772, NULL, N'8504311155', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Miccosukee Rd', N'Tallahassee', N'FL', N'12073', N'32308', 30.456171, -84.260662, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1050, N'Heart Of Florida Regional Medical Center', 1, NULL, NULL, N'100137', NULL, NULL, 0, 193, NULL, N'8634224971', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40100 Us Hwy 27 N', N'Davenport', N'FL', N'12105', N'33837', 28.161405, -81.601742, 908, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1051, N'Baptist Medical Center - Nassau', 1, NULL, NULL, N'100140', NULL, NULL, 0, 62, NULL, N'9043213500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S 18Th St', N'Fernandina Beach', N'FL', N'12089', N'32034', 30.654209, -81.449287, 830, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1052, N'Jackson Hospital', 1, NULL, NULL, N'100142', NULL, NULL, 0, 100, NULL, N'8507182620', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Hospital Dr', N'Marianna', N'FL', N'12063', N'32446', 30.786601, -85.242053, 859, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1053, N'Lower Keys Medical Center', 1, NULL, NULL, N'100150', NULL, NULL, 0, 167, NULL, N'3052945531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 College Road', N'Key West', N'FL', N'12087', N'33040', 24.581801, -81.743226, 848, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1054, N'Mayo Clinic', 1, NULL, NULL, N'100151', NULL, NULL, 0, 304, NULL, N'9049532000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 San Pablo Rd', N'Jacksonville', N'FL', N'12031', N'32224', 30.263702, -81.437533, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1055, N'South Miami Hospital', 1, NULL, NULL, N'100154', NULL, NULL, 0, 452, NULL, N'7866624000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 Sw 73Rd St', N'South Miami', N'FL', NULL, N'33143', 25.703051, -80.293367, 892, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1056, N'Lake City Medical Center', 1, NULL, NULL, N'100156', NULL, NULL, 0, 67, NULL, N'3867199000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Nw Commerce Dr', N'Lake City', N'FL', N'12023', N'32055', 30.18398, -82.68627, 850, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1057, N'Lakeland Regional Medical Center', 1, NULL, NULL, N'100157', NULL, NULL, 0, 851, NULL, N'8636871100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 Lakeland Hills Blvd', N'Lakeland', N'FL', N'12105', N'33805', 28.060742, -81.95324, 852, 60, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1058, N'Central Florida Regional Hospital', 1, NULL, NULL, N'100161', NULL, NULL, 0, 221, NULL, N'4073214500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W Seminole Blvd', N'Sanford', N'FL', N'12117', N'32771', 28.816185, -81.283623, 888, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1059, N'Doctors Hospital Of Sarasota', 1, NULL, NULL, N'100166', NULL, NULL, 0, 155, NULL, N'9413421100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5731 Bee Ridge Rd', N'Sarasota', N'FL', N'12115', N'34233', 27.298975, -82.454848, 889, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1060, N'Plantation General Hospital', 1, NULL, NULL, N'100167', NULL, NULL, 0, 737, NULL, N'9545875010', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Nw 42Nd Ave', N'Plantation', N'FL', N'12011', N'33317', 26.126566, -80.204183, 880, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1061, N'Boca Raton Regional Hospital', 1, NULL, NULL, N'100168', NULL, NULL, 0, 400, NULL, N'5613625002', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Meadows Rd', N'Boca Raton', N'FL', N'12099', N'33486', 26.359805, -80.101771, 805, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1062, N'Florida Hospital Tampa', 1, NULL, NULL, N'100173', NULL, NULL, 0, 493, NULL, N'8136157200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 E Fletcher Ave', N'Tampa', N'FL', N'12057', N'33613', 28.069226, -82.424525, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1063, N'Desoto Memorial Hospital', 1, NULL, NULL, N'100175', NULL, NULL, 0, 49, NULL, N'8634943535', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 N Robert Ave', N'Arcadia', N'FL', N'12027', N'34265', 27.215883, -81.858416, 799, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1064, N'Palm Beach Gardens Medical Center', 1, NULL, NULL, N'100176', NULL, NULL, 0, 199, NULL, N'5616221411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3360 Burns Rd', N'Palm Beach Gardens', N'FL', N'12099', N'33410', 26.830693, -80.085472, 875, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1065, N'Cape Canaveral Hospital', 1, NULL, NULL, N'100177', NULL, NULL, 0, 150, NULL, N'3217997111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 W Cocoa Beach Causeway', N'Cocoa Beach', N'FL', N'12009', N'32932', 28.357632, -80.633698, 816, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1066, N'Memorial Hospital Jacksonville', 1, NULL, NULL, N'100179', NULL, NULL, 0, 418, NULL, N'9043996111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3625 University Blvd S', N'Jacksonville', N'FL', N'12031', N'32216', 30.288327, -81.602345, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1067, N'St Petersburg General Hospital', 1, NULL, NULL, N'100180', NULL, NULL, 0, 215, NULL, N'7273841414', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 38Th Ave N', N'Saint Petersburg', N'FL', N'12103', N'33710', 27.806305, -82.727034, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1068, N'Larkin Community Hospital', 1, NULL, NULL, N'100181', NULL, NULL, 0, 146, NULL, N'3052847500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7031 Sw 62Nd Ave', N'South Miami', N'FL', NULL, N'33143', 25.705539, -80.293471, 892, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1069, N'Coral Gables Hospital', 1, NULL, NULL, N'100183', NULL, NULL, 0, 245, NULL, N'3054458461', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Douglas Rd', N'Coral Gables', N'FL', NULL, N'33134', 25.744581, -80.254373, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1070, N'Palmetto General Hospital', 1, NULL, NULL, N'100187', NULL, NULL, 0, 360, NULL, N'3058235000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 W 68Th St', N'Hialeah', N'FL', NULL, N'33016', 25.884168, -80.324568, 838, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1071, N'Northwest Medical Center', 1, NULL, NULL, N'100189', NULL, NULL, 0, 223, NULL, N'9549740400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 N State Rd 7', N'Margate', N'FL', N'12011', N'33063', 26.260789, -80.201724, 858, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1072, N'Medical Center Of Trinity', 1, NULL, NULL, N'100191', NULL, NULL, 0, 282, NULL, N'7278481733', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9332 Sr 54 Ste 401', N'Trinity', N'FL', N'12101', N'34655', 28.180846, -82.681766, 865, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1073, N'Broward Health Imperial Point', 1, NULL, NULL, N'100200', NULL, NULL, 0, 204, NULL, N'9547768500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.206881, -80.108056, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1074, N'North Florida Regional Medical Center', 1, NULL, NULL, N'100204', NULL, NULL, 0, 353, NULL, N'3523334100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Newberry Rd', N'Gainesville', N'FL', N'12001', N'32605', 29.659708, -82.412744, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1075, N'Memorial Hospital Of Tampa', 1, NULL, NULL, N'100206', NULL, NULL, 0, 183, NULL, N'8138736400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 W Swann Ave', N'Tampa', N'FL', N'12057', N'33609', 27.937443, -82.489828, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1076, N'Kendall Regional Medical Center', 1, NULL, NULL, N'100209', NULL, NULL, 0, 417, NULL, N'3052233000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11750 Bird Rd', N'Miami', N'FL', NULL, N'33175', 25.735099, -80.251484, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1077, N'Bayfront Health Dade City', 1, NULL, NULL, N'100211', NULL, NULL, 0, 120, NULL, N'3525683174', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13100 Ft King Rd', N'Dade City', N'FL', N'12101', N'33525', 28.348624, -82.201686, 821, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1078, N'Ocala Regional Medical Center', 1, NULL, NULL, N'100212', NULL, NULL, 0, 270, NULL, N'3524011000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1431 Sw 1St Ave', N'Ocala', N'FL', N'12083', N'34478', 29.174757, -82.137839, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1079, N'Blake Medical Center', 1, NULL, NULL, N'100213', NULL, NULL, 0, 383, NULL, N'9417926611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2020 59Th St W', N'Bradenton', N'FL', N'12081', N'34209', 27.4819, -82.620467, 807, 53, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1080, N'Sebastian River Medical Center', 1, NULL, NULL, N'100217', NULL, NULL, 0, 154, NULL, N'7725893187', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13695 Us Hwy 1', N'Sebastian', N'FL', N'12061', N'32978', 27.844359, -80.488128, 890, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1081, N'Gulf Coast Medical Center Lee Mem Health System', 1, NULL, NULL, N'100220', NULL, NULL, 0, 349, NULL, N'2397685000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13681 Doctors Way', N'Fort Myers', N'FL', N'12071', N'33912', 26.544025, -81.848561, 832, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1082, N'Fort Walton Beach Medical Center', 1, NULL, NULL, N'100223', NULL, NULL, 0, 257, NULL, N'8508621111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mar-Walt Dr', N'Fort Walton Beach', N'FL', N'12091', N'32547', 30.455535, -86.633622, 834, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1083, N'University Hospital And Medical Center', 1, NULL, NULL, N'100224', NULL, NULL, 0, 317, NULL, N'9547212200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7201 N University Dr', N'Tamarac', N'FL', N'12011', N'33321', 26.211385, -80.252543, 900, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1084, N'Orange Park Medical Center', 1, NULL, NULL, N'100226', NULL, NULL, 0, 297, NULL, N'9042768500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Kingsley Ave', N'Orange Park', N'FL', N'12019', N'32073', 30.164829, -81.737887, 870, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1085, N'Westside Regional Medical Center', 1, NULL, NULL, N'100228', NULL, NULL, 0, 224, NULL, N'9544736600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8201 W Broward Blvd', N'Plantation', N'FL', N'12011', N'33324', 26.120888, -80.260545, 880, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1086, N'Memorial Hospital Pembroke', 1, NULL, NULL, N'100230', NULL, NULL, 0, 301, NULL, N'9549629650', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7800 Sheridan St', N'Pembroke Pines', N'FL', N'12011', N'33024', 26.03096, -80.244613, 839, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1087, N'West Florida Hospital', 1, NULL, NULL, N'100231', NULL, NULL, 0, 515, NULL, N'8504944000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8383 N Davis Hwy', N'Pensacola', N'FL', N'12033', N'32514', 30.515253, -87.216849, 878, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1088, N'Putnam Community Medical Center', 1, NULL, NULL, N'100232', NULL, NULL, 0, 99, NULL, N'3863268500', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Zeagler Dr', N'Palatka', N'FL', N'12107', N'32177', 29.643001, -81.693532, 874, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1089, N'West Palm Hospital', 1, NULL, NULL, N'100234', NULL, NULL, 0, 245, NULL, N'5618446141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.758946, -80.087331, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1090, N'Fawcett Memorial Hospital', 1, NULL, NULL, N'100236', NULL, NULL, 0, 237, NULL, N'9416291181', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21298 Olean Blvd', N'Port Charlotte', N'FL', N'12015', N'33952', 26.987743, -82.098609, 882, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1091, N'Northside Hospital', 1, NULL, NULL, N'100238', NULL, NULL, 0, 288, NULL, N'8135215000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 49Th St N', N'Saint Petersburg', N'FL', N'12103', N'33709', 27.825548, -82.700003, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1092, N'Anne Bates Leach Eye Hospital', 1, NULL, NULL, N'100240', NULL, NULL, 0, 100, NULL, N'3053266000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Nw 17Th St', N'Miami', N'FL', NULL, N'33136', 25.791404, -80.210292, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1093, N'Gulf Coast Regional Medical Center', 1, NULL, NULL, N'100242', NULL, NULL, 0, 218, NULL, N'8507477926', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'449 W 23Rd St', N'Panama City', N'FL', N'12005', N'32405', 30.189678, -85.665874, 876, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1094, N'Brandon Regional Hospital', 1, NULL, NULL, N'100243', NULL, NULL, 0, 398, NULL, N'8136815551', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'119 Oakfield Dr', N'Brandon', N'FL', N'12057', N'33511', 27.933973, -82.288295, 808, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1095, N'Cape Coral Hospital', 1, NULL, NULL, N'100244', NULL, NULL, 0, 291, NULL, N'2395742323', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'636 Del Prado Blvd', N'Cape Coral', N'FL', N'12071', N'33990', 26.639677, -81.940951, 811, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1096, N'Lawnwood Regional Medical Center & Heart Institute', 1, NULL, NULL, N'100246', NULL, NULL, 0, 370, NULL, N'7724614000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 S 23Rd St', N'Fort Pierce', N'FL', N'12111', N'34950', 27.432023, -80.347357, 833, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1097, N'Lar Medical Center', 1, NULL, NULL, N'100248', NULL, NULL, 0, 425, NULL, N'7275885200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 14Th St Sw', N'Lar', N'FL', N'12103', N'33770', 27.914944, -82.802596, 853, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1098, N'Seven Rivers Regional Medical Center', 1, NULL, NULL, N'100249', NULL, NULL, 0, 128, NULL, N'3527956560', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6201 N Suncoast Blvd', N'Crystal River', N'FL', N'12017', N'34428', 28.951071, -82.625951, 820, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1099, N'Raulerson Hospital', 1, NULL, NULL, N'100252', NULL, NULL, 0, 100, NULL, N'8637632151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1796 Hwy 441 North', N'Okeechobee', N'FL', N'12093', N'34972', 27.243935, -80.829783, 869, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1100, N'Jupiter Medical Center', 1, NULL, NULL, N'100253', NULL, NULL, 0, 163, NULL, N'5617472234', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 S Old Dixie Hwy', N'Jupiter', N'FL', N'12099', N'33458', 26.922814, -80.094539, 847, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1101, N'Capital Regional Medical Center', 1, NULL, NULL, N'100254', NULL, NULL, 0, 246, NULL, N'8506565000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2626 Capital Medical Blvd', N'Tallahassee', N'FL', N'12073', N'32308', 30.475414, -84.230675, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1102, N'Tampa Community Hospital', 1, NULL, NULL, N'100255', NULL, NULL, 0, 201, NULL, N'8138827159', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Webb Rd', N'Tampa', N'FL', N'12057', N'33615', 28.002662, -82.575153, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1103, N'Regional Medical Center Bayonet Point', 1, NULL, NULL, N'100256', NULL, NULL, 0, 290, NULL, N'7278192929', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14000 Fivay Rd', N'Hudson', N'FL', N'12101', N'34667', 28.361827, -82.690821, 841, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1104, N'Delray Medical Center', 1, NULL, NULL, N'100258', NULL, NULL, 0, 493, NULL, N'5614984440', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5352 Linton Blvd', N'Delray Beach', N'FL', N'12099', N'33484', 26.439246, -80.127919, 825, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1105, N'South Bay Hospital', 1, NULL, NULL, N'100259', NULL, NULL, 0, 112, NULL, N'8136343301', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4016 Sun City Center Blvd', N'Sun City Center', N'FL', N'12057', N'33573', 27.71239, -82.365168, 898, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1106, N'St Lucie Medical Center', 1, NULL, NULL, N'100260', NULL, NULL, 0, 229, NULL, N'7723354000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Se Tiffany Ave', N'Port Saint Lucie', N'FL', N'12111', N'34952', 27.288962, -80.295488, 884, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1107, N'Oak Hill Hospital', 1, NULL, NULL, N'100264', NULL, NULL, 0, 262, NULL, N'3525966632', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11375 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34613', 28.533305, -82.534496, 893, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1108, N'Mease Countryside Hospital', 1, NULL, NULL, N'100265', NULL, NULL, 0, 300, NULL, N'7277346950', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3231 Mcmullen Booth Rd', N'Safety Harbor', N'FL', N'12103', N'34695', 28.040326, -82.708971, 887, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1109, N'Gulf Breeze Hospital', 1, NULL, NULL, N'100266', NULL, NULL, 0, 77, NULL, N'8509342000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Gulf Breeze Pkwy', N'Gulf Breeze', N'FL', N'12113', N'32561', 30.358735, -87.156476, 837, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1110, N'Englewood Community Hospital', 1, NULL, NULL, N'100267', NULL, NULL, 0, 100, NULL, N'9414756571', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Medical Blvd', N'Englewood', N'FL', N'12115', N'34223', 26.948971, -82.326633, 828, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1111, N'West Boca Medical Center', 1, NULL, NULL, N'100268', NULL, NULL, 0, 195, NULL, N'5614888000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21644 State Rd 7', N'Boca Raton', N'FL', N'12099', N'33428', 26.354571, -80.203236, 805, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1112, N'Palms West Hospital', 1, NULL, NULL, N'100269', NULL, NULL, 0, 204, NULL, N'5617534245', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13001 Southern Blvd', N'Loxahatchee', N'FL', N'12099', N'33470', 26.681928, -80.251439, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1113, N'H Lee Moffitt Cancer Center & Research Institute I', 1, NULL, NULL, N'100271', NULL, NULL, 0, 206, NULL, N'8139793054', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12902 Magnolia Dr', N'Tampa', N'FL', N'12057', N'33612', 28.062422, -82.419564, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1114, N'Wellington Regional Medical Center', 1, NULL, NULL, N'100275', NULL, NULL, 0, 233, NULL, N'5617988500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Forest Hill Blvd', N'Wellington', N'FL', N'12099', N'33414', 26.650806, -80.20477, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1115, N'Broward Health Coral Springs', 1, NULL, NULL, N'100276', NULL, NULL, 0, 200, NULL, N'9543443000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Coral Hills Dr', N'Coral Springs', N'FL', N'12011', N'33065', 26.268425, -80.254158, 818, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1116, N'Douglas Gardens Hospital', 1, NULL, NULL, N'100277', NULL, NULL, 0, 32, NULL, N'3057518626', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Ne 2Nd Ave', N'Miami', N'FL', NULL, N'33137', 25.823073, -80.191772, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1117, N'Memorial Hospital West', 1, NULL, NULL, N'100281', NULL, NULL, 0, 384, NULL, N'9544365000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 N Flamin Rd', N'Pembroke Pines', N'FL', N'12011', N'33028', 26.012252, -80.31195, 877, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1118, N'Westchester General Hospital', 1, NULL, NULL, N'100284', NULL, NULL, 0, 125, NULL, N'3052639270', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Sw 75Th Ave', N'Miami', N'FL', NULL, N'33155', 25.746803, -80.317458, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1119, N'Memorial Hospital Miramar', 1, NULL, NULL, N'100285', NULL, NULL, 0, 178, NULL, N'9545384810', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Sw 172Nd Ave', N'Miramar', N'FL', N'12011', N'33029', 25.990744, -80.375996, 877, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1120, N'Physicians Regional Medical Center - Pine Ridge', 1, NULL, NULL, N'100286', NULL, NULL, 0, 201, NULL, N'2393484000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6101 Pine Ridge Road', N'Naples', N'FL', N'12021', N'34119', 26.211764, -81.730707, 864, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1121, N'od Samaritan Medical Center', 1, NULL, NULL, N'100287', NULL, NULL, 0, 333, NULL, N'5616555511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 N Flagler Dr', N'West Palm Beach', N'FL', N'12099', N'33401', 26.725431, -80.050092, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1122, N'St Mary''s Medical Center', 1, NULL, NULL, N'100288', NULL, NULL, 0, 464, NULL, N'5618406202', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.753231, -80.063243, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1123, N'Cleveland Clinic Hospital', 1, NULL, NULL, N'100289', NULL, NULL, 0, 155, NULL, N'9546895000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Weston Rd', N'Weston', N'FL', N'12011', N'33331', 26.080374, -80.365423, 877, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1124, N'Villages Regional Hospital The', 1, NULL, NULL, N'100290', NULL, NULL, 0, 223, NULL, N'3527518000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 El Camino Real', N'The Villages', N'FL', N'12119', N'32159', 28.949433, -81.958428, 854, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1125, N'Wuesthoff Medical Center-Melbourne', 1, NULL, NULL, N'100291', NULL, NULL, 0, 119, NULL, N'3217521200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 North Wickham Road', N'Melbourne', N'FL', N'12009', N'32935', 28.110382, -80.672608, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1126, N'Sacred Heart Hospital On The Emerald Coast', 1, NULL, NULL, N'100292', NULL, NULL, 0, 58, NULL, N'8502783600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7800 Us Hwy 98 W', N'Miramar Beach', N'FL', N'12131', N'32550', 30.376817, -86.306807, 826, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1127, N'Doctors Hospital', 1, NULL, NULL, N'100296', NULL, NULL, 0, 281, NULL, N'3056662111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 University Dr', N'Coral Gables', N'FL', NULL, N'33146', 25.724785, -80.273145, 817, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1128, N'Florida State Hospital Unit 31 Med', 1, NULL, NULL, N'100298', NULL, NULL, 0, 1230, NULL, N'8506637536', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Main St', N'Chattahoochee', N'FL', N'12039', N'32324', 30.698022, -84.840732, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1129, N'Lakewood Ranch Medical Center', 1, NULL, NULL, N'100299', NULL, NULL, 0, 120, NULL, N'9417822100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8330 Lakewood Ranch Blvd', N'Bradenton', N'FL', N'12081', N'34202', 27.390816, -82.433337, 807, 53, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1130, N'St Cloud Regional Medical Center', 1, NULL, NULL, N'100302', NULL, NULL, 0, 84, NULL, N'4074983432', N'4078924835', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2906 17Th Street', N'Saint Cloud', N'FL', N'12097', N'34769', 28.242403, -81.30358, 895, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1131, N'St Vincent''s Medical Center Southside', 1, NULL, NULL, N'100307', NULL, NULL, 0, 311, NULL, N'9042963700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Belfort Rd', N'Jacksonville', N'FL', N'12031', N'32216', 30.253103, -81.584126, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1132, N'Sacred Heart Hospital On The Gulf', 1, NULL, NULL, N'100313', NULL, NULL, 0, 19, NULL, N'8502295600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 E Hwy 98', N'Port Saint Joe', N'FL', N'12045', N'32456', 29.776556, -85.286399, 883, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1133, N'West Kendall Baptist Hospital', 1, NULL, NULL, N'100314', NULL, NULL, 0, 133, NULL, N'7864672011', N'7864672012', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9555 Sw 162 Ave', N'Miami', N'FL', NULL, N'33196', 25.677111, -80.457359, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1134, N'Viera Hospital', 1, NULL, NULL, N'100315', NULL, NULL, 0, 84, NULL, N'3214349000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8745 N Wickham Rd', N'Melbourne', N'FL', N'12009', N'32940', 28.186663, -80.67216, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1135, N'Palm Bay Hospital', 1, NULL, NULL, N'100316', NULL, NULL, 0, 152, NULL, N'3214348000', N'3214348110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 Malabar Rd Ne', N'Palm Bay', N'FL', N'12009', N'32907', 27.99833, -80.61208, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1136, N'Florida Hospital Wesley Chapel', 1, NULL, NULL, N'100319', NULL, NULL, 0, 83, NULL, N'8139295490', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Bruce B Downs Blvd', N'Wesley Chapel', N'FL', N'12101', N'33544', 28.192137, -82.353415, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1137, N'Poinciana Medical Center', 1, NULL, NULL, N'100320', NULL, NULL, 0, 30, NULL, N'4075302000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Cypress Pkwy', N'Kissimmee', N'FL', N'12097', N'34758', 28.142723, -81.472985, 849, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1138, N'St Vincents Medical Center - Clay County', 1, NULL, NULL, N'100321', NULL, NULL, 0, 64, NULL, N'9043087164', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1670 St Vincents Way', N'Middleburg', N'FL', N'12019', N'32068', 30.108329, -81.831575, 870, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1139, N'Regional General Hospital Williston', 1, NULL, NULL, N'100322', NULL, NULL, 0, 40, NULL, N'3525282801', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Sw 7Th St', N'Williston', N'FL', N'12075', N'32696', 29.383904, -82.455788, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1140, N'Select Specialty Hospital-Daytona Beach', 1, NULL, NULL, N'100325', NULL, NULL, 0, 34, NULL, N'3862313907', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Memorial Medical Parkway', N'Daytona Beach', N'FL', N'12127', N'32117', 29.210815, -81.022833, 822, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1141, N'Promise Hospital Of Miami', 1, NULL, NULL, N'100326', NULL, NULL, 0, 90, NULL, N'9545945525', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14001 Nw 82Nd Avenue', N'Miami Lakes', N'FL', NULL, N'33016', 25.900596, -80.332504, 838, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1142, N'Florida Hospital Wauchula', 1, NULL, NULL, N'101300', NULL, NULL, 0, 25, NULL, N'8637733101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'533 Carlton St', N'Wauchula', N'FL', N'12049', N'33873', 27.536471, -81.816562, 801, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1143, N'Shands Live Oak Regional Medical Center', 1, NULL, NULL, N'101301', NULL, NULL, 0, 25, NULL, N'9043621413', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Sw 11Th St', N'Live Oak', N'FL', N'12121', N'32060', 30.289929, -83.002156, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1144, N'Campbellton-Graceville Hospital', 1, NULL, NULL, N'101302', NULL, NULL, 0, 25, NULL, N'8502637201', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5429 College Dr', N'Graceville', N'FL', N'12063', N'32440', 30.963261, -85.505543, 836, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1145, N'Lake Butler Hospital', 1, NULL, NULL, N'101303', NULL, NULL, 0, 25, NULL, N'3864962323', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 E Main St', N'Lake Butler', N'FL', N'12125', N'32054', 30.02361, -82.327269, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1146, N'Calhoun-Liberty Hospital', 1, NULL, NULL, N'101304', NULL, NULL, 0, 25, NULL, N'8506743493', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20370 Ne Burns Ave', N'Blountstown', N'FL', N'12013', N'32424', 30.458132, -85.050015, 804, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1147, N'George E Weems Memorial Hospital', 1, NULL, NULL, N'101305', NULL, NULL, 0, 25, NULL, N'8506538853', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Ave G', N'Apalachicola', N'FL', N'12037', N'32320', 29.723991, -84.99175, 798, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1148, N'Doctors Memorial Hospital', 1, NULL, NULL, N'101307', NULL, NULL, 0, 20, NULL, N'8505471120', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Hospital Dr', N'Bonifay', N'FL', N'12059', N'32425', 30.760717, -85.682643, 327, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1149, N'Northwest Florida Community Hospital', 1, NULL, NULL, N'101308', NULL, NULL, 0, 25, NULL, N'8506381610', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1360 Brickyard Rd', N'Chipley', N'FL', N'12133', N'32428', 30.764579, -85.542953, 812, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1150, N'Hendry Regional Medical Center', 1, NULL, NULL, N'101309', NULL, NULL, 0, 25, NULL, N'8639023033', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'524 W Sagamore Ave', N'Clewiston', N'FL', N'12051', N'33440', 26.753238, -80.941418, 815, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1151, N'Shands Starke Regional Medical Center', 1, NULL, NULL, N'101310', NULL, NULL, 0, 25, NULL, N'9043682300', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'922 E Call St', N'Starke', N'FL', N'12007', N'32091', 29.941979, -82.101931, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1152, N'Madison County Memorial Hospital', 1, NULL, NULL, N'101311', NULL, NULL, 0, 25, NULL, N'8509732271', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 Nw Crane Ave', N'Madison', N'FL', N'12079', N'32340', 30.470252, -83.411467, 856, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1153, N'Fishermen''s Hospital', 1, NULL, NULL, N'101312', NULL, NULL, 0, 25, NULL, N'3057435533', N'3057432373', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Overseas Hwy', N'Marathon', N'FL', N'12087', N'33050', 24.711047, -81.095028, 857, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1154, N'Mariners Hospital', 1, NULL, NULL, N'101313', NULL, NULL, 0, 25, NULL, N'3054343000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91500 Overseas Highway', N'Tavernier', N'FL', N'12087', N'33070', 25.004627, -80.522027, 903, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1155, N'Daystar Inc', 1, NULL, NULL, N'101993', NULL, NULL, 0, 14, NULL, N'9544730167', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3800 South Flamin Road', N'Fort Lauderdale', N'FL', N'12011', N'33330', 26.0722188, -80.3151767, 877, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1156, N'Select Specialty Hospital-Miami', 1, NULL, NULL, N'102001', NULL, NULL, 0, 47, NULL, N'3054165700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 Nw 3Rd Street 8Th Floor', N'Miami', N'FL', NULL, N'33128', 25.77665, -80.210605, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1157, N'Select Specialty Hospital - Orlando', 1, NULL, NULL, N'102003', NULL, NULL, 0, 75, NULL, N'4073031766', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5579 S Orange Ave', N'Orlando', N'FL', N'12095', N'32809', 28.445126, -81.365269, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1158, N'Kindred Hospital-Bay Area-Tampa', 1, NULL, NULL, N'102009', NULL, NULL, 0, 155, NULL, N'8138396341', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4555 S Manhattan Ave', N'Tampa', N'FL', N'12057', N'33611', 27.898028, -82.518527, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1159, N'Kindred Hospital-South Florida-Ft Lauderdale', 1, NULL, NULL, N'102010', NULL, NULL, 0, 249, NULL, N'9547648900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1516 E Las Olas Blvd', N'Fort Lauderdale', N'FL', N'12011', N'33301', 26.119325, -80.12825, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1160, N'Specialty Hospital Jacksonville', 1, NULL, NULL, N'102012', NULL, NULL, 0, 107, NULL, N'9047373120', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4901 Richard St', N'Jacksonville', N'FL', N'12031', N'32207', 30.264875, -81.612406, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1161, N'Kindred Hospital-Central Tampa', 1, NULL, NULL, N'102013', NULL, NULL, 0, 102, NULL, N'8138747575', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 N Howard Ave', N'Tampa', N'FL', N'12057', N'33603', 27.94776, -82.458444, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1162, N'Kindred Hospital-North Florida', 1, NULL, NULL, N'102015', NULL, NULL, 0, 80, NULL, N'9042849230', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Oak St', N'Green Cove Springs', N'FL', N'12019', N'32043', 29.988295, -81.682817, 870, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1163, N'Sister Emmanuel Hospital', 1, NULL, NULL, N'102016', NULL, NULL, 0, 29, NULL, N'3052852939', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3663 S Miami Ave 4Th Floor', N'Miami', N'FL', NULL, N'33133', 25.743142, -80.216738, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1164, N'Select Specialty Hospital - Panama City', 1, NULL, NULL, N'102017', NULL, NULL, 0, 30, NULL, N'8507673180', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Bonita Ave', N'Panama City', N'FL', N'12005', N'32401', 30.159151, -85.647168, 876, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1165, N'Complex Care Hospital At Ridgelake', 1, NULL, NULL, N'102018', NULL, NULL, 0, 40, NULL, N'9413423200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6150 Edgelake Dr', N'Sarasota', N'FL', N'12115', N'34240', 27.336435, -82.530653, 889, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1166, N'Kindred Hospital Ocala', 1, NULL, NULL, N'102019', NULL, NULL, 0, 31, NULL, N'3523690513', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 1St Avenue 5Th Floor', N'Ocala', N'FL', N'12083', N'34474', 29.174177, -82.137965, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1167, N'Select Specialty Hospital - Tallahassee', 1, NULL, NULL, N'102020', NULL, NULL, 0, 29, NULL, N'8502196800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1554 Surgeons Dr', N'Tallahassee', N'FL', N'12073', N'32308', 30.459277, -84.260105, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1168, N'Baycare Alliant Hospital', 1, NULL, NULL, N'102021', NULL, NULL, 0, 48, NULL, N'7277346302', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Main St', N'Dunedin', N'FL', N'12103', N'34698', 28.014078, -82.783616, 827, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1169, N'Select Specialty Hospital Gainesville Inc', 1, NULL, NULL, N'102022', NULL, NULL, 0, 44, NULL, N'3525865303', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2708 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32608', 29.651907, -82.324798, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1170, N'Select Specialty Hospital-Palm Beach', 1, NULL, NULL, N'102023', NULL, NULL, 0, 60, NULL, N'5613577200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3060 Melaleuca Lane', N'Lake Worth', N'FL', N'12099', N'33461', 26.606222, -80.090421, 800, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1171, N'Select Specialty Hospital Pensacola', 1, NULL, NULL, N'102024', NULL, NULL, 0, 54, NULL, N'8504795938', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Cobble Creek Dr', N'Pensacola', N'FL', N'12033', N'32504', 30.478514, -87.215681, 878, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1172, N'Kindred Hospital The Palm Beaches', 1, NULL, NULL, N'102025', NULL, NULL, 0, 70, NULL, N'5618400754', N'5618420271', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 W Blue Heron Blvd', N'Riviera Beach', N'FL', N'12099', N'33418', 26.782742, -80.089369, 875, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1173, N'Florida Hospital At Connerton Long Term Acute Care', 1, NULL, NULL, N'102026', NULL, NULL, 0, 50, NULL, N'8139716000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9441 Health Center Dr', N'Land O Lakes', N'FL', N'12101', N'34637', 28.218899, -82.457594, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1174, N'Kindred Hospital Melbourne', 1, NULL, NULL, N'102027', NULL, NULL, 0, 60, NULL, N'3217335725', N'3217335799', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'765 W Nasa Blvd', N'Melbourne', N'FL', N'12009', N'32901', 28.092833, -80.634551, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1175, N'Promise Hospital Of Florida At The Villages', 1, NULL, NULL, N'102028', NULL, NULL, 0, 40, NULL, N'5618693100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5050 County Road 472', N'Oxford', N'FL', N'12119', N'34484', 28.927536, -82.037333, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1176, N'Promise Hospital Of Fort Myers', 1, NULL, NULL, N'102029', NULL, NULL, 0, 60, NULL, N'7083634925', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Champion Ring Road', N'Fort Myers', N'FL', N'12071', N'33905', 26.626135, -81.801349, 832, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1177, N'St Catherine''s Rehabilitation Hospital', 1, NULL, NULL, N'103026', NULL, NULL, 0, 62, NULL, N'3058918850', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Ne 125Th St', N'North Miami', N'FL', NULL, N'33161', 25.890566, -80.177316, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1178, N'St Anthony''s Rehabilitation Hospital', 1, NULL, NULL, N'103027', NULL, NULL, 0, 26, NULL, N'9547396233', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3487 Nw 30Th St', N'Lauderdale Lakes', N'FL', N'12011', N'33311', 26.162625, -80.193159, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1179, N'Healthsouth Sunrise Rehabilitation Hospital', 1, NULL, NULL, N'103028', NULL, NULL, 0, 126, NULL, N'9547490300', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4399 Nob Hill Rd', N'Sunrise', N'FL', N'12011', N'33351', 26.165374, -80.283639, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1180, N'Healthsouth Rehabilitation Hospital Of Sarasota', 1, NULL, NULL, N'103031', NULL, NULL, 0, 96, NULL, N'9419218600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6400 Edgelake Dr', N'Sarasota', N'FL', N'12115', N'34240', 27.336435, -82.530653, 889, 67, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1181, N'Healthsouth Treasure Coast Rehabilitation Hospital', 1, NULL, NULL, N'103032', NULL, NULL, 0, 80, NULL, N'7727782100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 37Th St', N'Vero Beach', N'FL', N'12061', N'32960', 27.638716, -80.39754, 906, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1182, N'Healthsouth Rehabilitation Hospital Of Tallahassee', 1, NULL, NULL, N'103033', NULL, NULL, 0, 76, NULL, N'8506564800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1675 Riggins Rd', N'Tallahassee', N'FL', N'12073', N'32308', 30.459551, -84.237068, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1183, N'Healthsouth Sea Pines Rehabilitation Hospital', 1, NULL, NULL, N'103034', NULL, NULL, 0, 90, NULL, N'3219844600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Florida Avenue', N'Melbourne', N'FL', N'12009', N'32901', 28.056861, -80.620654, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1184, N'West Gables Rehabilitation Hospital', 1, NULL, NULL, N'103036', NULL, NULL, 0, 60, NULL, N'3052601816', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Sw 75Th Ave', N'Miami', N'FL', NULL, N'33155', 25.747354, -80.317108, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1185, N'Healthsouth Rehabilitation Hospital Of Lar', 1, NULL, NULL, N'103037', NULL, NULL, 0, 70, NULL, N'7275862999', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Clearwater Lar Rd N', N'Lar', N'FL', N'12103', N'34641', 27.909066, -82.796352, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1186, N'Healthsouth Rehabilitation Hospital Of Miami', 1, NULL, NULL, N'103038', NULL, NULL, 0, 60, NULL, N'3052513800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20601 Old Cutler Rd', N'Miami', N'FL', NULL, N'33189', 25.576507, -80.34019, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1187, N'Brooks Rehabilitation Hospital', 1, NULL, NULL, N'103039', NULL, NULL, 0, 157, NULL, N'9048587625', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3599 University Blvd S', N'Jacksonville', N'FL', N'12031', N'32216', 30.2902, -81.602079, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1188, N'Healthsouth Emerald Coast Rehabilitation Hospital', 1, NULL, NULL, N'103040', NULL, NULL, 0, 75, NULL, N'8509148653', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1847 Florida Ave', N'Panama City', N'FL', N'12005', N'32403', 30.182189, -85.668334, 876, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1189, N'Healthsouth Rehabilitation Hospital Of Spring Hill', 1, NULL, NULL, N'103042', NULL, NULL, 0, 80, NULL, N'3525924250', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12440 Cortez Blvd', N'Brooksville', N'FL', N'12053', N'34613', 28.551936, -82.422739, 893, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1190, N'Healthsouth Rehabilitation Hospital Of Ocala', 1, NULL, NULL, N'103043', NULL, NULL, 0, 40, NULL, N'3522824000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2275 Sw 22Nd Lane', N'Ocala', N'FL', N'12083', N'34471', 29.187199, -82.140092, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1191, N'Healthsouth Rehabilitation Hospital At Martin Heal', 1, NULL, NULL, N'103044', NULL, NULL, 0, 34, NULL, N'7723243522', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5850 Se Community Dr', N'Stuart', N'FL', N'12085', N'34997', 27.197983, -80.251917, 897, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1192, N'Healthsouth Rehabilitation Hospital Of Altamonte S', 1, NULL, NULL, N'103045', NULL, NULL, 0, 50, NULL, N'4075878600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'831 S State Rd 434', N'Altamonte', N'FL', N'12117', N'32714', 28.664906, -81.376269, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1193, N'All Children''s Hospital Inc', 1, NULL, NULL, N'103300', NULL, NULL, 0, 259, NULL, N'8138987451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Sixth Avenue South', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.7646641, -82.6425994, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1194, N'Nicklaus Children''s Hospital', 1, NULL, NULL, N'103301', NULL, NULL, 0, 289, NULL, N'3056666511', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Sw 62Nd Ave', N'Miami', N'FL', NULL, N'33155', 25.745407, -80.295306, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1195, N'Shriners Hospitals For Children-Tampa', 1, NULL, NULL, N'103303', NULL, NULL, 0, 60, NULL, N'8139722250', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12502 Usf Pine Dr', N'Tampa', N'FL', N'12057', N'33612', 28.056982, -82.425048, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1196, N'Nemours Children''s Hospital', 1, NULL, NULL, N'103304', NULL, NULL, 0, 95, NULL, N'4075674000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13535 Nemours Pkwy', N'Orlando', N'FL', N'12095', N'32827', 28.375112, -81.27667, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1197, N'Florida State Hospital Unit 14 Psych', 1, NULL, NULL, N'104000', NULL, NULL, 0, 1230, NULL, N'8506637536', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Main St', N'Chattahoochee', N'FL', N'12039', N'32324', 30.698022, -84.840732, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1198, N'South Florida State Hospital', 1, NULL, NULL, N'104001', NULL, NULL, 0, 350, NULL, N'3059677000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Cypress Dr', N'Pembroke Pines', N'FL', N'12011', N'33025', 26.002666, -80.256273, 839, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1199, N'Northeast Florida State Hospital', 1, NULL, NULL, N'104007', NULL, NULL, 0, 1138, NULL, N'9042596211', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7487 S State Rd 121', N'Macclenny', N'FL', N'12003', N'32063', 30.282181, -82.122057, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1200, N'The Jerome lden Center For Behavioral Health In', 1, NULL, NULL, N'104008', NULL, NULL, 0, 44, NULL, N'5618449741', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1041 45Th St', N'West Palm Beach', N'FL', N'12099', N'33407', 26.715343, -80.053375, 907, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1201, N'River Point Behavioral Health', 1, NULL, NULL, N'104016', NULL, NULL, 0, 93, NULL, N'8003427552', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6300 Beach Blvd', N'Jacksonville', N'FL', N'12031', N'32216', 30.291067, -81.597278, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1202, N'Windmoor Healthcare Of Clearwater', 1, NULL, NULL, N'104017', NULL, NULL, 0, 144, NULL, N'7275412646', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11300 Us 19 N', N'Clearwater', N'FL', N'12103', N'33764', 27.965853, -82.800103, 813, 54, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1203, N'Lifestream Behavioral Center', 1, NULL, NULL, N'104018', NULL, NULL, 0, 46, NULL, N'3523606598', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2020 Tally Rd', N'Leesburg', N'FL', N'12069', N'34749', 28.835968, -81.895012, 854, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1204, N'Circles Of Care Inc', 1, NULL, NULL, N'104024', NULL, NULL, 0, 52, NULL, N'3219844900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 E Sheridan Rd', N'Melbourne', N'FL', N'12009', N'32901', 28.0899924, -80.6180618, 860, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1205, N'Fort Lauderdale Hospital', 1, NULL, NULL, N'104026', NULL, NULL, 0, 100, NULL, N'9544634321', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 E Las Olas Blvd', N'Fort Lauderdale', N'FL', N'12011', N'33301', 26.119487, -80.127055, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1206, N'West Florida Community Care Center', 1, NULL, NULL, N'104027', NULL, NULL, 0, 100, NULL, N'9046234990', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5500 Stewart St', N'Milton', N'FL', N'12113', N'32570', 30.631393, -87.043224, 863, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1207, N'Gulf Coast Treatment Center', 1, NULL, NULL, N'104032', NULL, NULL, 0, 24, NULL, N'8508634160', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Mar Walt Dr', N'Fort Walton Beach', N'FL', N'12091', N'32547', 30.405755, -86.618842, 834, 66, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1208, N'Centerstone Of Florida', 1, NULL, NULL, N'104040', NULL, NULL, 0, 30, NULL, N'9417413805', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2020 26Th Ave E', N'Bradenton', N'FL', N'12081', N'34208', 27.498928, -82.574819, 807, 53, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1209, N'Southern Winds Hospital', 1, NULL, NULL, N'104049', NULL, NULL, 0, 72, NULL, N'3055589700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4225 W 20Th Ave', N'Hialeah', N'FL', NULL, N'33012', 25.86018, -80.322248, 838, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1210, N'Springbrook Hospital', 1, NULL, NULL, N'104057', NULL, NULL, 0, 66, NULL, N'3525964306', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7007 Grove Rd', N'Brooksville', N'FL', N'12053', N'34609', 28.555272, -82.387871, 893, 58, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1211, N'Eastside Psychiatric Hospital', 1, NULL, NULL, N'104059', NULL, NULL, 0, 46, NULL, N'9044872930', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2634B Capital Circle Ne 2Nd Flr', N'Tallahassee', N'FL', N'12073', N'32308', 30.428541, -84.352534, 899, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1212, N'Willough At Naples The', 1, NULL, NULL, N'104063', NULL, NULL, 0, 63, NULL, N'9417754500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9001 Tamiami Trail East', N'Naples', N'FL', N'12021', N'34113', 26.13837, -81.771829, 864, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1213, N'Atlantic Shores Hospital', 1, NULL, NULL, N'104065', NULL, NULL, 0, 42, NULL, N'9547712711', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4545 N Federal Hwy', N'Fort Lauderdale', N'FL', N'12011', N'33308', 26.122308, -80.143379, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1214, N'Aspire Health Partners', 1, NULL, NULL, N'104067', NULL, NULL, 0, 56, NULL, N'4078753700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Mercy Dr', N'Orlando', N'FL', N'12095', N'32808', 28.558478, -81.430489, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1215, N'Centers Inc The', 1, NULL, NULL, N'104068', NULL, NULL, 0, 15, NULL, N'3522915555', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5664 Sw 60Th Ave', N'Ocala', N'FL', N'12083', N'34474', 29.186961, -82.136012, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1216, N'Wekiva Springs', 1, NULL, NULL, N'104069', NULL, NULL, 0, 68, NULL, N'9042963533', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3947 Salisbury Rd', N'Jacksonville', N'FL', N'12031', N'32216', 30.25824, -81.596269, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1217, N'Port St Lucie Hospital', 1, NULL, NULL, N'104070', NULL, NULL, 0, 75, NULL, N'7723350400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 Se Walton Rd', N'Port Saint Lucie', N'FL', N'12111', N'34952', 27.298681, -80.256744, 884, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1218, N'Vines Hospital', 1, NULL, NULL, N'104071', NULL, NULL, 0, 64, NULL, N'3526713130', N'3528613134', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3130 Sw 27Th Ave', N'Ocala', N'FL', N'12001', N'34474', 29.158247, -82.169014, 868, 62, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1219, N'Central Florida Behavioral Hospital', 1, NULL, NULL, N'104072', NULL, NULL, 0, 126, NULL, N'4073700111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 Central Florida Parkway', N'Orlando', N'FL', N'12095', N'32821', 28.409267, -81.469647, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1220, N'Emerald Coast Behavioral Hospital', 1, NULL, NULL, N'104073', NULL, NULL, 0, 86, NULL, N'8507630017', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1940 Harrison Ave', N'Panama City', N'FL', N'12005', N'32405', 30.188735, -85.6583, 876, 65, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1221, N'Park Royal Hospital', 1, NULL, NULL, N'104074', NULL, NULL, 0, 103, NULL, N'2393320125', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9241 Park Royal Dr', N'Fort Myers', N'FL', N'12071', N'33908', 26.640628, -81.872308, 832, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1222, N'North Tampa Behavioral Health', 1, NULL, NULL, N'104075', NULL, NULL, 0, 75, NULL, N'8133330000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29910 Sr 56', N'Wesley Chapel', N'FL', N'12101', N'33543', 28.23973, -82.327866, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1223, N'University Behavioral Center', 1, NULL, NULL, N'104076', NULL, NULL, 0, 112, NULL, N'4072817000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2500 Discovery Drive', N'Orlando', N'FL', N'12095', N'32826', 28.542118, -81.379046, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1224, N'Suncoast Behavioral Health Center', 1, NULL, NULL, N'104078', NULL, NULL, 0, 60, NULL, N'9417922222', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4480 51St St W', N'Bradenton', N'FL', N'12081', N'34210', 27.459989, -82.612476, 807, 53, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1225, N'Tampa General Hospital', 1, NULL, NULL, N'109801', NULL, NULL, 0, 0, NULL, N'8138444602', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Tampa General Cir', N'Tampa', N'FL', N'12057', N'33601', 27.94776, -82.458444, 901, 70, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1226, N'Florida Hospital', 1, NULL, NULL, N'109802', NULL, NULL, 0, 0, NULL, N'4073039659', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 E Rollins Street', N'Orlando', N'FL', N'12095', N'32803', 28.542118, -81.379046, 871, 63, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1227, N'Shands Hospital At The University Of Florida', 1, NULL, NULL, N'109803', NULL, NULL, 0, 0, NULL, N'3522650111', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Sw Archer Rd', N'Gainesville', N'FL', N'12001', N'32610', 29.651907, -82.324798, 835, 57, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1228, N'Jackson Memorial Hospital', 1, NULL, NULL, N'109804', NULL, NULL, 0, 0, NULL, N'3055856754', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1611 Nw 12Th Avenue Ww117', N'Miami', N'FL', NULL, N'33136', 25.791163, -80.212101, 861, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1229, N'Broward Health Broward General Medical Center', 1, NULL, NULL, N'109805', NULL, NULL, 0, 0, NULL, N'9543555610', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 South Andrews Ave', N'Fort Lauderdale', N'FL', N'12011', N'33316', 26.122308, -80.143379, 831, 55, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1230, N'Mayo Clinic', 1, NULL, NULL, N'109806', NULL, NULL, 0, 0, NULL, N'9049532000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4500 San Pablo Road', N'Jacksonville', N'FL', N'12031', N'32224', 30.314319, -81.448054, 843, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1231, N'Halifax Health Medical Center', 1, NULL, NULL, N'109807', NULL, NULL, 0, 0, NULL, N'3862544060', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'303 N Clyde Morris Blvd', N'Daytona Beach', N'FL', N'12127', N'32114', 29.19971, -81.054771, 822, 64, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1232, N'All Children''s Hospital', 1, NULL, NULL, N'109808', NULL, NULL, 0, 0, NULL, N'7277674474', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'801 Sixth St S', N'Saint Petersburg', N'FL', N'12103', N'33701', 27.770861, -82.679266, 896, 68, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1233, N'Gulf Coast Medical Center Lee Mem Health System', 1, NULL, NULL, N'109809', NULL, NULL, 0, 0, NULL, N'2399391147', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'13681 Doctor''s Way', N'Fort Myers', N'FL', N'12071', N'33912', 26.640628, -81.872308, 832, 56, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1234, N'Memorial Regional Hospital', 1, NULL, NULL, N'109810', NULL, NULL, 0, 0, NULL, N'9542655814', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3501 Johnson St', N'Hollywood', N'FL', N'12011', N'33021', 26.018303, -80.180647, 839, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1235, N'Cleveland Clinic Florida', 1, NULL, NULL, N'109811', NULL, NULL, 0, 0, NULL, N'9546895000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2950 Cleveland Clinic Blvd', N'Weston', N'FL', N'12011', N'33331', 26.080444, -80.36426, 877, 61, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1236, N'Hamilton Medical Center', 1, NULL, NULL, N'110001', NULL, NULL, 0, 282, NULL, N'7062726105', N'7062726110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Memorial Drive', N'Dalton', N'GA', N'13313', N'30720', 34.788884, -84.983657, 945, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1237, N'Upson Regional Medical Center', 1, NULL, NULL, N'110002', NULL, NULL, 0, 119, NULL, N'7066478111', N'7066463310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 W rdon Street', N'Thomaston', N'GA', N'13293', N'30286', 32.887289, -84.337284, 1010, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1238, N'Mayo Clinic Health System In Waycross Inc', 1, NULL, NULL, N'110003', NULL, NULL, 0, 237, NULL, N'9122872500', N'9122872505', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Tebeau Street', N'Waycross', N'GA', N'13299', N'31501', 31.226326, -82.348837, 1021, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1239, N'Hutcheson Medical Center', 1, NULL, NULL, N'110004', NULL, NULL, 0, 179, NULL, N'7068582101', N'7068582864', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Gross Crescent', N'Fort Oglethorpe', N'GA', N'13047', N'30742', 34.94777, -85.262756, 960, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1240, N'Northside Hospital Forsyth', 1, NULL, NULL, N'110005', NULL, NULL, 0, 78, NULL, N'4048518700', N'7708443227', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Northside Forsyth Drive', N'Cumming', N'GA', N'13117', N'30041', 34.178338, -84.139554, 998, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1241, N'St Mary''s Hospital', 1, NULL, NULL, N'110006', NULL, NULL, 0, 196, NULL, N'7063893930', N'7063893931', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 Baxter Street', N'Athens', N'GA', N'13059', N'30606', 33.946069, -83.403236, 917, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1242, N'Phoebe Putney Memorial Hospital', 1, NULL, NULL, N'110007', NULL, NULL, 0, 691, NULL, N'2293124068', N'2293124115', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 Third Avenue', N'Albany', N'GA', N'13095', N'31703', 31.590227, -84.157357, 913, 71, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1243, N'Northside Hospital Cherokee', 1, NULL, NULL, N'110008', NULL, NULL, 0, 84, NULL, N'7707205298', N'7704793670', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hospital Road', N'Canton', N'GA', N'13057', N'30114', 34.245736, -84.492172, 930, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1244, N'Emory University Hospital', 1, NULL, NULL, N'110010', NULL, NULL, 0, 661, NULL, N'4046868500', N'4046868535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1364 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.791881, -84.320977, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1245, N'Tanner Medical Center - Carrollton', 1, NULL, NULL, N'110011', NULL, NULL, 0, 182, NULL, N'7708369580', N'7708369897', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 Dixie Street', N'Carrollton', N'GA', N'13045', N'30117', 33.570555, -85.072464, 931, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1246, N'Tanner Medical Center Villa Rica', 1, NULL, NULL, N'110015', NULL, NULL, 0, 40, NULL, N'7704563101', N'7704563390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Dallas Highway', N'Villa Rica', N'GA', N'13045', N'30180', 33.743913, -84.918918, 1018, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1247, N'West Georgia Medical Center', 1, NULL, NULL, N'110016', NULL, NULL, 0, 276, NULL, N'7068821411', N'7068458918', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1514 Vernon Road', N'Lagrange', N'GA', N'13285', N'30240', 33.030172, -85.058365, 976, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1248, N'Piedmont Newton Hospital', 1, NULL, NULL, N'110018', NULL, NULL, 0, 90, NULL, N'7707867053', N'7707879059', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5126 Hospital Drive Ne', N'Covington', N'GA', N'13217', N'30014', 33.602079, -83.84857, 941, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1249, N'rdon Hospital', 1, NULL, NULL, N'110023', NULL, NULL, 0, 69, NULL, N'7066292895', N'7066294842', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 Red Bud Road', N'Calhoun', N'GA', N'13129', N'30701', 34.5119, -84.925297, 929, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1250, N'Candler Hospital', 1, NULL, NULL, N'110024', NULL, NULL, 0, 320, NULL, N'9128196000', N'9128195887', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 Reynolds Street', N'Savannah', N'GA', N'13051', N'31412', 32.02736, -81.101731, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1251, N'Southeast Georgia Health System- Brunswick Campus', 1, NULL, NULL, N'110025', NULL, NULL, 0, 300, NULL, N'9124667000', N'9124667013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2415 Parkwood Drive', N'Brunswick', N'GA', N'13127', N'31520', 31.173786, -81.484523, 927, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1252, N'Elbert Memorial Hospital', 1, NULL, NULL, N'110026', NULL, NULL, 0, 52, NULL, N'7062132535', N'7062132578', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4 Medical Drive', N'Elberton', N'GA', N'13105', N'30635', 34.112831, -82.874873, 955, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1253, N'St Mary''s Sacred Heart Hospital Inc', 1, NULL, NULL, N'110027', NULL, NULL, 0, 56, NULL, N'7063567800', N'7063567828', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'367 Clear Creek Parkway', N'Lavonia', N'GA', N'13119', N'30553', 34.438102, -83.132813, 999, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1254, N'University Hospital', 1, NULL, NULL, N'110028', NULL, NULL, 0, 551, NULL, N'7067229011', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 Walton Way', N'Augusta', N'GA', N'13245', N'30901', 33.473139, -81.981699, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1255, N'Northeast Georgia Medical Center Inc', 1, NULL, NULL, N'110029', NULL, NULL, 0, 461, NULL, N'7705353553', N'7705353566', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'743 Spring Street', N'Gainesville', N'GA', N'13139', N'30501', 34.30335, -83.81737, 962, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1256, N'Cartersville Medical Center', 1, NULL, NULL, N'110030', NULL, NULL, 0, 112, NULL, N'7703878182', N'7706062127', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'960 Joe Frank Harris Parkway', N'Cartersville', N'GA', N'13015', N'30120', 34.199951, -84.796149, 932, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1257, N'Spalding Regional Hospital', 1, NULL, NULL, N'110031', NULL, NULL, 0, 160, NULL, N'7702282721', N'7702296953', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 South 8Th Street', N'Griffin', N'GA', N'13255', N'30223', 33.239201, -84.265671, 965, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1258, N'Stephens County Hospital', 1, NULL, NULL, N'110032', NULL, NULL, 0, 99, NULL, N'7062824250', N'7062824334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 Hospital Drive', N'Toccoa', N'GA', N'13257', N'30577', 34.593049, -83.347229, 1014, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1259, N'Medical College Of Ga Hospitals And Clinics', 1, NULL, NULL, N'110034', NULL, NULL, 0, 632, NULL, N'7067216569', N'7067216572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 15Th Street', N'Augusta', N'GA', N'13245', N'30912', 33.470738, -81.991602, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1260, N'Wellstar Kennestone Hospital', 1, NULL, NULL, N'110035', NULL, NULL, 0, 633, NULL, N'7707935000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'677 Church Street', N'Marietta', N'GA', N'13067', N'30060', 33.969172, -84.550331, 981, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1261, N'Memorial Health Univ Med Cen Inc', 1, NULL, NULL, N'110036', NULL, NULL, 0, 530, NULL, N'9123508000', N'9123507073', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Waters Avenue', N'Savannah', N'GA', N'13051', N'31403', 32.031785, -81.091827, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1262, N'John D Archbold Memorial Hospital', 1, NULL, NULL, N'110038', NULL, NULL, 0, 264, NULL, N'2292282880', N'2295518741', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 rdon Avenue & Mimosa Drive', N'Thomasville', N'GA', N'13275', N'31792', 30.825093, -83.973428, 1011, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1263, N'Trinity Hospital Of Augusta', 1, NULL, NULL, N'110039', NULL, NULL, 0, 231, NULL, N'7064817000', N'7064817599', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2260 Wrightsboro Rd', N'Augusta', N'GA', N'13245', N'30904', 33.467675, -82.017889, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1264, N'Northridge Medical Center', 1, NULL, NULL, N'110040', NULL, NULL, 0, 90, NULL, N'7063351100', N'7703357701', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Medical Center Drive', N'Commerce', N'GA', N'13157', N'30529', 34.218707, -83.469156, 938, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1265, N'Habersham County Medical Ctr', 1, NULL, NULL, N'110041', NULL, NULL, 0, 53, NULL, N'7067542161', N'7067547300', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'541 Historic Highway 441-North', N'Demorest', N'GA', N'13137', N'30535', 34.565193, -83.545332, 947, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1266, N'Wellstar Paulding Hospital', 1, NULL, NULL, N'110042', NULL, NULL, 0, 83, NULL, N'4706447000', N'4706447399', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2518 Jimmy Lee Smith Parkway', N'Hiram', N'GA', N'13223', N'30141', 33.900639, -84.78126, 920, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1267, N'St Joseph''s Hospital - Savannah', 1, NULL, NULL, N'110043', NULL, NULL, 0, 294, NULL, N'9128194100', N'9128192188', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11705 Mercy Boulevard', N'Savannah', N'GA', N'13051', N'31419', 31.985079, -81.152792, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1268, N'Phoebe Sumter Medical Center', 1, NULL, NULL, N'110044', NULL, NULL, 0, 143, NULL, N'2299311280', N'2299241014', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 Highway 280 W', N'Americus', N'GA', N'13261', N'31719', 32.072386, -84.232688, 915, 71, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1269, N'Barrow Regional Medical Center', 1, NULL, NULL, N'110045', NULL, NULL, 0, 56, NULL, N'7703075210', N'7703075221', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 North Broad Street', N'Winder', N'GA', N'13013', N'30680', 34.007043, -83.706689, 1023, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1270, N'Clearview  Regional Medical Center', 1, NULL, NULL, N'110046', NULL, NULL, 0, 77, NULL, N'7702678461', N'7702671888', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2151 West Spring Street', N'Monroe', N'GA', N'13297', N'30655', 33.798652, -83.746332, 986, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1271, N'Murray Medical Center', 1, NULL, NULL, N'110050', NULL, NULL, 0, 42, NULL, N'7065172031', N'7065172076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Old Dalton Ellijay Road Po Box 1406', N'Chatsworth', N'GA', N'13213', N'30705', 34.779926, -84.782162, 945, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1272, N'Union General Hospital', 1, NULL, NULL, N'110051', NULL, NULL, 0, 45, NULL, N'7067452111', N'7067457677', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Hospital Road', N'Blairsville', N'GA', N'13291', N'30512', 34.886699, -83.962676, 923, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1273, N'Floyd Medical Center', 1, NULL, NULL, N'110054', NULL, NULL, 0, 284, NULL, N'7065096900', N'7065096901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Turner Mccall Blvd P O Box 233', N'Rome', N'GA', N'13115', N'30162', 34.260457, -85.180345, 997, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1274, N'Midtown Medical Center', 1, NULL, NULL, N'110064', NULL, NULL, 0, 417, NULL, N'7065711000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Center St Box 951', N'Columbus', N'GA', N'13215', N'31901', 32.481668, -84.981885, 937, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1275, N'Houston Medical Center', 1, NULL, NULL, N'110069', NULL, NULL, 0, 186, NULL, N'4789224281', N'4783225174', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Watson Boulevard', N'Warner Robins', N'GA', N'13153', N'31093', 32.618198, -83.62941, 1019, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1276, N'Appling Hospital', 1, NULL, NULL, N'110071', NULL, NULL, 0, 49, NULL, N'9123679841', N'9123671272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 E Tollison Street', N'Baxley', N'GA', N'13001', N'31513', 31.769912, -82.351555, 922, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1277, N'Dorminy Medical Center', 1, NULL, NULL, N'110073', NULL, NULL, 0, 75, NULL, N'2294247100', N'2294247281', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Perry House Road Box 1447', N'Fitzgerald', N'GA', N'13017', N'31750', 31.696988, -83.260921, 957, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1278, N'Athens Regional Medical Center', 1, NULL, NULL, N'110074', NULL, NULL, 0, 315, NULL, N'7064757000', N'7064756775', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1199 Prince Avenue', N'Athens', N'GA', N'13059', N'30606', 33.962383, -83.397803, 917, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1279, N'East Georgia Regional Medical Center', 1, NULL, NULL, N'110075', NULL, NULL, 0, 150, NULL, N'9124861500', N'9128712354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1499 Fair Road', N'Statesboro', N'GA', N'13031', N'30458', 32.415229, -81.76869, 1006, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1280, N'Dekalb Medical Center', 1, NULL, NULL, N'110076', NULL, NULL, 0, 451, NULL, N'4045011000', N'4045015627', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 N Decatur Road', N'Decatur', N'GA', N'13089', N'30033', 33.79203, -84.283193, 946, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1281, N'Emory University Hospital Midtown', 1, NULL, NULL, N'110078', NULL, NULL, 0, 481, NULL, N'4046864411', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Peachtree St Ne', N'Atlanta', N'GA', N'13121', N'30308', 33.769802, -84.385172, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1282, N'Grady Memorial Hospital', 1, NULL, NULL, N'110079', NULL, NULL, 0, 953, NULL, N'4046164252', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Jesse Hill Jr Drive Se', N'Atlanta', N'GA', N'13121', N'30303', 33.752186, -84.382576, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1283, N'Saint Joseph''s Hospital Of Atlanta Inc', 1, NULL, NULL, N'110082', NULL, NULL, 0, 410, NULL, N'6788435720', N'6788437339', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5665 Peachtree Dunwoody Road', N'Atlanta', N'GA', N'13121', N'30342', 33.908474, -84.351818, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1284, N'Piedmont Hospital', 1, NULL, NULL, N'110083', NULL, NULL, 0, 458, NULL, N'4046055000', N'4046096699', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1968 Peachtree Rd Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.807481, -84.393754, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1285, N'Washington County Regional Medical Center', 1, NULL, NULL, N'110086', NULL, NULL, 0, 56, NULL, N'4782402100', N'4782402390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Sparta Road', N'Sandersville', N'GA', N'13303', N'31082', 32.996817, -82.805042, 1000, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1286, N'Gwinnett Medical Center', 1, NULL, NULL, N'110087', NULL, NULL, 0, 353, NULL, N'6783121000', N'7706822257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Medical Center Boulevard', N'Lawrenceville', N'GA', N'13135', N'30045', 33.961704, -84.016197, 978, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1287, N'Coffee Regional Medical Center', 1, NULL, NULL, N'110089', NULL, NULL, 0, 88, NULL, N'2293841900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Ocilla Road', N'Douglas', N'GA', N'13069', N'31533', 31.510257, -82.865369, 949, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1288, N'Rockdale Medical Center', 1, NULL, NULL, N'110091', NULL, NULL, 0, 107, NULL, N'7709183000', N'7709183104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1412 Milstead Avenue Ne', N'Conyers', N'GA', N'13247', N'30012', 33.682239, -84.001941, 939, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1289, N'Dodge County Hospital', 1, NULL, NULL, N'110092', NULL, NULL, 0, 94, NULL, N'4784484067', N'4783749411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Griffin Ave', N'Eastman', N'GA', N'13091', N'31023', 32.192813, -83.175215, 953, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1290, N'Tift Regional Medical Center', 1, NULL, NULL, N'110095', NULL, NULL, 0, 176, NULL, N'2293827120', N'2293536192', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E 18Th Street', N'Tifton', N'GA', N'13277', N'31793', 31.470415, -83.491222, 1013, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1291, N'Jefferson Hospital', 1, NULL, NULL, N'110100', NULL, NULL, 0, 65, NULL, N'4786257000', N'4786258907', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1067 Peachtree St', N'Louisville', N'GA', N'13163', N'30434', 33.010363, -82.404349, 979, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1292, N'Cook  Medical Center  A Campus Of Tift Reg Med Ctr', 1, NULL, NULL, N'110101', NULL, NULL, 0, 60, NULL, N'2298968077', N'2298968001', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 N Parrish Ave', N'Adel', N'GA', N'13075', N'31620', 31.143688, -83.424694, 912, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1293, N'Crisp Regional Hospital', 1, NULL, NULL, N'110104', NULL, NULL, 0, 65, NULL, N'2292763100', N'2292763108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'902 7Th Street North', N'Cordele', N'GA', N'13081', N'31015', 31.977335, -83.782841, 940, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1294, N'Colquitt Regional Medical Center', 1, NULL, NULL, N'110105', NULL, NULL, 0, 99, NULL, N'2299853420', N'2298919338', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 Thomasville Hwy Box 40', N'Moultrie', N'GA', N'13071', N'31768', 31.122834, -83.783856, 988, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1295, N'Medical Center Of Central Georgia', 1, NULL, NULL, N'110107', NULL, NULL, 0, 637, NULL, N'4786336805', N'4786335348', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Hemlock Street', N'Macon', N'GA', N'13021', N'31201', 32.833066, -83.636328, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1296, N'Emanuel Medical Center', 1, NULL, NULL, N'110109', NULL, NULL, 0, 72, NULL, N'4782891304', N'4782891300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Kite Road', N'Swainsboro', N'GA', N'13107', N'30401', 32.59326, -82.346605, 1008, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1297, N'University Mcduffie County Regional Medical Center', 1, NULL, NULL, N'110111', NULL, NULL, 0, 47, NULL, N'7065951411', N'7065975139', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2460 Washington Road', N'Thomson', N'GA', N'13189', N'30824', 33.525457, -82.504991, 1012, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1298, N'Burke Medical Center', 1, NULL, NULL, N'110113', NULL, NULL, 0, 40, NULL, N'7065544435', N'7065544854', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 South Liberty Street', N'Waynesboro', N'GA', N'13033', N'30830', 33.083439, -82.011603, 1022, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1299, N'Atlanta Medical Center - Atl Campus & South Campus', 1, NULL, NULL, N'110115', NULL, NULL, 0, 762, NULL, N'4042654000', N'4042653903', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Parkway Dr Ne', N'Atlanta', N'GA', N'13121', N'30312', 33.761921, -84.374251, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1300, N'Grady General Hospital', 1, NULL, NULL, N'110121', NULL, NULL, 0, 60, NULL, N'2293770251', N'2293777953', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1155 5Th Street Se', N'Cairo', N'GA', N'13131', N'39828', 30.851659, -84.193736, 928, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1301, N'South Georgia Medical Center', 1, NULL, NULL, N'110122', NULL, NULL, 0, 335, NULL, N'2293331020', N'2293331007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 North Patterson Street Po Box 1727', N'Valdosta', N'GA', N'13185', N'31603', 30.860933, -83.288877, 1015, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1302, N'Wayne Memorial Hospital', 1, NULL, NULL, N'110124', NULL, NULL, 0, 88, NULL, N'9125303302', N'9125303495', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'865 South First Street', N'Jesup', N'GA', N'13305', N'31545', 31.602794, -81.898737, 975, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1303, N'Fairview Park Hospital', 1, NULL, NULL, N'110125', NULL, NULL, 0, 190, NULL, N'4782743100', N'4782720211', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Industrial Boulevard', N'Dublin', N'GA', N'13175', N'31021', 32.534759, -82.951076, 951, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1304, N'Meadows Regional Medical Center', 1, NULL, NULL, N'110128', NULL, NULL, 0, 87, NULL, N'9125355828', N'9125355830', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Meadows Parkway', N'Vidalia', N'GA', N'13279', N'30474', 32.217686, -82.413461, 1016, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1305, N'St Francis Hospital Inc', 1, NULL, NULL, N'110129', NULL, NULL, 0, 376, NULL, N'7065964020', N'7065964481', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2122 Manchester Expressway', N'Columbus', N'GA', N'13215', N'31995', 32.506927, -84.961378, 937, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1306, N'Irwin County Hospital', 1, NULL, NULL, N'110130', NULL, NULL, 0, 34, NULL, N'2294683845', N'2284683973', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N Irwin Avenue', N'Ocilla', N'GA', N'13155', N'31774', 31.603331, -83.250322, 991, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1307, N'Memorial Hospital And Manor', 1, NULL, NULL, N'110132', NULL, NULL, 0, 80, NULL, N'2292463500', N'2292468142', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Shotwell Street', N'Bainbridge', N'GA', N'13087', N'39819', 30.903766, -84.550726, 921, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1308, N'Taylor Regional Hospital', 1, NULL, NULL, N'110135', NULL, NULL, 0, 55, NULL, N'4787830200', N'4788920518', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 Perry Hwy', N'Hawkinsville', N'GA', N'13235', N'31036', 32.295633, -83.485824, 968, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1309, N'Evans Memorial Hospital', 1, NULL, NULL, N'110142', NULL, NULL, 0, 49, NULL, N'9127395105', N'9127395101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N River Street', N'Claxton', N'GA', N'13109', N'30417', 32.164133, -81.900403, 933, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1310, N'Wellstar Cobb Hospital', 1, NULL, NULL, N'110143', NULL, NULL, 0, 382, NULL, N'7707324000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3950 Austell Rd', N'Austell', N'GA', N'13067', N'30106', 33.857961, -84.600703, 920, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1311, N'Southeast Georgia Health System- Camden Campus', 1, NULL, NULL, N'110146', NULL, NULL, 0, 40, NULL, N'9125766401', N'9125766404', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Dan Proctor Drive', N'Saint Marys', N'GA', N'13039', N'31558', 30.780986, -81.615607, 1005, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1312, N'Oconee Regional Medical Center', 1, NULL, NULL, N'110150', NULL, NULL, 0, 140, NULL, N'4784543550', N'4784543555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 N Cobb Street  Post Office Box 690', N'Milledgeville', N'GA', N'13009', N'31061', 33.088002, -83.244636, 984, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1313, N'Perry Hospital', 1, NULL, NULL, N'110153', NULL, NULL, 0, 39, NULL, N'4789873600', N'4783225174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Morningside Dr', N'Perry', N'GA', N'13153', N'31069', 32.458888, -83.711243, 992, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1314, N'Northside Hospital', 1, NULL, NULL, N'110161', NULL, NULL, 0, 444, NULL, N'4048518000', N'4043033820', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Johnson Ferry Road Ne', N'Atlanta', N'GA', N'13121', N'30342', 33.907899, -84.354048, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1315, N'Coliseum Medical Centers', 1, NULL, NULL, N'110164', NULL, NULL, 0, 250, NULL, N'4787657000', N'4787421247', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Hospital Drive', N'Macon', N'GA', N'13021', N'31217', 32.845999, -83.617823, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1316, N'Southern Regional Medical Center', 1, NULL, NULL, N'110165', NULL, NULL, 0, 376, NULL, N'7709918160', N'7709973304', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Upper Riverdale Road Sw', N'Riverdale', N'GA', N'13063', N'30274', 33.576612, -84.393249, 996, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1317, N'Redmond Regional Medical Center', 1, NULL, NULL, N'110168', NULL, NULL, 0, 201, NULL, N'7068023012', N'7062910971', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Redmond Road', N'Rome', N'GA', N'13115', N'30165', 34.278186, -85.193534, 997, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1318, N'Doctors Hospital', 1, NULL, NULL, N'110177', NULL, NULL, 0, 354, NULL, N'7066516008', N'7066512041', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3651 Wheeler Road', N'Augusta', N'GA', N'13245', N'30909', 33.48239, -82.089893, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1319, N'Emory-Adventist Hospital', 1, NULL, NULL, N'110183', NULL, NULL, 0, 88, NULL, N'7704340710', N'7704324260', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3949 South Cobb Drive', N'Smyrna', N'GA', N'13067', N'30080', 33.900972, -84.541001, 1002, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1320, N'Wellstar Douglas Hospital', 1, NULL, NULL, N'110184', NULL, NULL, 0, 108, NULL, N'7709491500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8954 Hospital Drive', N'Douglasville', N'GA', N'13097', N'30134', 33.739428, -84.732988, 950, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1321, N'Chestatee Regional Hospital', 1, NULL, NULL, N'110187', NULL, NULL, 0, 49, NULL, N'7068646136', N'7068641356', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'227 Mountain Dr', N'Dahlonega', N'GA', N'13187', N'30533', 34.522759, -83.976425, 943, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1322, N'Fannin Regional Hospital', 1, NULL, NULL, N'110189', NULL, NULL, 0, 50, NULL, N'7066323711', N'7066327216', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2855 Old Highway 5 North', N'Blue Ridge', N'GA', N'13111', N'30513', 34.916425, -84.375025, 925, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1323, N'Flint River Community Hospital', 1, NULL, NULL, N'110190', NULL, NULL, 0, 49, NULL, N'4784723100', N'4784722412', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Sumter Street Box 770', N'Montezuma', N'GA', N'13193', N'31063', 32.294195, -84.029901, 987, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1324, N'Piedmont Henry Hospital', 1, NULL, NULL, N'110191', NULL, NULL, 0, 122, NULL, N'6786041000', N'6786045580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1133 Eagle''s Landing Parkway', N'Stockbridge', N'GA', N'13151', N'30281', 33.50914, -84.225671, 1007, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1325, N'Eastside Medical Center', 1, NULL, NULL, N'110192', NULL, NULL, 0, 200, NULL, N'7707362498', N'7707362395', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Medical Way', N'Snellville', N'GA', N'13135', N'30078', 33.877487, -84.019732, 1003, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1326, N'Donalsonville Hospital Inc', 1, NULL, NULL, N'110194', NULL, NULL, 0, 65, NULL, N'2295245217', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Hospital Cir', N'Donalsonville', N'GA', N'13253', N'39845', 31.050546, -84.880142, 948, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1327, N'North Fulton Hospital', 1, NULL, NULL, N'110198', NULL, NULL, 0, 167, NULL, N'7707512500', N'7707512912', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Hospital Boulevard', N'Roswell', N'GA', N'13121', N'30076', 34.06229, -84.320496, 998, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1328, N'Northside Medical Center', 1, NULL, NULL, N'110200', NULL, NULL, 0, 100, NULL, N'7064942100', N'7064942446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Frist Court', N'Columbus', N'GA', N'13215', N'31909', 32.535232, -84.951322, 937, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1329, N'Coliseum Northside Hospital', 1, NULL, NULL, N'110201', NULL, NULL, 0, 103, NULL, N'4787578200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Charter Boulevard', N'Macon', N'GA', N'13021', N'31210', 32.868749, -83.693645, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1330, N'North Georgia Medical Center', 1, NULL, NULL, N'110205', NULL, NULL, 0, 49, NULL, N'7062764741', N'7062763698', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1362 South Main Street', N'Ellijay', N'GA', N'13123', N'30540', 34.688474, -84.490588, 956, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1331, N'Turning Point Hospital', 1, NULL, NULL, N'110209', NULL, NULL, 0, 59, NULL, N'2299854815', N'2298901614', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3015 Veterans Parkway', N'Moultrie', N'GA', N'13071', N'31788', 31.121495, -83.779869, 988, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1332, N'Piedmont Fayette Hospital', 1, NULL, NULL, N'110215', NULL, NULL, 0, 100, NULL, N'7707197071', N'7707197092', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1255 Highway 54 West', N'Fayetteville', N'GA', N'13113', N'30214', 33.451002, -84.506963, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1333, N'Piedmont Mountainside Hospital Inc', 1, NULL, NULL, N'110225', NULL, NULL, 0, 35, NULL, N'7063015269', N'7066920939', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1266 Highway 515 South', N'Jasper', N'GA', N'13227', N'30143', 34.446548, -84.445191, 974, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1334, N'Dekalb Medical Center At Hillandale', 1, NULL, NULL, N'110226', NULL, NULL, 0, 84, NULL, N'4045018040', N'4045018797', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Dekalb Medical Parkway', N'Lithonia', N'GA', N'13089', N'30058', 33.705488, -84.146927, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1335, N'Piedmont Newnan Hospital Inc', 1, NULL, NULL, N'110229', NULL, NULL, 0, 143, NULL, N'7704002300', N'7702538845', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'745 Poplar Road', N'Newnan', N'GA', N'13077', N'30265', 33.359375, -84.754178, 990, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1336, N'Emory Johns Creek Hospital', 1, NULL, NULL, N'110230', NULL, NULL, 0, 110, NULL, N'6784747000', N'6784747026', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6325 Hospital Parkway', N'Johns Creek', N'GA', N'13055', N'30097', 34.067466, -84.175187, 978, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1337, N'Southeastern Regional Medical Center', 1, NULL, NULL, N'110233', NULL, NULL, 0, 25, NULL, N'4048448334', N'7706033040', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Celebrate Life Parkway', N'Newnan', N'GA', N'13077', N'30265', 33.389774, -84.756084, 990, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1338, N'Sgmc Berrien Campus', 1, NULL, NULL, N'110234', NULL, NULL, 0, 63, NULL, N'2295437100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 E Mcpherson Avenue', N'Nashville', N'GA', N'13019', N'31639', 31.203849, -83.239122, 989, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1339, N'Landmark Hospital Of Savannah', 1, NULL, NULL, N'110235', NULL, NULL, 0, 50, NULL, N'5733318420', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E 68Th Street', N'Savannah', N'GA', N'13051', N'31405', 32.028446, -81.095346, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1340, N'Southwest Georgia Regional Medical Center', 1, NULL, NULL, N'111300', NULL, NULL, 0, 25, NULL, N'2297322181', N'2297326759', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'361 Randolph Street', N'Cuthbert', N'GA', N'13243', N'39840', 31.774807, -84.793312, 942, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1341, N'Bleckley Memorial Hospital', 1, NULL, NULL, N'111302', NULL, NULL, 0, 25, NULL, N'4789346211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 East Peacock Street', N'Cochran', N'GA', N'13023', N'31014', 32.384808, -83.345621, 935, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1342, N'Jasper Memorial Hospital', 1, NULL, NULL, N'111303', NULL, NULL, 0, 17, NULL, N'7064686411', N'7064689880', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'898 College Street', N'Monticello', N'GA', N'13159', N'31064', 33.313856, -83.686859, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1343, N'Morgan Memorial Hospital', 1, NULL, NULL, N'111304', NULL, NULL, 0, 25, NULL, N'7063421667', N'7063422345', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1077 South Main Street', N'Madison', N'GA', N'13211', N'30650', 33.583463, -83.477623, 917, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1344, N'Miller County Hospital', 1, NULL, NULL, N'111305', NULL, NULL, 0, 25, NULL, N'2297584231', N'2297586623', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 N Cuthbert Street', N'Colquitt', N'GA', N'13201', N'39837', 31.17439, -84.73457, 936, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1345, N'Effingham Hospital', 1, NULL, NULL, N'111306', NULL, NULL, 0, 25, NULL, N'9127540160', N'9127549901', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'459 Ga Highway 119 South', N'Springfield', N'GA', N'13103', N'31329', 32.362288, -81.32795, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1346, N'Clinch Memorial Hospital', 1, NULL, NULL, N'111308', NULL, NULL, 0, 25, NULL, N'9124875211', N'9124873769', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Valdosta Highway', N'Homerville', N'GA', N'13065', N'31634', 31.032647, -82.763854, 972, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1347, N'Medical Center Of Peach County The', 1, NULL, NULL, N'111310', NULL, NULL, 0, 25, NULL, N'4786542000', N'4786542001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1960 Highway 247 Connector', N'Byron', N'GA', N'13225', N'31008', 37.867148, -121.638007, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1348, N'Optim Medical Center - Jenkins', 1, NULL, NULL, N'111311', NULL, NULL, 0, 25, NULL, N'4784784221', N'4789822478', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'931 East Winthrope Avenue', N'Millen', N'GA', N'13165', N'30442', 32.803767, -81.935602, 985, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1349, N'Optim Medical Center - Screven', 1, NULL, NULL, N'111312', NULL, NULL, 0, 25, NULL, N'9125647426', N'9125640010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Mims Road', N'Sylvania', N'GA', N'13251', N'30467', 32.751182, -81.646962, 1009, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1350, N'Putnam General Hospital', 1, NULL, NULL, N'111313', NULL, NULL, 0, 25, NULL, N'7064852711', N'7069232139', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Lake Oconee Parkway', N'Eatonton', N'GA', N'13237', N'31024', 33.3268, -83.388496, 954, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1351, N'Pioneer Community Hospital Of Early', 1, NULL, NULL, N'111314', NULL, NULL, 0, 25, NULL, N'2297234241', N'2297232930', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11740 Columbia Street', N'Blakely', N'GA', N'13099', N'39823', 31.375387, -84.938032, 924, 2, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1352, N'Warm Springs Medical Center', 1, NULL, NULL, N'111316', NULL, NULL, 0, 25, NULL, N'7066559351', N'7066559233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5995 Spring Street', N'Warm Springs', N'GA', N'13199', N'31830', 32.890268, -84.68064, 976, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1353, N'Monroe County Hospital', 1, NULL, NULL, N'111318', NULL, NULL, 0, 25, NULL, N'4789942521', N'4789948798', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Martin Luther King Jr Drive', N'Forsyth', N'GA', N'13207', N'31029', 33.032879, -83.94647, 959, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1354, N'Sylvan Grove Hospital', 1, NULL, NULL, N'111319', NULL, NULL, 0, 25, NULL, N'7707757861', N'7707754478', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Mcdonough Road', N'Jackson', N'GA', N'13035', N'30233', 33.303932, -83.979153, 973, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1355, N'Higgins General Hospital', 1, NULL, NULL, N'111320', NULL, NULL, 0, 25, NULL, N'7708242210', N'7708242309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Allen Memorial Drive', N'Bremen', N'GA', N'13143', N'30110', 33.716504, -85.144251, 926, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1356, N'Optim Medical Center - Tattnall', 1, NULL, NULL, N'111323', NULL, NULL, 0, 25, NULL, N'9125571000', N'9125571009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'247 S Main Street', N'Reidsville', N'GA', N'13267', N'30453', 32.080191, -82.110503, 994, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1357, N'Chatuge Regional Hospital', 1, NULL, NULL, N'111324', NULL, NULL, 0, 25, NULL, N'7068962222', N'7068967872', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 East Main Street', N'Hiawassee', N'GA', N'13281', N'30546', 34.94661, -83.754898, 970, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1358, N'Wills Memorial Hospital', 1, NULL, NULL, N'111325', NULL, NULL, 0, 25, NULL, N'7066789212', N'7066781546', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 rdon Street', N'Washington', N'GA', N'13317', N'30673', 33.729478, -82.743457, 1020, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1359, N'Sgmc Lanier Campus', 1, NULL, NULL, N'111326', NULL, NULL, 0, 25, NULL, N'2294828402', N'2294828539', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 West Thigpen Avenue', N'Lakeland', N'GA', N'13173', N'31635', 31.041665, -83.087332, 977, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1360, N'Bacon County Hospital', 1, NULL, NULL, N'111327', NULL, NULL, 0, 25, NULL, N'9126328961', N'9126325000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 South Wayne Street', N'Alma', N'GA', N'13005', N'31510', 31.539158, -82.459678, 914, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1361, N'Phoebe Worth Medical Center', 1, NULL, NULL, N'111328', NULL, NULL, 0, 25, NULL, N'2297773851', N'2297760057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 South Isabella Street', N'Sylvester', N'GA', N'13321', N'31791', 31.517934, -83.838262, 913, 71, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1362, N'St Mary''s od Samaritan Hospital', 1, NULL, NULL, N'111329', NULL, NULL, 0, 25, NULL, N'7064537331', N'7064532812', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 Lake Oconee Parkway', N'Greensboro', N'GA', N'13133', N'30642', 33.480948, -83.240399, 964, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1363, N'Polk Medical Center', 1, NULL, NULL, N'111330', NULL, NULL, 0, 25, NULL, N'7707482500', N'7707498574', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2360 Rockmart Highway', N'Cedartown', N'GA', N'13233', N'30125', 34.015375, -85.196929, 997, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1364, N'Mitchell County Hospital', 1, NULL, NULL, N'111331', NULL, NULL, 0, 25, NULL, N'2293365284', N'2293364682', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Stephens Street', N'Camilla', N'GA', N'13205', N'31730', 31.229264, -84.206028, 913, 71, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1365, N'Brooks County Hospital', 1, NULL, NULL, N'111332', NULL, NULL, 0, 25, NULL, N'9122636309', N'2292636335', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'903 N Court St', N'Quitman', N'GA', N'13027', N'31643', 30.795012, -83.5595, 993, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1366, N'Jeff Davis Hospital', 1, NULL, NULL, N'111333', NULL, NULL, 0, 25, NULL, N'9123757781', N'9123754055', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 South Tallahassee Street P O Box 1690', N'Hazlehurst', N'GA', N'13161', N'31539', 31.858382, -82.606846, 969, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1367, N'Candler County Hospital', 1, NULL, NULL, N'111334', NULL, NULL, 0, 25, NULL, N'9126855741', N'9126853905', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Cedar Street', N'Metter', N'GA', N'13043', N'30439', 32.402518, -82.06464, 983, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1368, N'Liberty Regional Medical Center', 1, NULL, NULL, N'111335', NULL, NULL, 0, 25, NULL, N'9123699438', N'9128779438', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 E G Miles Parkway', N'Hinesville', N'GA', N'13179', N'31310', 31.84773, -81.596035, 971, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1369, N'Mountain Lakes Medical Center', 1, NULL, NULL, N'111336', NULL, NULL, 0, 25, NULL, N'7067820400', N'7067820451', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'196 Ridgecrest Circle', N'Clayton', N'GA', N'13241', N'30525', 34.883082, -83.415369, 934, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1370, N'Roosevelt Warm Springs Ltac Hospital', 1, NULL, NULL, N'112000', NULL, NULL, 0, 32, NULL, N'7066555515', N'7066555011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6135 Roosevelt Highway', N'Warm Springs', N'GA', N'13199', N'31830', 32.890408, -84.681038, 976, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1371, N'Shepherd Center', 1, NULL, NULL, N'112003', NULL, NULL, 0, 132, NULL, N'4043527311', N'4043507341', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2020 Peachtree Rd Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.809787, -84.393122, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1372, N'Kindred Hospital - Atlanta', 1, NULL, NULL, N'112004', NULL, NULL, 0, 72, NULL, N'4048732871', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 Juniper Street Ne', N'Atlanta', N'GA', N'13089', N'30308', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1373, N'Select Specialty Hospital - Northeast Atlanta', 1, NULL, NULL, N'112005', NULL, NULL, 0, 18, NULL, N'4047286200', N'4047286828', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1821 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30329', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1374, N'Dekalb Medical Center At Decatur', 1, NULL, NULL, N'112006', NULL, NULL, 0, 76, NULL, N'4043770221', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 North Candler Street', N'Decatur', N'GA', N'13089', N'30030', 33.776677, -84.292747, 946, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1375, N'Wellstar Windy Hill Hospital', 1, NULL, NULL, N'112007', NULL, NULL, 0, 115, NULL, N'7706441081', N'7706441082', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2540 Windy Hill Road', N'Marietta', N'GA', N'13067', N'30067', 33.952847, -84.549615, 981, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1376, N'Select Specialty Hospital - Atlanta', 1, NULL, NULL, N'112009', NULL, NULL, 0, 30, NULL, N'4046862270', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Peachtree Street Ne 7Th Floor', N'Atlanta', N'GA', N'13121', N'30308', 33.7695, -84.38527, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1377, N'Kindred Hospital Rome', 1, NULL, NULL, N'112010', NULL, NULL, 0, 45, NULL, N'7065094100', N'7065094150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Turner Mccall Boulevard', N'Rome', N'GA', N'13115', N'30165', 34.244931, -85.161225, 997, 76, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1378, N'Select Specialty Hospital - Savannah Inc', 1, NULL, NULL, N'112011', NULL, NULL, 0, 40, NULL, N'9128197986', N'9128195972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5353 Reynolds Street 4 South', N'Savannah', N'GA', N'13051', N'31405', 32.0279775, -81.1023963, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1379, N'Columbus Specialty Hospital Inc', 1, NULL, NULL, N'112012', NULL, NULL, 0, 30, NULL, N'7063216709', N'7063216616', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Center Street 9Th & 10Th Floors', N'Columbus', N'GA', N'13215', N'31901', 32.481335, -84.982995, 937, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1380, N'Select Specialty Hospital - Augusta Inc', 1, NULL, NULL, N'112013', NULL, NULL, 0, 30, NULL, N'7067311200', N'7067367087', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1537 Walton Way', N'Augusta', N'GA', N'13245', N'30904', 33.4762975, -81.9923894, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1381, N'Regency Hospital Of South Atlanta', 1, NULL, NULL, N'112014', NULL, NULL, 0, 40, NULL, N'4044666264', N'4044666267', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1170 Cleveland Ave 4Th Floor', N'East Point', N'GA', N'13121', N'30344', 33.665434, -84.486489, 952, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1382, N'Southern Crescent Hospital For Specialty Care', 1, NULL, NULL, N'112015', NULL, NULL, 0, 30, NULL, N'7708977600', N'7708977606', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Upper Riverdale Road Sw 6Th Floor', N'Riverdale', N'GA', N'13063', N'30274', 33.577268, -84.391814, 996, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1383, N'Regency Hospital Company Of Macon Llc', 1, NULL, NULL, N'112016', NULL, NULL, 0, 34, NULL, N'4788037300', N'4788037531', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 Coliseum Drive', N'Macon', N'GA', N'13021', N'31217', 32.8477075, -83.6175527, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1384, N'Landmark Hospital Of Athens Llc', 1, NULL, NULL, N'112017', NULL, NULL, 0, 42, NULL, N'7064251518', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 Sunset Drive', N'Athens', N'GA', N'13059', N'30606', 33.9663546, -83.4125785, 917, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1385, N'Landmark Hospital Of Savannah Llc', 1, NULL, NULL, N'112018', NULL, NULL, 0, 50, NULL, N'5733318420', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E 68Th Street', N'Savannah', N'GA', N'13051', N'31405', 32.0285725, -81.0970477, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1386, N'Roosevelt Warm Springs Rehabilitation Hospital', 1, NULL, NULL, N'113028', NULL, NULL, 0, 52, NULL, N'7066555515', N'7066555011', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6135 Roosevelt Highway', N'Warm Springs', N'GA', N'13199', N'31830', 32.890408, -84.681038, 976, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1387, N'Central Georgia Rehabilitation Hospital Llc', 1, NULL, NULL, N'113029', NULL, NULL, 0, 58, NULL, N'4784716500', N'4787570876', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3351 Northside Drive', N'Macon', N'GA', N'13021', N'31210', 32.893146, -83.6826827, 980, 75, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1388, N'Healthsouth Walton Rehabilitation Hospital', 1, NULL, NULL, N'113030', NULL, NULL, 0, 58, NULL, N'7067247746', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1355 Independence Drive', N'Augusta', N'GA', N'13245', N'30901', 33.474364, -81.979605, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1389, N'Emory Rehabilitation Hospital', 1, NULL, NULL, N'113031', NULL, NULL, 0, 56, NULL, N'4047125512', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 Clifton Road', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1390, N'Healthsouth Rehabilitation Hospital Of Newnan', 1, NULL, NULL, N'113032', NULL, NULL, 0, 50, NULL, N'6785526200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 East Newnan Crossing Blvd', N'Newnan', N'GA', N'13077', N'30265', 33.380672, -84.799657, 990, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1391, N'Savannah Rehabilitation Hospital', 1, NULL, NULL, N'113033', NULL, NULL, 0, 50, NULL, N'9123508000', N'9123503058', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Waters Avenue', N'Savannah', N'GA', N'13051', N'31404', 32.032254, -81.091565, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1392, N'Children''s Healthcare Of Atlanta At Egleston', 1, NULL, NULL, N'113300', NULL, NULL, 0, 249, NULL, N'4047856101', N'4047851922', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1393, N'Childrens Healthcare Of Atlanta At Scottish Rite', 1, NULL, NULL, N'113301', NULL, NULL, 0, 234, NULL, N'4047855252', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Johnson Ferry Rd', N'Atlanta', N'GA', N'13121', N'30342', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1394, N'Summitridge Center- Psychiatry & Addictive Med', 1, NULL, NULL, N'114004', NULL, NULL, 0, 76, NULL, N'6784425800', N'6783125909', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'250 Scenic Highway', N'Lawrenceville', N'GA', N'13135', N'30046', 33.943442, -83.989863, 978, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1395, N'Coastal Harbor Treatment Center', 1, NULL, NULL, N'114008', NULL, NULL, 0, 7, NULL, N'9123543911', N'9123551336', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1150 Cornell Ave', N'Savannah', N'GA', N'13051', N'31406', 32.011427, -81.097977, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1396, N'Peachford Behavioral Health System Of Atlanta', 1, NULL, NULL, N'114010', NULL, NULL, 0, 246, NULL, N'7704553200', N'7704542362', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2151 Peachford Road', N'Atlanta', N'GA', N'13089', N'30338', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1397, N'Ridgeview Institute', 1, NULL, NULL, N'114012', NULL, NULL, 0, 148, NULL, N'7704344567', N'7704317088', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3995 S Cobb Drive', N'Smyrna', N'GA', N'13067', N'30080', 33.900972, -84.541001, 1002, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1398, N'West Central Georgia Regional Hospital', 1, NULL, NULL, N'114013', NULL, NULL, 0, 300, NULL, N'7065685203', N'7065682257', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Schatulga Rd Box 12435', N'Columbus', N'GA', N'13215', N'31917', 32.48925, -84.869419, 937, 74, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1399, N'St Simons-By-The-Sea', 1, NULL, NULL, N'114016', NULL, NULL, 0, 101, NULL, N'9126381999', N'9126382112', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2927 Demere Road', N'Saint Simons Island', N'GA', N'13127', N'31522', 31.15051, -81.36954, 927, 59, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1400, N'Georgia Regional Hospital Atlanta', 1, NULL, NULL, N'114019', NULL, NULL, 0, 347, NULL, N'4042432100', N'4042124621', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3073 Panthersville Road', N'Decatur', N'GA', N'13089', N'30034', 33.773758, -84.296069, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1401, N'Georgia Regional Hosp Savannah', 1, NULL, NULL, N'114028', NULL, NULL, 0, 202, NULL, N'9123562045', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 Eisenhower Dr', N'Savannah', N'GA', N'13051', N'31416', 32.001985, -81.084339, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1402, N'East Central Regional Hospital', 1, NULL, NULL, N'114029', NULL, NULL, 0, 355, NULL, N'7067927066', N'7067902025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3405 Mike Padgett Hwy', N'Augusta', N'GA', N'13245', N'30906', 33.35229, -81.982264, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1403, N'So Crescent Beh Hlth Sys - Anchor Hospital Campus', 1, NULL, NULL, N'114032', NULL, NULL, 0, 122, NULL, N'7709916044', N'7709972757', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Yorktowne Drive', N'College Park', N'GA', N'13063', N'30349', 33.611475, -84.453712, 952, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1404, N'Riverwoods Behavioral Health System', 1, NULL, NULL, N'114035', NULL, NULL, 0, 45, NULL, N'7709918500', N'7709918507', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Medical Center Drive', N'Riverdale', N'GA', N'13063', N'30274', 33.572611, -84.413259, 996, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1405, N'Greenleaf Center', 1, NULL, NULL, N'114036', NULL, NULL, 0, 50, NULL, N'2292474357', N'2296716636', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2209 Pineview Drive', N'Valdosta', N'GA', N'13185', N'31602', 30.865464, -83.264606, 1015, 69, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1406, N'Emory University Hospital', 1, NULL, NULL, N'119800', NULL, NULL, 0, 0, NULL, N'4046868500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1364 Clifton Road Ne', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1407, N'Medical College Of Georgia- Transplant', 1, NULL, NULL, N'119801', NULL, NULL, 0, 0, NULL, N'7067214716', N'7067217877', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1120 Fifteenth St', N'Augusta', N'GA', N'13245', N'30912', 33.470971, -81.974843, 919, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1408, N'Children''s Healthcare Of Atlanta', 1, NULL, NULL, N'119802', NULL, NULL, 0, 0, NULL, N'4047856121', N'4047856747', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1405 Clifton Road Ne  6Th Floor Transplant Servi', N'Atlanta', N'GA', N'13089', N'30322', 33.749099, -84.390185, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1409, N'Piedmont Hospital', 1, NULL, NULL, N'119803', NULL, NULL, 0, 0, NULL, N'4046053775', N'4046096699', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1968 Peachtree Road Nw', N'Atlanta', N'GA', N'13121', N'30309', 33.808554, -84.393639, 918, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1410, N'The Queens Medical Center', 1, NULL, NULL, N'120001', NULL, NULL, 0, 505, NULL, N'8085389011', N'8085474018', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Punchbowl St', N'Honolulu', N'HI', N'15003', N'96813', 21.308063, -157.855051, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1411, N'Maui Memorial Medical Center', 1, NULL, NULL, N'120002', NULL, NULL, 0, 213, NULL, N'8084425101', N'8084425112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 Mahalani Street', N'Wailuku', N'HI', N'15009', N'96793', 20.884006, -156.488693, 1031, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1412, N'Wahiawa General Hospital', 1, NULL, NULL, N'120004', NULL, NULL, 0, 53, NULL, N'8086218411', N'8086214490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'128 Lehua Street', N'Wahiawa', N'HI', N'15003', N'96786', 21.498492, -158.02729, 1030, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1413, N'Hilo Medical Center', 1, NULL, NULL, N'120005', NULL, NULL, 0, 142, NULL, N'8089323000', N'8089744746', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1190 Waianuenue Avenue', N'Hilo', N'HI', N'15001', N'96720', 19.717493, -155.113286, 1024, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1414, N'Castle Medical Center', 1, NULL, NULL, N'120006', NULL, NULL, 0, 160, NULL, N'8082635500', N'8082635123', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Ulukahiki St', N'Kailua', N'HI', N'15003', N'96734', 21.381429, -157.757099, 1026, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1415, N'Kuakini Medical Center', 1, NULL, NULL, N'120007', NULL, NULL, 0, 212, NULL, N'8085362236', N'8085479547', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 North Kuakini Street', N'Honolulu', N'HI', N'15003', N'96817', 21.322405, -157.856394, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1416, N'Kaiser Foundation Hospital', 1, NULL, NULL, N'120011', NULL, NULL, 0, 250, NULL, N'8084320000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3288 Moanalua Rd', N'Honolulu', N'HI', N'15003', N'96819', 21.363277, -157.9011, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1417, N'Wilcox Memorial Hospital', 1, NULL, NULL, N'120014', NULL, NULL, 0, 71, NULL, N'8082451103', N'8082451171', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3-3420 Kuhio Highway', N'Lihue', N'HI', N'15007', N'96766', 21.986163, -159.366304, 1029, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1418, N'Kona Community Hospital', 1, NULL, NULL, N'120019', NULL, NULL, 0, 60, NULL, N'8083229311', N'8083224488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'79-1019 Haukapila Street', N'Kealakekua', N'HI', N'15001', N'96750', 19.520145, -155.918451, 1027, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1419, N'Straub Clinic And Hospital', 1, NULL, NULL, N'120022', NULL, NULL, 0, 159, NULL, N'8085224000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 So King Street', N'Honolulu', N'HI', N'15003', N'96813', 21.304547, -157.855676, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1420, N'Pali Momi Medical Center', 1, NULL, NULL, N'120026', NULL, NULL, 0, 116, NULL, N'8084866000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98-1079 Moanalua Road', N'Aiea', N'HI', N'15003', N'96701', 21.383687, -157.937544, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1421, N'North Hawaii Community Hospital', 1, NULL, NULL, N'120028', NULL, NULL, 0, 33, NULL, N'8088854444', N'8088814404', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67 1125 Mamalahoa Highway', N'Kamuela', N'HI', N'15001', N'96743', 20.023076, -155.665685, 1024, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1422, N'Kauai Veterans Memorial Hospital', 1, NULL, NULL, N'121300', NULL, NULL, 0, 25, NULL, N'8083389431', N'8083389420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4643 Waimea Canyon Drive', N'Waimea', N'HI', N'15007', N'96796', 21.960088, -159.670046, 1032, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1423, N'Kau Hospital', 1, NULL, NULL, N'121301', NULL, NULL, 0, 5, NULL, N'8089288331', N'8089288980', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Kamani Street', N'Pahala', N'HI', N'15001', N'96777', 19.199695, -155.471003, 1024, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1424, N'Kohala Hospital', 1, NULL, NULL, N'121302', NULL, NULL, 0, 4, NULL, N'8088896211', N'8088896978', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'54-383 Hospital Road', N'Kapaau', N'HI', N'15001', N'96755', 20.231128, -155.797777, 1028, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1425, N'Molokai General Hospital', 1, NULL, NULL, N'121303', NULL, NULL, 0, 13, NULL, N'8085535331', N'8085533133', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Home Olu Place', N'Kaunakakai', N'HI', N'15009', N'96748', 21.092818, -157.018662, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1426, N'Kahuku Medical Center', 1, NULL, NULL, N'121304', NULL, NULL, 0, 11, NULL, N'8082939221', N'8082932262', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56-117 Pualalea Street', N'Kahuku', N'HI', N'15003', N'96731', 21.676942, -157.952265, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1427, N'Lanai Community Hospital', 1, NULL, NULL, N'121305', NULL, NULL, 0, 4, NULL, N'8085658450', N'8085658474', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'628 7Th Street', N'Lanai City', N'HI', N'15009', N'96763', 20.825875, -156.920109, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1428, N'Samuel Mahelona Memorial Hospital', 1, NULL, NULL, N'121306', NULL, NULL, 0, 14, NULL, N'8088224961', N'8088234100', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Kawaihau Road', N'Kapaa', N'HI', N'15007', N'96746', 22.087604, -159.314147, 1029, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1429, N'Hale Ho''ola Hamakua', 1, NULL, NULL, N'121307', NULL, NULL, 0, 11, NULL, N'8089324100', N'8087759977', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45-547 Plumeria Street', N'Honokaa', N'HI', N'15001', N'96727', 20.078061, -155.468344, 1024, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1430, N'Kula Hospital', 1, NULL, NULL, N'121308', NULL, NULL, 0, 5, NULL, N'8088781221', N'8088781791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Kokea Place', N'Kula', N'HI', N'15009', N'96790', 20.701994, -156.357099, 1031, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1431, N'Leahi Hospital', 1, NULL, NULL, N'122001', NULL, NULL, 0, 9, NULL, N'8087338000', N'8087337914', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3675 Kilauea Avenue', N'Honolulu', N'HI', N'15003', N'96816', 21.273593, -157.801233, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1432, N'Rehabilitation Hospital Of The Pacific', 1, NULL, NULL, N'123025', NULL, NULL, 0, 100, NULL, N'8085313511', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'226 N Kuakini Street', N'Honolulu', N'HI', N'15003', N'96817', 21.321137, -157.855107, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1433, N'Kapiolani Medical Center For Women & Children', 1, NULL, NULL, N'123300', NULL, NULL, 0, 207, NULL, N'8089836000', N'8089838071', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1319 Punahou Street', N'Honolulu', N'HI', N'15003', N'96826', 21.300274, -157.83382, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1434, N'Shriners Hospital For Children', 1, NULL, NULL, N'123301', NULL, NULL, 0, 24, NULL, N'8089414466', N'8089428573', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Punahou Street', N'Honolulu', N'HI', N'15003', N'96826', 21.300816, -157.835512, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1435, N'Kahi Mohala', 1, NULL, NULL, N'124001', NULL, NULL, 0, 88, NULL, N'8086718511', N'8086772570', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91-2301 Fort Weaver Road', N'Ewa Beach', N'HI', N'15003', N'96706', 21.315544, -158.008177, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1436, N'The Queen''s Medical Center', 1, NULL, NULL, N'129801', NULL, NULL, 0, 0, NULL, N'8086917066', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1301 Punchbowl Street', N'Hon', N'HI', N'15003', N'96813', 21.216044, -157.975203, 1025, 78, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1437, N'St Luke''s Magic Valley Rmc', 1, NULL, NULL, N'130002', NULL, NULL, 0, 226, NULL, N'2088141000', N'2088140902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Pole Line Road West', N'Twin Falls', N'ID', N'16083', N'83301', 42.591808, -114.495624, 1061, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1438, N'St Joseph Regional Medical Center', 1, NULL, NULL, N'130003', NULL, NULL, 0, 145, NULL, N'2087995300', N'2087995528', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 Sixth Street', N'Lewiston', N'ID', N'16069', N'83501', 46.41649, -117.024956, 1044, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1439, N'St Luke''s Regional Medical Center', 1, NULL, NULL, N'130006', NULL, NULL, 0, 544, NULL, N'2083812222', N'2083812861', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 East Bannock Street', N'Boise', N'ID', N'16001', N'83712', 43.612115, -116.192165, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1440, N'St Alphonsus Regional Medical Center', 1, NULL, NULL, N'130007', NULL, NULL, 0, 365, NULL, N'2083672121', N'2083674299', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 North Curtis Road', N'Boise', N'ID', N'16001', N'83706', 43.614072, -116.253622, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1441, N'Saint Alphonsus Medical Center - Nampa', 1, NULL, NULL, N'130013', NULL, NULL, 0, 152, NULL, N'2084635000', N'2084635531', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1512 Twelfth Avenue Road', N'Nampa', N'ID', N'16027', N'83686', 43.573736, -116.559642, 1050, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1442, N'West Valley Medical Center', 1, NULL, NULL, N'130014', NULL, NULL, 0, 150, NULL, N'2084594641', N'2084553717', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 Arlington Street', N'Caldwell', N'ID', N'16027', N'83605', 43.654116, -116.695615, 1037, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1443, N'Eastern Idaho Regional Medical Center', 1, NULL, NULL, N'130018', NULL, NULL, 0, 330, NULL, N'2085296111', N'2085297021', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Channing Way', N'Idaho Falls', N'ID', N'16019', N'83404', 43.470382, -111.990169, 1042, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1444, N'Madison Memorial Hospital', 1, NULL, NULL, N'130025', NULL, NULL, 0, 49, NULL, N'2083596900', N'2083599879', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 East Main Street', N'Rexburg', N'ID', N'16065', N'83440', 43.831736, -111.775167, 1054, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1445, N'Portneuf Medical Center', 1, NULL, NULL, N'130028', NULL, NULL, 0, 187, NULL, N'2082391452', N'2082391958', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Hospital Way', N'Pocatello', N'ID', N'16005', N'83201', 42.873418, -112.41874, 1052, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1446, N'Kootenai Health', 1, NULL, NULL, N'130049', NULL, NULL, 0, 254, NULL, N'2086254000', N'2086254012', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2003 Kootenai Health Way', N'Coeur D''alene', N'ID', N'16055', N'83814', 47.694614, -116.792671, 1038, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1447, N'Treasure Valley Hospital', 1, NULL, NULL, N'130063', NULL, NULL, 0, 9, NULL, N'2083735000', N'2083735089', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8800 West Emerald Street', N'Boise', N'ID', N'16001', N'83704', 43.611259, -116.291414, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1448, N'Mountain View Hospital', 1, NULL, NULL, N'130065', NULL, NULL, 0, 43, NULL, N'2085572700', N'2085427052', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2325 Coronado Street', N'Idaho Falls', N'ID', N'16019', N'83404', 43.472521, -111.987748, 1042, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1449, N'Northwest Specialty Hospital', 1, NULL, NULL, N'130066', NULL, NULL, 0, 34, NULL, N'2082622300', N'2082622390', 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1593 East Polston Avenue', N'Post Falls', N'ID', N'16055', N'83854', 47.71441, -116.924455, 1038, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1450, N'Idaho Doctors Hospital', 1, NULL, NULL, N'130067', NULL, NULL, 0, 8, NULL, N'2087822900', N'2087822901', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 N Meridian Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.19573, -112.35613, 1033, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1451, N'Boundary Community Hospital', 1, NULL, NULL, N'131301', NULL, NULL, 0, 14, NULL, N'2082674850', N'2082672202', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6640 Kaniksu Street', N'Bonners Ferry', N'ID', N'16021', N'83805', 48.702606, -116.322283, 1035, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1452, N'North Canyon Medical Center', 1, NULL, NULL, N'131302', NULL, NULL, 0, 18, NULL, N'2089344433', N'2089349389', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'267 North Canyon Dr', N'oding', N'ID', N'16047', N'83330', 42.938792, -114.713108, 1061, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1453, N'Nell J Redfield Memorial Hospital', 1, NULL, NULL, N'131303', NULL, NULL, 0, 11, NULL, N'2087662231', N'2087664819', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 North 200 West', N'Malad', N'ID', N'16071', N'83252', 42.194859, -112.250624, 1045, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1454, N'Harms Memorial Hospital', 1, NULL, NULL, N'131304', NULL, NULL, 0, 10, NULL, N'2082263200', N'2082267411', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 Roosevelt Street', N'American Falls', N'ID', N'16077', N'83211', 42.781926, -112.848439, 1052, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1455, N'Steele Memorial Medical Center', 1, NULL, NULL, N'131305', NULL, NULL, 0, 18, NULL, N'2087565612', N'2087565656', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 South Daisy Street', N'Salmon', N'ID', N'16059', N'83467', 45.173205, -113.891001, 1056, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1456, N'Weiser Memorial Hospital', 1, NULL, NULL, N'131307', NULL, NULL, 0, 25, NULL, N'2085490370', N'2085494429', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'645 East 5Th Street', N'Weiser', N'ID', N'16087', N'83672', 44.248531, -116.96166, 1062, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1457, N'Cascade Medical Center', 1, NULL, NULL, N'131308', NULL, NULL, 0, 10, NULL, N'2083824242', N'2083825081', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 Lake Cascade Parkway', N'Cascade', N'ID', N'16085', N'83611', 44.516282, -116.041798, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1458, N'Caribou Memorial Hospital', 1, NULL, NULL, N'131309', NULL, NULL, 0, 25, NULL, N'2085473341', N'2085472790', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South 3Rd West', N'Soda Springs', N'ID', N'16029', N'83276', 42.654365, -111.604669, 1058, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1459, N'St Luke''s Jerome', 1, NULL, NULL, N'131310', NULL, NULL, 0, 25, NULL, N'2088149500', N'2083243878', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 North Lincoln Avenue', N'Jerome', N'ID', N'16053', N'83338', 42.730039, -114.518474, 1061, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1460, N'St Luke''s Elmore Medical Center', 1, NULL, NULL, N'131311', NULL, NULL, 0, 25, NULL, N'2085878401', N'2085878406', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'895 North 6Th East', N'Mountain Home', N'ID', N'16039', N'83647', 43.138087, -115.692488, 1049, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1461, N'St Luke''s Mccall', 1, NULL, NULL, N'131312', NULL, NULL, 0, 15, NULL, N'2086342221', N'2086347112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 State Street', N'Mc Call', N'ID', N'16085', N'83638', 44.909057, -116.109715, 1046, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1462, N'Teton Valley Hospital', 1, NULL, NULL, N'131313', NULL, NULL, 0, 13, NULL, N'2083542383', N'2083543158', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Howard Ave', N'Driggs', N'ID', N'16081', N'83422', 43.727337, -111.108181, 1040, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1463, N'Shoshone Medical Center', 1, NULL, NULL, N'131314', NULL, NULL, 0, 25, NULL, N'2087841221', N'2087838930', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Jacobs Gulch Road', N'Kellogg', N'ID', N'16079', N'83837', 47.556212, -116.126658, 1043, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1464, N'Syringa General Hospital', 1, NULL, NULL, N'131315', NULL, NULL, 0, 16, NULL, N'2089831700', N'2089838520', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 W Main Street', N'Grangeville', N'ID', N'16049', N'83530', 45.926791, -116.127519, 1041, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1465, N'Bear Lake Memorial Hospital', 1, NULL, NULL, N'131316', NULL, NULL, 0, 21, NULL, N'2088471630', N'2088472201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 South Fifth Street', N'Montpelier', N'ID', N'16007', N'83254', 42.31629, -111.300993, 1047, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1466, N'Benewah Community Hospital', 1, NULL, NULL, N'131317', NULL, NULL, 0, 19, NULL, N'2082457614', N'2082452262', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'229 South 7Th Street', N'St Maries', N'ID', N'16009', N'83861', 47.314716, -116.566682, 1059, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1467, N'Valor Health', 1, NULL, NULL, N'131318', NULL, NULL, 0, 16, NULL, N'2083653561', N'2083654176', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 East Locust Street', N'Emmett', N'ID', N'16045', N'83617', 43.879078, -116.485311, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1468, N'Minidoka Memorial Hospital', 1, NULL, NULL, N'131319', NULL, NULL, 0, 25, NULL, N'2084360481', N'2084366038', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1224 8Th Street', N'Rupert', N'ID', N'16067', N'83350', 42.619663, -113.686691, 1055, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1469, N'Clearwater Valley Hospital & Clinics', 1, NULL, NULL, N'131320', NULL, NULL, 0, 23, NULL, N'2084764555', N'2084765385', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Cedar Street', N'Orofino', N'ID', N'16035', N'83544', 46.486739, -116.259456, 1051, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1470, N'St Mary''s Hospital', 1, NULL, NULL, N'131321', NULL, NULL, 0, 23, NULL, N'2089623251', N'2089623722', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Lewiston St', N'Cottonwood', N'ID', N'16049', N'83522', 46.050324, -116.351596, 1039, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1471, N'Franklin County Medical Center', 1, NULL, NULL, N'131322', NULL, NULL, 0, 20, NULL, N'2088520137', N'2088523812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 North First East', N'Preston', N'ID', N'16041', N'83263', 42.097104, -111.874037, 1053, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1472, N'St Luke''s Wood River Medical Center', 1, NULL, NULL, N'131323', NULL, NULL, 0, 25, NULL, N'2087278800', N'2087278412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Ketchum', N'ID', N'16013', N'83340', 43.680741, -114.363662, 1060, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1473, N'Lost Rivers Hospital', 1, NULL, NULL, N'131324', NULL, NULL, 0, 14, NULL, N'2085278206', N'2085273105', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'551 Highland Drive', N'Arco', N'ID', N'16023', N'83213', 43.640374, -113.296527, 1042, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1474, N'Bingham Memorial Hospital', 1, NULL, NULL, N'131325', NULL, NULL, 0, 25, NULL, N'2087853804', N'2087853806', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98 Poplar Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.193178, -112.347434, 1033, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1475, N'Cassia Regional Medical Center', 1, NULL, NULL, N'131326', NULL, NULL, 0, 25, NULL, N'2086784444', N'2086776455', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Hiland Avenue', N'Burley', N'ID', N'16031', N'83318', 42.534179, -113.783419, 1036, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1476, N'Gritman Medical Center', 1, NULL, NULL, N'131327', NULL, NULL, 0, 25, NULL, N'2088824511', N'2088836571', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South Main Street', N'Moscow', N'ID', N'16057', N'83843', 46.727802, -117.001318, 1048, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1477, N'Bonner General Hospital', 1, NULL, NULL, N'131328', NULL, NULL, 0, 48, NULL, N'2082631441', N'2082651277', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 North Third Avenue', N'Sandpoint', N'ID', N'16017', N'83864', 48.277403, -116.550314, 1057, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1478, N'Northern Idaho Advanced Care Hospital', 1, NULL, NULL, N'132001', NULL, NULL, 0, 40, NULL, N'2082622800', N'2082622813', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Cecil Road', N'Post Falls', N'ID', N'16055', N'83854', 47.715147, -116.948065, 1038, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1479, N'Vibra Hospital Of Boise', 1, NULL, NULL, N'132002', NULL, NULL, 0, 60, NULL, N'2084899500', N'2084899599', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 South Bonito Way', N'Meridian', N'ID', N'16001', N'83642', 43.58739, -116.357653, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1480, N'Southwest Idaho Advanced Care Hospital', 1, NULL, NULL, N'132003', NULL, NULL, 0, 40, NULL, N'2086852400', N'2086852369', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6651 West Franklin Road', N'Boise', N'ID', N'16001', N'83709', 43.61656, -116.200835, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1481, N'Rehabilitation Hospital Of The Northwest', 1, NULL, NULL, N'133027', NULL, NULL, 0, 30, NULL, N'2082628700', N'2082628675', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3372 E Jenalan Ave', N'Post Falls', N'ID', N'16055', N'83854', 47.715147, -116.948065, 1038, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1482, N'Intermountain Hospital', 1, NULL, NULL, N'134002', NULL, NULL, 0, 155, NULL, N'2083778400', N'2083773520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 North Allumbaugh Street', N'Boise', N'ID', N'16001', N'83704', 43.60489, -116.266282, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1483, N'Safe Haven Hospital Of Treasure Valley', 1, NULL, NULL, N'134009', NULL, NULL, 0, 22, NULL, N'2083270504', N'2083270511', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 West Northview Street', N'Boise', N'ID', N'16001', N'83704', 43.61656, -116.200835, 1034, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1484, N'State Hospital South', 1, NULL, NULL, N'134010', NULL, NULL, 0, 120, NULL, N'2087851200', N'2087858409', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Alice Street', N'Blackfoot', N'ID', N'16011', N'83221', 43.188346, -112.338522, 1033, 80, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1485, N'Graham Hospital Association', 1, NULL, NULL, N'140001', NULL, NULL, 0, 144, NULL, N'3096475240', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 West Walnut Street', N'Canton', N'IL', N'17057', N'61520', 40.553254, -90.038125, 1076, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1486, N'Alton Memorial Hospital', 1, NULL, NULL, N'140002', NULL, NULL, 0, 222, NULL, N'6184637300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Memorial Drive', N'Alton', N'IL', N'17119', N'62002', 38.890604, -90.184276, 1064, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1487, N'Presence Saint Joseph Medical Center', 1, NULL, NULL, N'140007', NULL, NULL, 0, 443, NULL, N'8157257133', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Madison', N'Joliet', N'IL', N'17197', N'60435', 41.525031, -88.081725, 1123, 87, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1488, N'Loyola ttlieb Memorial Hospital', 1, NULL, NULL, N'140008', NULL, NULL, 0, 274, NULL, N'7084504924', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 West North Ave', N'Melrose Park', N'IL', N'17031', N'60160', 41.908319, -87.842473, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1489, N'Evanston Hospital', 1, NULL, NULL, N'140010', NULL, NULL, 0, 466, NULL, N'8474328000', NULL, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2650 Ridge Ave', N'Evanston', N'IL', N'17031', N'60201', 42.065977, -87.683168, 1098, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1490, N'Herrin Hospital', 1, NULL, NULL, N'140011', NULL, NULL, 0, 104, NULL, N'6189422171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 S 14Th St', N'Herrin', N'IL', N'17199', N'62948', 37.802854, -89.026494, 1113, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1491, N'Katherine Shaw Bethea Hospital', 1, NULL, NULL, N'140012', NULL, NULL, 0, 80, NULL, N'8152885531', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 E 1St St', N'Dixon', N'IL', N'17103', N'61021', 41.843953, -89.4792, 1090, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1492, N'Proctor Hospital', 1, NULL, NULL, N'140013', NULL, NULL, 0, 305, NULL, N'3096911000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5409 N Knoxville Ave', N'Peoria', N'IL', N'17143', N'61614', 40.752502, -89.593254, 1158, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1493, N'Blessing Hospital', 1, NULL, NULL, N'140015', NULL, NULL, 0, 312, NULL, N'2172235811', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Broadway At 11Th Street', N'Quincy', N'IL', N'17001', N'62301', 39.935624, -91.39833, 1164, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1494, N'Mt Sinai Hospital Medical Center', 1, NULL, NULL, N'140018', NULL, NULL, 0, 431, NULL, N'7732576751', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15Th Street At California', N'Chica', N'IL', N'17031', N'60608', 41.86016, -87.695723, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1495, N'Shelby Memorial Hospital', 1, NULL, NULL, N'140019', NULL, NULL, 0, 30, NULL, N'2177743961', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Cedar St', N'Shelbyville', N'IL', N'17173', N'62565', 39.405801, -88.807113, 1174, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1496, N'St Marys Hospital', 1, NULL, NULL, N'140026', NULL, NULL, 0, 251, NULL, N'8156732311', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111  Spring Street', N'Streator', N'IL', N'17099', N'61364', 41.114308, -88.835332, 1182, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1497, N'Copley Memorial Hospital', 1, NULL, NULL, N'140029', NULL, NULL, 0, 210, NULL, N'6309786200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Ogden Avenue', N'Aurora', N'IL', N'17089', N'60504', 41.726285, -88.270542, 1067, 81, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1498, N'Sherman Hospital', 1, NULL, NULL, N'140030', NULL, NULL, 0, 255, NULL, N'8477429800', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 North Randall Road', N'Elgin', N'IL', N'17089', N'60123', 42.070221, -88.331468, 1095, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1499, N'St Anthonys Memorial Hospital', 1, NULL, NULL, N'140032', NULL, NULL, 0, 146, NULL, N'2173422121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 N Maple Street', N'Effingham', N'IL', N'17049', N'62401', 39.125791, -88.549252, 1093, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1500, N'Vista Medical Center West', 1, NULL, NULL, N'140033', NULL, NULL, 0, 386, NULL, N'8472493900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2615 Washington St', N'Waukegan', N'IL', N'17097', N'60085', 42.359289, -87.868064, 1187, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1501, N'Ssm Health St Mary''s Hospital -Centralia', 1, NULL, NULL, N'140034', NULL, NULL, 0, 125, NULL, N'6184366519', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Pleasant Avenue', N'Centralia', N'IL', N'17121', N'62801', 38.530815, -89.115999, 1082, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1502, N'Galesburg Cottage Hospital', 1, NULL, NULL, N'140040', NULL, NULL, 0, 140, NULL, N'3093454555', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'695 N Kellogg St', N'Galesburg', N'IL', N'17095', N'61401', 40.95562, -90.366201, 1102, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1503, N'Cgh Medical Center', 1, NULL, NULL, N'140043', NULL, NULL, 0, 99, NULL, N'8156250400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East Lefevre Road', N'Sterling', N'IL', N'17195', N'61081', 41.801549, -89.697127, 1181, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1504, N'od Samaritan Regional Hlth Center', 1, NULL, NULL, N'140046', NULL, NULL, 0, 175, NULL, N'6188991469', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 od Samaritan Way', N'Mount Vernon', N'IL', N'17081', N'62864', 38.3149, -88.93, 1145, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1505, N'Advocate Trinity Hospital', 1, NULL, NULL, N'140048', NULL, NULL, 0, 263, NULL, N'7739672000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2320 E 93Rd St', N'Chica', N'IL', N'17031', N'60617', 41.726212, -87.567158, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1506, N'West Suburban Medical Center', 1, NULL, NULL, N'140049', NULL, NULL, 0, 287, NULL, N'7083836200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 Erie Court', N'Oak Park', N'IL', N'17031', N'60302', 41.89189, -87.775004, 1150, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1507, N'Osf Saint Anthony''s Health Center', 1, NULL, NULL, N'140052', NULL, NULL, 0, 296, NULL, N'6184652571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'St Anthony''s Way', N'Alton', N'IL', N'17119', N'62002', 38.908402, -90.172306, 1064, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1508, N'St Johns Hospital', 1, NULL, NULL, N'140053', NULL, NULL, 0, 731, NULL, N'2175446464', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Carpenter St', N'Springfield', N'IL', N'17167', N'62769', 39.807289, -89.644833, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1509, N'Macneal  Hospital', 1, NULL, NULL, N'140054', NULL, NULL, 0, 427, NULL, N'7087839100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3249 South Oak Park Avenue', N'Berwyn', N'IL', N'17031', N'60402', 41.832573, -87.792808, 1072, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1510, N'Passavant Area Hospital', 1, NULL, NULL, N'140058', NULL, NULL, 0, 93, NULL, N'2172459551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 W Walnut St', N'Jacksonville', N'IL', N'17137', N'62650', 39.745267, -90.259713, 1121, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1511, N'Jersey Community Hospital', 1, NULL, NULL, N'140059', NULL, NULL, 0, 67, NULL, N'6184986402', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Maple Summit Road', N'Jerseyville', N'IL', N'17083', N'62052', 39.110375, -90.341608, 1122, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1512, N'Palos Community Hospital', 1, NULL, NULL, N'140062', NULL, NULL, 0, 436, NULL, N'7089234000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12251 South 80Th Avenue', N'Palos Heights', N'IL', N'17031', N'60463', 41.668955, -87.815976, 1153, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1513, N'Rush Oak Park Hospital', 1, NULL, NULL, N'140063', NULL, NULL, 0, 296, NULL, N'7083839300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 S Maple Ave', N'Oak Park', N'IL', N'17031', N'60304', 41.877944, -87.803774, 1150, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1514, N'St Mary Medical Center', 1, NULL, NULL, N'140064', NULL, NULL, 0, 166, NULL, N'3093443161', NULL, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 North Seminary', N'Galesburg', N'IL', N'17095', N'61401', 40.986921, -90.363612, 1102, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1515, N'Adventist La Grange Memorial Hospital', 1, NULL, NULL, N'140065', NULL, NULL, 0, 223, NULL, N'7083521200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5101 S Willow Springs Rd', N'La Grange', N'IL', N'17031', N'60525', 41.798148, -87.888434, 1126, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1516, N'Saint Francis Medical Center', 1, NULL, NULL, N'140067', NULL, NULL, 0, 730, NULL, N'3096552000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Ne Glen Oak Ave', N'Peoria', N'IL', N'17143', N'61637', 40.702627, -89.590243, 1158, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1517, N'Roseland Community Hospital', 1, NULL, NULL, N'140068', NULL, NULL, 0, 162, NULL, N'7739953000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 W 111Th Street', N'Chica', N'IL', N'17031', N'60628', 41.692554, -87.625565, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1518, N'Touchette Regional Hospital Inc', 1, NULL, NULL, N'140077', NULL, NULL, 0, 109, NULL, N'6183323060', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Bond Avenue', N'Centreville', N'IL', N'17163', N'62207', 38.570821, -90.107089, 1069, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1519, N'Presence Saint Francis Hospital', 1, NULL, NULL, N'140080', NULL, NULL, 0, 427, NULL, N'8473164000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Ridge Ave', N'Evanston', N'IL', N'17031', N'60202', 42.023956, -87.685159, 1098, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1520, N'Louis A Weiss Memorial Hospital', 1, NULL, NULL, N'140082', NULL, NULL, 0, 236, NULL, N'7738788700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4646 N Marine Drive', N'Chica', N'IL', N'17031', N'60640', 41.967341, -87.649151, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1521, N'Loretto Hospital', 1, NULL, NULL, N'140083', NULL, NULL, 0, 176, NULL, N'7736264300', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'645 South Central Ave', N'Chica', N'IL', N'17031', N'60644', 41.872369, -87.764457, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1522, N'Vista Medical Center East', 1, NULL, NULL, N'140084', NULL, NULL, 0, 388, NULL, N'8473604000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 North Sheridan Road', N'Waukegan', N'IL', N'17097', N'60085', 42.378921, -87.831153, 1187, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1523, N'The University Of Chica Medical Center', 1, NULL, NULL, N'140088', NULL, NULL, 0, 633, NULL, N'7737021000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5841 South Maryland', N'Chica', N'IL', N'17031', N'60637', 41.788695, -87.604885, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1524, N'Mc Donough District Hospital', 1, NULL, NULL, N'140089', NULL, NULL, 0, 144, NULL, N'3098334101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East Grant Street', N'Macomb', N'IL', N'17109', N'61455', 40.447909, -90.664619, 1132, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1525, N'The Carle Foundation Hospital', 1, NULL, NULL, N'140091', NULL, NULL, 0, 316, NULL, N'2173833311', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 West Park Street', N'Urbana', N'IL', N'17019', N'61801', 40.117406, -88.215917, 1184, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1526, N'Presence United Samaritans Medical Center', 1, NULL, NULL, N'140093', NULL, NULL, 0, 210, NULL, N'2174435000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'812 N Logan', N'Danville', N'IL', N'17183', N'61832', 40.137356, -87.644912, 1087, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1527, N'Saint Anthony Hospital', 1, NULL, NULL, N'140095', NULL, NULL, 0, 176, NULL, N'7735211710', N'7734844174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2875 West 19Th Street', N'Chica', N'IL', N'17031', N'60623', 41.855536, -87.698443, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1528, N'Midwestern Region Med Center', 1, NULL, NULL, N'140100', NULL, NULL, 0, 95, NULL, N'8478724561', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Elisha Avenue', N'Zion', N'IL', N'17097', N'60099', 42.44897, -87.82684, 1187, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1529, N'Morris Hospital & Healthcare Centers', 1, NULL, NULL, N'140101', NULL, NULL, 0, 82, NULL, N'8159422932', N'8159411621', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 W High St', N'Morris', N'IL', N'17063', N'60450', 41.368907, -88.426016, 1143, 87, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1530, N'St Bernard Hospital', 1, NULL, NULL, N'140103', NULL, NULL, 0, 210, NULL, N'7739623900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 W 64Th St', N'Chica', N'IL', N'17031', N'60621', 41.778111, -87.633481, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1531, N'Ottawa Regional Hospital & Healthcare Center', 1, NULL, NULL, N'140110', NULL, NULL, 0, 50, NULL, N'8154333100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East Norris Drive', N'Ottawa', N'IL', N'17099', N'61350', 41.356301, -88.825399, 1152, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1532, N'Presence Covenant Medical Center', 1, NULL, NULL, N'140113', NULL, NULL, 0, 268, NULL, N'2173372000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 West Park Avenue', N'Urbana', N'IL', N'17019', N'61801', 40.117391, -88.227123, 1184, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1533, N'Swedish Covenant Hospital', 1, NULL, NULL, N'140114', NULL, NULL, 0, 284, NULL, N'7738788200', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5145 N California Ave', N'Chica', N'IL', N'17031', N'60625', 41.975405, -87.698925, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1534, N'Thorek Memorial Hospital', 1, NULL, NULL, N'140115', NULL, NULL, 0, 218, NULL, N'3125256780', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 W Irving Park Rd', N'Chica', N'IL', N'17031', N'60613', 41.954559, -87.650893, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1535, N'Centegra Health System - Mc Henry Hospital', 1, NULL, NULL, N'140116', NULL, NULL, 0, 177, NULL, N'8153445000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Medical Center Drive', N'Mchenry', N'IL', N'17111', N'60050', 42.318888, -88.281076, 1136, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1536, N'Presence Resurrection Medical Center', 1, NULL, NULL, N'140117', NULL, NULL, 0, 443, NULL, N'7737748000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7435 W Talcott Avenue', N'Chica', N'IL', N'17031', N'60631', 41.988768, -87.813175, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1537, N'Metrosouth Medical Center', 1, NULL, NULL, N'140118', NULL, NULL, 0, 309, NULL, N'7085972000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12935 S Grery', N'Blue Island', N'IL', N'17031', N'60406', 41.655308, -87.67759, 1074, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1538, N'Rush University Medical Center', 1, NULL, NULL, N'140119', NULL, NULL, 0, 53, NULL, N'3129425000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1653 West Congress Parkway', N'Chica', N'IL', N'17031', N'60612', 41.875158, -87.669133, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1539, N'Pekin Memorial Hospital', 1, NULL, NULL, N'140120', NULL, NULL, 0, 132, NULL, N'3093471151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South 13Th Street', N'Pekin', N'IL', N'17179', N'61554', 40.563795, -89.63321, 1157, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1540, N'Adventist Hinsdale Hospital', 1, NULL, NULL, N'140122', NULL, NULL, 0, 338, NULL, N'6308569000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 North Oak St', N'Hinsdale', N'IL', N'17043', N'60521', 41.805269, -87.920059, 1117, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1541, N'John H Stroger Jr Hospital', 1, NULL, NULL, N'140124', NULL, NULL, 0, 918, NULL, N'3128646000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 W Harrison St', N'Chica', N'IL', N'17031', N'60612', 41.874041, -87.674308, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1542, N'Gateway Regional Medical Center', 1, NULL, NULL, N'140125', NULL, NULL, 0, 406, NULL, N'6187983175', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Madison Avenue', N'Granite City', N'IL', N'17119', N'62040', 38.700891, -90.144958, 1106, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1543, N'Advocate Bromenn Medical Center', 1, NULL, NULL, N'140127', NULL, NULL, 0, 176, NULL, N'3094541400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1304 Franklin Avenue', N'Normal', N'IL', N'17113', N'61761', 40.496219, -88.990878, 1073, 93, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1544, N'Northwestern Lake Forest Hospital', 1, NULL, NULL, N'140130', NULL, NULL, 0, 222, NULL, N'8472345600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'660 N Westmoreland Road', N'Lake Forest', N'IL', N'17097', N'60045', 42.252748, -87.862974, 1127, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1545, N'Holy Cross Hospital', 1, NULL, NULL, N'140133', NULL, NULL, 0, 311, NULL, N'7734718000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 W 68Th Street', N'Chica', N'IL', N'17031', N'60629', 41.770029, -87.691238, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1546, N'Decatur Memorial Hospital', 1, NULL, NULL, N'140135', NULL, NULL, 0, 372, NULL, N'2178778121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 North Edward Street', N'Decatur', N'IL', N'17115', N'62526', 39.866404, -88.960911, 1089, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1547, N'Greenville Regional Hospital', 1, NULL, NULL, N'140137', NULL, NULL, 0, 60, NULL, N'6186641230', N'6186649707', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Healthcare Dr', N'Greenville', N'IL', N'17005', N'62246', 38.901655, -89.408701, 1107, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1548, N'St Margarets Hospital', 1, NULL, NULL, N'140143', NULL, NULL, 0, 90, NULL, N'8156641176', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E 1St St', N'Spring Valley', N'IL', N'17011', N'61362', 41.328409, -89.192611, 1178, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1549, N'St Josephs Hospital', 1, NULL, NULL, N'140145', NULL, NULL, 0, 96, NULL, N'6185264511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9515 Holy Cross Ln', N'Breese', N'IL', N'17027', N'62230', 38.625106, -89.523299, 1075, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1550, N'Richland Memorial Hospital', 1, NULL, NULL, N'140147', NULL, NULL, 0, 151, NULL, N'6183952131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Locust', N'Olney', N'IL', N'17159', N'62450', 38.735021, -88.077125, 1151, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1551, N'Memorial Medical Center', 1, NULL, NULL, N'140148', NULL, NULL, 0, 562, NULL, N'2177883000', N'2177885591', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 N First St', N'Springfield', N'IL', N'17167', N'62781', 39.80859, -89.654587, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1552, N'University Of Illinois Hospital', 1, NULL, NULL, N'140150', NULL, NULL, 0, 507, NULL, N'3129963900', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 West Taylor St Suite 1400', N'Chica', N'IL', N'17031', N'60612', 41.869222, -87.670687, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1553, N'Presence St Marys Hospital', 1, NULL, NULL, N'140155', NULL, NULL, 0, 170, NULL, N'8159372490', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Court St', N'Kankakee', N'IL', N'17091', N'60901', 41.121136, -87.871754, 1124, 87, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1554, N'Mercy Hospital And Medical Center', 1, NULL, NULL, N'140158', NULL, NULL, 0, 494, NULL, N'3125672000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 S Michigan Ave', N'Chica', N'IL', N'17031', N'60616', 41.847039, -87.623581, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1555, N'Fhn Memorial Hospital', 1, NULL, NULL, N'140160', NULL, NULL, 0, 203, NULL, N'8152354131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1045 West Stephenson Street', N'Freeport', N'IL', N'17177', N'61032', 42.295895, -89.637941, 1101, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1556, N'Saint James Hospital', 1, NULL, NULL, N'140161', NULL, NULL, 0, 81, NULL, N'8158422828', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 West Reynolds Street', N'Pontiac', N'IL', N'17105', N'61764', 40.873395, -88.679588, 1162, 93, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1557, N'St Joseph Medical Center', 1, NULL, NULL, N'140162', NULL, NULL, 0, 180, NULL, N'3096623311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 E Washington', N'Bloomington', N'IL', N'17113', N'61701', 40.480079, -88.957126, 1073, 93, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1558, N'Memorial Hospital Of Carbondale', 1, NULL, NULL, N'140164', NULL, NULL, 0, 140, NULL, N'6185490721', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 W Jackson', N'Carbondale', N'IL', N'17077', N'62902', 37.727995, -89.219832, 1077, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1559, N'St Marys Hospital', 1, NULL, NULL, N'140166', NULL, NULL, 0, 355, NULL, N'2174647000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 E Lake Shore Dr', N'Decatur', N'IL', N'17115', N'62521', 39.82635, -88.93191, 1089, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1560, N'Iroquois Memorial Hospital', 1, NULL, NULL, N'140167', NULL, NULL, 0, 94, NULL, N'8154325201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Fairman Street', N'Watseka', N'IL', N'17075', N'60970', 40.765541, -87.732666, 1186, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1561, N'Franciscan St James Health', 1, NULL, NULL, N'140172', NULL, NULL, 0, 200, NULL, N'7087474000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20201 S Crawford Avenue', N'Olympia Fields', N'IL', N'17031', N'60461', 41.522582, -87.713245, 1085, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1562, N'Presence Mercy Medical Center', 1, NULL, NULL, N'140174', NULL, NULL, 0, 315, NULL, N'6308592222', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 N Highland Avenue', N'Aurora', N'IL', N'17089', N'60506', 41.785632, -88.328889, 1067, 81, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1563, N'Centegra Health System - Woodstock Hospital', 1, NULL, NULL, N'140176', NULL, NULL, 0, 190, NULL, N'8157885823', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3701 Doty Road', N'Woodstock', N'IL', N'17111', N'60098', 42.275992, -88.398941, 1190, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1564, N'Jackson Park Hospital', 1, NULL, NULL, N'140177', NULL, NULL, 0, 336, NULL, N'7739477500', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7531 S Stony Island Ave', N'Chica', N'IL', N'17031', N'60649', 41.757792, -87.58573, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1565, N'Little Company Of Mary Hospital', 1, NULL, NULL, N'140179', NULL, NULL, 0, 298, NULL, N'7084226200', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 W 95Th St', N'Evergreen Park', N'IL', N'17031', N'60805', 41.720902, -87.691966, 1149, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1566, N'Presence Saints Mary And Elizabeth Medical Center', 1, NULL, NULL, N'140180', NULL, NULL, 0, 493, NULL, N'3127702000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2233 W Division St', N'Chica', N'IL', N'17031', N'60622', 41.903092, -87.684105, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1567, N'South Shore Hospital', 1, NULL, NULL, N'140181', NULL, NULL, 0, 125, NULL, N'7737680810', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8012 South Crandon Avenue', N'Chica', N'IL', N'17031', N'60617', 41.749496, -87.568623, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1568, N'Advocate Illinois Masonic Medical Center', 1, NULL, NULL, N'140182', NULL, NULL, 0, 997, NULL, N'7739751600', NULL, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'836 West Wellington Avenue', N'Chica', N'IL', N'17031', N'60657', 41.936304, -87.652156, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1569, N'Heartland Regional Medical Center', 1, NULL, NULL, N'140184', NULL, NULL, 0, 92, NULL, N'6189987000', N'6189976589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 W De Young', N'Marion', N'IL', N'17199', N'62959', 37.744876, -88.983744, 1133, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1570, N'Memorial Hospital', 1, NULL, NULL, N'140185', NULL, NULL, 0, 341, NULL, N'6182337750', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Memorial Drive', N'Belleville', N'IL', N'17163', N'62226', 38.548911, -90.020792, 1069, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1571, N'Riverside Medical Center', 1, NULL, NULL, N'140186', NULL, NULL, 0, 341, NULL, N'8159331671', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 N Wall St', N'Kankakee', N'IL', N'17091', N'60901', 41.122802, -87.881916, 1124, 87, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1572, N'St Elizabeth Hospital', 1, NULL, NULL, N'140187', NULL, NULL, 0, 260, NULL, N'6182342120', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 S Third St', N'Belleville', N'IL', N'17163', N'62220', 38.510748, -89.988247, 1069, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1573, N'Sarah Bush Lincoln Health Center', 1, NULL, NULL, N'140189', NULL, NULL, 0, 203, NULL, N'2172582572', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Health Center Drive P O Box 372', N'Mattoon', N'IL', N'17029', N'61938', 39.484476, -88.27581, 1135, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1574, N'Ingalls Memorial Hospital', 1, NULL, NULL, N'140191', NULL, NULL, 0, 582, NULL, N'7083332300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Ingalls Drive', N'Harvey', N'IL', N'17031', N'60426', 41.610034, -87.646713, 1110, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1575, N'Methodist Hospital Of Chica', 1, NULL, NULL, N'140197', NULL, NULL, 0, 245, NULL, N'7732719040', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5025 N Paulina Street', N'Chica', N'IL', N'17031', N'60640', 41.972925, -87.671144, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1576, N'Elmhurst Memorial Hospital', 1, NULL, NULL, N'140200', NULL, NULL, 0, 247, NULL, N'6308331400', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 East Brush Hill Road', N'Elmhurst', N'IL', N'17043', N'60126', 41.861652, -87.935298, 1097, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1577, N'Advocate Condell Medical Center', 1, NULL, NULL, N'140202', NULL, NULL, 0, 284, NULL, N'8479905200', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 S Milwaukee Ave', N'Libertyville', N'IL', N'17097', N'60048', 42.274602, -87.951664, 1129, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1578, N'Norwegian-American Hospital', 1, NULL, NULL, N'140206', NULL, NULL, 0, 270, NULL, N'7732928200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 N Francisco Ave', N'Chica', N'IL', N'17031', N'60622', 41.900472, -87.699288, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1579, N'Advocate Christ Hospital & Medical Center', 1, NULL, NULL, N'140208', NULL, NULL, 0, 695, NULL, N'7086848000', N'7086845012', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4440 W 95Th Street', N'Oak Lawn', N'IL', N'17031', N'60453', 41.720308, -87.732862, 1149, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1580, N'Methodist Medical Center Of Illinois', 1, NULL, NULL, N'140209', NULL, NULL, 0, 485, NULL, N'3096725522', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 N E Glen Oak Ave', N'Peoria', N'IL', N'17143', N'61636', 40.700183, -89.594596, 1158, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1581, N'Harrisburg Medical Center', 1, NULL, NULL, N'140210', NULL, NULL, 0, 78, NULL, N'6182537671', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Doctor Warren Tuttle Dr', N'Harrisburg', N'IL', N'17165', N'62946', 37.7385, -88.540521, 1108, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1582, N'Delnor Community Hospital', 1, NULL, NULL, N'140211', NULL, NULL, 0, 118, NULL, N'6302083000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Randall Rd', N'Geneva', N'IL', N'17089', N'60134', 41.888685, -88.340443, 1192, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1583, N'Silver Cross Hospital  And Medical Centers', 1, NULL, NULL, N'140213', NULL, NULL, 0, 304, NULL, N'8153001100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Silver Cross Blvd', N'New Lenox', N'IL', N'17197', N'60451', 41.542972, -87.985974, 1123, 87, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1584, N'Presence Saint Joseph Hospital - Elgin', 1, NULL, NULL, N'140217', NULL, NULL, 0, 277, NULL, N'8476953200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'77 N Airlite Street', N'Elgin', N'IL', N'17089', N'60123', 42.036899, -88.327671, 1095, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1585, N'Advocate Lutheran General Hospital', 1, NULL, NULL, N'140223', NULL, NULL, 0, 608, NULL, N'8477232210', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1775 Dempster St', N'Park Ridge', N'IL', N'17031', N'60068', 42.039606, -87.850922, 1156, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1586, N'Presence Saint Joseph Hospital - Chica', 1, NULL, NULL, N'140224', NULL, NULL, 0, 402, NULL, N'7736653000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 North Lake Shore Drive', N'Chica', N'IL', N'17031', N'60657', 41.934395, -87.636633, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1587, N'Swedish American Hospital', 1, NULL, NULL, N'140228', NULL, NULL, 0, 397, NULL, N'8159684400', NULL, 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 East State Street', N'Rockford', N'IL', N'17201', N'61104', 42.26694, -89.074288, 1169, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1588, N'Edward Hospital', 1, NULL, NULL, N'140231', NULL, NULL, 0, 159, NULL, N'6305273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Washington', N'Naperville', N'IL', N'17043', N'60540', 41.760787, -88.14896, 1147, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1589, N'Saint Anthony Medical Center', 1, NULL, NULL, N'140233', NULL, NULL, 0, 254, NULL, N'8152262000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5666 East State Street', N'Rockford', N'IL', N'17201', N'61108', 42.265789, -89.007246, 1169, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1590, N'Illinois Valley Community Hospital', 1, NULL, NULL, N'140234', NULL, NULL, 0, 65, NULL, N'8152233300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'925 West St', N'Peru', N'IL', N'17099', N'61354', 41.328761, -89.125181, 1159, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1591, N'Rockford Memorial Hospital', 1, NULL, NULL, N'140239', NULL, NULL, 0, 431, NULL, N'8159686861', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 North Rockton Avenue', N'Rockford', N'IL', N'17201', N'61103', 42.298434, -89.096782, 1169, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1592, N'Westlake Community Hospital', 1, NULL, NULL, N'140240', NULL, NULL, 0, 282, NULL, N'7089384000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Lake St', N'Melrose Park', N'IL', N'17031', N'60160', 41.891417, -87.847177, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1593, N'Central Dupage Hospital', 1, NULL, NULL, N'140242', NULL, NULL, 0, 361, NULL, N'6306821600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 North Winfield Road', N'Winfield', N'IL', N'17043', N'60190', 41.873765, -88.158095, 1189, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1594, N'Advocate South Suburban Hospital', 1, NULL, NULL, N'140250', NULL, NULL, 0, 286, NULL, N'7087998000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17800 S Kedzie Ave', N'Hazel Crest', N'IL', N'17031', N'60429', 41.566923, -87.694411, 1112, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1595, N'Community First Medical Center', 1, NULL, NULL, N'140251', NULL, NULL, 0, 299, NULL, N'7732827000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5645 W Addison Street', N'Chica', N'IL', N'17031', N'60634', 41.945874, -87.768146, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1596, N'Northwest Community Hospital 1', 1, NULL, NULL, N'140252', NULL, NULL, 0, 563, NULL, N'8476181000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Central Road', N'Arlington Heights', N'IL', N'17031', N'60005', 42.0666, -87.992216, 1066, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1597, N'Alexian Brothers Medical Center 1', 1, NULL, NULL, N'140258', NULL, NULL, 0, 483, NULL, N'8474375500', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Biesterfield Rd', N'Elk Grove Village', N'IL', N'17031', N'60007', 42.004124, -87.970646, 1096, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1598, N'Genesis Health System', 1, NULL, NULL, N'140275', NULL, NULL, 0, 149, NULL, N'3097929363', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Illini Drive', N'Silvis', N'IL', N'17161', N'61282', 41.493063, -90.418426, 1175, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1599, N'Loyola University Medical Center', 1, NULL, NULL, N'140276', NULL, NULL, 0, 507, NULL, N'7082169000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2160 S 1St Avenue', N'Maywood', N'IL', N'17031', N'60153', 41.857402, -87.833149, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1600, N'Trinity Rock Island', 1, NULL, NULL, N'140280', NULL, NULL, 0, 71, NULL, N'3097795000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 17Th St', N'Rock Island', N'IL', N'17161', N'61201', 41.481971, -90.572785, 1168, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1601, N'Northwestern Memorial Hospital', 1, NULL, NULL, N'140281', NULL, NULL, 0, 773, NULL, N'3129262000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 E Huron St', N'Chica', N'IL', N'17031', N'60611', 41.894987, -87.62184, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1602, N'Kishwaukee Community Hospital', 1, NULL, NULL, N'140286', NULL, NULL, 0, 94, NULL, N'8157561521', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Kish Hospital Drive', N'Dekalb', N'IL', N'17037', N'60115', 41.929474, -88.750365, 1088, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1603, N'Advocate od Samaritan Hospital', 1, NULL, NULL, N'140288', NULL, NULL, 0, 366, NULL, N'6302755900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3815 Highland Avenue', N'Downers Grove', N'IL', N'17043', N'60515', 41.819137, -88.01022, 1091, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1604, N'Anderson Hospital', 1, NULL, NULL, N'140289', NULL, NULL, 0, 151, NULL, N'6182885711', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 State Route 162', N'Maryville', N'IL', N'17119', N'62062', 38.738132, -89.946634, 1134, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1605, N'St Alexius Medical Center', 1, NULL, NULL, N'140290', NULL, NULL, 0, 342, NULL, N'8478432000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 N Barrington Rd', N'Hoffman Estates', N'IL', N'17031', N'60194', 42.052111, -88.144445, 1118, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1606, N'Advocate od Shepherd Hospital', 1, NULL, NULL, N'140291', NULL, NULL, 0, 154, NULL, N'8473819600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 West Highway 22', N'Barrington', N'IL', N'17097', N'60010', 42.193415, -88.177959, 1068, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1607, N'Adventist Glenoaks', 1, NULL, NULL, N'140292', NULL, NULL, 0, 186, NULL, N'6305456160', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Winthrop Avenue', N'Glendale Heights', N'IL', N'17043', N'60139', 41.915166, -88.058597, 1105, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1608, N'Crossroads Community Hospital', 1, NULL, NULL, N'140294', NULL, NULL, 0, 56, NULL, N'6182445500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8 Doctors Park Road', N'Mount Vernon', N'IL', N'17081', N'62864', 38.311468, -88.937068, 1145, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1609, N'Provident Hospital Of Chica', 1, NULL, NULL, N'140300', NULL, NULL, 0, 222, NULL, N'3125722000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E 51St St', N'Chica', N'IL', N'17031', N'60615', 41.802153, -87.613526, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1610, N'Adventist Bolingbrook Hospital', 1, NULL, NULL, N'140304', NULL, NULL, 0, 138, NULL, N'6302268100', N'6303126985', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Remington Boulevard', N'Bolingbrook', N'IL', N'17197', N'60440', 41.678146, -88.087329, 1147, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1611, N'Thc - Chica Inc D/B/A Kindred Hosp Springfield', 1, NULL, NULL, N'140306', NULL, NULL, 0, 50, NULL, N'2175281217', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 North Walnut Street', N'Springfield', N'IL', N'17167', N'62702', 39.8094696, -89.6668679, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1612, N'Thomas H Boyd Memorial Hospital', 1, NULL, NULL, N'141300', NULL, NULL, 0, 25, NULL, N'2179426946', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 School St', N'Carrollton', N'IL', N'17061', N'62016', 39.29617, -90.412303, 1080, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1613, N'Kirby Medical Center', 1, NULL, NULL, N'141301', NULL, NULL, 0, 16, NULL, N'2177622115', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 N State St', N'Monticello', N'IL', N'17147', N'61856', 40.034004, -88.570533, 1142, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1614, N'Midwest Medical Center', 1, NULL, NULL, N'141302', NULL, NULL, 0, 19, NULL, N'8157771340', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Galena', N'IL', N'17085', N'61036', 42.416674, -90.429017, 1309, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1615, N'Dr John Warner Hospital', 1, NULL, NULL, N'141303', NULL, NULL, 0, 25, NULL, N'2179359571', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'422 W White St', N'Clinton', N'IL', N'17039', N'61727', 40.148939, -88.965112, 1086, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1616, N'Genesis Medical Center Aledo', 1, NULL, NULL, N'141304', NULL, NULL, 0, 22, NULL, N'3095825301', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 Nw 9Th Avenue', N'Aledo', N'IL', N'17131', N'61231', 41.204495, -90.758475, 1063, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1617, N'Memorial Hospital L', 1, NULL, NULL, N'141305', NULL, NULL, 0, 48, NULL, N'2173573131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'South Adams St Po Box 160', N'Carthage', N'IL', N'17067', N'62321', 36.851627, 10.330441, 1081, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1618, N'Community Memorial Hospital', 1, NULL, NULL, N'141306', NULL, NULL, 0, 25, NULL, N'6186352200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Caldwell', N'Staunton', N'IL', N'17117', N'62088', 39.01509, -89.789896, 1180, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1619, N'Pinckneyville Community Hospital', 1, NULL, NULL, N'141307', NULL, NULL, 0, 25, NULL, N'6183572187', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5383 State Route 154', N'Pinckneyville', N'IL', N'17145', N'62274', 38.080329, -89.382032, 1160, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1620, N'Washington County Hospital*', 1, NULL, NULL, N'141308', NULL, NULL, 0, 15, NULL, N'6183272264', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 S Grand', N'Nashville', N'IL', N'17189', N'62263', 36.16223, -86.774353, 1148, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1621, N'Advocate Eureka  Hospital', 1, NULL, NULL, N'141309', NULL, NULL, 0, 18, NULL, N'3094672371', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 S Major St', N'Eureka', N'IL', N'17203', N'61530', 40.721405, -89.271661, 1191, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1622, N'Osf Saint Paul Medical Center', 1, NULL, NULL, N'141310', NULL, NULL, 0, 25, NULL, N'8155397461', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 E 12Th Street', N'Mendota', N'IL', N'17099', N'61342', 41.555187, -89.105497, 1139, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1623, N'Fairfield Memorial Hospital 1', 1, NULL, NULL, N'141311', NULL, NULL, 0, 15, NULL, N'6188422611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N W 11Th Street', N'Fairfield', N'IL', N'17191', N'62837', 38.381637, -88.374422, 1099, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1624, N'Rochelle Community Hospital', 1, NULL, NULL, N'141312', NULL, NULL, 0, 25, NULL, N'8155622181', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 N 2Nd St', N'Rochelle', N'IL', N'17141', N'61068', 41.92871, -89.062803, 1167, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1625, N'Mason District Hospital', 1, NULL, NULL, N'141313', NULL, NULL, 0, 25, NULL, N'3095434431', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 North Promenade Streetp O Box 530', N'Havana', N'IL', N'17125', N'62644', 40.305772, -90.056112, 1111, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1626, N'Illini Community Hospital', 1, NULL, NULL, N'141315', NULL, NULL, 0, 25, NULL, N'2172852113', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 W Washington', N'Pittsfield', N'IL', N'17149', N'62363', 39.606793, -90.814328, 1161, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1627, N'Hoopeston Community Memorial Hospital', 1, NULL, NULL, N'141316', NULL, NULL, 0, 23, NULL, N'2172835531', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Orange Street', N'Hoopeston', N'IL', N'17183', N'60942', 40.459189, -87.66002, 1119, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1628, N'Gibson Community Hospital', 1, NULL, NULL, N'141317', NULL, NULL, 0, 25, NULL, N'2177844251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 N Melvin Street', N'Gibson City', N'IL', N'17053', N'60936', 40.477899, -88.370724, 1104, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1629, N'Osf Holy Family Medical Center', 1, NULL, NULL, N'141318', NULL, NULL, 0, 23, NULL, N'3097343141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Harlem Avenue', N'Monmouth', N'IL', N'17187', N'61462', 40.921292, -90.659058, 1141, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1630, N'Hammond Henry Hospital', 1, NULL, NULL, N'141319', NULL, NULL, 0, 25, NULL, N'3099446431', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N College Avenue', N'Geneseo', N'IL', N'17073', N'61254', 41.460195, -90.158404, 1103, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1631, N'Paris Community Hospital', 1, NULL, NULL, N'141320', NULL, NULL, 0, 15, NULL, N'2174654141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'721 E Court Street', N'Paris', N'IL', N'17045', N'61944', 39.607227, -87.679364, 1155, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1632, N'Franklin Hospital', 1, NULL, NULL, N'141321', NULL, NULL, 0, 25, NULL, N'6184393761', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Bailey Lane', N'Benton', N'IL', N'17055', N'62812', 38.009141, -88.915798, 1071, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1633, N'Abraham Lincoln Memorial Hospital', 1, NULL, NULL, N'141322', NULL, NULL, 0, 15, NULL, N'2177322161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stahlhut Drive', N'Lincoln', N'IL', N'17107', N'62656', 40.152375, -89.388279, 1130, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1634, N'Massac Memorial Hospital', 1, NULL, NULL, N'141323', NULL, NULL, 0, 25, NULL, N'6185242176', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28 Chick Street Po Box 850', N'Metropolis', N'IL', N'17127', N'62960', 37.166781, -88.739453, 1140, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1635, N'Ferrell Hospital Community Foundations', 1, NULL, NULL, N'141324', NULL, NULL, 0, 25, NULL, N'6182733361', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Pine Street', N'Eldorado', N'IL', N'17165', N'62930', 37.815198, -88.441448, 1094, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1636, N'Osf Saint Lukes Medical Center', 1, NULL, NULL, N'141325', NULL, NULL, 0, 25, NULL, N'3098533361', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1051 West South Street', N'Kewanee', N'IL', N'17073', N'61443', 41.222188, -89.950551, 1125, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1637, N'Hamilton Memorial Hospital District', 1, NULL, NULL, N'141326', NULL, NULL, 0, 25, NULL, N'6186432361', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 S Marshall Avenue', N'Mcleansboro', N'IL', N'17065', N'62859', 38.088583, -88.541217, 1137, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1638, N'Wabash General Hospital 1', 1, NULL, NULL, N'141327', NULL, NULL, 0, 25, NULL, N'6182628621', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1418 College Drive', N'Mount Carmel', N'IL', N'17185', N'62863', 38.421622, -87.768768, 1144, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1639, N'Hardin County General Hospital', 1, NULL, NULL, N'141328', NULL, NULL, 0, 25, NULL, N'6182856634', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ferrell Road', N'Rosiclare', N'IL', N'17069', N'62982', 37.410873, -88.35511, 1170, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1640, N'Morrison Community Hospital', 1, NULL, NULL, N'141329', NULL, NULL, 0, 25, NULL, N'8157724003', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 N Jackson Street', N'Morrison', N'IL', N'17195', N'61270', 41.810003, -89.956076, 1181, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1641, N'Hopedale Medical Complex', 1, NULL, NULL, N'141330', NULL, NULL, 0, 25, NULL, N'3094493321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Tremont Street', N'Hopedale', N'IL', N'17179', N'61747', 40.41855, -89.417736, 1120, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1642, N'Marshall Browning Hospital', 1, NULL, NULL, N'141331', NULL, NULL, 0, 25, NULL, N'6185422146', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 North Washington Street', N'Du Quoin', N'IL', N'17145', N'62832', 38.024517, -89.236802, 1092, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1643, N'Hillsboro Area Hospital', 1, NULL, NULL, N'141332', NULL, NULL, 0, 25, NULL, N'2175326111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 E Tremont Street', N'Hillsboro', N'IL', N'17135', N'62049', 39.153672, -89.481508, 1116, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1644, N'Sarah D Culbertson Memorial Hospital', 1, NULL, NULL, N'141333', NULL, NULL, 0, 22, NULL, N'2173224321', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 South Congress Street', N'Rushville', N'IL', N'17169', N'62681', 40.1176, -90.563656, 1171, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1645, N'St Joseph Memorial Hospital', 1, NULL, NULL, N'141334', NULL, NULL, 0, 25, NULL, N'6186843156', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 South Hospital Drive', N'Murphysboro', N'IL', N'17077', N'62966', 37.773205, -89.32635, 1146, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1646, N'Mercy Harvard Hospital', 1, NULL, NULL, N'141335', NULL, NULL, 0, 25, NULL, N'8159435431', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Grant Street', N'Harvard', N'IL', N'17111', N'60033', 42.426008, -88.60775, 1109, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1647, N'St Joseph''s Hospital', 1, NULL, NULL, N'141336', NULL, NULL, 0, 25, NULL, N'6186512600', N'6186512533', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12866 Troxler Avenue', N'Highland', N'IL', N'17119', N'62249', 38.757077, -89.667426, 1114, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1648, N'Perry Memorial Hospital', 1, NULL, NULL, N'141337', NULL, NULL, 0, 25, NULL, N'8158752811', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Park Avenue East', N'Princeton', N'IL', N'17011', N'61356', 41.368012, -89.456479, 1163, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1649, N'Memorial Hospital', 1, NULL, NULL, N'141338', NULL, NULL, 0, 25, NULL, N'6188264581', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 State Street', N'Chester', N'IL', N'17157', N'62233', 37.920117, -89.810839, 1083, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1650, N'Taylorville Memorial Hospital', 1, NULL, NULL, N'141339', NULL, NULL, 0, 25, NULL, N'2178243331', N'2178242099', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East Pleasant Street', N'Taylorville', N'IL', N'17021', N'62568', 39.553759, -89.293744, 1183, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1651, N'Valley West Community Hospital', 1, NULL, NULL, N'141340', NULL, NULL, 0, 25, NULL, N'8157868484', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Main Street', N'Sandwich', N'IL', N'17037', N'60548', 41.652665, -88.621866, 1173, 81, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1652, N'Pana Community Hospital', 1, NULL, NULL, N'141341', NULL, NULL, 0, 25, NULL, N'2175622131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Ninth Street', N'Pana', N'IL', N'17021', N'62557', 39.380287, -89.084161, 1154, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1653, N'Union County Hospital', 1, NULL, NULL, N'141342', NULL, NULL, 0, 25, NULL, N'6188334511', N'6188338481', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'517 North Main Street', N'Anna', N'IL', N'17181', N'62906', 37.465462, -89.245024, 1065, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1654, N'Crawford Memorial Hospital', 1, NULL, NULL, N'141343', NULL, NULL, 0, 25, NULL, N'6185462514', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 North Allen Street', N'Robinson', N'IL', N'17033', N'62454', 39.013161, -87.749248, 1166, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1655, N'Lawrence County Memorial Hospital', 1, NULL, NULL, N'141344', NULL, NULL, 0, 25, NULL, N'6189431000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 W State St', N'Lawrenceville', N'IL', N'17101', N'62439', 38.729546, -87.694113, 1128, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1656, N'Salem Township Hospital', 1, NULL, NULL, N'141345', NULL, NULL, 0, 25, NULL, N'6185483194', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Ricker Drive', N'Salem', N'IL', N'17121', N'62881', 38.638398, -88.948285, 1172, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1657, N'Fayette County Hospital', 1, NULL, NULL, N'141346', NULL, NULL, 0, 25, NULL, N'6182831231', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7Th And Taylor', N'Vandalia', N'IL', N'17051', N'62471', 38.960601, -89.093678, 1185, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1658, N'Carlinville Area Hospital', 1, NULL, NULL, N'141347', NULL, NULL, 0, 25, NULL, N'2178543141', N'2178547027', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20733 N Broad Street', N'Carlinville', N'IL', N'17117', N'62626', 39.296251, -89.881597, 1078, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1659, N'Red Bud Regional Hospital', 1, NULL, NULL, N'141348', NULL, NULL, 0, 25, NULL, N'6182823831', N'6182826101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Spring Street', N'Red Bud', N'IL', N'17157', N'62278', 38.209622, -89.996426, 1165, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1660, N'Sparta Community Hospital', 1, NULL, NULL, N'141349', NULL, NULL, 0, 25, NULL, N'6184432177', N'6184431337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 E Broadway', N'Sparta', N'IL', N'17157', N'62286', 38.124752, -89.690065, 1177, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1661, N'St Francis Hospital', 1, NULL, NULL, N'141350', NULL, NULL, 0, 25, NULL, N'2173242191', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Franciscan Dr', N'Litchfield', N'IL', N'17135', N'62056', 39.179878, -89.640266, 1131, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1662, N'Clay County Hospital', 1, NULL, NULL, N'141351', NULL, NULL, 0, 18, NULL, N'6186622131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Stacy Burk Drive', N'Flora', N'IL', N'17025', N'62839', 38.68016, -88.470329, 1100, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1663, N'Thc Chica Inc Dba Kindred Hosp', 1, NULL, NULL, N'142006', NULL, NULL, 0, 69, NULL, N'8158952144', N'8158957054', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Edward Street', N'Sycamore', N'IL', N'17037', N'60178', 41.982703, -88.688715, 1088, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1664, N'Thc Chica Inc Dba Kindred Hosp Ch', 1, NULL, NULL, N'142008', NULL, NULL, 0, 258, NULL, N'7732672620', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 E North Ave', N'Northlake', N'IL', N'17031', N'60164', 41.917253, -87.895618, 1097, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1665, N'Thc Chica Inc Dba Kindred Chica', 1, NULL, NULL, N'142009', NULL, NULL, 0, 94, NULL, N'7737367000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4058 W Melrose', N'Chica', N'IL', N'17031', N'60641', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1666, N'Rml Specialty Hospital', 1, NULL, NULL, N'142010', NULL, NULL, 0, 189, NULL, N'6302864000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 S County Line Rd', N'Hinsdale', N'IL', N'17043', N'60521', 41.787232, -87.917034, 1117, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1667, N'Presence Holy Family Medical Center', 1, NULL, NULL, N'142011', NULL, NULL, 0, 238, NULL, N'8472971800', N'8472971863', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North River Road', N'Des Plaines', N'IL', N'17031', N'60016', 42.054542, -87.888253, 1156, 85, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1668, N'Greater Peoria Specialty Hospital', 1, NULL, NULL, N'142013', NULL, NULL, 0, 50, NULL, N'3096801500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Romeo B Garrett Avenue', N'Peoria', N'IL', N'17143', N'61605', 40.693328, -89.601115, 1158, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1669, N'Vibra Hospital Of Springfield', 1, NULL, NULL, N'142014', NULL, NULL, 0, 50, NULL, N'2175281217', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 N Walnut', N'Springfield', N'IL', N'17167', N'62702', 39.826427, -89.664031, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1670, N'Schwab Rehabilitation Hospital', 1, NULL, NULL, N'143025', NULL, NULL, 0, 125, NULL, N'7735222010', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 S California Blvd', N'Chica', N'IL', N'17031', N'60608', 41.841433, -87.694434, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1671, N'Rehabilitation Institute Of Chica', 1, NULL, NULL, N'143026', NULL, NULL, 0, 182, NULL, N'3122383305', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 E Superior St', N'Chica', N'IL', N'17031', N'60611', 41.89544, -87.618329, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1672, N'Marianjoy Rehabilitation Hospital', 1, NULL, NULL, N'143027', NULL, NULL, 0, 101, NULL, N'6305887817', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26 W 171 Roosevelt Road', N'Wheaton', N'IL', N'17043', N'60187', 41.863923, -88.112951, 1189, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1673, N'Van Matre Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'143028', NULL, NULL, 0, 37, NULL, N'8153818548', N'8154849035', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 S Mulford Rd', N'Rockford', N'IL', N'17201', N'61108', 42.260821, -88.999573, 1169, 90, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1674, N'Ann & Robert H Lurie Childrens Hospital Of Chica', 1, NULL, NULL, N'143300', NULL, NULL, 0, 262, NULL, N'7738804000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 E Chica', N'Chica', N'IL', N'17031', N'60611', 41.896704, -87.626176, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1675, N'Larabida Childrens Hospital I', 1, NULL, NULL, N'143301', NULL, NULL, 0, 77, NULL, N'7733636700', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'E 65Th St At Lake Michigan', N'Chica', N'IL', N'17031', N'60649', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1676, N'Shriners Hospital For Children', 1, NULL, NULL, N'143302', NULL, NULL, 0, 60, NULL, N'7736225400', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 North Oak Park Ave', N'Chica', N'IL', N'17031', N'60707', 41.92002, -87.793302, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1677, N'Aurora Chica Lakeshore Hospital', 1, NULL, NULL, N'144005', NULL, NULL, 0, 147, NULL, N'7738789700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4840 N Marine Dr', N'Chica', N'IL', N'17031', N'60640', 41.970339, -87.6506, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1678, N'Riveredge Hospital', 1, NULL, NULL, N'144009', NULL, NULL, 0, 210, NULL, N'7087717000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8311 West Roosevelt Road', N'Forest Park', N'IL', N'17031', N'60130', 43.779974, -85.888483, 1150, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1679, N'Chica-Read Mental Health Center', 1, NULL, NULL, N'144010', NULL, NULL, 0, 130, NULL, N'7737944000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4200 N Oak Park Ave', N'Chica', N'IL', N'17031', N'60634', 41.955135, -87.799236, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1680, N'Alton Mental Health Center', 1, NULL, NULL, N'144016', NULL, NULL, 0, 24, NULL, N'6184743800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 College Avenue', N'Alton', N'IL', N'17119', N'62002', 38.907701, -90.122408, 1064, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1681, N'Andrew Mcfarland Mental Hlth Ctr', 1, NULL, NULL, N'144021', NULL, NULL, 0, 146, NULL, N'2177866900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Southwind Rd', N'Springfield', N'IL', N'17167', N'62703', 39.72836, -89.639746, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1682, N'Hartgrove Hospital', 1, NULL, NULL, N'144026', NULL, NULL, 0, 160, NULL, N'7734131700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5730 W Roosevelt Road', N'Chica', N'IL', N'17031', N'60644', 41.866365, -87.76748, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1683, N'John J Madden Mental Health Center', 1, NULL, NULL, N'144028', NULL, NULL, 0, 269, NULL, N'7085317202', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 S First Ave', N'Hines', N'IL', N'17031', N'60141', 41.853643, -87.839503, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1684, N'Pavilion Foundationthe', 1, NULL, NULL, N'144029', NULL, NULL, 0, 46, NULL, N'2173731700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 W Church St', N'Champaign', N'IL', N'17019', N'61820', 40.126021, -88.239952, 1184, 92, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1685, N'Alexian Brothers Behavioral Hlth Hosp', 1, NULL, NULL, N'144031', NULL, NULL, 0, 136, NULL, N'8478821600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Moon Lake Blvd', N'Hoffman Estates', N'IL', N'17031', N'60194', 42.054139, -88.137218, 1118, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1686, N'Bhc Streamwood Hospital Inc', 1, NULL, NULL, N'144034', NULL, NULL, 0, 162, NULL, N'6308379000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Irving Park Road', N'Streamwood', N'IL', N'17031', N'60107', 42.00796, -88.152435, 1118, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1687, N'Linden Oaks Hospital', 1, NULL, NULL, N'144035', NULL, NULL, 0, 96, NULL, N'6303055500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Washington St', N'Naperville', N'IL', N'17043', N'60540', 41.770767, -88.148163, 1147, 86, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1688, N'Elgin Mental Health Center', 1, NULL, NULL, N'144037', NULL, NULL, 0, 582, NULL, N'8477421040', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 S State St', N'Elgin', N'IL', N'17089', N'60123', 42.021006, -88.28368, 1095, 84, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1689, N'Choate Mental Health & Development Ctr', 1, NULL, NULL, N'144038', NULL, NULL, 0, 113, NULL, N'6188335161', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 N Main St', N'Anna', N'IL', N'17181', N'62906', 37.474478, -89.245031, 1065, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1690, N'Garfield Park Hospital', 1, NULL, NULL, N'144039', NULL, NULL, 0, 88, NULL, N'7732653700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 N Ridgeway Ave', N'Chica', N'IL', N'17031', N'60624', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1691, N'University Of Chica Hospitals', 1, NULL, NULL, N'149801', NULL, NULL, 0, 0, NULL, N'7737021000', N'7737021213', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5841 South Maryland', N'Chica', N'IL', N'17031', N'60637', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1692, N'Loyola University Medical Center', 1, NULL, NULL, N'149802', NULL, NULL, 0, 0, NULL, N'7082169000', N'7082166227', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2160 South 1St Avenue', N'Maywood', N'IL', N'17031', N'60153', 41.871771, -87.833709, 1138, 88, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1693, N'Rush University Medical Center', 1, NULL, NULL, N'149803', NULL, NULL, 0, 0, NULL, N'3129425000', N'3129422055', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1653 West Congress Parkway', N'Chica', N'IL', N'17031', N'60612', 41.875067, -87.668382, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1694, N'Children''s Memorial Hospital', 1, NULL, NULL, N'149804', NULL, NULL, 0, 0, NULL, N'7738804092', N'7739758534', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2300 Childrens Plaza Box #37', N'Chica', N'IL', N'17031', N'60614', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1695, N'University Of Illinois Medical Center', 1, NULL, NULL, N'149805', NULL, NULL, 0, 0, NULL, N'3129963900', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1740 West Taylor Suite 1400', N'Chica', N'IL', N'17031', N'60612', 41.875555, -87.624421, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1696, N'Northwestern Memorial Hospital', 1, NULL, NULL, N'149806', NULL, NULL, 0, 0, NULL, N'3126951705', N'3126951817', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'251 East Huron Street', N'Chica', N'IL', N'17031', N'60611', 41.894401, -87.621241, 1084, 83, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1697, N'St Francis Medical Center Transplant', 1, NULL, NULL, N'149807', NULL, NULL, 0, 0, NULL, N'3096554101', N'3096552597', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'530 Ne Glen Oak Avenue', N'Peoria', N'IL', N'17143', N'61637', 40.701077, -89.592564, 1158, 89, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1698, N'Memorial Medical Center', 1, NULL, NULL, N'149808', NULL, NULL, 0, 0, NULL, N'2177577886', N'2175273120', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'701 North First Street - Transplant Services', N'Springfield', N'IL', N'17167', N'62781', 42.154909, -72.535797, 1179, 91, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1699, N'Advocate Christ Medical Center', 1, NULL, NULL, N'149809', NULL, NULL, 0, 0, NULL, N'7086842653', N'7086845012', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4400 West 95Th Street', N'Oak Lawn', N'IL', N'17031', N'60453', 41.720346, -87.731252, 1149, 82, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1700, N'Johnson Memorial Hospital', 1, NULL, NULL, N'150001', NULL, NULL, 0, 125, NULL, N'3177363300', N'3177362692', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 W Jefferson St', N'Franklin', N'IN', N'18081', N'46131', 39.480961, -86.077859, 1221, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1701, N'Methodist Hospitals Inc', 1, NULL, NULL, N'150002', NULL, NULL, 0, 536, NULL, N'2198864642', N'2198864209', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Grant St', N'Gary', N'IN', N'18089', N'46402', 41.599508, -87.357025, 1222, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1702, N'Franciscan St Margaret Health - Hammond', 1, NULL, NULL, N'150004', NULL, NULL, 0, 215, NULL, N'2199322300', N'2199332585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Hohman Ave', N'Hammond', N'IN', N'18089', N'46320', 41.61449, -87.52201, 1227, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1703, N'Hendricks Regional Health', 1, NULL, NULL, N'150005', NULL, NULL, 0, 160, NULL, N'3177454451', N'3177458352', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 E Main St', N'Danville', N'IN', N'18063', N'46122', 39.76077, -86.500743, 1212, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1704, N'Indiana University Health La Porte Hospital', 1, NULL, NULL, N'150006', NULL, NULL, 0, 227, NULL, N'2193261234', N'2193255403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 Lincolnway', N'La Porte', N'IN', N'18091', N'46350', 41.609839, -86.723854, 1239, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1705, N'Community Howard Regional Health Inc', 1, NULL, NULL, N'150007', NULL, NULL, 0, 162, NULL, N'7654538547', N'7654538087', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 S Lafountain St', N'Kokomo', N'IN', N'18067', N'46902', 40.446835, -86.127103, 1236, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1706, N'St Catherine Hospital Inc', 1, NULL, NULL, N'150008', NULL, NULL, 0, 189, NULL, N'2193927004', N'2193927002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Fir St', N'East Chica', N'IN', N'18089', N'46312', 41.633793, -87.448546, 1215, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1707, N'Clark Memorial Hospital', 1, NULL, NULL, N'150009', NULL, NULL, 0, 241, NULL, N'8122832142', N'8122832688', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 Missouri Ave', N'Jeffersonville', N'IN', N'18019', N'47130', 38.280777, -85.749529, 1233, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1708, N'St Vincent Kokomo', 1, NULL, NULL, N'150010', NULL, NULL, 0, 167, NULL, N'7654525611', N'7654565083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1907 W Sycamore St', N'Kokomo', N'IN', N'18067', N'46904', 40.487218, -86.155487, 1236, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1709, N'Marion General Hospital', 1, NULL, NULL, N'150011', NULL, NULL, 0, 99, NULL, N'7656607000', N'7656517351', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'441 N Wabash Ave', N'Marion', N'IN', N'18053', N'46952', 40.563628, -85.6648, 1245, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1710, N'Saint Joseph Regional Medical Center', 1, NULL, NULL, N'150012', NULL, NULL, 0, 301, NULL, N'5743355000', N'5743351002', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5215 Holy Cross Pkwy', N'Mishawaka', N'IN', N'18141', N'46545', 41.705543, -86.173262, 1267, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1711, N'Franciscan St Anthony Health - Michigan City', 1, NULL, NULL, N'150015', NULL, NULL, 0, 310, NULL, N'2198798511', N'2198771409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Homer St', N'Michigan City', N'IN', N'18091', N'46360', 41.706437, -86.898965, 1247, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1712, N'Lutheran Hospital Of Indiana', 1, NULL, NULL, N'150017', NULL, NULL, 0, 396, NULL, N'2604357001', N'2604357632', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7950 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.037374, -85.245885, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1713, N'Elkhart General Hospital', 1, NULL, NULL, N'150018', NULL, NULL, 0, 297, NULL, N'5742942621', N'5745233495', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Blvd', N'Elkhart', N'IN', N'18039', N'46514', 41.683131, -85.990835, 1216, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1714, N'Parkview Regional Medical Center', 1, NULL, NULL, N'150021', NULL, NULL, 0, 600, NULL, N'2602661000', N'2602661010', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11109 Parkview Plaza Drive', N'Fort Wayne', N'IN', N'18003', N'46845', 41.185668, -85.098727, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1715, N'Franciscan St Elizabeth Health - Crawfordsville', 1, NULL, NULL, N'150022', NULL, NULL, 0, 103, NULL, N'7653622800', N'7653643189', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Lafayette Rd', N'Crawfordsville', N'IN', N'18107', N'47933', 40.067397, -86.907818, 1210, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1716, N'Union Hospital Inc', 1, NULL, NULL, N'150023', NULL, NULL, 0, 318, NULL, N'8122387606', N'8122387113', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1606 N Seventh St', N'Terre Haute', N'IN', N'18167', N'47804', 39.485244, -87.406837, 1270, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1717, N'Eskenazi Health', 1, NULL, NULL, N'150024', NULL, NULL, 0, 343, NULL, N'3178804818', N'3178800308', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Eskenazi Avenue', N'Indianapolis', N'IN', N'18097', N'46202', 39.78053, -86.17345, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1718, N'Iu Health shen Hospital', 1, NULL, NULL, N'150026', NULL, NULL, 0, 123, NULL, N'5743641000', N'5743642849', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 High Park Ave', N'shen', N'IN', N'18039', N'46526', 41.56432, -85.830544, 1223, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1719, N'Henry County Memorial Hospital', 1, NULL, NULL, N'150030', NULL, NULL, 0, 90, NULL, N'7655210890', N'7655211555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 N 16Th St', N'New Castle', N'IN', N'18065', N'47362', 39.940942, -85.365028, 1252, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1720, N'St Mary Medical Center Inc', 1, NULL, NULL, N'150034', NULL, NULL, 0, 176, NULL, N'2199420551', N'2199476037', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Lake Park Ave', N'Hobart', N'IN', N'18089', N'46342', 41.512679, -87.258902, 1222, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1721, N'Porter Regional Hospital', 1, NULL, NULL, N'150035', NULL, NULL, 0, 301, NULL, N'2199838300', N'2199838080', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 East Us Hwy 6', N'Valparaiso', N'IN', N'18127', N'46383', 41.55007, -87.051316, 1272, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1722, N'Hancock Regional Hospital', 1, NULL, NULL, N'150037', NULL, NULL, 0, 69, NULL, N'3174625544', N'3174684222', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 N State St', N'Greenfield', N'IN', N'18059', N'46140', 39.795075, -85.76961, 1225, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1723, N'od Samaritan Hospital', 1, NULL, NULL, N'150042', NULL, NULL, 0, 165, NULL, N'8128825220', N'8128853737', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 S 7Th St', N'Vincennes', N'IN', N'18083', N'47591', 38.672985, -87.534083999999993, 1273, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1724, N'Floyd Memorial Hospital And Health Services', 1, NULL, NULL, N'150044', NULL, NULL, 0, 211, NULL, N'8129495500', N'8129495607', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 State St', N'New Albany', N'IN', N'18043', N'47150', 38.300212, -85.834777, 1251, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1725, N'Dekalb Health', 1, NULL, NULL, N'150045', NULL, NULL, 0, 45, NULL, N'2609254600', N'2609258350', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1316 E Seventh St', N'Auburn', N'IN', N'18033', N'46706', 41.367648, -85.036482, 1195, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1726, N'Terre Haute Regional Hospital', 1, NULL, NULL, N'150046', NULL, NULL, 0, 278, NULL, N'8122320021', N'8122379514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 S Seventh St', N'Terre Haute', N'IN', N'18167', N'47802', 39.419454, -87.406841, 1270, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1727, N'St Joseph Hospital', 1, NULL, NULL, N'150047', NULL, NULL, 0, 191, NULL, N'2604253000', N'2604253222', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Broadway', N'Fort Wayne', N'IN', N'18003', N'46802', 41.078664, -85.148811, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1728, N'Reid Health', 1, NULL, NULL, N'150048', NULL, NULL, 0, 223, NULL, N'7659833000', N'7659833324', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Reid Pkwy', N'Richmond', N'IN', N'18177', N'47374', 39.86303, -84.887765, 1261, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1729, N'Indiana University Health Bloomington Hospital', 1, NULL, NULL, N'150051', NULL, NULL, 0, 297, NULL, N'8123539555', N'8123539339', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 W Second St', N'Bloomington', N'IN', N'18105', N'47403', 39.161398, -86.540106, 1199, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1730, N'Indiana University Health', 1, NULL, NULL, N'150056', NULL, NULL, 0, 1733, NULL, N'3179625900', N'3179622276', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 N Senate Blvd', N'Indianapolis', N'IN', N'18097', N'46202', 39.790935, -86.165064, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1731, N'Franciscan St Francis Health - Mooresville', 1, NULL, NULL, N'150057', NULL, NULL, 0, 82, NULL, N'3178311160', N'3178319315', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Hadley Rd', N'Mooresville', N'IN', N'18109', N'46158', 39.609332, -86.355874, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1732, N'Memorial Hospital Of South Bend', 1, NULL, NULL, N'150058', NULL, NULL, 0, 463, NULL, N'5746471000', N'5746476898', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 N Michigan St', N'South Bend', N'IN', N'18141', N'46601', 41.685783, -86.250614, 1267, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1733, N'Riverview Health', 1, NULL, NULL, N'150059', NULL, NULL, 0, 162, NULL, N'3177767108', N'3177767134', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'395 Westfield Rd', N'Noblesville', N'IN', N'18057', N'46060', 40.047026, -86.024081, 1253, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1734, N'Daviess Community Hospital', 1, NULL, NULL, N'150061', NULL, NULL, 0, 80, NULL, N'8122542760', N'8122548850', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 E Walnut St', N'Washington', N'IN', N'18027', N'47501', 38.658695, -87.160319, 1276, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1735, N'Fayette Regional Health System', 1, NULL, NULL, N'150064', NULL, NULL, 0, 105, NULL, N'7658255131', N'7658277775', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1941 Virginia Ave', N'Connersville', N'IN', N'18041', N'47331', 39.656025, -85.131981, 1208, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1736, N'Schneck Medical Center', 1, NULL, NULL, N'150065', NULL, NULL, 0, 93, NULL, N'8125222349', N'8125220792', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 W Tipton St', N'Seymour', N'IN', N'18071', N'47274', 38.956754, -85.891268, 1265, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1737, N'King''s Daughters'' Health', 1, NULL, NULL, N'150069', NULL, NULL, 0, 86, NULL, N'8128010105', N'8128010680', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1373 East Sr 62', N'Madison', N'IN', N'18077', N'47250', 38.7901, -85.3633, 1244, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1738, N'Memorial Hospital', 1, NULL, NULL, N'150072', NULL, NULL, 0, 83, NULL, N'5747537541', N'5747531402', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Michigan Ave', N'Logansport', N'IN', N'18017', N'46947', 40.762965, -86.360941, 1243, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1739, N'Community Hospital East', 1, NULL, NULL, N'150074', NULL, NULL, 0, 263, NULL, N'3173555411', N'3173517723', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N Ritter Ave', N'Indianapolis', N'IN', N'18097', N'46219', 39.787113, -86.0738, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1740, N'Bluffton Regional Medical Center', 1, NULL, NULL, N'150075', NULL, NULL, 0, 79, NULL, N'2608243210', N'2609193201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 S Main St', N'Bluffton', N'IN', N'18179', N'46714', 40.737582, -85.171495, 1200, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1741, N'Saint Joseph Regional Medical Center - Plymouth', 1, NULL, NULL, N'150076', NULL, NULL, 0, 58, NULL, N'5749484000', N'5749485478', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1915 Lake Ave', N'Plymouth', N'IN', N'18099', N'46563', 41.333327, -86.333446, 1257, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1742, N'Deaconess Hospital Inc', 1, NULL, NULL, N'150082', NULL, NULL, 0, 558, NULL, N'8124505000', N'8124502155', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mary St', N'Evansville', N'IN', N'18163', N'47747', 37.984794, -87.571057, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1743, N'St Vincent Hospital & Health Services', 1, NULL, NULL, N'150084', NULL, NULL, 0, 779, NULL, N'3173387000', N'3173387005', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 W 86Th St', N'Indianapolis', N'IN', N'18097', N'46260', 39.911997, -86.195965, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1744, N'Dearborn County Hospital', 1, NULL, NULL, N'150086', NULL, NULL, 0, 78, NULL, N'8125371010', N'8125372897', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Wilson Creek Rd', N'Lawrenceburg', N'IN', N'18029', N'47025', 39.112922, -84.883951, 1240, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1745, N'St Vincent Anderson Regional Hospital Inc', 1, NULL, NULL, N'150088', NULL, NULL, 0, 195, NULL, N'7656468373', N'7656468504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2015 Jackson St', N'Anderson', N'IN', N'18095', N'46016', 40.095941, -85.680467, 1193, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1746, N'Indiana University Health Ball Memorial Hospital', 1, NULL, NULL, N'150089', NULL, NULL, 0, 379, NULL, N'7657473111', N'7657512506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 University Ave', N'Muncie', N'IN', N'18035', N'47303', 40.197621, -85.414495, 1249, 99, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1747, N'Franciscan St Margaret Health - Dyer', 1, NULL, NULL, N'150090', NULL, NULL, 0, 198, NULL, N'2198652141', N'2198642585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Joliet St', N'Dyer', N'IN', N'18089', N'46311', 41.494299, -87.523722, 1214, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1748, N'Parkview Huntington Hospital', 1, NULL, NULL, N'150091', NULL, NULL, 0, 36, NULL, N'2603553000', N'2603353310', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Stults Rd', N'Huntington', N'IN', N'18069', N'46750', 40.902763, -85.490567, 1230, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1749, N'Major Hospital', 1, NULL, NULL, N'150097', NULL, NULL, 0, 51, NULL, N'3173923211', N'3173981800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 W Washington St', N'Shelbyville', N'IN', N'18145', N'46176', 39.524441, -85.781105, 1266, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1750, N'St Mary''s Medical Center', 1, NULL, NULL, N'150100', NULL, NULL, 0, 414, NULL, N'8124854000', N'8124857800', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Washington Ave', N'Evansville', N'IN', N'18163', N'47750', 37.962405, -87.50513, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1751, N'Parkview Whitley Hospital', 1, NULL, NULL, N'150101', NULL, NULL, 0, 30, NULL, N'2602489301', N'2602489107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1260 E Sr 205', N'Columbia City', N'IN', N'18183', N'46725', 41.16013, -85.466858, 1206, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1752, N'Indiana University Health Starke Hospital', 1, NULL, NULL, N'150102', NULL, NULL, 0, 53, NULL, N'5747721102', N'5747725948', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 E Culver Rd', N'Knox', N'IN', N'18149', N'46534', 41.288064, -86.621937, 1235, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1753, N'Witham Health Services', 1, NULL, NULL, N'150104', NULL, NULL, 0, 52, NULL, N'7654858000', N'7654858118', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2605 N Lebanon St', N'Lebanon', N'IN', N'18011', N'46052', 40.074374, -86.47462, 1241, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1754, N'Franciscan St Elizabeth Health - Lafayette East', 1, NULL, NULL, N'150109', NULL, NULL, 0, 186, NULL, N'7655024334', N'7655024494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 S Creasy Ln', N'Lafayette', N'IN', N'18157', N'47905', 40.394146, -86.838382, 1237, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1755, N'Columbus Regional Hospital', 1, NULL, NULL, N'150112', NULL, NULL, 0, 160, NULL, N'8123794441', N'8123765001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 E 17Th St', N'Columbus', N'IN', N'18005', N'47201', 39.215872, -85.896854, 1207, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1756, N'Community Hospital Of Anderson And Madison County', 1, NULL, NULL, N'150113', NULL, NULL, 0, 137, NULL, N'7652984242', N'7652985848', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 N Madison Ave', N'Anderson', N'IN', N'18095', N'46011', 40.130049, -85.691578, 1193, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1757, N'Memorial Hospital And Health Care Center', 1, NULL, NULL, N'150115', NULL, NULL, 0, 123, NULL, N'8129962345', N'8129960302', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W 9Th St', N'Jasper', N'IN', N'18037', N'47546', 38.393754, -86.942695, 1232, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1758, N'Community Hospital', 1, NULL, NULL, N'150125', NULL, NULL, 0, 437, NULL, N'2198361600', N'2198366380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Macarthur Blvd', N'Munster', N'IN', N'18089', N'46321', 41.54975, -87.506401, 1250, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1759, N'Franciscan St Anthony Health - Crown Point', 1, NULL, NULL, N'150126', NULL, NULL, 0, 208, NULL, N'2197576100', N'2197576242', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 S Main St', N'Crown Point', N'IN', N'18089', N'46307', 41.396497, -87.364436, 1211, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1760, N'Community Hospital South', 1, NULL, NULL, N'150128', NULL, NULL, 0, 127, NULL, N'3178877000', N'3178877112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1402 E County Line Rd S', N'Indianapolis', N'IN', N'18097', N'46227', 39.378646, -86.251547, 1198, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1761, N'Community Westview Hospital', 1, NULL, NULL, N'150129', NULL, NULL, 0, 120, NULL, N'3179207288', N'3179207550', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3630 Guion Rd', N'Indianapolis', N'IN', N'18097', N'46222', 39.813378, -86.220258, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1762, N'Kosciusko Community Hospital', 1, NULL, NULL, N'150133', NULL, NULL, 0, 72, NULL, N'5742673200', N'5743727692', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 E Dubois Dr', N'Warsaw', N'IN', N'18085', N'46580', 41.24643, -85.82832, 1275, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1763, N'Parkview Noble Hospital', 1, NULL, NULL, N'150146', NULL, NULL, 0, 31, NULL, N'2603478700', N'2603478148', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sawyer Rd', N'Kendallville', N'IN', N'18113', N'46755', 41.448652, -85.293589, 1234, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1764, N'Women''s Hospital The', 1, NULL, NULL, N'150149', NULL, NULL, 0, 74, NULL, N'8128424200', N'8128424250', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4199 Gateway Blvd', N'Newburgh', N'IN', N'18173', N'47630', 37.974789, -87.445907, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1765, N'Dupont Hospital Llc', 1, NULL, NULL, N'150150', NULL, NULL, 0, 131, NULL, N'2604163000', N'2604163300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 E Dupont Rd', N'Fort Wayne', N'IN', N'18003', N'46825', 41.178706, -85.109619, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1766, N'St Vincent Heart Center Of Indiana Llc', 1, NULL, NULL, N'150153', NULL, NULL, 0, 107, NULL, N'3175835000', N'3175835405', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10580 N Meridian St', N'Indianapolis', N'IN', N'18057', N'46290', 39.778333, -86.157655, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1767, N'St Vincent Carmel Hospital Inc', 1, NULL, NULL, N'150157', NULL, NULL, 0, 107, NULL, N'3175827000', N'3175827492', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13500 N Meridian St', N'Carmel', N'IN', N'18057', N'46032', 39.983055, -86.1472, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1768, N'Iu Health West Hospital', 1, NULL, NULL, N'150158', NULL, NULL, 0, 127, NULL, N'3172173000', N'3172173026', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 N Ronald Reagan Pkwy', N'Avon', N'IN', N'18063', N'46123', 39.780651, -86.343645, 1212, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1769, N'Orthoindy Hospital', 1, NULL, NULL, N'150160', NULL, NULL, 0, 38, NULL, N'3179561000', N'3179561001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8400 Northwest Blvd', N'Indianapolis', N'IN', N'18097', N'46278', 39.906702, -86.266258, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1770, N'Indiana University Health North Hospital', 1, NULL, NULL, N'150161', NULL, NULL, 0, 149, NULL, N'3176882000', N'3176882001', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11700 N Meridian St', N'Carmel', N'IN', N'18057', N'46032', 39.959275, -86.162356, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1771, N'Franciscan St Francis Health - Indianapolis', 1, NULL, NULL, N'150162', NULL, NULL, 0, 385, NULL, N'3175285000', N'3175286696', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8111 S Emerson Ave', N'Indianapolis', N'IN', N'18097', N'46237', 39.648472, -86.082674, 1198, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1772, N'Monroe Hospital', 1, NULL, NULL, N'150164', NULL, NULL, 0, 32, NULL, N'8128251111', N'8128250750', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4011 S Monroe Medical Park Blvd', N'Bloomington', N'IN', N'18105', N'47403', 39.120141, -86.572683, 1199, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1773, N'Franciscan Healthcare - Munster', 1, NULL, NULL, N'150165', NULL, NULL, 0, 63, NULL, N'2199224200', N'2199226809', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Superior Ave', N'Munster', N'IN', N'18089', N'46321', 41.537258, -87.512313, 1250, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1774, N'Pinnacle Hospital', 1, NULL, NULL, N'150166', NULL, NULL, 0, 18, NULL, N'2197562100', N'2197560412', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9301 Connecticut Dr', N'Crown Point', N'IN', N'18089', N'46307', 41.416981, -87.365314, 1211, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1775, N'Orthopaedic Hospital At Parkview North Llc', 1, NULL, NULL, N'150167', NULL, NULL, 0, 49, NULL, N'2606724050', N'2606724859', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11130 Parkview Circle Dr', N'Fort Wayne', N'IN', N'18003', N'46845', 41.182548, -85.099986, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1776, N'The Orthopaedic Hospital Of Lutheran Health Networ', 1, NULL, NULL, N'150168', NULL, NULL, 0, 44, NULL, N'2604352999', N'2604352557', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7952 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.037352, -85.245918, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1777, N'Community Hospital North', 1, NULL, NULL, N'150169', NULL, NULL, 0, 298, NULL, N'3176215335', N'3176217878', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7150 Clearvista Dr', N'Indianapolis', N'IN', N'18097', N'46256', 39.899656, -86.040966, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1778, N'Physicians'' Medical Center Llc', 1, NULL, NULL, N'150172', NULL, NULL, 0, 12, NULL, N'8122067660', N'8122067650', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4023 Reas Ln', N'New Albany', N'IN', N'18043', N'47150', 38.340097, -85.827061, 1251, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1779, N'Indiana University Health Arnett Hospital', 1, NULL, NULL, N'150173', NULL, NULL, 0, 191, NULL, N'7654488000', N'7654487660', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5165 Mccarty Ln', N'Lafayette', N'IN', N'18157', N'47905', 40.40301, -86.807649, 1237, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1780, N'The Heart Hospital At Deaconess Gateway Llc', 1, NULL, NULL, N'150175', NULL, NULL, 0, 24, NULL, N'8128424784', N'8128423921', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4007 Gateway Blvd', N'Newburgh', N'IN', N'18173', N'47630', 37.976275, -87.445927, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1781, N'Kentuckiana Medical Center Llc', 1, NULL, NULL, N'150176', NULL, NULL, 0, 42, NULL, N'8122803300', N'8122805960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Medical Plaza Way', N'Clarksville', N'IN', N'18019', N'47129', 38.333321, -85.751198, 1233, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1782, N'Unity Medical And Surgical Hospital', 1, NULL, NULL, N'150177', NULL, NULL, 0, 29, NULL, N'5742316800', N'5742316845', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4455 Edison Lakes Pkwy', N'Mishawaka', N'IN', N'18141', N'46545', 41.700723, -86.176781, 1267, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1783, N'Fairbanks', 1, NULL, NULL, N'150179', NULL, NULL, 0, 62, NULL, N'3178498222', N'3178491455', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8102 Clearvista Parkway', N'Indianapolis', N'IN', N'18097', N'46256', 39.903152, -86.039584, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1784, N'St Vincent Fishers Hospital Inc', 1, NULL, NULL, N'150181', NULL, NULL, 0, 46, NULL, N'3174159000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13861 Olio Road', N'Fishers', N'IN', N'18057', N'46037', 39.989499, -85.918966, 1193, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1785, N'Franciscan St Francis Health - Carmel', 1, NULL, NULL, N'150182', NULL, NULL, 0, 6, NULL, N'3177054500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12188 B North Meridian Street', N'Carmel', N'IN', N'18057', N'46032', 39.966155, -86.158383, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1786, N'Community Hospital Of Bremen Inc', 1, NULL, NULL, N'151300', NULL, NULL, 0, 24, NULL, N'5745462211', N'5745464312', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 High Rd', N'Bremen', N'IN', N'18099', N'46506', 41.457008, -86.158165, 1203, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1787, N'St Vincent Randolph Hospital Inc', 1, NULL, NULL, N'151301', NULL, NULL, 0, 25, NULL, N'7655840004', N'7655840066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'473 E Greenville Ave', N'Winchester', N'IN', N'18135', N'47394', 40.168017999999996, -84.970587, 1279, 99, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1788, N'Indiana University Health Blackford Hospital', 1, NULL, NULL, N'151302', NULL, NULL, 0, 15, NULL, N'7653480300', N'7653480574', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Pilgrim Blvd', N'Hartford City', N'IN', N'18009', N'47348', 40.468642, -85.373482, 1228, 99, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1789, N'St Vincent Jennings Hospital Inc', 1, NULL, NULL, N'151303', NULL, NULL, 0, 19, NULL, N'8123524200', N'8123524201', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Henry St', N'North Vernon', N'IN', N'18079', N'47265', 39.011333, -85.641025, 1254, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1790, N'Rush Memorial Hospital', 1, NULL, NULL, N'151304', NULL, NULL, 0, 25, NULL, N'7659327513', N'7659327523', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 N Main St', N'Rushville', N'IN', N'18139', N'46173', 39.621442, -85.444792, 1263, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1791, N'Pulaski Memorial Hospital', 1, NULL, NULL, N'151305', NULL, NULL, 0, 25, NULL, N'5749462100', N'5749462134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'616 E 13Th St', N'Winamac', N'IN', N'18131', N'46996', 41.057397, -86.595328, 1278, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1792, N'Indiana University Health Paoli Hospital', 1, NULL, NULL, N'151306', NULL, NULL, 0, 25, NULL, N'8127232811', N'8127237500', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'642 W Hospital Rd', N'Paoli', N'IN', N'18117', N'47454', 38.567715, -86.474551, 1255, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1793, N'St Vincent Williamsport Hospital Inc', 1, NULL, NULL, N'151307', NULL, NULL, 0, 16, NULL, N'7657624000', N'7657624126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'412 N Monroe St', N'Williamsport', N'IN', N'18171', N'47993', 40.289129, -87.294798, 1277, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1794, N'St Vincent Mercy Hospital', 1, NULL, NULL, N'151308', NULL, NULL, 0, 25, NULL, N'7655524743', N'3175832162', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1331 S A St', N'Elwood', N'IN', N'18095', N'46036', 40.27602, -85.844018, 1217, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1795, N'St Vincent Clay Hospital Inc', 1, NULL, NULL, N'151309', NULL, NULL, 0, 25, NULL, N'8124422500', N'8124422605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1206 E National Ave', N'Brazil', N'IN', N'18021', N'47834', 39.526912, -87.111409, 1202, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1796, N'Parkview Wabash Hospital Inc', 1, NULL, NULL, N'151310', NULL, NULL, 0, 50, NULL, N'2605633131', N'2605692338', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N East St', N'Wabash', N'IN', N'18169', N'46992', 40.806949, -85.81525, 1274, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1797, N'Indiana University Health Tipton Hospital Inc', 1, NULL, NULL, N'151311', NULL, NULL, 0, 25, NULL, N'7656758500', N'7656758199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Main St', N'Tipton', N'IN', N'18159', N'46072', 40.272518, -86.041105, 1271, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1798, N'Indiana University Health White Memorial Hospital', 1, NULL, NULL, N'151312', NULL, NULL, 0, 25, NULL, N'5745837111', N'5745831703', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 South Sixth St', N'Monticello', N'IN', N'18181', N'47960', 40.734888, -86.775622, 1248, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1799, N'Woodlawn Hospital', 1, NULL, NULL, N'151313', NULL, NULL, 0, 25, NULL, N'5742233141', N'5742235318', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E 9Th St', N'Rochester', N'IN', N'18049', N'46975', 41.061692, -86.195585, 1262, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1800, N'St Vincent Salem Hospital Inc', 1, NULL, NULL, N'151314', NULL, NULL, 0, 25, NULL, N'8128835881', N'8128838563', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 N Shelby St', N'Salem', N'IN', N'18175', N'47167', 38.613321, -86.107803, 1264, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1801, N'Cameron Memorial Community Hospital Inc', 1, NULL, NULL, N'151315', NULL, NULL, 0, 25, NULL, N'2606652141', N'2606657893', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'416 E Maumee St', N'Anla', N'IN', N'18151', N'46703', 41.634879, -84.99533, 1194, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1802, N'St Vincent Frankfort Hospital Inc', 1, NULL, NULL, N'151316', NULL, NULL, 0, 25, NULL, N'7656563000', N'7656563020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 S Jackson St', N'Frankfort', N'IN', N'18023', N'46041', 40.269311, -86.510534, 1220, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1803, N'Greene County General Hospital', 1, NULL, NULL, N'151317', NULL, NULL, 0, 25, NULL, N'8128472281', N'8128476166', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1185 N 1000 W', N'Linton', N'IN', N'18055', N'47441', 39.040035, -87.129172, 1242, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1804, N'Dukes Memorial Hospital', 1, NULL, NULL, N'151318', NULL, NULL, 0, 25, NULL, N'7654728000', N'7654738244', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 W 12Th St', N'Peru', N'IN', N'18103', N'46970', 40.756437, -86.084096, 1256, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1805, N'Gibson General Hospital', 1, NULL, NULL, N'151319', NULL, NULL, 0, 25, NULL, N'8123853401', N'8123859323', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1808 Sherman Dr', N'Princeton', N'IN', N'18051', N'47670', 38.360232, -87.58912, 1259, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1806, N'Jay County Hospital', 1, NULL, NULL, N'151320', NULL, NULL, 0, 35, NULL, N'2607267131', N'2607261975', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Votaw St', N'Portland', N'IN', N'18075', N'47371', 40.439375, -84.983524, 1258, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1807, N'Perry County Memorial Hospital', 1, NULL, NULL, N'151322', NULL, NULL, 0, 25, NULL, N'8125477011', N'8125470169', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8885 Sr 237', N'Tell City', N'IN', N'18123', N'47586', 37.971692, -86.735534, 1269, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1808, N'Parkview Lagrange Hospital', 1, NULL, NULL, N'151323', NULL, NULL, 0, 25, NULL, N'2604639000', N'2604639420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 N Townline Rd', N'Lagrange', N'IN', N'18087', N'46761', 41.64468, -85.424925, 1238, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1809, N'Franciscan Healthcare Rensselaer', 1, NULL, NULL, N'151324', NULL, NULL, 0, 46, NULL, N'2198665141', N'2198663234', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1104 E Grace St', N'Rensselaer', N'IN', N'18073', N'47978', 40.9336, -87.138355, 1260, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1810, N'St Mary''s Warrick Hospital Inc', 1, NULL, NULL, N'151325', NULL, NULL, 0, 35, NULL, N'8128974800', N'8128977375', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1116 Millis Ave', N'Boonville', N'IN', N'18173', N'47601', 38.041317, -87.262584, 1201, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1811, N'Union Hospital Clinton', 1, NULL, NULL, N'151326', NULL, NULL, 0, 25, NULL, N'7658321234', N'7658321382', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 S Main St', N'Clinton', N'IN', N'18165', N'47842', 39.652926, -87.398213, 1205, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1812, N'Sullivan County Community Hospital', 1, NULL, NULL, N'151327', NULL, NULL, 0, 25, NULL, N'8122684311', N'8122682650', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 N Section St', N'Sullivan', N'IN', N'18153', N'47882', 39.116488, -87.409219, 1268, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1813, N'Indiana University Health Bedford Hospital', 1, NULL, NULL, N'151328', NULL, NULL, 0, 25, NULL, N'8122751200', N'8122751391', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 W 16Th St', N'Bedford', N'IN', N'18093', N'47421', 38.860988, -86.512167, 1197, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1814, N'Margaret Mary Health', 1, NULL, NULL, N'151329', NULL, NULL, 0, 25, NULL, N'8129346624', N'8129335017', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Mitchell Ave', N'Batesville', N'IN', N'18137', N'47006', 39.306057, -85.22283, 1196, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1815, N'Adams Memorial Hospital', 1, NULL, NULL, N'151330', NULL, NULL, 0, 50, NULL, N'2607242145', N'2607283865', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Mercer Ave', N'Decatur', N'IN', N'18001', N'46733', 40.817521, -84.912022, 1213, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1816, N'Harrison County Hospital', 1, NULL, NULL, N'151331', NULL, NULL, 0, 25, NULL, N'8127384251', N'8127387829', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1141 Hospital Dr Nw', N'Corydon', N'IN', N'18061', N'47112', 38.23898, -86.14774, 1209, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1817, N'Decatur County Memorial Hospital', 1, NULL, NULL, N'151332', NULL, NULL, 0, 25, NULL, N'8126634331', N'8126639738', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 N Lincoln St', N'Greensburg', N'IN', N'18031', N'47240', 39.344212, -85.479401, 1226, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1818, N'Putnam County Hospital', 1, NULL, NULL, N'151333', NULL, NULL, 0, 25, NULL, N'7656552620', N'7656552625', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1542 S Bloomington St', N'Greencastle', N'IN', N'18133', N'46135', 39.622102, -86.845955, 1224, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1819, N'Scott Memorial Hospital', 1, NULL, NULL, N'151334', NULL, NULL, 0, 25, NULL, N'8127523456', N'8127525884', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 N Gardner St', N'Scottsburg', N'IN', N'18143', N'47170', 38.703789, -85.785084, 1281, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1820, N'St Vincent Dunn Hospital Inc', 1, NULL, NULL, N'151335', NULL, NULL, 0, 25, NULL, N'8122753331', N'8122761265', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 23Rd St', N'Bedford', N'IN', N'18093', N'47421', 38.853488, -86.494527, 1197, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1821, N'Kindred Hospital Indianapolis', 1, NULL, NULL, N'152007', NULL, NULL, 0, 59, NULL, N'3176364400', N'3176364422', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 W 10Th St', N'Indianapolis', N'IN', N'18097', N'46222', 39.779669, -86.188224, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1822, N'Kindred Hospital- Indianapolis South', 1, NULL, NULL, N'152008', NULL, NULL, 0, 60, NULL, N'3178888155', N'3178887382', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 Greenwood Springs Drive', N'Greenwood', N'IN', N'18081', N'46143', 39.630666, -86.076528, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1823, N'Kindred Hospital Northwest Indiana', 1, NULL, NULL, N'152012', NULL, NULL, 0, 70, NULL, N'2198525305', N'2199332298', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5454 Hohman Ave  5Th Fl', N'Hammond', N'IN', N'18089', N'46320', 41.614478, -87.522126, 1227, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1824, N'Select Specialty Hospital- Indianapolis', 1, NULL, NULL, N'152013', NULL, NULL, 0, 45, NULL, N'3177826669', N'3177838913', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8060 Knue Road', N'Indianapolis', N'IN', N'18097', N'46250', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1825, N'Select Specialty Hospital-Evansville', 1, NULL, NULL, N'152014', NULL, NULL, 0, 60, NULL, N'8124212330', N'8124212333', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400  Se 4Th St', N'Evansville', N'IN', N'18163', N'47713', 37.968155, -87.568207, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1826, N'Select Specialty Hospital-Fort Wayne', 1, NULL, NULL, N'152016', NULL, NULL, 0, 32, NULL, N'2604253840', N'2604253812', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Broadway 7Th Fl E', N'Fort Wayne', N'IN', N'18003', N'46802', 41.07999, -85.138601, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1827, N'Kindred Hospital Northern Indiana', 1, NULL, NULL, N'152018', NULL, NULL, 0, 32, NULL, N'5742522000', N'5742522012', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 W 4Th St Ste 200', N'Mishawaka', N'IN', N'18141', N'46544', 41.661993, -86.158616, 1280, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1828, N'St Vincent Seton Specialty Hospital Indianapolis', 1, NULL, NULL, N'152020', NULL, NULL, 0, 74, NULL, N'3174158500', N'3174158400', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Township Line Rd', N'Indianapolis', N'IN', N'18097', N'46260', 39.9015143, -86.2053206, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1829, N'Regency Hospital Of Northwest Indiana', 1, NULL, NULL, N'152024', NULL, NULL, 0, 61, NULL, N'2193927799', N'2193984251', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Fir St 4Th Fl', N'East Chica', N'IN', N'18089', N'46312', 41.639786, -87.454847, 1215, 100, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1830, N'Central Indiana  Amg Specialty Hospital Llc', 1, NULL, NULL, N'152025', NULL, NULL, 0, 32, NULL, N'7657515253', N'7652897251', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W University Ave 8Th Fl', N'Muncie', N'IN', N'18035', N'47303', 40.19752, -85.414121, 1249, 99, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1831, N'Vibra Hospital Of Fort Wayne', 1, NULL, NULL, N'152027', NULL, NULL, 0, 48, NULL, N'2603992900', N'2603992958', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Randallia Drive 5Th Floor', N'Fort Wayne', N'IN', N'18003', N'46805', 41.07999, -85.138601, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1832, N'Vibra Hospital Of Northwestern Indiana', 1, NULL, NULL, N'152028', NULL, NULL, 0, 40, NULL, N'2194722200', N'2194722148', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9509 Georgia St', N'Crown Point', N'IN', N'18089', N'46307', 41.416981, -87.365314, 1211, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1833, N'Healthsouth Deaconess Rehabilitation Hospital', 1, NULL, NULL, N'153025', NULL, NULL, 0, 85, NULL, N'8124769983', N'8124764270', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 Covert Ave', N'Evansville', N'IN', N'18163', N'47714', 37.955103, -87.500086, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1834, N'Rehabilitation Hospital Of Indiana Inc', 1, NULL, NULL, N'153028', NULL, NULL, 0, 91, NULL, N'3173292000', N'3173292600', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4141 Shore Dr', N'Indianapolis', N'IN', N'18097', N'46254', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1835, N'Rehabilitation Hospital Of Fort Wayne General Par', 1, NULL, NULL, N'153030', NULL, NULL, 0, 36, NULL, N'2604356100', N'2604326128', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7970 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.03905, -85.243674, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1836, N'Southern Indiana Rehabilitation Hospital', 1, NULL, NULL, N'153037', NULL, NULL, 0, 60, NULL, N'8129416106', N'8129416276', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3104 Blackiston Blvd', N'New Albany', N'IN', N'18043', N'47150', 38.336141, -85.795314, 1251, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1837, N'Community Howard Specialty Hospital', 1, NULL, NULL, N'153039', NULL, NULL, 0, 30, NULL, N'7654526700', N'7654527470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'829 N Dixon Rd', N'Kokomo', N'IN', N'18067', N'46901', 40.487884, -86.164993, 1236, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1838, N'Lafayette Regional Rehabilitation Hospital', 1, NULL, NULL, N'153042', NULL, NULL, 0, 40, NULL, N'7654474040', N'7654474042', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 Park East Blvd', N'Lafayette', N'IN', N'18157', N'47905', 40.409822, -86.82901, 1237, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1839, N'Community Health Network Rehabilitation Hospital', 1, NULL, NULL, N'153043', NULL, NULL, 0, 60, NULL, N'3175855400', N'3175855470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7343 Clearvista Drive', N'Indianapolis', N'IN', N'18097', N'46256', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1840, N'River Bend Hospital', 1, NULL, NULL, N'154005', NULL, NULL, 0, 16, NULL, N'7654632555', N'3174973960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 N River Rd', N'West Lafayette', N'IN', N'18157', N'47906', 40.423684, -86.903318, 1237, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1841, N'Larue D Carter Memorial Hospital', 1, NULL, NULL, N'154008', NULL, NULL, 0, 159, NULL, N'3179414000', N'3179414010', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Cold Spring Rd', N'Indianapolis', N'IN', N'18097', N'46222', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1842, N'Hamilton Center Inc', 1, NULL, NULL, N'154009', NULL, NULL, 0, 16, NULL, N'8122318285', N'8122318411', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 8Th Ave', N'Terre Haute', N'IN', N'18167', N'47804', 39.484857, -87.409946, 1270, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1843, N'Community Mental Health Center Inc', 1, NULL, NULL, N'154011', NULL, NULL, 0, 16, NULL, N'8125371302', N'8125370194', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'285 Bielby Rd', N'Lawrenceburg', N'IN', N'18029', N'47025', 39.109506, -84.879328, 1240, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1844, N'Otis R Bowen Center For Human Services Inc', 1, NULL, NULL, N'154014', NULL, NULL, 0, 16, NULL, N'5742677169', N'5742693995', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1535 Provident Dr', N'Warsaw', N'IN', N'18085', N'46580', 41.252537, -85.830817, 1275, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1845, N'Richmond State Hospital', 1, NULL, NULL, N'154018', NULL, NULL, 0, 312, NULL, N'7659660511', N'3179664593', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'498 Nw 18Th St', N'Richmond', N'IN', N'18177', N'47374', 39.834613, -84.926969, 1261, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1846, N'Madison State Hospital', 1, NULL, NULL, N'154019', NULL, NULL, 0, 332, NULL, N'8122652611', N'8122657227', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Green Rd', N'Madison', N'IN', N'18077', N'47250', 38.761666, -85.399884, 1244, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1847, N'Regional Mental Health Center', 1, NULL, NULL, N'154020', NULL, NULL, 0, 16, NULL, N'2197694005', N'2197692508', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8555 Taft St', N'Merrillville', N'IN', N'18089', N'46410', 41.462641, -87.365077, 1222, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1848, N'Grant-Blackford Mental Health Inc', 1, NULL, NULL, N'154021', NULL, NULL, 0, 16, NULL, N'7656623971', N'7656627480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Wabash Ave', N'Marion', N'IN', N'18053', N'46952', 40.5082858, -85.7967816, 1245, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1849, N'Valle Vista Health System', 1, NULL, NULL, N'154024', NULL, NULL, 0, 96, NULL, N'3178835300', N'3178881104', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'898 E Main St', N'Greenwood', N'IN', N'18081', N'46143', 39.614298, -86.086703, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1850, N'Oaklawn Psychiatric Center Inc', 1, NULL, NULL, N'154031', NULL, NULL, 0, 16, NULL, N'5745331234', N'5745372673', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Lakeview Dr', N'shen', N'IN', N'18039', N'46527', 41.603388, -85.835353, 1223, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1851, N'Four County Counseling Center', 1, NULL, NULL, N'154035', NULL, NULL, 0, 15, NULL, N'5747225151', N'5747229523', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Michigan Ave', N'Logansport', N'IN', N'18017', N'46947', 40.76194, -86.361678, 1243, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1852, N'Bloomington Meadows Hospital', 1, NULL, NULL, N'154041', NULL, NULL, 0, 52, NULL, N'8123318000', N'8123318056', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 N Prow Rd', N'Bloomington', N'IN', N'18105', N'47404', 39.16704, -86.534288, 1199, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1853, N'Michiana Behavioral Health Center', 1, NULL, NULL, N'154047', NULL, NULL, 0, 51, NULL, N'5749363784', N'5749359076', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 N Oak Rd', N'Plymouth', N'IN', N'18099', N'46563', 41.337418, -86.328668, 1257, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1854, N'Northeastern Center', 1, NULL, NULL, N'154050', NULL, NULL, 0, 16, NULL, N'2609270726', N'2609270760', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Wesley Rd', N'Auburn', N'IN', N'18033', N'46706', 41.370269, -85.034319, 1195, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1855, N'Wellstone Regional Hospital', 1, NULL, NULL, N'154051', NULL, NULL, 0, 100, NULL, N'8122848000', N'8122581094', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Vissing Park Rd', N'Jeffersonville', N'IN', N'18019', N'47130', 38.328811, -85.711153, 1233, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1856, N'Porter-Starke Services Inc', 1, NULL, NULL, N'154052', NULL, NULL, 0, 16, NULL, N'2195313500', N'2194623975', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Wall St', N'Valparaiso', N'IN', N'18127', N'46383', 41.489191, -87.052707, 1272, 96, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1857, N'Meridian Services Corp', 1, NULL, NULL, N'154053', NULL, NULL, 0, 20, NULL, N'7657515377', N'7657511701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W University Ave', N'Muncie', N'IN', N'18035', N'47303', 40.19752, -85.414121, 1249, 99, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1858, N'Harsha Behavioral Center Inc', 1, NULL, NULL, N'154054', NULL, NULL, 0, 44, NULL, N'8122988888', N'8122315252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 E Crossing Blvd', N'Terre Haute', N'IN', N'18167', N'47802', 39.466703, -87.413912, 1270, 102, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1859, N'Brentwood Meadows Llc', 1, NULL, NULL, N'154055', NULL, NULL, 0, 48, NULL, N'8128587200', N'3178414425', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4488 Roslin Rd', N'Newburgh', N'IN', N'18173', N'47630', 37.945682, -87.404657, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1860, N'Evansville State Hospital', 1, NULL, NULL, N'154056', NULL, NULL, 0, 168, NULL, N'8124696800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Lincoln Avenue', N'Evansville', N'IN', N'18163', N'47714', 37.969729, -87.502237, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1861, N'Options Behavioral Health System', 1, NULL, NULL, N'154057', NULL, NULL, 0, 40, NULL, N'3175444340', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5602 Caito Drive', N'Indianapolis', N'IN', N'18097', N'46226', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1862, N'Doctors Neuropsychiatric Hospital', 1, NULL, NULL, N'154058', NULL, NULL, 0, 37, NULL, N'5745460330', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 S Whitlock St', N'Bremen', N'IN', N'18099', N'46506', 41.443328, -86.150076, 1203, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1863, N'Sycamore Springs', 1, NULL, NULL, N'154059', NULL, NULL, 0, 48, NULL, N'7657434400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'833 Park East Blvd', N'Lafayette', N'IN', N'18157', N'47905', 40.409822, -86.82901, 1237, 98, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1864, N'Park Center Inc', 1, NULL, NULL, N'154060', NULL, NULL, 0, 16, NULL, N'2604893543', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1909 Carew Street', N'Fort Wayne', N'IN', N'18003', N'46805', 41.0941588, -85.1115938, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1865, N'Rivercrest Specialty Hospital Llc', 1, NULL, NULL, N'154061', NULL, NULL, 0, 30, NULL, N'5744851703', N'5744851778', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 East Jefferson Blvd', N'Mishawaka', N'IN', N'18141', N'46545', 41.6730443, -86.1611229, 1267, 101, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1866, N'Assurance Health Psychiatric Hospital', 1, NULL, NULL, N'154062', NULL, NULL, 0, 22, NULL, N'3173726611', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2725 Enterprise Drive', N'Anderson', N'IN', N'18095', N'46013', 40.040383, -85.72159, 1193, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1867, N'Neuropsychiatric Hospital Of Indianapolis Llc', 1, NULL, NULL, N'154063', NULL, NULL, 0, 36, NULL, N'3176273137', N'3176532305', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6720 Parkdale Place Suite 100', N'Indianapolis', N'IN', N'18097', N'46254', 39.8264141, -86.2812057, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1868, N'Lutheran Hospital Of Indiana Th', 1, NULL, NULL, N'159801', NULL, NULL, 0, 0, NULL, N'2604357101', N'2604357632', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7950 W Jefferson Blvd', N'Fort Wayne', N'IN', N'18003', N'46804', 41.0388, -85.248702, 1219, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1869, N'St Vincent Hospital', 1, NULL, NULL, N'159802', NULL, NULL, 0, 0, NULL, N'3172809566', N'3173389710', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2001 W 86Th St', N'Indianapolis', N'IN', N'18097', N'46260', 39.768333, -86.15835, 1231, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1870, N'Indiana University Health Transplant', 1, NULL, NULL, N'159803', NULL, NULL, 0, 0, NULL, N'3179628677', N'3179625768', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1701 North Senate Blvd', N'Indianapolis', N'IN', N'18097', N'46206', 39.768333, -86.15835, 1198, 97, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1871, N'Evansville Psychiatric Children''s Center', 1, NULL, NULL, N'15J200', NULL, NULL, 0, 28, NULL, N'8124776436', N'8124744248', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 E Morgan Ave', N'Evansville', N'IN', N'18163', N'47715', 37.991484, -87.509252, 1218, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1872, N'Central Iowa Healthcare', 1, NULL, NULL, N'160001', NULL, NULL, 0, 70, NULL, N'6417545151', N'6418446208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 S 4Th Ave', N'Marshalltown', N'IA', N'19127', N'50158', 42.04849, -92.906348, 1340, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1873, N'St Anthony Regional Hospital & Nursing Home', 1, NULL, NULL, N'160005', NULL, NULL, 0, 142, NULL, N'7127923581', N'7127923119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 South Clark Street', N'Carroll', N'IA', N'19027', N'51401', 42.057042, -94.867956, 1291, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1874, N'Keokuk Area Hospital', 1, NULL, NULL, N'160008', NULL, NULL, 0, 71, NULL, N'3195247150', N'3195245317', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Morgan Street', N'Keokuk', N'IA', N'19111', N'52632', 40.406952, -91.388116, 1331, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1875, N'Trinity Muscatine', 1, NULL, NULL, N'160013', NULL, NULL, 0, 80, NULL, N'5632649100', N'5632649484', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1518 Mulberry Avenue', N'Muscatine', N'IA', N'19139', N'52761', 41.433948, -91.052402, 1344, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1876, N'Trinity Regional Medical Center', 1, NULL, NULL, N'160016', NULL, NULL, 0, 174, NULL, N'5155733101', N'5155738710', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 Kenyon Rd', N'Fort Dodge', N'IA', N'19187', N'50501', 42.489186, -94.192411, 1315, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1877, N'Iowa Lutheran Hospital', 1, NULL, NULL, N'160024', NULL, NULL, 0, 205, NULL, N'5152635612', N'5152635295', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East University Avenue', N'Des Moines', N'IA', N'19153', N'50316', 41.600395, -93.610853, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1878, N'Chi Health Mercy Council Bluffs', 1, NULL, NULL, N'160028', NULL, NULL, 0, 194, NULL, N'7123285000', N'7123252425', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Mercy Drive', N'Council Bluffs', N'IA', N'19155', N'51503', 41.267013, -95.835391, 1302, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1879, N'Mercy Hospital', 1, NULL, NULL, N'160029', NULL, NULL, 0, 234, NULL, N'3193390300', N'3193393788', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E Market Street', N'Iowa City', N'IA', N'19103', N'52245', 41.663541, -91.528684, 1328, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1880, N'Mary Greeley Medical Center', 1, NULL, NULL, N'160030', NULL, NULL, 0, 220, NULL, N'5152392011', N'5152392007', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Duff Avenue', N'Ames', N'IA', N'19169', N'50010', 42.032508, -93.61063, 1284, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1881, N'Skiff Medical Center', 1, NULL, NULL, N'160032', NULL, NULL, 0, 68, NULL, N'6417921273', N'6417914895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 N 4Th Ave E', N'Newton', N'IA', N'19099', N'50208', 41.702409, -93.052253, 1346, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1882, N'Genesis Medical Center-Davenport', 1, NULL, NULL, N'160033', NULL, NULL, 0, 502, NULL, N'5634211000', N'5634216500', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1227 East Rusholme Street', N'Davenport', N'IA', N'19163', N'52803', 41.542832, -90.556408, 1305, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1883, N'Sartori Memorial Hospital', 1, NULL, NULL, N'160040', NULL, NULL, 0, 83, NULL, N'3192683000', N'3192683270', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 College Street', N'Cedar Falls', N'IA', N'19013', N'50613', 42.533426, -92.455969, 1292, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1884, N'St Lukes Hospital', 1, NULL, NULL, N'160045', NULL, NULL, 0, 414, NULL, N'3193697211', N'3193698997', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 A Ave Ne', N'Cedar Rapids', N'IA', N'19113', N'52402', 41.985637, -91.659004, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1885, N'Methodist Jennie Edmundson', 1, NULL, NULL, N'160047', NULL, NULL, 0, 112, NULL, N'7123966000', N'7123966288', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'933 East Pierce Street', N'Council Bluffs', N'IA', N'19155', N'51503', 41.268398, -95.836045, 1302, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1886, N'Great River Medical Center', 1, NULL, NULL, N'160057', NULL, NULL, 0, 173, NULL, N'3197681000', N'3197683266', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 South Gear Avenue', N'West Burlington', N'IA', N'19057', N'52655', 40.805881, -91.170306, 1290, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1887, N'University Of Iowa Hospital & Clinics', 1, NULL, NULL, N'160058', NULL, NULL, 0, 1103, NULL, N'3193561616', N'3193563862', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hawkins Drive', N'Iowa City', N'IA', N'19103', N'52242', 41.660238, -91.550262, 1328, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1888, N'Mercy Medical Center-North Iowa', 1, NULL, NULL, N'160064', NULL, NULL, 0, 350, NULL, N'6414287000', N'6414287827', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Fourth Street Sw', N'Mason City', N'IA', N'19033', N'50401', 43.148377, -93.215987, 1341, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1889, N'Covenant Medical Center', 1, NULL, NULL, N'160067', NULL, NULL, 0, 423, NULL, N'3192728000', N'3192727313', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3421 West Ninth Street', N'Waterloo', N'IA', N'19013', N'50702', 42.463521, -92.346249, 1371, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1890, N'Mercy Medical Center-Dubuque', 1, NULL, NULL, N'160069', NULL, NULL, 0, 524, NULL, N'5635898000', N'5635898073', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Mercy Drive', N'Dubuque', N'IA', N'19061', N'52001', 42.492893, -90.674107, 1309, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1891, N'Mercy Medical Center - Cedar Rapids', 1, NULL, NULL, N'160079', NULL, NULL, 0, 347, NULL, N'3193986011', N'3193986912', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 10Th Street Se', N'Cedar Rapids', N'IA', N'19113', N'52403', 41.978785, -91.654674, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1892, N'Mercy Medical Center-Clinton', 1, NULL, NULL, N'160080', NULL, NULL, 0, 147, NULL, N'5632445555', N'5632445996', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1410 North 4Th Street', N'Clinton', N'IA', N'19045', N'52732', 41.860674, -90.188106, 1299, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1893, N'Iowa Methodist Medical Center', 1, NULL, NULL, N'160082', NULL, NULL, 0, 674, NULL, N'5152416212', N'5152415994', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Pleasant Street', N'Des Moines', N'IA', N'19153', N'50309', 41.588848, -93.631819, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1894, N'Mercy Medical Center-Des Moines', 1, NULL, NULL, N'160083', NULL, NULL, 0, 649, NULL, N'5152473121', N'5152478899', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 6Th Ave', N'Des Moines', N'IA', N'19153', N'50314', 41.598254, -93.625675, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1895, N'Ottumwa Regional Health Center', 1, NULL, NULL, N'160089', NULL, NULL, 0, 235, NULL, N'6416827511', N'6416842324', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 E Pennsylvania', N'Ottumwa', N'IA', N'19179', N'52501', 41.020015, -92.411296, 1353, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1896, N'Broadlawns Medical Center', 1, NULL, NULL, N'160101', NULL, NULL, 0, 200, NULL, N'5152822200', N'5152824580', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Hickman Road', N'Des Moines', N'IA', N'19153', N'50314', 41.615094, -93.642825, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1897, N'Trinity Bettendorf', 1, NULL, NULL, N'160104', NULL, NULL, 0, 150, NULL, N'5637425000', N'5637422005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Utica Ridge Road', N'Bettendorf', N'IA', N'19163', N'52722', 41.565701, -90.517364, 1305, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1898, N'Allen Hospital', 1, NULL, NULL, N'160110', NULL, NULL, 0, 234, NULL, N'3192353941', N'3192353906', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1825 Logan Avenue', N'Waterloo', N'IA', N'19013', N'50703', 42.525981, -92.337697, 1371, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1899, N'Spencer Municipal Hospital', 1, NULL, NULL, N'160112', NULL, NULL, 0, 93, NULL, N'7122648300', N'7122646404', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 1St Avenue East', N'Spencer', N'IA', N'19041', N'51301', 43.150188, -95.143849, 1366, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1900, N'Finley Hospital', 1, NULL, NULL, N'160117', NULL, NULL, 0, 158, NULL, N'5635821881', N'5635892562', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North Grandview Avenue', N'Dubuque', N'IA', N'19061', N'52001', 42.496189, -90.687662, 1309, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1901, N'Fort Madison Community Hospital', 1, NULL, NULL, N'160122', NULL, NULL, 0, 50, NULL, N'3193726530', N'3193729119', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5445 Ave O', N'Fort Madison', N'IA', N'19111', N'52627', 40.624245, -91.385706, 1316, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1902, N'Lakes Regional Healthcare', 1, NULL, NULL, N'160124', NULL, NULL, 0, 49, NULL, N'7123361230', N'7123368620', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Highway 71', N'Spirit Lake', N'IA', N'19059', N'51360', 43.417535, -95.126365, 1367, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1903, N'St Lukes Regional Medical Center', 1, NULL, NULL, N'160146', NULL, NULL, 0, 201, NULL, N'7122793500', N'7122797958', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2720 Stone Park Boulevard', N'Sioux City', N'IA', N'19193', N'51104', 42.518593, -96.406021, 1365, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1904, N'Grinnell Regional Medical Center', 1, NULL, NULL, N'160147', NULL, NULL, 0, 49, NULL, N'6412367511', N'6412362995', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Fourth Avenue', N'Grinnell', N'IA', N'19157', N'50112', 41.743278, -92.734319, 1318, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1905, N'Mercy Medical Center-Sioux City', 1, NULL, NULL, N'160153', NULL, NULL, 0, 267, NULL, N'7122792010', N'7122792034', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 5Th St', N'Sioux City', N'IA', N'19193', N'51101', 42.495276, -96.400456, 1365, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1906, N'Baum Harmon Mercy Hospital', 1, NULL, NULL, N'161300', NULL, NULL, 0, 14, NULL, N'7129572300', N'7127570300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 N Welch Avenue', N'Primghar', N'IA', N'19141', N'51245', 43.08868, -95.622824, 1357, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1907, N'Iowa Specialty Hospital - Belmond', 1, NULL, NULL, N'161301', NULL, NULL, 0, 25, NULL, N'6414443223', N'6414445614', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 First Street Se', N'Belmond', N'IA', N'19197', N'50421', 42.844996, -93.612976, 1341, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1908, N'Iowa Specialty Hospital-Clarion', 1, NULL, NULL, N'161302', NULL, NULL, 0, 25, NULL, N'5155322811', N'5155323443', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1316 South Main Street', N'Clarion', N'IA', N'19197', N'50525', 42.721637, -93.732628, 1298, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1909, N'Grundy County Memorial Hospital', 1, NULL, NULL, N'161303', NULL, NULL, 0, 25, NULL, N'3198245421', N'3198246291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East J Avenue', N'Grundy Center', N'IA', N'19075', N'50638', 42.35876, -92.761719, 1371, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1910, N'Chi Health  - Mercy Corning', 1, NULL, NULL, N'161304', NULL, NULL, 0, 22, NULL, N'6413223121', N'6413223616', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 Rosary Drive', N'Corning', N'IA', N'19003', N'50841', 40.988599, -94.747914, 1300, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1911, N'Pocahontas Community Hospital', 1, NULL, NULL, N'161305', NULL, NULL, 0, 25, NULL, N'7123353501', N'7123354745', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 N W 7Th Street', N'Pocahontas', N'IA', N'19151', N'50574', 42.740783, -94.678781, 1356, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1912, N'Jones Regional Medical Center', 1, NULL, NULL, N'161306', NULL, NULL, 0, 25, NULL, N'3194626131', N'3194816332', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1795 Highway 64 East', N'Anamosa', N'IA', N'19105', N'52205', 42.102247, -91.261961, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1913, N'Hancock County Health System', 1, NULL, NULL, N'161307', NULL, NULL, 0, 25, NULL, N'6418435000', N'6418435100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 1St St Nw', N'Britt', N'IA', N'19081', N'50423', 43.097818, -93.807018, 1289, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1914, N'Franklin General Hospital', 1, NULL, NULL, N'161308', NULL, NULL, 0, 77, NULL, N'6414565000', N'6414565005', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 Central Avenue East', N'Hampton', N'IA', N'19069', N'50441', 42.7402, -93.185063, 1322, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1915, N'Chi Health Missouri Valley', 1, NULL, NULL, N'161309', NULL, NULL, 0, 25, NULL, N'7126422784', N'7126429259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 N 8Th St', N'Missouri Valley', N'IA', N'19085', N'51555', 41.563184, -95.885106, 1342, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1916, N'Adair County Memorial Hospital', 1, NULL, NULL, N'161310', NULL, NULL, 0, 25, NULL, N'6417432123', N'6417437292', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 Se Kent', N'Greenfield', N'IA', N'19001', N'50849', 41.303091, -94.451868, 1317, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1917, N'Hawarden Regional Healthcare', 1, NULL, NULL, N'161311', NULL, NULL, 0, 25, NULL, N'7125513100', N'7125513106', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 11Th Street', N'Hawarden', N'IA', N'19167', N'51023', 42.99803, -96.479631, 1324, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1918, N'Guttenberg Municipal Hospital', 1, NULL, NULL, N'161312', NULL, NULL, 0, 25, NULL, N'5632521121', N'5632523955', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Main Street', N'Guttenberg', N'IA', N'19043', N'52052', 42.78552, -91.099993, 1320, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1919, N'Genesis Medical Center-Dewitt', 1, NULL, NULL, N'161313', NULL, NULL, 0, 90, NULL, N'5636594200', N'5636594201', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1118 11Th Street', N'Dewitt', N'IA', N'19045', N'52742', 41.825789, -90.54734, 1305, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1920, N'Guthrie County Hospital', 1, NULL, NULL, N'161314', NULL, NULL, 0, 25, NULL, N'6413322201', N'6417472702', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 North 12Th Street', N'Guthrie Center', N'IA', N'19077', N'50115', 41.683596, -94.494516, 1319, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1921, N'Keokuk County Health Center', 1, NULL, NULL, N'161315', NULL, NULL, 0, 14, NULL, N'6416222720', N'6416221187', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23019 Highway 149', N'Siurney', N'IA', N'19107', N'52591', 41.322894, -92.20512, 1328, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1922, N'Palmer Lutheran Health Center', 1, NULL, NULL, N'161316', NULL, NULL, 0, 25, NULL, N'5634223811', N'5634229754', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 Jefferson Street', N'West Union', N'IA', N'19065', N'52175', 42.967682, -91.808591, 1375, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1923, N'Maren Memorial Hospital', 1, NULL, NULL, N'161317', NULL, NULL, 0, 25, NULL, N'3196425543', N'3196428069', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W May St', N'Maren', N'IA', N'19095', N'52301', 41.801748, -92.072684, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1924, N'Veterans Memorial Hospital', 1, NULL, NULL, N'161318', NULL, NULL, 0, 25, NULL, N'5635683411', N'5635685550', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 1St Street Se', N'Waukon', N'IA', N'19005', N'52172', 43.267893, -91.473382, 1372, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1925, N'Central Community Hospital', 1, NULL, NULL, N'161319', NULL, NULL, 0, 25, NULL, N'5632457000', N'5632457080', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Davidson Street Nw', N'Elkader', N'IA', N'19043', N'52043', 42.859692, -91.414588, 1311, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1926, N'Community Memorial Hospital Medical Center', 1, NULL, NULL, N'161320', NULL, NULL, 0, 25, NULL, N'5635783275', N'3195783279', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 West First Street', N'Sumner', N'IA', N'19017', N'50674', 42.847425, -92.109316, 1369, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1927, N'Sanford Rock Rapids Medical Center', 1, NULL, NULL, N'161321', NULL, NULL, 0, 25, NULL, N'7124722591', N'7124726199', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 South Greene Street', N'Rock Rapids', N'IA', N'19119', N'51246', 43.424141, -96.171015, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1928, N'Dallas County Hospital', 1, NULL, NULL, N'161322', NULL, NULL, 0, 25, NULL, N'5154653547', N'5154657654', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Tenth Street', N'Perry', N'IA', N'19049', N'50220', 41.833838, -94.094468, 1355, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1929, N'Mitchell County Regional Health', 1, NULL, NULL, N'161323', NULL, NULL, 0, 25, NULL, N'6417326000', N'6417326028', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'616 North Eighth Street', N'Osage', N'IA', N'19131', N'50461', 43.289113, -92.809483, 1350, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1930, N'George C Grape Community Hospital', 1, NULL, NULL, N'161324', NULL, NULL, 0, 25, NULL, N'7123821515', N'7123822023', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2959 Us Highway 275', N'Hamburg', N'IA', N'19071', N'51640', 40.623195, -95.64938, 1321, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1931, N'Greene County Medical Center', 1, NULL, NULL, N'161325', NULL, NULL, 0, 25, NULL, N'5153862114', N'5153863271', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Lincolnway', N'Jefferson', N'IA', N'19073', N'50129', 42.015225, -94.388746, 1330, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1932, N'Madison County Memorial Hospital', 1, NULL, NULL, N'161326', NULL, NULL, 0, 25, NULL, N'5154622373', N'5154629060', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West Hutchings Street', N'Winterset', N'IA', N'19121', N'50273', 41.328815, -94.017015, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1933, N'Davis County Hospital', 1, NULL, NULL, N'161327', NULL, NULL, 0, 25, NULL, N'6416642145', N'6416641669', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 North Madison Street', N'Bloomfield', N'IA', N'19051', N'52537', 40.759539, -92.41459, 1287, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1934, N'Regional Health Services Of Howard County', 1, NULL, NULL, N'161328', NULL, NULL, 0, 25, NULL, N'5635472101', N'5635473448', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 8Th Avenue West', N'Cresco', N'IA', N'19089', N'52136', 43.381802, -92.117066, 1303, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1935, N'Jackson County Regional Health Center', 1, NULL, NULL, N'161329', NULL, NULL, 0, 25, NULL, N'5636522474', N'5636524073', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W Grove St', N'Maquoketa', N'IA', N'19097', N'52060', 42.073715, -90.673315, 1339, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1936, N'Audubon County Memorial Hospital', 1, NULL, NULL, N'161330', NULL, NULL, 0, 25, NULL, N'7125632611', N'7125635277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Pacific Street', N'Audubon', N'IA', N'19009', N'50025', 41.715107, -94.937034, 1286, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1937, N'Mercy Medical Center-New Hampton', 1, NULL, NULL, N'161331', NULL, NULL, 0, 25, NULL, N'6413944121', N'6413941669', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 North Maple Avenue', N'New Hampton', N'IA', N'19037', N'50659', 43.062063, -92.320436, 1345, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1938, N'Manning Regional Healthcare Center', 1, NULL, NULL, N'161332', NULL, NULL, 0, 17, NULL, N'7126552072', N'7126553330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 Sixth Street', N'Manning', N'IA', N'19027', N'51455', 41.909153, -95.064992, 1338, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1939, N'Story County Hospital', 1, NULL, NULL, N'161333', NULL, NULL, 0, 25, NULL, N'5153822111', N'5153827760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 South 19Th Street', N'Nevada', N'IA', N'19169', N'50201', 42.004963, -93.434907, 1284, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1940, N'Humboldt County Memorial Hospital', 1, NULL, NULL, N'161334', NULL, NULL, 0, 21, NULL, N'5153324200', N'5153324820', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North 15Th Street', N'Humboldt', N'IA', N'19091', N'50548', 42.730768, -94.230157, 1325, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1941, N'Buchanan County Health Center', 1, NULL, NULL, N'161335', NULL, NULL, 0, 25, NULL, N'3193320999', N'3193320958', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 First St East', N'Independence', N'IA', N'19019', N'50644', 42.468785, -91.87371, 1327, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1942, N'Hegg Memorial Health Center', 1, NULL, NULL, N'161336', NULL, NULL, 0, 25, NULL, N'7124768000', N'7124768024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 21St Avenue', N'Rock Valley', N'IA', N'19167', N'51247', 43.201389, -96.285075, 1359, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1943, N'Van Buren County Hospital', 1, NULL, NULL, N'161337', NULL, NULL, 0, 25, NULL, N'3192933171', N'3192936314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Franklin Street', N'Keosauqua', N'IA', N'19177', N'52565', 40.736216, -91.959682, 1332, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1944, N'Mercy Hospital Of Franciscan Sisters-Oelwein', 1, NULL, NULL, N'161338', NULL, NULL, 0, 25, NULL, N'3192836000', N'3192836004', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Eighth Avenue Se', N'Oelwein', N'IA', N'19065', N'50662', 42.675168, -91.902617, 1347, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1945, N'Waverly Health Center', 1, NULL, NULL, N'161339', NULL, NULL, 0, 25, NULL, N'3193524120', N'3193523992', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312  9Th Street Sw', N'Waverly', N'IA', N'19017', N'50677', 42.723726, -92.481779, 1373, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1946, N'Decatur County Hospital', 1, NULL, NULL, N'161340', NULL, NULL, 0, 25, NULL, N'6414464871', N'6414462201', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Nw Church Street', N'Leon', N'IA', N'19053', N'50144', 40.751843, -93.747771, 1336, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1947, N'Lucas County Health Center', 1, NULL, NULL, N'161341', NULL, NULL, 0, 25, NULL, N'6417743000', N'6417743233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North 7Th Street', N'Chariton', N'IA', N'19117', N'50049', 41.027761, -93.303422, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1948, N'Monroe County Hospital', 1, NULL, NULL, N'161342', NULL, NULL, 0, 25, NULL, N'6419322134', N'6419321665', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6580 165Th Street', N'Albia', N'IA', N'19135', N'52531', 41.045015, -92.784768, 1282, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1949, N'Regional Medical Center', 1, NULL, NULL, N'161343', NULL, NULL, 0, 25, NULL, N'5639273232', N'5639277577', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 W Main Street', N'Manchester', N'IA', N'19055', N'52057', 42.483903, -91.466826, 1337, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1950, N'Washington County Hospital And Clinics', 1, NULL, NULL, N'161344', NULL, NULL, 0, 25, NULL, N'3196535481', N'3198633976', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Polk Street', N'Washington', N'IA', N'19183', N'52353', 41.288525, -91.68576, 1370, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1951, N'Osceola Community Hospital', 1, NULL, NULL, N'161345', NULL, NULL, 0, 25, NULL, N'7127542574', N'7127542151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 9Th Avenue North', N'Sibley', N'IA', N'19143', N'51249', 43.41008, -95.741727, 1363, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1952, N'Sioux Center Health', 1, NULL, NULL, N'161346', NULL, NULL, 0, 25, NULL, N'7127221271', N'7127224107', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 9Th Street Se', N'Sioux Center', N'IA', N'19167', N'51250', 43.069685, -96.158136, 1364, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1953, N'Floyd County Medical Center', 1, NULL, NULL, N'161347', NULL, NULL, 0, 25, NULL, N'6412286830', N'6412574386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 11Th St', N'Charles City', N'IA', N'19067', N'50616', 43.052661, -92.685044, 1295, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1954, N'Clarke County Hospital', 1, NULL, NULL, N'161348', NULL, NULL, 0, 25, NULL, N'6413422184', N'6413425331', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Fillmore St', N'Osceola', N'IA', N'19039', N'50213', 41.025964, -93.767536, 1351, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1955, N'Virginia Gay Hospital', 1, NULL, NULL, N'161349', NULL, NULL, 0, 83, NULL, N'3194726200', N'3194726321', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 North 9Th Avenue', N'Vinton', N'IA', N'19011', N'52349', 42.175848, -92.013322, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1956, N'Stewart Memorial Community Hospital', 1, NULL, NULL, N'161350', NULL, NULL, 0, 25, NULL, N'7124643171', N'7124643269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 West Main Street', N'Lake City', N'IA', N'19025', N'51449', 42.26727, -94.746423, 1334, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1957, N'Avera Holy Family Hospital', 1, NULL, NULL, N'161351', NULL, NULL, 0, 25, NULL, N'7123622631', N'7123626183', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826 North 8Th Street', N'Estherville', N'IA', N'19063', N'51334', 43.410731, -94.833863, 1313, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1958, N'Clarinda Regional Health Center', 1, NULL, NULL, N'161352', NULL, NULL, 0, 25, NULL, N'7125422176', N'7125423380', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Essie Davison Drive', N'Clarinda', N'IA', N'19145', N'51632', 40.723116, -95.041406, 1297, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1959, N'Kossuth Regional Health Center', 1, NULL, NULL, N'161353', NULL, NULL, 0, 25, NULL, N'5152952451', N'5152959515', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 South Phillips Street', N'Alna', N'IA', N'19109', N'50511', 43.059814, -94.227041, 1283, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1960, N'Horn Memorial Hospital', 1, NULL, NULL, N'161354', NULL, NULL, 0, 25, NULL, N'7123643311', N'7123643363', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 E 2Nd St', N'Ida Grove', N'IA', N'19093', N'51445', 42.340656, -95.460265, 1326, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1961, N'Knoxville Hospital & Clinics', 1, NULL, NULL, N'161355', NULL, NULL, 0, 25, NULL, N'6418422151', N'6418421470', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 South Lincoln Street', N'Knoxville', N'IA', N'19125', N'50138', 41.310285, -93.109504, 1333, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1962, N'Henry County Health Center', 1, NULL, NULL, N'161356', NULL, NULL, 0, 74, NULL, N'3193853141', N'3193856731', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 S White St', N'Mount Pleasant', N'IA', N'19087', N'52641', 40.96368, -91.557921, 1343, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1963, N'Palo Alto County Hospital', 1, NULL, NULL, N'161357', NULL, NULL, 0, 25, NULL, N'7128525500', N'7128525409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 1St Street', N'Emmetsburg', N'IA', N'19147', N'50536', 43.119198, -94.693118, 1312, 108, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1964, N'Wayne County Hospital', 1, NULL, NULL, N'161358', NULL, NULL, 0, 25, NULL, N'6418722260', N'6418723116', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'417 South East Street', N'Corydon', N'IA', N'19185', N'50060', 40.753425, -93.312391, 1301, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1965, N'Burgess Health Center', 1, NULL, NULL, N'161359', NULL, NULL, 0, 25, NULL, N'7124232311', N'7124239199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Diamond Street', N'Onawa', N'IA', N'19133', N'51040', 42.025739, -96.105586, 1348, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1966, N'Orange City Area Health System', 1, NULL, NULL, N'161360', NULL, NULL, 0, 25, NULL, N'7127374984', N'7127375291', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Lincoln Circle Se', N'Orange City', N'IA', N'19167', N'51041', 43.007242, -96.058314, 1349, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1967, N'Van Diest Medical Center', 1, NULL, NULL, N'161361', NULL, NULL, 0, 25, NULL, N'5158329400', N'5158329420', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2350 Hospital Drive', N'Webster City', N'IA', N'19079', N'50595', 42.453559, -93.813469, 1374, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1968, N'Cherokee Regional Medical Center', 1, NULL, NULL, N'161362', NULL, NULL, 0, 25, NULL, N'7122255101', N'7122256870', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Sioux Valley Drive', N'Cherokee', N'IA', N'19035', N'51012', 42.759106, -95.547251, 1296, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1969, N'Montmery County Memorial Hospital', 1, NULL, NULL, N'161363', NULL, NULL, 0, 25, NULL, N'7126237000', N'7122637228', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Eastern Avenue', N'Red Oak', N'IA', N'19137', N'51566', 41.026557, -95.213919, 1358, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1970, N'Jefferson County Health Center', 1, NULL, NULL, N'161364', NULL, NULL, 0, 25, NULL, N'6414724111', N'6414694375', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 S Main', N'Fairfield', N'IA', N'19101', N'52556', 40.989349, -91.963083, 1314, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1971, N'Greater Regional Medical Center', 1, NULL, NULL, N'161365', NULL, NULL, 0, 25, NULL, N'6417827091', N'6417823866', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 West Townline Road', N'Creston', N'IA', N'19175', N'50801', 41.071214, -94.383777, 1304, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1972, N'Shenandoah Medical Center', 1, NULL, NULL, N'161366', NULL, NULL, 0, 25, NULL, N'7122461230', N'7122467357', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Pershing Avenue', N'Shenandoah', N'IA', N'19145', N'51601', 40.753639, -95.369029, 1362, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1973, N'Pella Regional Health Center', 1, NULL, NULL, N'161367', NULL, NULL, 0, 25, NULL, N'6416283150', N'5156287241', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 Jefferson Street', N'Pella', N'IA', N'19125', N'50219', 41.412337, -92.911201, 1354, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1974, N'Floyd Valley Hospital', 1, NULL, NULL, N'161368', NULL, NULL, 0, 25, NULL, N'7125467871', N'7125463352', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'714 Lincoln St Ne', N'Le Mars', N'IA', N'19149', N'51031', 42.798689, -96.152831, 1335, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1975, N'Crawford County Memorial Hospital', 1, NULL, NULL, N'161369', NULL, NULL, 0, 25, NULL, N'7122652500', N'7122652511', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Parkway', N'Denison', N'IA', N'19047', N'51442', 42.023257, -95.377086, 1307, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1976, N'Loring Hospital', 1, NULL, NULL, N'161370', NULL, NULL, 0, 25, NULL, N'7126627105', N'7126626418', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Highland Avenue Po Box 217', N'Sac City', N'IA', N'19161', N'50583', 42.419946, -94.97797, 1360, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1977, N'Winneshiek Medical Center', 1, NULL, NULL, N'161371', NULL, NULL, 0, 25, NULL, N'5633822911', N'5633873102', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Montmery Street', N'Decorah', N'IA', N'19191', N'52101', 43.294785, -91.771295, 1306, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1978, N'Boone County Hospital', 1, NULL, NULL, N'161372', NULL, NULL, 0, 25, NULL, N'5154323140', N'5154338926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Union Street', N'Boone', N'IA', N'19015', N'50036', 42.055576, -93.877607, 1288, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1979, N'Ringld County Hospital', 1, NULL, NULL, N'161373', NULL, NULL, 0, 25, NULL, N'6414643226', N'6414644414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 North Cleveland Street', N'Mount Ayr', N'IA', N'19159', N'50854', 40.717794, -94.223599, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1980, N'Myrtue Medical Center', 1, NULL, NULL, N'161374', NULL, NULL, 0, 25, NULL, N'7127555161', N'7127554412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1213 Garfield Avenue', N'Harlan', N'IA', N'19165', N'51537', 41.647497, -95.327287, 1323, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1981, N'Buena Vista Regional Medical Center', 1, NULL, NULL, N'161375', NULL, NULL, 0, 35, NULL, N'7127324030', N'7122131233', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 West 5Th Street', N'Storm Lake', N'IA', N'19021', N'50588', 42.644353, -95.223384, 1368, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1982, N'Cass County Memorial Hospital', 1, NULL, NULL, N'161376', NULL, NULL, 0, 33, NULL, N'7122433250', N'7122437587', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 East Tenth Street', N'Atlantic', N'IA', N'19029', N'50022', 41.402058, -94.992074, 1285, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1983, N'Mercy Medical Center-Centerville', 1, NULL, NULL, N'161377', NULL, NULL, 0, 25, NULL, N'6414374111', N'6414373304', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Joseph''s Drive', N'Centerville', N'IA', N'19007', N'52544', 40.73418, -92.874088, 1294, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1984, N'Mercy Medical Center-Dyersville', 1, NULL, NULL, N'161378', NULL, NULL, 0, 25, NULL, N'5638757101', N'5638752957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 3Rd Street Sw', N'Dyersville', N'IA', N'19061', N'52040', 42.475915, -91.129635, 1309, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1985, N'Mahaska  Health Partnership', 1, NULL, NULL, N'161379', NULL, NULL, 0, 33, NULL, N'6416723100', N'6416723339', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1229 C Avenue East', N'Oskaloosa', N'IA', N'19123', N'52577', 41.298559, -92.630634, 1352, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1986, N'Hansen Family Hospital', 1, NULL, NULL, N'161380', NULL, NULL, 0, 35, NULL, N'6416484631', N'6416482850', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 South Oak Street', N'Iowa Falls', N'IA', N'19083', N'50126', 42.500939, -93.262394, 1329, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1987, N'Sanford Sheldon Medical Center', 1, NULL, NULL, N'161381', NULL, NULL, 0, 25, NULL, N'7123245041', N'7123246025', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 North 7Th Avenue', N'Sheldon', N'IA', N'19141', N'51201', 43.186329, -95.847182, 1361, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1988, N'Select Specialty Hospital - Quad Cities', 1, NULL, NULL, N'162001', NULL, NULL, 0, 50, NULL, N'5634682000', N'5633868175', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 West Kimberly Road', N'Davenport', N'IA', N'19163', N'52806', 41.560274, -90.575314, 1305, 104, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1989, N'Continuing Care Hospital', 1, NULL, NULL, N'162002', NULL, NULL, 0, 24, NULL, N'3193698142', N'3192864320', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 A Avenue Northeast Sixth Floor', N'Cedar Rapids', N'IA', N'19113', N'52402', 41.975887, -91.670405, 1293, 103, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1990, N'Select Specialty Hospital - Des Moines', 1, NULL, NULL, N'162003', NULL, NULL, 0, 30, NULL, N'5152474400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 6Th Avenue 4Th Floor Main', N'Des Moines', N'IA', N'19153', N'50314', 41.597811, -93.625562, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1991, N'Mental Health Institute', 1, NULL, NULL, N'164002', NULL, NULL, 0, 97, NULL, N'7122252594', N'7122256933', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1251 North Cedar Loop', N'Cherokee', N'IA', N'19035', N'51012', 42.749428, -95.551674, 1296, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1992, N'Mental Health Institute', 1, NULL, NULL, N'164003', NULL, NULL, 0, 130, NULL, N'3193342583', N'3193345252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2277 Iowa Avenue', N'Independence', N'IA', N'19019', N'50644', 42.468598, -91.889339, 1327, 110, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1993, N'Iowa Methodist Medical Center Transplant Center', 1, NULL, NULL, N'169800', NULL, NULL, 0, 0, NULL, N'5152416212', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Pleasant Street', N'Des Moines', N'IA', N'19153', N'50309', 41.589777, -93.636535, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1994, N'Mercy Hospital Medical Center - Transplant', 1, NULL, NULL, N'169801', NULL, NULL, 0, 0, NULL, N'5152474261', N'5156438870', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1111 Sixth Ave', N'Des Moines', N'IA', N'19153', N'50314', 41.591064, -93.603715, 1308, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1995, N'The University Of Iowa Hospitals And Clinics', 1, NULL, NULL, N'169802', NULL, NULL, 0, 0, NULL, N'3193560537', N'3193561556', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Hawkins Drive', N'Iowa City', N'IA', N'19103', N'52242', 41.657527, -91.549811, 1328, 107, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1996, N'Via Christi Hospital Pittsburg Inc', 1, NULL, NULL, N'170006', NULL, NULL, 0, 168, NULL, N'6202316100', N'6202320493', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Mt Carmel Way', N'Pittsburg', N'KS', N'20037', N'66762', 37.38153, -94.68385, 1462, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1997, N'Saint John Hospital', 1, NULL, NULL, N'170009', NULL, NULL, 0, 76, NULL, N'9136806000', N'9135964098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 South 4Th Street', N'Leavenworth', N'KS', N'20103', N'66048', 39.283709, -94.903489, 1435, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1998, N'Salina Regional Health Center', 1, NULL, NULL, N'170012', NULL, NULL, 0, 353, NULL, N'7854527000', N'7854526963', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 South Santa Fe Avenue', N'Salina', N'KS', N'20169', N'67401', 38.834346, -97.609162, 1469, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (1999, N'Hays Medical Center', 1, NULL, NULL, N'170013', NULL, NULL, 0, 194, NULL, N'7856235000', N'7856232291', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Canterbury Drive', N'Hays', N'KS', N'20051', N'67601', 38.880328, -99.299245, 1413, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2000, N'Ransom Memorial Hospital', 1, NULL, NULL, N'170014', NULL, NULL, 0, 49, NULL, N'7852298200', N'7852298416', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 S Main Street', N'Ottawa', N'KS', N'20059', N'66067', 38.597285, -95.268759, 1459, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2001, N'St Francis Health Center Inc', 1, NULL, NULL, N'170016', NULL, NULL, 0, 378, NULL, N'7852958000', N'7852955479', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Sw 7Th Street', N'Topeka', N'KS', N'20177', N'66606', 39.055992, -95.696248, 1479, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2002, N'Susan B Allen Memorial Hospital', 1, NULL, NULL, N'170017', NULL, NULL, 0, 80, NULL, N'3163224557', N'3163212916', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 W Central St', N'El Dorado', N'KS', N'20015', N'67042', 37.817438, -96.858789, 1396, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2003, N'Hutchinson Regional Medical Center Inc', 1, NULL, NULL, N'170020', NULL, NULL, 0, 199, NULL, N'6206652001', N'6205133811', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 E 23Rd Avenue', N'Hutchinson', N'KS', N'20155', N'67502', 38.079454, -97.894601, 1422, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2004, N'Atchison Hospital', 1, NULL, NULL, N'170022', NULL, NULL, 0, 74, NULL, N'9133676600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Second Street', N'Atchison', N'KS', N'20005', N'66002', 39.563372, -95.121291, 1380, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2005, N'St Catherine Hospital', 1, NULL, NULL, N'170023', NULL, NULL, 0, 132, NULL, N'6202722222', N'6202722566', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Spruce', N'Garden City', N'KS', N'20055', N'67846', 37.968892, -100.868727, 1404, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2006, N'Pratt Regional Medical Center', 1, NULL, NULL, N'170027', NULL, NULL, 0, 69, NULL, N'6204501160', N'6206722113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Commodore St', N'Pratt', N'KS', N'20151', N'67124', 37.644873, -98.72912, 1464, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2007, N'Sumner Regional Medical Center', 1, NULL, NULL, N'170039', NULL, NULL, 0, 62, NULL, N'6203267451', N'6203262225', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1323 North A Street', N'Wellington', N'KS', N'20191', N'67152', 37.278353, -97.394259, 1485, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2008, N'University Of Kansas Hospital', 1, NULL, NULL, N'170040', NULL, NULL, 0, 620, NULL, N'9135887332', N'9135881280', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Rainbow Blvd', N'Kansas City', N'KS', N'20209', N'66103', 39.056189, -94.611793, 1428, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2009, N'Olathe Medical Center', 1, NULL, NULL, N'170049', NULL, NULL, 0, 300, NULL, N'9137914200', N'9137914313', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20333 West 151St Street', N'Olathe', N'KS', N'20091', N'66061', 38.854524, -94.823673, 1456, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2010, N'Mercy Hospital-Fort Scott', 1, NULL, NULL, N'170058', NULL, NULL, 0, 49, NULL, N'6202237057', N'6202235327', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Woodland Hills Blvd', N'Fort Scott', N'KS', N'20011', N'66701', 37.808317, -94.705344, 1402, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2011, N'Southwest Medical Center', 1, NULL, NULL, N'170068', NULL, NULL, 0, 80, NULL, N'6206296291', N'6206292425', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 West 15Th Street', N'Liberal', N'KS', N'20175', N'67901', 37.054208, -100.926103, 1437, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2012, N'Geary Community Hospital', 1, NULL, NULL, N'170074', NULL, NULL, 0, 92, NULL, N'7852384131', N'7852103444', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 St Mary''s Road', N'Junction City', N'KS', N'20061', N'66441', 39.013972, -96.849802, 1427, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2013, N'Mercy Hospital', 1, NULL, NULL, N'170075', NULL, NULL, 0, 21, NULL, N'6203456391', N'6203456344', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 E Pack St', N'Moundridge', N'KS', N'20113', N'67107', 38.205072, -97.517003, 1449, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2014, N'Stormont-Vail Healthcare', 1, NULL, NULL, N'170086', NULL, NULL, 0, 506, NULL, N'7853546121', N'7853545361', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sw 10Th St', N'Topeka', N'KS', N'20177', N'66604', 39.049011, -95.677556, 1479, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2015, N'Coffey County Hospital', 1, NULL, NULL, N'170094', NULL, NULL, 0, 36, NULL, N'6203642121', N'6203648425', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 North 4Th Street', N'Burlington', N'KS', N'20031', N'66839', 38.201744, -95.738569, 1384, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2016, N'Newton Medical Center', 1, NULL, NULL, N'170103', NULL, NULL, 0, 55, NULL, N'3162832700', N'3168046260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Medical Center Drive', N'Newton', N'KS', N'20079', N'67114', 38.023034, -97.33654, 1452, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2017, N'Shawnee Mission Medical Center', 1, NULL, NULL, N'170104', NULL, NULL, 0, 363, NULL, N'9136762151', N'9136767792', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9100 W 74Th Street', N'Shawnee Mission', N'KS', N'20091', N'66204', 38.995129, -94.692586, 1474, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2018, N'Mcpherson Hospital Inc', 1, NULL, NULL, N'170105', NULL, NULL, 0, 49, NULL, N'6202412250', N'6207982613', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Hospital Drive', N'Mcpherson', N'KS', N'20113', N'67460', 38.378265, -97.672311, 1444, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2019, N'Miami County Medical Center', 1, NULL, NULL, N'170109', NULL, NULL, 0, 39, NULL, N'9135574385', N'9132949897', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Baptiste Drive', N'Paola', N'KS', N'20121', N'66071', 38.568355, -94.85047, 1456, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2020, N'Bob Wilson Memorial Grant County Hospital', 1, NULL, NULL, N'170110', NULL, NULL, 0, 45, NULL, N'6203561266', N'6204246314', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 N Main Street', N'Ulysses', N'KS', N'20067', N'67880', 37.583878, -101.358015, 1481, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2021, N'Labette Health', 1, NULL, NULL, N'170120', NULL, NULL, 0, 109, NULL, N'6204214880', N'6208205042', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1902 South Us Hwy 59', N'Parsons', N'KS', N'20099', N'67357', 37.32387, -95.26454, 1460, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2022, N'Via Christi Hospitals Wichita Inc', 1, NULL, NULL, N'170122', NULL, NULL, 0, 1268, NULL, N'3162685000', N'3162917363', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'929 North St Francis Street', N'Wichita', N'KS', N'20173', N'67214', 37.700278, -97.331708, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2023, N'Wesley Medical Center', 1, NULL, NULL, N'170123', NULL, NULL, 0, 520, NULL, N'3169622000', N'3169627076', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 N Hillside Street', N'Wichita', N'KS', N'20173', N'67214', 37.695119, -97.299055, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2024, N'Saint Luke''s Cushing Hospital', 1, NULL, NULL, N'170133', NULL, NULL, 0, 58, NULL, N'9136841102', N'9136841239', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Marshall Street', N'Leavenworth', N'KS', N'20103', N'66048', 39.307812, -94.919334, 1435, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2025, N'Lawrence Memorial Hospital', 1, NULL, NULL, N'170137', NULL, NULL, 0, 146, NULL, N'7855056100', N'7855056126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Maine Street', N'Lawrence', N'KS', N'20045', N'66044', 38.978894, -95.247648, 1434, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2026, N'Via Christi Hospital Manhattan Inc', 1, NULL, NULL, N'170142', NULL, NULL, 0, 150, NULL, N'7857762831', N'7857762804', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1823 College Ave', N'Manhattan', N'KS', N'20161', N'66502', 39.201653, -96.598179, 1441, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2027, N'Coffeyville Regional Medical Center', 1, NULL, NULL, N'170145', NULL, NULL, 0, 110, NULL, N'6202511200', N'6202521651', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 W 4Th St', N'Coffeyville', N'KS', N'20125', N'67337', 37.040399, -95.638346, 1389, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2028, N'Providence Medical Center', 1, NULL, NULL, N'170146', NULL, NULL, 0, 400, NULL, N'9135964000', N'9135964098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8929 Parallel Parkway', N'Kansas City', N'KS', N'20209', N'66112', 39.128585, -94.784951, 1428, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2029, N'South Central Ks  Med Center', 1, NULL, NULL, N'170150', NULL, NULL, 0, 49, NULL, N'6204422500', N'6204415953', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Patterson Parkway', N'Arkansas City', N'KS', N'20035', N'67005', 37.132947, -97.038913, 1378, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2030, N'Morton County Hospital', 1, NULL, NULL, N'170166', NULL, NULL, 0, 40, NULL, N'6206972141', N'6206975264', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'445 N Hilltop', N'Elkhart', N'KS', N'20129', N'67950', 37.008079, -101.890166, 1397, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2031, N'Western Plains Medical Complex', 1, NULL, NULL, N'170175', NULL, NULL, 0, 99, NULL, N'6202258400', N'6202258403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Avenue A', N'Dodge City', N'KS', N'20057', N'67801', 37.785487, -100.014975, 1395, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2032, N'Overland Park Reg Med Ctr', 1, NULL, NULL, N'170176', NULL, NULL, 0, 343, NULL, N'9135415000', N'9135415035', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Quivira Road', N'Overland Park', N'KS', N'20091', N'66215', 38.937696, -94.723652, 1474, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2033, N'Menorah Medical Center', 1, NULL, NULL, N'170182', NULL, NULL, 0, 158, NULL, N'9134986773', N'9134987106', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5721 West 119Th Street', N'Overland Park', N'KS', N'20091', N'66209', 38.912834, -94.652084, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2034, N'Kansas Surgery & Recovery Center', 1, NULL, NULL, N'170183', NULL, NULL, 0, 34, NULL, N'3166340090', N'3166341964', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2770 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.732987, -97.226256, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2035, N'Saint Luke''s South Hospital', 1, NULL, NULL, N'170185', NULL, NULL, 0, 75, NULL, N'9133177904', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12300 Metcalf Avenue', N'Overland Park', N'KS', N'20091', N'66213', 38.903916, -94.667868, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2036, N'Kansas Heart Hospital', 1, NULL, NULL, N'170186', NULL, NULL, 0, 54, NULL, N'3166305000', N'3166305050', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.749305, -97.226366, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2037, N'Salina Surgical Hospital', 1, NULL, NULL, N'170187', NULL, NULL, 0, 16, NULL, N'7858270610', N'7858278608', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South Santa Fe Avenue', N'Salina', N'KS', N'20169', N'67401', 38.833845, -97.609169, 1469, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2038, N'Kansas City Orthopaedic Institute', 1, NULL, NULL, N'170188', NULL, NULL, 0, 9, NULL, N'9133197633', N'9132531745', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3651 College Blvd', N'Leawood', N'KS', N'20091', N'66211', 38.927549, -94.628235, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2039, N'Manhattan Surgical Hospital Llc', 1, NULL, NULL, N'170190', NULL, NULL, 0, 7, NULL, N'7857765100', N'7857765101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1829 College Avenue', N'Manhattan', N'KS', N'20161', N'66502', 39.202977, -96.598184, 1441, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2040, N'Great Bend Regional Hospital', 1, NULL, NULL, N'170191', NULL, NULL, 0, 33, NULL, N'6207928833', N'6207916876', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'514 Cleveland Street', N'Great Bend', N'KS', N'20009', N'67530', 38.356199, -98.791619, 1408, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2041, N'Doctors Hospital Llc', 1, NULL, NULL, N'170194', NULL, NULL, 0, 10, NULL, N'9135291801', N'9135294520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4901 College Blvd', N'Leawood', N'KS', N'20091', N'66211', 38.927412, -94.6435, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2042, N'Kansas Spine & Specialty Hospital Llc', 1, NULL, NULL, N'170196', NULL, NULL, 0, 22, NULL, N'3164625326', N'3164625267', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 North Webb Road', N'Wichita', N'KS', N'20173', N'67226', 37.743678, -97.226325, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2043, N'Kansas Medical Center Llc', 1, NULL, NULL, N'170197', NULL, NULL, 0, 58, NULL, N'3163004000', N'3163304040', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1124 West 21St Street', N'Andover', N'KS', N'20015', N'67002', 37.72324, -97.14648, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2044, N'Summit Surgical Llc', 1, NULL, NULL, N'170198', NULL, NULL, 0, 10, NULL, N'6206626000', N'6206634803', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 East 23Rd Avenue', N'Hutchinson', N'KS', N'20155', N'67502', 38.07953, -97.888595, 1422, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2045, N'Minimally Invasive Surgery Hospital', 1, NULL, NULL, N'170199', NULL, NULL, 0, 9, NULL, N'9133227401', N'9133227410', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11217 Lakeview Avenue', N'Lenexa', N'KS', N'20091', N'66219', 38.924373, -94.769705, 1474, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2046, N'Via Christi Hospital Wichita St Teresa Inc', 1, NULL, NULL, N'170200', NULL, NULL, 0, 68, NULL, N'3167967800', N'3167967802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14800 West St Teresa', N'Wichita', N'KS', N'20173', N'67235', 37.7257555, -97.5154851, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2047, N'Blue Valley Hospital Inc', 1, NULL, NULL, N'170201', NULL, NULL, 0, 4, NULL, N'9134920160', N'9134285573', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12850 Metcalf Avenue', N'Overland Park', N'KS', N'20091', N'66213', 38.896281, -94.667876, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2048, N'Premier Surgical Institute', 1, NULL, NULL, N'170203', NULL, NULL, 0, 16, NULL, N'6207831732', N'6207831733', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1619 K Highway 66 Po Box 127', N'Galena', N'KS', N'20021', N'66739', 37.075895, -94.639671, 2090, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2049, N'Grisell Memorial Hospital', 1, NULL, NULL, N'171300', NULL, NULL, 0, 12, NULL, N'7857312231', N'7857312895', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 South Vermont Avenue', N'Ransom', N'KS', N'20135', N'67572', 38.63671, -99.931546, 1466, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2050, N'Ellinwood District Hospital', 1, NULL, NULL, N'171301', NULL, NULL, 0, 24, NULL, N'6205642548', N'6205643117', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 N Main Street', N'Ellinwood', N'KS', N'20009', N'67526', 38.35993, -98.581098, 1398, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2051, N'Oswe Community Hospital', 1, NULL, NULL, N'171302', NULL, NULL, 0, 12, NULL, N'6207952921', N'6207953094', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Barker Drive', N'Oswe', N'KS', N'20099', N'67356', 37.160676, -95.108826, 1460, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2052, N'Lane County Hospital', 1, NULL, NULL, N'171303', NULL, NULL, 0, 17, NULL, N'6203975321', N'6203973569', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 West Vine  Po Box 969', N'Dighton', N'KS', N'20101', N'67839', 38.481961, -100.467084, 1394, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2053, N'Ashland Health Center', 1, NULL, NULL, N'171304', NULL, NULL, 0, 24, NULL, N'6206352241', N'6206352229', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Oak Street', N'Ashland', N'KS', N'20025', N'67831', 37.188055, -99.771937, 1379, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2054, N'Wichita County Health Center', 1, NULL, NULL, N'171306', NULL, NULL, 0, 25, NULL, N'6203752233', N'6203754954', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 E Earl Street', N'Leoti', N'KS', N'20203', N'67861', 38.479741, -101.358771, 1436, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2055, N'Rawlins County Health Center', 1, NULL, NULL, N'171307', NULL, NULL, 0, 24, NULL, N'7856263211', N'7856269414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Grant St', N'Atwood', N'KS', N'20153', N'67730', 39.813266, -101.03838, 1381, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2056, N'Mercy Hospital Columbus', 1, NULL, NULL, N'171308', NULL, NULL, 0, 25, NULL, N'6204292545', N'6204291984', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'220 N Pennsylvania Avenue', N'Columbus', N'KS', N'20021', N'66725', 37.172067, -94.843805, 2090, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2057, N'Jewell County Hospital', 1, NULL, NULL, N'171309', NULL, NULL, 0, 12, NULL, N'7853783137', N'7853783450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Crestvue Ave', N'Mankato', N'KS', N'20089', N'66956', 39.786905, -98.201171, 1383, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2058, N'Cheyenne County Hospital', 1, NULL, NULL, N'171310', NULL, NULL, 0, 16, NULL, N'7853322104', N'7853323255', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 West 1St Street', N'St Francis', N'KS', N'20023', N'67756', 39.770878, -101.802776, 1476, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2059, N'Rooks County Health Center', 1, NULL, NULL, N'171311', NULL, NULL, 0, 25, NULL, N'7854344553', N'7856884499', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 North Washington', N'Plainville', N'KS', N'20163', N'67663', 39.224435, -99.298287, 1463, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2060, N'Comanche County Hospital', 1, NULL, NULL, N'171312', NULL, NULL, 0, 14, NULL, N'6205822144', N'6205822572', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2Nd & Frisco Street', N'Coldwater', N'KS', N'20033', N'67029', 37.268913, -99.326781, 1391, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2061, N'Kearny County Hospital', 1, NULL, NULL, N'171313', NULL, NULL, 0, 25, NULL, N'6203557111', N'6203551527', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Thorpe Street', N'Lakin', N'KS', N'20093', N'67860', 37.946014, -101.25659, 1433, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2062, N'Fw Huston Medical Center', 1, NULL, NULL, N'171314', NULL, NULL, 0, 25, NULL, N'9137744340', N'9137743379', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Delaware Street', N'Winchester', N'KS', N'20087', N'66097', 39.325222, -95.269956, 1488, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2063, N'Nemaha Valley Community Hospital', 1, NULL, NULL, N'171315', NULL, NULL, 0, 24, NULL, N'7853366181', N'7853363052', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Community Dr', N'Seneca', N'KS', N'20131', N'66538', 39.837834, -96.077864, 1473, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2064, N'Anderson County Hospital', 1, NULL, NULL, N'171316', NULL, NULL, 0, 25, NULL, N'7852044000', N'7854483118', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 S Maple', N'Garnett', N'KS', N'20003', N'66032', 38.280137, -95.249287, 1405, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2065, N'Edwards County Hospital', 1, NULL, NULL, N'171317', NULL, NULL, 0, 12, NULL, N'6206593621', N'6206593869', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 West Eighth Street', N'Kinsley', N'KS', N'20047', N'67547', 37.920715, -99.419431, 1430, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2066, N'Sedan City Hospital', 1, NULL, NULL, N'171318', NULL, NULL, 0, 25, NULL, N'6207253115', N'6207253297', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Street', N'Sedan', N'KS', N'20019', N'67361', 37.133542, -96.18921, 1472, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2067, N'Holton Community Hospital', 1, NULL, NULL, N'171319', NULL, NULL, 0, 12, NULL, N'7853642116', N'7853649613', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Columbine Drive', N'Holton', N'KS', N'20085', N'66436', 39.479045, -95.751725, 1479, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2068, N'Horton Community Hospital', 1, NULL, NULL, N'171320', NULL, NULL, 0, 25, NULL, N'7854862642', N'7854863620', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 West 18Th Street', N'Horton', N'KS', N'20013', N'66439', 39.672712, -95.530294, 1419, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2069, N'Meade District Hospital', 1, NULL, NULL, N'171321', NULL, NULL, 0, 25, NULL, N'6208732141', N'6208732576', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 East Carthage', N'Meade', N'KS', N'20119', N'67864', 37.28549, -100.334573, 1445, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2070, N'Hamilton County Hospital', 1, NULL, NULL, N'171322', NULL, NULL, 0, 25, NULL, N'6203847461', N'6203845500', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 North Huser', N'Syracuse', N'KS', N'20075', N'67878', 37.980569, -101.752672, 1478, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2071, N'Stafford County Hospital', 1, NULL, NULL, N'171323', NULL, NULL, 0, 25, NULL, N'6202345221', N'6202345792', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 S Buckeye', N'Stafford', N'KS', N'20185', N'67578', 37.957108, -98.596155, 1477, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2072, N'Satanta District Hospital', 1, NULL, NULL, N'171324', NULL, NULL, 0, 13, NULL, N'6206492761', N'6206492776', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Cheyenne & Apache', N'Satanta', N'KS', N'20081', N'67870', 37.437065, -100.988276, 1470, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2073, N'Graham County Hospital', 1, NULL, NULL, N'171325', NULL, NULL, 0, 25, NULL, N'7854212121', N'7854212034', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'304 West Prout Street', N'Hill City', N'KS', N'20065', N'67642', 39.371784, -99.844552, 1416, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2074, N'Logan County Hospital', 1, NULL, NULL, N'171326', NULL, NULL, 0, 25, NULL, N'7856723211', N'7856728184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Cherry Avenue', N'Oakley', N'KS', N'20109', N'67748', 39.127222, -100.863295, 1454, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2075, N'Ellsworth County Medical Center', 1, NULL, NULL, N'171327', NULL, NULL, 0, 20, NULL, N'7854723111', N'7854725760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1604 Aylward Avenue', N'Ellsworth', N'KS', N'20053', N'67439', 38.738704, -98.218907, 1399, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2076, N'Ottawa County Health Center', 1, NULL, NULL, N'171328', NULL, NULL, 0, 25, NULL, N'7853922122', N'7853922852', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 E 8Th Street', N'Minneapolis', N'KS', N'20143', N'67467', 39.128796, -97.704277, 1447, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2077, N'Sumner County Hospital District No 1', 1, NULL, NULL, N'171329', NULL, NULL, 0, 25, NULL, N'6208456492', N'6208456475', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 South Osage Street', N'Caldwell', N'KS', N'20191', N'67022', 37.025898, -97.609545, 1385, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2078, N'Hospital District #1 Of Rice County', 1, NULL, NULL, N'171330', NULL, NULL, 0, 25, NULL, N'6202575173', N'6202572608', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'619 South Clark Avenue', N'Lyons', N'KS', N'20159', N'67554', 38.342156, -98.216146, 1440, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2079, N'Kiowa District Hospital', 1, NULL, NULL, N'171331', NULL, NULL, 0, 24, NULL, N'6208254131', N'6208254667', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 South 4Th Street', N'Kiowa', N'KS', N'20007', N'67070', 37.012801, -98.48928, 1431, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2080, N'Kiowa County Memorial Hospital', 1, NULL, NULL, N'171332', NULL, NULL, 0, 35, NULL, N'6207233341', N'6207232195', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'721 West Kansas', N'Greensburg', N'KS', N'20097', N'67054', 37.602796, -99.292613, 1409, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2081, N'Clara Barton Hospital', 1, NULL, NULL, N'171333', NULL, NULL, 0, 25, NULL, N'6206532114', N'6206532350', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 W 9Th Street', N'Hoisington', N'KS', N'20009', N'67544', 38.521549, -98.77941, 1418, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2082, N'Medicine Lodge Memorial Hospital', 1, NULL, NULL, N'171334', NULL, NULL, 0, 25, NULL, N'6208863771', N'6209303791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N Walnut Street', N'Medicine Lodge', N'KS', N'20007', N'67104', 37.288996, -98.577638, 1446, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2083, N'Stevens County Hospital', 1, NULL, NULL, N'171335', NULL, NULL, 0, 17, NULL, N'6205446178', N'6205447822', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1006 S Jackson', N'Huton', N'KS', N'20189', N'67951', 37.171675, -101.349796, 1421, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2084, N'Ness County Hospital District #2', 1, NULL, NULL, N'171336', NULL, NULL, 0, 20, NULL, N'7857982291', N'7857983435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Custer Street', N'Ness City', N'KS', N'20135', N'67560', 38.457599, -99.902106, 1451, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2085, N'Wame Health Center', 1, NULL, NULL, N'171337', NULL, NULL, 0, 25, NULL, N'7854587201', N'7854566916', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Genn Drive', N'Wame', N'KS', N'20149', N'66547', 39.205486, -96.318237, 1483, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2086, N'Sabetha Community Hospital', 1, NULL, NULL, N'171338', NULL, NULL, 0, 25, NULL, N'7852842121', N'7852842516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14Th & Oren', N'Sabetha', N'KS', N'20131', N'66534', 39.899723, -95.796512, 1468, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2087, N'Greenwood County Hospital', 1, NULL, NULL, N'171339', NULL, NULL, 0, 25, NULL, N'6205837451', N'6205836702', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 W 16Th Street', N'Eureka', N'KS', N'20073', N'67045', 37.835333, -96.294089, 1401, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2088, N'Herington Municipal Hospital', 1, NULL, NULL, N'171340', NULL, NULL, 0, 25, NULL, N'7852582207', N'7852585127', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 E Helen Street', N'Herington', N'KS', N'20041', N'67449', 38.679567, -96.942271, 1414, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2089, N'Hiawatha Community Hospital', 1, NULL, NULL, N'171341', NULL, NULL, 0, 25, NULL, N'7857422131', N'7857426558', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Utah Street', N'Hiawatha', N'KS', N'20013', N'66434', 39.85187, -95.530972, 1415, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2090, N'Rush County Memorial Hospital', 1, NULL, NULL, N'171342', NULL, NULL, 0, 24, NULL, N'7852222545', N'7852222868', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Locust St', N'La Crosse', N'KS', N'20165', N'67548', 38.530412, -99.316516, 1432, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2091, N'Stanton County Hospital', 1, NULL, NULL, N'171343', NULL, NULL, 0, 25, NULL, N'6204926250', N'6204921447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'404 N Chestnut', N'Johnson', N'KS', N'20187', N'67855', 37.573319, -101.749454, 1426, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2092, N'Wilson Medical Center', 1, NULL, NULL, N'171344', NULL, NULL, 0, 35, NULL, N'6203258369', N'6203258462', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Reece Campus 2600 Ottawa Road', N'Neodesha', N'KS', N'20205', N'66757', 37.418393, -95.680258, 1450, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2093, N'Pawnee Valley Community Hospital', 1, NULL, NULL, N'171345', NULL, NULL, 0, 25, NULL, N'6202853162', N'6202858883', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'923 Carroll Avenue', N'Larned', N'KS', N'20145', N'67550', 38.184717, -99.1066, 1408, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2094, N'Anthony Medical Center', 1, NULL, NULL, N'171346', NULL, NULL, 0, 25, NULL, N'6208425111', N'6208423715', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 East Spring Street', N'Anthony', N'KS', N'20077', N'67003', 37.154449, -98.01729, 1377, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2095, N'Sheridan County Hospital', 1, NULL, NULL, N'171347', NULL, NULL, 0, 25, NULL, N'7856753281', N'7856753840', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826  18Th Street', N'Hoxie', N'KS', N'20179', N'67740', 39.354186, -100.432735, 1420, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2096, N'Norton County Hospital', 1, NULL, NULL, N'171348', NULL, NULL, 0, 25, NULL, N'7858773351', N'7858772841', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'102 E Holme Street', N'Norton', N'KS', N'20137', N'67654', 39.838529, -99.888743, 1453, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2097, N'Cloud County Health Center', 1, NULL, NULL, N'171349', NULL, NULL, 0, 25, NULL, N'7852431234', N'7852438411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Highland Drive', N'Concordia', N'KS', N'20029', N'66901', 39.565974, -97.672517, 1392, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2098, N'Russell Regional Hospital', 1, NULL, NULL, N'171350', NULL, NULL, 0, 25, NULL, N'7854833131', N'7854833125', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Main Street', N'Russell', N'KS', N'20167', N'67665', 38.882164, -98.859839, 1467, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2099, N'Washington County Hospital', 1, NULL, NULL, N'171351', NULL, NULL, 0, 25, NULL, N'7853252211', N'7853253224', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 E 3Rd Street', N'Washington', N'KS', N'20201', N'66968', 39.817468, -97.046765, 1484, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2100, N'Decatur County Hospital', 1, NULL, NULL, N'171352', NULL, NULL, 0, 25, NULL, N'7854752208', N'7854752453', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 W  Columbia Street', N'Oberlin', N'KS', N'20039', N'67749', 39.816171, -100.5377, 1455, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2101, N'Phillips County Health Systems', 1, NULL, NULL, N'171353', NULL, NULL, 0, 25, NULL, N'7855435226', N'7855436272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 State Street', N'Phillipsburg', N'KS', N'20147', N'67661', 39.755862, -99.313583, 1461, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2102, N'Community Hospital Onaga And St Marys Campus', 1, NULL, NULL, N'171354', NULL, NULL, 0, 25, NULL, N'7858894272', N'7858897163', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 West 8Th Street', N'Onaga', N'KS', N'20149', N'66521', 39.495153, -96.171672, 1457, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2103, N'Tre County Lemke Memorial Hospital', 1, NULL, NULL, N'171355', NULL, NULL, 0, 25, NULL, N'7857432182', N'7857436317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Thirteenth St', N'Wa Keeney', N'KS', N'20195', N'67672', 39.02095, -99.871518, 1482, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2104, N'St Luke Hospital & Living Center', 1, NULL, NULL, N'171356', NULL, NULL, 0, 22, NULL, N'6203822177', N'6203829401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 South Freebron', N'Marion', N'KS', N'20115', N'66861', 38.342911, -97.010018, 1442, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2105, N'Hillsboro Community Hospital', 1, NULL, NULL, N'171357', NULL, NULL, 0, 25, NULL, N'6209473114', N'6209475690', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 S Main Street', N'Hillsboro', N'KS', N'20115', N'67063', 38.346761, -97.204667, 1417, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2106, N'Lindsborg Community Hospital', 1, NULL, NULL, N'171358', NULL, NULL, 0, 25, NULL, N'7852273308', N'7852274130', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 W Lincoln Street', N'Lindsborg', N'KS', N'20113', N'67456', 38.573477, -97.683778, 1439, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2107, N'Greeley County Health Services', 1, NULL, NULL, N'171359', NULL, NULL, 0, 18, NULL, N'6203764221', N'6203762406', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 3Rd Street', N'Tribune', N'KS', N'20071', N'67879', 38.470759, -101.749768, 1480, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2108, N'Lincoln County Hospital', 1, NULL, NULL, N'171360', NULL, NULL, 0, 14, NULL, N'7855244403', N'7855245296', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'624 N Second', N'Lincoln', N'KS', N'20105', N'67455', 39.045174, -98.14437, 1438, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2109, N'Republic County Hospital', 1, NULL, NULL, N'171361', NULL, NULL, 0, 35, NULL, N'7855272254', N'7855272324', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2420 G Street', N'Belleville', N'KS', N'20157', N'66935', 39.818769, -97.636982, 1382, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2110, N'Citizens Medical Center', 1, NULL, NULL, N'171362', NULL, NULL, 0, 25, NULL, N'7854627511', N'7854604895', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 E College Drive', N'Colby', N'KS', N'20193', N'67701', 39.379853, -101.044626, 1390, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2111, N'Community Memorial Healthcare Inc', 1, NULL, NULL, N'171363', NULL, NULL, 0, 25, NULL, N'7855622311', N'7855622348', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 N 18Th Street', N'Marysville', N'KS', N'20117', N'66508', 39.848289, -96.635954, 1443, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2112, N'Osborne County Memorial Hospital', 1, NULL, NULL, N'171364', NULL, NULL, 0, 25, NULL, N'7853462121', N'7853465498', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'424 W New Hampshire Street', N'Osborne', N'KS', N'20141', N'67473', 39.436681, -98.700889, 1458, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2113, N'Hanover Hospital', 1, NULL, NULL, N'171365', NULL, NULL, 0, 25, NULL, N'7853372214', N'7853372727', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 S Hanover Street', N'Hanover', N'KS', N'20201', N'66945', 39.891513, -96.874767, 1411, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2114, N'Harper Hospital District No 5', 1, NULL, NULL, N'171366', NULL, NULL, 0, 25, NULL, N'6208967324', N'6208967127', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West 13Th', N'Harper', N'KS', N'20077', N'67058', 37.283665, -98.033309, 1412, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2115, N've County Medical Center', 1, NULL, NULL, N'171367', NULL, NULL, 0, 25, NULL, N'7857543341', N'7857543329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West 5Th Street', N'Quinter', N'KS', N'20063', N'67752', 39.067074, -100.240394, 1465, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2116, N'Minneola District Hospital Nbr 2', 1, NULL, NULL, N'171368', NULL, NULL, 0, 18, NULL, N'6208854264', N'6208854602', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 Main', N'Minneola', N'KS', N'20025', N'67865', 37.485789, -99.897347, 1448, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2117, N'Hodgeman County Health Center', 1, NULL, NULL, N'171369', NULL, NULL, 0, 16, NULL, N'6203578361', N'6203576120', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Bramley', N'Jetmore', N'KS', N'20083', N'67854', 38.083656, -99.904186, 1425, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2118, N'odland Regional Medical Center', 1, NULL, NULL, N'171370', NULL, NULL, 0, 25, NULL, N'7858903625', N'7858906373', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 West Second Street', N'odland', N'KS', N'20181', N'67735', 39.357589, -101.713491, 1407, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2119, N'Clay County Medical Center', 1, NULL, NULL, N'171371', NULL, NULL, 0, 25, NULL, N'7856322144', N'7856323352', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'617 Liberty', N'Clay Center', N'KS', N'20027', N'67432', 39.391681, -97.124196, 1388, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2120, N'Scott County Hospital', 1, NULL, NULL, N'171372', NULL, NULL, 0, 25, NULL, N'6208725811', N'6208727193', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Albert Avenue', N'Scott City', N'KS', N'20171', N'67871', 38.48487, -100.9035, 1471, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2121, N'Allen County Regional Hospital', 1, NULL, NULL, N'171373', NULL, NULL, 0, 25, NULL, N'6203651021', N'6203651032', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3066 North Kentucky Street', N'Iola', N'KS', N'20001', N'66749', 37.944418, -95.390605, 1424, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2122, N'Fredonia Regional Hospital', 1, NULL, NULL, N'171374', NULL, NULL, 0, 32, NULL, N'6203782121', N'6203783169', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1527 Madison', N'Fredonia', N'KS', N'20205', N'66736', 37.533641, -95.814802, 1403, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2123, N'Mitchell County Hospital Health Systems', 1, NULL, NULL, N'171375', NULL, NULL, 0, 35, NULL, N'7857382266', N'7857389503', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 W 8Th Street P O Box 399', N'Beloit', N'KS', N'20123', N'67420', 39.466548, -98.11558, 1383, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2124, N'Girard Medical Center', 1, NULL, NULL, N'171376', NULL, NULL, 0, 25, NULL, N'6207248291', N'6207245195', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 North Hospital Drive', N'Girard', N'KS', N'20037', N'66743', 37.513849, -94.858464, 1406, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2125, N'Smith County Memorial Hospital', 1, NULL, NULL, N'171377', NULL, NULL, 0, 25, NULL, N'7852826845', N'7852826331', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'614 South Main Street', N'Smith Center', N'KS', N'20183', N'66967', 39.771659, -98.785715, 1475, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2126, N'Kingman Community Hospital', 1, NULL, NULL, N'171378', NULL, NULL, 0, 25, NULL, N'6205323147', N'6205320167', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 W Ave D', N'Kingman', N'KS', N'20095', N'67068', 37.645849, -98.113673, 1429, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2127, N'Morris County Hospital', 1, NULL, NULL, N'171379', NULL, NULL, 0, 25, NULL, N'6207676811', N'6207675611', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 N Washington St', N'Council Grove', N'KS', N'20127', N'66846', 38.664245, -96.499747, 1393, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2128, N'Neosho Memorial Regional Medical Center', 1, NULL, NULL, N'171380', NULL, NULL, 0, 25, NULL, N'6204314000', N'6204317556', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 South Plummer', N'Chanute', N'KS', N'20133', N'66720', 37.675185, -95.470896, 1387, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2129, N'Memorial Hospital', 1, NULL, NULL, N'171381', NULL, NULL, 0, 25, NULL, N'7852636610', N'7852636622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'511 Ne 10Th St', N'Abilene', N'KS', N'20041', N'67410', 38.924956, -97.205559, 1376, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2130, N'Atchison Hospital', 1, NULL, NULL, N'171382', NULL, NULL, 0, 25, NULL, N'9133605581', N'9136742023', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Ravin Hill Drive', N'Atchison', N'KS', N'20005', N'66002', 39.563372, -95.121291, 1380, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2131, N'William Newton Hospital', 1, NULL, NULL, N'171383', NULL, NULL, 0, 25, NULL, N'6202212300', N'6202213594', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 East Fifth Avenue', N'Winfield', N'KS', N'20035', N'67156', 37.244659, -96.981905, 1489, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2132, N'Newman Regional Health', 1, NULL, NULL, N'171384', NULL, NULL, 0, 53, NULL, N'6203436800', N'6203417801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 West 12Th Avenue', N'Emporia', N'KS', N'20111', N'66801', 38.412235, -96.195257, 1400, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2133, N'Wichita-Amg Specialty Hospital', 1, NULL, NULL, N'172003', NULL, NULL, 0, 26, NULL, N'3166820004', N'3166825790', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8080 E Pawnee', N'Wichita', N'KS', N'20173', N'67207', 37.692236, -97.337545, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2134, N'Promise Hospital Of Overland Park', 1, NULL, NULL, N'172004', NULL, NULL, 0, 56, NULL, N'9136493701', N'9136492408', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6509 West 103Rd Street', N'Overland Park', N'KS', N'20091', N'66212', 38.982228, -94.670792, 1474, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2135, N'Select Specialty Hospital Of Ks City', 1, NULL, NULL, N'172005', NULL, NULL, 0, 40, NULL, N'9137325930', N'9137325939', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1731 North 90Th Street', N'Kansas City', N'KS', N'20209', N'66112', 39.124952, -94.788423, 1428, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2136, N'Select Specialty Hospital Wichita', 1, NULL, NULL, N'172007', NULL, NULL, 0, 35, NULL, N'3169623930', N'3166923922', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'929 North St Francis 6Th Floor North Tower', N'Wichita', N'KS', N'20173', N'67214', 37.692236, -97.337545, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2137, N'The Kansas Rehabilitation Hospital', 1, NULL, NULL, N'173025', NULL, NULL, 0, 72, NULL, N'7852356600', N'7852328545', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1504 Sw 8Th Avenue', N'Topeka', N'KS', N'20177', N'66606', 39.055232, -95.69441, 1479, 111, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2138, N'Mid America Rehabilitation Hospital', 1, NULL, NULL, N'173026', NULL, NULL, 0, 80, NULL, N'9134912410', N'9133383762', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5701 W 110Th Street', N'Overland Park', N'KS', N'20091', N'66211', 38.929526, -94.651309, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2139, N'Wesley Rehabilitation Hospital', 1, NULL, NULL, N'173027', NULL, NULL, 0, 65, NULL, N'3167291121', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8338 West 13Th Street', N'Wichita', N'KS', N'20173', N'67212', 37.692236, -97.337545, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2140, N'Via Christi Rehabilitation Hospital Inc', 1, NULL, NULL, N'173028', NULL, NULL, 0, 40, NULL, N'3166343400', N'3166341141', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1151 N Rock Road', N'Wichita', N'KS', N'20173', N'67206', 37.7152, -97.244619, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2141, N'Rehabilitation Hospital Of Overland Park', 1, NULL, NULL, N'173032', NULL, NULL, 0, 45, NULL, N'9135441957', N'9135441958', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5100 Indian Creek Parkway', N'Overland Park', N'KS', N'20091', N'66207', 38.934332, -94.631794, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2142, N'Meadowbrook Rehabilitation Hospital', 1, NULL, NULL, N'173033', NULL, NULL, 0, 54, NULL, N'9138568747', N'9138568339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 West Main Street', N'Gardner', N'KS', N'20091', N'66030', 38.809474, -94.94174, 1456, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2143, N'Children''s Mercy  South', 1, NULL, NULL, N'173300', NULL, NULL, 0, 34, NULL, N'9132343000', N'8168426107', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5808 W 110Th Street', N'Overland Park', N'KS', N'20091', N'66211', 38.929326, -94.653263, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2144, N'Osawatomie State Hospital Psychiatric', 1, NULL, NULL, N'174004', NULL, NULL, 0, 279, NULL, N'9137557000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 State Hospital Drive', N'Osawatomie', N'KS', N'20121', N'66064', 38.51063, -94.942722, 1456, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2145, N'Larned State Hospital', 1, NULL, NULL, N'174006', NULL, NULL, 0, 299, NULL, N'6202854360', N'6202854357', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Ks Highway 264', N'Larned', N'KS', N'20145', N'67550', 38.180569, -99.098713, 1408, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2146, N'Prairie View Inc', 1, NULL, NULL, N'174016', NULL, NULL, 0, 80, NULL, N'3162846400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 E First Street Po Box 467', N'Newton', N'KS', N'20079', N'67114', 38.046917, -97.344724, 1452, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2147, N'Via Christi Reg Med Ctr-Transplant Unit', 1, NULL, NULL, N'179800', NULL, NULL, 0, 0, NULL, N'3162685000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'929 N St Francis', N'Wichita', N'KS', N'20173', N'67214', 37.692236, -97.337545, 1487, 112, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2148, N'University Of Kansas Hospital Transplant Center', 1, NULL, NULL, N'179801', NULL, NULL, 0, 0, NULL, N'9135886064', N'9135888763', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3901 Rainbow Blvd', N'Kansas City', N'KS', N'20209', N'66106', 39.053776, -94.611212, 1428, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2149, N'St Elizabeth Ft Thomas', 1, NULL, NULL, N'180001', NULL, NULL, 0, 312, NULL, N'8595723100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 North Grand Avenue', N'Fort Thomas', N'KY', N'21037', N'41075', 39.078134, -84.464496, 1509, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2150, N'Whitesburg Arh Hospital', 1, NULL, NULL, N'180002', NULL, NULL, 0, 90, NULL, N'6066333500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Hospital Road', N'Whitesburg', N'KY', N'21133', N'41858', 37.112944, -82.811861, 1568, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2151, N'Owensboro Health Muhlenberg Community Hospital', 1, NULL, NULL, N'180004', NULL, NULL, 0, 90, NULL, N'2703388000', N'2703388278', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 Hopkinsville Street', N'Greenville', N'KY', N'21177', N'42345', 37.196899, -87.18989, 1516, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2152, N'Highlands Regional Medical Center', 1, NULL, NULL, N'180005', NULL, NULL, 0, 166, NULL, N'6068868511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Kentucky Route 321', N'Prestonsburg', N'KY', N'21071', N'41653', 37.71054, -82.77025, 1555, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2153, N'King''s Daughters'' Medical Center', 1, NULL, NULL, N'180009', NULL, NULL, 0, 455, NULL, N'6064084401', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Lexington Avenue', N'Ashland', N'KY', N'21019', N'41101', 38.469976, -82.635083, 1491, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2154, N'Saint Joseph Hospital', 1, NULL, NULL, N'180010', NULL, NULL, 0, 468, NULL, N'8593131000', N'8593133000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Saint Joseph Drive', N'Lexington', N'KY', N'21067', N'40504', 38.046407, -84.497039, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2155, N'Saint Joseph London', 1, NULL, NULL, N'180011', NULL, NULL, 0, 120, NULL, N'6063306000', N'6063306020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Saint Joseph Lane', N'London', N'KY', N'21125', N'40741', 37.118553, -84.106349, 1532, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2156, N'Hardin Memorial Hospital', 1, NULL, NULL, N'180012', NULL, NULL, 0, 300, NULL, N'2707371212', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'913 North Dixie Avenue', N'Elizabethtown', N'KY', N'21093', N'42701', 37.709923, -85.875052, 1506, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2157, N'The Medical Center At Bowling Green', 1, NULL, NULL, N'180013', NULL, NULL, 0, 382, NULL, N'2707451000', N'2708420765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Park Street', N'Bowling Green', N'KY', N'21227', N'42101', 36.996456, -86.430074, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2158, N'Jewish Hospital - Shelbyville', 1, NULL, NULL, N'180016', NULL, NULL, 0, 68, NULL, N'5026474300', N'5026474039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 Hospital Drive', N'Shelbyville', N'KY', N'21211', N'40065', 38.209848, -85.235459, 1561, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2159, N'T J Samson Community Hospital', 1, NULL, NULL, N'180017', NULL, NULL, 0, 180, NULL, N'2706514159', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 North Race Street', N'Glasw', N'KY', N'21009', N'42141', 37.01068, -85.903236, 1514, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2160, N'St Claire Regional Medical Center', 1, NULL, NULL, N'180018', NULL, NULL, 0, 149, NULL, N'6067836503', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 Medical Circle', N'Morehead', N'KY', N'21205', N'40351', 38.179944, -83.442358, 1543, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2161, N'Meadowview Regional Medical Center', 1, NULL, NULL, N'180019', NULL, NULL, 0, 111, NULL, N'6067595311', N'6067595616', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'989 Medical Park Drive', N'Maysville', N'KY', N'21161', N'41056', 38.639654, -83.807877, 1539, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2162, N'Middlesboro Appalachian Regional Healthcare Hospit', 1, NULL, NULL, N'180020', NULL, NULL, 0, 96, NULL, N'6062421100', N'6062421472', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 West Cumberland Avenue', N'Middlesboro', N'KY', N'21013', N'40965', 36.605309, -83.738174, 1541, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2163, N'Pineville Community Hospital', 1, NULL, NULL, N'180021', NULL, NULL, 0, 120, NULL, N'6063373051', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Riverview Avenue', N'Pineville', N'KY', N'21013', N'40977', 36.76411, -83.71281, 1554, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2164, N'Spring View Hospital', 1, NULL, NULL, N'180024', NULL, NULL, 0, 75, NULL, N'2706925145', N'2706925155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Loretto Road', N'Lebanon', N'KY', N'21155', N'40033', 37.570325, -85.259397, 1529, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2165, N'Flaget Memorial Hospital (Member Of Saint Joseph H', 1, NULL, NULL, N'180025', NULL, NULL, 0, 40, NULL, N'5023505000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4305 New Shepherdsville Road', N'Bardstown', N'KY', N'21179', N'40004', 37.863012, -85.522679, 1493, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2166, N'Murray-Calloway County Hospital', 1, NULL, NULL, N'180027', NULL, NULL, 0, 140, NULL, N'2707621100', N'2707673600', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'803 Poplar Street', N'Murray', N'KY', N'21035', N'42071', 36.60866, -88.309502, 1547, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2167, N'Hazard Arh Regional Medical Center', 1, NULL, NULL, N'180029', NULL, NULL, 0, 308, NULL, N'6064396600', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Hazard', N'KY', N'21193', N'41701', 37.278959, -83.226388, 1521, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2168, N'St Elizabeth Medical Center North', 1, NULL, NULL, N'180035', NULL, NULL, 0, 621, NULL, N'8593012000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Village Drive', N'Edgewood', N'KY', N'21117', N'41017', 39.011733, -84.565165, 1503, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2169, N'Our Lady Of Bellefonte Hospital', 1, NULL, NULL, N'180036', NULL, NULL, 0, 190, NULL, N'6068333600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Saint Christopher Drive', N'Ashland', N'KY', N'21019', N'41101', 38.509301, -82.693059, 1491, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2170, N'Owensboro Health Regional Hospital', 1, NULL, NULL, N'180038', NULL, NULL, 0, 469, NULL, N'2704172000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Pleasant Valley Road', N'Owensboro', N'KY', N'21059', N'42303', 37.777296, -87.069958, 1548, 116, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2171, N'Jewish Hospital & St Mary''s Healthcare', 1, NULL, NULL, N'180040', NULL, NULL, 0, 1261, NULL, N'5025874011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Abraham Flexner Way', N'Louisville', N'KY', N'21111', N'40202', 38.249283, -85.750763, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2172, N'Memorial Hospital', 1, NULL, NULL, N'180043', NULL, NULL, 0, 63, NULL, N'6065985104', N'6065987008', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Marie Langdon Drive', N'Manchester', N'KY', N'21051', N'40962', 37.162181, -83.76134, 1536, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2173, N'Pikeville Medical Center', 1, NULL, NULL, N'180044', NULL, NULL, 0, 261, NULL, N'6062183500', N'6064374996', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Bypass Road', N'Pikeville', N'KY', N'21195', N'41501', 37.47251, -82.52395, 1553, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2174, N'St Elizabeth Florence', 1, NULL, NULL, N'180045', NULL, NULL, 0, 161, NULL, N'8592125220', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Houston Road', N'Florence', N'KY', N'21015', N'41042', 39.017539, -84.632897, 1508, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2175, N'Bourbon Community Hospital', 1, NULL, NULL, N'180046', NULL, NULL, 0, 58, NULL, N'8599873600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9 Linville Drive', N'Paris', N'KY', N'21017', N'40361', 38.221805, -84.238963, 1552, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2176, N'Ephraim Mcdowell Regional Medical Center', 1, NULL, NULL, N'180048', NULL, NULL, 0, 197, NULL, N'8592392409', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'217 South Third Street', N'Danville', N'KY', N'21021', N'40422', 37.643795, -84.77264, 1505, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2177, N'Baptist Health Richmond', 1, NULL, NULL, N'180049', NULL, NULL, 0, 105, NULL, N'8596233131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Eastern Bypass', N'Richmond', N'KY', N'21151', N'40475', 37.73128, -84.284507, 1557, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2178, N'Harlan Arh Hospital', 1, NULL, NULL, N'180050', NULL, NULL, 0, 150, NULL, N'6065738100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Ball Park Road', N'Harlan', N'KY', N'21095', N'40831', 36.810178, -83.313123, 1518, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2179, N'Jennie Stuart Medical Center', 1, NULL, NULL, N'180051', NULL, NULL, 0, 194, NULL, N'2708870100', N'2708870223', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 West 18Th Street', N'Hopkinsville', N'KY', N'21047', N'42240', 36.860231, -87.495139, 1523, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2180, N'Fleming County Hospital', 1, NULL, NULL, N'180053', NULL, NULL, 0, 52, NULL, N'6068492351', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Foundation Drive', N'Flemingsburg', N'KY', N'21069', N'41041', 38.4223, -83.733808, 1507, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2181, N'Methodist Hospital', 1, NULL, NULL, N'180056', NULL, NULL, 0, 205, NULL, N'2708277700', N'2708277402', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 N Elm St', N'Henderson', N'KY', N'21101', N'42420', 37.853858, -87.581257, 1522, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2182, N'Saint Joseph Mount Sterling', 1, NULL, NULL, N'180064', NULL, NULL, 0, 63, NULL, N'8594975018', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Falcon Drive', N'Mount Sterling', N'KY', N'21173', N'40353', 38.07591, -83.94692, 1545, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2183, N'Logan Memorial Hospital', 1, NULL, NULL, N'180066', NULL, NULL, 0, 92, NULL, N'2707264011', N'2707267465', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Nashville Street', N'Russellville', N'KY', N'21141', N'42276', 36.815916, -86.882796, 1559, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2184, N'University Of Kentucky Hospital', 1, NULL, NULL, N'180067', NULL, NULL, 0, 791, NULL, N'8593235211', N'8593232044', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Rose Street', N'Lexington', N'KY', N'21067', N'40536', 38.032772, -84.506765, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2185, N'Tug Valley Arh Regional Medical Center', 1, NULL, NULL, N'180069', NULL, NULL, 0, 113, NULL, N'6062371700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'260 Hospital Drive', N'South Williamson', N'KY', N'21195', N'41503', 37.677201, -82.29526, 1563, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2186, N'Twin Lakes Regional Medical Center', 1, NULL, NULL, N'180070', NULL, NULL, 0, 75, NULL, N'2702599400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 Wallace Avenue', N'Leitchfield', N'KY', N'21085', N'42754', 37.471592, -86.287104, 1530, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2187, N'Paul B Hall Regional Medical Center', 1, NULL, NULL, N'180078', NULL, NULL, 0, 72, NULL, N'6067893511', N'6067896486', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 James S Trimble Boulevard', N'Paintsville', N'KY', N'21115', N'41240', 37.815055, -82.812978, 1555, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2188, N'Harrison Memorial Hospital', 1, NULL, NULL, N'180079', NULL, NULL, 0, 61, NULL, N'8592342300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 Ky Hwy 36 E', N'Cynthiana', N'KY', N'21097', N'41031', 38.375307, -84.313813, 1504, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2189, N'Baptist Health Corbin', 1, NULL, NULL, N'180080', NULL, NULL, 0, 240, NULL, N'6065281212', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Trillium Way', N'Corbin', N'KY', N'21121', N'40701', 36.948699, -84.096876, 1502, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2190, N'Taylor Regional Hospital', 1, NULL, NULL, N'180087', NULL, NULL, 0, 90, NULL, N'2704653561', N'2704655386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Old Lebanon Road', N'Campbellsville', N'KY', N'21217', N'42718', 37.368148, -85.339261, 1498, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2191, N'Norton Hospital/Norton Medical Pavilions/Kosair Ch', 1, NULL, NULL, N'180088', NULL, NULL, 0, 1730, NULL, N'5026298000', N'5026292016', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East Chestnut Street', N'Louisville', N'KY', N'21111', N'40202', 38.24823, -85.751295, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2192, N'Clark Regional Medical Center', 1, NULL, NULL, N'180092', NULL, NULL, 0, 75, NULL, N'8597378559', N'8597376601', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Hospital Drive', N'Winchester', N'KY', N'21049', N'40391', 38.010511, -84.21459, 1570, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2193, N'Baptist Health Madisonville', 1, NULL, NULL, N'180093', NULL, NULL, 0, 390, NULL, N'2708255100', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hospital Drive', N'Madisonville', N'KY', N'21107', N'42431', 37.339979, -87.493645, 1535, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2194, N'Crittenden Health System', 1, NULL, NULL, N'180095', NULL, NULL, 0, 48, NULL, N'2709655281', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 West Gum Street', N'Marion', N'KY', N'21055', N'42064', 37.329411, -88.09014, 1537, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2195, N'Georgetown Community Hospital', 1, NULL, NULL, N'180101', NULL, NULL, 0, 75, NULL, N'5028681100', N'5028685607', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 Lexington Road', N'Georgetown', N'KY', N'21209', N'40324', 38.188493, -84.562459, 1513, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2196, N'Lourdes Hospital', 1, NULL, NULL, N'180102', NULL, NULL, 0, 359, NULL, N'2704442444', N'2704442980', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Lone Oak Road', N'Paducah', N'KY', N'21145', N'42003', 37.050207, -88.652375, 1550, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2197, N'Baptist Health Lexington', 1, NULL, NULL, N'180103', NULL, NULL, 0, 371, NULL, N'8592606104', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 Nicholasville Road', N'Lexington', N'KY', N'21067', N'40503', 38.018817, -84.513956, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2198, N'Baptist Health Paducah', 1, NULL, NULL, N'180104', NULL, NULL, 0, 349, NULL, N'2705752100', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Kentucky Avenue', N'Paducah', N'KY', N'21145', N'42003', 37.073279, -88.628162, 1550, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2199, N'Monroe County Medical Center', 1, NULL, NULL, N'180105', NULL, NULL, 0, 49, NULL, N'2704879231', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'529 Capp Harlan Road', N'Tompkinsville', N'KY', N'21171', N'42167', 36.698632, -85.677229, 1565, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2200, N'Clinton County Hospital Inc', 1, NULL, NULL, N'180106', NULL, NULL, 0, 42, NULL, N'6063876421', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'723 Burkesville Road', N'Albany', N'KY', N'21053', N'42602', 36.698538, -85.147585, 1490, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2201, N'Rockcastle Regional Hospital & Respiratory Care Ct', 1, NULL, NULL, N'180115', NULL, NULL, 0, 26, NULL, N'6062562195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Newcomb Avenue', N'Mount Vernon', N'KY', N'21203', N'40456', 37.358001, -84.336988, 1546, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2202, N'Jackson Purchase Medical Center', 1, NULL, NULL, N'180116', NULL, NULL, 0, 93, NULL, N'2702514585', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1099 Medical Center Circle', N'Mayfield', N'KY', N'21083', N'42066', 36.75508, -88.652127, 1538, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2203, N'Greenview Regional Hospital', 1, NULL, NULL, N'180124', NULL, NULL, 0, 211, NULL, N'2707931000', N'2707935205', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 Ashley Circle', N'Bowling Green', N'KY', N'21227', N'42104', 36.965695, -86.435642, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2204, N'Frankfort Regional Medical Center', 1, NULL, NULL, N'180127', NULL, NULL, 0, 173, NULL, N'5028755240', N'5022267936', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'299 Kings Daughters Drive', N'Frankfort', N'KY', N'21073', N'40601', 38.164798, -84.902777, 1510, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2205, N'Three Rivers Medical Center', 1, NULL, NULL, N'180128', NULL, NULL, 0, 90, NULL, N'6066389451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2485 Highway 644', N'Louisa', N'KY', N'21127', N'41230', 38.0933, -82.60474, 1533, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2206, N'Baptist Health Louisville', 1, NULL, NULL, N'180130', NULL, NULL, 0, 519, NULL, N'5028978100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Kresge Way', N'Louisville', N'KY', N'21111', N'40207', 38.239207, -85.639254, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2207, N'Lake Cumberland Regional Hospital', 1, NULL, NULL, N'180132', NULL, NULL, 0, 215, NULL, N'6066797441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Langdon Street', N'Somerset', N'KY', N'21199', N'42502', 37.086395, -84.617298, 1562, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2208, N'Baptist Health La Grange', 1, NULL, NULL, N'180138', NULL, NULL, 0, 90, NULL, N'5022225388', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 New Moody Lane', N'La Grange', N'KY', N'21185', N'40031', 38.396238, -85.375934, 1527, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2209, N'Kentucky River Medical Center', 1, NULL, NULL, N'180139', NULL, NULL, 0, 55, NULL, N'6066666000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'540 Jett Drive', N'Jackson', N'KY', N'21025', N'41339', 37.561335, -83.37208, 1571, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2210, N'University Of Louisville Hospital', 1, NULL, NULL, N'180141', NULL, NULL, 0, 404, NULL, N'5025623000', N'5025623333', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 South Jackson Street', N'Louisville', N'KY', N'21111', N'40202', 38.248843, -85.745001, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2211, N'Saint Joseph East', 1, NULL, NULL, N'180143', NULL, NULL, 0, 174, NULL, N'8599675000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 North Eagle Creek Drive', N'Lexington', N'KY', N'21067', N'40509', 38.000573, -84.439978, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2212, N'Westlake Regional Hospital', 1, NULL, NULL, N'180149', NULL, NULL, 0, 77, NULL, N'2703844753', N'2703846228', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Westlake Drive', N'Columbia', N'KY', N'21001', N'42728', 37.096948, -85.295954, 1501, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2213, N'Continuecare Hospital At Baptist Health Paducah', 1, NULL, NULL, N'180153', NULL, NULL, 0, 37, NULL, N'2705752100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Kentucky Avenue 5Th Floor', N'Paducah', N'KY', N'21145', N'42003', 37.073453, -88.626812, 1550, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2214, N'Marcum And Wallace Memorial Hospital', 1, NULL, NULL, N'181301', NULL, NULL, 0, 25, NULL, N'6067232115', N'6067232951', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Mercy Court', N'Irvine', N'KY', N'21065', N'40336', 37.70585, -83.977791, 1525, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2215, N'The James B Haggin Memorial Hospital', 1, NULL, NULL, N'181302', NULL, NULL, 0, 25, NULL, N'8597345441', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'464 Linden Avenue', N'Harrodsburg', N'KY', N'21167', N'40330', 37.756295, -84.848134, 1519, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2216, N'Trigg County Hospital', 1, NULL, NULL, N'181304', NULL, NULL, 0, 25, NULL, N'2705223215', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Main Street', N'Cadiz', N'KY', N'21221', N'42211', 36.867258, -87.821361, 1497, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2217, N'Saint Joseph Martin', 1, NULL, NULL, N'181305', NULL, NULL, 0, 25, NULL, N'6062856401', N'6062856409', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11203 Main Street', N'Martin', N'KY', N'21071', N'41649', 37.575716, -82.751555, 1555, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2218, N'Methodist Hospital Union County', 1, NULL, NULL, N'181306', NULL, NULL, 0, 25, NULL, N'2703895000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4604 Us Highway 60 West', N'Morganfield', N'KY', N'21225', N'42437', 37.627034, -87.943418, 1544, 94, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2219, N'Morgan County Arh Hospital', 1, NULL, NULL, N'181307', NULL, NULL, 0, 20, NULL, N'6067433186', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'476 Liberty Road', N'West Liberty', N'KY', N'21175', N'41472', 37.920208, -83.26638, 1567, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2220, N'Bluegrass Community Hospital', 1, NULL, NULL, N'181308', NULL, NULL, 0, 25, NULL, N'8598792300', N'8598731016', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 Amsden Avenue', N'Versailles', N'KY', N'21239', N'40383', 38.055167, -84.723674, 1566, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2221, N'Casey County Hospital', 1, NULL, NULL, N'181309', NULL, NULL, 0, 24, NULL, N'6067876275', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'187 Wolford Avenue', N'Liberty', N'KY', N'21045', N'42539', 37.317761, -84.931763, 1505, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2222, N'Carroll County Memorial Hospital', 1, NULL, NULL, N'181310', NULL, NULL, 0, 25, NULL, N'5027324321', N'5027323297', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Eleventh Street', N'Carrollton', N'KY', N'21041', N'41008', 38.679877, -85.169311, 1500, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2223, N'St Elizabeth Grant', 1, NULL, NULL, N'181311', NULL, NULL, 0, 15, NULL, N'8598248240', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 Barnes Road', N'Williamstown', N'KY', N'21081', N'41097', 38.647735, -84.578157, 1569, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2224, N'New Horizons Medical Center', 1, NULL, NULL, N'181312', NULL, NULL, 0, 25, NULL, N'5024844656', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Roland Avenue', N'Owenton', N'KY', N'21187', N'40359', 38.540262, -84.841183, 1549, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2225, N'Caverna Memorial Hospital', 1, NULL, NULL, N'181314', NULL, NULL, 0, 25, NULL, N'2707862191', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 South Dixie Street', N'Horse Cave', N'KY', N'21099', N'42749', 37.160777, -85.922717, 1514, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2226, N'Ephraim Mcdowell Fort Logan Hospital', 1, NULL, NULL, N'181315', NULL, NULL, 0, 25, NULL, N'6063654788', N'6063654631', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Metker Trail', N'Stanford', N'KY', N'21137', N'40484', 37.543616, -84.653879, 1564, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2227, N'Mary Breckinridge Arh Hospital', 1, NULL, NULL, N'181316', NULL, NULL, 0, 25, NULL, N'6066722901', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Kate Ireland Drive', N'Hyden', N'KY', N'21131', N'41749', 37.163242, -83.378247, 1524, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2228, N'Cumberland County Hospital', 1, NULL, NULL, N'181317', NULL, NULL, 0, 25, NULL, N'2708642511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'299 Glasw Road', N'Burkesville', N'KY', N'21057', N'42717', 36.79471, -85.370731, 1496, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2229, N'The Medical Center At Franklin', 1, NULL, NULL, N'181318', NULL, NULL, 0, 25, NULL, N'2705984800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Brookhaven Road', N'Franklin', N'KY', N'21213', N'42135', 36.69999, -86.575562, 1511, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2230, N'Breckinridge Memorial Hospital', 1, NULL, NULL, N'181319', NULL, NULL, 0, 25, NULL, N'2707567000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Old Highway 60', N'Hardinsburg', N'KY', N'21027', N'40143', 37.763514, -86.44092, 1517, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2231, N'Livingston Hospital And Healthcare Services Inc', 1, NULL, NULL, N'181320', NULL, NULL, 0, 25, NULL, N'2709882299', N'2709883900', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'131 Hospital Drive', N'Salem', N'KY', N'21139', N'42078', 37.263472, -88.229755, 1560, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2232, N'Wayne County Hospital', 1, NULL, NULL, N'181321', NULL, NULL, 0, 25, NULL, N'6063489343', N'6063403291', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'166 Hospital Street', N'Monticello', N'KY', N'21231', N'42633', 36.820868, -84.869597, 1542, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2233, N'Caldwell Medical Center', 1, NULL, NULL, N'181322', NULL, NULL, 0, 25, NULL, N'2703650300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Princeton', N'KY', N'21033', N'42445', 37.114192, -87.90763, 1556, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2234, N'Ohio County Hospital', 1, NULL, NULL, N'181323', NULL, NULL, 0, 25, NULL, N'2702987411', NULL, 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211 Old Main Street', N'Hartford', N'KY', N'21183', N'42347', 37.447539, -86.894909, 1520, 116, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2235, N'The Medical Center At Scottsville', 1, NULL, NULL, N'181324', NULL, NULL, 0, 25, NULL, N'2706222800', N'2706222208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'456 Burnley Road', N'Scottsville', N'KY', N'21003', N'42164', 36.761926, -86.216822, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2236, N'Jane Todd Crawford Hospital', 1, NULL, NULL, N'181325', NULL, NULL, 0, 35, NULL, N'2709324211', N'2709323504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202-206 Milby Street', N'Greensburg', N'KY', N'21087', N'42743', 37.242802, -85.493791, 1515, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2237, N'Marshall County Hospital', 1, NULL, NULL, N'181327', NULL, NULL, 0, 25, NULL, N'2705274800', N'2705274910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Old Symsonia Road', N'Benton', N'KY', N'21157', N'42025', 36.868565, -88.368647, 1550, 117, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2238, N'Knox County Hospital', 1, NULL, NULL, N'181328', NULL, NULL, 0, 25, NULL, N'6065464175', N'6065455511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Hospital Drive', N'Barbourville', N'KY', N'21121', N'40906', 36.85231, -83.87152, 1492, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2239, N'Saint Joseph Berea', 1, NULL, NULL, N'181329', NULL, NULL, 0, 25, NULL, N'8599866500', N'8599866768', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Estill Street', N'Berea', N'KY', N'21151', N'40403', 37.574925, -84.285904, 1494, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2240, N'Russell County Hospital', 1, NULL, NULL, N'181330', NULL, NULL, 0, 25, NULL, N'2708664141', N'2708662136', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'153 Dowell Road', N'Russell Springs', N'KY', N'21207', N'42642', 37.064579, -85.067888, 1558, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2241, N'Mcdowell Arh Hospital', 1, NULL, NULL, N'181331', NULL, NULL, 0, 25, NULL, N'6063773400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9879 Kentucky Route 122', N'Mc Dowell', N'KY', N'21071', N'41647', 37.572603, -85.155141, 1540, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2242, N'Kindred Hospital Louisville', 1, NULL, NULL, N'182001', NULL, NULL, 0, 367, NULL, N'5025877001', N'5025870060', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 Saint Anthony Place', N'Louisville', N'KY', N'21111', N'40204', 38.242555, -85.73178, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2243, N'Continuing Care Hosp At St Joseph East', 1, NULL, NULL, N'182002', NULL, NULL, 0, 57, NULL, N'8592684800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 N Eagle Creek Dr 5Th Floor', N'Lexington', N'KY', N'21067', N'40509', 37.997903, -84.443452, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2244, N'Select Specialty Hospital Lexington', 1, NULL, NULL, N'182003', NULL, NULL, 0, 41, NULL, N'8592267178', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Limestone Street 3Rd Floor', N'Lexington', N'KY', N'21067', N'40509', 38.043074, -84.501571, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2245, N'Select Specialty Hospital-Northern Kentucky', 1, NULL, NULL, N'182004', NULL, NULL, 0, 33, NULL, N'8595723880', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 North Grand Avenue Three Center 3Rd Flr Center', N'Fort Thomas', N'KY', N'21037', N'41075', 39.078555, -84.465208, 1509, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2246, N'Commonwealth Regional Specialty Hospital', 1, NULL, NULL, N'182005', NULL, NULL, 0, 28, NULL, N'2707966200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Park Drive 5Th Floor', N'Bowling Green', N'KY', N'21227', N'42101', 36.99032, -86.443602, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2247, N'Oak Tree Hosp At Bapt Regional Med Ctr', 1, NULL, NULL, N'182006', NULL, NULL, 0, 32, NULL, N'6065235150', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Trillium Way Lower Level', N'Corbin', N'KY', N'21121', N'40701', 36.948699, -84.096876, 1502, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2248, N'Cardinal Hill Rehabilitation Hospital', 1, NULL, NULL, N'183026', NULL, NULL, 0, 108, NULL, N'8592545701', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Versailles Road', N'Lexington', N'KY', N'21067', N'40504', 38.049427, -84.527049, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2249, N'Healthsouth Northern Kentucky Rehabilitation Hospi', 1, NULL, NULL, N'183027', NULL, NULL, 0, 40, NULL, N'8593442044', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Medical Village Drive', N'Edgewood', N'KY', N'21117', N'41017', 39.01281, -84.565521, 1503, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2250, N'Healthsouth Lakeview Rehab Hospital Of Central Ky', 1, NULL, NULL, N'183028', NULL, NULL, 0, 40, NULL, N'2707693100', N'2707696870', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 Heartland Drive', N'Elizabethtown', N'KY', N'21093', N'42701', 37.713083, -85.87547, 1506, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2251, N'Southern Kentucky Rehabilitation Hospital', 1, NULL, NULL, N'183029', NULL, NULL, 0, 60, NULL, N'2707826900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Campbell Lane', N'Bowling Green', N'KY', N'21227', N'42104', 36.954765, -86.444866, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2252, N'Gateway Rehabilitation Hospital', 1, NULL, NULL, N'183030', NULL, NULL, 0, 40, NULL, N'8594262400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5940 Merchants Street', N'Florence', N'KY', N'21015', N'41042', 39.008648, -84.655025, 1508, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2253, N'Shriners Hospital For Children', 1, NULL, NULL, N'183300', NULL, NULL, 0, 50, NULL, N'8592662101', N'8592685753', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Richmond Road', N'Lexington', N'KY', N'21067', N'40502', 38.004813, -84.449597, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2254, N'Western State Hospital', 1, NULL, NULL, N'184002', NULL, NULL, 0, 495, NULL, N'2708896025', N'2708864487', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Russellville Road', N'Hopkinsville', N'KY', N'21047', N'42240', 36.863902, -87.454917, 1523, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2255, N'Eastern State Hospital', 1, NULL, NULL, N'184004', NULL, NULL, 0, 323, NULL, N'8592468000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 Bull Lea Road', N'Lexington', N'KY', N'21067', N'40511', 38.082781, -84.497882, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2256, N'Northkey Community Care Children''s Intensive Serv', 1, NULL, NULL, N'184006', NULL, NULL, 0, 51, NULL, N'8595783252', N'8595783256', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'502 Farrell Drive', N'Covington', N'KY', N'21117', N'41011', 39.046399, -84.526543, 1503, 113, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2257, N'The Brook Hospital - Dupont', 1, NULL, NULL, N'184007', NULL, NULL, 0, 94, NULL, N'5028960495', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Browns Lane', N'Louisville', N'KY', N'21111', N'40207', 38.235713, -85.627311, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2258, N'The Brook Hospital - Kmi', 1, NULL, NULL, N'184008', NULL, NULL, 0, 94, NULL, N'5024266380', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8521 Lagrange Road', N'Louisville', N'KY', N'21111', N'40242', 38.254238, -85.759407, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2259, N'The Ridge Behavioral Health System', 1, NULL, NULL, N'184009', NULL, NULL, 0, 110, NULL, N'8592692325', N'8592686451', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3050 Rio Dosa Drive', N'Lexington', N'KY', N'21067', N'40509', 38.00467, -84.442441, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2260, N'Lincoln Trail Behavioral Health System', 1, NULL, NULL, N'184012', NULL, NULL, 0, 140, NULL, N'2703519444', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3909 S Wilson Road', N'Radcliff', N'KY', N'21093', N'40160', 37.789008, -85.912944, 1506, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2261, N'Rivervalley Behavioral Health Hospital', 1, NULL, NULL, N'184013', NULL, NULL, 0, 80, NULL, N'2706896800', N'2706896701', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 Industrial Drive', N'Owensboro', N'KY', N'21059', N'42302', 37.773545, -87.157485, 1548, 116, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2262, N'Cumberland Hall', 1, NULL, NULL, N'184014', NULL, NULL, 0, 97, NULL, N'2708861919', N'2708861335', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 Walton Way', N'Hopkinsville', N'KY', N'21047', N'42240', 36.738307, -87.468636, 1523, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2263, N'Central State Hospital', 1, NULL, NULL, N'184015', NULL, NULL, 0, 192, NULL, N'5022537045', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10510 Lagrange Road', N'Louisville', N'KY', N'21111', N'40223', 38.254238, -85.759407, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2264, N'Rivendell Behavioral Health Services', 1, NULL, NULL, N'184017', NULL, NULL, 0, 84, NULL, N'2708431199', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 Porter Pike', N'Bowling Green', N'KY', N'21227', N'42103', 36.99032, -86.443602, 1495, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2265, N'Jewish Hospital And St Mary''s Healthcare', 1, NULL, NULL, N'189800', NULL, NULL, 0, 0, NULL, N'5025818687', N'5025874537', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Abraham Flexner Way', N'Louisville', N'KY', N'21111', N'40202', 38.24917, -85.751246, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2266, N'Kosair Childrens Hosp/Norton', 1, NULL, NULL, N'189801', NULL, NULL, 0, 0, NULL, N'5026292087', N'5026298047', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'231 East Chestnut St', N'Louisville', N'KY', N'21111', N'40202', 38.248448, -85.749737, 1534, 115, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2267, N'University Of Kentucky Chandler Hospital', 1, NULL, NULL, N'189802', NULL, NULL, 0, 0, NULL, N'8593235470', N'8593232044', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 Rose Street', N'Lexington', N'KY', N'21067', N'40536', 38.032772, -84.506765, 1531, 114, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2268, N'Lafayette General Medical Center', 1, NULL, NULL, N'190002', NULL, NULL, 0, 299, NULL, N'3372897991', N'3372898671', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1214 Coolidge Avenue', N'Lafayette', N'LA', N'22055', N'70503', 30.202669, -92.018356, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2269, N'Dauterive Hospital', 1, NULL, NULL, N'190003', NULL, NULL, 0, 103, NULL, N'3373657311', N'3373744104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Lewis Street', N'New Iberia', N'LA', N'22045', N'70563', 30.007689, -91.795591, 1617, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2270, N'Thibodaux Regional Medical Center', 1, NULL, NULL, N'190004', NULL, NULL, 0, 180, NULL, N'9854475500', N'9854465033', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 N Acadia Road', N'Thibodaux', N'LA', N'22057', N'70301', 29.780172, -90.806405, 1632, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2271, N'University Medical Center New Orleans', 1, NULL, NULL, N'190005', NULL, NULL, 0, 446, NULL, N'5049033000', N'5049032837', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Canal Street', N'New Orleans', N'LA', N'22071', N'70112', 29.961056, -90.080858, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2272, N'University Hospital & Clinics', 1, NULL, NULL, N'190006', NULL, NULL, 0, 116, NULL, N'3372616000', N'3372616003', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2390 West Congress', N'Lafayette', N'LA', N'22055', N'70506', 30.215792, -92.045675, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2273, N'Natchitoches Regional Medical Center', 1, NULL, NULL, N'190007', NULL, NULL, 0, 96, NULL, N'3182144200', N'3182144354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Keyser Ave', N'Natchitoches', N'LA', N'22069', N'71457', 31.753409, -93.077017, 1616, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2274, N'Terrebonne General Medical Center', 1, NULL, NULL, N'190008', NULL, NULL, 0, 321, NULL, N'9858734141', N'9858734640', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8166 Main Street', N'Houma', N'LA', N'22109', N'70360', 29.598537, -90.714322, 1596, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2275, N'University Health Conway', 1, NULL, NULL, N'190011', NULL, NULL, 0, 247, NULL, N'3183307000', N'3183307591', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4864 Jackson Street', N'Monroe', N'LA', N'22073', N'71202', 32.452442, -92.105823, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2276, N'West Calcasieu Cameron Hospital', 1, NULL, NULL, N'190013', NULL, NULL, 0, 110, NULL, N'3375277034', N'3375274163', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Cypress Street', N'Sulphur', N'LA', N'22019', N'70663', 30.231058, -93.368718, 1630, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2277, N'Teche Regional Medical Center', 1, NULL, NULL, N'190014', NULL, NULL, 0, 165, NULL, N'9853842200', N'9853804546', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Marguerite Street', N'Morgan City', N'LA', N'22101', N'70380', 29.708704, -91.200052, 1614, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2278, N'North Oaks Medical Center L L C', 1, NULL, NULL, N'190015', NULL, NULL, 0, 330, NULL, N'9853452700', N'9852306482', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15790 Paul Vega Md Drive', N'Hammond', N'LA', N'22105', N'70403', 30.466368, -90.459166, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2279, N'Opelousas General Health System', 1, NULL, NULL, N'190017', NULL, NULL, 0, 209, NULL, N'3379483011', N'3379485126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'539 East Prudhomme Street', N'Opelousas', N'LA', N'22097', N'70570', 30.543462, -92.075816, 1622, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2280, N'Christus St Frances Cabrini Hospital', 1, NULL, NULL, N'190019', NULL, NULL, 0, 283, NULL, N'3184871122', N'3184486754', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Masonic Drive', N'Alexandria', N'LA', N'22079', N'71301', 31.282529, -92.460734, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2281, N'Lane Regional Medical Center', 1, NULL, NULL, N'190020', NULL, NULL, 0, 139, NULL, N'2256584000', N'2256584287', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6300 Main Street', N'Zachary', N'LA', N'22033', N'70791', 30.64996, -91.136768, 1638, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2282, N'Savoy Medical Center', 1, NULL, NULL, N'190025', NULL, NULL, 0, 180, NULL, N'3374685261', N'3374683342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Poinciana Avenue', N'Mamou', N'LA', N'22039', N'70554', 30.641032, -92.417605, 1606, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2283, N'Rapides Regional Medical Center', 1, NULL, NULL, N'190026', NULL, NULL, 0, 328, NULL, N'3187693000', N'3187693929', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 4Th Street', N'Alexandria', N'LA', N'22079', N'71301', 31.314363, -92.449683, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2284, N'Christus St Patrick Hospital', 1, NULL, NULL, N'190027', NULL, NULL, 0, 230, NULL, N'3374362511', N'3374917157', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'524 Dr Michael Debakey Street', N'Lake Charles', N'LA', N'22019', N'70601', 30.226595, -93.217376, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2285, N'Abbeville General Hospital', 1, NULL, NULL, N'190034', NULL, NULL, 0, 60, NULL, N'3378935466', N'3378932801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 N Hospital Dr', N'Abbeville', N'LA', N'22113', N'70510', 29.972116, -92.106982, 1572, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2286, N'Ochsner Medical Center', 1, NULL, NULL, N'190036', NULL, NULL, 0, 838, NULL, N'5048423000', N'5048423065', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1516 Jefferson Hwy', N'New Orleans', N'LA', N'22051', N'70121', 29.962943, -90.14632, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2287, N'West Jefferson Medical Center', 1, NULL, NULL, N'190039', NULL, NULL, 0, 435, NULL, N'5043475511', N'5043496299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Medical Center Blvd', N'Marrero', N'LA', N'22051', N'70072', 29.891619, -90.095875, 1609, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2288, N'Slidell Memorial Hospital', 1, NULL, NULL, N'190040', NULL, NULL, 0, 229, NULL, N'9856432200', N'9856498626', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Gause Blvd', N'Slidell', N'LA', N'22103', N'70458', 30.284651, -89.770468, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2289, N'Christus Health Shreveport - Bossier', 1, NULL, NULL, N'190041', NULL, NULL, 0, 169, NULL, N'3186815000', N'3186815475', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1453 E Bert Kouns Industrial Drive', N'Shreveport', N'LA', N'22017', N'71105', 32.426313, -93.718672, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2290, N'Acadia General Hospital', 1, NULL, NULL, N'190044', NULL, NULL, 0, 140, NULL, N'3377833222', N'3377886413', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 Crowley Rayne Highway', N'Crowley', N'LA', N'22001', N'70526', 30.226654, -92.362542, 1583, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2291, N'St Tammany Parish Hospital', 1, NULL, NULL, N'190045', NULL, NULL, 0, 223, NULL, N'9858984000', N'9858984394', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 S Tyler Street', N'Covington', N'LA', N'22103', N'70433', 30.469181, -90.113763, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2292, N'Touro Infirmary', 1, NULL, NULL, N'190046', NULL, NULL, 0, 360, NULL, N'5048977011', N'5048978769', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Foucher Street', N'New Orleans', N'LA', N'22071', N'70115', 29.925467, -90.092949, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2293, N'Beauregard Memorial Hospital', 1, NULL, NULL, N'190050', NULL, NULL, 0, 60, NULL, N'3374627100', N'3374627479', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 S Pine Street', N'Deridder', N'LA', N'22011', N'70634', 30.84195, -93.289056, 1585, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2294, N'Jennings American Legion Hospital', 1, NULL, NULL, N'190053', NULL, NULL, 0, 49, NULL, N'3376167000', N'3376167034', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1634 Elton Road', N'Jennings', N'LA', N'22053', N'70546', 30.23828, -92.66344, 1598, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2295, N'Iberia General Hospital And Medical Center', 1, NULL, NULL, N'190054', NULL, NULL, 0, 100, NULL, N'3373640441', N'3373747641', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2315 E Main Street', N'New Iberia', N'LA', N'22045', N'70562', 29.988867, -91.78537, 1617, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2296, N'Lake Charles Memorial Hospital', 1, NULL, NULL, N'190060', NULL, NULL, 0, 336, NULL, N'3374943000', N'3374943299', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Oak Park Blvd', N'Lake Charles', N'LA', N'22019', N'70601', 30.203261, -93.193293, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2297, N'Our Lady Of The Lake Regional Medical Center', 1, NULL, NULL, N'190064', NULL, NULL, 0, 844, NULL, N'2257656565', N'2257658305', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Hennessy Blvd', N'Baton Rouge', N'LA', N'22033', N'70808', 30.401318, -91.111528, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2298, N'Baton Rouge General Medical Center', 1, NULL, NULL, N'190065', NULL, NULL, 0, 590, NULL, N'2253877767', N'2253816129', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Florida Street', N'Baton Rouge', N'LA', N'22033', N'70806', 30.450336, -91.154638, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2299, N'St Charles Parish Hospital', 1, NULL, NULL, N'190079', NULL, NULL, 0, 59, NULL, N'9857856242', N'9857853642', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1057 Paul Maillard Road', N'Luling', N'LA', N'22089', N'70070', 29.924424, -90.371818, 1604, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2300, N'West Carroll Memorial Hospital', 1, NULL, NULL, N'190081', NULL, NULL, 0, 33, NULL, N'3184283237', N'3184283230', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 Ross Street', N'Oak Grove', N'LA', N'22123', N'71263', 32.867445, -91.383189, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2301, N'Northern Louisiana Medical Center', 1, NULL, NULL, N'190086', NULL, NULL, 0, 161, NULL, N'3182542100', N'3182542728', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Vaughn Avenue', N'Ruston', N'LA', N'22061', N'71270', 32.515766, -92.632414, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2302, N'Springhill Medical Center', 1, NULL, NULL, N'190088', NULL, NULL, 0, 60, NULL, N'3185391000', N'3185394085', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Doctors Drive', N'Springhill', N'LA', N'22119', N'71075', 33.010659, -93.443543, 1629, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2303, N'Winn Parish Medical Center', 1, NULL, NULL, N'190090', NULL, NULL, 0, 60, NULL, N'3186483000', N'3186282035', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Boundary Street', N'Winnfield', N'LA', N'22127', N'71483', 31.924979, -92.645139, 1636, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2304, N'University Health Shreveport', 1, NULL, NULL, N'190098', NULL, NULL, 0, 452, NULL, N'3186755000', N'3186753373', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1541 Kings Highway', N'Shreveport', N'LA', N'22017', N'71103', 32.48179, -93.761575, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2305, N'Avoyelles Hospital', 1, NULL, NULL, N'190099', NULL, NULL, 0, 55, NULL, N'3182538611', N'3182406077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4231 Highway 1192', N'Marksville', N'LA', N'22009', N'71351', 31.143128, -92.064433, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2306, N'Our Lady Of Lourdes Regional Medical Center Inc', 1, NULL, NULL, N'190102', NULL, NULL, 0, 267, NULL, N'3374702000', N'3374702574', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.14877, -92.0383, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2307, N'Oakdale Community Hospital', 1, NULL, NULL, N'190106', NULL, NULL, 0, 60, NULL, N'3183353700', N'3182153024', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 N Hospital Dr', N'Oakdale', N'LA', N'22003', N'71463', 30.817128, -92.644791, 1620, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2308, N'Willis Knighton Medical Center', 1, NULL, NULL, N'190111', NULL, NULL, 0, 720, NULL, N'3182124000', N'3182124956', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Greenwood Road', N'Shreveport', N'LA', N'22017', N'71103', 32.483912, -93.778797, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2309, N'Claiborne Memorial Medical Center', 1, NULL, NULL, N'190114', NULL, NULL, 0, 60, NULL, N'3189272024', N'3189279212', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 East College Street', N'Homer', N'LA', N'22027', N'71040', 32.794636, -93.062497, 1595, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2310, N'Morehouse General Hospital', 1, NULL, NULL, N'190116', NULL, NULL, 0, 49, NULL, N'3182833600', N'3182833663', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 W Walnut', N'Bastrop', N'LA', N'22067', N'71220', 32.775319, -91.917045, 1575, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2311, N'Desoto Regional Health System', 1, NULL, NULL, N'190118', NULL, NULL, 0, 38, NULL, N'3188724610', N'3188726134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Jefferson Street', N'Mansfield', N'LA', N'22031', N'71052', 32.035279, -93.709136, 1607, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2312, N'St Francis Medical Center', 1, NULL, NULL, N'190125', NULL, NULL, 0, 550, NULL, N'3189664000', N'3189664142', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Jackson Street', N'Monroe', N'LA', N'22073', N'71201', 32.499336, -92.114584, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2313, N'Woman''s Hospital', 1, NULL, NULL, N'190128', NULL, NULL, 0, 168, NULL, N'2259271300', N'2259248777', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Woman''s Way', N'Baton Rouge', N'LA', N'22033', N'70817', 30.385001, -91.037784, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2314, N'Allen Parish Hospital', 1, NULL, NULL, N'190133', NULL, NULL, 0, 49, NULL, N'3377382527', N'3377385305', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'108 6Th Avenue', N'Kinder', N'LA', N'22003', N'70648', 30.49143, -92.856859, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2315, N'Franklin Medical Center', 1, NULL, NULL, N'190140', NULL, NULL, 0, 39, NULL, N'3184359411', N'3184353842', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2106 Loop Road', N'Winnsboro', N'LA', N'22041', N'71295', 32.15888, -91.705234, 1637, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2316, N'Minden Medical Center', 1, NULL, NULL, N'190144', NULL, NULL, 0, 161, NULL, N'3183772321', N'3183715606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'No 1 Medical Plaza', N'Minden', N'LA', N'22119', N'71055', 52.288105, 8.916885, 1612, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2317, N'Lasalle General Hospital', 1, NULL, NULL, N'190145', NULL, NULL, 0, 49, NULL, N'3189929200', N'3189929245', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'187 Ninth St/Hwy 84 West', N'Jena', N'LA', N'22059', N'71342', 50.93314, 11.583309, 1597, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2318, N'East Jefferson General Hospital', 1, NULL, NULL, N'190146', NULL, NULL, 0, 407, NULL, N'5044544000', N'5044545591', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Houma Blvd', N'Metairie', N'LA', N'22051', N'70006', 30.014162, -90.181468, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2319, N'Richardson Medical Center', 1, NULL, NULL, N'190151', NULL, NULL, 0, 38, NULL, N'3187284181', N'3187288107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Highway 3048', N'Rayville', N'LA', N'22083', N'71269', 32.457961, -91.738617, 1625, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2320, N'Glenwood Regional Medical Center', 1, NULL, NULL, N'190160', NULL, NULL, 0, 268, NULL, N'3183294600', N'3183294710', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 Mcmillan Road', N'West Monroe', N'LA', N'22073', N'71291', 32.513457, -92.15607, 1635, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2321, N'Byrd Regional Hospital', 1, NULL, NULL, N'190164', NULL, NULL, 0, 60, NULL, N'3372399041', N'3372395360', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 Fertitta Blvd', N'Leesville', N'LA', N'22115', N'71446', 31.13728, -93.26915, 1603, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2322, N'Mercy Regional Medical Center', 1, NULL, NULL, N'190167', NULL, NULL, 0, 109, NULL, N'3373635684', N'3373639488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 E Main', N'Ville Platte', N'LA', N'22039', N'70586', 30.684745, -92.265504, 1633, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2323, N'River Parishes Hospital', 1, NULL, NULL, N'190175', NULL, NULL, 0, 80, NULL, N'9856527000', N'9856525161', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Rue De Sante', N'Laplace', N'LA', N'22095', N'70068', 48.836831, 2.341893, 1602, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2324, N'Tulane Medical Center', 1, NULL, NULL, N'190176', NULL, NULL, 0, 339, NULL, N'5049881900', N'5049882316', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1415 Tulane Ave', N'New Orleans', N'LA', N'22071', N'70112', 29.955196, -90.07598, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2325, N'Lakeview Regional Medical Center', 1, NULL, NULL, N'190177', NULL, NULL, 0, 167, NULL, N'9858674443', N'9858674449', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Judge Tanner Boulevard', N'Covington', N'LA', N'22103', N'70433', 30.409916, -90.081172, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2326, N'Leonard J Chabert Medical Center', 1, NULL, NULL, N'190183', NULL, NULL, 0, 156, NULL, N'9858731285', N'9858731262', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1978 Industrial Blvd', N'Houma', N'LA', N'22109', N'70363', 29.571382, -90.688112, 1596, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2327, N'Citizens Medical Center', 1, NULL, NULL, N'190184', NULL, NULL, 0, 40, NULL, N'3186496106', N'3186492080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7939 U S Hwy 165 South', N'Columbia', N'LA', N'22021', N'71418', 32.039671, -92.11913, 1581, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2328, N'Caldwell Memorial Hospital Inc', 1, NULL, NULL, N'190190', NULL, NULL, 0, 47, NULL, N'3186496111', N'3186495094', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Main Street', N'Columbia', N'LA', N'22021', N'71418', 32.104181, -92.076123, 1581, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2329, N'Villa Feliciana Medical Complex', 1, NULL, NULL, N'190199', NULL, NULL, 0, 297, NULL, N'2256344010', N'2256344191', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5002 Highway 10', N'Jackson', N'LA', N'22037', N'70748', 30.831248, -91.178356, 1638, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2330, N'Lake Area Medical Center', 1, NULL, NULL, N'190201', NULL, NULL, 0, 88, NULL, N'3374746370', N'3374754143', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Nelson Road', N'Lake Charles', N'LA', N'22019', N'70605', 30.181139, -93.24934, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2331, N'Ochsner Medical Center - Baton Rouge', 1, NULL, NULL, N'190202', NULL, NULL, 0, 150, NULL, N'2257554876', N'2257554883', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17000 Medical Center Dr', N'Baton Rouge', N'LA', N'22033', N'70816', 30.441083, -91.00008, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2332, N'Ochsner Medical Center - Northshore L L C', 1, NULL, NULL, N'190204', NULL, NULL, 0, 165, NULL, N'9856497070', N'9856465552', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Slidell', N'LA', N'22103', N'70461', 30.287607, -89.745587, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2333, N'Women''s And Children''s Hospital', 1, NULL, NULL, N'190205', NULL, NULL, 0, 241, NULL, N'3375219100', N'3375219102', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.198006, -92.075264, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2334, N'East Carroll Parish Hospital', 1, NULL, NULL, N'190208', NULL, NULL, 0, 23, NULL, N'3185594023', N'3185593761', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'336 North Hood Street', N'Lake Providence', N'LA', N'22035', N'71254', 32.811245, -91.171635, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2335, N'Sabine Medical Center', 1, NULL, NULL, N'190218', NULL, NULL, 0, 48, NULL, N'3182561232', N'3182561298', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Highland Drive', N'Many', N'LA', N'22085', N'71449', 31.561209, -93.471475, 1608, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2336, N'Willis Knighton Bossier Health Center', 1, NULL, NULL, N'190236', NULL, NULL, 0, 166, NULL, N'3182127000', N'3182127005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Hospital Dr', N'Bossier City', N'LA', N'22015', N'71111', 32.55753, -93.718216, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2337, N'Physicians Medical Center', 1, NULL, NULL, N'190241', NULL, NULL, 0, 10, NULL, N'9858531390', N'9858577440', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Corporate Drive', N'Houma', N'LA', N'22109', N'70360', 29.59995, -90.750128, 1596, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2338, N'St Elizabeth Hospital', 1, NULL, NULL, N'190242', NULL, NULL, 0, 95, NULL, N'2256475000', N'2256479806', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 West Highway 30', N'nzales', N'LA', N'22005', N'70737', 30.210812, -90.932171, 1592, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2339, N'Monroe Surgical Hospital', 1, NULL, NULL, N'190245', NULL, NULL, 0, 10, NULL, N'3184100002', N'3184101960', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 Broadmoor Blvd', N'Monroe', N'LA', N'22073', N'71201', 32.536874, -92.102296, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2340, N'P & S Surgical Hospital', 1, NULL, NULL, N'190246', NULL, NULL, 0, 22, NULL, N'3183884040', N'3183884099', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Grammont St Suite 101', N'Monroe', N'LA', N'22073', N'71201', 32.501117, -92.115305, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2341, N'Louisiana Heart Hospital', 1, NULL, NULL, N'190250', NULL, NULL, 0, 136, NULL, N'9856407500', N'9856407530', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64030 Highway 434', N'Lacombe', N'LA', N'22103', N'70445', 30.359009, -89.916007, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2342, N'Surgical Specialty Center Of Baton Rouge', 1, NULL, NULL, N'190251', NULL, NULL, 0, 16, NULL, N'2254085730', N'2254085569', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8080 Bluebonnet Blvd', N'Baton Rouge', N'LA', N'22033', N'70810', 30.376137, -91.099447, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2343, N'Park Place Surgical Hospital', 1, NULL, NULL, N'190255', NULL, NULL, 0, 10, NULL, N'3372378119', N'3372674182', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4811 Ambassador Caffery Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.14979, -92.040101, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2344, N'Sterling Surgical Hospital', 1, NULL, NULL, N'190256', NULL, NULL, 0, 10, NULL, N'5046908200', N'9856908259', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'989 Robert Blvd', N'Slidell', N'LA', N'22103', N'70458', 30.290964, -89.76924, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2345, N'Lafayette Surgical Specialty Hospital', 1, NULL, NULL, N'190259', NULL, NULL, 0, 20, NULL, N'3377694100', N'3377694209', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Kaliste Saloom Rd', N'Lafayette', N'LA', N'22055', N'70508', 30.175737, -92.028056, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2346, N'Ouachita Community Hospital', 1, NULL, NULL, N'190261', NULL, NULL, 0, 10, NULL, N'3183221339', N'3183221693', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 Glennwood Drive', N'West Monroe', N'LA', N'22073', N'71291', 32.50156, -92.149655, 1635, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2347, N'Heart Hospital Of Lafayette', 1, NULL, NULL, N'190263', NULL, NULL, 0, 32, NULL, N'3375211000', N'3375211006', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Kaliste Saloom Road', N'Lafayette', N'LA', N'22055', N'70508', 30.174353, -92.028537, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2348, N'The Spine Hospital Of Louisiana', 1, NULL, NULL, N'190266', NULL, NULL, 0, 23, NULL, N'2257639900', N'2259064818', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10105 Park Row Circle Suite 250', N'Baton Rouge', N'LA', N'22033', N'70810', 30.380555, -91.095887, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2349, N'Fairway Medical Center', 1, NULL, NULL, N'190267', NULL, NULL, 0, 21, NULL, N'9858013010', N'9858013099', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67252 Industry Lane', N'Covington', N'LA', N'22103', N'70433', 30.407969, -90.08308, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2350, N'Lafayette General Surgical Hospital', 1, NULL, NULL, N'190268', NULL, NULL, 0, 10, NULL, N'3372898095', N'3372898059', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W Pinhook Rd Suite 100', N'Lafayette', N'LA', N'22055', N'70503', 30.203831, -92.013719, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2351, N'Southern Surgical Hospital', 1, NULL, NULL, N'190270', NULL, NULL, 0, 37, NULL, N'9856410600', N'9856437677', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 W Lindberg Drive', N'Slidell', N'LA', N'22103', N'70458', 30.27373, -89.75453, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2352, N'Ochsner Medical Center-Kenner Llc', 1, NULL, NULL, N'190274', NULL, NULL, 0, 110, NULL, N'5044648065', N'5044648062', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 West Esplanade Avenue', N'Kenner', N'LA', N'22051', N'70065', 30.02322, -90.27294, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2353, N'Specialists Hospital Shreveport', 1, NULL, NULL, N'190278', NULL, NULL, 0, 15, NULL, N'3182133800', N'3182133801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Line Avenue', N'Shreveport', N'LA', N'22017', N'71101', 32.497364, -93.74605, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2354, N'Doctors Hospital At Deer Creek Llc', 1, NULL, NULL, N'190297', NULL, NULL, 0, 10, NULL, N'3373925088', N'3373924983', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 South 10Th Street', N'Leesville', N'LA', N'22115', N'71446', 31.1371, -93.269558, 1603, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2355, N'Central Louisiana Surgical Hospital', 1, NULL, NULL, N'190298', NULL, NULL, 0, 24, NULL, N'3184496400', N'3184277930', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 North Bolton Ave', N'Alexandria', N'LA', N'22079', N'71301', 31.314821, -92.466938, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2356, N'St Charles Surgical Hospital Llc', 1, NULL, NULL, N'190300', NULL, NULL, 0, 39, NULL, N'5045296600', N'5045296672', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 St Charles Ave', N'New Orleans', N'LA', N'22071', N'70130', 29.937235, -90.07698, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2357, N'Omega Hospital Llc', 1, NULL, NULL, N'190302', NULL, NULL, 0, 16, NULL, N'5048494900', N'5048494868', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Severn Avenue', N'Metairie', N'LA', N'22051', N'70002', 29.9991883, -90.1613761, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2358, N'Cypress Pointe Surgical Hospital', 1, NULL, NULL, N'190303', NULL, NULL, 0, 30, NULL, N'9855106200', N'9855106202', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42570 South Airport Rd', N'Hammond', N'LA', N'22105', N'70403', 30.477189, -90.414266, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2359, N'South Cameron Memorial Hospital', 1, NULL, NULL, N'190307', NULL, NULL, 0, 49, NULL, N'3375424111', N'3375424110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5360 West Creole Hwy', N'Cameron', N'LA', N'22023', N'70631', 29.808415, -93.155801, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2360, N'St Bernard Parish Hospital', 1, NULL, NULL, N'190308', NULL, NULL, 0, 40, NULL, N'5048269500', N'5048261593', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 West Judge Perez Drive', N'Chalmette', N'LA', N'22087', N'70043', 29.957335, -89.98908, 1580, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2361, N'Our Lady Of The Angels Hospital', 1, NULL, NULL, N'190312', NULL, NULL, 0, 80, NULL, N'9857306706', N'9857306709', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 Plaza Street', N'Bogalusa', N'LA', N'22117', N'70427', 30.778386, -89.86841, 1578, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2362, N'New Orleans East Hospital', 1, NULL, NULL, N'190313', NULL, NULL, 0, 80, NULL, N'5045926600', N'5045926619', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5620 Read Blvd', N'New Orleans', N'LA', N'22071', N'70127', 30.030744, -89.971587, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2363, N'St Helena Parish Hospital Cah', 1, NULL, NULL, N'191300', NULL, NULL, 0, 25, NULL, N'2252226111', N'2252224819', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16874 Highway 43', N'Greensburg', N'LA', N'22091', N'70441', 30.832041, -90.666701, 1593, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2364, N'Union General Hospital', 1, NULL, NULL, N'191301', NULL, NULL, 0, 20, NULL, N'3183689751', N'3183688270', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 James Ave', N'Farmerville', N'LA', N'22111', N'71241', 32.786408, -92.393855, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2365, N'St Martin Hospital', 1, NULL, NULL, N'191302', NULL, NULL, 0, 25, NULL, N'3373322178', N'3373325092', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Champagne Boulevard', N'Breaux Bridge', N'LA', N'22099', N'70517', 30.282406, -91.890506, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2366, N'Assumption Community Hospital', 1, NULL, NULL, N'191303', NULL, NULL, 0, 15, NULL, N'9853693600', N'9853694236', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Highway 402', N'Napoleonville', N'LA', N'22007', N'70390', 29.955515, -91.031508, 1615, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2367, N'North Caddo Medical Center', 1, NULL, NULL, N'191304', NULL, NULL, 0, 25, NULL, N'3183753235', N'3183752440', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 South Pine Street', N'Vivian', N'LA', N'22017', N'71082', 32.864968, -93.988168, 1634, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2368, N'St James Parish Hospital', 1, NULL, NULL, N'191305', NULL, NULL, 0, 25, NULL, N'2258695512', N'2258695271', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1645 Lutcher Avenue', N'Lutcher', N'LA', N'22093', N'70071', 30.053308, -90.70301, 1605, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2369, N'West Feliciana Parish Hospital', 1, NULL, NULL, N'191306', NULL, NULL, 0, 22, NULL, N'2256353811', N'2256352442', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5266 Commerce Street', N'Saint Francisville', N'LA', N'22125', N'70775', 30.778629, -91.36966, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2370, N'Dequincy Memorial Hospital', 1, NULL, NULL, N'191307', NULL, NULL, 0, 25, NULL, N'3377861200', N'3377861219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 West 4Th Street', N'Dequincy', N'LA', N'22019', N'70633', 30.451921, -93.43697, 1584, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2371, N'Prevost Memorial Hospital', 1, NULL, NULL, N'191308', NULL, NULL, 0, 25, NULL, N'2254737931', N'2254742138', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Memorial Dr', N'Donaldsonville', N'LA', N'22005', N'70346', 30.089566, -91.003469, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2372, N'Hood Memorial Hospital', 1, NULL, NULL, N'191309', NULL, NULL, 0, 25, NULL, N'9857489485', N'9857488144', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W Walnut Street', N'Amite', N'LA', N'22105', N'70422', 30.733072, -90.512186, 1574, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2373, N'Franklin Foundation Hospital', 1, NULL, NULL, N'191310', NULL, NULL, 0, 22, NULL, N'3378280760', N'3378285024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1097 Northwest Blvd', N'Franklin', N'LA', N'22101', N'70538', 29.800765, -91.52661, 1589, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2374, N'Bunkie General Hospital', 1, NULL, NULL, N'191311', NULL, NULL, 0, 25, NULL, N'3183466681', N'3183466780', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 Evergreen Street', N'Bunkie', N'LA', N'22009', N'71322', 30.951476, -92.172992, 1579, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2375, N'Christus Coushatta Health Care Center', 1, NULL, NULL, N'191312', NULL, NULL, 0, 25, NULL, N'3189322000', N'3189322198', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635 Marvel Street', N'Coushatta', N'LA', N'22081', N'71019', 32.022341, -93.343255, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2376, N'Riverside Medical Center', 1, NULL, NULL, N'191313', NULL, NULL, 0, 25, NULL, N'9857954431', N'9858390319', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 South Main St', N'Franklinton', N'LA', N'22117', N'70438', 30.833733, -90.151439, 1590, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2377, N'Madison Parish Hospital', 1, NULL, NULL, N'191314', NULL, NULL, 0, 25, NULL, N'3185742374', N'3185742396', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Johnson Street', N'Tallulah', N'LA', N'22065', N'71282', 32.402515, -91.184783, 1631, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2378, N'Hardtner Medical Center', 1, NULL, NULL, N'191315', NULL, NULL, 0, 35, NULL, N'3184953131', N'3184953229', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 N Pine Road', N'Olla', N'LA', N'22059', N'71465', 31.901822, -92.24026, 1621, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2379, N'Pointe Coupee General Hospital', 1, NULL, NULL, N'191316', NULL, NULL, 0, 25, NULL, N'2253686386', N'2256385846', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2202 False River Drive', N'New Roads', N'LA', N'22077', N'70760', 30.682516, -91.461372, 1619, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2380, N'Jackson Parish Hospital', 1, NULL, NULL, N'191317', NULL, NULL, 0, 25, NULL, N'3182594435', N'3183954259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'165 Beech Springs Road', N'Jonesboro', N'LA', N'22049', N'71251', 32.25235, -92.713926, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2381, N'Riverland Medical Center', 1, NULL, NULL, N'191318', NULL, NULL, 0, 25, NULL, N'3187576551', N'3187573467', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700  Wallace Blvd', N'Ferriday', N'LA', N'22029', N'71334', 31.647086, -91.553845, 1588, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2382, N'Acadia St Landry', 1, NULL, NULL, N'191319', NULL, NULL, 0, 33, NULL, N'3376845435', N'3376841175', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 South Broadway Street', N'Church Point', N'LA', N'22001', N'70525', 30.394328, -92.211239, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2383, N'Bienville Medical Center', 1, NULL, NULL, N'191320', NULL, NULL, 0, 21, NULL, N'3182634700', N'3182639843', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Pine Street', N'Arcadia', N'LA', N'22013', N'71001', 32.554373, -92.914216, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2384, N'Lallie Kemp Medical Center', 1, NULL, NULL, N'191321', NULL, NULL, 0, 24, NULL, N'9858789421', N'9858781306', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'52579 Highway 51 South', N'Independence', N'LA', N'22105', N'70443', 30.620168, -90.496337, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2385, N'Abrom Kaplan Memorial Hospital', 1, NULL, NULL, N'191322', NULL, NULL, 0, 35, NULL, N'3376438300', N'3376435233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 West Seventh Street', N'Kaplan', N'LA', N'22113', N'70548', 30.007352, -92.296516, 1599, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2386, N'Richland Parish Hospital-Delhi', 1, NULL, NULL, N'191323', NULL, NULL, 0, 25, NULL, N'3188785171', N'3188786427', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 Cincinnati Street', N'Delhi', N'LA', N'22083', N'71232', 32.453224, -91.494064, 1586, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2387, N'Ochsner St Anne General Hospital', 1, NULL, NULL, N'191324', NULL, NULL, 0, 33, NULL, N'9855378377', N'9855378272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4608 Highway 1', N'Raceland', N'LA', N'22057', N'70394', 29.702908, -90.563348, 1624, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2388, N'Lady Of The Sea General Hospital', 1, NULL, NULL, N'191325', NULL, NULL, 0, 25, NULL, N'9856326401', N'9856328263', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West 134Th Place', N'Cut Off', N'LA', N'22057', N'70345', 29.455513, -90.31268, 1591, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2389, N'Reeves Memorial Medical Center', 1, NULL, NULL, N'191326', NULL, NULL, 0, 15, NULL, N'3182859066', N'3182857234', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 First Street', N'Bernice', N'LA', N'22111', N'71222', 32.824378, -92.657007, 1577, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2390, N'Promise Hospital Baton Rouge', 1, NULL, NULL, N'192004', NULL, NULL, 0, 54, NULL, N'2254909600', N'2254909693', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5130 Mancuso Lane', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397184, -91.102004, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2391, N'Cornerstone Hospital Of Bossier City', 1, NULL, NULL, N'192006', NULL, NULL, 0, 62, NULL, N'3187479500', N'3187477878', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Medical Drive', N'Bossier City', N'LA', N'22015', N'71112', 32.463457, -93.666512, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2392, N'Louisiana Continuing Care Hospital', 1, NULL, NULL, N'192007', NULL, NULL, 0, 44, NULL, N'5043492584', N'5043491287', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Medical Center Blvd 7Th Floor', N'Marrero', N'LA', N'22051', N'70072', 29.899372, -90.100351, 1609, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2393, N'Baton Rouge - A M G Specialty Hospital', 1, NULL, NULL, N'192008', NULL, NULL, 0, 59, NULL, N'2256652664', N'2256650736', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8375 Florida Blvd', N'Denham Springs', N'LA', N'22063', N'70726', 30.461488, -91.041888, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2394, N'Kindred Hospital New Orleans', 1, NULL, NULL, N'192009', NULL, NULL, 0, 168, NULL, N'5047625100', N'5047625506', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Coliseum Street', N'New Orleans', N'LA', N'22071', N'70115', 29.92507, -90.09318, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2395, N'Promise Hospital Of Louisiana Inc', 1, NULL, NULL, N'192010', NULL, NULL, 0, 196, NULL, N'3184254096', N'3184242627', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Irving Place', N'Shreveport', N'LA', N'22017', N'71101', 32.4938675, -93.7463327, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2396, N'Lifecare Hospitals Of Shreveport', 1, NULL, NULL, N'192011', NULL, NULL, 0, 119, NULL, N'3186888504', N'3186716859', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9320 Linwood Avenue', N'Shreveport', N'LA', N'22017', N'71106', 32.399539, -93.763484, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2397, N'Christus Dubuis Hospital Of Alexandria', 1, NULL, NULL, N'192012', NULL, NULL, 0, 25, NULL, N'3184484938', N'3184834033', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3330 Masonic Dr', N'Alexandria', N'LA', N'22079', N'71301', 31.271835, -92.468534, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2398, N'Cornerstone Hospital Southwest Louisiana', 1, NULL, NULL, N'192013', NULL, NULL, 0, 30, NULL, N'3373106000', N'3373106049', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 Cypress Street', N'Sulphur', N'LA', N'22019', N'70663', 30.230984, -93.365113, 1630, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2399, N'Ochsner Extended Care Hospital Of Kenner', 1, NULL, NULL, N'192015', NULL, NULL, 0, 32, NULL, N'5044648590', N'5044648675', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 West Esplanade Fifth Floor', N'Kenner', N'LA', N'22051', N'70065', 29.994092, -90.241743, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2400, N'Specialty Hospital', 1, NULL, NULL, N'192016', NULL, NULL, 0, 32, NULL, N'3189664126', N'3189667031', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 Jackson Street 7Th Floor', N'Monroe', N'LA', N'22073', N'71201', 32.50004, -92.114863, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2401, N'Extended Care Of Southwest Louisiana', 1, NULL, NULL, N'192019', NULL, NULL, 0, 29, NULL, N'3374808990', N'3374391133', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2837 Ernest Bldg B', N'Lake Charles', N'LA', N'22019', N'70601', 30.226595, -93.217376, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2402, N'Lifecare Specialty Hospital Of North Louisiana', 1, NULL, NULL, N'192022', NULL, NULL, 0, 55, NULL, N'3182513126', N'3182511594', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Ezell Street', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2403, N'St Catherine Memorial Hospital', 1, NULL, NULL, N'192023', NULL, NULL, 0, 21, NULL, N'5042103000', N'5042103006', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14500 Hayne Blvd', N'New Orleans', N'LA', N'22071', N'70128', 30.071009, -89.947607, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2404, N'Promise Hospital Of Miss Lou', 1, NULL, NULL, N'192028', NULL, NULL, 0, 40, NULL, N'3183366500', N'3183366676', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Front Street', N'Vidalia', N'LA', N'22029', N'71373', 32.217686, -82.413461, 2040, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2405, N'Lafayette - A M G Specialty Hospital', 1, NULL, NULL, N'192029', NULL, NULL, 0, 58, NULL, N'3378399880', N'3377692021', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Youngsville Hwy', N'Lafayette', N'LA', N'22055', N'70508', 30.155676, -91.991128, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2406, N'St Theresa Specialty Hospital Llc', 1, NULL, NULL, N'192030', NULL, NULL, 0, 73, NULL, N'5049047600', N'5049047601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Loyola Drive', N'Kenner', N'LA', N'22051', N'70065', 30.029132, -90.2712411, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2407, N'Cornerstone Hospital West Monroe', 1, NULL, NULL, N'192031', NULL, NULL, 0, 47, NULL, N'3183965600', N'3183965665', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6198 Cypress Street', N'West Monroe', N'LA', N'22073', N'71291', 32.513982, -92.176336, 1635, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2408, N'Louisiana Extended Care Hospital Of Lafayette', 1, NULL, NULL, N'192032', NULL, NULL, 0, 76, NULL, N'3372898180', N'3372898181', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1214 Coolidge Blvd 9Th & 10Th Floors', N'Lafayette', N'LA', N'22055', N'70503', 30.22409, -92.019843, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2409, N'Post Acute Medical Specialty Hospital Of Lafayette', 1, NULL, NULL, N'192033', NULL, NULL, 0, 50, NULL, N'3372321905', N'3372611726', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Energy Parkway', N'Lafayette', N'LA', N'22055', N'70508', 30.182031, -92.009876, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2410, N'St Landry Extended Care Hospital', 1, NULL, NULL, N'192034', NULL, NULL, 0, 59, NULL, N'3379485184', N'3379483294', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3983 I-49 South Service Rd 2Nd Floor', N'Opelousas', N'LA', N'22097', N'70570', 30.53353, -92.081509, 1622, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2411, N'Louisiana Extended Care Hospital Of Natchitoches', 1, NULL, NULL, N'192035', NULL, NULL, 0, 21, NULL, N'3183542044', N'3183542041', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Keyser Ave 4Th Floor', N'Natchitoches', N'LA', N'22069', N'71457', 31.752553, -93.078621, 1616, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2412, N'Post Acute Specialty Hospital Of Hammond', 1, NULL, NULL, N'192036', NULL, NULL, 0, 40, NULL, N'9859028148', N'9859029148', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42074 Veterans Avenue', N'Hammond', N'LA', N'22105', N'70403', 30.474911, -90.457242, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2413, N'Houma - Amg Specialty Hospital', 1, NULL, NULL, N'192037', NULL, NULL, 0, 40, NULL, N'9852740001', N'9852740003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 Dunn Street', N'Houma', N'LA', N'22109', N'70360', 29.593161, -90.712203, 1596, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2414, N'Southeast Regional Medical Center Inc', 1, NULL, NULL, N'192040', NULL, NULL, 0, 14, NULL, N'9852299193', N'9852299180', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 Avenue G', N'Kentwood', N'LA', N'22105', N'70444', 30.9367428, -90.5213481, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2415, N'Feliciana - A M G Specialty Hospital', 1, NULL, NULL, N'192041', NULL, NULL, 0, 16, NULL, N'2256831600', N'2256861616', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9725 Grace Lane', N'Clinton', N'LA', N'22037', N'70722', 35.615556, -92.485685, 1638, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2416, N'Riverside Hospital Of Louisiana Inc', 1, NULL, NULL, N'192043', NULL, NULL, 0, 28, NULL, N'3187672900', N'3187672902', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Fourth St Fifth Floor', N'Alexandria', N'LA', N'22079', N'71301', 31.199004, 29.894379, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2417, N'Slidell - A M G Specialty Hospital', 1, NULL, NULL, N'192046', NULL, NULL, 0, 40, NULL, N'9853260440', N'9853260559', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Lindberg Drive', N'Slidell', N'LA', N'22103', N'70458', 30.276889, -89.752937, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2418, N'Northshore Specialty Hospital', 1, NULL, NULL, N'192048', NULL, NULL, 0, 58, NULL, N'9858757525', N'9858751934', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20050 Crestwood Blvd', N'Claiborne', N'LA', N'22103', N'70433', 38.159854, -77.455539, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2419, N'Promise Hospital Of Baton Rouge Inc', 1, NULL, NULL, N'192049', NULL, NULL, 0, 57, NULL, N'2252365440', N'2252365441', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17000 Medical Center Dr 3Rd Floor', N'Baton Rouge', N'LA', N'22033', N'70816', 30.4427491, -91.002079, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2420, N'Regency Hospital Of Covington', 1, NULL, NULL, N'192051', NULL, NULL, 0, 38, NULL, N'9858673977', N'9858673979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'195 Highland Park Entrance', N'Covington', N'LA', N'22103', N'70433', 39.083622, -84.508371, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2421, N'Specialty Hospital Of Winnfield Inc', 1, NULL, NULL, N'192052', NULL, NULL, 0, 20, NULL, N'3186483523', N'3182515343', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 1St Street', N'Winnfield', N'LA', N'22127', N'71483', 31.9320433, -92.6343317, 1636, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2422, N'Louisiana Extended Care Hospital Of West Monroe', 1, NULL, NULL, N'192055', NULL, NULL, 0, 21, NULL, N'3183294300', N'3183294339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 Mcmillian Road 3Rd Floor', N'West Monroe', N'LA', N'22073', N'71291', 32.518478, -92.147635, 1635, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2423, N'Baton Rouge Rehab Hospital', 1, NULL, NULL, N'193028', NULL, NULL, 0, 80, NULL, N'2259270567', N'2259280317', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8595 United Plaza Blvd', N'Baton Rouge', N'LA', N'22033', N'70809', 30.413109, -91.099503, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2424, N'Healthsouth Rehabilitation Hospital Of Alexandria', 1, NULL, NULL, N'193031', NULL, NULL, 0, 47, NULL, N'3184491370', N'3184491369', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 North Third Street', N'Alexandria', N'LA', N'22079', N'71301', 31.199004, 29.894379, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2425, N'North Oaks Rehabilitation Hospital L L C', 1, NULL, NULL, N'193044', NULL, NULL, 0, 27, NULL, N'9855427777', N'9852305670', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 S Morrison Blvd', N'Hammond', N'LA', N'22105', N'70403', 33.540242, -117.637177, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2426, N'Tri Parish Rehabilitation Hospital L L C', 1, NULL, NULL, N'193050', NULL, NULL, 0, 36, NULL, N'3374628880', N'3374628818', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8088 Hawks Rd', N'Leesville', N'LA', N'22115', N'71446', 38.141799, -77.046918, 1603, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2427, N'Bastrop Rehabilitation Hospital - Monroe', 1, NULL, NULL, N'193058', NULL, NULL, 0, 12, NULL, N'3185568000', N'3186548333', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4310 South Grand Street', N'Monroe', N'LA', N'22073', N'71202', 32.457125, -92.115461, 1613, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2428, N'Rehabilitation Hospital Of Jennings', 1, NULL, NULL, N'193067', NULL, NULL, 0, 16, NULL, N'3378215353', N'3378215366', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive Suite 101', N'Jennings', N'LA', N'22053', N'70546', 30.2402, -92.662674, 1598, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2429, N'Sterlington Rehabilitation Hospital', 1, NULL, NULL, N'193069', NULL, NULL, 0, 10, NULL, N'3182814531', N'3182814535', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'370 W Hickory Street', N'Bastrop', N'LA', N'22067', N'71220', 30.265765, -97.094456, 1575, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2430, N'M M O Rehabilitation And Wellness Center', 1, NULL, NULL, N'193070', NULL, NULL, 0, 13, NULL, N'2256878100', N'2256878110', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'59215 River West Drive', N'Plaquemine', N'LA', N'22047', N'70764', 30.289083, -91.234274, 1623, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2431, N'United Medical Healthwest-New Orleans', 1, NULL, NULL, N'193074', NULL, NULL, 0, 26, NULL, N'5044335551', N'5044335535', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 Wall Blvd Ste B', N'Gretna', N'LA', N'22051', N'70056', 36.952841, -79.360234, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2432, N'Sage Rehabilitation Hospital', 1, NULL, NULL, N'193078', NULL, NULL, 0, 42, NULL, N'2258190703', N'2259064085', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 Summa Ave', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397866, -91.098074, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2433, N'United Medical Rehabilitation Hospital', 1, NULL, NULL, N'193079', NULL, NULL, 0, 40, NULL, N'9853405998', N'9853405911', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15717 Belle Drive', N'Hammond', N'LA', N'22105', N'70403', 41.583366, -87.500043, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2434, N'Specialty Rehabilitation Hospital', 1, NULL, NULL, N'193080', NULL, NULL, 0, 12, NULL, N'3189321770', N'3184240390', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 Ringld Avenue', N'Coushatta', N'LA', N'22081', N'71019', 32.029026, -93.340266, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2435, N'Leesville Rehabilitation Hospital', 1, NULL, NULL, N'193086', NULL, NULL, 0, 16, NULL, N'3373928118', N'3373928415', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Sixth Street', N'Leesville', N'LA', N'22115', N'71446', 38.141799, -77.046918, 1603, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2436, N'The Neuromedical Center Rehabilitation Hospital L', 1, NULL, NULL, N'193090', NULL, NULL, 0, 27, NULL, N'2259062999', N'2259063837', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Park Rowe Avenue', N'Baton Rouge', N'LA', N'22033', N'70810', 30.38296, -84.297755, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2437, N'Bethesda Rehabilitation Hospital', 1, NULL, NULL, N'193092', NULL, NULL, 0, 14, NULL, N'2257672034', N'2257672039', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8225 Summa Ave', N'Baton Rouge', N'LA', N'22033', N'70809', 30.397866, -91.098074, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2438, N'Lafayette Physical Rehabilitation Hospital', 1, NULL, NULL, N'193093', NULL, NULL, 0, 32, NULL, N'3373141111', N'3372697321', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'307 Polly Lane', N'Lafayette', N'LA', N'22055', N'70508', 30.173288, -92.023232, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2439, N'Pathway Rehabilitation Hospital Of Bossier', 1, NULL, NULL, N'193094', NULL, NULL, 0, 24, NULL, N'3188415555', N'3188415563', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Medical Drive', N'Bossier City', N'LA', N'22015', N'71112', 32.463457, -93.666512, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2440, N'Pelican Rehabilitation Hospital Llc', 1, NULL, NULL, N'193095', NULL, NULL, 0, 16, NULL, N'5043785060', N'5043941480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Woodland Drive 3Rd Floor', N'New Orleans', N'LA', N'22071', N'70131', 29.9100933, -89.9969126, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2441, N'Iberia Rehabilitation Hospital', 1, NULL, NULL, N'193096', NULL, NULL, 0, 40, NULL, N'3373646923', N'3376080361', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 Jefferson Terrace Street', N'New Iberia', N'LA', N'22045', N'70560', 30.003537, -91.818728, 1617, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2442, N'Childrens Hospital', 1, NULL, NULL, N'193300', NULL, NULL, 0, 247, NULL, N'5048999511', N'5048969707', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Henry Clay Ave', N'New Orleans', N'LA', N'22071', N'70118', 29.917249, -90.127862, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2443, N'Shriners Hospitals For Children', 1, NULL, NULL, N'193301', NULL, NULL, 0, 45, NULL, N'3182225704', N'3184247610', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Samford Avenue', N'Shreveport', N'LA', N'22017', N'71103', 32.480357, -93.756736, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2444, N'Northlake Behavioral Health System', 1, NULL, NULL, N'194007', NULL, NULL, 0, 140, NULL, N'9856266300', N'9856266559', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23515 Highway 190', N'Mandeville', N'LA', N'22103', N'70448', 50.597775, -2.486505, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2445, N'Eastern La Mental Health System', 1, NULL, NULL, N'194008', NULL, NULL, 0, 232, NULL, N'2256340100', N'2256344345', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4502 Highway 951', N'Jackson', N'LA', N'22037', N'70748', 32.410438, -90.162065, 1638, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2446, N'Brentwood Hospital', 1, NULL, NULL, N'194020', NULL, NULL, 0, 200, NULL, N'3186787500', N'3182279296', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1006 Highland Avenue', N'Shreveport', N'LA', N'22017', N'71106', 32.502581, -93.739153, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2447, N'Longleaf Hospital', 1, NULL, NULL, N'194022', NULL, NULL, 0, 92, NULL, N'3184455111', N'3184422261', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 Versailles Blvd', N'Alexandria', N'LA', N'22079', N'71303', 31.283373, -92.503989, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2448, N'Central Louisiana State Hospital', 1, NULL, NULL, N'194025', NULL, NULL, 0, 196, NULL, N'3184846200', N'3184846501', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'242 W Shamrock Street', N'Pineville', N'LA', N'22079', N'71361', 31.322404, -92.434303, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2449, N'River Oaks Hospital', 1, NULL, NULL, N'194031', NULL, NULL, 0, 126, NULL, N'5047341740', N'5047341730', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 River Oaks West', N'New Orleans', N'LA', N'22051', N'70123', 29.949932, -90.070116, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2450, N'Vermilion Behavioral Health Systems', 1, NULL, NULL, N'194044', NULL, NULL, 0, 54, NULL, N'3372345614', N'3372101197', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 N University Avenue', N'Lafayette', N'LA', N'22055', N'70507', 30.267085, -92.044729, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2451, N'Community Care Hospital', 1, NULL, NULL, N'194056', NULL, NULL, 0, 32, NULL, N'5048992500', N'5048997127', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1421 General Taylor', N'New Orleans', N'LA', N'22071', N'70115', 29.925862, -90.096037, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2452, N'Greenbrier Behavioral Health', 1, NULL, NULL, N'194069', NULL, NULL, 0, 60, NULL, N'9858932970', N'9858671150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Greenbrier Blvd', N'Covington', N'LA', N'22103', N'70433', 39.083622, -84.508371, 1582, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2453, N'Oceans Hospital Of Broussard', 1, NULL, NULL, N'194073', NULL, NULL, 0, 38, NULL, N'3378399008', N'3372376445', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Albertsons Parkway', N'Broussard', N'LA', N'22055', N'70518', 30.147146, -91.961231, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2454, N'Serenity Springs Specialty Hospital', 1, NULL, NULL, N'194074', NULL, NULL, 0, 18, NULL, N'3182023860', N'3182025953', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1495 Frazier Road', N'Ruston', N'LA', N'22061', N'71270', 32.523205, -92.637927, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2455, N'Westend Hospital', 1, NULL, NULL, N'194075', NULL, NULL, 0, 20, NULL, N'3376168122', N'3376160590', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Highway 90 West', N'Jennings', N'LA', N'22053', N'70546', 39.090388, -76.563297, 1598, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2456, N'Optima Specialty Hospital', 1, NULL, NULL, N'194078', NULL, NULL, 0, 24, NULL, N'3379910571', N'3379919946', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1131 Rue Debelier', N'Lafayette', N'LA', N'22055', N'70506', 30.22409, -92.019843, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2457, N'Red River Behavioral Center Llc', 1, NULL, NULL, N'194079', NULL, NULL, 0, 20, NULL, N'3185492033', N'3185493745', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Melrose Avenue', N'Bossier City', N'LA', N'22015', N'71111', 32.5460044, -93.7067202, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2458, N'Beacon Behavioral Hospital - Northshore Inc', 1, NULL, NULL, N'194080', NULL, NULL, 0, 22, NULL, N'9858820226', N'5042100970', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64026 Hwy 434 Suite 300 (3Rd Floor)', N'Lacombe', N'LA', N'22103', N'70445', 30.3544391, -89.9213221, 1628, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2459, N'Oceans Behavioral Hospital Of Deridder', 1, NULL, NULL, N'194081', NULL, NULL, 0, 20, NULL, N'3374609472', N'3374609473', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 Blankenship Drive', N'Deridder', N'LA', N'22011', N'70634', 30.846306, -93.289053, 1585, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2460, N'Jennings Senior Care Hospital', 1, NULL, NULL, N'194082', NULL, NULL, 0, 18, NULL, N'3378241558', N'3378241561', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive Suite 201', N'Jennings', N'LA', N'22053', N'70546', 30.2402, -92.662674, 1598, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2461, N'Liberty Healthcare Systems Llc', 1, NULL, NULL, N'194083', NULL, NULL, 0, 60, NULL, N'3182812448', N'3182815445', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4673 Eugene Ware Road', N'Bastrop', N'LA', N'22067', N'71220', 32.7810873, -91.9438364, 1575, 124, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2462, N'Beacon Behavioral Hospital- New Orleans Inc', 1, NULL, NULL, N'194084', NULL, NULL, 0, 24, NULL, N'5042100460', N'5042100972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14500 Haynes Blvd', N'New Orleans', N'LA', N'22071', N'70128', 27.990298, -82.451148, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2463, N'Compass Behavioral Center Of Crowley', 1, NULL, NULL, N'194085', NULL, NULL, 0, 34, NULL, N'3377883380', N'3377883381', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1526 North Avenue I', N'Crowley', N'LA', N'22001', N'70526', 38.169726, -103.947493, 1583, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2464, N'Oceans Behavioral Hospital Of Baton Rouge', 1, NULL, NULL, N'194086', NULL, NULL, 0, 20, NULL, N'2253567030', N'2253567003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11135 Florida Blvd', N'Baton Rouge', N'LA', N'22033', N'70815', 30.458669, -91.060219, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2465, N'Allegiance Health Center Of Ruston Llc', 1, NULL, NULL, N'194087', NULL, NULL, 0, 29, NULL, N'3182558085', N'3182552179', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Ezell Street', N'Ruston', N'LA', N'22061', N'71270', 32.5139113, -92.6337888, 1626, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2466, N'St James Behavioral Health Hospital Inc', 1, NULL, NULL, N'194088', NULL, NULL, 0, 28, NULL, N'2256477524', N'2256441070', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3136 South St Landry Road', N'nzales', N'LA', N'22005', N'70737', 30.2039556, -90.9539967, 1592, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2467, N'Genesis Behavioral Hospital', 1, NULL, NULL, N'194089', NULL, NULL, 0, 18, NULL, N'3374426254', N'3374424674', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'606 Latiolais Road', N'Breaux Bridge', N'LA', N'22099', N'70517', 30.273532, -91.899284, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2468, N'Oceans Behavioral Hospital Of Lake Charles', 1, NULL, NULL, N'194090', NULL, NULL, 0, 20, NULL, N'3374747581', N'3374747582', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 West Mcneese Street', N'Lake Charles', N'LA', N'22019', N'70605', 30.176165, -93.223747, 1601, 122, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2469, N'Oceans Behavioral Hospital Of Kentwood', 1, NULL, NULL, N'194091', NULL, NULL, 0, 16, NULL, N'9852290717', N'9852290716', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Avenue G', N'Kentwood', N'LA', N'22105', N'70444', 42.869473, -85.644749, 1594, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2470, N'Physicians Behavioral Hospital', 1, NULL, NULL, N'194094', NULL, NULL, 0, 24, NULL, N'3372334165', N'3372376729', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Desoto St', N'Shreveport', N'LA', N'22017', N'71103', 32.47268, -93.770796, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2471, N'Oceans Behavioral Hospital Of Opelousas', 1, NULL, NULL, N'194095', NULL, NULL, 0, 20, NULL, N'3379488820', N'3379488821', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Heather Drive', N'Opelousas', N'LA', N'22097', N'70570', 30.50874, -92.073104, 1622, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2472, N'Oceans Behavioral Hospital Of Alexandria', 1, NULL, NULL, N'194096', NULL, NULL, 0, 24, NULL, N'3184488473', N'3184488018', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2621 North Bolton Avenue', N'Alexandria', N'LA', N'22079', N'71303', 31.326112, -92.480946, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2473, N'Phoenix Behavioral Hospital', 1, NULL, NULL, N'194097', NULL, NULL, 0, 16, NULL, N'3377880091', N'3377880092', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2021 Crowley Rayne Highway', N'Rayne', N'LA', N'22001', N'70578', 30.230247, -92.313124, 1600, 121, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2474, N'Oceans Behavioral Hospital Of Greater New Orleans', 1, NULL, NULL, N'194098', NULL, NULL, 0, 30, NULL, N'5044648895', N'5044648896', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'716 Village Road', N'Kenner', N'LA', N'22051', N'70065', 30.022461, -90.257921, 1611, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2475, N'Seaside Behavioral Center', 1, NULL, NULL, N'194100', NULL, NULL, 0, 24, NULL, N'5043934223', N'5042675692', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 Woodland Drive', N'New Orleans', N'LA', N'22071', N'70131', 29.912392, -89.993193, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2476, N'Beacon Behavioral Hospital Inc', 1, NULL, NULL, N'194102', NULL, NULL, 0, 34, NULL, N'2252586103', N'2252586116', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2471 Louisiana Ave', N'Lutcher', N'LA', N'22093', N'70071', 29.9362515, -90.0974262, 1605, 123, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2477, N'Seaside Health System', 1, NULL, NULL, N'194103', NULL, NULL, 0, 64, NULL, N'2255224076', N'2254482733', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4363 Convention Street', N'Baton Rouge', N'LA', N'22033', N'70806', 30.449473, -91.144731, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2478, N'Apollo Behavioral Health Hospital L L C', 1, NULL, NULL, N'194105', NULL, NULL, 0, 18, NULL, N'2256632881', N'2253551555', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7414 Sumrall Drive Suite C', N'Baton Rouge', N'LA', N'22033', N'70812', 30.5147882, -91.1189981, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2479, N'Compass Behavioral Center Of Alexandria Inc', 1, NULL, NULL, N'194106', NULL, NULL, 0, 16, NULL, N'3184423163', N'3184430220', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6410 Masonic Drive', N'Alexandria', N'LA', N'22079', N'71301', 33.915821, -84.476352, 1573, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2480, N'Baton Rouge Behavioral Hospital', 1, NULL, NULL, N'194107', NULL, NULL, 0, 47, NULL, N'2253008470', N'2253008523', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4040 North Blvd.', N'Baton Rouge', N'LA', N'22033', N'70806', 30.447609, -91.177295, 1576, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2481, N'Compass Behavioral Center Of Houma Inc', 1, NULL, NULL, N'194109', NULL, NULL, 0, 20, NULL, N'9858761715', N'9858761750', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4701 West Park Avenue', N'Houma', N'LA', N'22109', N'70364', 29.6184276, -90.7487871, 1596, 120, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2482, N'Beacon Behavioral Hospital - Central', 1, NULL, NULL, N'194112', NULL, NULL, 0, 18, NULL, N'3183463143', N'3182954189', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 Evergreen Street', N'Bunkie', N'LA', N'22009', N'71322', 30.95283, -92.177107, 1579, 118, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2483, N'Tulane University Hospital And Clinic', 1, NULL, NULL, N'199801', NULL, NULL, 0, 0, NULL, N'5049885800', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1415 Tulane Ave', N'New Orleans', N'LA', N'22071', N'70112', 29.955461, -90.076017, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2484, N'Ochsner Foundation Hospital', 1, NULL, NULL, N'199802', NULL, NULL, 0, 0, NULL, N'5048423925', N'5048423343', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1514 Jefferson Highway', N'New Orleans', N'LA', N'22051', N'70121', 29.949932, -90.070116, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2485, N'Children''s Hospital', 1, NULL, NULL, N'199803', NULL, NULL, 0, 0, NULL, N'5048969450', N'5048969707', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Henry Clay Ave', N'New Orleans', N'LA', N'22071', N'70118', 29.917249, -90.127862, 1618, 125, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2486, N'Willis-Knighton Medical Center', 1, NULL, NULL, N'199804', NULL, NULL, 0, 0, NULL, N'3182124170', N'3182128511', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2600 Greenwood Road', N'Shreveport', N'LA', N'22017', N'71103', 32.484002, -93.778844, 1627, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2487, N'St Joseph Hospital', 1, NULL, NULL, N'200001', NULL, NULL, 0, 112, NULL, N'2072621000', N'2072621922', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 Broadway', N'Banr', N'ME', N'23019', N'04401', 44.813055, -68.77049, 1640, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2488, N'Mercy Hospital', 1, NULL, NULL, N'200008', NULL, NULL, 0, 230, NULL, N'2078793000', N'2078793429', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'144 State Street', N'Portland', N'ME', N'23005', N'04101', 43.652114, -70.265322, 1662, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2489, N'Maine Medical Center', 1, NULL, NULL, N'200009', NULL, NULL, 0, 606, NULL, N'2076620111', N'2076624610', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Bramhall St', N'Portland', N'ME', N'23005', N'04102', 43.652311, -70.27494, 1662, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2490, N'Aroostook Medical Center', 1, NULL, NULL, N'200018', NULL, NULL, 0, 89, NULL, N'2077684000', N'2077684252', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 151', N'Presque Isle', N'ME', N'23003', N'04769', 46.681153, -68.015862, 1663, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2491, N'Southern Maine Health Care', 1, NULL, NULL, N'200019', NULL, NULL, 0, 150, NULL, N'2072837000', N'2072837020', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Drive', N'Biddeford', N'ME', N'23031', N'04005', 43.478662, -70.492262, 1643, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2492, N'York Hospital', 1, NULL, NULL, N'200020', NULL, NULL, 0, 79, NULL, N'2073634321', N'2073512308', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 Hospital Drive', N'York', N'ME', N'23031', N'03909', 43.142594, -70.650786, 1669, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2493, N'Mid Coast Hospital', 1, NULL, NULL, N'200021', NULL, NULL, 0, 92, NULL, N'2077290181', N'2073736039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Medical Center Drive', N'Brunswick', N'ME', N'23005', N'04011', 43.905666, -69.892004, 1647, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2494, N'Central Maine Medical Center', 1, NULL, NULL, N'200024', NULL, NULL, 0, 250, NULL, N'2077950111', N'2077952367', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Main Street', N'Lewiston', N'ME', N'23001', N'04240', 44.100829, -70.214705, 1656, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2495, N'Cary Medical Center', 1, NULL, NULL, N'200031', NULL, NULL, 0, 65, NULL, N'2074983111', N'2074962631', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'163 Van Buren Rd Suite 1', N'Caribou', N'ME', N'23003', N'04736', 46.878905, -68.010306, 1649, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2496, N'Eastern Maine Medical Center', 1, NULL, NULL, N'200033', NULL, NULL, 0, 411, NULL, N'2079737000', N'2079737348', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 404', N'Banr', N'ME', N'23019', N'04401', 44.801182, -68.777814, 1640, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2497, N'St Marys Regional Medical Center', 1, NULL, NULL, N'200034', NULL, NULL, 0, 233, NULL, N'2077778100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Campus Avenue - Po Box 7291', N'Lewiston', N'ME', N'23001', N'04240', 44.102486, -70.200365, 1656, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2498, N'Franklin Memorial Hospital', 1, NULL, NULL, N'200037', NULL, NULL, 0, 70, NULL, N'2077786031', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Franklin Health Commons', N'Farmington', N'ME', N'23007', N'04938', 44.625239, -70.161349, 1653, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2499, N'Mainegeneral Medical Center', 1, NULL, NULL, N'200039', NULL, NULL, 0, 287, NULL, N'2078721000', N'2078721678', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Medical Center Parkway', N'Augusta', N'ME', N'23011', N'04330', 44.360834, -69.782828, 1639, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2500, N'Inland Hospital', 1, NULL, NULL, N'200041', NULL, NULL, 0, 48, NULL, N'2078613012', N'2078613039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Kennedy Memorial Drive', N'Waterville', N'ME', N'23011', N'04901', 44.54269, -69.661405, 1668, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2501, N'Maine Coast Memorial Hospital', 1, NULL, NULL, N'200050', NULL, NULL, 0, 64, NULL, N'2076675311', N'2076645305', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Union Street', N'Ellsworth', N'ME', N'23009', N'04605', 44.546828, -68.415371, 1652, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2502, N'Northern Maine Medical Center', 1, NULL, NULL, N'200052', NULL, NULL, 0, 49, NULL, N'2078343195', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'194 E Main Street', N'Fort Kent', N'ME', N'23003', N'04743', 47.251498, -68.593828, 1654, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2503, N'Penobscot Bay Medical Center', 1, NULL, NULL, N'200063', NULL, NULL, 0, 109, NULL, N'2075968000', N'2075935287', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 Glen Cove Drive', N'Rockport', N'ME', N'23013', N'04856', 44.145848, -69.087853, 1664, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2504, N'Blue Hill Memorial Hospital', 1, NULL, NULL, N'201300', NULL, NULL, 0, 25, NULL, N'2073742836', N'2073743992', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'57 Water Street', N'Blue Hill', N'ME', N'23009', N'04614', 44.41293, -68.587812, 1644, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2505, N'Charles A Dean Memorial Hospital', 1, NULL, NULL, N'201301', NULL, NULL, 0, 25, NULL, N'2076955200', N'2076452329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Pritham Avenue Po Box 1129', N'Greenville', N'ME', N'23021', N'04441', 45.459188, -69.599555, 1670, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2506, N'St Andrews Hospital', 1, NULL, NULL, N'201302', NULL, NULL, 0, 25, NULL, N'2075631234', N'2076335389', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35 Miles Street', N'Damariscotta', N'ME', N'23015', N'04543', 44.026133, -69.528109, 1650, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2507, N'Penobscot Valley Hospital', 1, NULL, NULL, N'201303', NULL, NULL, 0, 25, NULL, N'2077943321', N'2077946488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7 Transalpine Road Po Box 368', N'Lincoln', N'ME', N'23019', N'04457', 45.348731, -68.516256, 1657, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2508, N'Mount Desert Island Hospital', 1, NULL, NULL, N'201304', NULL, NULL, 0, 25, NULL, N'2072885081', N'2072888600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Wayman Lane Po Box 8', N'Bar Harbor', N'ME', N'23009', N'04609', 44.384414, -68.202045, 1641, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2509, N'Calais Regional Hospital', 1, NULL, NULL, N'201305', NULL, NULL, 0, 25, NULL, N'2074547521', N'2074549238', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Hospital Lane', N'Calais', N'ME', N'23029', N'04619', 45.180612, -67.270465, 1648, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2510, N'Rumford  Hospital', 1, NULL, NULL, N'201306', NULL, NULL, 0, 25, NULL, N'2073691000', N'2073690834', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Franklin Street', N'Rumford', N'ME', N'23017', N'04276', 44.551703, -70.557148, 1665, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2511, N'Millinocket Regional Hospital', 1, NULL, NULL, N'201307', NULL, NULL, 0, 25, NULL, N'2077235161', N'2077234913', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Somerset Street', N'Millinocket', N'ME', N'23019', N'04462', 45.651649, -68.71425, 1659, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2512, N'Houlton Regional Hospital', 1, NULL, NULL, N'201308', NULL, NULL, 0, 25, NULL, N'2075322900', N'2075327334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Hartford Street', N'Houlton', N'ME', N'23003', N'04730', 46.131562, -67.843332, 1655, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2513, N'Mayo Regional Hospital', 1, NULL, NULL, N'201309', NULL, NULL, 0, 25, NULL, N'2075644251', N'2075644377', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'897 West Main Street', N'Dover Foxcroft', N'ME', N'23021', N'04426', 45.186557, -69.237847, 1651, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2514, N'Bridgton Hospital', 1, NULL, NULL, N'201310', NULL, NULL, 0, 25, NULL, N'2076476000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital Drive', N'Bridgton', N'ME', N'23005', N'04009', 44.046523, -70.714224, 1646, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2515, N'Down East Community Hospital', 1, NULL, NULL, N'201311', NULL, NULL, 0, 25, NULL, N'2072553356', N'2072550427', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Hospital Drive', N'Machias', N'ME', N'23029', N'04654', 44.71349, -67.47715, 1658, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2516, N'Waldo County General Hospital', 1, NULL, NULL, N'201312', NULL, NULL, 0, 25, NULL, N'2073382500', N'2073388600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 287', N'Belfast', N'ME', N'23027', N'04915', 44.425909, -69.006423, 1642, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2517, N'Sebasticook Valley Health', 1, NULL, NULL, N'201313', NULL, NULL, 0, 25, NULL, N'2074875141', N'2704873790', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'447 North Main Street', N'Pittsfield', N'ME', N'23025', N'04967', 44.790948, -69.370459, 1661, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2518, N'Redington Fairview General Hospital', 1, NULL, NULL, N'201314', NULL, NULL, 0, 25, NULL, N'2074745121', N'2074747004', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'46 Fairview Ave   Po Box 468', N'Skowhegan', N'ME', N'23025', N'04976', 44.758411, -69.713578, 1667, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2519, N'Stephens Memorial Hospital', 1, NULL, NULL, N'201315', NULL, NULL, 0, 25, NULL, N'2077435933', N'2077431566', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 Main Street', N'Norway', N'ME', N'23017', N'04268', 44.209597, -70.532997, 1660, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2520, N'Healthsouth/Maine Medical Center Llc', 1, NULL, NULL, N'203025', NULL, NULL, 0, 100, NULL, N'2077754000', N'2076628446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Brighton Avenue Unit 201', N'Portland', N'ME', N'23005', N'04102', 43.666213, -70.2940345, 1662, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2521, N'Dorothea Dix Psychiatric Center', 1, NULL, NULL, N'204004', NULL, NULL, 0, 100, NULL, N'2079414000', N'2079414062', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'656 State Street', N'Banr', N'ME', N'23019', N'04401', 44.811995, -68.742607, 1640, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2522, N'Spring Harbor Hospital', 1, NULL, NULL, N'204005', NULL, NULL, 0, 100, NULL, N'2077612200', N'2077612108', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Andover Road', N'Westbrook', N'ME', N'23005', N'04092', 43.677025, -70.371162, 1662, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2523, N'Acadia Hospital The', 1, NULL, NULL, N'204006', NULL, NULL, 0, 100, NULL, N'2079736100', N'2079736109', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'268 Stillwater Ave', N'Banr', N'ME', N'23019', N'04401', 44.817899, -68.782085, 1640, 128, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2524, N'Maine Medical Center -Transplant Center', 1, NULL, NULL, N'209801', NULL, NULL, 0, 0, NULL, N'2076627181', N'2076627160', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22 Bramhall St', N'Portland', N'ME', N'23005', N'04102', 43.652538, -70.274839, 1662, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2525, N'Meritus Medical Center', 1, NULL, NULL, N'210001', NULL, NULL, 0, 271, NULL, N'2403139500', N'3017909480', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11116 Medical Campus Road', N'Hagerstown', N'MD', N'24043', N'21742', 39.622789, -77.681154, 1686, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2526, N'University Of Maryland Medical Center', 1, NULL, NULL, N'210002', NULL, NULL, 0, 705, NULL, N'4103288667', N'4103287595', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 South  Greene Street', N'Baltimore', N'MD', N'24510', N'21201', 39.288956, -76.623661, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2527, N'Prince Georges  Hospital Center', 1, NULL, NULL, N'210003', NULL, NULL, 0, 224, NULL, N'3016182000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Hospital Drive', N'Cheverly', N'MD', N'24033', N'20785', 38.92994, -76.922928, 1676, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2528, N'Holy Cross Hospital', 1, NULL, NULL, N'210004', NULL, NULL, 0, 444, NULL, N'3017547000', N'3017547012', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Forest Glen Road', N'Silver Spring', N'MD', N'24031', N'20910', 39.016011, -77.035469, 1698, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2529, N'Frederick Memorial Hospital', 1, NULL, NULL, N'210005', NULL, NULL, 0, 248, NULL, N'2405663300', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Seventh St', N'Frederick', N'MD', N'24021', N'21701', 39.424177, -77.415057, 1684, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2530, N'University Of Maryland Harford Memorial Hospital', 1, NULL, NULL, N'210006', NULL, NULL, 0, 101, NULL, N'4436433303', N'4436433334', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South  Union Avenue', N'Havre De Grace', N'MD', N'24025', N'21078', 39.542775, -76.091508, 1687, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2531, N'Mercy Medical Center Inc', 1, NULL, NULL, N'210008', NULL, NULL, 0, 285, NULL, N'4103329237', N'4103585148', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Saint Paul Place', N'Baltimore', N'MD', N'24510', N'21202', 39.29255, -76.61355, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2532, N'Johns Hopkins Hospital The', 1, NULL, NULL, N'210009', NULL, NULL, 0, 1025, NULL, N'4109559540', N'4109550856', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North  Wolfe Street', N'Baltimore', N'MD', N'24510', N'21287', 39.296892, -76.590781, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2533, N'Saint Agnes Hospital', 1, NULL, NULL, N'210011', NULL, NULL, 0, 407, NULL, N'4103682101', N'4103682109', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Caton Avenue', N'Baltimore', N'MD', N'24510', N'21229', 39.272628, -76.670816, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2534, N'Sinai Hospital Of Baltimore', 1, NULL, NULL, N'210012', NULL, NULL, 0, 466, NULL, N'4106015131', N'4106018801', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 West Belvedere Avenue', N'Baltimore', N'MD', N'24510', N'21215', 39.353928, -76.663247, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2535, N'Bon Secours Hospital', 1, NULL, NULL, N'210013', NULL, NULL, 0, 208, NULL, N'4103623000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 W Baltimore Street', N'Baltimore', N'MD', N'24510', N'21223', 39.288011, -76.649078, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2536, N'Medstar Franklin Square Medical Center', 1, NULL, NULL, N'210015', NULL, NULL, 0, 405, NULL, N'4437777850', N'4437777904', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9000 Franklin Square Drive', N'Baltimore', N'MD', N'24005', N'21237', 39.350486, -76.478683, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2537, N'Adventist Healthcare Washington Adventist Hospital', 1, NULL, NULL, N'210016', NULL, NULL, 0, 298, NULL, N'3018915651', N'3018915991', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Carroll Avenue', N'Takoma Park', N'MD', N'24031', N'20912', 38.983989, -76.99977, 1699, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2538, N'Garrett County Memorial Hospital', 1, NULL, NULL, N'210017', NULL, NULL, 0, 33, NULL, N'3015334173', N'3015334175', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 North  Fourth Street', N'Oakland', N'MD', N'24023', N'21550', 39.413962, -79.402147, 1692, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2539, N'Medstar Montmery Medical Center', 1, NULL, NULL, N'210018', NULL, NULL, 0, 165, NULL, N'3017748882', N'3017748866', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Prince Philip Drive', N'Olney', N'MD', N'24031', N'20832', 39.152975, -77.056712, 1693, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2540, N'Peninsula Regional Medical Center', 1, NULL, NULL, N'210019', NULL, NULL, 0, 400, NULL, N'4105437111', N'4105437102', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East Carroll Avenue', N'Salisbury', N'MD', N'24045', N'21801', 38.363068, -75.599489, 1697, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2541, N'Suburban Hospital', 1, NULL, NULL, N'210022', NULL, NULL, 0, 229, NULL, N'3018962576', N'3018971355', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8600 Old Georgetown Road', N'Bethesda', N'MD', N'24031', N'20814', 38.997325, -77.109231, 1673, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2542, N'Anne Arundel Medical Center', 1, NULL, NULL, N'210023', NULL, NULL, 0, 317, NULL, N'4434811307', N'4434811313', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Medical Parkway', N'Annapolis', N'MD', N'24003', N'21401', 38.990616, -76.535163, 1671, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2543, N'Medstar Union Memorial Hospital', 1, NULL, NULL, N'210024', NULL, NULL, 0, 370, NULL, N'4105542227', N'4105542652', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East University Parkway', N'Baltimore', N'MD', N'24510', N'21218', 39.329994, -76.613776, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2544, N'Church Hospital Corporation', 1, NULL, NULL, N'210026', NULL, NULL, 0, 216, NULL, N'4105228000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N Broadway', N'Baltimore', N'MD', N'24510', N'21231', 39.290861, -76.610807, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2545, N'Western Maryland Regional Medical Center', 1, NULL, NULL, N'210027', NULL, NULL, 0, 240, NULL, N'2409648001', N'2409648080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12500 Willowbrook Road', N'Cumberland', N'MD', N'24001', N'21502', 39.649927, -78.732568, 1680, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2546, N'Medstar Saint Mary''s Hospital', 1, NULL, NULL, N'210028', NULL, NULL, 0, 107, NULL, N'3014756001', N'3014756475', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25500 Point Lookout Road', N'Leonardtown', N'MD', N'24037', N'20650', 38.299309, -76.640565, 1691, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2547, N'Johns Hopkins Bayview Medical Center', 1, NULL, NULL, N'210029', NULL, NULL, 0, 397, NULL, N'4105500123', N'4105509096', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4940 Eastern Avenue', N'Baltimore', N'MD', N'24510', N'21224', 39.287155, -76.554292, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2548, N'University Of Md Shore Medical Ctr At Chestertown', 1, NULL, NULL, N'210030', NULL, NULL, 0, 64, NULL, N'4107787668', N'4107787650', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Brown Street', N'Chestertown', N'MD', N'24029', N'21620', 39.216662, -76.064938, 1675, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2549, N'Union Hospital Of Cecil County', 1, NULL, NULL, N'210032', NULL, NULL, 0, 166, NULL, N'4103927009', N'4436741589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Bow Street', N'Elkton', N'MD', N'24015', N'21921', 39.608595, -75.831095, 1682, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2550, N'Carroll Hospital Center', 1, NULL, NULL, N'210033', NULL, NULL, 0, 158, NULL, N'4108483000', N'4108717474', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'291 Stoner Avenue', N'Westminster', N'MD', N'24013', N'21157', 39.56155, -76.989339, 1700, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2551, N'Medstar Harbor Hospital', 1, NULL, NULL, N'210034', NULL, NULL, 0, 376, NULL, N'4103503201', N'4103544440', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 South  Hanover Street', N'Baltimore', N'MD', N'24510', N'21225', 39.251345, -76.615045, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2552, N'University Of Md Charles Regional  Medical Center', 1, NULL, NULL, N'210035', NULL, NULL, 0, 131, NULL, N'3016094265', N'3016094037', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Garrett Avenue', N'La Plata', N'MD', N'24017', N'20646', 38.529254, -76.970808, 1688, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2553, N'University Of Md Shore Medical Center At Easton', 1, NULL, NULL, N'210037', NULL, NULL, 0, 189, NULL, N'4108221000', N'4108227834', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'219 South  Washington Street', N'Easton', N'MD', N'24041', N'21601', 38.769612, -76.075822, 1681, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2554, N'University Of Md Medical Center Midtown Campus', 1, NULL, NULL, N'210038', NULL, NULL, 0, 276, NULL, N'4102258996', N'4104625834', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'827 Linden Avenue', N'Baltimore', N'MD', N'24510', N'21201', 39.299501, -76.620807, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2555, N'Calvert Memorial Hospital', 1, NULL, NULL, N'210039', NULL, NULL, 0, 157, NULL, N'4105358239', N'4105358403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Road', N'Prince Frederick', N'MD', N'24009', N'20678', 38.560214, -76.595602, 1694, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2556, N'Northwest Hospital Center', 1, NULL, NULL, N'210040', NULL, NULL, 0, 215, NULL, N'4105215995', N'4105217977', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 Old Court Road', N'Randallstown', N'MD', N'24005', N'21133', 39.359734, -76.781681, 1695, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2557, N'University Of Md Balto Washington  Medical Center', 1, NULL, NULL, N'210043', NULL, NULL, 0, 329, NULL, N'4105951967', N'4105951972', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Hospital Drive', N'Glen Burnie', N'MD', N'24003', N'21061', 39.139219, -76.623615, 1685, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2558, N'Greater Baltimore Medical Center', 1, NULL, NULL, N'210044', NULL, NULL, 0, 303, NULL, N'4438492000', N'4438498679', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6701 North  Charles Street', N'Baltimore', N'MD', N'24005', N'21204', 39.393497, -76.628092, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2559, N'Edward Mccready Memorial Hospital', 1, NULL, NULL, N'210045', NULL, NULL, 0, 8, NULL, N'4107269496', N'4109680186', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hall Highway', N'Crisfield', N'MD', N'24039', N'21817', 37.997072, -75.853128, 1679, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2560, N'Howard County General Hospital', 1, NULL, NULL, N'210048', NULL, NULL, 0, 233, NULL, N'4107407890', N'4107407240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5755 Cedar Lane', N'Columbia', N'MD', N'24027', N'21044', 39.214552, -76.887294, 1678, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2561, N'University Of M D Upper Chesapeake Medical Center', 1, NULL, NULL, N'210049', NULL, NULL, 0, 219, NULL, N'4436433303', N'4436433334', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Upper Chesapeake Drive', N'Bel Air', N'MD', N'24025', N'21014', 39.519568, -76.348526, 1683, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2562, N'Doctors''  Community Hospital', 1, NULL, NULL, N'210051', NULL, NULL, 0, 182, NULL, N'3015528085', N'3015529306', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8118 od Luck Road', N'Lanham', N'MD', N'24033', N'20706', 38.980457, -76.865171, 1689, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2563, N'Laurel Regional Medical Center', 1, NULL, NULL, N'210055', NULL, NULL, 0, 87, NULL, N'3017254300', N'3014977953', 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7300 Van Dusen Road', N'Laurel', N'MD', N'24033', N'20707', 39.084742, -76.881591, 1690, 132, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2564, N'Medstar od Samaritan Hospital', 1, NULL, NULL, N'210056', NULL, NULL, 0, 208, NULL, N'4434443902', N'4434444599', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Loch Raven Boulevard', N'Baltimore', N'MD', N'24510', N'21239', 39.359548, -76.588565, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2565, N'Adventist Healthcare Shady Grove Medical Center', 1, NULL, NULL, N'210057', NULL, NULL, 0, 253, NULL, N'2408266517', N'2408265811', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9901 Medical Center Drive', N'Rockville', N'MD', N'24031', N'20850', 39.097983, -77.200942, 1696, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2566, N'Univ Of Md Rehabilitation &  Orthopaedic Institute', 1, NULL, NULL, N'210058', NULL, NULL, 0, 134, NULL, N'4104486701', N'4104482859', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 Kernan Drive', N'Baltimore', N'MD', N'24510', N'21207', 39.312874, -76.711697, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2567, N'Fort Washington Hospital', 1, NULL, NULL, N'210060', NULL, NULL, 0, 37, NULL, N'3012927000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11711 Livingston Road', N'Fort Washington', N'MD', N'24033', N'20744', 38.728435, -76.991389, 797, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2568, N'Atlantic General Hospital', 1, NULL, NULL, N'210061', NULL, NULL, 0, 55, NULL, N'4106419600', N'4106419670', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9733 Healthway Drive', N'Berlin', N'MD', N'24047', N'21811', 38.337265, -75.209897, 1697, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2569, N'Medstar Southern Maryland Hospital Center', 1, NULL, NULL, N'210062', NULL, NULL, 0, 239, NULL, N'3018688000', N'4434518538', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7503 Surratts Road', N'Clinton', N'MD', N'24033', N'20735', 38.75025, -76.874997, 1677, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2570, N'University Of Maryland St Joseph Medical Center', 1, NULL, NULL, N'210063', NULL, NULL, 0, 247, NULL, N'4103371000', N'4103371569', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Osler Drive', N'Towson', N'MD', N'24005', N'21204', 39.388123, -76.613278, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2571, N'Levindale Hebrew Geriatric Center And Hospital', 1, NULL, NULL, N'210064', NULL, NULL, 0, 100, NULL, N'4106012400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2434 West Belvedere Avenue', N'Baltimore', N'MD', N'24005', N'21215', 39.353383, -76.664561, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2572, N'Holy Cross Germantown Hospital', 1, NULL, NULL, N'210065', NULL, NULL, 0, 93, NULL, N'3015576020', N'3015575571', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19801 Observation Drive', N'Germantown', N'MD', N'24031', N'20876', 39.179289, -77.242662, 1696, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2573, N'Western Maryland Center', 1, NULL, NULL, N'212002', NULL, NULL, 0, 123, NULL, N'3017454140', N'3017914450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Pennsylvania Avenue', N'Hagerstown', N'MD', N'24043', N'21742', 39.652222, -77.717742, 1686, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2574, N'Deer''s Head Center', 1, NULL, NULL, N'212003', NULL, NULL, 0, 66, NULL, N'4105434000', N'4105434110', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Deer''s Head Hospital Road', N'Salisbury', N'MD', N'24045', N'21802', 38.366211, -75.600888, 1697, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2575, N'Healthsouth Chesapeake Rehabilitation Hospital', 1, NULL, NULL, N'213028', NULL, NULL, 0, 54, NULL, N'4102195500', N'4105468388', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Tilghman Road', N'Salisbury', N'MD', N'24045', N'21801', 38.368682, -75.547687, 1697, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2576, N'Adventist Rehabilitation Hospital Of Maryland', 1, NULL, NULL, N'213029', NULL, NULL, 0, 87, NULL, N'2408646005', N'2408646009', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9909 Medical Center Drive', N'Rockville', N'MD', N'24031', N'20850', 39.084005, -77.152757, 1696, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2577, N'Mount Washington Pediatric Hospital', 1, NULL, NULL, N'213300', NULL, NULL, 0, 87, NULL, N'4105785050', N'4105780566', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1708 West Rogers Avenue', N'Baltimore', N'MD', N'24510', N'21209', 39.362873, -76.653048, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2578, N'Kennedy Kreiger Institute', 1, NULL, NULL, N'213301', NULL, NULL, 0, 63, NULL, N'4439239305', N'4439239317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 North  Broadway', N'Baltimore', N'MD', N'24510', N'21205', 39.290861, -76.610807, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2579, N'Sheppard And Enoch Pratt Hospital The', 1, NULL, NULL, N'214000', NULL, NULL, 0, 322, NULL, N'4109383401', N'4109383450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 North  Charles Street', N'Baltimore', N'MD', N'24005', N'21204', 39.255674, -76.61718, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2580, N'Eastern Shore Hospital Center', 1, NULL, NULL, N'214002', NULL, NULL, 0, 80, NULL, N'4102212525', N'4102212534', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Post Office Box 800', N'Cambridge', N'MD', N'24019', N'21613', 38.563174, -76.078829, 1674, 131, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2581, N'Brook Lane Health Services', 1, NULL, NULL, N'214003', NULL, NULL, 0, 46, NULL, N'3017330330', N'3017334038', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13215  Brook Lane Drive', N'Hagerstown', N'MD', N'24043', N'21742', 39.641922, -77.720264, 1686, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2582, N'Springfield Hospital Center', 1, NULL, NULL, N'214004', NULL, NULL, 0, 522, NULL, N'4109707000', N'4109707005', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 Sykesville Road', N'Sykesville', N'MD', N'24013', N'21784', 39.37661, -76.966642, 1695, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2583, N'Thomas B Finan Center', 1, NULL, NULL, N'214012', NULL, NULL, 0, 119, NULL, N'3017772240', N'3017772364', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10102 Country Club Road  Post Office Box 1722', N'Cumberland', N'MD', N'24001', N'21502', 40.258279, -76.936379, 1680, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2584, N'Adventist Healthcare Behavioral Health & Wellness', 1, NULL, NULL, N'214013', NULL, NULL, 0, 107, NULL, N'3018384959', N'3012516052', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14901 Broschart Road', N'Rockville', N'MD', N'24031', N'20850', 39.084005, -77.152757, 1696, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2585, N'Spring Grove Hospital Center', 1, NULL, NULL, N'214018', NULL, NULL, 0, 440, NULL, N'4104027455', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Wade Avenue', N'Catonsville', N'MD', N'24005', N'21228', 39.270016, -76.723935, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2586, N'Johns Hopkins Hospital The', 1, NULL, NULL, N'219800', NULL, NULL, 0, 0, NULL, N'4106145477', N'4106149270', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'600 North Wolfe Street', N'Baltimore', N'MD', N'24510', N'21287', 39.255674, -76.61718, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2587, N'University Of Maryland Medical Center', 1, NULL, NULL, N'219801', NULL, NULL, 0, 0, NULL, N'4103281715', N'4103281798', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22 South Greene Street', N'Baltimore', N'MD', N'24510', N'21201', 39.287931, -76.625624, 1672, 130, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2588, N'Healthalliance Hospitals Inc', 1, NULL, NULL, N'220001', NULL, NULL, 0, 150, NULL, N'9784662000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Hospital Road', N'Leominster', N'MA', N'25027', N'01453', 42.541145, -71.761255, 1723, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2589, N'Mount Auburn Hospital', 1, NULL, NULL, N'220002', NULL, NULL, 0, 217, NULL, N'6174923500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Mount Auburn Street', N'Cambridge', N'MA', N'25017', N'02138', 42.375014, -71.135688, 1708, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2590, N'Sturdy Memorial Hospital', 1, NULL, NULL, N'220008', NULL, NULL, 0, 126, NULL, N'5082225200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Park Street', N'Attleboro', N'MA', N'25005', N'02703', 41.94262, -71.27478, 1702, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2591, N'Lawrence General Hospital', 1, NULL, NULL, N'220010', NULL, NULL, 0, 175, NULL, N'9786834000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One General Street', N'Lawrence', N'MA', N'25009', N'01842', 42.707035, -71.163114, 1722, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2592, N'Cambridge Health Alliance', 1, NULL, NULL, N'220011', NULL, NULL, 0, 159, NULL, N'6176652300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1493 Cambridge Street', N'Cambridge', N'MA', N'25017', N'02138', 42.37419, -71.104486, 1708, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2593, N'Cape Cod Hospital', 1, NULL, NULL, N'220012', NULL, NULL, 0, 259, NULL, N'5087711800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Lewis Bay Road', N'Hyannis', N'MA', N'25001', N'02601', 41.653169, -70.274896, 1721, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2594, N'Cooley Dickinson Hospital Incthe', 1, NULL, NULL, N'220015', NULL, NULL, 0, 142, NULL, N'4135822000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Locust Street', N'Northampton', N'MA', N'25015', N'01060', 42.331632, -72.653387, 1741, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2595, N'Baystate Franklin Medical Center', 1, NULL, NULL, N'220016', NULL, NULL, 0, 92, NULL, N'4137730211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 High Street', N'Greenfield', N'MA', N'25011', N'01301', 42.595606, -72.591287, 1718, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2596, N'Carney Hospital', 1, NULL, NULL, N'220017', NULL, NULL, 0, 159, NULL, N'6175062000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Dorchester Avenue', N'Boston', N'MA', N'25025', N'02124', 42.277558, -71.066592, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2597, N'Harrington Memorial Hospital', 1, NULL, NULL, N'220019', NULL, NULL, 0, 113, NULL, N'5087659771', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 South Street', N'Southbridge', N'MA', N'25027', N'01550', 42.077044, -72.043002, 1751, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2598, N'Saint Anne''s Hospital', 1, NULL, NULL, N'220020', NULL, NULL, 0, 160, NULL, N'5086745600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'795 Middle Street', N'Fall River', N'MA', N'25005', N'02721', 41.693262, -71.163321, 1712, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2599, N'Holyoke Medical Center', 1, NULL, NULL, N'220024', NULL, NULL, 0, 164, NULL, N'4135342500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 Beech Street', N'Holyoke', N'MA', N'25013', N'01040', 42.199421, -72.627955, 1720, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2600, N'Anna Jaques Hospital', 1, NULL, NULL, N'220029', NULL, NULL, 0, 123, NULL, N'9784631000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Highland Avenue', N'Newburyport', N'MA', N'25009', N'01950', 42.81433, -70.889695, 1737, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2601, N'Baystate Wing Hospital And Medical Centers', 1, NULL, NULL, N'220030', NULL, NULL, 0, 41, NULL, N'4132837651', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Wright Street', N'Palmer', N'MA', N'25013', N'01069', 42.168972, -72.340832, 1744, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2602, N'Boston Medical Center Corporation', 1, NULL, NULL, N'220031', NULL, NULL, 0, 185, NULL, N'6176388000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Boston Medical Center Place', N'Boston', N'MA', N'25025', N'02118', 42.334518, -71.075659, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2603, N'Beverly Hospital Corporation', 1, NULL, NULL, N'220033', NULL, NULL, 0, 283, NULL, N'9789223000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 Herrick Street', N'Beverly', N'MA', N'25009', N'01915', 42.568341, -70.8758, 1704, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2604, N'North Shore Medical Center', 1, NULL, NULL, N'220035', NULL, NULL, 0, 415, NULL, N'9787411215', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Highland Avenue', N'Salem', N'MA', N'25009', N'01970', 42.511902, -70.908699, 1748, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2605, N'St Elizabeth''s Medical Center', 1, NULL, NULL, N'220036', NULL, NULL, 0, 252, NULL, N'6177893000', N'6175627568', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Cambridge Street', N'Brighton', N'MA', N'25025', N'02135', 42.349624, -71.148469, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2606, N'Berkshire Medical Center Inc', 1, NULL, NULL, N'220046', NULL, NULL, 0, 319, NULL, N'4134472000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 North Street', N'Pittsfield', N'MA', N'25003', N'01201', 42.458748, -73.249004, 1745, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2607, N'Marlborough Hospital', 1, NULL, NULL, N'220049', NULL, NULL, 0, 79, NULL, N'5084815000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'157 Union Street', N'Marlborough', N'MA', N'25017', N'01752', 42.354246, -71.553996, 1728, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2608, N'Baystate Mary Lane Hospital', 1, NULL, NULL, N'220050', NULL, NULL, 0, 31, NULL, N'4139676211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 South Street', N'Ware', N'MA', N'25015', N'01082', 42.25276, -72.241542, 1757, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2609, N'Signature Healthcare Brockton Hospital', 1, NULL, NULL, N'220052', NULL, NULL, 0, 205, NULL, N'5089417000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'680 Center Street', N'Brockton', N'MA', N'25023', N'02302', 42.086197, -70.991188, 1706, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2610, N'Clinton Hospital Association', 1, NULL, NULL, N'220058', NULL, NULL, 0, 41, NULL, N'9783683000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Highland Street', N'Clinton', N'MA', N'25027', N'01510', 42.426986, -71.693649, 1709, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2611, N'Beth Israel Deaconess Hospital - Plymouth', 1, NULL, NULL, N'220060', NULL, NULL, 0, 155, NULL, N'5087462000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Sandwich Street', N'Plymouth', N'MA', N'25023', N'02360', 41.94367, -70.643637, 1746, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2612, N'Adcare Hospital Of Worcester Inc', 1, NULL, NULL, N'220062', NULL, NULL, 0, 114, NULL, N'5087999000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Lincoln Street', N'Worcester', N'MA', N'25027', N'01605', 42.27658, -71.795311, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2613, N'Lowell General Hospital', 1, NULL, NULL, N'220063', NULL, NULL, 0, 158, NULL, N'9789376000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'295 Varnum Avenue', N'Lowell', N'MA', N'25017', N'01854', 42.64646, -71.34068, 1724, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2614, N'Noble Hospital', 1, NULL, NULL, N'220065', NULL, NULL, 0, 97, NULL, N'4135682811', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 West Silver Street', N'Westfield', N'MA', N'25013', N'01085', 42.117485, -72.759775, 1760, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2615, N'Mercy Medical Ctr', 1, NULL, NULL, N'220066', NULL, NULL, 0, 339, NULL, N'4137489000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'271 Carew Street', N'Springfield', N'MA', N'25013', N'01104', 42.115878, -72.595442, 1752, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2616, N'Hallmark Health System', 1, NULL, NULL, N'220070', NULL, NULL, 0, 538, NULL, N'7819793000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'585 Lebanon Street', N'Melrose', N'MA', N'25017', N'02176', 42.460409, -71.06203, 1730, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2617, N'Massachusetts General Hospital', 1, NULL, NULL, N'220071', NULL, NULL, 0, 907, NULL, N'6177262000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Fruit Street', N'Boston', N'MA', N'25025', N'02114', 42.362421, -71.069802, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2618, N'Morton Hospital', 1, NULL, NULL, N'220073', NULL, NULL, 0, 133, NULL, N'5088287000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'88 Washington Street', N'Taunton', N'MA', N'25005', N'02780', 41.905589, -71.094342, 1755, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2619, N'Southcoast Hospital Group Inc', 1, NULL, NULL, N'220074', NULL, NULL, 0, 695, NULL, N'5086793131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'363 Highland Avenue', N'Fall River', N'MA', N'25005', N'02720', 41.710611, -71.146064, 1712, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2620, N'Massachusetts Eye And Ear Infirmary', 1, NULL, NULL, N'220075', NULL, NULL, 0, 42, NULL, N'6175237900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'243 Charles Street', N'Boston', N'MA', N'25025', N'02114', 42.363111, -71.070396, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2621, N'Baystate Medical Center', 1, NULL, NULL, N'220077', NULL, NULL, 0, 716, NULL, N'4137940000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'759 Chestnut Street', N'Springfield', N'MA', N'25013', N'01199', 42.120751, -72.605255, 1752, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2622, N'Holy Family Hospital', 1, NULL, NULL, N'220080', NULL, NULL, 0, 222, NULL, N'9786870156', N'9786829908', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 East Street', N'Methuen', N'MA', N'25009', N'01844', 42.725672, -71.168659, 1731, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2623, N'Beth Israel Deaconess Hospital - Needham', 1, NULL, NULL, N'220083', NULL, NULL, 0, 58, NULL, N'7814533002', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'148 Chestnut Street', N'Needham', N'MA', N'25021', N'02494', 42.277558, -71.23736, 1735, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2624, N'Emerson Hospital', 1, NULL, NULL, N'220084', NULL, NULL, 0, 149, NULL, N'9783691400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Old Road To 9 Acre Corner', N'W Concord', N'MA', N'25017', N'01742', 42.456686, -71.394232, 1710, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2625, N'Beth Israel Deaconess Medical Center', 1, NULL, NULL, N'220086', NULL, NULL, 0, 597, NULL, N'6176677000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Brookline Avenue', N'Boston', N'MA', N'25025', N'02215', 42.340351, -71.105735, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2626, N'New England Baptist Hospital', 1, NULL, NULL, N'220088', NULL, NULL, 0, 92, NULL, N'6177545800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Parker Hill Avenue', N'Boston', N'MA', N'25025', N'02120', 42.330025, -71.106294, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2627, N'Milford Regional Medical Center', 1, NULL, NULL, N'220090', NULL, NULL, 0, 121, NULL, N'5084731190', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 Prospect Street', N'Milford', N'MA', N'25027', N'01757', 42.132545, -71.528655, 1734, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2628, N'Heywood Hospital', 1, NULL, NULL, N'220095', NULL, NULL, 0, 134, NULL, N'9786323420', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'242 Green Street', N'Gardner', N'MA', N'25027', N'01440', 42.586393, -71.986092, 1715, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2629, N'Nashoba Valley Medical Center', 1, NULL, NULL, N'220098', NULL, NULL, 0, 57, NULL, N'9787849000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Groton Road', N'Ayer', N'MA', N'25017', N'01432', 42.576384, -71.573063, 1703, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2630, N'South Shore Hospital', 1, NULL, NULL, N'220100', NULL, NULL, 0, 284, NULL, N'7813408000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Fogg Road', N'South Weymouth', N'MA', N'25021', N'02190', 42.174729, -70.954258, 1750, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2631, N'Newton-Wellesley Hospital', 1, NULL, NULL, N'220101', NULL, NULL, 0, 224, NULL, N'6172436000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2014 Washington Street', N'Newton', N'MA', N'25017', N'02462', 42.332812, -71.246035, 1738, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2632, N'Winchester Hospital', 1, NULL, NULL, N'220105', NULL, NULL, 0, 189, NULL, N'7817299000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 Highland Avenue', N'Winchester', N'MA', N'25017', N'01890', 42.465496, -71.121408, 1761, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2633, N'Beth Israel Deaconess Hospital-Milton Inc', 1, NULL, NULL, N'220108', NULL, NULL, 0, 81, NULL, N'6176964600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 Reedsdale Road', N'Milton', N'MA', N'25021', N'02186', 42.25241, -71.075277, 1732, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2634, N'Brigham And Women''s Hospital', 1, NULL, NULL, N'220110', NULL, NULL, 0, 663, NULL, N'6177325500', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Francis Street', N'Boston', N'MA', N'25025', N'02115', 42.336211, -71.108083, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2635, N'od Samaritan Medical Center', 1, NULL, NULL, N'220111', NULL, NULL, 0, 231, NULL, N'5084273000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 North Pearl Street', N'Brockton', N'MA', N'25023', N'02301', 42.096879, -71.065635, 1706, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2636, N'Tufts Medical Center', 1, NULL, NULL, N'220116', NULL, NULL, 0, 415, NULL, N'6176365000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Washington Street', N'Boston', N'MA', N'25025', N'02111', 42.35005, -71.063454, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2637, N'Brigham And Women''s Faulkner Hospital', 1, NULL, NULL, N'220119', NULL, NULL, 0, 153, NULL, N'6179837000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1153 Centre Street', N'Boston', N'MA', N'25025', N'02130', 42.300641, -71.127428, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2638, N'Norwood Hospital', 1, NULL, NULL, N'220126', NULL, NULL, 0, 263, NULL, N'5087721000', N'5087721012', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Washington Street', N'Norwood', N'MA', N'25021', N'02062', 42.189462, -71.20264, 1742, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2639, N'Falmouth Hospital', 1, NULL, NULL, N'220135', NULL, NULL, 0, 95, NULL, N'5085485300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'67 & 100 Ter Heun Drive', N'Falmouth', N'MA', N'25001', N'02540', 41.564932, -70.621015, 1713, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2640, N'Dana-Farber Cancer Institute', 1, NULL, NULL, N'220162', NULL, NULL, 0, 27, NULL, N'6176323000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Brookline Avenue', N'Boston', N'MA', N'25025', N'02115', 42.337795, -71.108375, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2641, N'Umass Memorial Medical Center Inc', 1, NULL, NULL, N'220163', NULL, NULL, 0, 325, NULL, N'5083341000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Lake Avenue North', N'Worcester', N'MA', N'25027', N'01655', 42.27851, -71.759079, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2642, N'Lahey Hospital & Medical Center Burlington', 1, NULL, NULL, N'220171', NULL, NULL, 0, 327, NULL, N'7817445100', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 & 45 Mall Road', N'Burlington', N'MA', N'25017', N'01803', 42.476685, -71.21953, 1707, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2643, N'Metrowest Medical Center', 1, NULL, NULL, N'220175', NULL, NULL, 0, 360, NULL, N'5083831000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Lincoln Street', N'Framingham', N'MA', N'25017', N'01701', 42.284249, -71.419715, 1734, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2644, N'St Vincent Hospital', 1, NULL, NULL, N'220176', NULL, NULL, 0, 283, NULL, N'5083635000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Summer Street', N'Worcester', N'MA', N'25027', N'01608', 42.266786, -71.79563, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2645, N'Nantucket Cottage Hospital', 1, NULL, NULL, N'220177', NULL, NULL, 0, 19, NULL, N'5082281200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'57 Prospect Street', N'Nantucket', N'MA', N'25019', N'02554', 41.275319, -70.100016, 1733, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2646, N'Martha''s Vineyard Hospital Inc', 1, NULL, NULL, N'221300', NULL, NULL, 0, 19, NULL, N'5086930410', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Road Po Box 1477', N'Oak Bluffs', N'MA', N'25007', N'02557', 41.454279, -70.561972, 1743, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2647, N'Fairview Hospital', 1, NULL, NULL, N'221302', NULL, NULL, 0, 25, NULL, N'4135280790', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 Lewis Avenue', N'Great Barrington', N'MA', N'25003', N'01230', 42.191978, -73.372567, 1717, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2648, N'Athol Memorial Hospital', 1, NULL, NULL, N'221303', NULL, NULL, 0, 25, NULL, N'9782493511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2033 Main Street', N'Athol', N'MA', N'25027', N'01331', 42.58607, -72.208189, 1701, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2649, N'Chestnut Hill Benevolent Association', 1, NULL, NULL, N'221990', NULL, NULL, 0, 28, NULL, N'6177345600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'910 Boylston Street', N'Chestnut Hill', N'MA', N'25017', N'02167', 42.3234206, -71.1686622, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2650, N'Spaulding Hospital For Continuing Med Care-Camb', 1, NULL, NULL, N'222000', NULL, NULL, 0, 180, NULL, N'6178764344', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1575 Cambridge Street', N'Cambridge', N'MA', N'25017', N'02138', 42.374587, -71.106878, 1708, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2651, N'Kindred Hospital Northeast - Stoughton', 1, NULL, NULL, N'222002', NULL, NULL, 0, 221, NULL, N'7818482600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 Sumner Street 1St Floor', N'Stoughton', N'MA', N'25021', N'02072', 42.101534, -71.081052, 1754, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2652, N'Tewksbury Hospital', 1, NULL, NULL, N'222003', NULL, NULL, 0, 760, NULL, N'9788517321', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'365 East Street', N'Tewksbury', N'MA', N'25017', N'01876', 42.612428, -71.21686, 1724, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2653, N'Lemuel Shattuck Hospital', 1, NULL, NULL, N'222006', NULL, NULL, 0, 215, NULL, N'6175228110', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Morton Street', N'Jamaica Plain', N'MA', N'25025', N'02130', 42.289167, -71.095414, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2654, N'Hebrew Rehabilitation Center', 1, NULL, NULL, N'222007', NULL, NULL, 0, 675, NULL, N'6173258000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Centre Street', N'Boston', N'MA', N'25025', N'02131', 42.29696, -71.132255, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2655, N'Western Massachusetts Hospital', 1, NULL, NULL, N'222023', NULL, NULL, 0, 102, NULL, N'4135624131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91 East Mountain Road', N'Westfield', N'MA', N'25013', N'01085', 42.172407, -72.68933, 1760, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2656, N'Massachusetts Hospital School', 1, NULL, NULL, N'222025', NULL, NULL, 0, 239, NULL, N'6178282440', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3 Randolph Street', N'Canton', N'MA', N'25021', N'02021', 42.174611, -71.123422, 1742, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2657, N'Spaulding Hospital For Continuing Mc - North Shore', 1, NULL, NULL, N'222026', NULL, NULL, 0, 160, NULL, N'9787459000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Dove Avenue', N'Salem', N'MA', N'25009', N'01970', 42.510326, -70.903291, 1748, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2658, N'New England Sinai Hospital', 1, NULL, NULL, N'222027', NULL, NULL, 0, 212, NULL, N'7813644850', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 York Street', N'Stoughton', N'MA', N'25021', N'02072', 42.144595, -71.098841, 1754, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2659, N'New Bedford Rehabilitation Hospital', 1, NULL, NULL, N'222043', NULL, NULL, 0, 90, NULL, N'5089956900', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4499 Acushnet Avenue', N'New Bedford', N'MA', N'25005', N'02745', 41.73976, -70.944154, 1736, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2660, N'Kindred Hospital - Boston North Shore', 1, NULL, NULL, N'222044', NULL, NULL, 0, 50, NULL, N'5085312900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 King Street', N'Peabody', N'MA', N'25009', N'01960', 42.529165, -70.93675, 1748, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2661, N'Kindred Hospital - Boston', 1, NULL, NULL, N'222045', NULL, NULL, 0, 59, NULL, N'6172541100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Commonwealth Avenue', N'Boston', N'MA', N'25025', N'02135', 42.34711, -71.141229, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2662, N'Vibra Hospital Of Western Massachusetts', 1, NULL, NULL, N'222046', NULL, NULL, 0, 174, NULL, N'4137876700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 State Street', N'Springfield', N'MA', N'25013', N'01109', 42.120037, -72.54602, 1752, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2663, N'Whittier Rehabilitation Hospital - Bradford', 1, NULL, NULL, N'222047', NULL, NULL, 0, 60, NULL, N'9783728000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Ward Hill Avenue', N'Bradford', N'MA', N'25009', N'01835', 42.761646, -71.118947, 1719, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2664, N'Whittier Rehabilitation Hospital', 1, NULL, NULL, N'222048', NULL, NULL, 0, 88, NULL, N'5088712063', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Flanders Road', N'Westborough', N'MA', N'25027', N'01581', 42.276428, -71.567855, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2665, N'Healthsouth New England Rehabilitation Hospital', 1, NULL, NULL, N'223026', NULL, NULL, 0, 210, NULL, N'7819355050', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Rehabilitation Way', N'Woburn', N'MA', N'25017', N'01801', 42.463523, -71.161925, 1761, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2666, N'Healthsouth Braintree Rehabilitation Hospital', 1, NULL, NULL, N'223027', NULL, NULL, 0, 187, NULL, N'7818485353', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Pond Street', N'Braintree', N'MA', N'25021', N'02184', 42.199092, -71.018392, 1750, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2667, N'Fairlawn Rehabilitation Hospital', 1, NULL, NULL, N'223029', NULL, NULL, 0, 110, NULL, N'5087916351', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 May Street', N'Worcester', N'MA', N'25027', N'01602', 42.261333, -71.83409, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2668, N'Healthsouth Rehabilitation Hospital Of Western Ma', 1, NULL, NULL, N'223030', NULL, NULL, 0, 53, NULL, N'4135897581', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 State Street', N'Ludlow', N'MA', N'25013', N'01056', 42.156132, -72.472374, 1725, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2669, N'Spaulding Rehabilitation Hospital - Cape Cod', 1, NULL, NULL, N'223032', NULL, NULL, 0, 60, NULL, N'5088334010', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 Service Road', N'East Sandwich', N'MA', N'25001', N'02537', 41.726594, -70.439408, 1713, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2670, N'Spaulding Rehabilitation Hospital', 1, NULL, NULL, N'223034', NULL, NULL, 0, 132, NULL, N'6177206400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 First Avenue', N'Charlestown', N'MA', N'25025', N'02129', 42.378586, -71.04909, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2671, N'Franciscan Children''s Hospital & Rehab Center', 1, NULL, NULL, N'223300', NULL, NULL, 0, 112, NULL, N'6172543800', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Warren Street', N'Brighton', N'MA', N'25025', N'02135', 42.349621, -71.143514, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2672, N'Boston Children''s Hospital', 1, NULL, NULL, N'223302', NULL, NULL, 0, 395, NULL, N'6177356000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Longwood Avenue', N'Boston', N'MA', N'25025', N'02115', 42.337621, -71.104762, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2673, N'Shriners'' Hospital For Children (The)', 1, NULL, NULL, N'223303', NULL, NULL, 0, 40, NULL, N'4137872000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 Carew Street', N'Springfield', N'MA', N'25013', N'01104', 42.120591, -72.591725, 1752, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2674, N'Shriners'' Hospital For Children - Boston The', 1, NULL, NULL, N'223304', NULL, NULL, 0, 30, NULL, N'6177223000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 Blossom Street', N'Boston', N'MA', N'25025', N'02114', 42.37234, -71.039364, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2675, N'Taunton State Hospital', 1, NULL, NULL, N'224001', NULL, NULL, 0, 45, NULL, N'5089773000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'60 Hodges Avenue Box 151', N'Taunton', N'MA', N'25005', N'02780', 41.906666, -71.102334, 1755, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2676, N'Mclean Hospital Corporation', 1, NULL, NULL, N'224007', NULL, NULL, 0, 324, NULL, N'6178553450', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Mill Street', N'Belmont', N'MA', N'25017', N'02478', 42.396124, -71.194905, 1708, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2677, N'Arbour Hospital The', 1, NULL, NULL, N'224013', NULL, NULL, 0, 118, NULL, N'6175224400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'49 Robinwood Avenue', N'Boston', N'MA', N'25025', N'02130', 42.37234, -71.039364, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2678, N'Arbour Human Resource Institute', 1, NULL, NULL, N'224018', NULL, NULL, 0, 68, NULL, N'6177313200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'227 Babcock Street', N'Brookline', N'MA', N'25021', N'02146', 42.348021, -71.121069, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2679, N'Arbour-Fuller Hospital', 1, NULL, NULL, N'224021', NULL, NULL, 0, 86, NULL, N'5087618500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 May Street', N'South Attleboro', N'MA', N'25005', N'02703', 41.926287, -71.360868, 1702, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2680, N'Bournewood Hospital', 1, NULL, NULL, N'224022', NULL, NULL, 0, 90, NULL, N'6174690300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Street', N'Brookline', N'MA', N'25021', N'02146', 42.297927, -71.150921, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2681, N'Westwood Pembroke Health Systems', 1, NULL, NULL, N'224023', NULL, NULL, 0, 248, NULL, N'6177627764', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Clapboardtree Street', N'Westwood', N'MA', N'25021', N'02090', 42.213987, -71.224499, 1742, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2682, N'Dr John C Corrigan Mental Health Center', 1, NULL, NULL, N'224028', NULL, NULL, 0, 16, NULL, N'5082357600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'49 Hillside Street', N'Fall River', N'MA', N'25005', N'02720', 41.707814, -71.145658, 1712, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2683, N'Cape Cod & Islands Community Mental Health Center', 1, NULL, NULL, N'224031', NULL, NULL, 0, 16, NULL, N'5085632276', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 County Road', N'Pocasset', N'MA', N'25001', N'02559', 41.689537, -70.601267, 1713, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2684, N'Worcester Recovery Center And Hospital', 1, NULL, NULL, N'224032', NULL, NULL, 0, 166, NULL, N'5087524681', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'309 Belmont Street', N'Worcester', N'MA', N'25027', N'01604', 42.274189, -71.758351, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2685, N'Baldpate Hospital', 1, NULL, NULL, N'224033', NULL, NULL, 0, 18, NULL, N'9783522131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'83 Baldpate Road', N'Georgetown', N'MA', N'25009', N'01833', 42.695098, -71.007393, 1719, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2686, N'Walden Behavioral Care Llc', 1, NULL, NULL, N'224038', NULL, NULL, 0, 45, NULL, N'7816476727', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9 Hope Avenue', N'Waltham', N'MA', N'25017', N'02453', 42.3695532, -71.2515683, 1756, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2687, N'Whittier Pavilion', 1, NULL, NULL, N'224039', NULL, NULL, 0, 65, NULL, N'9783738222', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'76 Summer Street', N'Haverhill', N'MA', N'25009', N'01830', 42.778639, -71.072806, 1719, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2688, N'Dr Solomon Carter Fuller Mental Health Center', 1, NULL, NULL, N'224040', NULL, NULL, 0, 60, NULL, N'6172668800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'85 East Newton Street', N'Boston', N'MA', N'25025', N'02118', 42.338722, -71.072662, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2689, N'Brigham And Women''s Hospital -  Transplant Center', 1, NULL, NULL, N'229801', NULL, NULL, 0, 0, NULL, N'6177325500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'75 Francis Street', N'Boston', N'MA', N'25025', N'02115', 42.334897, -71.105855, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2690, N'Lahey Clinic - Transplant Center', 1, NULL, NULL, N'229802', NULL, NULL, 0, 0, NULL, N'7817445100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'41 & 45 Mall Road', N'Burlington', N'MA', N'25017', N'01803', 42.504817, -71.195611, 1707, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2691, N'Beth Israel Deaconess Med Ctr -  Transplant Center', 1, NULL, NULL, N'229803', NULL, NULL, 0, 0, NULL, N'6176677000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'330 Brookline Avenue', N'Boston', N'MA', N'25025', N'02115', 42.335586, -71.110808, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2692, N'Boston Medical Center - Transplant Center', 1, NULL, NULL, N'229804', NULL, NULL, 0, 0, NULL, N'6176388430', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Boston Medical Place', N'Boston', N'MA', N'25025', N'02118', 42.360482, -71.059568, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2693, N'University Of Mass Memorial Med Ctr - Transplant', 1, NULL, NULL, N'229805', NULL, NULL, 0, 0, NULL, N'5083347177', N'5083342017', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Lake Avenue North', N'Worcester', N'MA', N'25027', N'01655', 42.271697, -71.758754, 1763, 135, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2694, N'Boston Children''s Hospital - Transplant Center', 1, NULL, NULL, N'229806', NULL, NULL, 0, 0, NULL, N'6173556128', N'6177300630', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Longwood Ave', N'Boston', N'MA', N'25025', N'02115', 42.337783, -71.105141, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2695, N'Tufts Medical Center - Transplant', 1, NULL, NULL, N'229807', NULL, NULL, 0, 0, NULL, N'6176364229', N'6176366489', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'750 Washington Street', N'Boston', N'MA', N'25025', N'02111', 42.350384, -71.063181, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2696, N'Massachusetts General Hospital - Transplant Center', 1, NULL, NULL, N'229808', NULL, NULL, 0, 0, NULL, N'6177265111', N'6177243377', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Fruit Street', N'Boston', N'MA', N'25025', N'02114', 42.362507, -71.069707, 1705, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2697, N'Baystate Medical Center - Transplant Center', 1, NULL, NULL, N'229809', NULL, NULL, 0, 0, NULL, N'4137942602', N'4137942603', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'759 Chestnut Street', N'Springfield', N'MA', N'25013', N'01199', 42.119062, -72.604095, 1752, 134, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2698, N'St Mary Mercy Hospital', 1, NULL, NULL, N'230002', NULL, NULL, 0, 273, NULL, N'7346554800', N'7346553093', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36475 Five Mile Road', N'Livonia', N'MI', N'26163', N'48154', 42.36837, -83.35271, 1822, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2699, N'Spectrum Health Zeeland Community Hospital', 1, NULL, NULL, N'230003', NULL, NULL, 0, 57, NULL, N'6167724644', N'6167482828', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8333 Felch St', N'Zeeland', N'MI', N'26139', N'49464', 42.819534, -85.987602, 1873, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2700, N'Mercy Health Musken', 1, NULL, NULL, N'230004', NULL, NULL, 0, 282, NULL, N'2316723901', N'2316723074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Sherman Boulevard', N'Musken', N'MI', N'26121', N'49444', 43.204998, -86.208992, 1836, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2701, N'Promedica Bixby Hospital', 1, NULL, NULL, N'230005', NULL, NULL, 0, 88, NULL, N'5172650900', N'5172631839', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 Riverside Avenue', N'Adrian', N'MI', N'26091', N'49221', 41.912711, -84.048693, 1765, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2702, N'Doctors'' Hospital Of Michigan', 1, NULL, NULL, N'230013', NULL, NULL, 0, 306, NULL, N'2488577200', N'2488576842', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'461 W Huron St', N'Pontiac', N'MI', N'26125', N'48341', 42.635679, -83.309469, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2703, N'Three Rivers Health', 1, NULL, NULL, N'230015', NULL, NULL, 0, 60, NULL, N'2692739602', N'2692739611', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 S Health Parkway', N'Three Rivers', N'MI', N'26149', N'49093', 41.934945, -85.646958, 1864, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2704, N'Bronson Methodist Hospital', 1, NULL, NULL, N'230017', NULL, NULL, 0, 380, NULL, N'2693416000', N'2693418314', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 John Street 42', N'Kalamazoo', N'MI', N'26077', N'49007', 42.286165, -85.581333, 1816, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2705, N'Providence Hospital And Medical Centers', 1, NULL, NULL, N'230019', NULL, NULL, 0, 434, NULL, N'2488493011', N'2488493035', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16001 W Nine Mile Rd', N'Southfield', N'MI', N'26125', N'48075', 42.473369, -83.221873, 1855, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2706, N'Beaumont Hospital - Dearborn', 1, NULL, NULL, N'230020', NULL, NULL, 0, 623, NULL, N'3135937125', N'3134362042', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Oakwood Blvd', N'Dearborn', N'MI', N'26163', N'48124', 42.291912, -83.211951, 1787, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2707, N'Lakeland Hospital St Joseph', 1, NULL, NULL, N'230021', NULL, NULL, 0, 313, NULL, N'2699838300', N'2699824855', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1234 Napier Avenue', N'St Joseph', N'MI', N'26021', N'49085', 42.089775, -86.477296, 1858, 149, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2708, N'Community Health Center Of Branch County', 1, NULL, NULL, N'230022', NULL, NULL, 0, 110, NULL, N'5172795400', N'5172797140', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'274 E Chica St', N'Coldwater', N'MI', N'26023', N'49036', 41.939038, -84.991153, 1785, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2709, N'Sinai-Grace Hospital', 1, NULL, NULL, N'230024', NULL, NULL, 0, 991, NULL, N'3139663300', N'3139663160', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6071 W Outer Drive', N'Detroit', N'MI', N'26163', N'48235', 42.420085, -83.182379, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2710, N'St Joseph Mercy Oakland', 1, NULL, NULL, N'230029', NULL, NULL, 0, 395, NULL, N'2488583000', N'2488583299', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44405 Woodward Ave', N'Pontiac', N'MI', N'26125', N'48341', 42.614834, -83.274998, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2711, N'Midmichigan Medical Center-Gratiot', 1, NULL, NULL, N'230030', NULL, NULL, 0, 142, NULL, N'9894631101', N'9894636948', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 E Warwick Dr', N'Alma', N'MI', N'26057', N'48801', 43.391626, -84.662507, 1768, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2712, N'Lake Huron Medical Center', 1, NULL, NULL, N'230031', NULL, NULL, 0, 119, NULL, N'8109851500', N'8109851579', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Electric Avenue', N'Port Huron', N'MI', N'26147', N'48060', 42.955785, -82.431961, 1846, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2713, N'Spectrum Health United Memorial - United Campus', 1, NULL, NULL, N'230035', NULL, NULL, 0, 48, NULL, N'6167544691', N'6167545054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 S Bower Street', N'Greenville', N'MI', N'26117', N'48838', 43.175103, -85.26875, 1802, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2714, N'Alpena Regional Medical Center', 1, NULL, NULL, N'230036', NULL, NULL, 0, 150, NULL, N'9893567390', N'9893567305', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 W Chisholm St', N'Alpena', N'MI', N'26007', N'49707', 45.076789, -83.450608, 1769, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2715, N'Hillsdale Community Health Center', 1, NULL, NULL, N'230037', NULL, NULL, 0, 86, NULL, N'5174374451', N'5174370246', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'168 S Howell Street', N'Hillsdale', N'MI', N'26059', N'49242', 41.911797, -84.631703, 1807, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2716, N'Spectrum Health - Butterworth Campus', 1, NULL, NULL, N'230038', NULL, NULL, 0, 634, NULL, N'6163911774', N'6163918729', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Michigan St Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.970468, -85.664642, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2717, N'Spectrum Health Pennock', 1, NULL, NULL, N'230040', NULL, NULL, 0, 89, NULL, N'2699453451', N'2699454130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1009 W Green St', N'Hastings', N'MI', N'26015', N'49058', 42.6442, -85.3021, 1806, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2718, N'Mclaren Bay Region', 1, NULL, NULL, N'230041', NULL, NULL, 0, 387, NULL, N'9898943000', N'9898918172', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Columbus Ave', N'Bay City', N'MI', N'26017', N'48708', 43.589386, -83.868741, 1773, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2719, N'University Of Michigan Health System', 1, NULL, NULL, N'230046', NULL, NULL, 0, 884, NULL, N'7347641505', N'7349360156', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Medical Center Drive Spc 5474', N'Ann Arbor', N'MI', N'26161', N'48109', 42.281446, -83.730657, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2720, N'Henry Ford Macomb Hospital', 1, NULL, NULL, N'230047', NULL, NULL, 0, 350, NULL, N'5862632300', N'5862632255', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15855 Nineteen Mile Rd', N'Clinton Township', N'MI', N'26099', N'48038', 42.58484, -82.934824, 1833, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2721, N'Henry Ford Hospital', 1, NULL, NULL, N'230053', NULL, NULL, 0, 903, NULL, N'3139162600', N'3139168096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2799 W Grand Blvd', N'Detroit', N'MI', N'26163', N'48202', 42.366114, -83.084592, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2722, N'Up Health System - Marquette', 1, NULL, NULL, N'230054', NULL, NULL, 0, 289, NULL, N'9062289440', N'9062253032', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 W Magnetic', N'Marquette', N'MI', N'26103', N'49855', 46.553605, -87.39908, 1828, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2723, N'Dickinson County Memorial Hospital', 1, NULL, NULL, N'230055', NULL, NULL, 0, 96, NULL, N'9067741313', N'9067765427', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1721 S Stephenson Ave', N'Iron Mountain', N'MI', N'26043', N'49801', 45.808234, -88.047635, 1811, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2724, N'Munson Healthcare Grayling Hospital', 1, NULL, NULL, N'230058', NULL, NULL, 0, 90, NULL, N'9893485461', N'9893480477', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 E Michigan Ave', N'Grayling', N'MI', N'26039', N'49738', 44.669868, -84.707843, 1801, 150, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2725, N'Saint Mary''s Health Care', 1, NULL, NULL, N'230059', NULL, NULL, 0, 230, NULL, N'6166855000', N'6166856151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Jefferson Avenue Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.957181, -85.664091, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2726, N'Mercy Health Musken', 1, NULL, NULL, N'230066', NULL, NULL, 0, 154, NULL, N'2317263511', N'2317285818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Clinton Street', N'Musken', N'MI', N'26121', N'49442', 43.22174, -86.243088, 1836, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2727, N'Saint Joseph Mercy Livingston Hospital', 1, NULL, NULL, N'230069', NULL, NULL, 0, 136, NULL, N'5175456000', N'5175456192', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Byron Rd', N'Howell', N'MI', N'26093', N'48843', 42.615593, -83.939437, 1809, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2728, N'Covenant Medical Center', 1, NULL, NULL, N'230070', NULL, NULL, 0, 623, NULL, N'9895834000', N'9895832727', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1447 N Harrison', N'Saginaw', N'MI', N'26145', N'48602', 43.427844, -83.955546, 1850, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2729, N'Straith Hospital For Special Surgery', 1, NULL, NULL, N'230071', NULL, NULL, 0, 34, NULL, N'2483573360', N'2483570915', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'23901 Lahser', N'Southfield', N'MI', N'26125', N'48033', 42.464106, -83.26038, 1855, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2730, N'Holland Community Hospital', 1, NULL, NULL, N'230072', NULL, NULL, 0, 193, NULL, N'6163925141', N'6163943477', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Michigan Ave', N'Holland', N'MI', N'26139', N'49423', 42.774519, -86.112814, 1808, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2731, N'Bronson Battle Creek Hospital', 1, NULL, NULL, N'230075', NULL, NULL, 0, 204, NULL, N'2699668000', N'2699668008', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Avenue', N'Battle Creek', N'MI', N'26025', N'49017', 42.330192, -85.180415, 1772, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2732, N'St Mary''s Of Michigan Medical Center', 1, NULL, NULL, N'230077', NULL, NULL, 0, 268, NULL, N'9897768000', N'9897761704', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Washington Avenue', N'Saginaw', N'MI', N'26145', N'48601', 43.425889, -83.94201, 1850, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2733, N'Lakeland Community Hospital Watervliet', 1, NULL, NULL, N'230078', NULL, NULL, 0, 62, NULL, N'2694633111', N'2694635550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Medical Park Dr', N'Watervliet', N'MI', N'26021', N'49098', 42.184464, -86.250328, 1869, 149, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2734, N'Mclaren Central Michigan', 1, NULL, NULL, N'230080', NULL, NULL, 0, 151, NULL, N'9897726700', N'9897721150', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 South Drive', N'Mount Pleasant', N'MI', N'26073', N'48858', 43.598534, -84.760592, 1834, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2735, N'Munson Healthcare Cadillac Hospital', 1, NULL, NULL, N'230081', NULL, NULL, 0, 117, NULL, N'2318767200', N'2318767239', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Hobart St', N'Cadillac', N'MI', N'26165', N'49601', 44.246214, -85.39051, 1776, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2736, N'South Haven Community Hospital', 1, NULL, NULL, N'230085', NULL, NULL, 0, 82, NULL, N'2696375271', N'2696392818', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 S Bailey Ave', N'South Haven', N'MI', N'26159', N'49090', 42.391395, -86.264098, 1854, 149, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2737, N'Beaumont Hospital Grosse Pointe', 1, NULL, NULL, N'230089', NULL, NULL, 0, 311, NULL, N'3133431000', N'3133431509', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'468 Cadieux Rd', N'Grosse Pointe', N'MI', N'26163', N'48230', 42.384197, -82.915386, 1803, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2738, N'Allegiance Health', 1, NULL, NULL, N'230092', NULL, NULL, 0, 412, NULL, N'5177884800', N'5177884829', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 N East Ave', N'Jackson', N'MI', N'26075', N'49201', 42.252648, -84.394005, 1815, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2739, N'Spectrum Health Big Rapids Hospital', 1, NULL, NULL, N'230093', NULL, NULL, 0, 74, NULL, N'2317968691', N'2315924421', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Oak Street', N'Big Rapids', N'MI', N'26107', N'49307', 43.69312, -85.476068, 1775, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2740, N'West Branch Regional Medical Center', 1, NULL, NULL, N'230095', NULL, NULL, 0, 88, NULL, N'9893456366', N'9893433113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2463 South M-30', N'West Branch', N'MI', N'26129', N'48661', 44.262155, -84.246224, 1871, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2741, N'Sturgis Hospital', 1, NULL, NULL, N'230096', NULL, NULL, 0, 94, NULL, N'2696517824', N'2696594493', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'916 Myrtle Ave', N'Sturgis', N'MI', N'26149', N'49091', 41.794198, -85.408731, 1860, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2742, N'Munson Medical Center', 1, NULL, NULL, N'230097', NULL, NULL, 0, 377, NULL, N'2319355000', N'2319356548', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Sixth Street', N'Traverse City', N'MI', N'26055', N'49684', 44.761646, -85.641402, 1865, 150, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2743, N'Promedica Monroe Regional Hospital', 1, NULL, NULL, N'230099', NULL, NULL, 0, 217, NULL, N'7342408400', N'7342404424', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'718 N Macomb St', N'Monroe', N'MI', N'26115', N'48162', 41.926279, -83.388455, 1832, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2744, N'Tawas St Joseph Hospital', 1, NULL, NULL, N'230100', NULL, NULL, 0, 60, NULL, N'9893629301', N'5173627277', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hemlock', N'Tawas City', N'MI', N'26069', N'48764', 44.274806, -83.51072, 1861, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2745, N'Harper University Hospital', 1, NULL, NULL, N'230104', NULL, NULL, 0, 712, NULL, N'3137456211', N'3137451520', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3990 John R Street', N'Detroit', N'MI', N'26163', N'48201', 42.350837, -83.05754, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2746, N'Mclaren - Northern Michigan', 1, NULL, NULL, N'230105', NULL, NULL, 0, 243, NULL, N'2314874000', N'2314874552', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'416 Connable Ave', N'Petoskey', N'MI', N'26047', N'49770', 45.373384, -84.96912, 1843, 145, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2747, N'Up Health System Portage', 1, NULL, NULL, N'230108', NULL, NULL, 0, 36, NULL, N'9064831000', N'9064831521', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Campus Drive', N'Hancock', N'MI', N'26061', N'49930', 47.141355, -88.585078, 1804, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2748, N'Spectrum Health Ludington Hospital', 1, NULL, NULL, N'230110', NULL, NULL, 0, 81, NULL, N'2318432591', N'2318453607', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One N Atkinson Drive', N'Ludington', N'MI', N'26105', N'49431', 43.955283, -86.452583, 1823, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2749, N'Borgess Medical Center', 1, NULL, NULL, N'230117', NULL, NULL, 0, 372, NULL, N'2692267000', N'2692267396', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1521 Gull Road', N'Kalamazoo', N'MI', N'26077', N'49048', 42.304531, -85.561912, 1816, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2750, N'Huron Medical Center', 1, NULL, NULL, N'230118', NULL, NULL, 0, 64, NULL, N'9892699521', N'9892695260', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 South Van Dyke Road', N'Bad Axe', N'MI', N'26063', N'48413', 43.802404, -83.034389, 1771, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2751, N'Memorial Healthcare', 1, NULL, NULL, N'230121', NULL, NULL, 0, 115, NULL, N'9897235211', N'9897257902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'826 West King Street', N'Owosso', N'MI', N'26155', N'48867', 43.005092, -84.183037, 1841, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2752, N'Berrien General Hospital', 1, NULL, NULL, N'230125', NULL, NULL, 0, 55, NULL, N'6164717761', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6418 Deans Hill Rd', N'Berrien Center', N'MI', N'26021', N'49102', 41.955414, -86.301605, 1774, 149, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2753, N'Beaumont Hospital Royal Oak', 1, NULL, NULL, N'230130', NULL, NULL, 0, 1031, NULL, N'2488985000', N'2488985418', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 W Thirteen Mile Rd', N'Royal Oak', N'MI', N'26125', N'48073', 42.503719, -83.166837, 1849, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2754, N'Hurley Medical Center', 1, NULL, NULL, N'230132', NULL, NULL, 0, 383, NULL, N'8102579000', N'8102579003', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hurley Plaza', N'Flint', N'MI', N'26049', N'48503', 43.017177, -83.723602, 1793, 139, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2755, N'Otse Memorial Hospital', 1, NULL, NULL, N'230133', NULL, NULL, 0, 53, NULL, N'9897312100', N'9897312217', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 N Center Ave', N'Gaylord', N'MI', N'26137', N'49735', 45.035549, -84.673884, 1797, 145, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2756, N'Mclaren Flint', 1, NULL, NULL, N'230141', NULL, NULL, 0, 368, NULL, N'8103422000', N'8103422428', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 S Ballenger Highway', N'Flint', N'MI', N'26049', N'48532', 43.014384, -83.733557, 1793, 139, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2757, N'Beaumont Hospital - Wayne', 1, NULL, NULL, N'230142', NULL, NULL, 0, 259, NULL, N'7344674175', N'7344674017', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33155 Annapolis Ave', N'Wayne', N'MI', N'26163', N'48184', 42.274273, -83.365705, 1870, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2758, N'Forest Health Medical Center', 1, NULL, NULL, N'230144', NULL, NULL, 0, 148, NULL, N'7345474700', N'7435474795', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 S Prospect St', N'Ypsilanti', N'MI', N'26161', N'48198', 42.237492, -83.601918, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2759, N'Henry Ford Wyandotte Hospital', 1, NULL, NULL, N'230146', NULL, NULL, 0, 345, NULL, N'7342466000', N'7342468860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Biddle Ave', N'Wyandotte', N'MI', N'26163', N'48192', 42.209694, -83.148776, 1872, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2760, N'Beaumont Hospital - Farmington Hills', 1, NULL, NULL, N'230151', NULL, NULL, 0, 305, NULL, N'2484718000', N'2484718807', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'28050 Grand River Avenue', N'Farmington Hills', N'MI', N'26125', N'48336', 42.443242, -83.323838, 1792, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2761, N'St Joseph Mercy Hospital', 1, NULL, NULL, N'230156', NULL, NULL, 0, 505, NULL, N'7347123456', N'7347125459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 E Huron River Dr', N'Ann Arbor', N'MI', N'26161', N'48106', 42.270571, -83.696016, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2762, N'St John Hospital And Medical Center', 1, NULL, NULL, N'230165', NULL, NULL, 0, 625, NULL, N'3133434000', N'3133437533', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22101 Moross Rd', N'Detroit', N'MI', N'26163', N'48236', 42.419011, -82.915008, 1803, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2763, N'Mclaren Greater Lansing', 1, NULL, NULL, N'230167', NULL, NULL, 0, 363, NULL, N'5179756000', N'5179757560', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Greenlawn Ave', N'Lansing', N'MI', N'26065', N'48910', 42.704805, -84.555517, 1819, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2764, N'North Ottawa Community Health Center', 1, NULL, NULL, N'230174', NULL, NULL, 0, 81, NULL, N'6168423600', N'6168475621', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 Sheldon Rd', N'Grand Haven', N'MI', N'26139', N'49417', 43.050837, -86.227852, 1799, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2765, N'Beaumont Hospital - Trenton', 1, NULL, NULL, N'230176', NULL, NULL, 0, 195, NULL, N'7346713800', N'7346713891', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5450 Fort Street', N'Trenton', N'MI', N'26163', N'48183', 42.118286, -83.2096, 1866, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2766, N'Midmichigan Medical Center-Clare', 1, NULL, NULL, N'230180', NULL, NULL, 0, 64, NULL, N'9898025000', N'9898028800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 N Mcewan St', N'Clare', N'MI', N'26035', N'48617', 43.820585, -84.76835, 1784, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2767, N'Mclaren Lapeer Region', 1, NULL, NULL, N'230193', NULL, NULL, 0, 183, NULL, N'8106675500', N'8106675524', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1375 N Main St', N'Lapeer', N'MI', N'26087', N'48446', 43.061707, -83.319265, 1820, 139, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2768, N'St John Macomb-Oakland Hospital-Macomb Center', 1, NULL, NULL, N'230195', NULL, NULL, 0, 348, NULL, N'5865735000', N'5865735541', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11800 East Twelve Mile Road', N'Warren', N'MI', N'26099', N'48093', 42.477536, -83.0277, 1868, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2769, N'Genesys Regional Medical Center - Health Park', 1, NULL, NULL, N'230197', NULL, NULL, 0, 410, NULL, N'8106065000', N'8106066605', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Genesys Parkway', N'Grand Blanc', N'MI', N'26049', N'48439', 42.927528, -83.629952, 1793, 139, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2770, N'Mclaren Oakland', 1, NULL, NULL, N'230207', NULL, NULL, 0, 308, NULL, N'2483385000', N'2483385667', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Perry', N'Pontiac', N'MI', N'26125', N'48342', 42.637879, -83.290908, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2771, N'Sparrow Carson Hospital', 1, NULL, NULL, N'230208', NULL, NULL, 0, 103, NULL, N'9895843131', N'9895843163', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 East Elm St', N'Carson City', N'MI', N'26117', N'48811', 43.17595, -84.842141, 1778, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2772, N'Port Huron Hospital', 1, NULL, NULL, N'230216', NULL, NULL, 0, 163, NULL, N'8109875000', N'8109852675', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Pine Grove Ave', N'Port Huron', N'MI', N'26147', N'48060', 42.986743, -82.427839, 1846, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2773, N'Oaklawn Hospital', 1, NULL, NULL, N'230217', NULL, NULL, 0, 94, NULL, N'2697814271', N'2697817117', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N Madison', N'Marshall', N'MI', N'26025', N'49068', 42.273048, -84.95779, 1829, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2774, N'Midmichigan Medical Center-Midland', 1, NULL, NULL, N'230222', NULL, NULL, 0, 230, NULL, N'9898393000', N'9898393528', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Wellness Drive', N'Midland', N'MI', N'26111', N'48670', 43.63503, -84.260453, 1830, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2775, N'Mclaren Macomb', 1, NULL, NULL, N'230227', NULL, NULL, 0, 288, NULL, N'5864938000', N'5864938700', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Harrington Blvd', N'Mount Clemens', N'MI', N'26099', N'48043', 42.586815, -82.897089, 1833, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2776, N'Edward W Sparrow Hospital', 1, NULL, NULL, N'230230', NULL, NULL, 0, 617, NULL, N'5173641000', N'5173646009', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 E Michigan Avenue', N'Lansing', N'MI', N'26065', N'48912', 42.73361, -84.534521, 1819, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2777, N'Metro Health Hospital', 1, NULL, NULL, N'230236', NULL, NULL, 0, 208, NULL, N'6162527200', N'6162520788', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Byron Center Avenue Sw', N'Wyoming', N'MI', N'26081', N'49519', 42.858248, -85.722943, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2778, N'Chippewa County War Memorial Hospital', 1, NULL, NULL, N'230239', NULL, NULL, 0, 82, NULL, N'9066354460', N'9066354467', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Osborn Blvd', N'Sault Sainte Marie', N'MI', N'26033', N'49783', 46.498304, -84.349368, 1853, 145, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2779, N'St John River District Hospital', 1, NULL, NULL, N'230241', NULL, NULL, 0, 68, NULL, N'8103297111', N'8103298920', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 River Rd', N'East China', N'MI', N'26147', N'48054', 42.785866, -82.478023, 1856, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2780, N'Garden City Hospital', 1, NULL, NULL, N'230244', NULL, NULL, 0, 323, NULL, N'7344213300', N'7344213530', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6245 Inkster Rd', N'Garden City', N'MI', N'26163', N'48135', 42.332356, -83.311771, 1796, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2781, N'Crittenton Hospital Medical Center', 1, NULL, NULL, N'230254', NULL, NULL, 0, 290, NULL, N'2486525000', N'2486525424', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 W University Drive', N'Rochester', N'MI', N'26125', N'48307', 42.680882, -83.149228, 1848, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2782, N'St Joseph Mercy Chelsea', 1, NULL, NULL, N'230259', NULL, NULL, 0, 83, NULL, N'7344753911', N'7344754066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 S Main St', N'Chelsea', N'MI', N'26161', N'48118', 42.308469, -84.021141, 1783, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2783, N'Southeast Michigan Surgical Hospital', 1, NULL, NULL, N'230264', NULL, NULL, 0, 20, NULL, N'5864271000', N'5867590237', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21230 Dequindre Road', N'Warren', N'MI', N'26099', N'48091', 42.451563, -83.083566, 1868, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2784, N'Beaumont Hospital Troy', 1, NULL, NULL, N'230269', NULL, NULL, 0, 254, NULL, N'2489648800', N'2489648842', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'44201 Dequindre Road', N'Troy', N'MI', N'26125', N'48085', 42.618044, -83.091161, 1867, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2785, N'Beaumont Hospital - Taylor', 1, NULL, NULL, N'230270', NULL, NULL, 0, 163, NULL, N'3132955253', N'3132955085', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10000 Telegraph Road', N'Taylor', N'MI', N'26163', N'48180', 42.233315, -83.269659, 1862, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2786, N'Detroit Receiving Hospital & Univ Health Center', 1, NULL, NULL, N'230273', NULL, NULL, 0, 320, NULL, N'3137453104', N'3139667206', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 St Antoine St - 3M', N'Detroit', N'MI', N'26163', N'48201', 42.354518, -83.053764, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2787, N'Healthsource Saginaw', 1, NULL, NULL, N'230275', NULL, NULL, 0, 278, NULL, N'9897907888', N'9897909297', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3340 Hospital Road', N'Saginaw', N'MI', N'26145', N'48603', 43.455109, -84.052052, 1850, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2788, N'Huron Valley-Sinai Hospital', 1, NULL, NULL, N'230277', NULL, NULL, 0, 153, NULL, N'2489373370', N'2489373378', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One William Carls Drive', N'Commerce Township', N'MI', N'26125', N'48382', 42.569521, -83.49969, 1831, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2789, N'Brighton Hospital', 1, NULL, NULL, N'230279', NULL, NULL, 0, 63, NULL, N'8102271211', N'8102271869', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12851 Grand River Rd', N'Brighton', N'MI', N'26093', N'48116', 42.517871, -83.68972, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2790, N'Karmanos Cancer Center', 1, NULL, NULL, N'230297', NULL, NULL, 0, 123, NULL, N'8005766266', N'3135768661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 John R', N'Detroit', N'MI', N'26163', N'48201', 42.35151, -83.057974, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2791, N'Oakland Regional Hospital', 1, NULL, NULL, N'230301', NULL, NULL, 0, 45, NULL, N'2484235100', N'2484231467', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22401 Foster Winter Drive', N'Southfield', N'MI', N'26125', N'48075', 42.457572, -83.20269, 1855, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2792, N'Henry Ford West Bloomfield Hospital', 1, NULL, NULL, N'230302', NULL, NULL, 0, 191, NULL, N'2483251000', N'2486616494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6777 West Maple Road', N'West Bloomfield', N'MI', N'26125', N'48322', 42.541451, -83.409433, 1849, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2793, N'West Shore Medical Center', 1, NULL, NULL, N'230303', NULL, NULL, 0, 25, NULL, N'2313981000', N'2313981098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1465 E Parkdale Ave', N'Manistee', N'MI', N'26101', N'49660', 44.272366, -86.273369, 1825, 150, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2794, N'Paul Oliver Memorial Hospital', 1, NULL, NULL, N'231300', NULL, NULL, 0, 8, NULL, N'2313522200', N'2313526141', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 Park Avenue', N'Frankfort', N'MI', N'26019', N'49635', 44.637353, -86.242849, 1794, 150, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2795, N'Kalkaska Memorial Health Center', 1, NULL, NULL, N'231301', NULL, NULL, 0, 8, NULL, N'2312587500', N'2312587527', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'419 S Coral', N'Kalkaska', N'MI', N'26079', N'49646', 44.731754, -85.183091, 1865, 150, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2796, N'Schoolcraft Memorial Hospital', 1, NULL, NULL, N'231303', NULL, NULL, 0, 25, NULL, N'9063413200', N'9063413297', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7870W Us Highway 2', N'Manistique', N'MI', N'26153', N'49854', 45.925502, -86.984862, 1826, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2797, N'Helen Newberry Joy Hospital', 1, NULL, NULL, N'231304', NULL, NULL, 0, 25, NULL, N'9062939200', N'9062939208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Harrie St', N'Newberry', N'MI', N'26095', N'49868', 46.352761, -85.515686, 1837, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2798, N'Saint Mary''s Standish Community Hospital', 1, NULL, NULL, N'231305', NULL, NULL, 0, 25, NULL, N'5178464521', N'9898463549', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 W Cedar St', N'Standish', N'MI', N'26011', N'48658', 43.982807, -83.968936, 1859, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2799, N'Mackinac Straits Hospital And Health Center', 1, NULL, NULL, N'231306', NULL, NULL, 0, 15, NULL, N'9066438585', N'9066430373', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 N State Street', N'Saint Ignace', N'MI', N'26097', N'49781', 45.886683, -84.725898, 1843, 145, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2800, N'Baraga County Memorial Hospital', 1, NULL, NULL, N'231307', NULL, NULL, 0, 24, NULL, N'9065243300', N'9065245466', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18341 Us Highway 41', N'L'' Anse', N'MI', N'26013', N'49946', 43.621196, -84.682435, 1817, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2801, N'Munising Memorial Hospital', 1, NULL, NULL, N'231308', NULL, NULL, 0, 25, NULL, N'9063874110', N'9063874649', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Sand Point Rd', N'Munising', N'MI', N'26003', N'49862', 46.423861, -86.625749, 1835, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2802, N'Aspirus Ontonan Hospital Inc', 1, NULL, NULL, N'231309', NULL, NULL, 0, 25, NULL, N'9068848000', N'9068844384', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 S Seventh St', N'Ontonan', N'MI', N'26131', N'49953', 46.865494, -89.302975, 1840, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2803, N'Scheurer Hospital', 1, NULL, NULL, N'231310', NULL, NULL, 0, 25, NULL, N'9894533223', N'9894534451', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 N Caseville Rd', N'Pigeon', N'MI', N'26063', N'48755', 43.830503, -83.279376, 1844, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2804, N'Deckerville Community Hospital', 1, NULL, NULL, N'231311', NULL, NULL, 0, 15, NULL, N'8103762835', N'8103764978', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3559 Pine St', N'Deckerville', N'MI', N'26151', N'48427', 43.528095, -82.733772, 1788, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2805, N'Sheridan Community Hospital', 1, NULL, NULL, N'231312', NULL, NULL, 0, 25, NULL, N'9892913261', N'9892913062', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 N Main St', N'Sheridan', N'MI', N'26117', N'48884', 43.215416, -85.073531, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2806, N'Harbor Beach Community Hospital', 1, NULL, NULL, N'231313', NULL, NULL, 0, 17, NULL, N'9894793201', N'9894795003', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 S First St', N'Harbor Beach', N'MI', N'26063', N'48441', 43.84271, -82.652546, 1805, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2807, N'Mckenzie Health System', 1, NULL, NULL, N'231314', NULL, NULL, 0, 25, NULL, N'8106483770', N'8106485058', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 N Delaware Street', N'Sandusky', N'MI', N'26151', N'48471', 43.423367, -82.832932, 1852, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2808, N'Borgess-Lee Memorial Hospital', 1, NULL, NULL, N'231315', NULL, NULL, 0, 25, NULL, N'2697828681', N'2697833097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 W High Street', N'Dowagiac', N'MI', N'26027', N'49047', 41.982554, -86.115342, 1790, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2809, N'Hills & Dales General Hospital', 1, NULL, NULL, N'231316', NULL, NULL, 0, 25, NULL, N'9898722121', N'9898725376', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4675 Hill Street', N'Cass City', N'MI', N'26157', N'48726', 43.602044, -83.180623, 1779, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2810, N'Spectrum Health Kelsey Hospital', 1, NULL, NULL, N'231317', NULL, NULL, 0, 25, NULL, N'9893527211', N'9893526435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'418 Washington', N'Lakeview', N'MI', N'26117', N'48850', 43.4412, -85.278692, 1818, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2811, N'Aspirus Iron River Hospital & Clinics Inc', 1, NULL, NULL, N'231318', NULL, NULL, 0, 25, NULL, N'9062656121', N'9062650741', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 W Ice Lake Road', N'Iron River', N'MI', N'26071', N'49935', 46.098125, -88.619122, 1812, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2812, N'Aspirus Keweenaw Hospital', 1, NULL, NULL, N'231319', NULL, NULL, 0, 25, NULL, N'9063376500', N'9063376540', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Osceola', N'Laurium', N'MI', N'26061', N'49913', 47.239012, -88.442848, 1821, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2813, N'Mercy Health Lakeshore Campus', 1, NULL, NULL, N'231320', NULL, NULL, 0, 24, NULL, N'2318612156', N'2318613028', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'72 South State Street', N'Shelby', N'MI', N'26127', N'49455', 43.607521, -86.364758, 1836, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2814, N'Bell Hospital', 1, NULL, NULL, N'231321', NULL, NULL, 0, 25, NULL, N'9064864431', N'9064866898', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Lakeshore Drive', N'Ishpeming', N'MI', N'26103', N'49849', 46.498665, -87.682993, 1814, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2815, N'Charlevoix Area Hospital', 1, NULL, NULL, N'231322', NULL, NULL, 0, 25, NULL, N'2315474024', N'2315478080', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14700 Lakeshore Drive', N'Charlevoix', N'MI', N'26029', N'49720', 45.314844, -85.273653, 1780, 145, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2816, N'Spectrum Health Reed City Hospital', 1, NULL, NULL, N'231323', NULL, NULL, 0, 25, NULL, N'2318323271', N'2318321817', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 N Patterson Po Box 75', N'Reed City', N'MI', N'26133', N'49677', 43.875017, -85.51005, 1847, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2817, N'Eaton Rapids Medical Center', 1, NULL, NULL, N'231324', NULL, NULL, 0, 25, NULL, N'5176632671', N'5176632472', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Main Street', N'Eaton Rapids', N'MI', N'26045', N'48827', 42.496021, -84.657539, 1819, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2818, N'Midmichigan Medical Center-Gladwin', 1, NULL, NULL, N'231325', NULL, NULL, 0, 25, NULL, N'9894269286', N'9892466400', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Quarter Street', N'Gladwin', N'MI', N'26051', N'48624', 43.975786, -84.495355, 1798, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2819, N'Sparrow Clinton Hospital', 1, NULL, NULL, N'231326', NULL, NULL, 0, 25, NULL, N'9892246881', N'9892248744', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 S Oakland', N'Saint Johns', N'MI', N'26037', N'48879', 42.99406, -84.555793, 1857, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2820, N'Hayes Green Beach Memorial Hospital', 1, NULL, NULL, N'231327', NULL, NULL, 0, 25, NULL, N'5175431050', N'5175410875', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 E Harris Street', N'Charlotte', N'MI', N'26045', N'48813', 42.564927, -84.831824, 1781, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2821, N'Allegan General Hospital', 1, NULL, NULL, N'231328', NULL, NULL, 0, 25, NULL, N'2696864101', N'2696738179', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Linn Street', N'Allegan', N'MI', N'26005', N'49010', 42.52151, -85.856515, 1767, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2822, N'Caro Community Hospital', 1, NULL, NULL, N'231329', NULL, NULL, 0, 25, NULL, N'9896733141', N'9896738471', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 N Hooper Street', N'Caro', N'MI', N'26157', N'48723', 43.49315, -83.407121, 1777, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2823, N'Marlette Regional Hospital', 1, NULL, NULL, N'231330', NULL, NULL, 0, 25, NULL, N'9896354000', N'9896355358', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2770 Main Street', N'Marlette', N'MI', N'26151', N'48453', 43.333886, -83.080688, 1827, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2824, N'Sparrow Ionia Hospital', 1, NULL, NULL, N'231331', NULL, NULL, 0, 25, NULL, N'6165274200', N'6165275731', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3565 S State Road', N'Ionia', N'MI', N'26067', N'48846', 42.934881, -85.074781, 1810, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2825, N'Bronson Lakeview Hospital', 1, NULL, NULL, N'231332', NULL, NULL, 0, 25, NULL, N'2696571400', N'2696572278', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Hazen Street', N'Paw Paw', N'MI', N'26159', N'49079', 42.221651, -85.897994, 1842, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2826, N'Aspirus Grand View Hospital', 1, NULL, NULL, N'231333', NULL, NULL, 0, 25, NULL, N'9069322525', N'9069322290', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'N10561 Grand View Lane', N'Ironwood', N'MI', N'26053', N'49938', 46.481186, -90.104439, 1813, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2827, N'Promedica Herrick Hospital', 1, NULL, NULL, N'231334', NULL, NULL, 0, 25, NULL, N'5174243000', N'5174243916', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 E Pottawatamie Street', N'Tecumseh', N'MI', N'26091', N'49286', 42.002879, -83.938425, 1863, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2828, N'St Francis Hospital', 1, NULL, NULL, N'231337', NULL, NULL, 0, 25, NULL, N'9067863311', N'9067864004', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 Ludington St', N'Escanaba', N'MI', N'26041', N'49829', 45.745754, -87.097825, 1791, 143, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2829, N'Spectrum Health Gerber Memorial', 1, NULL, NULL, N'231338', NULL, NULL, 0, 61, NULL, N'2319243300', N'2319241320', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 S Sullivan St', N'Fremont', N'MI', N'26123', N'49412', 43.464092, -85.950756, 1795, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2830, N'Select Specialty Hospital-Flint', 1, NULL, NULL, N'232012', NULL, NULL, 0, 36, NULL, N'8103424550', N'8103424517', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 S Ballenger 5Th Floor', N'Flint', N'MI', N'26049', N'48532', 43.017177, -83.723602, 1793, 139, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2831, N'Vibra Of Southeastern Michigan', 1, NULL, NULL, N'232019', NULL, NULL, 0, 220, NULL, N'3135946000', N'3135946252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26400 W Outer Drive', N'Lincoln Park', N'MI', N'26163', N'48146', 42.261974, -83.167005, 1872, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2832, N'Mclaren Bay Special Care', 1, NULL, NULL, N'232020', NULL, NULL, 0, 31, NULL, N'9896676802', N'9896676809', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3250 E Midland Rd Suite 1', N'Bay City', N'MI', N'26017', N'48706', 43.602103, -83.923911, 1773, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2833, N'Select Specialty Hospital - Musken', 1, NULL, NULL, N'232021', NULL, NULL, 0, 31, NULL, N'2317285800', N'2317285820', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Clinton Street 2 South And 3 South Floors', N'Musken', N'MI', N'26121', N'49442', 43.222403, -86.242192, 1836, 144, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2834, N'Select Specialty Hospital-Macomb County', 1, NULL, NULL, N'232023', NULL, NULL, 0, 36, NULL, N'5863079000', N'5863079001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 North Ave Suite 200', N'Mount Clemens', N'MI', N'26099', N'48043', 42.60672, -82.882038, 1833, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2835, N'Select Specialty Hospital-Ann Arbor', 1, NULL, NULL, N'232024', NULL, NULL, 0, 36, NULL, N'7347120500', N'7347120505', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5301 E Huron River Dr 7Th Fl', N'Ypsilanti', N'MI', N'26161', N'48197', 42.24115, -83.612994, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2836, N'Select Specialty Hospital - Grand Rapids', 1, NULL, NULL, N'232026', NULL, NULL, 0, 20, NULL, N'2316726202', N'2316726358', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Se Jefferson 5Th Floor', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2837, N'Kindred Hospital Detroit', 1, NULL, NULL, N'232027', NULL, NULL, 0, 77, NULL, N'3133695800', N'3133695876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4777 E Outer Drive', N'Detroit', N'MI', N'26163', N'48234', 42.442138, -83.019793, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2838, N'Spectrum Health Kent Community Campus', 1, NULL, NULL, N'232029', NULL, NULL, 0, 146, NULL, N'6164862453', N'6164862555', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Fuller Ave Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2839, N'Select Specialty Hospital-Pontiac', 1, NULL, NULL, N'232030', NULL, NULL, 0, 30, NULL, N'2484525200', N'2484525201', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44405 Woodward Avenue 8Th Floor', N'Pontiac', N'MI', N'26125', N'48341', 42.615381, -83.276976, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2840, N'Select Specialty Hospital-Wyandotte Llc', 1, NULL, NULL, N'232031', NULL, NULL, 0, 40, NULL, N'3133757075', N'3133757120', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Biddle Avenue 8Th Floor', N'Wyandotte', N'MI', N'26163', N'48192', 42.2104145, -83.1504528, 1872, 137, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2841, N'Select Specialty Hospital-Northwest Detroit', 1, NULL, NULL, N'232032', NULL, NULL, 0, 36, NULL, N'3139663939', N'3139666137', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6071 West Outer Drive 7Th Floor', N'Detroit', N'MI', N'26163', N'48235', 42.418894, -83.182376, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2842, N'Select Specialty Hospital-Saginaw', 1, NULL, NULL, N'232033', NULL, NULL, 0, 32, NULL, N'9895834667', N'9895834895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1447 North Harrison 7Th & 8Th Floor', N'Saginaw', N'MI', N'26145', N'48602', 43.420039, -83.949036, 1850, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2843, N'Borgess Pipp Hospital', 1, NULL, NULL, N'232034', NULL, NULL, 0, 43, NULL, N'2696850700', N'2696850800', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Naomi Street', N'Plainwell', N'MI', N'26005', N'49080', 42.446954, -85.653941, 1816, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2844, N'Select Specialty Hospital- Battle Creek', 1, NULL, NULL, N'232035', NULL, NULL, 0, 25, NULL, N'2692454675', N'2692454676', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Avenue 6Th Floor', N'Battle Creek', N'MI', N'26025', N'49016', 42.319255, -85.182427, 1772, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2845, N'Carelink Of Jackson A Community-Owned Specialty H', 1, NULL, NULL, N'232036', NULL, NULL, 0, 64, NULL, N'5177964426', N'5177872480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 N Elm Avenue', N'Jackson', N'MI', N'26075', N'49202', 42.252049, -84.3876363, 1815, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2846, N'Sparrow Specialty Hospital', 1, NULL, NULL, N'232037', NULL, NULL, 0, 36, NULL, N'5173646800', N'5173646874', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1215 E Michigan Ave 8W Sparrow Hospital Tower', N'Lansing', N'MI', N'26065', N'48912', 42.73416, -84.535278, 1819, 142, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2847, N'Select Specialty Hospital-Grosse Pointe', 1, NULL, NULL, N'232038', NULL, NULL, 0, 30, NULL, N'3136402220', N'3136402269', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'468 Cadieux Rd 3 Northeast', N'Grosse Pointe', N'MI', N'26163', N'48230', 42.386149, -82.911859, 1803, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2848, N'Pioneer Specialty Hospital', 1, NULL, NULL, N'232039', NULL, NULL, 0, 30, NULL, N'2485931990', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Perry', N'Pontiac', N'MI', N'26125', N'48342', 42.638922, -83.291047, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2849, N'Mary Free Bed Hospital & Rehabilitation Center', 1, NULL, NULL, N'233026', NULL, NULL, 0, 80, NULL, N'6162420300', N'6164543939', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 Wealthy Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2850, N'Rehabilitation Institute Of Michigan', 1, NULL, NULL, N'233027', NULL, NULL, 0, 94, NULL, N'3137459710', N'3137452376', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'261 Mack Blvd', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2851, N'Children''s Hospital Of Michigan', 1, NULL, NULL, N'233300', NULL, NULL, 0, 228, NULL, N'3137455437', N'3139930389', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Beaubien', N'Detroit', N'MI', N'26163', N'48201', 42.351816, -83.05375, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2852, N'Pine Rest Christian Mental Health Services', 1, NULL, NULL, N'234006', NULL, NULL, 0, 118, NULL, N'6164555000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 - 68Th Street Se', N'Grand Rapids', N'MI', N'26081', N'49548', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2853, N'Henry Ford Kingswood Hospital', 1, NULL, NULL, N'234011', NULL, NULL, 0, 100, NULL, N'2486914868', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 W Eight Mile Road', N'Ferndale', N'MI', N'26125', N'48220', 42.460592, -83.134648, 1849, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2854, N'Harbor Oaks Hospital', 1, NULL, NULL, N'234021', NULL, NULL, 0, 64, NULL, N'5867255777', N'5867252080', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35031 23 Mile Rd', N'New Baltimore', N'MI', N'26099', N'48047', 42.676069, -82.75636, 1833, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2855, N'Havenwyck Hospital', 1, NULL, NULL, N'234023', NULL, NULL, 0, 120, NULL, N'2483739200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1525 University Drive', N'Auburn Hills', N'MI', N'26125', N'48326', 42.661456, -83.249504, 1845, 146, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2856, N'Caro Center', 1, NULL, NULL, N'234025', NULL, NULL, 0, 208, NULL, N'9896733191', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Chambers Box A', N'Caro', N'MI', N'26157', N'48723', 43.491132, -83.396897, 1777, 148, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2857, N'Kalamazoo Regional Psychiatric Hospital', 1, NULL, NULL, N'234026', NULL, NULL, 0, 210, NULL, N'2693373309', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1312 Oakland Dr', N'Kalamazoo', N'MI', N'26077', N'49008', 42.279033, -85.605191, 1816, 141, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2858, N'Forest View Psychiatric Hospital', 1, NULL, NULL, N'234030', NULL, NULL, 0, 62, NULL, N'6169429610', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1055 Medical Park Se', N'Grand Rapids', N'MI', N'26081', N'49546', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2859, N'Walter P Reuther Psychiatric Hospital', 1, NULL, NULL, N'234035', NULL, NULL, 0, 239, NULL, N'7343678400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30901 Palmer Rd', N'Westland', N'MI', N'26163', N'48185', 42.296559, -83.34556, 1870, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2860, N'Bca Stonecrest Center', 1, NULL, NULL, N'234038', NULL, NULL, 0, 90, NULL, N'3132450600', N'3133728657', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15000 Gratiot Avenue', N'Detroit', N'MI', N'26163', N'48205', 42.443777, -82.971839, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2861, N'Samaritan Behavioral Center', 1, NULL, NULL, N'234040', NULL, NULL, 0, 55, NULL, N'3133447730', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5555 Conner Avenue Suite 3N', N'Detroit', N'MI', N'26163', N'48213', 42.390314, -82.981995, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2862, N'The Center For Forensic Psychiatry', 1, NULL, NULL, N'234041', NULL, NULL, 0, 210, NULL, N'7344292531', N'7342954512', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8303 Platt Road', N'Saline', N'MI', N'26161', N'48176', 42.166707, -83.781607, 1851, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2863, N'The Behavioral Center Of Michigan', 1, NULL, NULL, N'234042', NULL, NULL, 0, 42, NULL, N'5862612266', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 E 12 Mile Road', N'Warren', N'MI', N'26099', N'48092', 42.505616, -83.067002, 1868, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2864, N'Henry Ford Hospital', 1, NULL, NULL, N'239801', NULL, NULL, 0, 0, NULL, N'3139168058', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2799 W Grand Blvd', N'Detroit', N'MI', N'26163', N'48202', 42.36708, -83.081557, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2865, N'Childrens Of Mi Transplant', 1, NULL, NULL, N'239802', NULL, NULL, 0, 0, NULL, N'3137451401', N'3139930531', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3901 Beaubien Blvd', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2866, N'University Of Michigan Medical Center', 1, NULL, NULL, N'239803', NULL, NULL, 0, 0, NULL, N'7347644141', N'7346473417', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1500 E Medical Ctr Dr 3868 Taubman Center Spc', N'Ann Arbor', N'MI', N'26161', N'48109', 42.284779, -83.729416, 1770, 136, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2867, N'St John Hospital - Transplant', 1, NULL, NULL, N'239804', NULL, NULL, 0, 0, NULL, N'3133433134', N'3133437349', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'22101 Moross', N'Detroit', N'MI', N'26163', N'48236', 42.419472, -82.913222, 1803, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2868, N'Harper University Hospital', 1, NULL, NULL, N'239805', NULL, NULL, 0, 0, NULL, N'3137456211', N'3137451520', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3990 John R', N'Detroit', N'MI', N'26163', N'48201', 42.348664, -83.056737, 1789, 138, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2869, N'Beaumont Health System', 1, NULL, NULL, N'239806', NULL, NULL, 0, 0, NULL, N'2485511033', N'2485512125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3601 W 13 Mile Rd', N'Royal Oak', N'MI', N'26125', N'48073', 42.514255, -83.192906, 1849, 147, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2870, N'Devos Childrens Hospital - Transplant Unit', 1, NULL, NULL, N'239807', NULL, NULL, 0, 0, NULL, N'6163919000', N'6163913105', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Michigan Street Ne', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2871, N'Saint Mary''s Health Care', 1, NULL, NULL, N'239808', NULL, NULL, 0, 0, NULL, N'6167526889', N'6167327989', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Jefferson St Se', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2872, N'Spectrum Health Adult Solid Organ Transplant Progr', 1, NULL, NULL, N'239809', NULL, NULL, 0, 0, NULL, N'6163910800', N'6163910801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Michigan St Ne Mc231', N'Grand Rapids', N'MI', N'26081', N'49503', 42.96336, -85.668086, 1800, 140, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2873, N'North Memorial Medical Center', 1, NULL, NULL, N'240001', NULL, NULL, 0, 518, NULL, N'7635205200', N'7635205006', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Oakdale North', N'Robbinsdale', N'MN', N'27053', N'55422', 45.014214, -93.321172, 1960, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2874, N'Essentia Health St Mary''s Medical Center', 1, NULL, NULL, N'240002', NULL, NULL, 0, 380, NULL, N'2187864000', N'2187864888', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 East Third Street', N'Duluth', N'MN', N'27137', N'55805', 46.793635, -92.095431, 1903, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2875, N'Hennepin County Medical Center 1', 1, NULL, NULL, N'240004', NULL, NULL, 0, 894, NULL, N'6128732338', N'6129044271', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Park Avenue', N'Minneapolis', N'MN', N'27053', N'55415', 44.97285, -93.262707, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2876, N'Olmsted Medical Center', 1, NULL, NULL, N'240006', NULL, NULL, 0, 61, NULL, N'5072872761', N'5072872779', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 Fourth Street Southeast', N'Rochester', N'MN', N'27109', N'55904', 44.021006, -92.439806, 1961, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2877, N'Mayo Clinic Hospital Rochester', 1, NULL, NULL, N'240010', NULL, NULL, 0, 2059, NULL, N'5072555123', N'5072556306', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1216 Second Street Southwest', N'Rochester', N'MN', N'27109', N'55902', 44.021643, -92.481355, 1961, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2878, N'Northfield Hospital', 1, NULL, NULL, N'240014', NULL, NULL, 0, 37, NULL, N'5076461001', N'5076461392', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 North Avenue', N'Northfield', N'MN', N'27037', N'55057', 44.471386, -93.191166, 1948, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2879, N'Mayo Clinic Health System In Red Wing', 1, NULL, NULL, N'240018', NULL, NULL, 0, 57, NULL, N'6512675000', N'6512675935', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Hewitt Boulevard Po Box 95', N'Red Wing', N'MN', N'27049', N'55066', 44.560274, -92.575197, 1958, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2880, N'Essentia Health Duluth', 1, NULL, NULL, N'240019', NULL, NULL, 0, 165, NULL, N'2187862646', N'2187865922', 1, 0, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 East Second Street', N'Duluth', N'MN', N'27137', N'55805', 46.792523, -92.094863, 1903, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2881, N'Cambridge Medical Center', 1, NULL, NULL, N'240020', NULL, NULL, 0, 75, NULL, N'7636897700', N'7636887941', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 South Dellwood Avenue', N'Cambridge', N'MN', N'27059', N'55008', 45.56657, -93.229319, 1892, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2882, N'Sanford Worthington Medical Center', 1, NULL, NULL, N'240022', NULL, NULL, 0, 48, NULL, N'5073723380', N'5073723240', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1018 Sixth Avenue Po Box 997', N'Worthington', N'MN', N'27105', N'56187', 43.621858, -95.59918, 1993, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2883, N'Douglas County Hospital', 1, NULL, NULL, N'240030', NULL, NULL, 0, 127, NULL, N'3207621511', N'3207626120', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 17Th Avenue East', N'Alexandria', N'MN', N'27041', N'56308', 45.872683, -95.37544, 1877, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2884, N'St Cloud Hospital', 1, NULL, NULL, N'240036', NULL, NULL, 0, 489, NULL, N'3202512700', N'3206567099', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1406 6Th Ave North', N'Saint Cloud', N'MN', N'27145', N'56303', 45.574304, -94.17, 1970, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2885, N'United Hospital', 1, NULL, NULL, N'240038', NULL, NULL, 0, 546, NULL, N'6512418802', N'6512415189', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Smith Avenue', N'Saint Paul', N'MN', N'27123', N'55102', 44.942157, -93.107925, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2886, N'University Medical Center-Mesabi/ Mesaba Clinics', 1, NULL, NULL, N'240040', NULL, NULL, 0, 175, NULL, N'2183626659', N'2183626619', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 East 34Th St', N'Hibbing', N'MN', N'27137', N'55746', 47.411202, -92.931762, 1921, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2887, N'Mayo Clinic Health System - Albert Lea', 1, NULL, NULL, N'240043', NULL, NULL, 0, 89, NULL, N'5073732384', N'5073776383', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'404 West Fountain Street', N'Albert Lea', N'MN', N'27047', N'56007', 43.651567, -93.372616, 1876, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2888, N'Winona Health Services', 1, NULL, NULL, N'240044', NULL, NULL, 0, 99, NULL, N'5074543650', N'5074574159', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 Mankato Avenue', N'Winona', N'MN', N'27169', N'55987', 44.033016, -91.622136, 1992, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2889, N'St Lukes Hospital', 1, NULL, NULL, N'240047', NULL, NULL, 0, 267, NULL, N'2182495555', N'2187332472', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 East 1St Street', N'Duluth', N'MN', N'27137', N'55805', 46.796675, -92.08748, 1903, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2890, N'Fairview Lakes Medical Center', 1, NULL, NULL, N'240050', NULL, NULL, 0, 61, NULL, N'6519827104', N'6519827110', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Fairview Boulevard', N'Wyoming', N'MN', N'27025', N'55092', 45.322842, -92.999791, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2891, N'Lake Region Healthcare Corporation', 1, NULL, NULL, N'240052', NULL, NULL, 0, 100, NULL, N'2187368000', N'2187368765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'712 South Cascade', N'Fergus Falls', N'MN', N'27111', N'56537', 46.277149, -96.072402, 1909, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2892, N'Park Nicollet Methodist Hospital', 1, NULL, NULL, N'240053', NULL, NULL, 0, 426, NULL, N'9529935000', N'9529935936', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Excelsior Blvd', N'Saint Louis Park', N'MN', N'27053', N'55426', 44.927087, -93.363512, 1972, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2893, N'Ridgeview Medical Center', 1, NULL, NULL, N'240056', NULL, NULL, 0, 109, NULL, N'9524422191', N'9524426543', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'500 South Maple Street', N'Waconia', N'MN', N'27019', N'55387', 44.843306, -93.790772, 1984, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2894, N'Abbott Northwestern Hospital', 1, NULL, NULL, N'240057', NULL, NULL, 0, 996, NULL, N'6128634509', N'6128635667', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East 28Th Street', N'Minneapolis', N'MN', N'27053', N'55407', 44.951948, -93.262646, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2895, N'Regina Hospital', 1, NULL, NULL, N'240059', NULL, NULL, 0, 57, NULL, N'6514804100', N'6514041460', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Nininger Road', N'Hastings', N'MN', N'27037', N'55033', 44.748037, -92.873145, 1919, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2896, N'St Joseph''s Hospital', 1, NULL, NULL, N'240063', NULL, NULL, 0, 401, NULL, N'6512327707', N'6512323518', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 West 10Th Street', N'Saint Paul', N'MN', N'27123', N'55102', 44.948774, -93.100808, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2897, N'Grand Itasca Clinic And Hospital', 1, NULL, NULL, N'240064', NULL, NULL, 0, 64, NULL, N'2183263401', N'2183267743', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 lf Course Road', N'Grand Rapids', N'MN', N'27061', N'55744', 47.221039, -93.554716, 1916, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2898, N'Lakeview Memorial Hospital', 1, NULL, NULL, N'240066', NULL, NULL, 0, 97, NULL, N'6514305330', N'6514304512', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'927 West Churchill Street', N'Stillwater', N'MN', N'27163', N'55082', 45.048124, -92.818271, 1977, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2899, N'Owatonna Hospital', 1, NULL, NULL, N'240069', NULL, NULL, 0, 77, NULL, N'5079772337', N'5079772335', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2250 26Th Street Northwest', N'Owatonna', N'MN', N'27147', N'55060', 44.109718, -93.251245, 1952, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2900, N'District One Hospital', 1, NULL, NULL, N'240071', NULL, NULL, 0, 99, NULL, N'5073346451', N'5073324848', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 State Avenue', N'Faribault', N'MN', N'27131', N'55021', 44.288423, -93.256021, 1907, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2901, N'Essentia Health St Joseph''s Medical Center', 1, NULL, NULL, N'240075', NULL, NULL, 0, 162, NULL, N'2188292861', N'2188283103', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'523 North 3Rd Street', N'Brainerd', N'MN', N'27035', N'56401', 46.361701, -94.205146, 1888, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2902, N'Buffalo Hospital', 1, NULL, NULL, N'240076', NULL, NULL, 0, 65, NULL, N'7636841212', N'7636847910', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Catlin St', N'Buffalo', N'MN', N'27171', N'55313', 45.193199, -93.871025, 1890, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2903, N'Fairview Southdale Hospital', 1, NULL, NULL, N'240078', NULL, NULL, 0, 390, NULL, N'9529245000', N'9529245382', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 France Avenue South', N'Edina', N'MN', N'27053', N'55435', 44.886279, -93.328857, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2904, N'University Of Minnesota  Medical Center Fairview', 1, NULL, NULL, N'240080', NULL, NULL, 0, 1700, NULL, N'6122733000', N'6122734098', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 Riverside Avenue', N'Minneapolis', N'MN', N'27053', N'55454', 44.965702, -93.236632, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2905, N'Essentia Health Virginia', 1, NULL, NULL, N'240084', NULL, NULL, 0, 83, NULL, N'2187413340', N'2187499427', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 9Th Street North', N'Virginia', N'MN', N'27137', N'55792', 47.530585, -92.554823, 1982, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2906, N'Rice Memorial Hospital', 1, NULL, NULL, N'240088', NULL, NULL, 0, 136, NULL, N'3202314227', N'3202314869', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Becker Ave Sw', N'Willmar', N'MN', N'27067', N'56201', 45.120535, -95.04619, 1990, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2907, N'Mayo Clinic Health System - Mankato', 1, NULL, NULL, N'240093', NULL, NULL, 0, 272, NULL, N'5076254031', N'5073852908', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Marsh Street', N'Mankato', N'MN', N'27013', N'56001', 44.16505, -93.983708, 1936, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2908, N'Sanford Bemidji Medical Center', 1, NULL, NULL, N'240100', NULL, NULL, 0, 118, NULL, N'2187515430', N'2187595880', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Anne St Nw', N'Bemidji', N'MN', N'27007', N'56601', 47.505011, -94.898428, 1884, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2909, N'Essentia Health St Marys - Detroit Lakes', 1, NULL, NULL, N'240101', NULL, NULL, 0, 87, NULL, N'2188470888', N'2188477674', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 Washington Ave', N'Detroit Lakes', N'MN', N'27005', N'56501', 46.815678, -95.845435, 1902, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2910, N'St Francis Regional Medical Center', 1, NULL, NULL, N'240104', NULL, NULL, 0, 93, NULL, N'9524033000', N'9524033820', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1455 St Francis Avenue', N'Shakopee', N'MN', N'27139', N'55379', 44.770073, -93.504151, 1966, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2911, N'Regions Hospital', 1, NULL, NULL, N'240106', NULL, NULL, 0, 480, NULL, N'6512543456', N'6512542194', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Jackson Street', N'Saint Paul', N'MN', N'27123', N'55101', 44.954193, -93.09516, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2912, N'Mercy Hospital', 1, NULL, NULL, N'240115', NULL, NULL, 0, 298, NULL, N'7632368205', N'7632368124', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 Coon Rapids Blvd', N'Coon Rapids', N'MN', N'27003', N'55433', 45.183842, -93.368221, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2913, N'Unity Hospital', 1, NULL, NULL, N'240132', NULL, NULL, 0, 275, NULL, N'7632365000', N'7632363774', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Osborne Road', N'Fridley', N'MN', N'27003', N'55432', 45.107851, -93.257123, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2914, N'Fairview Northland Regional Hospital', 1, NULL, NULL, N'240141', NULL, NULL, 0, 54, NULL, N'7633891313', N'7633896306', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Northland Dr', N'Princeton', N'MN', N'27141', N'55371', 45.558907, -93.58897, 1957, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2915, N'Mayo Clinic Health System - Fairmont', 1, NULL, NULL, N'240166', NULL, NULL, 0, 57, NULL, N'5072388101', N'5072388686', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Medical Center Drive Po Box 800', N'Fairmont', N'MN', N'27091', N'56031', 43.640065, -94.450685, 1906, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2916, N'Hutchinson Health', 1, NULL, NULL, N'240187', NULL, NULL, 0, 66, NULL, N'3202345000', N'3204844688', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1095 Highway 15 South', N'Hutchinson', N'MN', N'27085', N'55350', 44.875105, -94.375533, 1922, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2917, N'Phillips Eye Institute', 1, NULL, NULL, N'240196', NULL, NULL, 0, 20, NULL, N'6127758815', N'6127769601', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Park Avenue South', N'Minneapolis', N'MN', N'27053', N'55404', 44.960524, -93.265105, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2918, N'Red Lake Hospital A', 1, NULL, NULL, N'240206', NULL, NULL, 0, 23, NULL, N'2186793912', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 497', N'Redlake', N'MN', N'27007', N'56671', 45.989659, -94.611329, 1994, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2919, N'Fairview Ridges Hospital', 1, NULL, NULL, N'240207', NULL, NULL, 0, 150, NULL, N'9528922000', N'9528922107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 East Nicollet Boulevard', N'Burnsville', N'MN', N'27037', N'55337', 44.750104, -93.272966, 1891, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2920, N'Healtheast St John''s Hospital', 1, NULL, NULL, N'240210', NULL, NULL, 0, 184, NULL, N'6512327000', N'6512327240', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1575 Beam Avenue', N'Maplewood', N'MN', N'27123', N'55109', 45.028131, -93.033544, 1937, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2921, N'Healtheast Woodwinds Hospital', 1, NULL, NULL, N'240213', NULL, NULL, 0, 86, NULL, N'6512322185', N'6512326888', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1925 Woodwinds Drive', N'Woodbury', N'MN', N'27163', N'55125', 44.921913, -92.979797, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2922, N'Maple Grove Hospital', 1, NULL, NULL, N'240214', NULL, NULL, 0, 90, NULL, N'7635811000', N'7635811555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9875 Hospital Drive', N'Maple Grove', N'MN', N'27053', N'55369', 45.133424, -93.479513, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2923, N'Mahnomen Health Center', 1, NULL, NULL, N'241300', NULL, NULL, 0, 18, NULL, N'2189352511', N'2189352370', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'414 W Jefferson Po Box 396', N'Mahnomen', N'MN', N'27087', N'56557', 47.315239, -95.968654, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2924, N'Lakewood Health Center', 1, NULL, NULL, N'241301', NULL, NULL, 0, 15, NULL, N'2186342120', N'2186341094', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Main Ave S', N'Baudette', N'MN', N'27077', N'56623', 48.706706, -94.5996, 1883, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2925, N'Sanford Westbrook Medical Center', 1, NULL, NULL, N'241302', NULL, NULL, 0, 8, NULL, N'5072746121', N'5072745671', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Bell Avenue Po Box 188', N'Westbrook', N'MN', N'27033', N'56183', 44.045285, -95.438891, 1988, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2926, N'Sanford Tracy', 1, NULL, NULL, N'241303', NULL, NULL, 0, 25, NULL, N'5076293200', N'5076293202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 Fifth Street East', N'Tracy', N'MN', N'27083', N'56175', 44.232244, -95.606675, 1979, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2927, N'Sanford Medical Center Wheaton', 1, NULL, NULL, N'241304', NULL, NULL, 0, 25, NULL, N'3205638226', N'3205638012', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 12Th Street North', N'Wheaton', N'MN', N'27155', N'56296', 45.808052, -96.500514, 1989, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2928, N'Riverwood Healthcare Center', 1, NULL, NULL, N'241305', NULL, NULL, 0, 31, NULL, N'2189275501', N'2189275575', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Bunker Hill Drive', N'Aitkin', N'MN', N'27001', N'56431', 46.528735, -93.696835, 1875, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2929, N'Renville County Hospital And Clinics', 1, NULL, NULL, N'241306', NULL, NULL, 0, 16, NULL, N'3205231261', N'3205233458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Healthy Way', N'Olivia', N'MN', N'27129', N'56277', 44.774284, -94.983078, 1949, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2930, N'Lake View Memorial Hospital', 1, NULL, NULL, N'241308', NULL, NULL, 0, 25, NULL, N'2188347300', N'2188347388', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 Eleventh Ave', N'Two Harbors', N'MN', N'27075', N'55616', 47.029671, -91.666841, 1980, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2931, N'Essentia Health Sandstone', 1, NULL, NULL, N'241309', NULL, NULL, 0, 35, NULL, N'3202452212', N'3202455243', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'109 Court Ave South', N'Sandstone', N'MN', N'27115', N'55072', 46.127486, -92.866154, 1964, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2932, N'Ridgeview Sibley Medical Center', 1, NULL, NULL, N'241311', NULL, NULL, 0, 20, NULL, N'5079642271', N'5079648490', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 West Chandler', N'Arlington', N'MN', N'27143', N'55307', 44.609782, -94.084631, 1879, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2933, N'Cook Hospital', 1, NULL, NULL, N'241312', NULL, NULL, 0, 14, NULL, N'2186665945', N'2186666238', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Se Fifth St', N'Cook', N'MN', N'27137', N'55723', 47.852964, -92.679997, 1897, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2934, N'Essentia Health Ada', 1, NULL, NULL, N'241313', NULL, NULL, 0, 14, NULL, N'2187845000', N'2187843855', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 9Th Street West', N'Ada', N'MN', N'27107', N'56510', 47.296091, -96.53019, 1874, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2935, N'Johnson Memorial Hospital', 1, NULL, NULL, N'241314', NULL, NULL, 0, 24, NULL, N'3207694323', N'3207692972', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1282 Walnut Street', N'Dawson', N'MN', N'27073', N'56232', 44.930971, -96.06698, 1900, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2936, N'Sanford Jackson Medical Center', 1, NULL, NULL, N'241315', NULL, NULL, 0, 20, NULL, N'5078472420', N'5078473728', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 North Highway', N'Jackson', N'MN', N'27063', N'56143', 43.623748, -95.003274, 1925, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2937, N'Bigfork Valley Hospital', 1, NULL, NULL, N'241316', NULL, NULL, 0, 20, NULL, N'2187433177', N'2187433559', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'258 Pine Tree Drive Po Box 258', N'Bigfork', N'MN', N'27061', N'56628', 47.746879, -93.646237, 1886, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2938, N'Cook County Northshore Hospital', 1, NULL, NULL, N'241317', NULL, NULL, 0, 16, NULL, N'2183873040', N'2183873270', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 5Th Ave West', N'Grand Marais', N'MN', N'27031', N'55604', 47.756744, -90.340179, 1915, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2939, N'Ely Bloomenson Community Hospital', 1, NULL, NULL, N'241318', NULL, NULL, 0, 28, NULL, N'2183653271', N'2183658777', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'328 West Conan Street', N'Ely', N'MN', N'27137', N'55731', 47.9006, -91.872323, 1905, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2940, N'Murray County Memorial Hospital', 1, NULL, NULL, N'241319', NULL, NULL, 0, 25, NULL, N'5078361277', N'5078366700', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2042 Juniper Avenue', N'Slayton', N'MN', N'27101', N'56172', 43.992794, -95.759226, 1967, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2941, N'Riverview Hospital', 1, NULL, NULL, N'241320', NULL, NULL, 0, 49, NULL, N'2182819200', N'2182819222', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South Minnesota', N'Crookston', N'MN', N'27119', N'56716', 47.774491, -96.618061, 1898, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2942, N'Essentia Health Holy Trinity Hospital', 1, NULL, NULL, N'241321', NULL, NULL, 0, 15, NULL, N'3207488200', N'3207487240', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115  Second Street West Box 157', N'Graceville', N'MN', N'27011', N'56240', 45.562376, -96.433455, 1914, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2943, N'Rainy Lake Medical Center', 1, NULL, NULL, N'241322', NULL, NULL, 0, 25, NULL, N'2182835400', N'2182832281', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Highway 71', N'International Falls', N'MN', N'27071', N'56649', 48.594021, -93.4307, 1923, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2944, N'Madelia Community Hospital', 1, NULL, NULL, N'241323', NULL, NULL, 0, 25, NULL, N'5076423255', N'5076428516', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 Drew Avenue Southeast', N'Madelia', N'MN', N'27165', N'56062', 44.04955, -94.409365, 1934, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2945, N'Chippewa County Hospital', 1, NULL, NULL, N'241325', NULL, NULL, 0, 30, NULL, N'3203218100', N'3202698186', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'824 North 11Th Street', N'Montevideo', N'MN', N'27023', N'56265', 44.952379, -95.713565, 1941, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2946, N'Centracare Health System - Long Prairie', 1, NULL, NULL, N'241326', NULL, NULL, 0, 34, NULL, N'3207322141', N'3207323802', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Ninth Street Southeast', N'Long Prairie', N'MN', N'27153', N'56347', 45.973688, -94.85026, 1932, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2947, N'Sleepy Eye Municipal Hospital', 1, NULL, NULL, N'241327', NULL, NULL, 0, 16, NULL, N'5077943571', N'5077945462', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Fourth Avenue Northwest', N'Sleepy Eye', N'MN', N'27015', N'56085', 44.299319, -94.727315, 1968, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2948, N'Sanford Bagley Medical Center', 1, NULL, NULL, N'241328', NULL, NULL, 0, 25, NULL, N'2186946501', N'2186943528', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 4Th Street Northwest', N'Bagley', N'MN', N'27029', N'56621', 47.525833, -95.402232, 1882, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2949, N'Lakewood Health System', 1, NULL, NULL, N'241329', NULL, NULL, 0, 37, NULL, N'2188941515', N'2188948355', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'49725 County Road 83', N'Staples', N'MN', N'27153', N'56479', 46.369341, -94.808326, 1975, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2950, N'Centracare Health System - Melrose Hospital', 1, NULL, NULL, N'241330', NULL, NULL, 0, 28, NULL, N'3202564231', N'3202564949', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 West Main Street', N'Melrose', N'MN', N'27145', N'56352', 45.674916, -94.82349, 1939, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2951, N'Albany Area Hospital', 1, NULL, NULL, N'241331', NULL, NULL, 0, 17, NULL, N'3208452121', N'3208456127', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Third Avenue', N'Albany', N'MN', N'27145', N'56307', 45.639797, -94.566269, 1970, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2952, N'Windom Area Hospital', 1, NULL, NULL, N'241332', NULL, NULL, 0, 18, NULL, N'5078312400', N'5078315749', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2150 Hospital Drive Po Box 339', N'Windom', N'MN', N'27033', N'56101', 43.877022, -95.114488, 1991, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2953, N'Mayo Clinic Health System - St James', 1, NULL, NULL, N'241333', NULL, NULL, 0, 25, NULL, N'5073753261', N'5073758605', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Moulton And Parsons Drive', N'St James', N'MN', N'27165', N'56081', 43.968929, -94.623624, 1971, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2954, N'River''s Edge Hospital & Clinic', 1, NULL, NULL, N'241334', NULL, NULL, 0, 17, NULL, N'5079347602', N'5079347651', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North Sunrise Drive', N'St Peter', N'MN', N'27103', N'56082', 44.34934, -93.970861, 1974, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2955, N'St Elizabeth Medical Center', 1, NULL, NULL, N'241335', NULL, NULL, 0, 25, NULL, N'6515654531', N'6515652482', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Grant Blvd W', N'Wabasha', N'MN', N'27157', N'55981', 44.386744, -92.049949, 1983, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2956, N'Kittson Memorial Hospital', 1, NULL, NULL, N'241336', NULL, NULL, 0, 15, NULL, N'2188433612', N'2188438879', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1010 South Birch', N'Hallock', N'MN', N'27069', N'56728', 48.767148, -96.940488, 1918, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2957, N'North Valley Health Center', 1, NULL, NULL, N'241337', NULL, NULL, 0, 12, NULL, N'2187454211', N'2187454215', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 West od Samaritan Drive', N'Warren', N'MN', N'27089', N'56762', 48.190267, -96.770396, 1986, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2958, N'Mayo Clinic Health System - Lake City', 1, NULL, NULL, N'241338', NULL, NULL, 0, 15, NULL, N'6513451114', N'6513451182', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Grant Street', N'Lake City', N'MN', N'27157', N'55041', 44.458335, -92.288365, 1927, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2959, N'Hendricks Community Hospital', 1, NULL, NULL, N'241339', NULL, NULL, 0, 24, NULL, N'5072753134', N'5072752242', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 E Lincoln Street', N'Hendricks', N'MN', N'27081', N'56136', 44.506452, -96.41845, 1920, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2960, N'Essentia Health Northern Pines Medical Center', 1, NULL, NULL, N'241340', NULL, NULL, 0, 16, NULL, N'2182294222', N'2182292042', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5211 Highway 110', N'Aurora', N'MN', N'27137', N'55705', 47.517202, -92.230935, 1880, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2961, N'Appleton Municipal Hospital', 1, NULL, NULL, N'241341', NULL, NULL, 0, 15, NULL, N'3202891580', N'3202891585', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 South Behl Street', N'Appleton', N'MN', N'27151', N'56208', 45.199748, -96.009222, 1878, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2962, N'Ortonville Area Health Services', 1, NULL, NULL, N'241342', NULL, NULL, 0, 29, NULL, N'3208392502', N'3208394277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 Eastvold Ave', N'Ortonville', N'MN', N'27011', N'56278', 45.314768, -96.44669, 1951, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2963, N'Municipal Hospital And Granite Manor', 1, NULL, NULL, N'241343', NULL, NULL, 0, 30, NULL, N'3205643111', N'3205642169', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 Tenth Avenue', N'Granite Falls', N'MN', N'27173', N'56241', 44.808885, -95.543569, 1917, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2964, N'Lifecare Medical Center', 1, NULL, NULL, N'241344', NULL, NULL, 0, 15, NULL, N'2184632500', N'2184631266', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 Delmore Drive', N'Roseau', N'MN', N'27135', N'56751', 48.839607, -95.759935, 1962, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2965, N'Mayo Clinic Health System - Waseca', 1, NULL, NULL, N'241345', NULL, NULL, 0, 25, NULL, N'5078351210', N'5077818945', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North State Street', N'Waseca', N'MN', N'27161', N'56093', 44.081525, -93.507297, 1987, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2966, N'Mayo Clinic Health System - Cannon Falls', 1, NULL, NULL, N'241346', NULL, NULL, 0, 15, NULL, N'5072636000', N'5072639640', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'32021 County 24 Boulevard', N'Cannon Falls', N'MN', N'27049', N'55009', 44.483783, -92.919128, 1894, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2967, N'Sanford Canby Medical Center', 1, NULL, NULL, N'241347', NULL, NULL, 0, 29, NULL, N'5072237277', N'5072237340', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 St Olaf Avenue South', N'Canby', N'MN', N'27173', N'56220', 44.708157, -96.277201, 1893, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2968, N'Tyler Healthcare Center', 1, NULL, NULL, N'241348', NULL, NULL, 0, 20, NULL, N'5072475521', N'5072475972', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Willow Street', N'Tyler', N'MN', N'27081', N'56178', 44.272274, -96.130943, 1981, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2969, N'Centra Care Health Paynesville', 1, NULL, NULL, N'241349', NULL, NULL, 0, 30, NULL, N'3202433779', N'3202435244', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 1St Street West', N'Paynesville', N'MN', N'27145', N'56362', 45.374891, -94.716214, 1954, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2970, N'Mercy Hospital', 1, NULL, NULL, N'241350', NULL, NULL, 0, 25, NULL, N'2184854481', N'2184855654', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4572 County Road 61', N'Moose Lake', N'MN', N'27017', N'55767', 46.437863, -92.782231, 1943, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2971, N'Redwood Area Hospital', 1, NULL, NULL, N'241351', NULL, NULL, 0, 31, NULL, N'5076374500', N'5076376000', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fallwood Road', N'Redwood Falls', N'MN', N'27127', N'56283', 44.536999, -95.107906, 1959, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2972, N'Mayo Clinic Health System - Springfield', 1, NULL, NULL, N'241352', NULL, NULL, 0, 24, NULL, N'5077236201', N'5077236447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 Jackson Avenue North', N'Springfield', N'MN', N'27015', N'56087', 44.245907, -94.971608, 1969, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2973, N'Cuyuna Regional Medical Center', 1, NULL, NULL, N'241353', NULL, NULL, 0, 42, NULL, N'2185467000', N'2185467268', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 East Main Street', N'Crosby', N'MN', N'27035', N'56441', 46.482408, -93.945253, 1899, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2974, N'Tri County Hospital', 1, NULL, NULL, N'241354', NULL, NULL, 0, 49, NULL, N'2186313510', N'2186317503', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'415 Jefferson Street North', N'Wadena', N'MN', N'27159', N'56482', 46.446572, -95.13274, 1985, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2975, N'Glencoe Regional Health Services', 1, NULL, NULL, N'241355', NULL, NULL, 0, 49, NULL, N'3208643121', N'3208647887', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 Hennepin Avenue North', N'Glencoe', N'MN', N'27085', N'55336', 44.777542, -94.151714, 1912, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2976, N'Mille Lacs Health System', 1, NULL, NULL, N'241356', NULL, NULL, 0, 28, NULL, N'3205323154', N'3205323111', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North Elm Street', N'Onamia', N'MN', N'27095', N'56359', 46.073093, -93.661815, 1950, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2977, N'Essentia Health Fosston', 1, NULL, NULL, N'241357', NULL, NULL, 0, 43, NULL, N'2184351133', N'2184351134', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Hilliss Boulevard Se', N'Fosston', N'MN', N'27119', N'56542', 47.571971, -95.738986, 1911, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2978, N'Cass Lake Indian Health Services Hospital', 1, NULL, NULL, N'241358', NULL, NULL, 0, 11, NULL, N'2183353200', N'2183353300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 7Th Street Nw', N'Cass Lake', N'MN', N'27021', N'56633', 47.384088, -94.607907, 1884, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2979, N'Avera Marshall Regional Medical Ctr', 1, NULL, NULL, N'241359', NULL, NULL, 0, 25, NULL, N'5075379661', N'5075379053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Bruce Street', N'Marshall', N'MN', N'27083', N'56258', 44.447847, -95.77619, 1938, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2980, N'Deer River Healthcare Center', 1, NULL, NULL, N'241360', NULL, NULL, 0, 20, NULL, N'2182462900', N'2182468279', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 10Th Avenue Northeast', N'Deer River', N'MN', N'27061', N'56636', 47.343523, -93.790887, 1901, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2981, N'Mayo Clinic Health System - New Prague', 1, NULL, NULL, N'241361', NULL, NULL, 0, 25, NULL, N'9527588101', N'9527582166', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 2Nd Street Northeast', N'New Prague', N'MN', N'27139', N'56071', 44.545914, -93.574076, 1946, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2982, N'Centracare Health - Monticello', 1, NULL, NULL, N'241362', NULL, NULL, 0, 39, NULL, N'7632952945', N'7632712299', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 Hart Boulevard', N'Monticello', N'MN', N'27171', N'55362', 45.300905, -93.780492, 1942, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2983, N'Stevens Community Medical Center', 1, NULL, NULL, N'241363', NULL, NULL, 0, 54, NULL, N'3205891313', N'3205891065', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East First Street Po Box 660', N'Morris', N'MN', N'27149', N'56267', 45.585186, -95.905581, 1945, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2984, N'Community Memorial Hospital', 1, NULL, NULL, N'241364', NULL, NULL, 0, 36, NULL, N'2188794641', N'2188799167', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'512 Skyline Boulevard', N'Cloquet', N'MN', N'27017', N'55720', 46.731831, -92.463528, 1896, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2985, N'Swift County Benson Hospital', 1, NULL, NULL, N'241365', NULL, NULL, 0, 31, NULL, N'3208434232', N'3208434172', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1815 Wisconsin Avenue', N'Benson', N'MN', N'27151', N'56215', 45.314399, -95.607392, 1885, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2986, N'Meeker Memorial Hospital', 1, NULL, NULL, N'241366', NULL, NULL, 0, 35, NULL, N'3206933242', N'3206934567', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 South Sibley Avenue', N'Litchfield', N'MN', N'27093', N'55355', 45.120003, -94.528031, 1930, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2987, N'Firstlight Health System', 1, NULL, NULL, N'241367', NULL, NULL, 0, 49, NULL, N'3202253315', N'3202253320', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 South Highway 65', N'Mora', N'MN', N'27065', N'55051', 45.874624, -93.28958, 1944, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2988, N'Centracare Health System - Sauk Centre', 1, NULL, NULL, N'241368', NULL, NULL, 0, 25, NULL, N'3203522221', N'3203525150', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 North Elm Street', N'Sauk Centre', N'MN', N'27145', N'56378', 45.745877, -94.954567, 1965, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2989, N'United Hospital District', 1, NULL, NULL, N'241369', NULL, NULL, 0, 43, NULL, N'5075263273', N'5075263285', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 South Moore Street Po Box 160', N'Blue Earth', N'MN', N'27043', N'56013', 43.634293, -94.100884, 1887, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2990, N'St Gabriels Hospital', 1, NULL, NULL, N'241370', NULL, NULL, 0, 49, NULL, N'3206325441', N'3203621190', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Southeast Second Street', N'Little Falls', N'MN', N'27097', N'56345', 45.968146, -94.362662, 1931, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2991, N'Sanford Luverne Medical Center', 1, NULL, NULL, N'241371', NULL, NULL, 0, 28, NULL, N'5072832321', N'5072832091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 North Kniss Avenue P O Box 1019', N'Luverne', N'MN', N'27133', N'56156', 43.671605, -96.212523, 1933, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2992, N'Madison Hospital', 1, NULL, NULL, N'241372', NULL, NULL, 0, 12, NULL, N'3205987536', N'3205983470', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Third Avenue', N'Madison', N'MN', N'27073', N'56256', 45.016635, -96.188782, 1935, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2993, N'Perham Health', 1, NULL, NULL, N'241373', NULL, NULL, 0, 29, NULL, N'2183474500', N'2183474540', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Coney Street West', N'Perham', N'MN', N'27111', N'56573', 46.592973, -95.595491, 1955, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2994, N'Pipestone County  Medical Center', 1, NULL, NULL, N'241374', NULL, NULL, 0, 44, NULL, N'5078255811', N'5078255733', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'916 4Th Avenue Southwest', N'Pipestone', N'MN', N'27117', N'56164', 43.991292, -96.322104, 1956, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2995, N'Minnesota Valley Health Center  Inc', 1, NULL, NULL, N'241375', NULL, NULL, 0, 15, NULL, N'5076653375', N'5076652191', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'621 South Fourth Street', N'Le Sueur', N'MN', N'27079', N'56058', 44.454474, -93.916036, 1929, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2996, N'Glacial Ridge Hospital', 1, NULL, NULL, N'241376', NULL, NULL, 0, 34, NULL, N'3206344521', N'3206342269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 4Th Avenue Southeast', N'Glenwood', N'MN', N'27121', N'56334', 45.646775, -95.389206, 1913, 154, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2997, N'St Francis Medical Center', 1, NULL, NULL, N'241377', NULL, NULL, 0, 25, NULL, N'2186433000', N'2186437502', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Francis Drive', N'Breckenridge', N'MN', N'27167', N'56520', 46.291297, -96.588908, 1889, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2998, N'New Ulm Medical Center', 1, NULL, NULL, N'241378', NULL, NULL, 0, 76, NULL, N'5072331000', N'5072331575', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1324 Fifth North Street', N'New Ulm', N'MN', N'27015', N'56073', 44.289604, -94.460707, 1947, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (2999, N'Prairie Ridge Hospital And Health Services', 1, NULL, NULL, N'241379', NULL, NULL, 0, 10, NULL, N'2186854461', N'2186856749', 1, 1, 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1411 State Highway 793', N'Elbow Lake', N'MN', N'27051', N'56531', 45.99221, -95.961026, 1904, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3000, N'St Josephs Area  Health Services', 1, NULL, NULL, N'241380', NULL, NULL, 0, 50, NULL, N'2187323311', N'2187321368', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Pleasant Avenue', N'Park Rapids', N'MN', N'27057', N'56470', 46.915845, -95.061507, 1953, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3001, N'Sanford Medical Center Thief River Falls', 1, NULL, NULL, N'241381', NULL, NULL, 0, 36, NULL, N'2186814240', N'2186834511', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Sanford Parkway', N'Thief River Falls', N'MN', N'27113', N'56701', 48.11723, -96.177067, 1978, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3002, N'Beacon Haven', 1, NULL, NULL, N'241991', NULL, NULL, 0, 8, NULL, N'6513790100', N'6513790601', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Long Lake Road', N'New Brighton', N'MN', N'27123', N'55112', 45.068647, -93.204335, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3003, N'Healtheast Bethesda Hospital', 1, NULL, NULL, N'242004', NULL, NULL, 0, 254, NULL, N'6512322000', N'6512322118', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'559 Capitol Boulevard', N'Saint Paul', N'MN', N'27123', N'55103', 44.950404, -93.101503, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3004, N'Regency Hospital Of Minneapolis Llc', 1, NULL, NULL, N'242005', NULL, NULL, 0, 92, NULL, N'7633028301', N'7635213805', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Hidden Lakes Parkway', N'lden Valley', N'MN', N'27053', N'55422', 44.992845, -93.332505, 1960, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3005, N'Gillette Childrens Specialty Hospital', 1, NULL, NULL, N'243300', NULL, NULL, 0, 60, NULL, N'6122912848', N'6512293999', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 University Avenue East', N'Saint Paul', N'MN', N'27123', N'55106', 44.956445, -93.095727, 1973, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3006, N'Children''s Hospitals & Clinics Of Mn', 1, NULL, NULL, N'243302', NULL, NULL, 0, 279, NULL, N'6128136112', N'6128136807', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Chica Avenue South', N'Minneapolis', N'MN', N'27053', N'55404', 44.956009, -93.262588, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3007, N'Shriners Hospitals For Children', 1, NULL, NULL, N'243303', NULL, NULL, 0, 40, NULL, N'6125966100', N'6123397634', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 East River Parkway', N'Minneapolis', N'MN', N'27053', N'55414', 44.958598, -93.212464, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3008, N'Anoka-Metro Reg Treatment Ctr', 1, NULL, NULL, N'244002', NULL, NULL, 0, 175, NULL, N'6514315000', N'6514317701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Seventh Ave North', N'Anoka', N'MN', N'27003', N'55303', 45.197743, -93.387176, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3009, N'Child & Adolescent Behavioral Health Services', 1, NULL, NULL, N'244005', NULL, NULL, 0, 16, NULL, N'3202315421', N'2188252189', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Technology Drive Ne', N'Willmar', N'MN', N'27067', N'56201', 45.121908, -95.043342, 1990, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3010, N'Comm Behavioral Health Hosp - St Peter', 1, NULL, NULL, N'244010', NULL, NULL, 0, 16, NULL, N'5079335001', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2000 Klein Street', N'Saint Peter', N'MN', N'27103', N'56082', 44.323838, -93.958529, 1974, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3011, N'Community Behavioral Health Hospital Annandale', 1, NULL, NULL, N'244011', NULL, NULL, 0, 16, NULL, N'6512593850', N'3202747018', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Annandale Boulevard', N'Annandale', N'MN', N'27171', N'55302', 45.262743, -94.124427, 1890, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3012, N'Comm Behavioral Health Hosp', 1, NULL, NULL, N'244012', NULL, NULL, 0, 16, NULL, N'3203356201', N'3207591002', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1610 8Th Avenue East', N'Alexandria', N'MN', N'27041', N'56308', 45.88524, -95.377538, 1877, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3013, N'Community Behavioral Hospital Fergus Falls', 1, NULL, NULL, N'244013', NULL, NULL, 0, 16, NULL, N'2183325001', N'2187391329', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1801 West Alcott', N'Fergus Falls', N'MN', N'27111', N'56537', 46.283015, -96.077558, 1909, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3014, N'Community Behavioral Health Hospital - Bemidji', 1, NULL, NULL, N'244014', NULL, NULL, 0, 16, NULL, N'2183082400', N'2183336800', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Bemidji Avenue North Suite 200', N'Bemidji', N'MN', N'27007', N'56601', 47.478654, -94.890802, 1884, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3015, N'Community Behavioral Health Hospital - Baxter', 1, NULL, NULL, N'244015', NULL, NULL, 0, 16, NULL, N'2183163101', N'2188299141', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14241 Grand Oaks Drive', N'Baxter', N'MN', N'27035', N'56425', 46.358151, -94.255988, 1888, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3016, N'Prairiecare', 1, NULL, NULL, N'244016', NULL, NULL, 0, 20, NULL, N'7633835800', N'7633835801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12915 63Rd Avenue North', N'Maple Grove', N'MN', N'27053', N'55369', 45.07598, -93.456105, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3017, N'Community Behavioral Health Hospital Rochester', 1, NULL, NULL, N'244017', NULL, NULL, 0, 16, NULL, N'5072062561', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'251 Wood Lake Drive Southeast', N'Rochester', N'MN', N'27109', N'55904', 44.023327, -92.463021, 1961, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3018, N'Mayo Clinic Methodist Hospital', 1, NULL, NULL, N'249801', NULL, NULL, 0, 0, NULL, N'5072667890', N'5072553125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'201 West Center Street', N'Rochester', N'MN', N'27109', N'55902', 44.023562, -92.465977, 1961, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3019, N'Abbott Northwestern Organ Transplant Hospital', 1, NULL, NULL, N'249802', NULL, NULL, 0, 0, NULL, N'6128634000', N'6128635667', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'800 East 28Th Street', N'Minneapolis', N'MN', N'27053', N'55407', 44.952026, -93.262437, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3020, N'St Marys Hospital Organ Transplant', 1, NULL, NULL, N'249803', NULL, NULL, 0, 0, NULL, N'5072555123', N'5072553125', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1216 Second Street Southwest', N'Rochester', N'MN', N'27109', N'55902', 44.023327, -92.463021, 1961, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3021, N'University Of Minnesota Medical Center Fairview', 1, NULL, NULL, N'249804', NULL, NULL, 0, 0, NULL, N'6122736150', N'6122734098', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2450 Riverside Avenue', N'Minneapolis', N'MN', N'27053', N'55455', 44.9672142, -93.2392487, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3022, N'Hennepin County Medical Center', 1, NULL, NULL, N'249805', NULL, NULL, 0, 0, NULL, N'6128739393', N'6128734214', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'701 Park Ave', N'Minneapolis', N'MN', N'27053', N'55415', 44.972717, -93.262671, 1940, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3023, N'University Of Mississippi Med Center', 1, NULL, NULL, N'250001', NULL, NULL, 0, 710, NULL, N'6019844100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 N State St', N'Jackson', N'MS', N'28049', N'39216', 32.328655, -90.175582, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3024, N'Tishomin Health Services Inc', 1, NULL, NULL, N'250002', NULL, NULL, 0, 48, NULL, N'6624236051', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1777 Curtis Drive', N'Iuka', N'MS', N'28141', N'38852', 34.803672, -88.208438, 2023, 1, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3025, N'North Mississippi Medical Center', 1, NULL, NULL, N'250004', NULL, NULL, 0, 650, NULL, N'6623773000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 S Gloster', N'Tupelo', N'MS', N'28081', N'38801', 34.242203, -88.717758, 2052, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3026, N'Baptist Memorial Hospital Union County', 1, NULL, NULL, N'250006', NULL, NULL, 0, 153, NULL, N'6625387631', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hwy 30 West', N'New Albany', N'MS', N'28145', N'38652', 34.494561, -89.016463, 2041, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3027, N'Merit Health Biloxi', 1, NULL, NULL, N'250007', NULL, NULL, 0, 153, NULL, N'2284361104', N'2284361205', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Reynoir Street', N'Biloxi', N'MS', N'28047', N'39530', 30.396059, -88.890551, 2000, 156, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3028, N'Magnolia Regional Health Center', 1, NULL, NULL, N'250009', NULL, NULL, 0, 164, NULL, N'6622931000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Alcorn Drive', N'Corinth', N'MS', N'28003', N'38834', 34.93621, -88.558582, 2011, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3029, N'Tippah County Hospital', 1, NULL, NULL, N'250010', NULL, NULL, 0, 45, NULL, N'6628379221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1005 City Ave North', N'Ripley', N'MS', N'28139', N'38663', 34.73869, -88.949325, 2048, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3030, N'Alliance Healthcare System', 1, NULL, NULL, N'250012', NULL, NULL, 0, 40, NULL, N'6622521212', N'6625513422', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 Highway 4 East / P O Box 6000', N'Holly Springs', N'MS', N'28093', N'38635', 34.769093, -89.441249, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3031, N'Trace Regional Hosp And Swing Bed', 1, NULL, NULL, N'250017', NULL, NULL, 0, 84, NULL, N'6624563700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 East Madison Street', N'Houston', N'MS', N'28017', N'38851', 33.894626, -88.984742, 2021, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3032, N'Jasper General Hospital', 1, NULL, NULL, N'250018', NULL, NULL, 0, 20, NULL, N'6017642101', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 South 6Th Street', N'Bay Springs', N'MS', N'28061', N'39422', 31.977598, -89.290563, 2027, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3033, N'Memorial Hospital At Gulfport', 1, NULL, NULL, N'250019', NULL, NULL, 0, 445, NULL, N'2288674000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 13Th St-P O Box 1810', N'Gulfport', N'MS', N'28047', N'39502', 30.36742, -89.092815, 2018, 156, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3034, N'Webster General Hospital/ Swing Bed', 1, NULL, NULL, N'250020', NULL, NULL, 0, 43, NULL, N'6622586221', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Medical Plaza', N'Eupora', N'MS', N'28155', N'39744', 33.540677, -89.267012, 2012, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3035, N'Merit Health Gilmore Memorial', 1, NULL, NULL, N'250025', NULL, NULL, 0, 95, NULL, N'6622566002', N'6622566007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Earl Frye Blvd', N'Amory', N'MS', N'28095', N'38821', 33.976267, -88.47755, 1996, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3036, N'Winston Medical Center & Swingbed', 1, NULL, NULL, N'250027', NULL, NULL, 0, 41, NULL, N'6627795124', N'6627795113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'923 South Chruch Street', N'Louisville', N'MS', N'28159', N'39339', 33.122708, -89.055237, 2029, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3037, N'Merit Health River Region', 1, NULL, NULL, N'250031', NULL, NULL, 0, 354, NULL, N'6018835000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Hwy 61 N', N'Vicksburg', N'MS', N'28149', N'39183', 32.37437, -90.827518, 2054, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3038, N'Baptist Memorial Hospital North Ms', 1, NULL, NULL, N'250034', NULL, NULL, 0, 217, NULL, N'6622328100', N'6622328391', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 South Lamar', N'Oxford', N'MS', N'28071', N'38655', 34.349714, -89.520575, 2042, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3039, N'George Regional Health System', 1, NULL, NULL, N'250036', NULL, NULL, 0, 48, NULL, N'6019473161', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'859 Winter Street', N'Lucedale', N'MS', N'28039', N'39452', 30.921642, -88.592841, 2030, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3040, N'Merit Health Madison', 1, NULL, NULL, N'250038', NULL, NULL, 0, 67, NULL, N'6018554000', N'6018555100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 River Oaks Drive', N'Canton', N'MS', N'28089', N'39046', 32.583029, -90.08225, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3041, N'Singing River Hospital', 1, NULL, NULL, N'250040', NULL, NULL, 0, 551, NULL, N'2288095000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2809 Denny Av', N'Pascaula', N'MS', N'28059', N'39581', 30.375986, -88.530692, 2043, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3042, N'Northwest Mississippi Regional Medical Center', 1, NULL, NULL, N'250042', NULL, NULL, 0, 195, NULL, N'6626273211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1970 Hospital Drive', N'Clarksdale', N'MS', N'28027', N'38614', 34.197133, -90.552762, 2007, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3043, N'Neshoba County General Hospital', 1, NULL, NULL, N'250043', NULL, NULL, 0, 82, NULL, N'6016631200', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Holland Avenue', N'Philadelphia', N'MS', N'28099', N'39350', 32.754663, -89.103077, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3044, N'Baptist Memorial Hospital Booneville', 1, NULL, NULL, N'250044', NULL, NULL, 0, 114, NULL, N'6627205000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Booneville', N'MS', N'28117', N'38829', 34.656337, -88.565763, 2001, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3045, N'St Dominic-Jackson Memorial Hospital', 1, NULL, NULL, N'250048', NULL, NULL, 0, 571, NULL, N'6012002000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Lakeland Dr', N'Jackson', N'MS', N'28049', N'39216', 32.33369, -90.165147, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3046, N'Beacham Memorial Hospital', 1, NULL, NULL, N'250049', NULL, NULL, 0, 37, NULL, N'6017832351', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'205 N Cherry St', N'Magnolia', N'MS', N'28113', N'39652', 31.145613, -90.459297, 2033, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3047, N'Och Regional Medical Center', 1, NULL, NULL, N'250050', NULL, NULL, 0, 96, NULL, N'6623234320', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Hospital Road /Mail Po Box 1506', N'Starkville', N'MS', N'28105', N'39759', 33.47497, -88.820308, 2051, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3048, N'King''s Daughters Medical Center-Brookhaven', 1, NULL, NULL, N'250057', NULL, NULL, 0, 122, NULL, N'6018336011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 948/427 Highway 51 North', N'Brookhaven', N'MS', N'28085', N'39601', 31.58369, -90.441809, 2002, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3049, N'South Central Reg Med Ctr', 1, NULL, NULL, N'250058', NULL, NULL, 0, 285, NULL, N'6014264000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 Jefferson St Box 607', N'Laurel', N'MS', N'28067', N'39440', 31.685911, -89.14135, 2027, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3050, N'Jefferson County Hospital', 1, NULL, NULL, N'250060', NULL, NULL, 0, 48, NULL, N'6017863401', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'870 S Main', N'Fayette', N'MS', N'28063', N'39069', 32.355097, -89.474164, 2013, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3051, N'Yalobusha General Hospital', 1, NULL, NULL, N'250061', NULL, NULL, 0, 32, NULL, N'6624731411', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 South Main Street', N'Water Valley', N'MS', N'28161', N'38965', 34.144719, -89.635218, 2042, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3052, N'Clay County Medical Center', 1, NULL, NULL, N'250067', NULL, NULL, 0, 60, NULL, N'6624952300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Medical Center Dr', N'West Point', N'MS', N'28025', N'39773', 33.619764, -88.663935, 2056, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3053, N'Rush Foundation Hospital', 1, NULL, NULL, N'250069', NULL, NULL, 0, 215, NULL, N'6014830011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 19Th Ave', N'Meridian', N'MS', N'28075', N'39301', 32.369974, -88.697785, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3054, N'Merit Health Central', 1, NULL, NULL, N'250072', NULL, NULL, 0, 473, NULL, N'6013761000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Chadwick Dr', N'Jackson', N'MS', N'28049', N'39204', 32.286897, -90.255627, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3055, N'Wayne General Hospital', 1, NULL, NULL, N'250077', NULL, NULL, 0, 80, NULL, N'6017355151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 Matthew Dr', N'Waynesboro', N'MS', N'28153', N'39367', 31.674211, -88.634375, 2055, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3056, N'Forrest General Hospital', 1, NULL, NULL, N'250078', NULL, NULL, 0, 537, NULL, N'6012887000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6051 Us Highway 49', N'Hattiesburg', N'MS', N'28035', N'39404', 31.320677, -89.328827, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3057, N'Sharkey Issaquena Community Hospital', 1, NULL, NULL, N'250079', NULL, NULL, 0, 29, NULL, N'6628734395', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'47 South Fourth St', N'Rolling Fork', N'MS', N'28125', N'39159', 32.904716, -90.885028, 2049, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3058, N'Anderson Rmc South', 1, NULL, NULL, N'250081', NULL, NULL, 0, 140, NULL, N'6014843590', N'6014843130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Constitution Avenue', N'Meridian', N'MS', N'28075', N'39301', 32.367356, -88.699317, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3059, N'Delta Regional Medical Center', 1, NULL, NULL, N'250082', NULL, NULL, 0, 268, NULL, N'6623783783', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 E Union St', N'Greenville', N'MS', N'28151', N'38704', 33.409906, -91.035329, 2015, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3060, N'Merit Health Natchez', 1, NULL, NULL, N'250084', NULL, NULL, 0, 179, NULL, N'6014432100', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'52 Sergeant Prentiss Drive', N'Natchez', N'MS', N'28001', N'39120', 31.544502, -91.389135, 2040, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3061, N'Marion General Hospital', 1, NULL, NULL, N'250085', NULL, NULL, 0, 79, NULL, N'6017366303', N'6017402244', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1560 Sumrall Rd', N'Columbia', N'MS', N'28091', N'39429', 31.257234, -89.806253, 2009, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3062, N'Bolivar Medical Center', 1, NULL, NULL, N'250093', NULL, NULL, 0, 165, NULL, N'6628460061', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E Sunflower Rd', N'Cleveland', N'MS', N'28011', N'38732', 33.747469, -90.710947, 2008, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3063, N'Wesley Medical Center', 1, NULL, NULL, N'250094', NULL, NULL, 0, 211, NULL, N'6012688000', N'6012685008', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 W Hardy St', N'Hattiesburg', N'MS', N'28035', N'39402', 31.322789, -89.36939, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3064, N'South Sunflower County Hospital', 1, NULL, NULL, N'250095', NULL, NULL, 0, 69, NULL, N'6628875235', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 E Baker St', N'Indianola', N'MS', N'28133', N'38751', 33.457234, -90.650235, 2022, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3065, N'Merit Health Rankin', 1, NULL, NULL, N'250096', NULL, NULL, 0, 134, NULL, N'6018252811', N'6018248592', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Crossgates Blvd', N'Brandon', N'MS', N'28121', N'39042', 32.286039, -90.035958, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3066, N'Southwest Ms Regional Medical Center', 1, NULL, NULL, N'250097', NULL, NULL, 0, 160, NULL, N'6012495500', N'6012491800', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Marion Av Box 1307', N'Mccomb', N'MS', N'28113', N'39649', 31.250229, -90.473518, 2035, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3067, N'Greenwood Leflore Hospital', 1, NULL, NULL, N'250099', NULL, NULL, 0, 260, NULL, N'6624597000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 River Rd / Po Box 1410', N'Greenwood', N'MS', N'28083', N'38930', 33.518248, -90.198663, 2016, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3068, N'Baptist Mem Hosp/ lden Triangle Inc', 1, NULL, NULL, N'250100', NULL, NULL, 0, 328, NULL, N'6622441500', N'6622442028', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 5Th St N', N'Columbus', N'MS', N'28087', N'39701', 33.526446, -88.429071, 2010, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3069, N'Mississippi Baptist Medical Center', 1, NULL, NULL, N'250102', NULL, NULL, 0, 639, NULL, N'6019681000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 N State St', N'Jackson', N'MS', N'28049', N'39202', 32.316428, -90.178364, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3070, N'Anderson Regional Medical Ctr', 1, NULL, NULL, N'250104', NULL, NULL, 0, 260, NULL, N'6015536000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2124 14 St', N'Meridian', N'MS', N'28075', N'39301', 32.370777, -88.700035, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3071, N'Highland Community  Hospital', 1, NULL, NULL, N'250117', NULL, NULL, 0, 60, NULL, N'6013589400', N'6017994417', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Highland Pkwy', N'Picayune', N'MS', N'28109', N'39466', 30.524888, -89.679152, 2044, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3072, N'Merit Health Natchez-Community Campus', 1, NULL, NULL, N'250122', NULL, NULL, 0, 101, NULL, N'6014456200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'129 Jefferson Davis Blvd Box 1203', N'Natchez', N'MS', N'28001', N'39120', 31.523565, -91.387309, 2040, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3073, N'Garden Park Medical Center', 1, NULL, NULL, N'250123', NULL, NULL, 0, 130, NULL, N'2285757000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15200 Community Road', N'Gulfport', N'MS', N'28047', N'39503', 30.44201, -89.092773, 2018, 156, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3074, N'Magee General Hospital', 1, NULL, NULL, N'250124', NULL, NULL, 0, 64, NULL, N'6018495070', N'6018490618', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 3Rd Ave Se', N'Magee', N'MS', N'28127', N'39111', 31.8723, -89.728745, 2032, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3075, N'North Oak Regional Medical Center', 1, NULL, NULL, N'250126', NULL, NULL, 0, 76, NULL, N'6625623100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Getwell Dr', N'Senatobia', N'MS', N'28137', N'38668', 34.62471, -89.956743, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3076, N'Choctaw Health Center', 1, NULL, NULL, N'250127', NULL, NULL, 0, 40, NULL, N'6016562211', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Route 7 Box R50', N'Philadelphia', N'MS', N'28099', N'39350', 32.770384, -89.115349, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3077, N'Merit Health Batesville', 1, NULL, NULL, N'250128', NULL, NULL, 0, 120, NULL, N'6625635611', N'6625630155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Medical Center Drive', N'Batesville', N'MS', N'28107', N'38606', 34.305668, -89.916833, 1997, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3078, N'Whitfield Medical Surgical Hospital', 1, NULL, NULL, N'250134', NULL, NULL, 0, 43, NULL, N'6013518023', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Hwy 468 W Bldg 60', N'Whitfield', N'MS', N'28121', N'39193', 32.237919, -90.073325, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3079, N'Merit Health Women''s Hospital', 1, NULL, NULL, N'250136', NULL, NULL, 0, 111, NULL, N'6019321000', N'6019363086', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1026 River Oaks Drive', N'Flowood', N'MS', N'28121', N'39232', 32.325539, -90.106883, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3080, N'Merit Health River Oaks', 1, NULL, NULL, N'250138', NULL, NULL, 0, 106, NULL, N'6019321030', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1030 River Oaks Drive', N'Flowood', N'MS', N'28121', N'39232', 32.325982, -90.106545, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3081, N'Baptist Memorial Hospital Desoto', 1, NULL, NULL, N'250141', NULL, NULL, 0, 161, NULL, N'6627724000', N'6627722111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Southcrest Parkway', N'Southaven', N'MS', N'28033', N'38671', 34.970993, -89.996752, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3082, N'Alliance Health Center', 1, NULL, NULL, N'250151', NULL, NULL, 0, 134, NULL, N'6014836211', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Highway 39 North', N'Meridian', N'MS', N'28075', N'39301', 32.4096, -88.678759, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3083, N'Mississippi Methodist Rehab Ctr', 1, NULL, NULL, N'250152', NULL, NULL, 0, 124, NULL, N'6019812611', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 E Woodrow Wilson Dr', N'Jackson', N'MS', N'28049', N'39216', 32.326792, -90.170988, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3084, N'Alliance Laird Hospital', 1, NULL, NULL, N'250159', NULL, NULL, 0, 49, NULL, N'6017748214', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25117 Highway 15', N'Union', N'MS', N'28101', N'39365', 32.571527, -89.121448, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3085, N'Hancock Medical Center', 1, NULL, NULL, N'250162', NULL, NULL, 0, 104, NULL, N'2284678600', N'2284678799', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'149 Drinkwater Blvd', N'Bay Saint Louis', N'MS', N'28045', N'39521', 30.31304, -89.355657, 1998, 127, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3086, N'Patients Choice Medical Center', 1, NULL, NULL, N'250163', NULL, NULL, 0, 29, NULL, N'6017829997', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'347 Magnolia Drive', N'Raleigh', N'MS', N'28129', N'39153', 32.015552, -89.516977, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3087, N'Methodist Healthcare - Olive Branch Hospital', 1, NULL, NULL, N'250167', NULL, NULL, 0, 60, NULL, N'6629329000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4250 Bethel Road', N'Olive Branch', N'MS', N'28033', N'38654', 34.922042, -89.794876, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3088, N'University Of Mississippi Medical Center- Grenada', 1, NULL, NULL, N'250168', NULL, NULL, 0, 156, NULL, N'6622277000', N'6622276519', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'960 Avent Drive', N'Grenada', N'MS', N'28043', N'38901', 33.782739, -89.818184, 2017, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3089, N'Lackey Memorial Hospital', 1, NULL, NULL, N'251300', NULL, NULL, 0, 35, NULL, N'6014694151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 N Broad Street', N'Forest', N'MS', N'28123', N'39074', 32.365746, -89.470953, 2014, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3090, N'Pioneer Community Hospital Of Aberdeen', 1, NULL, NULL, N'251302', NULL, NULL, 0, 33, NULL, N'6623692455', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S Chestnut Street', N'Aberdeen', N'MS', N'28095', N'39730', 33.82027, -88.540929, 2052, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3091, N'Stone County Hospital', 1, NULL, NULL, N'251303', NULL, NULL, 0, 25, NULL, N'6019286600', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1434 East Central Avenue', N'Wiggins', N'MS', N'28131', N'39577', 30.845656, -89.115237, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3092, N'Tallahatchie Critical Access Hospital', 1, NULL, NULL, N'251304', NULL, NULL, 0, 18, NULL, N'6626475535', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 South Market St / Po Box 230', N'Charleston', N'MS', N'28135', N'38921', 34.005879, -90.058166, 2006, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3093, N'Lawrence County Hospital Cah', 1, NULL, NULL, N'251305', NULL, NULL, 0, 25, NULL, N'6015874051', NULL, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1065 East Broad St', N'Monticello', N'MS', N'28077', N'39654', 31.553382, -90.099586, 2039, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3094, N'Perry County General Hosp', 1, NULL, NULL, N'251306', NULL, NULL, 0, 30, NULL, N'6017886316', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 Bay St', N'Richton', N'MS', N'28111', N'39476', 31.347082, -88.938927, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3095, N'Noxubee General Critical Access Hosp', 1, NULL, NULL, N'251307', NULL, NULL, 0, 25, NULL, N'6627264231', N'6627265784', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 North Jefferson Street', N'Macon', N'MS', N'28103', N'39341', 33.12129, -88.555479, 2031, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3096, N'Pontotoc Health Service Cah', 1, NULL, NULL, N'251308', NULL, NULL, 0, 25, NULL, N'6624895510', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'176 South Main Street', N'Pontotoc', N'MS', N'28115', N'38863', 34.242725, -88.99676, 2052, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3097, N'Field Health System', 1, NULL, NULL, N'251309', NULL, NULL, 0, 25, NULL, N'6018900500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'178 Highway 24', N'Centreville', N'MS', N'28157', N'39631', 31.077727, -91.064099, 2005, 119, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3098, N'Tyler Holmes Memorial Hospital Cah', 1, NULL, NULL, N'251312', NULL, NULL, 0, 25, NULL, N'6622834114', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 Tyler Holmes Drive', N'Winona', N'MS', N'28097', N'38967', 33.490685, -89.737749, 2057, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3099, N'Baptist Medical Center Yazoo', 1, NULL, NULL, N'251313', NULL, NULL, 0, 35, NULL, N'6627462261', N'6627464839', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'823 Grand Avenue', N'Yazoo City', N'MS', N'28163', N'39194', 32.858467, -90.403472, 2058, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3100, N'Quitman County Hospital Cah', 1, NULL, NULL, N'251314', NULL, NULL, 0, 33, NULL, N'6623268031', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Getwell Drive', N'Marks', N'MS', N'28119', N'38646', 34.259648, -90.291191, 2034, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3101, N'Baptist Medical Center-Leake', 1, NULL, NULL, N'251315', NULL, NULL, 0, 25, NULL, N'6012671454', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Ellis Street', N'Carthage', N'MS', N'28079', N'39051', 32.740784, -89.519804, 2004, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3102, N'H C Watkins Memorial Hospital Inc', 1, NULL, NULL, N'251316', NULL, NULL, 0, 25, NULL, N'6017766925', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 South Archusa Avenue', N'Quitman', N'MS', N'28023', N'39355', 32.029915, -88.727928, 2047, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3103, N'Simpson General Hospital Cah', 1, NULL, NULL, N'251317', NULL, NULL, 0, 35, NULL, N'6018472221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1842 Simpson Highway 149', N'Mendenhall', N'MS', N'28127', N'39114', 31.971384, -89.892091, 2037, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3104, N'North Sunflower Medical Center Cah', 1, NULL, NULL, N'251318', NULL, NULL, 0, 35, NULL, N'6627562711', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'840 North Oak Avenue', N'Ruleville', N'MS', N'28133', N'38771', 33.734832, -90.546773, 2050, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3105, N'Holmes County Hospital And Clinics', 1, NULL, NULL, N'251319', NULL, NULL, 0, 25, NULL, N'6628341321', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'239 Bowling Green Road', N'Lexington', N'MS', N'28051', N'39095', 33.111982, -90.028568, 2028, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3106, N'Claiborne County Hospital', 1, NULL, NULL, N'251320', NULL, NULL, 0, 35, NULL, N'6014375141', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Mccomb Avenue', N'Port Gibson', N'MS', N'28021', N'39150', 31.946466, -90.986769, 2045, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3107, N'Laird Hospital Inc', 1, NULL, NULL, N'251322', NULL, NULL, 0, 25, NULL, N'6017748214', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25117 Highway 15', N'Union', N'MS', N'28099', N'39365', 32.559207, -89.102561, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3108, N'Scott Regional Hospital Cah', 1, NULL, NULL, N'251323', NULL, NULL, 0, 30, NULL, N'6017326301', N'6017328970', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Highway 13 South', N'Morton', N'MS', N'28123', N'39117', 32.342862, -89.671299, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3109, N'Walthall County General Hospital Cah', 1, NULL, NULL, N'251324', NULL, NULL, 0, 35, NULL, N'6018762122', N'6012220432', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Tylertown', N'MS', N'28147', N'39667', 31.119055, -90.154809, 2053, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3110, N'Covington County Hospital Cah', 1, NULL, NULL, N'251325', NULL, NULL, 0, 35, NULL, N'6017656711', N'6016980180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 South Holly Avenue', N'Collins', N'MS', N'28031', N'39428', 31.638318, -89.554545, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3111, N'Jefferson Davis Community Hospital Cah', 1, NULL, NULL, N'251326', NULL, NULL, 0, 35, NULL, N'6017924276', N'6017922947', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Rose Street', N'Prentiss', N'MS', N'28065', N'39474', 31.593829, -89.872183, 2046, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3112, N'Hardy Wilson Memorial Hospital Cah', 1, NULL, NULL, N'251327', NULL, NULL, 0, 35, NULL, N'6018944541', N'6018946279', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'233 Magnolia Street', N'Hazlehurst', N'MS', N'28029', N'39083', 31.869696, -90.400863, 2020, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3113, N'Greene County Hospital Cah', 1, NULL, NULL, N'251329', NULL, NULL, 0, 3, NULL, N'6013944135', N'6013945495', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1017 Jackson Street', N'Leakesville', N'MS', N'28041', N'39451', 31.15473, -88.559759, 2030, 4, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3114, N'Franklin County Memorial Hospital', 1, NULL, NULL, N'251330', NULL, NULL, 0, 36, NULL, N'6013845801', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Union Church Rd', N'Meadville', N'MS', N'28037', N'39653', 31.473023, -90.884901, 2036, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3115, N'Calhoun Health Services', 1, NULL, NULL, N'251331', NULL, NULL, 0, 30, NULL, N'6626286611', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Burke-Calhoun City Road', N'Calhoun City', N'MS', N'28013', N'38916', 33.870385, -89.318658, 2003, 160, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3116, N'Pioneer Health Services Of Newton', 1, NULL, NULL, N'251332', NULL, NULL, 0, 30, NULL, N'6016832031', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9421 East Side Drive Extension Pob 299', N'Newton', N'MS', N'28101', N'39345', 32.321255, -89.163393, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3117, N'Pearl River County Hospital', 1, NULL, NULL, N'251333', NULL, NULL, 0, 24, NULL, N'6017954543', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 West Moody Street', N'Poplarville', N'MS', N'28109', N'39470', 30.857118, -89.541022, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3118, N'Choctaw Regional Medical Center', 1, NULL, NULL, N'251334', NULL, NULL, 0, 25, NULL, N'6622854400', N'6012859485', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8613 Ms Hwy 12', N'Ackerman', N'MS', N'28019', N'39735', 33.627587, -88.310791, 1995, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3119, N'John C Stennis Memorial Hospital', 1, NULL, NULL, N'251335', NULL, NULL, 0, 25, NULL, N'7694861000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14365 Highway 16 West', N'De Kalb', N'MS', N'28069', N'39328', 32.776819, -88.679122, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3120, N'Baptist Medical Center - Attala', 1, NULL, NULL, N'251336', NULL, NULL, 0, 25, NULL, N'6622894311', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Hwy 12 West', N'Kosciusko', N'MS', N'28007', N'39090', 33.06205, -89.603553, 2026, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3121, N'Mississippi Hospital For Restorative Care', 1, NULL, NULL, N'252003', NULL, NULL, 0, 25, NULL, N'6019731660', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 North State St', N'Jackson', N'MS', N'28049', N'39202', 32.313855, -90.1783, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3122, N'Speciality Hospital Of Meridianthe', 1, NULL, NULL, N'252004', NULL, NULL, 0, 49, NULL, N'6017034211', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1314 19Th Avenue', N'Meridian', N'MS', N'28075', N'39301', 32.366727, -88.670602, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3123, N'Select Specialty Hospital-Gulf Coast Inc', 1, NULL, NULL, N'252005', NULL, NULL, 0, 70, NULL, N'2285757500', N'2285757509', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1520 Broad Avenue Suite 300', N'Gulfport', N'MS', N'28047', N'39501', 30.3702016, -89.1183137, 2018, 156, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3124, N'Regency Hospital Of Meridian', 1, NULL, NULL, N'252006', NULL, NULL, 0, 40, NULL, N'6014847900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 Constitution Avenue 2Nd Floor', N'Meridian', N'MS', N'28075', N'39301', 32.36431, -88.703656, 2038, 159, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3125, N'Select Specialty Hospital Jackson', 1, NULL, NULL, N'252007', NULL, NULL, 0, 53, NULL, N'6018993800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5903 Ridgewood Road', N'Jackson', N'MS', N'28049', N'39211', 32.390113, -90.141727, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3126, N'Promise Hospital Of Vicksburg Inc', 1, NULL, NULL, N'252008', NULL, NULL, 0, 35, NULL, N'6018833439', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 North Frontage Road 2D Floor', N'Vicksburg', N'MS', N'28149', N'39180', 32.318544, -90.8844916, 2054, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3127, N'Regency Hospital Of Hattiesburg', 1, NULL, NULL, N'252009', NULL, NULL, 0, 33, NULL, N'6012888510', N'6012282525', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6051 Us Highway 49 5Th Floor', N'Hattiesburg', N'MS', N'28035', N'39404', 31.327119, -89.290339, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3128, N'Greenwood - Amg Specialty Hospital', 1, NULL, NULL, N'252010', NULL, NULL, 0, 40, NULL, N'6624515172', N'6624515173', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 River Road 2D Floor', N'Greenwood', N'MS', N'28083', N'38930', 33.518176, -90.199905, 2016, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3129, N'Regency Hospital Of Jackson Llc', 1, NULL, NULL, N'252012', NULL, NULL, 0, 36, NULL, N'6013646200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Lakeland Drive 6Th Floor', N'Jackson', N'MS', N'28049', N'39216', 32.3321843, -90.1670104, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3130, N'Allegiance Specialty Hospital Of Greenville', 1, NULL, NULL, N'252013', NULL, NULL, 0, 39, NULL, N'6623327344', N'6623327295', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Washington Ave 3Rd Floor', N'Greenville', N'MS', N'28151', N'38701', 33.400063, -91.055131, 2015, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3131, N'Parkwood Behavioral Health System', 1, NULL, NULL, N'254005', NULL, NULL, 0, 88, NULL, N'6628954900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8135 odman Road', N'Olive Branch', N'MS', N'28033', N'38654', 34.962113, -89.845739, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3132, N'Brentwood Behavioral Healthcare Of Ms', 1, NULL, NULL, N'254007', NULL, NULL, 0, 1231, NULL, N'6019362024', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3531 East Lakeland Drive', N'Flowood', N'MS', N'28121', N'39232', 32.30959, -90.138976, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3133, N'South Mississippi State Hospital', 1, NULL, NULL, N'254008', NULL, NULL, 0, 50, NULL, N'6017940100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'823 Highway 589', N'Purvis', N'MS', N'28073', N'39475', 31.144335, -89.406955, 2019, 157, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3134, N'North Mississippi State Hospital', 1, NULL, NULL, N'254009', NULL, NULL, 0, 82, NULL, N'6626904200', N'6626904227', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1937 Briar Ridge Rd', N'Tupelo', N'MS', N'28081', N'38804', 34.235889, -88.671953, 2052, 161, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3135, N'Ms State Hospital-Whitfield', 1, NULL, NULL, N'254010', NULL, NULL, 0, 306, NULL, N'6013518000', N'6013518326', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Highway 468 West', N'Whitfield', N'MS', N'28121', N'39193', 31.445171, -89.074501, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3136, N'University Of Mississippi Medical Center', 1, NULL, NULL, N'259800', NULL, NULL, 0, 0, NULL, N'6019844100', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2500 N State Street', N'Jackson', N'MS', N'28049', N'39216', 32.331803, -90.175423, 2024, 158, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3137, N'Mercy Hospital Joplin', 1, NULL, NULL, N'260001', NULL, NULL, 0, 367, NULL, N'4177812727', N'4176252910', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Mercy Way', N'Joplin', N'MO', N'29097', N'64804', 37.034697, -94.511799, 2090, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3138, N'Cooper County Memorial Hospital', 1, NULL, NULL, N'260004', NULL, NULL, 0, 46, NULL, N'6608827461', N'6608826093', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17651 B Hwy', N'Boonville', N'MO', N'29053', N'65233', 38.933254, -92.74365, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3139, N'Ssm St Joseph Health Center', 1, NULL, NULL, N'260005', NULL, NULL, 0, 362, NULL, N'6369475000', N'6369475090', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 1St Capitol Dr', N'Saint Charles', N'MO', N'29183', N'63301', 38.780224, -90.484017, 2122, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3140, N'Heartland Regional Medical Center', 1, NULL, NULL, N'260006', NULL, NULL, 0, 353, NULL, N'8162716000', N'8162716656', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5325 Faraon Street', N'Saint Joseph', N'MO', N'29021', N'64506', 39.770201, -94.770247, 2123, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3141, N'Bothwell Regional Health Center', 1, NULL, NULL, N'260009', NULL, NULL, 0, 185, NULL, N'6608268833', N'6608276804', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 14Th St', N'Sedalia', N'MO', N'29159', N'65302', 38.699012, -93.222762, 2118, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3142, N'Ssm Health St. Mary''s Hospital - Jefferson City', 1, NULL, NULL, N'260011', NULL, NULL, 0, 167, NULL, N'5736813000', N'5736365733', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2505 Mission Drive', N'Jefferson City', N'MO', N'29051', N'65109', 38.560142, -92.220281, 2089, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3143, N'Twin Rivers Regional Medical Center', 1, NULL, NULL, N'260015', NULL, NULL, 0, 116, NULL, N'5738884522', N'5738885525', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 First St', N'Kennett', N'MO', N'29069', N'63857', 36.236624, -90.041068, 2092, 13, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3144, N'Phelps County Regional Medical Center', 1, NULL, NULL, N'260017', NULL, NULL, 0, 240, NULL, N'5734588899', N'5733645110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 W 10Th St', N'Rolla', N'MO', N'29161', N'65401', 37.951442, -91.784993, 2116, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3145, N'Mercy Hospital St Louis', 1, NULL, NULL, N'260020', NULL, NULL, 0, 859, NULL, N'3145696000', N'3145696910', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 New Ballas Road', N'Saint Louis', N'MO', N'29189', N'63141', 38.666813, -90.443303, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3146, N'Northeast Regional Medical Center', 1, NULL, NULL, N'260022', NULL, NULL, 0, 194, NULL, N'6607851000', N'6607851110', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 S Osteopathy', N'Kirksville', N'MO', N'29001', N'63501', 40.192482, -92.590847, 2093, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3147, N'Mercy Hospital Jefferson', 1, NULL, NULL, N'260023', NULL, NULL, 0, 240, NULL, N'6369331000', N'6369331119', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Highway 61 South', N'Crystal City', N'MO', N'29099', N'63019', 38.221166, -90.379009, 2075, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3148, N'Texas County Memorial Hospital', 1, NULL, NULL, N'260024', NULL, NULL, 0, 66, NULL, N'4179673311', N'4179673764', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1333 Sam Houston Boulevard', N'Houston', N'MO', N'29215', N'65483', 37.33849, -91.93877, 2087, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3149, N'Hannibal Regional Hospital', 1, NULL, NULL, N'260025', NULL, NULL, 0, 91, NULL, N'5732481300', N'5732485264', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6000 Hospital Dr', N'Hannibal', N'MO', N'29127', N'63401', 39.710492, -91.449829, 2083, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3150, N'Research Medical Center', 1, NULL, NULL, N'260027', NULL, NULL, 0, 545, NULL, N'8162764000', N'8162764387', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2316 E Meyer Blvd', N'Kansas City', N'MO', N'29095', N'64132', 39.007169, -94.558742, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3151, N'Barnes Jewish Hospital', 1, NULL, NULL, N'260032', NULL, NULL, 0, 1737, NULL, N'3147473000', N'3143620468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Barnes-Jewish Hospital Plaza', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3152, N'Bates County Memorial Hospital', 1, NULL, NULL, N'260034', NULL, NULL, 0, 60, NULL, N'6602007000', N'6606794381', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 W Nursery St', N'Butler', N'MO', N'29013', N'64730', 38.24959, -94.342633, 2067, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3153, N'Cox Medical Centers', 1, NULL, NULL, N'260040', NULL, NULL, 0, 592, NULL, N'4172696000', N'4172694104', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 South National Avenue', N'Springfield', N'MO', N'29077', N'65807', 37.144966, -93.27808, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3154, N'Capital Region Medical Center', 1, NULL, NULL, N'260047', NULL, NULL, 0, 135, NULL, N'5736325000', N'5736325880', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 Madison St', N'Jefferson City', N'MO', N'29051', N'65102', 38.567645, -92.180876, 2089, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3155, N'Truman Medical Center Hospital Hill', 1, NULL, NULL, N'260048', NULL, NULL, 0, 283, NULL, N'8164041000', N'8164043508', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Holmes Street', N'Kansas City', N'MO', N'29095', N'64108', 39.084207, -94.575825, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3156, N'Ssm Health St Francis Hospital - Maryville', 1, NULL, NULL, N'260050', NULL, NULL, 0, 90, NULL, N'6605622600', N'6605627911', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2016 South Main St', N'Maryville', N'MO', N'29147', N'64468', 40.325845, -94.874044, 2102, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3157, N'Mercy Hospital Washington', 1, NULL, NULL, N'260052', NULL, NULL, 0, 185, NULL, N'6362398000', N'6365696733', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 East 5Th Street', N'Washington', N'MO', N'29071', N'63090', 38.5522, -91.002023, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3158, N'Cameron Regional Medical Center', 1, NULL, NULL, N'260057', NULL, NULL, 0, 49, NULL, N'8166322101', N'8166493362', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 E Evergreen', N'Cameron', N'MO', N'29049', N'64429', 39.731633, -94.221756, 2068, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3159, N'Mercy Hospital Lebanon', 1, NULL, NULL, N'260059', NULL, NULL, 0, 48, NULL, N'4175336100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Lebanon', N'MO', N'29105', N'65536', 37.681437, -92.635875, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3160, N'Nevada Regional Medical Center', 1, NULL, NULL, N'260061', NULL, NULL, 0, 71, NULL, N'4176673355', N'4174483848', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Ash St', N'Nevada', N'MO', N'29217', N'64772', 37.830538, -94.359703, 2107, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3161, N'Saint Lukes Northland Hospital', 1, NULL, NULL, N'260062', NULL, NULL, 0, 147, NULL, N'8168916000', N'8168806155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5830 N W Barry Road', N'Kansas City', N'MO', N'29165', N'64154', 39.246884, -94.647757, 2108, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3162, N'Ssm Health St. Mary''s Hospital-Audrain', 1, NULL, NULL, N'260064', NULL, NULL, 0, 201, NULL, N'5735825000', N'5735823700', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 E Monroe', N'Mexico', N'MO', N'29007', N'65265', 39.172921, -91.877163, 2104, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3163, N'Mercy Hospital Springfield', 1, NULL, NULL, N'260065', NULL, NULL, 0, 866, NULL, N'4178202000', N'4178888730', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1235 E Cherokee', N'Springfield', N'MO', N'29077', N'65804', 37.178174, -93.275861, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3164, N'Boone Hospital Center', 1, NULL, NULL, N'260068', NULL, NULL, 0, 394, NULL, N'5738158000', N'5738152638', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 E Broadway', N'Columbia', N'MO', N'29019', N'65201', 38.950374, -92.315757, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3165, N'Pemiscot County Memorial Hospital', 1, NULL, NULL, N'260070', NULL, NULL, 0, 102, NULL, N'5733591372', N'5733593601', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'946 East Reed', N'Hayti', N'MO', N'29155', N'63851', 36.236855, -89.739997, 2085, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3166, N'Moberly Regional Medical Center', 1, NULL, NULL, N'260074', NULL, NULL, 0, 101, NULL, N'6602638400', N'6602693091', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Union Ave', N'Moberly', N'MO', N'29175', N'65270', 39.423855, -92.413341, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3167, N'St Anthony''s Medical Center', 1, NULL, NULL, N'260077', NULL, NULL, 0, 767, NULL, N'3145251000', N'3145251228', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10010 Kennerly Road', N'Saint Louis', N'MO', N'29189', N'63128', 38.509318, -90.377341, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3168, N'Ozarks Medical Center', 1, NULL, NULL, N'260078', NULL, NULL, 0, 120, NULL, N'4172569111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Kentucky Ave', N'West Plains', N'MO', N'29091', N'65775', 36.737988, -91.875552, 2130, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3169, N'Southeast Health Center Of Ripley County', 1, NULL, NULL, N'260080', NULL, NULL, 0, 30, NULL, N'5739962141', N'5439963949', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'109 Plum St', N'Doniphan', N'MO', N'29181', N'63935', 36.620754, -90.827051, 2113, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3170, N'Ssm St Clare Health Center', 1, NULL, NULL, N'260081', NULL, NULL, 0, 180, NULL, N'6364962000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Bowles', N'Fenton', N'MO', N'29099', N'63026', 38.527021, -90.473623, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3171, N'St Joseph Medical Center', 1, NULL, NULL, N'260085', NULL, NULL, 0, 300, NULL, N'8169424000', N'8169433131', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Carondelet Dr', N'Kansas City', N'MO', N'29095', N'64114', 38.935007, -94.605907, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3172, N'Ssm St Marys Health Center', 1, NULL, NULL, N'260091', NULL, NULL, 0, 690, NULL, N'3147688000', N'3147688011', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6420 Clayton Rd', N'Richmond Heights', N'MO', N'29189', N'63117', 38.633943, -90.310138, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3173, N'Cox Medical Center Branson', 1, NULL, NULL, N'260094', NULL, NULL, 0, 99, NULL, N'4173357000', N'4173341505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Branson Landing Blvd Po Box 650', N'Branson', N'MO', N'29213', N'65615', 36.650286, -93.220248, 2065, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3174, N'Centerpoint Medical Center', 1, NULL, NULL, N'260095', NULL, NULL, 0, 366, NULL, N'8166987000', N'8168366603', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19600 East 39Th Street', N'Independence', N'MO', N'29095', N'64057', 39.047771, -94.349313, 2088, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3175, N'North Kansas City Hospital', 1, NULL, NULL, N'260096', NULL, NULL, 0, 451, NULL, N'8166912000', N'8166911097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Clay Edwards Drive', N'North Kansas City', N'MO', N'29047', N'64116', 39.149494, -94.552465, 2108, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3176, N'Western Missouri Medical Center', 1, NULL, NULL, N'260097', NULL, NULL, 0, 104, NULL, N'6607472500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'403 Burkarth Road', N'Warrensburg', N'MO', N'29101', N'64093', 38.765958, -93.723723, 2129, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3177, N'Truman Medical Center Lakewood', 1, NULL, NULL, N'260102', NULL, NULL, 0, 304, NULL, N'8164047000', N'8164787500', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7900 Lee''s Summit Rd', N'Kansas City', N'MO', N'29095', N'64139', 38.973566, -94.39046, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3178, N'Ssm Depaul Health Center', 1, NULL, NULL, N'260104', NULL, NULL, 0, 538, NULL, N'3143446000', N'3143446840', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12303 Depaul Drive', N'Bridgeton', N'MO', N'29189', N'63044', 38.74912, -90.43453, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3179, N'Ssm Health Saint Louis University Hospital', 1, NULL, NULL, N'260105', NULL, NULL, 0, 356, NULL, N'3145778000', N'3145778003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3635 Vista Ave', N'Saint Louis', N'MO', N'29510', N'63110', 38.622548, -90.23945, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3180, N'Missouri Baptist Medical Center', 1, NULL, NULL, N'260108', NULL, NULL, 0, 494, NULL, N'3149965000', N'3149965250', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3015 N Ballas Rd', N'Town And Country', N'MO', N'29189', N'63131', 38.636176, -90.443637, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3181, N'Southeasthealth', 1, NULL, NULL, N'260110', NULL, NULL, 0, 281, NULL, N'5733344822', N'5736515850', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Lacey St', N'Cape Girardeau', N'MO', N'29031', N'63701', 37.311273, -89.540936, 2069, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3182, N'Missouri Delta Medical Center', 1, NULL, NULL, N'260113', NULL, NULL, 0, 188, NULL, N'5734711600', N'5734727606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1008 North Main St', N'Sikeston', N'MO', N'29143', N'63801', 36.889074, -89.584392, 2119, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3183, N'Parkland Health Center - Weber Road', 1, NULL, NULL, N'260116', NULL, NULL, 0, 127, NULL, N'5737564581', N'5737566007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1212 Weber Rd', N'Farmington', N'MO', N'29187', N'63640', 37.800177, -90.440986, 2081, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3184, N'Poplar Bluff Regional Medical Center', 1, NULL, NULL, N'260119', NULL, NULL, 0, 230, NULL, N'5737857721', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Oak Grove Road', N'Poplar Bluff', N'MO', N'29023', N'63901', 36.788987, -90.443301, 2113, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3185, N'Freeman Health System - Freeman West', 1, NULL, NULL, N'260137', NULL, NULL, 0, 322, NULL, N'4173471111', N'4173476646', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 West 32Nd Street', N'Joplin', N'MO', N'29097', N'64804', 37.054408, -94.526884, 2090, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3186, N'St Lukes Hospital Of Kansas City', 1, NULL, NULL, N'260138', NULL, NULL, 0, 642, NULL, N'8169322000', N'8169325990', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Wornall Road', N'Kansas City', N'MO', N'29095', N'64111', 39.048719, -94.590077, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3187, N'University Of Missouri Health Care', 1, NULL, NULL, N'260141', NULL, NULL, 0, 368, NULL, N'5738824141', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive Room Ce121 Dc03100', N'Columbia', N'MO', N'29019', N'65212', 38.951883, -92.333737, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3188, N'Fitzgibbon Hospital', 1, NULL, NULL, N'260142', NULL, NULL, 0, 60, NULL, N'6608867431', N'6608869001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 S 65 Highway', N'Marshall', N'MO', N'29195', N'65340', 39.123078, -93.19687, 2101, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3189, N'Southeasthealth Center Of Stoddard County', 1, NULL, NULL, N'260160', NULL, NULL, 0, 50, NULL, N'5736245566', N'5736248895', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N One Mile Rd', N'Dexter', N'MO', N'29207', N'63841', 36.807155, -89.970006, 2076, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3190, N'Barnes-Jewish West County Hospital', 1, NULL, NULL, N'260162', NULL, NULL, 0, 113, NULL, N'3149968000', N'3149968619', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12634 Olive Boulevard', N'Creve Coeur', N'MO', N'29189', N'63141', 38.67697, -90.466163, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3191, N'Parkland Health Center', 1, NULL, NULL, N'260163', NULL, NULL, 0, 133, NULL, N'5734316005', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 W Liberty', N'Farmington', N'MO', N'29187', N'63640', 37.780523, -90.438959, 2081, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3192, N'lden Valley Memorial Hospital', 1, NULL, NULL, N'260175', NULL, NULL, 0, 65, NULL, N'6608855511', N'6608558496', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N 2Nd St', N'Clinton', N'MO', N'29083', N'64735', 38.391389, -93.770506, 2073, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3193, N'Des Peres Hospital', 1, NULL, NULL, N'260176', NULL, NULL, 0, 143, NULL, N'3149669100', N'3149669274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2345 Dougherty Ferry Road', N'Saint Louis', N'MO', N'29189', N'63122', 38.58098, -90.451147, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3194, N'Liberty Hospital', 1, NULL, NULL, N'260177', NULL, NULL, 0, 250, NULL, N'8167817200', N'8167927117', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Glenn Hendren Dr', N'Liberty', N'MO', N'29047', N'64069', 39.276422, -94.424894, 2098, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3195, N'St Lukes Hospital', 1, NULL, NULL, N'260179', NULL, NULL, 0, 493, NULL, N'3144341500', N'3142056865', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'232 S Woods Mill Rd', N'Chesterfield', N'MO', N'29189', N'63017', 38.653066, -90.50592, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3196, N'Christian Hospital Northeast-Northwest', 1, NULL, NULL, N'260180', NULL, NULL, 0, 475, NULL, N'3146535000', N'3146534408', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11133 Dunn Road', N'Saint Louis', N'MO', N'29189', N'63136', 38.776084, -90.23888, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3197, N'Saint Francis Medical Center', 1, NULL, NULL, N'260183', NULL, NULL, 0, 264, NULL, N'5733313000', N'5733315009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 St Francis Dr', N'Cape Girardeau', N'MO', N'29031', N'63703', 37.302249, -89.571932, 2069, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3198, N'Lake Regional Health System', 1, NULL, NULL, N'260186', NULL, NULL, 0, 99, NULL, N'5733488000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'54 Hospital Drive', N'Osage Beach', N'MO', N'29029', N'65065', 38.119188, -92.68336, 2109, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3199, N'Lee''s Summit Medical Center', 1, NULL, NULL, N'260190', NULL, NULL, 0, 102, NULL, N'8162825000', N'8162825942', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Se Blue Parkway', N'Lees Summit', N'MO', N'29095', N'64063', 38.902017, -94.323381, 2096, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3200, N'Barnes-Jewish St Peters Hospital', 1, NULL, NULL, N'260191', NULL, NULL, 0, 111, NULL, N'6369169000', N'6369169414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital Dr', N'Saint Peters', N'MO', N'29183', N'63376', 38.792852, -90.579154, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3201, N'St Mary''s Medical Center', 1, NULL, NULL, N'260193', NULL, NULL, 0, 111, NULL, N'8162285900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Nw R D Mize Rd', N'Blue Springs', N'MO', N'29095', N'64014', 39.023528, -94.266042, 2063, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3202, N'Citizens Memorial Hospital', 1, NULL, NULL, N'260195', NULL, NULL, 0, 74, NULL, N'4173266000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N Oakland', N'Bolivar', N'MO', N'29167', N'65613', 37.622444, -93.421056, 2064, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3203, N'Ssm Health Saint Joseph Hospital-Lake Saint Louis', 1, NULL, NULL, N'260200', NULL, NULL, 0, 100, NULL, N'6366255200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Plaza', N'Lake Saint Louis', N'MO', N'29183', N'63367', 38.803075, -90.774729, 2094, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3204, N'Ozarks Community Hospital', 1, NULL, NULL, N'260207', NULL, NULL, 0, 45, NULL, N'4178374000', N'4178374291', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2828 North National', N'Springfield', N'MO', N'29077', N'65803', 37.248812, -93.274438, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3205, N'Fulton Medical Center Llc', 1, NULL, NULL, N'260209', NULL, NULL, 0, 49, NULL, N'5736423376', N'5736429830', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 South Hospital Drive', N'Fulton', N'MO', N'29027', N'65251', 38.842258, -91.966108, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3206, N'St Alexius Hospital', 1, NULL, NULL, N'260210', NULL, NULL, 0, 563, NULL, N'3148657000', N'3148657934', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3933 S Broadway', N'Saint Louis', N'MO', N'29510', N'63118', 38.583359, -90.227557, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3207, N'Belton Regional Medical Center', 1, NULL, NULL, N'260214', NULL, NULL, 0, 71, NULL, N'8163481236', N'8163481271', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17065 S 71 Highway', N'Belton', N'MO', N'29037', N'64012', 38.811953, -94.531898, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3208, N'Saint Luke''s East Lee''s Summit Hospital', 1, NULL, NULL, N'260216', NULL, NULL, 0, 52, NULL, N'8163475000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 N E Saint Luke''s Boulevard', N'Lees Summit', N'MO', N'29095', N'64086', 38.94076, -94.380963, 2096, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3209, N'Progress West Hospital', 1, NULL, NULL, N'260219', NULL, NULL, 0, 72, NULL, N'6363441000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Progress Point Pkwy', N'O Fallon', N'MO', N'29183', N'63368', 38.717665, -90.701179, 2122, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3210, N'Black River Community Medical Center', 1, NULL, NULL, N'260227', NULL, NULL, 0, 3, NULL, N'5736866001', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'217 Physicians Park Drive', N'Poplar Bluff', N'MO', N'29023', N'63901', 36.770882, -90.456445, 2113, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3211, N'Mercy Mccune Brooks Hospital', 1, NULL, NULL, N'260228', NULL, NULL, 0, 49, NULL, N'4173588121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3125 Dr Russell Smith Way', N'Carthage', N'MO', N'29097', N'64836', 37.176447, -94.310223, 2071, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3212, N'Ellett Memorial Hospital', 1, NULL, NULL, N'261301', NULL, NULL, 0, 12, NULL, N'6604762111', N'6604765591', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 N Ohio Ave', N'Appleton City', N'MO', N'29185', N'64724', 38.190582, -94.029387, 2060, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3213, N'Madison Medical Center', 1, NULL, NULL, N'261302', NULL, NULL, 0, 25, NULL, N'5737813341', N'5737831096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 W Main St', N'Fredericktown', N'MO', N'29123', N'63645', 37.559814, -90.301112, 2082, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3214, N'Community Hospital Association', 1, NULL, NULL, N'261303', NULL, NULL, 0, 25, NULL, N'6606862111', N'6606862618', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26136 Us Highway 59 Po Box 107', N'Fairfax', N'MO', N'29005', N'64446', 40.338609, -95.393314, 2080, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3215, N'Putnam County Memorial Hospital', 1, NULL, NULL, N'261305', NULL, NULL, 0, 25, NULL, N'6609472411', N'6609473825', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1926 Oak Street  Po Box 389', N'Unionville', N'MO', N'29171', N'63565', 40.482023, -93.005763, 2128, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3216, N'Sullivan County Memorial Hospital', 1, NULL, NULL, N'261306', NULL, NULL, 0, 25, NULL, N'6602654212', N'6602654898', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 West Third Street', N'Milan', N'MO', N'29211', N'63556', 40.202025, -93.133162, 2105, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3217, N'Pershing Memorial Hospital', 1, NULL, NULL, N'261307', NULL, NULL, 0, 25, NULL, N'6602582222', N'6602585668', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 East Lockling', N'Brookfield', N'MO', N'29115', N'64628', 39.77504, -93.068432, 2066, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3218, N'Washington County Memorial Hospital', 1, NULL, NULL, N'261308', NULL, NULL, 0, 25, NULL, N'5734385451', N'5734382399', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Health Way', N'Potosi', N'MO', N'29221', N'63664', 37.936438, -90.787909, 2114, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3219, N'Wright Memorial Hospital', 1, NULL, NULL, N'261309', NULL, NULL, 0, 25, NULL, N'6603595621', N'6603593541', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'191 Iowa Boulevard', N'Trenton', N'MO', N'29079', N'64683', 40.068251, -93.579936, 2126, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3220, N'Scotland County  Hospital', 1, NULL, NULL, N'261310', NULL, NULL, 0, 25, NULL, N'6604658511', N'6604652513', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 E Sigler Avenue', N'Memphis', N'MO', N'29199', N'63555', 40.466023, -92.168171, 2103, 105, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3221, N'Perry County Memorial Hospital', 1, NULL, NULL, N'261311', NULL, NULL, 0, 25, NULL, N'5735472530', N'5735472530', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'434 North West Street', N'Perryville', N'MO', N'29157', N'63775', 37.730621, -89.864818, 2111, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3222, N'Harrison County Community Hospital', 1, NULL, NULL, N'261312', NULL, NULL, 0, 19, NULL, N'6604250284', N'6604252366', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Miller Street', N'Bethany', N'MO', N'29081', N'64424', 40.265292, -94.026145, 2062, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3223, N'Macon County Samaritan Memorial Hospital', 1, NULL, NULL, N'261313', NULL, NULL, 0, 25, NULL, N'6603858700', N'6603854772', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1205 North Missouri St', N'Macon', N'MO', N'29121', N'63552', 39.747907, -92.468134, 2100, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3224, N'Hermann Area District Hospital', 1, NULL, NULL, N'261314', NULL, NULL, 0, 25, NULL, N'5734862191', N'5734863743', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 W 18Th St', N'Hermann', N'MO', N'29073', N'65041', 38.692309, -91.448615, 2086, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3225, N'Parkland Health Center - Bonne Terre', 1, NULL, NULL, N'261315', NULL, NULL, 0, 3, NULL, N'5733581400', N'5737608168', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7245 Raider Road', N'Bonne Terre', N'MO', N'29187', N'63628', 37.917133, -90.53831, 2081, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3226, N'Mercy Hospital Aurora', 1, NULL, NULL, N'261316', NULL, NULL, 0, 25, NULL, N'4176782122', N'4176787877', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Porter Avenue', N'Aurora', N'MO', N'29109', N'65605', 36.97051, -93.710962, 2061, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3227, N'Mercy Hospital Cassville', 1, NULL, NULL, N'261317', NULL, NULL, 0, 18, NULL, N'4178476065', N'4178476073', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94 Main Street', N'Cassville', N'MO', N'29009', N'65625', 36.673903, -93.87227, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3228, N'Salem Memorial District Hospital', 1, NULL, NULL, N'261318', NULL, NULL, 0, 25, NULL, N'5737296626', N'5737294511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 774', N'Salem', N'MO', N'29065', N'65560', 37.645599, -91.535981, 2117, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3229, N'Mercy Hospital Lincoln', 1, NULL, NULL, N'261319', NULL, NULL, 0, 25, NULL, N'6365288551', N'6365283444', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Cherry Street', N'Troy', N'MO', N'29113', N'63379', 38.985142, -90.956513, 2127, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3230, N'Lafayette Regional Health Center', 1, NULL, NULL, N'261320', NULL, NULL, 0, 25, NULL, N'6602592203', N'6602596819', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 State Street', N'Lexington', N'MO', N'29107', N'64067', 39.189134, -93.876596, 2097, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3231, N'Hedrick Medical Center', 1, NULL, NULL, N'261321', NULL, NULL, 0, 25, NULL, N'6606461480', N'6606466024', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2799 North Washington Street', N'Chillicothe', N'MO', N'29117', N'64601', 39.818782, -93.552323, 2072, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3232, N'Excelsior Springs Hospital', 1, NULL, NULL, N'261322', NULL, NULL, 0, 25, NULL, N'8166306081', N'8166292701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Rainbow Boulevard', N'Excelsior Springs', N'MO', N'29047', N'64024', 39.363071, -94.237822, 2079, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3233, N'Cedar County Memorial Hospital', 1, NULL, NULL, N'261323', NULL, NULL, 0, 25, NULL, N'4178762511', N'4178763812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 South Park Street', N'El Dorado Springs', N'MO', N'29039', N'64744', 37.860289, -94.017493, 2077, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3234, N'Cass Regional Medical Center', 1, NULL, NULL, N'261324', NULL, NULL, 0, 35, NULL, N'8163805888', N'8163804639', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 E Rock Haven Road', N'Harrisonville', N'MO', N'29037', N'64701', 38.663345, -94.375315, 2084, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3235, N'Barton County Memorial Hospital', 1, NULL, NULL, N'261325', NULL, NULL, 0, 25, NULL, N'4176826081', N'4176822138', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 Nw 1St Lane', N'Lamar', N'MO', N'29011', N'64759', 37.502011, -94.300034, 2095, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3236, N'Ray County Memorial Hospital', 1, NULL, NULL, N'261327', NULL, NULL, 0, 25, NULL, N'8164705432', N'8164702331', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'904 Wollard Boulevard', N'Richmond', N'MO', N'29177', N'64085', 39.263928, -93.955821, 2115, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3237, N'Northwest Medical Center', 1, NULL, NULL, N'261328', NULL, NULL, 0, 25, NULL, N'6607263941', N'6607263647', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 N College Street', N'Albany', N'MO', N'29075', N'64402', 40.252041, -94.325477, 2059, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3238, N'Cox Monett Hospital', 1, NULL, NULL, N'261329', NULL, NULL, 0, 25, NULL, N'4173541400', N'4173541412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 North Lincoln Avenue', N'Monett', N'MO', N'29009', N'65708', 36.926831, -93.93125, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3239, N'Ste Genevieve County Memorial Hospital', 1, NULL, NULL, N'261330', NULL, NULL, 0, 25, NULL, N'5738832751', N'5738837755', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Ste Genevieve Drive Po Box 468', N'Sainte Genevieve', N'MO', NULL, N'63670', 37.968178, -90.051629, 2125, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3240, N'Freeman Neosho Hospital', 1, NULL, NULL, N'261331', NULL, NULL, 0, 25, NULL, N'4174511234', N'4174554355', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 West Hickory Street', N'Neosho', N'MO', N'29145', N'64850', 36.867664, -94.369884, 2106, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3241, N'Carroll County Memorial Hospital', 1, NULL, NULL, N'261332', NULL, NULL, 0, 25, NULL, N'6605421695', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1502 North Jefferson', N'Carrollton', N'MO', N'29033', N'64633', 39.37345, -93.494147, 2070, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3242, N'Pike County Memorial Hospital', 1, NULL, NULL, N'261333', NULL, NULL, 0, 25, NULL, N'5737545531', N'5737545874', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 West Georgia Street', N'Louisiana', N'MO', N'29163', N'63353', 39.440565, -91.063563, 2099, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3243, N'I-70 Community Hospital', 1, NULL, NULL, N'261334', NULL, NULL, 0, 15, NULL, N'6603354700', N'6603357487', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Hospital Drive Building B', N'Sweet Springs', N'MO', N'29195', N'65351', 38.963629, -93.414932, 2101, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3244, N'Mercy St Francis Hospital', 1, NULL, NULL, N'261335', NULL, NULL, 0, 25, NULL, N'4179347000', N'4179347092', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Highway 60 Po Box 82', N'Mountain View', N'MO', N'29091', N'65548', 33.340101, -104.523302, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3245, N'Iron County Hospital', 1, NULL, NULL, N'261336', NULL, NULL, 0, 15, NULL, N'5735461260', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 North Highway 21', N'Pilot Knob', N'MO', N'29093', N'63663', 37.621161, -90.640401, 2112, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3246, N'Missouri Baptist Sullivan Hospital', 1, NULL, NULL, N'261337', NULL, NULL, 0, 50, NULL, N'5734684186', N'5738602696', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Sappington Bridge Rd', N'Sullivan', N'MO', N'29071', N'63080', 38.196364, -91.169, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3247, N'Mercy Hospital Carthage', 1, NULL, NULL, N'261338', NULL, NULL, 0, 49, NULL, N'4173588121', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3125 Dr Russell Smith Way', N'Carthage', N'MO', N'29097', N'64836', 37.136705, -94.320884, 2071, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3248, N'Southeast Health Center Of Reynolds County', 1, NULL, NULL, N'261339', NULL, NULL, 0, 25, NULL, N'5733344822', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hwy 21 N', N'Ellington', N'MO', N'29179', N'63638', 37.241715, -90.968736, 2078, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3249, N'Peace Haven Association', 1, NULL, NULL, N'261993', NULL, NULL, 0, 42, NULL, N'3149653833', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12630 Rott Road', N'Saint Louis', N'MO', N'29189', N'63127', 38.550404, -90.418474, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3250, N'Kindred Hospital - St Louis', 1, NULL, NULL, N'262010', NULL, NULL, 0, 60, NULL, N'3143618700', N'3143611210', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4930 Lindell Boulevard', N'Saint Louis', N'MO', N'29510', N'63108', 38.643397, -90.262902, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3251, N'Kindred Hospital - Kansas City', 1, NULL, NULL, N'262011', NULL, NULL, 0, 167, NULL, N'8169952000', N'8169952171', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8701 Troost Avenue', N'Kansas City', N'MO', N'29095', N'64131', 38.968099, -94.574839, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3252, N'Select Specialty Hospital-St Louis', 1, NULL, NULL, N'262013', NULL, NULL, 0, 33, NULL, N'3147683400', N'3147683002', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 First Capitol Drive', N'Saint Charles', N'MO', N'29183', N'63301', 38.780933, -90.484898, 2122, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3253, N'Select Specialty Hospital - Western Missouri', 1, NULL, NULL, N'262014', NULL, NULL, 0, 34, NULL, N'8162769444', N'8162769777', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2316 East Meyer Boulevard 3-West', N'Kansas City', N'MO', N'29095', N'64132', 39.007228, -94.559451, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3254, N'Landmark Hospital Of Cape Girardeau Llc', 1, NULL, NULL, N'262015', NULL, NULL, 0, 30, NULL, N'5733351091', N'5733318453', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3255 Independence Street', N'Cape Girardeau', N'MO', N'29031', N'63703', 37.3078366, -89.5780475, 2069, 162, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3255, N'Landmark Hospital Of Joplin Llc', 1, NULL, NULL, N'262016', NULL, NULL, 0, 30, NULL, N'4177814352', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2040 W 32Nd Street', N'Joplin', N'MO', N'29097', N'64804', 37.0535374, -94.540576, 2090, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3256, N'Select Specialty Hospital Springfield Inc', 1, NULL, NULL, N'262017', NULL, NULL, 0, 44, NULL, N'4178811657', N'4178854777', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1630 East Primrose', N'Springfield', N'MO', N'29077', N'65804', 37.1465259, -93.2685034, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3257, N'Kindred Hospital Northland', 1, NULL, NULL, N'262018', NULL, NULL, 0, 35, NULL, N'8164206300', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Nw 68Th Street', N'Kansas City', N'MO', N'29047', N'64118', 39.217494, -94.587433, 2108, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3258, N'Mosiac Life Care At St Joseph', 1, NULL, NULL, N'262019', NULL, NULL, 0, 41, NULL, N'8162716480', N'8162714077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5325 Faraon Street', N'Saint Joseph', N'MO', N'29021', N'64506', 39.772896, -94.77047, 2123, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3259, N'Landmark Hospital Of Columbia Llc', 1, NULL, NULL, N'262020', NULL, NULL, 0, 42, NULL, N'5734996600', N'5734996651', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 Old Highway 63 North', N'Columbia', N'MO', N'29019', N'65201', 38.9440363, -92.3090372, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3260, N'Kindred Hospital-St Louis At Mercy', 1, NULL, NULL, N'262021', NULL, NULL, 0, 54, NULL, N'3145674326', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 S New Ballas Road 7Th Floor', N'Saint Louis', N'MO', N'29189', N'63141', 38.645489, -90.446079, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3261, N'Rusk Rehabilitation Ctr', 1, NULL, NULL, N'263027', NULL, NULL, 0, 72, NULL, N'5738172703', N'5738174690', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Business Loop 70 W', N'Columbia', N'MO', N'29019', N'65203', 38.967535, -92.361947, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3262, N'The Rehabilitation Institute Of St Louis', 1, NULL, NULL, N'263028', NULL, NULL, 0, 80, NULL, N'3146583925', N'3145341132', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4455 Duncan Ave', N'Saint Louis', N'MO', N'29510', N'63110', 38.635478, -90.252432, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3263, N'Mercy Rehabilitation Hospital St Louis', 1, NULL, NULL, N'263029', NULL, NULL, 0, 68, NULL, N'3148892704', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14561 North Outer Forty', N'Chesterfield', N'MO', N'29189', N'63017', 38.656057, -90.574203, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3264, N'St Luke''s Rehabilitation Hospital', 1, NULL, NULL, N'263030', NULL, NULL, 0, 35, NULL, N'3143175700', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14709 Olive Boulevard', N'Chesterfield', N'MO', N'29189', N'63017', 38.674623, -90.532112, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3265, N'Ssm Rehabilitation Hospital', 1, NULL, NULL, N'263031', NULL, NULL, 0, 95, NULL, N'3147685202', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 Bellevue Avenue', N'Richmond Heights', N'MO', N'29189', N'63117', 38.632958, -90.312166, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3266, N'Mercy Rehabilitation Hospital Springfield', 1, NULL, NULL, N'263032', NULL, NULL, 0, 60, NULL, N'4178202973', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5904 S Southwood Rd', N'Springfield', N'MO', N'29077', N'65804', 37.215331, -93.298252, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3267, N'St Louis Childrens Hospital', 1, NULL, NULL, N'263301', NULL, NULL, 0, 235, NULL, N'3144546000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Childrens Place', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3268, N'Childrens Mercy Hospital', 1, NULL, NULL, N'263302', NULL, NULL, 0, 263, NULL, N'8162343000', N'8162343793', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 Gillham Road', N'Kansas City', N'MO', N'29095', N'64108', 39.085393, -94.578985, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3269, N'Ranken Jordan A Pediatric Rehab', 1, NULL, NULL, N'263303', NULL, NULL, 0, 30, NULL, N'3148726400', N'3148726500', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11365 Dorsett Road', N'Maryland Heights', N'MO', N'29189', N'63043', 38.711047, -90.417431, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3270, N'Shriners Hospitals For Children', 1, NULL, NULL, N'263304', NULL, NULL, 0, 80, NULL, N'3144323600', N'3144322930', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4400 Clayton Ave', N'Saint Louis', N'MO', N'29510', N'63110', 38.632224, -90.258243, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3271, N'Fulton State Hospital', 1, NULL, NULL, N'264004', NULL, NULL, 0, 484, NULL, N'5735924100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 East 5Th Street', N'Fulton', N'MO', N'29027', N'65251', 38.847019, -91.939708, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3272, N'Southeast Missouri Mental Hlth Ctr', 1, NULL, NULL, N'264005', NULL, NULL, 0, 196, NULL, N'5732186792', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 West Columbia Street', N'Farmington', N'MO', N'29187', N'63640', 37.773927, -90.439018, 2081, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3273, N'Northwest Mo Psychiatric Rehab Ctr', 1, NULL, NULL, N'264007', NULL, NULL, 0, 142, NULL, N'8163872300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3505 Frederick Avenue', N'Saint Joseph', N'MO', N'29021', N'64502', 39.767542, -94.849154, 2123, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3274, N'Center For Behavioral Medicine', 1, NULL, NULL, N'264008', NULL, NULL, 0, 160, NULL, N'8165127000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 E 24Th Street', N'Kansas City', N'MO', N'29095', N'64108', 39.083813, -94.57207, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3275, N'St Louis Psychiatric Rehab Center', 1, NULL, NULL, N'264010', NULL, NULL, 0, 216, NULL, N'3146448000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 Arsenal St', N'Saint Louis', N'MO', N'29510', N'63139', 38.60594, -90.279496, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3276, N'Centerpointe Hospital', 1, NULL, NULL, N'264012', NULL, NULL, 0, 104, NULL, N'6364417300', N'6364772165', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4801 Weldon Spring Parkway', N'Saint Charles', N'MO', N'29183', N'63304', 38.783194, -90.482368, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3277, N'Two Rivers Behavioral Health System', 1, NULL, NULL, N'264017', NULL, NULL, 0, 105, NULL, N'8163565688', N'8163566147', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5121 Raytown Road', N'Kansas City', N'MO', N'29095', N'64133', 39.044348, -94.488761, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3278, N'Crittenton Children''s Center', 1, NULL, NULL, N'264018', NULL, NULL, 0, 75, NULL, N'8167656600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10918 Elm Avenue', N'Kansas City', N'MO', N'29095', N'64134', 38.92424, -94.481397, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3279, N'Royal Oaks Hospital', 1, NULL, NULL, N'264020', NULL, NULL, 0, 41, NULL, N'6606472182', N'6606472217', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'307 N Main', N'Windsor', N'MO', N'29083', N'65360', 38.53224, -93.522154, 2073, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3280, N'Lakeland Behavioral Health System', 1, NULL, NULL, N'264024', NULL, NULL, 0, 106, NULL, N'4178655581', N'4178655964', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 S Market', N'Springfield', N'MO', N'29077', N'65806', 37.215331, -93.298252, 2121, 166, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3281, N'Metropolitan St Louis Psychiatric Ctr', 1, NULL, NULL, N'264025', NULL, NULL, 0, 125, NULL, N'3148770500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5351 Delmar Boulevard', N'Saint Louis', N'MO', N'29510', N'63112', 38.65307, -90.274735, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3282, N'Hawthorn Children''s Psychiatric Hospital', 1, NULL, NULL, N'264028', NULL, NULL, 0, 44, NULL, N'3145127800', N'3145127812', 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Pennsylvania Avenue', N'Saint Louis', N'MO', N'29189', N'63133', 38.686541, -90.313809, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3283, N'St Louis Regional Psychiatric Stabilization Center', 1, NULL, NULL, N'264029', NULL, NULL, 0, 25, NULL, N'3149327110', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5355 Delmar Blvd', N'Saint Louis', N'MO', N'29510', N'63112', 38.653071, -90.274743, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3284, N'Signature Psychiatric Hospital', 1, NULL, NULL, N'264030', NULL, NULL, 0, 24, NULL, N'8166915101', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Clay Edwards Drive', N'North Kansas City', N'MO', N'29047', N'64116', 39.130004, -94.562177, 2108, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3285, N'St Luke''s Hospital Of Kansas City', 1, NULL, NULL, N'269800', NULL, NULL, 0, 0, NULL, N'8169322000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4401 Wornall Road', N'Kansas City', N'MO', N'29095', N'64111', 39.046483, -94.590033, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3286, N'Research Medical Center', 1, NULL, NULL, N'269801', NULL, NULL, 0, 0, NULL, N'8162764000', N'8162764387', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2316 East Meyer Boulevard', N'Kansas City', N'MO', N'29095', N'64132', 39.007228, -94.559451, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3287, N'St Louis University Hospital', 1, NULL, NULL, N'269802', NULL, NULL, 0, 0, NULL, N'3145778000', N'3145778003', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3635 Vista Ave Po Box 15250', N'Saint Louis', N'MO', N'29510', N'63111', 38.622635, -90.239517, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3288, N'Barnes-Jewish Hospital', 1, NULL, NULL, N'269803', NULL, NULL, 0, 0, NULL, N'3147473000', N'3143620468', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'216 South Kingshighway', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3289, N'University Of Mo Hospital & Clinics', 1, NULL, NULL, N'269804', NULL, NULL, 0, 0, NULL, N'5738824141', N'5738844174', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive Room Ce121 Dc03100', N'Columbia', N'MO', N'29019', N'65212', 38.951883, -92.333737, 2074, 163, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3290, N'St Louis Children''s Hospital', 1, NULL, NULL, N'269805', NULL, NULL, 0, 0, NULL, N'3144546000', N'3144542101', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Children''s Place', N'Saint Louis', N'MO', N'29510', N'63110', 38.627273, -90.197889, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3291, N'The Children''s Mercy Hospital', 1, NULL, NULL, N'269806', NULL, NULL, 0, 0, NULL, N'8162343000', N'8162343793', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 Gillham Road', N'Kansas City', N'MO', N'29095', N'64108', 39.083487, -94.578741, 2091, 165, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3292, N'Ssm Cardinal Glennon Children''s Hospital', 1, NULL, NULL, N'269807', NULL, NULL, 0, 0, NULL, N'3145775600', N'3145775304', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1465 South Grand Boulevard', N'Saint Louis', N'MO', N'29510', N'63104', 38.621436, -90.23843, 2124, 167, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3293, N'St Peter''s Hospital', 1, NULL, NULL, N'270003', NULL, NULL, 0, 99, NULL, N'4064422480', N'4064442389', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2475 Broadway', N'Helena', N'MT', N'30049', N'59601', 46.584234, -111.994817, 2148, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3294, N'Billings Clinic Hospital', 1, NULL, NULL, N'270004', NULL, NULL, 0, 304, NULL, N'4066574000', N'4062382785', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 10Th Ave N', N'Billings', N'MT', N'30111', N'59101', 45.790372, -108.51431, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3295, N'Benefis Hospitals Inc', 1, NULL, NULL, N'270012', NULL, NULL, 0, 398, NULL, N'4064555000', N'4064554587', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 26Th St S', N'Great Falls', N'MT', N'30013', N'59405', 47.493154, -111.262606, 2144, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3296, N'St Patrick Hospital', 1, NULL, NULL, N'270014', NULL, NULL, 0, 253, NULL, N'4065437271', N'4063295693', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W Broadway', N'Missoula', N'MT', N'30063', N'59806', 46.873905, -113.999891, 2155, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3297, N'St James Healthcare', 1, NULL, NULL, N'270017', NULL, NULL, 0, 98, NULL, N'4067232500', N'4067232486', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S Clark St', N'Butte', N'MT', N'30093', N'59701', 46.008582, -112.546375, 2135, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3298, N'Community Medical Center', 1, NULL, NULL, N'270023', NULL, NULL, 0, 151, NULL, N'4067284100', N'4063274545', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2827 Fort Missoula Rd', N'Missoula', N'MT', N'30063', N'59804', 46.845324, -114.047142, 2155, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3299, N'Northern Montana Hospital', 1, NULL, NULL, N'270032', NULL, NULL, 0, 49, NULL, N'4062652211', N'4062651651', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 13Th St', N'Havre', N'MT', N'30041', N'59501', 48.539326, -109.686089, 2147, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3300, N'St Vincent Healthcare', 1, NULL, NULL, N'270049', NULL, NULL, 0, 286, NULL, N'4066577000', N'4062373078', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1233 N 30Th St', N'Billings', N'MT', N'30111', N'59101', 45.793541, -108.520657, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3301, N'Kalispell Regional Medical Center', 1, NULL, NULL, N'270051', NULL, NULL, 0, 160, NULL, N'4067525111', N'4067563690', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Sunnyview Lane', N'Kalispell', N'MT', N'30029', N'59901', 48.216148, -114.322773, 2149, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3302, N'Bozeman Deaconess Hospital', 1, NULL, NULL, N'270057', NULL, NULL, 0, 86, NULL, N'4065855000', N'4065851070', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 Highland Blvd', N'Bozeman', N'MT', N'30031', N'59715', 45.66787, -111.019875, 2134, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3303, N'P H S Indian Hospital At Browning - Blackfeet', 1, NULL, NULL, N'270074', NULL, NULL, 0, 28, NULL, N'4063386157', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'760 Hospital Circle Post Office Box 760', N'Browning', N'MT', N'30035', N'59417', 48.556877, -113.013045, 2171, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3304, N'Great Falls Clinic Medical Center', 1, NULL, NULL, N'270086', NULL, NULL, 0, 20, NULL, N'4062168000', N'4062168001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 9Th St S', N'Great Falls', N'MT', N'30013', N'59405', 47.489711, -111.292244, 2144, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3305, N'The Healthcenter', 1, NULL, NULL, N'270087', NULL, NULL, 0, 30, NULL, N'4067564720', N'4067515430', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Sunnyview Lane', N'Kalispell', N'MT', N'30029', N'59901', 48.216097, -114.322644, 2149, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3306, N'Poplar Community Hospital', 1, NULL, NULL, N'271300', NULL, NULL, 0, 20, NULL, N'4067686100', N'4067686160', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 H St E', N'Poplar', N'MT', N'30085', N'59255', 48.114941, -105.197204, 2159, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3307, N'Fallon Medical Complex Hospital', 1, NULL, NULL, N'271301', NULL, NULL, 0, 25, NULL, N'4067783331', N'4067782488', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 S 4Th St W', N'Baker', N'MT', N'30025', N'59313', 46.364754, -104.281438, 2132, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3308, N'Dahl Memorial Healthcare Assoc', 1, NULL, NULL, N'271302', NULL, NULL, 0, 25, NULL, N'4067758739', N'4067756706', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Sandy St', N'Ekalaka', N'MT', N'30011', N'59324', 45.88762, -104.549067, 2132, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3309, N'Granite County Medical Center', 1, NULL, NULL, N'271303', NULL, NULL, 0, 25, NULL, N'4068593271', N'4068593011', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Sansome St', N'Philipsburg', N'MT', N'30039', N'59858', 46.332755, -113.294207, 2155, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3310, N'Missouri River Medical Center', 1, NULL, NULL, N'271304', NULL, NULL, 0, 7, NULL, N'4066223331', N'4066225670', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 St Charles St', N'Fort Benton', N'MT', N'30015', N'59442', 47.8202, -110.673058, 2144, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3311, N'Mccone County Health Center', 1, NULL, NULL, N'271305', NULL, NULL, 0, 25, NULL, N'4064853381', N'4064853383', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Sullivan Ave', N'Circle', N'MT', N'30055', N'59215', 47.418937, -105.581834, 2165, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3312, N'Mountainview Medical Center', 1, NULL, NULL, N'271306', NULL, NULL, 0, 25, NULL, N'4065473321', N'4065473589', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 W Main St', N'White Sulphur Spring', N'MT', N'30059', N'59645', 46.548205, -110.903471, 2168, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3313, N'Benefis Teton Medical Center', 1, NULL, NULL, N'271307', NULL, NULL, 0, 10, NULL, N'4064665763', N'4064665852', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 4Th St Nw', N'Choteau', N'MT', N'30099', N'59422', 47.813417, -112.192174, 2144, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3314, N'Roosevelt Medical Center', 1, NULL, NULL, N'271308', NULL, NULL, 0, 25, NULL, N'4067876401', N'4067876461', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'818 2Nd Ave E', N'Culbertson', N'MT', N'30085', N'59218', 48.150775, -104.515387, 2642, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3315, N'Prairie Community Hospital', 1, NULL, NULL, N'271309', NULL, NULL, 0, 22, NULL, N'4066355511', N'4066355510', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 S Adams', N'Terry', N'MT', N'30079', N'59349', 46.793063, -105.312209, 2154, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3316, N'Garfield County Health Center', 1, NULL, NULL, N'271310', NULL, NULL, 0, 4, NULL, N'4065572500', N'4065572950', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'332 Leavitt Ave', N'Jordan', N'MT', N'30033', N'59337', 47.3186, -106.91176, 2154, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3317, N'Big Sandy Medical Center', 1, NULL, NULL, N'271311', NULL, NULL, 0, 8, NULL, N'4063782188', N'4063782180', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'166 Montana Ave E', N'Big Sandy', N'MT', N'30015', N'59520', 48.179132, -110.108301, 2144, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3318, N'Phillips County Medical Center', 1, NULL, NULL, N'271312', NULL, NULL, 0, 6, NULL, N'4066541100', N'4066542876', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 S 8Th Ave E', N'Malta', N'MT', N'30071', N'59538', 48.356658, -107.860355, 2153, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3319, N'Pioneer Medical Center', 1, NULL, NULL, N'271313', NULL, NULL, 0, 25, NULL, N'4069324603', N'4069325468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 W 7Th Ave', N'Big Timber', N'MT', N'30097', N'59011', 45.828448, -109.952479, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3320, N'Deer Lodge Medical Center', 1, NULL, NULL, N'271314', NULL, NULL, 0, 16, NULL, N'4068462212', N'4068463074', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Hollenback Ln', N'Deer Lodge', N'MT', N'30077', N'59722', 46.395761, -112.730038, 2139, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3321, N'P H S Indian Hospital-Ft Belknap At Harlem - Cah', 1, NULL, NULL, N'271315', NULL, NULL, 0, 6, NULL, N'4063533100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'456 Gros Ventre Ave Rr 1', N'Harlem', N'MT', N'30005', N'59526', 48.533331, -108.784046, 2147, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3322, N'Frances Mahon Deaconess Hospital', 1, NULL, NULL, N'271316', NULL, NULL, 0, 25, NULL, N'4062283500', N'4062283680', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 3Rd St S', N'Glasw', N'MT', N'30105', N'59230', 48.189871, -106.636382, 2142, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3323, N'Livingston Healthcare', 1, NULL, NULL, N'271317', NULL, NULL, 0, 25, NULL, N'4062223541', N'4068236434', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 S 13Th St', N'Livingston', N'MT', N'30067', N'59047', 45.649368, -110.568518, 2152, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3324, N'Barrett Memorial Hospital', 1, NULL, NULL, N'271318', NULL, NULL, 0, 18, NULL, N'4066833000', N'4066833206', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mt Hwy 91 S', N'Dillon', N'MT', N'30001', N'59725', 45.216416, -112.637844, 2140, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3325, N'Ruby Valley Hospital', 1, NULL, NULL, N'271319', NULL, NULL, 0, 10, NULL, N'4068425453', N'4068425455', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 E Crofoot', N'Sheridan', N'MT', N'30057', N'59749', 45.453523, -112.191046, 2164, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3326, N'Cabinet Peaks Medical Center', 1, NULL, NULL, N'271320', NULL, NULL, 0, 25, NULL, N'4062930100', N'4062934428', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Health Park Dr', N'Libby', N'MT', N'30053', N'59923', 48.388286, -115.555999, 2151, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3327, N'Wheatland Memorial Hospital', 1, NULL, NULL, N'271321', NULL, NULL, 0, 25, NULL, N'4066324351', N'4066323172', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 3Rd St Nw', N'Harlowton', N'MT', N'30107', N'59036', 46.437062, -109.841352, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3328, N'Sheridan Memorial Hosptial', 1, NULL, NULL, N'271322', NULL, NULL, 0, 19, NULL, N'4067653700', N'4067653800', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 W Laurel Ave', N'Plentywood', N'MT', N'30091', N'59254', 48.778676, -104.563076, 2157, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3329, N'Clark Fork Valley Hospital', 1, NULL, NULL, N'271323', NULL, NULL, 0, 16, NULL, N'4068264800', N'4068264811', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Kruger Rd', N'Plains', N'MT', N'30089', N'59859', 47.469541, -114.892304, 2156, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3330, N'Pondera Medical Center', 1, NULL, NULL, N'271324', NULL, NULL, 0, 20, NULL, N'4062713211', N'4062713917', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Sunset Blvd', N'Conrad', N'MT', N'30073', N'59425', 48.173911, -111.958354, 2137, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3331, N'St Luke Community Hospital', 1, NULL, NULL, N'271325', NULL, NULL, 0, 25, NULL, N'4066764441', N'4066760835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 6Th Ave Sw', N'Ronan', N'MT', N'30047', N'59864', 47.528202, -114.106257, 2161, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3332, N'Beartooth Billings Clinic', 1, NULL, NULL, N'271326', NULL, NULL, 0, 10, NULL, N'4064462345', N'4064460031', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 N Broadway', N'Red Lodge', N'MT', N'30009', N'59068', 45.185778, -109.246821, 2160, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3333, N'Rosebud Health Care Center', 1, NULL, NULL, N'271327', NULL, NULL, 0, 24, NULL, N'4063462161', N'4063464255', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'383 N 17Th Av', N'Forsyth', N'MT', N'30087', N'59327', 46.272069, -106.671401, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3334, N'Marias Medical Center', 1, NULL, NULL, N'271328', NULL, NULL, 0, 25, NULL, N'4064343200', N'4064343213', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Park Dr', N'Shelby', N'MT', N'30101', N'59474', 48.508827, -111.849993, 2163, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3335, N'Madison Valley Medical Center', 1, NULL, NULL, N'271329', NULL, NULL, 0, 10, NULL, N'4066824222', N'4066824756', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 N Main', N'Ennis', N'MT', N'30057', N'59729', 45.348817, -111.729697, 2141, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3336, N'Stillwater Billings Clinic', 1, NULL, NULL, N'271330', NULL, NULL, 0, 10, NULL, N'4063225316', N'4063225207', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 N 11Th St', N'Columbus', N'MT', N'30095', N'59019', 45.642375, -109.243227, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3337, N'Mineral Community Hospital', 1, NULL, NULL, N'271331', NULL, NULL, 0, 25, NULL, N'4068224841', N'4068224963', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1208 6Th Ave E', N'Superior', N'MT', N'30061', N'59872', 47.191594, -114.891798, 2166, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3338, N'Glendive Medical Center', 1, NULL, NULL, N'271332', NULL, NULL, 0, 25, NULL, N'4063453306', N'4063453358', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Prospect Dr', N'Glendive', N'MT', N'30021', N'59330', 47.117147, -104.704905, 2143, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3339, N'Broadwater Health Center', 1, NULL, NULL, N'271333', NULL, NULL, 0, 9, NULL, N'4062663186', N'4062663180', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 N Oak St', N'Townsend', N'MT', N'30007', N'59644', 46.321714, -111.516672, 2167, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3340, N'Liberty Medical Center', 1, NULL, NULL, N'271334', NULL, NULL, 0, 25, NULL, N'4067595181', N'4067595799', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 W Madison Ave', N'Chester', N'MT', N'30051', N'59522', 48.510503, -110.968689, 2136, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3341, N'Community Hospital Of Anaconda', 1, NULL, NULL, N'271335', NULL, NULL, 0, 25, NULL, N'4065638500', N'4065638565', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Pennsylvania', N'Anaconda', N'MT', N'30023', N'59711', 46.133247, -112.956877, 2131, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3342, N'North Valley Hospital', 1, NULL, NULL, N'271336', NULL, NULL, 0, 25, NULL, N'4068633550', N'4068622532', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Hospital Way', N'Whitefish', N'MT', N'30029', N'59937', 48.381049, -114.332781, 2169, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3343, N'Northern Rockies Medical Center', 1, NULL, NULL, N'271337', NULL, NULL, 0, 20, NULL, N'4068732251', N'4068733118', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 2Nd St Se', N'Cut Bank', N'MT', N'30035', N'59427', 48.629596, -112.327737, 2138, 169, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3344, N'Big Horn Co Memorial Hospital', 1, NULL, NULL, N'271338', NULL, NULL, 0, 25, NULL, N'4066652310', N'4066659238', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 N Miles', N'Hardin', N'MT', N'30003', N'59034', 45.728624, -107.617005, 2146, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3345, N'P H S Indian Hospital Crow / Northern Cheyenne', 1, NULL, NULL, N'271339', NULL, NULL, 0, 24, NULL, N'4066382626', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 South 7650 East Post Office Box 9', N'Crow Agency', N'MT', N'30003', N'59022', 45.601641, -107.461194, 2146, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3346, N'Marcus Daly Memorial Hospital - Cah', 1, NULL, NULL, N'271340', NULL, NULL, 0, 25, NULL, N'4063754408', N'4063636536', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Westwood Dr', N'Hamilton', N'MT', N'30081', N'59840', 46.247128, -114.171932, 2145, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3347, N'Trinity Hospital', 1, NULL, NULL, N'271341', NULL, NULL, 0, 22, NULL, N'4066536500', N'4066536589', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Knapp St', N'Wolf Point', N'MT', N'30085', N'59201', 48.100895, -105.640949, 2170, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3348, N'Daniels Memorial Hospital', 1, NULL, NULL, N'271342', NULL, NULL, 0, 24, NULL, N'4064872296', N'4064872471', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 5Th Ave E', N'Scobey', N'MT', N'30019', N'59263', 48.788779, -105.417789, 2162, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3349, N'Providence St Joseph Medical Center', 1, NULL, NULL, N'271343', NULL, NULL, 0, 22, NULL, N'4068835377', N'4068838488', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 13Th Ave E', N'Polson', N'MT', N'30047', N'59860', 47.683344, -114.163327, 2158, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3350, N'Sidney Health Center', 1, NULL, NULL, N'271344', NULL, NULL, 0, 25, NULL, N'4064882100', N'4064882125', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 14Th Ave Sw', N'Sidney', N'MT', N'30083', N'59270', 47.716213, -104.174166, 2165, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3351, N'Central Montana Medical Center', 1, NULL, NULL, N'271345', NULL, NULL, 0, 25, NULL, N'4065357711', N'4065352099', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'408 Wendell Ave', N'Lewistown', N'MT', N'30027', N'59457', 47.058503, -109.442171, 2150, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3352, N'Roundup Memorial Healthcare', 1, NULL, NULL, N'271346', NULL, NULL, 0, 25, NULL, N'4063232301', N'4063233681', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 3Rd St W', N'Roundup', N'MT', N'30065', N'59072', 46.45335, -108.546333, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3353, N'Holy Rosary Healthcare', 1, NULL, NULL, N'271347', NULL, NULL, 0, 25, NULL, N'4062332600', N'4062332611', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Wilson St', N'Miles City', N'MT', N'30017', N'59301', 46.397346, -105.827028, 2154, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3354, N'Advanced Care Hospital Of Montana', 1, NULL, NULL, N'272001', NULL, NULL, 0, 40, NULL, N'4063738000', N'4063738020', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3528 Gabel Rd', N'Billings', N'MT', N'30111', N'59102', 45.741646, -108.606751, 2133, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3355, N'Shodair Children''s Hospital', 1, NULL, NULL, N'274004', NULL, NULL, 0, 20, NULL, N'4064447500', N'4064447588', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2755 Colonial Dr', N'Helena', N'MT', N'30049', N'59601', 46.582611, -111.987659, 2148, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3356, N'Montana State Hospital', 1, NULL, NULL, N'274086', NULL, NULL, 0, 166, NULL, N'4066937000', N'4066937069', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Garnet Way', N'Warm Springs', N'MT', N'30023', N'59756', 46.181315, -112.78476, 2139, 170, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3357, N'Bryan Medical Center', 1, NULL, NULL, N'280003', NULL, NULL, 0, 630, NULL, N'4024811111', N'4024818306', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 South 48Th St', N'Lincoln', N'NE', N'31109', N'68506', 40.796516, -96.653662, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3358, N'Chi Health od Samaritan', 1, NULL, NULL, N'280009', NULL, NULL, 0, 165, NULL, N'3088657100', N'3088652913', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1990 10 East 31St St', N'Kearney', N'NE', N'31019', N'68848', 40.699457, -99.081477, 2210, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3359, N'The Nebraska Medical Center Dba Nebraska Medicine', 1, NULL, NULL, N'280013', NULL, NULL, 0, 689, NULL, N'4025522040', N'4025522152', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'987400 Nebraska Medical Center', N'Omaha', N'NE', N'31055', N'68198', 41.258732, -95.937873, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3360, N'Chi Health St Elizabeth', 1, NULL, NULL, N'280020', NULL, NULL, 0, 265, NULL, N'4022197700', N'4022198973', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 South 70Th St', N'Lincoln', N'NE', N'31109', N'68510', 40.807658, -96.625179, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3361, N'Chi Health St Francis', 1, NULL, NULL, N'280023', NULL, NULL, 0, 130, NULL, N'3083844600', N'3083985589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2620 West Faidley Ave', N'Grand Island', N'NE', N'31079', N'68803', 40.92428, -98.371692, 2202, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3362, N'Chi Health Creighton University Medical Center', 1, NULL, NULL, N'280030', NULL, NULL, 0, 334, NULL, N'4024494000', N'4024495020', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 North 30Th St', N'Omaha', N'NE', N'31055', N'68131', 41.264776, -95.956512, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3363, N'Mary Lanning Healthcare', 1, NULL, NULL, N'280032', NULL, NULL, 0, 163, NULL, N'4024634521', N'4024615321', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 N St Joseph Ave', N'Hastings', N'NE', N'31001', N'68901', 40.591713, -98.388144, 2204, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3364, N'Methodist Hospital', 1, NULL, NULL, N'280040', NULL, NULL, 0, 430, NULL, N'4023544000', N'4023548735', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8303 Dodge St', N'Omaha', N'NE', N'31055', N'68114', 41.259682, -96.0426, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3365, N'Chi Health Bergan Mercy', 1, NULL, NULL, N'280060', NULL, NULL, 0, 400, NULL, N'4023986060', N'4023986920', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Mercy Rd', N'Omaha', N'NE', N'31055', N'68124', 41.237927, -96.032024, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3366, N'Regional West Medical Center', 1, NULL, NULL, N'280061', NULL, NULL, 0, 166, NULL, N'3086353711', N'3086301815', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4021 Ave B', N'Scottsbluff', N'NE', N'31157', N'69361', 41.886902, -103.665858, 2235, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3367, N'Great Plains Health', 1, NULL, NULL, N'280065', NULL, NULL, 0, 116, NULL, N'3086968000', N'3086967199', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 West Leota St', N'North Platte', N'NE', N'31111', N'69101', 41.120749, -100.770364, 2220, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3368, N'Fremont Health Medical Center', 1, NULL, NULL, N'280077', NULL, NULL, 0, 90, NULL, N'4027211610', N'4027273656', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 East 23Rd St', N'Fremont', N'NE', N'31053', N'68025', 41.451472, -96.491721, 2197, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3369, N'Chi Health Immanuel', 1, NULL, NULL, N'280081', NULL, NULL, 0, 356, NULL, N'4025722121', N'4025723177', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 North 72Nd St', N'Omaha', N'NE', N'31055', N'68122', 41.322582, -96.023838, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3370, N'Chi Health Midlands', 1, NULL, NULL, N'280105', NULL, NULL, 0, 131, NULL, N'4025933000', N'4025933117', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11111 South 84Th St', N'Papillion', N'NE', N'31153', N'68046', 41.137517, -96.042918, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3371, N'Columbus Community Hospital', 1, NULL, NULL, N'280111', NULL, NULL, 0, 47, NULL, N'4025647118', N'4025623378', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 38Th St', N'Columbus', N'NE', N'31141', N'68601', 41.453274, -97.385452, 2188, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3372, N'Faith Regional Health Services', 1, NULL, NULL, N'280125', NULL, NULL, 0, 133, NULL, N'4023714880', N'4026447468', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 West Norfolk Ave', N'Norfolk', N'NE', N'31119', N'68701', 42.032526, -97.450942, 2219, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3373, N'Lincoln Surgical Hospital', 1, NULL, NULL, N'280127', NULL, NULL, 0, 21, NULL, N'4024849090', N'4024830476', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 South 70Th St Suite 200', N'Lincoln', N'NE', N'31109', N'68506', 40.795012, -96.624976, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3374, N'Chi Health Nebraska Heart', 1, NULL, NULL, N'280128', NULL, NULL, 0, 63, NULL, N'4023283000', N'4023283010', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 South 91St St', N'Lincoln', N'NE', N'31109', N'68526', 40.736113, -96.595045, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3375, N'Nebraska Orthopaedic Hospital', 1, NULL, NULL, N'280129', NULL, NULL, 0, 24, NULL, N'4026091600', N'4026091020', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2808 South 143Rd Plz', N'Omaha', N'NE', N'31055', N'68144', 41.231963, -96.13557, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3376, N'Chi Health Lakeside', 1, NULL, NULL, N'280130', NULL, NULL, 0, 157, NULL, N'4027178000', N'4027178108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16901 Lakeside Hills Ct', N'Omaha', N'NE', N'31055', N'68130', 41.239042, -96.180551, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3377, N'Midwest Surgical Hospital Llc', 1, NULL, NULL, N'280131', NULL, NULL, 0, 19, NULL, N'4023991900', N'4023991999', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7915 Farnam Drive', N'Omaha', N'NE', N'31055', N'68114', 41.258007, -96.036483, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3378, N'Bellevue Medical Center Dba Nebraska Medicine-Bell', 1, NULL, NULL, N'280132', NULL, NULL, 0, 91, NULL, N'4027633600', N'4027633619', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bellevue Medical Center Dr', N'Bellevue', N'NE', N'31153', N'68123', 41.13639, -95.94586, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3379, N'Nebraska Spine Hospital Llc', 1, NULL, NULL, N'280133', NULL, NULL, 0, 34, NULL, N'4025723000', N'4025722657', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 34400 6901 North 72Nd St Ste 20300', N'Omaha', N'NE', N'31055', N'68122', 41.321824, -96.0235172, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3380, N'Kearney Regional Medical Center', 1, NULL, NULL, N'280134', NULL, NULL, 0, 44, NULL, N'3084553600', N'3084553950', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'804 22Nd Avenue', N'Kearney', N'NE', N'31019', N'68845', 40.6975, -99.0931, 2210, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3381, N'Harlan County Health System', 1, NULL, NULL, N'281300', NULL, NULL, 0, 19, NULL, N'3089282151', N'3089289059', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 836 717 North Brown St', N'Alma', N'NE', N'31083', N'68920', 40.097511, -99.362043, 2175, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3382, N'Fillmore County Hospital', 1, NULL, NULL, N'281301', NULL, NULL, 0, 25, NULL, N'4027593167', N'4027593093', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 193 1900 F Street', N'Geneva', N'NE', N'31059', N'68361', 40.526951, -97.595882, 2198, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3383, N'Pawnee County Memorial Hospital', 1, NULL, NULL, N'281302', NULL, NULL, 0, 17, NULL, N'4028522231', N'4028522098', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 433 600 I St', N'Pawnee City', N'NE', N'31133', N'68420', 40.108333, -96.154451, 2229, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3384, N'Niobrara Valley Hospital', 1, NULL, NULL, N'281303', NULL, NULL, 0, 20, NULL, N'4025692451', N'4025692474', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 118 401 South 5Th Street', N'Lynch', N'NE', N'31015', N'68746', 42.830276, -98.466193, 2214, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3385, N'Thayer County Health Services', 1, NULL, NULL, N'281304', NULL, NULL, 0, 19, NULL, N'4027686041', N'4027684697', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 Park Ave', N'Hebron', N'NE', N'31169', N'68370', 40.160125, -97.59457, 2205, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3386, N'Kimball Health Services', 1, NULL, NULL, N'281305', NULL, NULL, 0, 20, NULL, N'3082351952', N'3082351955', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 South Burg St', N'Kimball', N'NE', N'31105', N'69145', 41.232505, -103.667153, 2211, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3387, N'Kearney County Health Services Hospital', 1, NULL, NULL, N'281306', NULL, NULL, 0, 25, NULL, N'3088323400', N'3088323417', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 East 1St St', N'Minden', N'NE', N'31099', N'68959', 40.495777, -98.943308, 2216, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3388, N'Saunders Medical Center', 1, NULL, NULL, N'281307', NULL, NULL, 0, 16, NULL, N'4024434191', N'4024431433', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1760 County Rd J', N'Wahoo', N'NE', N'31155', N'68066', 41.19156, -96.634852, 2243, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3389, N'Henderson Health Care Services', 1, NULL, NULL, N'281308', NULL, NULL, 0, 13, NULL, N'4027234512', N'4027234520', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1621 Front Street', N'Henderson', N'NE', N'31185', N'68371', 40.782773, -97.807664, 2206, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3390, N'Community Memorial Hospital', 1, NULL, NULL, N'281309', NULL, NULL, 0, 18, NULL, N'4022692011', N'4022692795', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box N 1579 Midland St', N'Syracuse', N'NE', N'31131', N'68446', 40.657224, -96.186397, 2240, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3391, N'Regional West Garden County Hospital', 1, NULL, NULL, N'281310', NULL, NULL, 0, 10, NULL, N'3087723283', N'3087721079', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West 2Nd St', N'Oshkosh', N'NE', N'31069', N'69154', 41.41176, -102.347582, 2227, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3392, N'Franklin County Memorial Hospital', 1, NULL, NULL, N'281311', NULL, NULL, 0, 14, NULL, N'3084256221', N'3084253164', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 315 1406 Q St', N'Franklin', N'NE', N'31061', N'68939', 40.096124, -98.952581, 2196, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3393, N'Genoa Community Hospital', 1, NULL, NULL, N'281312', NULL, NULL, 0, 20, NULL, N'4029932283', N'4029932373', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 310 606/706 Ewing Ave', N'Genoa', N'NE', N'31125', N'68640', 41.447948, -97.733255, 2199, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3394, N'thenburg Memorial Hospital', 1, NULL, NULL, N'281313', NULL, NULL, 0, 12, NULL, N'3085373661', N'3085373074', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 20Th St', N'thenburg', N'NE', N'31047', N'69138', 40.938131, -100.153851, 2201, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3395, N'Annie Jeffrey Memorial County Health Center', 1, NULL, NULL, N'281314', NULL, NULL, 0, 21, NULL, N'4027472031', N'4027471405', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 428 531 Beebe St', N'Osceola', N'NE', N'31143', N'68651', 41.179989, -97.547319, 2226, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3396, N'Brodstone Memorial Hosp', 1, NULL, NULL, N'281315', NULL, NULL, 0, 25, NULL, N'4028793281', N'4028793401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 187 520 East 10Th St', N'Superior', N'NE', N'31129', N'68978', 40.020847, -98.070044, 2239, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3397, N'Webster County Community Hospital', 1, NULL, NULL, N'281316', NULL, NULL, 0, 16, NULL, N'4027465600', N'4027465687', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 465 621 N Franklin St', N'Red Cloud', N'NE', N'31181', N'68970', 40.088903, -98.519505, 2232, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3398, N'Morrill County Community Hospital', 1, NULL, NULL, N'281318', NULL, NULL, 0, 20, NULL, N'3082621616', N'3082620843', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 S Street', N'Bridgeport', N'NE', N'31123', N'69336', 41.662149, -103.091381, 2235, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3399, N'Jefferson Community Health Center', 1, NULL, NULL, N'281319', NULL, NULL, 0, 17, NULL, N'4027293351', N'4027292102', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 277 2200 H St', N'Fairbury', N'NE', N'31095', N'68352', 40.137225, -97.180591, 2194, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3400, N'Memorial Hospital', 1, NULL, NULL, N'281320', NULL, NULL, 0, 25, NULL, N'4026943171', N'4026945024', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1423 Seventh St', N'Aurora', N'NE', N'31081', N'68818', 40.871235, -98.009491, 2178, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3401, N'Oakland Mercy Hospital', 1, NULL, NULL, N'281321', NULL, NULL, 0, 18, NULL, N'4026855601', N'4026856223', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 East Second St', N'Oakland', N'NE', N'31021', N'68045', 41.834548, -96.461248, 2222, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3402, N'St Francis Memorial Hospital', 1, NULL, NULL, N'281322', NULL, NULL, 0, 25, NULL, N'4023722404', N'4023722360', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 North Monitor St', N'West Point', N'NE', N'31039', N'68788', 41.843232, -96.706756, 2245, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3403, N'Chi Health Schuyler', 1, NULL, NULL, N'281323', NULL, NULL, 0, 25, NULL, N'4023522441', N'4023522643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 West 17Th St', N'Schuyler', N'NE', N'31037', N'68661', 41.454579, -97.059725, 2234, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3404, N'Nemaha County Hospital', 1, NULL, NULL, N'281324', NULL, NULL, 0, 20, NULL, N'4022744366', N'4022744399', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2022  13Th St', N'Auburn', N'NE', N'31127', N'68305', 40.391568, -95.853223, 2177, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3405, N'Brown County Hospital', 1, NULL, NULL, N'281325', NULL, NULL, 0, 25, NULL, N'4023872800', N'4023872804', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'945 East Zero St', N'Ainsworth', N'NE', N'31017', N'69210', 42.544919, -99.850791, 2172, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3406, N'Antelope Memorial Hospital', 1, NULL, NULL, N'281326', NULL, NULL, 0, 25, NULL, N'4028874151', N'4028876397', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 229 102 West 9Th St', N'Neligh', N'NE', N'31003', N'68756', 42.128618, -98.029789, 2218, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3407, N'Cozad Community Hospital', 1, NULL, NULL, N'281327', NULL, NULL, 0, 21, NULL, N'3087842261', N'3087844691', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 108 300 East 12Th St', N'Cozad', N'NE', N'31047', N'69130', 40.859729, -99.987344, 2189, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3408, N'Litzenberg Memorial County Hospital', 1, NULL, NULL, N'281328', NULL, NULL, 0, 20, NULL, N'3089463015', N'3089462633', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1715  26Th St', N'Central City', N'NE', N'31121', N'68826', 41.106582, -98.002156, 2186, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3409, N'Avera St Anthony''s Hospital', 1, NULL, NULL, N'281329', NULL, NULL, 0, 25, NULL, N'4023362611', N'4023365135', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North 2Nd St', N'O'' Neill', N'NE', N'31089', N'68763', 42.460534, -98.651118, 2221, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3410, N'Warren Memorial Hospital', 1, NULL, NULL, N'281330', NULL, NULL, 0, 14, NULL, N'4029472541', N'4029472811', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 Second St', N'Friend', N'NE', N'31151', N'68359', 40.653692, -97.281901, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3411, N'Avera Creighton Hospital', 1, NULL, NULL, N'281331', NULL, NULL, 0, 23, NULL, N'4023585700', N'4023585769', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 186 1503 Main St', N'Creighton', N'NE', N'31107', N'68729', 42.466671, -97.906178, 2191, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3412, N'Butler County Health Care Center', 1, NULL, NULL, N'281332', NULL, NULL, 0, 20, NULL, N'4023671200', N'8552973221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'372 South 9Th St', N'David City', N'NE', N'31023', N'68632', 41.246044, -97.123038, 2193, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3413, N'Rock County Hospital', 1, NULL, NULL, N'281333', NULL, NULL, 0, 24, NULL, N'4026843366', N'4026843677', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 East South Street', N'Bassett', N'NE', N'31149', N'68714', 42.575763, -99.536578, 2179, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3414, N'Boone County Health Center', 1, NULL, NULL, N'281334', NULL, NULL, 0, 25, NULL, N'4023952191', N'4023955165', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 151 723 West Fairview St', N'Albion', N'NE', N'31011', N'68620', 41.690844, -98.003672, 2173, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3415, N'Callaway District Hospital', 1, NULL, NULL, N'281335', NULL, NULL, 0, 12, NULL, N'3088362228', N'3088362733', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 100 211 E Kimball St', N'Callaway', N'NE', N'31041', N'68825', 41.29195, -99.922621, 2184, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3416, N'York General Hospital', 1, NULL, NULL, N'281336', NULL, NULL, 0, 25, NULL, N'4023626671', N'4023620499', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Lincoln Ave', N'York', N'NE', N'31185', N'68467', 40.842074, -97.598134, 2246, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3417, N'Howard County Medical Center', 1, NULL, NULL, N'281338', NULL, NULL, 0, 25, NULL, N'3087544421', N'3087544429', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 406 1113 Sherman St', N'St Paul', N'NE', N'31093', N'68873', 41.214729, -98.457537, 2238, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3418, N'Memorial Health Care Systems', 1, NULL, NULL, N'281339', NULL, NULL, 0, 25, NULL, N'4026432971', N'4026464605', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Columbia Ave', N'Seward', N'NE', N'31159', N'68434', 40.909667, -97.091909, 2236, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3419, N'Dundy County Hospital', 1, NULL, NULL, N'281340', NULL, NULL, 0, 14, NULL, N'3084232204', N'3084235691', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 626 1313 North Cheyenne St', N'Benkelman', N'NE', N'31057', N'69021', 40.049162, -101.532944, 2181, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3420, N'Chadron Community Hospital And Health Services', 1, NULL, NULL, N'281341', NULL, NULL, 0, 25, NULL, N'3084325586', N'3084322737', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Centennial Drive', N'Chadron', N'NE', N'31045', N'69337', 42.823595, -103.013297, 2187, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3421, N'Chi Health St Mary''s', 1, NULL, NULL, N'281342', NULL, NULL, 0, 18, NULL, N'4028733321', N'4028739033', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Grundman Blvd', N'Nebraska City', N'NE', N'31131', N'68410', 40.658471, -95.860337, 2217, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3422, N'West Holt Memorial Hospital', 1, NULL, NULL, N'281343', NULL, NULL, 0, 18, NULL, N'4029252811', N'4029252810', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 W Neely St', N'Atkinson', N'NE', N'31089', N'68713', 42.528519, -98.983006, 2176, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3423, N'Cherry County Hospital', 1, NULL, NULL, N'281344', NULL, NULL, 0, 25, NULL, N'4023762525', N'4023761627', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 410 510 North Green St', N'Valentine', N'NE', N'31031', N'69201', 42.872783, -100.550967, 2242, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3424, N'Providence Medical Center', 1, NULL, NULL, N'281345', NULL, NULL, 0, 25, NULL, N'4023753800', N'4023757989', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Providence Rd', N'Wayne', N'NE', N'31179', N'68787', 42.240694, -97.008069, 2244, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3425, N'Chi Health Plainview', 1, NULL, NULL, N'281346', NULL, NULL, 0, 19, NULL, N'4025824245', N'4025823940', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 489 704 North Third St', N'Plainview', N'NE', N'31139', N'68769', 42.349727, -97.792009, 2231, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3426, N'Osmond General Hospital', 1, NULL, NULL, N'281347', NULL, NULL, 0, 25, NULL, N'4027483393', N'4027483349', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 429 402 North Maple St', N'Osmond', N'NE', N'31139', N'68765', 42.360003, -97.596728, 2228, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3427, N'Tri Valley Health System', 1, NULL, NULL, N'281348', NULL, NULL, 0, 25, NULL, N'3086973329', N'3086973331', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 West Highway 6/34', N'Cambridge', N'NE', N'31065', N'69022', 40.280354, -100.178916, 2185, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3428, N'Pender Community Hospital', 1, NULL, NULL, N'281349', NULL, NULL, 0, 25, NULL, N'4023853083', N'4023854041', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 100 100 Hospital Drive', N'Pender', N'NE', N'31173', N'68047', 42.114165, -96.707258, 2230, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3429, N'Johnson County Hospital', 1, NULL, NULL, N'281350', NULL, NULL, 0, 18, NULL, N'4023353361', N'4023356342', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 High St', N'Tecumseh', N'NE', N'31097', N'68450', 40.379192, -96.197311, 2241, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3430, N'Chase County Community Hospital', 1, NULL, NULL, N'281351', NULL, NULL, 0, 22, NULL, N'3088827111', N'3088827342', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 819 600 W 12Th St', N'Imperial', N'NE', N'31029', N'69033', 40.51694, -101.643225, 2209, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3431, N'Community Medical Center Inc', 1, NULL, NULL, N'281352', NULL, NULL, 0, 24, NULL, N'4022452428', N'4022456640', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 399 3307 Barada St', N'Falls City', N'NE', N'31147', N'68355', 40.0777163, -95.6101752, 2195, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3432, N'Valley County Health System', 1, NULL, NULL, N'281353', NULL, NULL, 0, 16, NULL, N'3087284200', N'3087287809', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2707 L Street', N'Ord', N'NE', N'31175', N'68862', 41.603189, -98.943024, 2225, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3433, N'Crete Area Medical Center', 1, NULL, NULL, N'281354', NULL, NULL, 0, 25, NULL, N'4028262102', N'4028267950', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 220 2910 Betten Dr', N'Crete', N'NE', N'31151', N'68333', 40.627782, -96.961417, 2192, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3434, N'Ogallala Community Hospital', 1, NULL, NULL, N'281355', NULL, NULL, 0, 18, NULL, N'3082844011', N'3082847262', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 North Spruce St', N'Ogallala', N'NE', N'31101', N'69153', 41.151432, -101.720459, 2223, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3435, N'Perkins County Health Services', 1, NULL, NULL, N'281356', NULL, NULL, 0, 20, NULL, N'3083527200', N'3083527291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Lincoln Ave', N'Grant', N'NE', N'31135', N'69140', 40.847687, -101.726778, 2203, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3436, N'Sidney Regional Medical Center', 1, NULL, NULL, N'281357', NULL, NULL, 0, 25, NULL, N'3082545825', N'3082542300', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Pole Creek Crossing', N'Sidney', N'NE', N'31033', N'69162', 41.138986, -102.972042, 2237, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3437, N'rdon Memorial Hospital District', 1, NULL, NULL, N'281358', NULL, NULL, 0, 25, NULL, N'3082820401', N'3082820431', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 East 8Th St', N'rdon', N'NE', N'31161', N'69343', 42.811836, -102.200385, 2200, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3438, N'Memorial Community Hospital Mch & Health System', 1, NULL, NULL, N'281359', NULL, NULL, 0, 25, NULL, N'4024262182', N'4024261439', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 North 22Nd St', N'Blair', N'NE', N'31177', N'68008', 41.551311, -96.145563, 2182, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3439, N'Box Butte General Hospital', 1, NULL, NULL, N'281360', NULL, NULL, 0, 25, NULL, N'3087626660', N'3087621923', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 810 2101 Box Butte Ave', N'Alliance', N'NE', N'31013', N'69301', 42.101634, -102.872145, 2174, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3440, N'Lexington Regional Health Center', 1, NULL, NULL, N'281361', NULL, NULL, 0, 25, NULL, N'3083245651', N'3083248359', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 980 1201 North Erie St', N'Lexington', N'NE', N'31047', N'68850', 40.78084, -99.741504, 2212, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3441, N'Phelps Memorial Health Center', 1, NULL, NULL, N'281362', NULL, NULL, 0, 25, NULL, N'3089952211', N'3089953336', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Tibbals St', N'Holdrege', N'NE', N'31137', N'68949', 40.447422, -99.382017, 2207, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3442, N'Community Hospital', 1, NULL, NULL, N'281363', NULL, NULL, 0, 25, NULL, N'3083442650', N'3083448572', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1328 1301 East H St', N'Mccook', N'NE', N'31145', N'69001', 40.201948, -100.625708, 2215, 43, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3443, N'Beatrice Community Hospital & Health Center Inc', 1, NULL, NULL, N'281364', NULL, NULL, 0, 25, NULL, N'4022283344', N'4022237299', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 278 4800 Hospital Parkway', N'Beatrice', N'NE', N'31067', N'68310', 40.3160741, -96.7516815, 2180, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3444, N'Jennie M Melham Memorial Medical Center', 1, NULL, NULL, N'281365', NULL, NULL, 0, 23, NULL, N'3088724100', N'3088724150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 Memorial Drive', N'Broken Bow', N'NE', N'31041', N'68822', 41.408961, -99.631644, 2183, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3445, N'Madonna Rehabilitation Ltc Hospital', 1, NULL, NULL, N'282000', NULL, NULL, 0, 96, NULL, N'4024133000', N'4024134604', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 South St', N'Lincoln', N'NE', N'31109', N'68506', 40.791553, -96.647932, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3446, N'Select Specialty Hospital - Omaha (Central Campus)', 1, NULL, NULL, N'282001', NULL, NULL, 0, 52, NULL, N'4023615755', N'4023615777', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1870 South 75Th Street', N'Omaha', N'NE', N'31055', N'68124', 41.241424, -96.028838, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3447, N'Select Specialty Hospital - Lincoln', 1, NULL, NULL, N'282002', NULL, NULL, 0, 24, NULL, N'4023615755', N'4028845284', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 South 16Th Street - 7Th Floor', N'Lincoln', N'NE', N'31109', N'68502', 40.79271, -96.698311, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3448, N'Madonna Rehabilitation Specialty Hospital', 1, NULL, NULL, N'282003', NULL, NULL, 0, 32, NULL, N'4028840006', N'4029910880', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bellevue Medical Center Drive 4Th Floor', N'Bellevue', N'NE', N'31153', N'68123', 41.136649, -95.890737, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3449, N'Madonna Rehabilitation Hospital', 1, NULL, NULL, N'283025', NULL, NULL, 0, 96, NULL, N'4024133000', N'4024134113', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 South St', N'Lincoln', N'NE', N'31109', N'68506', 40.791553, -96.647932, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3450, N'Boys Town National Research Hospital', 1, NULL, NULL, N'283300', NULL, NULL, 0, 66, NULL, N'4024986362', N'4024986357', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 North 30Th St', N'Omaha', N'NE', N'31055', N'68131', 41.264666, -95.956504, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3451, N'Children''s Hospital & Medical Center', 1, NULL, NULL, N'283301', NULL, NULL, 0, 134, NULL, N'4029555400', N'4029554100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8200 Dodge St', N'Omaha', N'NE', N'31055', N'68114', 41.259682, -96.042029, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3452, N'Lincoln Regional Center', 1, NULL, NULL, N'284003', NULL, NULL, 0, 240, NULL, N'4024714444', N'4024795124', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 94949 Folsom & West Prospector', N'Lincoln', N'NE', N'31109', N'68509', 40.800055, -96.6674, 2213, 171, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3453, N'Douglas County Health Center', 1, NULL, NULL, N'284009', NULL, NULL, 0, 30, NULL, N'4024447676', N'4029968171', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4102 Woolworth Ave', N'Omaha', N'NE', N'31055', N'68105', 41.246217, -95.974429, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3454, N'Children''s Hospital & Medical Center  Transplant', 1, NULL, NULL, N'289806', NULL, NULL, 0, 0, NULL, N'4029554374', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'8200 Dodge Street', N'Omaha', N'NE', N'31055', N'68114', 41.259763, -96.040399, 2224, 172, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3455, N'Renown Regional Medical Center', 1, NULL, NULL, N'290001', NULL, NULL, 0, 529, NULL, N'7759824100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1155 Mill Street', N'Reno', N'NV', N'32031', N'89502', 39.524706, -119.796626, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3456, N'South Lyon Medical Center', 1, NULL, NULL, N'290002', NULL, NULL, 0, 14, NULL, N'7757813761', N'7754637864', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 S Whitacre/Po Box 940', N'Yerington', N'NV', N'32019', N'89447', 38.993911, -119.163156, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3457, N'Sunrise Hospital And Medical Center', 1, NULL, NULL, N'290003', NULL, NULL, 0, 701, NULL, N'7027318000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3186 S Maryland Pkwy', N'Las Vegas', N'NV', N'32003', N'89109', 36.131699, -115.13688, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3458, N'North Vista Hospital', 1, NULL, NULL, N'290005', NULL, NULL, 0, 198, NULL, N'7026575504', N'7026575636', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1409 East Lake Mead Blvd', N'North Las Vegas', N'NV', N'32003', N'89030', 36.19574, -115.122865, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3459, N'Banner Churchill Community Hospital', 1, NULL, NULL, N'290006', NULL, NULL, 0, 40, NULL, N'7754233151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Williams Avenue', N'Fallon', N'NV', N'32001', N'89406', 39.474875, -118.764893, 2252, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3460, N'University Medical Center', 1, NULL, NULL, N'290007', NULL, NULL, 0, 578, NULL, N'7023832000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.15894, -115.165463, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3461, N'Northeastern Nevada Regional Hospital', 1, NULL, NULL, N'290008', NULL, NULL, 0, 75, NULL, N'7757385151', N'7757482002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Errecart Blvd', N'Elko', N'NV', N'32007', N'89801', 40.822684, -115.728877, 2250, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3462, N'Saint Mary''s Regional Medical Center', 1, NULL, NULL, N'290009', NULL, NULL, 0, 380, NULL, N'7757703000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 W 6Th St', N'Reno', N'NV', N'32031', N'89503', 39.5317, -119.817864, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3463, N'St Rose Dominican Hospitals - Rose De Lima Campus', 1, NULL, NULL, N'290012', NULL, NULL, 0, 145, NULL, N'7026165000', N'7026164699', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 E Lake Mead Dr', N'Henderson', N'NV', N'32003', N'89015', 36.037407, -114.985663, 2254, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3464, N'Carson Tahoe Regional Medical Center', 1, NULL, NULL, N'290019', NULL, NULL, 0, 190, NULL, N'7754458000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Medical Parkway', N'Carson City', N'NV', N'32510', N'89703', 39.201828, -119.781726, 2249, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3465, N'Nye Regional Medical Center', 1, NULL, NULL, N'290020', NULL, NULL, 0, 44, NULL, N'7754826233', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Erie Main St (Aka South Main)', N'Tonopah', N'NV', N'32023', N'89049', 38.068101, -117.23095, 2257, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3466, N'Valley Hospital Medical Center', 1, NULL, NULL, N'290021', NULL, NULL, 0, 320, NULL, N'7023884000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Shadow Lane', N'Las Vegas', N'NV', N'32003', N'89106', 36.162575, -115.165476, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3467, N'Desert Springs Hospital', 1, NULL, NULL, N'290022', NULL, NULL, 0, 346, NULL, N'7023697600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2075 East Flamin Road', N'Las Vegas', N'NV', N'32003', N'89119', 36.114574, -115.124139, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3468, N'Northern Nevada Medical Center', 1, NULL, NULL, N'290032', NULL, NULL, 0, 108, NULL, N'7753317000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2375 Prater Way', N'Sparks', N'NV', N'32031', N'89434', 39.542505, -119.697455, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3469, N'Mountainview Hospital', 1, NULL, NULL, N'290039', NULL, NULL, 0, 235, NULL, N'7022555065', N'7022555074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 N Tenaya Way', N'Las Vegas', N'NV', N'32003', N'89128', 36.215326, -115.250674, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3470, N'Summerlin Hospital Medical Center', 1, NULL, NULL, N'290041', NULL, NULL, 0, 199, NULL, N'7022337500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'657 Town Center Drive', N'Las Vegas', N'NV', N'32003', N'89144', 36.17967, -115.315719, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3471, N'Harmon Hospital', 1, NULL, NULL, N'290042', NULL, NULL, 0, 116, NULL, N'7027940100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2170 East Harmon Avenue', N'Las Vegas', N'NV', N'32003', N'89119', 36.107952, -115.16846, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3472, N'St Rose Dominican Hospitals - Siena Campus', 1, NULL, NULL, N'290045', NULL, NULL, 0, 219, NULL, N'7026165000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 St Rose Parkway', N'Henderson', N'NV', N'32003', N'89052', 36.004707, -115.1175, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3473, N'Spring Valley Hospital Medical Center', 1, NULL, NULL, N'290046', NULL, NULL, 0, 210, NULL, N'7028533000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 South Rainbow Blvd', N'Las Vegas', N'NV', N'32003', N'89118', 36.090649, -115.242895, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3474, N'Southern Hills Hospital And Medical Center', 1, NULL, NULL, N'290047', NULL, NULL, 0, 130, NULL, N'7028802100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9300 West Sunset Rd', N'Las Vegas', N'NV', N'32003', N'89148', 36.070256, -115.295512, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3475, N'Renown South Meadows Medical Center', 1, NULL, NULL, N'290049', NULL, NULL, 0, 118, NULL, N'7759827063', N'7759827072', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Double R Blvd', N'Reno', N'NV', N'32510', N'89521', 39.437199, -119.758498, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3476, N'Sierra Surgery Hospital', 1, NULL, NULL, N'290051', NULL, NULL, 0, 15, NULL, N'7758831700', N'7758838905', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Medical Pkwy', N'Carson City', N'NV', N'32510', N'89703', 39.199544, -119.784351, 2249, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3477, N'St Rose Dominican Hospitals - San Martin Campus', 1, NULL, NULL, N'290053', NULL, NULL, 0, 145, NULL, N'7024928509', N'7024928511', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8280 W Warm Springs Road', N'Las Vegas', N'NV', N'32003', N'89113', 36.055544, -115.271876, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3478, N'Centennial Hills Hospital Medical Center', 1, NULL, NULL, N'290054', NULL, NULL, 0, 177, NULL, N'7028359700', N'7028359780', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6900 N Duran Dr', N'Las Vegas', N'NV', N'32003', N'89149', 36.286014, -115.28773, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3479, N'Mount Grant General Hospital', 1, NULL, NULL, N'291300', NULL, NULL, 0, 11, NULL, N'7029452461', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'First And A Streets', N'Hawthorne', N'NV', N'32021', N'89415', 38.524644, -118.624578, 2253, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3480, N'Incline Village Health Center', 1, NULL, NULL, N'291301', NULL, NULL, 0, 8, NULL, N'7758334100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 Alder Street', N'Incline Village', N'NV', N'32031', N'89451', 39.250892, -119.954734, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3481, N'William Bee Ririe Hospital', 1, NULL, NULL, N'291302', NULL, NULL, 0, 25, NULL, N'7752893001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Avenue H', N'Ely', N'NV', N'32033', N'89301', 39.256065, -114.860086, 2251, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3482, N'Battle Mountain General Hospital', 1, NULL, NULL, N'291303', NULL, NULL, 0, 7, NULL, N'7756352550', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 South Humboldt Street', N'Batte Mtn', N'NV', N'32015', N'89820', 40.64065, -116.938824, 2247, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3483, N'Pershing General Hospital', 1, NULL, NULL, N'291304', NULL, NULL, 0, 17, NULL, N'7752732621', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 6Th Street/Po Box 661', N'Lovelock', N'NV', N'32027', N'89419', 40.176537, -118.483437, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3484, N'Carson Valley Medical Center', 1, NULL, NULL, N'291306', NULL, NULL, 0, 15, NULL, N'7757821500', N'7757834849', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1107 Highway 395', N'Gardnerville', N'NV', N'32005', N'89410', 38.941296, -119.749622, 2249, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3485, N'Mesa View Regional Hospital', 1, NULL, NULL, N'291307', NULL, NULL, 0, 25, NULL, N'7023468040', N'7023467031', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1299 Bertha Howe Avenue', N'Mesquite', N'NV', N'32003', N'89027', 36.808809, -114.114446, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3486, N'Humboldt General Hospital', 1, NULL, NULL, N'291308', NULL, NULL, 0, 22, NULL, N'7756235222', N'7756235094', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'118 East Haskell Street', N'Winnemucca', N'NV', N'32013', N'89445', 40.971581, -117.728534, 2258, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3487, N'Boulder City Hospital', 1, NULL, NULL, N'291309', NULL, NULL, 0, 67, NULL, N'7022934111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Adams Blvd', N'Boulder City', N'NV', N'32003', N'89005', 35.968358, -114.843405, 2248, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3488, N'Desert View Regional Medical Center', 1, NULL, NULL, N'291311', NULL, NULL, 0, 24, NULL, N'7757517500', N'7757517835', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 South Lola Lane', N'Pahrump', N'NV', N'32023', N'89048', 36.214381, -116.023482, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3489, N'Grover C Dils Medical Center', 1, NULL, NULL, N'291312', NULL, NULL, 0, 20, NULL, N'7757263171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 N Spring St Box 1010-C-Adm Bldg', N'Caliente', N'NV', N'32017', N'89008', 37.622281, -114.511824, 3433, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3490, N'Kindred Hospital - Las Vegas (Sahara Campus)', 1, NULL, NULL, N'292002', NULL, NULL, 0, 52, NULL, N'7028352926', N'7028714713', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5110 W Sahara Ave', N'Las Vegas', N'NV', N'32003', N'89146', 36.143855, -115.256458, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3491, N'Horizon Specialty Hospital', 1, NULL, NULL, N'292003', NULL, NULL, 0, 199, NULL, N'7023823155', N'7024051995', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'640 Desert Lane', N'Las Vegas', N'NV', N'32003', N'89106', 36.163674, -115.162192, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3492, N'Tahoe Pacific Hospital - Meadows', 1, NULL, NULL, N'292004', NULL, NULL, 0, 39, NULL, N'7753311044', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 Double R Blvd-1St Floor', N'Reno', N'NV', N'32031', N'89521', 39.52927, -119.813674, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3493, N'Complex Care Hospital At Tenaya', 1, NULL, NULL, N'292006', NULL, NULL, 0, 70, NULL, N'7025622021', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Tenaya Way', N'Las Vegas', N'NV', N'32003', N'89128', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3494, N'Las Vegas-Amg Specialty Hospital', 1, NULL, NULL, N'292007', NULL, NULL, 0, 24, NULL, N'7024332200', N'7027310581', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4015 South Mcleod', N'Las Vegas', N'NV', N'32003', N'89121', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3495, N'Carson Tahoe Continuing Care Hospital', 1, NULL, NULL, N'292008', NULL, NULL, 0, 29, NULL, N'7754457783', N'7758854141', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'775 Fleischmann Way 2Nd Flr', N'Carson City', N'NV', N'32510', N'89703', 39.171658, -119.772535, 2249, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3496, N'Healthsouth Rehabilitation Hospital Of Las Vegas', 1, NULL, NULL, N'293026', NULL, NULL, 0, 79, NULL, N'7028778898', N'7022593402', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S Valley View Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.139295, -115.184432, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3497, N'Healthsouth Rehabilitiation Hospital Of Henderson', 1, NULL, NULL, N'293032', NULL, NULL, 0, 60, NULL, N'7029399400', N'7029399746', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10301 Jeffreys St', N'Henderson', N'NV', N'32003', N'89052', 36.002692, -115.120462, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3498, N'Healthsouth Desert Canyon Rehabilitation Hospital', 1, NULL, NULL, N'293033', NULL, NULL, 0, 50, NULL, N'7022527342', N'7027955828', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9175 West Oquendo Road', N'Las Vegas', N'NV', N'32003', N'89148', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3499, N'Dini-Townsend Hospital At Nnmh', 1, NULL, NULL, N'294000', NULL, NULL, 0, 70, NULL, N'7756882001', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'480 Galletti Way', N'Sparks', N'NV', N'32031', N'89431', 39.530399, -119.779995, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3500, N'Southern Nevada Adult Mental Health Services', 1, NULL, NULL, N'294002', NULL, NULL, 0, 293, NULL, N'7024866000', N'7022280226', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6161 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89146', 36.159132, -115.239285, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3501, N'Bhc West Hills Hospital', 1, NULL, NULL, N'294003', NULL, NULL, 0, 95, NULL, N'7753230478', N'7757894405', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1240 E Ninth St', N'Reno', N'NV', N'32031', N'89512', 39.52927, -119.813674, 2256, 174, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3502, N'Red Rock Behavioral Health Hospital', 1, NULL, NULL, N'294008', NULL, NULL, 0, 21, NULL, N'7022148099', N'7023648183', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5975 West Twain Avenue', N'Las Vegas', N'NV', N'32003', N'89103', 36.121968, -115.220691, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3503, N'Montevista Hospital', 1, NULL, NULL, N'294009', NULL, NULL, 0, 80, NULL, N'7023641111', N'7023648183', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 West Rochelle Avenue', N'Las Vegas', N'NV', N'32003', N'89103', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3504, N'Spring Mountain Sahara', 1, NULL, NULL, N'294010', NULL, NULL, 0, 30, NULL, N'7028732400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5460 West Sahara', N'Las Vegas', N'NV', N'32003', N'89146', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3505, N'Spring Mountain Treatment Center', 1, NULL, NULL, N'294011', NULL, NULL, 0, 82, NULL, N'7028732400', N'7028732710', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 West Spring Mountain Road', N'Las Vegas', N'NV', N'32003', N'89117', 36.166286, -115.149225, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3506, N'Seven Hills Behavioral Institute', 1, NULL, NULL, N'294012', NULL, NULL, 0, 55, NULL, N'7026465000', N'7026465553', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3021 W Horizon Ridge Pkwy', N'Henderson', N'NV', N'32003', N'89052', 35.998854, -115.107871, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3507, N'Umc Transplantation Services', 1, NULL, NULL, N'299800', NULL, NULL, 0, 0, NULL, N'7023833658', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1800 W Charleston Blvd', N'Las Vegas', N'NV', N'32003', N'89102', 36.159751, -115.166047, 2255, 173, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3508, N'Concord Hospital', 1, NULL, NULL, N'300001', NULL, NULL, 0, 295, NULL, N'6032252711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Pleasant St', N'Concord', N'NH', N'33013', N'03301', 43.195963, -71.560369, 2263, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3509, N'Mary Hitchcock Memorial Hospital', 1, NULL, NULL, N'300003', NULL, NULL, 0, 396, NULL, N'6036505000', N'6036531111', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Drive', N'Lebanon', N'NH', N'33009', N'03756', 43.677276, -72.27415, 2271, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3510, N'Lakes Region General Hospital', 1, NULL, NULL, N'300005', NULL, NULL, 0, 143, NULL, N'6035243211', N'6035272887', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80 Highland St', N'Laconia', N'NH', N'33001', N'03246', 43.5281, -71.460757, 2269, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3511, N'St Joseph Hospital', 1, NULL, NULL, N'300011', NULL, NULL, 0, 208, NULL, N'6038823000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'172 Kinsley St', N'Nashua', N'NH', N'33011', N'03060', 42.749854, -71.481492, 2274, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3512, N'Elliot Hospital', 1, NULL, NULL, N'300012', NULL, NULL, 0, 296, NULL, N'6036695300', N'6036474420', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Elliot Way', N'Manchester', N'NH', N'33011', N'03103', 42.983851, -71.437232, 2273, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3513, N'Frisbie Memorial Hospital', 1, NULL, NULL, N'300014', NULL, NULL, 0, 122, NULL, N'6033325211', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11 Whitehall Road', N'Rochester', N'NH', N'33017', N'03867', 43.298198, -70.960915, 2280, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3514, N'Parkland Medical Center', 1, NULL, NULL, N'300017', NULL, NULL, 0, 86, NULL, N'6034212100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Parkland Drive', N'Derry', N'NH', N'33015', N'03038', 42.875672, -71.317759, 2264, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3515, N'Wentworth-Douglass Hospital', 1, NULL, NULL, N'300018', NULL, NULL, 0, 178, NULL, N'6037402580', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'789 Central Ave', N'Dover', N'NH', N'33017', N'03820', 43.212442, -70.875139, 2265, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3516, N'Cheshire Medical Center', 1, NULL, NULL, N'300019', NULL, NULL, 0, 169, NULL, N'6033545400', N'6033545402', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'580 Court Street', N'Keene', N'NH', N'33005', N'03431', 42.954514, -72.2968, 2268, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3517, N'Southern Nh Medical Center', 1, NULL, NULL, N'300020', NULL, NULL, 0, 188, NULL, N'6035772000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8 Prospect Street', N'Nashua', N'NH', N'33011', N'03060', 42.756109, -71.461023, 2274, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3518, N'Exeter Hospital Inc', 1, NULL, NULL, N'300023', NULL, NULL, 0, 100, NULL, N'6037787311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Alumni Drive', N'Exeter', N'NH', N'33015', N'03833', 42.981779, -70.936054, 2266, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3519, N'Portsmouth Regional Hospital', 1, NULL, NULL, N'300029', NULL, NULL, 0, 209, NULL, N'6034365110', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Borthwick Ave', N'Portsmouth', N'NH', N'33015', N'03801', 43.063667, -70.790628, 2279, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3520, N'Catholic Medical Center', 1, NULL, NULL, N'300034', NULL, NULL, 0, 330, NULL, N'6036683545', N'6036636547', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Mcgrer Street', N'Manchester', N'NH', N'33011', N'03102', 42.992054, -71.47341, 2273, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3521, N'Upper Connecticut Valley Hospital', 1, NULL, NULL, N'301300', NULL, NULL, 0, 16, NULL, N'6032374971', N'6032374452', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'181 Corliss Lane', N'Colebrook', N'NH', N'33007', N'03576', 44.903571, -71.482463, 2262, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3522, N'Cottage Hospital', 1, NULL, NULL, N'301301', NULL, NULL, 0, 25, NULL, N'6037479000', N'6037473310', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Swiftwater Rd', N'Woodsville', N'NH', N'33009', N'03785', 44.136331, -72.023349, 2282, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3523, N'Littleton Regional Healthcare', 1, NULL, NULL, N'301302', NULL, NULL, 0, 25, NULL, N'6034449000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 St Johnsbury Road', N'Littleton', N'NH', N'33009', N'03561', 44.31666, -71.82442, 2272, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3524, N'Weeks Medical Center', 1, NULL, NULL, N'301303', NULL, NULL, 0, 25, NULL, N'6037884911', N'6037885068', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'173 Middle Street', N'Lancaster', N'NH', N'33007', N'03584', 44.488224, -71.563429, 2270, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3525, N'New London Hospital', 1, NULL, NULL, N'301304', NULL, NULL, 0, 25, NULL, N'6035262911', N'6035262990', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'273 County Road', N'New London', N'NH', N'33013', N'03257', 43.421345, -72.001155, 2275, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3526, N'Alice Peck Day Memorial Hospital', 1, NULL, NULL, N'301305', NULL, NULL, 0, 25, NULL, N'6034483121', N'6034487444', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Alice Peck Day Drive', N'Lebanon', N'NH', N'33009', N'03766', 43.640318, -72.264438, 2271, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3527, N'Franklin Regional Hospital', 1, NULL, NULL, N'301306', NULL, NULL, 0, 25, NULL, N'6039342060', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 Aiken Avenue', N'Franklin', N'NH', N'33013', N'03235', 43.447764, -71.642801, 2267, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3528, N'Memorial Hospital The', 1, NULL, NULL, N'301307', NULL, NULL, 0, 25, NULL, N'6033565461', N'6033568135', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3073 White Mountain Highway', N'North Conway', N'NH', N'33003', N'03860', 44.060731, -71.138744, 2276, 129, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3529, N'Valley Regional Hospital', 1, NULL, NULL, N'301308', NULL, NULL, 0, 25, NULL, N'6035427771', N'6035421814', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'243 Elm Street', N'Claremont', N'NH', N'33019', N'03743', 43.385729, -72.34209, 2261, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3530, N'Monadnock Community Hospital', 1, NULL, NULL, N'301309', NULL, NULL, 0, 25, NULL, N'6039247191', N'6039249586', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'452 Old Street Road', N'Peterborough', N'NH', N'33011', N'03458', 42.894104, -71.937601, 2277, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3531, N'Androscoggin Valley Hospital', 1, NULL, NULL, N'301310', NULL, NULL, 0, 25, NULL, N'6037522200', N'6037221836', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'59 Page Hill Road', N'Berlin', N'NH', N'33007', N'03570', 44.488035, -71.158977, 2260, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3532, N'Speare Memorial Hospital', 1, NULL, NULL, N'301311', NULL, NULL, 0, 25, NULL, N'6035361120', N'6035364828', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 Hospital Road', N'Plymouth', N'NH', N'33009', N'03264', 43.75843, -71.694791, 2278, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3533, N'Huggins Hospital', 1, NULL, NULL, N'301312', NULL, NULL, 0, 25, NULL, N'6035697500', N'6035697509', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 South Main Street', N'Wolfeboro', N'NH', N'33003', N'03894', 43.580174, -71.200169, 2281, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3534, N'Northeast Rehabilitation Hospital', 1, NULL, NULL, N'303026', NULL, NULL, 0, 135, NULL, N'6038932900', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Butler Street', N'Salem', N'NH', N'33015', N'03079', 42.765753, -71.186762, 1731, 133, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3535, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'303027', NULL, NULL, 0, 50, NULL, N'6032269800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Pleasant Street', N'Concord', N'NH', N'33013', N'03301', 43.201267, -71.56306, 2263, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3536, N'New Hampshire Hosp-Psych Unit', 1, NULL, NULL, N'304000', NULL, NULL, 0, 230, NULL, N'6032715300', N'6032715395', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36 Clinton Street', N'Concord', N'NH', N'33013', N'03301', 43.193076, -71.544149, 2263, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3537, N'Hampstead Hospital', 1, NULL, NULL, N'304001', NULL, NULL, 0, 111, NULL, N'6033295311', N'6033294746', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 East Road', N'Hampstead', N'NH', N'33015', N'03841', 42.869042, -71.152585, 2264, 176, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3538, N'Mary Hitchcock Memorial Hospital - Transplant', 1, NULL, NULL, N'309801', NULL, NULL, 0, 0, NULL, N'6036533770', N'6035600924', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Lebanon', N'NH', N'33009', N'03756', 43.642538, -72.251383, 2271, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3539, N'Hackensack University Medical Center', 1, NULL, NULL, N'310001', NULL, NULL, 0, 670, NULL, N'2019962000', N'2019963450', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Prospect Ave', N'Hackensack', N'NJ', N'34003', N'07601', 40.88397, -74.057987, 2297, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3540, N'Newark Beth Israel Medical Center', 1, NULL, NULL, N'310002', NULL, NULL, 0, 572, NULL, N'9739267850', N'9737053477', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Lyons Ave', N'Newark', N'NJ', N'34013', N'07112', 40.709131, -74.212097, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3541, N'Palisades Medical Center', 1, NULL, NULL, N'310003', NULL, NULL, 0, 202, NULL, N'2018545000', N'2018545036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 River Rd', N'North Bergen', N'NJ', N'34017', N'07047', 40.793709, -73.997412, 2316, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3542, N'Hunterdon Medical Center', 1, NULL, NULL, N'310005', NULL, NULL, 0, 176, NULL, N'9087886100', N'9087886111', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Wescott Drive', N'Flemington', N'NJ', N'34019', N'08822', 40.532524, -74.86041, 2295, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3543, N'St Mary''s General Hospital', 1, NULL, NULL, N'310006', NULL, NULL, 0, 286, NULL, N'9733654300', N'9734715531', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Boulevard', N'Passaic', N'NJ', N'34031', N'07055', 40.85871, -74.137982, 2319, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3544, N'Holy Name Medical Center', 1, NULL, NULL, N'310008', NULL, NULL, 0, 336, NULL, N'2018333000', N'2018333230', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'718 Teaneck Rd', N'Teaneck', N'NJ', N'34003', N'07666', 40.882338, -74.00865, 2339, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3545, N'Clara Maass Medical Center', 1, NULL, NULL, N'310009', NULL, NULL, 0, 416, NULL, N'9734502002', N'9734500181', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Clara Maas Drive', N'Belleville', N'NJ', N'34013', N'07109', 40.793712, -74.150144, 2285, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3546, N'Univ Medical Center Of Princeton At Plainsboro', 1, NULL, NULL, N'310010', NULL, NULL, 0, 375, NULL, N'8664604776', N'6098537101', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One-Five Plainsboro Road', N'Plainsboro', N'NJ', N'34023', N'08536', 40.333441, -74.600434, 2326, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3547, N'Cape Regional Medical Center Inc', 1, NULL, NULL, N'310011', NULL, NULL, 0, 242, NULL, N'6094632000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Stone Harbor Blvd', N'Cape May Court House', N'NJ', N'34009', N'08210', 39.082614, -74.823786, 2288, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3548, N'Valley Hospital', 1, NULL, NULL, N'310012', NULL, NULL, 0, 421, NULL, N'2014478000', N'2012916194', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 N Van Dien Avenue', N'Ridgewood', N'NJ', N'34003', N'07450', 40.983204, -74.101761, 2329, 183, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3549, N'Cooper University Hospital', 1, NULL, NULL, N'310014', NULL, NULL, 0, 522, NULL, N'8563422000', N'8563423299', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Cooper Plaza', N'Camden', N'NJ', N'34007', N'08103', 39.940789, -75.115758, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3550, N'Morristown Medical Center', 1, NULL, NULL, N'310015', NULL, NULL, 0, 483, NULL, N'9739715450', N'9732907010', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Madison Ave', N'Morristown', N'NJ', N'34027', N'07962', 40.787937, -74.463273, 2310, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3551, N'Carepoint Health-Christ Hospital', 1, NULL, NULL, N'310016', NULL, NULL, 0, 401, NULL, N'2017958200', N'2017958796', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'176 Palisade Ave', N'Jersey City', N'NJ', N'34017', N'07306', 40.734674, -74.050272, 2303, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3552, N'Chilton Medical Center', 1, NULL, NULL, N'310017', NULL, NULL, 0, 232, NULL, N'9738315000', N'9738315183', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'97 West Parkway', N'Pompton Plains', N'NJ', N'34027', N'07444', 40.994337, -74.150139, 2325, 182, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3553, N'St Joseph''s Regional Medical Center', 1, NULL, NULL, N'310019', NULL, NULL, 0, 566, NULL, N'9737542010', N'9737542009', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'703 Main St', N'Paterson', N'NJ', N'34031', N'07503', 40.902278, -74.166585, 2320, 182, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3554, N'St Francis Medical Center', 1, NULL, NULL, N'310021', NULL, NULL, 0, 436, NULL, N'6095995000', N'6096952744', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Hamilton Ave', N'Trenton', N'NJ', N'34021', N'08629', 40.217126, -74.742576, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3555, N'Virtua West Jersey Hospitals Berlin', 1, NULL, NULL, N'310022', NULL, NULL, 0, 765, NULL, N'8563223200', N'8563223201', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Whitehorse Pike And Townsend Avenue', N'Berlin', N'NJ', N'34007', N'08009', 39.791226, -74.929054, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3556, N'Robert Wood Johnson University Hospital At Rahway', 1, NULL, NULL, N'310024', NULL, NULL, 0, 281, NULL, N'7323814200', N'7324996337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'865 Stone St', N'Rahway', N'NJ', N'34039', N'07065', 40.612243, -74.291721, 2327, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3557, N'Carepoint Health - Bayonne Medical Center', 1, NULL, NULL, N'310025', NULL, NULL, 0, 254, NULL, N'2018585000', N'2018587355', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 East 29Th St', N'Bayonne', N'NJ', N'34017', N'07002', 40.667531, -74.112371, 2284, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3558, N'Trinitas Regional Medical Center', 1, NULL, NULL, N'310027', NULL, NULL, 0, 384, NULL, N'9089945000', N'9089945756', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Williamson Street', N'Elizabeth', N'NJ', N'34039', N'07207', 40.659859, -74.214418, 2292, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3559, N'Newton Medical Center', 1, NULL, NULL, N'310028', NULL, NULL, 0, 148, NULL, N'9735798300', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 High St', N'Newton', N'NJ', N'34037', N'07860', 41.055592, -74.765035, 2315, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3560, N'Our Lady Of Lourdes Medical Center', 1, NULL, NULL, N'310029', NULL, NULL, 0, 376, NULL, N'8567573500', N'8566352400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Haddon Avenue', N'Camden', N'NJ', N'34007', N'08103', 39.927037, -75.09571, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3561, N'Deborah Heart And Lung Center', 1, NULL, NULL, N'310031', NULL, NULL, 0, 161, NULL, N'6098936611', N'6098931213', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Trenton Road', N'Browns Mills', N'NJ', N'34005', N'08015', 39.977274, -74.58621, 2311, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3562, N'Inspira Medical Center Vineland', 1, NULL, NULL, N'310032', NULL, NULL, 0, 293, NULL, N'8566416610', N'8565755178', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1505 W Sherman Ave', N'Vineland', N'NJ', N'34011', N'08360', 39.447505, -75.058638, 2343, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3563, N'Riverview Medical Center', 1, NULL, NULL, N'310034', NULL, NULL, 0, 440, NULL, N'7327412700', N'7322248408', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Riverview Plaza', N'Red Bank', N'NJ', N'34025', N'07701', 40.347054, -74.064306, 2328, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3564, N'Robert Wood Johnson University Hospital', 1, NULL, NULL, N'310038', NULL, NULL, 0, 610, NULL, N'7329378900', N'7329378773', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Robert Wood Johnson Place', N'New Brunswick', N'NJ', N'34023', N'08901', 40.486217, -74.451817, 2313, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3565, N'Raritan Bay Medical Center', 1, NULL, NULL, N'310039', NULL, NULL, 0, 522, NULL, N'7324423700', N'7323245330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 New Brunswick Ave', N'Perth Amboy', N'NJ', N'34023', N'08861', 40.518857, -74.281538, 2321, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3566, N'Carepoint Health-Hoboken University Medical Center', 1, NULL, NULL, N'310040', NULL, NULL, 0, 333, NULL, N'2014181000', N'2014281011', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 Willow Ave', N'Hoboken', N'NJ', N'34017', N'07030', 40.74072, -74.033708, 2300, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3567, N'Community Medical Center', 1, NULL, NULL, N'310041', NULL, NULL, 0, 596, NULL, N'7325578000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Rt 37 West', N'Toms River', N'NJ', N'34029', N'08755', 39.964983, -74.213979, 2340, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3568, N'Clara Maass Medical Center West Hudson Division', 1, NULL, NULL, N'310042', NULL, NULL, 0, 166, NULL, N'2019557000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 Bergen Ave', N'Kearny', N'NJ', N'34017', N'07032', 40.757918, -74.1512877, 2304, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3569, N'Capital Health Medical Center - Hopewell', 1, NULL, NULL, N'310044', NULL, NULL, 0, 344, NULL, N'6093034000', N'6093946687', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Capital Way', N'Pennington', N'NJ', N'34021', N'08534', 40.29461, -74.81099, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3570, N'Englewood Hospital And Medical Center', 1, NULL, NULL, N'310045', NULL, NULL, 0, 490, NULL, N'2018943000', N'2018941345', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Engle St', N'Englewood', N'NJ', N'34003', N'07631', 40.902855, -73.967993, 2294, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3571, N'Shore Medical Center', 1, NULL, NULL, N'310047', NULL, NULL, 0, 302, NULL, N'6096533545', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Way', N'Somers Point', N'NJ', N'34001', N'08244', 39.317616, -74.594601, 2333, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3572, N'Robert Wood Johnson University Hospital Somerset', 1, NULL, NULL, N'310048', NULL, NULL, 0, 335, NULL, N'9086852200', N'9086852898', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Rehill Ave', N'Somerville', N'NJ', N'34035', N'08876', 40.568692, -74.595751, 2334, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3573, N'Saint Clare''s Hospital', 1, NULL, NULL, N'310050', NULL, NULL, 0, 106, NULL, N'9739835506', N'9736256184', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Pocono Road', N'Denville', N'NJ', N'34027', N'07834', 40.894366, -74.465007, 2289, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3574, N'Overlook Medical Center', 1, NULL, NULL, N'310051', NULL, NULL, 0, 448, NULL, N'9085222000', N'9082735134', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 Beauvoir Avenue', N'Summit', N'NJ', N'34039', N'07902', 40.712418, -74.354008, 2337, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3575, N'Ocean Medical Center', 1, NULL, NULL, N'310052', NULL, NULL, 0, 436, NULL, N'7328402200', N'7328403284', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Jack Martin Blvd', N'Brick', N'NJ', N'34029', N'08724', 40.078346, -74.129786, 2324, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3576, N'Hackensack-Umc Mountainside', 1, NULL, NULL, N'310054', NULL, NULL, 0, 328, NULL, N'9734296000', N'9734296209', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Bay And Highland Ave', N'Montclair', N'NJ', N'34013', N'07042', 40.825933, -74.209034, 2309, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3577, N'Virtua Memorial Hospital Of Burlington County', 1, NULL, NULL, N'310057', NULL, NULL, 0, 341, NULL, N'6099146200', N'6099146201', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Madison Ave', N'Mount Holly', N'NJ', N'34005', N'08060', 39.985955, -74.795715, 2311, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3578, N'Bergen Regional Medical Center', 1, NULL, NULL, N'310058', NULL, NULL, 0, 496, NULL, N'2019674000', N'2012256748', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 East Ridgewood Ave', N'Paramus', N'NJ', N'34003', N'07652', 40.958533, -74.0619, 2318, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3579, N'St Luke''s Warren Hospital', 1, NULL, NULL, N'310060', NULL, NULL, 0, 214, NULL, N'9088596700', N'9088594546', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'185 Roseberry St', N'Phillipsburg', N'NJ', N'34041', N'08865', 40.701734, -75.179672, 2322, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3580, N'Lourdes Medical Center Of Burlington County', 1, NULL, NULL, N'310061', NULL, NULL, 0, 221, NULL, N'6098352900', N'6098353061', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218A Sunset Road', N'Willingboro', N'NJ', N'34005', N'08046', 40.04865, -74.881779, 2346, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3581, N'Atlanticare Regional Medical Center - City Campus', 1, NULL, NULL, N'310064', NULL, NULL, 0, 263, NULL, N'6094418020', N'6094412108', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1925 Pacific Avenue', N'Atlantic City', N'NJ', N'34001', N'08401', 39.357876, -74.433732, 2283, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3582, N'Inspira Medical Center Elmer', 1, NULL, NULL, N'310069', NULL, NULL, 0, 91, NULL, N'8565754500', N'8563583248', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 West Front Street Post Office Box  1090', N'Elmer', N'NJ', N'34033', N'08318', 39.588012, -75.179518, 2293, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3583, N'Saint Peter''s University Hospital', 1, NULL, NULL, N'310070', NULL, NULL, 0, 416, NULL, N'7327458600', N'7327457938', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Easton Ave', N'New Brunswick', N'NJ', N'34023', N'08901', 40.501782, -74.458968, 2313, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3584, N'Jersey Shore University Medical Center', 1, NULL, NULL, N'310073', NULL, NULL, 0, 490, NULL, N'7327764900', N'7327764583', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1945 Rte 33', N'Neptune', N'NJ', N'34025', N'07754', 40.223998, -74.047822, 2312, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3585, N'Jersey City Medical Center', 1, NULL, NULL, N'310074', NULL, NULL, 0, 255, NULL, N'2019152000', N'2019152002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Grand Street', N'Jersey City', N'NJ', N'34017', N'07302', 40.716684, -74.050096, 2303, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3586, N'Monmouth Medical Center', 1, NULL, NULL, N'310075', NULL, NULL, 0, 450, NULL, N'7322225200', N'7329237511', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Second Avenue', N'Long Branch', N'NJ', N'34025', N'07740', 40.295448, -73.983598, 2307, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3587, N'Saint Barnabas Medical Center', 1, NULL, NULL, N'310076', NULL, NULL, 0, 485, NULL, N'9733225000', N'9733225007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94 Old Short Hills Road', N'Livingston', N'NJ', N'34013', N'07039', 40.764045, -74.302334, 2306, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3588, N'Inspira Medical Center Woodbury', 1, NULL, NULL, N'310081', NULL, NULL, 0, 287, NULL, N'8566416616', N'8565755178', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 N Broad St', N'Woodbury', N'NJ', N'34015', N'08096', 39.843518, -75.149055, 2347, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3589, N'East Orange General Hospital', 1, NULL, NULL, N'310083', NULL, NULL, 0, 211, NULL, N'9732664401', N'9732668488', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Central Ave', N'East Orange', N'NJ', N'34013', N'07018', 40.753598, -74.213077, 2317, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3590, N'Monmouth Medical Center-Southern Campus', 1, NULL, NULL, N'310084', NULL, NULL, 0, 350, NULL, N'7323631900', N'7328864406', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 River Ave', N'Lakewood', N'NJ', N'34029', N'08701', 40.074178, -74.21735, 2305, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3591, N'Kennedy University Hospital - Stratford Div', 1, NULL, NULL, N'310086', NULL, NULL, 0, 607, NULL, N'8563467802', N'8563466005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18 East Laurel Road', N'Stratford', N'NJ', N'34007', N'08084', 39.828719, -75.008886, 2336, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3592, N'Memorial Hospital Of Salem County', 1, NULL, NULL, N'310091', NULL, NULL, 0, 152, NULL, N'8569351000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 Woodstown Road', N'Salem', N'NJ', N'34033', N'08079', 39.718816, -75.317877, 2331, 51, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3593, N'Capital Health System-Fuld Campus', 1, NULL, NULL, N'310092', NULL, NULL, 0, 269, NULL, N'6093946000', N'6093946687', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 Brunswick Ave', N'Trenton', N'NJ', N'34021', N'08638', 40.236123, -74.752705, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3594, N'Saint Michael''s Medical Center Inc', 1, NULL, NULL, N'310096', NULL, NULL, 0, 358, NULL, N'9738775350', N'9738775593', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Central Avenue', N'Newark', N'NJ', N'34013', N'07102', 40.743034, -74.174503, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3595, N'Jfk Medical Ctr - Anthony M. Yelencsics Community', 1, NULL, NULL, N'310108', NULL, NULL, 0, 551, NULL, N'7323217000', N'7325498532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'65 James Street', N'Edison', N'NJ', N'34023', N'08818', 40.557637, -74.348038, 2291, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3596, N'Robert Wood Johnson University Hospital Hamilton', 1, NULL, NULL, N'310110', NULL, NULL, 0, 248, NULL, N'6095867900', N'6098907638', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hamilton Health Place', N'Hamilton', N'NJ', N'34021', N'08690', 40.207057, -74.081251, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3597, N'Centrastate Medical Center', 1, NULL, NULL, N'310111', NULL, NULL, 0, 273, NULL, N'7324312000', N'7324625129', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Main Street', N'Freehold', N'NJ', N'34025', N'07728', 40.23566, -74.312025, 2296, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3598, N'Bayshore Community Hospital', 1, NULL, NULL, N'310112', NULL, NULL, 0, 225, NULL, N'7327395900', N'7327395887', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 N Beers St', N'Holmdel', N'NJ', N'34025', N'07733', 40.405264, -74.19418, 2301, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3599, N'Southern Ocean Medical Center', 1, NULL, NULL, N'310113', NULL, NULL, 0, 134, NULL, N'6095976011', N'6099788920', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1140 Rt 72 W', N'Manahawkin', N'NJ', N'34029', N'08050', 39.722365, -74.287799, 2308, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3600, N'Hackettstown Regional Medical Center', 1, NULL, NULL, N'310115', NULL, NULL, 0, 91, NULL, N'9088525100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Willow Grove St', N'Hackettstown', N'NJ', N'34041', N'07840', 40.860461, -74.815135, 2298, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3601, N'Meadowlands Hospital Medical Center', 1, NULL, NULL, N'310118', NULL, NULL, 0, 208, NULL, N'2013923200', N'2013923527', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Meadowlands Pkwy', N'Secaucus', N'NJ', N'34017', N'07094', 40.791736, -74.072165, 2332, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3602, N'University Hospital', 1, NULL, NULL, N'310119', NULL, NULL, 0, 518, NULL, N'9739725658', N'9739726943', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Bergen St', N'Newark', N'NJ', N'34013', N'07103', 40.740322, -74.192468, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3603, N'Hackensack-Umc At Pascack Valley', 1, NULL, NULL, N'310130', NULL, NULL, 0, 128, NULL, N'2013831074', N'2013831098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Old Hook Road', N'Westwood', N'NJ', N'34003', N'07675', 40.983671, -74.014254, 2345, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3604, N'Matheny School & Hospital The', 1, NULL, NULL, N'312014', NULL, NULL, 0, 102, NULL, N'9082340011', N'9087192137', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'65 Highland Avenue', N'Peapack', N'NJ', N'34035', N'07977', 40.716768, -74.656549, 2310, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3605, N'Specialty Hospital Of Central Jersey', 1, NULL, NULL, N'312017', NULL, NULL, 0, 50, NULL, N'7329423594', N'7329423595', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 River Avenue   4 West', N'Lakewood', N'NJ', N'34029', N'08701', 40.073107, -74.218579, 2305, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3606, N'Care One At Raritan Bay Medical Center Llc', 1, NULL, NULL, N'312018', NULL, NULL, 0, 51, NULL, N'7323246090', N'7323246091', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 New Brunswick Avenue 2Nd Floor Green', N'Perth Amboy', N'NJ', N'34023', N'08861', 40.5188914, -74.284008, 2321, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3607, N'Select Specialty Hospital Northeast', 1, NULL, NULL, N'312019', NULL, NULL, 0, 62, NULL, N'2012212352', N'2012212495', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'96 Parkway', N'Rochelle Park', N'NJ', N'34003', N'07662', 40.898003, -74.075828, 2297, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3608, N'Kindred Hospital New Jersey - Morris County', 1, NULL, NULL, N'312020', NULL, NULL, 0, 117, NULL, N'9735373816', N'9735373895', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Blackwell Street', N'Dover', N'NJ', N'34027', N'07801', 40.886142, -74.576714, 2290, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3609, N'Lourdes Specialty Hospital Of Southern New Jerse', 1, NULL, NULL, N'312022', NULL, NULL, 0, 30, NULL, N'6098355782', N'6098355784', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Sunset Road', N'Willingboro', N'NJ', N'34005', N'08046', 40.050428, -74.850715, 2346, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3610, N'Acuity Specialty Hospital Of New Jersey', 1, NULL, NULL, N'312023', NULL, NULL, 0, 30, NULL, N'6094412122', N'6094412169', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1925 Pacific Avenue 5Th Floor', N'Atlantic City', N'NJ', N'34001', N'08401', 39.357966, -74.433735, 2283, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3611, N'Columbus Hospital Ltach', 1, NULL, NULL, N'312024', NULL, NULL, 0, 63, NULL, N'9735877712', N'9735877830', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'495 North 13Th Street', N'Newark', N'NJ', N'34013', N'07107', 40.773025, -74.186868, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3612, N'Kessler Institute For Rehabilitation - West Fac', 1, NULL, NULL, N'313025', NULL, NULL, 0, 336, NULL, N'9737313600', N'9732436819', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1199 Pleasant Valley Way', N'West Orange', N'NJ', N'34013', N'07052', 40.785378, -74.277092, 2306, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3613, N'St Lawrence Rehabilitation Center', 1, NULL, NULL, N'313027', NULL, NULL, 0, 86, NULL, N'6098969500', N'6098950242', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2381 Lawrenceville Road', N'Lawrenceville', N'NJ', N'34021', N'08648', 40.285995, -74.732374, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3614, N'Healthsouth Rehabilitation Hospital Of Toms River', 1, NULL, NULL, N'313029', NULL, NULL, 0, 92, NULL, N'8007654772', N'7328184840', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 Hospital Drive', N'Toms River', N'NJ', N'34029', N'08755', 39.961306, -74.218249, 2340, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3615, N'Bacharach Institute For Rehabilitation', 1, NULL, NULL, N'313030', NULL, NULL, 0, 80, NULL, N'6096527000', N'6096527487', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'61 W Jimmie Leeds Road', N'Pomona', N'NJ', N'34001', N'08240', 39.480537, -74.566797, 2283, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3616, N'Marlton Rehabilitation Hospital', 1, NULL, NULL, N'313032', NULL, NULL, 0, 46, NULL, N'8569888778', N'8569888254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'92 Brick Road', N'Marlton', N'NJ', N'34005', N'08053', 39.873346, -74.937635, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3617, N'Shore Rehabilitation Institute', 1, NULL, NULL, N'313033', NULL, NULL, 0, 40, NULL, N'7328364530', N'7328364531', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Jack Martin Boulevard Second Floor East Wing', N'Brick', N'NJ', N'34029', N'08724', 40.073564, -74.122226, 2324, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3618, N'Healthsouth Rehabilitation Hospital Of Tinton Fall', 1, NULL, NULL, N'313035', NULL, NULL, 0, 60, NULL, N'7324605320', N'7324607446', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Centre Plaza', N'Tinton Falls', N'NJ', N'34025', N'07724', 40.286311, -74.078685, 2307, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3619, N'Healthsouth Rehabilitation Hospital Of Vineland', 1, NULL, NULL, N'313036', NULL, NULL, 0, 41, NULL, N'8566967100', N'8566969040', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1237 W Sherman Avenue', N'Vineland', N'NJ', N'34011', N'08360', 39.447774, -75.064397, 2343, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3620, N'Children''s Specialized Hospital', 1, NULL, NULL, N'313300', NULL, NULL, 0, 90, NULL, N'7322587137', N'7322587210', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Somerset Street', N'New Brunswick', N'NJ', N'34023', N'08901', 40.494995, -74.451921, 2313, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3621, N'Weisman Childrens Rehabilitation Hospital', 1, NULL, NULL, N'313302', NULL, NULL, 0, 30, NULL, N'8564894520', N'8564891169', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'92 Brick Road 3Rd Floor', N'Marlton', N'NJ', N'34005', N'08053', 39.873346, -74.937635, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3622, N'Summit Oaks Hospital', 1, NULL, NULL, N'314001', NULL, NULL, 0, 150, NULL, N'9085227000', N'9085227098', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19 Prospect St', N'Summit', N'NJ', N'34039', N'07901', 40.713907, -74.362896, 2337, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3623, N'Ancora Psych Hosp', 1, NULL, NULL, N'314005', NULL, NULL, 0, 709, NULL, N'6095611700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ancora Branch', N'Hammonton', N'NJ', N'34001', N'08037', 39.636506, -74.802385, 2299, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3624, N'University Behavioral Health Care', 1, NULL, NULL, N'314011', NULL, NULL, 0, 48, NULL, N'7322355900', N'7322354594', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'671 Hoes Lane', N'Piscataway', N'NJ', N'34023', N'08854', 40.529952, -74.471063, 2313, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3625, N'Carrier Clinic', 1, NULL, NULL, N'314012', NULL, NULL, 0, 281, NULL, N'9082811000', N'9082811680', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 Route 601', N'Belle Mead', N'NJ', N'34035', N'08502', 40.466771, -74.660714, 2334, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3626, N'Trenton Psychiatric Hosp', 1, NULL, NULL, N'314013', NULL, NULL, 0, 436, NULL, N'6096331586', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Station A', N'Trenton', N'NJ', N'34021', N'08625', 40.217058, -74.742946, 2341, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3627, N'Greystone Park Psych Hosp', 1, NULL, NULL, N'314016', NULL, NULL, 0, 605, NULL, N'9735381800', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Central Ave', N'Greystone Park', N'NJ', N'34027', N'07950', 40.075738, -74.404162, 2310, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3628, N'Northbrook Behavioral Health Hospital', 1, NULL, NULL, N'314018', NULL, NULL, 0, 150, NULL, N'8563746600', N'8563746520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425  Woodbury Turnersville Road', N'Blackwood', N'NJ', N'34007', N'08012', 39.792853, -75.080977, 2336, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3629, N'Ramapo Ridge Psych Hosp', 1, NULL, NULL, N'314019', NULL, NULL, 0, 58, NULL, N'2018485805', N'2018975181', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Sicomac Ave', N'Wyckoff', N'NJ', N'34003', N'07481', 40.984593, -74.171671, 2329, 183, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3630, N'Essex County Hospital Center', 1, NULL, NULL, N'314020', NULL, NULL, 0, 180, NULL, N'9735712801', N'9735712864', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Grove Avenue', N'Cedar Grove', N'NJ', N'34013', N'07009', 39.955918, -74.186632, 2309, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3631, N'Hampton Behavioral Health System', 1, NULL, NULL, N'314021', NULL, NULL, 0, 100, NULL, N'8006032194', N'6095182150', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'650 Rancocas Road', N'Westampton', N'NJ', N'34005', N'08060', 40.075738, -74.404162, 2311, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3632, N'St Barnabas Behavioral Health Center', 1, NULL, NULL, N'314022', NULL, NULL, 0, 40, NULL, N'7329141688', N'7329143854', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1691 Highway 9  -  Cn2025', N'Toms River', N'NJ', N'34029', N'08755', 39.953736, -74.197958, 2340, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3633, N'Aspen Hills Healthcare Center', 1, NULL, NULL, N'314023', NULL, NULL, 0, 30, NULL, N'6098366100', N'6098366101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Pemberton-Browns Mills Road', N'Pemberton', N'NJ', N'34005', N'08068', 39.971561, -74.685644, 2311, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3634, N'Hudson County Meadowview Psychiatric H', 1, NULL, NULL, N'314024', NULL, NULL, 0, 84, NULL, N'2013695252', N'2013695260', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 County Avenue', N'Secaucus', N'NJ', N'34017', N'07094', 40.781296, -74.058256, 2332, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3635, N'East Mountain Hospital', 1, NULL, NULL, N'314026', NULL, NULL, 0, 16, NULL, N'9082811500', N'9082811339', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 East Mountain Road', N'Belle Mead', N'NJ', N'34035', N'08502', 40.501971, -74.693547, 2334, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3636, N'Cornerstone Behavioral Health Hospital Of Union Co', 1, NULL, NULL, N'314027', NULL, NULL, 0, 44, NULL, N'9087715857', N'9087715820', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Watchung Way', N'Berkeley Heights', N'NJ', N'34039', N'07922', 40.66499, -74.421574, 2337, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3637, N'Our Lady Of Lourdes Medical Center', 1, NULL, NULL, N'319800', NULL, NULL, 0, 0, NULL, N'8567573500', N'8566352400', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1600 Haddon Avenue', N'Camden', N'NJ', N'34007', N'08103', 39.926832, -75.095258, 2287, 177, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3638, N'Robert Wood Johnson University Hospital', 1, NULL, NULL, N'319801', NULL, NULL, 0, 0, NULL, N'7324188365', N'7324188225', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Robert Wood Johnson Place', N'New Brunswick', N'NJ', N'34023', N'08901', 40.486217, -74.451817, 2313, 180, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3639, N'Hackensack University Medical Center', 1, NULL, NULL, N'319802', NULL, NULL, 0, 0, NULL, N'2019962608', N'2014980148', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'30 Prospect Ave', N'Hackensack', N'NJ', N'34003', N'07601', 40.884312, -74.05768, 2297, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3640, N'Newark Beth Israel Medical Center', 1, NULL, NULL, N'319803', NULL, NULL, 0, 0, NULL, N'9733228988', N'9733222634', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'201 Lyon Avenue At Osborne Terrace', N'Newark', N'NJ', N'34013', N'07112', 40.735657, -74.172367, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3641, N'St Barnabas Medical Center', 1, NULL, NULL, N'319804', NULL, NULL, 0, 0, NULL, N'9733225502', N'9733225007', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'94 Old Short Hills Road', N'Livingston', N'NJ', N'34013', N'07039', 40.767136, -74.301436, 2306, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3642, N'University Hospital University Of Medicine And De', 1, NULL, NULL, N'319805', NULL, NULL, 0, 0, NULL, N'9739721351', N'9739726227', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'150 Bergen Street', N'Newark', N'NJ', N'34013', N'07103', 40.7403044, -74.1923243, 2314, 181, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3643, N'Unm Hospital', 1, NULL, NULL, N'320001', NULL, NULL, 0, 527, NULL, N'5052722111', N'5052721827', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 Lomas Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87106', 35.087491, -106.616839, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3644, N'Christus St Vincent Regional Medical Center', 1, NULL, NULL, N'320002', NULL, NULL, 0, 248, NULL, N'5059135201', N'5059135210', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 St Michael''s Drive', N'Santa Fe', N'NM', N'35049', N'87505', 35.656958, -105.944465, 2368, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3645, N'Alta Vista Regional Hospital', 1, NULL, NULL, N'320003', NULL, NULL, 0, 62, NULL, N'5054263930', N'5054549502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 Legion Drive', N'Las Vegas', N'NM', N'35047', N'87701', 35.619764, -105.214841, 2362, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3646, N'Gerald Champion Regional Medical Center', 1, NULL, NULL, N'320004', NULL, NULL, 0, 94, NULL, N'5754396100', N'5754437858', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2669 North Scenic Drive', N'Alamordo', N'NM', N'35035', N'88310', 32.925637, -105.932653, 2348, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3647, N'San Juan Regional Medical Center', 1, NULL, NULL, N'320005', NULL, NULL, 0, 240, NULL, N'5056092000', N'5056096909', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 West Maple Street', N'Farmington', N'NM', N'35045', N'87401', 36.724842, -108.217946, 2356, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3648, N'Eastern New Mexico Medical Center', 1, NULL, NULL, N'320006', NULL, NULL, 0, 149, NULL, N'5756228170', N'5756248726', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 W Country Club Road', N'Roswell', N'NM', N'35005', N'88201', 33.423324, -104.529495, 2366, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3649, N'Lovelace Medical Center', 1, NULL, NULL, N'320009', NULL, NULL, 0, 254, NULL, N'5057278000', N'5057278162', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Dr Martin Luther King Jr Ave Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.085606, -106.639595, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3650, N'Presbyterian Espanola Hospital', 1, NULL, NULL, N'320011', NULL, NULL, 0, 80, NULL, N'5057531502', N'5053670257', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1010 Spruce Street', N'Espanola', N'NM', N'35039', N'87532', 35.997087, -106.087096, 2355, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3651, N'Holy Cross Hospital A Div Of Taos Health Systems', 1, NULL, NULL, N'320013', NULL, NULL, 0, 42, NULL, N'5757588883', N'5057515719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1397 Weimer Road', N'Taos', N'NM', N'35055', N'87571', 36.366863, -105.576688, 2372, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3652, N'Gila Regional Medical Center', 1, NULL, NULL, N'320016', NULL, NULL, 0, 68, NULL, N'5755384000', N'5755384096', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 E 32Nd St', N'Silver City', N'NM', N'35017', N'88061', 32.795578, -108.262432, 2370, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3653, N'Lovelace Women''s Hospital', 1, NULL, NULL, N'320017', NULL, NULL, 0, 120, NULL, N'5057277805', N'5057277888', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4701 Montmery Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87109', 35.131008, -106.591057, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3654, N'Memorial Medical Center Inc', 1, NULL, NULL, N'320018', NULL, NULL, 0, 286, NULL, N'5755228641', N'5755215013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2450 South Telshor Blvd', N'Las Cruces', N'NM', N'35013', N'88011', 32.291993, -106.735018, 2361, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3655, N'Presbyterian Hospital', 1, NULL, NULL, N'320021', NULL, NULL, 0, 623, NULL, N'5057248386', N'5058411861', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Central Avenue Se', N'Albuquerque', N'NM', N'35001', N'87106', 35.082348, -106.634908, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3656, N'Plains Regional Medical Center', 1, NULL, NULL, N'320022', NULL, NULL, 0, 106, NULL, N'5757697155', N'5757697337', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 N Martin Luther King Jr Blvd', N'Clovis', N'NM', N'35009', N'88101', 34.405472, -103.205071, 2353, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3657, N'Artesia General Hospital', 1, NULL, NULL, N'320030', NULL, NULL, 0, 38, NULL, N'5757483333', N'5757488540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 N 13Th Street', N'Artesia', N'NM', N'35015', N'88210', 32.849732, -104.412753, 2350, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3658, N'Los Alamos Medical Center', 1, NULL, NULL, N'320033', NULL, NULL, 0, 53, NULL, N'5056624201', N'5056619598', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3917 West Road', N'Los Alamos', N'NM', N'35028', N'87544', 35.882215, -106.319762, 2363, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3659, N'Rehoboth Mckinley Christian Health Care Services', 1, NULL, NULL, N'320038', NULL, NULL, 0, 69, NULL, N'5058637000', N'5058635806', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Red Rock Drive', N'Gallup', N'NM', N'35031', N'87301', 35.5075, -108.727248, 2358, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3660, N'Santa Fe Phs Indian Hospital', 1, NULL, NULL, N'320057', NULL, NULL, 0, 20, NULL, N'5059889821', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Cerrillos Road', N'Santa Fe', N'NM', N'35049', N'87501', 35.66695, -105.969665, 2368, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3661, N'Mescalero Phs Indian Hospital', 1, NULL, NULL, N'320058', NULL, NULL, 0, 15, NULL, N'5054644441', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 210', N'Mescalero', N'NM', N'35035', N'88340', 33.157442, -105.774244, 2375, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3662, N'Northern Navajo Medical Center', 1, NULL, NULL, N'320059', NULL, NULL, 0, 69, NULL, N'5053686001', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Us Hwy 491 North', N'Shiprock', N'NM', N'35045', N'87420', 36.786304, -108.684558, 2376, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3663, N'Zuni Comprehensive Community Health Center', 1, NULL, NULL, N'320060', NULL, NULL, 0, 35, NULL, N'5057824431', N'5057827405', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Route 301 North B Street', N'Zuni', N'NM', N'35031', N'87327', 35.069789, -108.847636, 2377, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3664, N'Gallup Indian Medical Center', 1, NULL, NULL, N'320061', NULL, NULL, 0, 85, NULL, N'5057221000', N'5057221397', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 E Nizhoni Blvd', N'Gallup', N'NM', N'35031', N'87301', 35.508444, -108.730203, 2358, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3665, N'Crownpoint Healthcare Facility', 1, NULL, NULL, N'320062', NULL, NULL, 0, 20, NULL, N'5057865291', N'5057866440', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Junction Of Hwy 371', N'Crownpoint', N'NM', N'35031', N'87313', 35.679, -108.147205, 2358, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3666, N'Carlsbad Medical Center', 1, NULL, NULL, N'320063', NULL, NULL, 0, 116, NULL, N'5758874570', N'5758874256', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2430 West Pierce Street', N'Carlsbad', N'NM', N'35015', N'88220', 32.441835, -104.258655, 2351, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3667, N'Lea Regional Medical Center', 1, NULL, NULL, N'320065', NULL, NULL, 0, 250, NULL, N'5754925000', N'5754925505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5419 N Lovington Highway', N'Hobbs', N'NM', N'35025', N'88240', 32.761045, -103.181283, 2360, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3668, N'Guadalupe County Hospital', 1, NULL, NULL, N'320067', NULL, NULL, 0, 12, NULL, N'5754723417', N'5754724587', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'117 Camino De Vida Suite 100', N'Santa Rosa', N'NM', N'35019', N'88435', 34.93867, -104.682489, 2369, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3669, N'Dhhs Usphs Indian Health Services', 1, NULL, NULL, N'320070', NULL, NULL, 0, 32, NULL, N'5055525300', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Exit #102 Off I-40 1/2 Mile South', N'San Fidel', N'NM', N'35006', N'87049', 35.082801, -107.598048, 2359, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3670, N'Lovelace Westside Hospital', 1, NULL, NULL, N'320074', NULL, NULL, 0, 95, NULL, N'5057272001', N'5057279565', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10501 lf Course Road Nw', N'Albuquerque', N'NM', N'35001', N'87114', 35.208049, -106.676523, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3671, N'Roosevelt General Hospital', 1, NULL, NULL, N'320084', NULL, NULL, 0, 22, NULL, N'5753563412', N'5753569212', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42121 Us Highway 70', N'Portales', N'NM', N'35041', N'88130', 34.172648, -103.358944, 2364, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3672, N'Mountain View Regional Medical Center', 1, NULL, NULL, N'320085', NULL, NULL, 0, 168, NULL, N'5755567600', N'5755567619', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4311 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.322639, -106.728297, 2361, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3673, N'Lovelace Regional Hospital - Roswell', 1, NULL, NULL, N'320086', NULL, NULL, 0, 26, NULL, N'5756277000', N'5756253309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 East 19Th Street', N'Roswell', N'NM', N'35005', N'88201', 33.415977, -104.521831, 2366, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3674, N'Unm Sandoval Regional Medical Center', 1, NULL, NULL, N'320089', NULL, NULL, 0, 72, NULL, N'5052728087', N'5052726507', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3001 Broadmoor Blvd Ne', N'Rio Rancho', N'NM', N'35043', N'87144', 35.307062, -106.676997, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3675, N'Sierra Vista Hospital', 1, NULL, NULL, N'321300', NULL, NULL, 0, 15, NULL, N'5758942111', N'5758947659', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East 9Th Street', N'T Or C', N'NM', N'35051', N'87901', 33.139104, -107.241975, 2373, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3676, N'Socorro General Hospital', 1, NULL, NULL, N'321301', NULL, NULL, 0, 24, NULL, N'5758351140', N'5758358703', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1202 Highway 60 West', N'Socorro', N'NM', N'35053', N'87801', 34.027937, -106.919358, 2371, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3677, N'Dr Dan C Trigg Memorial Hospital', 1, NULL, NULL, N'321302', NULL, NULL, 0, 25, NULL, N'5754617007', N'5754617272', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East Miel De Luna Avenue', N'Tucumcari', N'NM', N'35037', N'88401', 35.156329, -103.723592, 2374, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3678, N'Union County General Hospital', 1, NULL, NULL, N'321304', NULL, NULL, 0, 25, NULL, N'5753742585', N'5753748146', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wilson Street', N'Clayton', N'NM', N'35059', N'88415', 36.45564, -103.19208, 2352, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3679, N'Nor-Lea Hospital District', 1, NULL, NULL, N'321305', NULL, NULL, 0, 25, NULL, N'5753966611', N'5753960318', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 North Main', N'Lovington', N'NM', N'35025', N'88260', 32.96479, -103.348637, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3680, N'Lincoln County Medical Center', 1, NULL, NULL, N'321306', NULL, NULL, 0, 25, NULL, N'5752578250', N'5756304233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Sudderth Drive', N'Ruidoso', N'NM', N'35027', N'88345', 33.322919, -105.631874, 2367, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3681, N'Miners'' Colfax Medical Center', 1, NULL, NULL, N'321307', NULL, NULL, 0, 25, NULL, N'5754453661', N'5754457875', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 Hospital Drive', N'Raton', N'NM', N'35007', N'87740', 36.864206, -104.442954, 2365, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3682, N'Cibola General Hospital', 1, NULL, NULL, N'321308', NULL, NULL, 0, 25, NULL, N'5052874446', N'5052875309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1016 E Roosevelt Avenue', N'Grants', N'NM', N'35006', N'87020', 35.161179, -107.82553, 2359, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3683, N'Mimbres Memorial Hospital', 1, NULL, NULL, N'321309', NULL, NULL, 0, 49, NULL, N'5755465803', N'5755436907', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 W Ash', N'Deming', N'NM', N'35029', N'88031', 32.26125, -107.768748, 2354, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3684, N'Kindred Hospital  Albuquerque', 1, NULL, NULL, N'322002', NULL, NULL, 0, 61, NULL, N'5052424444', N'5058437170', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 High Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3685, N'Albuquerque - Amg Specialty Hospital Llc', 1, NULL, NULL, N'322003', NULL, NULL, 0, 25, NULL, N'5058425550', N'5052470206', 1, 0, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', -100.445882, 0, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3686, N'Advanced Care Hospital Of Southern New Mexico Llc', 1, NULL, NULL, N'322004', NULL, NULL, 0, 20, NULL, N'5755216600', N'5755325077', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4451 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.325773, -106.724827, 2361, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3687, N'New Mexico Rehabilitation Center', 1, NULL, NULL, N'323026', NULL, NULL, 0, 41, NULL, N'5753473400', N'5753475177', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'72 Gail Harris Avenue', N'Roswell', N'NM', N'35005', N'88203', 33.394266, -104.523024, 2366, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3688, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'323027', NULL, NULL, 0, 61, NULL, N'5053449478', N'5053412717', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Jefferson Street Ne', N'Albuquerque', N'NM', N'35001', N'87109', 35.190483, -106.593598, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3689, N'Lovelace Rehabilitation Hospital', 1, NULL, NULL, N'323028', NULL, NULL, 0, 52, NULL, N'5057274781', N'5057279404', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3690, N'San Juan Regional Rehabilitation Hospital Inc', 1, NULL, NULL, N'323029', NULL, NULL, 0, 18, NULL, N'5056092630', N'5053276562', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 South Schwartz Avenue', N'Farmington', N'NM', N'35045', N'87401', 36.724449, -108.215643, 2356, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3691, N'Rehabilitation Hospital Of Southern New Mexicoinc', 1, NULL, NULL, N'323032', NULL, NULL, 0, 56, NULL, N'5755216400', N'5755216423', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4441 East Lohman Avenue', N'Las Cruces', N'NM', N'35013', N'88011', 32.3252045, -106.7263947, 2361, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3692, N'Bhc Mesilla Valley Hospital Llc', 1, NULL, NULL, N'324010', NULL, NULL, 0, 88, NULL, N'5753823500', N'5753824900', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3751 Del Rey Boulevard', N'Las Cruces', N'NM', N'35013', N'88012', 32.3567216, -106.77591, 2361, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3693, N'Peak Behavioral Health Services Llc', 1, NULL, NULL, N'324012', NULL, NULL, 0, 56, NULL, N'5755893000', N'5055896730', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5065 Mcnutt Road', N'Santa Teresa', N'NM', N'35013', N'88008', 31.8417763, -106.6254267, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3694, N'Haven Behavioral Hospital Of Albuquerque', 1, NULL, NULL, N'324013', NULL, NULL, 0, 34, NULL, N'5052544503', N'5052544501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5400 Gibson Boulevard Se 4Th Floor', N'Albuquerque', N'NM', N'35001', N'87108', 35.042789, -106.741007, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3695, N'Central Desert Behavioral Health Center', 1, NULL, NULL, N'324014', NULL, NULL, 0, 26, NULL, N'5052433387', N'5052477986', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'239 Elm Street Ne', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3696, N'Presbyterian Healthcare Transplant', 1, NULL, NULL, N'329801', NULL, NULL, 0, 0, NULL, N'5058411275', N'5052222149', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 Central Se', N'Albuquerque', N'NM', N'35001', N'87102', 35.084103, -106.650985, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3697, N'University Hospital University Of New Mexico Heal', 1, NULL, NULL, N'329802', NULL, NULL, 0, 0, NULL, N'5052722583', N'5052723150', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2211 Lomas Boulevard Ne', N'Albuquerque', N'NM', N'35001', N'87106', 35.0881956, -106.6212476, 2349, 184, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3698, N'Albany Memorial Hospital', 1, NULL, NULL, N'330003', NULL, NULL, 0, 165, NULL, N'5184713221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Northern Boulevard', N'Albany', N'NY', N'36001', N'12204', 42.674326, -73.749301, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3699, N'Healthalliance Hospital Broadway Campus', 1, NULL, NULL, N'330004', NULL, NULL, 0, 160, NULL, N'9143313131', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'396 Broadway', N'Kingston', N'NY', N'36111', N'12401', 41.926475, -73.995792, 2433, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3700, N'Kaleida Health', 1, NULL, NULL, N'330005', NULL, NULL, 0, 1157, NULL, N'7168598620', N'7168598678', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 Exchange Street Suite 522', N'Buffalo', N'NY', N'36029', N'14210', 42.874534, -78.849749, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3701, N'St Joseph''s Medical Center', 1, NULL, NULL, N'330006', NULL, NULL, 0, 332, NULL, N'9143787000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'127 South Broadway', N'Yonkers', N'NY', N'36119', N'10701', 40.92965, -73.897041, 2509, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3702, N'Wyoming County Community Hospital', 1, NULL, NULL, N'330008', NULL, NULL, 0, 62, NULL, N'5857862233', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 North Main Street', N'Warsaw', N'NY', N'36121', N'14569', 42.753447, -78.132533, 2502, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3703, N'Bronx-Lebanon Hospital Center', 1, NULL, NULL, N'330009', NULL, NULL, 0, 579, NULL, N'2125887000', N'7185881686', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1276 Fulton Avenue', N'Bronx', N'NY', N'36005', N'10456', 40.83175, -73.903756, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3704, N'Our Lady Of Lourdes Memorial Hospital Inc', 1, NULL, NULL, N'330011', NULL, NULL, 0, 267, NULL, N'6077985111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Riverside Drive', N'Binghamton', N'NY', N'36007', N'13905', 42.092638, -75.935541, 2387, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3705, N'Albany Medical Center Hospital', 1, NULL, NULL, N'330013', NULL, NULL, 0, 714, NULL, N'5182623125', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43 New Scotland Avenue', N'Albany', N'NY', N'36001', N'12208', 42.653333, -73.773775, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3706, N'Jamaica Hospital Medical Center', 1, NULL, NULL, N'330014', NULL, NULL, 0, 424, NULL, N'7182626000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'89Th Avenue And Van Wyck Expressway', N'Jamaica', N'NY', N'36081', N'11418', 40.703338, -73.810578, 2430, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3707, N'New York Community Hospital Of Brooklyn Inc.', 1, NULL, NULL, N'330019', NULL, NULL, 0, 134, NULL, N'7186925302', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Kings Highway', N'Brooklyn', N'NY', N'36047', N'11229', 40.613359, -73.948947, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3708, N'Vassar Brothers Medical Center', 1, NULL, NULL, N'330023', NULL, NULL, 0, 365, NULL, N'8454548500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Reade Place', N'Poughkeepsie', N'NY', N'36027', N'12601', 41.694574, -73.935734, 2476, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3709, N'Mount Sinai Hospital', 1, NULL, NULL, N'330024', NULL, NULL, 0, 1171, NULL, N'2122417981', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Gustave L Levy Place', N'New York', N'NY', N'36061', N'10029', 43.102443, -75.291082, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3710, N'Nassau University Medical Center', 1, NULL, NULL, N'330027', NULL, NULL, 0, 530, NULL, N'5165720123', N'5165725792', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Hempstead Turnpike', N'East Meadow', N'NY', N'36059', N'11554', 40.725298, -73.554413, 2409, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3711, N'Richmond University Medical Center', 1, NULL, NULL, N'330028', NULL, NULL, 0, 473, NULL, N'7188181234', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 Bard Avenue', N'Staten Island', N'NY', N'36085', N'10304', 40.635731, -74.106735, 2492, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3712, N'Newark-Wayne Community Hospital', 1, NULL, NULL, N'330030', NULL, NULL, 0, 120, NULL, N'3153322022', N'3153322371', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Driving Park Avenue', N'Newark', N'NY', N'36117', N'14513', 43.060063, -77.099713, 2453, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3713, N'Chenan Memorial Hospital Inc', 1, NULL, NULL, N'330033', NULL, NULL, 0, 58, NULL, N'6073354111', N'6073342024', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'179 North Broad Street', N'Norwich', N'NY', N'36017', N'13815', 42.541885, -75.524709, 2459, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3714, N'Lakeside Memorial Hospital', 1, NULL, NULL, N'330037', NULL, NULL, 0, 61, NULL, N'5856373131', N'5853956036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'156 West Avenue', N'Brockport', N'NY', N'36055', N'14420', 43.219989, -77.95381, 2388, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3715, N'Southside Hospital', 1, NULL, NULL, N'330043', NULL, NULL, 0, 341, NULL, N'6319683000', N'6319683315', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 East Main Street', N'Bay Shore', N'NY', N'36103', N'11706', 40.724781, -73.241346, 2385, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3716, N'Faxton-St Luke''s Healthcare', 1, NULL, NULL, N'330044', NULL, NULL, 0, 372, NULL, N'3157986000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1656 Champlin Avenue', N'Utica', N'NY', N'36065', N'13503', 43.098141, -75.275278, 2499, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3717, N'Huntington Hospital', 1, NULL, NULL, N'330045', NULL, NULL, 0, 408, NULL, N'6313512000', N'6313512586', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 Park Avenue', N'Huntington', N'NY', N'36103', N'11743', 40.880096, -73.417599, 2427, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3718, N'St Luke''s Roosevelt Hospital', 1, NULL, NULL, N'330046', NULL, NULL, 0, 1028, NULL, N'2125234000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Tenth Avenue', N'New York', N'NY', N'36061', N'10019', 40.770114, -73.987858, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3719, N'St Mary''s Hospital At Amsterdam', 1, NULL, NULL, N'330047', NULL, NULL, 0, 149, NULL, N'5188421900', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'427 Guy Park Avenue', N'Amsterdam', N'NY', N'36057', N'12010', 42.95386, -74.216686, 2381, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3720, N'Northern Dutchess Hospital', 1, NULL, NULL, N'330049', NULL, NULL, 0, 68, NULL, N'8458713391', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6511 Springbrook Avenue', N'Rhinebeck', N'NY', N'36027', N'12572', 41.934723, -73.911571, 2477, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3721, N'Medina Memorial Hospital', 1, NULL, NULL, N'330053', NULL, NULL, 0, 71, NULL, N'5857988111', N'5857988107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Ohio Street', N'Medina', N'NY', N'36073', N'14103', 43.223582, -78.397182, 2445, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3722, N'New York-Presbyterian/Queens', 1, NULL, NULL, N'330055', NULL, NULL, 0, 489, NULL, N'7186702000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'56-45 Main Street', N'Flushing', N'NY', N'36081', N'11355', 40.747277, -73.826137, 2414, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3723, N'Brooklyn Hospital Center At Downtown Campus', 1, NULL, NULL, N'330056', NULL, NULL, 0, 464, NULL, N'7182508000', N'7186254109', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 Dekalb Avenue', N'Brooklyn', N'NY', N'36047', N'11201', 40.689785, -73.9774, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3724, N'St Peter''s Hospital', 1, NULL, NULL, N'330057', NULL, NULL, 0, 442, NULL, N'5185251550', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 South Manning Boulevard', N'Albany', N'NY', N'36001', N'12208', 42.657501, -73.803987, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3725, N'Geneva General Hospital', 1, NULL, NULL, N'330058', NULL, NULL, 0, 132, NULL, N'3157874175', N'3157874029', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'196 -198 North Street', N'Geneva', N'NY', N'36069', N'14456', 42.875702, -76.988003, 2416, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3726, N'Montefiore Medical Center', 1, NULL, NULL, N'330059', NULL, NULL, 0, 1491, NULL, N'7189204321', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 East 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.879777, -73.879975, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3727, N'Lawrence Hospital Center', 1, NULL, NULL, N'330061', NULL, NULL, 0, 291, NULL, N'9147871000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Palmer Avenue', N'Bronxville', N'NY', N'36119', N'10708', 40.941636, -73.836245, 2390, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3728, N'New York Downtown Hospital', 1, NULL, NULL, N'330064', NULL, NULL, 0, 180, NULL, N'2123125000', N'2123125196', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 William Street', N'New York', N'NY', N'36061', N'10038', 40.710751, -74.005133, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3729, N'Niagara Falls Memorial Medical Center', 1, NULL, NULL, N'330065', NULL, NULL, 0, 171, NULL, N'7162784000', N'7162784054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 Tenth Street', N'Niagara Falls', N'NY', N'36063', N'14302', 43.094057, -79.050478, 2456, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3730, N'St Clare''s Hospital', 1, NULL, NULL, N'330066', NULL, NULL, 0, 200, NULL, N'5183822000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Mcclellan Street', N'Schenectady', N'NY', N'36093', N'12304', 42.805216, -73.917425, 2484, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3731, N'St Francis Hospital', 1, NULL, NULL, N'330067', NULL, NULL, 0, 292, NULL, N'8454835000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'241 North Road', N'Poughkeepsie', N'NY', N'36027', N'12601', 41.717797, -73.927585, 2476, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3732, N'United Memorial Medical Center', 1, NULL, NULL, N'330073', NULL, NULL, 0, 166, NULL, N'5853436030', N'5853437434', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'127 North Street', N'Batavia', N'NY', N'36037', N'14020', 43.003997, -78.177592, 2383, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3733, N'F F Thompson Hospital', 1, NULL, NULL, N'330074', NULL, NULL, 0, 113, NULL, N'5853966000', N'5853966481', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Parrish Street', N'Canandaigua', N'NY', N'36069', N'14424', 42.874854, -77.290111, 2394, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3734, N'Sisters Of Charity Hospital', 1, NULL, NULL, N'330078', NULL, NULL, 0, 413, NULL, N'7168621000', N'7168621899', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2157 Main Street', N'Buffalo', N'NY', N'36029', N'14214', 42.929195, -78.84989, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3735, N'Adirondack Medical Center', 1, NULL, NULL, N'330079', NULL, NULL, 0, 95, NULL, N'5188914141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2233 State Route 86', N'Saranac Lake', N'NY', N'36033', N'12983', 44.343914, -74.144441, 2482, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3736, N'Lincoln Medical & Mental Health Center', 1, NULL, NULL, N'330080', NULL, NULL, 0, 586, NULL, N'7185795000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'234 East 149Th Street', N'Bronx', N'NY', N'36005', N'10451', 40.817711, -73.924188, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3737, N'Alice Hyde Medical Center', 1, NULL, NULL, N'330084', NULL, NULL, 0, 76, NULL, N'5184833000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'133 Park Street', N'Malone', N'NY', N'36033', N'12953', 44.856786, -74.29198, 2441, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3738, N'Aurelia Osborn Fox Memorial Hospital', 1, NULL, NULL, N'330085', NULL, NULL, 0, 60, NULL, N'6074232000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Norton Avenue', N'Oneonta', N'NY', N'36077', N'13820', 42.453492, -75.062953, 2465, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3739, N'Montefiore Mount Vernon Hospital', 1, NULL, NULL, N'330086', NULL, NULL, 0, 245, NULL, N'9146648000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12 North 7Th Avenue', N'Mount Vernon', N'NY', N'36119', N'10550', 40.91248, -73.839934, 2450, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3740, N'Eastern Long Island Hospital', 1, NULL, NULL, N'330088', NULL, NULL, 0, 85, NULL, N'6314771000', N'6314771746', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Manor Place', N'Greenport', N'NY', N'36103', N'11944', 41.11068, -72.36212, 2423, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3741, N'Arnot Ogden Medical Center', 1, NULL, NULL, N'330090', NULL, NULL, 0, 266, NULL, N'6077374100', N'6077374447', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Roe Avenue', N'Elmira', N'NY', N'36015', N'14905', 42.099256, -76.826668, 2412, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3742, N'Columbia Memorial Hospital', 1, NULL, NULL, N'330094', NULL, NULL, 0, 124, NULL, N'5188287601', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Prospect Avenue', N'Hudson', N'NY', N'36021', N'12534', 42.246221, -73.776159, 2397, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3743, N'Jones Memorial Hospital', 1, NULL, NULL, N'330096', NULL, NULL, 0, 70, NULL, N'5855931100', N'5855964005', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'191 North Main Street', N'Wellsville', N'NY', N'36003', N'14895', 42.122929, -77.949868, 2505, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3744, N'N Y Eye And Ear Infirmary', 1, NULL, NULL, N'330100', NULL, NULL, 0, 69, NULL, N'2129794000', NULL, 1, 0, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 East 14Th Street', N'New York', N'NY', N'36061', N'10003', 40.732269, -73.984761, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3745, N'New York-Presbyterian Hospital', 1, NULL, NULL, N'330101', NULL, NULL, 0, 2262, NULL, N'2127464189', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East 68Th Street', N'New York', N'NY', N'36061', N'10021', 40.764059, -73.955023, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3746, N'Kenmore Mercy Hospital', 1, NULL, NULL, N'330102', NULL, NULL, 0, 184, NULL, N'7164476100', N'7164476090', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2950 Elmwood Avenue', N'Kenmore', N'NY', N'36029', N'14217', 42.9779, -78.878678, 2432, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3747, N'Olean General Hospital', 1, NULL, NULL, N'330103', NULL, NULL, 0, 186, NULL, N'7163732600', N'7163756360', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Main Street', N'Olean', N'NY', N'36009', N'14760', 42.089448, -78.426977, 2463, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3748, N'Nyack Hospital', 1, NULL, NULL, N'330104', NULL, NULL, 0, 375, NULL, N'8453482000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 North Midland Avenue', N'Nyack', N'NY', N'36087', N'10960', 41.0952, -73.925273, 2460, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3749, N'North Shore University Hospital', 1, NULL, NULL, N'330106', NULL, NULL, 0, 812, NULL, N'5165620100', N'5165621395', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Community Drive', N'Manhasset', N'NY', N'36059', N'11030', 40.775035, -73.703132, 2442, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3750, N'Peconic Bay Medical Center', 1, NULL, NULL, N'330107', NULL, NULL, 0, 122, NULL, N'6315486000', N'6317278890', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Roanoke Avenue', N'Riverhead', N'NY', N'36103', N'11901', 40.933578, -72.674317, 2478, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3751, N'St Joseph''s Hospital Inc', 1, NULL, NULL, N'330108', NULL, NULL, 0, 105, NULL, N'6077336541', N'6077377837', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 St Joseph''s Blvd', N'Elmira', N'NY', N'36015', N'14902', 42.091393, -76.796843, 2412, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3752, N'Bertrand Chaffee Hospital', 1, NULL, NULL, N'330111', NULL, NULL, 0, 49, NULL, N'7165922871', N'7165929674', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 East Main Street', N'Springville', N'NY', N'36029', N'14141', 42.508483, -78.659178, 2490, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3753, N'Oneida Healthcare', 1, NULL, NULL, N'330115', NULL, NULL, 0, 101, NULL, N'3153636000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Genesee Street', N'Oneida', N'NY', N'36053', N'13421', 43.078737, -75.654385, 2464, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3754, N'Lenox Hill Hospital', 1, NULL, NULL, N'330119', NULL, NULL, 0, 652, NULL, N'2124392345', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 East 77Th Street', N'New York', N'NY', N'36061', N'10021', 40.773978, -73.960654, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3755, N'Rochester General Hospital', 1, NULL, NULL, N'330125', NULL, NULL, 0, 528, NULL, N'5859224000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1425 Portland Avenue', N'Rochester', N'NY', N'36055', N'14621', 43.192542, -77.584424, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3756, N'Orange Regional Medical Center', 1, NULL, NULL, N'330126', NULL, NULL, 0, 450, NULL, N'8453432424', N'8453332801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 East Main Street', N'Middletown', N'NY', N'36071', N'10940', 41.439962, -74.369415, 2446, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3757, N'Jacobi Medical Center', 1, NULL, NULL, N'330127', NULL, NULL, 0, 457, NULL, N'7189185000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Pelham Parkway South', N'Bronx', N'NY', N'36005', N'10461', 40.857439, -73.846706, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3758, N'Elmhurst Hospital Center', 1, NULL, NULL, N'330128', NULL, NULL, 0, 545, NULL, N'7183341141', N'7183341810', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'79-01 Broadway', N'Elmhurst', N'NY', N'36081', N'11373', 40.74434, -73.88598, 2414, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3759, N'Tlc Health Network', 1, NULL, NULL, N'330132', NULL, NULL, 0, 45, NULL, N'7165323377', N'7169349604', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Memorial Drive', N'wanda', N'NY', N'36009', N'14070', 42.465449, -78.942919, 2422, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3760, N'Bon Secours Community Hospital', 1, NULL, NULL, N'330135', NULL, NULL, 0, 141, NULL, N'8458565351', N'8458587415', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 East Main Street', N'Port Jervis', N'NY', N'36071', N'12771', 41.367955, -74.682557, 2474, 179, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3761, N'Mary Imogene Bassett Hospital', 1, NULL, NULL, N'330136', NULL, NULL, 0, 180, NULL, N'6075473456', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Atwell Road', N'Cooperstown', N'NY', N'36077', N'13326', 42.70063, -74.924321, 2401, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3762, N'St Joseph''s Hospital Health Center', 1, NULL, NULL, N'330140', NULL, NULL, 0, 431, NULL, N'3154485111', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Prospect Avenue', N'Syracuse', N'NY', N'36067', N'13203', 43.055782, -76.149328, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3763, N'Brookhaven Memorial Hospital Medical Center', 1, NULL, NULL, N'330141', NULL, NULL, 0, 306, NULL, N'6316547100', N'6314473714', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Road', N'Patchogue', N'NY', N'36103', N'11772', 40.779156, -72.978132, 2467, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3764, N'Ira Davenport Memorial Hospital Inc', 1, NULL, NULL, N'330144', NULL, NULL, 0, 66, NULL, N'6077768500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7571 State Route 54', N'Bath', N'NY', N'36101', N'14810', 42.372854, -77.278776, 2384, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3765, N'St James Mercy Hospital', 1, NULL, NULL, N'330151', NULL, NULL, 0, 157, NULL, N'6073248000', N'6073248115', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Canisteo Street', N'Hornell', N'NY', N'36101', N'14843', 42.313509, -77.659856, 2426, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3766, N'Ellis Hospital', 1, NULL, NULL, N'330153', NULL, NULL, 0, 368, NULL, N'5182434196', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Nott Street', N'Schenectady', N'NY', N'36093', N'12308', 42.8191, -73.91653, 2484, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3767, N'Memorial Hospital For Cancer And Allied Diseases', 1, NULL, NULL, N'330154', NULL, NULL, 0, 514, NULL, N'2126392000', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 York Avenue', N'New York', N'NY', N'36061', N'10021', 40.764045, -73.956024, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3768, N'Samaritan Medical Center', 1, NULL, NULL, N'330157', NULL, NULL, 0, 287, NULL, N'3157854121', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Washington Street', N'Watertown', N'NY', N'36045', N'13601', 43.965106, -75.912719, 2504, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3769, N'od Samaritan Hospital Of Suffern', 1, NULL, NULL, N'330158', NULL, NULL, 0, 269, NULL, N'9143685000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 Lafayette Avenue', N'Suffern', N'NY', N'36087', N'10901', 41.112304, -74.133051, 2494, 183, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3770, N'Community-General Hospital Of Greater Syracuse', 1, NULL, NULL, N'330159', NULL, NULL, 0, 306, NULL, N'3154925011', N'3154925953', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Broad Road', N'Syracuse', N'NY', N'36067', N'13215', 43.048122, -76.147424, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3771, N'Staten Island University Hospital', 1, NULL, NULL, N'330160', NULL, NULL, 0, 714, NULL, N'7182269000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Seaview Avenue', N'Staten Island', N'NY', N'36085', N'10305', 40.583245, -74.085416, 2492, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3772, N'Northern Westchester Hospital', 1, NULL, NULL, N'330162', NULL, NULL, 0, 259, NULL, N'9146661200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Main Street', N'Mount Kisco', N'NY', N'36119', N'10549', 41.196569, -73.724487, 2449, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3773, N'Eastern Niagara Hospital', 1, NULL, NULL, N'330163', NULL, NULL, 0, 148, NULL, N'7165145700', N'7165145549', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'521 East Avenue', N'Lockport', N'NY', N'36063', N'14094', 43.17638, -78.671075, 2437, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3774, N'Highland Hospital', 1, NULL, NULL, N'330164', NULL, NULL, 0, 261, NULL, N'5854732200', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Avenue', N'Rochester', N'NY', N'36055', N'14620', 43.135184, -77.607745, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3775, N'Westfield Memorial Hospital Inc', 1, NULL, NULL, N'330166', NULL, NULL, 0, 4, NULL, N'7163264921', N'7163263802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 East Main Street', N'Westfield', N'NY', N'36013', N'14787', 42.327907, -79.569388, 2507, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3776, N'Winthrop-University Hospital', 1, NULL, NULL, N'330167', NULL, NULL, 0, 591, NULL, N'5166630333', N'5166632953', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'259 First Street', N'Mineola', N'NY', N'36059', N'11501', 40.741643, -73.643554, 2447, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3777, N'Beth Israel Medical Center', 1, NULL, NULL, N'330169', NULL, NULL, 0, 1111, NULL, N'2124202000', N'2124202881', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'First Avenue At 16Th Street', N'New York', N'NY', N'36061', N'10003', 40.732665, -73.9816, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3778, N'Cortland Regional Medical Center Inc', 1, NULL, NULL, N'330175', NULL, NULL, 0, 181, NULL, N'6077563500', N'6077563590', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 Homer Avenue', N'Cortland', N'NY', N'36023', N'13045', 42.609031, -76.186119, 2404, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3779, N'Samaritan Hospital', 1, NULL, NULL, N'330180', NULL, NULL, 0, 238, NULL, N'5182713225', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Burdett Avenue', N'Troy', N'NY', N'36083', N'12180', 42.734018, -73.671251, 2498, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3780, N'Glen Cove Hospital', 1, NULL, NULL, N'330181', NULL, NULL, 0, 247, NULL, N'5166747300', N'5166747588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 St Andrews Lane', N'Glen Cove', N'NY', N'36059', N'11542', 40.871508, -73.623321, 2417, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3781, N'St Francis Hospital Roslyn', 1, NULL, NULL, N'330182', NULL, NULL, 0, 364, NULL, N'5165626000', N'5165626909', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Port Washington Boulevard', N'Roslyn', N'NY', N'36059', N'11576', 40.759742, -73.625475, 2442, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3782, N'Montefiore New Rochelle Hospital', 1, NULL, NULL, N'330184', NULL, NULL, 0, 242, NULL, N'9146325000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16 Guion Place', N'New Rochelle', N'NY', N'36119', N'10802', 40.912931, -73.786985, 2451, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3783, N'John T Mather Memorial Hospital  Of Port Jefferson', 1, NULL, NULL, N'330185', NULL, NULL, 0, 248, NULL, N'6314731320', N'6314737367', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 North Country Road', N'Port Jefferson', N'NY', N'36103', N'11777', 40.938128, -73.053786, 2473, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3784, N'Mount St Mary''s Hospital And  Health Center', 1, NULL, NULL, N'330188', NULL, NULL, 0, 179, NULL, N'7162974800', N'7162982001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5300 Military Road', N'Lewiston', N'NY', N'36063', N'14092', 43.154757, -79.030561, 2435, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3785, N'Albany Medical Center / South Clinical Campus', 1, NULL, NULL, N'330189', NULL, NULL, 0, 20, NULL, N'5182421461', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Hackett Boulevard', N'Albany', N'NY', N'36001', N'12208', 42.65099, -73.799965, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3786, N'Glens Falls Hospital', 1, NULL, NULL, N'330191', NULL, NULL, 0, 442, NULL, N'5189261000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Park Street', N'Glens Falls', N'NY', N'36113', N'12801', 43.307254, -73.646274, 2418, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3787, N'Flushing Hospital Medical Center', 1, NULL, NULL, N'330193', NULL, NULL, 0, 293, NULL, N'7186705000', N'7186703077', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45Th Avenue And Parsons Boulevard', N'Flushing', N'NY', N'36081', N'11355', 40.751774, -73.821637, 2414, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3788, N'Maimonides Medical Center', 1, NULL, NULL, N'330194', NULL, NULL, 0, 711, NULL, N'7182836000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4802 Tenth Avenue', N'Brooklyn', N'NY', N'36047', N'11219', 40.63908, -73.998667, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3789, N'Long Island Jewish Medical Center', 1, NULL, NULL, N'330195', NULL, NULL, 0, 1025, NULL, N'7184707000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'270 - 05 76Th Avenue', N'New Hyde Park', N'NY', N'36081', N'11040', 40.735102, -73.687908, 2447, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3790, N'Coney Island Hospital', 1, NULL, NULL, N'330196', NULL, NULL, 0, 371, NULL, N'7186163000', N'7186164439', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Ocean Parkway', N'Brooklyn', N'NY', N'36047', N'11235', 40.586701, -73.965856, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3791, N'Canton-Potsdam Hospital', 1, NULL, NULL, N'330197', NULL, NULL, 0, 94, NULL, N'3152653300', N'2152650562', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Leroy Street', N'Potsdam', N'NY', N'36089', N'13676', 44.676085, -74.981451, 2475, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3792, N'South Nassau Communities Hospital', 1, NULL, NULL, N'330198', NULL, NULL, 0, 435, NULL, N'5166323000', N'5166323499', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Healthy Way', N'Oceanside', N'NY', N'36059', N'11572', 40.638714, -73.64013, 2461, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3793, N'Metropolitan Hospital Center', 1, NULL, NULL, N'330199', NULL, NULL, 0, 363, NULL, N'2124237554', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 First Avenue', N'New York', N'NY', N'36061', N'10029', 40.784696, -73.943653, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3794, N'Kingsbrook Jewish Medical Center', 1, NULL, NULL, N'330201', NULL, NULL, 0, 303, NULL, N'7186045789', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'585 Schenectady Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.658893, -73.934069, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3795, N'Kings County Hospital Center', 1, NULL, NULL, N'330202', NULL, NULL, 0, 639, NULL, N'7182453901', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 Clarkson Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.655679, -73.94574, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3796, N'Crouse Hospital', 1, NULL, NULL, N'330203', NULL, NULL, 0, 466, NULL, N'3154707449', N'3154702651', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Irving Avenue', N'Syracuse', N'NY', N'36067', N'13210', 43.041081, -76.137861, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3797, N'Bellevue Hospital Center', 1, NULL, NULL, N'330204', NULL, NULL, 0, 912, NULL, N'2125614132', N'2125624036', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 First Avenue', N'New York', N'NY', N'36061', N'10016', 40.739696, -73.976526, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3798, N'St Anthony Community Hospital', 1, NULL, NULL, N'330205', NULL, NULL, 0, 60, NULL, N'8459862276', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15 - 19  Maple Avenue', N'Warwick', N'NY', N'36071', N'10990', 41.267751, -74.354811, 2503, 183, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3799, N'St John''s Riverside Hospital', 1, NULL, NULL, N'330208', NULL, NULL, 0, 385, NULL, N'9149644444', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'976 North Broadway', N'Yonkers', N'NY', N'36119', N'10701', 40.967894, -73.885078, 2509, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3800, N'Claxton-Hepburn Medical Center', 1, NULL, NULL, N'330211', NULL, NULL, 0, 130, NULL, N'3153933600', N'3153938506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 King Street', N'Ogdensburg', N'NY', N'36089', N'13669', 44.692091, -75.499934, 2462, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3801, N'Nyu Hospitals Center', 1, NULL, NULL, N'330214', NULL, NULL, 0, 1069, NULL, N'2122637300', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 First Avenue', N'New York', N'NY', N'36061', N'10016', 40.742871, -73.974225, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3802, N'Rome Memorial Hospital Inc', 1, NULL, NULL, N'330215', NULL, NULL, 0, 144, NULL, N'3153387000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 North James Street', N'Rome', N'NY', N'36065', N'13440', 43.229898, -75.443578, 2481, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3803, N'Oswe Hospital', 1, NULL, NULL, N'330218', NULL, NULL, 0, 132, NULL, N'3153495511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 West Sixth Street', N'Oswe', N'NY', N'36075', N'13126', 43.454214, -76.516042, 2466, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3804, N'Erie County Medical Center', 1, NULL, NULL, N'330219', NULL, NULL, 0, 526, NULL, N'7168983936', N'7168983890', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'462 Grider Street', N'Buffalo', N'NY', N'36029', N'14215', 42.925935, -78.829145, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3805, N'Wyckoff Heights Medical Center', 1, NULL, NULL, N'330221', NULL, NULL, 0, 324, NULL, N'7189637272', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'374 Stockholm Street', N'Brooklyn', N'NY', N'36047', N'11237', 40.704566, -73.917784, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3806, N'Saratoga Hospital', 1, NULL, NULL, N'330222', NULL, NULL, 0, 171, NULL, N'5185873222', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Church Street', N'Saratoga Springs', N'NY', N'36091', N'12866', 43.084791, -73.796267, 2483, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3807, N'Massena Memorial Hospital', 1, NULL, NULL, N'330223', NULL, NULL, 0, 50, NULL, N'3157641711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive', N'Massena', N'NY', N'36089', N'13662', 44.93712, -74.908572, 2444, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3808, N'Healthalliance Hospital Marys Avenue Campus', 1, NULL, NULL, N'330224', NULL, NULL, 0, 222, NULL, N'8453382500', N'8453343149', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Mary''s Avenue', N'Kingston', N'NY', N'36111', N'12401', 41.922224, -73.999084, 2433, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3809, N'Unity Hospital Of Rochester', 1, NULL, NULL, N'330226', NULL, NULL, 0, 311, NULL, N'5857237000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1555 Long Pond Road', N'Rochester', N'NY', N'36055', N'14626', 43.191527, -77.701464, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3810, N'Brooks Memorial Hospital', 1, NULL, NULL, N'330229', NULL, NULL, 0, 65, NULL, N'7163661111', N'7163666919', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'529 Central Avenue', N'Dunkirk', N'NY', N'36013', N'14048', 42.480398, -79.333697, 2408, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3811, N'Queens Hospital Center', 1, NULL, NULL, N'330231', NULL, NULL, 0, 581, NULL, N'7188833000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'82-68 164Th Street', N'Jamaica', N'NY', N'36081', N'11432', 40.717209, -73.803502, 2430, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3812, N'St Mary''s Hospital ( Troy )', 1, NULL, NULL, N'330232', NULL, NULL, 0, 201, NULL, N'5182725000', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Massachusetts Avenue', N'Troy', N'NY', N'36083', N'12180', 42.74315, -73.675647, 2498, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3813, N'Brookdale Hospital Medical Center', 1, NULL, NULL, N'330233', NULL, NULL, 0, 530, NULL, N'7182405966', N'7182406487', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Brookdale Plaza', N'Brooklyn', N'NY', N'36047', N'11212', 40.6545, -73.91275, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3814, N'Westchester Medical Center', 1, NULL, NULL, N'330234', NULL, NULL, 0, 643, NULL, N'9142857017', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Woods Rd', N'Valhalla', N'NY', N'36119', N'10595', 41.08768, -73.803897, 2508, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3815, N'Auburn Community Hospital', 1, NULL, NULL, N'330235', NULL, NULL, 0, 99, NULL, N'3152557011', N'3152557382', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 Lansing Street', N'Auburn', N'NY', N'36011', N'13021', 42.940761, -76.564614, 2382, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3816, N'New York Methodist Hospital', 1, NULL, NULL, N'330236', NULL, NULL, 0, 591, NULL, N'7187803000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 Sixth Street', N'Brooklyn', N'NY', N'36047', N'11215', 40.667862, -73.97831, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3817, N'Nicholas H Noyes Memorial Hospital', 1, NULL, NULL, N'330238', NULL, NULL, 0, 72, NULL, N'5853356001', N'5853355881', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111  Clara Barton Street', N'Dansville', N'NY', N'36051', N'14437', 42.551882, -77.700243, 2406, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3818, N'Woman''s Christian Association', 1, NULL, NULL, N'330239', NULL, NULL, 0, 88, NULL, N'7164870141', N'7166648336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Foote Avenue', N'Jamestown', N'NY', N'36013', N'14701', 42.09128, -79.232959, 2431, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3819, N'Harlem Hospital Center', 1, NULL, NULL, N'330240', NULL, NULL, 0, 268, NULL, N'2124918400', N'2129398300', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 Lenox Avenue', N'New York', N'NY', N'36061', N'10037', 40.814367, -73.940579, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3820, N'University Hospital S U N Y Health Science Center', 1, NULL, NULL, N'330241', NULL, NULL, 0, 378, NULL, N'3154734240', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 East Adams Street', N'Syracuse', N'NY', N'36067', N'13210', 43.042677, -76.138852, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3821, N'St Elizabeth Medical Center', 1, NULL, NULL, N'330245', NULL, NULL, 0, 217, NULL, N'3157988100', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2209 Genesee Street', N'Utica', N'NY', N'36065', N'13501', 43.083646, -75.267158, 2499, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3822, N'St Charles Hospital', 1, NULL, NULL, N'330246', NULL, NULL, 0, 231, NULL, N'6314746000', N'6314746884', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Belle Terre Road', N'Port Jefferson', N'NY', N'36103', N'11777', 40.947623, -73.060088, 2473, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3823, N'Champlain Valley Physicians Hospital Medical Ctr', 1, NULL, NULL, N'330250', NULL, NULL, 0, 300, NULL, N'5185612000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Beekman Street', N'Plattsburgh', N'NY', N'36019', N'12901', 44.700122, -73.466647, 2471, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3824, N'Mercy Medical Center', 1, NULL, NULL, N'330259', NULL, NULL, 0, 375, NULL, N'5167052525', N'5167051406', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Village Avenue', N'Rockville Centre', N'NY', N'36059', N'11570', 40.688191, -73.633236, 2480, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3825, N'Phelps Memorial Hospital Assn', 1, NULL, NULL, N'330261', NULL, NULL, 0, 235, NULL, N'9143663000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 North Broadway', N'Sleepy Hollow', N'NY', N'36119', N'10591', 41.107555, -73.859639, 2457, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3826, N'St Luke''s Cornwall Hospital', 1, NULL, NULL, N'330264', NULL, NULL, 0, 244, NULL, N'8455614400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'70 Dubois Street', N'Newburgh', N'NY', N'36071', N'12550', 41.50286, -74.015205, 2454, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3827, N'Clifton Springs Hospital And Clinic', 1, NULL, NULL, N'330265', NULL, NULL, 0, 154, NULL, N'3154629561', N'3154623492', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Coulter Road', N'Clifton Springs', N'NY', N'36069', N'14432', 42.960462, -77.13974, 2398, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3828, N'New York-Presbyterian/Hudson Valley Hospital', 1, NULL, NULL, N'330267', NULL, NULL, 0, 128, NULL, N'9147343611', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1980 Crompond Road', N'Cortlandt Manor', N'NY', N'36119', N'10567', 41.29146, -73.893442, 2468, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3829, N'Cobleskill Regional Hospital', 1, NULL, NULL, N'330268', NULL, NULL, 0, 40, NULL, N'5182543270', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'178 Grandview Drive', N'Cobleskill', N'NY', N'36095', N'12043', 42.686673, -74.48327, 2399, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3830, N'Hospital For Special Surgery', 1, NULL, NULL, N'330270', NULL, NULL, 0, 205, NULL, N'2126061000', N'2126061930', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 East 70Th Street', N'New York', N'NY', N'36061', N'10021', 40.765311, -73.954164, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3831, N'Putnam Hospital Center', 1, NULL, NULL, N'330273', NULL, NULL, 0, 164, NULL, N'9142795711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'670 Stoneleigh Avenue', N'Carmel', N'NY', N'36079', N'10512', 41.384389, -73.66458, 2395, 50, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3832, N'Nathan Littauer Hospital', 1, NULL, NULL, N'330276', NULL, NULL, 0, 74, NULL, N'5187258621', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'99 East State Street', N'Gloversville', N'NY', N'36035', N'12078', 43.068029, -74.330817, 2419, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3833, N'Corning Hospital', 1, NULL, NULL, N'330277', NULL, NULL, 0, 65, NULL, N'6079377200', N'6079377693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Guthrie Drive', N'Corning', N'NY', N'36101', N'14830', 42.136107, -76.969841, 2402, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3834, N'Mercy Hospital', 1, NULL, NULL, N'330279', NULL, NULL, 0, 387, NULL, N'7168267000', N'7168282700', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'565 Abbott Road', N'Buffalo', N'NY', N'36029', N'14220', 42.848556, -78.812795, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3835, N'Strong Memorial Hospital', 1, NULL, NULL, N'330285', NULL, NULL, 0, 739, NULL, N'5852752121', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Elmwood Ave', N'Rochester', N'NY', N'36055', N'14642', 43.124394, -77.623692, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3836, N'od Samaritan Hospital Medical Center', 1, NULL, NULL, N'330286', NULL, NULL, 0, 437, NULL, N'6313763000', N'6313764208', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Montauk Highway', N'West Islip', N'NY', N'36103', N'11795', 40.695833, -73.294848, 2506, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3837, N'Svcmc-St Vincent''s Ctrs  Ny & West Branches', 1, NULL, NULL, N'330290', NULL, NULL, 0, 860, NULL, N'2126047000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 West 12Th Street', N'New York', N'NY', N'36061', N'10011', 40.736938, -74.000212, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3838, N'White Plains Hospital Center', 1, NULL, NULL, N'330304', NULL, NULL, 0, 240, NULL, N'9146810600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'41 East Post R0ad', N'White Plains', N'NY', N'36119', N'10601', 41.033986, -73.76291, 2508, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3839, N'Lutheran Medical Center', 1, NULL, NULL, N'330306', NULL, NULL, 0, 468, NULL, N'7186308000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 55Th Street', N'Brooklyn', N'NY', N'36047', N'11220', 40.646595, -74.020331, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3840, N'Cayuga Medical Center At Ithaca', 1, NULL, NULL, N'330307', NULL, NULL, 0, 212, NULL, N'6072744401', N'6072744527', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Dates Drive', N'Ithaca', N'NY', N'36109', N'14850', 42.469788, -76.536964, 2429, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3841, N'Plainview Hospital', 1, NULL, NULL, N'330331', NULL, NULL, 0, 204, NULL, N'5167193000', N'5167192719', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 Old Country Road', N'Plainview', N'NY', N'36059', N'11803', 40.774181, -73.479424, 2470, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3842, N'St Joseph Hospital', 1, NULL, NULL, N'330332', NULL, NULL, 0, 203, NULL, N'5165796000', N'5165790739', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4295 Hempstead Turnpike', N'Bethpage', N'NY', N'36059', N'11714', 40.725797, -73.478716, 2386, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3843, N'Southampton Hospital', 1, NULL, NULL, N'330340', NULL, NULL, 0, 125, NULL, N'5167268200', N'6317268886', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Meeting House Lane', N'Southampton', N'NY', N'36103', N'11968', 40.885931, -72.380281, 2489, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3844, N'University Hospital Of Brooklyn ( Downstate )', 1, NULL, NULL, N'330350', NULL, NULL, 0, 376, NULL, N'7182701000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'445 Lenox Road', N'Brooklyn', N'NY', N'36047', N'11203', 40.654459, -73.945132, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3845, N'Forest Hills Hospital', 1, NULL, NULL, N'330353', NULL, NULL, 0, 302, NULL, N'7188304000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 - 01 66Th Road', N'Forest Hills', N'NY', N'36081', N'11375', 40.72861, -73.8513, 2414, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3846, N'Roswell Park Cancer Institute', 1, NULL, NULL, N'330354', NULL, NULL, 0, 133, NULL, N'7168452300', N'7168458261', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Elm And Carlton Streets', N'Buffalo', N'NY', N'36029', N'14203', 42.89718, -78.853322, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3847, N'Franklin Hospital', 1, NULL, NULL, N'330372', NULL, NULL, 0, 305, NULL, N'5162566000', N'5162566503', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Franklin Avenue', N'Valley Stream', N'NY', N'36059', N'11580', 40.680698, -73.685386, 2500, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3848, N'North Central Bronx Hospital', 1, NULL, NULL, N'330385', NULL, NULL, 0, 215, NULL, N'2125195000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3424 Kossuth Avenue & 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.880211, -73.881594, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3849, N'Catskill Regional Medical Center', 1, NULL, NULL, N'330386', NULL, NULL, 0, 164, NULL, N'8457943300', N'8457943240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Harris Bushville Road', N'Harris', N'NY', N'36105', N'12742', 41.714256, -74.726273, 2425, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3850, N'Rockefeller University Hospital', 1, NULL, NULL, N'330387', NULL, NULL, 0, 40, NULL, N'2125708000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 York Avenue', N'New York', N'NY', N'36061', N'10021', 40.759284, -73.959263, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3851, N'North General Hospital', 1, NULL, NULL, N'330390', NULL, NULL, 0, 200, NULL, N'2126504000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1879 Madison Avenue', N'New York', N'NY', N'36061', N'10035', 40.803402, -73.942074, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3852, N'University Hospital ( Stony Brook )', 1, NULL, NULL, N'330393', NULL, NULL, 0, 540, NULL, N'6314444000', N'6314442509', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Health Sciences Center Suny', N'Stony Brook', N'NY', N'36103', N'11794', 40.925654, -73.140943, 2493, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3853, N'United Health Services Hospitals Inc', 1, NULL, NULL, N'330394', NULL, NULL, 0, 500, NULL, N'6077636000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33-57 Harrison Street', N'Johnson City', N'NY', N'36007', N'13790', 42.1142994, -75.9606225, 2387, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3854, N'St John''s Episcopal Hospital At South Shore', 1, NULL, NULL, N'330395', NULL, NULL, 0, 257, NULL, N'7188697000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'327 Beach 19Th Street', N'Far Rockaway', N'NY', N'36081', N'11691', 40.598549, -73.752728, 2413, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3855, N'Woodhull Medical And Mental Health Center', 1, NULL, NULL, N'330396', NULL, NULL, 0, 411, NULL, N'7189638100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'760 Broadway', N'Brooklyn', N'NY', N'36047', N'11206', 40.700582, -73.94168, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3856, N'Interfaith Medical Center', 1, NULL, NULL, N'330397', NULL, NULL, 0, 287, NULL, N'7186134000', N'7189357588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1545 Atlantic Avenue', N'Brooklyn', N'NY', N'36047', N'11213', 40.677866, -73.937154, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3857, N'St Barnabas Hospital', 1, NULL, NULL, N'330399', NULL, NULL, 0, 446, NULL, N'2129609000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4422 Third Avenue', N'Bronx', N'NY', N'36005', N'10457', 40.854123, -73.890909, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3858, N'St Catherine Of Siena Hospital', 1, NULL, NULL, N'330401', NULL, NULL, 0, 318, NULL, N'6318623000', N'6318623105', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Route 25A', N'Smithtown', N'NY', N'36103', N'11787', 40.858303, -73.18609, 2487, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3859, N'Monroe Community Hospital', 1, NULL, NULL, N'330403', NULL, NULL, 0, 5, NULL, N'5857606500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 East Henrietta Road', N'Rochester', N'NY', N'36055', N'14620', 43.111856, -77.616078, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3860, N'Winifred Masterson Burke Rehabilitation Hospital', 1, NULL, NULL, N'330404', NULL, NULL, 0, 150, NULL, N'9145972232', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'785 Mamaroneck Avenue', N'White Plains', N'NY', N'36119', N'10605', 41.015002, -73.755707, 2508, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3861, N'Helen Hayes Hospital', 1, NULL, NULL, N'330405', NULL, NULL, 0, 130, NULL, N'8457864000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 North Route 9W', N'West Haverstraw', N'NY', N'36087', N'10993', 41.214694, -73.98606, 2460, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3862, N'Sunnyview Hospital And Rehabilitation Center', 1, NULL, NULL, N'330406', NULL, NULL, 0, 115, NULL, N'5183863580', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1270 Belmont Avenue', N'Schenectady', N'NY', N'36093', N'12308', 42.822134, -73.91367, 2484, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3863, N'Tri-Town Regional Healthcare', 1, NULL, NULL, N'330408', NULL, NULL, 0, 4, NULL, N'6075612021', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'43 West Pearl Street', N'Sidney', N'NY', N'36025', N'13838', 42.305207, -75.391637, 2486, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3864, N'Burdett Care Center', 1, NULL, NULL, N'330409', NULL, NULL, 0, 15, NULL, N'5182713655', N'5182713203', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2215 Burdett Ave', N'Troy', N'NY', N'36083', N'12180', 42.734018, -73.671251, 2498, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3865, N'Cuba Memorial Hospital Inc', 1, NULL, NULL, N'331301', NULL, NULL, 0, 20, NULL, N'5859612000', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 West Main Street', N'Cuba', N'NY', N'36003', N'14727', 42.213341, -78.28814, 2405, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3866, N'Elizabethtown Community Hospital', 1, NULL, NULL, N'331302', NULL, NULL, 0, 15, NULL, N'5188736377', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 Park Street', N'Elizabethtown', N'NY', N'36031', N'12932', 44.21573, -73.596856, 2410, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3867, N'Catskill Regional Medical Center - G Hermann Site', 1, NULL, NULL, N'331303', NULL, NULL, 0, 15, NULL, N'8458875530', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8081 Route 97', N'Callicoon', N'NY', N'36105', N'12723', 41.767311, -75.056278, 2510, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3868, N'Margaretville Memorial Hospital', 1, NULL, NULL, N'331304', NULL, NULL, 0, 22, NULL, N'8455865631', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42084 State Highway 28', N'Margaretville', N'NY', N'36025', N'12455', 42.147751, -74.643139, 2443, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3869, N'O''connor Hospital', 1, NULL, NULL, N'331305', NULL, NULL, 0, 25, NULL, N'6077460300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'460 Andes Road', N'Delhi', N'NY', N'36025', N'13753', 42.269285, -74.915484, 2401, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3870, N'Moses-Ludington Hospital', 1, NULL, NULL, N'331306', NULL, NULL, 0, 25, NULL, N'5185852831', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1019 Wicker Street', N'Ticonderoga', N'NY', N'36031', N'12883', 43.84953, -73.435545, 2497, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3871, N'Clifton Fine Hospital', 1, NULL, NULL, N'331307', NULL, NULL, 0, 20, NULL, N'3158483351', N'3158482314', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1014 Oswegatchie Trail', N'Star Lake', N'NY', N'36089', N'13690', 44.162697, -75.055678, 2491, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3872, N'River Hospital Inc', 1, NULL, NULL, N'331309', NULL, NULL, 0, 24, NULL, N'3154822511', N'3154827153', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4 Fuller Street', N'Alexandria Bay', N'NY', N'36045', N'13607', 44.33715, -75.92017, 2379, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3873, N'Ellenville Regional Hospital', 1, NULL, NULL, N'331310', NULL, NULL, 0, 25, NULL, N'8456476400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Healthy Way', N'Ellenville', N'NY', N'36111', N'12428', 41.733206, -74.379592, 2411, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3874, N'Little Falls Hospital', 1, NULL, NULL, N'331311', NULL, NULL, 0, 25, NULL, N'3158235261', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Burwell Street', N'Little Falls', N'NY', N'36043', N'13365', 43.043895, -74.847371, 2436, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3875, N'Delaware Valley Hospital Inc', 1, NULL, NULL, N'331312', NULL, NULL, 0, 25, NULL, N'6078652100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Titus Place', N'Walton', N'NY', N'36025', N'13856', 42.164675, -75.128478, 2501, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3876, N'Schuyler Hospital Inc', 1, NULL, NULL, N'331313', NULL, NULL, 0, 25, NULL, N'6075307121', N'6075359097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Steuben Street', N'Montour Falls', N'NY', N'36097', N'14865', 42.351493, -76.858562, 2448, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3877, N'Soldiers And Sailors Memorial Hospital Of Yates', 1, NULL, NULL, N'331314', NULL, NULL, 0, 35, NULL, N'3157874175', N'3155312029', 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'418 North Main Street', N'Penn Yan', N'NY', N'36123', N'14527', 42.671543, -77.060259, 2469, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3878, N'uverneur Hospital', 1, NULL, NULL, N'331315', NULL, NULL, 0, 25, NULL, N'3152871000', N'3152874841', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'77 West Barney Street', N'uverneur', N'NY', N'36089', N'13642', 44.338128, -75.474961, 2421, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3879, N'Community Memorial Hospital Inc', 1, NULL, NULL, N'331316', NULL, NULL, 0, 25, NULL, N'3158241100', N'3158423182', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Broad Street', N'Hamilton', N'NY', N'36053', N'13346', 42.813725, -75.541947, 2424, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3880, N'Lewis County General Hospital', 1, NULL, NULL, N'331317', NULL, NULL, 0, 25, NULL, N'3153765200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7785 North State Street', N'Lowville', N'NY', N'36049', N'13367', 43.795699, -75.498082, 2440, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3881, N'Carthage Area Hospital Inc', 1, NULL, NULL, N'331318', NULL, NULL, 0, 25, NULL, N'3154931000', N'3154934231', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 West Street', N'Carthage', N'NY', N'36045', N'13619', 43.986406, -75.593824, 2396, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3882, N'Medina Memorial Hospital', 1, NULL, NULL, N'331319', NULL, NULL, 0, 34, NULL, N'5857988111', N'5857988107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Ohio Street', N'Medina', N'NY', N'36073', N'14103', 43.223582, -78.397182, 2445, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3883, N'High Ridge House', 1, NULL, NULL, N'331990', NULL, NULL, 0, 20, NULL, N'7187964200', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5959 Independence Avenue', N'Bronx', N'NY', N'36005', N'10471', 40.90976, -73.906895, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3884, N'Calvary Hospital Inc', 1, NULL, NULL, N'332006', NULL, NULL, 0, 225, NULL, N'7188636900', N'7185182674', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 - 70 Eastchester R0ad', N'Bronx', N'NY', N'36005', N'10461', 40.8501, -73.866246, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3885, N'Coler-ldwater  Specialty Hospital', 1, NULL, NULL, N'332008', NULL, NULL, 0, 411, NULL, N'2123188000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1752 Park Avenue', N'New York', N'NY', N'36061', N'10035', 40.802967, -73.940688, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3886, N'Summit Park Hospital - Rockland County Infirmary', 1, NULL, NULL, N'332014', NULL, NULL, 0, 108, NULL, N'9143642700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Sanatorium Road', N'Pomona', N'NY', N'36087', N'10970', 41.160362, -74.03967, 2494, 183, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3887, N'Terence Cardinal Cooke Health Care Center', 1, NULL, NULL, N'332022', NULL, NULL, 0, 50, NULL, N'2123603600', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1249 Fifth Avenue', N'New York', N'NY', N'36061', N'10029', 42.798499, -73.950136, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3888, N'Blythedale Children''s Hospital', 1, NULL, NULL, N'333301', NULL, NULL, 0, 92, NULL, N'9145927555', N'9145920407', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Bradhurst Avenue', N'Valhalla', N'NY', N'36119', N'10595', 41.074819, -73.775133, 2508, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3889, N'Hutchings Psychiatric Ctr', 1, NULL, NULL, N'334001', NULL, NULL, 0, 128, NULL, N'3154734980', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'620 Madison Street', N'Syracuse', N'NY', N'36067', N'13210', 43.045303, -76.139977, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3890, N'Four Winds', 1, NULL, NULL, N'334002', NULL, NULL, 0, 175, NULL, N'9147638151', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Cross River Rd', N'Katonah', N'NY', N'36119', N'10536', 41.267025, -73.645231, 2449, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3891, N'St Lawrence Psych Center', 1, NULL, NULL, N'334003', NULL, NULL, 0, 108, NULL, N'3155412071', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Chimney Point Drive', N'Ogdensburg', N'NY', N'36089', N'13669', 44.694229, -75.486336, 2462, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3892, N'Creedmoor Psychiatric Center', 1, NULL, NULL, N'334004', NULL, NULL, 0, 476, NULL, N'7182644000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'80-45 Winchester Blvd Bldg B', N'Queens Village', N'NY', N'36081', N'11427', 40.726769, -73.741521, 2414, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3893, N'New York State Psychiatric Institute', 1, NULL, NULL, N'334009', NULL, NULL, 0, 22, NULL, N'2125435000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'722 W 168Th St', N'New York', N'NY', N'36061', N'10032', 40.842445, -73.943349, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3894, N'Greater Binghamton Health Center', 1, NULL, NULL, N'334012', NULL, NULL, 0, 154, NULL, N'6077241391', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Robinson St', N'Binghamton', N'NY', N'36007', N'13901', 42.108026, -75.866485, 2387, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3895, N'Pilgrim Psychiatric Center', 1, NULL, NULL, N'334013', NULL, NULL, 0, 560, NULL, N'6317613500', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'998 Crooked Hill Road', N'West Brentwood', N'NY', N'36103', N'11717', 43.156168, -75.844995, 2385, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3896, N'Rockland Psych Ctr', 1, NULL, NULL, N'334015', NULL, NULL, 0, 503, NULL, N'8453591000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Old Orangeburg Rd', N'Orangeburg', N'NY', N'36087', N'10962', 41.046578, -73.949671, 2460, 178, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3897, N'Rochester Psychiatric Center', 1, NULL, NULL, N'334020', NULL, NULL, 0, 247, NULL, N'5852411200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 South Ave', N'Rochester', N'NY', N'36055', N'14620', 43.124063, -77.614501, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3898, N'Mohawk Valley Psychiatric Center', 1, NULL, NULL, N'334021', NULL, NULL, 0, 189, NULL, N'3157976800', NULL, 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Noyes St', N'Utica', N'NY', N'36065', N'13502', 43.100856, -75.257331, 2499, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3899, N'Brylin Hosp', 1, NULL, NULL, N'334022', NULL, NULL, 0, 88, NULL, N'7168868200', N'7168861986', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1263 Delaware Ave', N'Buffalo', N'NY', N'36029', N'14209', 42.934544, -78.865794, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3900, N'Brunswick Psych Center', 1, NULL, NULL, N'334026', NULL, NULL, 0, 124, NULL, N'5167897000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'366 Broadway', N'Amityville', N'NY', N'36103', N'11701', 40.672268, -73.414899, 2380, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3901, N'South Oaks Hosp', 1, NULL, NULL, N'334027', NULL, NULL, 0, 245, NULL, N'5162644000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Sunrise Highway', N'Amityville', N'NY', N'36103', N'11701', 40.686325, -73.425655, 2380, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3902, N'South Beach Psychiatric Center', 1, NULL, NULL, N'334043', NULL, NULL, 0, 290, NULL, N'7186672300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Seaview Ave', N'Staten Island', N'NY', N'36085', N'10305', 40.583479, -74.082782, 2492, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3903, N'Elmira Psych Center', 1, NULL, NULL, N'334045', NULL, NULL, 0, 95, NULL, N'6077374739', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Washington St', N'Elmira', N'NY', N'36015', N'14901', 42.092391, -76.795991, 2412, 189, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3904, N'Capital District Psych Center', 1, NULL, NULL, N'334046', NULL, NULL, 0, 165, NULL, N'8453985566', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'75 New Scotland Ave', N'Albany', N'NY', N'36001', N'12208', 42.652816, -73.780903, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3905, N'Gracie Square Hosp', 1, NULL, NULL, N'334048', NULL, NULL, 0, 157, NULL, N'2124345322', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 East 76 St', N'New York', N'NY', N'36061', N'10021', 43.102443, -75.291082, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3906, N'Four Winds', 1, NULL, NULL, N'334049', NULL, NULL, 0, 83, NULL, N'5185843600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'30 Crescent Ave', N'Saratoga Springs', N'NY', N'36091', N'12866', 43.051973, -73.732357, 2483, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3907, N'Buffalo Psychiatric Center', 1, NULL, NULL, N'334052', NULL, NULL, 0, 260, NULL, N'7168852261', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Forest Ave', N'Buffalo', N'NY', N'36029', N'14213', 42.929258, -78.880201, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3908, N'Bronx Psychiatric Center', 1, NULL, NULL, N'334053', NULL, NULL, 0, 412, NULL, N'7189310600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Waters Place', N'Bronx', N'NY', N'36005', N'10461', 40.845217, -73.839832, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3909, N'Manhattan Psychiatric Center', 1, NULL, NULL, N'334054', NULL, NULL, 0, 509, NULL, N'2123690500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ward''s Island', N'New York', N'NY', N'36061', N'10035', 40.632918, -74.082918, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3910, N'Holliswood Hospitalthe', 1, NULL, NULL, N'334055', NULL, NULL, 0, 133, NULL, N'7187768181', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'87-37 Palermo Street', N'Hollis', N'NY', N'36081', N'11423', 40.71512, -73.773571, 2430, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3911, N'Stoney Lodge Hospital', 1, NULL, NULL, N'334059', NULL, NULL, 0, 66, NULL, N'9149417400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Croton Dam Road', N'Ossining', N'NY', N'36119', N'10562', 41.177553, -73.847999, 2457, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3912, N'Kirby Forensic Psychiatric Center', 1, NULL, NULL, N'334060', NULL, NULL, 0, 164, NULL, N'2124279003', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Ward Island', N'New York', N'NY', N'36061', N'10035', 40.632918, -74.082918, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3913, N'Mid Hudson Forensic Psychiatric Ctr', 1, NULL, NULL, N'334061', NULL, NULL, 0, 280, NULL, N'8453743171', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 158 Route 17M', N'New Hampton', N'NY', N'36071', N'10958', 41.410927, -74.4071, 2446, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3914, N'Kingsboro Psychiatric Hospital', 1, NULL, NULL, N'334063', NULL, NULL, 0, 173, NULL, N'7182217395', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'681 Clarkson Avenue', N'Brooklyn', N'NY', N'36047', N'11203', 40.656499, -73.936501, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3915, N'University Hospital S U N Y Health Science Ctr T C', 1, NULL, NULL, N'339800', NULL, NULL, 0, 0, NULL, N'3154734240', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'750 East Adams Street', N'Syracuse', N'NY', N'36067', N'13210', 43.042563, -76.140152, 2496, 193, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3916, N'North Shore University Hospital - Manhasset T C', 1, NULL, NULL, N'339801', NULL, NULL, 0, 0, NULL, N'5164652667', N'5164658381', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Community Drive', N'Manhasset', N'NY', N'36059', N'11030', 40.797879, -73.699575, 2442, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3917, N'University Hospital Of Brooklyn ( Downstate) T C', 1, NULL, NULL, N'339802', NULL, NULL, 0, 0, NULL, N'7182701000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'445 Lenox Road', N'Brooklyn', N'NY', N'36047', N'11203', 40.65473, -73.944186, 2391, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3918, N'New York-Presbyterian Hospital At Columbia T C', 1, NULL, NULL, N'339803', NULL, NULL, 0, 0, NULL, N'2123052500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'622 West 168Th Street', N'New York', N'NY', N'36061', N'10032', 40.841173, -73.940209, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3919, N'Nyu Hospitals Center T C', 1, NULL, NULL, N'339804', NULL, NULL, 0, 0, NULL, N'2122638360', N'2122638157', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'550 First Avenue', N'New York', N'NY', N'36061', N'10016', 42.802139, -73.952846, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3920, N'St Luke''s Roosevelt Hospital - St Luke''s Div T C', 1, NULL, NULL, N'339805', NULL, NULL, 0, 0, NULL, N'2125235700', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1111 Amsterdam Avenue', N'New York', N'NY', N'36061', N'10025', 43.102443, -75.291082, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3921, N'Westchester Medical Center T C', 1, NULL, NULL, N'339806', NULL, NULL, 0, 0, NULL, N'9142857017', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Woods Rd', N'Valhalla', N'NY', N'36119', N'10595', 41.074819, -73.775133, 2508, 194, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3922, N'Montefiore Medical Center T C', 1, NULL, NULL, N'339807', NULL, NULL, 0, 0, NULL, N'7189205333', N'7185474773', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 East 210Th Street', N'Bronx', N'NY', N'36005', N'10467', 40.879996, -73.880623, 2389, 187, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3923, N'Strong Memorial Hospital T C', 1, NULL, NULL, N'339808', NULL, NULL, 0, 0, NULL, N'5852752121', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 Elmwood Avenue', N'Rochester', N'NY', N'36055', N'14642', 43.124362, -77.625263, 2479, 192, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3924, N'University Hospital ( Stony Brook ) T C', 1, NULL, NULL, N'339809', NULL, NULL, 0, 0, NULL, N'6314442209', N'6314446639', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Nicholls Road Hsc T19040', N'Stony Brook', N'NY', N'36103', N'11794', 40.925654, -73.140943, 2493, 190, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3925, N'New York-Presbyterian Hospital At Cornell T C', 1, NULL, NULL, N'339810', NULL, NULL, 0, 0, NULL, N'2123055551', N'2123422204', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'525 East 68Th Street', N'New York', N'NY', N'36061', N'10021', 40.764347, -73.954508, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3926, N'Albany Medical Center T C', 1, NULL, NULL, N'339811', NULL, NULL, 0, 0, NULL, N'5182623028', N'5182623398', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'43 New Scotland Avenue', N'Albany', N'NY', N'36001', N'12208', 42.653178, -73.776211, 2378, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3927, N'Kaleida Health - Buffalo General Med Ctr T C', 1, NULL, NULL, N'339812', NULL, NULL, 0, 0, NULL, N'7168591345', N'7168591896', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 High Street', N'Buffalo', N'NY', N'36029', N'14203', 42.900407, -78.865273, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3928, N'Mount Sinai Hospital T C', 1, NULL, NULL, N'339813', NULL, NULL, 0, 0, NULL, N'2122417981', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Gustave Levy Place', N'New York', N'NY', N'36061', N'10029', 40.790382, -73.953391, 2452, 191, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3929, N'Erie County Medical Center T C', 1, NULL, NULL, N'339814', NULL, NULL, 0, 0, NULL, N'7168985240', N'7168986195', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'462 Grider Street', N'Buffalo', N'NY', N'36029', N'14215', 42.924527, -78.82916, 2392, 188, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3930, N'Carolinas Medical Center-Northeast', 1, NULL, NULL, N'340001', NULL, NULL, 0, 457, NULL, N'7047833000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Church St N', N'Concord', N'NC', N'37025', N'28025', 35.434363, -80.603114, 2529, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3931, N'Memorial Mission Hospital And Asheville Surgery Ce', 1, NULL, NULL, N'340002', NULL, NULL, 0, 735, NULL, N'8282131111', N'8282131669', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Biltmore Ave', N'Asheville', N'NC', N'37021', N'28801', 35.577942, -82.54837, 2515, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3932, N'Northern Hospital Of Surry County', 1, NULL, NULL, N'340003', NULL, NULL, 0, 112, NULL, N'3367197000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Rockford St', N'Mount Airy', N'NC', N'37171', N'27030', 36.488367, -80.61119, 2568, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3933, N'High Point Regional Hospital', 1, NULL, NULL, N'340004', NULL, NULL, 0, 354, NULL, N'3368786000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 N Elm St', N'High Point', N'NC', N'37081', N'27261', 35.962403, -80.012021, 2549, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3934, N'Scotland Memorial Hospital', 1, NULL, NULL, N'340008', NULL, NULL, 0, 104, NULL, N'9102917000', N'9102917499', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Lauchwood Dr', N'Laurinburg', N'NC', N'37165', N'28352', 34.7517, -79.47042, 2556, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3935, N'Wayne Memorial Hospital', 1, NULL, NULL, N'340010', NULL, NULL, 0, 316, NULL, N'9197361110', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Wayne Memorial Dr', N'ldsboro', N'NC', N'37191', N'27534', 35.400679, -77.953852, 2542, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3936, N'Rutherford Regional Medical Center', 1, NULL, NULL, N'340013', NULL, NULL, 0, 143, NULL, N'8282865000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'288 South Ridgecrest Ave', N'Rutherfordton', N'NC', N'37161', N'28139', 35.36358, -81.965052, 2581, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3937, N'Novant Health Forsyth Medical Center', 1, NULL, NULL, N'340014', NULL, NULL, 0, 912, NULL, N'3367185000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Silas Creek Parkway', N'Winston-Salem', N'NC', N'37067', N'27103', 36.073922, -80.298547, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3938, N'Novant Health Rowan Medical Center', 1, NULL, NULL, N'340015', NULL, NULL, 0, 308, NULL, N'7042105000', N'7042105562', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 Mocksville Ave', N'Salisbury', N'NC', N'37159', N'28144', 35.682169, -80.471441, 2582, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3939, N'Harris Regional Hospital', 1, NULL, NULL, N'340016', NULL, NULL, 0, 86, NULL, N'8285867000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Hospital Rd', N'Sylva', N'NC', N'37099', N'28779', 35.383927, -83.202792, 2592, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3940, N'Margaret R Pardee Memorial Hospital', 1, NULL, NULL, N'340017', NULL, NULL, 0, 222, NULL, N'8286961000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 N Justice St', N'Hendersonville', N'NC', N'37089', N'28791', 35.321605, -82.468089, 2547, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3941, N'Central Carolina Hospital', 1, NULL, NULL, N'340020', NULL, NULL, 0, 137, NULL, N'9197742100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1135 Carthage St', N'Sanford', N'NC', N'37105', N'27330', 35.469624, -79.188745, 2583, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3942, N'Carolinas Healthcare System Cleveland', 1, NULL, NULL, N'340021', NULL, NULL, 0, 241, NULL, N'7044873000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 E Grover St', N'Shelby', N'NC', N'37045', N'28150', 35.301837, -81.535343, 2584, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3943, N'Park Ridge Health', 1, NULL, NULL, N'340023', NULL, NULL, 0, 103, NULL, N'8286848501', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Hendersonville', N'NC', N'37089', N'28792', 35.390724, -82.487077, 2547, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3944, N'Sampson Regional Medical Center', 1, NULL, NULL, N'340024', NULL, NULL, 0, 146, NULL, N'9105928511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'607 Beaman St', N'Clinton', N'NC', N'37163', N'28328', 35.007552, -78.323547, 2526, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3945, N'Lenoir Memorial Hospital', 1, NULL, NULL, N'340027', NULL, NULL, 0, 235, NULL, N'2525227000', N'2525227007', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Airport Rd', N'Kinston', N'NC', N'37107', N'28501', 35.290955, -77.581407, 2555, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3946, N'Cape Fear Valley Medical Center', 1, NULL, NULL, N'340028', NULL, NULL, 0, 600, NULL, N'9106094000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1638 Owen Drive P O Box 2000', N'Fayetteville', N'NC', N'37051', N'28302', 35.032864, -78.931309, 2539, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3947, N'Duke University Hospital', 1, NULL, NULL, N'340030', NULL, NULL, 0, 1019, NULL, N'9196848111', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 3814 Dumc  Erwin Rd', N'Durham', N'NC', N'37063', N'27710', 35.994033, -78.898619, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3948, N'Caromont Regional Medical Center', 1, NULL, NULL, N'340032', NULL, NULL, 0, 442, NULL, N'7048344891', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Court Dr', N'Gastonia', N'NC', N'37071', N'28052', 35.275208, -81.139078, 2541, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3949, N'Carolinas Healthcare System Kings Mountain', 1, NULL, NULL, N'340037', NULL, NULL, 0, 102, NULL, N'7047393601', N'7047390800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 W King St', N'Kings Mountain', N'NC', N'37045', N'28086', 35.240876, -81.355969, 2554, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3950, N'Iredell Memorial Hospital Inc', 1, NULL, NULL, N'340039', NULL, NULL, 0, 247, NULL, N'7048735661', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'557 Brookdale Dr  P O Box 1828', N'Statesville', N'NC', N'37097', N'28677', 35.799781, -80.876815, 2590, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3951, N'Vidant Medical Center', 1, NULL, NULL, N'340040', NULL, NULL, 0, 909, NULL, N'2528474100', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Stantonsburg Rd', N'Greenville', N'NC', N'37147', N'27834', 35.60581, -77.400952, 2544, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3952, N'Caldwell Memorial Hospital', 1, NULL, NULL, N'340041', NULL, NULL, 0, 110, NULL, N'8287575100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Mulberry St Sw', N'Lenoir', N'NC', N'37027', N'28645', 35.910227, -81.535978, 2557, 200, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3953, N'Onslow Memorial Hospital', 1, NULL, NULL, N'340042', NULL, NULL, 0, 150, NULL, N'9105772345', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Western Boulevard', N'Jacksonville', N'NC', N'37133', N'28540', 34.762394, -77.382591, 2551, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3954, N'North Carolina Baptist Hospital', 1, NULL, NULL, N'340047', NULL, NULL, 0, 885, NULL, N'3367162011', N'3367162067', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Medical Center Boulevard', N'Winston-Salem', N'NC', N'37067', N'27157', 36.089827, -80.271364, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3955, N'North Carolina Specialty Hospital', 1, NULL, NULL, N'340049', NULL, NULL, 0, 24, NULL, N'9199569300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3916 Ben Franklin Boulevard', N'Durham', N'NC', N'37063', N'27704', 36.042726, -78.897484, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3956, N'Southeastern Regional Medical Center', 1, NULL, NULL, N'340050', NULL, NULL, 0, 314, NULL, N'9106715000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W 27 St  Po Box 1408', N'Lumberton', N'NC', N'37155', N'28359', 34.63649, -79.012161, 2561, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3957, N'Watauga Medical Center', 1, NULL, NULL, N'340051', NULL, NULL, 0, 117, NULL, N'8282624100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'336 Deerfield Road', N'Boone', N'NC', N'37189', N'28607', 36.199187, -81.652298, 2519, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3958, N'Novant Health Presbyterian Medical Center', 1, NULL, NULL, N'340053', NULL, NULL, 0, 877, NULL, N'7043844000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hawthorne Lane Box 33549', N'Charlotte', N'NC', N'37119', N'28233', 35.2129, -80.825589, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3959, N'Valdese General Hospital Inc', 1, NULL, NULL, N'340055', NULL, NULL, 0, 172, NULL, N'8288742251', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Malcolm Blvd', N'Valdese', N'NC', N'37023', N'28690', 35.740686, -81.563149, 2597, 200, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3960, N'Morehead Memorial Hospital', 1, NULL, NULL, N'340060', NULL, NULL, 0, 108, NULL, N'3366239711', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 E Kings Highway', N'Eden', N'NC', N'37157', N'27288', 36.493611, -79.737889, 2533, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3961, N'University Of North Carolina Hospital', 1, NULL, NULL, N'340061', NULL, NULL, 0, 724, NULL, N'9199664141', N'9199667772', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Manning Drive', N'Chapel Hill', N'NC', N'37135', N'27514', 35.903781, -79.052621, 2524, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3962, N'Wilkes Regional Medical Center', 1, NULL, NULL, N'340064', NULL, NULL, 0, 120, NULL, N'3366518100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1370 West D St', N'North Wilkesboro', N'NC', N'37193', N'28659', 36.158526, -81.156826, 2571, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3963, N'Columbus Regional Healthcare System', 1, NULL, NULL, N'340068', NULL, NULL, 0, 166, NULL, N'9106428011', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Jefferson St', N'Whiteville', N'NC', N'37047', N'28472', 34.338657, -78.693644, 2600, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3964, N'Wakemed Raleigh Campus', 1, NULL, NULL, N'340069', NULL, NULL, 0, 678, NULL, N'9193508000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 New Bern Ave', N'Raleigh', N'NC', N'37183', N'27610', 35.786057, -78.589155, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3965, N'Alamance Regional Medical Center', 1, NULL, NULL, N'340070', NULL, NULL, 0, 238, NULL, N'3365387000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1240 Huffman Mill Rd', N'Burlington', N'NC', N'37001', N'27216', 36.063749, -79.502528, 2523, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3966, N'Betsy Johnson Regional  Hospital', 1, NULL, NULL, N'340071', NULL, NULL, 0, 108, NULL, N'9108927161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Tilghman Dr', N'Dunn', N'NC', N'37085', N'28334', 35.307713, -78.633139, 2531, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3967, N'Duke Health Raleigh Hospital', 1, NULL, NULL, N'340073', NULL, NULL, 0, 218, NULL, N'9199543000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Wake Forest Rd', N'Raleigh', N'NC', N'37183', N'27609', 35.829296, -78.619402, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3968, N'Carolinas Healthcare System-Blue Ridge', 1, NULL, NULL, N'340075', NULL, NULL, 0, 204, NULL, N'8285805000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 S Sterling St', N'Morganton', N'NC', N'37023', N'28655', 35.723354, -81.657615, 2567, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3969, N'Carolinas Health Care System Anson', 1, NULL, NULL, N'340084', NULL, NULL, 0, 15, NULL, N'7046945131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Us Highway 74 West', N'Wadesboro', N'NC', N'37007', N'28170', 34.963397, -80.034057, 2598, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3970, N'Novant Health Thomasville Medical Center', 1, NULL, NULL, N'340085', NULL, NULL, 0, 149, NULL, N'3364722000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 Old Lexington Rd Box 789', N'Thomasville', N'NC', N'37057', N'27360', 35.882029, -80.11138, 2595, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3971, N'The Mcdowell Hospital', 1, NULL, NULL, N'340087', NULL, NULL, 0, 65, NULL, N'8286595000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 Rankin Drive P O Box 730', N'Marion', N'NC', N'37111', N'28752', 35.66409, -82.027691, 2562, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3972, N'Johnston Health', 1, NULL, NULL, N'340090', NULL, NULL, 0, 175, NULL, N'9199348171', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'509 Bright Leaf Blvd', N'Smithfield', N'NC', N'37101', N'27577', 35.503618, -78.343578, 2586, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3973, N'Moses H Cone Memorial Hospital The', 1, NULL, NULL, N'340091', NULL, NULL, 0, 1232, NULL, N'3368327000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N Elm St', N'Greensboro', N'NC', N'37081', N'27401', 36.090652, -79.788812, 2543, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3974, N'Lexington Memorial Hospital Inc', 1, NULL, NULL, N'340096', NULL, NULL, 0, 94, NULL, N'3362485161', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Hospital Drive Po Box 1817', N'Lexington', N'NC', N'37057', N'27293', 35.805354, -80.288573, 2558, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3975, N'Hugh Chatham Memorial Hospital', 1, NULL, NULL, N'340097', NULL, NULL, 0, 81, NULL, N'3365277000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Parkwood Dr', N'Elkin', N'NC', N'37171', N'28621', 36.26159, -80.837403, 2537, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3976, N'Carolinas Healthcare System Pineville', 1, NULL, NULL, N'340098', NULL, NULL, 0, 344, NULL, N'7043795000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10628 Park Rd', N'Charlotte', N'NC', N'37119', N'28210', 35.091285, -80.869569, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3977, N'Vidant Roanoke Chowan Hospital', 1, NULL, NULL, N'340099', NULL, NULL, 0, 124, NULL, N'2522093000', N'2522093049', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 S Academy St', N'Ahoskie', N'NC', N'37091', N'27910', 36.284898, -76.99426, 2511, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3978, N'Sandhills Regional Medical Center', 1, NULL, NULL, N'340106', NULL, NULL, 0, 49, NULL, N'9109582361', N'9102058000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Hamlet Avenue', N'Hamlet', N'NC', N'37153', N'28345', 34.900776, -79.709624, 2545, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3979, N'Vidant Edgecombe Hospital', 1, NULL, NULL, N'340107', NULL, NULL, 0, 83, NULL, N'2526417700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Hospital Dr', N'Tarboro', N'NC', N'37065', N'27886', 35.92162, -77.557159, 2593, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3980, N'Sentara Albemarle Medical Center', 1, NULL, NULL, N'340109', NULL, NULL, 0, 182, NULL, N'2523350531', N'2523844693', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1144 N Road St', N'Elizabeth City', N'NC', N'37139', N'27909', 36.32153, -76.22002, 2535, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3981, N'Carolinas Medical Center/Behav Health', 1, NULL, NULL, N'340113', NULL, NULL, 0, 843, NULL, N'7043552000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Blythe Blvd', N'Charlotte', N'NC', N'37119', N'28203', 35.205246, -80.840815, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3982, N'Rex Hospital', 1, NULL, NULL, N'340114', NULL, NULL, 0, 425, NULL, N'9197843100', N'9197843004', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4420 Lake Boone Trail', N'Raleigh', N'NC', N'37183', N'27607', 35.815458, -78.705032, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3983, N'Firsthealth Moore Regional Hospital', 1, NULL, NULL, N'340115', NULL, NULL, 0, 395, NULL, N'9107151000', N'9102151926', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Memorial Drive', N'Pinehurst', N'NC', N'37125', N'28374', 35.20722, -79.457596, 2573, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3984, N'Frye Regional Medical Center', 1, NULL, NULL, N'340116', NULL, NULL, 0, 338, NULL, N'8283226070', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 N Center St', N'Hickory', N'NC', N'37035', N'28601', 35.737611, -81.337766, 2548, 200, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3985, N'Stanly Regional Medical Center', 1, NULL, NULL, N'340119', NULL, NULL, 0, 109, NULL, N'7049844000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Yadkin St', N'Albemarle', N'NC', N'37167', N'28001', 35.362613, -80.194601, 2512, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3986, N'Vidant Duplin  Hospital', 1, NULL, NULL, N'340120', NULL, NULL, 0, 101, NULL, N'9102960941', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 N Main St', N'Kenansville', N'NC', N'37061', N'28349', 34.968106, -77.959485, 2553, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3987, N'Randolph Hospital', 1, NULL, NULL, N'340123', NULL, NULL, 0, 145, NULL, N'3366255151', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'364 White Oak Street', N'Asheboro', N'NC', N'37151', N'27204', 35.711532, -79.814934, 2514, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3988, N'Wilson Medical Center', 1, NULL, NULL, N'340126', NULL, NULL, 0, 317, NULL, N'2523998040', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1705 S Tarboro St', N'Wilson', N'NC', N'37195', N'27893', 35.720506, -77.944098, 2603, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3989, N'Granville Health Systems', 1, NULL, NULL, N'340127', NULL, NULL, 0, 62, NULL, N'9196903000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'College St Box 947', N'Oxford', N'NC', N'37077', N'27565', 36.3107, -78.590834, 2572, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3990, N'Lake Norman Regional Medical Center', 1, NULL, NULL, N'340129', NULL, NULL, 0, 105, NULL, N'7046604000', N'7046604009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'171 Fairview Road', N'Mooresville', N'NC', N'37097', N'28117', 35.547749, -80.852746, 2565, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3991, N'Carolinas Healthcare System Union', 1, NULL, NULL, N'340130', NULL, NULL, 0, 157, NULL, N'7042833100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Hospital Dr', N'Monroe', N'NC', N'37179', N'28110', 34.975129, -80.522794, 2564, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3992, N'Carolina East Medical Center', 1, NULL, NULL, N'340131', NULL, NULL, 0, 314, NULL, N'2526338640', N'2526365376', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Neuse Blvd', N'New Bern', N'NC', N'37049', N'28560', 35.112384, -77.067119, 2570, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3993, N'Maria Parham Medical Center', 1, NULL, NULL, N'340132', NULL, NULL, 0, 102, NULL, N'2524313708', N'2524313734', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 59', N'Henderson', N'NC', N'37181', N'27536', 36.329591, -78.399164, 2546, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3994, N'Martin General Hospital', 1, NULL, NULL, N'340133', NULL, NULL, 0, 49, NULL, N'2528096179', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 S Mccaskey Rd P O Box 1128', N'Williamston', N'NC', N'37117', N'27892', 35.84088, -77.072726, 2601, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3995, N'Central Regional Hospital', 1, NULL, NULL, N'340138', NULL, NULL, 0, 16, NULL, N'9197335540', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Veazey Road', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3996, N'New Hanover Regional Medical Center', 1, NULL, NULL, N'340141', NULL, NULL, 0, 769, NULL, N'9103437000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2131 S 17Th St Box 9000', N'Wilmington', N'NC', N'37129', N'28402', 34.206164, -77.924176, 2602, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3997, N'Carteret General Hospital', 1, NULL, NULL, N'340142', NULL, NULL, 0, 117, NULL, N'2528086000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Arendell St', N'Morehead City', N'NC', N'37031', N'28557', 34.724692, -76.754148, 2566, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3998, N'Catawba Valley Medical Center', 1, NULL, NULL, N'340143', NULL, NULL, 0, 258, NULL, N'8283263809', N'8283263371', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 Fairgrove Church Rd', N'Hickory', N'NC', N'37035', N'28602', 35.71275, -81.264921, 2548, 200, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (3999, N'Davis Regional Medical Center', 1, NULL, NULL, N'340144', NULL, NULL, 0, 136, NULL, N'7048730281', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'218 Old Mocksbville Rd Po Box 1823', N'Statesville', N'NC', N'37097', N'28687', 35.782636, -80.887296, 2590, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4000, N'Carolinas Healthcare System Lincoln', 1, NULL, NULL, N'340145', NULL, NULL, 0, 110, NULL, N'9802122000', N'9082121001', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 Mcalister Rd', N'Lincolnton', N'NC', N'37109', N'28092', 35.488447, -81.20123, 2559, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4001, N'Nash General Hospital', 1, NULL, NULL, N'340147', NULL, NULL, 0, 332, NULL, N'2524438000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2460 Curtis Ellis Drive', N'Rocky Mount', N'NC', N'37127', N'27804', 35.974388, -77.850091, 2579, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4002, N'Novant Health Medical Park Hospital', 1, NULL, NULL, N'340148', NULL, NULL, 0, 136, NULL, N'3367180600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 S Hawthorne Rd', N'Winston-Salem', N'NC', N'37067', N'27103', 36.078159, -80.295714, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4003, N'Halifax Regional Medical Center Inc', 1, NULL, NULL, N'340151', NULL, NULL, 0, 206, NULL, N'2525358005', N'2525358466', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Smith Church Rd', N'Roanoke Rapids', N'NC', N'37083', N'27870', 36.435306, -77.647071, 2577, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4004, N'Duke Regional Hospital', 1, NULL, NULL, N'340155', NULL, NULL, 0, 391, NULL, N'9196201078', N'9196204921', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3643 N Roxboro Road', N'Durham', N'NC', N'37063', N'27704', 36.037439, -78.897037, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4005, N'Cherokee Indian Hospital Authority', 1, NULL, NULL, N'340156', NULL, NULL, 0, 26, NULL, N'7044979163', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Caller Box C268', N'Cherokee', N'NC', N'37173', N'28719', 35.474266, -83.314874, 2606, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4006, N'Novant Health Brunswick Medical Center', 1, NULL, NULL, N'340158', NULL, NULL, 0, 60, NULL, N'9107558121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Dr  Po Box 139', N'Supply', N'NC', N'37019', N'28462', 34.009092, -78.289923, 2591, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4007, N'Person Memorial Hospital', 1, NULL, NULL, N'340159', NULL, NULL, 0, 50, NULL, N'3365992121', N'3365035765', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Ridge Rd', N'Roxboro', N'NC', N'37145', N'27573', 36.407558, -78.984756, 2580, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4008, N'Carolinas Med Ctr-University', 1, NULL, NULL, N'340166', NULL, NULL, 0, 130, NULL, N'7045486000', N'7045486236', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8800 North Tyron Street', N'Charlotte', N'NC', N'37119', N'28262', 35.307869, -80.748031, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4009, N'Wilmington Treatment Center', 1, NULL, NULL, N'340168', NULL, NULL, 0, 44, NULL, N'9197622727', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Troy Drive', N'Wilmington', N'NC', N'37129', N'28401', 34.194919, -77.928552, 2602, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4010, N'Presbyterian Hospital Matthews', 1, NULL, NULL, N'340171', NULL, NULL, 0, 102, NULL, N'7043846500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Matthews Twnshp Prkwy Box 3310', N'Matthews', N'NC', N'37119', N'28106', 35.116813, -80.72368, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4011, N'Wakemed Cary Hospital', 1, NULL, NULL, N'340173', NULL, NULL, 0, 156, NULL, N'9193502550', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Kildare Farm Road', N'Cary', N'NC', N'37183', N'27518', 35.741314, -78.780217, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4012, N'Novant Health Huntersville Medical Center', 1, NULL, NULL, N'340183', NULL, NULL, 0, 75, NULL, N'7043164000', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10030 Gilead Road', N'Huntersville', N'NC', N'37119', N'28078', 35.407899, -80.860744, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4013, N'Haywood Regional Medical Center', 1, NULL, NULL, N'340184', NULL, NULL, 0, 178, NULL, N'8284567311', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'262 Leroy George Drive', N'Clyde', N'NC', N'37087', N'28721', 35.525748, -82.944023, 2527, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4014, N'Vidant Beaufort Hospital', 1, NULL, NULL, N'340186', NULL, NULL, 0, 142, NULL, N'2529754100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'628 E 12Th St', N'Washington', N'NC', N'37013', N'27889', 35.548683, -77.038858, 2601, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4015, N'Davie Medical Center', 1, NULL, NULL, N'340187', NULL, NULL, 0, 81, NULL, N'3367518100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'223 Hospital Street', N'Mocksville', N'NC', N'37059', N'27028', 35.89911, -80.571078, 2563, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4016, N'Cape Fear Valley Hoke Hospital', 1, NULL, NULL, N'340188', NULL, NULL, 0, 41, NULL, N'9100000000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Medical Pavilion Drive', N'Raeford', N'NC', N'37093', N'28376', 35.031426, -79.108824, 2573, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4017, N'Our Community Hospital', 1, NULL, NULL, N'341302', NULL, NULL, 0, 20, NULL, N'2528264144', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Junior High Road', N'Scotland Neck', N'NC', N'37083', N'27874', 36.1296, -77.420247, 2579, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4018, N'Firsthealth Montmery Memorial Hosp', 1, NULL, NULL, N'341303', NULL, NULL, 0, 25, NULL, N'9105721301', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Allen Street', N'Troy', N'NC', N'37123', N'27371', 35.364837, -79.891582, 2596, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4019, N'Vidant Bertie  Hospital', 1, NULL, NULL, N'341304', NULL, NULL, 0, 15, NULL, N'2527946600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1403 South Kings Street', N'Windsor', N'NC', N'37015', N'27983', 35.998493, -76.946064, 2604, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4020, N'Swain County Hospital', 1, NULL, NULL, N'341305', NULL, NULL, 0, 48, NULL, N'8284882155', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 Plateau Street', N'Bryson City', N'NC', N'37173', N'28713', 35.434496, -83.444731, 2521, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4021, N'Pender Memorial Hospital', 1, NULL, NULL, N'341307', NULL, NULL, 0, 25, NULL, N'9102595451', N'9102590711', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 E Fremont St', N'Burgaw', N'NC', N'37141', N'28425', 34.551263, -77.920423, 2522, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4022, N'Chatham Hospital Inc', 1, NULL, NULL, N'341311', NULL, NULL, 0, 68, NULL, N'9196632113', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Progress Blvd', N'Siler City', N'NC', N'37037', N'27344', 35.723921, -79.422322, 2585, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4023, N'Washington County Hosp Inc', 1, NULL, NULL, N'341314', NULL, NULL, 0, 49, NULL, N'2527934135', N'2527931530', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'958 Us Hwy 64 East', N'Plymouth', N'NC', N'37187', N'27962', 35.847939, -76.755774, 2574, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4024, N'Cape Fear Valley-Bladen County Hospital', 1, NULL, NULL, N'341315', NULL, NULL, 0, 35, NULL, N'9108625100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Poplar Street', N'Elizabethtown', N'NC', N'37017', N'28337', 34.623455, -78.608275, 2536, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4025, N'Highlands Cashiers Hospital Inc', 1, NULL, NULL, N'341316', NULL, NULL, 0, 25, NULL, N'8285261200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 Hospital Drive', N'Highlands', N'NC', N'37113', N'28741', 35.08613, -83.185722, 2550, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4026, N'Pioneer Community Hospital Of Stokes', 1, NULL, NULL, N'341317', NULL, NULL, 0, 93, NULL, N'3365932831', N'3365935350', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1570 Nc 8 & 89 Hwy North', N'Danbury', N'NC', N'37169', N'27016', 36.409305, -80.205883, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4027, N'Vidant Chowan Hospital', 1, NULL, NULL, N'341318', NULL, NULL, 0, 25, NULL, N'2524828451', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Virginia Rd', N'Edenton', N'NC', N'37041', N'27932', 36.070999, -76.60954, 2534, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4028, N'Transylvania Regional Hospital Inc', 1, NULL, NULL, N'341319', NULL, NULL, 0, 25, NULL, N'8288835302', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 Hospital Drive Po Box 1116', N'Brevard', N'NC', N'37175', N'28712', 35.256324, -82.715196, 2520, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4029, N'Alleghany County Memorial Hospital', 1, NULL, NULL, N'341320', NULL, NULL, 0, 25, NULL, N'3363725511', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'617 Doctors Street', N'Sparta', N'NC', N'37005', N'28675', 36.509562, -81.109183, 2588, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4030, N'St Lukes Hospital', 1, NULL, NULL, N'341322', NULL, NULL, 0, 35, NULL, N'8288943311', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Drive', N'Columbus', N'NC', N'37149', N'28722', 35.239079, -82.212578, 2528, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4031, N'Charles A Cannon Jr Memorial Hospital', 1, NULL, NULL, N'341323', NULL, NULL, 0, 40, NULL, N'8287377000', N'8287377491', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'434 Hospital Drive', N'Linville', N'NC', N'37011', N'28646', 36.061938, -81.888299, 2530, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4032, N'The Outer Banks Hospital Inc', 1, NULL, NULL, N'341324', NULL, NULL, 0, 19, NULL, N'2524494500', N'2524494555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 South Croatan Highway', N'Nags Head', N'NC', N'37055', N'27959', 35.941132, -75.61707, 2535, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4033, N'Ashe Memorial Hospital', 1, NULL, NULL, N'341325', NULL, NULL, 0, 76, NULL, N'3362467101', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Ave', N'Jefferson', N'NC', N'37009', N'28640', 36.423128, -81.459633, 2552, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4034, N'Angel Medical Center', 1, NULL, NULL, N'341326', NULL, NULL, 0, 25, NULL, N'8285248411', N'8283694492', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 Riverview St Po Box 1209', N'Franklin', N'NC', N'37113', N'28734', 35.184188, -83.377558, 2540, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4035, N'J Arthur Dosher Memorial Hospital', 1, NULL, NULL, N'341327', NULL, NULL, 0, 25, NULL, N'9104573800', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'924 Howe St', N'Southport', N'NC', N'37019', N'28461', 33.929038, -78.022194, 2587, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4036, N'Murphy Medical Center Inc', 1, NULL, NULL, N'341328', NULL, NULL, 0, 50, NULL, N'8288378161', N'8288357507', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3990 East Us Highway 64 Alt', N'Murphy', N'NC', N'37039', N'28906', 35.087584, -84.034631, 2569, 72, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4037, N'Blue Ridge Regional Hospital Inc', 1, NULL, NULL, N'341329', NULL, NULL, 0, 85, NULL, N'8287654201', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Hospital Dr', N'Spruce Pine', N'NC', N'37121', N'28777', 35.910641, -82.063293, 2589, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4038, N'Kindred Hospital Greensboro', 1, NULL, NULL, N'342012', NULL, NULL, 0, 101, NULL, N'3362712800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 Southside Blvd', N'Greensboro', N'NC', N'37081', N'27406', 36.072636, -79.791975, 2543, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4039, N'Lifecare Hospitals Of Nc', 1, NULL, NULL, N'342013', NULL, NULL, 0, 50, NULL, N'2524512300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1031 Noell Lane', N'Rocky Mount', N'NC', N'37127', N'27804', 35.971338, -77.82239, 2579, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4040, N'Highsmith Rainey Memorial Hospital', 1, NULL, NULL, N'342014', NULL, NULL, 0, 112, NULL, N'9106096700', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Robeson Street 4Th Floor', N'Fayetteville', N'NC', N'37051', N'28301', 35.054319, -78.887458, 2539, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4041, N'Carolinas Continuecare Hospital At Pineville', 1, NULL, NULL, N'342015', NULL, NULL, 0, 40, NULL, N'7043795117', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10648 Park Rd 3Rd Fl', N'Charlotte', N'NC', N'37119', N'28210', 35.151597, -80.848684, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4042, N'Select Specialty Hospital-Winston Salem', 1, NULL, NULL, N'342016', NULL, NULL, 0, 52, NULL, N'9012776970', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Silas Creek Parkway 6Th Flr', N'Winston Salem', N'NC', N'37067', N'27103', 36.066016, -80.254524, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4043, N'Ashville Specialty Hospital', 1, NULL, NULL, N'342017', NULL, NULL, 0, 34, NULL, N'8282131127', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'428 Biltmore Avenue 4Th Floor', N'Asheville', N'NC', N'37021', N'28802', 35.579977, -82.550533, 2515, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4044, N'Select Specialty Hospital Durham Inc', 1, NULL, NULL, N'342018', NULL, NULL, 0, 30, NULL, N'9194709010', N'9194709020', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3643 North Roxboro Road 6Th Floor', N'Durham', N'NC', N'37063', N'27704', 35.994033, -78.898619, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4045, N'Carolinas Continuecare At Kings Mountain', 1, NULL, NULL, N'342019', NULL, NULL, 0, 41, NULL, N'7044349466', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'706 West King Street 2Nd Floor', N'Kings Mountain', N'NC', N'37071', N'28086', 35.240955, -81.356051, 2554, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4046, N'Select Specialty Hospital-Greensboro', 1, NULL, NULL, N'342020', NULL, NULL, 0, 30, NULL, N'3368327000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 North Elm Street 5Th Floor', N'Greensboro', N'NC', N'37081', N'27401', 36.092342, -79.78871, 2543, 198, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4047, N'Carepartners  Rehabilitation Hosp', 1, NULL, NULL, N'343025', NULL, NULL, 0, 80, NULL, N'8282742400', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'68 Sweeten Creek Rd', N'Asheville', N'NC', N'37021', N'28813', 35.46903, -82.51611, 2515, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4048, N'Carolinas Rehabilitation', 1, NULL, NULL, N'343026', NULL, NULL, 0, 133, NULL, N'7043554370', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Blythe Boulevard', N'Charlotte', N'NC', N'37119', N'28203', 35.20289, -80.837574, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4049, N'Dorothea Dix Hospital', 1, NULL, NULL, N'344001', NULL, NULL, 0, 838, NULL, N'9197335324', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 South Boylan Ave', N'Raleigh', N'NC', N'37183', N'27603', 35.776151, -78.650784, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4050, N'Central Regional Hospital', 1, NULL, NULL, N'344004', NULL, NULL, 0, 466, NULL, N'9197642000', N'9197647510', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Veazy Rd', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4051, N'Old Vineyard Youth Services', 1, NULL, NULL, N'344007', NULL, NULL, 0, 104, NULL, N'3367943550', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3637 Old Vineyard Road', N'Winston Salem', N'NC', N'37067', N'27104', 36.099817, -80.244144, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4052, N'Holly Hill Mental Health Services', 1, NULL, NULL, N'344014', NULL, NULL, 0, 168, NULL, N'9192507000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3019 Falstaff Rd', N'Raleigh', N'NC', N'37183', N'27610', 35.782242, -78.584307, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4053, N'Brynn Marr Hosp', 1, NULL, NULL, N'344016', NULL, NULL, 0, 88, NULL, N'9195771400', N'8667849687', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'192 Village Drive', N'Jacksonville', N'NC', N'37133', N'28540', 34.746855, -77.373045, 2551, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4054, N'Julian F Keith Alcohol & Drug Abuse Tx', 1, NULL, NULL, N'344023', NULL, NULL, 0, 80, NULL, N'8286693402', N'8282576300', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Tabernacle Road', N'Black Mountain', N'NC', N'37021', N'28711', 35.609215, -82.346474, 2515, 195, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4055, N'Broughton Hospital', 1, NULL, NULL, N'344025', NULL, NULL, 0, 737, NULL, N'8284332111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Sterling Street', N'Morganton', N'NC', N'37023', N'28655', 35.737511, -81.677916, 2567, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4056, N'Cherry Hospital', 1, NULL, NULL, N'344026', NULL, NULL, 0, 251, NULL, N'9197313203', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Stevens Mills Rd', N'ldsboro', N'NC', N'37191', N'27530', 35.384884, -77.992765, 2542, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4057, N'Rj Blackley Alcohol And Drug Abuse Treatment Ctr', 1, NULL, NULL, N'344027', NULL, NULL, 0, 80, NULL, N'9195757240', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Bldg 29 30 Barrett Bldg 100 H Street', N'Butner', N'NC', N'37077', N'27509', 36.132089, -78.756671, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4058, N'Strategic Behavorial Center-Garner', 1, NULL, NULL, N'344028', NULL, NULL, 0, 20, NULL, N'9198004400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Waterfield Drive', N'Garner', N'NC', N'37101', N'27529', 35.680377, -78.55892, 2575, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4059, N'od Hope Hospital Inc', 1, NULL, NULL, N'344029', NULL, NULL, 0, 16, NULL, N'9102304011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'410 Denim Drive', N'Erwin', N'NC', N'37085', N'28339', 35.3272863, -78.6718607, 2538, 201, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4060, N'Strategic Behavioral Center-Leland', 1, NULL, NULL, N'344030', NULL, NULL, 0, 20, NULL, N'9013712500', N'6013712508', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2050 Mercantile Drive', N'Leland', N'NC', N'37019', N'28451', 34.256281, -78.044714, 2602, 202, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4061, N'University Of North Carolina Hospitals', 1, NULL, NULL, N'349800', NULL, NULL, 0, 0, NULL, N'9199661645', N'9199668481', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 Manning Drive', N'Chapel Hill', N'NC', N'37135', N'27514', 35.904812, -79.049704, 2524, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4062, N'Pitt County Memorial Hospital', 1, NULL, NULL, N'349801', NULL, NULL, 0, 0, NULL, N'2528474398', N'2528478147', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2100 Stantonsburg Road Po Box 6028', N'Greenville', N'NC', N'37147', N'27835', 35.605141, -77.408421, 2544, 199, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4063, N'Carolinas Medical Center', 1, NULL, NULL, N'349802', NULL, NULL, 0, 0, NULL, N'7043556649', N'7043555010', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Transplant Center Po Box 32861', N'Charlotte', N'NC', N'37119', N'28232', 35.227087, -80.843127, 2525, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4064, N'Wake Forest University Baptist Medical Center', 1, NULL, NULL, N'349803', NULL, NULL, 0, 0, NULL, N'3367135623', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Medical Center Boulevard', N'Winston Salem', N'NC', N'37067', N'27157', 36.089827, -80.271364, 2605, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4065, N'Duke University Hosptial', 1, NULL, NULL, N'349804', NULL, NULL, 0, 0, NULL, N'9196845926', N'9199849039', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Po Box 3876 Duke University Medical Center', N'Durham', N'NC', N'37063', N'27710', 35.994033, -78.898619, 2532, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4066, N'St Alexius Medical Center', 1, NULL, NULL, N'350002', NULL, NULL, 0, 287, NULL, N'7015307000', N'7015307612', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 E Broadway', N'Bismarck', N'ND', N'38015', N'58501', 46.806381, -100.778534, 2608, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4067, N'Trinity Hospitals', 1, NULL, NULL, N'350006', NULL, NULL, 0, 416, NULL, N'7018575000', N'7018575117', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 3Rd St Se', N'Minot', N'ND', N'38101', N'58701', 48.232479, -101.288452, 2631, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4068, N'Sanford Medical Center Far', 1, NULL, NULL, N'350011', NULL, NULL, 0, 582, NULL, N'7012342000', N'7012346979', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Broadway North', N'Far', N'ND', N'38017', N'58122', 46.88468, -96.78773, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4069, N'Sanford Medical Center Bismarck', 1, NULL, NULL, N'350015', NULL, NULL, 0, 223, NULL, N'7013236000', N'7013235221', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 N 7Th St', N'Bismarck', N'ND', N'38015', N'58506', 46.807457, -100.781563, 2608, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4070, N'Altru Hospital', 1, NULL, NULL, N'350019', NULL, NULL, 0, 257, NULL, N'7017805000', N'7017801631', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 S Columbia Rd', N'Grand Forks', N'ND', N'38035', N'58201', 47.910637, -97.066383, 2620, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4071, N'P H S Indian Hosp At Belcourt-Quentin N Burdick', 1, NULL, NULL, N'350063', NULL, NULL, 0, 46, NULL, N'7014776111', N'7014778410', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 160', N'Belcourt', N'ND', N'38079', N'58316', 48.839177, -99.744874, 2635, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4072, N'Standing Rock Indian Health Service Hospital', 1, NULL, NULL, N'350064', NULL, NULL, 0, 12, NULL, N'7018543831', N'7018547567', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 North River Road', N'Fort Yates', N'ND', N'38085', N'58538', 46.086941, -100.630127, 2608, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4073, N'Essentia Health-Far', 1, NULL, NULL, N'350070', NULL, NULL, 0, 133, NULL, N'7013648000', N'7013644528', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 32Nd Ave South', N'Far', N'ND', N'38017', N'58104', 46.832504, -96.828583, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4074, N'Tioga Medical Center', 1, NULL, NULL, N'351300', NULL, NULL, 0, 25, NULL, N'7016643305', N'7016642240', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 N Welo St', N'Tioga', N'ND', N'38105', N'58852', 48.402815, -102.934752, 2638, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4075, N'Mountrail County Medical Center', 1, NULL, NULL, N'351301', NULL, NULL, 0, 11, NULL, N'7016282424', N'7016283106', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 6Th St Se', N'Stanley', N'ND', N'38061', N'58784', 48.312519, -102.380869, 2637, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4076, N'Mckenzie County Healthcare Systems', 1, NULL, NULL, N'351302', NULL, NULL, 0, 24, NULL, N'7018423000', N'7018426248', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'516 North Main St', N'Watford City', N'ND', N'38053', N'58854', 47.806152, -103.28304, 2641, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4077, N'Garrison Memorial Hospital', 1, NULL, NULL, N'351303', NULL, NULL, 0, 22, NULL, N'7014632275', N'7014636569', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'407 3Rd Ave Se', N'Garrison', N'ND', N'38055', N'58540', 47.648342, -101.411299, 2631, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4078, N'Community Memorial Hospital', 1, NULL, NULL, N'351304', NULL, NULL, 0, 25, NULL, N'7014482331', N'7014482441', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 5Th Ave W', N'Turtle Lake', N'ND', N'38055', N'58575', 47.517923, -100.894317, 2639, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4079, N'Kenmare Community Hospital', 1, NULL, NULL, N'351305', NULL, NULL, 0, 25, NULL, N'7013854296', N'7013854341', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 697', N'Kenmare', N'ND', N'38101', N'58746', 48.674748, -102.082664, 2631, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4080, N'Cooperstown Medical Center', 1, NULL, NULL, N'351306', NULL, NULL, 0, 18, NULL, N'7017972221', N'7017972421', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Roberts Ave Ne', N'Cooperstown', N'ND', N'38039', N'58425', 47.445629, -98.119185, 2614, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4081, N'St Andrews Health Center - Cah', 1, NULL, NULL, N'351307', NULL, NULL, 0, 25, NULL, N'7012289300', N'7012289384', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 Ohmer Street', N'Bottineau', N'ND', N'38009', N'58318', 48.829242, -100.449077, 2609, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4082, N'Nelson County Health System', 1, NULL, NULL, N'351308', NULL, NULL, 0, 19, NULL, N'7013224328', N'7013222250', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 N Main St', N'Mcville', N'ND', N'38063', N'58254', 47.766616, -98.177285, 2630, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4083, N'Sanford Mayville', 1, NULL, NULL, N'351309', NULL, NULL, 0, 25, NULL, N'7017863800', N'7017882145', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'42 6Th Avenue Se', N'Mayville', N'ND', N'38097', N'58257', 47.501114, -97.317379, 2629, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4084, N'Sakakawea Medical Center - Cah', 1, NULL, NULL, N'351310', NULL, NULL, 0, 25, NULL, N'7017482225', N'7017485757', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 8Th Avenue Ne', N'Hazen', N'ND', N'38057', N'58545', 47.298196, -101.611562, 2622, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4085, N'Lisbon Area Health Services', 1, NULL, NULL, N'351311', NULL, NULL, 0, 25, NULL, N'7016835241', N'7016834345', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 Main St', N'Lisbon', N'ND', N'38073', N'58054', 46.437537, -97.681413, 2628, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4086, N'Northwood Deaconess Health Center', 1, NULL, NULL, N'351312', NULL, NULL, 0, 12, NULL, N'7015876060', N'7015876479', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 190', N'Northwood', N'ND', N'38035', N'58267', 47.734155, -97.566754, 2632, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4087, N'Southwest Healthcare Services', 1, NULL, NULL, N'351313', NULL, NULL, 0, 23, NULL, N'7015235265', N'7015237104', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14 6Th Ave Sw', N'Bowman', N'ND', N'38011', N'58623', 46.182059, -103.403794, 2610, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4088, N'Jacobson Memorial Hospital Care Center', 1, NULL, NULL, N'351314', NULL, NULL, 0, 25, NULL, N'7015842792', N'7015843348', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 East St N', N'Elgin', N'ND', N'38037', N'58533', 46.407017, -101.842151, 2618, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4089, N'Oakes Community Hospital', 1, NULL, NULL, N'351315', NULL, NULL, 0, 20, NULL, N'7017423291', N'7017423639', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 N 7Th St', N'Oakes', N'ND', N'38021', N'58474', 46.152359, -98.090473, 2633, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4090, N'Presentation Medical Center', 1, NULL, NULL, N'351316', NULL, NULL, 0, 25, NULL, N'7014773161', N'7014775564', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 Second Ave Ne', N'Rolla', N'ND', N'38079', N'58367', 48.861559, -99.615523, 2635, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4091, N'Carrington Health Center', 1, NULL, NULL, N'351318', NULL, NULL, 0, 25, NULL, N'7016523141', N'7016522884', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 461', N'Carrington', N'ND', N'38031', N'58421', 47.44972, -99.126223, 2612, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4092, N'Pembina County Memorial Hospital', 1, NULL, NULL, N'351319', NULL, NULL, 0, 20, NULL, N'7012658461', N'7012656269', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 380', N'Cavalier', N'ND', N'38067', N'58220', 48.793881, -97.62231, 2613, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4093, N'Unity Medical Center', 1, NULL, NULL, N'351320', NULL, NULL, 0, 14, NULL, N'7013521620', N'7013521671', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 W 13Th Street', N'Grafton', N'ND', N'38099', N'58237', 48.411484, -97.413731, 2620, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4094, N'Wishek Community Hospital', 1, NULL, NULL, N'351321', NULL, NULL, 0, 24, NULL, N'7014522326', N'7014522392', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1007 4Th Ave S', N'Wishek', N'ND', N'38051', N'58495', 46.255129, -99.551931, 2643, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4095, N'Ashley Medical Center', 1, NULL, NULL, N'351322', NULL, NULL, 0, 20, NULL, N'7012883433', N'7012883938', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'612 Center Avenue N', N'Ashley', N'ND', N'38051', N'58413', 46.039647, -99.371712, 2607, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4096, N'Cavalier County Memorial Hospital', 1, NULL, NULL, N'351323', NULL, NULL, 0, 20, NULL, N'7012566100', N'7012562170', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 2Nd St', N'Langdon', N'ND', N'38019', N'58249', 48.761233, -98.366661, 2626, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4097, N'Mercy Hospital Of Valley City', 1, NULL, NULL, N'351324', NULL, NULL, 0, 25, NULL, N'7018456400', N'7018456413', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'570 Chautauqua Blvd', N'Valley City', N'ND', N'38003', N'58072', 46.928561, -97.994865, 2640, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4098, N'St Luke''s Hospital', 1, NULL, NULL, N'351325', NULL, NULL, 0, 15, NULL, N'7019656384', N'7019654258', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'702 1St St Sw', N'Crosby', N'ND', N'38023', N'58730', 48.906844, -103.29823, 2615, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4099, N'First Care Health Center', 1, NULL, NULL, N'351326', NULL, NULL, 0, 14, NULL, N'7012847500', N'7012844576', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Vivian St', N'Park River', N'ND', N'38099', N'58270', 48.399087, -97.747617, 2634, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4100, N'St Aloisius Medical Center', 1, NULL, NULL, N'351327', NULL, NULL, 0, 25, NULL, N'7013244651', N'7013244687', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 E Brewster St', N'Harvey', N'ND', N'38103', N'58341', 47.767694, -99.92972, 2621, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4101, N'Linton Hospital - Cah', 1, NULL, NULL, N'351328', NULL, NULL, 0, 14, NULL, N'7012544511', N'7012540112', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'518 North Broadway', N'Linton', N'ND', N'38029', N'58552', 46.269469, -100.232887, 2627, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4102, N'Sanford Hillsboro', 1, NULL, NULL, N'351329', NULL, NULL, 0, 16, NULL, N'7016363200', N'7016363206', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12 Third Street South East', N'Hillsboro', N'ND', N'38097', N'58045', 47.403607, -97.056678, 2624, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4103, N'West River Regional Medical Center-Cah', 1, NULL, NULL, N'351330', NULL, NULL, 0, 25, NULL, N'7015674561', N'7015676368', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Highway 12', N'Hettinger', N'ND', N'38001', N'58639', 46.001196, -102.630886, 2623, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4104, N'Towner County Medical Center', 1, NULL, NULL, N'351331', NULL, NULL, 0, 20, NULL, N'7019684411', N'7019682574', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 281 N', N'Cando', N'ND', N'38095', N'58324', 48.486668, -99.209859, 2611, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4105, N'Heart Of America Medical Center', 1, NULL, NULL, N'351332', NULL, NULL, 0, 25, NULL, N'7017765261', N'7017765448', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 S Main Ave', N'Rugby', N'ND', N'38069', N'58368', 48.36351, -99.996111, 2636, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4106, N'The Mercy Hospital Of Devils Lake', 1, NULL, NULL, N'351333', NULL, NULL, 0, 25, NULL, N'7016622131', N'7016629651', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1031 7Th St Ne', N'Devils Lake', N'ND', N'38071', N'58301', 48.114773, -98.850855, 2616, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4107, N'Mercy Medical Center', 1, NULL, NULL, N'351334', NULL, NULL, 0, 25, NULL, N'7017747400', N'7017747479', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 15Th Ave W', N'Williston', N'ND', N'38105', N'58801', 48.155119, -103.645426, 2642, 207, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4108, N'Jamestown Regional Medical Center', 1, NULL, NULL, N'351335', NULL, NULL, 0, 25, NULL, N'7012521050', N'7019523267', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2422 20Th St Sw', N'Jamestown', N'ND', N'38093', N'58401', 46.888795, -98.71163, 2625, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4109, N'St Joseph''s Hospital & Health Center', 1, NULL, NULL, N'351336', NULL, NULL, 0, 25, NULL, N'7014564000', N'7014564800', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Fairway Street', N'Dickinson', N'ND', N'38089', N'58601', 46.887267, -102.820598, 2617, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4110, N'Vibra Hospital Of Far', 1, NULL, NULL, N'352004', NULL, NULL, 0, 31, NULL, N'7012419099', N'7012419114', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1720 University Drive South', N'Far', N'ND', N'38017', N'58103', 46.877229, -96.789821, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4111, N'Vibra Hospital Of Central Dakotas', 1, NULL, NULL, N'352005', NULL, NULL, 0, 41, NULL, N'7016672000', N'7016635944', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 18Th Street Nw', N'Mandan', N'ND', N'38059', N'58554', 46.826437, -100.889654, 2608, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4112, N'North Dakota State Hospital', 1, NULL, NULL, N'354003', NULL, NULL, 0, 142, NULL, N'7012533650', N'7012533999', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2605 Circle Drive', N'Jamestown', N'ND', N'38093', N'58401', 46.910544, -98.708436, 2625, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4113, N'Prairie St Johns', 1, NULL, NULL, N'354004', NULL, NULL, 0, 110, NULL, N'7014767200', N'7014767261', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 4Th Street South', N'Far', N'ND', N'38017', N'58103', 46.877229, -96.789821, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4114, N'Richard P Stadter Psychiatric Center', 1, NULL, NULL, N'354005', NULL, NULL, 0, 70, NULL, N'7017722500', N'7017322517', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 44Th Avenue S', N'Grand Forks', N'ND', N'38035', N'58208', 47.907824, -97.059203, 2620, 206, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4115, N'Sanford Bismarck Transplant Center', 1, NULL, NULL, N'359810', NULL, NULL, 0, 0, NULL, N'7013232828', N'7013232801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 N 7Th St', N'Bismarck', N'ND', N'38015', N'58501', 46.834486, -100.781513, 2608, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4116, N'Sanford Transplant Center', 1, NULL, NULL, N'359811', NULL, NULL, 0, 0, NULL, N'7012342411', N'7012342808', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'736 Broadway', N'Far', N'ND', N'38017', N'58122', 46.877229, -96.789821, 2619, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4117, N'Mercy Hospital Anderson', 1, NULL, NULL, N'360001', NULL, NULL, 0, 226, NULL, N'5136244006', N'5136243299', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 State Road', N'Cincinnati', N'OH', N'39061', N'45255', 39.08438, -84.349296, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4118, N'Samaritan Regional Health System', 1, NULL, NULL, N'360002', NULL, NULL, 0, 123, NULL, N'4192890491', N'4192077929', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Center St', N'Ashland', N'OH', N'39005', N'44805', 40.858784, -82.310456, 2646, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4119, N'University Of Cincinnati Medical Center Llc', 1, NULL, NULL, N'360003', NULL, NULL, 0, 771, NULL, N'5135841000', N'5135840526', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'234 odman Street', N'Cincinnati', N'OH', N'39061', N'45219', 39.136716, -84.502372, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4120, N'Riverside Methodist Hospital', 1, NULL, NULL, N'360006', NULL, NULL, 0, 1000, NULL, N'6145665000', N'6145666760', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Olentangy River Rd', N'Columbus', N'OH', N'39049', N'43214', 40.03203, -83.031317, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4121, N'Southern Ohio Medical Center', 1, NULL, NULL, N'360008', NULL, NULL, 0, 237, NULL, N'7403565000', N'7403532981', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1805 27Th Street', N'Portsmouth', N'OH', N'39145', N'45662', 38.753115, -82.977991, 2731, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4122, N'Lima Memorial Health System', 1, NULL, NULL, N'360009', NULL, NULL, 0, 285, NULL, N'4199984731', N'4199984571', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Bellefontaine Avenue', N'Lima', N'OH', N'39003', N'45804', 40.735602, -84.087713, 2698, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4123, N'Union Hospital', 1, NULL, NULL, N'360010', NULL, NULL, 0, 220, NULL, N'3303433311', N'3303640951', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'659 Boulevard', N'Dover', N'OH', N'39157', N'44622', 40.513502, -81.455852, 2676, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4124, N'Marion General Hospital', 1, NULL, NULL, N'360011', NULL, NULL, 0, 389, NULL, N'7403838400', N'7403838706', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mckinley Park Drive', N'Marion', N'OH', N'39101', N'43302', 40.571602, -83.128048, 2706, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4125, N'Mount Carmel St Ann''s', 1, NULL, NULL, N'360012', NULL, NULL, 0, 161, NULL, N'6148984000', N'6145464535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 South Cleveland Avenue', N'Westerville', N'OH', N'39049', N'43081', 40.114004, -82.948936, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4126, N'Wilson Memorial Hospital', 1, NULL, NULL, N'360013', NULL, NULL, 0, 128, NULL, N'9374985418', N'9374975675', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 West Michigan Street', N'Sidney', N'OH', N'39149', N'45365', 40.287931, -84.168961, 2736, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4127, N'Ohiohealth O''bleness Hospital', 1, NULL, NULL, N'360014', NULL, NULL, 0, 114, NULL, N'7405929233', N'7405929466', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'55 Hospital Drive', N'Athens', N'OH', N'39009', N'45701', 39.327733, -82.114153, 2648, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4128, N'Jewish Hospital Llc', 1, NULL, NULL, N'360016', NULL, NULL, 0, 658, NULL, N'5136863000', N'5136863004', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4777 East Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45236', 39.206913, -84.381797, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4129, N'Grant Medical Center', 1, NULL, NULL, N'360017', NULL, NULL, 0, 645, NULL, N'6145669978', N'6145668043', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South Grant Avenue', N'Columbus', N'OH', N'39049', N'43215', 39.960767, -82.990609, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4130, N'Summa Barberton Hospital', 1, NULL, NULL, N'360019', NULL, NULL, 0, 270, NULL, N'3306153000', N'3306153033', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 5Th Street N E', N'Barberton', N'OH', N'39153', N'44203', 41.015225, -81.589808, 2649, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4131, N'Summa Health System', 1, NULL, NULL, N'360020', NULL, NULL, 0, 1093, NULL, N'3303753000', N'3303753050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 East Market Street', N'Akron', N'OH', N'39153', N'44309', 41.078801, -81.501157, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4132, N'Firelands Regional Medical Center', 1, NULL, NULL, N'360025', NULL, NULL, 0, 400, NULL, N'4195577400', N'4195576824', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Hayes Avenue', N'Sandusky', N'OH', N'39043', N'44870', 41.446362, -82.7087, 2734, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4133, N'Greene Memorial Hospital', 1, NULL, NULL, N'360026', NULL, NULL, 0, 235, NULL, N'9373522000', N'9373523230', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1141 North Monroe Drive', N'Xenia', N'OH', N'39057', N'45385', 39.700126, -83.928749, 2757, 215, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4134, N'Akron General Medical Center', 1, NULL, NULL, N'360027', NULL, NULL, 0, 511, NULL, N'3303446000', N'3303764835', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Wabash Avenue', N'Akron', N'OH', N'39153', N'44307', 41.077673, -81.53233, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4135, N'Wood County Hospital', 1, NULL, NULL, N'360029', NULL, NULL, 0, 168, NULL, N'4193548900', N'4193548957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 West Wooster Street', N'Bowling Green', N'OH', N'39173', N'43402', 41.373604, -83.666764, 2657, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4136, N'Grand Lake Health System', 1, NULL, NULL, N'360032', NULL, NULL, 0, 113, NULL, N'4193943335', N'4193948485', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Saint Clair Street', N'Saint Marys', N'OH', N'39011', N'45885', 40.545212, -84.369837, 2738, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4137, N'Mount Carmel West', 1, NULL, NULL, N'360035', NULL, NULL, 0, 937, NULL, N'6142345000', N'6142345105', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'793 West State Street', N'Columbus', N'OH', N'39049', N'43222', 39.957482, -83.02332, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4138, N'Wooster Community Hospital', 1, NULL, NULL, N'360036', NULL, NULL, 0, 207, NULL, N'3302638100', N'3302638497', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1761 Beall Avenue', N'Wooster', N'OH', N'39169', N'44691', 40.820556, -81.934247, 2756, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4139, N'St Vincent Charity Medical Center', 1, NULL, NULL, N'360037', NULL, NULL, 0, 448, NULL, N'2168616200', N'2166944608', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2351 East 22Nd Street', N'Cleveland', N'OH', N'39035', N'44115', 41.496418, -81.673984, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4140, N'Genesis Hospital', 1, NULL, NULL, N'360039', NULL, NULL, 0, 767, NULL, N'7404545000', N'7404544914', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2951 Maple Avenue', N'Zanesville', N'OH', N'39119', N'43701', 39.975279, -82.013473, 2759, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4141, N'Knox Community Hospital', 1, NULL, NULL, N'360040', NULL, NULL, 0, 166, NULL, N'7403939000', N'7403993130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1330 Coshocton Road', N'Mount Vernon', N'OH', N'39083', N'43050', 40.402482, -82.447579, 2716, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4142, N'Parma Community General Hospital', 1, NULL, NULL, N'360041', NULL, NULL, 0, 309, NULL, N'4407433000', N'4407434386', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7007 Powers Boulevard', N'Parma', N'OH', N'39035', N'44129', 41.382746, -81.730366, 2726, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4143, N'Wayne Hospital', 1, NULL, NULL, N'360044', NULL, NULL, 0, 92, NULL, N'9375475722', N'9375475784', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Sweitzer Street', N'Greenville', N'OH', N'39037', N'45331', 40.088645, -84.635122, 2689, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4144, N'Mccullough-Hyde Memorial Hospital', 1, NULL, NULL, N'360046', NULL, NULL, 0, 94, NULL, N'5135232111', N'5135245665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 North Poplar Street', N'Oxford', N'OH', N'39017', N'45056', 39.512596, -84.740817, 2724, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4145, N'Pike County Hospital', 1, NULL, NULL, N'360047', NULL, NULL, 0, 63, NULL, N'6149472186', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Dawn Lane', N'Waverly', N'OH', N'39131', N'45690', 39.116843, -83.00594, 2751, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4146, N'University Of Toledo Medical Center', 1, NULL, NULL, N'360048', NULL, NULL, 0, 319, NULL, N'4193833407', N'4193833850', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Arlington Avenue', N'Toledo', N'OH', N'39095', N'43699', 41.621355, -83.615267, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4147, N'Miami Valley Hospital', 1, NULL, NULL, N'360051', NULL, NULL, 0, 848, NULL, N'9372088000', N'9372083000', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Wyoming Street', N'Dayton', N'OH', N'39113', N'45409', 39.758948, -84.191607, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4148, N'od Samaritan Hospital', 1, NULL, NULL, N'360052', NULL, NULL, 0, 577, NULL, N'9372782612', N'9374997813', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Philadelphia Drive', N'Dayton', N'OH', N'39113', N'45406', 39.787958, -84.234956, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4149, N'Holzer Medical Center', 1, NULL, NULL, N'360054', NULL, NULL, 0, 287, NULL, N'7404465000', N'7404465522', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Jackson Pike', N'Gallipolis', N'OH', N'39053', N'45631', 38.844321, -82.237955, 2684, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4150, N'Trumbull Memorial Hospital', 1, NULL, NULL, N'360055', NULL, NULL, 0, 346, NULL, N'3308419011', N'3308419281', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 East Market Street', N'Warren', N'OH', N'39155', N'44482', 41.236457, -80.799018, 2748, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4151, N'Mercy Hospital Fairfield', 1, NULL, NULL, N'360056', NULL, NULL, 0, 271, NULL, N'5138707197', N'5138707065', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Mack Road', N'Fairfield', N'OH', N'39017', N'45014', 39.31082, -84.520075, 2690, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4152, N'Mercer County Joint Township Community Hospital', 1, NULL, NULL, N'360058', NULL, NULL, 0, 88, NULL, N'4196784843', N'4196783271', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 West Main Street', N'Coldwater', N'OH', N'39107', N'45828', 40.479776, -84.639393, 2668, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4153, N'Metrohealth System', 1, NULL, NULL, N'360059', NULL, NULL, 0, 702, NULL, N'2167787089', N'2167787181', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Metrohealth Drive', N'Cleveland', N'OH', N'39035', N'44109', 41.462116, -81.69685, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4154, N'St Elizabeth Health Center', 1, NULL, NULL, N'360064', NULL, NULL, 0, 628, NULL, N'3307467211', N'3304807974', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Belmont Avenue', N'Youngstown', N'OH', N'39099', N'44501', 41.114223, -80.65569, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4155, N'Fisher-Titus Hospital', 1, NULL, NULL, N'360065', NULL, NULL, 0, 112, NULL, N'4196688101', N'4916636036', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'272 Benedict Avenue', N'Norwalk', N'OH', N'39077', N'44857', 41.226832, -82.602723, 2720, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4156, N'St Rita''s Medical Center', 1, NULL, NULL, N'360066', NULL, NULL, 0, 424, NULL, N'4192273361', N'4192269750', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 West Market Street', N'Lima', N'OH', N'39003', N'45801', 40.739998, -84.117393, 2698, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4157, N'Toledo Hospital The', 1, NULL, NULL, N'360068', NULL, NULL, 0, 794, NULL, N'4192917463', N'4194796000', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2142 North Cove Boulevard', N'Toledo', N'OH', N'39095', N'43606', 41.671343, -83.594074, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4158, N'Mercy Medical Center', 1, NULL, NULL, N'360070', NULL, NULL, 0, 520, NULL, N'3304891001', N'3304891312', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 Mercy Drive Nw', N'Canton', N'OH', N'39151', N'44708', 40.812402, -81.397064, 2662, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4159, N'Van Wert County Hospital', 1, NULL, NULL, N'360071', NULL, NULL, 0, 120, NULL, N'4192388627', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 S Washington Street', N'Van Wert', N'OH', N'39161', N'45891', 40.850774, -84.581367, 2746, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4160, N'Fairfield Medical Center', 1, NULL, NULL, N'360072', NULL, NULL, 0, 250, NULL, N'7406878009', N'7406878115', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 North Ewing Street', N'Lancaster', N'OH', N'39045', N'43130', 39.717053, -82.576684, 2697, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4161, N'Flower Hospital', 1, NULL, NULL, N'360074', NULL, NULL, 0, 287, NULL, N'4198241444', N'4198822342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Harroun Road', N'Sylvania', N'OH', N'39095', N'43560', 41.70906, -83.69441, 2740, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4162, N'Uhhs Richmond Heights Hospital', 1, NULL, NULL, N'360075', NULL, NULL, 0, 213, NULL, N'4405856170', N'4405856142', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'27100 Chardon Road', N'Richmond Heights', N'OH', N'39035', N'44143', 41.581402, -81.489628, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4163, N'Atrium Medical Center', 1, NULL, NULL, N'360076', NULL, NULL, 0, 328, NULL, N'5134205102', N'5134205657', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Drive', N'Franklin', N'OH', N'39165', N'45005', 39.558947, -84.304107, 2713, 215, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4164, N'Fairview Hospital', 1, NULL, NULL, N'360077', NULL, NULL, 0, 468, NULL, N'2164767000', N'2164767017', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18101 Lorain Avenue', N'Cleveland', N'OH', N'39035', N'44111', 41.450877, -81.82313, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4165, N'Robinson Memorial Hospital', 1, NULL, NULL, N'360078', NULL, NULL, 0, 302, NULL, N'3302972300', N'3302972949', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6847 N Chestnut', N'Ravenna', N'OH', N'39133', N'44266', 41.177073, -81.245986, 2732, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4166, N'Kettering Medical Center', 1, NULL, NULL, N'360079', NULL, NULL, 0, 549, NULL, N'9372984331', N'9373958384', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Southern Boulevard', N'Kettering', N'OH', N'39113', N'45429', 39.697092, -84.190611, 2695, 215, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4167, N'East Ohio Regional Hospital', 1, NULL, NULL, N'360080', NULL, NULL, 0, 161, NULL, N'7406334151', N'7406334512', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'90 North Fourth Street', N'Martins Ferry', N'OH', N'39013', N'43935', 40.098717, -80.720802, 2707, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4168, N'Mercy St Charles Hospital', 1, NULL, NULL, N'360081', NULL, NULL, 0, 342, NULL, N'4196967200', N'4196967328', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Navarre Avenue', N'Oren', N'OH', N'39095', N'43616', 41.636669, -83.486589, 2722, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4169, N'Euclid Hospital', 1, NULL, NULL, N'360082', NULL, NULL, 0, 301, NULL, N'2165319000', N'2166927425', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18901 Lake Shore Boulevard', N'Euclid', N'OH', N'39035', N'44119', 41.596734, -81.547421, 2679, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4170, N'Aultman Hospital', 1, NULL, NULL, N'360084', NULL, NULL, 0, 808, NULL, N'3304529911', N'3304554799', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Sixth Street Sw', N'Canton', N'OH', N'39151', N'44710', 40.796898, -81.404579, 2662, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4171, N'Ohio State University Hospitals', 1, NULL, NULL, N'360085', NULL, NULL, 0, 971, NULL, N'6142939700', N'6142933535', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 West 10Th Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.994881, -83.017713, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4172, N'Springfield Regional Medical Center', 1, NULL, NULL, N'360086', NULL, NULL, 0, 254, NULL, N'9375231000', N'9375235950', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Center Drive', N'Springfield', N'OH', N'39023', N'45504', 39.927624, -83.81574, 2737, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4173, N'Lutheran Hospital', 1, NULL, NULL, N'360087', NULL, NULL, 0, 203, NULL, N'2166964300', N'2165237029', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1730 West 25Th Street', N'Cleveland', N'OH', N'39035', N'44113', 41.487243, -81.705834, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4174, N'Mercy Tiffin Hospital', 1, NULL, NULL, N'360089', NULL, NULL, 0, 120, NULL, N'4194557000', N'4194557066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'45 St Lawrence Drive', N'Tiffin', N'OH', N'39147', N'44883', 41.104797, -83.218304, 2741, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4175, N'St Luke''s Hospital', 1, NULL, NULL, N'360090', NULL, NULL, 0, 215, NULL, N'4198935900', N'4198918081', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5901 Monclova Road', N'Maumee', N'OH', N'39095', N'43537', 41.558762, -83.683877, 2710, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4176, N'Medina Hospital', 1, NULL, NULL, N'360091', NULL, NULL, 0, 157, NULL, N'3307251000', N'3307214926', 1, 1, 0, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Washington Street', N'Medina', N'OH', N'39103', N'44256', 41.138857, -81.836717, 2712, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4177, N'Memorial Hospital', 1, NULL, NULL, N'360092', NULL, NULL, 0, 97, NULL, N'9375782289', N'9375782820', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 London Avenue', N'Marysville', N'OH', N'39159', N'43040', 40.231291, -83.368841, 2708, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4178, N'Blanchard Valley Hospital', 1, NULL, NULL, N'360095', NULL, NULL, 0, 239, NULL, N'4194234500', N'4194235399', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 South Main Street', N'Findlay', N'OH', N'39063', N'45840', 41.017406, -83.650339, 2680, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4179, N'East Liverpool City Hospital', 1, NULL, NULL, N'360096', NULL, NULL, 0, 144, NULL, N'3303857200', N'3303862074', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 West 5Th Street', N'East Liverpool', N'OH', N'39029', N'43920', 40.621409, -80.586218, 2677, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4180, N'Lake Health', 1, NULL, NULL, N'360098', NULL, NULL, 0, 399, NULL, N'4409539600', N'4403542400', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7590 Auburn Road', N'Concord', N'OH', N'39085', N'44077', 41.663918, -81.244375, 2725, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4181, N'Bellevue Hospital', 1, NULL, NULL, N'360107', NULL, NULL, 0, 70, NULL, N'4194834040', N'4194839718', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 West Main Street', N'Bellevue', N'OH', N'39143', N'44811', 41.285355, -82.883552, 2655, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4182, N'Coshocton County Memorial Hospital', 1, NULL, NULL, N'360109', NULL, NULL, 0, 165, NULL, N'7406226411', N'7406234095', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1460 Orange Street', N'Coshocton', N'OH', N'39031', N'43812', 40.270441, -81.847549, 2671, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4183, N'Mercy St Vincent Medical Center', 1, NULL, NULL, N'360112', NULL, NULL, 0, 568, NULL, N'4192513232', N'4192513812', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2213 Cherry Street', N'Toledo', N'OH', N'39095', N'43608', 41.668448, -83.541688, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4184, N'Medcentral Health System Mansfield Hospital', 1, NULL, NULL, N'360118', NULL, NULL, 0, 358, NULL, N'4195268000', N'4195217960', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Glessner Avenue', N'Mansfield', N'OH', N'39139', N'44903', 40.753383, -82.528563, 2704, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4185, N'Community Hospitals And Wellness Centers', 1, NULL, NULL, N'360121', NULL, NULL, 0, 70, NULL, N'4196361131', N'4196363100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'433 West High Street', N'Bryan', N'OH', N'39171', N'43506', 41.47461, -84.556808, 2658, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4186, N'St John Medical Center', 1, NULL, NULL, N'360123', NULL, NULL, 0, 240, NULL, N'4408358000', N'4408275015', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'29000 Center Ridge Road', N'Westlake', N'OH', N'39035', N'44145', 41.43475, -81.941705, 2753, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4187, N'Ashtabula County Medical Center', 1, NULL, NULL, N'360125', NULL, NULL, 0, 249, NULL, N'4409972262', N'4409976644', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2420 Lake Avenue', N'Ashtabula', N'OH', N'39007', N'44004', 41.880817, -80.796588, 2647, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4188, N'Alliance Community Hospital', 1, NULL, NULL, N'360131', NULL, NULL, 0, 207, NULL, N'3305967527', N'3305967555', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East State Street', N'Alliance', N'OH', N'39151', N'44601', 40.901679, -81.102427, 2645, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4189, N'Fort Hamilton Hughes Memorial Hospital', 1, NULL, NULL, N'360132', NULL, NULL, 0, 310, NULL, N'5138672000', N'5138672119', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 Eaton Avenue', N'Hamilton', N'OH', N'39017', N'45013', 39.415162, -84.573825, 2690, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4190, N'Grandview Hospital & Medical Center', 1, NULL, NULL, N'360133', NULL, NULL, 0, 427, NULL, N'9377233312', N'9374610020', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 Grand Avenue', N'Dayton', N'OH', N'39113', N'45405', 39.768985, -84.202998, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4191, N'od Samaritan Hospital', 1, NULL, NULL, N'360134', NULL, NULL, 0, 672, NULL, N'5138622601', N'5138621190', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Dixmyth Avenue', N'Cincinnati', N'OH', N'39061', N'45220', 39.14001, -84.52377, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4192, N'University Hospitals Case Medical Center', 1, NULL, NULL, N'360137', NULL, NULL, 0, 1032, NULL, N'2168441000', N'2168442446', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.507368, -81.607166, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4193, N'Northside Medical Center', 1, NULL, NULL, N'360141', NULL, NULL, 0, 398, NULL, N'3308841003', N'3308845735', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Gypsy Lane', N'Youngstown', N'OH', N'39099', N'44501', 41.133637, -80.657886, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4194, N'Highland District Hospital', 1, NULL, NULL, N'360142', NULL, NULL, 0, 79, NULL, N'9373936100', N'9373936278', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 North High Street', N'Hillsboro', N'OH', N'39071', N'45133', 39.22496, -83.609779, 2692, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4195, N'Marymount Hospital', 1, NULL, NULL, N'360143', NULL, NULL, 0, 349, NULL, N'2165810500', N'2165878212', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12300 Mccracken Road', N'Garfield Heights', N'OH', N'39035', N'44125', 41.422417, -81.598006, 2685, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4196, N'South Pointe Hospital', 1, NULL, NULL, N'360144', NULL, NULL, 0, 180, NULL, N'2164916000', N'2164917260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20000 Harvard Road', N'Warrensville Heights', N'OH', N'39035', N'44122', 41.449865, -81.537782, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4197, N'University Hospitals - Elyria Medical Center', 1, NULL, NULL, N'360145', NULL, NULL, 0, 400, NULL, N'4403297500', N'4403297643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 East River Street', N'Elyria', N'OH', N'39093', N'44035', 41.36698, -82.097755, 2678, 214, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4198, N'Marietta Memorial Hospital', 1, NULL, NULL, N'360147', NULL, NULL, 0, 204, NULL, N'7403741400', N'7403765073', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Matthew Street', N'Marietta', N'OH', N'39167', N'45750', 39.430679, -81.465074, 2705, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4199, N'Pomerene Hospital', 1, NULL, NULL, N'360148', NULL, NULL, 0, 55, NULL, N'3306741015', N'3306743019', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'981 Wooster Road', N'Millersburg', N'OH', N'39075', N'44654', 40.565031, -81.920858, 2714, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4200, N'Summa Western Reserve Hospital', 1, NULL, NULL, N'360150', NULL, NULL, 0, 258, NULL, N'3309717000', N'3309717277', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 23Rd Street', N'Cuyahoga Falls', N'OH', N'39153', N'44223', 41.133087, -81.509843, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4201, N'Affinity Medical Center', 1, NULL, NULL, N'360151', NULL, NULL, 0, 216, NULL, N'3308376863', N'3308376871', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'875 Eighth Street Ne', N'Massillon', N'OH', N'39151', N'44646', 40.806358, -81.515933, 2709, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4202, N'Doctors Hospital', 1, NULL, NULL, N'360152', NULL, NULL, 0, 262, NULL, N'6145441000', N'6145441844', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5100 West  Broad Street', N'Columbus', N'OH', N'39049', N'43228', 39.951968, -83.136709, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4203, N'Belmont Community Hospital', 1, NULL, NULL, N'360153', NULL, NULL, 0, 99, NULL, N'7406711200', N'7406711210', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4697 Harrison Street', N'Bellaire', N'OH', N'39013', N'43906', 40.031019, -80.740632, 2653, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4204, N'Southwest General Health Center', 1, NULL, NULL, N'360155', NULL, NULL, 0, 346, NULL, N'4408168000', N'4408168063', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18697 Bagley Road', N'Middleburg Heights', N'OH', N'39035', N'44130', 41.37208, -81.83291, 2726, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4205, N'Memorial Hospital', 1, NULL, NULL, N'360156', NULL, NULL, 0, 179, NULL, N'4193346617', N'4193325875', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'715 South Taft Avenue', N'Fremont', N'OH', N'39143', N'43420', 41.338786, -83.134951, 2682, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4206, N'Adena Regional Medical Center', 1, NULL, NULL, N'360159', NULL, NULL, 0, 261, NULL, N'7407797500', N'7407797476', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'272 Hospital Road', N'Chillicothe', N'OH', N'39141', N'45601', 39.39365, -82.968485, 2664, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4207, N'St Joseph Warren Hospital', 1, NULL, NULL, N'360161', NULL, NULL, 0, 219, NULL, N'3308414000', N'3308414019', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'667 Eastland Ave Se', N'Warren', N'OH', N'39155', N'44481', 41.230593, -80.778341, 2748, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4208, N'Christ Hospital', 1, NULL, NULL, N'360163', NULL, NULL, 0, 621, NULL, N'5135852000', N'5135852793', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2139 Auburn Avenue', N'Cincinnati', N'OH', N'39061', N'45219', 39.120891, -84.508519, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4209, N'Berger Hospital', 1, NULL, NULL, N'360170', NULL, NULL, 0, 94, NULL, N'7404208585', N'7404208608', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 North Pickaway Street', N'Circleville', N'OH', N'39129', N'43113', 39.610009, -82.937887, 2666, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4210, N'Mercy Regional Medical Center', 1, NULL, NULL, N'360172', NULL, NULL, 0, 317, NULL, N'4409604000', N'4409604630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 Kolbe Road', N'Lorain', N'OH', N'39093', N'44053', 41.436857, -82.235247, 2702, 214, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4211, N'Upper Valley Medical Center', 1, NULL, NULL, N'360174', NULL, NULL, 0, 178, NULL, N'9374407853', N'9373395310', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3130 North County Road 25A', N'Troy', N'OH', N'39109', N'45373', 40.091089, -84.224329, 2743, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4212, N'Clinton Memorial Hospital', 1, NULL, NULL, N'360175', NULL, NULL, 0, 143, NULL, N'9373826611', N'9373826633', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 West Main Street', N'Wilmington', N'OH', N'39027', N'45177', 39.445547, -83.839166, 2755, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4213, N'Bethesda North', 1, NULL, NULL, N'360179', NULL, NULL, 0, 465, NULL, N'5138651241', N'5138651441', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Montmery Road', N'Cincinnati', N'OH', N'39061', N'45242', 39.251968, -84.343986, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4214, N'Cleveland Clinic', 1, NULL, NULL, N'360180', NULL, NULL, 0, 1267, NULL, N'2164442200', N'2166363333', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9500 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44195', 41.503444, -81.621465, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4215, N'Salem Regional Medical Center', 1, NULL, NULL, N'360185', NULL, NULL, 0, 252, NULL, N'3303321551', N'3303327691', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1995 East State Street', N'Salem', N'OH', N'39029', N'44460', 40.900944, -80.832674, 2733, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4216, N'Madison County Hospital Inc', 1, NULL, NULL, N'360189', NULL, NULL, 0, 107, NULL, N'7408457000', N'7408457001', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 North Main Street', N'London', N'OH', N'39097', N'43140', 39.891314, -83.454296, 2701, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4217, N'Uh Geauga Medical Center', 1, NULL, NULL, N'360192', NULL, NULL, 0, 126, NULL, N'4402696000', N'4402867219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13207 Ravenna Rd', N'Chardon', N'OH', N'39055', N'44024', 41.50887, -81.193619, 2663, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4218, N'Summa Wadsworth-Rittman Hospital', 1, NULL, NULL, N'360195', NULL, NULL, 0, 96, NULL, N'3303311000', N'3303311942', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'195 Wadsworth Road', N'Wadsworth', N'OH', N'39103', N'44281', 41.027123, -81.754492, 2747, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4219, N'Mary Rutan Hospital', 1, NULL, NULL, N'360197', NULL, NULL, 0, 115, NULL, N'9375924015', N'9375927007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Palmer Avenue', N'Bellefontaine', N'OH', N'39091', N'43311', 40.368965, -83.756913, 2654, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4220, N'Southeastern Ohio Regional Medical Center', 1, NULL, NULL, N'360203', NULL, NULL, 0, 221, NULL, N'7404398111', N'7404398935', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1341 North Clark Street', N'Cambridge', N'OH', N'39059', N'43725', 40.040267, -81.576736, 2661, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4221, N'Grady Memorial Hospital', 1, NULL, NULL, N'360210', NULL, NULL, 0, 130, NULL, N'7403685145', N'7403685340', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'561 West Central Avenue', N'Delaware', N'OH', N'39041', N'43015', 40.306042, -83.088828, 2674, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4222, N'Trinity Medical Ctr East &Trinity Medical Ctr West', 1, NULL, NULL, N'360211', NULL, NULL, 0, 519, NULL, N'7402837000', N'7402837104', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Summit Avenue', N'Steubenville', N'OH', N'39081', N'43952', 40.356232, -80.625105, 2739, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4223, N'Lakewood Hospital', 1, NULL, NULL, N'360212', NULL, NULL, 0, 224, NULL, N'2165214200', N'2165217161', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14519 Detroit Avenue', N'Lakewood', N'OH', N'39035', N'44107', 41.485331, -81.795856, 2696, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4224, N'Licking Memorial Hospital', 1, NULL, NULL, N'360218', NULL, NULL, 0, 227, NULL, N'7403484000', N'7403484106', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 West Main Street', N'Newark', N'OH', N'39089', N'43055', 40.043798, -82.463543, 2719, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4225, N'Hillcrest Hospital', 1, NULL, NULL, N'360230', NULL, NULL, 0, 280, NULL, N'4403124500', N'4403126407', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6780 Mayfield Road', N'Mayfield Heights', N'OH', N'39035', N'44124', 41.520129, -81.435261, 2711, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4226, N'Mercy Health - West Hospital', 1, NULL, NULL, N'360234', NULL, NULL, 0, 297, NULL, N'5132155000', N'5132150962', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Mercy Health Blvd', N'Cincinnati', N'OH', N'39061', N'45211', 39.180884, -84.595394, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4227, N'Mercy Hospital Clermont', 1, NULL, NULL, N'360236', NULL, NULL, 0, 157, NULL, N'5137328278', N'5137328537', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Hospital Drive', N'Batavia', N'OH', N'39025', N'45103', 39.081, -84.147711, 2651, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4228, N'Sycamore Medical Center', 1, NULL, NULL, N'360239', NULL, NULL, 0, 183, NULL, N'9373848776', N'9373848724', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Miamisburg-Centerville Road', N'Miamisburg', N'OH', N'39113', N'45342', 39.63982, -84.25126, 2695, 215, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4229, N'Edwin Shaw Rehab Institute', 1, NULL, NULL, N'360241', NULL, NULL, 0, 160, NULL, N'3304360910', N'3304360925', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 Broadway East', N'Cuyahoga Falls', N'OH', N'39153', N'44221', 41.133594, -81.477126, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4230, N'James Cancer Hospital & Solove Research Institute', 1, NULL, NULL, N'360242', NULL, NULL, 0, 172, NULL, N'6142933121', N'6142933132', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'460 West Tenth Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.994995, -83.019668, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4231, N'Glenbeigh', 1, NULL, NULL, N'360245', NULL, NULL, 0, 114, NULL, N'4405633400', N'4405639661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2863 State Route 45', N'Rock Creek', N'OH', N'39007', N'44084', 41.672125, -80.856822, 2686, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4232, N'Woods At Parksidethe', 1, NULL, NULL, N'360247', NULL, NULL, 0, 50, NULL, N'6144712552', N'6143373644', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'349 Olde Ridenour Road', N'Columbus', N'OH', N'39049', N'43230', 40.026848, -82.881131, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4233, N'Bay Park Community Hospital', 1, NULL, NULL, N'360259', NULL, NULL, 0, 92, NULL, N'4196907700', N'4196976713', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Bay Park Drive', N'Oren', N'OH', N'39095', N'43616', 41.6183, -83.4787, 2722, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4234, N'Three Gables Surgery Center', 1, NULL, NULL, N'360261', NULL, NULL, 0, 25, NULL, N'7408869911', N'7408869922', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5897 County Road 107', N'Proctorville', N'OH', N'39087', N'45669', 38.440786, -82.393403, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4235, N'Mercy St Anne Hospital', 1, NULL, NULL, N'360262', NULL, NULL, 0, 25, NULL, N'4194072663', N'4194072400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3404 Sylvania Avenue', N'Toledo', N'OH', N'39095', N'43623', 41.691745, -83.625176, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4236, N'Institute For Orthopaedic Surgery', 1, NULL, NULL, N'360263', NULL, NULL, 0, 3, NULL, N'4192247586', N'4192249769', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Medical Drive Suite B', N'Lima', N'OH', N'39003', N'45804', 40.697389, -84.088217, 2698, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4237, N'Mount Carmel New Albany Surgical Hospital', 1, NULL, NULL, N'360266', NULL, NULL, 0, 42, NULL, N'6147756600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7333 Smith''s Mill Road', N'New Albany', N'OH', N'39049', N'43054', 40.083803, -82.769639, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4238, N'Mercy Hospital Of Defiance', 1, NULL, NULL, N'360270', NULL, NULL, 0, 23, NULL, N'4197828444', N'4197853998', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1404 East Second Street', N'Defiance', N'OH', N'39039', N'43512', 41.282695, -84.339886, 2673, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4239, N'Medical Center At Elizabeth Place', 1, NULL, NULL, N'360274', NULL, NULL, 0, 27, NULL, N'9378531053', N'9378531055', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place', N'Dayton', N'OH', N'39113', N'45417', 39.758948, -84.191607, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4240, N'St Elizabeth Boardman Health Center', 1, NULL, NULL, N'360276', NULL, NULL, 0, 65, NULL, N'3307291566', N'3307291563', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8401 Market Street', N'Boardman', N'OH', N'39099', N'44512', 40.995336, -80.662745, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4241, N'Medical Center Of Newark Llc', 1, NULL, NULL, N'360347', NULL, NULL, 0, 33, NULL, N'7405227800', N'7405224812', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Tamarack Road', N'Newark', N'OH', N'39089', N'43055', 40.038769, -82.463785, 2719, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4242, N'Dublin Methodist Hospital', 1, NULL, NULL, N'360348', NULL, NULL, 0, 107, NULL, N'6145448000', N'6145448008', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Hospital Avenue', N'Dublin', N'OH', N'39049', N'43016', 40.102661, -83.169138, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4243, N'Crystal Clinic Orthopaedic Center', 1, NULL, NULL, N'360351', NULL, NULL, 0, 94, NULL, N'3306684040', N'3306669423', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'444 North Main Street', N'Akron', N'OH', N'39153', N'44310', 41.097097, -81.512142, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4244, N'Surgical Hospital At Southwoods', 1, NULL, NULL, N'360352', NULL, NULL, 0, 36, NULL, N'3307581954', N'3307583254', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7630 Southern Blvd', N'Youngstown', N'OH', N'39099', N'44512', 41.01571, -80.653444, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4245, N'West Chester Hospital Llc', 1, NULL, NULL, N'360354', NULL, NULL, 0, 162, NULL, N'5132983000', N'5132987726', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 University Drive', N'West Chester', N'OH', N'39017', N'45069', 39.356815, -84.368234, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4246, N'Ohio Valley Medical Center Llc', 1, NULL, NULL, N'360355', NULL, NULL, 0, 24, NULL, N'9375213900', N'9375213910', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Main Street', N'Springfield', N'OH', N'39023', N'45502', 39.92477, -83.812885, 2737, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4247, N'Diley Ridge Medical Center', 1, NULL, NULL, N'360358', NULL, NULL, 0, 10, NULL, N'6148387910', N'6145464086', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7911 Diley Road', N'Canal Winchester', N'OH', N'39045', N'43110', 39.850053, -82.7811, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4248, N'University Hospitals Ahuja Medical Center', 1, NULL, NULL, N'360359', NULL, NULL, 0, 72, NULL, N'2165935510', N'2165935541', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3999 Richmond Road', N'Beachwood', N'OH', N'39035', N'44122', 41.453791, -81.497709, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4249, N'Soin Medical Center', 1, NULL, NULL, N'360360', NULL, NULL, 0, 95, NULL, N'9377024000', N'9377024011', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 Pentan Park Blvd', N'Beaver Creek', N'OH', N'39057', N'45431', 39.771927, -84.062588, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4250, N'Kings Daughters Medical Center Ohio', 1, NULL, NULL, N'360361', NULL, NULL, 0, 10, NULL, N'7409914000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Arnne Road', N'Portsmouth', N'OH', N'39145', N'45662', 38.747317, -82.993354, 2731, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4251, N'Trihealth Evendale Hospital', 1, NULL, NULL, N'360362', NULL, NULL, 0, 29, NULL, N'5134542222', N'5134542500', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3155 Glendale Milford Road', N'Cincinnati', N'OH', N'39061', N'45241', 39.253934, -84.420098, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4252, N'Select Specialty Hospital Youngstown (Boardman)', 1, NULL, NULL, N'360363', NULL, NULL, 0, 24, NULL, N'3307291750', N'3307291750', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8401 Market Street 7 South', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4253, N'Paulding County Hospital', 1, NULL, NULL, N'361300', NULL, NULL, 0, 25, NULL, N'4193994080', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035 West Wayne St.', N'Paulding', N'OH', N'39125', N'45879', 41.135287, -84.599991, 2727, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4254, N'Community Memorial Hospital', 1, NULL, NULL, N'361301', NULL, NULL, 0, 25, NULL, N'4195426692', N'4195426902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'208 N Columbus St', N'Hicksville', N'OH', N'39039', N'43526', 41.30031, -84.755974, 2691, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4255, N'Trinity Hospital Twin City', 1, NULL, NULL, N'361302', NULL, NULL, 0, 25, NULL, N'7409222800', N'7409226945', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'819 North First Street', N'Dennison', N'OH', N'39157', N'44621', 40.400994, -81.335905, 2675, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4256, N'Lodi Community Hospital', 1, NULL, NULL, N'361303', NULL, NULL, 0, 20, NULL, N'3309481222', N'3339485545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Elyria Street', N'Lodi', N'OH', N'39103', N'44254', 41.036371, -82.013656, 2699, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4257, N'Greenfield Area Medical Center', 1, NULL, NULL, N'361304', NULL, NULL, 0, 25, NULL, N'9379819400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Mirabeau Street', N'Greenfield', N'OH', N'39071', N'45123', 39.349333, -83.387588, 2688, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4258, N'Mercy Allen Hospital', 1, NULL, NULL, N'361306', NULL, NULL, 0, 25, NULL, N'4407751211', N'4407759147', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 West Lorain Street', N'Oberlin', N'OH', N'39093', N'44074', 41.29422, -82.224474, 2721, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4259, N'Uhhs Memorial Hospital Of Geneva', 1, NULL, NULL, N'361307', NULL, NULL, 0, 25, NULL, N'4404661141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'870 West Main Street', N'Geneva', N'OH', N'39007', N'44041', 41.800047, -80.962819, 2686, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4260, N'University Hospitals Conneaut Medical Center', 1, NULL, NULL, N'361308', NULL, NULL, 0, 25, NULL, N'4405931131', N'4405935050', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'158 West Main Road', N'Conneaut', N'OH', N'39007', N'44030', 41.936904, -80.587557, 2670, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4261, N'Henry County Hospital Inc', 1, NULL, NULL, N'361309', NULL, NULL, 0, 25, NULL, N'4195924015', N'4195913869', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 East Riverview Avenue', N'Napoleon', N'OH', N'39069', N'43545', 41.40969, -84.096552, 2717, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4262, N'Mercy Willard Hospital', 1, NULL, NULL, N'361310', NULL, NULL, 0, 15, NULL, N'4199645000', N'4199359506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Neal Zick Road', N'Willard', N'OH', N'39077', N'44890', 41.048589, -82.724, 2754, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4263, N'Harrison Community Hospital', 1, NULL, NULL, N'361311', NULL, NULL, 0, 25, NULL, N'7409424631', N'7409422749', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 East Market Street', N'Cadiz', N'OH', N'39067', N'43907', 40.257183, -80.978558, 2660, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4264, N'Mercy Memorial Hospital', 1, NULL, NULL, N'361312', NULL, NULL, 0, 25, NULL, N'9376535231', N'9374846105', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'904 Scioto Street', N'Urbana', N'OH', N'39021', N'43078', 40.106716, -83.729999, 2745, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4265, N'Morrow County Hospital', 1, NULL, NULL, N'361313', NULL, NULL, 0, 25, NULL, N'4199465015', N'4199493100', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 West Marion Road', N'Mount Gilead', N'OH', N'39117', N'43338', 40.549217, -82.849158, 2715, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4266, N'H B Magruder Memorial Hospital', 1, NULL, NULL, N'361314', NULL, NULL, 0, 15, NULL, N'4197343131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Fulton St', N'Port Clinton', N'OH', N'39123', N'43452', 41.505799, -82.933719, 2730, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4267, N'Hardin Memorial Hospital', 1, NULL, NULL, N'361315', NULL, NULL, 0, 25, NULL, N'4196730761', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 East Franklin Street', N'Kenton', N'OH', N'39065', N'43326', 40.645572, -83.595691, 2694, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4268, N'Bucyrus Community Hospital', 1, NULL, NULL, N'361316', NULL, NULL, 0, 15, NULL, N'4195624677', N'4195625598', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'629 North Sandusky Avenue', N'Bucyrus', N'OH', N'39033', N'44820', 40.815178, -82.975667, 2659, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4269, N'Fostoria Community Hospital', 1, NULL, NULL, N'361318', NULL, NULL, 0, 15, NULL, N'4194357734', N'4194366603', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Van Buren Street', N'Fostoria', N'OH', N'39147', N'44830', 41.163337, -83.423625, 2681, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4270, N'Selby General Hospital', 1, NULL, NULL, N'361319', NULL, NULL, 0, 25, NULL, N'7405682000', N'7405682089', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106 Colegate Drive', N'Marietta', N'OH', N'39167', N'45750', 39.438875, -81.444455, 2705, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4271, N'Holzer Medical Center Jackson', 1, NULL, NULL, N'361320', NULL, NULL, 0, 25, NULL, N'7403958500', N'7403958502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Burlington Road', N'Jackson', N'OH', N'39079', N'45640', 39.031781, -82.638081, 2684, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4272, N'Barnesville Hospital Association Inc', 1, NULL, NULL, N'361321', NULL, NULL, 0, 25, NULL, N'7404255101', N'7404259213', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'639 West Main Street', N'Barnesville', N'OH', N'39013', N'43713', 39.990324, -81.185446, 2650, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4273, N'Bluffton Hospital', 1, NULL, NULL, N'361322', NULL, NULL, 0, 25, NULL, N'4193589010', N'4193581532', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'139 Garau Street', N'Bluffton', N'OH', N'39003', N'45817', 40.88728, -83.897755, 2656, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4274, N'Aultman Orrville Hospital', 1, NULL, NULL, N'361323', NULL, NULL, 0, 25, NULL, N'3306823010', N'3306832130', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'832 South Main Street', N'Orrville', N'OH', N'39169', N'44667', 40.831918, -81.764584, 2723, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4275, N'Ohiohealth Medcentral Shelby Hospital', 1, NULL, NULL, N'361324', NULL, NULL, 0, 25, NULL, N'4193425015', N'4193421701', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'199 West Main Street', N'Shelby', N'OH', N'39139', N'44875', 40.881201, -82.674457, 2735, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4276, N'Galion Community Hospital', 1, NULL, NULL, N'361325', NULL, NULL, 0, 35, NULL, N'4194684841', N'4194682381', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'269 Portland Way South', N'Galion', N'OH', N'39033', N'44833', 40.730156, -82.803598, 2683, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4277, N'Adams County Regional Medical Center', 1, NULL, NULL, N'361326', NULL, NULL, 0, 25, NULL, N'9373863400', N'9373863019', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 Medical Center Drive', N'Seaman', N'OH', N'39001', N'45679', 38.934115, -83.585844, 2651, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4278, N'Community Hospitals And Wellness Centers', 1, NULL, NULL, N'361327', NULL, NULL, 0, 35, NULL, N'4194853154', N'4194853833', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 East Snyder Avenue', N'Montpelier', N'OH', N'39171', N'43543', 41.589326, -84.595168, 2658, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4279, N'Defiance Regional Medical Center', 1, NULL, NULL, N'361328', NULL, NULL, 0, 35, NULL, N'4197836955', N'4197836904', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Ralston Avenue', N'Defiance', N'OH', N'39039', N'43512', 41.299093, -84.372979, 2673, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4280, N'Wyandot Memorial Hospital', 1, NULL, NULL, N'361329', NULL, NULL, 0, 25, NULL, N'4192944991', N'4192942233', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'885 North Sandusky Avenue', N'Upper Sandusky', N'OH', N'39175', N'43351', 40.841884, -83.28072, 2744, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4281, N'Hocking Valley Community Hospital', 1, NULL, NULL, N'361330', NULL, NULL, 0, 25, NULL, N'7403808000', N'7403857458', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 State Route 664N', N'Logan', N'OH', N'39073', N'43138', 39.539871, -82.408489, 2700, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4282, N'Fayette County Memorial Hospital', 1, NULL, NULL, N'361331', NULL, NULL, 0, 25, NULL, N'7403331210', N'7403332998', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 Columbus Avenue', N'Washington Ch', N'OH', N'39047', N'43160', 39.548442, -83.425285, 2749, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4283, N'Highland District Hospital', 1, NULL, NULL, N'361332', NULL, NULL, 0, 35, NULL, N'9373936100', N'9373936278', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 North High Street', N'Hillsboro', N'OH', N'39071', N'45133', 39.221523, -83.608757, 2692, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4284, N'Fulton County Health Center', 1, NULL, NULL, N'361333', NULL, NULL, 0, 35, NULL, N'4193352015', N'4193302602', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 South Shoop Avenue', N'Wauseon', N'OH', N'39051', N'43567', 41.539239, -84.134283, 2750, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4285, N'Adena Pike Medical Center', 1, NULL, NULL, N'361334', NULL, NULL, 0, 25, NULL, N'7409472186', N'7409476538', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Dawn Lane', N'Waverly', N'OH', N'39131', N'45690', 39.116363, -83.005839, 2751, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4286, N'Glenmont', 1, NULL, NULL, N'361991', NULL, NULL, 0, 37, NULL, N'6148760084', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4599 Avery Road', N'Hilliard', N'OH', N'39049', N'43026', 40.033814, -83.159611, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4287, N'Drake Center Inc', 1, NULL, NULL, N'362004', NULL, NULL, 0, 108, NULL, N'5134182500', N'5134185979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 West Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45216', 39.212871, -84.475489, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4288, N'Elmwood Healthcare Center At The Springs', 1, NULL, NULL, N'362007', NULL, NULL, 0, 36, NULL, N'4196392626', N'4196396225', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 North Broadway Street', N'Green Springs', N'OH', N'39147', N'44836', 41.256165, -83.051583, 2682, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4289, N'Heather Hill Care Communities', 1, NULL, NULL, N'362014', NULL, NULL, 0, 56, NULL, N'4402792443', N'4402850946', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12340 Bass Lake Road', N'Chardon', N'OH', N'39055', N'44024', 41.582466, -81.20334, 2663, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4290, N'Grace Hospital', 1, NULL, NULL, N'362015', NULL, NULL, 0, 104, NULL, N'2164563891', N'2164568981', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2307 West 14Th Street', N'Cleveland', N'OH', N'39035', N'44113', 41.4805, -81.691246, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4291, N'Select Specialty Hospital-Northeast Ohio Inc', 1, NULL, NULL, N'362016', NULL, NULL, 0, 61, NULL, N'3304898198', N'3304898199', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1320 Mercy Drive 6Th Floor', N'Canton', N'OH', N'39151', N'44708', 40.8121381, -81.3984577, 2662, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4292, N'Select Specialty Hospital-Cincinnati Inc', 1, NULL, NULL, N'362019', NULL, NULL, 0, 36, NULL, N'5138624444', N'5138624437', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'375 Dixmyth Ave 15Th Floor', N'Cincinnati', N'OH', N'39061', N'45220', 39.140039, -84.5228614, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4293, N'Kindred Hospital Lima', 1, NULL, NULL, N'362020', NULL, NULL, 0, 12, NULL, N'4192241888', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 W Market St', N'Lima', N'OH', N'39003', N'45801', 40.74011, -84.117329, 2698, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4294, N'Kindred Hospital Central Ohio', 1, NULL, NULL, N'362021', NULL, NULL, 0, 33, NULL, N'4195260777', N'4195260929', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Glessner Avenue 5Th Floor', N'Mansfield', N'OH', N'39139', N'44903', 40.752672, -82.528789, 2704, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4295, N'Select Specialty Hospital-Columbus Inc', 1, NULL, NULL, N'362022', NULL, NULL, 0, 186, NULL, N'6144589000', N'6144589003', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1087 Dennison Avenue 2Nd Floor', N'Columbus', N'OH', N'39049', N'43201', 39.98438, -83.0110513, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4296, N'Vibra Hospital Of Mahoning Valley', 1, NULL, NULL, N'362023', NULL, NULL, 0, 45, NULL, N'3307265021', N'3307265053', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8049 South Avenue', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4297, N'Select Specialty Hospital - Youngstown', 1, NULL, NULL, N'362024', NULL, NULL, 0, 31, NULL, N'3308414750', N'3308414761', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Belmont Ave', N'Youngstown', N'OH', N'39099', N'44501', 41.114112, -80.655807, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4298, N'Community Specialty Hospital', 1, NULL, NULL, N'362025', NULL, NULL, 0, 30, NULL, N'4409886141', N'4402452197', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'254 Cleveland Avenue 2Nd Floor', N'Amherst', N'OH', N'39093', N'44001', 41.399692, -82.224058, 2702, 214, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4299, N'Kindred Hospital', 1, NULL, NULL, N'362026', NULL, NULL, 0, 119, NULL, N'2169838030', N'2165922831', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11900 Fairhill Road', N'Cleveland', N'OH', N'39035', N'44120', 41.492924, -81.599316, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4300, N'Select Specialty Hospital-Akron', 1, NULL, NULL, N'362027', NULL, NULL, 0, 34, NULL, N'3307617500', N'3307617555', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 East Market Street', N'Akron', N'OH', N'39153', N'44308', 41.083122, -81.511237, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4301, N'Life Care Hospitals Of Dayton', 1, NULL, NULL, N'362028', NULL, NULL, 0, 33, NULL, N'9373848300', N'9373848399', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Miamisburg-Centerville Road', N'Miamisburg', N'OH', N'39113', N'45342', 39.640134, -84.234441, 2695, 215, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4302, N'Regency Hospital Of Cleveland East', 1, NULL, NULL, N'362029', NULL, NULL, 0, 142, NULL, N'3308612065', N'3308969546', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Interchange Corporate Center Road', N'Warrensville Hts', N'OH', N'39035', N'44128', 41.435054, -81.536233, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4303, N'Select Specialty Hospital Southeast Ohio', 1, NULL, NULL, N'362031', NULL, NULL, 0, 35, NULL, N'7405887888', N'7405887856', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Tamarack Road 2Nd Floor', N'Newark', N'OH', N'39089', N'43055', 40.038769, -82.463785, 2719, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4304, N'Acute Care Specialty Hospital - Aultman', 1, NULL, NULL, N'362032', NULL, NULL, 0, 30, NULL, N'3303634000', N'3303634001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Sixth Street', N'Canton', N'OH', N'39151', N'44710', 40.798952, -81.378444, 2662, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4305, N'Kindred Hospitals-Dayton', 1, NULL, NULL, N'362033', NULL, NULL, 0, 67, NULL, N'9373319265', N'9373319275', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 East Edwin C Moses Blvd', N'Dayton', N'OH', N'39113', N'45417', 39.757485, -84.206969, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4306, N'Regency Hospital Of Cincinnati Llc', 1, NULL, NULL, N'362034', NULL, NULL, 0, 39, NULL, N'5135595957', N'5135595952', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10500 Montmery Road', N'Cincinnati', N'OH', N'39061', N'45219', 39.2520892, -84.3432676, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4307, N'Acuity Specialty Ohio Valley', 1, NULL, NULL, N'362035', NULL, NULL, 0, 72, NULL, N'7402837499', N'7402837452', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 Summit Avenue 3Rd Floor', N'Steubenville', N'OH', N'39081', N'43952', 40.356129, -80.625016, 2739, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4308, N'Regency Hospital Of Toledo', 1, NULL, NULL, N'362036', NULL, NULL, 0, 45, NULL, N'4193185700', N'4198826090', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5220 West Alexis Road', N'Sylvania', N'OH', N'39095', N'43560', 41.715158, -83.686587, 2740, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4309, N'Select Specialty Hospital Columbus', 1, NULL, NULL, N'362037', NULL, NULL, 0, 43, NULL, N'6144560339', N'6144459520', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1430 South High Street', N'Columbus', N'OH', N'39049', N'43207', 39.932896, -82.995812, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4310, N'Advanced Specialty Hospital Of Toledo', 1, NULL, NULL, N'362038', NULL, NULL, 0, 40, NULL, N'4193810037', N'4193813990', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Garden Lake Parkway', N'Toledo', N'OH', N'39095', N'43614', 41.678675, -83.512728, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4311, N'Life Line Hospital', 1, NULL, NULL, N'362039', NULL, NULL, 0, 36, NULL, N'7403462600', N'7403462601', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 School Street', N'Wintersville', N'OH', N'39081', N'43953', 40.372955, -80.699673, 2739, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4312, N'Hillside Rehabilitation Hospital', 1, NULL, NULL, N'363026', NULL, NULL, 0, 120, NULL, N'3308413700', N'3308845735', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8747 Squires Lane Ne', N'Warren', N'OH', N'39155', N'44484', 41.237557, -80.818417, 2748, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4313, N'Greenbriar Rehabilitation Hospital', 1, NULL, NULL, N'363032', NULL, NULL, 0, 29, NULL, N'3309656432', N'3309656438', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8064 South Avenue Suite One', N'Boardman', N'OH', N'39099', N'44512', 41.024226, -80.662853, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4314, N'Reliant Rehabilitation Hospital Dayton', 1, NULL, NULL, N'363033', NULL, NULL, 0, 50, NULL, N'9374248200', N'9372227726', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place', N'Dayton', N'OH', N'39113', N'45408', 39.758948, -84.191607, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4315, N'Healthsouth Rehabilitation Hospital At Drake', 1, NULL, NULL, N'363034', NULL, NULL, 0, 60, NULL, N'5134185600', N'5134185699', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'151 West Galbraith Road', N'Cincinnati', N'OH', N'39061', N'45216', 39.212871, -84.475489, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4316, N'Summa Rehab Hospital', 1, NULL, NULL, N'363035', NULL, NULL, 0, 60, NULL, N'3305727300', N'3305727310', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'29 North Adams Street', N'Akron', N'OH', N'39153', N'44304', 41.078642, -81.498418, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4317, N'University Hospitals Rehabilitation Hospital', 1, NULL, NULL, N'363036', NULL, NULL, 0, 50, NULL, N'2165932200', N'2165932270', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23333 Harvard Road', N'Beachwood', N'OH', N'39035', N'44122', 41.449848, -81.499245, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4318, N'Ohiohealth Rehabilitation Hospital', 1, NULL, NULL, N'363037', NULL, NULL, 0, 44, NULL, N'6144589496', N'6144589497', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1087 Dennison Avenue 4Th Floor', N'Columbus', N'OH', N'39049', N'43201', 39.983971, -83.008502, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4319, N'Cincinnati Children''s Hospital Medical Center', 1, NULL, NULL, N'363300', NULL, NULL, 0, 523, NULL, N'5136363333', N'5136367194', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Burnet Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.14102, -84.500494, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4320, N'Rainbow Babies And Childrens Hospital', 1, NULL, NULL, N'363302', NULL, NULL, 0, 244, NULL, N'2168441000', N'2168447625', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.505776, -81.606069, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4321, N'Akron Children''s Hospital', 1, NULL, NULL, N'363303', NULL, NULL, 0, 253, NULL, N'3305431000', N'3305433008', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Perkins Square', N'Akron', N'OH', N'39153', N'44308', 41.083064, -81.518485, 2644, 208, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4322, N'Cleveland Clinic Children''s Hospital For Rehab', 1, NULL, NULL, N'363304', NULL, NULL, 0, 52, NULL, N'2167216400', N'2164486244', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Martin Luther King Jr Drive', N'Cleveland', N'OH', N'39035', N'44104', 41.481624, -81.609657, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4323, N'Nationwide Children''s Hospital', 1, NULL, NULL, N'363305', NULL, NULL, 0, 378, NULL, N'6147222000', N'6147225995', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Children''s Drive', N'Columbus', N'OH', N'39049', N'43205', 39.96226, -83.000706, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4324, N'Dayton Children''s Hospital', 1, NULL, NULL, N'363306', NULL, NULL, 0, 155, NULL, N'9376413450', N'9376415400', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Childrens Plaza', N'Dayton', N'OH', N'39113', N'45404', 39.758948, -84.191607, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4325, N'Shriners Hospitals For Children - Cincinnati', 1, NULL, NULL, N'363308', NULL, NULL, 0, 30, NULL, N'5138726000', N'5138726999', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3229 Burnett Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.101454, -84.51246, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4326, N'Twin Valley Behavioral Healthcare', 1, NULL, NULL, N'364007', NULL, NULL, 0, 176, NULL, N'6147520333', N'6147520087', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 West Broad Street', N'Columbus', N'OH', N'39049', N'43223', 39.96226, -83.000706, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4327, N'Northcoast Behavioral Healthcare Northfield Campus', 1, NULL, NULL, N'364011', NULL, NULL, 0, 260, NULL, N'3304677131', N'3304672420', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1756 Sagamore Road', N'Northfield', N'OH', N'39153', N'44067', 41.345055, -81.528452, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4328, N'Northwest Ohio Psychiatric Hospital', 1, NULL, NULL, N'364014', NULL, NULL, 0, 114, NULL, N'4193811881', N'4193895971', 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 South Detroit Avenue', N'Toledo', N'OH', N'39095', N'43614', 41.6225, -83.597213, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4329, N'Appalachian Behavioral Health Care', 1, NULL, NULL, N'364015', NULL, NULL, 0, 40, NULL, N'6145945000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Athens', N'OH', N'39009', N'45701', 39.327798, -82.115116, 2648, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4330, N'Cambridge Behavorial Hospital', 1, NULL, NULL, N'364027', NULL, NULL, 0, 44, NULL, N'7404324906', N'7404325082', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'66755 State Street', N'Cambridge', N'OH', N'39059', N'43725', 40.031183, -81.588456, 2661, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4331, N'Windsor Laurelwood Center For Behavorial Medicine', 1, NULL, NULL, N'364029', NULL, NULL, 0, 160, NULL, N'4409533000', N'4409533938', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'35900 Euclid Avenue', N'Willoughby', N'OH', N'39085', N'44094', 41.632956, -81.411951, 2725, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4332, N'Heartland Behavioral Healthcare', 1, NULL, NULL, N'364031', NULL, NULL, 0, 212, NULL, N'3308333135', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Erie Sw', N'Massillon', N'OH', N'39151', N'44648', 40.796724, -81.521509, 2709, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4333, N'Summit Behavioral Healthcare', 1, NULL, NULL, N'364035', NULL, NULL, 0, 291, NULL, N'5139483600', N'5139483080', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1101 Summit Road', N'Cincinnati', N'OH', N'39061', N'45237', 39.194558, -84.47371, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4334, N'Arrowhead Behavioral Health', 1, NULL, NULL, N'364036', NULL, NULL, 0, 42, NULL, N'4198919333', N'4198919330', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1725 Timber Line Road', N'Maumee', N'OH', N'39095', N'43537', 41.562829, -83.653824, 2710, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4335, N'Belmont Pines Hospital', 1, NULL, NULL, N'364038', NULL, NULL, 0, 46, NULL, N'3307592700', N'3307592776', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Churchill-Hubbard Rd', N'Youngstown', N'OH', N'39099', N'44505', 41.09978, -80.649519, 2758, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4336, N'Ohio Hospital For Psychiatry', 1, NULL, NULL, N'364041', NULL, NULL, 0, 78, NULL, N'6144499664', N'6144447919', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'880 Greenlawn Avenue', N'Columbus', N'OH', N'39049', N'43223', 39.939397, -82.997588, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4337, N'Ten Lakes Center Llc', 1, NULL, NULL, N'364042', NULL, NULL, 0, 14, NULL, N'7409227499', N'7409227498', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'819 North First Street 3Rd Floor', N'Dennison', N'OH', N'39157', N'44621', 40.4014458, -81.3387723, 2675, 209, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4338, N'Lindner Center Of Hope', 1, NULL, NULL, N'364044', NULL, NULL, 0, 32, NULL, N'5135364673', N'5135360309', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4075 Old Western Row Road', N'Mason', N'OH', N'39165', N'45040', 39.33677, -84.293579, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4339, N'Pomegranate Health Systems Of Columbus', 1, NULL, NULL, N'364045', NULL, NULL, 0, 10, NULL, N'6142231650', N'8887277834', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'765 Pierce Drive', N'Columbus', N'OH', N'39049', N'43223', 39.946989, -83.018957, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4340, N'Ridgeview Hospital', 1, NULL, NULL, N'364047', NULL, NULL, 0, 86, NULL, N'4199682950', N'4199682956', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17872 Lincoln Highway', N'Middle Point', N'OH', N'39161', N'45863', 40.855605, -84.447175, 2746, 95, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4341, N'Haven Behavioral Senior Care Of Dayton', 1, NULL, NULL, N'364048', NULL, NULL, 0, 32, NULL, N'6152509500', N'6152509515', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Elizabeth Place E3 Suite A', N'Dayton', N'OH', N'39113', N'45417', 39.758948, -84.191607, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4342, N'Dublin Springs', 1, NULL, NULL, N'364049', NULL, NULL, 0, 48, NULL, N'6147171800', N'6147171801', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7625 Hospital Drive', N'Dublin', N'OH', N'39049', N'43016', 40.102197, -83.161896, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4343, N'Access Hospital Dayton Llc', 1, NULL, NULL, N'364050', NULL, NULL, 0, 110, NULL, N'9372567801', N'9372567811', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2611 Wayne Avenue', N'Dayton', N'OH', N'39113', N'45420', 39.7361411, -84.1557956, 2672, 213, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4344, N'Beckett Springs', 1, NULL, NULL, N'364051', NULL, NULL, 0, 48, NULL, N'5139429500', N'5139429501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8614 Shepherd Farm Drive', N'West Chester', N'OH', N'39017', N'45069', 40.19695, -81.352755, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4345, N'Clear Vista Health & Wellness', 1, NULL, NULL, N'364052', NULL, NULL, 0, 30, NULL, N'4402822244', N'4402827709', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3364 Kolbe Road', N'Lorain', N'OH', N'39093', N'44053', 41.438434, -82.235425, 2702, 214, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4346, N'Cleveland Clinic Transplant Center', 1, NULL, NULL, N'369801', NULL, NULL, 0, 0, NULL, N'2164442200', N'2166363333', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9500 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.502571, -81.62085, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4347, N'Ohio State University Hospitals', 1, NULL, NULL, N'369803', NULL, NULL, 0, 0, NULL, N'6142938000', N'6142933535', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'410 West 10Th Avenue', N'Columbus', N'OH', N'39049', N'43210', 39.995752, -83.017717, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4348, N'University Of Cincinnati Medical Center', 1, NULL, NULL, N'369804', NULL, NULL, 0, 0, NULL, N'5135841000', N'5135840526', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'234 odman Street', N'Cincinnati', N'OH', N'39061', N'45267', 39.136894, -84.503934, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4349, N'University Of Toledo Medical Center', 1, NULL, NULL, N'369805', NULL, NULL, 0, 0, NULL, N'4193833413', N'4193833850', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3000 Arlington Ave', N'Toledo', N'OH', N'39095', N'43614', 41.621362, -83.615671, 2742, 216, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4350, N'Cincinnati Children''s Hospital Medical Center', 1, NULL, NULL, N'369806', NULL, NULL, 0, 0, NULL, N'5136363333', N'5136367194', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3333 Burnet Avenue', N'Cincinnati', N'OH', N'39061', N'45229', 39.14102, -84.500494, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4351, N'University Hospitals Case Medical Center', 1, NULL, NULL, N'369807', NULL, NULL, 0, 0, NULL, N'2168447064', N'2169832053', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'11100 Euclid Avenue', N'Cleveland', N'OH', N'39035', N'44106', 41.505776, -81.606069, 2667, 211, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4352, N'Nationwide Children''s Hospital', 1, NULL, NULL, N'369810', NULL, NULL, 0, 0, NULL, N'6147226592', N'6147223837', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'700 Children''s Drive', N'Columbus', N'OH', N'39049', N'43205', 39.96226, -83.000706, 2669, 212, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4353, N'Christ Hospital - Transplant', 1, NULL, NULL, N'369811', NULL, NULL, 0, 0, NULL, N'5135852771', N'5135853300', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2139 Auburn Avenue 5Th Floor', N'Cincinnati', N'OH', N'39061', N'45219', 39.121025, -84.508619, 2665, 210, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4354, N'Hillcrest Medical Center', 1, NULL, NULL, N'370001', NULL, NULL, 0, 686, NULL, N'9185791000', N'9185840840', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 South Utica Avenue', N'Tulsa', N'OK', N'40143', N'74104', 36.147164, -95.967141, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4355, N'Alliancehealth Woodward', 1, NULL, NULL, N'370002', NULL, NULL, 0, 87, NULL, N'5802548492', N'5802548418', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 17Th Street', N'Woodward', N'OK', N'40153', N'73801', 36.437636, -99.400957, 2840, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4356, N'Integris Baptist Regional Health Center', 1, NULL, NULL, N'370004', NULL, NULL, 0, 117, NULL, N'9185426611', N'9185407605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Second Avenue Southwest', N'Miami', N'OK', N'40115', N'74355', 36.872154, -94.879772, 2804, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4357, N'Alliancehealth Ponca City', 1, NULL, NULL, N'370006', NULL, NULL, 0, 140, NULL, N'5807653301', N'5807650341', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 North 14Th Street', N'Ponca City', N'OK', N'40071', N'74601', 36.725143, -97.067257, 2815, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4358, N'Newman Memorial Hospital', 1, NULL, NULL, N'370007', NULL, NULL, 0, 79, NULL, N'5809382551', N'5809382309', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 South Main Street', N'Shattuck', N'OK', N'40045', N'73858', 36.267876, -99.881536, 2824, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4359, N'Norman Regional Hospital Authority', 1, NULL, NULL, N'370008', NULL, NULL, 0, 450, NULL, N'4053211700', N'4053071076', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 North Porter', N'Norman', N'OK', N'40027', N'73070', 35.229624, -97.441116, 2807, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4360, N'Mercy Hospital El Reno Inc', 1, NULL, NULL, N'370011', NULL, NULL, 0, 54, NULL, N'4052622640', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2115 Parkview Drive', N'El Reno', N'OK', N'40017', N'73036', 35.530876, -97.978628, 2783, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4361, N'Mercy Hospital Oklahoma City Inc', 1, NULL, NULL, N'370013', NULL, NULL, 0, 369, NULL, N'4057523754', N'4057523811', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73120', 35.609026, -97.599625, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4362, N'Alliancehealth Durant', 1, NULL, NULL, N'370014', NULL, NULL, 0, 148, NULL, N'4059243080', N'5809240422', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 University Boulevard', N'Durant', N'OK', N'40013', N'74702', 34.004904, -96.39518, 2781, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4363, N'Alliancehealth Pryor', 1, NULL, NULL, N'370015', NULL, NULL, 0, 52, NULL, N'9188251600', N'9188246316', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 North Bailey Street', N'Pryor', N'OK', N'40097', N'74361', 36.308178, -95.305387, 2818, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4364, N'Integris Bass Baptist Health Center', 1, NULL, NULL, N'370016', NULL, NULL, 0, 183, NULL, N'5802332300', N'5802338802', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Monroe', N'Enid', N'OK', N'40047', N'73701', 36.39087, -97.886522, 2785, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4365, N'Jane Phillips Memorial Medical Center Inc', 1, NULL, NULL, N'370018', NULL, NULL, 0, 140, NULL, N'9183337200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 East Frank Phillips Boulevard', N'Bartlesville', N'OK', N'40147', N'74006', 36.750674, -95.939698, 2767, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4366, N'Great Plains Regional Medical Center', 1, NULL, NULL, N'370019', NULL, NULL, 0, 62, NULL, N'5802252511', N'5802259143', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 West 3Rd Street', N'Elk City', N'OK', N'40009', N'73644', 35.411721, -99.42552, 2784, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4367, N'Mercy Hospital Ada', 1, NULL, NULL, N'370020', NULL, NULL, 0, 156, NULL, N'5803322323', N'5804216060', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 North Monte Vista', N'Ada', N'OK', N'40123', N'74820', 34.782824, -96.63476, 2760, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4368, N'Jackson County Memorial Hospital Authority', 1, NULL, NULL, N'370022', NULL, NULL, 0, 99, NULL, N'5803795000', N'5804812345', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 East Pecan St', N'Altus', N'OK', N'40065', N'73523', 34.635274, -99.319118, 2761, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4369, N'Duncan Regional Hospital Inc', 1, NULL, NULL, N'370023', NULL, NULL, 0, 145, NULL, N'5802525300', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1407 Whisenant Drive', N'Duncan', N'OK', N'40137', N'73533', 34.520012, -97.975031, 2780, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4370, N'Eastar Health System', 1, NULL, NULL, N'370025', NULL, NULL, 0, 325, NULL, N'9186825501', N'9186842552', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Rockefeller Drive', N'Muskogee', N'OK', N'40101', N'74401', 35.753828, -95.406221, 2806, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4371, N'St Mary''s Regional Medical Center', 1, NULL, NULL, N'370026', NULL, NULL, 0, 229, NULL, N'5802336100', N'5802493790', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 South 5Th Street', N'Enid', N'OK', N'40047', N'73701', 36.393907, -97.871777, 2785, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4372, N'Integris Baptist Medical Center', 1, NULL, NULL, N'370028', NULL, NULL, 0, 629, NULL, N'4059518110', N'4059493573', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Northwest Expressway', N'Oklahoma City', N'OK', N'40109', N'73112', 35.52996, -97.57455, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4373, N'Alliancehealth Clinton', 1, NULL, NULL, N'370029', NULL, NULL, 0, 66, NULL, N'5803232363', N'5803238369', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North 30Th Street', N'Clinton', N'OK', N'40039', N'73601', 35.51455, -98.996879, 2775, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4374, N'Alliancehealth Blackwell', 1, NULL, NULL, N'370030', NULL, NULL, 0, 53, NULL, N'5803632311', N'5803632339', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 South 13Th Street', N'Blackwell', N'OK', N'40071', N'74631', 36.798433, -97.300883, 2769, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4375, N'Alliancehealth Deaconess', 1, NULL, NULL, N'370032', NULL, NULL, 0, 238, NULL, N'4056046109', N'4056046153', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 North Portland Avenue', N'Oklahoma City', N'OK', N'40109', N'73112', 35.525314, -97.583433, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4376, N'Mcalester Regional Health Center Authority', 1, NULL, NULL, N'370034', NULL, NULL, 0, 187, NULL, N'9184261800', N'9184218066', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Clark Bass Boulevard', N'Mcalester', N'OK', N'40121', N'74501', 34.933498, -95.769793, 2803, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4377, N'Harmon Memorial Hospital', 1, NULL, NULL, N'370036', NULL, NULL, 0, 31, NULL, N'5806883363', N'5806889730', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Chestnut Street', N'Hollis', N'OK', N'40057', N'73550', 34.69154, -99.91489, 2795, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4378, N'St Anthony Hospital', 1, NULL, NULL, N'370037', NULL, NULL, 0, 686, NULL, N'4052727000', N'4052726592', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Lee Avenue', N'Oklahoma City', N'OK', N'40109', N'73101', 35.477263, -97.524298, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4379, N'Hillcrest Hospital Claremore', 1, NULL, NULL, N'370039', NULL, NULL, 0, 81, NULL, N'9183412556', N'9183423330', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1202 N Muskogee Place', N'Claremore', N'OK', N'40131', N'74017', 36.321875, -95.605333, 2774, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4380, N'Eastern Oklahoma Medical Center', 1, NULL, NULL, N'370040', NULL, NULL, 0, 59, NULL, N'9186478161', N'9186353308', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Wall Street', N'Poteau', N'OK', N'40079', N'74953', 35.04457, -94.612129, 2816, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4381, N'Bristow Medical Center', 1, NULL, NULL, N'370041', NULL, NULL, 0, 30, NULL, N'9183672215', N'9183679190', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W. 7Th Street', N'Bristow', N'OK', N'40037', N'74010', 35.832843, -96.401424, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4382, N'Mercy Hospital Ardmore Inc', 1, NULL, NULL, N'370047', NULL, NULL, 0, 190, NULL, N'5802235400', N'5802206580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Fourteenth Avenue Northwest', N'Ardmore', N'OK', N'40019', N'73401', 34.188462, -97.141292, 2765, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4383, N'Mccurtain Memorial Hospital', 1, NULL, NULL, N'370048', NULL, NULL, 0, 91, NULL, N'5802867623', N'5802083199', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Lincoln Road', N'Idabel', N'OK', N'40089', N'74745', 33.880912, -94.810985, 2796, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4384, N'Stillwater Medical Center', 1, NULL, NULL, N'370049', NULL, NULL, 0, 117, NULL, N'4053721480', N'4057425631', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1323 West 6Th Street', N'Stillwater', N'OK', N'40119', N'74076', 36.115631, -97.058572, 2827, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4385, N'Memorial Hospital & Physician Group', 1, NULL, NULL, N'370051', NULL, NULL, 0, 37, NULL, N'5803357565', N'5803357329', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'319 East Josephine', N'Frederick', N'OK', N'40141', N'73542', 34.403304, -99.013425, 2789, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4386, N'Grady Memorial Hospital', 1, NULL, NULL, N'370054', NULL, NULL, 0, 99, NULL, N'4052242300', N'4057792413', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Iowa Street', N'Chickasha', N'OK', N'40051', N'73018', 35.047699, -97.961786, 2773, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4387, N'Comanche County Memorial Hospital', 1, NULL, NULL, N'370056', NULL, NULL, 0, 283, NULL, N'5803558620', N'5805855458', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 West re Blvd', N'Lawton', N'OK', N'40031', N'73505', 34.608969, -98.434497, 2798, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4388, N'Muscogee (Creek) Nation Medical Center', 1, NULL, NULL, N'370057', NULL, NULL, 0, 66, NULL, N'9187564233', N'9187565968', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Morris Drive', N'Okmulgee', N'OK', N'40111', N'74447', 35.610384, -95.953304, 2810, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4389, N'Craig General Hospital', 1, NULL, NULL, N'370065', NULL, NULL, 0, 62, NULL, N'9182567551', N'9182567395', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'735 North Foreman', N'Vinita', N'OK', N'40035', N'74301', 36.653172, -95.155757, 2833, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4390, N'Latimer County General Hospital', 1, NULL, NULL, N'370072', NULL, NULL, 0, 33, NULL, N'9184652391', N'9184653755', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'806 State Highway 2 North', N'Wilburton', N'OK', N'40077', N'74578', 34.919562, -95.319475, 2839, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4391, N'Oklahoma State University Medical Center', 1, NULL, NULL, N'370078', NULL, NULL, 0, 249, NULL, N'9185991000', N'9185991750', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'744 West 9Th Street', N'Tulsa', N'OK', N'40113', N'74127', 36.146836, -96.000119, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4392, N'Share Medical Center', 1, NULL, NULL, N'370080', NULL, NULL, 0, 25, NULL, N'5803272800', N'5804303332', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Share Drive', N'Alva', N'OK', N'40151', N'73717', 36.786911, -98.669116, 2762, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4393, N'Pushmataha County Town Of Antlers Hospital', 1, NULL, NULL, N'370083', NULL, NULL, 0, 23, NULL, N'5802983341', N'5802984713', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 East Main Street', N'Antlers', N'OK', N'40127', N'74523', 34.231717, -95.615603, 2764, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4394, N'Northeastern Health System', 1, NULL, NULL, N'370089', NULL, NULL, 0, 100, NULL, N'9184560641', N'9184568886', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 East Downing Street', N'Tahlequah', N'OK', N'40021', N'74465', 35.915326, -94.950558, 2830, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4395, N'Saint Francis Hospital Inc', 1, NULL, NULL, N'370091', NULL, NULL, 0, 962, NULL, N'9184942200', N'9184942475', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6161 South Yale', N'Tulsa', N'OK', N'40143', N'74136', 36.075107, -95.92209, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4396, N'O U Medical Center', 1, NULL, NULL, N'370093', NULL, NULL, 0, 750, NULL, N'4052715911', N'4052716753', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Ne 13Th Street', N'Oklahoma City', N'OK', N'40109', N'73104', 35.482317, -97.501002, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4397, N'Alliancehealth Midwest', 1, NULL, NULL, N'370094', NULL, NULL, 0, 255, NULL, N'4056108585', N'4056101380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2825 Parklawn Drive', N'Midwest City', N'OK', N'40109', N'73110', 35.466527, -97.392925, 2805, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4398, N'Southwestern Medical Center', 1, NULL, NULL, N'370097', NULL, NULL, 0, 199, NULL, N'5805314700', N'5805314702', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5602 Southwest Lee Boulevard', N'Lawton', N'OK', N'40031', N'73505', 34.594383, -98.46334, 2798, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4399, N'Hillcrest Hospital Cushing', 1, NULL, NULL, N'370099', NULL, NULL, 0, 99, NULL, N'9182252915', N'9182256550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1027 East Cherry Street', N'Cushing', N'OK', N'40119', N'74023', 35.978942, -96.757446, 2778, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4400, N'Choctaw Memorial Hospital', 1, NULL, NULL, N'370100', NULL, NULL, 0, 34, NULL, N'5803179500', N'5803263541', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 East Kirk Road', N'Hu', N'OK', N'40023', N'74743', 34.011639, -95.49715, 3352, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4401, N'Sayre Memorial Hospital Inc', 1, NULL, NULL, N'370103', NULL, NULL, 0, 46, NULL, N'5809285541', N'5809283523', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 Hospital Drive', N'Sayre', N'OK', N'40009', N'73662', 35.313047, -99.623658, 2822, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4402, N'Integris Southwest Medical Center', 1, NULL, NULL, N'370106', NULL, NULL, 0, 389, NULL, N'4056367000', N'4056367702', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 South Western Avenue', N'Oklahoma City', N'OK', N'40109', N'73109', 35.421153, -97.530211, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4403, N'Sequoyah County City Of Sallisaw Hospital Authorit', 1, NULL, NULL, N'370112', NULL, NULL, 0, 41, NULL, N'9187741100', N'9187741103', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'213 East Redwood', N'Sallisaw', N'OK', N'40135', N'74955', 35.46343, -94.78885, 2820, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4404, N'Integris Grove Hospital', 1, NULL, NULL, N'370113', NULL, NULL, 0, 58, NULL, N'9187862243', N'9187873643', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 East 18Th Street', N'Grove', N'OK', N'40041', N'74344', 36.593686, -94.769119, 2790, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4405, N'St John Medical Center Inc', 1, NULL, NULL, N'370114', NULL, NULL, 0, 703, NULL, N'9187443606', N'9187442357', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1923 South Utica Avenue', N'Tulsa', N'OK', N'40143', N'74104', 36.134235, -95.967236, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4406, N'Memorial Hospital Of Texas County', 1, NULL, NULL, N'370138', NULL, NULL, 0, 47, NULL, N'5803386515', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 Medical Drive', N'Guymon', N'OK', N'40139', N'73942', 36.690725, -101.475105, 2792, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4407, N'Perry Memorial Hospital Authority', 1, NULL, NULL, N'370139', NULL, NULL, 0, 26, NULL, N'5803363541', N'5803367209', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Fourteenth Street', N'Perry', N'OK', N'40103', N'73077', 36.28848, -97.299223, 2814, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4408, N'St Anthony Shawnee Hospital', 1, NULL, NULL, N'370149', NULL, NULL, 0, 102, NULL, N'4052732270', N'4058788101', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 W Macarthur', N'Shawnee', N'OK', N'40125', N'74804', 35.361768, -96.937639, 2825, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4409, N'Elkview General Hospital', 1, NULL, NULL, N'370153', NULL, NULL, 0, 38, NULL, N'5807263324', N'5807266041', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'429 West Elm Street', N'Hobart', N'OK', N'40075', N'73651', 35.036817, -99.097454, 2793, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4410, N'Pauls Valley Hospital Authority', 1, NULL, NULL, N'370156', NULL, NULL, 0, 64, NULL, N'4052385501', N'4052385926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Valley Drive', N'Pauls Valley', N'OK', N'40049', N'73075', 34.720109, -97.212899, 2811, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4411, N'Purcell Municipal Hospital', 1, NULL, NULL, N'370158', NULL, NULL, 0, 39, NULL, N'4055276524', N'4055273529', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 North Green Avenue', N'Purcell', N'OK', N'40087', N'73080', 35.027832, -97.365655, 2819, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4412, N'Waner Community Hospital', 1, NULL, NULL, N'370166', NULL, NULL, 0, 100, NULL, N'9184855514', N'9184859994', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Cherokee Street', N'Waner', N'OK', N'40145', N'74467', 35.959911, -95.392377, 2834, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4413, N'Jeay Medical Services Llc', 1, NULL, NULL, N'370169', NULL, NULL, 0, 33, NULL, N'9186892535', N'9186897285', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Drive', N'Eufaula', N'OK', N'40091', N'74432', 35.292843, -95.595568, 2786, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4414, N'Usphs Lawton Indian Hospital', 1, NULL, NULL, N'370170', NULL, NULL, 0, 26, NULL, N'5803545000', N'5803545105', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Lawrie Tatum Road', N'Lawton', N'OK', N'40031', N'73507', 34.625985, -98.385763, 2798, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4415, N'W W Hastings Indian Hospital', 1, NULL, NULL, N'370171', NULL, NULL, 0, 60, NULL, N'9184583100', N'9184583365', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 S Bliss Avenue', N'Tahlequah', N'OK', N'40021', N'74464', 35.915313, -94.948925, 2830, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4416, N'Choctaw Nation Health Services Authority', 1, NULL, NULL, N'370172', NULL, NULL, 0, 44, NULL, N'9185677000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Choctaw Way', N'Talihina', N'OK', N'40077', N'74571', 34.753721, -95.081906, 2816, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4417, N'Claremore Indian Hospital', 1, NULL, NULL, N'370173', NULL, NULL, 0, 60, NULL, N'9183418430', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 South Moore Ave', N'Claremore', N'OK', N'40131', N'74017', 36.316696, -95.628254, 2774, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4418, N'Memorial Hospital', 1, NULL, NULL, N'370178', NULL, NULL, 0, 67, NULL, N'9186963101', N'9186963388', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 West Locust', N'Stilwell', N'OK', N'40001', N'74960', 35.808537, -94.660251, 2841, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4419, N'Chickasaw Nation Medical Center', 1, NULL, NULL, N'370180', NULL, NULL, 0, 48, NULL, N'5804363980', N'5804216267', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1921 Stonecipher Blvd', N'Ada', N'OK', N'40123', N'74820', 34.736811, -96.647612, 2760, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4420, N'Hillcrest Hospital Henryetta', 1, NULL, NULL, N'370183', NULL, NULL, 0, 41, NULL, N'9186151100', N'9186501391', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 W Main Dewey Bartlett And Main', N'Henryetta', N'OK', N'40111', N'74437', 35.439826, -95.981943, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4421, N'Southwestern Regional Medical Center Inc', 1, NULL, NULL, N'370190', NULL, NULL, 0, 40, NULL, N'9182865000', N'9182497500', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10109 East 79Th Street', N'Tulsa', N'OK', N'40143', N'74133', 36.046339, -95.864211, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4422, N'Northwest Surgical Hospital', 1, NULL, NULL, N'370192', NULL, NULL, 0, 9, NULL, N'4048481918', N'4058487537', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9204 North May Avenue', N'Oklahoma City', N'OK', N'40109', N'73120', 35.564166, -97.567159, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4423, N'Lakeside Women''s Hospital A Member Of Integris He', 1, NULL, NULL, N'370199', NULL, NULL, 0, 23, NULL, N'4059361500', N'4059361584', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11200 North Portland Avenue', N'Oklahoma City', N'OK', N'40109', N'73120', 35.583924, -97.585017, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4424, N'Surgical Hospital Of Oklahoma Llc', 1, NULL, NULL, N'370201', NULL, NULL, 0, 12, NULL, N'4056349300', N'4056167049', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Southeast 59Th Street', N'Oklahoma City', N'OK', N'40109', N'73129', 35.406181, -97.50969, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4425, N'Hillcrest Hospital South', 1, NULL, NULL, N'370202', NULL, NULL, 0, 180, NULL, N'9182944000', N'9182944809', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8801 South 101St East Avenue', N'Tulsa', N'OK', N'40143', N'74133', 36.035714, -95.86464, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4426, N'Community Hospital Llc', 1, NULL, NULL, N'370203', NULL, NULL, 0, 49, NULL, N'4056028100', N'4056028158', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Southwest 89Th Street', N'Oklahoma City', N'OK', N'40109', N'73159', 35.377116, -97.570919, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4427, N'Oklahoma Spine Hospital', 1, NULL, NULL, N'370206', NULL, NULL, 0, 25, NULL, N'4057492700', N'4057492783', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14101 Parkway Commons Drive', N'Oklahoma City', N'OK', N'40109', N'73134', 35.615067, -97.582644, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4428, N'Oklahoma Surgical Hospital Llc', 1, NULL, NULL, N'370210', NULL, NULL, 0, 76, NULL, N'9184775000', N'9184775995', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 East 81St Street Suite 300', N'Tulsa', N'OK', N'40143', N'74137', 36.046326, -95.957404, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4429, N'Integris Canadian Valley  Hospital', 1, NULL, NULL, N'370211', NULL, NULL, 0, 75, NULL, N'4057176800', N'4057177964', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Health Center Parkway', N'Yukon', N'OK', N'40017', N'73099', 35.48381, -97.764138, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4430, N'Oklahoma Center For Orthopaedic & Multi-Sp', 1, NULL, NULL, N'370212', NULL, NULL, 0, 14, NULL, N'4056026500', N'4056068976', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8100 South Walker Bldg C', N'Oklahoma City', N'OK', N'40027', N'73139', 35.472989, -97.517054, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4431, N'Lindsay Municipal Hospital', 1, NULL, NULL, N'370214', NULL, NULL, 0, 26, NULL, N'4057561404', N'4057561476', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 W Cherokee Street - Highway 19 West', N'Lindsay', N'OK', N'40049', N'73052', 34.837104, -97.618301, 2799, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4432, N'Oklahoma Heart Hospital', 1, NULL, NULL, N'370215', NULL, NULL, 0, 99, NULL, N'4056083200', N'4056081493', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4050 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73120', 35.609037, -97.596027, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4433, N'Tulsa Spine & Specialty Hospital Llc', 1, NULL, NULL, N'370216', NULL, NULL, 0, 38, NULL, N'9183885701', N'9183882728', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 South Olympia Avenue', N'Tulsa', N'OK', N'40143', N'74132', 36.064258, -96.004542, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4434, N'Saint Francis Hospital South Llc', 1, NULL, NULL, N'370218', NULL, NULL, 0, 96, NULL, N'9183076000', N'9183076011', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10501 East 91St Street South', N'Tulsa', N'OK', N'40143', N'74133', 36.03189, -95.85692, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4435, N'Onecore Health', 1, NULL, NULL, N'370220', NULL, NULL, 0, 8, NULL, N'4056313085', N'4056162676', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1044 Sw 44Th Suite 350', N'Oklahoma City', N'OK', N'40109', N'73109', 35.42073, -97.53362, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4436, N'Mcbride Clinic Orthopedic Hospital  L L C', 1, NULL, NULL, N'370222', NULL, NULL, 0, 75, NULL, N'4054862100', N'4054862144', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9600 North Broadway Extension', N'Oklahoma City', N'OK', N'40109', N'73114', 35.5676647, -97.5150232, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4437, N'Summit Medical Center', 1, NULL, NULL, N'370225', NULL, NULL, 0, 15, NULL, N'4053592400', N'4057159185', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 South Renaissance Boulevard', N'Edmond', N'OK', N'40109', N'73013', 35.635546, -97.499408, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4438, N'St John Owasso', 1, NULL, NULL, N'370227', NULL, NULL, 0, 36, NULL, N'9182745100', N'9184030170', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12451 East 100Th Street North', N'Owasso', N'OK', N'40143', N'74055', 36.298748, -95.835025, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4439, N'Bailey Medical Center Llc', 1, NULL, NULL, N'370228', NULL, NULL, 0, 83, NULL, N'9183768000', N'9183768549', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10502 North 110Th East Avenue', N'Owasso', N'OK', N'40143', N'74055', 36.304304, -95.851822, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4440, N'Alliancehealth Seminole', 1, NULL, NULL, N'370229', NULL, NULL, 0, 32, NULL, N'4053034050', N'4053034150', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 Wrangler Boulevard', N'Seminole', N'OK', N'40133', N'74868', 35.246455, -96.698374, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4441, N'Pinnacle Specialty Hospital', 1, NULL, NULL, N'370233', NULL, NULL, 0, 4, NULL, N'9183922780', N'9183922782', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 East 81St Street Suite 600', N'Tulsa', N'OK', N'40143', N'74137', 36.046326, -95.957404, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4442, N'Oklahoma Heart Hospital South', 1, NULL, NULL, N'370234', NULL, NULL, 0, 46, NULL, N'4056286000', N'4056081585', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 East I-240 Service Road', N'Oklahoma City', N'OK', N'40109', N'73135', 35.391787, -97.427448, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4443, N'St John Broken Arrow Inc', 1, NULL, NULL, N'370235', NULL, NULL, 0, 44, NULL, N'9189948199', N'9189948000', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 West Boise Circle', N'Broken Arrow', N'OK', N'40143', N'74012', 36.0780272, -95.8028901, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4444, N'Integris Health Edmond', 1, NULL, NULL, N'370236', NULL, NULL, 0, 40, NULL, N'4056573000', N'4054710003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4801 Integris Parkway', N'Edmond', N'OK', N'40109', N'73034', 35.643453, -97.42435, 2782, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4445, N'Atoka County Medical Center', 1, NULL, NULL, N'371300', NULL, NULL, 0, 25, NULL, N'5808893333', N'5808898779', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Liberty Road', N'Atoka', N'OK', N'40005', N'74525', 34.394243, -96.143921, 2766, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4446, N'Prague Community Hospital', 1, NULL, NULL, N'371301', NULL, NULL, 0, 25, NULL, N'4055674922', N'4055674290', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1322 Klabzuba Avenue', N'Prague', N'OK', N'40081', N'74864', 35.489816, -96.684553, 2817, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4447, N'Mercy Hospital Watonga Inc', 1, NULL, NULL, N'371302', NULL, NULL, 0, 25, NULL, N'5806237211', N'5806237405', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 North Clarence Nash Boulevard', N'Watonga', N'OK', N'40011', N'73772', 35.849655, -98.419247, 2835, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4448, N'Roger Mills Memorial Hospital', 1, NULL, NULL, N'371303', NULL, NULL, 0, 15, NULL, N'5804973336', N'5804972124', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South L L Males Avenue', N'Cheyenne', N'OK', N'40129', N'73628', 35.613937, -99.671494, 2772, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4449, N'Mercy Hospital Tishomin Inc', 1, NULL, NULL, N'371304', NULL, NULL, 0, 25, NULL, N'5803712327', N'5803712889', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Byrd', N'Tishomin', N'OK', N'40069', N'73460', 34.22228, -96.675294, 2831, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4450, N'Jane Phillips Nowata Health Center', 1, NULL, NULL, N'371305', NULL, NULL, 0, 25, NULL, N'9182733102', N'9182731529', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'237 South Locust Street', N'Nowata', N'OK', N'40105', N'74048', 36.697239, -95.630468, 2767, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4451, N'Mercy Health Love County', 1, NULL, NULL, N'371306', NULL, NULL, 0, 25, NULL, N'5802763347', N'5802762182', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wanda Street', N'Marietta', N'OK', N'40085', N'73448', 33.942475, -97.131038, 2802, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4452, N'Cimarron Memorial Hospital', 1, NULL, NULL, N'371307', NULL, NULL, 0, 25, NULL, N'5805442501', N'5805443200', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 South Ellis', N'Boise City', N'OK', N'40025', N'73933', 36.724677, -102.517529, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4453, N'Pawhuska Hospital Inc', 1, NULL, NULL, N'371309', NULL, NULL, 0, 25, NULL, N'9182873232', N'9182875161', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 East 15Th Street', N'Pawhuska', N'OK', N'40113', N'74056', 36.672852, -96.32509, 2812, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4454, N'Mercy Hospital Healdton Inc.', 1, NULL, NULL, N'371310', NULL, NULL, 0, 22, NULL, N'5802290701', N'5802291454', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3462 Hospital Rd', N'Healdton', N'OK', N'40019', N'73438', 34.222413, -97.492174, 2765, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4455, N'Jefferson County Hospital', 1, NULL, NULL, N'371311', NULL, NULL, 0, 25, NULL, N'5802282344', N'5082283410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Intersection Hyws 81 & 70', N'Waurika', N'OK', N'40067', N'73573', 34.167037, -97.997536, 2836, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4456, N'St John Sapulpa Inc', 1, NULL, NULL, N'371312', NULL, NULL, 0, 25, NULL, N'9182278601', N'9182271093', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1004 East Bryan', N'Sapulpa', N'OK', N'40037', N'74066', 35.993347, -96.100838, 2821, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4457, N'Mercy Hospital Kingfisher', 1, NULL, NULL, N'371313', NULL, NULL, 0, 25, NULL, N'4053753141', N'4053757997', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Kingfisher Hospital Drive', N'Kingfisher', N'OK', N'40073', N'73750', 35.861432, -97.93172, 2797, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4458, N'The Physicians'' Hospital In Anadarko', 1, NULL, NULL, N'371314', NULL, NULL, 0, 25, NULL, N'4052472551', N'4052478258', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1002 East Central Boulevard', N'Anadarko', N'OK', N'40015', N'73005', 35.07227, -98.228016, 2763, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4459, N'Stroud Regional Medical Center', 1, NULL, NULL, N'371316', NULL, NULL, 0, 25, NULL, N'9189683571', N'9189684814', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2308 Highway 66 West', N'Stroud', N'OK', N'40081', N'74079', 35.750678, -96.680949, 2828, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4460, N'Mercy Hospital Logan County Inc', 1, NULL, NULL, N'371317', NULL, NULL, 0, 25, NULL, N'4052826700', N'4052826790', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 South Academy Road', N'Guthrie', N'OK', N'40083', N'73044', 35.876163, -97.460455, 2791, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4461, N'Fairfax Community Hospital', 1, NULL, NULL, N'371318', NULL, NULL, 0, 15, NULL, N'9186423291', N'9186423694', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'40 Hospital Road', N'Fairfax', N'OK', N'40113', N'74637', 36.562704, -96.705551, 2787, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4462, N'Mary Hurley Hospital', 1, NULL, NULL, N'371319', NULL, NULL, 0, 20, NULL, N'5809272327', N'5809272349', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6 North Covington', N'Coalgate', N'OK', N'40029', N'74538', 34.538865, -96.224356, 2776, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4463, N'Cleveland Area Hospital', 1, NULL, NULL, N'371320', NULL, NULL, 0, 14, NULL, N'9183582501', N'9183589274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 West Pawnee', N'Cleveland', N'OK', N'40117', N'74020', 36.309882, -96.481121, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4464, N'Holdenville General Hospital', 1, NULL, NULL, N'371321', NULL, NULL, 0, 25, NULL, N'4053794200', N'4053794284', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Mcdougal Drive', N'Holdenville', N'OK', N'40063', N'74848', 35.089252, -96.379764, 2794, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4465, N'Beaver County Memorial Hospital', 1, NULL, NULL, N'371322', NULL, NULL, 0, 24, NULL, N'5806254551', N'5806254212', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'212 East 8Th Street', N'Beaver', N'OK', N'40007', N'73932', 36.810196, -100.516253, 2768, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4466, N'Weatherford Regional Hospital Inc Of Weatherford', 1, NULL, NULL, N'371323', NULL, NULL, 0, 25, NULL, N'5807725551', N'5807742314', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3701 E Main', N'Weatherford', N'OK', N'40039', N'73096', 35.536922, -98.661204, 2837, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4467, N'Harper County Community Hospital', 1, NULL, NULL, N'371324', NULL, NULL, 0, 25, NULL, N'5807352555', N'5807352342', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1003 Us Highway 64 North', N'Buffalo', N'OK', N'40059', N'73834', 36.835587, -99.630397, 2770, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4468, N'Cordell Memorial Hospital', 1, NULL, NULL, N'371325', NULL, NULL, 0, 14, NULL, N'5808323339', N'5808325076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 North Glenn English Street', N'Cordell', N'OK', N'40149', N'73632', 35.291251, -98.989545, 2777, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4469, N'Alliancehealth Madill', 1, NULL, NULL, N'371326', NULL, NULL, 0, 25, NULL, N'5807953384', N'5807950173', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive', N'Madill', N'OK', N'40095', N'73446', 34.090375, -96.771669, 2800, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4470, N'Okeene Municipal Hospital', 1, NULL, NULL, N'371327', NULL, NULL, 0, 17, NULL, N'5808224417', N'5808223927', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'207 East F Street', N'Okeene', N'OK', N'40011', N'73763', 36.117096, -98.315166, 2808, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4471, N'Arbuckle Memorial Hospital Authority', 1, NULL, NULL, N'371328', NULL, NULL, 0, 25, NULL, N'5806222161', N'5806225519', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2011 West Broadway', N'Sulphur', N'OK', N'40099', N'73086', 34.506329, -96.995212, 2829, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4472, N'Fairview Regional Medical Center Authority', 1, NULL, NULL, N'371329', NULL, NULL, 0, 25, NULL, N'5802273721', N'5802272882', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'523 East State Road', N'Fairview', N'OK', N'40093', N'73737', 36.275207, -98.474645, 2788, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4473, N'Quartz Mountain Medical Center', 1, NULL, NULL, N'371330', NULL, NULL, 0, 17, NULL, N'5807823353', N'5807825944', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Wickersham Drive', N'Mangum', N'OK', N'40055', N'73554', 34.872004, -99.504256, 2801, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4474, N'Drumright Regional Hospital', 1, NULL, NULL, N'371331', NULL, NULL, 0, 15, NULL, N'9183822300', N'9183522675', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 West Bypass', N'Drumright', N'OK', N'40037', N'74030', 36.775185, -95.647563, 2779, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4475, N'Seiling Municipal Hospital', 1, NULL, NULL, N'371332', NULL, NULL, 0, 18, NULL, N'5809227361', N'5809227360', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Us Highway 60', N'Seiling', N'OK', N'40043', N'73663', 36.148096, -98.924261, 2823, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4476, N'Creek Nation Community Hospital', 1, NULL, NULL, N'371333', NULL, NULL, 0, 25, NULL, N'9186231424', N'9186231066', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 North 14Th Street', N'Okemah', N'OK', N'40107', N'74859', 35.434052, -96.317453, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4477, N'Carnegie Tri-County Municipal Hospital', 1, NULL, NULL, N'371334', NULL, NULL, 0, 21, NULL, N'5806541050', N'5806542111', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 North Broadway', N'Carnegie', N'OK', N'40015', N'73015', 35.107133, -98.604922, 2771, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4478, N'Haskell County Community Hospital', 1, NULL, NULL, N'371335', NULL, NULL, 0, 25, NULL, N'9189674682', N'9189678694', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Northwest H Street', N'Stigler', N'OK', N'40061', N'74462', 35.260798, -95.128255, 2826, 12, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4479, N'Kindred Hospital - Oklahoma City', 1, NULL, NULL, N'372004', NULL, NULL, 0, 93, NULL, N'4052328000', N'4052363839', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1407 North Robinson Avenue', N'Oklahoma City', N'OK', N'40109', N'73103', 35.48255, -97.51608, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4480, N'Edmond - Amg Specialty Hospital', 1, NULL, NULL, N'372005', NULL, NULL, 0, 37, NULL, N'4053415617', N'4053410105', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 East 9Th Street', N'Edmond', N'OK', N'40109', N'73034', 35.645554, -97.48236, 2782, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4481, N'Select Specialty Hospital - Tulsa/Midtown Llc', 1, NULL, NULL, N'372007', NULL, NULL, 0, 56, NULL, N'9185797301', N'9185797354', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1125 South Trenton 2Nd & 3Rd Floor', N'Tulsa', N'OK', N'40143', N'74120', 36.1473744, -95.9719473, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4482, N'Select Specialty Hospital - Oklahoma City', 1, NULL, NULL, N'372009', NULL, NULL, 0, 72, NULL, N'4056066901', N'4056066110', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3524 Northwest 56Th Street', N'Oklahoma City', N'OK', N'40109', N'73112', 35.527436, -97.578531, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4483, N'Tulsa-Amg Specialty Hospital Llc', 1, NULL, NULL, N'372011', NULL, NULL, 0, 40, NULL, N'9187103620', N'9187103624', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2408 E 81St Street Ste 2800', N'Tulsa', N'OK', N'40143', N'74137', 36.0432253, -95.9558043, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4484, N'Specialty Hospital Of Midwest City', 1, NULL, NULL, N'372012', NULL, NULL, 0, 31, NULL, N'4057390800', N'4057396479', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8210 National Avenue', N'Midwest City', N'OK', N'40109', N'73110', 35.466332, -97.387693, 2805, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4485, N'Integris Bass Pavilion', 1, NULL, NULL, N'372016', NULL, NULL, 0, 24, NULL, N'5802494260', N'5802494256', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South Third Street', N'Enid', N'OK', N'40047', N'73701', 36.396762, -97.879134, 2785, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4486, N'Lane Frost Health And Rehabilitation Center', 1, NULL, NULL, N'372017', NULL, NULL, 0, 60, NULL, N'5803269200', N'5803268876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2815 East Jackson', N'Hu', N'OK', N'40023', N'74743', 34.017861, -95.539293, 3352, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4487, N'Post Acute Medical Specialty Hospital Of Tulsa', 1, NULL, NULL, N'372018', NULL, NULL, 0, 60, NULL, N'9186638183', N'9186605398', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3219 South 79Th East Avenue', N'Tulsa', N'OK', N'40143', N'74145', 36.115966, -95.890424, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4488, N'Chg Cornerstone Hospital Of Oklahoma - Shawnee', 1, NULL, NULL, N'372019', NULL, NULL, 0, 34, NULL, N'4053955800', N'4053955802', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 rdon Cooper Drive 2Nd Floor', N'Shawnee', N'OK', N'40125', N'74801', 35.327293, -96.9253, 2825, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4489, N'Norman Specialty Hospital', 1, NULL, NULL, N'372021', NULL, NULL, 0, 50, NULL, N'4053218824', N'4057018010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1210 West Robinson', N'Norman', N'OK', N'40027', N'73069', 35.222572, -97.439482, 2807, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4490, N'Cornerstone Hospital Of Oklahoma- Muskogee', 1, NULL, NULL, N'372022', NULL, NULL, 0, 64, NULL, N'9186826161', N'9186826164', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 South 40Th Street', N'Muskogee', N'OK', N'40101', N'74401', 35.753649, -95.411709, 2806, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4491, N'Muscogee (Creek) Nation Long Term Acute Care Hospi', 1, NULL, NULL, N'372023', NULL, NULL, 0, 4, NULL, N'9187569211', N'9187569452', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Airport Road', N'Okmulgee', N'OK', N'40111', N'74447', 35.667969, -95.960325, 2810, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4492, N'Valir Rehabilitation Hospital Of Okc', 1, NULL, NULL, N'373025', NULL, NULL, 0, 81, NULL, N'4052363131', N'4055531042', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Northwest 7Th Street', N'Oklahoma City', N'OK', N'40109', N'73102', 35.475023, -97.514901, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4493, N'Muscogee (Creek) Nation Physical Rehabilitation Ce', 1, NULL, NULL, N'373026', NULL, NULL, 0, 26, NULL, N'9187569211', N'9187569452', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Airport Road', N'Okmulgee', N'OK', N'40111', N'74447', 35.667969, -95.960325, 2810, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4494, N'Mercy Rehabilitation Hospital Oklahoma City', 1, NULL, NULL, N'373033', NULL, NULL, 0, 50, NULL, N'4054342609', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5401 West Memorial Road', N'Oklahoma City', N'OK', N'40109', N'73142', 35.608869, -97.615865, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4495, N'J D Mccarty Center For Children', 1, NULL, NULL, N'373300', NULL, NULL, 0, 36, NULL, N'4053072800', N'4053072801', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2002  East Robinson', N'Norman', N'OK', N'40027', N'73071', 35.222572, -97.439482, 2807, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4496, N'The Children''s Center', 1, NULL, NULL, N'373302', NULL, NULL, 0, 120, NULL, N'4057896711', N'4057890690', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 Northwest 39Th Expressway', N'Bethany', N'OK', N'40109', N'73008', 35.512078, -97.63221, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4497, N'Griffin Memorial Hospital', 1, NULL, NULL, N'374000', NULL, NULL, 0, 182, NULL, N'4053214880', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Main Street', N'Norman', N'OK', N'40027', N'73070', 35.225479, -97.432272, 2807, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4498, N'Northwest Center For Behavioral Health (Ncbh)', 1, NULL, NULL, N'374001', NULL, NULL, 0, 130, NULL, N'5807662311', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Mile East Us Highway 270', N'Fort Supply', N'OK', N'40153', N'73841', 36.573411, -99.574693, 2840, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4499, N'Carl Albert Community Mental Health Center', 1, NULL, NULL, N'374006', NULL, NULL, 0, 15, NULL, N'9184267800', N'9184265521', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 East Monroe', N'Mcalester', N'OK', N'40121', N'74501', 34.933498, -95.769793, 2803, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4500, N'Jim Taliaferro Comm Mental Health Ctr', 1, NULL, NULL, N'374008', NULL, NULL, 0, 30, NULL, N'5802485780', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Southwest 38Th Street', N'Lawton', N'OK', N'40031', N'73505', 34.602791, -98.439681, 2798, 218, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4501, N'Brookhaven Hospital Inc', 1, NULL, NULL, N'374012', NULL, NULL, 0, 64, NULL, N'9184384257', N'9184388016', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 South Garnett Road', N'Tulsa', N'OK', N'40143', N'74128', 36.1581463, -95.8521776, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4502, N'Rolling Hills Hospital Llc', 1, NULL, NULL, N'374016', NULL, NULL, 0, 60, NULL, N'5804363600', N'5804363958', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 Rolling Hills Lane', N'Ada', N'OK', N'40123', N'74820', 34.7845436, -96.6295467, 2760, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4503, N'Willow Crest Hospital Inc', 1, NULL, NULL, N'374017', NULL, NULL, 0, 50, NULL, N'9185421836', N'9185428730', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 A Street Southwest', N'Miami', N'OK', N'40115', N'74354', 36.872664, -94.8808713, 2804, 164, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4504, N'Laureate Psychiatric Clinic And Hospital Inc', 1, NULL, NULL, N'374020', NULL, NULL, 0, 90, NULL, N'9184814000', N'9184814063', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6655 South Yale Avenue', N'Tulsa', N'OK', N'40143', N'74136', 36.0663163, -95.9185547, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4505, N'Parkside Inc', 1, NULL, NULL, N'374021', NULL, NULL, 0, 51, NULL, N'9185822131', N'9185888822', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1619 East 13Th Street', N'Tulsa', N'OK', N'40143', N'74120', 36.1443274, -95.9711451, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4506, N'Cedar Ridge', 1, NULL, NULL, N'374023', NULL, NULL, 0, 60, NULL, N'4056056111', N'4056050457', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6501 Northeast 50Th Street', N'Oklahoma City', N'OK', N'40109', N'73141', 35.522411, -97.422971, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4507, N'Shadow Mountain Behavioral Health System', 1, NULL, NULL, N'374024', NULL, NULL, 0, 40, NULL, N'9184928200', N'9184922849', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6262 South Sheridan Road', N'Tulsa', N'OK', N'40143', N'74133', 36.014082, -95.904257, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4508, N'O U Medical Center', 1, NULL, NULL, N'379801', NULL, NULL, 0, 0, NULL, N'4052711773', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 Everett Dr', N'Oklahoma City', N'OK', N'40109', N'73117', 35.605522, -97.454471, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4509, N'St Anthony Hospital', 1, NULL, NULL, N'379802', NULL, NULL, 0, 0, NULL, N'4052727000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 North Lee Ave', N'Oklahoma City', N'OK', N'40109', N'73101', 35.477368, -97.524213, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4510, N'Integris Baptist Medical Center', 1, NULL, NULL, N'379803', NULL, NULL, 0, 0, NULL, N'4059493011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 Northwest Expressway', N'Oklahoma City', N'OK', N'40109', N'73112', 35.567613, -97.660205, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4511, N'St John Medical Center-Transplant', 1, NULL, NULL, N'379804', NULL, NULL, 0, 0, NULL, N'9187443537', N'9187443341', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1923 S Utica Ave', N'Tulsa', N'OK', N'40143', N'74104', 36.134749, -95.967117, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4512, N'Saint Francis Hospital', 1, NULL, NULL, N'379805', NULL, NULL, 0, 0, NULL, N'9184948467', N'9184946326', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6161 South Yale Avenue', N'Tulsa', N'OK', N'40143', N'74136', 36.046303, -95.922185, 2832, 220, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4513, N'Ou Medical Center - Presbyterian Tower', 1, NULL, NULL, N'379806', NULL, NULL, 0, 0, NULL, N'4052717498', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'700 Ne 13Th Street', N'Oklahoma City', N'OK', N'40109', N'73104', 35.482262, -97.502757, 2809, 219, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4514, N'Mid-Columbia Medical Center', 1, NULL, NULL, N'380001', NULL, NULL, 0, 49, NULL, N'5412961111', N'5412967650', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 E 19Th Street', N'The Dalles', N'OR', N'41065', N'97058', 45.587839, -121.165781, 2883, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4515, N'Asante Three Rivers Medical Center', 1, NULL, NULL, N'380002', NULL, NULL, 0, 150, NULL, N'5414727000', N'5414727317', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Sw Ramsey Avenue', N'Grants Pass', N'OR', N'41033', N'97527', 42.439371, -123.327249, 2856, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4516, N'Providence St Vincent Medical Center', 1, NULL, NULL, N'380004', NULL, NULL, 0, 523, NULL, N'5032162213', N'5032162468', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9205 Sw Barnes Road', N'Portland', N'OR', N'41067', N'97225', 45.513446, -122.75568, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4517, N'Asante Ashland Community Hospital', 1, NULL, NULL, N'380005', NULL, NULL, 0, 49, NULL, N'5412014001', N'5414887411', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Maple Street', N'Ashland', N'OR', N'41029', N'97520', 42.206445, -122.724815, 2843, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4518, N'Legacy Emanuel Medical Center', 1, NULL, NULL, N'380007', NULL, NULL, 0, 554, NULL, N'5034132200', N'5034133003', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 N Gantenbein Avenue', N'Portland', N'OR', N'41051', N'97227', 45.544202, -122.669449, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4519, N'Ohsu Hospital And Clinics', 1, NULL, NULL, N'380009', NULL, NULL, 0, 560, NULL, N'5034944036', N'5034948020', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3181 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.499103, -122.689227, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4520, N'od Samaritan Regional Medical Center', 1, NULL, NULL, N'380014', NULL, NULL, 0, 188, NULL, N'5417685111', N'5417685100', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Nw Samaritan Drive', N'Corvallis', N'OR', N'41003', N'97330', 44.600903, -123.249671, 2849, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4521, N'Legacy od Samaritan Medical Center', 1, NULL, NULL, N'380017', NULL, NULL, 0, 539, NULL, N'5034137682', N'5034136347', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 Nw 22Nd Avenue W121', N'Portland', N'OR', N'41051', N'97210', 45.530056, -122.696572, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4522, N'Asante Rogue Regional Medical Center', 1, NULL, NULL, N'380018', NULL, NULL, 0, 378, NULL, N'5417897000', N'5417895870', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2825 E Barnett Road', N'Medford', N'OR', N'41029', N'97504', 42.316483, -122.830443, 2869, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4523, N'Mckenzie-Willamette Medical Center', 1, NULL, NULL, N'380020', NULL, NULL, 0, 113, NULL, N'5417264400', N'5417264540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1460 G Street', N'Springfield', N'OR', N'41039', N'97477', 44.052402, -123.003296, 2882, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4524, N'Tuality Community Hospital', 1, NULL, NULL, N'380021', NULL, NULL, 0, 215, NULL, N'5036811111', N'5036811608', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'335 Se 8Th Avenue', N'Hillsboro', N'OR', N'41067', N'97123', 45.519637, -122.97731, 2859, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4525, N'Samaritan Albany General Hospital', 1, NULL, NULL, N'380022', NULL, NULL, 0, 79, NULL, N'5418124000', N'5418124447', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1046 6Th Avenue Sw', N'Albany', N'OR', N'41043', N'97321', 44.632129, -123.116242, 2842, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4526, N'Legacy Mount Hood Medical Center', 1, NULL, NULL, N'380025', NULL, NULL, 0, 115, NULL, N'5036741122', N'5036741575', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24800 Se Stark Street', N'Gresham', N'OR', N'41051', N'97030', 45.519054, -122.407395, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4527, N'Mercy Medical Center', 1, NULL, NULL, N'380027', NULL, NULL, 0, 174, NULL, N'5416730611', N'5416772391', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Nw Stewart Parkway', N'Roseburg', N'OR', N'41019', N'97471', 43.239863, -123.367073, 2878, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4528, N'Silverton Hospital', 1, NULL, NULL, N'380029', NULL, NULL, 0, 48, NULL, N'5038731500', N'5038731534', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'342 Fairview Street', N'Silverton', N'OR', N'41047', N'97381', 45.003752, -122.790752, 2881, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4529, N'Sacred Heart University District', 1, NULL, NULL, N'380033', NULL, NULL, 0, 104, NULL, N'5416867300', N'5414347449', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1255 Hilyard Street', N'Eugene', N'OR', N'41039', N'97401', 44.045405, -123.082107, 2853, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4530, N'Providence Newberg Medical Center', 1, NULL, NULL, N'380037', NULL, NULL, 0, 40, NULL, N'5035371555', N'5035371811', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Providence Drive', N'Newberg', N'OR', N'41071', N'97132', 45.308689, -122.933955, 2870, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4531, N'Providence Willamette Falls Medical Center', 1, NULL, NULL, N'380038', NULL, NULL, 0, 143, NULL, N'5036576915', N'5036506807', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Division Street', N'Oren City', N'OR', N'41005', N'97045', 45.356733, -122.588369, 2873, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4532, N'St Charles Medical Center - Redmond', 1, NULL, NULL, N'380040', NULL, NULL, 0, 48, NULL, N'5415488131', N'5415266673', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1253 N Canal Blvd', N'Redmond', N'OR', N'41017', N'97756', 44.28814, -121.168858, 2877, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4533, N'St Charles Medical Center - Bend', 1, NULL, NULL, N'380047', NULL, NULL, 0, 231, NULL, N'5417066879', N'5417065807', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Ne Neff Road', N'Bend', N'OR', N'41017', N'97701', 44.065758, -121.265718, 2846, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4534, N'Sky Lakes Medical Center', 1, NULL, NULL, N'380050', NULL, NULL, 0, 176, NULL, N'5412746150', N'5412746725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2865 Daggett Avenue', N'Klamath Falls', N'OR', N'41035', N'97601', 42.252654, -121.787275, 2862, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4535, N'Salem Hospital', 1, NULL, NULL, N'380051', NULL, NULL, 0, 434, NULL, N'5035615200', N'5035614844', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'890 Oak Street Se', N'Salem', N'OR', N'41047', N'97301', 44.933016, -123.033478, 2879, 225, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4536, N'Saint Alphonsus Medical Center - Ontario Inc', 1, NULL, NULL, N'380052', NULL, NULL, 0, 49, NULL, N'5418817000', N'5418817184', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'351 Sw 9Th Street', N'Ontario', N'OR', N'41045', N'97914', 44.025488, -116.975115, 2872, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4537, N'Santiam Memorial Hospital', 1, NULL, NULL, N'380056', NULL, NULL, 0, 40, NULL, N'5037692175', N'5037695877', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 N 10Th Avenue', N'Stayton', N'OR', N'41047', N'97383', 44.805595, -122.78413, 2879, 225, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4538, N'Adventist Medical Center', 1, NULL, NULL, N'380060', NULL, NULL, 0, 302, NULL, N'5032572500', N'5032616638', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10123 Se Market Street', N'Portland', N'OR', N'41051', N'97216', 45.511351, -122.559602, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4539, N'Providence Portland Medical Center', 1, NULL, NULL, N'380061', NULL, NULL, 0, 483, NULL, N'5032151111', N'5032156858', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4805 Ne Glisan Street', N'Portland', N'OR', N'41051', N'97213', 45.526524, -122.613762, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4540, N'Willamette Valley Medical Center', 1, NULL, NULL, N'380071', NULL, NULL, 0, 88, NULL, N'5034726131', N'5034728691', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Se Stratus Ave.', N'Mcminnville', N'OR', N'41071', N'97128', 45.200027, -123.166263, 2868, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4541, N'Providence Medford Medical Center', 1, NULL, NULL, N'380075', NULL, NULL, 0, 168, NULL, N'5417325196', N'5417325872', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1111 Crater Lake Avenue', N'Medford', N'OR', N'41029', N'97504', 42.339902, -122.861004, 2869, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4542, N'Providence Milwaukie Hospital', 1, NULL, NULL, N'380082', NULL, NULL, 0, 77, NULL, N'5035138336', N'5035138191', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10150 Se 32Nd Avenue', N'Milwaukie', N'OR', N'41005', N'97222', 45.449567, -122.629787, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4543, N'Legacy Meridian Park Medical Center', 1, NULL, NULL, N'380089', NULL, NULL, 0, 150, NULL, N'5036922182', N'5036910919', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19300 Sw 65Th Avenue', N'Tualatin', N'OR', N'41067', N'97062', 45.381265, -122.743929, 2885, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4544, N'Bay Area Hospital', 1, NULL, NULL, N'380090', NULL, NULL, 0, 172, NULL, N'5412698124', N'5412677057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1775 Thompson Road', N'Coos Bay', N'OR', N'41011', N'97420', 43.38583, -124.23333, 2848, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4545, N'Kaiser Sunnyside Medical Center', 1, NULL, NULL, N'380091', NULL, NULL, 0, 329, NULL, N'5035712880', N'5035712671', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10180 Se Sunnyside Road', N'Clackamas', N'OR', N'41005', N'97015', 45.433517, -122.557085, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4546, N'Sacred Heart Medical Center - Riverbend', 1, NULL, NULL, N'380102', NULL, NULL, 0, 347, NULL, N'5412227300', N'5412222006', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 Riverbend Drive', N'Springfield', N'OR', N'41039', N'97477', 44.081312, -123.028655, 2882, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4547, N'Kaiser Foundation Hospital - Westside', 1, NULL, NULL, N'380103', NULL, NULL, 0, 122, NULL, N'9713101000', N'9713103302', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2875 Nw Stucki Ave', N'Hillsboro', N'OR', N'41067', N'97124', 45.539713, -122.875667, 2859, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4548, N'Peacehealth Cottage Grove Community Medical Center', 1, NULL, NULL, N'381301', NULL, NULL, 0, 11, NULL, N'5417675500', N'5417675208', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Village Drive', N'Cottage Grove', N'OR', N'41039', N'97424', 43.802974, -123.038245, 2850, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4549, N'Samaritan North Lincoln Hospital', 1, NULL, NULL, N'381302', NULL, NULL, 0, 15, NULL, N'5419943661', N'5419967383', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3043 Ne 28Th Street', N'Lincoln City', N'OR', N'41041', N'97367', 44.985172, -123.996061, 2866, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4550, N'Providence Seaside Hospital', 1, NULL, NULL, N'381303', NULL, NULL, 0, 34, NULL, N'5037177000', N'5037177505', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 S Wahanna Road', N'Seaside', N'OR', N'41007', N'97138', 45.988801, -123.915044, 2880, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4551, N'Southern Coos Hospital & Health Center', 1, NULL, NULL, N'381304', NULL, NULL, 0, 24, NULL, N'5413472426', N'5413473923', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 11Th Street Se', N'Bandon', N'OR', N'41011', N'97411', 43.113246, -124.402529, 2848, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4552, N'Blue Mountain Hospital', 1, NULL, NULL, N'381305', NULL, NULL, 0, 39, NULL, N'5415751311', N'5415750650', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 Ford Road', N'John Day', N'OR', N'41023', N'97845', 44.417184, -118.957928, 2861, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4553, N'Wallowa Memorial Hospital', 1, NULL, NULL, N'381306', NULL, NULL, 0, 25, NULL, N'5414263111', N'5414261901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Medical Parkway', N'Enterprise', N'OR', N'41063', N'97828', 45.431756, -117.279982, 2852, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4554, N'Harney District Hospital', 1, NULL, NULL, N'381307', NULL, NULL, 0, 44, NULL, N'5415737281', N'5415738627', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'557 W Washington Street', N'Burns', N'OR', N'41025', N'97720', 43.588717, -119.060151, 2847, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4555, N'West Valley Hospital', 1, NULL, NULL, N'381308', NULL, NULL, 0, 25, NULL, N'5036238301', N'5038313485', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 Se Washington Street', N'Dallas', N'OR', N'41053', N'97338', 44.919404, -123.310391, 2851, 225, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4556, N'Lake District Hospital', 1, NULL, NULL, N'381309', NULL, NULL, 0, 21, NULL, N'5419472114', N'5419472433', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South J Street', N'Lakeview', N'OR', N'41037', N'97630', 42.181369, -120.351417, 2864, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4557, N'Pioneer Memorial Hospital', 1, NULL, NULL, N'381310', NULL, NULL, 0, 21, NULL, N'5416769133', N'5416762901', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'564 E Pioneer Drive', N'Heppner', N'OR', N'41049', N'97836', 45.356268, -119.54763, 2857, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4558, N'Lower Umpqua Hospital District', 1, NULL, NULL, N'381311', NULL, NULL, 0, 24, NULL, N'5412712171', N'5412716380', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Ranch Road', N'Reedsport', N'OR', N'41019', N'97467', 43.695355, -124.135596, 2848, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4559, N'Coquille Valley Hospital District', 1, NULL, NULL, N'381312', NULL, NULL, 0, 30, NULL, N'5413963101', N'5413961783', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'940 East 5Th Street', N'Coquille', N'OR', N'41011', N'97423', 43.17898, -124.178993, 2848, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4560, N'St Charles Prineville', 1, NULL, NULL, N'381313', NULL, NULL, 0, 35, NULL, N'5414478424', N'5414478715', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'384 Se Combs Flat Road', N'Prineville', N'OR', N'41013', N'97754', 44.299307, -120.82699, 2876, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4561, N'Samaritan Pacific Community Hospital', 1, NULL, NULL, N'381314', NULL, NULL, 0, 48, NULL, N'5412652244', N'5415741832', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Sw Abbey Street', N'Newport', N'OR', N'41041', N'97365', 44.630139, -124.06, 2871, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4562, N'Saint Alphonsus Medical Center - Baker City Inc', 1, NULL, NULL, N'381315', NULL, NULL, 0, 36, NULL, N'5415236461', N'5415238151', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3325 Pocahontas Road', N'Baker City', N'OR', N'41001', N'97814', 44.796118, -117.847454, 2845, 79, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4563, N'Peace Harbor Medical Center', 1, NULL, NULL, N'381316', NULL, NULL, 0, 21, NULL, N'5419978412', N'5419972913', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 9Th Street', N'Florence', N'OR', N'41039', N'97439', 43.975335, -124.119339, 2854, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4564, N'Tillamook Regional Medical Center', 1, NULL, NULL, N'381317', NULL, NULL, 0, 49, NULL, N'5038424444', N'5038423062', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Third Street', N'Tillamook', N'OR', N'41057', N'97141', 45.456322, -123.855064, 2884, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4565, N'Providence Hood River Memorial Hospital', 1, NULL, NULL, N'381318', NULL, NULL, 0, 32, NULL, N'5413863911', N'5413876462', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 12Th Street', N'Hood River', N'OR', N'41027', N'97031', 45.704478, -121.523225, 2860, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4566, N'St Anthony Hospital', 1, NULL, NULL, N'381319', NULL, NULL, 0, 49, NULL, N'5412765121', N'5412783678', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 St Anthony Way', N'Pendleton', N'OR', N'41059', N'97801', 45.648775, -118.816194, 2874, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4567, N'Columbia Memorial Hospital', 1, NULL, NULL, N'381320', NULL, NULL, 0, 49, NULL, N'5033254321', N'5033254042', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2111 Exchange Street', N'Astoria', N'OR', N'41007', N'97103', 46.188506, -123.818457, 2844, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4568, N'Grande Ronde Hospital', 1, NULL, NULL, N'381321', NULL, NULL, 0, 49, NULL, N'5419638421', N'5419631476', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Sunset Drive', N'La Grande', N'OR', N'41061', N'97850', 45.319464, -118.104828, 2863, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4569, N'Curry General Hospital', 1, NULL, NULL, N'381322', NULL, NULL, 0, 24, NULL, N'5412473000', N'5412473101', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'94220 Fourth Street', N'ld Beach', N'OR', N'41015', N'97444', 42.411656, -124.418579, 2855, 223, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4570, N'Samaritan Lebanon Community Hospital', 1, NULL, NULL, N'381323', NULL, NULL, 0, 49, NULL, N'5412582101', N'5414517862', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Santiam Highway', N'Lebanon', N'OR', N'41043', N'97355', 44.551681, -122.90889, 2865, 222, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4571, N'St Charles - Madras', 1, NULL, NULL, N'381324', NULL, NULL, 0, 36, NULL, N'5414753882', N'5414604014', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'470 Ne A Street', N'Madras', N'OR', N'41031', N'97741', 44.637375, -121.119549, 2867, 221, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4572, N'od Shepherd Medical Center', 1, NULL, NULL, N'381325', NULL, NULL, 0, 49, NULL, N'5416673400', N'5416673414', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'610 Nw 11Th Street', N'Hermiston', N'OR', N'41059', N'97838', 45.845702, -119.310901, 2858, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4573, N'Vibra Specialty Hospital Of Portland', 1, NULL, NULL, N'382004', NULL, NULL, 0, 73, NULL, N'5032575500', N'5032575673', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 Ne Hancock Street', N'Portland', N'OR', N'41051', N'97220', 45.535773, -122.556529, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4574, N'Shriners Hospital For Children-Portland', 1, NULL, NULL, N'383300', NULL, NULL, 0, 29, NULL, N'5032415090', N'5032213701', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3101 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.501116, -122.684377, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4575, N'Oren State Hospital Distinct Part', 1, NULL, NULL, N'384008', NULL, NULL, 0, 604, NULL, N'5039452870', N'5039452900', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Center Street Ne', N'Salem', N'OR', N'41047', N'97301', 44.939157, -123.033121, 2879, 225, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4576, N'Cedar Hills Hospital', 1, NULL, NULL, N'384012', NULL, NULL, 0, 78, NULL, N'5039445000', N'5039442224', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10300 Sw Eastridge Street', N'Portland', N'OR', N'41067', N'97225', 45.520247, -122.674195, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4577, N'Ohsu Transplant Hospital', 1, NULL, NULL, N'389800', NULL, NULL, 0, 0, NULL, N'5034946096', N'5034944725', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3181 Sw Sam Jackson Park Road', N'Portland', N'OR', N'41051', N'97239', 45.500563, -122.688027, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4578, N'Legacy Transplant Services', 1, NULL, NULL, N'389801', NULL, NULL, 0, 0, NULL, N'5034136722', N'5034136563', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1015 Nw 22 Ave', N'Portland', N'OR', N'41051', N'97210', 45.520247, -122.674195, 2875, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4579, N'Geisinger - Community Medical Center', 1, NULL, NULL, N'390001', NULL, NULL, 0, 297, NULL, N'5709698240', N'5709698951', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1822 Mulberry Street', N'Scranton', N'PA', N'42069', N'18510', 41.400717, -75.64589, 2984, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4580, N'Upmc Mckeesport', 1, NULL, NULL, N'390002', NULL, NULL, 0, 200, NULL, N'4126642000', N'4126642600', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Fifth Avenue', N'Mc Keesport', N'PA', N'42003', N'15132', 40.352292, -79.849272, 2954, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4581, N'Geisinger - Bloomsburg Hospital', 1, NULL, NULL, N'390003', NULL, NULL, 0, 72, NULL, N'5703872100', N'5703872444', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'549 East Fair Street', N'Bloomsburg', N'PA', N'42037', N'17815', 41.010331, -76.44893, 2894, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4582, N'Holy Spirit Hospital', 1, NULL, NULL, N'390004', NULL, NULL, 0, 315, NULL, N'7177632100', N'7177632180', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 North 21St Street', N'Camp Hill', N'PA', N'42041', N'17011', 40.253083, -76.923949, 2903, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4583, N'Geisinger Medical Center', 1, NULL, NULL, N'390006', NULL, NULL, 0, 530, NULL, N'5702716211', N'5702716490', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue', N'Danville', N'PA', N'42093', N'17822', 40.966819, -76.603274, 2914, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4584, N'Ellwood City Hospital', 1, NULL, NULL, N'390008', NULL, NULL, 0, 62, NULL, N'7247520081', N'7247520966', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'724 Pershing Street', N'Ellwood City', N'PA', N'42073', N'16117', 40.869596, -80.274487, 2921, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4585, N'Saint Vincent Hospital', 1, NULL, NULL, N'390009', NULL, NULL, 0, 428, NULL, N'8144525000', N'8144525102', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'232 West 25Th Street', N'Erie', N'PA', N'42049', N'16544', 42.110622, -80.080377, 2923, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4586, N'Lansdale Hospital', 1, NULL, NULL, N'390012', NULL, NULL, 0, 150, NULL, N'2153682100', N'2153614933', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Campus Drive', N'Lansdale', N'PA', N'42091', N'19446', 40.251328, -75.271733, 2945, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4587, N'Evangelical Community Hospital', 1, NULL, NULL, N'390013', NULL, NULL, 0, 181, NULL, N'5705222200', N'5705222745', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive', N'Lewisburg', N'PA', N'42119', N'17837', 40.964529, -76.88441, 2949, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4588, N'Jameson Memorial Hospital', 1, NULL, NULL, N'390016', NULL, NULL, 0, 175, NULL, N'7246589001', N'7246564241', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211 Wilmington Avenue', N'New Castle', N'PA', N'42073', N'16105', 41.013573, -80.351187, 2964, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4589, N'Palmerton Hospital', 1, NULL, NULL, N'390019', NULL, NULL, 0, 70, NULL, N'6108263141', N'6108261282', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 Lafayette Avenue', N'Palmerton', N'PA', N'42025', N'18071', 40.802158, -75.615261, 2967, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4590, N'Kensington Hospital', 1, NULL, NULL, N'390025', NULL, NULL, 0, 45, NULL, N'2154268100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'136 W Diamond Street', N'Philadelphia', N'PA', N'42101', N'19122', 39.985152, -75.159891, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4591, N'Chestnut Hill Hospital', 1, NULL, NULL, N'390026', NULL, NULL, 0, 179, NULL, N'2152488200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8835 Germantown Ave', N'Philadelphia', N'PA', N'42101', N'19118', 40.078271, -75.211419, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4592, N'Temple University Hospital', 1, NULL, NULL, N'390027', NULL, NULL, 0, 677, NULL, N'2157072000', N'2157077351', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3401 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19140', 40.004667, -75.1522, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4593, N'Upmc Mercy', 1, NULL, NULL, N'390028', NULL, NULL, 0, 495, NULL, N'4122328111', N'4122327380', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Locust Street', N'Pittsburgh', N'PA', N'42003', N'15219', 40.436674, -79.983063, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4594, N'Schuylkill Medical Center - South Jackson Street', 1, NULL, NULL, N'390030', NULL, NULL, 0, 180, NULL, N'5706215000', N'5706228221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 South Jackson Street', N'Pottsville', N'PA', N'42107', N'17901', 40.683751, -76.188861, 2975, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4595, N'Schuylkill Medical Center - East Norwegian Street', 1, NULL, NULL, N'390031', NULL, NULL, 0, 174, NULL, N'5706214000', N'5706227950', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Norwegian Street', N'Pottsville', N'PA', N'42107', N'17901', 40.689488, -76.1884, 2975, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4596, N'Allegheny Valley Hospital', 1, NULL, NULL, N'390032', NULL, NULL, 0, 250, NULL, N'4122245100', N'7242267490', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Carlisle St', N'Natrona', N'PA', N'42003', N'15065', 40.617196, -79.737562, 2963, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4597, N'St Luke''s Quakertown Hospital', 1, NULL, NULL, N'390035', NULL, NULL, 0, 62, NULL, N'2155384500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1021 Park Avenue', N'Quakertown', N'PA', N'42017', N'18951', 40.437793, -75.348749, 2977, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4598, N'Heritage Valley Beaver', 1, NULL, NULL, N'390036', NULL, NULL, 0, 361, NULL, N'4127287000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Dutch Ridge Road', N'Beaver', N'PA', N'42007', N'15009', 40.710345, -80.324352, 2891, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4599, N'Heritage Valley Sewickley', 1, NULL, NULL, N'390037', NULL, NULL, 0, 186, NULL, N'4127416600', N'4127497400', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Blackburn Road', N'Sewickley', N'PA', N'42003', N'15143', 40.543554, -80.178702, 2986, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4600, N'Somerset Hospital', 1, NULL, NULL, N'390039', NULL, NULL, 0, 111, NULL, N'8144435000', N'8144434937', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 South Center Avenue', N'Somerset', N'PA', N'42111', N'15501', 40.007101, -79.078628, 2989, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4601, N'Uniontown Hospital', 1, NULL, NULL, N'390041', NULL, NULL, 0, 190, NULL, N'7244305000', N'7244303342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Berkeley Street', N'Uniontown', N'PA', N'42051', N'15401', 39.901938, -79.737546, 3000, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4602, N'Washington Hospital The', 1, NULL, NULL, N'390042', NULL, NULL, 0, 260, NULL, N'7242257000', N'7242227316', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'155 Wilson Avenue', N'Washington', N'PA', N'42125', N'15301', 40.183235, -80.247501, 3004, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4603, N'Soldiers And Sailors Memorial Hospital', 1, NULL, NULL, N'390043', NULL, NULL, 0, 103, NULL, N'5707241631', N'5707242126', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'32-36 Central Avenue', N'Wellsboro', N'PA', N'42117', N'16901', 41.726748, -77.287301, 3007, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4604, N'Reading Hospital', 1, NULL, NULL, N'390044', NULL, NULL, 0, 639, NULL, N'6109888000', N'6109885192', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Sixth Avenue And Spruce St', N'Reading', N'PA', N'42011', N'19603', 40.335345, -75.927949, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4605, N'Williamsport Regional Medical Center', 1, NULL, NULL, N'390045', NULL, NULL, 0, 238, NULL, N'5703211000', N'5703213719', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 High Street', N'Williamsport', N'PA', N'42081', N'17701', 41.24542, -77.01453, 3011, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4606, N'York Hospital', 1, NULL, NULL, N'390046', NULL, NULL, 0, 572, NULL, N'7178512345', N'7178513020', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 South George Street', N'York', N'PA', N'42133', N'17403', 39.945256, -76.719695, 3013, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4607, N'Geisinger-Lewistown Hospital', 1, NULL, NULL, N'390048', NULL, NULL, 0, 244, NULL, N'7172485411', N'7172427132', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Highland Avenue', N'Lewistown', N'PA', N'42087', N'17044', 40.617243, -77.56832, 2950, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4608, N'St Luke''s Hospital Bethlehem', 1, NULL, NULL, N'390049', NULL, NULL, 0, 638, NULL, N'6109544000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Ostrum Street', N'Bethlehem', N'PA', N'42095', N'18015', 40.60918, -75.39206, 2893, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4609, N'Allegheny General Hospital', 1, NULL, NULL, N'390050', NULL, NULL, 0, 829, NULL, N'4123593131', N'4123593888', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 East North Avenue', N'Pittsburgh', N'PA', N'42003', N'15212', 40.456142, -80.003285, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4610, N'Clearfield Hospital', 1, NULL, NULL, N'390052', NULL, NULL, 0, 89, NULL, N'8147682497', N'8147682421', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Turnpike Ave', N'Clearfield', N'PA', N'42033', N'16830', 41.033397, -78.450279, 2909, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4611, N'J C Blair Memorial Hospital', 1, NULL, NULL, N'390056', NULL, NULL, 0, 100, NULL, N'8146432290', N'8146439718', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1225 Warm Springs Ave', N'Huntingdon', N'PA', N'42061', N'16652', 40.493528, -78.013981, 2935, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4612, N'Grand View Hospital', 1, NULL, NULL, N'390057', NULL, NULL, 0, 250, NULL, N'2154534615', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Lawn Avenue', N'Sellersville', N'PA', N'42017', N'18960', 40.363298, -75.325342, 2985, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4613, N'Carlisle Regional Medical Center', 1, NULL, NULL, N'390058', NULL, NULL, 0, 165, NULL, N'7172491212', N'7172490770', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'361 Alexander Spring Road', N'Carlisle', N'PA', N'42041', N'17015', 40.184767, -77.223007, 2906, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4614, N'Lancaster Regional Medical Center', 1, NULL, NULL, N'390061', NULL, NULL, 0, 290, NULL, N'7172918123', N'7172918090', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 College Avenue', N'Lancaster', N'PA', N'42071', N'17604', 40.040507, -76.320674, 2943, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4615, N'Nason Hospital', 1, NULL, NULL, N'390062', NULL, NULL, 0, 42, NULL, N'8142242141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'105 Nason Drive', N'Roaring Spring', N'PA', N'42013', N'16673', 40.338038, -78.388829, 2982, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4616, N'Upmc Hamot', 1, NULL, NULL, N'390063', NULL, NULL, 0, 343, NULL, N'8148776000', N'8148774150', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 State Street', N'Erie', N'PA', N'42049', N'16550', 42.133463, -80.087915, 2923, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4617, N'Gettysburg Hospital', 1, NULL, NULL, N'390065', NULL, NULL, 0, 76, NULL, N'7173342121', N'7173374142', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'147 Gettys Street', N'Gettysburg', N'PA', N'42001', N'17325', 39.823318, -77.234044, 2926, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4618, N'od Samaritan Hospital', 1, NULL, NULL, N'390066', NULL, NULL, 0, 196, NULL, N'7172707500', N'7172702239', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Fourth And Walnut Streets', N'Lebanon', N'PA', N'42075', N'17042', 40.34655, -76.428381, 2947, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4619, N'Pinnacle Health Hospitals', 1, NULL, NULL, N'390067', NULL, NULL, 0, 717, NULL, N'7177825181', N'7172318860', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 South Second Street', N'Harrisburg', N'PA', N'42043', N'17105', 40.229944, -76.83211, 2931, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4620, N'Heart Of Lancaster Regional Medical Center', 1, NULL, NULL, N'390068', NULL, NULL, 0, 206, NULL, N'7176255000', N'7172394301', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Highlands Drive', N'Lititz', N'PA', N'42071', N'17543', 40.131086, -76.310857, 2943, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4621, N'Lower Bucks Hospital', 1, NULL, NULL, N'390070', NULL, NULL, 0, 186, NULL, N'2157859200', N'2157859175', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Bath Road', N'Bristol', N'PA', N'42017', N'19007', 40.103681, -74.864448, 2897, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4622, N'Lock Haven Hospital', 1, NULL, NULL, N'390071', NULL, NULL, 0, 47, NULL, N'5708935000', N'5708935172', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24 Cree Drive', N'Lock Haven', N'PA', N'42035', N'17745', 41.132612, -77.470816, 2951, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4623, N'Berwick Hospital Center', 1, NULL, NULL, N'390072', NULL, NULL, 0, 130, NULL, N'5707595000', N'5707593473', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East 16Th Street', N'Berwick', N'PA', N'42037', N'18603', 41.070178, -76.230739, 2892, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4624, N'Upmc Altoona', 1, NULL, NULL, N'390073', NULL, NULL, 0, 433, NULL, N'8148892011', N'8148897808', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Howard Avenue', N'Altoona', N'PA', N'42013', N'16601', 40.521085, -78.398301, 2889, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4625, N'Brandywine Hospital', 1, NULL, NULL, N'390076', NULL, NULL, 0, 208, NULL, N'6103838000', N'6103838360', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Reeceville Road', N'Coatesville', N'PA', N'42029', N'19320', 40.00914, -75.790187, 2902, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4626, N'Robert Packer Hospital', 1, NULL, NULL, N'390079', NULL, NULL, 0, 366, NULL, N'5708886666', N'5708825091', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Guthrie Square', N'Sayre', N'PA', N'42015', N'18840', 41.978963, -76.515499, 2983, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4627, N'Jeanes Hospital', 1, NULL, NULL, N'390080', NULL, NULL, 0, 176, NULL, N'2157282000', N'2157282026', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Central Avenue', N'Philadelphia', N'PA', N'42101', N'19111', 40.069437, -75.086183, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4628, N'Delaware County Memorial Hospital', 1, NULL, NULL, N'390081', NULL, NULL, 0, 247, NULL, N'2152848100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 North Lansdowne Ave', N'Drexel Hill', N'PA', N'42045', N'19026', 39.953877, -75.283921, 2917, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4629, N'Sunbury Community Hospital', 1, NULL, NULL, N'390084', NULL, NULL, 0, 96, NULL, N'5702863333', N'5708632128', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 North 11Th Street', N'Sunbury', N'PA', N'42097', N'17801', 40.862531, -76.777713, 2993, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4630, N'Penn Highlands Dubois', 1, NULL, NULL, N'390086', NULL, NULL, 0, 250, NULL, N'8143712200', N'8143753488', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Avenue', N'Dubois', N'PA', N'42033', N'15801', 41.114096, -78.775305, 2918, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4631, N'Western Pennsylvania Hospital', 1, NULL, NULL, N'390090', NULL, NULL, 0, 500, NULL, N'4125785000', N'4125784441', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Friendship Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.462419, -79.946435, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4632, N'Upmc Northwest', 1, NULL, NULL, N'390091', NULL, NULL, 0, 173, NULL, N'8146767600', N'8146767150', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fairfield Drive', N'Seneca', N'PA', N'42121', N'16346', 41.360026, -79.707926, 2925, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4633, N'Clarion Hospital', 1, NULL, NULL, N'390093', NULL, NULL, 0, 82, NULL, N'8142269500', N'8142261224', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Drive', N'Clarion', N'PA', N'42031', N'16214', 41.214785, -79.385322, 2908, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4634, N'St Joseph Medical Center', 1, NULL, NULL, N'390096', NULL, NULL, 0, 240, NULL, N'6103782300', N'6103782798', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Bernville Road', N'Reading', N'PA', N'42011', N'19605', 40.376697, -75.9776, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4635, N'Holy Redeemer Hospital And Medical Center', 1, NULL, NULL, N'390097', NULL, NULL, 0, 268, NULL, N'2159473000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1648 Huntingdon Pike', N'Meadowbrook', N'PA', N'42091', N'19046', 40.108944, -75.081101, 2886, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4636, N'Lancaster General Hospital', 1, NULL, NULL, N'390100', NULL, NULL, 0, 463, NULL, N'7172995511', N'7172904189', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 North Duke Street', N'Lancaster', N'PA', N'42071', N'17604', 40.047353, -76.305399, 2943, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4637, N'Memorial Hospital', 1, NULL, NULL, N'390101', NULL, NULL, 0, 150, NULL, N'7178438623', N'7178495329', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 South Belmont Street', N'York', N'PA', N'42133', N'17403', 39.967244, -76.693816, 3013, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4638, N'Upmc St Margaret', 1, NULL, NULL, N'390102', NULL, NULL, 0, 237, NULL, N'4127844000', N'4127844008', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Freeport Road', N'Pittsburgh', N'PA', N'42003', N'15215', 40.487848, -79.897459, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4639, N'Kane Community Hospital', 1, NULL, NULL, N'390104', NULL, NULL, 0, 31, NULL, N'8148378585', N'8148377992', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4372 Route 6', N'Kane', N'PA', N'42083', N'16735', 41.673383, -78.731046, 2940, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4640, N'Upmc Passavant', 1, NULL, NULL, N'390107', NULL, NULL, 0, 346, NULL, N'4123676700', N'4123676527', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9100 Babcock Boulevard', N'Pittsburgh', N'PA', N'42003', N'15237', 40.567453, -80.016508, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4641, N'Memorial Medical Center', 1, NULL, NULL, N'390110', NULL, NULL, 0, 486, NULL, N'8145349000', N'8145340264', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1086 Franklin Street', N'Johnstown', N'PA', N'42021', N'15905', 40.305149, -78.918335, 2939, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4642, N'Hospital Of Univ Of Pennsylvania', 1, NULL, NULL, N'390111', NULL, NULL, 0, 782, NULL, N'2156623227', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34Th & Spruce Sts', N'Philadelphia', N'PA', N'42101', N'19104', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4643, N'Windber Hospital', 1, NULL, NULL, N'390112', NULL, NULL, 0, 54, NULL, N'8144673000', N'8144673451', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Somerset Avenue', N'Windber', N'PA', N'42111', N'15963', 40.241759, -78.837501, 3012, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4644, N'Meadville Medical Center', 1, NULL, NULL, N'390113', NULL, NULL, 0, 217, NULL, N'8143335000', N'8143335496', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Liberty Street', N'Meadville', N'PA', N'42039', N'16335', 41.642259, -80.146166, 2955, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4645, N'Magee Womens Hospital Of Upmc Health System', 1, NULL, NULL, N'390114', NULL, NULL, 0, 341, NULL, N'4126414010', N'4126411221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Halket Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.437634, -79.960239, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4646, N'Aria Health', 1, NULL, NULL, N'390115', NULL, NULL, 0, 464, NULL, N'2156124129', N'2156124942', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10800 Knights Road', N'Philadelphia', N'PA', N'42101', N'19114', 40.070614, -74.981446, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4647, N'Mercy Suburban Hospital', 1, NULL, NULL, N'390116', NULL, NULL, 0, 130, NULL, N'2152782000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Dekalb Pike', N'Norristown', N'PA', N'42091', N'19401', 40.138631, -75.31561, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4648, N'Upmc Bedford Memorial', 1, NULL, NULL, N'390117', NULL, NULL, 0, 95, NULL, N'8146236161', N'8146237202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10455 Lincoln Highway', N'Everett', N'PA', N'42009', N'15537', 40.02476, -78.43367, 2924, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4649, N'Bradford Regional Medical Center', 1, NULL, NULL, N'390118', NULL, NULL, 0, 109, NULL, N'8143684143', N'8143685722', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 Interstate Parkway', N'Bradford', N'PA', N'42083', N'16701', 41.960825, -78.660094, 2896, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4650, N'Moses Taylor Hospital', 1, NULL, NULL, N'390119', NULL, NULL, 0, 290, NULL, N'5703402100', N'5709692629', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Quincy Avenue', N'Scranton', N'PA', N'42069', N'18510', 41.41052, -75.650985, 2984, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4651, N'Pottstown Memorial Medical Center', 1, NULL, NULL, N'390123', NULL, NULL, 0, 205, NULL, N'6103277000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 East High Street And Armand Hammer Blvd', N'Pottstown', N'PA', N'42091', N'19464', 40.243925, -75.613439, 2974, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4652, N'Wayne Memorial Hospital', 1, NULL, NULL, N'390125', NULL, NULL, 0, 112, NULL, N'5702538100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Park Street', N'Honesdale', N'PA', N'42127', N'18431', 41.576188, -75.259945, 2934, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4653, N'Phoenixville Hospital', 1, NULL, NULL, N'390127', NULL, NULL, 0, 206, NULL, N'6109831000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'140 Nutt Road', N'Phoenixville', N'PA', N'42029', N'19460', 40.124692, -75.515616, 2972, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4654, N'Conemaugh Miners Medical Center', 1, NULL, NULL, N'390130', NULL, NULL, 0, 30, NULL, N'8142473100', N'8142473119', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'290 Haida Avenue', N'Hastings', N'PA', N'42021', N'16646', 40.658872, -78.705497, 2990, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4655, N'St Joseph''s Hospital', 1, NULL, NULL, N'390132', NULL, NULL, 0, 146, NULL, N'2157872000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West Girard Avenue', N'Philadelphia', N'PA', N'42101', N'19130', 39.971975, -75.163506, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4656, N'Lehigh Valley Hospital', 1, NULL, NULL, N'390133', NULL, NULL, 0, 797, NULL, N'6104022273', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 South Cedar Crest Boulvard', N'Allentown', N'PA', N'42077', N'18105', 40.622901, -75.43604, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4657, N'Wilkes-Barre General Hospital', 1, NULL, NULL, N'390137', NULL, NULL, 0, 412, NULL, N'5708298111', N'5705523030', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'575 North River Street', N'Wilkes-Barre', N'PA', N'42079', N'18764', 41.258431, -75.868104, 3010, 238, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4658, N'Waynesboro Hospital', 1, NULL, NULL, N'390138', NULL, NULL, 0, 69, NULL, N'7177654000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 East Main St', N'Waynesboro', N'PA', N'42055', N'17268', 39.753538, -77.574023, 3005, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4659, N'Main Line Hospital Bryn Mawr Campus', 1, NULL, NULL, N'390139', NULL, NULL, 0, 320, NULL, N'6105263000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 South Bryn Mawr Ave', N'Bryn Mawr', N'PA', N'42045', N'19010', 40.018404, -75.320609, 2900, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4660, N'Albert Einstein Medical Center', 1, NULL, NULL, N'390142', NULL, NULL, 0, 783, NULL, N'2154566090', N'2154566199', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 Old York Road', N'Philadelphia', N'PA', N'42101', N'19141', 40.037127, -75.144679, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4661, N'Excela Health Westmoreland Hospital', 1, NULL, NULL, N'390145', NULL, NULL, 0, 364, NULL, N'4128325050', N'4128325051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'532 West Pittsburgh Street', N'Greensburg', N'PA', N'42129', N'15601', 40.301281, -79.555472, 2927, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4662, N'Warren General Hospital', 1, NULL, NULL, N'390146', NULL, NULL, 0, 87, NULL, N'8147233300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Crescent Park West', N'Warren', N'PA', N'42123', N'16365', 41.843949, -79.145044, 3003, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4663, N'Monongahela Valley Hospital', 1, NULL, NULL, N'390147', NULL, NULL, 0, 210, NULL, N'7242581000', N'7242581365', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1163 Country Club Road', N'Monongahela', N'PA', N'42125', N'15063', 40.181566, -79.916274, 2958, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4664, N'Washington Health System Greene', 1, NULL, NULL, N'390150', NULL, NULL, 0, 69, NULL, N'7246272602', N'7246277639', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Bonar Avenue', N'Waynesburg', N'PA', N'42059', N'15370', 39.900605, -80.173929, 3006, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4665, N'Chambersburg Hospital', 1, NULL, NULL, N'390151', NULL, NULL, 0, 217, NULL, N'7172673000', N'7172677704', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 North Seventh Street', N'Chambersburg', N'PA', N'42055', N'17201', 39.934915, -77.647451, 2907, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4666, N'Main Line Hospital Paoli', 1, NULL, NULL, N'390153', NULL, NULL, 0, 157, NULL, N'6106481000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 West Lancaster Avenue', N'Paoli', N'PA', N'42029', N'19301', 40.042097, -75.499806, 2968, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4667, N'Mercy Fitzgerald Hospital', 1, NULL, NULL, N'390156', NULL, NULL, 0, 447, NULL, N'2152374000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Lansdowne & Baily Rds', N'Darby', N'PA', N'42045', N'19023', 39.918446, -75.259072, 2915, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4668, N'Ohio Valley General Hospital', 1, NULL, NULL, N'390157', NULL, NULL, 0, 138, NULL, N'4127776161', N'4127776189', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Heckel Road', N'Mckees Rocks', N'PA', N'42003', N'15136', 40.471782, -80.091749, 2953, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4669, N'Canonsburg General Hospital', 1, NULL, NULL, N'390160', NULL, NULL, 0, 104, NULL, N'7248735892', N'7247437211', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Boulevard', N'Canonsburg', N'PA', N'42125', N'15317', 40.248875, -80.190117, 2904, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4670, N'Easton Hospital', 1, NULL, NULL, N'390162', NULL, NULL, 0, 254, NULL, N'6102504076', N'6102504957', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 South 21St Street', N'Easton', N'PA', N'42095', N'18042', 40.686379, -75.242894, 2920, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4671, N'Acmh Hospital', 1, NULL, NULL, N'390163', NULL, NULL, 0, 154, NULL, N'7245438500', N'7245438535', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Nolte Drive', N'Kittanning', N'PA', N'42005', N'16201', 40.816453, -79.521989, 2942, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4672, N'Upmc Presbyterian Shadyside', 1, NULL, NULL, N'390164', NULL, NULL, 0, 1571, NULL, N'4126478788', N'4126475551', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.441778, -79.960674, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4673, N'Butler Memorial Hospital', 1, NULL, NULL, N'390168', NULL, NULL, 0, 296, NULL, N'7242836666', N'7242844645', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Hospital Way', N'Butler', N'PA', N'42019', N'16001', 40.861021, -79.895225, 2901, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4674, N'Indiana Regional Medical Center', 1, NULL, NULL, N'390173', NULL, NULL, 0, 164, NULL, N'7243577000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 Hospital Road', N'Indiana', N'PA', N'42063', N'15701', 40.608728, -79.158893, 2936, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4675, N'Thomas Jefferson University Hospital', 1, NULL, NULL, N'390174', NULL, NULL, 0, 925, NULL, N'2159556000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South 11Th Street', N'Philadelphia', N'PA', N'42101', N'19107', 39.949632, -75.15877, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4676, N'Upmc Horizon', 1, NULL, NULL, N'390178', NULL, NULL, 0, 201, NULL, N'7245882100', N'7245882289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 North Main Street', N'Greenville', N'PA', N'42085', N'16125', 41.411218, -80.371781, 2928, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4677, N'Chester County Hospital', 1, NULL, NULL, N'390179', NULL, NULL, 0, 263, NULL, N'6104315000', N'6107382554', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 East Marshall Street', N'West Chester', N'PA', N'42029', N'19380', 39.972278, -75.600736, 3008, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4678, N'Crozer Chester Medical Center', 1, NULL, NULL, N'390180', NULL, NULL, 0, 672, NULL, N'6104472000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Boulevard', N'Upland', N'PA', N'42045', N'19013', 39.852612, -75.382692, 3001, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4679, N'St Luke''s Miners Memorial Hospital', 1, NULL, NULL, N'390183', NULL, NULL, 0, 108, NULL, N'5706452131', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'360 W Ruddle Street', N'Coaldale', N'PA', N'42107', N'18218', 40.821424, -75.914666, 2910, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4680, N'Highlands Hospital', 1, NULL, NULL, N'390184', NULL, NULL, 0, 64, NULL, N'7246281500', N'7246262334', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 East Murphy Avenue', N'Connellsville', N'PA', N'42051', N'15425', 40.023372, -79.586222, 2911, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4681, N'Lehigh Valley Hospital - Hazleton', 1, NULL, NULL, N'390185', NULL, NULL, 0, 120, NULL, N'5705014000', N'5705016203', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Broad Street', N'Hazleton', N'PA', N'42079', N'18201', 40.950464, -75.963454, 2932, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4682, N'Tyler Memorial Hospital', 1, NULL, NULL, N'390192', NULL, NULL, 0, 60, NULL, N'5708362161', N'5708367057', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5950 State Route 6 West', N'Tunkhannock', N'PA', N'42131', N'18657', 41.538516, -75.946844, 2997, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4683, N'Gnaden Huetten Memorial Hospital', 1, NULL, NULL, N'390194', NULL, NULL, 0, 105, NULL, N'6073771300', N'6103777920', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 North 12Th Street', N'Lehighton', N'PA', N'42025', N'18235', 40.831391, -75.726658, 2948, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4684, N'Main Line Hospital Lankenau', 1, NULL, NULL, N'390195', NULL, NULL, 0, 331, NULL, N'6106452000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Lancaster Ave', N'Wynnewood', N'PA', N'42091', N'19096', 39.990473, -75.258688, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4685, N'Hospital Of The Fox Chase Cancer Center', 1, NULL, NULL, N'390196', NULL, NULL, 0, 100, NULL, N'2157282660', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Cottman Avenue', N'Philadelphia', N'PA', N'42101', N'19111', 40.066732, -75.092688, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4686, N'Sacred Heart Hospital', 1, NULL, NULL, N'390197', NULL, NULL, 0, 215, NULL, N'6107764900', N'6107764559', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 Chew Street', N'Allentown', N'PA', N'42077', N'18102', 40.60794, -75.468209, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4687, N'Millcreek Community Hospital', 1, NULL, NULL, N'390198', NULL, NULL, 0, 144, NULL, N'8148644031', N'8148688249', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5515 Peach Street', N'Erie', N'PA', N'42049', N'16509', 42.073574, -80.093648, 2923, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4688, N'Punxsutawney Area Hospital', 1, NULL, NULL, N'390199', NULL, NULL, 0, 49, NULL, N'8149381800', N'8149381630', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'81 Hillcrest Drive', N'Punxsutawney', N'PA', N'42065', N'15767', 40.961663, -78.999497, 2976, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4689, N'Pocono Medical Center', 1, NULL, NULL, N'390201', NULL, NULL, 0, 239, NULL, N'5704763348', N'5704763478', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'206 East Brown Street', N'East Stroudsburg', N'PA', N'42089', N'18301', 40.992232, -75.1747, 2919, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4690, N'Doylestown Hospital', 1, NULL, NULL, N'390203', NULL, NULL, 0, 239, NULL, N'2153452200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 West State St', N'Doylestown', N'PA', N'42017', N'18901', 40.304193, -75.144395, 2916, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4691, N'Nazareth Hospital', 1, NULL, NULL, N'390204', NULL, NULL, 0, 203, NULL, N'2153356000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Holme Ave', N'Philadelphia', N'PA', N'42101', N'19152', 40.058698, -75.043505, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4692, N'Sharon Regional Health System', 1, NULL, NULL, N'390211', NULL, NULL, 0, 220, NULL, N'7249833800', N'7249833958', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'740 East State Street', N'Sharon', N'PA', N'42085', N'16146', 41.233009, -80.495487, 2988, 217, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4693, N'Excela Health Frick Hospital', 1, NULL, NULL, N'390217', NULL, NULL, 0, 210, NULL, N'7245471500', N'7248321266', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 South Church Street', N'Mount Pleasant', N'PA', N'42129', N'15666', 40.145895, -79.547984, 2961, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4694, N'Excela Health Latrobe Hospital', 1, NULL, NULL, N'390219', NULL, NULL, 0, 188, NULL, N'7245371000', N'7245371447', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Mellon Way', N'Latrobe', N'PA', N'42129', N'15650', 40.321181, -79.379481, 2946, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4695, N'Jennersville Regional Hospital', 1, NULL, NULL, N'390220', NULL, NULL, 0, 59, NULL, N'6108691000', N'6108691362', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1015 West Baltimore Pike', N'West Grove', N'PA', N'42029', N'19390', 39.822837, -75.887059, 3009, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4696, N'Riddle Memorial Hospital', 1, NULL, NULL, N'390222', NULL, NULL, 0, 212, NULL, N'6105669400', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1068 West Baltimore Pike', N'Media', N'PA', N'42045', N'19063', 39.914616, -75.427934, 2956, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4697, N'Penn Presbyterian Medical Center', 1, NULL, NULL, N'390223', NULL, NULL, 0, 305, NULL, N'2156628000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'51 North 39Th Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.956982000000004, -75.199595, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4698, N'Ephrata Community Hospital', 1, NULL, NULL, N'390225', NULL, NULL, 0, 130, NULL, N'7177330311', N'7177836675', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Martin Avenue', N'Ephrata', N'PA', N'42071', N'17522', 40.186866, -76.184268, 2922, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4699, N'Pennsylvania Hospital', 1, NULL, NULL, N'390226', NULL, NULL, 0, 460, NULL, N'2158293000', N'2158293614', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Spruce Street', N'Philadelphia', N'PA', N'42101', N'19107', 39.945775, -75.155177, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4700, N'St Clair Hospital', 1, NULL, NULL, N'390228', NULL, NULL, 0, 328, NULL, N'4129424000', N'4129426219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Bower Hill Road', N'Pittsburgh', N'PA', N'42003', N'15243', 40.377593, -80.06568, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4701, N'Abington Memorial Hospital', 1, NULL, NULL, N'390231', NULL, NULL, 0, 880, NULL, N'2154812000', N'2154814014', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Old York Road', N'Abington', N'PA', N'42091', N'19001', 40.119002, -75.119351, 2886, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4702, N'Hanover Hospital', 1, NULL, NULL, N'390233', NULL, NULL, 0, 111, NULL, N'7176373711', N'7176332217', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Highland Ave', N'Hanover', N'PA', N'42133', N'17331', 39.807981, -76.983731, 2930, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4703, N'Memorial Hospital Inc  Towanda', 1, NULL, NULL, N'390236', NULL, NULL, 0, 41, NULL, N'5702652191', N'5702655763', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'91 Hospital Drive', N'Towanda', N'PA', N'42015', N'18848', 41.783843, -76.448514, 2996, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4704, N'Regional Hospital Of Scranton', 1, NULL, NULL, N'390237', NULL, NULL, 0, 198, NULL, N'5703487100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'746 Jefferson Avenue', N'Scranton', N'PA', N'42069', N'18501', 41.412848, -75.654047, 2984, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4705, N'Milton S Hershey Medical Center', 1, NULL, NULL, N'390256', NULL, NULL, 0, 504, NULL, N'7175318521', N'7175313991', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 University Drive', N'Hershey', N'PA', N'42043', N'17033', 40.265932, -76.674557, 2933, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4706, N'St Mary Medical Center', 1, NULL, NULL, N'390258', NULL, NULL, 0, 287, NULL, N'2157502003', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Langhorne-Newtown Rd', N'Langhorne', N'PA', N'42017', N'19047', 40.200277, -74.929484, 2944, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4707, N'Lehigh Valley Hospital - Muhlenberg', 1, NULL, NULL, N'390263', NULL, NULL, 0, 184, NULL, N'6104022273', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2545 Schoenersville Road', N'Bethlehem', N'PA', N'42077', N'18017', 40.646085, -75.406613, 2893, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4708, N'Jefferson Regional Medical Center', 1, NULL, NULL, N'390265', NULL, NULL, 0, 390, NULL, N'4124695000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'565 Coal Valley Rd', N'Pittsburgh', N'PA', N'42003', N'15236', 40.441694, -79.990086, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4709, N'Grove City Medical Center', 1, NULL, NULL, N'390266', NULL, NULL, 0, 90, NULL, N'7244507000', N'7244507179', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 North Broad Street Ext.', N'Grove City', N'PA', N'42085', N'16127', 41.170709, -80.083156, 2929, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4710, N'Forbes Hospital', 1, NULL, NULL, N'390267', NULL, NULL, 0, 353, NULL, N'4128582000', N'4128582532', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2570 Haymaker Road', N'Monroeville', N'PA', N'42003', N'15146', 40.428517, -79.751233, 2959, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4711, N'Mount Nittany Medical Center', 1, NULL, NULL, N'390268', NULL, NULL, 0, 260, NULL, N'8142317000', N'8142317200', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 East Park Ave', N'State College', N'PA', N'42027', N'16803', 40.834025, -77.836985, 2992, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4712, N'Geisinger Wyoming Valley Medical Center', 1, NULL, NULL, N'390270', NULL, NULL, 0, 177, NULL, N'5708267300', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East Mountain Boulevard', N'Wilkes Barre', N'PA', N'42079', N'18711', 41.250596, -75.808445, 3010, 238, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4713, N'Valley Forge Medical Center And Hospital', 1, NULL, NULL, N'390272', NULL, NULL, 0, 67, NULL, N'2155398500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1033 W Germantown Pike', N'Norristown', N'PA', N'42091', N'19401', 40.156662, -75.369528, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4714, N'Eagleville Hospital', 1, NULL, NULL, N'390278', NULL, NULL, 0, 83, NULL, N'2155396000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Eagleville Rd', N'Eagleville', N'PA', N'42091', N'19408', 40.155844, -75.411929, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4715, N'Hahnemann University Hospital', 1, NULL, NULL, N'390290', NULL, NULL, 0, 541, NULL, N'2157627000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19102', 39.956847, -75.162705, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4716, N'Barix Clinics Of Pennsylvania', 1, NULL, NULL, N'390302', NULL, NULL, 0, 47, NULL, N'2675723100', N'2675723113', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'280 Middletown Road', N'Langhorne', N'PA', N'42017', N'19047', 40.181801, -74.884542, 2944, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4717, N'Roxborough Memorial Hospital', 1, NULL, NULL, N'390304', NULL, NULL, 0, 137, NULL, N'2154839900', N'2154874274', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5800 Ridge Ave', N'Philadelphia', N'PA', N'42101', N'19128', 40.029609, -75.211022, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4718, N'Edgewood Surgical Hospital', 1, NULL, NULL, N'390307', NULL, NULL, 0, 10, NULL, N'7246460400', N'7246460413', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'239 Edgewood Drive Extension', N'Transfer', N'PA', N'42085', N'16154', 41.33006, -80.417159, 2928, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4719, N'Cancer Treatment Centers Of America', 1, NULL, NULL, N'390312', NULL, NULL, 0, 22, NULL, N'2157446728', N'2157446715', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1331 East Wyoming Avenue', N'Philadelphia', N'PA', N'42101', N'19124', 40.018297, -75.098455, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4720, N'Coordinated Health Orthopedic Hospital', 1, NULL, NULL, N'390314', NULL, NULL, 0, 20, NULL, N'6106914300', N'6106916257', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2310 Highland Avenue', N'Bethlehem', N'PA', N'42077', N'18017', 40.674111, -75.364584, 2893, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4721, N'Surgical Institute Of Reading', 1, NULL, NULL, N'390316', NULL, NULL, 0, 15, NULL, N'7179999999', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2752 Century Boulevard', N'Wyomissing', N'PA', N'42011', N'19610', 40.358283, -75.98768, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4722, N'Surgical Specialty Center At Coordinated Health', 1, NULL, NULL, N'390321', NULL, NULL, 0, 20, NULL, N'6108719110', N'6108415020', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1503 Cedar Crest Boulevard', N'Allentown', N'PA', N'42077', N'18104', 40.61219, -75.53275, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4723, N'Rothman Orthopaedic Specialty Hospital Llc', 1, NULL, NULL, N'390322', NULL, NULL, 0, 24, NULL, N'2152447400', N'2152447480', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Tillman Drive', N'Bensalem', N'PA', N'42017', N'19020', 40.113303, -74.961728, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4724, N'Advanced Surgical Hospital', 1, NULL, NULL, N'390323', NULL, NULL, 0, 32, NULL, N'7248840710', N'7248840722', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Trich Drive', N'Washington', N'PA', N'42125', N'15301', 40.156976, -80.280875, 3004, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4725, N'Physician''s Care Surgical Hospital', 1, NULL, NULL, N'390324', NULL, NULL, 0, 12, NULL, N'6104954793', N'6104953323', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'454 Enterprise Drive', N'Royersford', N'PA', N'42091', N'19468', 40.216783, -75.553437, 2972, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4726, N'Oss Orthopaedic Hospital', 1, NULL, NULL, N'390325', NULL, NULL, 0, 38, NULL, N'7177182000', N'7177183640', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1861 Powder Mill Rd', N'York', N'PA', N'42133', N'17402', 39.916512, -76.696778, 3013, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4727, N'St Luke''s Hospital - Anderson Campus', 1, NULL, NULL, N'390326', NULL, NULL, 0, 72, NULL, N'6109543850', N'6109546063', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1872 Riverside Circle', N'Easton', N'PA', N'42095', N'18045', 40.648978, -75.290063, 2920, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4728, N'Wellspan Surgery And Rehabilitation Hospital', 1, NULL, NULL, N'390327', NULL, NULL, 0, 73, NULL, N'7178126100', N'7177472994', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'55 Monument Road', N'York', N'PA', N'42133', N'17403', 39.923342, -76.716747, 3013, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4729, N'Upmc East', 1, NULL, NULL, N'390328', NULL, NULL, 0, 156, NULL, N'4123573000', N'4123723024', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2775 Mosside Boulevard', N'Monroeville', N'PA', N'42003', N'15146', 40.436729, -79.757977, 2959, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4730, N'Einstein Medical Center Montmery', 1, NULL, NULL, N'390329', NULL, NULL, 0, 146, NULL, N'4846621000', N'4846624261', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'559 West Germantown Pike', N'East Norriton', N'PA', N'42091', N'19403', 40.150788, -75.34299, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4731, N'Jersey Shore Hospital', 1, NULL, NULL, N'391300', NULL, NULL, 0, 25, NULL, N'5703980100', N'5703984412', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 Thompson Street', N'Jersey Shore', N'PA', N'42081', N'17740', 41.201649, -77.267976, 2938, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4732, N'Muncy Valley Hospital', 1, NULL, NULL, N'391301', NULL, NULL, 0, 20, NULL, N'5705468282', N'5705464150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 East Water Street', N'Muncy', N'PA', N'42081', N'17756', 41.209409, -76.774528, 2962, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4733, N'Meyersdale Medical Center', 1, NULL, NULL, N'391302', NULL, NULL, 0, 20, NULL, N'8146345911', N'8146340435', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Myersdale', N'PA', N'42111', N'15552', 39.80843, -79.026068, 2957, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4734, N'Fulton County Medical Center', 1, NULL, NULL, N'391303', NULL, NULL, 0, 21, NULL, N'7174853155', N'7174855605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 Peach Orchard Road', N'Mcconnellsburg', N'PA', N'42057', N'17233', 39.937278, -78.009022, 2952, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4735, N'Bucktail Medical Center', 1, NULL, NULL, N'391304', NULL, NULL, 0, 21, NULL, N'5709231000', N'5709230835', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Pine Street', N'Renovo', N'PA', N'42035', N'17764', 41.327053, -77.737272, 2979, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4736, N'Troy Community Hospital', 1, NULL, NULL, N'391305', NULL, NULL, 0, 25, NULL, N'5702972121', N'5702973970', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 Guthrie Drive', N'Troy', N'PA', N'42015', N'16947', 31.764098, -85.956653, 2983, 236, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4737, N'Endless Mountains Health Systems', 1, NULL, NULL, N'391306', NULL, NULL, 0, 25, NULL, N'5702783801', N'5702783648', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Montrose', N'PA', N'42115', N'18801', 41.833965, -75.877139, 2960, 186, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4738, N'Tyrone Hospital', 1, NULL, NULL, N'391307', NULL, NULL, 0, 25, NULL, N'8146841255', N'8146846395', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'187 Hospital Drive', N'Tyrone', N'PA', N'42013', N'16686', 40.670551, -78.238348, 2998, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4739, N'Corry Memorial Hospital', 1, NULL, NULL, N'391308', NULL, NULL, 0, 20, NULL, N'8146644641', N'8146647967', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'965 Shamrock Lane', N'Corry', N'PA', N'42049', N'16407', 41.935379, -79.612891, 2912, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4740, N'Barnes-Kasson County Hospital', 1, NULL, NULL, N'391309', NULL, NULL, 0, 25, NULL, N'5708533135', N'5708533695', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2872 Turnpike Street', N'Susquehanna', N'PA', N'42115', N'18847', 41.92993, -75.590402, 2994, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4741, N'Penn Highlands Brookville', 1, NULL, NULL, N'391312', NULL, NULL, 0, 35, NULL, N'8148492312', N'8148494841', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Road', N'Brookville', N'PA', N'42065', N'15825', 41.156616, -79.093379, 2898, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4742, N'Charles Cole Memorial Hospital', 1, NULL, NULL, N'391313', NULL, NULL, 0, 59, NULL, N'8142749301', N'8142740884', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 East Second Street', N'Coudersport', N'PA', N'42105', N'16915', 41.770513, -77.979473, 2913, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4743, N'Titusville Hospital', 1, NULL, NULL, N'391314', NULL, NULL, 0, 25, NULL, N'8148271851', N'8148273099', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 West Oak Street', N'Titusville', N'PA', N'42039', N'16354', 41.6332, -79.67972, 2995, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4744, N'Penn Highlands Elk', 1, NULL, NULL, N'391315', NULL, NULL, 0, 35, NULL, N'8147888000', N'8147888040', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'763 Johnsonburg Road', N'Saint Marys', N'PA', N'42047', N'15857', 41.425239, -78.575669, 2991, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4745, N'Lifecare Hospitals Of Pittsburgh', 1, NULL, NULL, N'392024', NULL, NULL, 0, 196, NULL, N'4122472356', N'4122472333', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15221', 40.449995, -79.903754, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4746, N'Post Acute Medical Specialty  Hospital', 1, NULL, NULL, N'392025', NULL, NULL, 0, 67, NULL, N'5702083310', N'5702080317', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'275 North River St', N'Wilkes-Barre', N'PA', N'42079', N'18702', 41.252618, -75.875839, 3010, 238, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4747, N'Kindred Hospital Philadelphia', 1, NULL, NULL, N'392027', NULL, NULL, 0, 52, NULL, N'2157228555', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6129 Palmetto Street', N'Lawncrest', N'PA', N'42101', N'19111', 40.045639, -75.097703, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4748, N'Kindred Hospital - Pittsburgh', 1, NULL, NULL, N'392028', NULL, NULL, 0, 63, NULL, N'4124945500', N'4124947682', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7777 Steubenville Pike', N'Oakdale', N'PA', N'42003', N'15071', 40.398125, -80.185613, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4749, N'Select Specialty Hospital - Johnstown', 1, NULL, NULL, N'392031', NULL, NULL, 0, 39, NULL, N'8145345000', N'8145349965', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Main Street', N'Johnstown', N'PA', N'42021', N'15901', 40.32399, -78.915109, 2939, 231, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4750, N'od Shepherd Specialty Hospital', 1, NULL, NULL, N'392033', NULL, NULL, 0, 32, NULL, N'4848845051', N'4848845085', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2545 Schoenersville Road', N'Bethlehem', N'PA', N'42077', N'18017', 40.656213, -75.416823, 2893, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4751, N'Select Specialty Hospital Laurel Highlands Inc', 1, NULL, NULL, N'392036', NULL, NULL, 0, 40, NULL, N'7248308649', N'7248308645', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Mellon Way', N'Latrobe', N'PA', N'42129', N'15650', 40.321181, -79.379481, 2946, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4752, N'Select Specialty Hospital - Erie', 1, NULL, NULL, N'392037', NULL, NULL, 0, 50, NULL, N'8148745300', N'8148745303', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 West 11Th Street', N'Erie', N'PA', N'42049', N'16501', 42.122648, -80.087178, 2923, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4753, N'Lifecare Hospitals Of Mechanicsburg', 1, NULL, NULL, N'392038', NULL, NULL, 0, 68, NULL, N'7177908540', N'7177908635', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4950 Wilson Lane', N'Mechanicsburg', N'PA', N'42041', N'17055', 40.210197, -77.004728, 2903, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4754, N'Select Specialty Hospital - Central Pa (Camp Hill)', 1, NULL, NULL, N'392039', NULL, NULL, 0, 31, NULL, N'7179724560', N'7179724561', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 North 21St Street Fifth Floor', N'Camp Hill', N'PA', N'42041', N'17011', 40.250168, -76.922581, 2903, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4755, N'Lifecare Hospitals Of Pittsburgh- Monroeville', 1, NULL, NULL, N'392041', NULL, NULL, 0, 89, NULL, N'4128562400', N'8148569320', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2380 Mcginley Road', N'Monroeville', N'PA', N'42003', N'15146', 40.421668, -79.742367, 2959, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4756, N'Kindred Hospital At Heritage Valley', 1, NULL, NULL, N'392043', NULL, NULL, 0, 35, NULL, N'7247738480', N'7247756906', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Dutch Ridge Road', N'Beaver', N'PA', N'42007', N'15009', 40.713295, -80.333149, 2891, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4757, N'Select Specialty Hospital - Pittsburgh/Upmc', 1, NULL, NULL, N'392044', NULL, NULL, 0, 32, NULL, N'4125869821', N'4125869811', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street Muh E824', N'Pittsburgh', N'PA', N'42003', N'15213', 40.442627, -79.960432, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4758, N'Select Specialty Hospital - Mckeesport Inc', 1, NULL, NULL, N'392045', NULL, NULL, 0, 30, NULL, N'4126642900', N'4126642927', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Fifth Avenue', N'Mc Keesport', N'PA', N'42003', N'15132', 40.3513472, -79.8516453, 2954, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4759, N'Kindred Hospital South Philadelphia', 1, NULL, NULL, N'392046', NULL, NULL, 0, 58, NULL, N'2675705200', N'2154631028', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1930 South Broad Street Unit #12', N'Philadelphia', N'PA', N'42101', N'19145', 39.926402, -75.169425, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4760, N'Select Specialty Hospital - Danville', 1, NULL, NULL, N'392047', NULL, NULL, 0, 30, NULL, N'5702149648', N'5702149661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue 3Rd Flr Bush & Geisinger', N'Danville', N'PA', N'42093', N'17822', 40.966481, -76.613147, 2914, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4761, N'Lifecare Hospitals Of Chester County', 1, NULL, NULL, N'392048', NULL, NULL, 0, 39, NULL, N'4848260400', N'4848260499', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 East Marshal Street', N'West Chester', N'PA', N'42029', N'19380', 39.960922, -75.618914, 3008, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4762, N'od Shepherd Penn Partners', 1, NULL, NULL, N'392050', NULL, NULL, 0, 38, NULL, N'2158932548', N'2158932549', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Lombard Street', N'Philadelphia', N'PA', N'42101', N'19146', 39.945393, -75.171868, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4763, N'Bryn Mawr Rehabilitation Hospital', 1, NULL, NULL, N'393025', NULL, NULL, 0, 148, NULL, N'6102515400', N'6108890943', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'414 Paoli Pike', N'Malvern', N'PA', N'42029', N'19355', 40.036202, -75.513896, 2968, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4764, N'Healthsouth Reading Rehabilitation Hospital', 1, NULL, NULL, N'393026', NULL, NULL, 0, 60, NULL, N'6107966000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1623 Morgantown Road', N'Reading', N'PA', N'42011', N'19607', 40.310838, -75.924198, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4765, N'Healthsouth Harmarville Rehabilitation Hospital', 1, NULL, NULL, N'393027', NULL, NULL, 0, 162, NULL, N'4128281300', N'4128287705', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Guys Run Road', N'Pittsburgh', N'PA', N'42003', N'15238', 40.441694, -79.990086, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4766, N'Allied Services Institute Of Rehabilitati Medicine', 1, NULL, NULL, N'393030', NULL, NULL, 0, 135, NULL, N'5703481367', N'5703414551', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 Morgan Highway', N'Scranton', N'PA', N'42069', N'18508', 41.454404, -75.678492, 2984, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4767, N'Healthsouth Rehab Hospital Of Mechanicsburg', 1, NULL, NULL, N'393031', NULL, NULL, 0, 75, NULL, N'7176913720', N'7176976524', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Lancaster Boulevard', N'Mechanicsburg', N'PA', N'42041', N'17055', 40.210197, -77.004728, 2903, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4768, N'od Shepherd Rehabilitation Hospital The', 1, NULL, NULL, N'393035', NULL, NULL, 0, 102, NULL, N'6107763223', N'6107763595', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 South Fifth Street', N'Allentown', N'PA', N'42077', N'18103', 40.565311, -75.491555, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4769, N'John Heinz Institute Of Rehabilitation', 1, NULL, NULL, N'393036', NULL, NULL, 0, 67, NULL, N'5708263800', N'5708269108', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Mundy Street', N'Wilkes Barre Townshi', N'PA', N'42079', N'18702', 40.969989, -77.727883, 3010, 238, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4770, N'Healthsouth Rehabilitation Hospital Of York', 1, NULL, NULL, N'393037', NULL, NULL, 0, 90, NULL, N'7177676941', N'7177641341', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Normandie Drive', N'York', N'PA', N'42133', N'17404', 39.98007, -76.783636, 3013, 239, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4771, N'Magee Rehabilitation Hospital', 1, NULL, NULL, N'393038', NULL, NULL, 0, 96, NULL, N'2155873034', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Six Franklin Plaza', N'Philadelphia', N'PA', N'42101', N'19102', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4772, N'Healthsouth Nittany Valley Rehabilitation Hospital', 1, NULL, NULL, N'393039', NULL, NULL, 0, 73, NULL, N'8143593421', N'8143595898', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 West College Avenue', N'Pleasant Gap', N'PA', N'42027', N'16823', 40.868118, -77.746666, 2992, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4773, N'Healthsouth Rehab Hosp Of Altoona', 1, NULL, NULL, N'393040', NULL, NULL, 0, 80, NULL, N'8149443535', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 Valley View Boulevard', N'Altoona', N'PA', N'42013', N'16602', 40.498193, -78.391692, 2889, 227, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4774, N'Healthsouth Rehabilitation Hospital Of Sewickley', 1, NULL, NULL, N'393045', NULL, NULL, 0, 44, NULL, N'4127419500', N'4127492323', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Camp Meeting Road', N'Sewickley', N'PA', N'42003', N'15143', 40.536457, -80.184503, 2986, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4775, N'Healthsouth Rehabilitation Hospital Of Erie', 1, NULL, NULL, N'393046', NULL, NULL, 0, 108, NULL, N'8148781200', N'8148781399', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'143 East Second Street', N'Erie', N'PA', N'42049', N'16507', 42.129066, -80.085242, 2923, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4776, N'Geisinger Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'393047', NULL, NULL, 0, 42, NULL, N'5702716110', N'5702716796', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Rehab Lane', N'Danville', N'PA', N'42093', N'17821', 40.966481, -76.613147, 2914, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4777, N'Penn State Hershey Rehabilitation Llc', 1, NULL, NULL, N'393053', NULL, NULL, 0, 54, NULL, N'7178322600', N'7175831190', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1135 Old West Chocolate Ave', N'Hummelstown', N'PA', N'42043', N'17036', 40.2727114, -76.6897817, 2931, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4778, N'Lancaster Rehabilitation Hospital', 1, NULL, NULL, N'393054', NULL, NULL, 0, 59, NULL, N'7175444819', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'675 od Drive', N'Lancaster', N'PA', N'42071', N'17604', 40.064442, -76.349084, 2943, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4779, N'St Mary Rehabilitation Hospital', 1, NULL, NULL, N'393055', NULL, NULL, 0, 50, NULL, N'2676880711', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1208 Langhorne-Newtown Road', N'Langhorne', N'PA', N'42017', N'19047', 40.201389, -74.929478, 2944, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4780, N'Helen M Simpson Rehabilitation Hospital', 1, NULL, NULL, N'393056', NULL, NULL, 0, 55, NULL, N'7179204300', N'7179204367', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4300 Londonderry Road', N'Harrisburg', N'PA', N'42043', N'17109', 40.266311, -76.886112, 2931, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4781, N'Children''s Hospital Of Pittsburgh Of Upmc', 1, NULL, NULL, N'393302', NULL, NULL, 0, 312, NULL, N'4126925325', N'4126927589', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.466013, -79.953019, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4782, N'Children''s Hospital Of Philadelphia', 1, NULL, NULL, N'393303', NULL, NULL, 0, 514, NULL, N'2155903745', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34Th St & Civic Center Blvd', N'Philadelphia', N'PA', N'42101', N'19104', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4783, N'Children''s Home Of Pittsburgh', 1, NULL, NULL, N'393304', NULL, NULL, 0, 16, NULL, N'4124414884', N'4124410167', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5324 Penn Avenue', N'Pittsburgh', N'PA', N'42003', N'15224', 40.464512, -79.937987, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4784, N'St Christopher''s Hospital For Children', 1, NULL, NULL, N'393307', NULL, NULL, 0, 189, NULL, N'2154275000', N'2154274444', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Erie Ave', N'Philadelphia', N'PA', N'42101', N'19133', 40.006814, -75.130955, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4785, N'Children''s Institute Of Pittsburgh The', 1, NULL, NULL, N'393308', NULL, NULL, 0, 62, NULL, N'4124202400', N'4124202524', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6301 Northumberland Street', N'Pittsburgh', N'PA', N'42003', N'15217', 40.435671, -79.963871, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4786, N'Shriners Hospitals For Children - Philadelphia', 1, NULL, NULL, N'393309', NULL, NULL, 0, 53, NULL, N'2154304000', N'2154304131', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3551 N Broad Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4787, N'Norristown State Hospital', 1, NULL, NULL, N'394001', NULL, NULL, 0, 266, NULL, N'6103131000', N'6103131013', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Sterigere Street', N'Norristown', N'PA', N'42091', N'19401', 40.129284, -75.348229, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4788, N'Danville State Hospital', 1, NULL, NULL, N'394004', NULL, NULL, 0, 167, NULL, N'5702714500', N'5702714514', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 State Hospital Drive', N'Danville', N'PA', N'42093', N'17821', 40.966481, -76.613147, 2914, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4789, N'Kirkbride Center', 1, NULL, NULL, N'394007', NULL, NULL, 0, 74, NULL, N'2154712358', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 N 49Th St', N'Philadelphia', N'PA', N'42101', N'19139', 39.961203, -75.219589, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4790, N'Friends Hospital', 1, NULL, NULL, N'394008', NULL, NULL, 0, 192, NULL, N'2158314600', N'2158314538', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4641 Roosevelt Boulevard', N'Philadelphia', N'PA', N'42101', N'19124', 40.028923, -75.101382, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4791, N'Clarks Summit State Hospital', 1, NULL, NULL, N'394012', NULL, NULL, 0, 210, NULL, N'5705862011', N'5705877415', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1451 Hillside Drive', N'Clarks Summit', N'PA', N'42069', N'18411', 41.488689, -75.708525, 2984, 237, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4792, N'Wernersville State Hospital', 1, NULL, NULL, N'394014', NULL, NULL, 0, 266, NULL, N'6106704100', N'6106704101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Main Street', N'Wernersville', N'PA', N'42011', N'19565', 40.330092, -76.080497, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4793, N'Warren State Hospital', 1, NULL, NULL, N'394016', NULL, NULL, 0, 162, NULL, N'8147235500', N'8147264378', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'33 Main Drive', N'North Warren', N'PA', N'42123', N'16365', 41.878876, -79.145212, 3003, 229, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4794, N'Philhaven Hospital', 1, NULL, NULL, N'394020', NULL, NULL, 0, 103, NULL, N'7172738871', N'7172702452', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'283 South Butler Road', N'Mt Gretna', N'PA', N'42075', N'17064', 40.246359, -76.470321, 2943, 232, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4795, N'Belmont Center For Comprehensive Treatment', 1, NULL, NULL, N'394023', NULL, NULL, 0, 147, NULL, N'2158772000', N'2155813827', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4200 Monument Avenue', N'Philadelphia', N'PA', N'42101', N'19131', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4796, N'Torrance State Hospital', 1, NULL, NULL, N'394026', NULL, NULL, 0, 346, NULL, N'7244598000', N'7244594498', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 Longview Drive', N'Torrance', N'PA', N'42129', N'15779', 40.417291, -79.222812, 2946, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4797, N'Fairmount Behavioral Health System', 1, NULL, NULL, N'394027', NULL, NULL, 0, 239, NULL, N'2154874000', N'2154838187', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'561 Fairthorne Avenue', N'Philadelphia', N'PA', N'42101', N'19128', 40.042566, -75.223583, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4798, N'Montmery County Emergency Service Inc', 1, NULL, NULL, N'394033', NULL, NULL, 0, 73, NULL, N'6102796100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 Beech Drive', N'Norristown', N'PA', N'42091', N'19403', 40.1359327, -75.3580159, 2966, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4799, N'Horsham Clinic', 1, NULL, NULL, N'394034', NULL, NULL, 0, 146, NULL, N'2156437800', N'2156541256', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'722 East Butler Pike', N'Ambler', N'PA', N'42091', N'19002', 40.154554, -75.221565, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4800, N'Foundations Behavioral Health', 1, NULL, NULL, N'394038', NULL, NULL, 0, 54, NULL, N'2153450444', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'833 East Butler Ave', N'Doylestown', N'PA', N'42017', N'18901', 40.310004, -75.130484, 2916, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4801, N'First Hospital Of Wyoming Valley', 1, NULL, NULL, N'394039', NULL, NULL, 0, 107, NULL, N'5705523900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'562 Wyoming Avenue', N'Kingston', N'PA', N'42079', N'18704', 41.269609, -75.889161, 2941, 238, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4802, N'Meadows Psychiatric Center', 1, NULL, NULL, N'394040', NULL, NULL, 0, 101, NULL, N'8143642161', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'132 Meadows Drive', N'Centre Hall', N'PA', N'42027', N'16828', 40.847564, -77.686109, 2992, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4803, N'Clarion Psychiatric Center', 1, NULL, NULL, N'394043', NULL, NULL, 0, 74, NULL, N'8142269545', N'8142269622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Two Hospital Dr Rd#3 Box 188', N'Clarion', N'PA', N'42031', N'16214', 41.214785, -79.385322, 2908, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4804, N'Kidspeace Orchard Hills Campus', 1, NULL, NULL, N'394047', NULL, NULL, 0, 80, NULL, N'6107998800', N'6107998801', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5300 Kidspeace Drive', N'Orefield', N'PA', N'42077', N'18069', 40.634818, -75.584353, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4805, N'Divine Providence Hospital', 1, NULL, NULL, N'394048', NULL, NULL, 0, 31, NULL, N'5703268000', N'5703207979', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Grampian Boulevard', N'Williamsport', N'PA', N'42081', N'17701', 41.257064, -76.998049, 3011, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4806, N'Brooke Glen Behavioral Hospital', 1, NULL, NULL, N'394049', NULL, NULL, 0, 146, NULL, N'2156415300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7170 Lafayette Avenue', N'Fort Washington', N'PA', N'42091', N'19034', 40.134892, -75.216311, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4807, N'Roxbury Treatment Center', 1, NULL, NULL, N'394050', NULL, NULL, 0, 26, NULL, N'7175324217', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'601 Roxbury Road', N'Shippensburg', N'PA', N'42041', N'17257', 40.051632, -77.528063, 2907, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4808, N'Pennsylvania Psychiatric Institute', 1, NULL, NULL, N'394051', NULL, NULL, 0, 60, NULL, N'7177824742', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 North Third Street', N'Harrisburg', N'PA', N'42043', N'17110', 40.266311, -76.886112, 2931, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4809, N'Haven Behavioral Hospital Of Eastern Pennsylvania', 1, NULL, NULL, N'394052', NULL, NULL, 0, 48, NULL, N'6104064340', N'6102088844', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'145 North 6Th Street', N'Reading', N'PA', N'42011', N'19601', 40.337618, -75.925731, 2978, 235, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4810, N'Haven Behavioral Hospital Of Philadelphia', 1, NULL, NULL, N'394053', NULL, NULL, 0, 36, NULL, N'2154753400', N'2154753401', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Henry Avenue Unit 4', N'Philadelphia', N'PA', N'42101', N'19129', 40.01143, -75.182123, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4811, N'Geisinger Medical Center - Transplant Center', 1, NULL, NULL, N'399800', NULL, NULL, 0, 0, NULL, N'5702716211', N'5702716490', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 North Academy Avenue', N'Danville', N'PA', N'42093', N'17822', 40.966481, -76.613147, 2914, 228, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4812, N'Upmc Presbyterian Shadyside', 1, NULL, NULL, N'399801', NULL, NULL, 0, 0, NULL, N'4126478788', N'4126475551', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'200 Lothrop Street', N'Pittsburgh', N'PA', N'42003', N'15213', 40.442627, -79.960432, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4813, N'Allegheny General Hospital  Transplant Care', 1, NULL, NULL, N'399804', NULL, NULL, 0, 0, NULL, N'4123593131', N'4123593888', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'320 East North Avenue', N'Pittsburgh', N'PA', N'42003', N'15212', 40.45673, -80.003236, 2973, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4814, N'Hahnemann University Hospital Transplant Center', 1, NULL, NULL, N'399805', NULL, NULL, 0, 0, NULL, N'2157627167', N'2152465451', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Broad And Vine Streets', N'Philadelphia', N'PA', N'42101', N'19102', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4815, N'Temple University Hospital - Transplant Center', 1, NULL, NULL, N'399806', NULL, NULL, 0, 0, NULL, N'2157072000', N'2157077061', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3401 North Broad Street', N'Philadelphia', N'PA', N'42101', N'19140', 39.952399, -75.16359, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4816, N'Hospital Of The University Of Pennsylvania', 1, NULL, NULL, N'399808', NULL, NULL, 0, 0, NULL, N'2156623227', N'2156140028', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3400 Spruce Street', N'Philadelphia', N'PA', N'42101', N'19104', 39.949606, -75.193197, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4817, N'Pinnacle Health Hospitals Transplant Center', 1, NULL, NULL, N'399809', NULL, NULL, 0, 0, NULL, N'7177825181', N'7172318240', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'409 South Second Street', N'Harrisburg', N'PA', N'42043', N'17105', 40.266311, -76.886112, 2931, 230, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4818, N'Main Line Hospital Lankenau Transplant Center', 1, NULL, NULL, N'399811', NULL, NULL, 0, 0, NULL, N'6106452000', N'6106458007', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 Lancaster Avenue', N'Wynnewood', N'PA', N'42091', N'19096', 39.980803, -75.235689, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4819, N'Children''s Hospital Of Philadelphia Transplant', 1, NULL, NULL, N'399812', NULL, NULL, 0, 0, NULL, N'2674266922', N'2674266990', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'34Th Street And Civic Center Blvd', N'Philadelphia', N'PA', N'42101', N'19104', 39.9488335, -75.1951364, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4820, N'Albert Einstein Medical Center Transplant Center', 1, NULL, NULL, N'399813', NULL, NULL, 0, 0, NULL, N'2154567010', N'2154566199', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5501 Old York Road', N'Philadelphia', N'PA', N'42101', N'19141', 40.015874, -75.147201, 2970, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4821, N'Lehigh Valley Hospital - Transplant Center', 1, NULL, NULL, N'399815', NULL, NULL, 0, 0, NULL, N'6104022273', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 South Cedar Crest Boulevard Po Box 689', N'Allentown', N'PA', N'42077', N'18105', 40.602206, -75.471279, 2888, 226, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4822, N'Crozer Chester Medical Center - Transplant Center', 1, NULL, NULL, N'399816', NULL, NULL, 0, 0, NULL, N'6104472000', N'6104472234', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'One Medical Center Boulevard', N'Upland', N'PA', N'42045', N'19013', 39.852612, -75.382692, 3001, 233, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4823, N'Memorial Hospital Of Rhode Island', 1, NULL, NULL, N'410001', NULL, NULL, 0, 294, NULL, N'4017292000', N'4017288216', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Brewster Street', N'Pawtucket', N'RI', N'44007', N'02860', 41.870519, -71.374793, 3015, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4824, N'Roger Williams Medical Center', 1, NULL, NULL, N'410004', NULL, NULL, 0, 220, NULL, N'4014562000', N'4014562029', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Chalkstone Avenue', N'Providence', N'RI', N'44007', N'02908', 41.833786, -71.435305, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4825, N'Our Lady Of Fatima Hospital', 1, NULL, NULL, N'410005', NULL, NULL, 0, 359, NULL, N'4014563000', N'4014563028', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 High Service Avenue', N'North Providence', N'RI', N'44007', N'02904', 41.856558, -71.460041, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4826, N'Newport Hospital', 1, NULL, NULL, N'410006', NULL, NULL, 0, 129, NULL, N'4018466400', N'4018451088', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Friendship Street', N'Newport', N'RI', N'44005', N'02840', 41.497182, -71.305045, 3014, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4827, N'Rhode Island Hospital', 1, NULL, NULL, N'410007', NULL, NULL, 0, 719, NULL, N'4014444000', N'4014444218', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'593 Eddy Street', N'Providence', N'RI', N'44007', N'02903', 41.812045, -71.407047, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4828, N'South County Hospital Inc', 1, NULL, NULL, N'410008', NULL, NULL, 0, 100, NULL, N'4017828000', N'4017899765', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Kenyon Ave', N'Wakefield', N'RI', N'44009', N'02879', 41.431961, -71.496028, 3017, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4829, N'Kent County Memorial Hospital', 1, NULL, NULL, N'410009', NULL, NULL, 0, 359, NULL, N'4017377000', N'4017361000', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 Toll Gate Rd', N'Warwick', N'RI', N'44003', N'02886', 41.704478, -71.477902, 3018, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4830, N'Women And Infants Hospital Of Rhode Island', 1, NULL, NULL, N'410010', NULL, NULL, 0, 167, NULL, N'4012741100', N'4014537666', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Dudley Street', N'Providence', N'RI', N'44007', N'02905', 41.810239, -71.411209, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4831, N'Landmark Medical Center  Inc', 1, NULL, NULL, N'410011', NULL, NULL, 0, 214, NULL, N'4017694100', N'4017665488', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Cass Ave', N'Woonsocket', N'RI', N'44007', N'02895', 42.00534, -71.496115, 3020, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4832, N'Miriam Hospital', 1, NULL, NULL, N'410012', NULL, NULL, 0, 247, NULL, N'4017932500', N'4017937587', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'164 Summit Avenue', N'Providence', N'RI', N'44007', N'02906', 41.851723, -71.397517, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4833, N'Westerly Hospital', 1, NULL, NULL, N'410013', NULL, NULL, 0, 116, NULL, N'4015966000', N'4013483716', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Wells Street', N'Westerly', N'RI', N'44009', N'02891', 41.362798, -71.825814, 3019, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4834, N'Eleanor Slater Hospital', 1, NULL, NULL, N'412001', NULL, NULL, 0, 495, NULL, N'4014623666', N'4014623679', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111Howard Ave', N'Cranston', N'RI', N'44007', N'02921', 41.738415, -71.481888, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4835, N'Rehabilitation Hospital Of Rhode Island', 1, NULL, NULL, N'413025', NULL, NULL, 0, 82, NULL, N'4017660800', N'4017665488', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'116 Eddie Dowling Highway', N'North Smithfield', N'RI', N'44007', N'02896', 41.966765, -71.549507, 3020, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4836, N'Butler Hospital', 1, NULL, NULL, N'414000', NULL, NULL, 0, 143, NULL, N'4014556270', N'4014556252', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'345 Blackstone Blvd', N'Providence', N'RI', N'44007', N'02906', 41.845255, -71.38726, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4837, N'Emma Pendleton Bradley Hospital', 1, NULL, NULL, N'414003', NULL, NULL, 0, 60, NULL, N'4014343400', N'4014321500', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 Veterans Memorial Parkway', N'East Providence', N'RI', N'44007', N'02915', 41.792179, -71.365851, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4838, N'Rhode Island Hospital - Transplant Center', 1, NULL, NULL, N'419801', NULL, NULL, 0, 0, NULL, N'4014444000', N'4014444218', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'593 Eddy Street', N'Providence', N'RI', N'44007', N'02905', 41.811815, -71.407168, 3016, 240, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4839, N'Piedmont Medical Center', 1, NULL, NULL, N'420002', NULL, NULL, 0, 288, NULL, N'8033291234', N'8033290979', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'222 S Herlong Ave', N'Rock Hill', N'SC', N'45091', N'29730', 34.955198, -81.05125, 3060, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4840, N'Musc Medical Center', 1, NULL, NULL, N'420004', NULL, NULL, 0, 709, NULL, N'8437922300', N'8437921931', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'169 Ashley Ave', N'Charleston', N'SC', N'45019', N'29425', 32.7854, -79.946559, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4841, N'Mcleod Medical Center - Dillon', 1, NULL, NULL, N'420005', NULL, NULL, 0, 92, NULL, N'8437744111', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E Jackson St', N'Dillon', N'SC', N'45033', N'29536', 34.421266, -79.366107, 3036, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4842, N'Spartanburg Regional Medical Center', 1, NULL, NULL, N'420007', NULL, NULL, 0, 540, NULL, N'8645606000', N'8645604023', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Wood St', N'Spartanburg', N'SC', N'45083', N'29303', 34.967852, -81.939927, 3062, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4843, N'Ghs Oconee Memorial  Hospital', 1, NULL, NULL, N'420009', NULL, NULL, 0, 169, NULL, N'8644823100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'298 Memorial Drive', N'Seneca', N'SC', N'45073', N'29672', 34.693992, -82.988836, 3061, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4844, N'Carolina Pines Regional Medical Center', 1, NULL, NULL, N'420010', NULL, NULL, 0, 116, NULL, N'8643392100', N'8433394116', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1304 W Bobo Newsom Hwy', N'Hartsville', N'SC', N'45031', N'29550', 34.348766, -80.105944, 3046, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4845, N'Cannon Memorial Hospital', 1, NULL, NULL, N'420011', NULL, NULL, 0, 55, NULL, N'8648784791', N'8648981047', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'123 Medical Park Drive Po Box 188', N'Pickens', N'SC', N'45077', N'29671', 34.883449, -82.707357, 3058, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4846, N'Baptist Easley Hospital', 1, NULL, NULL, N'420015', NULL, NULL, 0, 109, NULL, N'8644427200', N'8644427521', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 2129', N'Easley', N'SC', N'45077', N'29641', 34.826928, -82.581705, 3037, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4847, N'Southern Palmetto Hospital', 1, NULL, NULL, N'420016', NULL, NULL, 0, 53, NULL, N'8032591000', N'8035414388', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811  Reynolds Road', N'Barnwell', N'SC', N'45011', N'29812', 33.255265, -81.360566, 3025, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4848, N'Palmetto Health Richland', 1, NULL, NULL, N'420018', NULL, NULL, 0, 649, NULL, N'8032965678', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5 Richland Medical Park', N'Columbia', N'SC', N'45079', N'29203', 34.026689, -81.03012, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4849, N'Chester Regional Medical Center', 1, NULL, NULL, N'420019', NULL, NULL, 0, 82, NULL, N'8035813151', N'8035812565', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Park Drive', N'Chester', N'SC', N'45023', N'29706', 34.683429, -81.184551, 3032, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4850, N'Georgetown Memorial Hospital', 1, NULL, NULL, N'420020', NULL, NULL, 0, 131, NULL, N'8435277000', N'8435208403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 Black River Rd Drawer 1718', N'Georgetown', N'SC', N'45043', N'29440', 33.379938, -79.285723, 3042, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4851, N'St Francis-Downtown', 1, NULL, NULL, N'420023', NULL, NULL, 0, 338, NULL, N'8008055678', N'8646053956', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Francis Dr', N'Greenville', N'SC', N'45045', N'29601', 34.851354, -82.398488, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4852, N'Sisters Of Charity Providence Hospitals', 1, NULL, NULL, N'420026', NULL, NULL, 0, 258, NULL, N'8032565300', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2435 Forest Dr', N'Columbia', N'SC', N'45079', N'29204', 34.013278, -81.012142, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4853, N'Anmed Health', 1, NULL, NULL, N'420027', NULL, NULL, 0, 533, NULL, N'8642611109', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 N Fant St', N'Anderson', N'SC', N'45007', N'29621', 34.511071, -82.647355, 3023, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4854, N'Colleton Medical Center', 1, NULL, NULL, N'420030', NULL, NULL, 0, 135, NULL, N'8437822000', N'8435497562', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Robertson Boulevard', N'Walterboro', N'SC', N'45029', N'29488', 32.921855, -80.67088, 3066, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4855, N'Ghs Greer Memorial Hospital', 1, NULL, NULL, N'420033', NULL, NULL, 0, 82, NULL, N'8648488200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 South Buncombe Road', N'Greer', N'SC', N'45045', N'29650', 34.919241, -82.242003, 3045, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4856, N'Springs Memorial Hospital', 1, NULL, NULL, N'420036', NULL, NULL, 0, 217, NULL, N'8032861481', N'8032861367', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Meeting St', N'Lancaster', N'SC', N'45057', N'29720', 34.716906, -80.786842, 3049, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4857, N'Ghs-Hillcrest Memorial Hospital', 1, NULL, NULL, N'420037', NULL, NULL, 0, 43, NULL, N'8644546151', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'729 South East Main Street', N'Simpsonville', N'SC', N'45045', N'29681', 34.72423, -82.253888, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4858, N'Ghs  Laurens County Memorial Hospital', 1, NULL, NULL, N'420038', NULL, NULL, 0, 76, NULL, N'8648339100', N'8648339486', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22725 Highway 76 East', N'Clinton', N'SC', N'45059', N'29325', 34.479721, -81.941169, 3033, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4859, N'Mary Black Health System Gaffney', 1, NULL, NULL, N'420043', NULL, NULL, 0, 125, NULL, N'8644874271', N'8644890585', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 N Limestone St', N'Gaffney', N'SC', N'45021', N'29340', 35.090854, -81.635054, 3041, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4860, N'Kershaw Health', 1, NULL, NULL, N'420048', NULL, NULL, 0, 121, NULL, N'8034324311', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Haile And Roberts Streets Box 7003', N'Camden', N'SC', N'45055', N'29020', 34.246539, -80.607024, 3029, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4861, N'Conway Medical Center', 1, NULL, NULL, N'420049', NULL, NULL, 0, 210, NULL, N'8433478037', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Singleton Ridge Road', N'Conway', N'SC', N'45051', N'29526', 33.787012, -79.001662, 3035, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4862, N'Mcleod Regional Medical Center-Pee Dee', 1, NULL, NULL, N'420051', NULL, NULL, 0, 453, NULL, N'8437772900', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 E Cheves St Box 8700', N'Florence', N'SC', N'45041', N'29506', 34.19595, -79.758496, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4863, N'Newberry County Memorial Hospital', 1, NULL, NULL, N'420053', NULL, NULL, 0, 90, NULL, N'8034057145', N'8032766885', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2669 Kinard St Po Box 497', N'Newberry', N'SC', N'45071', N'29108', 34.289723, -81.604714, 3056, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4864, N'Carolinas Hospital System Marion', 1, NULL, NULL, N'420055', NULL, NULL, 0, 124, NULL, N'8434312000', N'8434312414', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2829 E Hwy 76', N'Mullins', N'SC', N'45067', N'29574', 34.189232, -79.321945, 3054, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4865, N'Mcleod Medical Center - Darlington', 1, NULL, NULL, N'420057', NULL, NULL, 0, 72, NULL, N'8437771100', N'8437771149', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Cashua Ferry Road', N'Darlington', N'SC', N'45031', N'29540', 34.312385, -79.839676, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4866, N'Bon Secours-St Francis Xavier Hospital', 1, NULL, NULL, N'420065', NULL, NULL, 0, 204, NULL, N'8434021006', N'8434021945', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2095 Henry Tecklenburg Drive', N'Charleston', N'SC', N'45019', N'29414', 32.810487, -80.041516, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4867, N'Lake City Community Hospital', 1, NULL, NULL, N'420066', NULL, NULL, 0, 48, NULL, N'8433742036', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'258 N Ron Mcnair Blvd', N'Lake City', N'SC', N'45041', N'29560', 33.881532, -79.758701, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4868, N'Beaufort County Memorial Hospital', 1, NULL, NULL, N'420067', NULL, NULL, 0, 197, NULL, N'8435225200', N'8435225765', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'955 Ribaut Rd', N'Beaufort', N'SC', N'45013', N'29902', 32.416835, -80.688546, 3026, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4869, N'Trmc Of Orangeburg & Calhoun', 1, NULL, NULL, N'420068', NULL, NULL, 0, 286, NULL, N'8035332460', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 St Matthews Rd Box 1806', N'Orangeburg', N'SC', N'45075', N'29115', 33.540783, -80.832814, 3057, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4870, N'Clarendon Memorial Hospital', 1, NULL, NULL, N'420069', NULL, NULL, 0, 61, NULL, N'8034353386', N'8034353414', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Hospital St Box 550', N'Manning', N'SC', N'45027', N'29102', 33.687869, -80.21197, 3051, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4871, N'Tuomey Healthcare System', 1, NULL, NULL, N'420070', NULL, NULL, 0, 283, NULL, N'8037741752', N'8037749589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'129 N Washington St', N'Sumter', N'SC', N'45085', N'29150', 33.923775, -80.344334, 3063, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4872, N'Self Regional Healthcare', 1, NULL, NULL, N'420071', NULL, NULL, 0, 414, NULL, N'8642274111', N'8647254260', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Spring Street', N'Greenwood', N'SC', N'45047', N'29646', 34.175367, -82.157873, 3044, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4873, N'Hampton Regional Medical Center', 1, NULL, NULL, N'420072', NULL, NULL, 0, 32, NULL, N'8039432771', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'595 West Carolina Avenue', N'Varnville', N'SC', N'45049', N'29944', 32.855107, -81.087473, 3065, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4874, N'Lexington Medical Center', 1, NULL, NULL, N'420073', NULL, NULL, 0, 414, NULL, N'8037912000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2720 Sunset Blvd', N'West Columbia', N'SC', N'45063', N'29169', 34.004483, -81.114848, 3067, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4875, N'Ghs Greenville Memorial Hospital', 1, NULL, NULL, N'420078', NULL, NULL, 0, 845, NULL, N'8644557000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Grove Rd', N'Greenville', N'SC', N'45045', N'29605', 34.821617, -82.41359, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4876, N'Trident Medical Center', 1, NULL, NULL, N'420079', NULL, NULL, 0, 390, NULL, N'8437978800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9330 Medical Plaza Dr', N'Charleston', N'SC', N'45019', N'29406', 32.977461, -80.07365, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4877, N'Hilton Head Regional Medical Center', 1, NULL, NULL, N'420080', NULL, NULL, 0, 93, NULL, N'8436816122', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'25 Hospital Center Blvd', N'Hilton Head Island', N'SC', N'45013', N'29925', 32.222744, -80.714267, 3047, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4878, N'Aiken Regional Medical Center', 1, NULL, NULL, N'420082', NULL, NULL, 0, 230, NULL, N'8036415900', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'302 University Parkway', N'Aiken', N'SC', N'45003', N'29801', 33.576922, -81.765649, 3022, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4879, N'Mary Black Health System Spartanburg', 1, NULL, NULL, N'420083', NULL, NULL, 0, 207, NULL, N'8645733000', N'8645733155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Skylyn Dr Po Box 3217', N'Spartanburg', N'SC', N'45083', N'29307', 34.978285, -81.893659, 3062, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4880, N'Grand Strand Regional Medical Center', 1, NULL, NULL, N'420085', NULL, NULL, 0, 269, NULL, N'8436921000', N'8436921109', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 82Nd Parkway', N'Myrtle Beach', N'SC', N'45051', N'29572', 33.757825, -78.816423, 3055, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4881, N'Palmetto Health Baptist', 1, NULL, NULL, N'420086', NULL, NULL, 0, 391, NULL, N'8032965678', N'8032965462', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Taylor At Marion St', N'Columbia', N'SC', N'45079', N'29220', 34.007556, -81.032688, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4882, N'Roper Hospital', 1, NULL, NULL, N'420087', NULL, NULL, 0, 368, NULL, N'8437242800', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'316 Calhoun St', N'Charleston', N'SC', N'45019', N'29401', 32.782372, -79.948734, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4883, N'East Cooper Medical Center', 1, NULL, NULL, N'420089', NULL, NULL, 0, 140, NULL, N'8438810100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hospital Dr', N'Mount Pleasant', N'SC', N'45019', N'29464', 32.820879, -79.8496, 3053, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4884, N'Carolinas Hospital System', 1, NULL, NULL, N'420091', NULL, NULL, 0, 420, NULL, N'8436742500', N'8436742519', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 Pamplico Hwy Box 100550', N'Florence', N'SC', N'45041', N'29505', 34.158376, -79.753814, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4885, N'Waccamaw Community Hospital', 1, NULL, NULL, N'420098', NULL, NULL, 0, 167, NULL, N'8436521000', N'8435208403', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4070 Highway 17 Bypass', N'Murrells Inlet', N'SC', N'45043', N'29576', 33.559666, -79.041284, 3055, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4886, N'Coastal Carolina Hospital', 1, NULL, NULL, N'420101', NULL, NULL, 0, 41, NULL, N'8437848182', N'4698937272', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Medical Center Drive', N'Hardeeville', N'SC', N'45053', N'29927', 32.31256, -81.055052, 1001, 77, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4887, N'Ghs Patewood Memorial Hospital', 1, NULL, NULL, N'420102', NULL, NULL, 0, 72, NULL, N'8647971000', N'8644541130', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Patewood Drive', N'Greenville', N'SC', N'45045', N'29615', 34.852418, -82.325899, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4888, N'Village Hospital', 1, NULL, NULL, N'420103', NULL, NULL, 0, 48, NULL, N'8645306000', N'8645304665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 Westmoreland Road', N'Greer', N'SC', N'45045', N'29651', 34.863444, -82.217524, 3045, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4889, N'Mount Pleasant Hospital', 1, NULL, NULL, N'420104', NULL, NULL, 0, 85, NULL, N'8437242954', N'8438813070', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Highway 17 North', N'Mount Pleasant', N'SC', N'45019', N'29466', 32.877082, -79.7679, 3053, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4890, N'Mcleod Loris Seacoast Hospital', 1, NULL, NULL, N'420105', NULL, NULL, 0, 105, NULL, N'8437167000', N'8437167195', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3655 Mitchell Street', N'Loris', N'SC', N'45051', N'29569', 34.056501, -78.898443, 3050, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4891, N'Palmetto Health Baptist Parkridge', 1, NULL, NULL, N'420106', NULL, NULL, 0, 57, NULL, N'8039077011', N'8039077009', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Palmetto Health Parkway', N'Columbia', N'SC', N'45063', N'29212', 34.089403, -81.160598, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4892, N'Mcleod Health Cheraw', 1, NULL, NULL, N'420107', NULL, NULL, 0, 59, NULL, N'8435377881', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Chesterfield Highway', N'Cheraw', N'SC', N'45025', N'29520', 34.697656, -79.883397, 3031, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4893, N'Union Medical Center', 1, NULL, NULL, N'420108', NULL, NULL, 0, 155, NULL, N'8643012000', N'8643012653', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'322 West South Street', N'Union', N'SC', N'45087', N'29379', 34.711631, -81.627756, 3064, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4894, N'Allendale County Hospital', 1, NULL, NULL, N'421300', NULL, NULL, 0, 25, NULL, N'8036323311', N'8036322410', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1787 Allendale Fairfax Rd', N'Fairfax', N'SC', N'45005', N'29827', 32.958538, -81.237212, 3039, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4895, N'Abbeville Area Medical Center', 1, NULL, NULL, N'421301', NULL, NULL, 0, 25, NULL, N'8643665011', N'8643663343', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'420 Thomson Circle', N'Abbeville', N'SC', N'45001', N'29620', 34.154291, -82.372819, 3021, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4896, N'Fairfield Memorial Hospital', 1, NULL, NULL, N'421302', NULL, NULL, 0, 25, NULL, N'8036350233', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Bypass Po Box 620', N'Winnsboro', N'SC', N'45039', N'29180', 34.380701, -81.086478, 3068, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4897, N'Williamsburg Regional Hospital', 1, NULL, NULL, N'421303', NULL, NULL, 0, 25, NULL, N'8433558888', N'8433559994', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Nelson Boulevard', N'Kingstree', N'SC', N'45089', N'29556', 33.660657, -79.820267, 3048, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4898, N'Edgefield County Hospital', 1, NULL, NULL, N'421304', NULL, NULL, 0, 25, NULL, N'8036371193', N'8036371171', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Ridge Medical Plaza', N'Edgefield', N'SC', N'45037', N'29824', 33.778969, -81.929028, 3038, 73, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4899, N'Spartanburg Hosp For Restorative Care', 1, NULL, NULL, N'422004', NULL, NULL, 0, 97, NULL, N'8645603235', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'389 Serpentine Dr', N'Spartanburg', N'SC', N'45083', N'29303', 34.967701, -81.935932, 3062, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4900, N'Vibra Hospital Of Charleston', 1, NULL, NULL, N'422005', NULL, NULL, 0, 59, NULL, N'8438814047', N'8438814738', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Hospital Drive', N'Mount Pleasant', N'SC', N'45019', N'29464', 32.817117, -79.85219, 3053, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4901, N'Intermedical Hospital Of Sc', 1, NULL, NULL, N'422006', NULL, NULL, 0, 35, NULL, N'8032963097', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Taylor At Marion Street', N'Columbia', N'SC', N'45079', N'29220', 34.000749, -81.034331, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4902, N'Regency Hospital Of Florence', 1, NULL, NULL, N'422007', NULL, NULL, 0, 40, NULL, N'8436613481', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'121 East Cedar St 4Th Fl', N'Florence', N'SC', N'45041', N'29501', 34.1987, -79.7677, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4903, N'Ghs North Greenville Long Term Acute Care Hospital', 1, NULL, NULL, N'422008', NULL, NULL, 0, 45, NULL, N'8648345132', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'807 North Main Street', N'Travelers Rest', N'SC', N'45045', N'29690', 34.975041, -82.450033, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4904, N'Regency Hospital Of Greenville', 1, NULL, NULL, N'422009', NULL, NULL, 0, 32, NULL, N'8642551401', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 St Francis Drive 4Th Floor', N'Greenville', N'SC', N'45045', N'29601', 34.840327, -82.421429, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4905, N'Healthsouth Rehabilitation Hospital Of Columbia', 1, NULL, NULL, N'423025', NULL, NULL, 0, 96, NULL, N'8032547777', N'8034011414', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2935 Colonial Drive', N'Columbia', N'SC', N'45079', N'29203', 34.022166, -81.031782, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4906, N'Healthsouth Rehabilitation Hospital Of Florence', 1, NULL, NULL, N'423026', NULL, NULL, 0, 88, NULL, N'8436799000', N'8436783787', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Cheves St', N'Florence', N'SC', N'45041', N'29506', 34.195994, -79.755799, 3040, 243, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4907, N'Healthsouth Rehabilitation Hosp Of Charleston Inc', 1, NULL, NULL, N'423027', NULL, NULL, 0, 49, NULL, N'8438207777', N'8435534025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9181 Medcom St', N'North Charleston', N'SC', N'45019', N'29406', 32.9757784, -80.072179, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4908, N'Healthsouth Rehabilitation Hospital Of Rock Hill', 1, NULL, NULL, N'423028', NULL, NULL, 0, 50, NULL, N'8033263500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1795 Frank Gaston Blvd', N'Rock Hill', N'SC', N'45091', N'29732', 34.924867, -81.025078, 3060, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4909, N'Anmed Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'423029', NULL, NULL, 0, 60, NULL, N'8647162600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Springback Way', N'Anderson', N'SC', N'45007', N'29621', 34.50686, -82.650626, 3023, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4910, N'Greenwood Regional Rehabilitation Hospital Inc', 1, NULL, NULL, N'423030', NULL, NULL, 0, 34, NULL, N'8643309070', N'8643309075', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Parkway', N'Greenwood', N'SC', N'45047', N'29646', 34.1676512, -82.158071, 3044, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4911, N'Spartanburg Rehabilitation Institute Inc', 1, NULL, NULL, N'423031', NULL, NULL, 0, 40, NULL, N'8646416510', N'8646416512', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Harold Fleming Court', N'Spartanburg', N'SC', N'45083', N'29303', 34.9898717, -81.9447291, 3062, 245, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4912, N'Shriners Hospitals For Children', 1, NULL, NULL, N'423300', NULL, NULL, 0, 50, NULL, N'8602713444', N'8642714471', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 West Faris Road', N'Greenville', N'SC', N'45045', N'29605', 34.817887, -82.417704, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4913, N'Lighthouse Care Center Of Conway', 1, NULL, NULL, N'424002', NULL, NULL, 0, 52, NULL, N'8433478871', N'8432346100', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'152 Waccamaw Medical Park Drive', N'Conway', N'SC', N'45051', N'29526', 33.836004, -79.047814, 3035, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4914, N'William S Hall Psychiatric Institute', 1, NULL, NULL, N'424003', NULL, NULL, 0, 89, NULL, N'8038981725', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Colonial Drive', N'Columbia', N'SC', N'45079', N'29202', 34.022166, -81.031782, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4915, N'G Werber Bryan Psych Hosp', 1, NULL, NULL, N'424005', NULL, NULL, 0, 543, NULL, N'8039357143', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'220 Faison Dr', N'Columbia', N'SC', N'45079', N'29203', 34.082385, -80.995702, 3034, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4916, N'Palmetto Lowcountry Behavioral Health', 1, NULL, NULL, N'424006', NULL, NULL, 0, 112, NULL, N'8437475830', NULL, 1, 0, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2777 Speissegger Drive', N'Charleston', N'SC', N'45019', N'29405', 32.839183, -79.975052, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4917, N'Springbrook Behavioral Health System', 1, NULL, NULL, N'424007', NULL, NULL, 0, 44, NULL, N'8648348013', N'8648346977', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Havenwood Lane  Po Box 1005', N'Travelers Rest', N'SC', N'45045', N'29690', 34.967617, -82.443455, 3043, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4918, N'Three Rivers Behavioral Health', 1, NULL, NULL, N'424008', NULL, NULL, 0, 98, NULL, N'8037969911', N'8037917622', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Sunset Boulevard', N'West Columbia', N'SC', N'45063', N'29169', 33.998573, -81.083992, 3067, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4919, N'Carolina Ctr For Behavioral Healththe', 1, NULL, NULL, N'424010', NULL, NULL, 0, 130, NULL, N'8642352335', N'8649686338', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 E Phillips Rd', N'Greer', N'SC', N'45045', N'29650', 34.94349, -82.181291, 3045, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4920, N'Patrick B Harris Psychiatric Hospital', 1, NULL, NULL, N'424011', NULL, NULL, 0, 206, NULL, N'8032312600', NULL, 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Highway 252', N'Anderson', N'SC', N'45007', N'29622', 34.50686, -82.650626, 3023, 244, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4921, N'The William J Mccord Adolescent Treatment Facility', 1, NULL, NULL, N'424013', NULL, NULL, 0, 15, NULL, N'8035342328', N'8035318419', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 Cook Road', N'Orangeburg', N'SC', N'45075', N'29118', 33.535879, -80.823727, 3057, 242, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4922, N'Rebound Behavioral Health', 1, NULL, NULL, N'424014', NULL, NULL, 0, 42, NULL, N'8033133700', N'8032890912', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'134 East Rebound Road', N'Lancaster', N'SC', N'45057', N'29720', 34.865251, -80.803182, 3049, 196, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4923, N'Musc Medical Center', 1, NULL, NULL, N'429800', NULL, NULL, 0, 0, NULL, N'8437922300', N'8438762968', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'169 Ashley Avenue', N'Charleston', N'SC', N'45019', N'29425', 32.785398, -79.946661, 3030, 241, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4924, N'Prairie Lakes Hospital', 1, NULL, NULL, N'430005', NULL, NULL, 0, 81, NULL, N'6058827000', N'6058827607', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 9Th Avenue Nw  Post Office Box 1210', N'Watertown', N'SD', N'46029', N'57201', 44.910677, -97.120996, 3109, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4925, N'Brookings Health System', 1, NULL, NULL, N'430008', NULL, NULL, 0, 49, NULL, N'6056969000', N'6056967776', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 22Nd Ave', N'Brookings', N'SD', N'46011', N'57006', 44.307751, -96.768153, 3075, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4926, N'Avera Sacred Heart Hospital', 1, NULL, NULL, N'430012', NULL, NULL, 0, 144, NULL, N'6056688000', N'6056680170', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Summit', N'Yankton', N'SD', N'46135', N'57078', 42.871285, -97.404888, 3113, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4927, N'Avera Queen Of Peace', 1, NULL, NULL, N'430013', NULL, NULL, 0, 120, NULL, N'6059952000', N'6059955765', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'525 N Foster', N'Mitchell', N'SD', N'46035', N'57301', 43.713842, -98.007324, 3092, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4928, N'Avera St Lukes', 1, NULL, NULL, N'430014', NULL, NULL, 0, 133, NULL, N'6056225000', N'6056225127', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 S State St  Post Office Box 4450', N'Aberdeen', N'SD', N'46013', N'57401', 45.461211, -98.479282, 3070, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4929, N'Avera St Mary''s Hospital', 1, NULL, NULL, N'430015', NULL, NULL, 0, 60, NULL, N'6052243100', N'6052248339', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 E Sioux', N'Pierre', N'SD', N'46065', N'57501', 44.361479, -100.343282, 3096, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4930, N'Avera Mckennan Hospital & University Health Center', 1, NULL, NULL, N'430016', NULL, NULL, 0, 505, NULL, N'6053228000', N'6053227810', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 S Cliff Ave  Post Office Box 5045', N'Sioux Falls', N'SD', N'46099', N'57117', 43.534607, -96.711304, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4931, N'Sanford Usd Medical Center', 1, NULL, NULL, N'430027', NULL, NULL, 0, 537, NULL, N'6053331000', N'6053331531', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 W 18Th St  Post Office Box 5039', N'Sioux Falls', N'SD', N'46099', N'57117', 43.53668, -96.743372, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4932, N'Spearfish Regional Hospital', 1, NULL, NULL, N'430048', NULL, NULL, 0, 40, NULL, N'6056444000', N'6056444011', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1440 N Main St', N'Spearfish', N'SD', N'46081', N'57783', 44.498351, -103.861259, 3103, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4933, N'Rapid City Regional Hospital', 1, NULL, NULL, N'430077', NULL, NULL, 0, 417, NULL, N'6057551000', N'6057198053', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'353 Fairmont Blvd  Post Office Box 6000', N'Rapid City', N'SD', N'46103', N'57701', 44.05862, -103.225005, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4934, N'Phs Indian Hospital At Pine Ridge', 1, NULL, NULL, N'430081', NULL, NULL, 0, 45, NULL, N'6058675131', N'6058673271', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 18 Main St. Bldg. 159', N'Pine Ridge', N'SD', N'46113', N'57770', 43.028378, -102.552263, 3115, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4935, N'Phs Indian Hospital At Rapid City - Sioux San', 1, NULL, NULL, N'430082', NULL, NULL, 0, 39, NULL, N'6053552500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Canyon Lake Dr', N'Rapid City', N'SD', N'46103', N'57702', 44.071276, -103.278346, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4936, N'Phs Indian Hospital At Eagle Butte', 1, NULL, NULL, N'430083', NULL, NULL, 0, 35, NULL, N'6059643005', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Main Street', N'Eagle Butte', N'SD', N'46041', N'57625', 44.998159, -101.234822, 3114, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4937, N'Phs Indian Hospital At Rosebud', 1, NULL, NULL, N'430084', NULL, NULL, 0, 29, NULL, N'6057472231', N'6057472216', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Soldier Creek Road', N'Rosebud', N'SD', N'46121', N'57570', 43.232782, -100.853478, 3116, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4938, N'Dunes Surgical Hospital', 1, NULL, NULL, N'430089', NULL, NULL, 0, 40, NULL, N'6052323332', N'6052320854', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Sioux Point Road', N'Dakota Dunes', N'SD', N'46127', N'57049', 42.505484, -96.497447, 1365, 109, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4939, N'Sioux Falls Specialty Hospital Llp', 1, NULL, NULL, N'430090', NULL, NULL, 0, 35, NULL, N'6053346730', N'6053348096', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'910 East 20Th Street', N'Sioux Falls', N'SD', N'46099', N'57105', 43.534842, -96.714388, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4940, N'Black Hills Surgical Hospital Llp', 1, NULL, NULL, N'430091', NULL, NULL, 0, 26, NULL, N'6057214700', N'6057214964', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 Anamaria Dr', N'Rapid City', N'SD', N'46103', N'57703', 44.046271, -103.22251, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4941, N'Dakota Plains Surgical Center Llp', 1, NULL, NULL, N'430092', NULL, NULL, 0, 15, NULL, N'6052253300', N'6052253877', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 8Th Avenue Nw Suite C', N'Aberdeen', N'SD', N'46013', N'57401', 45.473935, -98.502266, 3070, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4942, N'Same Day Surgery Center Llc', 1, NULL, NULL, N'430093', NULL, NULL, 0, 6, NULL, N'6057559900', N'6057559955', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Cathedral Drive', N'Rapid City', N'SD', N'46103', N'57701', 44.05919, -103.229093, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4943, N'Avera Heart Hospital Of South Dakota', 1, NULL, NULL, N'430095', NULL, NULL, 0, 53, NULL, N'6059777000', N'6059777001', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 W 69Th St', N'Sioux Falls', N'SD', N'46099', N'57108', 43.489923, -96.781442, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4944, N'Lewis And Clark Specialty Hospital', 1, NULL, NULL, N'430096', NULL, NULL, 0, 10, NULL, N'6056655100', N'6056655200', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Fox Run Parkway', N'Yankton', N'SD', N'46135', N'57078', 42.904989, -97.39999, 3113, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4945, N'Sanford Aberdeen Medical Center', 1, NULL, NULL, N'430097', NULL, NULL, 0, 48, NULL, N'6056264200', N'6056264211', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2905 3Rd Ave Se', N'Aberdeen', N'SD', N'46013', N'57402', 45.46214, -98.447186, 3070, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4946, N'Madison Regional Health System', 1, NULL, NULL, N'431300', NULL, NULL, 0, 25, NULL, N'6052566551', N'6052566469', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 Sw 10Th St', N'Madison', N'SD', N'46079', N'57042', 44.006085, -97.11395, 3088, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4947, N'Faulkton Area Medical Center', 1, NULL, NULL, N'431301', NULL, NULL, 0, 12, NULL, N'6055986262', N'6055984186', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Oak Street  Post Office Box 100', N'Faulkton', N'SD', N'46049', N'57438', 45.030046, -99.131753, 3082, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4948, N'Avera Gettysburg Hospital', 1, NULL, NULL, N'431302', NULL, NULL, 0, 10, NULL, N'6057652480', N'6057652704', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'606 East Garfield', N'Gettysburg', N'SD', N'46107', N'57442', 45.013517, -99.951263, 3084, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4949, N'Douglas County Memorial Hospital-Cah', 1, NULL, NULL, N'431305', NULL, NULL, 0, 11, NULL, N'6057242159', N'6057242985', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 8Th St', N'Armour', N'SD', N'46043', N'57313', 43.324927, -98.345054, 3071, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4950, N'Platte Health Center - Cah', 1, NULL, NULL, N'431306', NULL, NULL, 0, 17, NULL, N'6053373364', N'6053372670', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 7Th St  Post Office Box 200', N'Platte', N'SD', N'46023', N'57369', 43.384182, -98.836395, 3097, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4951, N'Sanford Clear Lake Medical Center', 1, NULL, NULL, N'431307', NULL, NULL, 0, 20, NULL, N'6058742141', N'6058748441', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Third Avenue South', N'Clear Lake', N'SD', N'46039', N'57226', 44.751488, -96.682542, 3078, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4952, N'Eureka Community Health Services - Cah', 1, NULL, NULL, N'431308', NULL, NULL, 0, 6, NULL, N'6052842661', N'6052842054', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 9Th St Post Office Box 517', N'Eureka', N'SD', N'46089', N'57437', 45.771616, -99.622616, 3081, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4953, N'Community Memorial Hospital - Cah', 1, NULL, NULL, N'431309', NULL, NULL, 0, 16, NULL, N'6057752621', N'6057752754', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'809 Jackson  Post Office Box 319', N'Burke', N'SD', N'46053', N'57523', 43.1825, -99.292045, 3076, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4954, N'Avera Flandreau Hospital - Cah', 1, NULL, NULL, N'431310', NULL, NULL, 0, 18, NULL, N'6059972433', N'6059973611', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 North Prairie Street', N'Flandreau', N'SD', N'46101', N'57028', 44.049633, -96.591442, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4955, N'Sanford Hospital Webster - Cah', 1, NULL, NULL, N'431311', NULL, NULL, 0, 25, NULL, N'6053453336', N'6053452402', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W First St Post Office Box 489', N'Webster', N'SD', N'46037', N'57274', 45.338566, -97.521508, 3110, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4956, N'Marshall County Healthcare Center - Cah', 1, NULL, NULL, N'431312', NULL, NULL, 0, 20, NULL, N'6054482253', N'6054482304', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'413 9Th Street', N'Britton', N'SD', N'46091', N'57430', 45.789172, -97.744827, 3074, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4957, N'Freeman Medical Center - Cah', 1, NULL, NULL, N'431313', NULL, NULL, 0, 25, NULL, N'6059254000', N'6059252137', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 E 8Th St  Post Office Box 370', N'Freeman', N'SD', N'46067', N'57029', 43.352487, -97.437286, 3083, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4958, N'Bennett County Hospital And Nursing Home - Cah', 1, NULL, NULL, N'431314', NULL, NULL, 0, 11, NULL, N'6056856622', N'6056856915', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Major Allen   Post Office Box 70D', N'Martin', N'SD', N'46007', N'57551', 43.172498, -101.732648, 3089, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4959, N'Wagner Community Memorial Hospital - Cah', 1, NULL, NULL, N'431315', NULL, NULL, 0, 20, NULL, N'6053843611', N'6053843232', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'513 3Rd St Sw  Post Office Box 280', N'Wagner', N'SD', N'46023', N'57380', 43.079081, -98.30099, 3108, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4960, N'Community Memorial Hospital - Cah', 1, NULL, NULL, N'431316', NULL, NULL, 0, 25, NULL, N'6054721110', N'6054720331', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 W 10Th Ave  Post Office Box 420', N'Redfield', N'SD', N'46115', N'57469', 44.871968, -98.520206, 3099, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4961, N'Landmann-Jungman Memorial Hospital - Cah', 1, NULL, NULL, N'431317', NULL, NULL, 0, 25, NULL, N'6055832226', N'6055834557', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Billars St', N'Scotland', N'SD', N'46009', N'57059', 43.14922, -97.726998, 3100, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4962, N'Bowdle Hospital - Cah', 1, NULL, NULL, N'431318', NULL, NULL, 0, 12, NULL, N'6052856146', N'6052856410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8001 W 5Th  Post Office Box 556', N'Bowdle', N'SD', N'46045', N'57428', 45.453038, -99.654007, 3073, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4963, N'Hans P Peterson Memorial Hospital - Cah', 1, NULL, NULL, N'431319', NULL, NULL, 0, 18, NULL, N'6058592511', N'6058593506', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 W Pine  Post Office Box 790', N'Philip', N'SD', N'46055', N'57567', 44.039433, -101.665144, 3095, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4964, N'Lead - Deadwood Regional Hospital - Cah', 1, NULL, NULL, N'431320', NULL, NULL, 0, 18, NULL, N'6057226101', N'6057196133', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'61 Charles Street', N'Deadwood', N'SD', N'46081', N'57732', 44.369841, -103.728735, 3079, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4965, N'Sturgis Regional Hospital', 1, NULL, NULL, N'431321', NULL, NULL, 0, 25, NULL, N'6057202400', N'6057200338', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'949 Harmon Street', N'Sturgis', N'SD', N'46093', N'57785', 44.401882, -103.508392, 3104, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4966, N'Fall River Hospital - Cah', 1, NULL, NULL, N'431322', NULL, NULL, 0, 25, NULL, N'6057458910', N'6057453957', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Highway 71 South', N'Hot Springs', N'SD', N'46047', N'57747', 43.418594, -103.47988, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4967, N'Custer Regional Hospital - Cah', 1, NULL, NULL, N'431323', NULL, NULL, 0, 16, NULL, N'6056739400', N'6056733586', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1039 Montmery Street', N'Custer', N'SD', N'46033', N'57730', 43.772139, -103.593355, 3098, 246, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4968, N'Avera Weskota Memorial Medical Center - Cah', 1, NULL, NULL, N'431324', NULL, NULL, 0, 16, NULL, N'6055391201', N'6055394580', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'604 1St St Ne', N'Wessington Springs', N'SD', N'46073', N'57382', 44.080394, -98.563683, 3111, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4969, N'Mobridge Regional Hospital - Cah', 1, NULL, NULL, N'431325', NULL, NULL, 0, 25, NULL, N'6058453692', N'6058458252', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 10Th Ave West', N'Mobridge', N'SD', N'46129', N'57601', 45.546136, -100.448152, 3093, 204, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4970, N'Milbank Area Hospital/Avera Health - Cah', 1, NULL, NULL, N'431326', NULL, NULL, 0, 25, NULL, N'6054324538', N'6054325412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 E Virgil Ave', N'Milbank', N'SD', N'46051', N'57252', 45.22187, -96.626294, 3090, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4971, N'St Michael''s Hospital - Cah', 1, NULL, NULL, N'431327', NULL, NULL, 0, 25, NULL, N'6055893341', N'6055893288', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 W 16Th Ave', N'Tyndall', N'SD', N'46009', N'57066', 42.991253, -97.867896, 3105, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4972, N'Pioneer Memorial Hospital - Cah', 1, NULL, NULL, N'431328', NULL, NULL, 0, 12, NULL, N'6053265161', N'6053265734', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 N Washington Ave  Post Office Box 368', N'Viborg', N'SD', N'46125', N'57070', 43.170266, -97.08144, 3107, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4973, N'Sanford Chamberlain Medical Center', 1, NULL, NULL, N'431329', NULL, NULL, 0, 25, NULL, N'6052345511', N'6052347118', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 S Byron', N'Chamberlain', N'SD', N'46015', N'57325', 43.785385, -99.326214, 3077, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4974, N'Avera St Benedict Health Center - Cah', 1, NULL, NULL, N'431330', NULL, NULL, 0, 25, NULL, N'6059283311', N'6059287368', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 West Glynn Drive', N'Parkston', N'SD', N'46067', N'57366', 43.398945, -97.990061, 3094, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4975, N'Avera Dells Area Hospital  - Cah', 1, NULL, NULL, N'431331', NULL, NULL, 0, 23, NULL, N'6054285431', N'6054283906', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 N Iowa Ave', N'Dell Rapids', N'SD', N'46099', N'57022', 43.828571, -96.715352, 3080, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4976, N'Avera Desmet Memorial Hospital - Cah', 1, NULL, NULL, N'431332', NULL, NULL, 0, 6, NULL, N'6058543329', N'6058543161', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 Prairie Avenue Sw  Post Office Box 160', N'De Smet', N'SD', N'46077', N'57231', 44.384346, -97.561711, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4977, N'Sanford Canton-Inwood Medical Center - Cah', 1, NULL, NULL, N'431333', NULL, NULL, 0, 16, NULL, N'6057641400', N'6057641450', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'440 North Hiawatha Drive', N'Canton', N'SD', N'46083', N'57013', 43.304786, -96.554539, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4978, N'Winner Regional Healthcare Center - Cah', 1, NULL, NULL, N'431334', NULL, NULL, 0, 25, NULL, N'6058427100', N'6058427211', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'745 East 8Th Street', N'Winner', N'SD', N'46123', N'57580', 43.370947, -99.847617, 3112, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4979, N'Huron Regional Medical Center', 1, NULL, NULL, N'431335', NULL, NULL, 0, 25, NULL, N'6053536200', N'6053536300', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'172 Fourth Street Se', N'Huron', N'SD', N'46005', N'57350', 44.36204, -98.21121, 3087, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4980, N'Sanford Vermillion Hospital', 1, NULL, NULL, N'431336', NULL, NULL, 0, 25, NULL, N'6056242611', N'6056248684', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 South Plum Street', N'Vermillion', N'SD', N'46027', N'57069', 42.779219, -96.9199, 3106, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4981, N'Avera Hand County Memorial Hospital And Clinic', 1, NULL, NULL, N'431337', NULL, NULL, 0, 25, NULL, N'6058532421', N'6058530333', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 W 5Th St', N'Miller', N'SD', N'46059', N'57362', 44.520623, -98.992044, 3091, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4982, N'Avera Grery Hospital', 1, NULL, NULL, N'431338', NULL, NULL, 0, 25, NULL, N'6058358394', N'6058359422', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Park Street  Post Office Box 408', N'Grery', N'SD', N'46053', N'57533', 43.229437, -99.435206, 3085, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4983, N'Coteau Des Prairies Health Care System', 1, NULL, NULL, N'431339', NULL, NULL, 0, 25, NULL, N'6056987647', N'6056984626', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Orchard Dr', N'Sisseton', N'SD', N'46109', N'57262', 45.65733, -97.050763, 3102, 205, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4984, N'Select Specialty Hospital - Sioux Falls', 1, NULL, NULL, N'432002', NULL, NULL, 0, 24, NULL, N'6053129520', N'6053129501', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1305 West 18Th Street', N'Sioux Falls', N'SD', N'46099', N'57105', 43.535326, -96.74313, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4985, N'Lifescape', 1, NULL, NULL, N'433300', NULL, NULL, 0, 18, NULL, N'6054449500', N'6054449501', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 W 26Th St', N'Sioux Falls', N'SD', N'46099', N'57105', 43.529342, -96.756029, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4986, N'South Dakota Human Services Center', 1, NULL, NULL, N'434003', NULL, NULL, 0, 133, NULL, N'6056683100', N'6056683460', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3515 Broadway Ave   Post Office Box 7600', N'Yankton', N'SD', N'46135', N'57078', 42.871205, -97.397112, 3113, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4987, N'Sanford Usd Medical Center', 1, NULL, NULL, N'439801', NULL, NULL, 0, 0, NULL, N'6053289292', N'6053289291', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1205 South Grange Avenue Suite 201', N'Sioux Falls', N'SD', N'46099', N'57105', 43.534915, -96.741399, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4988, N'Avera Mckennan Transplant Institute', 1, NULL, NULL, N'439802', NULL, NULL, 0, 0, NULL, N'6053227814', N'6053227810', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1315 S Cliff Ave  Ste 1000  Po Box 5045', N'Sioux Falls', N'SD', N'46099', N'57117', 43.541999, -96.71137, 3101, 247, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4989, N'Unicoi County Memorial Hospital', 1, NULL, NULL, N'440001', NULL, NULL, 0, 48, NULL, N'4237433141', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Greenway Circle', N'Erwin', N'TN', N'47171', N'37650', 36.133267, -82.412187, 3136, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4990, N'Jackson-Madison County General Hospital', 1, NULL, NULL, N'440002', NULL, NULL, 0, 635, NULL, N'7315415000', N'7314254990', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 Skyline Drive', N'Jackson', N'TN', N'47113', N'38301', 35.63954, -88.831973, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4991, N'Sumner Regional Medical Center', 1, NULL, NULL, N'440003', NULL, NULL, 0, 155, NULL, N'6154524210', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Hartsville Pike', N'Gallatin', N'TN', N'47165', N'37066', 36.391021, -86.433656, 3141, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4992, N'Tristar Skyline Medical Center', 1, NULL, NULL, N'440006', NULL, NULL, 0, 395, NULL, N'6157692000', N'6157697102', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3441 Dickerson Pike', N'Nashville', N'TN', N'47037', N'37207', 36.24542, -86.756471, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4993, N'United Regional Medical Center', 1, NULL, NULL, N'440007', NULL, NULL, 0, 54, NULL, N'9317283586', N'9317286877', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Mcarthur St', N'Manchester', N'TN', N'47031', N'37355', 35.469529, -86.084939, 3163, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4994, N'Henderson County Community Hospital', 1, NULL, NULL, N'440008', NULL, NULL, 0, 45, NULL, N'7319681801', N'7319688113', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 W Church St', N'Lexington', N'TN', N'47077', N'38351', 35.654195, -88.398838, 3159, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4995, N'Cumberland Medical Center', 1, NULL, NULL, N'440009', NULL, NULL, 0, 189, NULL, N'9314849511', N'9317078150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'421 S Main St', N'Crossville', N'TN', N'47035', N'38555', 35.940869, -85.020874, 3131, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4996, N'Wayne Medical Center', 1, NULL, NULL, N'440010', NULL, NULL, 0, 80, NULL, N'9317225411', N'7312856400', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 J V Mangubat Dr', N'Waynesboro', N'TN', N'47181', N'38485', 35.319522, -87.762247, 3197, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4997, N'Blount Memorial Hospital', 1, NULL, NULL, N'440011', NULL, NULL, 0, 304, NULL, N'8659837211', N'8659812333', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'907 E Lamar Alexander Parkway', N'Maryville', N'TN', N'47009', N'37804', 35.754958, -83.958602, 3165, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4998, N'Wellmont Bristol Regional Medical Center', 1, NULL, NULL, N'440012', NULL, NULL, 0, 282, NULL, N'4238441121', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Park Blvd', N'Bristol', N'TN', N'47163', N'37620', 36.595106, -82.188744, 3118, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (4999, N'The University Of Tn Medical Center', 1, NULL, NULL, N'440015', NULL, NULL, 0, 581, NULL, N'8655449000', N'8653056968', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1924 Alcoa Highway', N'Knoxville', N'TN', N'47093', N'37920', 35.937282, -83.948635, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5000, N'Baptist Memorial Hospital Huntingdon', 1, NULL, NULL, N'440016', NULL, NULL, 0, 70, NULL, N'7319864461', N'7319867288', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'631 Rb Wilson Dr', N'Huntingdon', N'TN', N'47017', N'38344', 36.023062, -88.413493, 3146, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5001, N'Wellmont Holston Valley Medical Center', 1, NULL, NULL, N'440017', NULL, NULL, 0, 519, NULL, N'4232244000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 West Ravine Road', N'Kingsport', N'TN', N'47163', N'37662', 36.553005, -82.55426, 3152, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5002, N'Sycamore Shoals Hospital', 1, NULL, NULL, N'440018', NULL, NULL, 0, 109, NULL, N'4235421300', N'4235421439', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 West Elk Avenue', N'Elizabethton', N'TN', N'47019', N'37643', 36.342759, -82.251718, 3151, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5003, N'Southern Tennessee Regional Health System Pulaski', 1, NULL, NULL, N'440020', NULL, NULL, 0, 95, NULL, N'9313637531', N'9316369303', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1265 E College St', N'Pulaski', N'TN', N'47055', N'38478', 35.192228, -87.007123, 3180, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5004, N'Laughlin Memorial Hospital Inc', 1, NULL, NULL, N'440025', NULL, NULL, 0, 140, NULL, N'4237875000', N'4237986545', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1420 Tusculum Blvd', N'Greeneville', N'TN', N'47059', N'37745', 36.173873, -82.792743, 3142, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5005, N'Williamson Medical Center', 1, NULL, NULL, N'440029', NULL, NULL, 0, 185, NULL, N'6154355000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4321 Carothers Parkway', N'Franklin', N'TN', N'47187', N'37067', 35.916151, -86.81696, 3139, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5006, N'Morristown Hamblen Hospital Association', 1, NULL, NULL, N'440030', NULL, NULL, 0, 155, NULL, N'4235864231', N'4234925001', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'908 W 4Th North St', N'Morristown', N'TN', N'47063', N'37814', 36.211897, -83.304451, 3170, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5007, N'Roane Medical Center', 1, NULL, NULL, N'440031', NULL, NULL, 0, 109, NULL, N'8653161000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8045 Roane Medical Center Drive', N'Harriman', N'TN', N'47145', N'37748', 35.888312, -84.554418, 3143, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5008, N'Wellmont Hawkins County Memorial Hospital', 1, NULL, NULL, N'440032', NULL, NULL, 0, 50, NULL, N'4239217000', N'4239217034', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'851 Locust Street', N'Rogersville', N'TN', N'47073', N'37857', 36.400416, -83.011651, 3183, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5009, N'Tennova Healthcare-Lafollett Medical Center', 1, NULL, NULL, N'440033', NULL, NULL, 0, 67, NULL, N'4239071440', N'4239071163', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'923 East Central Avenue', N'La Follette', N'TN', N'47013', N'37766', 36.387967, -84.111365, 3154, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5010, N'Methodist Medical Center Of Oak Ridge', 1, NULL, NULL, N'440034', NULL, NULL, 0, 301, NULL, N'8658351000', N'8658354054', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'990 Oak Ridge Turnpike Box 529', N'Oak Ridge', N'TN', N'47001', N'37830', 36.023397, -84.2439, 3174, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5011, N'Gateway Medical Center', 1, NULL, NULL, N'440035', NULL, NULL, 0, 270, NULL, N'9315021000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'651 Dunlop Lane', N'Clarksville', N'TN', N'47125', N'37040', 36.580414, -87.268485, 3125, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5012, N'Vanderbilt University Hospital', 1, NULL, NULL, N'440039', NULL, NULL, 0, 985, NULL, N'6153223454', N'6153437317', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1161 21St Avenue South', N'Nashville', N'TN', N'47037', N'37232', 36.143378, -86.799946, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5013, N'Perry Community Hospital', 1, NULL, NULL, N'440040', NULL, NULL, 0, 53, NULL, N'9315892121', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2718 Squirrel Hollow Drive', N'Linden', N'TN', N'47135', N'37096', 35.593032, -87.862568, 3160, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5014, N'Tristar Horizon Medical Center', 1, NULL, NULL, N'440046', NULL, NULL, 0, 157, NULL, N'6154460446', N'6154412514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Highway 70 East', N'Dickson', N'TN', N'47043', N'37055', 36.072121, -87.374809, 3133, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5015, N'Baptist Memorial Hospital', 1, NULL, NULL, N'440048', NULL, NULL, 0, 927, NULL, N'9012265000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove Road', N'Memphis', N'TN', N'47157', N'38120', 35.130758, -89.861022, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5016, N'Methodist Healthcare Memphis Hospitals', 1, NULL, NULL, N'440049', NULL, NULL, 0, 1537, NULL, N'9015168274', N'9015160842', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1265 Union Ave Suite 700', N'Memphis', N'TN', N'47157', N'38104', 35.137088, -90.019145, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5017, N'Takoma Regional Hospital', 1, NULL, NULL, N'440050', NULL, NULL, 0, 94, NULL, N'4236393151', N'4236362374', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Takoma Ave', N'Greeneville', N'TN', N'47059', N'37743', 36.152421, -82.84509, 3142, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5018, N'Tennova Healthcare-Mcnairy Regional', 1, NULL, NULL, N'440051', NULL, NULL, 0, 86, NULL, N'7316453221', N'7316458275', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 E Poplar Ave', N'Selmer', N'TN', N'47109', N'38375', 35.163028, -88.574535, 3185, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5019, N'Saint Thomas Rutherford Hospital', 1, NULL, NULL, N'440053', NULL, NULL, 0, 286, NULL, N'6153964100', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Medical Center Parkway', N'Murfreesboro', N'TN', N'47149', N'37129', 35.85864, -86.424241, 3171, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5020, N'Tennova Healthcare-Jefferson Memorial Hospital', 1, NULL, NULL, N'440056', NULL, NULL, 0, 58, NULL, N'8654712500', N'8654712450', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Hospital Drive', N'Jefferson City', N'TN', N'47089', N'37760', 36.10686, -83.51964, 3149, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5021, N'Claiborne Medical Center', 1, NULL, NULL, N'440057', NULL, NULL, 0, 85, NULL, N'4236264211', N'4236269926', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Old Knoxville Highway', N'Tazewell', N'TN', N'47025', N'37879', 36.453341, -83.571972, 3193, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5022, N'Southern Tennessee Regional Hlth System Winchester', 1, NULL, NULL, N'440058', NULL, NULL, 0, 145, NULL, N'9319678295', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'185 Hospital Road', N'Winchester', N'TN', N'47051', N'37398', 35.176003, -86.091088, 3198, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5023, N'Cookeville Regional Medical Center', 1, NULL, NULL, N'440059', NULL, NULL, 0, 227, NULL, N'9316462000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Boulevard', N'Cookeville', N'TN', N'47141', N'38501', 36.16996, -85.50935, 3128, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5024, N'Milan General Hospital', 1, NULL, NULL, N'440060', NULL, NULL, 0, 70, NULL, N'7316861591', N'7316865129', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4039 Highland St', N'Milan', N'TN', N'47053', N'38358', 35.913311, -88.753495, 3169, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5025, N'Tennova Healthcare-Volunteer Martin', 1, NULL, NULL, N'440061', NULL, NULL, 0, 100, NULL, N'7315874261', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 Mount Pelia Rd', N'Martin', N'TN', N'47183', N'38237', 36.333451, -88.869384, 3164, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5026, N'Johnson City Medical Center', 1, NULL, NULL, N'440063', NULL, NULL, 0, 585, NULL, N'4234316111', N'4234311037', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N State Of Franklin Rd', N'Johnson City', N'TN', N'47179', N'37604', 36.307484, -82.386395, 3151, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5027, N'Grandview Medical Center', 1, NULL, NULL, N'440064', NULL, NULL, 0, 70, NULL, N'4238379500', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Highway 28', N'Jasper', N'TN', N'47115', N'37347', 35.074245, -85.626079, 3189, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5028, N'Northcrest Medical Center', 1, NULL, NULL, N'440065', NULL, NULL, 0, 109, NULL, N'6153842411', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Northcrest Drive', N'Springfield', N'TN', N'47147', N'37172', 36.479581, -86.889033, 3191, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5029, N'Lakeway Regional Hospital', 1, NULL, NULL, N'440067', NULL, NULL, 0, 135, NULL, N'4235226000', N'4235878548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'726 Mcfarland St', N'Morristown', N'TN', N'47063', N'37814', 36.214632, -83.304331, 3170, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5030, N'Starr Regional Medical Center Athens', 1, NULL, NULL, N'440068', NULL, NULL, 0, 118, NULL, N'4237451411', N'4237443362', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1114 W Madison Ave', N'Athens', N'TN', N'47107', N'37371', 35.440789, -84.608823, 3117, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5031, N'Decatur County General Hospital', 1, NULL, NULL, N'440070', NULL, NULL, 0, 40, NULL, N'7318473031', N'7318471122', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'969 Tennessee Ave S', N'Parsons', N'TN', N'47039', N'38363', 35.635713, -88.12317, 3177, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5032, N'Tennova Healthcare-Dyersburg Regional', 1, NULL, NULL, N'440072', NULL, NULL, 0, 225, NULL, N'7312852410', N'7312884705', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Tickle St', N'Dyersburg', N'TN', N'47045', N'38024', 36.047358, -89.38059, 3134, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5033, N'Maury Regional Hospital', 1, NULL, NULL, N'440073', NULL, NULL, 0, 258, NULL, N'9313811111', N'9315404160', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1224 Trotwood Ave', N'Columbia', N'TN', N'47119', N'38401', 35.605855, -87.065844, 3127, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5034, N'Leconte Medical Center', 1, NULL, NULL, N'440081', NULL, NULL, 0, 79, NULL, N'8654467500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'742 Middlecreek Road', N'Sevierville', N'TN', N'47035', N'37862', 35.853732, -83.536841, 3186, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5035, N'Saint Thomas West Hospital', 1, NULL, NULL, N'440082', NULL, NULL, 0, 571, NULL, N'6152222111', N'6152226502', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4220 Harding Rd Po Box 380', N'Nashville', N'TN', N'47037', N'37205', 36.128055, -86.842905, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5036, N'Jamestown Regional Medical Center', 1, NULL, NULL, N'440083', NULL, NULL, 0, 85, NULL, N'9318793352', N'9318794896', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'436 Central Avenue West', N'Jamestown', N'TN', N'47049', N'38556', 36.431226, -84.942554, 3148, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5037, N'Sweetwater Hospital Association', 1, NULL, NULL, N'440084', NULL, NULL, 0, 59, NULL, N'8652138200', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 Wright St', N'Sweetwater', N'TN', N'47123', N'37874', 35.60025, -84.464223, 3192, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5038, N'Memorial Healthcare System Inc', 1, NULL, NULL, N'440091', NULL, NULL, 0, 405, NULL, N'4234952525', N'4234957726', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Desales Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.039821, -85.260508, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5039, N'Lincoln Medical Center', 1, NULL, NULL, N'440102', NULL, NULL, 0, 91, NULL, N'9314381100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Medical Center Blvd', N'Fayetteville', N'TN', N'47103', N'37334', 35.15092, -86.556198, 3138, 3, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5040, N'Erlanger Medical Center', 1, NULL, NULL, N'440104', NULL, NULL, 0, 760, NULL, N'4237787000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 E 3Rd St', N'Chattanooga', N'TN', N'47065', N'37403', 35.047899, -85.290853, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5041, N'Hardin Medical Center', 1, NULL, NULL, N'440109', NULL, NULL, 0, 58, NULL, N'7319268121', N'7319268303', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'935 Wayne Road', N'Savannah', N'TN', N'47071', N'38372', 35.227115, -88.230265, 3184, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5042, N'Fort Loudon Medical Center', 1, NULL, NULL, N'440110', NULL, NULL, 0, 50, NULL, N'8652716000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'550 Fort Loudon Medical Center Dr', N'Lenoir City', N'TN', N'47105', N'37772', 35.825854, -84.27085, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5043, N'Metro Nashville General Hospital', 1, NULL, NULL, N'440111', NULL, NULL, 0, 150, NULL, N'6153414490', N'6153414202', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 Albion Street', N'Nashville', N'TN', N'47037', N'37208', 36.166128, -86.806373, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5044, N'Tennova Healthcare', 1, NULL, NULL, N'440120', NULL, NULL, 0, 610, NULL, N'8655458000', N'8655457380', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Oak Hill Avenue', N'Knoxville', N'TN', N'47093', N'37917', 35.992217, -83.928169, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5045, N'Fort Sanders Regional Medical Center', 1, NULL, NULL, N'440125', NULL, NULL, 0, 553, NULL, N'8655411101', N'8655411853', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 W Clinch Ave', N'Knoxville', N'TN', N'47093', N'37916', 35.95689, -83.936923, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5046, N'Baptist Memorial Hospital Union City', 1, NULL, NULL, N'440130', NULL, NULL, 0, 137, NULL, N'7318852410', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Bishop St Po Box 310', N'Union City', N'TN', N'47131', N'38261', 36.414423, -89.039037, 3195, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5047, N'Baptist Memorial Hospital Tipton', 1, NULL, NULL, N'440131', NULL, NULL, 0, 100, NULL, N'9014762621', N'9014755504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1995 Highway 51 S', N'Covington', N'TN', N'47167', N'38019', 35.534904, -89.676647, 3130, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5048, N'Henry County Medical Center', 1, NULL, NULL, N'440132', NULL, NULL, 0, 142, NULL, N'7316421220', N'7316429588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Tyson Av', N'Paris', N'TN', N'47079', N'38242', 36.297671, -88.310907, 3176, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5049, N'Saint Thomas Midtown Hospital', 1, NULL, NULL, N'440133', NULL, NULL, 0, 683, NULL, N'6152845555', N'6152841592', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Church St', N'Nashville', N'TN', N'47037', N'37236', 36.1534, -86.800835, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5050, N'Heritage Medical Center', 1, NULL, NULL, N'440137', NULL, NULL, 0, 104, NULL, N'9316855433', N'9316858257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2835 Hwy 231 N', N'Shelbyville', N'TN', N'47003', N'37160', 35.562985, -86.446426, 3187, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5051, N'Harton Regional Medical Center', 1, NULL, NULL, N'440144', NULL, NULL, 0, 137, NULL, N'9313933000', N'9313937855', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 N Jackson St Box 460', N'Tullahoma', N'TN', N'47031', N'37388', 35.382495, -86.230148, 3194, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5052, N'Baptist Rehabilitation Germantown', 1, NULL, NULL, N'440147', NULL, NULL, 0, 11, NULL, N'9017571350', N'9017573496', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 Exeter Road', N'Germantown', N'TN', N'47157', N'38138', 35.092708, -89.802259, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5053, N'Dekalb Community Hosp', 1, NULL, NULL, N'440148', NULL, NULL, 0, 71, NULL, N'6152155000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 W Main St', N'Smithville', N'TN', N'47041', N'37166', 35.959403, -85.829841, 3188, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5054, N'Tristar Summit Medical Center', 1, NULL, NULL, N'440150', NULL, NULL, 0, 188, NULL, N'6153163000', N'6153164912', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5655 Frist Blvd', N'Hermitage', N'TN', N'47037', N'37076', 36.177543, -86.607163, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5055, N'River Park Hospital', 1, NULL, NULL, N'440151', NULL, NULL, 0, 152, NULL, N'9318154101', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1559 Sparta Street', N'Mc Minnville', N'TN', N'47177', N'37110', 35.698694, -85.742339, 3167, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5056, N'Regional One Health', 1, NULL, NULL, N'440152', NULL, NULL, 0, 631, NULL, N'9015457928', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'877 Jefferson Avenue', N'Memphis', N'TN', N'47157', N'38103', 35.142634, -90.031273, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5057, N'Tennova Healthcare-Newport Medical Center', 1, NULL, NULL, N'440153', NULL, NULL, 0, 74, NULL, N'4236252200', N'4236252215', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'435 2Nd St', N'Newport', N'TN', N'47029', N'37821', 35.965067, -83.181619, 3173, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5058, N'Parkridge Medical Center', 1, NULL, NULL, N'440156', NULL, NULL, 0, 621, NULL, N'4238944220', N'4234931208', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2333 Mccallie Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.033739, -85.26886, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5059, N'Delta Medical Center', 1, NULL, NULL, N'440159', NULL, NULL, 0, 243, NULL, N'9013698100', N'9013698503', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Getwell Rd', N'Memphis', N'TN', N'47157', N'38118', 35.066399, -89.932243, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5060, N'Tristar Centennial Medical Center', 1, NULL, NULL, N'440161', NULL, NULL, 0, 586, NULL, N'6153421000', N'6153421045', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Patterson Street', N'Nashville', N'TN', N'47037', N'37203', 36.152463, -86.808599, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5061, N'Healthsouth Chattanooga Rehab Hospital', 1, NULL, NULL, N'440162', NULL, NULL, 0, 80, NULL, N'4236980221', N'4236979117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 Mccallie Ave', N'Chattanooga', N'TN', N'47065', N'37404', 35.031447, -85.262446, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5062, N'Parkwest Medical Center', 1, NULL, NULL, N'440173', NULL, NULL, 0, 555, NULL, N'8659709800', N'8653731012', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9352 Park West Blvd', N'Knoxville', N'TN', N'47093', N'37923', 35.917901, -84.100732, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5063, N'Southern Tennessee Regional Health System Lawrence', 1, NULL, NULL, N'440175', NULL, NULL, 0, 99, NULL, N'9317626571', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 43 S Box 847', N'Lawrenceburg', N'TN', N'47099', N'38464', 35.242302, -87.334739, 3156, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5064, N'Indian Path Medical Center', 1, NULL, NULL, N'440176', NULL, NULL, 0, 300, NULL, N'4234311941', N'4234311244', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Brookside Dr', N'Kingsport', N'TN', N'47163', N'37660', 36.550686, -82.517916, 3152, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5065, N'Jellico Community Hospital', 1, NULL, NULL, N'440180', NULL, NULL, 0, 54, NULL, N'4237847252', N'4237841136', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'188 Hospital Lane', N'Jellico', N'TN', N'47013', N'37762', 36.573614, -84.127239, 3150, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5066, N'Bolivar General Hospital', 1, NULL, NULL, N'440181', NULL, NULL, 0, 61, NULL, N'7316583100', N'7316590259', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'650 Nuckolls Road', N'Bolivar', N'TN', N'47069', N'38008', 35.267563, -89.000587, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5067, N'Mckenzie Regional Hospital', 1, NULL, NULL, N'440182', NULL, NULL, 0, 45, NULL, N'7313525344', N'7313522733', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'161 Hospital Drive', N'Mc Kenzie', N'TN', N'47017', N'38201', 36.13756, -88.490722, 3166, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5068, N'St Francis Hospital', 1, NULL, NULL, N'440183', NULL, NULL, 0, 519, NULL, N'9017651000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Park Ave', N'Memphis', N'TN', N'47157', N'38119', 35.099901, -89.864516, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5069, N'Franklin Woods Community Hospital', 1, NULL, NULL, N'440184', NULL, NULL, 0, 139, NULL, N'4233021120', N'4233021129', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Med Tech Parkway', N'Johnson City', N'TN', N'47179', N'37604', 36.339065, -82.40371, 3151, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5070, N'Tennova Healthcare-Cleveland', 1, NULL, NULL, N'440185', NULL, NULL, 0, 351, NULL, N'4233394132', N'4235596653', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2305 Chambliss Ave Nw', N'Cleveland', N'TN', N'47011', N'37311', 35.176965, -84.868485, 3126, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5071, N'Livingston Regional Hospital', 1, NULL, NULL, N'440187', NULL, NULL, 0, 110, NULL, N'9318235611', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 Oak St Box 550', N'Livingston', N'TN', N'47133', N'38570', 36.384664, -85.328086, 3161, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5072, N'Tennova Healthcare-Regional Jackson', 1, NULL, NULL, N'440189', NULL, NULL, 0, 154, NULL, N'7316612000', N'7316612187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'367 Hospital Blvd', N'Jackson', N'TN', N'47113', N'38305', 35.683683, -88.853085, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5073, N'Highlands Medical Center', 1, NULL, NULL, N'440192', NULL, NULL, 0, 60, NULL, N'9317389211', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sewell Dr', N'Sparta', N'TN', N'47185', N'38583', 35.947982, -85.477281, 3190, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5074, N'University Medical Center', 1, NULL, NULL, N'440193', NULL, NULL, 0, 250, NULL, N'6154448262', N'6154491215', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 Baddour Parkway', N'Lebanon', N'TN', N'47189', N'37087', 36.219101, -86.328101, 3157, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5075, N'Tristar Hendersonville Medical Center', 1, NULL, NULL, N'440194', NULL, NULL, 0, 148, NULL, N'6153381000', N'6152644281', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 New Shackle Island Rd', N'Hendersonville', N'TN', N'47165', N'37075', 36.323824, -86.620393, 3145, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5076, N'Tristar Southern Hills Medical Center', 1, NULL, NULL, N'440197', NULL, NULL, 0, 180, NULL, N'6157814000', N'6157814113', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'391 Wallace Rd', N'Nashville', N'TN', N'47037', N'37211', 36.077872, -86.723814, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5077, N'Stones River Hospital', 1, NULL, NULL, N'440200', NULL, NULL, 0, 55, NULL, N'6155634001', N'6155633151', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'324 Doolittle Road', N'Woodbury', N'TN', N'47015', N'37190', 35.832864, -86.072943, 3199, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5078, N'Saint Thomas Hospital For Specialty Surgery', 1, NULL, NULL, N'440218', NULL, NULL, 0, 23, NULL, N'6155158200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2011 Murphy Avenue', N'Nashville', N'TN', N'47037', N'37203', 36.155685, -86.804042, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5079, N'Tristar Stonecrest Medical Center', 1, NULL, NULL, N'440227', NULL, NULL, 0, 75, NULL, N'6157682000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stonecrest Boulevard', N'Smyrna', N'TN', N'47149', N'37167', 35.976793, -86.562475, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5080, N'Saint Francis Bartlett Medical Center', 1, NULL, NULL, N'440228', NULL, NULL, 0, 196, NULL, N'9018207050', N'9017651799', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2986 Kate Bond Rd', N'Bartlett', N'TN', N'47157', N'38133', 35.207034, -89.802347, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5081, N'(Closed) Behavioral Healthcare Center At Clark', 1, NULL, NULL, N'440229', NULL, NULL, 0, 26, NULL, N'9315386420', N'9315386447', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Professonial Park Drive', N'Clarksville', N'TN', N'47125', N'37040', 36.528592, -87.30987, 3125, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5082, N'Trustpoint Hospital', 1, NULL, NULL, N'440231', NULL, NULL, 0, 86, NULL, N'6155771111', N'6155774945', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1009 North Thompson Lane', N'Murfreesboro', N'TN', N'47149', N'37129', 35.864591, -86.428065, 3171, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5083, N'Houston County Community Hospital', 1, NULL, NULL, N'440232', NULL, NULL, 0, 25, NULL, N'9312894211', N'9312894337', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5001 East Main Street', N'Erin', N'TN', N'47083', N'37061', 36.319516, -87.689193, 3135, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5084, N'Saint Thomas Hickman Hospital', 1, NULL, NULL, N'441300', NULL, NULL, 0, 25, NULL, N'9317294271', N'9317294612', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 East Swan Street', N'Centerville', N'TN', N'47081', N'37033', 35.779377, -87.460254, 3123, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5085, N'Trousdale Medical Center', 1, NULL, NULL, N'441301', NULL, NULL, 0, 25, NULL, N'6153742221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Church Street', N'Hartsville', N'TN', N'47169', N'37074', 36.386881, -86.167595, 3144, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5086, N'Three Rivers Hospital', 1, NULL, NULL, N'441303', NULL, NULL, 0, 25, NULL, N'9312964203', N'9312961013', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 Highway 13 South', N'Waverly', N'TN', N'47085', N'37185', 36.082931, -87.794643, 3196, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5087, N'Johnson County Community Hospital', 1, NULL, NULL, N'441304', NULL, NULL, 0, 2, NULL, N'4237271110', N'4237271112', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 S Shady St', N'Mountain City', N'TN', N'47091', N'37683', 36.453074, -81.798595, 2519, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5088, N'Macon County General Hospital', 1, NULL, NULL, N'441305', NULL, NULL, 0, 25, NULL, N'6156662147', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'204 Medical Drive', N'Lafayette', N'TN', N'47111', N'37083', 36.51969, -86.025377, 3155, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5089, N'Erlanger Bledsoe Hospital', 1, NULL, NULL, N'441306', NULL, NULL, 0, 31, NULL, N'4234472112', N'4234475289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'71 Wheelertown Avenue', N'Pikeville', N'TN', N'47007', N'37367', 35.621399, -85.190396, 3178, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5090, N'Riverview Regional Medical Center', 1, NULL, NULL, N'441307', NULL, NULL, 0, 35, NULL, N'6157359815', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'158 Hospital Drive', N'Carthage', N'TN', N'47159', N'37030', 36.263594, -85.948852, 3121, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5091, N'Medical Center Of Manchester', 1, NULL, NULL, N'441308', NULL, NULL, 0, 25, NULL, N'9317286354', N'9317286354', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'481 Interstate Drive', N'Manchester', N'TN', N'47031', N'37355', 35.497875, -86.077981, 3163, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5092, N'Marshall Medical Center', 1, NULL, NULL, N'441309', NULL, NULL, 0, 25, NULL, N'9313596276', N'9313599522', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1080 North Ellington Parkway', N'Lewisburg', N'TN', N'47117', N'37091', 35.46312, -86.784954, 3158, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5093, N'Rhea Medical Center', 1, NULL, NULL, N'441310', NULL, NULL, 0, 25, NULL, N'4237751121', N'4238434500', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9400 Rhea County Highway', N'Dayton', N'TN', N'47143', N'37321', 35.530763, -84.981829, 3132, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5094, N'Tristar Ashland City Medical Center', 1, NULL, NULL, N'441311', NULL, NULL, 0, 12, NULL, N'6157923030', N'6157922490', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'313 North Main St', N'Ashland City', N'TN', N'47021', N'37015', 36.277202, -87.066156, 3200, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5095, N'Wellmont Hancock County Hospital', 1, NULL, NULL, N'441313', NULL, NULL, 0, 25, NULL, N'4237335001', N'4237335092', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1519 Main Street Hwy 33', N'Sneedville', N'TN', N'47067', N'37869', 36.535505, -83.211287, 3170, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5096, N'Lauderdale Community Hospital', 1, NULL, NULL, N'441314', NULL, NULL, 0, 25, NULL, N'7312212200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'326 Asbury Avenue', N'Ripley', N'TN', N'47097', N'38063', 35.746554, -89.548949, 3181, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5097, N'Copper Basin Medical Center', 1, NULL, NULL, N'441315', NULL, NULL, 0, 25, NULL, N'4234965511', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Highway 68', N'Copperhill', N'TN', N'47139', N'37317', 34.988969, -84.370756, 3129, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5098, N'Camden General Hospital', 1, NULL, NULL, N'441316', NULL, NULL, 0, 25, NULL, N'7315840109', N'7315840124', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'175 Hospital Drive', N'Camden', N'TN', N'47005', N'38320', 36.055783, -88.107521, 3120, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5099, N'Pioneer Community Hospital Of Scott', 1, NULL, NULL, N'441318', NULL, NULL, 0, 25, NULL, N'4232865300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18797 Alberta Street', N'Oneida', N'TN', N'47151', N'37841', 36.504788, -84.514914, 3175, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5100, N'Cumberland River Hospital', 1, NULL, NULL, N'441319', NULL, NULL, 0, 36, NULL, N'9312433581', N'9312435219', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Old Jefferson St', N'Celina', N'TN', N'47027', N'38551', 36.544389, -85.50123, 3122, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5101, N'Kindred Hospital - Nashville', 1, NULL, NULL, N'442006', NULL, NULL, 0, 60, NULL, N'6156872600', N'6158626933', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1412 County Hospital Road B-1', N'Nashville', N'TN', N'47037', N'37218', 36.183771, -86.843631, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5102, N'Kindred Hospital - Chattanooga', 1, NULL, NULL, N'442007', NULL, NULL, 0, 49, NULL, N'4232667721', N'4232267516', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Walnut Street', N'Chattanooga', N'TN', N'47065', N'37402', 35.048236, -85.307506, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5103, N'Baptist Memorial Restorative Care Hospital', 1, NULL, NULL, N'442010', NULL, NULL, 0, 30, NULL, N'9012261400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove Road 1 West', N'Memphis', N'TN', N'47157', N'38120', 35.130876, -89.860255, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5104, N'Select Specialty Hospital-Nashville', 1, NULL, NULL, N'442011', NULL, NULL, 0, 70, NULL, N'6152844599', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hayes Street', N'Nashville', N'TN', N'47037', N'37203', 36.152386, -86.800259, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5105, N'Select Specialty Hospital-Knoxville', 1, NULL, NULL, N'442012', NULL, NULL, 0, 35, NULL, N'8655472615', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Clinch Ave Forth Floor N', N'Knoxville', N'TN', N'47093', N'37916', 35.957194, -83.936391, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5106, N'Methodist Extended Care Hospital', 1, NULL, NULL, N'442013', NULL, NULL, 0, 36, NULL, N'9015162152', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 South Claybrook', N'Memphis', N'TN', N'47157', N'38104', 35.149022, -90.051628, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5107, N'Select Specialty Hospital Memphis', 1, NULL, NULL, N'442014', NULL, NULL, 0, 30, NULL, N'9017651245', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5959 Park Avenue', N'Memphis', N'TN', N'47157', N'38119', 35.10057, -89.865115, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5108, N'Select Specialty Hospital-North Knoxville', 1, NULL, NULL, N'442015', NULL, NULL, 0, 33, NULL, N'8655457370', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7557 B Dannaher Drive Suite 145', N'Powell', N'TN', N'47093', N'37849', 36.031747, -84.027968, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5109, N'Select Specialty Hospital-Tricities', 1, NULL, NULL, N'442016', NULL, NULL, 0, 25, NULL, N'4238445900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Medical Park Boulevard 5Th Floor', N'Bristol', N'TN', N'47163', N'37620', 36.595106, -82.188744, 3118, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5110, N'Regional One Health Extended Care Hospital', 1, NULL, NULL, N'442017', NULL, NULL, 0, 24, NULL, N'9015133000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'890 Madison Avenue 4Th Floor', N'Memphis', N'TN', N'47157', N'38103', 35.145372, -90.053451, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5111, N'Siskin Hospital For Physical Rehabilitation', 1, NULL, NULL, N'443025', NULL, NULL, 0, 80, NULL, N'4236341200', N'4236341209', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Siskin Plaza', N'Chattanooga', N'TN', N'47065', N'37403', 35.04563, -85.30968, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5112, N'Healthsouth Rehabilitation Hospital', 1, NULL, NULL, N'443027', NULL, NULL, 0, 50, NULL, N'4232467240', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 Cassel Drive', N'Kingsport', N'TN', N'47163', N'37660', 36.555634, -82.55661, 3152, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5113, N'Vanderbilt Stallworth Rehab Hospital', 1, NULL, NULL, N'443028', NULL, NULL, 0, 80, NULL, N'6153207600', N'6153279289', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 Childrens Way', N'Nashville', N'TN', N'47037', N'37212', 36.16223, -86.774353, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5114, N'Healthsouth Rehabilitation Hospital Of Memphis', 1, NULL, NULL, N'443029', NULL, NULL, 0, 80, NULL, N'9017222000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1282 Union Avenue', N'Memphis', N'TN', N'47157', N'38104', 35.137142, -90.01885, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5115, N'Healthsouth Cane Creek Rehab Hospital', 1, NULL, NULL, N'443030', NULL, NULL, 0, 40, NULL, N'7315874231', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Mt Pelia Road', N'Martin', N'TN', N'47183', N'38237', 36.332813, -88.870848, 3164, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5116, N'Healthsouth Rehabilitation Hospital - North', 1, NULL, NULL, N'443031', NULL, NULL, 0, 40, NULL, N'9012135400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4100 Austin Peay Highway', N'Memphis', N'TN', N'47157', N'38128', 35.238452, -89.891962, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5117, N'Healthsouth Chattanooga Rehab Hospital', 1, NULL, NULL, N'443032', NULL, NULL, 0, 69, NULL, N'4236980221', N'4236979117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 Mccallie Avenue', N'Chattanooga', N'TN', N'47065', N'37404', 35.031447, -85.262446, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5118, N'Quillen Rehabilitation Hospital', 1, NULL, NULL, N'443033', NULL, NULL, 0, 26, NULL, N'4239521700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2511 Wesley Street', N'Johnson City', N'TN', N'47179', N'37601', 36.35124, -82.376753, 3151, 250, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5119, N'Baptist Memorial Rehabilitation Hospital', 1, NULL, NULL, N'443034', NULL, NULL, 0, 49, NULL, N'9017571350', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1240 S Germantown Road', N'Germantown', N'TN', N'47157', N'38138', 35.116497, -89.801187, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5120, N'St Jude Childrens Research Hospital', 1, NULL, NULL, N'443302', NULL, NULL, 0, 78, NULL, N'9014953300', NULL, 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'262 Danny Thomas Place', N'Memphis', N'TN', N'47157', N'38105', 35.154783, -90.043109, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5121, N'East Tennessee Childrens Hospital', 1, NULL, NULL, N'443303', NULL, NULL, 0, 122, NULL, N'8655418000', N'8655418343', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2018 Clinch Ave Sw', N'Knoxville', N'TN', N'47093', N'37916', 35.956463, -83.937816, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5122, N'Memphis Mental Health Institute', 1, NULL, NULL, N'444001', NULL, NULL, 0, 135, NULL, N'9015771800', N'9015771434', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'951 Court Avenue', N'Memphis', N'TN', N'47157', N'38103', 35.141466, -90.029287, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5123, N'Moccassin Bend Mental Health Institute', 1, NULL, NULL, N'444002', NULL, NULL, 0, 172, NULL, N'4237852271', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Moccasin Bend Road', N'Chattanooga', N'TN', N'47065', N'37405', 35.02822, -85.335395, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5124, N'Ridgeview Psychiatric Hospital And Center', 1, NULL, NULL, N'444003', NULL, NULL, 0, 44, NULL, N'8654821076', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 W Tyrone Rd', N'Oak Ridge', N'TN', N'47001', N'37830', 36.024957, -84.243568, 3174, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5125, N'Lakeside Behavioral Health System', 1, NULL, NULL, N'444004', NULL, NULL, 0, 290, NULL, N'9013774700', N'9013730987', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2911 Brunswick Rd', N'Memphis', N'TN', N'47157', N'38133', 35.204394, -89.777713, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5126, N'Behavioral Healthcare Center At Martin', 1, NULL, NULL, N'444005', NULL, NULL, 0, 16, NULL, N'7315882830', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'458 Hannings Lane P O Box 1006', N'Martin', N'TN', N'47183', N'38237', 36.33737, -88.867864, 3164, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5127, N'Rolling Hills Psychiatric Hospital', 1, NULL, NULL, N'444007', NULL, NULL, 0, 80, NULL, N'6152264930', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2014 Quail Hollow Circle', N'Franklin', N'TN', N'47187', N'37067', 35.914521, -86.816624, 3139, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5128, N'Western Mental Health Institute', 1, NULL, NULL, N'444008', NULL, NULL, 0, 247, NULL, N'7312282000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Old Hwy 64 West', N'Bolivar', N'TN', N'47069', N'38008', 35.256194, -88.987839, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5129, N'Pathways Of Tennessee Inc', 1, NULL, NULL, N'444010', NULL, NULL, 0, 25, NULL, N'7319358200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'238 Summar Dr', N'Jackson', N'TN', N'47113', N'38301', 35.6367934, -88.8357773, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5130, N'Middle Tn Mental Health Institute', 1, NULL, NULL, N'444014', NULL, NULL, 0, 100, NULL, N'6159027565', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'221 Stewarts Ferry Pike', N'Nashville', N'TN', N'47037', N'37214', 36.160463, -86.646299, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5131, N'Behavioral Healthcare Center At Clarksville', 1, NULL, NULL, N'444019', NULL, NULL, 0, 26, NULL, N'9315386420', N'9315386447', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'930 Professional Park Drive', N'Clarksville', N'TN', N'47125', N'37040', 36.574042, -87.272006, 3125, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5132, N'Behavioral Healthcare Center At Columbia', 1, NULL, NULL, N'444021', NULL, NULL, 0, 16, NULL, N'9313886593', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Rosewood Drive', N'Columbia', N'TN', N'47119', N'38401', 35.605503, -87.059478, 3127, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5133, N'Ten Broeck Tennessee', 1, NULL, NULL, N'444022', NULL, NULL, 0, 32, NULL, N'9317832075', N'9317832521', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1 Medical Center Blvd 5 West', N'Cookeville', N'TN', N'47141', N'38501', 36.162839, -85.501642, 3128, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5134, N'Oak Hills Behavioral Center', 1, NULL, NULL, N'444023', NULL, NULL, 0, 16, NULL, N'1112223333', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'49 Old Hickory Blvd', N'Jackson', N'TN', N'47113', N'38305', 35.654828, -88.830082, 3147, 249, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5135, N'University Of Tn Transplant Center At Knoxville', 1, NULL, NULL, N'449800', NULL, NULL, 0, 0, NULL, N'8655449000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1924 Alcoa Highway', N'Knoxville', N'TN', N'47093', N'37920', 35.94255, -83.949369, 3153, 252, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5136, N'Vanderbilt University Transplant Center', 1, NULL, NULL, N'449802', NULL, NULL, 0, 0, NULL, N'6153223454', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1161 21St Ave South', N'Nashville', N'TN', N'47037', N'37232', 36.134577, -86.801131, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5137, N'Baptist Memorial Hospital Transplant Center', 1, NULL, NULL, N'449803', NULL, NULL, 0, 0, NULL, N'9012265000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6019 Walnut Grove', N'Memphis', N'TN', N'47157', N'38120', 35.149022, -90.051628, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5138, N'Centennial Medical Transplant Center', 1, NULL, NULL, N'449804', NULL, NULL, 0, 0, NULL, N'6153421000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2300 Patterson Street', N'Nashville', N'TN', N'47037', N'37203', 36.151885, -86.809746, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5139, N'Lebonheur Children''s Medical Transplant Center', 1, NULL, NULL, N'449805', NULL, NULL, 0, 0, NULL, N'9015167270', N'9015188590', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'50 North Dunlap', N'Memphis', N'TN', N'47157', N'38103', 35.149022, -90.051628, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5140, N'Methodist Hc Transplant', 1, NULL, NULL, N'449806', NULL, NULL, 0, 0, NULL, N'9015167270', N'9015162036', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1265 Union Avenue', N'Memphis', N'TN', N'47157', N'38104', 35.136931, -90.018397, 3168, 253, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5141, N'Erlanger Regional Kidney Transplant', 1, NULL, NULL, N'449807', NULL, NULL, 0, 0, NULL, N'4237782174', N'4237786674', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'975 East Third Street', N'Chattanooga', N'TN', N'47065', N'37403', 35.04563, -85.30968, 3124, 248, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5142, N'St Thomas Hospital Transplant', 1, NULL, NULL, N'449808', NULL, NULL, 0, 0, NULL, N'6152225480', N'6152228074', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4220 Harding Road', N'Nashville', N'TN', N'47037', N'37205', 36.16223, -86.774353, 3172, 254, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5143, N'Providence Memorial Hospital', 1, NULL, NULL, N'450002', NULL, NULL, 0, 500, NULL, N'9155776011', N'9155776109', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 N Oren St', N'El Paso', N'TX', N'48141', N'79902', 31.771813, -106.499907, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5144, N'Peterson Regional Medical Center', 1, NULL, NULL, N'450007', NULL, NULL, 0, 145, NULL, N'8308964200', N'8302587381', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'551 Hill Country Drive', N'Kerrville', N'TX', N'48265', N'78028', 30.044733, -99.151596, 3312, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5145, N'Children''s Hospital -Scott & White Healthcare', 1, NULL, NULL, N'450008', NULL, NULL, 0, 138, NULL, N'2547718600', N'2547718665', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Sw H K Dodgen Loop', N'Temple', N'TX', N'48027', N'76502', 31.094226, -97.389985, 3382, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5146, N'United Regional Health Care System', 1, NULL, NULL, N'450010', NULL, NULL, 0, 565, NULL, N'9407643055', N'9407643041', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 11Th Street', N'Wichita Falls', N'TX', N'48485', N'76301', 33.902109, -98.501852, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5147, N'St Joseph Regional Health Center', 1, NULL, NULL, N'450011', NULL, NULL, 0, 316, NULL, N'9797763912', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Franciscan Dr', N'Bryan', N'TX', N'48041', N'77802', 30.655598, -96.346767, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5148, N'Parkland Health And Hospital System', 1, NULL, NULL, N'450015', NULL, NULL, 0, 968, NULL, N'2145908000', N'2145908096', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5200 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.811799, -96.836982, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5149, N'University Of Texas Medical Branch', 1, NULL, NULL, N'450018', NULL, NULL, 0, 1236, NULL, N'4097721011', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 University Boulevard', N'Galveston', N'TX', N'48167', N'77555', 29.31122, -94.774556, 3278, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5150, N'Baylor University Medical Center', 1, NULL, NULL, N'450021', NULL, NULL, 0, 997, NULL, N'2148200111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Gaston Ave', N'Dallas', N'TX', N'48113', N'75246', 32.790685, -96.780663, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5151, N'Citizens Medical Center', 1, NULL, NULL, N'450023', NULL, NULL, 0, 344, NULL, N'3615725113', N'3615725070', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Hospital Drive', N'Victoria', N'TX', N'48469', N'77901', 28.812866, -96.976723, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5152, N'University Medical Center Of El Paso', 1, NULL, NULL, N'450024', NULL, NULL, 0, 346, NULL, N'9155217602', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4815 Alameda Ave', N'El Paso', N'TX', N'48141', N'79905', 31.770742, -106.434452, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5153, N'Vhs Brownsville Hospital Company Llc', 1, NULL, NULL, N'450028', NULL, NULL, 0, 280, NULL, N'9565441400', N'9565542001', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1040 W Jefferson St', N'Brownsville', N'TX', N'48061', N'78520', 25.916569, -97.510566, 3229, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5154, N'Laredo Medical Center', 1, NULL, NULL, N'450029', NULL, NULL, 0, 326, NULL, N'9567965000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 East Saunders', N'Laredo', N'TX', N'48479', N'78044', 27.530589, -99.479142, 3320, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5155, N'od Shepherd Medical Center Marshall', 1, NULL, NULL, N'450032', NULL, NULL, 0, 149, NULL, N'9039276712', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 S Washington', N'Marshall', N'TX', N'48203', N'75670', 32.536651, -94.367868, 3331, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5156, N'Vhs Harlingen Hospital Company Llc', 1, NULL, NULL, N'450033', NULL, NULL, 0, 602, NULL, N'9563891100', N'9563891632', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2101 Pease St', N'Harlingen', N'TX', N'48061', N'78550', 26.173893, -97.671081, 3294, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5157, N'Christus Southeast Texas- St Elizabeth', 1, NULL, NULL, N'450034', NULL, NULL, 0, 658, NULL, N'4098927171', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830 Calder Avenue', N'Beaumont', N'TX', N'48245', N'77702', 30.085592, -94.131263, 3219, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5158, N'St Joseph Medical Center', 1, NULL, NULL, N'450035', NULL, NULL, 0, 792, NULL, N'7137571000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 St. Joseph Parkway', N'Houston', N'TX', N'48201', N'77002', 29.747785, -95.366182, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5159, N'od Shepherd Medical Center', 1, NULL, NULL, N'450037', NULL, NULL, 0, 425, NULL, N'9033152000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Marshall Avenue', N'Longview', N'TX', N'48183', N'75601', 32.501448, -94.731471, 3325, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5160, N'Jps Health Network', 1, NULL, NULL, N'450039', NULL, NULL, 0, 429, NULL, N'8179213431', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Main St', N'Fort Worth', N'TX', N'48439', N'76104', 32.726764, -97.326407, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5161, N'Covenant Medical Center', 1, NULL, NULL, N'450040', NULL, NULL, 0, 868, NULL, N'8067256000', N'8067237361', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3615 19Th Street', N'Lubbock', N'TX', N'48303', N'79410', 33.577867, -101.892357, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5162, N'Providence Health Center', 1, NULL, NULL, N'450042', NULL, NULL, 0, 278, NULL, N'2547514000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6901 Medical Parkway', N'Waco', N'TX', N'48309', N'76712', 31.514649, -97.197926, 3392, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5163, N'Ut Southwestern University Hospital St Paul', 1, NULL, NULL, N'450044', NULL, NULL, 0, 550, NULL, N'2146335555', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6201 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.819472, -96.846871, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5164, N'Christus Spohn Hospital Corpus Christi', 1, NULL, NULL, N'450046', NULL, NULL, 0, 1049, NULL, N'3619024103', N'3619024949', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Elizabeth Street', N'Corpus Christi', N'TX', N'48355', N'78404', 27.777489, -97.395121, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5165, N'Methodist Dallas Medical Center', 1, NULL, NULL, N'450051', NULL, NULL, 0, 478, NULL, N'2149472879', N'2149472519', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1441 North Beckley Avenue', N'Dallas', N'TX', N'48113', N'75203', 32.761639, -96.823006, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5166, N'odall Witcher Hospital', 1, NULL, NULL, N'450052', NULL, NULL, 0, 33, NULL, N'2546758322', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Posey Avenue', N'Clifton', N'TX', N'48035', N'76634', 31.78238, -97.576686, 3244, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5167, N'Scott & White Memorial Hospital', 1, NULL, NULL, N'450054', NULL, NULL, 0, 564, NULL, N'2547242111', N'2547246120', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2401 31St St', N'Temple', N'TX', N'48027', N'76508', 31.078693, -97.365938, 3382, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5168, N'Rolling Plains Memorial Hospital', 1, NULL, NULL, N'450055', NULL, NULL, 0, 85, NULL, N'3252351701', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 E Arizona', N'Sweetwater', N'TX', N'48353', N'79556', 32.453882, -100.398314, 3380, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5169, N'Seton Medical Center Austin', 1, NULL, NULL, N'450056', NULL, NULL, 0, 530, NULL, N'5123241000', N'5123241924', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 W 38Th St', N'Austin', N'TX', N'48453', N'78705', 30.306075, -97.745038, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5170, N'Baptist Medical Center', 1, NULL, NULL, N'450058', NULL, NULL, 0, 1741, NULL, N'2102971020', N'2102970005', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Dallas Street', N'San Antonio', N'TX', N'48029', N'78205', 29.433174, -98.492305, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5171, N'Texas Health Arlington Memorial Hospital', 1, NULL, NULL, N'450064', NULL, NULL, 0, 369, NULL, N'8175486100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 W Randol Mill Rd', N'Arlington', N'TX', N'48439', N'76012', 32.750113, -97.114916, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5172, N'Memorial Hermann Texas Medical Center', 1, NULL, NULL, N'450068', NULL, NULL, 0, 1098, NULL, N'7137043700', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6411 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.713791, -95.397547, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5173, N'Brazosport Regional Health System', 1, NULL, NULL, N'450072', NULL, NULL, 0, 165, NULL, N'9792974411', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Drive', N'Lake Jackson', N'TX', N'48039', N'77566', 29.031022, -95.451843, 3318, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5174, N'University Of Texas M D Anderson Cancer Centerthe', 1, NULL, NULL, N'450076', NULL, NULL, 0, 656, NULL, N'7137922121', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Holcombe Blvd', N'Houston', N'TX', N'48201', N'77030', 31.309358, -95.483801, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5175, N'Anson General Hospital', 1, NULL, NULL, N'450078', NULL, NULL, 0, 45, NULL, N'3258233231', N'3258233098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Avenue J', N'Anson', N'TX', N'48253', N'79501', 32.767506, -99.895515, 3209, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5176, N'Baylor Medical Center At Irving', 1, NULL, NULL, N'450079', NULL, NULL, 0, 288, NULL, N'9725798100', N'9725795290', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 N Macarthur Blvd', N'Irving', N'TX', N'48113', N'75061', 32.834578, -96.959215, 3303, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5177, N'Titus Regional Medical Center', 1, NULL, NULL, N'450080', NULL, NULL, 0, 165, NULL, N'9035776000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 N Jefferson', N'Mount Pleasant', N'TX', N'48449', N'75455', 33.175273, -94.97043, 3339, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5178, N'Christus Spohn Hospital Beeville', 1, NULL, NULL, N'450082', NULL, NULL, 0, 69, NULL, N'3613542000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 E Houston Hwy', N'Beeville', N'TX', N'48025', N'78102', 28.408247, -97.732159, 3221, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5179, N'East Texas Medical Center', 1, NULL, NULL, N'450083', NULL, NULL, 0, 536, NULL, N'9035970351', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Beckham Street', N'Tyler', N'TX', N'48423', N'75701', 32.338102, -95.291862, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5180, N'Graham Regional Medical Center', 1, NULL, NULL, N'450085', NULL, NULL, 0, 42, NULL, N'9405493400', N'9405215156', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Montmery Road', N'Graham', N'TX', N'48503', N'76450', 33.089869, -98.584909, 3285, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5181, N'North Hills Hospital', 1, NULL, NULL, N'450087', NULL, NULL, 0, 140, NULL, N'8172551000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Booth Calloway Road', N'North Richland Hills', N'TX', N'48439', N'76180', 32.829303, -97.212235, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5182, N'North Texas Medical Center', 1, NULL, NULL, N'450090', NULL, NULL, 0, 60, NULL, N'9406128600', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Hospital Blvd', N'Gainesville', N'TX', N'48097', N'76240', 33.645361, -97.162143, 3277, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5183, N'Fort Duncan Medical Center', 1, NULL, NULL, N'450092', NULL, NULL, 0, 101, NULL, N'8307735321', N'8308722517', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3333 N Foster Maldonado Blvd', N'Eagle Pass', N'TX', N'48323', N'78852', 28.711418, -100.454105, 3264, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5184, N'Bayshore Medical Center', 1, NULL, NULL, N'450097', NULL, NULL, 0, 481, NULL, N'7133591000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4000 Spencer Hwy', N'Pasadena', N'TX', N'48201', N'77504', 29.665195, -95.181617, 3353, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5185, N'Pampa Regional Medical Center', 1, NULL, NULL, N'450099', NULL, NULL, 0, 115, NULL, N'8066653721', N'8066635514', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Plaza', N'Pampa', N'TX', N'48179', N'79065', 35.536156, -100.959871, 3351, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5186, N'Hillcrest Baptist Medical Center', 1, NULL, NULL, N'450101', NULL, NULL, 0, 393, NULL, N'2542022000', N'2542029441', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hillcrest Medical Blvd', N'Waco', N'TX', N'48309', N'76712', 31.489272, -97.156788, 3392, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5187, N'Mother Frances Hospital', 1, NULL, NULL, N'450102', NULL, NULL, 0, 474, NULL, N'9035938441', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Dawson', N'Tyler', N'TX', N'48423', N'75701', 32.342265, -95.292285, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5188, N'Guadalupe Regional Medical Center', 1, NULL, NULL, N'450104', NULL, NULL, 0, 117, NULL, N'8303792411', N'8303721582', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 E Court St', N'Seguin', N'TX', N'48187', N'78155', 29.569035, -97.948297, 3372, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5189, N'Las Palmas Medical Center', 1, NULL, NULL, N'450107', NULL, NULL, 0, 550, NULL, N'9155211200', N'9155445203', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1801 North Oren Street', N'El Paso', N'TX', N'48141', N'79902', 31.770257, -106.498544, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5190, N'Connally Memorial Medical Center', 1, NULL, NULL, N'450108', NULL, NULL, 0, 44, NULL, N'8303931300', N'8303931301', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'499 10Th Street', N'Floresville', N'TX', N'48493', N'78114', 29.158608, -98.172361, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5191, N'South Texas Health System', 1, NULL, NULL, N'450119', NULL, NULL, 0, 848, NULL, N'9566324000', N'9562892002', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1102 W Trenton Road', N'Edinburg', N'TX', N'48215', N'78539', 26.262556, -98.177336, 3266, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5192, N'University Medical Center At Brackenridge', 1, NULL, NULL, N'450124', NULL, NULL, 0, 399, NULL, N'5123247000', N'5123247051', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 E 15Th Street', N'Austin', N'TX', N'48453', N'78701', 30.274993, -97.732749, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5193, N'Knapp Medical Center', 1, NULL, NULL, N'450128', NULL, NULL, 0, 233, NULL, N'9569688567', N'9569692293', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 East Eight Street', N'Weslaco', N'TX', N'48215', N'78596', 26.163237, -98.01578, 3398, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5194, N'Nix Health Care System', 1, NULL, NULL, N'450130', NULL, NULL, 0, 294, NULL, N'2102712188', N'2102712023', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'414 Navarro Suite 600', N'San Antonio', N'TX', N'48029', N'78205', 29.425383, -98.489706, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5195, N'Medical Center Hospital', 1, NULL, NULL, N'450132', NULL, NULL, 0, 402, NULL, N'4326404000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 W 4Th Street', N'Odessa', N'TX', N'48135', N'79761', 31.844698, -102.374336, 3346, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5196, N'Midland Memorial Hospital', 1, NULL, NULL, N'450133', NULL, NULL, 0, 321, NULL, N'4326851111', N'4326854970', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Rosalind Redfern Grover Parkway', N'Midland', N'TX', N'48329', N'79701', 31.997585, -102.100006, 3336, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5197, N'Texas Health Harris Methodist Fort Worth', 1, NULL, NULL, N'450135', NULL, NULL, 0, 610, NULL, N'8172502100', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Pennsylvania Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.73848, -97.339313, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5198, N'Baylor Scott And White All Saints Medical Center', 1, NULL, NULL, N'450137', NULL, NULL, 0, 537, NULL, N'8179262544', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Eighth Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.730288, -97.34373, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5199, N'Seton Smithville Regional Hospital', 1, NULL, NULL, N'450143', NULL, NULL, 0, 36, NULL, N'5122373214', N'5122375708', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Highway 71', N'Smithville', N'TX', N'48021', N'78957', 29.974448, -97.105872, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5200, N'Permian Regional Medical Center Andrews County Ho', 1, NULL, NULL, N'450144', NULL, NULL, 0, 85, NULL, N'4325232200', N'4324642180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'720 Hospital Drive', N'Andrews', N'TX', N'48003', N'79714', 32.337144, -102.546362, 3207, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5201, N'Detar Hospital Navarro', 1, NULL, NULL, N'450147', NULL, NULL, 0, 308, NULL, N'3615757441', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 E San Antonio St', N'Victoria', N'TX', N'48469', N'77902', 28.807595, -96.99946, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5202, N'Texas Health Harris Methodist Hospital Cleburne', 1, NULL, NULL, N'450148', NULL, NULL, 0, 137, NULL, N'8176412551', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Walls Drive', N'Cleburne', N'TX', N'48251', N'76033', 32.332874, -97.438798, 3242, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5203, N'Metroplex Hospital', 1, NULL, NULL, N'450152', NULL, NULL, 0, 177, NULL, N'2545267523', N'2545263483', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 S Clear Creek Road', N'Killeen', N'TX', N'48027', N'76542', 31.112873, -97.799705, 3314, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5204, N'Val Verde Regional Medical Center', 1, NULL, NULL, N'450154', NULL, NULL, 0, 93, NULL, N'8307758566', N'8307031704', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Bedell Ave', N'Del Rio', N'TX', N'48465', N'78840', 29.374519, -100.89314, 3258, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5205, N'Hereford Regional Medical Center', 1, NULL, NULL, N'450155', NULL, NULL, 0, 42, NULL, N'8063642141', N'8063499387', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Third', N'Hereford', N'TX', N'48117', N'79045', 34.820348, -102.391915, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5206, N'Grace Medical Center', 1, NULL, NULL, N'450162', NULL, NULL, 0, 123, NULL, N'8067884100', N'8067884278', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2412 50Th St', N'Lubbock', N'TX', N'48303', N'79412', 33.548786, -101.869732, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5207, N'Christus Spohn Hospital Kleberg', 1, NULL, NULL, N'450163', NULL, NULL, 0, 106, NULL, N'3615951661', N'3615955005', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1311 East General Cavazos Blvd', N'Kingsville', N'TX', N'48273', N'78363', 27.491403, -97.850797, 3315, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5208, N'South Texas Regional Medical Center', 1, NULL, NULL, N'450165', NULL, NULL, 0, 30, NULL, N'8307693515', N'8307695264', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1905 Hwy 97 East', N'Jourdanton', N'TX', N'48013', N'78026', 28.918029, -98.546407, 3306, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5209, N'Mission Regional Medical Center', 1, NULL, NULL, N'450176', NULL, NULL, 0, 297, NULL, N'9563239000', N'9565809102', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Bryan Road', N'Mission', N'TX', N'48215', N'78572', 26.19658, -98.312673, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5210, N'Uvalde Memorial Hospital', 1, NULL, NULL, N'450177', NULL, NULL, 0, 66, NULL, N'8302786251', N'8302788529', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 Garner Field Road', N'Uvalde', N'TX', N'48463', N'78801', 29.215109, -99.768688, 3389, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5211, N'Pecos County Memorial Hospital', 1, NULL, NULL, N'450178', NULL, NULL, 0, 27, NULL, N'4323364201', N'4323364545', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'387 West I 10', N'Fort Stockton', N'TX', N'48371', N'79735', 30.904962, -102.875306, 3273, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5212, N'Memorial Hermann Hospital System', 1, NULL, NULL, N'450184', NULL, NULL, 0, 1375, NULL, N'7134486796', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1635  North Loop West', N'Houston', N'TX', N'48201', N'77008', 29.812283, -95.430685, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5213, N'Scott & White Hospital Brenham', 1, NULL, NULL, N'450187', NULL, NULL, 0, 99, NULL, N'9798366173', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Medical Parkway', N'Brenham', N'TX', N'48477', N'77833', 30.145217, -96.398828, 3228, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5214, N'Hill Regional Hospital', 1, NULL, NULL, N'450192', NULL, NULL, 0, 92, NULL, N'2545808500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Circle Drive', N'Hillsboro', N'TX', N'48217', N'76645', 32.011484, -97.099044, 3298, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5215, N'Chi St Luke''s Health Baylor College Of Medicine Me', 1, NULL, NULL, N'450193', NULL, NULL, 0, 881, NULL, N'8323551000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6720 Bertner', N'Houston', N'TX', N'48201', N'77030', 29.708468, -95.399166, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5216, N'East Texas Medical Center Jacksonville', 1, NULL, NULL, N'450194', NULL, NULL, 0, 74, NULL, N'9035415000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 S Ragsdale', N'Jacksonville', N'TX', N'48073', N'75766', 31.961418, -95.270547, 3304, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5217, N'Paris Regional Medical Center', 1, NULL, NULL, N'450196', NULL, NULL, 0, 368, NULL, N'9037854521', N'9037373848', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Clarksville St', N'Paris', N'TX', N'48277', N'75460', 33.660277, -95.546783, 3352, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5218, N'Wadley Regional Medical Center', 1, NULL, NULL, N'450200', NULL, NULL, 0, 370, NULL, N'9037988000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Pine Street', N'Texarkana', N'TX', N'48037', N'75501', 33.428603, -94.047255, 3384, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5219, N'Weatherford Regional Medical Center', 1, NULL, NULL, N'450203', NULL, NULL, 0, 99, NULL, N'8175991190', N'8175991162', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'713 E Anderson St', N'Weatherford', N'TX', N'48367', N'76086', 32.747472, -97.785759, 3394, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5220, N'Northwest Texas Hospital', 1, NULL, NULL, N'450209', NULL, NULL, 0, 475, NULL, N'8063541110', N'8063541109', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Coulter Road', N'Amarillo', N'TX', N'48375', N'79106', 35.198606, -101.921855, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5221, N'Etmc Carthage', 1, NULL, NULL, N'450210', NULL, NULL, 0, 42, NULL, N'936933841', N'9036944633', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'409 West Cottage', N'Carthage', N'TX', N'48365', N'75633', 32.157041, -94.338114, 3238, 126, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5222, N'Memorial Medical Center Of East Texas', 1, NULL, NULL, N'450211', NULL, NULL, 0, 271, NULL, N'9366348111', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 West Frank Street', N'Lufkin', N'TX', N'48005', N'75901', 31.338624, -94.728856, 3327, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5223, N'University Health System', 1, NULL, NULL, N'450213', NULL, NULL, 0, 604, NULL, N'2103584000', N'2103584020', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4502 Medical Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.509532, -98.577242, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5224, N'Gulf Coast Medical Center', 1, NULL, NULL, N'450214', NULL, NULL, 0, 161, NULL, N'9795322500', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10141 Us 59 North', N'Wharton', N'TX', N'48481', N'77488', 29.328013, -96.120493, 3399, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5225, N'Baylor Scott & White Medical Center - Llano', 1, NULL, NULL, N'450219', NULL, NULL, 0, 30, NULL, N'3252475040', N'9152472313', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 W Ollie', N'Llano', N'TX', N'48299', N'78643', 30.743343, -98.677078, 3324, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5226, N'Moore County Hospital District', 1, NULL, NULL, N'450221', NULL, NULL, 0, 60, NULL, N'8069357171', N'8069356458', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'224 E Second Street', N'Dumas', N'TX', N'48341', N'79029', 35.864265, -101.971058, 3262, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5227, N'Conroe Regional Medical Center', 1, NULL, NULL, N'450222', NULL, NULL, 0, 328, NULL, N'9365391111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 Medical Center Blvd', N'Conroe', N'TX', N'48339', N'77304', 30.283054, -95.46936, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5228, N'Hendrick Medical Center', 1, NULL, NULL, N'450229', NULL, NULL, 0, 511, NULL, N'3256702000', N'3256702293', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Pine', N'Abilene', N'TX', N'48441', N'79601', 32.471542, -99.73115, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5229, N'Baptist St Anthony''s Hospital', 1, NULL, NULL, N'450231', NULL, NULL, 0, 452, NULL, N'8062122000', N'8062122919', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Wallace Blvd', N'Amarillo', N'TX', N'48375', N'79106', 35.196243, -101.917897, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5230, N'Memorial Hospital', 1, NULL, NULL, N'450235', NULL, NULL, 0, 35, NULL, N'8306727581', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 North Sarah Dewitt Drive', N'nzales', N'TX', N'48177', N'78629', 29.519215, -97.450983, 3284, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5231, N'Hopkins County Memorial Hospital', 1, NULL, NULL, N'450236', NULL, NULL, 0, 96, NULL, N'9038857671', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Airport Rd', N'Sulphur Springs', N'TX', N'48223', N'75482', 33.156216, -95.599632, 3379, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5232, N'Christus Santa Rosa Hospital', 1, NULL, NULL, N'450237', NULL, NULL, 0, 601, NULL, N'2107043342', N'2107043466', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Santa Rosa Steet', N'San Antonio', N'TX', N'48029', N'78207', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5233, N'Faith Community Hospital', 1, NULL, NULL, N'450241', NULL, NULL, 0, 41, NULL, N'9405676633', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'215 Chisholm Trail', N'Jacksboro', N'TX', N'48237', N'76458', 33.218448, -98.158656, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5234, N'Hamlin Memorial Hospital', 1, NULL, NULL, N'450243', NULL, NULL, 0, 25, NULL, N'3255763646', N'3255762922', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'632 N W Second Street', N'Hamlin', N'TX', N'48253', N'79520', 32.885162, -100.13466, 3293, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5235, N'Bellville General Hospital', 1, NULL, NULL, N'450253', NULL, NULL, 0, 32, NULL, N'9798653141', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 N Cummings', N'Bellville', N'TX', N'48015', N'77418', 29.952858, -96.260414, 3222, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5236, N'Wise Regional Health System', 1, NULL, NULL, N'450271', NULL, NULL, 0, 85, NULL, N'9406275921', N'9406260101', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'609 Medical Center Drive', N'Decatur', N'TX', N'48497', N'76234', 33.219793, -97.593883, 3257, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5237, N'Central Texas Medical Center', 1, NULL, NULL, N'450272', NULL, NULL, 0, 113, NULL, N'5127533690', N'5127533598', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Wonder World Drive', N'San Marcos', N'TX', N'48209', N'78666', 29.85143, -97.94664, 3371, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5238, N'Baylor Scott & White Medical Center Garland', 1, NULL, NULL, N'450280', NULL, NULL, 0, 243, NULL, N'9724875000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Marie Curie Drive', N'Garland', N'TX', N'48113', N'75042', 32.918601, -96.661092, 3279, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5239, N'Harris Health System', 1, NULL, NULL, N'450289', NULL, NULL, 0, 975, NULL, N'7135666417', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2525 Holly Hall', N'Houston', N'TX', N'48201', N'77054', 29.685371, -95.390939, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5240, N'Texas Health Presbyterian Hospital Kaufman', 1, NULL, NULL, N'450292', NULL, NULL, 0, 91, NULL, N'9729327200', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Ed Hall', N'Kaufman', N'TX', N'48257', N'75142', 32.591119, -96.315984, 3309, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5241, N'Frio Regional Hospital', 1, NULL, NULL, N'450293', NULL, NULL, 0, 22, NULL, N'8303343617', N'8303349812', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 S Ih 35', N'Pearsall', N'TX', N'48163', N'78061', 28.896252, -99.116212, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5242, N'College Station Medical Center', 1, NULL, NULL, N'450299', NULL, NULL, 0, 167, NULL, N'9797645151', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1604 Rock Prairie Road', N'College Station', N'TX', N'48041', N'77842', 30.582626, -96.291014, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5243, N'Stamford Memorial Hospital', 1, NULL, NULL, N'450306', NULL, NULL, 0, 25, NULL, N'3257732725', N'3257733781', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 Columbia Street', N'Stamford', N'TX', N'48253', N'79553', 32.92799, -99.78501, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5244, N'Texoma Medical Center', 1, NULL, NULL, N'450324', NULL, NULL, 0, 251, NULL, N'9034164000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5016 S Us Highway 75', N'Denison', N'TX', N'48181', N'75020', 33.568811, -96.603059, 3259, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5245, N'Oakbend Medical Center', 1, NULL, NULL, N'450330', NULL, NULL, 0, 243, NULL, N'2813413000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1705 Jackson St', N'Richmond', N'TX', N'48157', N'77469', 29.5778, -95.771213, 3364, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5246, N'San Angelo Community Medical Center', 1, NULL, NULL, N'450340', NULL, NULL, 0, 171, NULL, N'3259499511', N'3259476550', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Knickerbocker Road', N'San Angelo', N'TX', N'48451', N'76904', 31.422315, -100.467158, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5247, N'Baptist Beaumont Hospital', 1, NULL, NULL, N'450346', NULL, NULL, 0, 507, NULL, N'4092125012', N'4092125022', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3080 College Street', N'Beaumont', N'TX', N'48245', N'77701', 30.068484, -94.119621, 3219, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5248, N'Huntsville Memorial Hospital', 1, NULL, NULL, N'450347', NULL, NULL, 0, 144, NULL, N'9362913411', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Memorial Hospital Drive', N'Huntsville', N'TX', N'48471', N'77340', 30.69849, -95.55799, 3301, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5249, N'Falls Community Hospital And Clinic', 1, NULL, NULL, N'450348', NULL, NULL, 0, 44, NULL, N'2548033561', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'322 Coleman Street', N'Marlin', N'TX', N'48145', N'76661', 31.307469, -96.894747, 3330, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5250, N'Texas Health Harris Methodist Hospital Stephenvill', 1, NULL, NULL, N'450351', NULL, NULL, 0, 98, NULL, N'2549651500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 N Belknap St', N'Stephenville', N'TX', N'48143', N'76401', 32.222235, -98.204224, 3378, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5251, N'Hunt Regional Medical Center', 1, NULL, NULL, N'450352', NULL, NULL, 0, 192, NULL, N'9034085000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4215 Joe Ramsey Blvd', N'Greenville', N'TX', N'48231', N'75401', 33.123657, -96.123204, 3289, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5252, N'Methodist Hospitalthe', 1, NULL, NULL, N'450358', NULL, NULL, 0, 1299, NULL, N'7137902221', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6565 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.710842, -95.399887, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5253, N'Childress Regional Medical Center', 1, NULL, NULL, N'450369', NULL, NULL, 0, 39, NULL, N'9409376371', N'9409379133', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Hwy 83 North', N'Childress', N'TX', N'48075', N'79201', 34.426453, -100.204002, 3239, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5254, N'Columbus Community Hospital', 1, NULL, NULL, N'450370', NULL, NULL, 0, 40, NULL, N'9797322371', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 Shult Dr', N'Columbus', N'TX', N'48089', N'78934', 29.694203, -96.54294, 3247, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5255, N'Baylor Scott & White Medical Center- Waxahachie', 1, NULL, NULL, N'450372', NULL, NULL, 0, 104, NULL, N'9729237000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 N Interstate Highway 35E', N'Waxahachie', N'TX', N'48139', N'75165', 32.386531, -96.848331, 3393, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5256, N'Dallas Medical Center', 1, NULL, NULL, N'450379', NULL, NULL, 0, 155, NULL, N'9722471000', N'9728887090', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7 Medical Parkway', N'Dallas', N'TX', N'48113', N'75234', 32.915645, -96.871433, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5257, N'Methodist Hospital', 1, NULL, NULL, N'450388', NULL, NULL, 0, 1887, NULL, N'2105754000', N'2105756420', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7700 Floyd Curl Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.507399, -98.573474, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5258, N'East Texas Medical Center Athens', 1, NULL, NULL, N'450389', NULL, NULL, 0, 127, NULL, N'9036761000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 South Palestine', N'Athens', N'TX', N'48213', N'75751', 32.167003, -95.841391, 3213, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5259, N'Memorial Medical Center Livingston', 1, NULL, NULL, N'450395', NULL, NULL, 0, 66, NULL, N'9363274381', N'9363298730', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 Hwy 59 Bypass', N'Livingston', N'TX', N'48373', N'77351', 30.711029, -94.93299, 3327, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5260, N'Brownfield Regional Medical Center', 1, NULL, NULL, N'450399', NULL, NULL, 0, 42, NULL, N'8066373551', N'8066371779', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 East Felt Street', N'Brownfield', N'TX', N'48445', N'79316', 33.187101, -102.267668, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5261, N'Parkview Regional Hospital', 1, NULL, NULL, N'450400', NULL, NULL, 0, 59, NULL, N'2545625332', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Bonham Street', N'Mexia', N'TX', N'48293', N'76667', 31.675937, -96.4801, 3335, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5262, N'Medical Center Of Mckinney', 1, NULL, NULL, N'450403', NULL, NULL, 0, 225, NULL, N'9725478000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4500 Medical Center Drive', N'Mckinney', N'TX', N'48085', N'75069', 33.159033, -96.635558, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5263, N'Eastland Memorial Hospital', 1, NULL, NULL, N'450411', NULL, NULL, 0, 83, NULL, N'2546292601', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'304 S Daugherty', N'Eastland', N'TX', N'48133', N'76448', 32.399631, -98.821638, 3265, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5264, N'Texas Health Harris Methodist Hospital Azle', 1, NULL, NULL, N'450419', NULL, NULL, 0, 36, NULL, N'8174448700', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'108 Denver Trail', N'Azle', N'TX', N'48439', N'76020', 32.88129, -97.533632, 3216, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5265, N'Baylor Medical Center At Uptown', 1, NULL, NULL, N'450422', NULL, NULL, 0, 28, NULL, N'2144433000', N'2144433049', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2727 East Lemmon Avenue Building I', N'Dallas', N'TX', N'48113', N'75204', 32.80429, -96.79453, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5266, N'Houston Methodist San Jacinto Hospital', 1, NULL, NULL, N'450424', NULL, NULL, 0, 318, NULL, N'2814208600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Garth Road', N'Baytown', N'TX', N'48201', N'77521', 29.768499, -94.977543, 3218, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5267, N'St David''s Medical Center', 1, NULL, NULL, N'450431', NULL, NULL, 0, 570, NULL, N'5124767111', N'5124048102', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'919 E 32Nd St', N'Austin', N'TX', N'48453', N'78705', 30.290095, -97.725128, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5268, N'Navarro Regional Hospital', 1, NULL, NULL, N'450447', NULL, NULL, 0, 162, NULL, N'9036546800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3201 West Highway 22', N'Corsicana', N'TX', N'48349', N'75110', 32.091299, -96.464682, 3251, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5269, N'Glen Rose Medical Center', 1, NULL, NULL, N'450451', NULL, NULL, 0, 16, NULL, N'2548972215', N'2548971427', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1021 Holden Street', N'Glen Rose', N'TX', N'48425', N'76043', 32.241375, -97.747029, 3283, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5270, N'Tyler County Hospital', 1, NULL, NULL, N'450460', NULL, NULL, 0, 25, NULL, N'4092838141', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 West Bluff', N'Woodville', N'TX', N'48457', N'75979', 30.77526, -94.426934, 3406, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5271, N'Texas Health Presbyterian Hospital  Dallas', 1, NULL, NULL, N'450462', NULL, NULL, 0, 866, NULL, N'2143456789', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8200 Walnut Hill Lane', N'Dallas', N'TX', N'48113', N'75231', 32.883056, -96.763901, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5272, N'Matarda Regional Medical Center', 1, NULL, NULL, N'450465', NULL, NULL, 0, 58, NULL, N'9792456383', N'9792451525', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'104 7Th Street', N'Bay City', N'TX', N'48321', N'77414', 28.982805, -95.99129, 3217, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5273, N'Wilson N Jones Regional Medical Center', 1, NULL, NULL, N'450469', NULL, NULL, 0, 241, NULL, N'9038704611', N'9038912030', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 N Highland Avenue', N'Sherman', N'TX', N'48181', N'75091', 33.635677, -96.622864, 3375, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5274, N'Etmc Henderson', 1, NULL, NULL, N'450475', NULL, NULL, 0, 158, NULL, N'9036577541', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 Wilson Street', N'Henderson', N'TX', N'48401', N'75652', 32.161647, -94.796035, 3297, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5275, N'Woodland Heights Medical Center', 1, NULL, NULL, N'450484', NULL, NULL, 0, 117, NULL, N'9366348311', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 South John Redditt Drive', N'Lufkin', N'TX', N'48005', N'75904', 31.327115, -94.75602, 3327, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5276, N'Allegiance Specialty Hospital Of Kilre', 1, NULL, NULL, N'450488', NULL, NULL, 0, 60, NULL, N'9039843505', N'9039834354', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1612 South Henderson Blvd', N'Kilre', N'TX', N'48183', N'75662', 32.37387, -94.869194, 3313, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5277, N'Medical Arts Hospital', 1, NULL, NULL, N'450489', NULL, NULL, 0, 44, NULL, N'8068722183', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2200 N Bryan Ave', N'Lamesa', N'TX', N'48115', N'79331', 32.750279, -101.966471, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5278, N'Bowie Memorial Hospital', 1, NULL, NULL, N'450497', NULL, NULL, 0, 49, NULL, N'9408721126', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'705 East Greenwood Av', N'Bowie', N'TX', N'48337', N'76230', 33.560845, -97.834045, 3225, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5279, N'Stephens Memorial Hospital', 1, NULL, NULL, N'450498', NULL, NULL, 0, 40, NULL, N'2545592241', N'2545596536', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 South Geneva Street', N'Breckenridge', N'TX', N'48429', N'76424', 32.754329, -98.887722, 3227, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5280, N'Memorial Hospital', 1, NULL, NULL, N'450508', NULL, NULL, 0, 216, NULL, N'9365644611', N'9365688588', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1204 Mound St', N'Nacogdoches', N'TX', N'48347', N'75961', 31.613771, -94.649451, 3342, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5281, N'The Medical Center Of Southeast Texas', 1, NULL, NULL, N'450518', NULL, NULL, 0, 216, NULL, N'4098535900', N'4098535910', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2555 Jimmy Johnson Blvd', N'Port Arthur', N'TX', N'48245', N'77640', 29.934985, -93.984938, 3358, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5282, N'Methodist Richardson Medical Center', 1, NULL, NULL, N'450537', NULL, NULL, 0, 205, NULL, N'4692041000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2831 E President George Bush Highway', N'Richardson', N'TX', N'48113', N'75082', 32.995987, -96.669064, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5283, N'Covenant Hospital Plainview', 1, NULL, NULL, N'450539', NULL, NULL, 0, 100, NULL, N'8062965531', N'8062931885', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 Dimmitt Rd', N'Plainview', N'TX', N'48189', N'79072', 34.207225, -101.731639, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5284, N'Abilene Regional Medical Center', 1, NULL, NULL, N'450558', NULL, NULL, 0, 231, NULL, N'3254281000', N'3254281029', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6250 Hwy 83/84', N'Abilene', N'TX', N'48441', N'79606', 32.446453, -99.733348, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5285, N'Baylor Scott & White Medical Center  Grapevine', 1, NULL, NULL, N'450563', NULL, NULL, 0, 273, NULL, N'8174811588', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1650 W College St', N'Grapevine', N'TX', N'48439', N'76051', 32.935596, -97.093949, 3288, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5286, N'Palo Pinto General Hospital', 1, NULL, NULL, N'450565', NULL, NULL, 0, 99, NULL, N'9403257891', NULL, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'400 Southwest 25 Ave', N'Mineral Wells', N'TX', N'48363', N'76067', 32.799561, -98.145343, 3337, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5287, N'Shannon Medical Center', 1, NULL, NULL, N'450571', NULL, NULL, 0, 401, NULL, N'3256536741', N'3256588295', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 East Harris Avenue', N'San Angelo', N'TX', N'48451', N'76903', 31.46447, -100.435144, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5288, N'Christus Jasper Memorial Hospital', 1, NULL, NULL, N'450573', NULL, NULL, 0, 59, NULL, N'4093845461', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1275 Marvin Hancock Drive', N'Jasper', N'TX', N'48241', N'75951', 30.907296, -94.008503, 3305, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5289, N'Hemphill County Hospital', 1, NULL, NULL, N'450578', NULL, NULL, 0, 26, NULL, N'8063236622', N'8063238061', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 S 4Th St', N'Canadian', N'TX', N'48211', N'79014', 35.902889, -100.387404, 3235, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5290, N'Houston County Medical Center', 1, NULL, NULL, N'450580', NULL, NULL, 0, 49, NULL, N'9365463890', N'9365463892', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Loop 304 East', N'Crockett', N'TX', N'48225', N'75835', 31.317869, -95.436691, 3252, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5291, N'Wilbarger General Hospital', 1, NULL, NULL, N'450584', NULL, NULL, 0, 47, NULL, N'9405529351', N'9405532981', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'920 Hillcrest Dr', N'Vernon', N'TX', N'48487', N'76384', 34.158467, -99.312936, 3390, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5292, N'Seymour Hospital', 1, NULL, NULL, N'450586', NULL, NULL, 0, 49, NULL, N'9408895572', N'9408893337', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Stadium Drive', N'Seymour', N'TX', N'48023', N'76380', 33.589277, -99.247505, 3373, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5293, N'Brownwood Regional Medical Center', 1, NULL, NULL, N'450587', NULL, NULL, 0, 216, NULL, N'3256468541', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Burnet Dr', N'Brownwood', N'TX', N'48049', N'76801', 31.677419, -98.992315, 3230, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5294, N'Lake Granbury Medical Center', 1, NULL, NULL, N'450596', NULL, NULL, 0, 59, NULL, N'8175732683', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 Paluxy Rd', N'Granbury', N'TX', N'48221', N'76048', 32.431753, -97.802844, 3286, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5295, N'Cuero Community Hospital', 1, NULL, NULL, N'450597', NULL, NULL, 0, 49, NULL, N'3612756191', N'3602753999', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2550 N Esplanade', N'Cuero', N'TX', N'48123', N'77954', 29.116589, -97.280492, 3254, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5296, N'Hill Country Memorial Hospital Inc', 1, NULL, NULL, N'450604', NULL, NULL, 0, 88, NULL, N'8309974353', N'8309971348', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1020 South State Highway 16', N'Fredericksburg', N'TX', N'48171', N'78624', 30.26328, -98.87925, 3275, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5297, N'Care Regional Medical Center', 1, NULL, NULL, N'450605', NULL, NULL, 0, 75, NULL, N'3617588585', N'3617580477', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1711 W Wheeler Avenue', N'Aransas Pass', N'TX', N'48409', N'78336', 27.916082, -97.162123, 3210, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5298, N'Memorial Hermann Memorial City Medical Center', 1, NULL, NULL, N'450610', NULL, NULL, 0, 821, NULL, N'7132423000', NULL, 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 Gessner', N'Houston', N'TX', N'48201', N'77024', 29.781416, -95.544324, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5299, N'Clear Lake Regional Medical Center', 1, NULL, NULL, N'450617', NULL, NULL, 0, 528, NULL, N'2813322511', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.540283, -95.127349, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5300, N'Dimmit Regional Hospital', 1, NULL, NULL, N'450620', NULL, NULL, 0, 48, NULL, N'8308762424', N'8308765774', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'704 Hospital Drive', N'Carrizo Springs', N'TX', N'48127', N'78834', 28.519914, -99.86209, 3237, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5301, N'Denton Regional Medical Center', 1, NULL, NULL, N'450634', NULL, NULL, 0, 202, NULL, N'9403843535', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3535 South I35 East', N'Denton', N'TX', N'48121', N'76210', 33.176196, -97.093133, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5302, N'Houston Northwest Medical Center', 1, NULL, NULL, N'450638', NULL, NULL, 0, 423, NULL, N'2814401000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 Cypress Creek Parkway', N'Houston', N'TX', N'48201', N'77090', 30.018099, -95.439796, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5303, N'Texas Health Harris Methodist Hurst-Euless-Bedford', 1, NULL, NULL, N'450639', NULL, NULL, 0, 286, NULL, N'8178484000', N'8178484890', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Hospital Parkway', N'Bedford', N'TX', N'48439', N'76022', 32.835348, -97.125242, 3220, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5304, N'Nocona General Hospital', 1, NULL, NULL, N'450641', NULL, NULL, 0, 38, NULL, N'9408253235', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Park Road', N'Nocona', N'TX', N'48337', N'76255', 33.777813, -97.731568, 3345, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5305, N'Doctors Hospital Of Laredo', 1, NULL, NULL, N'450643', NULL, NULL, 0, 297, NULL, N'9565232000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10700 Mcpherson Road', N'Laredo', N'TX', N'48479', N'78041', 27.604217, -99.477038, 3320, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5306, N'West Houston Medical Center', 1, NULL, NULL, N'450644', NULL, NULL, 0, 238, NULL, N'2815888080', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12141 Richmond Ave', N'Houston', N'TX', N'48201', N'77082', 29.730278, -95.59486, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5307, N'Medical City Dallas Hospital', 1, NULL, NULL, N'450647', NULL, NULL, 0, 592, NULL, N'9725666222', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7777 Forest Lane', N'Dallas', N'TX', N'48113', N'75230', 32.909447, -96.772089, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5308, N'Medical Center Of Plano', 1, NULL, NULL, N'450651', NULL, NULL, 0, 427, NULL, N'9725966800', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 W 15Th St', N'Plano', N'TX', N'48085', N'75075', 33.019359, -96.765907, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5309, N'Scenic Mountain Medical Center', 1, NULL, NULL, N'450653', NULL, NULL, 0, 150, NULL, N'4322631211', N'4322530151', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1601 W 11Th Place', N'Big Spring', N'TX', N'48227', N'79720', 32.239603, -101.494337, 3223, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5310, N'Starr County Memorial Hospital', 1, NULL, NULL, N'450654', NULL, NULL, 0, 48, NULL, N'9564875561', N'9567168710', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'128  N Fm Rd 3167', N'Rio Grande City', N'TX', N'48427', N'78582', 26.385149, -98.829691, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5311, N'Nacogdoches Medical Center', 1, NULL, NULL, N'450656', NULL, NULL, 0, 150, NULL, N'9365699481', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4920 Ne Stallings Drive', N'Nacogdoches', N'TX', N'48347', N'75961', 31.652058, -94.654265, 3342, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5312, N'East Texas Medical Center - Fairfield', 1, NULL, NULL, N'450658', NULL, NULL, 0, 48, NULL, N'9033891612', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Newman St', N'Fairfield', N'TX', N'48161', N'75840', 31.725902, -96.169619, 3271, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5313, N'Park Plaza Hospital', 1, NULL, NULL, N'450659', NULL, NULL, 0, 508, NULL, N'7135275019', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1313 Hermann Dr', N'Houston', N'TX', N'48201', N'77004', 29.722334, -95.387978, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5314, N'Odessa Regional Medical Center', 1, NULL, NULL, N'450661', NULL, NULL, 0, 230, NULL, N'4325828340', N'4325828900', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 E 6Th Street', N'Odessa', N'TX', N'48135', N'79761', 31.851458, -102.366027, 3346, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5315, N'Valley Regional Medical Center', 1, NULL, NULL, N'450662', NULL, NULL, 0, 214, NULL, N'9563507000', N'9563507111', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 A Alton Gloor', N'Brownsville', N'TX', N'48061', N'78526', 25.979108, -97.516076, 3229, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5316, N'Sierra Medical Center', 1, NULL, NULL, N'450668', NULL, NULL, 0, 333, NULL, N'9157474000', N'9157472550', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Medical Center Dr', N'El Paso', N'TX', N'48141', N'79902', 31.77867, -106.47965, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5317, N'Medical Center Of Lewisville', 1, NULL, NULL, N'450669', NULL, NULL, 0, 202, NULL, N'9724201000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 West Main Street', N'Lewisville', N'TX', N'48121', N'75057', 33.046306, -97.004207, 3321, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5318, N'Tomball Regional Medical Center', 1, NULL, NULL, N'450670', NULL, NULL, 0, 289, NULL, N'2813511623', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 Holderrieth', N'Tomball', N'TX', N'48201', N'77375', 30.088849, -95.623972, 3386, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5319, N'Plaza Medical Center Of Fort Worth', 1, NULL, NULL, N'450672', NULL, NULL, 0, 320, NULL, N'8173362100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.734721, -97.343709, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5320, N'Womans Hospital Of Texasthe', 1, NULL, NULL, N'450674', NULL, NULL, 0, 397, NULL, N'7137901234', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7600 Fannin', N'Houston', N'TX', N'48201', N'77054', 29.692926, -95.401122, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5321, N'Medical Center Of Arlington', 1, NULL, NULL, N'450675', NULL, NULL, 0, 326, NULL, N'8174653241', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Matlock Road', N'Arlington', N'TX', N'48439', N'76015', 32.691845, -97.114799, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5322, N'Huguley Memorial Medical Center', 1, NULL, NULL, N'450677', NULL, NULL, 0, 213, NULL, N'8175685317', N'8175686545', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11801 South Freeway', N'Burleson', N'TX', N'48251', N'76028', 32.586544, -97.319104, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5323, N'Doctors Hospital', 1, NULL, NULL, N'450678', NULL, NULL, 0, 232, NULL, N'2143246100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9440 Poppy Dr', N'Dallas', N'TX', N'48113', N'75218', 32.835231, -96.705836, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5324, N'Memorial Hermann Northeast', 1, NULL, NULL, N'450684', NULL, NULL, 0, 237, NULL, N'2815407700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18951 Memorial North', N'Humble', N'TX', N'48201', N'77338', 29.994517, -95.275353, 3300, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5325, N'University Medical Center', 1, NULL, NULL, N'450686', NULL, NULL, 0, 499, NULL, N'8067758200', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'602 Indiana Avenue', N'Lubbock', N'TX', N'48303', N'79415', 33.589429, -101.887977, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5326, N'Dallas Regional Medical Center', 1, NULL, NULL, N'450688', NULL, NULL, 0, 172, NULL, N'2143207000', N'9722899468', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1011 North Galloway Avenue', N'Mesquite', N'TX', N'48113', N'75149', 32.777322, -96.599646, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5327, N'University Of Texas Health Science Center At Tyler', 1, NULL, NULL, N'450690', NULL, NULL, 0, 107, NULL, N'9038777777', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11937 Us Highway 271', N'Tyler', N'TX', N'48423', N'75708', 32.419948, -95.218309, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5328, N'El Campo Memorial Hospital', 1, NULL, NULL, N'450694', NULL, NULL, 0, 49, NULL, N'9795785251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Sandy Corner Rd', N'El Campo', N'TX', N'48481', N'77437', 29.219127, -96.289577, 3267, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5329, N'Southwest General Hospital', 1, NULL, NULL, N'450697', NULL, NULL, 0, 289, NULL, N'2109212000', N'2109213508', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Blvd', N'San Antonio', N'TX', N'48029', N'78224', 29.354092, -98.54654, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5330, N'Lamb Healthcare Center', 1, NULL, NULL, N'450698', NULL, NULL, 0, 75, NULL, N'8063856411', N'8063853998', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 S Sunset', N'Littlefield', N'TX', N'48279', N'79339', 33.91091, -102.345445, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5331, N'Longview Regional Medical Center', 1, NULL, NULL, N'450702', NULL, NULL, 0, 230, NULL, N'9037581818', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 N Fourth St', N'Longview', N'TX', N'48183', N'75605', 32.532039, -94.728825, 3325, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5332, N'Houston Methodist St John Hospital', 1, NULL, NULL, N'450709', NULL, NULL, 0, 178, NULL, N'2813335503', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18300 St John Drive', N'Nassau Bay', N'TX', N'48201', N'77058', 29.549553, -95.085116, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5333, N'Rio Grande Regional Hospital', 1, NULL, NULL, N'450711', NULL, NULL, 0, 320, NULL, N'9566326000', N'9566326621', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 E Ridge Rd', N'Mcallen', N'TX', N'48215', N'78503', 26.185574, -98.221226, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5334, N'St David''s South Austin Medical Center', 1, NULL, NULL, N'450713', NULL, NULL, 0, 225, NULL, N'5124487107', N'5124487326', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Ben White Blvd', N'Austin', N'TX', N'48453', N'78704', 30.227315, -97.773392, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5335, N'Cypress Fairbanks Medical Center', 1, NULL, NULL, N'450716', NULL, NULL, 0, 181, NULL, N'2818973100', N'2818905341', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10655 Steepletop Drive', N'Houston', N'TX', N'48201', N'77065', 29.927725, -95.588584, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5336, N'Round Rock Medical Center', 1, NULL, NULL, N'450718', NULL, NULL, 0, 170, NULL, N'5123411000', N'5122381799', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Round Rock Ave', N'Round Rock', N'TX', N'48491', N'78681', 30.509439, -97.712073, 3367, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5337, N'Methodist Charlton Medical Center', 1, NULL, NULL, N'450723', NULL, NULL, 0, 285, NULL, N'2149477777', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 W Wheatland Road', N'Dallas', N'TX', N'48113', N'75237', 32.647444, -96.876265, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5338, N'Baylor Medical Center At Carrollton', 1, NULL, NULL, N'450730', NULL, NULL, 0, 197, NULL, N'9724921010', N'9723944783', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4343 North Josey Lane', N'Carrollton', N'TX', N'48121', N'75010', 33.027442, -96.884763, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5339, N'Lake Pointe Medical Center', 1, NULL, NULL, N'450742', NULL, NULL, 0, 112, NULL, N'9724122273', N'9724123276', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 Scenic Dr', N'Rowlett', N'TX', N'48113', N'75088', 32.921991, -96.509495, 3368, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5340, N'Texas Health Presbyterian Hospital Denton', 1, NULL, NULL, N'450743', NULL, NULL, 0, 255, NULL, N'9408987000', N'9728987071', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 N I-35', N'Denton', N'TX', N'48121', N'76201', 33.212735, -97.165874, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5341, N'Knox County Hospital', 1, NULL, NULL, N'450746', NULL, NULL, 0, 28, NULL, N'9406573535', N'9406575521', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Se 5Th Street', N'Knox City', N'TX', N'48275', N'79529', 33.414084, -99.809607, 3316, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5342, N'Palestine Regional Medical Center', 1, NULL, NULL, N'450747', NULL, NULL, 0, 156, NULL, N'9037311000', NULL, 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 S Loop 256', N'Palestine', N'TX', N'48001', N'75801', 31.734082, -95.627602, 3350, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5343, N'East Texas Medical Center Trinity', 1, NULL, NULL, N'450749', NULL, NULL, 0, 45, NULL, N'9365943541', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'317 Prospect Dr/Po Box 3169', N'Trinity', N'TX', N'48455', N'75862', 30.954331, -95.379035, 3387, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5344, N'Hamilton General Hospital', 1, NULL, NULL, N'450754', NULL, NULL, 0, 34, NULL, N'2543863151', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 N Brown Building 1', N'Hamilton', N'TX', N'48193', N'76531', 31.703852, -98.113462, 3292, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5345, N'Covenant Hospital Levelland', 1, NULL, NULL, N'450755', NULL, NULL, 0, 78, NULL, N'8068944963', N'8068946461', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 College Ave', N'Levelland', N'TX', N'48219', N'79336', 33.574063, -102.367746, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5346, N'Ut Southwestern University Hospital-Zale Lipshy', 1, NULL, NULL, N'450766', NULL, NULL, 0, 152, NULL, N'2148793758', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5151 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.815797, -96.842156, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5347, N'Texas Health Presbyterian Hospital Plano', 1, NULL, NULL, N'450771', NULL, NULL, 0, 203, NULL, N'9729818000', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6200 W Parker Rd', N'Plano', N'TX', N'48085', N'75093', 33.045127, -96.838515, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5348, N'Tops Surgical Specialty Hospital', 1, NULL, NULL, N'450774', NULL, NULL, 0, 15, NULL, N'2815392900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17080 Red Oak Drive', N'Houston', N'TX', N'48201', N'77090', 30.018255, -95.444605, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5349, N'Kingwood Medical Center', 1, NULL, NULL, N'450775', NULL, NULL, 0, 360, NULL, N'2813597500', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22999 Us Hwy 59', N'Kingwood', N'TX', N'48201', N'77325', 30.04797, -95.253468, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5350, N'Texas Health Harris Methodist Hospital Southwest F', 1, NULL, NULL, N'450779', NULL, NULL, 0, 630, NULL, N'8174335000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6100 Harris Pkwy', N'Fort Worth', N'TX', N'48439', N'76132', 32.658155, -97.41944, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5351, N'Methodist Ambulatory Surgery Hospital Nw', 1, NULL, NULL, N'450780', NULL, NULL, 0, 31, NULL, N'2105755000', N'2105755190', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9150 Huebner Rd Suite 100', N'San Antonio', N'TX', N'48029', N'78240', 29.52773, -98.595871, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5352, N'Corpus Christi Medical Centerthe', 1, NULL, NULL, N'450788', NULL, NULL, 0, 583, NULL, N'3617611501', N'3618575960', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7101 S Padre Island Dr', N'Corpus Christi', N'TX', N'48355', N'78412', 27.694289, -97.343992, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5353, N'Northwest Texas Surgery Center', 1, NULL, NULL, N'450796', NULL, NULL, 0, 4, NULL, N'8063597999', N'8063557598', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Soncy Rd Suite 118', N'Amarillo', N'TX', N'48381', N'79109', 35.175394, -101.938155, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5354, N'Houston Hospital For Specialized Surgery', 1, NULL, NULL, N'450797', NULL, NULL, 0, 7, NULL, N'7135286800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5445 Labranch Street', N'Houston', N'TX', N'48201', N'77004', 29.724393, -95.384401, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5355, N'Christus St Michael Health System', 1, NULL, NULL, N'450801', NULL, NULL, 0, 376, NULL, N'9036141000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 St Michael Dr', N'Texarkana', N'TX', N'48037', N'75504', 33.464034, -94.070669, 3384, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5356, N'Doctors Hospital Tidwell', 1, NULL, NULL, N'450803', NULL, NULL, 0, 117, NULL, N'7136911111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'510 W Tidwell', N'Houston', N'TX', N'48201', N'77091', 29.847222, -95.407991, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5357, N'Texas Orthopedic Hospital', 1, NULL, NULL, N'450804', NULL, NULL, 0, 49, NULL, N'7137998600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7401 South Main Street', N'Houston', N'TX', N'48201', N'77030', 29.700371, -95.409631, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5358, N'Northwest Hills Surgical Hospital', 1, NULL, NULL, N'450808', NULL, NULL, 0, 8, NULL, N'5123461994', N'5123452760', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6818 Austin Ctr Blvd Suite 100', N'Austin', N'TX', N'48453', N'78731', 30.350571, -97.751109, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5359, N'North Austin Medical Center', 1, NULL, NULL, N'450809', NULL, NULL, 0, 332, NULL, N'5129011000', N'5129011995', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12221 Mopac Expressway North', N'Austin', N'TX', N'48453', N'78758', 30.411705, -97.708547, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5360, N'Methodist Sugar Land Hospital', 1, NULL, NULL, N'450820', NULL, NULL, 0, 243, NULL, N'2812748000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16655 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.590986, -95.631198, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5361, N'Las Colinas Medical Center', 1, NULL, NULL, N'450822', NULL, NULL, 0, 100, NULL, N'9729692000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6800 N Macarthur Blvd', N'Irving', N'TX', N'48113', N'75039', 32.902165, -96.958677, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5362, N'Cornerstone Regional Hospital', 1, NULL, NULL, N'450825', NULL, NULL, 0, 14, NULL, N'9566184444', N'9566184242', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2302 Cornerstone Boulevard', N'Edinburg', N'TX', N'48215', N'78539', 26.262919, -98.201101, 3266, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5363, N'Kell West Regional Hospital', 1, NULL, NULL, N'450827', NULL, NULL, 0, 41, NULL, N'9406925888', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5402 Kell West Boulevard', N'Wichita Falls', N'TX', N'48485', N'76310', 33.913709, -98.493387, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5364, N'Christus Spohn Hospital Alice', 1, NULL, NULL, N'450828', NULL, NULL, 0, 135, NULL, N'3616618016', N'3616618073', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 E Main Street', N'Alice', N'TX', N'48249', N'78332', 27.764603, -98.044991, 3202, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5365, N'Surgery Specialty Hospitals Of America Se Houston', 1, NULL, NULL, N'450831', NULL, NULL, 0, 37, NULL, N'7133783000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 B Vista', N'Pasadena', N'TX', N'48201', N'77504', 29.691063, -95.209101, 3353, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5366, N'Ennis Regional Medical Center', 1, NULL, NULL, N'450833', NULL, NULL, 0, 60, NULL, N'9728750900', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2201 West Lampasas Street', N'Ennis', N'TX', N'48139', N'75119', 32.30843, -96.64225, 3270, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5367, N'Physicians Centrethe', 1, NULL, NULL, N'450834', NULL, NULL, 0, 16, NULL, N'9797313100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 University Drive East', N'Bryan', N'TX', N'48041', N'77802', 30.649512, -96.296433, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5368, N'Texas Health Presbyterian Hospital Allen', 1, NULL, NULL, N'450840', NULL, NULL, 0, 29, NULL, N'9727476197', N'2146454187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Central Expressway North', N'Allen', N'TX', N'48085', N'75013', 33.115782, -96.671289, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5369, N'Methodist Willowbrook Hospital', 1, NULL, NULL, N'450844', NULL, NULL, 0, 251, NULL, N'2814771000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18220 Tomball Parkway', N'Houston', N'TX', N'48201', N'77070', 29.964059, -95.550789, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5370, N'El Paso Specialty Hospital', 1, NULL, NULL, N'450845', NULL, NULL, 0, 31, NULL, N'9155443636', N'9155446114', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1755 Curie Suite A', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5371, N'Memorial Hermann Katy Hospital', 1, NULL, NULL, N'450847', NULL, NULL, 0, 142, NULL, N'2813921111', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'23900 Katy Freeway', N'Katy', N'TX', N'48201', N'77494', 29.785918, -95.785657, 3308, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5372, N'Memorial Hermann Sugar Land Hospital', 1, NULL, NULL, N'450848', NULL, NULL, 0, 81, NULL, N'2814994800', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17500 W Grand Parkway South', N'Sugar Land', N'TX', N'48157', N'77479', 29.56408, -95.68791, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5373, N'Baylor Heart And Vascular Hospital', 1, NULL, NULL, N'450851', NULL, NULL, 0, 61, NULL, N'2148200670', N'2148200690', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'621 North Hall Street', N'Dallas', N'TX', N'48113', N'75226', 32.788418, -96.780808, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5374, N'Baylor Medical Center At Frisco', 1, NULL, NULL, N'450853', NULL, NULL, 0, 25, NULL, N'2146182000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Warren Parkway', N'Frisco', N'TX', N'48085', N'75034', 33.106709, -96.838022, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5375, N'Harlingen Medical Center', 1, NULL, NULL, N'450855', NULL, NULL, 0, 112, NULL, N'9563651000', N'9563651875', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 South Expressway 77', N'Harlingen', N'TX', N'48061', N'78550', 26.190631, -97.696103, 3294, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5376, N'South Texas Spine And Surgical Hospital', 1, NULL, NULL, N'450856', NULL, NULL, 0, 30, NULL, N'2104040800', N'2104040802', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18600 North Hardy Oak Blvd', N'San Antonio', N'TX', N'48029', N'78258', 29.613952, -98.478446, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5377, N'Sugar Land Surgical Hospital Llp', 1, NULL, NULL, N'450860', NULL, NULL, 0, 6, NULL, N'2812431000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16906 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.589961, -95.636835, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5378, N'St Luke''s The Woodlands Hospital', 1, NULL, NULL, N'450862', NULL, NULL, 0, 184, NULL, N'9362664050', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17200 St Luke''s Way', N'The Woodlands', N'TX', N'48339', N'77384', 30.20499, -95.459467, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5379, N'Texas Spine And Joint Hospital', 1, NULL, NULL, N'450864', NULL, NULL, 0, 20, NULL, N'9035253300', N'9035253391', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1814 Roseland Boulevard', N'Tyler', N'TX', N'48423', N'75701', 32.328962, -95.299465, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5380, N'Seton Southwest Hospital', 1, NULL, NULL, N'450865', NULL, NULL, 0, 33, NULL, N'5123249000', N'5123249002', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7900 Fm 1826', N'Austin', N'TX', N'48453', N'78737', 30.22696, -97.88951, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5381, N'Seton Northwest Hospital', 1, NULL, NULL, N'450867', NULL, NULL, 0, 124, NULL, N'5123246000', N'5123246924', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11113 Research Boulevard', N'Austin', N'TX', N'48453', N'78759', 30.404743, -97.745018, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5382, N'Doctors Hospital At Renaissance', 1, NULL, NULL, N'450869', NULL, NULL, 0, 513, NULL, N'9563628677', N'9566617331', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5501 South Mccoll', N'Edinburg', N'TX', N'48215', N'78539', 26.252807, -98.204032, 3266, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5383, N'Arise Austin Medical Center', 1, NULL, NULL, N'450871', NULL, NULL, 0, 23, NULL, N'5123479888', N'5123479869', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3003 Bee Caves Road', N'Austin', N'TX', N'48453', N'78746', 30.271664, -97.795469, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5384, N'Usmd Hospital At Arlington L P', 1, NULL, NULL, N'450872', NULL, NULL, 0, 34, NULL, N'8174723400', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 W Interstate 20', N'Arlington', N'TX', N'48439', N'76017', 32.678855, -97.117732, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5385, N'Promise Specialty Hospital Of San Antonio (452090)', 1, NULL, NULL, N'450873', NULL, NULL, 0, 26, NULL, N'2109254165', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Boulevard  2Nd Floor', N'San Antonio', N'TX', N'48029', N'78224', 29.346864, -98.546896, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5386, N'Baylor Surgical Hospital At Las Colinas', 1, NULL, NULL, N'450874', NULL, NULL, 0, 20, NULL, N'9728684000', N'9728384009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 West Interstate 635 Suite 101', N'Irving', N'TX', N'48113', N'75063', 32.676648, -97.01673, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5387, N'Quail Creek Surgical Hospital', 1, NULL, NULL, N'450875', NULL, NULL, 0, 40, NULL, N'8063546100', N'8063546101', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6819 Plum Creek', N'Amarillo', N'TX', N'48375', N'79124', 35.207219, -101.833825, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5388, N'Lubbock Heart Hospital Lp', 1, NULL, NULL, N'450876', NULL, NULL, 0, 74, NULL, N'8066877777', N'8066877778', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4810 North Loop 289', N'Lubbock', N'TX', N'48303', N'79416', 33.602124, -101.914918, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5389, N'Foundation Surgical Hospital Of El Paso', 1, NULL, NULL, N'450877', NULL, NULL, 0, 40, NULL, N'9155984240', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1416 George Dieter', N'El Paso', N'TX', N'48141', N'79936', 31.734985, -106.301578, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5390, N'Baylor Surgical Hospital At Fort Worth', 1, NULL, NULL, N'450880', NULL, NULL, 0, 34, NULL, N'6827035600', N'6827035612', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Park Place Avenue', N'Fort Worth', N'TX', N'48439', N'76110', 32.725778, -97.346185, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5391, N'Baylor Medical Center At Trophy Club', 1, NULL, NULL, N'450883', NULL, NULL, 0, 20, NULL, N'8178374600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2850  E State Highway 114', N'Trophy Club', N'TX', N'48121', N'76262', 32.997901, -97.183625, 3288, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5392, N'Centennial Medical Center', 1, NULL, NULL, N'450885', NULL, NULL, 0, 118, NULL, N'9729633333', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12505 Lebanon Road', N'Frisco', N'TX', N'48085', N'75035', 33.115882, -96.771793, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5393, N'Southwest Surgical Hospital', 1, NULL, NULL, N'450886', NULL, NULL, 0, 23, NULL, N'8173454100', N'8176561490', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1612 Hurst Town Center Drive', N'Hurst', N'TX', N'48439', N'76054', 32.841595, -97.188701, 3220, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5394, N'Texas Health Harris Methodist Hospital Southlake', 1, NULL, NULL, N'450888', NULL, NULL, 0, 6, NULL, N'8177488700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1545 E Southlake Blvd', N'Southlake', N'TX', N'48439', N'76092', 32.94097, -97.127539, 3288, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5395, N'Texas Institute For Surgery At Presbyterian Hospit', 1, NULL, NULL, N'450889', NULL, NULL, 0, 9, NULL, N'2146475300', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7115 Greenville Avenue Suite 100', N'Dallas', N'TX', N'48113', N'75231', 32.876714, -96.761567, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5396, N'Baylor Regional Medical Center At Plano', 1, NULL, NULL, N'450890', NULL, NULL, 0, 96, NULL, N'4698142000', N'4698142999', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4700 Alliance Boulevard', N'Plano', N'TX', N'48085', N'75093', 33.014377, -96.791437, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5397, N'Texas Health Center For Diagnostics & Surgery Plan', 1, NULL, NULL, N'450891', NULL, NULL, 0, 18, NULL, N'9724032700', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6020 W Parker Road', N'Plano', N'TX', N'48085', N'75093', 33.045097, -96.831869, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5398, N'The Heart Hospital Baylor Denton', 1, NULL, NULL, N'450893', NULL, NULL, 0, 16, NULL, N'9402200600', N'9402200605', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.177536, -97.087444, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5399, N'Pine Creek Medical Center Llp', 1, NULL, NULL, N'450894', NULL, NULL, 0, 18, NULL, N'2142312273', N'2142312274', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9032 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.84026, -96.868953, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5400, N'Parmer County Community Hospital', 1, NULL, NULL, N'451300', NULL, NULL, 0, 25, NULL, N'8062502754', N'8062502031', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1307 Cleveland Street', N'Friona', N'TX', N'48369', N'79035', 34.641734, -102.724105, 3276, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5401, N'Reagan Memorial Hospital', 1, NULL, NULL, N'451301', NULL, NULL, 0, 14, NULL, N'3258442561', N'3258842891', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'805 North Main', N'Big Lake', N'TX', N'48383', N'76932', 31.197961, -101.461701, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5402, N'Limestone Medical Center', 1, NULL, NULL, N'451303', NULL, NULL, 0, 20, NULL, N'2547293281', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Mcclintic Drive', N'Groesbeck', N'TX', N'48293', N'76642', 31.531876, -96.529658, 3290, 275, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5403, N'Schleicher County Medical Center', 1, NULL, NULL, N'451304', NULL, NULL, 0, 14, NULL, N'3258532507', N'3258533166', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 North Us Highway 277', N'Eldorado', N'TX', N'48413', N'76936', 30.860159, -100.600857, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5404, N'Burleson St Joseph Health Center', 1, NULL, NULL, N'451305', NULL, NULL, 0, 25, NULL, N'9795673245', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1101 Woodson Drive', N'Caldwell', N'TX', N'48051', N'77836', 30.520951, -96.71596, 3233, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5405, N'Kimble Hospital', 1, NULL, NULL, N'451306', NULL, NULL, 0, 15, NULL, N'3254463321', N'3254463769', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'349 Reid Road', N'Junction', N'TX', N'48267', N'76849', 30.489356, -99.772011, 3307, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5406, N'Iraan General Hospital', 1, NULL, NULL, N'451307', NULL, NULL, 0, 14, NULL, N'4326392575', N'4326392664', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Highway 349 North', N'Iraan', N'TX', N'48371', N'79744', 30.914189, -101.906673, 3302, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5407, N'Yoakum County Hospital', 1, NULL, NULL, N'451308', NULL, NULL, 0, 24, NULL, N'8065922121', N'8065922891', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'412 Mustang Avenue', N'Denver City', N'TX', N'48501', N'79323', 32.968561, -102.836388, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5408, N'Mccamey Hospital', 1, NULL, NULL, N'451309', NULL, NULL, 0, 14, NULL, N'4326528626', N'4326523465', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Hwy 305 South', N'Mccamey', N'TX', N'48461', N'79752', 31.135591, -102.224443, 3333, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5409, N'Ballinger Memorial Hospital', 1, NULL, NULL, N'451310', NULL, NULL, 0, 25, NULL, N'3253652531', N'3253652662', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'608 Avenue B', N'Ballinger', N'TX', N'48399', N'76821', 31.750195, -99.962044, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5410, N'Sweeny Community Hospital', 1, NULL, NULL, N'451311', NULL, NULL, 0, 20, NULL, N'9795483311', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 North Mckinney', N'Sweeny', N'TX', N'48039', N'77480', 29.048509, -95.691386, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5411, N'Rice Medical Center', 1, NULL, NULL, N'451312', NULL, NULL, 0, 25, NULL, N'9792345571', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 South Austin Road', N'Eagle Lake', N'TX', N'48089', N'77434', 29.590178, -96.344399, 3263, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5412, N'Fisher County Hospital District', 1, NULL, NULL, N'451313', NULL, NULL, 0, 14, NULL, N'3257352256', N'3257353070', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'774 State Highway 70 N', N'Rotan', N'TX', N'48151', N'79546', 32.858917, -100.467992, 3366, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5413, N'Winkler County Memorial Hospital', 1, NULL, NULL, N'451314', NULL, NULL, 0, 25, NULL, N'4325865865', N'4325865031', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 Jeffee Drive', N'Kermit', N'TX', N'48495', N'79745', 31.849331, -103.089826, 3311, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5414, N'North Runnels Hospital', 1, NULL, NULL, N'451315', NULL, NULL, 0, 25, NULL, N'3257544553', N'3257545097', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7821 East Highway 153', N'Winters', N'TX', N'48399', N'79567', 31.956534, -99.962313, 3405, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5415, N'Madison St Joseph Health Center', 1, NULL, NULL, N'451316', NULL, NULL, 0, 25, NULL, N'9363482631', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 West Cross Street', N'Madisonville', N'TX', N'48313', N'77864', 30.942053, -95.909929, 3329, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5416, N'Refugio County Memorial Hospital', 1, NULL, NULL, N'451317', NULL, NULL, 0, 20, NULL, N'3615262321', N'3615262420', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'107 Swift Street', N'Refugio', N'TX', N'48391', N'78377', 28.306538, -97.279506, 3363, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5417, N'Stonewall Memorial Hospital', 1, NULL, NULL, N'451318', NULL, NULL, 0, 20, NULL, N'9409893551', N'9409893395', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'821 North Broadway', N'Aspermont', N'TX', N'48433', N'79502', 33.133431, -100.227328, 3212, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5418, N'Mother Frances Hospital Jacksonville', 1, NULL, NULL, N'451319', NULL, NULL, 0, 25, NULL, N'9035414500', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2026 S Jackson Street', N'Jacksonville', N'TX', N'48073', N'75766', 31.93937, -95.25095, 3304, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5419, N'Bayside Community Hospital', 1, NULL, NULL, N'451320', NULL, NULL, 0, 14, NULL, N'4092673143', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Anahuac', N'TX', N'48071', N'77514', 29.753054, -94.686651, 3206, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5420, N'Grimes St Joseph Health Center', 1, NULL, NULL, N'451322', NULL, NULL, 0, 25, NULL, N'9368256585', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'210 Judson St', N'Navasota', N'TX', N'48185', N'77868', 30.392233, -96.07669, 3343, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5421, N'Rollins Brook Community Hospital', 1, NULL, NULL, N'451323', NULL, NULL, 0, 25, NULL, N'5125563682', N'5125568869', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'608 North Key Avenue', N'Lampasas', N'TX', N'48281', N'76550', 31.072512, -98.185632, 3314, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5422, N'Lillian M Hudspeth Memorial Hospital', 1, NULL, NULL, N'451324', NULL, NULL, 0, 12, NULL, N'3253872521', N'3253872396', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'308 Hudspeth', N'Sonora', N'TX', N'48435', N'76950', 30.56423, -100.634783, 3377, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5423, N'Concho County Hospital', 1, NULL, NULL, N'451325', NULL, NULL, 0, 16, NULL, N'9158695911', N'9158693861', 1, 0, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'614 Eaker Street', N'Eden', N'TX', N'48095', N'76837', 31.220781, -99.847622, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5424, N'Chillicothe Hospital District', 1, NULL, NULL, N'451326', NULL, NULL, 0, 21, NULL, N'9408525131', N'9408525252', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'303 Avenue I', N'Chillicothe', N'TX', N'48197', N'79225', 34.255494, -99.51593, 3240, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5425, N'Riceland Medical Center', 1, NULL, NULL, N'451328', NULL, NULL, 0, 25, NULL, N'4092966000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'538 Broadway', N'Winnie', N'TX', N'48071', N'77665', 29.820221, -94.384078, 3403, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5426, N'Rankin Hospital Medical Clinic', 1, NULL, NULL, N'451329', NULL, NULL, 0, 15, NULL, N'4326932443', N'4326932178', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1105 Elizabeth', N'Rankin', N'TX', N'48461', N'79778', 31.227007, -101.946957, 3362, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5427, N'Medina Regional Hospital', 1, NULL, NULL, N'451330', NULL, NULL, 0, 25, NULL, N'8304267700', N'8304267860', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Avenue E', N'Hondo', N'TX', N'48325', N'78861', 29.352953, -99.155461, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5428, N'Coon Memorial Hospital', 1, NULL, NULL, N'451331', NULL, NULL, 0, 25, NULL, N'8062444571', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1411 Denver Avenue', N'Dalhart', N'TX', N'48111', N'79022', 36.0522, -102.521896, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5429, N'Palacios Community Medical Center', 1, NULL, NULL, N'451332', NULL, NULL, 0, 17, NULL, N'3619722511', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'311 Green Avenue', N'Palacios', N'TX', N'48321', N'77465', 28.708046, -96.217467, 3349, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5430, N'Martin County Hospital District', 1, NULL, NULL, N'451333', NULL, NULL, 0, 18, NULL, N'4327563345', N'9157562349', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 E Interstate 20     Po Box 640', N'Stanton', N'TX', N'48317', N'79782', 32.129289, -101.788464, 3336, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5431, N'Parkview Hospital', 1, NULL, NULL, N'451334', NULL, NULL, 0, 16, NULL, N'8068265581', N'8068263201', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 S. Sweetwater', N'Wheeler', N'TX', N'48483', N'79096', 35.439722, -100.270812, 3400, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5432, N'Muenster Memorial Hospital', 1, NULL, NULL, N'451335', NULL, NULL, 0, 18, NULL, N'9407592271', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'605 N Maple Street', N'Muenster', N'TX', N'48097', N'76252', 33.654749, -97.379937, 3341, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5433, N'W J Manld Memorial Hospital', 1, NULL, NULL, N'451337', NULL, NULL, 0, 25, NULL, N'8066523373', N'8066522172', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 North Main', N'Lockney', N'TX', N'48153', N'79241', 34.126632, -101.44179, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5434, N'Culberson Hospital', 1, NULL, NULL, N'451338', NULL, NULL, 0, 25, NULL, N'4322832760', N'4322832581', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Eisenhower Road And Fm 2185', N'Van Horn', N'TX', N'48109', N'79855', 31.047492, -104.828072, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5435, N'Throckmorton County Memorial Hospital', 1, NULL, NULL, N'451339', NULL, NULL, 0, 14, NULL, N'9408492151', N'9408497141', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 N Minter Avenue', N'Throckmorton', N'TX', N'48447', N'76483', 33.19047, -99.177181, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5436, N'Shamrock General Hospital', 1, NULL, NULL, N'451340', NULL, NULL, 0, 25, NULL, N'8062562114', N'8062562423', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 South Main Street', N'Shamrock', N'TX', N'48483', N'79079', 35.197569, -100.249046, 3374, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5437, N'Haskell Memorial Hospital', 1, NULL, NULL, N'451341', NULL, NULL, 0, 25, NULL, N'9408642621', N'9408643713', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 North Avenue N  Po Box 1117', N'Haskell', N'TX', N'48207', N'79521', 33.157603, -99.733701, 3295, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5438, N'Mitchell County Hospital District', 1, NULL, NULL, N'451342', NULL, NULL, 0, 25, NULL, N'3257283431', N'3257288974', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'997 West I-20', N'Colorado City', N'TX', N'48335', N'79512', 32.388174, -100.864558, 3246, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5439, N'Electra Memorial Hospital', 1, NULL, NULL, N'451343', NULL, NULL, 0, 25, NULL, N'9404953981', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1207 S Bailey Street', N'Electra', N'TX', N'48485', N'76360', 34.019123, -98.923957, 3269, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5440, N'Hansford County Hospital', 1, NULL, NULL, N'451344', NULL, NULL, 0, 25, NULL, N'8066592535', N'8066591027', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Roland St', N'Spearman', N'TX', N'48195', N'79081', 36.190785, -101.200129, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5441, N'Crosbyton Clinic Hospital', 1, NULL, NULL, N'451345', NULL, NULL, 0, 25, NULL, N'8066752382', N'8066752645', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'710 West Main Street', N'Crosbyton', N'TX', N'48107', N'79322', 33.660067, -101.245766, 3253, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5442, N'Yoakum Community Hospital', 1, NULL, NULL, N'451346', NULL, NULL, 0, 25, NULL, N'3612932321', N'3612936172', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Carl Ramert Drive', N'Yoakum', N'TX', N'48123', N'77995', 29.306658, -97.130284, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5443, N'Coleman County Medical Center Company', 1, NULL, NULL, N'451347', NULL, NULL, 0, 25, NULL, N'3256252135', N'3256253895', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Pecos Street', N'Coleman', N'TX', N'48083', N'76834', 31.828919, -99.425237, 3245, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5444, N'Heart Of Texas Memorial Hospital', 1, NULL, NULL, N'451348', NULL, NULL, 0, 25, NULL, N'3255972901', N'3255972280', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2008 Nine Road', N'Brady', N'TX', N'48307', N'76825', 31.114883, -99.348032, 3226, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5445, N'Swisher Memorial Hospital', 1, NULL, NULL, N'451349', NULL, NULL, 0, 20, NULL, N'8069953581', N'8069958283', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'539 Southeast 2Nd', N'Tulia', N'TX', N'48437', N'79088', 34.53557, -101.756231, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5446, N'Plains Memorial Hospital', 1, NULL, NULL, N'451350', NULL, NULL, 0, 25, NULL, N'8066472191', N'8066472282', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 West Halsell Street', N'Dimmitt', N'TX', N'48069', N'79027', 34.55558, -102.315112, 3261, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5447, N'Lynn County Hospital District', 1, NULL, NULL, N'451351', NULL, NULL, 0, 24, NULL, N'8069984533', N'8065614049', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Lockwood Street', N'Tahoka', N'TX', N'48305', N'79373', 33.166538, -101.815141, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5448, N'Hardeman County Memorial Hospital', 1, NULL, NULL, N'451352', NULL, NULL, 0, 24, NULL, N'9406632795', N'9406635149', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 Mercer St', N'Quanah', N'TX', N'48197', N'79252', 34.296119, -99.741266, 3360, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5449, N'Crane County Hospital District', 1, NULL, NULL, N'451353', NULL, NULL, 0, 25, NULL, N'4325583555', N'9155581159', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1310 S Alford St', N'Crane', N'TX', N'48103', N'79731', 31.390567, -102.349373, 3346, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5450, N'Hamilton Hospital', 1, NULL, NULL, N'451354', NULL, NULL, 0, 25, NULL, N'9405645521', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 West Hamilton', N'Olney', N'TX', N'48503', N'76374', 33.369214, -98.764985, 3347, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5451, N'Collingsworth General Hospital', 1, NULL, NULL, N'451355', NULL, NULL, 0, 16, NULL, N'8064472521', N'8064472421', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 15Th St', N'Wellington', N'TX', N'48087', N'79095', 34.849109, -100.212939, 3397, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5452, N'Memorial Medical Center', 1, NULL, NULL, N'451356', NULL, NULL, 0, 25, NULL, N'3615526713', N'3615520220', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 N Virginia Street', N'Port Lavaca', N'TX', N'48057', N'77979', 28.62087, -96.6315, 3359, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5453, N'Little River Healthcare', 1, NULL, NULL, N'451357', NULL, NULL, 0, 25, NULL, N'5124464500', N'5124460084', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Brazos', N'Rockdale', N'TX', N'48331', N'76567', 30.650156, -97.020575, 3365, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5454, N'Memorial Hospital', 1, NULL, NULL, N'451358', NULL, NULL, 0, 25, NULL, N'4327584854', N'4327584880', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'209 Northwest 8Th Street', N'Seminole', N'TX', N'48165', N'79360', 32.72278, -102.65385, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5455, N'Ochiltree General Hospital', 1, NULL, NULL, N'451359', NULL, NULL, 0, 25, NULL, N'8064353606', N'8064352813', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3101 Garrett Drive', N'Perryton', N'TX', N'48357', N'79070', 36.370534, -100.7997, 3355, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5456, N'Chi St Lukes Health Memorial San Augustine', 1, NULL, NULL, N'451360', NULL, NULL, 0, 18, NULL, N'9362753446', N'9362759921', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'511 Hospital St', N'San Augustine', N'TX', N'48405', N'75972', 31.531475, -94.105005, 3342, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5457, N'Sabine County Hospital', 1, NULL, NULL, N'451361', NULL, NULL, 0, 25, NULL, N'4097873300', N'4097875003', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 750 2301 Hwy 83 W', N'Hemphill', N'TX', N'48403', N'75948', 31.34074, -93.846852, 3296, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5458, N'Clay County Memorial Hospital', 1, NULL, NULL, N'451362', NULL, NULL, 0, 25, NULL, N'9405385621', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 W South Street', N'Henrietta', N'TX', N'48077', N'76365', 33.813974, -98.197595, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5459, N'Jackson Healthcare Center', 1, NULL, NULL, N'451363', NULL, NULL, 0, 25, NULL, N'3617827800', N'3617827495', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1013 S Wells', N'Edna', N'TX', N'48239', N'77957', 28.978595, -96.646088, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5460, N'Otto Kaiser Memorial Hospital', 1, NULL, NULL, N'451364', NULL, NULL, 0, 25, NULL, N'8305833401', N'8305839053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3349 S Highway 181', N'Kenedy', N'TX', N'48255', N'78119', 28.804213, -97.85663, 3310, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5461, N'Seton Highland Lakes', 1, NULL, NULL, N'451365', NULL, NULL, 0, 25, NULL, N'5127153000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Highway 281 South', N'Burnet', N'TX', N'48053', N'78611', 30.757311, -98.228901, 3232, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5462, N'Cochran Memorial Hospital', 1, NULL, NULL, N'451366', NULL, NULL, 0, 18, NULL, N'8062665565', N'8062665342', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 E Grant Street', N'Morton', N'TX', N'48079', N'79346', 33.719294, -102.758075, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5463, N'East Texas Medical Center Pittsburg', 1, NULL, NULL, N'451367', NULL, NULL, 0, 25, NULL, N'9038564520', N'9038564598', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2701 Us Hwy 271 N', N'Pittsburg', N'TX', N'48063', N'75686', 33.033685, -94.961069, 3356, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5464, N'lden Plains Community Hospital', 1, NULL, NULL, N'451369', NULL, NULL, 0, 25, NULL, N'8062731100', N'8062731104', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Medical Drive', N'Borger', N'TX', N'48233', N'79007', 35.662923, -101.392291, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5465, N'T M C- Bonham Hospital', 1, NULL, NULL, N'451370', NULL, NULL, 0, 25, NULL, N'9036407311', N'9036407601', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'504 Lipscomb Street', N'Bonham', N'TX', N'48147', N'75418', 33.578064, -96.167538, 3224, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5466, N'Seton Edgar B Davis Hospital', 1, NULL, NULL, N'451371', NULL, NULL, 0, 25, NULL, N'8308757000', N'8308757053', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Hays Street', N'Luling', N'TX', N'48055', N'78648', 29.672522, -97.654654, 3328, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5467, N'Muleshoe Area Medical Center', 1, NULL, NULL, N'451372', NULL, NULL, 0, 25, NULL, N'8062724524', N'8062724938', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'708 S 1St St', N'Muleshoe', N'TX', N'48017', N'79347', 34.221162, -102.728344, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5468, N'Ward Memorial Hospital', 1, NULL, NULL, N'451373', NULL, NULL, 0, 25, NULL, N'4329432511', N'4329434767', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'406 South Gary St', N'Monahans', N'TX', N'48475', N'79756', 31.593969, -102.884585, 3338, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5469, N'Baylor Scott & White Medical Center -Taylor', 1, NULL, NULL, N'451374', NULL, NULL, 0, 25, NULL, N'5123527611', N'5123524216', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'305 Mallard', N'Taylor', N'TX', N'48491', N'76574', 30.592025, -97.415012, 3381, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5470, N'Liberty Dayton Regional Medical Center', 1, NULL, NULL, N'451375', NULL, NULL, 0, 25, NULL, N'9363367316', N'9363367772', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1353 N Travis St', N'Liberty', N'TX', N'48291', N'77575', 30.068223, -94.797978, 3322, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5471, N'Lavaca Medical Center', 1, NULL, NULL, N'451376', NULL, NULL, 0, 25, NULL, N'3617983671', N'3617982682', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 North Texana Street', N'Hallettsville', N'TX', N'48285', N'77964', 29.457419, -96.939814, 3291, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5472, N'Reeves County Hospital District', 1, NULL, NULL, N'451377', NULL, NULL, 0, 25, NULL, N'4324473551', N'4324475434', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2323 Texas Street', N'Pecos', N'TX', N'48389', N'79772', 31.402329, -103.512645, 3354, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5473, N'Big Bend Regional Medical Center', 1, NULL, NULL, N'451378', NULL, NULL, 0, 25, NULL, N'4328373447', N'4328370330', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Highway 118 North', N'Alpine', N'TX', N'48043', N'79830', 30.383807, -103.672137, 3203, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5474, N'Coryell Memorial Healthcare System', 1, NULL, NULL, N'451379', NULL, NULL, 0, 25, NULL, N'2548658251', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1507 W Main Street', N'Gatesville', N'TX', N'48099', N'76528', 31.433152, -97.778822, 3280, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5475, N'East Texas Medical Center Quitman', 1, NULL, NULL, N'451380', NULL, NULL, 0, 25, NULL, N'9037634500', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Winnsboro Street', N'Quitman', N'TX', N'48499', N'75783', 32.795804, -95.445402, 3361, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5476, N'Mother Frances Hospital- Winnsboro', 1, NULL, NULL, N'451381', NULL, NULL, 0, 35, NULL, N'9033425227', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'719 West Coke Road', N'Winnsboro', N'TX', N'48499', N'75494', 32.946398, -95.309476, 3404, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5477, N'Comanche County Medical Center', 1, NULL, NULL, N'451382', NULL, NULL, 0, 38, NULL, N'2548794900', N'2548794992', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10201 Hwy 16', N'Comanche', N'TX', N'48093', N'76442', 31.897369, -98.603658, 3248, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5478, N'Cogdell Memorial Hospital', 1, NULL, NULL, N'451384', NULL, NULL, 0, 25, NULL, N'3255747437', N'3255747433', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 Cogdell Blvd', N'Snyder', N'TX', N'48415', N'79549', 32.688478, -100.917746, 3376, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5479, N'Leavesthe', 1, NULL, NULL, N'451990', NULL, NULL, 0, 27, NULL, N'9722314864', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1230 West Spring Valley Road', N'Richardson', N'TX', N'48113', N'75080', 32.948179, -96.729721, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5480, N'Kindred Hospital Dallas', 1, NULL, NULL, N'452015', NULL, NULL, 0, 140, NULL, N'2143552600', N'2143552634', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9525 Greenville Avenue', N'Dallas', N'TX', N'48113', N'75218', 32.905226, -96.74855, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5481, N'Kindred Hospital San Antonio', 1, NULL, NULL, N'452016', NULL, NULL, 0, 59, NULL, N'2106160616', N'2105930661', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3636 Medical Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.520944, -98.558064, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5482, N'Texas Health Specialty Hospital Fort Worth', 1, NULL, NULL, N'452018', NULL, NULL, 0, 15, NULL, N'8178785500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Pennsylvania 4Th Floor Main Bldg', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5483, N'Kindred Hospital Fort Worth- Mansfield', 1, NULL, NULL, N'452019', NULL, NULL, 0, 55, NULL, N'8173324812', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1802 Highway 157 North', N'Mansfield', N'TX', N'48439', N'76063', 32.563192, -97.141677, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5484, N'Select Specialty Hospital-Dallas', 1, NULL, NULL, N'452022', NULL, NULL, 0, 60, NULL, N'9728842407', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2329 Parker Road', N'Carrollton', N'TX', N'48121', N'75010', 33.046425, -96.905774, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5485, N'Kindred Hospital Houston Medical Center', 1, NULL, NULL, N'452023', NULL, NULL, 0, 110, NULL, N'7137900500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6441 Main St', N'Houston', N'TX', N'48201', N'77030', 29.726317, -95.389183, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5486, N'Kindred Hospital-Tarrant County', 1, NULL, NULL, N'452028', NULL, NULL, 0, 80, NULL, N'8175430200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 N Cooper St', N'Arlington', N'TX', N'48439', N'76011', 32.750196, -97.113916, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5487, N'Continue Care Hospital At Hendrick Medical Center', 1, NULL, NULL, N'452029', NULL, NULL, 0, 19, NULL, N'3256705151', N'3256705157', 1, 1, 1, 1, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Pine St 5Th Floor', N'Abilene', N'TX', N'48441', N'79601', 32.446453, -99.733348, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5488, N'Memorial Specialty Hospital', 1, NULL, NULL, N'452031', NULL, NULL, 0, 26, NULL, N'9366397975', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 Frank St Suite D', N'Lufkin', N'TX', N'48005', N'75901', 31.338624, -94.728856, 3327, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5489, N'Cornerstone Hospital Of Houston', 1, NULL, NULL, N'452032', NULL, NULL, 0, 148, NULL, N'7135515300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'709 Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.538727, -95.129836, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5490, N'Texas Center For Infectious Disease', 1, NULL, NULL, N'452033', NULL, NULL, 0, 75, NULL, N'2105348857', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2303 Se Military Dr P O Box 23340', N'San Antonio', N'TX', N'48029', N'78223', 29.359618, -98.405612, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5491, N'Cornerstone Hospital Austin', 1, NULL, NULL, N'452034', NULL, NULL, 0, 157, NULL, N'5127061900', N'5124218282', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4207 Burnet Rd', N'Austin', N'TX', N'48453', N'78756', 30.312122, -97.743436, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5492, N'Mesa Hills Specialty Hospital', 1, NULL, NULL, N'452035', NULL, NULL, 0, 32, NULL, N'9155481823', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2311 N Oren Street', N'El Paso', N'TX', N'48141', N'79902', 31.773617, -106.50164, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5493, N'Texas Neuro Rehabilitation Center', 1, NULL, NULL, N'452038', NULL, NULL, 0, 47, NULL, N'5124444835', N'5124626636', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106 W Dittmar', N'Austin', N'TX', N'48453', N'78745', 30.271129, -97.743699, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5494, N'Kindred Hospital', 1, NULL, NULL, N'452039', NULL, NULL, 0, 76, NULL, N'2818978114', NULL, 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11297 Fallbrook', N'Houston', N'TX', N'48201', N'77065', 29.925274, -95.588061, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5495, N'Acuity Hospital Of South Texas', 1, NULL, NULL, N'452040', NULL, NULL, 0, 30, NULL, N'2105724600', N'2105724628', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'718 Lexington Avenue', N'San Antonio', N'TX', N'48029', N'78212', 29.437359, -98.493139, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5496, N'Carrus Specialty Hospital', 1, NULL, NULL, N'452041', NULL, NULL, 0, 16, NULL, N'9034164441', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1810 West Highway 82', N'Sherman', N'TX', N'48181', N'75092', 33.617501, -96.595493, 3375, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5497, N'Christus Dubuis Hospital Of Beaumont', 1, NULL, NULL, N'452042', NULL, NULL, 0, 51, NULL, N'4098997680', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830 Calder Avenue 4Th Floor', N'Beaumont', N'TX', N'48245', N'77702', 30.085677, -94.131252, 3219, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5498, N'Promise Hospital Of Houston', 1, NULL, NULL, N'452043', NULL, NULL, 0, 59, NULL, N'7136402400', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6160 S Loop East', N'Houston', N'TX', N'48201', N'77087', 29.695507, -95.295514, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5499, N'Lifecare Hospitals Of Dallas', 1, NULL, NULL, N'452044', NULL, NULL, 0, 64, NULL, N'2145256300', N'2145250602', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Record Crossing', N'Dallas', N'TX', N'48113', N'75235', 32.817498, -96.849274, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5500, N'Plaza Specialty Hosp', 1, NULL, NULL, N'452046', NULL, NULL, 0, 65, NULL, N'7132851000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 Binz', N'Houston', N'TX', N'48201', N'77004', 29.724108, -95.386941, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5501, N'Select Specialty Hospital-Houston Heig', 1, NULL, NULL, N'452049', NULL, NULL, 0, 300, NULL, N'7138616161', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1917 Ashland', N'Houston', N'TX', N'48201', N'77008', 29.803096, -95.403712, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5502, N'Llano Specialty Hospital', 1, NULL, NULL, N'452050', NULL, NULL, 0, 30, NULL, N'8067679133', N'8067679033', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1409 9Th St', N'Lubbock', N'TX', N'48303', N'79401', 33.587283, -101.850472, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5503, N'Etmc Specialty', 1, NULL, NULL, N'452051', NULL, NULL, 0, 36, NULL, N'9035356551', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 S Beckham 5Th Floor', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5504, N'Plano Specialty Hospital', 1, NULL, NULL, N'452054', NULL, NULL, 0, 30, NULL, N'9727585200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1621 Coit Road', N'Plano', N'TX', N'48085', N'75075', 33.0578, -96.770571, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5505, N'Cornerstone Hospital Medical Center', 1, NULL, NULL, N'452055', NULL, NULL, 0, 35, NULL, N'8326496200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Hermann Drive', N'Houston', N'TX', N'48201', N'77004', 29.717703, -95.382989, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5506, N'Post Acute Medical Specialty Hospital Of Victoria', 1, NULL, NULL, N'452056', NULL, NULL, 0, 23, NULL, N'3615751445', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'506 E San Antonio Street  3 East Floor', N'Victoria', N'TX', N'48469', N'77901', 28.807463, -97.001664, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5507, N'Nexus Specialty Hospital The Woodlands', 1, NULL, NULL, N'452057', NULL, NULL, 0, 75, NULL, N'7133640317', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9182 Six Pines Drive', N'The Woodlands', N'TX', N'48339', N'77380', 30.175711, -95.459965, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5508, N'Lifecare Hospital Of San Antonio', 1, NULL, NULL, N'452059', NULL, NULL, 0, 62, NULL, N'2106907000', N'2106907128', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8902 Floyd Curl Drive', N'San Antonio', N'TX', N'48029', N'78240', 29.52571, -98.590874, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5509, N'Vibra Hospital Of Amarillo', 1, NULL, NULL, N'452060', NULL, NULL, 0, 72, NULL, N'8063511600', N'8063539106', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7500 Wallace Blvd', N'Amarillo', N'TX', N'48375', N'79120', 35.195303, -101.926207, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5510, N'Post Acute Medical Specialty Hospital Of Texarkana', 1, NULL, NULL, N'452061', NULL, NULL, 0, 49, NULL, N'9036147600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Michael Drive 2Nd Floor', N'Texarkana', N'TX', N'48037', N'75503', 33.46459, -94.069672, 3384, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5511, N'Warm Spring Speciality Hosptial At Luling', 1, NULL, NULL, N'452062', NULL, NULL, 0, 34, NULL, N'5126726592', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Memorial Drive', N'Luling', N'TX', N'48055', N'78648', 29.673413, -97.653766, 3328, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5512, N'Lifecare Hospitals Of South Tx', 1, NULL, NULL, N'452063', NULL, NULL, 0, 62, NULL, N'9569267000', N'9566884530', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 M Street', N'Mc Allen', N'TX', N'48215', N'78504', 31.816038, -99.512099, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5513, N'Plum Creek Specialty Hospital', 1, NULL, NULL, N'452066', NULL, NULL, 0, 47, NULL, N'8063511000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5601 Plum Creek Drive', N'Amarillo', N'TX', N'48375', N'79124', 35.216709, -101.900399, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5514, N'Promise Hospital Of Dallas', 1, NULL, NULL, N'452067', NULL, NULL, 0, 66, NULL, N'2146370000', N'2146376512', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7955 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75235', 32.83315, -96.860771, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5515, N'Promise Hospital Of Wichita Falls', 1, NULL, NULL, N'452068', NULL, NULL, 0, 31, NULL, N'9407637901', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1103 Grace Street', N'Wichita Falls', N'TX', N'48485', N'76301', 33.902875, -98.50015, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5516, N'Kindred Hospital-White Rock', 1, NULL, NULL, N'452071', NULL, NULL, 0, 25, NULL, N'2143246730', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9440 Poppy Drive 5Th Floor', N'Dallas', N'TX', N'48113', N'75218', 32.834802, -96.707094, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5517, N'Select Specialty Hospital San Antonio', 1, NULL, NULL, N'452073', NULL, NULL, 0, 44, NULL, N'2102977182', N'2102970949', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Dallas Street  4Th Floor', N'San Antonio', N'TX', N'48029', N'78205', 29.433045, -98.492681, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5518, N'Kindred Hospital Tomball', 1, NULL, NULL, N'452074', NULL, NULL, 0, 288, NULL, N'2817652622', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'505 Graham Drive', N'Tomball', N'TX', N'48201', N'77375', 30.08874, -95.625587, 3386, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5519, N'Kindred Hospital Clear Lake', 1, NULL, NULL, N'452075', NULL, NULL, 0, 147, NULL, N'2813167800', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Blossom St', N'Webster', N'TX', N'48201', N'77598', 29.540751, -95.130079, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5520, N'Select Specialty Hospital South Dallas', 1, NULL, NULL, N'452078', NULL, NULL, 0, 100, NULL, N'9727806506', N'9725726359', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 West Wheatland Road 4Th Floor', N'Dallas', N'TX', N'48113', N'75237', 32.647498, -96.877447, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5521, N'Kindred Hosptial El Paso', 1, NULL, NULL, N'452079', NULL, NULL, 0, 62, NULL, N'9153519044', N'9153519066', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1740 Curie Drive', N'El Paso', N'TX', N'48141', N'79902', 31.779278, -106.477454, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5522, N'Kindred Hospital Sugar Land', 1, NULL, NULL, N'452080', NULL, NULL, 0, 171, NULL, N'2812756000', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 First Colony Boulevard', N'Sugar Land', N'TX', N'48157', N'77479', 29.598836, -95.637076, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5523, N'Dubuis Hospital Of Paris', 1, NULL, NULL, N'452082', NULL, NULL, 0, 25, NULL, N'9037822961', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Clarksville St 6Th Floor', N'Paris', N'TX', N'48277', N'75460', 33.661796, -95.555513, 3352, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5524, N'Mid-Jefferson Extended Care Hospital', 1, NULL, NULL, N'452083', NULL, NULL, 0, 48, NULL, N'4097268700', N'4097268701', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Hwy 365', N'Nederland', N'TX', N'48245', N'77627', 29.97438, -93.992396, 3358, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5525, N'Post Acute Medical Specialty Hospital Corpus Ch', 1, NULL, NULL, N'452086', NULL, NULL, 0, 22, NULL, N'3618813223', N'3618838901', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Elizabeth Street 3Rd Floor', N'Corpus Christi', N'TX', N'48355', N'78404', 27.777363, -97.3971, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5526, N'Select Speciality Hospital Of Longview', 1, NULL, NULL, N'452087', NULL, NULL, 0, 32, NULL, N'9033151111', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 East Marshall Ave First Floor West Wing', N'Longview', N'TX', N'48183', N'75601', 32.500775, -94.730476, 3325, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5527, N'Kindred Hospital Fort Worth', 1, NULL, NULL, N'452088', NULL, NULL, 0, 67, NULL, N'8173324812', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5528, N'Warm Springs Specialty Hospital Of San Antonio', 1, NULL, NULL, N'452090', NULL, NULL, 0, 26, NULL, N'2109213550', N'2109213578', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7400 Barlite Blvd 2Nd Floor', N'San Antonio', N'TX', N'48029', N'78224', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5529, N'Tyler Continuecare Hospital (At Mother Frances)', 1, NULL, NULL, N'452091', NULL, NULL, 0, 51, NULL, N'9035314942', N'9035251580', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 East Dawson 4Th Floor', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5530, N'Post Acute Specialty Hospital Of  Corpus Christi', 1, NULL, NULL, N'452092', NULL, NULL, 0, 74, NULL, N'3619861600', N'3619850330', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6226 Saratoga Boulevard', N'Corpus Christi', N'TX', N'48355', N'78414', 27.679395, -97.371366, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5531, N'Warm Springs Specialty Hospital Of Victoria Llc', 1, NULL, NULL, N'452094', NULL, NULL, 0, 26, NULL, N'3615766200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'102 Medical Drive', N'Victoria', N'TX', N'48469', N'77904', 28.854479, -97.021331, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5532, N'Solara Hospital Mcallen', 1, NULL, NULL, N'452095', NULL, NULL, 0, 78, NULL, N'9566324880', N'9566324891', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 West Expressway 83-8Th Floor', N'Mc Allen', N'TX', N'48215', N'78503', 31.816038, -99.512099, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5533, N'Laredo Specialty Hospital Lp', 1, NULL, NULL, N'452096', NULL, NULL, 0, 60, NULL, N'9567535353', N'9567535300', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 Bustamante Street', N'Laredo', N'TX', N'48479', N'78041', 27.506099, -99.508898, 3320, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5534, N'Vibra Specialty Hospital', 1, NULL, NULL, N'452097', NULL, NULL, 0, 60, NULL, N'2146381500', N'2146384545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 Walker Way', N'De Soto', N'TX', N'48113', N'75115', 32.589858, -96.856945, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5535, N'Regency Hospital Of Fort Worth Lllp', 1, NULL, NULL, N'452099', NULL, NULL, 0, 44, NULL, N'8178402500', NULL, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6801 Oakmont Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.662759, -97.414802, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5536, N'Mesquite Specialty Hospital', 1, NULL, NULL, N'452100', NULL, NULL, 0, 40, NULL, N'9722162300', N'9722887578', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1024  N Galloway Avenue', N'Mesquite', N'TX', N'48113', N'75149', 32.76661, -96.599472, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5537, N'Solara Hospital Harlingen', 1, NULL, NULL, N'452101', NULL, NULL, 0, 41, NULL, N'6828319670', N'6828319595', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'508 Victoria Lane', N'Harlingen', N'TX', N'48061', N'78550', 26.190631, -97.696103, 3294, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5538, N'Covenant Specialty Hospital', 1, NULL, NULL, N'452102', NULL, NULL, 0, 56, NULL, N'8067259200', N'8067259201', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3815 20Th Street', N'Lubbock', N'TX', N'48303', N'79410', 33.576771, -101.89682, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5539, N'El Paso Ltac Hosptial', 1, NULL, NULL, N'452103', NULL, NULL, 0, 33, NULL, N'9154969687', N'9154969695', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 N Cotton St 3Rd Floor', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5540, N'Baylor Scott & White Continuing Care Hospital', 1, NULL, NULL, N'452105', NULL, NULL, 0, 50, NULL, N'2542150900', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'546 N Kegley Road', N'Temple', N'TX', N'48027', N'76502', 31.119626, -97.397152, 3382, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5541, N'Warm Springs Specialty Hospital At New Braunfels', 1, NULL, NULL, N'452106', NULL, NULL, 0, 40, NULL, N'8306277600', N'8306277603', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1445 Hanz Drive', N'New Braunfels', N'TX', N'48091', N'78130', 29.727461, -98.101563, 3344, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5542, N'Chg Cornerstone- Conroe', 1, NULL, NULL, N'452107', NULL, NULL, 0, 41, NULL, N'6828319670', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Grand Lake Drive', N'Conroe', N'TX', N'48339', N'77304', 30.282308, -95.464444, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5543, N'Dallas Ltach Llc', 1, NULL, NULL, N'452108', NULL, NULL, 0, 60, NULL, N'4692326500', N'4692326501', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Meadows Road', N'Dallas', N'TX', N'48113', N'75231', 32.776272, -96.796856, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5544, N'Integrity Transitional Hospital', 1, NULL, NULL, N'452109', NULL, NULL, 0, 24, NULL, N'8167292740', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2813 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.19511, -97.08477, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5545, N'Ethicus Hospital - Grapevine', 1, NULL, NULL, N'452110', NULL, NULL, 0, 60, NULL, N'8172881300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4201 William D Tate Avenue', N'Grapevine', N'TX', N'48439', N'76051', 32.922711, -97.090821, 3288, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5546, N'Atrium Medical Center At Corinth', 1, NULL, NULL, N'452111', NULL, NULL, 0, 60, NULL, N'9402704100', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3305 Corinth Parkway', N'Corinth', N'TX', N'48121', N'76208', 33.153458, -97.050735, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5547, N'Icon Hospital', 1, NULL, NULL, N'452112', NULL, NULL, 0, 54, NULL, N'7048877283', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19211 Mckay Blvd', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5548, N'Christus Dubuis Hospital Of Bryan', 1, NULL, NULL, N'452113', NULL, NULL, 0, 30, NULL, N'9798217592', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 Joseph Drive 2Nd Floor', N'Bryan', N'TX', N'48041', N'77802', 30.693444, -96.400802, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5549, N'Atrium Medical Center', 1, NULL, NULL, N'452114', NULL, NULL, 0, 68, NULL, N'2812078200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11929 W Airport Blvd Suite 110', N'Stafford', N'TX', N'48157', N'77477', 29.616067, -95.557722, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5550, N'Texas Specialty Hospital At Lubbock', 1, NULL, NULL, N'452116', NULL, NULL, 0, 37, NULL, N'8067238731', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4302 B Princeton St', N'Lubbock', N'TX', N'48303', N'79415', 33.577863, -101.855166, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5551, N'Continuecare Hospittal  At Midland Memorial', 1, NULL, NULL, N'452117', NULL, NULL, 0, 29, NULL, N'4322211111', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4214 Andrews Highway', N'Midland', N'TX', N'48329', N'79703', 31.997366, -102.077948, 3336, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5552, N'Houston Methodist St Catherine Hospital', 1, NULL, NULL, N'452118', NULL, NULL, 0, 102, NULL, N'2815995700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 S Fry Road', N'Katy', N'TX', N'48201', N'77450', 29.785785, -95.824396, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5553, N'Select Specialty Hospital Dallas Downtown', 1, NULL, NULL, N'452119', NULL, NULL, 0, 46, NULL, N'9722270093', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Gaston Avenue 3Rd And 4Th Floors', N'Dallas', N'TX', N'48113', N'75246', 32.790462, -96.780872, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5554, N'Select Specialty Hospital Dallas Garland', 1, NULL, NULL, N'452120', NULL, NULL, 0, 40, NULL, N'4693340853', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Marie Curie 3W And 3E', N'Garland', N'TX', N'48113', N'75042', 32.912624, -96.638883, 3279, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5555, N'Tirr Memorial Hermann', 1, NULL, NULL, N'453025', NULL, NULL, 0, 119, NULL, N'7137997022', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1333 Moursund Ave', N'Houston', N'TX', N'48201', N'77030', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5556, N'Healthsouth Rehabilitation Hospital Of Humble', 1, NULL, NULL, N'453029', NULL, NULL, 0, 90, NULL, N'2813199509', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'19002 Mckay Drive', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5557, N'Healthsouth Rehab Institute Of San Antonio', 1, NULL, NULL, N'453031', NULL, NULL, 0, 108, NULL, N'2106910737', N'2105581297', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9119 Cinnamon Hill', N'San Antonio', N'TX', N'48029', N'78240', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5558, N'Warm Springs Rehab Hospital Of San Antonio Llc', 1, NULL, NULL, N'453035', NULL, NULL, 0, 65, NULL, N'2106160100', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5101 Medical Dr', N'San Antonio', N'TX', N'48029', N'78229', 29.520944, -98.558064, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5559, N'Baylor Institute For Rehabilitation', 1, NULL, NULL, N'453036', NULL, NULL, 0, 92, NULL, N'2148209543', N'2148209295', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'909 North Washington Avenue', N'Dallas', N'TX', N'48113', N'75246', 32.792009, -96.779451, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5560, N'Healthsouth Rehabilitation Hospital Of Arlington', 1, NULL, NULL, N'453040', NULL, NULL, 0, 85, NULL, N'8174684000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Matlock', N'Arlington', N'TX', N'48439', N'76015', 32.696273, -97.115097, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5561, N'Healthsouth Rehabilitation Hospital Of Fort Worth', 1, NULL, NULL, N'453041', NULL, NULL, 0, 60, NULL, N'8178702336', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1212 West Lancaster', N'Fort Worth', N'TX', N'48439', N'76102', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5562, N'Healthsouth City View Rehab Hospital', 1, NULL, NULL, N'453042', NULL, NULL, 0, 62, NULL, N'8173704700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6701 Oakmont Boulevard', N'Fort Worth', N'TX', N'48439', N'76132', 32.662748, -97.41206, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5563, N'Healthsouth Rehabilitation Hospital Of Austin', 1, NULL, NULL, N'453044', NULL, NULL, 0, 83, NULL, N'5124793713', N'5124742720', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1215 Red River', N'Austin', N'TX', N'48453', N'78701', 30.271129, -97.743699, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5564, N'Healthsouth Plano Rehabilitation Hospital', 1, NULL, NULL, N'453047', NULL, NULL, 0, 83, NULL, N'9726129000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 W 15Th St', N'Plano', N'TX', N'48085', N'75075', 33.019543, -96.739105, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5565, N'Healthsouth Rehabilitation Hospital Of Beaumont', 1, NULL, NULL, N'453048', NULL, NULL, 0, 61, NULL, N'4098350835', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3340 Plaza 10 Blvd Ste B', N'Beaumont', N'TX', N'48245', N'77707', 30.086046, -94.101846, 3219, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5566, N'Kindred Rehabilitation Hospital Clear Lake', 1, NULL, NULL, N'453052', NULL, NULL, 0, 60, NULL, N'2812861500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'655 E Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.538851, -95.129514, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5567, N'Healthsouth  Rehabilitation Hospital Of Texarkana', 1, NULL, NULL, N'453053', NULL, NULL, 0, 60, NULL, N'9037930088', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 West 12Th St', N'Texarkana', N'TX', N'48037', N'75501', 33.430878, -94.047455, 3384, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5568, N'Healthsouth Rehab Hospital Of Wichita Falls', 1, NULL, NULL, N'453054', NULL, NULL, 0, 63, NULL, N'9407205700', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3901 Armory Road', N'Wichita Falls', N'TX', N'48485', N'76301', 33.874684, -98.485502, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5569, N'Trinity Mother Frances Rehabilitation Hospital', 1, NULL, NULL, N'453056', NULL, NULL, 0, 74, NULL, N'9035107000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3131 Troup Hwy', N'Tyler', N'TX', N'48423', N'75701', 32.315304, -95.276708, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5570, N'Healthsouth Rehabilitation Of Midland Odessa', 1, NULL, NULL, N'453057', NULL, NULL, 0, 60, NULL, N'9155201600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1800 Heritage Boulevard', N'Midland', N'TX', N'48329', N'79707', 32.000103, -102.157545, 3336, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5571, N'Healthsouth Rehab Hospital The Woodlands', 1, NULL, NULL, N'453059', NULL, NULL, 0, 84, NULL, N'2813643304', N'2813648947', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18550 I 45 South', N'Conroe', N'TX', N'48339', N'77384', 30.39338, -95.47042, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5572, N'Christus St Michael Rehab Hospital', 1, NULL, NULL, N'453065', NULL, NULL, 0, 50, NULL, N'9036144000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 St Michael Drive', N'Texarkana', N'TX', N'48037', N'75503', 33.46459, -94.069672, 3384, 16, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5573, N'Etmc Rehab', 1, NULL, NULL, N'453072', NULL, NULL, 0, 49, NULL, N'9035963000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Olympic Plaza Circle', N'Tyler', N'TX', N'48423', N'75701', 32.337078, -95.292046, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5574, N'Highlands Regional Rehabilitation Hospital', 1, NULL, NULL, N'453086', NULL, NULL, 0, 41, NULL, N'9152987222', N'9152987237', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1395 George Dieter Drive', N'El Paso', N'TX', N'48141', N'79936', 31.73387, -106.301838, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5575, N'Weslaco Regional Rehabilitation Hospital Llc', 1, NULL, NULL, N'453091', NULL, NULL, 0, 32, NULL, N'9569692222', N'9569692221', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'906 James Street', N'Weslaco', N'TX', N'48215', N'78596', 26.151747, -97.97636, 3398, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5576, N'South Texas Rehabiltation Hospital', 1, NULL, NULL, N'453092', NULL, NULL, 0, 40, NULL, N'9565546000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 East Alton Gloor Blvd', N'Brownsville', N'TX', N'48061', N'78526', 25.979882, -97.497606, 3229, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5577, N'Kindred  Rehabilitation Hospital Arlington', 1, NULL, NULL, N'453094', NULL, NULL, 0, 24, NULL, N'8178044410', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2601 West Randol  Mill Road # 101', N'Arlington', N'TX', N'48439', N'76012', 32.756334, -97.143146, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5578, N'Vibra Rehabilitation Hospital Of Amarillo', 1, NULL, NULL, N'453096', NULL, NULL, 0, 44, NULL, N'8064682981', N'8067142642', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7200 West 9Th Street', N'Amarillo', N'TX', N'48375', N'79106', 35.207219, -101.833825, 3205, 256, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5579, N'Cook Childrens Medical Center', 1, NULL, NULL, N'453300', NULL, NULL, 0, 282, NULL, N'6828854000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Seventh Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.736561, -97.341976, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5580, N'Driscoll Childrens Hospital', 1, NULL, NULL, N'453301', NULL, NULL, 0, 200, NULL, N'3617394846', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3533 S Alameda Box 6530', N'Corpus Christi', N'TX', N'48355', N'78411', 27.749573, -97.385163, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5581, N'Childrens Medical Ctr Of Dallas', 1, NULL, NULL, N'453302', NULL, NULL, 0, 406, NULL, N'2144567000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1935 Medical District Drive', N'Dallas', N'TX', N'48113', N'75235', 32.809496, -96.837518, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5582, N'Texas Childrens Hosp', 1, NULL, NULL, N'453304', NULL, NULL, 0, 606, NULL, N'8328241000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6621 Fannin Street', N'Houston', N'TX', N'48201', N'77030', 29.709777, -95.400712, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5583, N'Covenant Childrens Hospital', 1, NULL, NULL, N'453306', NULL, NULL, 0, 73, NULL, N'8067250532', N'8067237183', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4015 22Nd Place', N'Lubbock', N'TX', N'48303', N'79410', 33.574022, -101.900419, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5584, N'Our Childrens House At Baylor', 1, NULL, NULL, N'453308', NULL, NULL, 0, 38, NULL, N'2148284747', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3301 Swiss Ave', N'Dallas', N'TX', N'48113', N'75204', 32.791197, -96.782966, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5585, N'Healthbridge Childrens''s Hospital Of Houston', 1, NULL, NULL, N'453309', NULL, NULL, 0, 40, NULL, N'2812937774', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2929 Woodland Park Drive', N'Houston', N'TX', N'48201', N'77082', 29.733148, -95.580499, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5586, N'Dell Children''s Medical Center Of Central Texas', 1, NULL, NULL, N'453310', NULL, NULL, 0, 176, NULL, N'5123240000', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4900 Mueller Blvd', N'Austin', N'TX', N'48453', N'78723', 30.302549, -97.704957, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5587, N'Shriners Hospitals For Children', 1, NULL, NULL, N'453311', NULL, NULL, 0, 30, NULL, N'4097706600', N'4097706977', 1, 0, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'815 Market Street', N'Galveston', N'TX', N'48167', N'77550', 29.78739, -95.095441, 3278, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5588, N'Shriners Hospitals For Children', 1, NULL, NULL, N'453312', NULL, NULL, 0, 40, NULL, N'7137971616', N'7137971029', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6977 Main Street', N'Houston', N'TX', N'48201', N'77030', 29.704337, -95.405749, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5589, N'El Paso Children''s Hospital', 1, NULL, NULL, N'453313', NULL, NULL, 0, 122, NULL, N'9155217148', N'9155217849', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4845 Alameda Avenue', N'El Paso', N'TX', N'48141', N'79905', 31.770324, -106.432954, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5590, N'Texas Scottish Rite Hospital For Children', 1, NULL, NULL, N'453314', NULL, NULL, 0, 100, NULL, N'2145595000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2222 Welborn Street', N'Dallas', N'TX', N'48113', N'75219', 32.802014, -96.814555, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5591, N'Children''s Hospital Of San Antonio', 1, NULL, NULL, N'453315', NULL, NULL, 0, 120, NULL, N'2107043342', N'2107043466', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 North Santa Rosa Street', N'San Antonio', N'TX', N'48029', N'78207', 29.427988, -98.499243, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5592, N'Childrens Medical Center Plano', 1, NULL, NULL, N'453316', NULL, NULL, 0, 72, NULL, N'2144561792', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7601 Preston Road', N'Plano', N'TX', N'48085', N'75024', 33.07031, -96.795578, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5593, N'Big Spring State Hospital', 1, NULL, NULL, N'454000', NULL, NULL, 0, 160, NULL, N'4322687222', N'4322687259', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 North Highway 87', N'Big Spring', N'TX', N'48227', N'79721', 32.250398, -101.478736, 3223, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5594, N'Terrell State Hospital', 1, NULL, NULL, N'454006', NULL, NULL, 0, 74, NULL, N'9725246452', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 E Brin Street', N'Terrell', N'TX', N'48257', N'75160', 32.738354, -96.262675, 3383, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5595, N'North Texas State Hospital', 1, NULL, NULL, N'454008', NULL, NULL, 0, 354, NULL, N'9406921220', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6515 Kemp Blvd', N'Wichita Falls', N'TX', N'48485', N'76308', 33.840533, -98.527873, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5596, N'Rusk State Hosp', 1, NULL, NULL, N'454009', NULL, NULL, 0, 380, NULL, N'9036833421', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'805 N Dickinson Dr', N'Rusk', N'TX', N'48073', N'75785', 31.809813, -95.156774, 3304, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5597, N'San Antonio State Hosp  State School', 1, NULL, NULL, N'454011', NULL, NULL, 0, 302, NULL, N'2105317711', N'2105317876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6711 S New Braunfels Ave', N'San Antonio', N'TX', N'48029', N'78223', 29.365783, -98.459812, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5598, N'Millwood Hospital', 1, NULL, NULL, N'454012', NULL, NULL, 0, 122, NULL, N'8172613121', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1011 North Cooper Street', N'Arlington', N'TX', N'48439', N'76011', 32.750327, -97.113704, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5599, N'Kerrville State Hosp', 1, NULL, NULL, N'454014', NULL, NULL, 0, 233, NULL, N'8308962211', N'8307924926', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'721 Thompson Dr', N'Kerrville', N'TX', N'48265', N'78028', 30.046969, -99.151302, 3312, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5600, N'Red River Hospital', 1, NULL, NULL, N'454018', NULL, NULL, 0, 66, NULL, N'9403223171', N'9403227010', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1505 8Th St', N'Wichita Falls', N'TX', N'48485', N'76301', 33.906648, -98.501173, 3402, 276, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5601, N'West Oaks Hospital', 1, NULL, NULL, N'454026', NULL, NULL, 0, 144, NULL, N'7139950909', N'7137785253', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6500 Hornwood', N'Houston', N'TX', N'48201', N'77074', 29.708962, -95.49698, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5602, N'Seton Shoal Creek Hospital', 1, NULL, NULL, N'454029', NULL, NULL, 0, 151, NULL, N'5123242000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3501 Mills Ave', N'Austin', N'TX', N'48453', N'78731', 30.306057, -97.748597, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5603, N'Glen Oaks Hospital', 1, NULL, NULL, N'454050', NULL, NULL, 0, 54, NULL, N'9034546000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E Division Box 1885', N'Greenville', N'TX', N'48231', N'75401', 33.138449, -96.110807, 3289, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5604, N'Laurel Ridge Treatment Center', 1, NULL, NULL, N'454060', NULL, NULL, 0, 208, NULL, N'5124919400', N'2104913350', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17720 Corporate Woods Drive', N'San Antonio', N'TX', N'48029', N'78259', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5605, N'River Crest Hosp', 1, NULL, NULL, N'454064', NULL, NULL, 0, 80, NULL, N'9159495722', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1636 Hunters Glen Road', N'San Angelo', N'TX', N'48451', N'76901', 31.446109, -100.510006, 3369, 270, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5606, N'Hickory Trail Hospital', 1, NULL, NULL, N'454065', NULL, NULL, 0, 76, NULL, N'9722987323', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 N Old Hickory Trail', N'Desoto', N'TX', N'48113', N'75115', 31.816038, -99.512099, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5607, N'Austin Lakes Hospital', 1, NULL, NULL, N'454069', NULL, NULL, 0, 58, NULL, N'5128675800', N'5124048102', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 East 32Nd Street', N'Austin', N'TX', N'48453', N'78705', 30.289243, -97.723739, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5608, N'Harris Cty Psychiatric Ctr', 1, NULL, NULL, N'454076', NULL, NULL, 0, 272, NULL, N'7137415000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 Macgrer Way', N'Houston', N'TX', N'48201', N'77021', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5609, N'Intracare North Hospital', 1, NULL, NULL, N'454083', NULL, NULL, 0, 90, NULL, N'2818937200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Cypress Station Dr', N'Houston', N'TX', N'48201', N'77090', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5610, N'Austin State Hospital', 1, NULL, NULL, N'454084', NULL, NULL, 0, 352, NULL, N'5124192100', N'5124192139', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4110 Guadalupe', N'Austin', N'TX', N'48453', N'78751', 30.307654, -97.735342, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5611, N'Devereux Texas Treatment Network', 1, NULL, NULL, N'454085', NULL, NULL, 0, 132, NULL, N'2813351000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1150 Devereux Dr', N'League City', N'TX', N'48167', N'77573', 29.506495, -95.106458, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5612, N'Rio Grande State Center', 1, NULL, NULL, N'454088', NULL, NULL, 0, 160, NULL, N'9563648000', N'9563648245', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Rangerville Road', N'Harlingen', N'TX', N'48061', N'78550', 26.164851, -97.705776, 3294, 264, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5613, N'Sunrise Canyon Hospital', 1, NULL, NULL, N'454093', NULL, NULL, 0, 30, NULL, N'8067660268', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1950 Aspen Avenue', N'Lubbock', N'TX', N'48303', N'79408', 33.574137, -101.807455, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5614, N'Green Oaks Hospital', 1, NULL, NULL, N'454094', NULL, NULL, 0, 106, NULL, N'9729919504', N'4694842132', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7808 Clodus Fields Drive', N'Dallas', N'TX', N'48113', N'75251', 32.913458, -96.770853, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5615, N'Abilene Behavioral Health Llc', 1, NULL, NULL, N'454098', NULL, NULL, 0, 92, NULL, N'3256986600', N'3256988200', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4225 Woods Place', N'Abilene', N'TX', N'48441', N'79608', 32.400107, -99.739868, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5616, N'El Paso Psychiatric Center', 1, NULL, NULL, N'454100', NULL, NULL, 0, 85, NULL, N'9155322202', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4615 Alameda Avenue', N'El Paso', N'TX', N'48141', N'79905', 31.771389, -106.436204, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5617, N'Allegiance Behavioral Health Center Of Plainview', 1, NULL, NULL, N'454101', NULL, NULL, 0, 20, NULL, N'8062969191', N'8062969292', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2601 Dimmitt Road Suite 400', N'Plainview', N'TX', N'48189', N'79072', 34.206789, -101.731133, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5618, N'Kingwood Pines Hospital', 1, NULL, NULL, N'454103', NULL, NULL, 0, 116, NULL, N'2813581495', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Ladbrook', N'Kingwood', N'TX', N'48201', N'77339', 30.045284, -95.228863, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5619, N'University Behavioral Health', 1, NULL, NULL, N'454104', NULL, NULL, 0, 104, NULL, N'9403208100', N'9403840307', 1, 0, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2026 West University Drive', N'Denton', N'TX', N'48121', N'76201', 33.22973, -97.156303, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5620, N'Behavioral Hospital Of Longview', 1, NULL, NULL, N'454105', NULL, NULL, 0, 76, NULL, N'9032913456', N'9036631722', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'22 Bermuda Lane', N'Longview', N'TX', N'48183', N'75605', 32.564875, -94.764979, 3325, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5621, N'Behavioral Hospital Of Bellaire', 1, NULL, NULL, N'454107', NULL, NULL, 0, 124, NULL, N'7136009500', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5314 Dashwood Suite 200', N'Houston', N'TX', N'48201', N'77081', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5622, N'Cypress Creek Hospital', 1, NULL, NULL, N'454108', NULL, NULL, 0, 96, NULL, N'2815867600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17750 Cali Drive', N'Houston', N'TX', N'48201', N'77090', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5623, N'El Paso Behavioral Health System', 1, NULL, NULL, N'454109', NULL, NULL, 0, 163, NULL, N'9155444000', N'9155320733', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Denver Ave', N'El Paso', N'TX', N'48141', N'79902', 31.781368, -106.47597, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5624, N'Oceans Behavioral  Hospital Of Permian Basin', 1, NULL, NULL, N'454110', NULL, NULL, 0, 64, NULL, N'4325615915', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 S Fm 1788', N'Midland', N'TX', N'48329', N'79706', 31.997366, -102.077948, 3336, 269, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5625, N'Texas Star Recovery', 1, NULL, NULL, N'454111', NULL, NULL, 0, 60, NULL, N'5124444835', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1106  West Dittmar Rd', N'Austin', N'TX', N'48453', N'78745', 30.271129, -97.743699, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5626, N'Sundance Hospital', 1, NULL, NULL, N'454113', NULL, NULL, 0, 116, NULL, N'8175838080', N'8174831572', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7000 Us Highway 287', N'Arlington', N'TX', N'48439', N'76001', 32.735582, -97.107119, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5627, N'Cedar Crest Hospital & Rtc', 1, NULL, NULL, N'454114', NULL, NULL, 0, 88, NULL, N'2549392100', N'2549392334', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 South Ih-35', N'Belton', N'TX', N'48027', N'76513', 31.056013, -97.464453, 3382, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5628, N'Oceans Behavioral Hospital Of Longview', 1, NULL, NULL, N'454117', NULL, NULL, 0, 24, NULL, N'9032123105', N'9032122930', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'615 Clinic Dr', N'Longview', N'TX', N'48183', N'75605', 32.536682, -94.732089, 3325, 266, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5629, N'Lone Star Behavioral Health Cypress', 1, NULL, NULL, N'454118', NULL, NULL, 0, 24, NULL, N'2815166186', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16303 Grant Road', N'Cypress', N'TX', N'48201', N'77429', 29.966805, -95.557488, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5630, N'Carrollton Springs', 1, NULL, NULL, N'454119', NULL, NULL, 0, 45, NULL, N'9722424114', N'9722424117', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2225 Parker Road', N'Carrollton', N'TX', N'48121', N'75010', 33.046425, -96.905774, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5631, N'Austin Oaks Hospital', 1, NULL, NULL, N'454121', NULL, NULL, 0, 80, NULL, N'5123838939', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1407 West Stassney Lane', N'Austin', N'TX', N'48453', N'78745', 30.211635, -97.791745, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5632, N'Oceans Behavioral Hospital Of Abilene', 1, NULL, NULL, N'454122', NULL, NULL, 0, 35, NULL, N'3296910030', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Directors Parkway', N'Abilene', N'TX', N'48441', N'79606', 32.371325, -99.745065, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5633, N'Oceans Behavioral Hospital Of Lufkin Llc', 1, NULL, NULL, N'454123', NULL, NULL, 0, 24, NULL, N'9366322276', N'9366322295', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'302 bblers Knob Rd', N'Lufkin', N'TX', N'48005', N'75904', 31.306132, -94.750086, 3327, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5634, N'Mesa Springs', 1, NULL, NULL, N'454124', NULL, NULL, 0, 72, NULL, N'8172924600', N'8172924604', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5560 Mesa Springs Drive', N'Fort Worth', N'TX', N'48439', N'76123', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5635, N'Rock Prairie Behavioral Health', 1, NULL, NULL, N'454125', NULL, NULL, 0, 105, NULL, N'9797038848', N'9797036485', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3550 Normand Drive', N'College Station', N'TX', N'48041', N'77845', 30.625346, -96.327154, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5636, N'Dallas Behavioral Healthcare Hospital Llc', 1, NULL, NULL, N'454126', NULL, NULL, 0, 116, NULL, N'9722961005', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Kirnwood Drive', N'De Soto', N'TX', N'48113', N'75115', 32.589858, -96.856945, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5637, N'Oceans Behavioral Hospital Of Fort Worth', 1, NULL, NULL, N'454128', NULL, NULL, 0, 48, NULL, N'8173611991', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6200 Overton Ridge Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.680406, -97.420018, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5638, N'Georgetown Behavioral Health Institute', 1, NULL, NULL, N'454129', NULL, NULL, 0, 118, NULL, N'2489055091', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3101 S Austin Avenue', N'Georgetown', N'TX', N'48491', N'78626', 30.609656, -97.684167, 3381, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5639, N'Oceans Behavioral Hospital Of Plano', 1, NULL, NULL, N'454130', NULL, NULL, 0, 48, NULL, N'9725965445', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4301 Mapleshade Lane', N'Plano', N'TX', N'48085', N'75093', 33.006155, -96.805811, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5640, N'Westpark Springs Llc', 1, NULL, NULL, N'454131', NULL, NULL, 0, 72, NULL, N'8325352770', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6902 S Peek Road', N'Richmond', N'TX', N'48157', N'77407', 29.582181, -95.760783, 3364, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5641, N'San Antonio Behavioral Healthcare Hospital', 1, NULL, NULL, N'454132', NULL, NULL, 0, 108, NULL, N'2105415300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8550 Huebner Road', N'San Antonio', N'TX', N'48029', N'78240', 29.520176, -98.603259, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5642, N'Cross Creek Hospital', 1, NULL, NULL, N'454133', NULL, NULL, 0, 90, NULL, N'8445724956', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8402 Cross Park Drive', N'Austin', N'TX', N'48453', N'78754', 30.338112, -97.677184, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5643, N'Haven Behavioral Hospital Of Frisco', 1, NULL, NULL, N'454134', NULL, NULL, 0, 36, NULL, N'4695358000', N'4695358001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5680 Frisco Square Blvd Suite 3000', N'Frisco', N'TX', N'48085', N'75034', 33.150674, -96.823612, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5644, N'Houston Behavioral Healthcare Hospital Llc', 1, NULL, NULL, N'454135', NULL, NULL, 0, 88, NULL, N'8328347710', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2801 Gessner Road', N'Houston', N'TX', N'48201', N'77080', 29.821132, -95.545346, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5645, N'Oceans Behavioral Hospital Of Katy', 1, NULL, NULL, N'454136', NULL, NULL, 0, 48, NULL, N'2814928888', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'455 Park Grove Lane', N'Katy', N'TX', N'48201', N'77450', 29.785785, -95.824396, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5646, N'Medical City Hospital', 1, NULL, NULL, N'459801', NULL, NULL, 0, 0, NULL, N'9725667199', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7777 Forest Lane', N'Dallas', N'TX', N'48113', N'75230', 32.909449, -96.771223, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5647, N'Methodist Dallas Medical Center', 1, NULL, NULL, N'459802', NULL, NULL, 0, 0, NULL, N'2149472879', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1441 N Beckley Avenue', N'Dallas', N'TX', N'48113', N'75203', 32.761651, -96.823094, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5648, N'University Hospital Transplant', 1, NULL, NULL, N'459803', NULL, NULL, 0, 0, NULL, N'2105675772', N'2105675122', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4502 Medical Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.520944, -98.558064, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5649, N'St Lukes Episcopal Hospital Transplant', 1, NULL, NULL, N'459805', NULL, NULL, 0, 0, NULL, N'8323551000', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6720 Bertner', N'Houston', N'TX', N'48201', N'77030', 29.706776, -95.399023, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5650, N'Christus Santa Rosa Medical Center Transplant', 1, NULL, NULL, N'459806', NULL, NULL, 0, 0, NULL, N'2108889999', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'333 Santa Rosa Street', N'San Antonio', N'TX', N'48029', N'78207', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5651, N'North Austin Medical Center', 1, NULL, NULL, N'459807', NULL, NULL, 0, 0, NULL, N'5129012896', N'5129011995', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'12221 North Mopac Expressway', N'Austin', N'TX', N'48453', N'78758', 30.412485, -97.706855, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5652, N'Baylor University Medical Center', 1, NULL, NULL, N'459808', NULL, NULL, 0, 0, NULL, N'2148202657', N'2148204527', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3500 Gaston Ave', N'Dallas', N'TX', N'48113', N'75246', 32.790462, -96.780872, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5653, N'The Methodist Hospital Transplant', 1, NULL, NULL, N'459809', NULL, NULL, 0, 0, NULL, N'7137902221', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6565 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.710741, -95.399149, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5654, N'Seton Medical Center', 1, NULL, NULL, N'459810', NULL, NULL, 0, 0, NULL, N'5123241902', N'5124595629', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1201 West 38Th Street', N'Austin', N'TX', N'48453', N'78705', 30.305199, -97.745461, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5655, N'Harris Methodist Ft Worth Transplant', 1, NULL, NULL, N'459811', NULL, NULL, 0, 552, NULL, N'8178822100', N'8178822149', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1301 Pennsylvania Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.738406, -97.339167, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5656, N'Cook Childrens Medical Center Transplant Services', 1, NULL, NULL, N'459812', NULL, NULL, 0, 0, NULL, N'6828854286', N'6828857883', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'801 Seventh Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5657, N'Utmb Galveston Transplant', 1, NULL, NULL, N'459813', NULL, NULL, 0, 0, NULL, N'4097721011', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'301 University Blvd', N'Galveston', N'TX', N'48167', N'77555', 29.310307, -94.774521, 3278, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5658, N'Children''s Medical Center Dallas', 1, NULL, NULL, N'459814', NULL, NULL, 0, 0, NULL, N'2144566332', N'2144568586', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1935 Motor St', N'Dallas', N'TX', N'48113', N'75235', 32.809496, -96.837518, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5659, N'Texas Children''s Hospital Transplant', 1, NULL, NULL, N'459815', NULL, NULL, 0, 0, NULL, N'8328241120', N'8328251005', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6621 Fannin', N'Houston', N'TX', N'48201', N'77030', 29.709777, -95.400712, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5660, N'Ut Southwestern Medical Center University Hospital', 1, NULL, NULL, N'459816', NULL, NULL, 0, 0, NULL, N'2146451914', N'2146451900', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5909 Harry Hines Blvd', N'Dallas', N'TX', N'48113', N'75390', 32.817634, -96.844658, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5661, N'East Texas Medical Center Transplant', 1, NULL, NULL, N'459817', NULL, NULL, 0, 0, NULL, N'9035318643', N'9035356703', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1000 S Beckham', N'Tyler', N'TX', N'48423', N'75701', 32.35126, -95.301062, 3388, 273, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5662, N'Methodist Hospital', 1, NULL, NULL, N'459818', NULL, NULL, 0, 0, NULL, N'2105756275', N'2105754410', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7700 Floyd Curl Drive', N'San Antonio', N'TX', N'48029', N'78229', 29.507341, -98.573582, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5663, N'Parkland Hospital', 1, NULL, NULL, N'459819', NULL, NULL, 0, 0, NULL, N'2145906773', N'2145904595', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5201 Harry Hines', N'Dallas', N'TX', N'48113', N'75235', 32.81088, -96.835826, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5664, N'Mcallen Medical Center - S Texas Transplant Center', 1, NULL, NULL, N'459820', NULL, NULL, 0, 0, NULL, N'9569715726', N'9569715840', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'301 W Expressway 83', N'Mcallen', N'TX', N'48215', N'78503', 26.204369, -98.230082, 3332, 268, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5665, N'Scott & White Transplant', 1, NULL, NULL, N'459821', NULL, NULL, 0, 0, NULL, N'2547247545', N'2547248772', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2401 S 31St St', N'Temple', N'TX', N'48027', N'76508', 31.077909, -97.366162, 3382, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5666, N'Baylor All Saints Medical Center Of Fort Worth', 1, NULL, NULL, N'459822', NULL, NULL, 0, 0, NULL, N'8179224650', N'8179224655', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1400 Eighth Ave', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5667, N'Driscoll Children''s Hospital Transplant Center', 1, NULL, NULL, N'459823', NULL, NULL, 0, 0, NULL, N'3616946852', N'3616946859', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3533 S Alameda', N'Corpus Christi', N'TX', N'48355', N'78466', 27.715689, -97.338327, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5668, N'Memorial Hermann Hospital', 1, NULL, NULL, N'459824', NULL, NULL, 0, 0, NULL, N'7137041735', N'7137046374', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'6411 Fannin Drive', N'Houston', N'TX', N'48201', N'77030', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5669, N'Las Palmas Medical Center (Transplant)', 1, NULL, NULL, N'459825', NULL, NULL, 0, 0, NULL, N'9155211828', N'9155994381', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1700 North Oren Suite 680', N'El Paso', N'TX', N'48141', N'79902', 31.760037, -106.487287, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5670, N'Plaza Medical Center Of Fort Worth', 1, NULL, NULL, N'459826', NULL, NULL, 0, 0, NULL, N'8178775292', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'900 Eighth Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.753177, -97.332746, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5671, N'Utah Valley Regional Medical Center', 1, NULL, NULL, N'460001', NULL, NULL, 0, 395, NULL, N'8013737850', N'8013577780', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1034 North 500 West', N'Provo', N'UT', N'49049', N'84604', 40.248084, -111.667383, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5672, N'Salt Lake Regional Medical Center', 1, NULL, NULL, N'460003', NULL, NULL, 0, 158, NULL, N'8013504111', N'8013504522', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 East South Temple', N'Salt Lake City', N'UT', N'49035', N'84102', 40.769348, -111.861309, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5673, N'Mckay Dee Hospital', 1, NULL, NULL, N'460004', NULL, NULL, 0, 304, NULL, N'8013872800', N'8013873725', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4401 Harrison Boulevard', N'Ogden', N'UT', N'49057', N'84403', 41.184218, -111.94908, 3425, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5674, N'Ogden Regional Medical Center', 1, NULL, NULL, N'460005', NULL, NULL, 0, 227, NULL, N'8014792111', N'8014792007', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5475 South 500 East', N'Ogden', N'UT', N'49057', N'84405', 41.165015, -111.984329, 3425, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5675, N'Lds Hospital', 1, NULL, NULL, N'460006', NULL, NULL, 0, 213, NULL, N'8014081100', N'8014081665', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8Th Avenue And C Street', N'Salt Lake City', N'UT', N'49035', N'84143', 40.778499, -111.873058, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5676, N'Valley View Medical Center', 1, NULL, NULL, N'460007', NULL, NULL, 0, 42, NULL, N'4358685800', N'4355865803', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1303 North Main Street', N'Cedar City', N'UT', N'49021', N'84721', 37.702469, -113.063698, 3412, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5677, N'University Health Care/Univ Hospitals And  Clinics', 1, NULL, NULL, N'460009', NULL, NULL, 0, 425, NULL, N'8015812121', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'50 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84132', 40.772984, -111.83672, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5678, N'Intermountain Medical Center', 1, NULL, NULL, N'460010', NULL, NULL, 0, 520, NULL, N'8015077000', N'8015077995', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5121 South Cottonwood Street', N'Murray', N'UT', N'49035', N'84107', 40.666784, -111.888417, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5679, N'Castleview Hospital', 1, NULL, NULL, N'460011', NULL, NULL, 0, 84, NULL, N'4356374800', N'4356379513', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 North Hospital Drive', N'Price', N'UT', N'49007', N'84501', 39.605806, -110.832182, 3428, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5680, N'Mountain View Hospital', 1, NULL, NULL, N'460013', NULL, NULL, 0, 126, NULL, N'8014657100', N'8014657170', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 East 100 North', N'Payson', N'UT', N'49049', N'84651', 40.044696, -111.714851, 3427, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5681, N'Mountain West Medical Center', 1, NULL, NULL, N'460014', NULL, NULL, 0, 44, NULL, N'4358433700', N'4358828770', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2055 North Main Street', N'Tooele', N'UT', N'49045', N'84074', 40.531647, -112.298558, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5682, N'Logan Regional Hospital', 1, NULL, NULL, N'460015', NULL, NULL, 0, 148, NULL, N'4357161000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East 1400 North', N'Logan', N'UT', N'49005', N'84341', 41.757336, -111.819219, 3418, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5683, N'Brigham City Community Hospital', 1, NULL, NULL, N'460017', NULL, NULL, 0, 52, NULL, N'4357349471', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'950 South Medical Drive', N'Brigham City', N'UT', N'49003', N'84302', 41.49109, -112.024429, 3411, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5684, N'Uintah Basin Medical Center', 1, NULL, NULL, N'460019', NULL, NULL, 0, 49, NULL, N'4357224691', N'4357229291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'250 West 300 North', N'Roosevelt', N'UT', N'49013', N'84066', 40.302755, -109.997086, 3431, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5685, N'Dixie Regional Medical Center', 1, NULL, NULL, N'460021', NULL, NULL, 0, 245, NULL, N'4352512100', N'4352512115', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1380 East Medical Center Drive', N'St George', N'UT', N'49053', N'84790', 37.09985, -113.55333, 3433, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5686, N'American Fork Hospital', 1, NULL, NULL, N'460023', NULL, NULL, 0, 76, NULL, N'8018553305', N'8018553548', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'170 North 1100 East', N'American Fork', N'UT', N'49049', N'84003', 40.380319, -111.769096, 3408, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5687, N'Sevier Valley Medical Center', 1, NULL, NULL, N'460026', NULL, NULL, 0, 42, NULL, N'4358934100', N'4358930540', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Main Street', N'Richfield', N'UT', N'49041', N'84701', 38.783275, -112.084663, 3430, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5688, N'Ashley Regional Medical Center', 1, NULL, NULL, N'460030', NULL, NULL, 0, 39, NULL, N'4357893342', N'4357891314', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 West 100 North', N'Vernal', N'UT', N'49047', N'84078', 40.454275, -109.531298, 3435, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5689, N'Garfield Memorial Hospital', 1, NULL, NULL, N'460033', NULL, NULL, 0, 41, NULL, N'4356768811', N'4356761525', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 North 400 East', N'Panguitch', N'UT', N'49017', N'84759', 37.825779, -112.427925, 3426, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5690, N'Beaver Valley Hospital', 1, NULL, NULL, N'460035', NULL, NULL, 0, 57, NULL, N'4354387102', N'4354387166', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1109 North 100 West', N'Beaver', N'UT', N'49001', N'84713', 38.288865, -112.64312, 3409, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5691, N'Bear River Valley Hospital', 1, NULL, NULL, N'460039', NULL, NULL, 0, 16, NULL, N'4352074500', N'4352074715', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'905 North 1000 West', N'Tremonton', N'UT', N'49003', N'84337', 41.724529, -112.182865, 3434, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5692, N'Davis Hospital And Medical Center', 1, NULL, NULL, N'460041', NULL, NULL, 0, 220, NULL, N'8018077001', N'8018077045', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 West Antelope Drive', N'Layton', N'UT', N'49011', N'84041', 41.089245, -111.995094, 3417, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5693, N'Lakeview Hospital', 1, NULL, NULL, N'460042', NULL, NULL, 0, 117, NULL, N'8012992200', N'8012992534', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'630 East Medical Drive', N'Bountiful', N'UT', N'49011', N'84010', 40.886859, -111.868677, 3410, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5694, N'Orem Community Hospital', 1, NULL, NULL, N'460043', NULL, NULL, 0, 20, NULL, N'8017143307', N'8012267831', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'331 North 400 West', N'Orem', N'UT', N'49049', N'84057', 40.303481, -111.705478, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5695, N'Alta View Hospital', 1, NULL, NULL, N'460044', NULL, NULL, 0, 70, NULL, N'8015012600', N'8015014327', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9660 South 1300 East', N'Sandy', N'UT', N'49035', N'84094', 40.574927, -111.85319, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5696, N'St Marks Hospital', 1, NULL, NULL, N'460047', NULL, NULL, 0, 294, NULL, N'8012687700', N'8012703489', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 East 3900 South', N'Salt Lake City', N'UT', N'49035', N'84124', 40.687061, -111.85757, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5697, N'The Orthopedic Specialty Hospital', 1, NULL, NULL, N'460049', NULL, NULL, 0, 14, NULL, N'8013144100', N'8013144149', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5848 South 300 East', N'Murray', N'UT', N'49035', N'84107', 40.644021, -111.898369, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5698, N'Jordan Valley Medical Center', 1, NULL, NULL, N'460051', NULL, NULL, 0, 322, NULL, N'8015618888', N'8015698723', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3580 West 9000 South', N'West Jordan', N'UT', N'49035', N'84088', 40.587958, -111.975037, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5699, N'Timpanos Regional Hospital', 1, NULL, NULL, N'460052', NULL, NULL, 0, 122, NULL, N'8017146800', N'8017146597', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'750 West 800 North', N'Orem', N'UT', N'49049', N'84057', 40.312071, -111.713615, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5700, N'Cache Valley  Hospital', 1, NULL, NULL, N'460054', NULL, NULL, 0, 22, NULL, N'4357139700', N'4357139589', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2380 North 400 East', N'North Logan', N'UT', N'49005', N'84341', 41.775982, -111.823071, 3418, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5701, N'Park City Medical Center', 1, NULL, NULL, N'460057', NULL, NULL, 0, 30, NULL, N'4356586700', N'4356586739', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Round Valley Drive', N'Park City', N'UT', N'49043', N'84060', 40.68756, -111.467791, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5702, N'Riverton Hospital', 1, NULL, NULL, N'460058', NULL, NULL, 0, 48, NULL, N'8012854000', N'8012852025', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3741 West 12600 South', N'Riverton', N'UT', N'49035', N'84065', 40.522238, -111.979725, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5703, N'Lone Peak Hospital', 1, NULL, NULL, N'460060', NULL, NULL, 0, 30, NULL, N'8015458000', N'8015458009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11925 S State Street', N'Draper', N'UT', N'49035', N'84020', 40.534522, -111.891522, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5704, N'Delta Community Medical Center', 1, NULL, NULL, N'461300', NULL, NULL, 0, 20, NULL, N'4358645591', N'4358644186', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'126 South White Sage Avenue', N'Delta', N'UT', N'49027', N'84624', 39.350567, -112.559935, 3413, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5705, N'Fillmore Community Medical Center', 1, NULL, NULL, N'461301', NULL, NULL, 0, 19, NULL, N'4357435591', N'4357436312', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'674 South Highway 99', N'Fillmore', N'UT', N'49027', N'84631', 38.953575, -112.340232, 3414, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5706, N'Moab Regional Hospital', 1, NULL, NULL, N'461302', NULL, NULL, 0, 17, NULL, N'4357193501', N'4357193509', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'450 West Williams Way', N'Moab', N'UT', N'49019', N'84532', 38.574296, -109.560198, 3420, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5707, N'Sanpete Valley Hospital - Cah', 1, NULL, NULL, N'461303', NULL, NULL, 0, 18, NULL, N'4354624123', N'4354624637', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 South Medical Drive', N'Mount Pleasant', N'UT', N'49039', N'84647', 39.531757, -111.461243, 3423, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5708, N'Central Valley Medical Center - Cah', 1, NULL, NULL, N'461304', NULL, NULL, 0, 25, NULL, N'4356233000', N'4356233290', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'48 West 1500 North', N'Nephi', N'UT', N'49023', N'84648', 39.730611, -111.838497, 3424, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5709, N'Milford Valley Memorial Hospital', 1, NULL, NULL, N'461305', NULL, NULL, 0, 23, NULL, N'4353872411', N'4354386384', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 North Main Street', N'Milford', N'UT', N'49001', N'84751', 38.407308, -113.009543, 3419, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5710, N'Gunnison Valley Hospital', 1, NULL, NULL, N'461306', NULL, NULL, 0, 25, NULL, N'4355287246', N'4355282197', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'64 East 100 North', N'Gunnison', N'UT', N'49039', N'84634', 39.153646, -111.816289, 3415, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5711, N'Heber Valley Medical Center', 1, NULL, NULL, N'461307', NULL, NULL, 0, 19, NULL, N'4356542500', N'4356542576', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1485 South Highway 40', N'Heber City', N'UT', N'49051', N'84032', 40.489044, -111.409215, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5712, N'San Juan Hospital', 1, NULL, NULL, N'461308', NULL, NULL, 0, 25, NULL, N'4355872116', N'4355873004', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'380 West 100 North', N'Monticello', N'UT', N'49037', N'84535', 37.867075, -109.341109, 3421, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5713, N'Kane County Hospital', 1, NULL, NULL, N'461309', NULL, NULL, 0, 25, NULL, N'4356445811', N'4356443588', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'355 North Main Street', N'Kanab', N'UT', N'49025', N'84741', 37.054093, -112.528542, 3416, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5714, N'Blue Mountain Hospital', 1, NULL, NULL, N'461310', NULL, NULL, 0, 11, NULL, N'4356783993', N'4356783992', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'802 South 200 West', N'Blanding', N'UT', N'49037', N'84511', 37.614384, -109.474297, 3421, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5715, N'South Davis Community Hospital', 1, NULL, NULL, N'462003', NULL, NULL, 0, 39, NULL, N'8012952361', N'8012951398', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 South 400 East', N'Bountiful', N'UT', N'49011', N'84010', 40.885323, -111.872272, 3410, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5716, N'Promise Hospital Of Salt Lake', 1, NULL, NULL, N'462004', NULL, NULL, 0, 32, NULL, N'8014087100', N'8014087113', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8Th Avenue C Street', N'Salt Lake City', N'UT', N'49035', N'84143', 40.778499, -111.873058, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5717, N'Utah Valley Specialty Hospital', 1, NULL, NULL, N'462005', NULL, NULL, 0, 40, NULL, N'8012268880', N'8012268890', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 West River Bend Lane', N'Provo', N'UT', N'49049', N'84604', 40.233844, -111.658534, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5718, N'Landmark Hospital Of Salt Lake City Llc', 1, NULL, NULL, N'462006', NULL, NULL, 0, 38, NULL, N'8012685400', N'8012685452', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4252 S Birkhill Blvd', N'Murray', N'UT', N'49035', N'84107', 40.6795248, -111.8956133, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5719, N'Healthsouth Rehabilitation Hospital Of Utah', 1, NULL, NULL, N'463025', NULL, NULL, 0, 84, NULL, N'8015613400', N'8015656576', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8074 South 1300 East', N'Sandy', N'UT', N'49035', N'84094', 40.604645, -111.853225, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5720, N'Northern Utah Rehabilitation Hospital', 1, NULL, NULL, N'463027', NULL, NULL, 0, 40, NULL, N'8014755254', N'8014755259', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5825 Harrison Boulevard', N'South Ogden', N'UT', N'49057', N'84403', 41.191893, -111.971343, 3425, 277, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5721, N'Primary Childrens Hospital', 1, NULL, NULL, N'463301', NULL, NULL, 0, 232, NULL, N'8016626200', N'8016626202', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 North Mario Capecchi Drive', N'Salt Lake City', N'UT', N'49035', N'84113', 40.768675, -111.837136, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5722, N'Shriners Hospitals For Children - S L C', 1, NULL, NULL, N'463302', NULL, NULL, 0, 45, NULL, N'8015363500', N'8015363799', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Fairfax Road At Virginia Street', N'Salt Lake City', N'UT', N'49035', N'84103', 40.776665, -111.850834, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5723, N'Utah State Hospital', 1, NULL, NULL, N'464001', NULL, NULL, 0, 384, NULL, N'8013444200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 East Center Street', N'Provo', N'UT', N'49057', N'84605', 40.233472, -111.635524, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5724, N'University Of Utah Neuropsychiatric Institute', 1, NULL, NULL, N'464009', NULL, NULL, 0, 90, NULL, N'8015832500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Chipeta Way', N'Salt Lake City', N'UT', N'49035', N'84108', 40.758066, -111.823547, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5725, N'Marian Center', 1, NULL, NULL, N'464012', NULL, NULL, 0, 12, NULL, N'8014686856', N'8014686850', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'451 East Bishop Federal Lane', N'Salt Lake City', N'UT', N'49035', N'84115', 40.727941, -111.877286, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5726, N'Salt Lake Behavioral Health', 1, NULL, NULL, N'464013', NULL, NULL, 0, 118, NULL, N'8012646000', N'8012646070', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3802 South 700 East', N'Salt Lake City', N'UT', N'49035', N'84106', 40.725408, -111.871097, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5727, N'Provo Canyon Behavioral Hospital', 1, NULL, NULL, N'464014', NULL, NULL, 0, 80, NULL, N'8018522273', N'8012272199', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1350 East 750 North', N'Orem', N'UT', N'49049', N'84097', 40.311167, -111.664224, 3429, 278, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5728, N'Highland Ridge Hospital', 1, NULL, NULL, N'464015', NULL, NULL, 0, 41, NULL, N'8015692153', N'8015679006', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'7309 South 180 West', N'Midvale', N'UT', N'49035', N'84047', 40.618602, -111.89652, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5729, N'University Of Utah Hospital - Tc', 1, NULL, NULL, N'469810', NULL, NULL, 0, 0, NULL, N'8015812121', N'8015855280', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'50 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84132', 40.772592, -111.838627, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5730, N'Intermountain Medical Center', 1, NULL, NULL, N'469811', NULL, NULL, 0, 0, NULL, N'8015074060', N'8015074810', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'5121 South Cottonwood Street', N'Murray', N'UT', N'49035', N'84107', 40.666784, -111.888417, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5731, N'Primary Childrens Medical Center', 1, NULL, NULL, N'469812', NULL, NULL, 0, 0, NULL, N'8016626513', N'8016626202', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'100 North Medical Drive', N'Salt Lake City', N'UT', N'49035', N'84113', 40.773184, -111.837128, 3432, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5732, N'Central Vermont Medical Center', 1, NULL, NULL, N'470001', NULL, NULL, 0, 175, NULL, N'8023714100', N'8023714401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Box 547', N'Barre', N'VT', N'50023', N'05641', 44.197006, -72.502049, 3437, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5733, N'University Of Vermont Medical Center', 1, NULL, NULL, N'470003', NULL, NULL, 0, 615, NULL, N'8028470000', N'8028475252', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 Colchester Ave', N'Burlington', N'VT', N'50007', N'05401', 44.480794, -73.195971, 3439, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5734, N'Rutland Regional Medical Center', 1, NULL, NULL, N'470005', NULL, NULL, 0, 301, NULL, N'8027757111', N'8027471620', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'160 Allen St', N'Rutland', N'VT', N'50021', N'05701', 43.599193, -72.956122, 3444, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5735, N'Brattleboro Memorial Hospital', 1, NULL, NULL, N'470011', NULL, NULL, 0, 104, NULL, N'8022570341', N'8022578822', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17 Belmont Ave', N'Brattleboro', N'VT', N'50025', N'05301', 42.842272, -72.565723, 3438, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5736, N'Southwestern Vermont Medical Center', 1, NULL, NULL, N'470012', NULL, NULL, 0, 180, NULL, N'8024426361', N'8024428331', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hospital Drive', N'Bennington', N'VT', N'50003', N'05201', 42.873404, -73.206746, 3436, 185, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5737, N'Northwestern Medical Center Inc', 1, NULL, NULL, N'470024', NULL, NULL, 0, 70, NULL, N'8025245911', N'8025241238', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'133 Fairfield Street', N'Saint Albans', N'VT', N'50011', N'05478', 44.806802, -73.073446, 3446, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5738, N'Grace Cottage Hospital', 1, NULL, NULL, N'471300', NULL, NULL, 0, 19, NULL, N'8023657920', N'8023657031', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 216', N'Townshend', N'VT', N'50025', N'05353', 43.047301, -72.667593, 3448, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5739, N'Gifford Medical Center', 1, NULL, NULL, N'471301', NULL, NULL, 0, 25, NULL, N'8027284441', N'8027284245', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44 South Main Street', N'Randolph', N'VT', N'50017', N'05060', 43.916728, -72.665967, 3443, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5740, N'Mt Ascutney Hospital', 1, NULL, NULL, N'471302', NULL, NULL, 0, 25, NULL, N'8026746711', N'8026747155', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'289 County Road', N'Windsor', N'VT', N'50027', N'05089', 43.487522, -72.40091, 3449, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5741, N'Northeastern Vermont Regional Hospital', 1, NULL, NULL, N'471303', NULL, NULL, 0, 25, NULL, N'8027487400', N'8027487398', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1315 Hospital Drive', N'Saint Johnsbury', N'VT', N'50005', N'05819', 44.44526, -72.009438, 3447, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5742, N'North Country Hospital And Health Center', 1, NULL, NULL, N'471304', NULL, NULL, 0, 25, NULL, N'8023347331', N'8023343240', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'189 Prouty Drive', N'Newport', N'VT', N'50019', N'05855', 44.95464, -72.200855, 3442, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5743, N'Copley Hospital', 1, NULL, NULL, N'471305', NULL, NULL, 0, 25, NULL, N'8028884231', N'8028888223', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'528 Washington Highway', N'Morrisville', N'VT', N'50015', N'05661', 44.554191, -72.591365, 3441, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5744, N'Springfield Hospital', 1, NULL, NULL, N'471306', NULL, NULL, 0, 25, NULL, N'8028852151', N'8028853959', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 2003', N'Springfield', N'VT', N'50027', N'05156', 43.298408, -72.482312, 3445, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5745, N'Porter Hospital Inc', 1, NULL, NULL, N'471307', NULL, NULL, 0, 25, NULL, N'8023884701', N'8023884799', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'115 Porter Drive', N'Middlebury', N'VT', N'50001', N'05753', 43.999275, -73.169203, 3440, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5746, N'Brattleboro Retreat', 1, NULL, NULL, N'474001', NULL, NULL, 0, 149, NULL, N'8022577785', N'8022583791', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Anna Marsh Lane Po Box 803', N'Brattleboro', N'VT', N'50025', N'05301', 42.85833, -72.561788, 3438, 175, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5747, N'Vermont Psychiatric Care Hospital', 1, NULL, NULL, N'474004', NULL, NULL, 0, 25, NULL, N'8028886770', N'8028886799', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Fisher Road', N'Berlin', N'VT', N'50023', N'05602', 44.222576, -72.566348, 3437, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5748, N'University Of Vermont Medical  Center - Transplant', 1, NULL, NULL, N'479801', NULL, NULL, 0, 0, NULL, N'8028474771', N'8028473607', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'111 Colchester Avenue', N'Burlington', N'VT', N'50007', N'05401', 44.480616, -73.197268, 3439, 280, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5749, N'Norton Community Hospital', 1, NULL, NULL, N'490001', NULL, NULL, 0, 129, NULL, N'7036798865', N'2766799664', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100  15Th Nw Street', N'Norton', N'VA', N'51720', N'24273', 36.932011, -82.643249, 3488, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5750, N'Russell County Medical Center', 1, NULL, NULL, N'490002', NULL, NULL, 0, 78, NULL, N'2768838100', N'2768894336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'58 Carroll Street', N'Lebanon', N'VA', N'51167', N'24266', 36.900908, -82.080126, 3476, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5751, N'Sentara Rmh Medical Center', 1, NULL, NULL, N'490004', NULL, NULL, 0, 238, NULL, N'5406891000', N'5406891220', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2010 Health Campus Drive', N'Harrisonburg', N'VA', N'51660', N'22801', 38.406143, -78.85832, 3472, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5752, N'Winchester Medical Center', 1, NULL, NULL, N'490005', NULL, NULL, 0, 399, NULL, N'5405368000', N'5405367847', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1840 Amherst St', N'Winchester', N'VA', N'51840', N'22601', 39.191594, -78.193138, 3511, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5753, N'Sentara Norfolk General Hospital', 1, NULL, NULL, N'490007', NULL, NULL, 0, 525, NULL, N'7573883000', N'7573884319', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Gresham Dr', N'Norfolk', N'VA', N'51710', N'23507', 36.863435, -76.304268, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5754, N'University Of Virginia Medical Center', 1, NULL, NULL, N'490009', NULL, NULL, 0, 622, NULL, N'8002513627', N'4349823759', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Jefferson Park Ave', N'Charlottesville', N'VA', N'51540', N'22908', 38.028106, -78.510718, 3456, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5755, N'Bon Secours Depaul Medical Center', 1, NULL, NULL, N'490011', NULL, NULL, 0, 204, NULL, N'7578895000', N'7578895837', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Kingsley Lane', N'Norfolk', N'VA', N'51710', N'23505', 36.898116, -76.280788, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5756, N'Sentara Halifax Regional Hospital', 1, NULL, NULL, N'490013', NULL, NULL, 0, 192, NULL, N'4345173100', N'4345173626', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2204 Wilborn Avenue', N'Halifax', N'VA', N'51083', N'24558', 36.713695, -78.913302, 3501, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5757, N'Bon Secours Maryview Medical Center', 1, NULL, NULL, N'490017', NULL, NULL, 0, 346, NULL, N'7573982200', N'7573982359', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3636 High Street', N'Portsmouth', N'VA', N'51740', N'23707', 36.836213, -76.348368, 3492, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5758, N'Augusta Health', 1, NULL, NULL, N'490018', NULL, NULL, 0, 255, NULL, N'5409324000', N'5409324809', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'78 Medical Center Drive', N'Fishersville', N'VA', N'51015', N'22939', 38.092979, -78.986818, 3503, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5759, N'Culpeper Community Hospital', 1, NULL, NULL, N'490019', NULL, NULL, 0, 70, NULL, N'5408294100', N'5408294353', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Sunset Lane', N'Culpeper', N'VA', N'51047', N'22701', 38.456379, -78.012415, 3459, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5760, N'John Randolph Medical Center', 1, NULL, NULL, N'490020', NULL, NULL, 0, 147, NULL, N'8045411600', N'8044523346', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 West Randolph Road', N'Hopewell', N'VA', N'51670', N'23860', 37.306863, -77.291153, 3473, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5761, N'Centra  Health Inc', 1, NULL, NULL, N'490021', NULL, NULL, 0, 161, NULL, N'4342004789', N'4342004706', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1901 Tate Springs Road', N'Lynchburg', N'VA', N'51680', N'24501', 37.413946, -79.169688, 3481, 283, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5762, N'Mary Washington Hospital Inc', 1, NULL, NULL, N'490022', NULL, NULL, 0, 437, NULL, N'5407411100', N'5407411097', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Sam Perry Boulevard', N'Fredericksburg', N'VA', N'51630', N'22401', 38.311983, -77.481077, 3466, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5763, N'Fauquier Hospital', 1, NULL, NULL, N'490023', NULL, NULL, 0, 97, NULL, N'5403165000', N'5403165001', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Hospital Drive', N'Warrenton', N'VA', N'51061', N'20186', 38.714858, -77.808307, 3509, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5764, N'Carilion Roanoke Memorial Hospital', 1, NULL, NULL, N'490024', NULL, NULL, 0, 703, NULL, N'5409817000', N'5409817862', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1906 Belleview Avenue Se', N'Roanoke', N'VA', N'51770', N'24014', 37.270973, -79.941431, 3498, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5765, N'Medical College Of Virginia Hospitals', 1, NULL, NULL, N'490032', NULL, NULL, 0, 779, NULL, N'8048280938', N'8048281657', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1250 East Marshall Street - Box 980510', N'Richmond', N'VA', N'51760', N'23298', 37.539753, -77.429882, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5766, N'Warren Memorial Hospital', 1, NULL, NULL, N'490033', NULL, NULL, 0, 196, NULL, N'7036360300', N'5406360258', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 North Shenandoah Ave', N'Front Royal', N'VA', N'51187', N'22630', 38.930752, -78.198965, 3467, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5767, N'Riverside Shore Memorial Hospital', 1, NULL, NULL, N'490037', NULL, NULL, 0, 143, NULL, N'7574148000', N'7574148566', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9507 Hospital Avenue', N'Nassawadox', N'VA', N'51131', N'23413', 37.474044, -75.864579, 3485, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5768, N'Smyth County Community Hospital', 1, NULL, NULL, N'490038', NULL, NULL, 0, 170, NULL, N'2763781000', N'2767821436', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Medical Park Drive', N'Marion', N'VA', N'51173', N'24354', 36.834838, -81.514837, 3483, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5769, N'Inova Alexandria Hospital', 1, NULL, NULL, N'490040', NULL, NULL, 0, 318, NULL, N'7035043167', N'7035043700', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4320 Seminary Rd', N'Alexandria', N'VA', N'51510', N'22304', 38.824128, -77.104437, 3451, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5770, N'Mary Immaculate Hospital', 1, NULL, NULL, N'490041', NULL, NULL, 0, 110, NULL, N'7578866000', N'7578866751', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2 Bernardine Drive', N'Newport News', N'VA', N'51700', N'23602', 37.145055, -76.511657, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5771, N'Carilion New River Valley Medical Center', 1, NULL, NULL, N'490042', NULL, NULL, 0, 146, NULL, N'5407312000', N'5407312505', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 Lamb Circle', N'Christiansburg', N'VA', N'51121', N'24073', 37.088634, -80.50514, 3455, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5772, N'Inova Loudoun Hospital', 1, NULL, NULL, N'490043', NULL, NULL, 0, 183, NULL, N'7038586600', N'7038586610', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'44045 Riverside Parkway', N'Leesburg', N'VA', N'51107', N'20176', 39.074609, -77.475227, 3477, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5773, N'Sentara Obici Hospital', 1, NULL, NULL, N'490044', NULL, NULL, 0, 168, NULL, N'7579344000', N'7579344284', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2800 dwin Boulevard', N'Suffolk', N'VA', N'51800', N'23439', 36.773058, -76.583413, 3505, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5774, N'Novant Health Prince William Medical Center', 1, NULL, NULL, N'490045', NULL, NULL, 0, 170, NULL, N'7033698000', N'7033698010', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8700 Sudley Rd', N'Manassas', N'VA', N'51683', N'20110', 38.767458, -77.484936, 3482, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5775, N'Sentara Leigh Hospital', 1, NULL, NULL, N'490046', NULL, NULL, 0, 250, NULL, N'7572616601', N'7574616796', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'830 Kempsville Road', N'Norfolk', N'VA', N'51710', N'23502', 36.850441, -76.191654, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5776, N'Lewisgale Medical Center', 1, NULL, NULL, N'490048', NULL, NULL, 0, 506, NULL, N'5407764000', N'5407764785', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1900 Electric Road', N'Salem', N'VA', N'51775', N'24153', 37.263837, -80.033316, 3500, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5777, N'Virginia Hospital Center', 1, NULL, NULL, N'490050', NULL, NULL, 0, 342, NULL, N'7035585000', N'7035586583', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 North George Mason Drive', N'Arlington', N'VA', N'51013', N'22205', 38.889961, -77.128857, 3452, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5778, N'Riverside Regional Medical Center', 1, NULL, NULL, N'490052', NULL, NULL, 0, 510, NULL, N'7575942000', N'7575942084', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 J Clyde Morris Blvd', N'Newport News', N'VA', N'51700', N'23601', 37.06389, -76.4854, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5779, N'Johnston Memorial Hospital', 1, NULL, NULL, N'490053', NULL, NULL, 0, 116, NULL, N'2762581000', N'2762582805', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16000 Johnston Memorial Drive', N'Abingdon', N'VA', N'51191', N'24211', 36.72067, -81.90856, 3450, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5780, N'Sentara Virginia Beach General Hospital', 1, NULL, NULL, N'490057', NULL, NULL, 0, 276, NULL, N'7573958000', N'7573956106', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1060 First Colonial Road', N'Virginia Beach', N'VA', N'51810', N'23454', 36.864366, -76.02844, 3508, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5781, N'Bon Secours St Marys Hospital', 1, NULL, NULL, N'490059', NULL, NULL, 0, 391, NULL, N'8042852011', N'8042858327', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5801 Bremo Rd', N'Richmond', N'VA', N'51087', N'23226', 37.58512, -77.512525, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5782, N'Clinch Valley Medical Center', 1, NULL, NULL, N'490060', NULL, NULL, 0, 175, NULL, N'2765966000', N'2765966009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2949 West Front Street', N'Richlands', N'VA', N'51185', N'24641', 37.092442, -81.811633, 3496, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5783, N'Inova Fairfax Hospital', 1, NULL, NULL, N'490063', NULL, NULL, 0, 833, NULL, N'7037763332', N'7037763623', 1, 0, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8110 Gatehouse Road 400 West', N'Falls Church', N'VA', N'51059', N'22042', 38.86893, -77.22442, 3463, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5784, N'Sentara Williamsburg Regional Medical Center', 1, NULL, NULL, N'490066', NULL, NULL, 0, 145, NULL, N'7579846000', N'7579848145', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Sentara Circle', N'Williamsburg', N'VA', N'51095', N'23188', 37.337968, -76.739315, 3510, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5785, N'Southside Regional Medical Center', 1, NULL, NULL, N'490067', NULL, NULL, 0, 300, NULL, N'8047655000', N'8047655948', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Medical Park Boulevard', N'Petersburg', N'VA', N'51730', N'23805', 37.183654, -77.361466, 3491, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5786, N'Bon Secours Memorial Regional Medical Center', 1, NULL, NULL, N'490069', NULL, NULL, 0, 225, NULL, N'8047646000', N'8047646420', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8260 Atlee Road', N'Mechanicsville', N'VA', N'51085', N'23116', 37.630307, -77.387882, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5787, N'Danville Regional Medical Center', 1, NULL, NULL, N'490075', NULL, NULL, 0, 250, NULL, N'4347992100', N'4347992260', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'142 South Main Street', N'Danville', N'VA', N'51590', N'24541', 36.577337, -79.40468, 3460, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5788, N'Martha Jefferson Hospital', 1, NULL, NULL, N'490077', NULL, NULL, 0, 176, NULL, N'4346547000', N'4346547324', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Martha Jefferson Drive', N'Charlottesville', N'VA', N'51003', N'22911', 38.021772, -78.442233, 3456, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5789, N'Memorial Hospital Of Martinsville & Henry County', 1, NULL, NULL, N'490079', NULL, NULL, 0, 220, NULL, N'2766667200', N'2766667600', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'320 Hospital Drive', N'Martinsville', N'VA', N'51089', N'24115', 36.699413, -79.865988, 3484, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5790, N'Riverside Tappahannock Hospital', 1, NULL, NULL, N'490084', NULL, NULL, 0, 67, NULL, N'8044436189', N'8044436150', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'618 Hospital Road', N'Tappahannock', N'VA', N'51057', N'22560', 37.899446, -76.875577, 3506, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5791, N'Bedford Memorial Hospital', 1, NULL, NULL, N'490088', NULL, NULL, 0, 161, NULL, N'4342006366', N'4342004763', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1613 Oakwood Street', N'Bedford', N'VA', N'51515', N'24523', 37.351488, -79.516427, 3453, 283, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5792, N'Carilion Franklin Memorial Hospital', 1, NULL, NULL, N'490089', NULL, NULL, 0, 37, NULL, N'5404835277', N'5404836479', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'180 Floyd Avenue', N'Rocky Mount', N'VA', N'51067', N'24151', 36.994583, -79.889771, 3499, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5793, N'Southside Community Hospital Inc', 1, NULL, NULL, N'490090', NULL, NULL, 0, 116, NULL, N'4343928811', N'4343927654', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Oak Street', N'Farmville', N'VA', N'51147', N'23901', 37.302996, -78.402486, 3464, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5794, N'Southampton Memorial Hospital', 1, NULL, NULL, N'490092', NULL, NULL, 0, 221, NULL, N'7575696100', N'7575696390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Fairview Drive - Po Box 817', N'Franklin', N'VA', N'51620', N'23851', 36.691171, -76.934942, 3465, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5795, N'Sentara Careplex Hospital', 1, NULL, NULL, N'490093', NULL, NULL, 0, 224, NULL, N'7577361000', N'7577362659', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3000 Coliseum Drive', N'Hampton', N'VA', N'51650', N'23666', 37.056375, -76.392354, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5796, N'Bon Secours Richmond Community Hospital', 1, NULL, NULL, N'490094', NULL, NULL, 0, 104, NULL, N'8042251700', N'8042251725', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 N. 28Th Street', N'Richmond', N'VA', N'51760', N'23223', 37.540265, -77.40627, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5797, N'Southern Virginia Regional Medical Center', 1, NULL, NULL, N'490097', NULL, NULL, 0, 80, NULL, N'4343484400', N'4343484933', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'727 North Main Street', N'Emporia', N'VA', N'51595', N'23847', 36.701534, -77.535969, 3461, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5798, N'Community Memorial Healthcenter Inc', 1, NULL, NULL, N'490098', NULL, NULL, 0, 260, NULL, N'4344473151', N'4347742401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Buena Vista Circle', N'South Hill', N'VA', N'51117', N'23970', 36.733994, -78.132758, 3502, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5799, N'Inova Fair Oaks Hospital', 1, NULL, NULL, N'490101', NULL, NULL, 0, 182, NULL, N'7033914170', N'7033914116', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3600 Joseph Siewick Drive', N'Fairfax', N'VA', N'51059', N'22033', 38.884731, -77.379027, 3462, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5800, N'Hiram W Davis Medical Center', 1, NULL, NULL, N'490104', NULL, NULL, 0, 10, NULL, N'8045247344', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 4030', N'Petersburg', N'VA', N'51730', N'23803', 38.909278, -78.053331, 3491, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5801, N'Reston Hospital Center', 1, NULL, NULL, N'490107', NULL, NULL, 0, 187, NULL, N'7036899000', N'7036890840', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1850 Town Center Parkway', N'Reston', N'VA', N'51059', N'20190', 38.961925, -77.362633, 3495, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5802, N'Central Virginia Training Center', 1, NULL, NULL, N'490108', NULL, NULL, 0, 46, NULL, N'4349476000', NULL, 1, 0, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 1098', N'Lynchburg', N'VA', N'51680', N'24505', 37.413754, -79.142246, 3481, 283, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5803, N'Lewisgale Hospital Montmery', 1, NULL, NULL, N'490110', NULL, NULL, 0, 146, NULL, N'5409511111', N'5409535295', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3700 South Main Street', N'Blacksburg', N'VA', N'51121', N'24060', 37.18597, -80.408388, 3455, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5804, N'Wythe County Community Hospital', 1, NULL, NULL, N'490111', NULL, NULL, 0, 100, NULL, N'2762280200', N'2762280397', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 West Ridge Road', N'Wytheville', N'VA', N'51197', N'24382', 36.953247, -81.095288, 3514, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5805, N'Cjw Medical Center', 1, NULL, NULL, N'490112', NULL, NULL, 0, 758, NULL, N'8043302001', N'8043302313', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7101 Jahnke Road', N'Richmond', N'VA', N'51041', N'23235', 37.515832, -77.52488, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5806, N'Sentara Northern Virginia Medical Center', 1, NULL, NULL, N'490113', NULL, NULL, 0, 183, NULL, N'7035231000', N'7036707643', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Opitz Boulevard', N'Woodbridge', N'VA', N'51153', N'22191', 38.634477, -77.283105, 3512, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5807, N'Wellmont Lonesome Pine Hospital', 1, NULL, NULL, N'490114', NULL, NULL, 0, 60, NULL, N'2765233111', N'2765238726', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1990 Holton Avenue East', N'Big Stone Gap', N'VA', N'51195', N'24219', 36.876448, -82.757355, 3454, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5808, N'Twin County Regional Hospital', 1, NULL, NULL, N'490115', NULL, NULL, 0, 141, NULL, N'2762368181', N'2762361715', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Galax', N'VA', N'51640', N'24333', 36.672471, -80.921363, 3468, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5809, N'Lewisgale Hospital Pulaski', 1, NULL, NULL, N'490116', NULL, NULL, 0, 147, NULL, N'5409948100', N'5409948333', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 Lee Highway', N'Pulaski', N'VA', N'51155', N'24301', 37.069306, -80.758003, 3493, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5810, N'Carilion Tazewell Community Hospital', 1, NULL, NULL, N'490117', NULL, NULL, 0, 238, NULL, N'2769888700', N'2769886239', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'141 Ben Bolt Avenue', N'Tazewell', N'VA', N'51185', N'24651', 37.125922, -81.489825, 3507, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5811, N'Henrico Doctors'' Hospital', 1, NULL, NULL, N'490118', NULL, NULL, 0, 340, NULL, N'8042894500', N'8042894801', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1602 Skipwith Road', N'Richmond', N'VA', N'51087', N'23229', 37.603156, -77.537702, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5812, N'Sentara Princess Anne Hospital', 1, NULL, NULL, N'490119', NULL, NULL, 0, 160, NULL, N'7575071520', N'7577163954', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2025 Glenn Mitchell Drive', N'Virginia Beach', N'VA', N'51810', N'23456', 36.775912, -76.097591, 3508, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5813, N'Chesapeake General Hospital', 1, NULL, NULL, N'490120', NULL, NULL, 0, 310, NULL, N'7573128121', N'7573126300', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'736 Battlefield Blvd North', N'Chesapeake', N'VA', N'51550', N'23320', 36.746111, -76.244828, 3457, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5814, N'Inova Mount Vernon Hospital', 1, NULL, NULL, N'490122', NULL, NULL, 0, 237, NULL, N'7036647000', N'7036647235', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2501 Parkers Lane', N'Alexandria', N'VA', N'51059', N'22306', 38.739647, -77.074397, 3451, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5815, N'Rappahannock General Hospital', 1, NULL, NULL, N'490123', NULL, NULL, 0, 76, NULL, N'8044358000', N'8044358543', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Harris Road', N'Kilmarnock', N'VA', N'51103', N'22482', 37.700643, -76.389817, 3475, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5816, N'Lewisgale Hospital Alleghany', 1, NULL, NULL, N'490126', NULL, NULL, 0, 205, NULL, N'5408626011', N'5408626589', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One Arh Lane - Po Box 7', N'Low Moor', N'VA', N'51005', N'24457', 37.788738, -79.883664, 3479, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5817, N'Buchanan General Hospital', 1, NULL, NULL, N'490127', NULL, NULL, 0, 134, NULL, N'2769351000', N'2769354959', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1535 Slate Creek Road', N'Grundy', N'VA', N'51027', N'24614', 37.285506, -82.067817, 3470, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5818, N'Capital Hospice', 1, NULL, NULL, N'490129', NULL, NULL, 0, 15, NULL, N'7035257070', N'7035254127', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4715 North 15 Street', N'Arlington', N'VA', N'51013', N'22205', 38.890396, -77.084158, 3452, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5819, N'Riverside Walter Reed Hospital', 1, NULL, NULL, N'490130', NULL, NULL, 0, 67, NULL, N'8046938800', N'7576938812', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7519 Hospital Road', N'Gloucester', N'VA', N'51073', N'23061', 37.420016, -76.543655, 3469, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5820, N'Bon Secours St Francis Medical Center', 1, NULL, NULL, N'490136', NULL, NULL, 0, 130, NULL, N'8045947400', N'8045947410', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13710 St Francis Boulevard', N'Midlothian', N'VA', N'51041', N'23114', 37.466478, -77.659026, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5821, N'Stafford Hospital Llc', 1, NULL, NULL, N'490140', NULL, NULL, 0, 100, NULL, N'5407419000', N'5407411097', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 Hospital Center Boulevard Suite 307', N'Stafford', N'VA', N'51179', N'22554', 38.414103, -77.40664, 3466, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5822, N'Spotsylvania Regional Medical Center', 1, NULL, NULL, N'490141', NULL, NULL, 0, 126, NULL, N'5404984000', N'5404984066', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 Spotsylvania Parkway', N'Fredericksburg', N'VA', N'51177', N'22408', 38.219496, -77.49645, 3466, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5823, N'Riverside Doctors'' Hospital Of Williamsburg', 1, NULL, NULL, N'490143', NULL, NULL, 0, 40, NULL, N'7573453000', N'7573450138', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1500 Commonwealth Avenue', N'Williamsburg', N'VA', N'51095', N'23185', 37.251622, -76.666875, 3510, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5824, N'Novant Health Haymarket Medical Center', 1, NULL, NULL, N'490144', NULL, NULL, 0, 60, NULL, N'5712841000', N'5712841009', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'15225 Healthcote Boulevard', N'Haymarket', N'VA', N'51153', N'20169', 38.812101, -77.636677, 3482, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5825, N'Bath Community Hospital', 1, NULL, NULL, N'491300', NULL, NULL, 0, 25, NULL, N'5408397137', N'5408397088', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'106 Park Drive- Po Drawer Z', N'Hot Springs', N'VA', N'51017', N'24445', 37.99957, -79.831719, 3474, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5826, N'Carilion Giles Community Hospital', 1, NULL, NULL, N'491302', NULL, NULL, 0, 25, NULL, N'5409216000', N'5409215606', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'159 Hartley Way', N'Pearisburg', N'VA', N'51071', N'24134', 37.326511, -80.735071, 3489, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5827, N'Dickenson Community Hospital', 1, NULL, NULL, N'491303', NULL, NULL, 0, 25, NULL, N'2769260300', N'2769260329', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'312 Hospital Drive', N'Clintwood', N'VA', N'51051', N'24228', 37.162595, -82.451973, 3458, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5828, N'Carilion Stonewall Jackson Hospital', 1, NULL, NULL, N'491304', NULL, NULL, 0, 25, NULL, N'5404583503', N'5404583535', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Health Circle', N'Lexington', N'VA', N'51678', N'24450', 37.779441, -79.442816, 3478, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5829, N'Shenandoah Memorial Hospital', 1, NULL, NULL, N'491305', NULL, NULL, 0, 25, NULL, N'5404591100', N'5404591121', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'759 South Main Street', N'Woodstock', N'VA', N'51171', N'22664', 38.871341, -78.514166, 3513, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5830, N'Pioneer Health Services Of Patrick Countyinc', 1, NULL, NULL, N'491306', NULL, NULL, 0, 25, NULL, N'2766943151', N'2766948655', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18688 Jeb Stuart Highway', N'Stuart', N'VA', N'51141', N'24171', 36.675475, -80.27834, 3504, 203, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5831, N'Page Memorial Hospital Inc', 1, NULL, NULL, N'491307', NULL, NULL, 0, 25, NULL, N'5407434561', N'5407436825', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Memorial Drive', N'Luray', N'VA', N'51139', N'22835', 38.66394, -78.469548, 3480, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5832, N'Lynn House Of Potomac Valley', 1, NULL, NULL, N'491991', NULL, NULL, 0, 16, NULL, N'7033796000', N'7036718897', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4400 West Braddock Road', N'Alexandria', N'VA', N'51510', N'22304', 38.829724, -77.104779, 3451, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5833, N'Lake Taylor Transitional Care Hospital', 1, NULL, NULL, N'492001', NULL, NULL, 0, 296, NULL, N'7574615001', N'7574614282', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1309 Kempsville Road', N'Norfolk', N'VA', N'51710', N'23502', 36.847987, -76.191138, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5834, N'Hospital For Extended Recovery', 1, NULL, NULL, N'492007', NULL, NULL, 0, 35, NULL, N'7573881700', N'7573881371', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Gresham Drive Suite 700', N'Norfolk', N'VA', N'51710', N'23507', 36.862304, -76.303342, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5835, N'Hampton Roads Specialty Hospital', 1, NULL, NULL, N'492008', NULL, NULL, 0, 25, NULL, N'7575345000', N'7579288271', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Chesapeake Avenue', N'Newport News', N'VA', N'51700', N'23607', 36.986073, -76.392816, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5836, N'Vibra Hospital Of Richmond', 1, NULL, NULL, N'492009', NULL, NULL, 0, 60, NULL, N'8046787000', N'8042541972', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2220 Edward Holland Drive', N'Richmond', N'VA', N'51087', N'23230', 37.58955, -77.490113, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5837, N'Centra Specialty Hospital', 1, NULL, NULL, N'492010', NULL, NULL, 0, 36, NULL, N'4342001960', N'4342001980', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3300 Rivermont Avenue  Krise Building 5Th Floor', N'Lynchburg', N'VA', N'51680', N'24503', 37.439325, -79.188976, 3481, 283, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5838, N'Uva Health Sciences Center', 1, NULL, NULL, N'492011', NULL, NULL, 0, 10, NULL, N'4349247897', N'4349242078', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2965 Ivy Road', N'Charlottesville', N'VA', N'51540', N'22908', 38.040664, -78.508174, 3456, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5839, N'Sheltering Arms Hospital', 1, NULL, NULL, N'493025', NULL, NULL, 0, 40, NULL, N'8043424320', N'8043424316', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8254 Atlee Road', N'Mechanicsville', N'VA', N'51085', N'23116', 37.62752, -77.388659, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5840, N'Riverside Rehabilitation Institute', 1, NULL, NULL, N'493027', NULL, NULL, 0, 50, NULL, N'7579288100', N'7579288108', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'245 Chesapeake Avenue', N'Newport News', N'VA', N'51700', N'23607', 36.986073, -76.392816, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5841, N'Healthsouth Rehabilitation Hospital Of Virginia', 1, NULL, NULL, N'493028', NULL, NULL, 0, 40, NULL, N'8042885700', N'8042886713', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5700 Fitzhugh Avenue', N'Richmond', N'VA', N'51087', N'23226', 37.592255, -77.518827, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5842, N'University Of Virginia - Healthsouth Llc', 1, NULL, NULL, N'493029', NULL, NULL, 0, 50, NULL, N'4342442000', N'4342442001', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'515 Ray C Hunt Drive', N'Charlottesville', N'VA', N'51540', N'22903', 38.0239112, -78.5272697, 3456, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5843, N'Sheltering Arms Hospital South', 1, NULL, NULL, N'493030', NULL, NULL, 0, 28, NULL, N'8043424320', N'8043424316', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13700 Saint Francis Blvd Suite 400', N'Midlothian', N'VA', N'51041', N'23114', 37.506267, -77.649268, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5844, N'Healthsouth Rehabilitation Hospital Of Petersburg', 1, NULL, NULL, N'493031', NULL, NULL, 0, 64, NULL, N'8045048100', N'8045048101', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'95 Medical Park Blvd', N'Petersburg', N'VA', N'51730', N'23805', 37.183411, -77.361925, 3491, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5845, N'Healthsouth Rehabilitation Hospital Of Fredericks', 1, NULL, NULL, N'493032', NULL, NULL, 0, 52, NULL, N'5403687300', N'5403687596', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Park Hill Drive', N'Fredericksburg', N'VA', N'51630', N'22401', 38.313126, -77.486456, 3466, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5846, N'Healthsouth Rehabilitation Hospital Of Northern Va', 1, NULL, NULL, N'493033', NULL, NULL, 0, 55, NULL, N'7039572000', N'7039572394', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24430 Millstream Drive', N'Aldie', N'VA', N'51107', N'20105', 38.975806, -77.64284, 3477, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5847, N'The Rehabilitation Hospital Of Southwest Va', 1, NULL, NULL, N'493034', NULL, NULL, 0, 25, NULL, N'2766427900', N'2766428094', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'103 North Street', N'Bristol', N'VA', N'51520', N'24201', 36.596516, -82.216868, 3118, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5848, N'Cumberland Hospital Llc', 1, NULL, NULL, N'493300', NULL, NULL, 0, 94, NULL, N'8049662242', N'8049665639', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9407 Cumberland Road', N'New Kent', N'VA', N'51127', N'23124', 37.536952, -76.979492, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5849, N'Childrens Hospital Of The Kings Daughters Inc', 1, NULL, NULL, N'493301', NULL, NULL, 0, 206, NULL, N'7576687000', N'7576689450', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Children''s Lane', N'Norfolk', N'VA', N'51710', N'23507', 36.846288, -76.292925, 3487, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5850, N'Children''s Hosp Of Richmond Of The Vcu Health Sys', 1, NULL, NULL, N'493302', NULL, NULL, 0, 60, NULL, N'8043217474', N'8043212728', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2924 Brook Road', N'Richmond', N'VA', N'51760', N'23220', 37.570712, -77.449336, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5851, N'Riverside Behaviorial Health Center', 1, NULL, NULL, N'494001', NULL, NULL, 0, 125, NULL, N'7578271001', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2244 Executive Drive', N'Hampton', N'VA', N'51650', N'23666', 37.053838, -76.39527, 3486, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5852, N'Northern Virginia Mental Health Insti', 1, NULL, NULL, N'494010', NULL, NULL, 0, 129, NULL, N'7032077100', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3302 Gallows Rd', N'Falls Church', N'VA', N'51059', N'22042', 38.882334, -77.171091, 3463, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5853, N'Southern Virginia Mental Health Institute', 1, NULL, NULL, N'494017', NULL, NULL, 0, 96, NULL, N'4347996220', N'4347734274', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'382 Taylor Drive', N'Danville', N'VA', N'51590', N'24541', 36.555728, -79.410547, 3460, 197, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5854, N'Western State Hospital', 1, NULL, NULL, N'494021', NULL, NULL, 0, 246, NULL, N'5403328000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1301 Richmond Road', N'Staunton', N'VA', N'51790', N'24402', 38.14935, -79.071646, 3503, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5855, N'Poplar Springs Hospital', 1, NULL, NULL, N'494022', NULL, NULL, 0, 130, NULL, N'8047336874', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'350 Poplar Drive  Po Box 3060', N'Petersburg', N'VA', N'51730', N'23805', 37.189214, -77.361475, 3491, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5856, N'Dominion Hospital', 1, NULL, NULL, N'494023', NULL, NULL, 0, 100, NULL, N'7035362000', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2960 Sleepy Hollow Road', N'Falls Church', N'VA', N'51059', N'22044', 38.882334, -77.171091, 3452, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5857, N'Virginia Beach Psychiatric Center', 1, NULL, NULL, N'494025', NULL, NULL, 0, 100, NULL, N'7574966000', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 First Colonial Road', N'Virginia Beach', N'VA', N'51810', N'23454', 36.866252, -76.028561, 3508, 285, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5858, N'Southwestern Virginia Mental Health Institute', 1, NULL, NULL, N'494029', NULL, NULL, 0, 109, NULL, N'2767831200', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'340 Bagley Circle', N'Marion', N'VA', N'51173', N'24354', 36.833734, -81.512147, 3483, 251, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5859, N'Eastern State Hospital', 1, NULL, NULL, N'494030', NULL, NULL, 0, 302, NULL, N'7572535241', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4601 Ironbound Road', N'Williamsburg', N'VA', N'51830', N'23187', 37.290537, -76.725778, 3510, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5860, N'The Pavilion At Williamsburg Place', 1, NULL, NULL, N'494032', NULL, NULL, 0, 57, NULL, N'7579416400', N'7579416419', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5483 Mooretown Road', N'Williamsburg', N'VA', N'51095', N'23188', 37.270703, -76.70745, 3510, 284, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5861, N'Inova Fairfax Hospital', 1, NULL, NULL, N'499801', NULL, NULL, 0, 0, NULL, N'7039702600', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3300 Gallows Road', N'Falls Church', N'VA', N'51059', N'22042', 38.882334, -77.171091, 3463, 281, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5862, N'University Of Virginia Health System', 1, NULL, NULL, N'499802', NULL, NULL, 0, 0, NULL, N'4342439308', N'4342439328', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1215 Less Street Po Box 800265', N'Charlottesville', N'VA', N'51540', N'22908', 39.536162, -84.853012, 3456, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5863, N'Henrico Doctors Hospital - Transplant', 1, NULL, NULL, N'499804', NULL, NULL, 0, 0, NULL, N'8042894800', N'8042894801', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1602 Skipwith Road', N'Richmond', N'VA', N'51087', N'23229', 37.602086, -77.537818, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5864, N'Medical College Of Virginia', 1, NULL, NULL, N'499805', NULL, NULL, 0, 0, NULL, N'8046282430', N'8048289371', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1200 E Broad Street Po Box 980510', N'Richmond', N'VA', N'51760', N'23298', 37.53803, -77.429182, 3497, 286, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5865, N'Northwest Hospital', 1, NULL, NULL, N'500001', NULL, NULL, 0, 194, NULL, N'2063681700', N'2063681949', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1550 North 115Th Street', N'Seattle', N'WA', N'53033', N'98133', 47.712261, -122.335522, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5866, N'Providence St Mary Medical Center', 1, NULL, NULL, N'500002', NULL, NULL, 0, 146, NULL, N'5095225900', N'5095225789', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Poplar St', N'Walla Walla', N'WA', N'53071', N'99362', 46.063771, -118.341053, 3570, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5867, N'Skagit Valley Hospital', 1, NULL, NULL, N'500003', NULL, NULL, 0, 234, NULL, N'3604244111', N'3604282459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1415 Kincaid Street', N'Mount Vernon', N'WA', N'53057', N'98274', 48.417415, -122.323914, 3547, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5868, N'Virginia Mason Medical Center', 1, NULL, NULL, N'500005', NULL, NULL, 0, 336, NULL, N'2062236867', N'2062237540', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'925 Seneca St', N'Seattle', N'WA', N'53033', N'98101', 47.610176, -122.327819, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5869, N'Island Hospital', 1, NULL, NULL, N'500007', NULL, NULL, 0, 43, NULL, N'3602991300', N'3602991339', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1211  24Th Street', N'Anacortes', N'WA', N'53057', N'98221', 48.502816, -122.616702, 3516, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5870, N'University Of Washington Medical Ctr', 1, NULL, NULL, N'500008', NULL, NULL, 0, 450, NULL, N'2065983300', N'2065986364', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1959 Ne Pacific St  Box 356151', N'Seattle', N'WA', N'53033', N'98195', 47.65064, -122.307742, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5871, N'Highline Medical Center', 1, NULL, NULL, N'500011', NULL, NULL, 0, 279, NULL, N'2062449970', N'2062465385', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16251 Sylvester Road Sw', N'Burien', N'WA', N'53033', N'98166', 47.456585, -122.341623, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5872, N'Yakima Regional Medical And Cardiac Center', 1, NULL, NULL, N'500012', NULL, NULL, 0, 125, NULL, N'5095755102', N'5094546193', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 South Ninth Ave', N'Yakima', N'WA', N'53077', N'98902', 46.597628, -120.520919, 3573, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5873, N'Providence Regional Medical Center Everett', 1, NULL, NULL, N'500014', NULL, NULL, 0, 268, NULL, N'4252612000', N'4252614051', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1321 Colby Avenue', N'Everett', N'WA', N'53061', N'98201', 48.000086, -122.207979, 3535, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5874, N'Multicare Auburn Medical Center', 1, NULL, NULL, N'500015', NULL, NULL, 0, 195, NULL, N'2538337711', N'2539392376', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 North Division Street Plaza One', N'Auburn', N'WA', N'53033', N'98001', 47.308978, -122.229699, 3518, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5875, N'Central Washington Hospital', 1, NULL, NULL, N'500016', NULL, NULL, 0, 198, NULL, N'5096621511', N'5096656017', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1201 South Miller Street', N'Wenatchee', N'WA', N'53007', N'98807', 47.407963, -120.324593, 3571, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5876, N'Providence Centralia Hospital', 1, NULL, NULL, N'500019', NULL, NULL, 0, 191, NULL, N'3607362803', N'3603308614', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'914 S Scheuber Road', N'Centralia', N'WA', N'53041', N'98531', 46.712649, -122.986991, 3523, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5877, N'St Clare Hospital', 1, NULL, NULL, N'500021', NULL, NULL, 0, 105, NULL, N'2535881711', N'2535122833', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11315 Bridgeport Way S W', N'Lakewood', N'WA', N'53053', N'98499', 47.153766, -122.504488, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5878, N'Providence St Peter Hospital', 1, NULL, NULL, N'500024', NULL, NULL, 0, 340, NULL, N'3604919480', N'3604934277', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'413 Lilly Road Ne', N'Olympia', N'WA', N'53067', N'98506', 47.051243, -122.844374, 3548, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5879, N'Swedish Medical Center / Cherry Hill', 1, NULL, NULL, N'500025', NULL, NULL, 0, 376, NULL, N'2063202000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 17Th Avenue', N'Seattle', N'WA', N'53033', N'98122', 47.606569, -122.310234, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5880, N'Swedish Edmonds Hospital', 1, NULL, NULL, N'500026', NULL, NULL, 0, 217, NULL, N'4256404000', N'4256404010', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21601 76Th Avenue West', N'Edmonds', N'WA', N'53061', N'98026', 47.803284, -122.335697, 3532, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5881, N'Swedish Medical Center', 1, NULL, NULL, N'500027', NULL, NULL, 0, 697, NULL, N'2063866000', N'2063862479', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'747 Broadway', N'Seattle', N'WA', N'53033', N'98122', 47.608112, -122.320765, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5882, N'Peacehealth St Joseph Medical Center', 1, NULL, NULL, N'500030', NULL, NULL, 0, 253, NULL, N'3607345400', N'3607386393', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2901 Squalicum Parkway', N'Bellingham', N'WA', N'53073', N'98225', 48.772264, -122.474877, 3520, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5883, N'Grays Harbor Community Hospital', 1, NULL, NULL, N'500031', NULL, NULL, 0, 70, NULL, N'3605328330', N'5098431234', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'915 Anderson Drive', N'Aberdeen', N'WA', N'53027', N'98520', 46.979658, -123.846384, 3515, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5884, N'Samaritan Hospital', 1, NULL, NULL, N'500033', NULL, NULL, 0, 50, NULL, N'5097655606', N'5097656507', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 East Wheeler Road', N'Moses Lake', N'WA', N'53025', N'98837', 47.131104, -119.264196, 3546, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5885, N'Yakima Valley Memorial Hospital', 1, NULL, NULL, N'500036', NULL, NULL, 0, 218, NULL, N'5095758000', N'5095745800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2811 Tieton Drive', N'Yakima', N'WA', N'53077', N'98902', 46.592708, -120.547439, 3573, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5886, N'Toppenish Community Hospital', 1, NULL, NULL, N'500037', NULL, NULL, 0, 63, NULL, N'5098651520', N'5098651519', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 W Fourth Ave', N'Toppenish', N'WA', N'53077', N'98948', 46.371355, -120.316651, 3568, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5887, N'Harrison Memorial Hospital', 1, NULL, NULL, N'500039', NULL, NULL, 0, 297, NULL, N'3603773911', N'3607926515', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Cherry Avenue', N'Bremerton', N'WA', N'53035', N'98310', 47.583426, -122.626046, 3521, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5888, N'Peachealth St John Medical Center', 1, NULL, NULL, N'500041', NULL, NULL, 0, 368, NULL, N'3604142000', N'3604147550', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1615 Delaware Street', N'Longview', N'WA', N'53015', N'98632', 46.131054, -122.941508, 3543, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5889, N'Deaconess Hospital', 1, NULL, NULL, N'500044', NULL, NULL, 0, 388, NULL, N'5094735800', N'5094737286', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W 800 Fifth Avenue', N'Spokane', N'WA', N'53063', N'99210', 47.65886, -117.424713, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5890, N'Walla Walla General Hospital', 1, NULL, NULL, N'500049', NULL, NULL, 0, 72, NULL, N'5095250480', N'5095278258', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1025 S Second Ave', N'Walla Walla', N'WA', N'53071', N'99362', 46.054089, -118.331571, 3570, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5891, N'Peacehealth Southwest Medical Center', 1, NULL, NULL, N'500050', NULL, NULL, 0, 275, NULL, N'3602562000', N'3605142006', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Ne Mother Joseph Place', N'Vancouver', N'WA', N'53011', N'98668', 45.623443, -122.580644, 3569, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5892, N'Overlake Hospital Medical Center', 1, NULL, NULL, N'500051', NULL, NULL, 0, 218, NULL, N'4256885000', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1035-116Th Ave Ne', N'Bellevue', N'WA', N'53033', N'98004', 47.619961, -122.185641, 3519, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5893, N'Group Health Central Hospital', 1, NULL, NULL, N'500052', NULL, NULL, 0, 346, NULL, N'2063263000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 - 16Th Avenue East', N'Seattle', N'WA', N'53033', N'98112', 47.619731, -122.311413, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5894, N'Kennewick General Hospital', 1, NULL, NULL, N'500053', NULL, NULL, 0, 71, NULL, N'5095866111', N'5095865892', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 South Auburn Street', N'Kennewick', N'WA', N'53005', N'99336', 46.199089, -119.118462, 3541, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5895, N'Providence Sacred Heart Medical Center', 1, NULL, NULL, N'500054', NULL, NULL, 0, 615, NULL, N'5094743040', N'5094744925', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 West 8Th Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.648251, -117.411879, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5896, N'Kadlec Regional Medical Center', 1, NULL, NULL, N'500058', NULL, NULL, 0, 141, NULL, N'5099464611', N'5099422679', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'888 Swift Blvd', N'Richland', N'WA', N'53005', N'99352', 46.280448, -119.282199, 3559, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5897, N'Cascade Valley Hospital', 1, NULL, NULL, N'500060', NULL, NULL, 0, 48, NULL, N'3604352133', N'3604350513', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 S Stillaguamish Ave', N'Arlington', N'WA', N'53061', N'98223', 48.189355, -122.11763, 3517, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5898, N'Harborview Medical Center', 1, NULL, NULL, N'500064', NULL, NULL, 0, 413, NULL, N'2067313000', N'2067318551', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'325 9Th Avenue', N'Seattle', N'WA', N'53033', N'98104', 47.603598, -122.322954, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5899, N'Olympic Medical Center', 1, NULL, NULL, N'500072', NULL, NULL, 0, 126, NULL, N'3604177000', N'3604527391', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'939 Caroline St', N'Port Angeles', N'WA', N'53009', N'98362', 48.114711, -123.414281, 3552, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5900, N'Providence Holy Family Hospital', 1, NULL, NULL, N'500077', NULL, NULL, 0, 272, NULL, N'5094822450', N'5094822456', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5633 North Lidgerwood', N'Spokane', N'WA', N'53063', N'99208', 47.709697, -117.405904, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5901, N'Multicare od Samaritan Hospital', 1, NULL, NULL, N'500079', NULL, NULL, 0, 225, NULL, N'2536972102', N'2536975174', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 15Th Avenue Se', N'Puyallup', N'WA', N'53053', N'98372', 47.177411, -122.289468, 3556, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5902, N'Evergreen Health Monroe', 1, NULL, NULL, N'500084', NULL, NULL, 0, 72, NULL, N'3607947497', N'3607941486', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'14701 179Th Se', N'Monroe', N'WA', N'53061', N'98272', 47.863707, -121.990623, 3544, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5903, N'Valley Medical Center', 1, NULL, NULL, N'500088', NULL, NULL, 0, 303, NULL, N'4252283450', N'4256564202', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 S 43Rd St', N'Renton', N'WA', N'53033', N'98055', 47.44109, -122.214085, 3557, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5904, N'St Joseph Medical Center', 1, NULL, NULL, N'500108', NULL, NULL, 0, 340, NULL, N'2536274101', N'2534266880', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1717 South J Street', N'Tacoma', N'WA', N'53053', N'98405', 47.245263, -122.448713, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5905, N'Valley Hospital', 1, NULL, NULL, N'500119', NULL, NULL, 0, 123, NULL, N'5099246650', N'5094737286', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12606 East Mission Avenue', N'Spokane', N'WA', N'53063', N'99216', 47.671645, -117.235621, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5906, N'Evergreen Hospital Medical Center', 1, NULL, NULL, N'500124', NULL, NULL, 0, 227, NULL, N'4258991000', N'4258992624', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12040 Ne 128Th Street', N'Kirkland', N'WA', N'53033', N'98034', 47.714917, -122.178607, 3542, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5907, N'Tacoma General Allenmore Hospital', 1, NULL, NULL, N'500129', NULL, NULL, 0, 521, NULL, N'2534031000', N'2534031366', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 S Mlk Jr Way', N'Tacoma', N'WA', N'53053', N'98415', 47.24958, -122.439875, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5908, N'Seattle Cancer Care Alliance', 1, NULL, NULL, N'500138', NULL, NULL, 0, 20, NULL, N'2066675000', N'2062881025', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'825 Eastlake Avenue East', N'Seattle', N'WA', N'53033', N'98109', 47.618116, -122.329168, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5909, N'Capital Medical Center', 1, NULL, NULL, N'500139', NULL, NULL, 0, 110, NULL, N'3607545858', N'3609562574', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3900 Capital Mall Dr Sw', N'Olympia', N'WA', N'53067', N'98502', 47.041671, -122.951483, 3548, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5910, N'St Francis Community Hospital', 1, NULL, NULL, N'500141', NULL, NULL, 0, 110, NULL, N'2539448100', N'2539447988', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34515 9Th Avenue South', N'Federal Way', N'WA', N'53033', N'98003', 47.292561, -122.322944, 3536, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5911, N'Confluence Health- Wenatchee Valley Hosp & Clinics', 1, NULL, NULL, N'500148', NULL, NULL, 0, 20, NULL, N'5096638711', N'5096647178', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 North Chelan Avenue', N'Wenatchee', N'WA', N'53007', N'98801', 47.433262, -120.321737, 3571, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5912, N'Legacy Salmon Creek Medical Center', 1, NULL, NULL, N'500150', NULL, NULL, 0, 165, NULL, N'3604871000', N'3604873459', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2211 Ne 139Th Street', N'Vancouver', N'WA', N'53011', N'98686', 45.721874, -122.647983, 3569, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5913, N'St Anthony Hospital', 1, NULL, NULL, N'500151', NULL, NULL, 0, 80, NULL, N'2535302050', N'2535302068', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11567 Canterwood Boulevard Nw', N'Gig Harbor', N'WA', N'53053', N'98332', 47.363825, -122.614792, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5914, N'Swedish Issaquah', 1, NULL, NULL, N'500152', NULL, NULL, 0, 120, NULL, N'4253134000', N'4253862277', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'751 Ne Blakely Dr', N'Issaquah', N'WA', N'53033', N'98029', 47.536567, -122.0221, 3519, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5915, N'Garfield County Memorial Hospital', 1, NULL, NULL, N'501301', NULL, NULL, 0, 25, NULL, N'5098431591', N'5098431234', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'66 North Sixth Street', N'Pomeroy', N'WA', N'53023', N'99347', 46.474949, -117.602781, 1044, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5916, N'Dayton General Hospital', 1, NULL, NULL, N'501302', NULL, NULL, 0, 25, NULL, N'5093822531', N'5093823209', 1, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1012 South 3Rd Street', N'Dayton', N'WA', N'53013', N'99328', 46.312433, -117.968743, 3531, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5917, N'Willapa Harbor Hospital', 1, NULL, NULL, N'501303', NULL, NULL, 0, 25, NULL, N'3608755526', N'3608756336', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Alder Street', N'South Bend', N'WA', N'53049', N'98586', 46.662195, -123.812327, 3563, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5918, N'Summit Pacific Medical Center-Swing Bed Unit', 1, NULL, NULL, N'501304', NULL, NULL, 0, 24, NULL, N'3603462222', N'3603462160', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 East Main Street', N'Elma', N'WA', N'53027', N'98541', 47.006706, -123.39085, 3548, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5919, N'Lincoln Hospital', 1, NULL, NULL, N'501305', NULL, NULL, 0, 25, NULL, N'5097257101', N'5097252112', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10 Nichols Street', N'Davenport', N'WA', N'53043', N'99122', 47.657256, -118.146023, 3530, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5920, N'Odessa Memorial Healthcare Center', 1, NULL, NULL, N'501307', NULL, NULL, 0, 25, NULL, N'5099822611', N'5099822616', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'502 E Amende Drive', N'Odessa', N'WA', N'53043', N'99159', 47.331603, -118.682403, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5921, N'Coulee Community Hospital', 1, NULL, NULL, N'501308', NULL, NULL, 0, 48, NULL, N'5096331753', N'5096330951', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'411 Fortuyn Road', N'Grand Coulee', N'WA', N'53025', N'99133', 47.942391, -119.004532, 3539, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5922, N'Providence St Joseph Hospital', 1, NULL, NULL, N'501309', NULL, NULL, 0, 65, NULL, N'5099358211', N'5099355257', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 East Webster', N'Chewelah', N'WA', N'53065', N'99109', 48.278213, -117.710823, 3525, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5923, N'Newport Community Hospital', 1, NULL, NULL, N'501310', NULL, NULL, 0, 25, NULL, N'5094472441', N'5094475527', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'714 West Pine Street', N'Newport', N'WA', N'53051', N'99156', 48.182083, -117.047874, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5924, N'East Adams Rural Hospital', 1, NULL, NULL, N'501311', NULL, NULL, 0, 20, NULL, N'5096591200', N'5096591252', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'903 South Adams', N'Ritzville', N'WA', N'53001', N'99169', 47.121155, -118.372617, 3560, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5925, N'Prosser Memorial Hospital', 1, NULL, NULL, N'501312', NULL, NULL, 0, 25, NULL, N'5097862222', N'5097866683', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'723 Memorial Street', N'Prosser', N'WA', N'53005', N'99350', 46.207952, -119.763503, 3554, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5926, N'Cascade Medical Center', 1, NULL, NULL, N'501313', NULL, NULL, 0, 12, NULL, N'5095485815', N'5095481411', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'817 Commercial Street', N'Leavenworth', N'WA', N'53007', N'98826', 47.594694, -120.661092, 3571, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5927, N'Ocean Beach Hospital', 1, NULL, NULL, N'501314', NULL, NULL, 0, 15, NULL, N'3606423181', N'3606426309', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'174 First Avenue North', N'Ilwaco', N'WA', N'53049', N'98624', 46.310145, -124.043363, 3540, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5928, N'Skyline Hospital', 1, NULL, NULL, N'501315', NULL, NULL, 0, 25, NULL, N'5094911101', N'5094934607', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'211 Skyline Drive', N'White Salmon', N'WA', N'53039', N'98672', 45.723105, -121.471118, 3572, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5929, N'Klickitat Valley Hospital', 1, NULL, NULL, N'501316', NULL, NULL, 0, 25, NULL, N'5097734022', N'5097734714', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 South Roosevelt', N'ldendale', N'WA', N'53039', N'98620', 45.820629, -120.812269, 3538, 224, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5930, N'Columbia Basin Hospital', 1, NULL, NULL, N'501317', NULL, NULL, 0, 28, NULL, N'5097544631', N'5097546356', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Nat Washington Way', N'Ephrata', N'WA', N'53025', N'98823', 47.31566, -119.547881, 3571, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5931, N'Othello Community Hospital', 1, NULL, NULL, N'501318', NULL, NULL, 0, 49, NULL, N'5094882636', N'5093312617', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'315 North 14Th Avenue', N'Othello', N'WA', N'53001', N'99344', 46.831175, -119.154365, 3550, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5932, N'Morton General Hospital', 1, NULL, NULL, N'501319', NULL, NULL, 0, 31, NULL, N'3604965112', N'3604963537', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'521 Adams Street', N'Morton', N'WA', N'53041', N'98356', 46.555937, -122.280559, 3545, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5933, N'Quincy Valley Hospital', 1, NULL, NULL, N'501320', NULL, NULL, 0, 29, NULL, N'5097873531', N'5097872016', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'908 10Th Avenue Southwest', N'Quincy', N'WA', N'53025', N'98848', 47.230989, -119.869181, 3571, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5934, N'North Valley Hospital', 1, NULL, NULL, N'501321', NULL, NULL, 0, 85, NULL, N'5094862151', N'5094863119', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'203 South Western', N'Tonasket', N'WA', N'53047', N'98855', 48.706958, -119.439479, 3567, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5935, N'Ferry County Memorial Hospital', 1, NULL, NULL, N'501322', NULL, NULL, 0, 25, NULL, N'5097753333', N'5097753866', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36 Klondike Road', N'Republic', N'WA', N'53019', N'99166', 48.652944, -118.732967, 3558, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5936, N'Jefferson Healthcare', 1, NULL, NULL, N'501323', NULL, NULL, 0, 25, NULL, N'3603852200', N'3603792242', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'834 Sheridan Street', N'Port Townsend', N'WA', N'53031', N'98368', 48.105502, -122.790284, 3553, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5937, N'Three Rivers Hospital', 1, NULL, NULL, N'501324', NULL, NULL, 0, 43, NULL, N'5096892517', N'5096892086', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 Hospital Way', N'Brewster', N'WA', N'53047', N'98812', 48.105521, -119.783717, 3522, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5938, N'Forks Community Hospital', 1, NULL, NULL, N'501325', NULL, NULL, 0, 45, NULL, N'3603746271', N'3603745220', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'530 Bogachiel Way', N'Forks', N'WA', N'53009', N'98331', 47.946446, -124.393214, 3537, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5939, N'Providence Mount Carmel Hospital', 1, NULL, NULL, N'501326', NULL, NULL, 0, 25, NULL, N'5096842561', N'5096852492', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'982 East Columbia', N'Colville', N'WA', N'53065', N'99114', 48.541304, -117.8934, 3528, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5940, N'Whitman Hospital And Medical Center', 1, NULL, NULL, N'501327', NULL, NULL, 0, 25, NULL, N'5093973435', N'5093972563', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 West Fairview', N'Colfax', N'WA', N'53075', N'99111', 46.869249, -117.374602, 3527, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5941, N'Mid Valley Hospital', 1, NULL, NULL, N'501328', NULL, NULL, 0, 25, NULL, N'5098261760', N'5098267379', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 Jasmine Street', N'Omak', N'WA', N'53047', N'98841', 48.396393, -119.545364, 3549, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5942, N'Peacehealth United General Medical Center', 1, NULL, NULL, N'501329', NULL, NULL, 0, 30, NULL, N'3608566021', N'3608567204', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Hospital Drive', N'Sedro Woolley', N'WA', N'53057', N'98284', 48.49551, -122.276027, 3547, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5943, N'Sunnyside Community Hospital', 1, NULL, NULL, N'501330', NULL, NULL, 0, 25, NULL, N'5098371500', N'5098371740', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1016 Tacoma Avenue', N'Sunnyside', N'WA', N'53077', N'98944', 46.322218, -120.006966, 3565, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5944, N'Pullman Regional Hospital', 1, NULL, NULL, N'501331', NULL, NULL, 0, 25, NULL, N'5093322541', N'5093324242', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 S Bishop Blvd', N'Pullman', N'WA', N'53075', N'99163', 46.713506, -117.170278, 3555, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5945, N'Tri-State Memorial Hospital', 1, NULL, NULL, N'501332', NULL, NULL, 0, 25, NULL, N'5097585511', N'5097583566', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Highland Avenue', N'Clarkston', N'WA', N'53003', N'99403', 46.403637, -117.055073, 3526, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5946, N'Kittitas Valley Community Hospital', 1, NULL, NULL, N'501333', NULL, NULL, 0, 25, NULL, N'5099629841', N'5099258485', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'603 South Chestnut', N'Ellensburg', N'WA', N'53037', N'98926', 46.987252, -120.536739, 3533, 294, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5947, N'Lake Chelan Community Hospital', 1, NULL, NULL, N'501334', NULL, NULL, 0, 25, NULL, N'5096823300', N'5096823475', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'503 East Highland', N'Chelan', N'WA', N'53007', N'98816', 47.845274, -120.010935, 3524, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5948, N'St Elizabeth Hospital', 1, NULL, NULL, N'501335', NULL, NULL, 0, 25, NULL, N'3608252505', N'3602724018', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1450 Battersby Avenue', N'Enumclaw', N'WA', N'53033', N'98022', 47.208406, -121.988133, 3534, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5949, N'Mason General Hospital & Family Of Clinics', 1, NULL, NULL, N'501336', NULL, NULL, 0, 25, NULL, N'3604261611', N'3604271921', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Mt View Drive', N'Shelton', N'WA', N'53045', N'98584', 47.470214, -122.975869, 3562, 290, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5950, N'Lourdes Medical Center', 1, NULL, NULL, N'501337', NULL, NULL, 0, 35, NULL, N'5095462278', N'5095462291', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'520 N Fourth Avenue', N'Pasco', N'WA', N'53021', N'99301', 46.235463, -119.094643, 3551, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5951, N'Snoqualmie Valley Hospital', 1, NULL, NULL, N'501338', NULL, NULL, 0, 25, NULL, N'4258312300', N'4258311994', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9801 Frontier Ave Se', N'Snoqualmie', N'WA', N'53033', N'98065', 47.512309, -121.885917, 3519, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5952, N'Whidbey General Hospital', 1, NULL, NULL, N'501339', NULL, NULL, 0, 25, NULL, N'3606785151', N'3606780945', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 North Main Street', N'Coupeville', N'WA', N'53029', N'98239', 48.21424, -122.686122, 3529, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5953, N'Peacehealth Peace Island Medical Center', 1, NULL, NULL, N'501340', NULL, NULL, 0, 10, NULL, N'3603782141', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1117 Spring Street', N'Friday Harbor', N'WA', N'53055', N'98250', 48.529857, -123.028171, 3516, 289, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5954, N'Sunrise Haven', 1, NULL, NULL, N'501992', NULL, NULL, 0, 8, NULL, N'2538132096', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'Po Box 6057  24423 100Th Avenue South', N'Kent', N'WA', N'53033', N'98064', 47.38269, -122.227027, 3557, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5955, N'Regional Hospital For Respiratory And Complex Care', 1, NULL, NULL, N'502001', NULL, NULL, 0, 40, NULL, N'2062484548', N'2064394688', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16251 Sylvester Sw Road', N'Burien', N'WA', N'53033', N'98166', 47.469918, -122.348527, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5956, N'Kindred Hospital-Seattle', 1, NULL, NULL, N'502002', NULL, NULL, 0, 80, NULL, N'2063642050', N'2063615722', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10631 8Th Ave Ne', N'Seattle', N'WA', N'53033', N'98125', 47.611943, -122.332155, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5957, N'St Lukes Rehabilitation Institute', 1, NULL, NULL, N'503025', NULL, NULL, 0, 102, NULL, N'5094736000', N'5094736978', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 South Cowley St', N'Spokane', N'WA', N'53063', N'99202', 47.649766, -117.408023, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5958, N'Seattle Children''s Hospital', 1, NULL, NULL, N'503300', NULL, NULL, 0, 250, NULL, N'2069872000', N'2069873830', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4800 Sand Point Way Ne Po Box C-5371', N'Seattle', N'WA', N'53033', N'98105', 47.664447, -122.283227, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5959, N'Mary Bridge Children''s Hospital', 1, NULL, NULL, N'503301', NULL, NULL, 0, 68, NULL, N'2534031400', N'2534031930', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'317 Martin Luther King Jr W Box 5299', N'Tacoma', N'WA', N'53053', N'98415', 47.24958, -122.439875, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5960, N'Shriners Hospital For Children', 1, NULL, NULL, N'503302', NULL, NULL, 0, 30, NULL, N'5096230422', N'5096230474', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'911 West 5Th Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.650994, -117.425565, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5961, N'Bhc Fairfax Hospital', 1, NULL, NULL, N'504002', NULL, NULL, 0, 133, NULL, N'4258212000', N'4258219010', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10200 Ne 132Nd Street', N'Kirkland', N'WA', N'53033', N'98034', 47.718987, -122.204291, 3542, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5962, N'Western State Hospital', 1, NULL, NULL, N'504003', NULL, NULL, 0, 895, NULL, N'2537562350', N'2537562879', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9601 Steilacoom Blvd Sw', N'Tacoma', N'WA', N'53053', N'98498', 47.24958, -122.439875, 3566, 293, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5963, N'Eastern State Hospital', 1, NULL, NULL, N'504004', NULL, NULL, 0, 317, NULL, N'5092993121', N'5092997015', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 Maple Street - P O Box  A', N'Medical Lake', N'WA', N'53063', N'99022', 47.572023, -117.695119, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5964, N'Lourdes Counseling Center', 1, NULL, NULL, N'504008', NULL, NULL, 0, 32, NULL, N'5099439104', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1175 Carondelet Drive', N'Richland', N'WA', N'53005', N'99352', 46.283486, -119.281664, 3559, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5965, N'Navos', 1, NULL, NULL, N'504009', NULL, NULL, 0, 68, NULL, N'2069337299', N'2069337005', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 Southwest Holden', N'Seattle', N'WA', N'53033', N'98126', 47.603832, -122.330062, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5966, N'Cascade Behavioral Hospital', 1, NULL, NULL, N'504011', NULL, NULL, 0, 63, NULL, N'2062440180', N'2062437002', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12844 Military Road South', N'Tukwila', N'WA', N'53033', N'98168', 47.462736, -122.255916, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5967, N'Virginia Mason Medical Center', 1, NULL, NULL, N'509800', NULL, NULL, 0, 0, NULL, N'2065836544', N'2063410886', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1100 9Th Ave Mailstop C1-Tx', N'Seattle', N'WA', N'53033', N'98111', 47.613528, -122.332038, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5968, N'Swedish Medical Center Transplant Services', 1, NULL, NULL, N'509801', NULL, NULL, 0, 0, NULL, N'2062153005', N'2062153101', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1101 Madison St Suite 200', N'Seattle', N'WA', N'53033', N'98104', 47.603832, -122.330062, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5969, N'University Of Washington Medical Center', 1, NULL, NULL, N'509802', NULL, NULL, 0, 0, NULL, N'2065986364', N'2065986292', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1959 Ne Pacific Street', N'Seattle', N'WA', N'53033', N'98195', 47.649235, -122.308347, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5970, N'Seattle Childrens Hospital - Transplant', 1, NULL, NULL, N'509803', NULL, NULL, 0, 0, NULL, N'2069875090', N'2069873925', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'4800 Sand Point Way Ne (Mail Stop Mb9-420)', N'Seattle', N'WA', N'53033', N'98105', 47.603832, -122.330062, 3561, 291, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5971, N'Providence Sacred Heart Medical Center', 1, NULL, NULL, N'509804', NULL, NULL, 0, 0, NULL, N'5094744500', N'5094744487', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'101 W Eighth Avenue', N'Spokane', N'WA', N'53063', N'99204', 47.65886, -117.424713, 3564, 292, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5972, N'West Virginia University Hospitals', 1, NULL, NULL, N'510001', NULL, NULL, 0, 531, NULL, N'3045984000', N'3045984124', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Medical Center Drive', N'Morgantown', N'WV', N'54061', N'26506', 39.651385, -79.959392, 3595, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5973, N'Greenbrier Valley Medical Center', 1, NULL, NULL, N'510002', NULL, NULL, 0, 122, NULL, N'3046474411', NULL, 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 Maplewood Avenue  Po Box 497', N'Ronceverte', N'WV', N'54025', N'24970', 37.771814, -80.469288, 3607, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5974, N'United Hospital Center', 1, NULL, NULL, N'510006', NULL, NULL, 0, 375, NULL, N'6813421000', N'6813421625', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'327 Medical Park Drive', N'Bridgeport', N'WV', N'54033', N'26330', 39.32886, -80.241401, 3579, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5975, N'St Mary''s Medical Center', 1, NULL, NULL, N'510007', NULL, NULL, 0, 440, NULL, N'3045261234', N'3045261538', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 1St Avenue', N'Huntington', N'WV', N'54011', N'25702', 38.431845, -82.401465, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5976, N'Berkeley Medical Center', 1, NULL, NULL, N'510008', NULL, NULL, 0, 241, NULL, N'3042641000', N'3042641255', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2500 Hospital Drive', N'Martinsburg', N'WV', N'54003', N'25401', 39.476612, -77.980868, 3593, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5977, N'Pleasant Valley Hospital', 1, NULL, NULL, N'510012', NULL, NULL, 0, 201, NULL, N'3046754340', N'3046751328', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2520 Valley Drive', N'Point Pleasant', N'WV', N'54053', N'25550', 38.868595, -82.123593, 3601, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5978, N'Reynolds Memorial Hospital', 1, NULL, NULL, N'510013', NULL, NULL, 0, 127, NULL, N'3048433230', N'3048433202', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Wheeling Ave', N'Glen Dale', N'WV', N'54051', N'26038', 39.946226, -80.754249, 3583, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5979, N'Charleston Area Medical Center', 1, NULL, NULL, N'510022', NULL, NULL, 0, 908, NULL, N'3043885432', N'3043883604', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 Morris Street', N'Charleston', N'WV', N'54039', N'25301', 38.347134, -81.626144, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5980, N'Weirton Medical Center', 1, NULL, NULL, N'510023', NULL, NULL, 0, 238, NULL, N'3047976000', N'3047976176', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Colliers Way', N'Weirton', N'WV', N'54029', N'26062', 40.393733, -80.529667, 3613, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5981, N'Monongalia County General Hospital', 1, NULL, NULL, N'510024', NULL, NULL, 0, 189, NULL, N'3045981200', N'3045988382', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 Jd Anderson Dr', N'Morgantown', N'WV', N'54061', N'26505', 39.66262, -79.94639, 3595, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5982, N'Thomas Memorial Hospital', 1, NULL, NULL, N'510029', NULL, NULL, 0, 266, NULL, N'3047663600', N'3047663477', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4605 Maccorkle Ave Sw', N'South Charleston', N'WV', N'54039', N'25309', 38.355427, -81.727078, 3609, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5983, N'Davis Medical Center', 1, NULL, NULL, N'510030', NULL, NULL, 0, 90, NULL, N'3046363300', N'3046373184', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 1484', N'Elkins', N'WV', N'54083', N'26241', 38.925882, -79.84665, 3580, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5984, N'St Francis Hospital', 1, NULL, NULL, N'510031', NULL, NULL, 0, 155, NULL, N'3043476500', N'3043476885', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Laidley St', N'Charleston', N'WV', N'54039', N'25301', 38.353391, -81.632523, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5985, N'Stonewall Jackson Memorial Hospital', 1, NULL, NULL, N'510038', NULL, NULL, 0, 70, NULL, N'3042698080', N'3042698090', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 Hospital Plaza', N'Weston', N'WV', N'54041', N'26452', 39.047801, -80.492767, 3614, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5986, N'Ohio Valley Medical Center', 1, NULL, NULL, N'510039', NULL, NULL, 0, 453, NULL, N'3042340123', N'3042341830', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Eoff Street', N'Wheeling', N'WV', N'54069', N'26003', 40.058681, -80.722088, 3615, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5987, N'Princeton Community Hospital', 1, NULL, NULL, N'510046', NULL, NULL, 0, 267, NULL, N'3044877260', N'3044872161', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'122 12Th Street', N'Princeton', N'WV', N'54055', N'24740', 37.362279, -81.116422, 3602, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5988, N'Fairmont Regional Medical Center', 1, NULL, NULL, N'510047', NULL, NULL, 0, 252, NULL, N'3043677100', N'3043677167', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Locust Avenue', N'Fairmont', N'WV', N'54049', N'26554', 39.480826, -80.164067, 3581, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5989, N'Logan Regional Medical Center', 1, NULL, NULL, N'510048', NULL, NULL, 0, 140, NULL, N'3048311350', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20 Hospital Drive', N'Logan', N'WV', N'54045', N'25601', 37.846741, -81.995588, 3590, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5990, N'Wheeling Hospital', 1, NULL, NULL, N'510050', NULL, NULL, 0, 277, NULL, N'3042433000', N'3042433060', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Medical Park', N'Wheeling', N'WV', N'54069', N'26003', 40.060074, -80.684022, 3615, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5991, N'Cabell Huntington Hospital Inc', 1, NULL, NULL, N'510055', NULL, NULL, 0, 322, NULL, N'3045262000', N'3045262008', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1340 Hal Greer Boulevard', N'Huntington', N'WV', N'54011', N'25701', 38.409448, -82.428233, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5992, N'Camden Clark Medical Center', 1, NULL, NULL, N'510058', NULL, NULL, 0, 343, NULL, N'3044242111', N'3044242688', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Garfield Ave', N'Parkersburg', N'WV', N'54107', N'26101', 39.270186, -81.560448, 3598, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5993, N'Beckley Arh Hospital', 1, NULL, NULL, N'510062', NULL, NULL, 0, 173, NULL, N'3042553456', N'3042553544', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'306 Stanaford Road', N'Beckley', N'WV', N'54081', N'25801', 37.799237, -81.169059, 3574, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5994, N'Raleigh General Hospital', 1, NULL, NULL, N'510070', NULL, NULL, 0, 300, NULL, N'3042564100', N'3042564009', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1710 Harper Road', N'Beckley', N'WV', N'54081', N'25801', 37.787439, -81.203168, 3574, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5995, N'Bluefield Regional Medical Center', 1, NULL, NULL, N'510071', NULL, NULL, 0, 240, NULL, N'3043271100', N'3043271709', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 Cherry St', N'Bluefield', N'WV', N'54055', N'24701', 37.257543, -81.23415, 3576, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5996, N'Wetzel County Hospital', 1, NULL, NULL, N'510072', NULL, NULL, 0, 68, NULL, N'3044558000', N'3044554259', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#3 East Benjamin Drive', N'New Martinsville', N'WV', N'54103', N'26155', 39.680473, -80.857257, 3596, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5997, N'Williamson Memorial Hospital', 1, NULL, NULL, N'510077', NULL, NULL, 0, 76, NULL, N'3042352500', N'3042350538', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'859 Alderson Street', N'Williamson', N'WV', N'54059', N'25661', 37.676825, -82.272521, 3616, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5998, N'Summersville Regional Medical Center', 1, NULL, NULL, N'510082', NULL, NULL, 0, 105, NULL, N'3048722891', N'3048722080', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 Fairview Heights Road', N'Summersville', N'WV', N'54067', N'26651', 38.291749, -80.829665, 3611, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (5999, N'Welch Community Hospital', 1, NULL, NULL, N'510086', NULL, NULL, 0, 124, NULL, N'3044368461', N'3044366380', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'454 Mcdowell Street', N'Welch', N'WV', N'54047', N'24801', 37.438831, -81.589287, 3576, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6000, N'Charleston Surgical Hospital', 1, NULL, NULL, N'510091', NULL, NULL, 0, 35, NULL, N'3043434371', N'3043530215', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1306 Kanawha Boulevard East', N'Charleston', N'WV', N'54039', N'25301', 38.349822, -81.63263, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6001, N'Broaddus Hospital Association Inc', 1, NULL, NULL, N'511300', NULL, NULL, 0, 72, NULL, N'3044571760', N'3044573781', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Mansfield Hill P O Box 930', N'Philippi', N'WV', N'54001', N'26416', 39.1515753, -80.0473719, 3600, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6002, N'Webster County Memorial Hospital', 1, NULL, NULL, N'511301', NULL, NULL, 0, 15, NULL, N'3048475682', N'3048477660', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 312 (Miller Mountain Drive)', N'Webster Springs', N'WV', N'54101', N'26288', 38.479275, -80.413416, 3612, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6003, N'Minnie Hamilton Health Care Center', 1, NULL, NULL, N'511303', NULL, NULL, 0, 43, NULL, N'3043549244', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'186 Hospital Drive', N'Grantsville', N'WV', N'54013', N'26147', 38.922536, -81.092258, 3585, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6004, N'Sistersville General Hospital', 1, NULL, NULL, N'511304', NULL, NULL, 0, 25, NULL, N'3046522611', N'3046521448', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'314 South Wells Street', N'Sistersville', N'WV', N'54095', N'26175', 39.558529, -81.003873, 3608, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6005, N'Roane General Hospital', 1, NULL, NULL, N'511306', NULL, NULL, 0, 60, NULL, N'3049274444', N'3049275345', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Hospital Drive', N'Spencer', N'WV', N'54087', N'25276', 38.811881, -81.367867, 3610, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6006, N'Grafton City Hospital', 1, NULL, NULL, N'511307', NULL, NULL, 0, 102, NULL, N'3042650400', N'3042653926', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Hospital Plaza', N'Grafton', N'WV', N'54091', N'26354', 39.270718, -80.374806, 3584, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6007, N'Braxton County Memorial Hospital', 1, NULL, NULL, N'511308', NULL, NULL, 0, 25, NULL, N'3043645156', N'3043644129', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Hoylman Drive', N'Gassaway', N'WV', N'54007', N'26624', 38.661181, -80.749091, 3582, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6008, N'War Memorial Hospital Inc', 1, NULL, NULL, N'511309', NULL, NULL, 0, 25, NULL, N'3042581234', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Healthy Way', N'Berkeley Springs', N'WV', N'54065', N'25411', 39.640923, -78.19987, 3575, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6009, N'Summers County Arh Hospital', 1, NULL, NULL, N'511310', NULL, NULL, 0, 25, NULL, N'3044661000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Terrace Street   P O Box 940', N'Hinton', N'WV', N'54089', N'25951', 37.650494, -80.864603, 3586, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6010, N'Hampshire Memorial Hospital', 1, NULL, NULL, N'511311', NULL, NULL, 0, 44, NULL, N'3048224561', N'3048227809', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'363 Sunrise Boulevard', N'Romney', N'WV', N'54027', N'26757', 39.341917, -78.756757, 3606, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6011, N'Preston Memorial Hospital', 1, NULL, NULL, N'511312', NULL, NULL, 0, 25, NULL, N'3043291400', N'3043291175', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Memorial Drive', N'Kingwood', N'WV', N'54077', N'26537', 39.665597, -79.626573, 3589, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6012, N'Boone Memorial Hospital', 1, NULL, NULL, N'511313', NULL, NULL, 0, 25, NULL, N'3043691230', N'3043691525', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'701 Madison Avenue', N'Madison', N'WV', N'54005', N'25130', 38.035905, -81.782109, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6013, N'Pocahontas Memorial Hospital', 1, NULL, NULL, N'511314', NULL, NULL, 0, 25, NULL, N'3047997400', N'3047996636', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 Duncan Road', N'Buckeye', N'WV', N'54075', N'24924', 38.201424, -80.108702, 3592, 282, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6014, N'Potomac Valley Hospital', 1, NULL, NULL, N'511315', NULL, NULL, 0, 25, NULL, N'3045973500', N'3047880141', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100 Pin Oak Lane', N'Keyser', N'WV', N'54057', N'26726', 39.440928, -78.973916, 1680, 52, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6015, N'Grant Memorial Hospital', 1, NULL, NULL, N'511316', NULL, NULL, 0, 45, NULL, N'3042571026', N'3042579776', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'P O Box 1019', N'Petersburg', N'WV', N'54023', N'26847', 38.992489, -79.123975, 3599, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6016, N'Plateau Medical Center', 1, NULL, NULL, N'511317', NULL, NULL, 0, 25, NULL, N'3044698600', N'3044698605', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 Main Street West', N'Oak Hill', N'WV', N'54019', N'25901', 37.974531, -81.144357, 3597, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6017, N'Montmery General Hospital Inc', 1, NULL, NULL, N'511318', NULL, NULL, 0, 69, NULL, N'3044425151', N'3044427494', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 Sixth Avenue Fayette County', N'Montmery', N'WV', N'54019', N'25136', 38.182763, -81.325594, 3594, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6018, N'Jefferson Medical Center', 1, NULL, NULL, N'511319', NULL, NULL, 0, 25, NULL, N'3047281600', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 South Preston Street', N'Ranson', N'WV', N'54037', N'25438', 39.29569, -77.858102, 3603, 288, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6019, N'Jackson General Hospital', 1, NULL, NULL, N'511320', NULL, NULL, 0, 25, NULL, N'3043722731', N'3043722749', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'122 Pinnell St', N'Ripley', N'WV', N'54035', N'25271', 38.823539, -81.728325, 3605, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6020, N'St Joseph Hospital', 1, NULL, NULL, N'511321', NULL, NULL, 0, 51, NULL, N'3044722000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1 Amalia Drive', N'Buckhannon', N'WV', N'54097', N'26201', 38.992793, -80.234799, 3577, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6021, N'Select Specialty Hospital', 1, NULL, NULL, N'512002', NULL, NULL, 0, 32, NULL, N'3043886671', N'3043883604', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Laidley Street', N'Charleston', N'WV', N'54039', N'25301', 38.353187, -81.633198, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6022, N'Cornerstone Hospital Of Huntington', 1, NULL, NULL, N'512003', NULL, NULL, 0, 28, NULL, N'3043992600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 First Avenue 2E', N'Huntington', N'WV', N'54011', N'25702', 38.41925, -82.445154, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6023, N'Peterson Healthcare And Rehabilitation Hospital', 1, NULL, NULL, N'513025', NULL, NULL, 0, 22, NULL, N'3042340500', N'3042340591', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Homestead Avenue', N'Wheeling', N'WV', N'54069', N'26003', 40.080511, -80.694173, 3615, 234, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6024, N'Healthsouth Southern Hills Regional Rehab', 1, NULL, NULL, N'513026', NULL, NULL, 0, 60, NULL, N'3044878000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'120 12Th St', N'Princeton', N'WV', N'54055', N'24740', 37.366328, -81.102577, 3602, 287, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6025, N'Healthsouth Western Hills Regional Rehab Hospital', 1, NULL, NULL, N'513027', NULL, NULL, 0, 50, NULL, N'3044201300', N'3044201374', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'#3 Western Hills Drive', N'Parkersburg', N'WV', N'54107', N'26105', 39.266742, -81.561513, 3598, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6026, N'Healthsouth Rehabilitation Hospital Of Huntington', 1, NULL, NULL, N'513028', NULL, NULL, 0, 62, NULL, N'3047331060', N'3047339284', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6900 West Country Club Drive', N'Huntington', N'WV', N'54011', N'25705', 38.41925, -82.445154, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6027, N'Healthsouth Mountainview Regional Rehab Hospital', 1, NULL, NULL, N'513030', NULL, NULL, 0, 96, NULL, N'3045981100', N'3045981103', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1160 Van Voorhis Road', N'Morgantown', N'WV', N'54061', N'26504', 39.65739, -79.963218, 3595, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6028, N'Highland Hospital', 1, NULL, NULL, N'514001', NULL, NULL, 0, 80, NULL, N'3049261600', N'3049261649', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1418A Maccorkle Avenue Sw', N'Charleston', N'WV', N'54039', N'25303', 38.353849, -81.736055, 3578, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6029, N'River Park Hospital', 1, NULL, NULL, N'514008', NULL, NULL, 0, 165, NULL, N'3045269100', N'3045269140', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1230 Sixth Avenue', N'Huntington', N'WV', N'54011', N'25701', 38.41925, -82.445154, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6030, N'Mildred Mitchell-Bateman Hospital', 1, NULL, NULL, N'514009', NULL, NULL, 0, 110, NULL, N'3045257801', N'3045257249', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1530 Norway Avenue', N'Huntington', N'WV', N'54099', N'25709', 38.401631, -82.387976, 3587, 296, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6031, N'William R Sharpe Jr Hospital', 1, NULL, NULL, N'514010', NULL, NULL, 0, 150, NULL, N'3042691210', N'3042696235', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'936 Sharpe Hospital Road', N'Weston', N'WV', N'54041', N'26452', 39.0408791, -80.4991087, 3614, 295, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6032, N'Highland-Clarksburg Hospital Inc', 1, NULL, NULL, N'514011', NULL, NULL, 0, 150, NULL, N'3046224951', N'3046224955', 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'3 Hospital Plaza', N'Clarksburg', N'WV', N'54033', N'26301', 39.280645, -80.344534, 3579, 297, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6033, N'Ministry St Michaels Hospital Of Stevens Point', 1, NULL, NULL, N'520002', NULL, NULL, 0, 181, NULL, N'7153465000', N'7153465088', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Illinois Ave', N'Stevens Point', N'WI', N'55097', N'54481', 44.526164, -89.566197, 3700, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6034, N'Mayo Clinic Hlth System  Franciscan Med Ctr', 1, NULL, NULL, N'520004', NULL, NULL, 0, 345, NULL, N'6087850940', N'6083929429', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 West Avenue South', N'La Crosse', N'WI', N'55063', N'54601', 43.804645, -91.239513, 3657, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6035, N'Waukesha Memorial Hospital', 1, NULL, NULL, N'520008', NULL, NULL, 0, 400, NULL, N'2629281000', N'2629287810', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'725 American Ave', N'Waukesha', N'WI', N'55133', N'53188', 43.01135, -88.24388, 3707, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6036, N'St Elizabeth Hospital', 1, NULL, NULL, N'520009', NULL, NULL, 0, 332, NULL, N'9207382000', N'9208318916', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1506 S Oneida St', N'Appleton', N'WI', N'55087', N'54915', 44.247879, -88.404141, 3619, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6037, N'Lakeview Medical Center', 1, NULL, NULL, N'520011', NULL, NULL, 0, 75, NULL, N'7152341515', N'7152366342', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1700 West Stout Street', N'Rice Lake', N'WI', N'55005', N'54868', 45.508042, -91.759027, 3690, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6038, N'Sacred Heart Hospital', 1, NULL, NULL, N'520013', NULL, NULL, 0, 344, NULL, N'7157174121', N'7157176076', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 W Clairemont Ave', N'Eau Claire', N'WI', N'55035', N'54701', 44.793462, -91.51067, 3642, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6039, N'St Josephs Hospital', 1, NULL, NULL, N'520017', NULL, NULL, 0, 217, NULL, N'7157177200', N'7157171694', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2661 County Hwy I', N'Chippewa Falls', N'WI', N'55017', N'54729', 44.951661, -91.358219, 3634, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6040, N'Ministry Saint Marys Hospital', 1, NULL, NULL, N'520019', NULL, NULL, 0, 99, NULL, N'7153612000', N'7153614877', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2251 North Shore Dr', N'Rhinelander', N'WI', N'55085', N'54501', 45.637123, -89.374618, 3689, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6041, N'United Hospital System', 1, NULL, NULL, N'520021', NULL, NULL, 0, 380, NULL, N'2626562011', N'2626535852', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6308 Eighth Ave', N'Kenosha', N'WI', N'55059', N'53143', 42.577036, -87.819278, 3655, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6042, N'Columbia St Marys Hospital Ozaukee', 1, NULL, NULL, N'520027', NULL, NULL, 0, 118, NULL, N'2622437300', N'2622437329', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13111 N Port Washington Rd', N'Mequon', N'WI', N'55089', N'53097', 43.25606, -87.924149, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6043, N'The Monroe Clinic', 1, NULL, NULL, N'520028', NULL, NULL, 0, 100, NULL, N'6083241000', N'6083241114', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 5Th Street', N'Monroe', N'WI', N'55045', N'53566', 42.607799, -89.634313, 3670, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6044, N'Aspirus Wausau Hospital', 1, NULL, NULL, N'520030', NULL, NULL, 0, 321, NULL, N'7158472121', N'7158472108', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 Pine Ridge Blvd', N'Wausau', N'WI', N'55073', N'54401', 44.965761, -89.670276, 3710, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6045, N'Aspirus Riverview Hospital & Clinics Inc', 1, NULL, NULL, N'520033', NULL, NULL, 0, 99, NULL, N'7154236060', N'7154217512', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'410 Dewey St', N'Wisconsin Rapids', N'WI', N'55141', N'54495', 44.382149, -89.829166, 3715, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6046, N'Aurora Medical Ctr Manitowoc County', 1, NULL, NULL, N'520034', NULL, NULL, 0, 69, NULL, N'9207945000', N'9207945487', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 Memorial Drive', N'Two Rivers', N'WI', N'55071', N'54241', 44.125862, -87.615137, 3704, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6047, N'Aurora Sheboygan Memorial Medical Ctr', 1, NULL, NULL, N'520035', NULL, NULL, 0, 185, NULL, N'9204515000', N'9204515333', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2629 N 7Th St', N'Sheboygan', N'WI', N'55117', N'53083', 43.772588, -87.711206, 3695, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6048, N'Ministry Saint Josephs Hospital', 1, NULL, NULL, N'520037', NULL, NULL, 0, 504, NULL, N'7153877850', N'7153878601', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 St Joseph Ave', N'Marshfield', N'WI', N'55141', N'54449', 44.676008, -90.180027, 3663, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6049, N'Aurora Medical Ctr Washington County', 1, NULL, NULL, N'520038', NULL, NULL, 0, 71, NULL, N'2626732300', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1032 E Sumner St', N'Hartford', N'WI', N'55131', N'53027', 43.317603, -88.362389, 3650, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6050, N'Divine Savior Healthcare', 1, NULL, NULL, N'520041', NULL, NULL, 0, 73, NULL, N'6087424131', N'6087426098', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2817 New Pinery Road', N'Portage', N'WI', N'55021', N'53901', 43.566374, -89.469441, 3684, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6051, N'St Nicholas Hospital', 1, NULL, NULL, N'520044', NULL, NULL, 0, 185, NULL, N'9204598300', N'9204528336', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Superior Ave', N'Sheboygan', N'WI', N'55117', N'53081', 43.761115, -87.747489, 3695, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6052, N'Theda Clark Medical Center', 1, NULL, NULL, N'520045', NULL, NULL, 0, 182, NULL, N'9207293100', N'9207293167', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 2Nd St', N'Neenah', N'WI', N'55139', N'54956', 44.188186, -88.453445, 3671, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6053, N'Mercy Medical Center Of Oshkosh', 1, NULL, NULL, N'520048', NULL, NULL, 0, 157, NULL, N'9202232000', N'9202230508', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'500 S Oakwood Rd', N'Oshkosh', N'WI', N'55139', N'54904', 44.012636, -88.603057, 3678, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6054, N'Bellin Memorial Hospital', 1, NULL, NULL, N'520049', NULL, NULL, 0, 242, NULL, N'9204333500', N'9204333707', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'744 S Webster Ave', N'Green Bay', N'WI', N'55009', N'54305', 44.501872, -88.010724, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6055, N'Columbia St Marys Hospital Milwaukee', 1, NULL, NULL, N'520051', NULL, NULL, 0, 422, NULL, N'4142911000', N'4142911444', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2323 N Lake Dr', N'Milwaukee', N'WI', N'55079', N'53211', 43.060636, -87.879882, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6056, N'St Clare Hospital', 1, NULL, NULL, N'520057', NULL, NULL, 0, 100, NULL, N'6083561400', N'6083561367', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 14Th St', N'Baraboo', N'WI', N'55111', N'53913', 43.48059, -89.732088, 3623, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6057, N'Aurora Memorial Hospital Burlington', 1, NULL, NULL, N'520059', NULL, NULL, 0, 123, NULL, N'2627676545', N'2627676380', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'252 Mchenry St', N'Burlington', N'WI', N'55101', N'53105', 42.673014, -88.282817, 3632, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6058, N'Oconomowoc Memorial Hospital', 1, NULL, NULL, N'520062', NULL, NULL, 0, 156, NULL, N'2625699400', N'2625690336', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'791 E Summit Ave', N'Oconomowoc', N'WI', N'55133', N'53066', 43.042811, -88.46381, 3675, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6059, N'St Josephs Community Hospital Of West Bend', 1, NULL, NULL, N'520063', NULL, NULL, 0, 121, NULL, N'2623345533', N'2628367118', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3200 Pleasant Valley Road', N'West Bend', N'WI', N'55131', N'53095', 43.353365, -88.194938, 3712, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6060, N'Mercy Health System Corp', 1, NULL, NULL, N'520066', NULL, NULL, 0, 240, NULL, N'6087566080', N'6087566168', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Mineral Point Ave', N'Janesville', N'WI', N'55105', N'53548', 42.686742, -89.0331, 3654, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6061, N'Mayo Clinic Health System Eau Claire Hospital', 1, NULL, NULL, N'520070', NULL, NULL, 0, 304, NULL, N'7158383311', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1221 Whipple St', N'Eau Claire', N'WI', N'55035', N'54703', 44.811763, -91.513451, 3642, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6062, N'Fort Memorial Hospital', 1, NULL, NULL, N'520071', NULL, NULL, 0, 82, NULL, N'9205685000', N'9205685412', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'611 Sherman Ave E', N'Fort Atkinson', N'WI', N'55055', N'53538', 42.929968, -88.827953, 3646, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6063, N'St Vincent Hospital', 1, NULL, NULL, N'520075', NULL, NULL, 0, 523, NULL, N'9204330111', N'9204313215', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'835 S Van Buren St', N'Green Bay', N'WI', N'55009', N'54301', 44.501039, -88.013175, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6064, N'Beaver Dam Community Hospital', 1, NULL, NULL, N'520076', NULL, NULL, 0, 125, NULL, N'9208877181', N'9208877973', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 S University Ave', N'Beaver Dam', N'WI', N'55027', N'53916', 43.448085, -88.828099, 3625, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6065, N'Wheaton Franciscan Healthcare St Francis', 1, NULL, NULL, N'520078', NULL, NULL, 0, 270, NULL, N'4146475000', N'4146475565', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3237 S 16Th St', N'Milwaukee', N'WI', N'55079', N'53215', 42.985885, -87.933826, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6066, N'St Marys Hospital', 1, NULL, NULL, N'520083', NULL, NULL, 0, 440, NULL, N'6082516100', N'6082586731', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 South Park St', N'Madison', N'WI', N'55025', N'53715', 43.059474, -89.400805, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6067, N'Gundersen Lutheran Medical Center', 1, NULL, NULL, N'520087', NULL, NULL, 0, 325, NULL, N'6087827300', NULL, 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1910 South Ave', N'La Crosse', N'WI', N'55063', N'54601', 43.794742, -91.24621, 3657, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6068, N'St Agnes Hospital', 1, NULL, NULL, N'520088', NULL, NULL, 0, 151, NULL, N'9209292300', N'9209264866', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'430 E Divison St', N'Fond Du Lac', N'WI', N'55039', N'54935', 43.778692, -88.431215, 3645, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6069, N'Meriter Hospital', 1, NULL, NULL, N'520089', NULL, NULL, 0, 448, NULL, N'6084176000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'202 S Park St', N'Madison', N'WI', N'55025', N'53715', 43.065857, -89.400912, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6070, N'Howard Young Medical Ctr', 1, NULL, NULL, N'520091', NULL, NULL, 0, 109, NULL, N'7153568000', N'7153566097', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'240 Maple St', N'Woodruff', N'WI', N'55085', N'54568', 45.894415, -89.701815, 3716, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6071, N'Sauk Prairie Hospital', 1, NULL, NULL, N'520095', NULL, NULL, 0, 36, NULL, N'6086433311', N'6086437680', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'260 26Th Street', N'Prairie Du Sac', N'WI', N'55111', N'53578', 43.285904, -89.752186, 3686, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6072, N'Wheaton Franciscan Healthcare All Saints', 1, NULL, NULL, N'520096', NULL, NULL, 0, 553, NULL, N'2626874011', N'2626878039', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3801 Spring St', N'Racine', N'WI', N'55101', N'53405', 42.734687, -87.827876, 3687, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6073, N'St Marys Hospital Medical Ctr', 1, NULL, NULL, N'520097', NULL, NULL, 0, 158, NULL, N'9204984200', N'9208845712', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1726 Shawano Ave', N'Green Bay', N'WI', N'55009', N'54303', 44.533652, -88.07075, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6074, N'University Of Wi  Hospitals & Clinics Authority', 1, NULL, NULL, N'520098', NULL, NULL, 0, 536, NULL, N'6082638991', N'6082657248', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'600 Highland Avenue', N'Madison', N'WI', N'55025', N'53792', 43.07393, -89.428762, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6075, N'Beloit Memorial Hospital', 1, NULL, NULL, N'520100', NULL, NULL, 0, 256, NULL, N'6083645011', N'6083645356', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1969 W Hart Rd', N'Beloit', N'WI', N'55105', N'53511', 42.546766, -89.008424, 3626, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6076, N'Aurora Lakeland Medical Center', 1, NULL, NULL, N'520102', NULL, NULL, 0, 99, NULL, N'2627412000', N'2627412180', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W3985 County Road Nn', N'Elkhorn', N'WI', N'55127', N'53121', 42.662618, -88.496078, 3644, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6077, N'Community Memorial Hospital', 1, NULL, NULL, N'520103', NULL, NULL, 0, 237, NULL, N'2622511000', N'2622537169', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'W180 N8085 Town Hall Rd', N'Menomonee Falls', N'WI', N'55133', N'53051', 43.16465, -88.13381, 3666, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6078, N'Holy Family Memorial', 1, NULL, NULL, N'520107', NULL, NULL, 0, 167, NULL, N'9203202011', N'9203205129', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2300 Western Ave', N'Manitowoc', N'WI', N'55071', N'54221', 44.09441, -87.676865, 3661, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6079, N'Mile Bluff Medical Center', 1, NULL, NULL, N'520109', NULL, NULL, 0, 40, NULL, N'6088476161', N'6088473881', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1050 Division St', N'Mauston', N'WI', N'55057', N'53948', 43.782614, -90.076778, 3664, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6080, N'Bay Area Medical Center', 1, NULL, NULL, N'520113', NULL, NULL, 0, 99, NULL, N'7157356621', N'7157358083', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Shore Drive', N'Marinette', N'WI', N'55075', N'54143', 45.072099, -87.619332, 3662, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6081, N'Watertown Regional Medical Center', 1, NULL, NULL, N'520116', NULL, NULL, 0, 95, NULL, N'9202614210', N'9202613940', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'125 Hospital Drive', N'Watertown', N'WI', N'55027', N'53098', 43.201315, -88.699008, 3706, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6082, N'Wheaton Franciscan St Joseph', 1, NULL, NULL, N'520136', NULL, NULL, 0, 538, NULL, N'4144472000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5000 W Chambers St', N'Milwaukee', N'WI', N'55079', N'53210', 43.073465, -87.9761, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6083, N'Aurora St Lukes Medical Center', 1, NULL, NULL, N'520138', NULL, NULL, 0, 1213, NULL, N'4146496000', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2900 W Oklahoma Ave', N'Milwaukee', N'WI', N'55079', N'53215', 42.988598, -87.950653, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6084, N'Aurora West Allis Medical Center', 1, NULL, NULL, N'520139', NULL, NULL, 0, 149, NULL, N'4143286000', N'4143288536', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8901 W Lincoln Ave', N'West Allis', N'WI', N'55079', N'53227', 43.0027, -88.02335, 3711, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6085, N'Appleton Medical Center', 1, NULL, NULL, N'520160', NULL, NULL, 0, 160, NULL, N'9207314101', NULL, 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1818 N Meade St', N'Appleton', N'WI', N'55087', N'54911', 44.278756, -88.395612, 3619, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6086, N'Froedtert Memorial Lutheran Hospital', 1, NULL, NULL, N'520177', NULL, NULL, 0, 596, NULL, N'4148053000', N'4148058910', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9200 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038407, -88.027358, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6087, N'Aurora Medical Ctr Kenosha', 1, NULL, NULL, N'520189', NULL, NULL, 0, 74, NULL, N'2629485600', N'2629485828', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10400 75Th St', N'Kenosha', N'WI', N'55059', N'53142', 42.567355, -87.933877, 3655, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6088, N'Aurora Baycare Medical Ctr', 1, NULL, NULL, N'520193', NULL, NULL, 0, 132, NULL, N'9202888000', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2845 Greenbrier Rd', N'Green Bay', N'WI', N'55009', N'54311', 44.47335, -87.941091, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6089, N'Orthopaedic Hospital Of Wisconsin', 1, NULL, NULL, N'520194', NULL, NULL, 0, 25, NULL, N'4149616800', N'4149616778', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'475 W River Woods Pkwy', N'Glendale', N'WI', N'55079', N'53212', 43.098477, -87.91389, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6090, N'Columbia Center', 1, NULL, NULL, N'520195', NULL, NULL, 0, 92, NULL, N'2622437408', N'2622436670', 1, 0, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13125 N Port Washington Rd', N'Mequon', N'WI', N'55089', N'53097', 43.256306, -87.924152, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6091, N'Oakleaf Surgical Hospital', 1, NULL, NULL, N'520196', NULL, NULL, 0, 13, NULL, N'7158318130', N'7158317894', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1000 Oakleaf Way', N'Altoona', N'WI', N'55035', N'54720', 44.815288, -91.451632, 3642, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6092, N'Aurora Medical Ctr Oshkosh', 1, NULL, NULL, N'520198', NULL, NULL, 0, 84, NULL, N'9204566000', N'9204567601', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 N Westhaven Drive', N'Oshkosh', N'WI', N'55139', N'54904', 44.026487, -88.593898, 3678, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6093, N'St Clares Hospital Of Weston', 1, NULL, NULL, N'520202', NULL, NULL, 0, 86, NULL, N'7153933000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 Ministry Parkway', N'Weston', N'WI', N'55073', N'54476', 44.889675, -89.582214, 3710, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6094, N'Wheaton Franciscan Healthcare Franklin', 1, NULL, NULL, N'520204', NULL, NULL, 0, 52, NULL, N'4143254500', N'4143254511', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 South 27Th St', N'Franklin', N'WI', N'55079', N'53132', 42.859942, -87.951727, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6095, N'Midwest Orthopedic Specialty Hospital', 1, NULL, NULL, N'520205', NULL, NULL, 0, 16, NULL, N'4148175800', N'4143254511', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10101 South 27Th St  2Nd Floor', N'Franklin', N'WI', N'55079', N'53132', 42.859942, -87.951727, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6096, N'Aurora Medical Center', 1, NULL, NULL, N'520206', NULL, NULL, 0, 66, NULL, N'2624341000', N'2624341221', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'36500 Aurora Drive', N'Summit', N'WI', N'55133', N'53066', 43.064083, -88.469521, 3675, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6097, N'Aurora Medical Center', 1, NULL, NULL, N'520207', NULL, NULL, 0, 62, NULL, N'2623291000', N'2623291001', 1, 1, 1, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'975 Port Washington Road', N'Grafton', N'WI', N'55089', N'53024', 43.311643, -87.924997, 3683, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6098, N'St Marys Janesville Hospital', 1, NULL, NULL, N'520208', NULL, NULL, 0, 50, NULL, N'6083738000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3400 East Racine Street', N'Janesville', N'WI', N'55105', N'53546', 42.670977, -88.975924, 3654, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6099, N'Ministry Eagle River Memorial Hospital', 1, NULL, NULL, N'521300', NULL, NULL, 0, 25, NULL, N'7154797411', N'7153566097', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Hospital Road', N'Eagle River', N'WI', N'55125', N'54521', 45.927464, -89.253627, 3641, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6100, N'Mayo Clinic Health System Oakridge', 1, NULL, NULL, N'521302', NULL, NULL, 0, 18, NULL, N'7155973121', N'7155976250', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'13025 8Th St', N'Osseo', N'WI', N'55121', N'54758', 44.577911, -91.216351, 3642, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6101, N'Wild Rose Community Memorial Hospital', 1, NULL, NULL, N'521303', NULL, NULL, 0, 25, NULL, N'9206223257', N'9206226020', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 Grove Ave', N'Wild Rose', N'WI', N'55137', N'54984', 44.183056, -89.245934, 3714, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6102, N'St Josephs Health Services', 1, NULL, NULL, N'521304', NULL, NULL, 0, 25, NULL, N'6084898000', N'6084898181', 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'400 Water Ave', N'Hillsboro', N'WI', N'55123', N'54634', 43.64878, -90.344004, 3652, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6103, N'Mayo Clinic Hlth Systm Franciscan Hlthcare Sparta', 1, NULL, NULL, N'521305', NULL, NULL, 0, 25, NULL, N'6082692132', N'6082694562', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'310 W Main St', N'Sparta', N'WI', N'55081', N'54656', 43.94465, -90.81443, 3657, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6104, N'Chippewa Valley Hospital', 1, NULL, NULL, N'521307', NULL, NULL, 0, 25, NULL, N'7156724211', N'7156725112', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1220 3Rd Ave W', N'Durand', N'WI', N'55091', N'54736', 44.620801, -91.963498, 3640, 153, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6105, N'Amery Hospital & Clinic', 1, NULL, NULL, N'521308', NULL, NULL, 0, 25, NULL, N'7152680300', N'7152680311', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'265 Griffin Street East', N'Amery', N'WI', N'55095', N'54001', 45.295954, -92.359025, 3617, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6106, N'Moundview Memorial Hospital And Clinics', 1, NULL, NULL, N'521309', NULL, NULL, 0, 25, NULL, N'6083393331', N'6083399385', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'402 W Lake St', N'Friendship', N'WI', N'55001', N'53934', 43.974017, -89.821557, 3647, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6107, N'Hshs St Clare Memorial Hospital', 1, NULL, NULL, N'521310', NULL, NULL, 0, 15, NULL, N'9208463444', N'9208460250', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'855 S Main St', N'Oconto Falls', N'WI', N'55083', N'54154', 44.866202, -88.127595, 3676, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6108, N'Our Lady Of Victory Hospital', 1, NULL, NULL, N'521311', NULL, NULL, 0, 24, NULL, N'7156445571', N'7156446221', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1120 Pine St', N'Stanley', N'WI', N'55017', N'54768', 44.955311, -90.920564, 3699, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6109, N'Memorial Hospital Of Lafayette County', 1, NULL, NULL, N'521312', NULL, NULL, 0, 15, NULL, N'6087764466', NULL, 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Clay St', N'Darlington', N'WI', N'55065', N'53530', 42.683988, -90.110418, 3638, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6110, N'Ministry Sacred Heart Hospital', 1, NULL, NULL, N'521313', NULL, NULL, 0, 18, NULL, N'7154537700', N'7154537716', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'401 W Mohawk Dr  Suite 100', N'Tomahawk', N'WI', N'55069', N'54487', 45.489085, -89.734526, 3689, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6111, N'Mayo Clinic Health System  Chippewa Valley', 1, NULL, NULL, N'521314', NULL, NULL, 0, 15, NULL, N'7155682000', N'7155686196', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Thompson St', N'Bloomer', N'WI', N'55017', N'54724', 45.102101, -91.500572, 3629, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6112, N'Mayo Clinic Health System  Northland', 1, NULL, NULL, N'521315', NULL, NULL, 0, 29, NULL, N'7155373186', N'7155376902', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1222 E Woodland Ave', N'Barron', N'WI', N'55005', N'54812', 45.398157, -91.839924, 3624, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6113, N'Tri County Memorial Hospital', 1, NULL, NULL, N'521316', NULL, NULL, 0, 25, NULL, N'7155384361', N'7155382271', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18601 Lincoln St', N'Whitehall', N'WI', N'55121', N'54773', 44.364829, -91.318642, 3713, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6114, N'Calumet Medical Center', 1, NULL, NULL, N'521317', NULL, NULL, 0, 29, NULL, N'9208492386', N'9208497510', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'614 Memorial Drive', N'Chilton', N'WI', N'55015', N'53014', 44.025439, -88.154399, 3633, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6115, N'Ladd Memorial Hospital', 1, NULL, NULL, N'521318', NULL, NULL, 0, 23, NULL, N'7152942111', N'7152943694', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 65Th Avenue', N'Osceola', N'WI', N'55095', N'54020', 45.302115, -92.699804, 3677, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6116, N'Edgerton Hospital And Health Services', 1, NULL, NULL, N'521319', NULL, NULL, 0, 29, NULL, N'6088843441', N'6085616905', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11101 N Sherman Road', N'Edgerton', N'WI', N'55105', N'53534', 42.834341, -89.043003, 3643, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6117, N'Tomah Memorial Hospital', 1, NULL, NULL, N'521320', NULL, NULL, 0, 15, NULL, N'6083722181', N'6083740289', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'321 Butts Ave', N'Tomah', N'WI', N'55081', N'54660', 43.98416, -90.514671, 3703, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6118, N'Ripon Medical Center', 1, NULL, NULL, N'521321', NULL, NULL, 0, 15, NULL, N'9207483101', N'9207480452', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'845 Parkside St', N'Ripon', N'WI', N'55039', N'54971', 43.84245, -88.837297, 3692, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6119, N'Grant Regional Health Center', 1, NULL, NULL, N'521322', NULL, NULL, 0, 15, NULL, N'6087232143', N'6087234464', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 S Monroe St', N'Lancaster', N'WI', N'55043', N'53813', 42.843982, -90.708524, 3659, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6120, N'Memorial Medical Center', 1, NULL, NULL, N'521323', NULL, NULL, 0, 25, NULL, N'7157433101', N'7157438015', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'216 Sunset Place', N'Neillsville', N'WI', N'55019', N'54456', 44.556515, -90.606921, 3672, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6121, N'Aspirus Medford Hospital & Clinics Inc', 1, NULL, NULL, N'521324', NULL, NULL, 0, 15, NULL, N'7157488100', N'7157488199', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'135 S Gibson St', N'Medford', N'WI', N'55119', N'54451', 45.135642, -90.353998, 3665, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6122, N'Flambeau Hospital', 1, NULL, NULL, N'521325', NULL, NULL, 0, 15, NULL, N'7157627500', N'7157627518', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'98 Sherry Ave', N'Park Falls', N'WI', N'55099', N'54552', 45.930915, -90.441984, 3679, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6123, N'Thedacare Medical Center New London', 1, NULL, NULL, N'521326', NULL, NULL, 0, 15, NULL, N'9205312000', N'9205312098', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1405 Mill St', N'New London', N'WI', N'55087', N'54961', 44.38118, -88.732762, 3673, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6124, N'Waupun Memorial Hospital', 1, NULL, NULL, N'521327', NULL, NULL, 0, 15, NULL, N'9203246530', N'9203242085', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'620 W Brown St', N'Waupun', N'WI', N'55027', N'53963', 43.630968, -88.745846, 3709, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6125, N'Rusk County Memorial Hospital', 1, NULL, NULL, N'521328', NULL, NULL, 0, 25, NULL, N'7155325561', N'7155329809', 1, 1, 0, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 College Ave West', N'Ladysmith', N'WI', N'55107', N'54848', 45.455495, -91.109436, 3658, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6126, N'St Marys Hospital Of Superior', 1, NULL, NULL, N'521329', NULL, NULL, 0, 15, NULL, N'7158177000', NULL, 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3500 Tower Ave', N'Superior', N'WI', N'55031', N'54880', 46.698195, -92.104048, 1903, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6127, N'Crossing Rivers Health Medical Center', 1, NULL, NULL, N'521330', NULL, NULL, 0, 25, NULL, N'6083572000', N'6083572100', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'37868 Us Hwy 18', N'Prairie Du Chien', N'WI', N'55023', N'53821', 43.01384, -91.094544, 3685, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6128, N'Burnett Medical Center', 1, NULL, NULL, N'521331', NULL, NULL, 0, 25, NULL, N'7154635353', N'7154632423', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'257 W St George Ave', N'Grantsburg', N'WI', N'55013', N'54840', 45.775542, -92.687201, 3648, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6129, N'Spooner Health System', 1, NULL, NULL, N'521332', NULL, NULL, 0, 25, NULL, N'7156352111', N'7156356846', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'819 Ash Street', N'Spooner', N'WI', N'55129', N'54801', 45.825977, -91.897162, 3697, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6130, N'Black River Memorial Hospital', 1, NULL, NULL, N'521333', NULL, NULL, 0, 25, NULL, N'7152845361', N'7152841390', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 W Adams St', N'Black River Falls', N'WI', N'55053', N'54615', 44.302401, -90.855853, 3628, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6131, N'Riverside Medical Center', 1, NULL, NULL, N'521334', NULL, NULL, 0, 25, NULL, N'7152581000', N'7152581009', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Riverside Drive', N'Waupaca', N'WI', N'55135', N'54981', 44.345489, -89.076208, 3708, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6132, N'Hudson Hospital', 1, NULL, NULL, N'521335', NULL, NULL, 0, 25, NULL, N'7155316000', N'7155316011', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'405 Stageline Road', N'Hudson', N'WI', N'55109', N'54016', 44.962871, -92.718041, 3653, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6133, N'Hayward Area Memorial Hospital', 1, NULL, NULL, N'521336', NULL, NULL, 0, 25, NULL, N'7159344321', N'7159344270', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11040 N State Rd 77', N'Hayward', N'WI', N'55113', N'54843', 46.05797, -91.509956, 3651, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6134, N'St Croix Regional Medical Center', 1, NULL, NULL, N'521337', NULL, NULL, 0, 25, NULL, N'7154833261', N'7154830295', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'235 State Street', N'Saint Croix Falls', N'WI', N'55095', N'54024', 45.409614, -92.643477, 3698, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6135, N'Columbus Community Hospital', 1, NULL, NULL, N'521338', NULL, NULL, 0, 25, NULL, N'9206232200', N'9206233546', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1515 Park Ave', N'Columbus', N'WI', N'55021', N'53925', 43.323391, -89.036747, 3635, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6136, N'od Samaritan Health Center', 1, NULL, NULL, N'521339', NULL, NULL, 0, 25, NULL, N'7155365511', N'7155392107', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'601 S Center Ave', N'Merrill', N'WI', N'55069', N'54452', 45.175497, -89.683199, 3668, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6137, N'Mayo Clinic Health System  Red Cedar', 1, NULL, NULL, N'521340', NULL, NULL, 0, 25, NULL, N'7152355531', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2321 Stout Rd', N'Menomonie', N'WI', N'55033', N'54751', 44.882555, -91.900511, 3667, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6138, N'Richland Hospital', 1, NULL, NULL, N'521341', NULL, NULL, 0, 25, NULL, N'6086476321', N'6086476235', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 E Second St', N'Richland Center', N'WI', N'55103', N'53581', 43.339118, -90.383236, 3691, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6139, N'Indianhead Medical Ctr', 1, NULL, NULL, N'521342', NULL, NULL, 0, 25, NULL, N'7154687833', N'7154687303', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'113 4Th Ave', N'Shell Lake', N'WI', N'55129', N'54871', 45.742302, -91.926367, 3696, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6140, N'Stoughton Hospital', 1, NULL, NULL, N'521343', NULL, NULL, 0, 25, NULL, N'6088736611', N'6088732315', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 Ridge St', N'Stoughton', N'WI', N'55025', N'53589', 42.920323, -89.210266, 3701, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6141, N'Gundersen Boscobel Area Hospital And Clinics', 1, NULL, NULL, N'521344', NULL, NULL, 0, 25, NULL, N'6083754112', N'6083756208', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'205 Parker St', N'Boscobel', N'WI', N'55043', N'53805', 43.132936, -90.708192, 3630, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6142, N'Westfields Hospital And Clinic', 1, NULL, NULL, N'521345', NULL, NULL, 0, 25, NULL, N'7152432600', N'7152432851', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'535 Hospital Rd', N'New Richmond', N'WI', N'55109', N'54017', 45.118137, -92.55321, 3674, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6143, N'Shawano Medical Ctr', 1, NULL, NULL, N'521346', NULL, NULL, 0, 25, NULL, N'7155262111', N'7155267205', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'309 N Bartlette St', N'Shawano', N'WI', N'55115', N'54166', 44.784053, -88.615516, 3694, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6144, N'Baldwin Area Medical Center', 1, NULL, NULL, N'521347', NULL, NULL, 0, 25, NULL, N'7156843311', N'7156844757', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'730 10Th Ave', N'Baldwin', N'WI', N'55109', N'54002', 44.970739, -92.374917, 3622, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6145, N'Vernon Memorial Hospital', 1, NULL, NULL, N'521348', NULL, NULL, 0, 25, NULL, N'6086372101', N'6086372141', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'507 South Main St', N'Viroqua', N'WI', N'55123', N'54665', 43.55146, -90.888946, 3705, 300, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6146, N'River Falls Area Hospital', 1, NULL, NULL, N'521349', NULL, NULL, 0, 25, NULL, N'7153076000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1629 E Division St', N'River Falls', N'WI', N'55093', N'54022', 44.8631, -92.602146, 3693, 155, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6147, N'Aspirus Langlade Hospital', 1, NULL, NULL, N'521350', NULL, NULL, 0, 25, NULL, N'7156232331', N'7156239440', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'112 E Fifth Ave', N'Anti', N'WI', N'55067', N'54409', 45.140319, -89.140292, 3618, 298, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6148, N'Reedsburg Area Medical Center', 1, NULL, NULL, N'521351', NULL, NULL, 0, 25, NULL, N'6085246487', NULL, 1, 1, 0, 0, 1, 1, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2000 N Dewey Ave', N'Reedsburg', N'WI', N'55111', N'53959', 43.549588, -89.994544, 3688, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6149, N'Upland Hills Health', 1, NULL, NULL, N'521352', NULL, NULL, 0, 25, NULL, N'6089308000', N'6089307250', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'800 Compassion Way', N'Dodgeville', N'WI', N'55049', N'53533', 42.952633, -90.130432, 3639, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6150, N'Cumberland Memorial Hospital', 1, NULL, NULL, N'521353', NULL, NULL, 0, 25, NULL, N'7158222741', N'7158226299', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1110 7Th Avenue', N'Cumberland', N'WI', N'55005', N'54829', 45.53091, -92.029673, 3637, 152, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6151, N'Southwest Health Center', 1, NULL, NULL, N'521354', NULL, NULL, 0, 25, NULL, N'6083482331', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 East Side Rd', N'Platteville', N'WI', N'55043', N'53818', 42.734294, -90.478445, 3681, 106, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6152, N'Berlin Memorial Hospital', 1, NULL, NULL, N'521355', NULL, NULL, 0, 25, NULL, N'9203611313', N'9203615579', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'225 Memorial Drive', N'Berlin', N'WI', N'55047', N'54923', 43.977623, -88.943226, 3627, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6153, N'Bellin Health Oconto Hospital', 1, NULL, NULL, N'521356', NULL, NULL, 0, 4, NULL, N'9208351101', N'9205167088', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'820 Arbutus Ave', N'Oconto', N'WI', N'55083', N'54153', 44.89625, -87.867172, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6154, N'Mercy Walworth Hospital & Medical Center', 1, NULL, NULL, N'521357', NULL, NULL, 0, 25, NULL, N'2622450535', N'2622452198', 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'N2950 State Road 67', N'Lake Geneva', N'WI', N'55127', N'53147', 42.597769, -88.540875, 3644, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6155, N'Ministry Door County Medical Center', 1, NULL, NULL, N'521358', NULL, NULL, 0, 25, NULL, N'9207435566', NULL, 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'323 South 18Th Avenue', N'Sturgeon Bay', N'WI', N'55029', N'54235', 44.832732, -87.351419, 3702, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6156, N'Memorial Medical Center', 1, NULL, NULL, N'521359', NULL, NULL, 0, 25, NULL, N'7156855500', N'7156824022', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1615 Maple Lane', N'Ashland', N'WI', N'55003', N'54806', 46.566879, -90.887908, 3621, 151, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6157, N'Clearview Home Corporation', 1, NULL, NULL, N'521990', NULL, NULL, 0, 12, NULL, N'2626463361', NULL, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'935 Main St', N'Delafield', N'WI', N'55133', N'53018', 43.060804, -88.405889, 3707, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6158, N'Post Acute Medical Specialty Hospital Of Milwaukee', 1, NULL, NULL, N'522004', NULL, NULL, 0, 62, NULL, N'4144278282', N'4145296656', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5017 S 110Th St', N'Greenfield', N'WI', N'55079', N'53228', 42.953824, -88.050402, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6159, N'Lakeview Specialty Hospital & Rehab Center', 1, NULL, NULL, N'522005', NULL, NULL, 0, 39, NULL, N'2625347297', N'2625347257', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1701 Sharp Road', N'Waterford', N'WI', N'55101', N'53185', 42.763072, -88.214256, 3632, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6160, N'Select Specialty Hospital Milwaukee', 1, NULL, NULL, N'522006', NULL, NULL, 0, 63, NULL, N'4143287700', N'4143287434', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8901 W Lincoln Ave  2Nd Floor', N'West Allis', N'WI', N'55079', N'53227', 43.001221, -88.024377, 3711, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6161, N'Lifecare Hospitals Of Wisconsin', 1, NULL, NULL, N'522007', NULL, NULL, 0, 17, NULL, N'2625242600', N'2625242631', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2400 lf Road', N'Pewaukee', N'WI', N'55133', N'53072', 43.050566, -88.294749, 3707, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6162, N'Select Specialty Hospital Madison', 1, NULL, NULL, N'522008', NULL, NULL, 0, 23, NULL, N'6082602700', N'6082569865', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'801 Braxton Place', N'Madison', N'WI', N'55025', N'53715', 43.066263, -89.399847, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6163, N'Sacred Heart Rehabilitation Institute', 1, NULL, NULL, N'523025', NULL, NULL, 0, 81, NULL, N'4145856700', N'8667474708', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2301 N Lake Drive  8Th Floor', N'Milwaukee', N'WI', N'55079', N'53211', 43.060688, -87.881525, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6164, N'Rehabilitation Hospital Of Wisconsin', 1, NULL, NULL, N'523027', NULL, NULL, 0, 40, NULL, N'2625218800', N'2625218876', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1625 Cold Water Creek Drive', N'Waukesha', N'WI', N'55133', N'53188', 43.011678, -88.231481, 3707, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6165, N'Childrens Hospital Of Wisconsin', 1, NULL, NULL, N'523300', NULL, NULL, 0, 296, NULL, N'4142662000', N'4142666409', 1, 1, 1, 1, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9000 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038823, -87.958978, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6166, N'Childrens Hospital Of Wisconsin Fox Valley', 1, NULL, NULL, N'523302', NULL, NULL, 0, 42, NULL, N'9209697900', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'130 Second St', N'Neenah', N'WI', N'55139', N'54956', 44.185819, -88.462609, 3671, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6167, N'Aurora Psychiatric Hospital', 1, NULL, NULL, N'524000', NULL, NULL, 0, 105, NULL, N'4144546600', N'4144546450', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1220 Dewey Ave', N'Wauwatosa', N'WI', N'55079', N'53213', 43.046545, -88.009412, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6168, N'Milwaukee County Behavioral Health Division', 1, NULL, NULL, N'524001', NULL, NULL, 0, 234, NULL, N'4142575202', N'4142578018', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9455 W Watertown Plank Rd', N'Milwaukee', N'WI', N'55079', N'53226', 43.04547, -88.060896, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6169, N'Winneba Mental Health Institute', 1, NULL, NULL, N'524002', NULL, NULL, 0, 315, NULL, N'9202354910', N'9202372043', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1300 South Drive', N'Winneba', N'WI', N'55139', N'54985', 44.073686, -88.52263, 3678, 304, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6170, N'Mendota Mental Health Institute', 1, NULL, NULL, N'524008', NULL, NULL, 0, 36, NULL, N'6083011000', N'6083011390', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 Troy Dr', N'Madison', N'WI', N'55025', N'53704', 43.129298, -89.400423, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6171, N'Brown County Community Treatment Ctr', 1, NULL, NULL, N'524014', NULL, NULL, 0, 88, NULL, N'9203914700', N'9203914870', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3150 Gershwin Drive', N'Green Bay', N'WI', N'55009', N'54311', 44.529941, -88.024832, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6172, N'North Central Health Care', 1, NULL, NULL, N'524017', NULL, NULL, 0, 16, NULL, N'7158484600', N'7158482362', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Lakeview Dr', N'Wausau', N'WI', N'55073', N'54403', 44.959602, -89.629824, 3710, 305, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6173, N'Rogers Memorial Hospital', 1, NULL, NULL, N'524018', NULL, NULL, 0, 168, NULL, N'2626464411', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'34700 Valley Rd', N'Oconomowoc', N'WI', N'55133', N'53066', 43.0843, -88.507411, 3675, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6174, N'Norwood Health Center', 1, NULL, NULL, N'524019', NULL, NULL, 0, 16, NULL, N'7153842188', N'7153871533', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1600 N Chestnut Ave', N'Marshfield', N'WI', N'55141', N'54449', 44.681776, -90.164872, 3663, 302, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6175, N'Fond Du Lac County Acute Psych Unit', 1, NULL, NULL, N'524025', NULL, NULL, 0, 25, NULL, N'9209293500', N'9209064768', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'459 E First St', N'Fond Du Lac', N'WI', N'55039', N'54935', 43.774876, -88.445803, 3645, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6176, N'Waukesha County Mental Health Ctr', 1, NULL, NULL, N'524026', NULL, NULL, 0, 28, NULL, N'2625487950', N'2628968046', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1501 Airport Rd', N'Waukesha', N'WI', N'55133', N'53188', 43.025117, -88.233523, 3707, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6177, N'Bellin Psychiatric Center', 1, NULL, NULL, N'524038', NULL, NULL, 0, 80, NULL, N'9204333630', N'9204370533', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'301 E St Joseph St', N'Green Bay', N'WI', N'55009', N'54301', 44.529941, -88.024832, 3649, 299, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6178, N'Aurora St Lukes Medical Center', 1, NULL, NULL, N'529801', NULL, NULL, 0, 0, NULL, N'4146461865', N'4146465452', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2900 W Oklahoma Ave  5Th Floor Galleria Building', N'Milwaukee', N'WI', N'55079', N'53215', 42.98862, -87.950865, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6179, N'University Of Wisconsin Hospitals And Clinics', 1, NULL, NULL, N'529802', NULL, NULL, 0, 0, NULL, N'6082657050', N'6082655568', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'600 Highland Ave', N'Madison', N'WI', N'55025', N'53792', 43.076379, -89.432009, 3660, 301, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6180, N'Childrens Hospital Of Wisconsin', 1, NULL, NULL, N'529803', NULL, NULL, 0, 0, NULL, N'4142662000', N'4142666409', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9000 W Wisconsin Aveune', N'Milwaukee', N'WI', N'55079', N'53226', 43.038823, -87.958978, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6181, N'Froedtert Memorial Lutheran Hospital', 1, NULL, NULL, N'529804', NULL, NULL, 0, 0, NULL, N'4148050008', N'4148057790', 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'9200 W Wisconsin Ave', N'Milwaukee', N'WI', N'55079', N'53226', 43.038823, -87.958978, 3669, 303, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6182, N'Campbell County Memorial Hospital', 1, NULL, NULL, N'530002', NULL, NULL, 0, 119, NULL, N'3076881551', N'3076881570', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'501 South Burma Avenue', N'Gillette', N'WY', N'56005', N'82716', 44.289804, -105.519557, 3724, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6183, N'Sheridan Memorial Hospital', 1, NULL, NULL, N'530006', NULL, NULL, 0, 88, NULL, N'3076721044', N'3076721007', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 W 5Th St', N'Sheridan', N'WY', N'56033', N'82801', 44.807403, -106.974875, 3736, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6184, N'Sagewest Health Care', 1, NULL, NULL, N'530008', NULL, NULL, 0, 159, NULL, N'3078564161', N'3078573571', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2100 W Sunset Dr', N'Riverton', N'WY', N'56013', N'82501', 43.033669, -108.418854, 3734, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6185, N'Memorial Hospital Sweetwater County', 1, NULL, NULL, N'530011', NULL, NULL, 0, 99, NULL, N'3073623711', N'3073528180', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1200 College Drive', N'Rock Springs', N'WY', N'56037', N'82901', 41.580666, -109.237176, 3735, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6186, N'Wyoming Medical Center', 1, NULL, NULL, N'530012', NULL, NULL, 0, 217, NULL, N'3075777201', N'3072371703', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1233 East 2Nd St', N'Casper', N'WY', N'56025', N'82601', 42.848717, -106.308505, 3719, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6187, N'Cheyenne Regional Medical Center', 1, NULL, NULL, N'530014', NULL, NULL, 0, 206, NULL, N'3076342273', N'3076337715', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'214 East 23Rd Street', N'Cheyenne', N'WY', N'56021', N'82001', 41.13979, -104.817035, 3720, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6188, N'St Johns Medical Center', 1, NULL, NULL, N'530015', NULL, NULL, 0, 42, NULL, N'3077333636', N'3077397596', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'625 East Broadway', N'Jackson', N'WY', N'56039', N'83001', 43.479689, -110.74908, 3725, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6189, N'Ivinson Memorial Hospital', 1, NULL, NULL, N'530025', NULL, NULL, 0, 99, NULL, N'3077422141', N'3077420678', 1, 1, 1, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'255 N 30Th', N'Laramie', N'WY', N'56001', N'82072', 41.312733, -105.557532, 3728, 44, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6190, N'Evanston Regional Hospital', 1, NULL, NULL, N'530032', NULL, NULL, 0, 42, NULL, N'3077893636', N'3077898187', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'190 Arrowhead Dr', N'Evanston', N'WY', N'56041', N'82930', 41.242224, -110.990352, 3723, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6191, N'Mountain View Regional Hospital', 1, NULL, NULL, N'530033', NULL, NULL, 0, 23, NULL, N'3079958100', N'3079958112', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6550 East 2Nd Street', N'Casper', N'WY', N'56025', N'82605', 42.839723, -106.226345, 3719, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6192, N'Summit Medical Center', 1, NULL, NULL, N'530034', NULL, NULL, 0, 16, NULL, N'3072326600', N'3073335733', 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6350 E 2Nd Street', N'Casper', N'WY', N'56025', N'82609', 42.848719, -106.303224, 3719, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6193, N'South Big Horn County Critical Access Hospital', 1, NULL, NULL, N'531301', NULL, NULL, 0, 6, NULL, N'3075683311', N'3075682139', 1, 1, 1, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'388 Us Highway 20 South', N'Basin', N'WY', N'56003', N'82410', 44.434974, -108.049004, 3741, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6194, N'Memorial Hospital Of Converse County', 1, NULL, NULL, N'531302', NULL, NULL, 0, 25, NULL, N'3073582122', N'3073583630', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'111 South 5Th Street', N'Douglas', N'WY', N'56009', N'82633', 42.759377, -105.38127, 3722, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6195, N'Weston County Health Services', 1, NULL, NULL, N'531303', NULL, NULL, 0, 21, NULL, N'3077464491', N'3077463728', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1124 Washington Boulevard', N'Newcastle', N'WY', N'56045', N'82701', 43.848742, -104.189089, 3731, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6196, N'Hot Springs County Memorial Hospital', 1, NULL, NULL, N'531304', NULL, NULL, 0, 25, NULL, N'3078643121', N'3078645050', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'150 East Arapahoe', N'Thermopolis', N'WY', N'56017', N'82443', 43.64743, -108.199713, 3738, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6197, N'Platte County Memorial Hospital', 1, NULL, NULL, N'531305', NULL, NULL, 0, 25, NULL, N'3073223636', N'3073221504', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 14Th Street', N'Wheatland', N'WY', N'56031', N'82201', 42.04981, -104.960221, 3740, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6198, N'Washakie Medical Center', 1, NULL, NULL, N'531306', NULL, NULL, 0, 25, NULL, N'3073473221', N'3073476937', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'400 South 15Th Street', N'Worland', N'WY', N'56043', N'82401', 44.013755, -107.948409, 3741, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6199, N'Community Hospital', 1, NULL, NULL, N'531307', NULL, NULL, 0, 25, NULL, N'3075324181', N'3075323800', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Campbell Drive', N'Torrington', N'WY', N'56015', N'82240', 42.081734, -104.191509, 3739, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6200, N'Johnson County Healthcare Center', 1, NULL, NULL, N'531308', NULL, NULL, 0, 25, NULL, N'3076845521', N'3076845385', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'497 West Lott', N'Buffalo', N'WY', N'56019', N'82834', 44.34964, -106.705161, 3718, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6201, N'North Big Horn Hospital District', 1, NULL, NULL, N'531309', NULL, NULL, 0, 15, NULL, N'3075485200', N'3075485205', 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'1115 Lane 12', N'Lovell', N'WY', N'56003', N'82431', 44.825803, -108.390025, 3729, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6202, N'Powell Valley Hospital', 1, NULL, NULL, N'531310', NULL, NULL, 0, 25, NULL, N'3077542267', N'3077547790', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'777 Avenue H', N'Powell', N'WY', N'56029', N'82435', 44.756616, -108.770443, 3732, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6203, N'Crook County Hospital', 1, NULL, NULL, N'531311', NULL, NULL, 0, 16, NULL, N'3072833501', N'3072833506', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'713 Oak Street', N'Sundance', N'WY', N'56011', N'82729', 44.408355, -104.374763, 3737, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6204, N'West Park Hospital District', 1, NULL, NULL, N'531312', NULL, NULL, 0, 25, NULL, N'3075782488', N'3075782485', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Sheridan Avenue', N'Cody', N'WY', N'56029', N'82414', 44.526025, -109.073577, 3721, 168, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6205, N'Star Valley Medical Center', 1, NULL, NULL, N'531313', NULL, NULL, 0, 20, NULL, N'3078855800', N'3078855889', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'901 Adams Street', N'Afton', N'WY', N'56023', N'83110', 42.718962, -110.931009, 3717, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6206, N'Niobrara Health & Life Center', 1, NULL, NULL, N'531314', NULL, NULL, 0, 24, NULL, N'3073344000', N'3073340124', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'921 South Ballancee Avenue', N'Lusk', N'WY', N'56027', N'82225', 42.762467, -104.452175, 3730, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6207, N'South Lincoln Medical Center - Cah', 1, NULL, NULL, N'531315', NULL, NULL, 0, 16, NULL, N'3078774401', N'3078773236', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'711 Onyx Street', N'Kemmerer', N'WY', N'56023', N'83101', 41.789572, -110.540494, 3726, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6208, N'Memorial Hospital Of Carbon County', 1, NULL, NULL, N'531316', NULL, NULL, 0, 25, NULL, N'3073242221', N'3073248232', 1, 1, 1, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2221 West Elm Street', N'Rawlins', N'WY', N'56007', N'82301', 41.786586, -107.261223, 3733, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6209, N'Elkhorn Valley Rehabilitation Hospital Llc', 1, NULL, NULL, N'533027', NULL, NULL, 0, 41, NULL, N'3072650005', N'3072652860', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5715 East 2Nd Street', N'Casper', N'WY', N'56025', N'82609', 42.848719, -106.303224, 3719, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6210, N'Wyoming State Hospital', 1, NULL, NULL, N'534001', NULL, NULL, 0, 183, NULL, N'3077893464', N'3077895277', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'831 Hwy 150 South', N'Evanston', N'WY', N'56041', N'82931', 41.268047, -110.963323, 3723, 279, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6211, N'Wyoming Behavioral Institute', 1, NULL, NULL, N'534004', NULL, NULL, 0, 85, NULL, N'3072377444', N'3072655525', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2521 East 15Th Street', N'Casper', N'WY', N'56025', N'82609', 42.835414, -106.294691, 3719, 306, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6212, N'Lbj Tropical Medical Center', 1, NULL, NULL, N'640001', NULL, NULL, 0, 120, NULL, N'6846334590', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Fagaalu Village', N'Pa Pa', NULL, NULL, N'96799', -14.252294, -170.71345, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6213, N'Commonwealth Health Center', 1, NULL, NULL, N'660001', NULL, NULL, 0, 86, NULL, N'6702348950', N'6702368600', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'Po Box 409Ck Navy Hill Road', N'Garapan', NULL, NULL, N'96950', 15.205696, 145.718347, NULL, NULL, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6214, N'St Marks Medical Center', 1, NULL, NULL, N'670004', NULL, NULL, 0, 65, NULL, N'9792422200', N'9792422299', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'One St Mark''s Place', N'La Grange', N'TX', N'48149', N'78945', 29.905503, -96.876647, 3317, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6215, N'Memorial Hermann Surgical Hospital Kingwood', 1, NULL, NULL, N'670005', NULL, NULL, 0, 10, NULL, N'2813124000', N'2813582461', 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'300 Kingwood Medical Drive', N'Kingwood', N'TX', N'48201', N'77339', 30.047162, -95.258247, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6216, N'The Hospital At Westlake Medical Center', 1, NULL, NULL, N'670006', NULL, NULL, 0, 23, NULL, N'5123270000', N'5123296688', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5656 Bee Caves Road Suite M-302', N'Austin', N'TX', N'48453', N'78746', 30.294611, -97.82469, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6217, N'Houston Physicians'' Hospital', 1, NULL, NULL, N'670008', NULL, NULL, 0, 21, NULL, N'2813351700', N'2813341708', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'333 N Texas Avenue', N'Webster', N'TX', N'48201', N'77598', 29.53456, -95.12547, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6218, N'Mayhill Hospital', 1, NULL, NULL, N'670010', NULL, NULL, 0, 59, NULL, N'9402393000', N'9402393090', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2809 South Mayhill Road', N'Denton', N'TX', N'48121', N'76208', 33.17775, -97.087108, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6219, N'University General Hospital', 1, NULL, NULL, N'670019', NULL, NULL, 0, 72, NULL, N'7136523800', N'7136523888', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7501 Fannin', N'Houston', N'TX', N'48201', N'77054', 29.692834, -95.400999, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6220, N'Innova Hospital San Antonio', 1, NULL, NULL, N'670021', NULL, NULL, 0, 9, NULL, N'2103687487', N'2103687446', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4243 Southcross Blvd', N'San Antonio', N'TX', N'48029', N'78222', 29.374943, -98.411352, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6221, N'Methodist Mansfield Medical Center', 1, NULL, NULL, N'670023', NULL, NULL, 0, 88, NULL, N'6826222059', N'6886222051', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2700 E Broad Street', N'Mansfield', N'TX', N'48439', N'76063', 32.568584, -97.096962, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6222, N'North Cypress Medical Center', 1, NULL, NULL, N'670024', NULL, NULL, 0, 139, NULL, N'2818900203', N'7134666050', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21214 Northwest Freeway', N'Cypress', N'TX', N'48201', N'77429', 29.92482, -95.632487, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6223, N'The Heart Hospital Baylor Plano', 1, NULL, NULL, N'670025', NULL, NULL, 0, 68, NULL, N'4698143278', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1100 Allied Drive', N'Plano', N'TX', N'48085', N'75093', 33.015635, -96.789918, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6224, N'Acuity Hospital Of Houston', 1, NULL, NULL, N'670027', NULL, NULL, 0, 18, NULL, N'7137950200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2001 Hermann Drive', N'Houston', N'TX', N'48201', N'77004', 29.717703, -95.382989, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6225, N'St Luke''s Patients Medical Center', 1, NULL, NULL, N'670031', NULL, NULL, 0, 61, NULL, N'2814870700', N'2814870788', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4600 East Sam Houston Parkway South', N'Pasadena', N'TX', N'48201', N'77505', 29.640397, -95.160584, 3353, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6226, N'Scott & White Hospital-Round Rock', 1, NULL, NULL, N'670034', NULL, NULL, 0, 101, NULL, N'5125090100', N'5125090257', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'300 University Blvd', N'Round Rock', N'TX', N'48491', N'78664', 30.560291, -97.684909, 3367, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6227, N'Seton Medical Center Williamson', 1, NULL, NULL, N'670041', NULL, NULL, 0, 149, NULL, N'5123240000', NULL, 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'201 Seton Parkway', N'Round Rock', N'TX', N'48491', N'78664', 30.567944, -97.652784, 3367, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6228, N'Cedar Park Regional Medical Center', 1, NULL, NULL, N'670043', NULL, NULL, 0, 85, NULL, N'5125287000', N'5122599772', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1401 Medical Parkway', N'Cedar Park', N'TX', N'48491', N'78613', 30.530162, -97.810854, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6229, N'Texas Health Presbyterian Hospital Rockwall', 1, NULL, NULL, N'670044', NULL, NULL, 0, 50, NULL, N'4696981000', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3150 Horizon Road', N'Rockwall', N'TX', N'48397', N'75032', 32.885751, -96.464308, 3368, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6230, N'Cook Childrens Northeast Hospital Llc', 1, NULL, NULL, N'670045', NULL, NULL, 0, 3, NULL, N'8176052500', N'8176052985', 1, 1, 0, 1, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6316 Precinct Line Rd', N'Hurst', N'TX', N'48439', N'76054', 32.863272, -97.186133, 3220, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6231, N'Usmd Hospital  At Fort Worth Lp', 1, NULL, NULL, N'670046', NULL, NULL, 0, 8, NULL, N'8174339100', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5900 Altamesa Blvd', N'Fort Worth', N'TX', N'48439', N'76132', 32.645592, -97.41814, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6232, N'Sierra Providence East Medical Center', 1, NULL, NULL, N'670047', NULL, NULL, 0, 110, NULL, N'9158567349', N'9158567334', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3280 Joe Battle Blvd', N'El Paso', N'TX', N'48141', N'79938', 31.790511, -106.267642, 3268, 262, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6233, N'North Central Surgical Center Llp', 1, NULL, NULL, N'670049', NULL, NULL, 0, 17, NULL, N'2142652810', N'2148534385', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9301 North Central Expressway Suite 100', N'Dallas', N'TX', N'48113', N'75231', 32.874836, -96.770604, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6234, N'Trustpoint Hospital Of Lubbock', 1, NULL, NULL, N'670050', NULL, NULL, 0, 71, NULL, N'8067492222', N'8067495555', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4302 Princeton', N'Lubbock', N'TX', N'48303', N'79415', 33.617021, -101.900489, 3326, 267, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6235, N'St Luke''s Sugar Land Hospital', 1, NULL, NULL, N'670053', NULL, NULL, 0, 100, NULL, N'2816377000', N'2816377938', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1317 Lake Pointe Parkway', N'Sugar Land', N'TX', N'48157', N'77478', 29.604655, -95.621302, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6236, N'Foundation Surgical Hospital Of San Antonio', 1, NULL, NULL, N'670054', NULL, NULL, 0, 20, NULL, N'2104785400', N'2104785401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9522 Huebner Road', N'San Antonio', N'TX', N'48029', N'78240', 29.531035, -98.592554, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6237, N'Methodist Stone Oak Hospital', 1, NULL, NULL, N'670055', NULL, NULL, 0, 140, NULL, N'2106382100', N'2106383876', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1139 E Sonterra Blvd', N'San Antonio', N'TX', N'48029', N'78258', 29.614811, -98.47406, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6238, N'Seton Medical Center Hays', 1, NULL, NULL, N'670056', NULL, NULL, 0, 112, NULL, N'5123245000', N'5123807556', 1, 1, 1, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6001 Kyle Pkwy', N'Kyle', N'TX', N'48209', N'78640', 30.007734, -97.85528, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6239, N'Emerus Hospital', 1, NULL, NULL, N'670058', NULL, NULL, 0, 7, NULL, N'2815160911', N'2815164511', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16000 Southwest Freeway', N'Sugar Land', N'TX', N'48157', N'77479', 29.597792, -95.623799, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6240, N'St Lukes Lakeside Hospital', 1, NULL, NULL, N'670059', NULL, NULL, 0, 30, NULL, N'9362664055', N'9362664051', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17400 St Lukes Way', N'The Woodlands', N'TX', N'48339', N'77384', 30.199789, -95.459386, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6241, N'Texas Regional Medical Center At Sunnyvale', 1, NULL, NULL, N'670060', NULL, NULL, 0, 20, NULL, N'9728923000', N'9728924401', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'231 South Collins Road', N'Sunnyvale', N'TX', N'48113', N'75182', 32.780308, -96.565611, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6242, N'South Texas Surgical Hospital', 1, NULL, NULL, N'670061', NULL, NULL, 0, 33, NULL, N'3619932000', N'3619856834', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6130 Parkway Drive', N'Corpus Christi', N'TX', N'48355', N'78414', 27.687208, -97.374867, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6243, N'Baylor Emergency Medical Center', 1, NULL, NULL, N'670062', NULL, NULL, 0, 2, NULL, N'9723472525', N'9723476725', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'26791 Highway 380', N'Aubrey', N'TX', N'48121', N'76227', 33.304283, -96.986118, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6244, N'Baylor Orthopedic And Spine Hospital At Arlington', 1, NULL, NULL, N'670067', NULL, NULL, 0, 24, NULL, N'8175492364', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'707 Highlander Blvd', N'Arlington', N'TX', N'48439', N'76015', 32.682606, -97.115508, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6245, N'Texas Health Presbyterian Hospital Flower Mound', 1, NULL, NULL, N'670068', NULL, NULL, 0, 103, NULL, N'9724191530', N'9724191545', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'4400 Long Prairie Road', N'Flower Mound', N'TX', N'48121', N'75028', 33.045812, -97.069324, 3321, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6246, N'Methodist Mckinney Hospital', 1, NULL, NULL, N'670069', NULL, NULL, 0, 12, NULL, N'4694246400', N'4694246401', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8000 W Eldorado Pkwy', N'Mc Kinney', N'TX', N'48085', N'75070', 33.175803, -96.72431, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6247, N'Texas Health Heart & Vascular Hospital Arlington', 1, NULL, NULL, N'670071', NULL, NULL, 0, 48, NULL, N'8179603500', N'8179603589', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'811 Wright Street', N'Arlington', N'TX', N'48439', N'76012', 32.748209, -97.115578, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6248, N'Hopebridge Hospital', 1, NULL, NULL, N'670072', NULL, NULL, 0, 137, NULL, N'7134222650', N'7135903395', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5556 Gasmer Drive', N'Houston', N'TX', N'48201', N'77035', 29.651317, -95.460642, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6249, N'Methodist Hospital For Surgery', 1, NULL, NULL, N'670073', NULL, NULL, 0, 32, NULL, N'4692483900', N'4692483901', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'17101 Dallas Parkway', N'Addison', N'TX', N'48113', N'75001', 32.986214, -96.828773, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6250, N'St Luke''s Hospital At The Vintage', 1, NULL, NULL, N'670075', NULL, NULL, 0, 106, NULL, N'8325345000', N'7138522210', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20171 Chasewood Park Drive', N'Houston', N'TX', N'48201', N'77070', 29.989489, -95.570248, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6251, N'Baylor Scott And White Surgical Hospital At Sherma', 1, NULL, NULL, N'670076', NULL, NULL, 0, 14, NULL, N'9038133728', N'9038133784', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3601 Calais Drive', N'Sherman', N'TX', N'48181', N'75090', 33.617501, -96.595493, 3375, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6252, N'Methodist West Houston Hospital', 1, NULL, NULL, N'670077', NULL, NULL, 0, 100, NULL, N'8325221000', N'8325220351', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18500 Katy Freeway', N'Houston', N'TX', N'48201', N'77094', 29.785529, -95.697331, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6253, N'Baptist Emergency Hospital', 1, NULL, NULL, N'670078', NULL, NULL, 0, 42, NULL, N'2104024092', N'2104024056', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'16088 San Pedro', N'San Antonio', N'TX', N'48029', N'78232', 29.588034, -98.474175, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6254, N'Lakeway Regional Medical Center Llc', 1, NULL, NULL, N'670079', NULL, NULL, 0, 106, NULL, N'5122058102', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'100  Medical Parkway', N'Lakeway', N'TX', N'48453', N'78734', 30.334275, -97.970505, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6255, N'Seton Medical Center Harker Heights', 1, NULL, NULL, N'670080', NULL, NULL, 0, 83, NULL, N'2549538342', N'2549538344', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'850 W Central Texas Expressway', N'Harker Heights', N'TX', N'48027', N'76548', 31.074298, -97.683725, 3314, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6256, N'Baylor Scott And White  Medical Center  Mckinney', 1, NULL, NULL, N'670082', NULL, NULL, 0, 95, NULL, N'4697422200', N'4697429685', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5252 West University Drive', N'Mc Kinney', N'TX', N'48085', N'75071', 33.218404, -96.681052, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6257, N'Texas General Hospital', 1, NULL, NULL, N'670083', NULL, NULL, 0, 41, NULL, N'4696352073', NULL, 1, 1, 0, 0, 1, 0, 0, 0, 0, 0, 0, 0, NULL, NULL, N'2709 Hospital Blvd', N'Grand Prairie', N'TX', N'48113', N'75051', 32.733743, -97.050999, 3287, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6258, N'Texas Health Harris Methodist Hospital Alliance', 1, NULL, NULL, N'670085', NULL, NULL, 0, 58, NULL, N'6822122004', N'6822129201', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'10864 Texas Health Trail', N'Fort Worth', N'TX', N'48439', N'76244', 32.931717, -97.309987, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6259, N'Baylor Scott & White Emergency Medical Center At C', 1, NULL, NULL, N'670087', NULL, NULL, 0, 8, NULL, N'5126844911', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 East Whitestone Blvd', N'Cedar Park', N'TX', N'48491', N'78613', 30.52395, -97.82018, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6260, N'Scott & White Hospital- College Station', 1, NULL, NULL, N'670088', NULL, NULL, 0, 119, NULL, N'9796913701', N'9796913615', 1, 1, 0, 0, 1, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 Scott & White Drive', N'College Station', N'TX', N'48041', N'77845', 30.625346, -96.327154, 3231, 259, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6261, N'Nix Community General Hospital', 1, NULL, NULL, N'670089', NULL, NULL, 0, 18, NULL, N'2102712190', N'2102712023', 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'230 West Miller Street', N'Dilley', N'TX', N'48163', N'78017', 28.669867, -99.172453, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6262, N'Crescent Medical Center Lancaster', 1, NULL, NULL, N'670090', NULL, NULL, 0, 84, NULL, N'9722308888', N'4692975702', 1, 1, 0, 1, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2600 West Pleasant Run Road', N'Lancaster', N'TX', N'48113', N'75146', 32.604128, -96.814483, 3319, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6263, N'Walnut Hill Medical Center', 1, NULL, NULL, N'670092', NULL, NULL, 0, 100, NULL, N'9728636000', N'9728636020', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7502 Greenville Avenue', N'Dallas', N'TX', N'48113', N'75231', 32.883788, -96.758945, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6264, N'Aspire Behavioral Health Of Conroe Llc', 1, NULL, NULL, N'670093', NULL, NULL, 0, 30, NULL, N'9366473500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2006 South Loop 336 West Suite 500', N'Conroe', N'TX', N'48339', N'77304', 30.2844624, -95.4838801, 3249, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6265, N'Little River Healthcare Cameron Hospital', 1, NULL, NULL, N'670094', NULL, NULL, 0, 10, NULL, N'2546050025', N'2546050029', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'806 N Crockett Ave', N'Cameron', N'TX', N'48331', N'76520', 30.856802, -96.976839, 3234, 272, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6266, N'Emerus Community Hospital', 1, NULL, NULL, N'670095', NULL, NULL, 0, 8, NULL, N'2815160911', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'24429 Tomball Parkway Suite 100', N'Tomball', N'TX', N'48201', N'77375', 30.037379, -95.605451, 3386, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6267, N'Bay Area Regional Medical Center Llc', 1, NULL, NULL, N'670096', NULL, NULL, 0, 104, NULL, N'2815257000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'200 Blossom Street', N'Webster', N'TX', N'48201', N'77598', 29.544291, -95.125078, 3395, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6268, N'Baylor Emergency Medical Center', 1, NULL, NULL, N'670097', NULL, NULL, 0, 8, NULL, N'2142946200', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1975 Alpha Ste 100', N'Rockwall', N'TX', N'48397', N'75087', 32.914368, -96.445142, 3368, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6269, N'Resolute Health Hospital', 1, NULL, NULL, N'670098', NULL, NULL, 0, 128, NULL, N'4698396778', N'4698938628', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'555 Creekside Xing', N'New Braunfels', N'TX', N'48091', N'78130', 29.719394, -98.071408, 3344, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6270, N'Emil J Freireich Cancer Center', 1, NULL, NULL, N'670099', NULL, NULL, 0, 5, NULL, N'8553532201', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'9201 Pinecroft', N'Shenandoah', N'TX', N'48339', N'77380', 30.177507, -95.456784, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6271, N'Victory Surgical Hospital East Houston', 1, NULL, NULL, N'670102', NULL, NULL, 0, 4, NULL, N'7133303897', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12950 East Freeway', N'Houston', N'TX', N'48201', N'77015', 29.772027, -95.200622, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6272, N'Medical Center Of Alliance', 1, NULL, NULL, N'670103', NULL, NULL, 0, 55, NULL, N'8176391100', N'8176391199', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3101 North Tarrant Parkway', N'Fort Worth', N'TX', N'48439', N'76177', 32.898534, -97.313849, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6273, N'Pearland Medical Center', 1, NULL, NULL, N'670106', NULL, NULL, 0, 33, NULL, N'7137707000', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'11100 Shadow Creek Parkway', N'Pearland', N'TX', N'48039', N'77584', 29.579539, -95.396238, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6274, N'Baylor Emergency Medical Center', 1, NULL, NULL, N'670107', NULL, NULL, 0, 16, NULL, N'2142946250', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'12500 South Freeway Suite 100', N'Burleson', N'TX', N'48251', N'76028', 32.577787, -97.317275, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6275, N'Baylor Scott & White Medical Center - Marble Falls', 1, NULL, NULL, N'670108', NULL, NULL, 0, 46, NULL, N'8302017308', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'810 W Highway 71', N'Marble Falls', N'TX', N'48053', N'78654', 30.578726, -98.271724, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6276, N'Altus Baytown Hosptial', 1, NULL, NULL, N'670109', NULL, NULL, 0, 14, NULL, N'2818377600', NULL, 1, 1, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1626 W Baker Rd', N'Baytown', N'TX', N'48201', N'77521', 29.769857, -94.984017, 3218, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6277, N'Warm Springs Rehabilitation Hospital Of Allen', 1, NULL, NULL, N'673025', NULL, NULL, 0, 40, NULL, N'9729082015', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1001 Raintree Circle', N'Allen', N'TX', N'48085', N'75013', 33.103174, -96.67055, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6278, N'Gulf States Ltac Of New Braunfels', 1, NULL, NULL, N'673026', NULL, NULL, 0, 40, NULL, N'8306277600', N'8306277603', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1445 Hanz Drive', N'New Braunfels', N'TX', N'48091', N'78130', 29.727461, -98.101563, 3344, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6279, N'Central Texas Rehabilitation Hospital', 1, NULL, NULL, N'673027', NULL, NULL, 0, 50, NULL, N'5124072101', N'5123230790', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'700 W 45Th St', N'Austin', N'TX', N'48453', N'78705', 30.320095, -97.751722, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6280, N'Dallas Ltach Llc', 1, NULL, NULL, N'673028', NULL, NULL, 0, 60, NULL, N'4692326500', N'4692326501', 1, 1, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'8050 Meadow Road', N'Dallas', N'TX', N'48113', N'75231', 32.88737, -96.767572, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6281, N'Reliant Rehabilitation Hospital North Texas', 1, NULL, NULL, N'673029', NULL, NULL, 0, 50, NULL, N'9723985700', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3351 Waterview Parkway', N'Richardson', N'TX', N'48113', N'75080', 32.98229, -96.756736, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6282, N'Kate Dishman Rehabilitation Hospital', 1, NULL, NULL, N'673030', NULL, NULL, 0, 27, NULL, N'4098998380', N'4098998381', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2830  Calder St 6Th Fl South', N'Beaumont', N'TX', N'48245', N'77702', 30.086046, -94.101846, 3219, 258, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6283, N'Methodist Rehabilitation Hospital', 1, NULL, NULL, N'673031', NULL, NULL, 0, 40, NULL, N'9727088600', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3020 West Wheatland Road', N'Dallas', N'TX', N'48113', N'75237', 32.647493, -96.870175, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6284, N'Reliant Rehabilitation Hospital Of Central Texas', 1, NULL, NULL, N'673032', NULL, NULL, 0, 75, NULL, N'9723088517', N'9723088509', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1400 Hester''s Crossing', N'Round Rock', N'TX', N'48491', N'78681', 30.488592, -97.677772, 3367, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6285, N'Baylor Institute For Rehabilitation At Northwest D', 1, NULL, NULL, N'673033', NULL, NULL, 0, 42, NULL, N'2148797300', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1340 Empire Central Drive', N'Dallas', N'TX', N'48113', N'75247', 32.826707, -96.871191, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6286, N'Reliant Rehabilitation Hospital North Houston', 1, NULL, NULL, N'673034', NULL, NULL, 0, 60, NULL, N'9364441700', N'9364441980', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'117 Vision Park Blvd', N'Shenandoah', N'TX', N'48339', N'77302', 30.190123, -95.459675, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6287, N'Baylor Institute For Rehabilitation At Fort Worth', 1, NULL, NULL, N'673035', NULL, NULL, 0, 42, NULL, N'2145250619', NULL, 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6601 Harris Parkway', N'Fort Worth', N'TX', N'48439', N'76132', 32.653419, -97.419215, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6288, N'Select Rehabilitation Hospital Of Denton', 1, NULL, NULL, N'673036', NULL, NULL, 0, 44, NULL, N'9402976500', N'9409276565', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2620 Scripture Street', N'Denton', N'TX', N'48121', N'76201', 33.219155, -97.165546, 3260, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6289, N'Memorial Hermann Rehabilitation Hospital Katy', 1, NULL, NULL, N'673038', NULL, NULL, 0, 118, NULL, N'2815795678', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'21720 Kingsland Blvd Suite 102', N'Katy', N'TX', N'48201', N'77450', 29.785785, -95.824396, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6290, N'Reliant Rehabilitation Hospital  Abilene', 1, NULL, NULL, N'673039', NULL, NULL, 0, 30, NULL, N'3256911600', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'6401 Directors Parkway', N'Abilene', N'TX', N'48441', N'79606', 32.371325, -99.745065, 3201, 255, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6291, N'Select Rehabilitation Hospital Of San Antonio', 1, NULL, NULL, N'673040', NULL, NULL, 0, 42, NULL, N'2104823400', N'2103823401', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'19126 Stone Hue', N'San Antonio', N'TX', N'48029', N'78258', 29.4246, -98.49514, 3370, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6292, N'Carrus Rehabilitation Hospital', 1, NULL, NULL, N'673041', NULL, NULL, 0, 24, NULL, N'9038702600', N'9038702601', 1, 1, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1810 West Highway 82', N'Sherman', N'TX', N'48181', N'75092', 33.617501, -96.595493, 3375, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6293, N'Healthsouth Sugar Land Rehabilitation Hospital', 1, NULL, NULL, N'673042', NULL, NULL, 0, 50, NULL, N'2812767599', N'2814944950', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1325 Hwy 6', N'Sugar Land', N'TX', N'48157', N'77478', 29.619679, -95.634946, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6294, N'Reliant Rehabilitation Hospital Dallas', 1, NULL, NULL, N'673043', NULL, NULL, 0, 60, NULL, N'2147068200', N'2147068384', 1, 1, 0, 0, 0, 1, 0, 1, 0, 0, 0, 0, NULL, NULL, N'7930 Northaven Road', N'Dallas', N'TX', N'48113', N'75230', 32.776272, -96.796856, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6295, N'Reliant Rehabilitation Hospital Midcities Lp', 1, NULL, NULL, N'673044', NULL, NULL, 0, 60, NULL, N'8176842000', N'8176842162', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2304 Highway 121', N'Bedford', N'TX', N'48439', N'76021', 32.844017, -97.143067, 3220, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6296, N'Mesquite Rehabilitation Institute', 1, NULL, NULL, N'673045', NULL, NULL, 0, 20, NULL, N'9722162400', N'9722162455', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'1023 N Beltline Road', N'Mesquite', N'TX', N'48113', N'75149', 32.76661, -96.599472, 3255, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6297, N'Baylor Institute For Rehabilitation At Frisco', 1, NULL, NULL, N'673046', NULL, NULL, 0, 44, NULL, N'4698885100', N'4698885222', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2990 Legacy Drive', N'Frisco', N'TX', N'48085', N'75034', 33.116422, -96.839842, 3334, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6298, N'Continuum Rehabilitation Hospital Of North Texas L', 1, NULL, NULL, N'673047', NULL, NULL, 0, 29, NULL, N'2145130310', N'2145130329', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'3100 Peters Colony Road', N'Flower Mound', N'TX', N'48121', N'75022', 33.014567, -97.096955, 3321, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6299, N'Texas Rehabilitation Hospital', 1, NULL, NULL, N'673048', NULL, NULL, 0, 66, NULL, N'8178203400', N'8178203470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'425 Alabama Avenue', N'Fort Worth', N'TX', N'48439', N'76104', 32.740859, -97.341286, 3274, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6300, N'New Braunfels Reg Rehab Hosp Inc', 1, NULL, NULL, N'673049', NULL, NULL, 0, 40, NULL, N'8306276700', N'8306276701', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2041 Sundance Parkway', N'New Braunfels', N'TX', N'48091', N'78130', 29.734627, -98.094596, 3344, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6301, N'Healthsouth Rehabilitation Hospital Of Cypress', 1, NULL, NULL, N'673050', NULL, NULL, 0, 40, NULL, N'8322802500', N'8322500279', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'13031 Wortham Center Drive', N'Houston', N'TX', N'48201', N'77065', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6302, N'Kindred Rehabilitation Hospital Northeast Houston', 1, NULL, NULL, N'673051', NULL, NULL, 0, 46, NULL, N'2814463655', N'2814461381', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'18839 Mckay Boulevard', N'Humble', N'TX', N'48201', N'77338', 29.998831, -95.262155, 3300, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6303, N'Reliant Northwest Houston', 1, NULL, NULL, N'673052', NULL, NULL, 0, 60, NULL, N'9723088567', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'20180 Chasewood Park Drive', N'Houston', N'TX', N'48201', N'77070', 29.758938, -95.367697, 3299, 265, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6304, N'Corpus Christi Rehabilitation Hospital Llc', 1, NULL, NULL, N'673053', NULL, NULL, 0, 35, NULL, N'3619911007', N'3619912031', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5726 Esplanade Drive', N'Corpus Christi', N'TX', N'48355', N'78414', 27.688816, -97.37969, 3250, 260, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6305, N'Reliant Austin', 1, NULL, NULL, N'673054', NULL, NULL, 0, 60, NULL, N'9723088567', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'330 W Ben White Blvd', N'Austin', N'TX', N'48453', N'78704', 30.22585, -97.766248, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6306, N'Accel Rehabilitation Hospital Of Plano', 1, NULL, NULL, N'673055', NULL, NULL, 0, 42, NULL, N'9728995510', N'9728994389', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2301 Marsh Lane Suite 200', N'Plano', N'TX', N'48085', N'75093', 32.979762, -96.85574, 3357, 261, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6307, N'Warm Springs Rehabilitation Hospital Of Victoria', 1, NULL, NULL, N'673056', NULL, NULL, 0, 26, NULL, N'3618947830', N'3615805174', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'101 James Coleman Drive', N'Victoria', N'TX', N'48469', N'77904', 28.856007, -97.023421, 3391, 274, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6308, N'Warm Springs Rehabilitation Hospital Of Kyle', 1, NULL, NULL, N'673057', NULL, NULL, 0, 40, NULL, N'5122620821', NULL, 1, 0, 0, 0, 1, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'5980 Kyle Parkway', N'Kyle', N'TX', N'48209', N'78640', 30.012787, -97.860442, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6309, N'Vibra  Rehabilitation Hospital Of Lake Travis', 1, NULL, NULL, N'673058', NULL, NULL, 0, 36, NULL, N'5122634500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2000 Medical Drive', N'Lakeway', N'TX', N'48453', N'78734', 30.364489, -97.987532, 3215, 257, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6310, N'Laredo Rehabilitation Hospital Llc', 1, NULL, NULL, N'673059', NULL, NULL, 0, 20, NULL, N'9567648555', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'2005 A Bustamante Street', N'Laredo', N'TX', N'48479', N'78041', 27.5336821, -99.475812, 3320, 271, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6311, N'Texas Rehabilitation Hospital Of Arlington', 1, NULL, NULL, N'673060', NULL, NULL, 0, 40, NULL, N'6823089867', N'8178203470', 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'900 W Arbrook Blvd', N'Arlington', N'TX', N'48439', N'76015', 32.683189, -97.119167, 3211, 263, NULL, NULL)

INSERT [dbo].[HospitalsTemp] ([Id], [Name], [IsSourcedFromBaseData], [Version], [CCR], [CmsProviderID], [LocalHospitalId], [Description], [Employees], [TotalBeds], [HospitalOwnership], [PhoneNumber], [FaxNumber], [MedicareMedicaidProvider], [EmergencyService], [TraumaService], [UrgentCareService], [PediatricService], [PediatricICUService], [CardiacCatherizationService], [PharmacyService], [DiagnosticXRayService], [ForceLocalHospitalIdValidation], [IsDeleted], [IsArchived], [ArchiveDate], [LinkedHospitalId], [Address], [City], [State], [County], [Zip], [Latitude], [Longitude], [HospitalServiceArea_Id], [HealthReferralRegion_Id], [CustomRegion_Id], [Registry_Id]) VALUES (6312, N'Bay Area Rehabilitation Hospital', 1, NULL, NULL, N'673061', NULL, NULL, 0, 45, NULL, N'8322249500', NULL, 1, 0, 0, 0, 0, 0, 0, 1, 0, 0, 0, 0, NULL, NULL, N'110 East Medical Center Blvd', N'Webster', N'TX', N'48201', N'77598', 29.539413, -95.128852, 3395, 265, NULL, NULL)
SET IDENTITY_INSERT [dbo].[HospitalsTemp] OFF;


END TRY
BEGIN CATCH
DECLARE @ErrorMessage VARCHAR(5000);
    DECLARE @ErrorSeverity INT;
    DECLARE @ErrorState INT;

    SELECT @ErrorMessage = 'Error Line: ' + CAST(ERROR_LINE() AS VARCHAR(50)) +' Error: ' + ERROR_MESSAGE(),
           @ErrorSeverity = ERROR_SEVERITY(),
           @ErrorState = ERROR_STATE();

    RAISERROR (@ErrorMessage, @ErrorSeverity, @ErrorState); 

END CATCH